/* DUPLICATOR-LITE (PHP BUILD MODE) MYSQL SCRIPT CREATED ON : 2019-11-10 10:12:37 */

/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;

SET FOREIGN_KEY_CHECKS = 0;

CREATE TABLE `wp_464683_commentmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `comment_id` (`comment_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_464683_comments` (
  `comment_ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_post_ID` bigint(20) unsigned NOT NULL DEFAULT '0',
  `comment_author` tinytext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `comment_author_email` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_author_url` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_author_IP` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_content` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `comment_karma` int(11) NOT NULL DEFAULT '0',
  `comment_approved` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '1',
  `comment_agent` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`comment_ID`),
  KEY `comment_post_ID` (`comment_post_ID`),
  KEY `comment_approved_date_gmt` (`comment_approved`,`comment_date_gmt`),
  KEY `comment_date_gmt` (`comment_date_gmt`),
  KEY `comment_parent` (`comment_parent`),
  KEY `comment_author_email` (`comment_author_email`(10))
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_464683_cpd_counter` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `ip` int(10) unsigned NOT NULL,
  `client` varchar(500) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `date` date NOT NULL,
  `page` mediumint(9) NOT NULL,
  `country` char(2) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `referer` varchar(500) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_page` (`page`),
  KEY `idx_dateip` (`date`,`ip`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_464683_duplicator_packages` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(250) NOT NULL,
  `hash` varchar(50) NOT NULL,
  `status` int(11) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `owner` varchar(60) NOT NULL,
  `package` longtext NOT NULL,
  PRIMARY KEY (`id`),
  KEY `hash` (`hash`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_464683_itsec_distributed_storage` (
  `storage_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `storage_group` varchar(40) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `storage_key` varchar(40) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `storage_chunk` int(11) NOT NULL DEFAULT '0',
  `storage_data` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `storage_updated` datetime NOT NULL,
  PRIMARY KEY (`storage_id`),
  UNIQUE KEY `storage_group__key__chunk` (`storage_group`,`storage_key`,`storage_chunk`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_464683_itsec_fingerprints` (
  `fingerprint_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `fingerprint_user` bigint(20) unsigned NOT NULL,
  `fingerprint_hash` char(32) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `fingerprint_created_at` datetime NOT NULL,
  `fingerprint_approved_at` datetime NOT NULL,
  `fingerprint_data` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `fingerprint_snapshot` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `fingerprint_last_seen` datetime NOT NULL,
  `fingerprint_uses` int(11) NOT NULL DEFAULT '0',
  `fingerprint_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `fingerprint_uuid` char(36) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  PRIMARY KEY (`fingerprint_id`),
  UNIQUE KEY `fingerprint_user__hash` (`fingerprint_user`,`fingerprint_hash`),
  UNIQUE KEY `fingerprint_uuid` (`fingerprint_uuid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_464683_itsec_geolocation_cache` (
  `location_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `location_host` varchar(40) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `location_lat` decimal(10,8) NOT NULL,
  `location_long` decimal(11,8) NOT NULL,
  `location_label` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `location_credit` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `location_time` datetime NOT NULL,
  PRIMARY KEY (`location_id`),
  UNIQUE KEY `location_host` (`location_host`),
  KEY `location_time` (`location_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_464683_itsec_lockouts` (
  `lockout_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `lockout_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `lockout_start` datetime NOT NULL,
  `lockout_start_gmt` datetime NOT NULL,
  `lockout_expire` datetime NOT NULL,
  `lockout_expire_gmt` datetime NOT NULL,
  `lockout_host` varchar(40) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `lockout_user` bigint(20) unsigned DEFAULT NULL,
  `lockout_username` varchar(60) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `lockout_active` int(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`lockout_id`),
  KEY `lockout_expire_gmt` (`lockout_expire_gmt`),
  KEY `lockout_host` (`lockout_host`),
  KEY `lockout_user` (`lockout_user`),
  KEY `lockout_username` (`lockout_username`),
  KEY `lockout_active` (`lockout_active`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_464683_itsec_logs` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `parent_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `module` varchar(50) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `code` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `data` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'notice',
  `timestamp` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `init_timestamp` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `memory_current` bigint(20) unsigned NOT NULL DEFAULT '0',
  `memory_peak` bigint(20) unsigned NOT NULL DEFAULT '0',
  `url` varchar(500) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `blog_id` bigint(20) NOT NULL DEFAULT '0',
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `remote_ip` varchar(50) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `module` (`module`),
  KEY `code` (`code`),
  KEY `type` (`type`),
  KEY `timestamp` (`timestamp`),
  KEY `user_id` (`user_id`),
  KEY `blog_id` (`blog_id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_464683_itsec_temp` (
  `temp_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `temp_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `temp_date` datetime NOT NULL,
  `temp_date_gmt` datetime NOT NULL,
  `temp_host` varchar(40) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `temp_user` bigint(20) unsigned DEFAULT NULL,
  `temp_username` varchar(60) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  PRIMARY KEY (`temp_id`),
  KEY `temp_date_gmt` (`temp_date_gmt`),
  KEY `temp_host` (`temp_host`),
  KEY `temp_user` (`temp_user`),
  KEY `temp_username` (`temp_username`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_464683_links` (
  `link_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `link_url` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_name` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_image` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_target` varchar(25) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_description` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_visible` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'Y',
  `link_owner` bigint(20) unsigned NOT NULL DEFAULT '1',
  `link_rating` int(11) NOT NULL DEFAULT '0',
  `link_updated` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `link_rel` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_notes` mediumtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `link_rss` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`link_id`),
  KEY `link_visible` (`link_visible`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_464683_options` (
  `option_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `option_name` varchar(191) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `option_value` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `autoload` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'yes',
  PRIMARY KEY (`option_id`),
  UNIQUE KEY `option_name` (`option_name`)
) ENGINE=InnoDB AUTO_INCREMENT=611 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_464683_postmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `post_id` (`post_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=1185 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_464683_posts` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_author` bigint(20) unsigned NOT NULL DEFAULT '0',
  `post_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_title` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_excerpt` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'publish',
  `comment_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'open',
  `ping_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'open',
  `post_password` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `post_name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `to_ping` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `pinged` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content_filtered` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `guid` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `menu_order` int(11) NOT NULL DEFAULT '0',
  `post_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'post',
  `post_mime_type` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`),
  KEY `post_name` (`post_name`(191)),
  KEY `type_status_date` (`post_type`,`post_status`,`post_date`,`ID`),
  KEY `post_parent` (`post_parent`),
  KEY `post_author` (`post_author`)
) ENGINE=InnoDB AUTO_INCREMENT=461 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_464683_term_relationships` (
  `object_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_taxonomy_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`object_id`,`term_taxonomy_id`),
  KEY `term_taxonomy_id` (`term_taxonomy_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_464683_term_taxonomy` (
  `term_taxonomy_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `taxonomy` varchar(32) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `description` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_taxonomy_id`),
  UNIQUE KEY `term_id_taxonomy` (`term_id`,`taxonomy`),
  KEY `taxonomy` (`taxonomy`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_464683_termmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `term_id` (`term_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_464683_terms` (
  `term_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `slug` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `term_group` bigint(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  KEY `slug` (`slug`(191)),
  KEY `name` (`name`(191))
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_464683_usermeta` (
  `umeta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`umeta_id`),
  KEY `user_id` (`user_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=28 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_464683_users` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_login` varchar(60) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_pass` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_nicename` varchar(50) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_email` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_url` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_registered` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `user_activation_key` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_status` int(11) NOT NULL DEFAULT '0',
  `display_name` varchar(250) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`),
  KEY `user_login_key` (`user_login`),
  KEY `user_nicename` (`user_nicename`),
  KEY `user_email` (`user_email`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;


/* INSERT TABLE DATA: wp_464683_cpd_counter */
INSERT INTO `wp_464683_cpd_counter` VALUES("1", "3103966404", "Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko", "2019-11-09", "38", "", "");
INSERT INTO `wp_464683_cpd_counter` VALUES("2", "1403423331", "WordPress/5.2.4; https://emilyhunt.ch", "2019-11-09", "38", "", "https://emilyhunt.ch/");

/* INSERT TABLE DATA: wp_464683_duplicator_packages */
INSERT INTO `wp_464683_duplicator_packages` VALUES("1", "20191109_emilyhunt", "b9539adf21f145db5297_20191109153134", "100", "2019-11-09 15:32:12", "unknown", "O:11:\"DUP_Package\":25:{s:7:\"Created\";s:19:\"2019-11-09 15:31:34\";s:7:\"Version\";s:6:\"1.3.22\";s:9:\"VersionWP\";s:5:\"5.2.4\";s:9:\"VersionDB\";s:6:\"5.7.26\";s:10:\"VersionPHP\";s:6:\"7.2.24\";s:9:\"VersionOS\";s:5:\"Linux\";s:2:\"ID\";i:1;s:4:\"Name\";s:18:\"20191109_emilyhunt\";s:4:\"Hash\";s:35:\"b9539adf21f145db5297_20191109153134\";s:8:\"NameHash\";s:54:\"20191109_emilyhunt_b9539adf21f145db5297_20191109153134\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:73:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-snapshots/tmp\";s:8:\"StoreURL\";s:34:\"https://emilyhunt.ch/wp-snapshots/\";s:8:\"ScanFile\";s:64:\"20191109_emilyhunt_b9539adf21f145db5297_20191109153134_scan.json\";s:10:\"TimerStart\";i:-1;s:7:\"Runtime\";s:10:\"19.05 sec.\";s:7:\"ExeSize\";s:7:\"58.82KB\";s:7:\"ZipSize\";s:7:\"68.03MB\";s:6:\"Status\";s:5:\"100.0\";s:6:\"WPUser\";s:7:\"unknown\";s:7:\"Archive\";O:11:\"DUP_Archive\":23:{s:10:\"FilterDirs\";s:74:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content/cache;\";s:11:\"FilterFiles\";s:0:\"\";s:10:\"FilterExts\";s:22:\"zip;rar;tar;gz;bz2;7z;\";s:13:\"FilterDirsAll\";a:0:{}s:14:\"FilterFilesAll\";a:0:{}s:13:\"FilterExtsAll\";a:0:{}s:8:\"FilterOn\";i:1;s:12:\"ExportOnlyDB\";i:0;s:4:\"File\";s:66:\"20191109_emilyhunt_b9539adf21f145db5297_20191109153134_archive.zip\";s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:56:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt\";s:4:\"Size\";i:71333968;s:4:\"Dirs\";a:0:{}s:5:\"Files\";a:0:{}s:10:\"FilterInfo\";O:23:\"DUP_Archive_Filter_Info\":8:{s:4:\"Dirs\";O:34:\"DUP_Archive_Filter_Scope_Directory\":5:{s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:5:\"Files\";O:29:\"DUP_Archive_Filter_Scope_File\":6:{s:4:\"Size\";a:0:{}s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:4:\"Exts\";O:29:\"DUP_Archive_Filter_Scope_Base\":3:{s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:9:\"UDirCount\";i:0;s:10:\"UFileCount\";i:0;s:9:\"UExtCount\";i:0;s:8:\"TreeSize\";a:0:{}s:11:\"TreeWarning\";a:0:{}}s:14:\"RecursiveLinks\";a:0:{}s:10:\"file_count\";i:9831;s:10:\"\0*\0Package\";r:1;s:29:\"\0DUP_Archive\0tmpFilterDirsAll\";a:0:{}s:24:\"\0DUP_Archive\0wpCorePaths\";a:5:{i:0;s:65:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-admin\";i:1;s:75:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content/uploads\";i:2;s:77:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content/languages\";i:3;s:74:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content/themes\";i:4;s:68:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-includes\";}s:29:\"\0DUP_Archive\0wpCoreExactPaths\";a:2:{i:0;s:56:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt\";i:1;s:67:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content\";}s:19:\"isOuterWPContentDir\";b:0;s:25:\"wpContentDirNormalizePath\";s:68:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content/\";}s:9:\"Installer\";O:13:\"DUP_Installer\":11:{s:4:\"File\";s:68:\"20191109_emilyhunt_b9539adf21f145db5297_20191109153134_installer.php\";s:4:\"Size\";i:60228;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBPort\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:12:\"OptsSecureOn\";i:0;s:14:\"OptsSecurePass\";s:0:\"\";s:13:\"numFilesAdded\";i:0;s:12:\"numDirsAdded\";i:0;s:10:\"\0*\0Package\";r:1;}s:8:\"Database\";O:12:\"DUP_Database\":15:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";i:4772294;s:4:\"File\";s:67:\"20191109_emilyhunt_b9539adf21f145db5297_20191109153134_database.sql\";s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"Compatible\";s:0:\"\";s:8:\"Comments\";s:28:\"MySQL Community Server (GPL)\";s:4:\"info\";O:16:\"DUP_DatabaseInfo\":15:{s:9:\"buildMode\";s:3:\"PHP\";s:13:\"collationList\";a:2:{i:0;s:22:\"utf8mb4_unicode_520_ci\";i:1;s:15:\"utf8_general_ci\";}s:17:\"isTablesUpperCase\";i:0;s:15:\"isNameUpperCase\";i:1;s:4:\"name\";s:14:\"xs21h_WP464683\";s:15:\"tablesBaseCount\";i:20;s:16:\"tablesFinalCount\";i:20;s:14:\"tablesRowCount\";s:5:\"3,758\";s:16:\"tablesSizeOnDisk\";s:6:\"7.45MB\";s:18:\"varLowerCaseTables\";s:1:\"0\";s:7:\"version\";s:6:\"5.7.26\";s:14:\"versionComment\";s:28:\"MySQL Community Server (GPL)\";s:18:\"tableWiseRowCounts\";a:20:{s:21:\"wp_464683_commentmeta\";s:1:\"0\";s:18:\"wp_464683_comments\";s:1:\"1\";s:21:\"wp_464683_cpd_counter\";s:1:\"2\";s:29:\"wp_464683_duplicator_packages\";s:1:\"1\";s:35:\"wp_464683_itsec_distributed_storage\";s:1:\"0\";s:28:\"wp_464683_itsec_fingerprints\";s:1:\"0\";s:33:\"wp_464683_itsec_geolocation_cache\";s:1:\"0\";s:24:\"wp_464683_itsec_lockouts\";s:1:\"0\";s:20:\"wp_464683_itsec_logs\";s:1:\"0\";s:20:\"wp_464683_itsec_temp\";s:1:\"0\";s:15:\"wp_464683_links\";s:1:\"0\";s:17:\"wp_464683_options\";s:3:\"335\";s:18:\"wp_464683_postmeta\";s:3:\"479\";s:15:\"wp_464683_posts\";s:3:\"124\";s:28:\"wp_464683_term_relationships\";s:2:\"11\";s:23:\"wp_464683_term_taxonomy\";s:1:\"4\";s:18:\"wp_464683_termmeta\";s:1:\"0\";s:15:\"wp_464683_terms\";s:1:\"4\";s:18:\"wp_464683_usermeta\";s:2:\"24\";s:15:\"wp_464683_users\";s:1:\"1\";}s:33:\"\0DUP_DatabaseInfo\0intFieldsStruct\";a:0:{}s:42:\"\0DUP_DatabaseInfo\0indexProcessedSchemaSize\";a:0:{}}s:10:\"\0*\0Package\";r:1;s:25:\"\0DUP_Database\0dbStorePath\";s:141:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-snapshots/tmp/20191109_emilyhunt_b9539adf21f145db5297_20191109153134_database.sql\";s:23:\"\0DUP_Database\0EOFMarker\";s:0:\"\";s:26:\"\0DUP_Database\0networkFlush\";b:0;s:19:\"sameNameTableExists\";b:0;}s:13:\"BuildProgress\";O:18:\"DUP_Build_Progress\":12:{s:17:\"thread_start_time\";N;s:11:\"initialized\";b:0;s:15:\"installer_built\";b:1;s:15:\"archive_started\";b:0;s:20:\"archive_has_database\";b:0;s:13:\"archive_built\";b:0;s:21:\"database_script_built\";b:0;s:6:\"failed\";b:0;s:7:\"retries\";i:0;s:14:\"build_failures\";a:0:{}s:19:\"validation_failures\";a:0:{}s:27:\"\0DUP_Build_Progress\0package\";O:11:\"DUP_Package\":25:{s:7:\"Created\";s:19:\"2019-11-09 15:31:34\";s:7:\"Version\";s:6:\"1.3.22\";s:9:\"VersionWP\";s:5:\"5.2.4\";s:9:\"VersionDB\";s:6:\"5.7.26\";s:10:\"VersionPHP\";s:6:\"7.2.24\";s:9:\"VersionOS\";s:5:\"Linux\";s:2:\"ID\";N;s:4:\"Name\";s:18:\"20191109_emilyhunt\";s:4:\"Hash\";s:35:\"b9539adf21f145db5297_20191109153134\";s:8:\"NameHash\";s:54:\"20191109_emilyhunt_b9539adf21f145db5297_20191109153134\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:73:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-snapshots/tmp\";s:8:\"StoreURL\";s:34:\"https://emilyhunt.ch/wp-snapshots/\";s:8:\"ScanFile\";N;s:10:\"TimerStart\";i:-1;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";i:0;s:6:\"WPUser\";N;s:7:\"Archive\";r:23;s:9:\"Installer\";r:76;s:8:\"Database\";r:88;s:13:\"BuildProgress\";r:141;}}}");
INSERT INTO `wp_464683_duplicator_packages` VALUES("2", "20191109_emilyhunt", "4f25460fd59e55408985_20191109170838", "100", "2019-11-09 17:08:46", "unknown", "O:11:\"DUP_Package\":25:{s:7:\"Created\";s:19:\"2019-11-09 17:08:38\";s:7:\"Version\";s:6:\"1.3.22\";s:9:\"VersionWP\";s:5:\"5.2.4\";s:9:\"VersionDB\";s:6:\"5.7.26\";s:10:\"VersionPHP\";s:6:\"7.2.24\";s:9:\"VersionOS\";s:5:\"Linux\";s:2:\"ID\";i:2;s:4:\"Name\";s:18:\"20191109_emilyhunt\";s:4:\"Hash\";s:35:\"4f25460fd59e55408985_20191109170838\";s:8:\"NameHash\";s:54:\"20191109_emilyhunt_4f25460fd59e55408985_20191109170838\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:73:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-snapshots/tmp\";s:8:\"StoreURL\";s:34:\"https://emilyhunt.ch/wp-snapshots/\";s:8:\"ScanFile\";s:64:\"20191109_emilyhunt_4f25460fd59e55408985_20191109170838_scan.json\";s:10:\"TimerStart\";i:-1;s:7:\"Runtime\";s:10:\"14.52 sec.\";s:7:\"ExeSize\";s:7:\"58.82KB\";s:7:\"ZipSize\";s:7:\"53.22MB\";s:6:\"Status\";s:5:\"100.0\";s:6:\"WPUser\";s:7:\"unknown\";s:7:\"Archive\";O:11:\"DUP_Archive\":23:{s:10:\"FilterDirs\";s:74:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content/cache;\";s:11:\"FilterFiles\";s:0:\"\";s:10:\"FilterExts\";s:22:\"zip;rar;tar;gz;bz2;7z;\";s:13:\"FilterDirsAll\";a:0:{}s:14:\"FilterFilesAll\";a:0:{}s:13:\"FilterExtsAll\";a:0:{}s:8:\"FilterOn\";i:1;s:12:\"ExportOnlyDB\";i:0;s:4:\"File\";s:66:\"20191109_emilyhunt_4f25460fd59e55408985_20191109170838_archive.zip\";s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:56:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt\";s:4:\"Size\";i:55803978;s:4:\"Dirs\";a:0:{}s:5:\"Files\";a:0:{}s:10:\"FilterInfo\";O:23:\"DUP_Archive_Filter_Info\":8:{s:4:\"Dirs\";O:34:\"DUP_Archive_Filter_Scope_Directory\":5:{s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:5:\"Files\";O:29:\"DUP_Archive_Filter_Scope_File\":6:{s:4:\"Size\";a:0:{}s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:4:\"Exts\";O:29:\"DUP_Archive_Filter_Scope_Base\":3:{s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:9:\"UDirCount\";i:0;s:10:\"UFileCount\";i:0;s:9:\"UExtCount\";i:0;s:8:\"TreeSize\";a:0:{}s:11:\"TreeWarning\";a:0:{}}s:14:\"RecursiveLinks\";a:0:{}s:10:\"file_count\";i:9531;s:10:\"\0*\0Package\";r:1;s:29:\"\0DUP_Archive\0tmpFilterDirsAll\";a:0:{}s:24:\"\0DUP_Archive\0wpCorePaths\";a:5:{i:0;s:65:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-admin\";i:1;s:75:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content/uploads\";i:2;s:77:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content/languages\";i:3;s:74:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content/themes\";i:4;s:68:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-includes\";}s:29:\"\0DUP_Archive\0wpCoreExactPaths\";a:2:{i:0;s:56:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt\";i:1;s:67:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content\";}s:19:\"isOuterWPContentDir\";b:0;s:25:\"wpContentDirNormalizePath\";s:68:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content/\";}s:9:\"Installer\";O:13:\"DUP_Installer\":11:{s:4:\"File\";s:68:\"20191109_emilyhunt_4f25460fd59e55408985_20191109170838_installer.php\";s:4:\"Size\";i:60228;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBPort\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:12:\"OptsSecureOn\";i:0;s:14:\"OptsSecurePass\";s:0:\"\";s:13:\"numFilesAdded\";i:0;s:12:\"numDirsAdded\";i:0;s:10:\"\0*\0Package\";r:1;}s:8:\"Database\";O:12:\"DUP_Database\":15:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";i:1674817;s:4:\"File\";s:67:\"20191109_emilyhunt_4f25460fd59e55408985_20191109170838_database.sql\";s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"Compatible\";s:0:\"\";s:8:\"Comments\";s:28:\"MySQL Community Server (GPL)\";s:4:\"info\";O:16:\"DUP_DatabaseInfo\":15:{s:9:\"buildMode\";s:3:\"PHP\";s:13:\"collationList\";a:2:{i:0;s:22:\"utf8mb4_unicode_520_ci\";i:1;s:15:\"utf8_general_ci\";}s:17:\"isTablesUpperCase\";i:0;s:15:\"isNameUpperCase\";i:1;s:4:\"name\";s:14:\"xs21h_WP464683\";s:15:\"tablesBaseCount\";i:20;s:16:\"tablesFinalCount\";i:20;s:14:\"tablesRowCount\";s:3:\"351\";s:16:\"tablesSizeOnDisk\";s:6:\"4.25MB\";s:18:\"varLowerCaseTables\";s:1:\"0\";s:7:\"version\";s:6:\"5.7.26\";s:14:\"versionComment\";s:28:\"MySQL Community Server (GPL)\";s:18:\"tableWiseRowCounts\";a:20:{s:21:\"wp_464683_commentmeta\";s:1:\"0\";s:18:\"wp_464683_comments\";s:1:\"0\";s:21:\"wp_464683_cpd_counter\";s:1:\"2\";s:29:\"wp_464683_duplicator_packages\";s:1:\"2\";s:35:\"wp_464683_itsec_distributed_storage\";s:1:\"0\";s:28:\"wp_464683_itsec_fingerprints\";s:1:\"0\";s:33:\"wp_464683_itsec_geolocation_cache\";s:1:\"0\";s:24:\"wp_464683_itsec_lockouts\";s:1:\"0\";s:20:\"wp_464683_itsec_logs\";s:1:\"0\";s:20:\"wp_464683_itsec_temp\";s:1:\"0\";s:15:\"wp_464683_links\";s:1:\"0\";s:17:\"wp_464683_options\";s:3:\"296\";s:18:\"wp_464683_postmeta\";s:3:\"151\";s:15:\"wp_464683_posts\";s:2:\"46\";s:28:\"wp_464683_term_relationships\";s:1:\"7\";s:23:\"wp_464683_term_taxonomy\";s:1:\"4\";s:18:\"wp_464683_termmeta\";s:1:\"0\";s:15:\"wp_464683_terms\";s:1:\"4\";s:18:\"wp_464683_usermeta\";s:2:\"24\";s:15:\"wp_464683_users\";s:1:\"1\";}s:33:\"\0DUP_DatabaseInfo\0intFieldsStruct\";a:0:{}s:42:\"\0DUP_DatabaseInfo\0indexProcessedSchemaSize\";a:0:{}}s:10:\"\0*\0Package\";r:1;s:25:\"\0DUP_Database\0dbStorePath\";s:141:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-snapshots/tmp/20191109_emilyhunt_4f25460fd59e55408985_20191109170838_database.sql\";s:23:\"\0DUP_Database\0EOFMarker\";s:0:\"\";s:26:\"\0DUP_Database\0networkFlush\";b:0;s:19:\"sameNameTableExists\";b:0;}s:13:\"BuildProgress\";O:18:\"DUP_Build_Progress\":12:{s:17:\"thread_start_time\";N;s:11:\"initialized\";b:0;s:15:\"installer_built\";b:1;s:15:\"archive_started\";b:0;s:20:\"archive_has_database\";b:0;s:13:\"archive_built\";b:0;s:21:\"database_script_built\";b:0;s:6:\"failed\";b:0;s:7:\"retries\";i:0;s:14:\"build_failures\";a:0:{}s:19:\"validation_failures\";a:0:{}s:27:\"\0DUP_Build_Progress\0package\";O:11:\"DUP_Package\":25:{s:7:\"Created\";s:19:\"2019-11-09 17:08:38\";s:7:\"Version\";s:6:\"1.3.22\";s:9:\"VersionWP\";s:5:\"5.2.4\";s:9:\"VersionDB\";s:6:\"5.7.26\";s:10:\"VersionPHP\";s:6:\"7.2.24\";s:9:\"VersionOS\";s:5:\"Linux\";s:2:\"ID\";N;s:4:\"Name\";s:18:\"20191109_emilyhunt\";s:4:\"Hash\";s:35:\"4f25460fd59e55408985_20191109170838\";s:8:\"NameHash\";s:54:\"20191109_emilyhunt_4f25460fd59e55408985_20191109170838\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:73:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-snapshots/tmp\";s:8:\"StoreURL\";s:34:\"https://emilyhunt.ch/wp-snapshots/\";s:8:\"ScanFile\";N;s:10:\"TimerStart\";i:-1;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";i:0;s:6:\"WPUser\";N;s:7:\"Archive\";r:23;s:9:\"Installer\";r:76;s:8:\"Database\";r:88;s:13:\"BuildProgress\";r:141;}}}");
INSERT INTO `wp_464683_duplicator_packages` VALUES("3", "20191109_emilyhunt", "8e5327c6e4444f5b4285_20191110101229", "22", "2019-11-10 10:12:37", "unknown", "O:11:\"DUP_Package\":25:{s:7:\"Created\";s:19:\"2019-11-10 10:12:29\";s:7:\"Version\";s:6:\"1.3.22\";s:9:\"VersionWP\";s:5:\"5.2.4\";s:9:\"VersionDB\";s:6:\"5.7.26\";s:10:\"VersionPHP\";s:6:\"7.2.24\";s:9:\"VersionOS\";s:5:\"Linux\";s:2:\"ID\";i:3;s:4:\"Name\";s:18:\"20191109_emilyhunt\";s:4:\"Hash\";s:35:\"8e5327c6e4444f5b4285_20191110101229\";s:8:\"NameHash\";s:54:\"20191109_emilyhunt_8e5327c6e4444f5b4285_20191110101229\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:73:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-snapshots/tmp\";s:8:\"StoreURL\";s:34:\"https://emilyhunt.ch/wp-snapshots/\";s:8:\"ScanFile\";s:64:\"20191109_emilyhunt_8e5327c6e4444f5b4285_20191110101229_scan.json\";s:10:\"TimerStart\";i:-1;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";s:4:\"22.0\";s:6:\"WPUser\";s:7:\"unknown\";s:7:\"Archive\";O:11:\"DUP_Archive\":21:{s:10:\"FilterDirs\";s:74:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content/cache;\";s:11:\"FilterFiles\";s:0:\"\";s:10:\"FilterExts\";s:22:\"zip;rar;tar;gz;bz2;7z;\";s:13:\"FilterDirsAll\";a:0:{}s:14:\"FilterFilesAll\";a:0:{}s:13:\"FilterExtsAll\";a:0:{}s:8:\"FilterOn\";i:1;s:12:\"ExportOnlyDB\";i:0;s:4:\"File\";s:66:\"20191109_emilyhunt_8e5327c6e4444f5b4285_20191110101229_archive.zip\";s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:56:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt\";s:4:\"Size\";i:0;s:4:\"Dirs\";a:0:{}s:5:\"Files\";a:0:{}s:10:\"FilterInfo\";O:23:\"DUP_Archive_Filter_Info\":8:{s:4:\"Dirs\";O:34:\"DUP_Archive_Filter_Scope_Directory\":5:{s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:5:\"Files\";O:29:\"DUP_Archive_Filter_Scope_File\":6:{s:4:\"Size\";a:0:{}s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:4:\"Exts\";O:29:\"DUP_Archive_Filter_Scope_Base\":3:{s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:9:\"UDirCount\";i:0;s:10:\"UFileCount\";i:0;s:9:\"UExtCount\";i:0;s:8:\"TreeSize\";a:0:{}s:11:\"TreeWarning\";a:0:{}}s:14:\"RecursiveLinks\";a:0:{}s:10:\"file_count\";i:-1;s:10:\"\0*\0Package\";O:11:\"DUP_Package\":25:{s:7:\"Created\";s:19:\"2019-11-10 10:12:29\";s:7:\"Version\";s:6:\"1.3.22\";s:9:\"VersionWP\";s:5:\"5.2.4\";s:9:\"VersionDB\";s:6:\"5.7.26\";s:10:\"VersionPHP\";s:6:\"7.2.24\";s:9:\"VersionOS\";s:5:\"Linux\";s:2:\"ID\";N;s:4:\"Name\";s:18:\"20191109_emilyhunt\";s:4:\"Hash\";s:35:\"8e5327c6e4444f5b4285_20191110101229\";s:8:\"NameHash\";s:54:\"20191109_emilyhunt_8e5327c6e4444f5b4285_20191110101229\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:73:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-snapshots/tmp\";s:8:\"StoreURL\";s:34:\"https://emilyhunt.ch/wp-snapshots/\";s:8:\"ScanFile\";N;s:10:\"TimerStart\";i:-1;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";i:0;s:6:\"WPUser\";N;s:7:\"Archive\";r:23;s:9:\"Installer\";O:13:\"DUP_Installer\":11:{s:4:\"File\";s:68:\"20191109_emilyhunt_8e5327c6e4444f5b4285_20191110101229_installer.php\";s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBPort\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:12:\"OptsSecureOn\";i:0;s:14:\"OptsSecurePass\";s:0:\"\";s:13:\"numFilesAdded\";i:0;s:12:\"numDirsAdded\";i:0;s:10:\"\0*\0Package\";r:63;}s:8:\"Database\";O:12:\"DUP_Database\":15:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";s:67:\"20191109_emilyhunt_8e5327c6e4444f5b4285_20191110101229_database.sql\";s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"Compatible\";s:0:\"\";s:8:\"Comments\";s:28:\"MySQL Community Server (GPL)\";s:4:\"info\";O:16:\"DUP_DatabaseInfo\":15:{s:9:\"buildMode\";N;s:13:\"collationList\";a:0:{}s:17:\"isTablesUpperCase\";N;s:15:\"isNameUpperCase\";N;s:4:\"name\";N;s:15:\"tablesBaseCount\";N;s:16:\"tablesFinalCount\";N;s:14:\"tablesRowCount\";N;s:16:\"tablesSizeOnDisk\";N;s:18:\"varLowerCaseTables\";i:0;s:7:\"version\";N;s:14:\"versionComment\";N;s:18:\"tableWiseRowCounts\";a:3:{s:21:\"wp_464683_commentmeta\";s:1:\"0\";s:18:\"wp_464683_comments\";s:1:\"0\";s:21:\"wp_464683_cpd_counter\";s:1:\"2\";}s:33:\"\0DUP_DatabaseInfo\0intFieldsStruct\";a:0:{}s:42:\"\0DUP_DatabaseInfo\0indexProcessedSchemaSize\";a:0:{}}s:10:\"\0*\0Package\";r:1;s:25:\"\0DUP_Database\0dbStorePath\";s:141:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-snapshots/tmp/20191109_emilyhunt_8e5327c6e4444f5b4285_20191110101229_database.sql\";s:23:\"\0DUP_Database\0EOFMarker\";s:0:\"\";s:26:\"\0DUP_Database\0networkFlush\";b:0;s:19:\"sameNameTableExists\";b:0;}s:13:\"BuildProgress\";O:18:\"DUP_Build_Progress\":12:{s:17:\"thread_start_time\";N;s:11:\"initialized\";b:0;s:15:\"installer_built\";b:0;s:15:\"archive_started\";b:0;s:20:\"archive_has_database\";b:0;s:13:\"archive_built\";b:0;s:21:\"database_script_built\";b:0;s:6:\"failed\";b:0;s:7:\"retries\";i:0;s:14:\"build_failures\";a:0:{}s:19:\"validation_failures\";a:0:{}s:27:\"\0DUP_Build_Progress\0package\";r:63;}}s:29:\"\0DUP_Archive\0tmpFilterDirsAll\";a:0:{}s:24:\"\0DUP_Archive\0wpCorePaths\";a:5:{i:0;s:65:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-admin\";i:1;s:75:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content/uploads\";i:2;s:77:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content/languages\";i:3;s:74:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content/themes\";i:4;s:68:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-includes\";}s:29:\"\0DUP_Archive\0wpCoreExactPaths\";a:2:{i:0;s:56:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt\";i:1;s:67:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content\";}}s:9:\"Installer\";r:86;s:8:\"Database\";r:98;s:13:\"BuildProgress\";r:132;}");

/* INSERT TABLE DATA: wp_464683_itsec_logs */
INSERT INTO `wp_464683_itsec_logs` VALUES("1", "0", "brute_force", "invalid-login::user-1", "a:5:{s:7:\"details\";a:2:{s:6:\"source\";s:12:\"wp-login.php\";s:20:\"authentication_types\";a:1:{i:0;s:21:\"username_and_password\";}}s:4:\"user\";O:8:\"WP_Error\":2:{s:6:\"errors\";a:1:{s:18:\"incorrect_password\";a:1:{i:0;s:192:\"<strong>ERROR</strong>: The password you entered for the username <strong>svadmin</strong> is incorrect. <a href=\"https://emilyhunt.ch/wp-login.php?action=lostpassword\">Lost your password?</a>\";}}s:10:\"error_data\";a:0:{}}s:8:\"username\";s:7:\"svadmin\";s:7:\"user_id\";i:1;s:6:\"SERVER\";a:75:{s:15:\"SERVER_SOFTWARE\";s:6:\"Apache\";s:11:\"REQUEST_URI\";s:13:\"/wp-login.php\";s:4:\"TEMP\";s:50:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/tmp\";s:6:\"TMPDIR\";s:50:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/tmp\";s:3:\"TMP\";s:50:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/tmp\";s:16:\"ORIG_SCRIPT_NAME\";s:19:\"/.fpm/php5.external\";s:20:\"ORIG_PATH_TRANSLATED\";s:69:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-login.php\";s:14:\"ORIG_PATH_INFO\";s:13:\"/wp-login.php\";s:20:\"ORIG_SCRIPT_FILENAME\";s:93:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/.config/apache/emilyhunt.ch/.fpm/php5.external\";s:11:\"SCRIPT_NAME\";s:13:\"/wp-login.php\";s:12:\"QUERY_STRING\";s:0:\"\";s:14:\"REQUEST_METHOD\";s:4:\"POST\";s:15:\"SERVER_PROTOCOL\";s:8:\"HTTP/2.0\";s:17:\"GATEWAY_INTERFACE\";s:7:\"CGI/1.1\";s:12:\"REDIRECT_URL\";s:13:\"/wp-login.php\";s:11:\"REMOTE_PORT\";s:5:\"49387\";s:15:\"SCRIPT_FILENAME\";s:69:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-login.php\";s:12:\"SERVER_ADMIN\";s:26:\"stickysites@protonmail.com\";s:21:\"CONTEXT_DOCUMENT_ROOT\";s:80:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/.config/apache/emilyhunt.ch/.fpm/\";s:14:\"CONTEXT_PREFIX\";s:6:\"/.fpm/\";s:14:\"REQUEST_SCHEME\";s:5:\"https\";s:13:\"DOCUMENT_ROOT\";s:56:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt\";s:11:\"REMOTE_ADDR\";s:11:\"88.8.240.47\";s:11:\"SERVER_PORT\";s:3:\"443\";s:11:\"SERVER_ADDR\";s:13:\"83.166.138.99\";s:11:\"SERVER_NAME\";s:12:\"emilyhunt.ch\";s:16:\"SERVER_SIGNATURE\";s:0:\"\";s:4:\"PATH\";s:60:\"/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin\";s:9:\"HTTP_HOST\";s:12:\"emilyhunt.ch\";s:11:\"HTTP_COOKIE\";s:126:\"wp-settings-1=libraryContent%3Dbrowse%26editor%3Dtinymce; wp-settings-time-1=1573317440; wordpress_test_cookie=WP+Cookie+check\";s:20:\"HTTP_ACCEPT_LANGUAGE\";s:44:\"en-GB,en;q=0.9,en-US;q=0.8,es;q=0.7,ca;q=0.6\";s:20:\"HTTP_ACCEPT_ENCODING\";s:17:\"gzip, deflate, br\";s:12:\"HTTP_REFERER\";s:95:\"https://emilyhunt.ch/wp-login.php?redirect_to=https%3A%2F%2Femilyhunt.ch%2Fwp-admin%2F&reauth=1\";s:19:\"HTTP_SEC_FETCH_MODE\";s:8:\"navigate\";s:19:\"HTTP_SEC_FETCH_SITE\";s:11:\"same-origin\";s:11:\"HTTP_ACCEPT\";s:118:\"text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3\";s:19:\"HTTP_SEC_FETCH_USER\";s:2:\"?1\";s:15:\"HTTP_USER_AGENT\";s:120:\"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3904.87 Safari/537.36\";s:12:\"CONTENT_TYPE\";s:33:\"application/x-www-form-urlencoded\";s:30:\"HTTP_UPGRADE_INSECURE_REQUESTS\";s:1:\"1\";s:11:\"HTTP_ORIGIN\";s:20:\"https://emilyhunt.ch\";s:18:\"HTTP_CACHE_CONTROL\";s:9:\"max-age=0\";s:14:\"CONTENT_LENGTH\";s:3:\"105\";s:11:\"SSL_TLS_SNI\";s:12:\"emilyhunt.ch\";s:5:\"HTTPS\";s:2:\"on\";s:13:\"H2_STREAM_TAG\";s:5:\"257-1\";s:12:\"H2_STREAM_ID\";s:1:\"1\";s:12:\"H2_PUSHED_ON\";s:0:\"\";s:9:\"H2_PUSHED\";s:0:\"\";s:7:\"H2_PUSH\";s:2:\"on\";s:6:\"H2PUSH\";s:2:\"on\";s:5:\"HTTP2\";s:2:\"on\";s:11:\"PHP_VERSION\";s:3:\"7.2\";s:10:\"SCRIPT_URI\";s:33:\"https://emilyhunt.ch/wp-login.php\";s:10:\"SCRIPT_URL\";s:13:\"/wp-login.php\";s:9:\"UNIQUE_ID\";s:27:\"XccosEriDHaosFjAymsc-wAAAAE\";s:15:\"REDIRECT_STATUS\";s:3:\"200\";s:16:\"REDIRECT_HANDLER\";s:9:\"php5-fcgi\";s:20:\"REDIRECT_SSL_TLS_SNI\";s:12:\"emilyhunt.ch\";s:14:\"REDIRECT_HTTPS\";s:2:\"on\";s:22:\"REDIRECT_H2_STREAM_TAG\";s:5:\"257-1\";s:21:\"REDIRECT_H2_STREAM_ID\";s:1:\"1\";s:21:\"REDIRECT_H2_PUSHED_ON\";s:0:\"\";s:18:\"REDIRECT_H2_PUSHED\";s:0:\"\";s:16:\"REDIRECT_H2_PUSH\";s:2:\"on\";s:15:\"REDIRECT_H2PUSH\";s:2:\"on\";s:14:\"REDIRECT_HTTP2\";s:2:\"on\";s:20:\"REDIRECT_PHP_VERSION\";s:3:\"7.2\";s:19:\"REDIRECT_SCRIPT_URI\";s:33:\"https://emilyhunt.ch/wp-login.php\";s:19:\"REDIRECT_SCRIPT_URL\";s:13:\"/wp-login.php\";s:18:\"REDIRECT_UNIQUE_ID\";s:27:\"XccosEriDHaosFjAymsc-wAAAAE\";s:9:\"FCGI_ROLE\";s:9:\"RESPONDER\";s:8:\"PHP_SELF\";s:13:\"/wp-login.php\";s:18:\"REQUEST_TIME_FLOAT\";s:15:\"1573333168.1972\";s:12:\"REQUEST_TIME\";s:10:\"1573333168\";}}", "notice", "2019-11-09 20:59:28", "2019-11-09 20:59:28", "35242744", "35306504", "https://emilyhunt.ch/wp-login.php", "1", "0", "88.8.240.47");

/* INSERT TABLE DATA: wp_464683_itsec_temp */
INSERT INTO `wp_464683_itsec_temp` VALUES("1", "brute_force", "2019-11-09 12:59:28", "2019-11-09 20:59:28", "88.8.240.47", NULL, NULL);
INSERT INTO `wp_464683_itsec_temp` VALUES("2", "brute_force", "2019-11-09 12:59:28", "2019-11-09 20:59:28", NULL, "1", "svadmin");

/* INSERT TABLE DATA: wp_464683_options */
INSERT INTO `wp_464683_options` VALUES("1", "siteurl", "http://emilyhunt.ch", "yes");
INSERT INTO `wp_464683_options` VALUES("2", "home", "https://emilyhunt.ch", "yes");
INSERT INTO `wp_464683_options` VALUES("3", "blogname", "Emily Hunt", "yes");
INSERT INTO `wp_464683_options` VALUES("4", "blogdescription", "Just another WordPress site", "yes");
INSERT INTO `wp_464683_options` VALUES("5", "users_can_register", "0", "yes");
INSERT INTO `wp_464683_options` VALUES("6", "admin_email", "stickysites@protonmail.com", "yes");
INSERT INTO `wp_464683_options` VALUES("7", "start_of_week", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("8", "use_balanceTags", "0", "yes");
INSERT INTO `wp_464683_options` VALUES("9", "use_smilies", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("10", "require_name_email", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("11", "comments_notify", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("12", "posts_per_rss", "10", "yes");
INSERT INTO `wp_464683_options` VALUES("13", "rss_use_excerpt", "0", "yes");
INSERT INTO `wp_464683_options` VALUES("14", "mailserver_url", "mail.example.com", "yes");
INSERT INTO `wp_464683_options` VALUES("15", "mailserver_login", "login@example.com", "yes");
INSERT INTO `wp_464683_options` VALUES("16", "mailserver_pass", "password", "yes");
INSERT INTO `wp_464683_options` VALUES("17", "mailserver_port", "110", "yes");
INSERT INTO `wp_464683_options` VALUES("18", "default_category", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("19", "default_comment_status", "open", "yes");
INSERT INTO `wp_464683_options` VALUES("20", "default_ping_status", "open", "yes");
INSERT INTO `wp_464683_options` VALUES("21", "default_pingback_flag", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("22", "posts_per_page", "10", "yes");
INSERT INTO `wp_464683_options` VALUES("23", "date_format", "F j, Y", "yes");
INSERT INTO `wp_464683_options` VALUES("24", "time_format", "g:i a", "yes");
INSERT INTO `wp_464683_options` VALUES("25", "links_updated_date_format", "F j, Y g:i a", "yes");
INSERT INTO `wp_464683_options` VALUES("26", "comment_moderation", "0", "yes");
INSERT INTO `wp_464683_options` VALUES("27", "moderation_notify", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("28", "permalink_structure", "/%postname%/", "yes");
INSERT INTO `wp_464683_options` VALUES("29", "rewrite_rules", "a:122:{s:11:\"^wp-json/?$\";s:22:\"index.php?rest_route=/\";s:14:\"^wp-json/(.*)?\";s:33:\"index.php?rest_route=/$matches[1]\";s:21:\"^index.php/wp-json/?$\";s:22:\"index.php?rest_route=/\";s:24:\"^index.php/wp-json/(.*)?\";s:33:\"index.php?rest_route=/$matches[1]\";s:47:\"category/(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:42:\"category/(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:23:\"category/(.+?)/embed/?$\";s:46:\"index.php?category_name=$matches[1]&embed=true\";s:35:\"category/(.+?)/page/?([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&paged=$matches[2]\";s:17:\"category/(.+?)/?$\";s:35:\"index.php?category_name=$matches[1]\";s:44:\"tag/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:39:\"tag/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:20:\"tag/([^/]+)/embed/?$\";s:36:\"index.php?tag=$matches[1]&embed=true\";s:32:\"tag/([^/]+)/page/?([0-9]{1,})/?$\";s:43:\"index.php?tag=$matches[1]&paged=$matches[2]\";s:14:\"tag/([^/]+)/?$\";s:25:\"index.php?tag=$matches[1]\";s:45:\"type/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:40:\"type/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:21:\"type/([^/]+)/embed/?$\";s:44:\"index.php?post_format=$matches[1]&embed=true\";s:33:\"type/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?post_format=$matches[1]&paged=$matches[2]\";s:15:\"type/([^/]+)/?$\";s:33:\"index.php?post_format=$matches[1]\";s:38:\"aam_policy/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:48:\"aam_policy/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:68:\"aam_policy/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:63:\"aam_policy/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:63:\"aam_policy/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:44:\"aam_policy/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:27:\"aam_policy/([^/]+)/embed/?$\";s:43:\"index.php?aam_policy=$matches[1]&embed=true\";s:31:\"aam_policy/([^/]+)/trackback/?$\";s:37:\"index.php?aam_policy=$matches[1]&tb=1\";s:39:\"aam_policy/([^/]+)/page/?([0-9]{1,})/?$\";s:50:\"index.php?aam_policy=$matches[1]&paged=$matches[2]\";s:46:\"aam_policy/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?aam_policy=$matches[1]&cpage=$matches[2]\";s:35:\"aam_policy/([^/]+)(?:/([0-9]+))?/?$\";s:49:\"index.php?aam_policy=$matches[1]&page=$matches[2]\";s:27:\"aam_policy/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\"aam_policy/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\"aam_policy/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\"aam_policy/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\"aam_policy/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:33:\"aam_policy/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:39:\"text-blocks/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:49:\"text-blocks/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:69:\"text-blocks/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:64:\"text-blocks/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:64:\"text-blocks/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:45:\"text-blocks/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:28:\"text-blocks/([^/]+)/embed/?$\";s:44:\"index.php?text-blocks=$matches[1]&embed=true\";s:32:\"text-blocks/([^/]+)/trackback/?$\";s:38:\"index.php?text-blocks=$matches[1]&tb=1\";s:40:\"text-blocks/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?text-blocks=$matches[1]&paged=$matches[2]\";s:47:\"text-blocks/([^/]+)/comment-page-([0-9]{1,})/?$\";s:51:\"index.php?text-blocks=$matches[1]&cpage=$matches[2]\";s:36:\"text-blocks/([^/]+)(?:/([0-9]+))?/?$\";s:50:\"index.php?text-blocks=$matches[1]&page=$matches[2]\";s:28:\"text-blocks/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:38:\"text-blocks/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:58:\"text-blocks/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:53:\"text-blocks/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:53:\"text-blocks/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:34:\"text-blocks/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:12:\"robots\\.txt$\";s:18:\"index.php?robots=1\";s:48:\".*wp-(atom|rdf|rss|rss2|feed|commentsrss2)\\.php$\";s:18:\"index.php?feed=old\";s:20:\".*wp-app\\.php(/.*)?$\";s:19:\"index.php?error=403\";s:18:\".*wp-register.php$\";s:23:\"index.php?register=true\";s:32:\"feed/(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:27:\"(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:8:\"embed/?$\";s:21:\"index.php?&embed=true\";s:20:\"page/?([0-9]{1,})/?$\";s:28:\"index.php?&paged=$matches[1]\";s:27:\"comment-page-([0-9]{1,})/?$\";s:40:\"index.php?&page_id=287&cpage=$matches[1]\";s:41:\"comments/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:36:\"comments/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:17:\"comments/embed/?$\";s:21:\"index.php?&embed=true\";s:44:\"search/(.+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:39:\"search/(.+)/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:20:\"search/(.+)/embed/?$\";s:34:\"index.php?s=$matches[1]&embed=true\";s:32:\"search/(.+)/page/?([0-9]{1,})/?$\";s:41:\"index.php?s=$matches[1]&paged=$matches[2]\";s:14:\"search/(.+)/?$\";s:23:\"index.php?s=$matches[1]\";s:47:\"author/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:42:\"author/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:23:\"author/([^/]+)/embed/?$\";s:44:\"index.php?author_name=$matches[1]&embed=true\";s:35:\"author/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?author_name=$matches[1]&paged=$matches[2]\";s:17:\"author/([^/]+)/?$\";s:33:\"index.php?author_name=$matches[1]\";s:69:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:45:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/embed/?$\";s:74:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&embed=true\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&paged=$matches[4]\";s:39:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/?$\";s:63:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]\";s:56:\"([0-9]{4})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:51:\"([0-9]{4})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:32:\"([0-9]{4})/([0-9]{1,2})/embed/?$\";s:58:\"index.php?year=$matches[1]&monthnum=$matches[2]&embed=true\";s:44:\"([0-9]{4})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&paged=$matches[3]\";s:26:\"([0-9]{4})/([0-9]{1,2})/?$\";s:47:\"index.php?year=$matches[1]&monthnum=$matches[2]\";s:43:\"([0-9]{4})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:38:\"([0-9]{4})/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:19:\"([0-9]{4})/embed/?$\";s:37:\"index.php?year=$matches[1]&embed=true\";s:31:\"([0-9]{4})/page/?([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&paged=$matches[2]\";s:13:\"([0-9]{4})/?$\";s:26:\"index.php?year=$matches[1]\";s:27:\".?.+?/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\".?.+?/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\".?.+?/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:33:\".?.+?/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:16:\"(.?.+?)/embed/?$\";s:41:\"index.php?pagename=$matches[1]&embed=true\";s:20:\"(.?.+?)/trackback/?$\";s:35:\"index.php?pagename=$matches[1]&tb=1\";s:40:\"(.?.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:35:\"(.?.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:28:\"(.?.+?)/page/?([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&paged=$matches[2]\";s:35:\"(.?.+?)/comment-page-([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&cpage=$matches[2]\";s:24:\"(.?.+?)(?:/([0-9]+))?/?$\";s:47:\"index.php?pagename=$matches[1]&page=$matches[2]\";s:27:\"[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\"[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\"[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\"[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\"[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:33:\"[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:16:\"([^/]+)/embed/?$\";s:37:\"index.php?name=$matches[1]&embed=true\";s:20:\"([^/]+)/trackback/?$\";s:31:\"index.php?name=$matches[1]&tb=1\";s:40:\"([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?name=$matches[1]&feed=$matches[2]\";s:35:\"([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?name=$matches[1]&feed=$matches[2]\";s:28:\"([^/]+)/page/?([0-9]{1,})/?$\";s:44:\"index.php?name=$matches[1]&paged=$matches[2]\";s:35:\"([^/]+)/comment-page-([0-9]{1,})/?$\";s:44:\"index.php?name=$matches[1]&cpage=$matches[2]\";s:24:\"([^/]+)(?:/([0-9]+))?/?$\";s:43:\"index.php?name=$matches[1]&page=$matches[2]\";s:16:\"[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:26:\"[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:46:\"[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:41:\"[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:41:\"[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:22:\"[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";}", "yes");
INSERT INTO `wp_464683_options` VALUES("30", "hack_file", "0", "yes");
INSERT INTO `wp_464683_options` VALUES("31", "blog_charset", "UTF-8", "yes");
INSERT INTO `wp_464683_options` VALUES("32", "moderation_keys", "", "no");
INSERT INTO `wp_464683_options` VALUES("33", "active_plugins", "a:27:{i:0;s:31:\"advanced-access-manager/aam.php\";i:1;s:61:\"all-404-redirect-to-homepage/all-404-redirect-to-homepage.php\";i:2;s:41:\"all-in-one-favicon/all-in-one-favicon.php\";i:3;s:35:\"backupwordpress/backupwordpress.php\";i:4;s:47:\"better-search-replace/better-search-replace.php\";i:5;s:41:\"better-wp-security/better-wp-security.php\";i:6;s:33:\"classic-editor/classic-editor.php\";i:7;s:37:\"disable-comments/disable-comments.php\";i:8;s:35:\"disable-xml-rpc/disable-xml-rpc.php\";i:9;s:33:\"duplicate-post/duplicate-post.php\";i:10;s:25:\"duplicator/duplicator.php\";i:11;s:37:\"elementor-extras/elementor-extras.php\";i:12;s:31:\"elementor-pro/elementor-pro.php\";i:13;s:23:\"elementor/elementor.php\";i:14;s:63:\"granular-controls-for-elementor/granular-controls-elementor.php\";i:15;s:29:\"jet-elements/jet-elements.php\";i:16;s:25:\"login-logo/login-logo.php\";i:17;s:77:\"minimal-coming-soon-maintenance-mode/minimal-coming-soon-maintenance-mode.php\";i:18;s:53:\"mousewheel-smooth-scroll/mousewheel-smooth-scroll.php\";i:19;s:53:\"page-management-dropdown/page-management-dropdown.php\";i:20;s:41:\"password-protected/password-protected.php\";i:21;s:37:\"rcd-right-click-disabler/rcd-main.php\";i:22;s:36:\"reusable-text-blocks/text-blocks.php\";i:23;s:27:\"updraftplus/updraftplus.php\";i:24;s:53:\"w2o-admin-drop-down-menu/w2o-admin-drop-down-menu.php\";i:25;s:32:\"white-label-cms/wlcms-plugin.php\";i:26;s:21:\"wp-sweep/wp-sweep.php\";}", "yes");
INSERT INTO `wp_464683_options` VALUES("34", "category_base", "", "yes");
INSERT INTO `wp_464683_options` VALUES("35", "ping_sites", "http://rpc.pingomatic.com/", "yes");
INSERT INTO `wp_464683_options` VALUES("36", "comment_max_links", "2", "yes");
INSERT INTO `wp_464683_options` VALUES("37", "gmt_offset", "", "yes");
INSERT INTO `wp_464683_options` VALUES("38", "default_email_category", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("39", "recently_edited", "", "no");
INSERT INTO `wp_464683_options` VALUES("40", "template", "blankslate", "yes");
INSERT INTO `wp_464683_options` VALUES("41", "stylesheet", "blankslate", "yes");
INSERT INTO `wp_464683_options` VALUES("42", "comment_whitelist", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("43", "blacklist_keys", "", "no");
INSERT INTO `wp_464683_options` VALUES("44", "comment_registration", "0", "yes");
INSERT INTO `wp_464683_options` VALUES("45", "html_type", "text/html", "yes");
INSERT INTO `wp_464683_options` VALUES("46", "use_trackback", "0", "yes");
INSERT INTO `wp_464683_options` VALUES("47", "default_role", "subscriber", "yes");
INSERT INTO `wp_464683_options` VALUES("48", "db_version", "44719", "yes");
INSERT INTO `wp_464683_options` VALUES("49", "uploads_use_yearmonth_folders", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("50", "upload_path", "", "yes");
INSERT INTO `wp_464683_options` VALUES("51", "blog_public", "0", "yes");
INSERT INTO `wp_464683_options` VALUES("52", "default_link_category", "2", "yes");
INSERT INTO `wp_464683_options` VALUES("53", "show_on_front", "page", "yes");
INSERT INTO `wp_464683_options` VALUES("54", "tag_base", "", "yes");
INSERT INTO `wp_464683_options` VALUES("55", "show_avatars", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("56", "avatar_rating", "G", "yes");
INSERT INTO `wp_464683_options` VALUES("57", "upload_url_path", "", "yes");
INSERT INTO `wp_464683_options` VALUES("58", "thumbnail_size_w", "150", "yes");
INSERT INTO `wp_464683_options` VALUES("59", "thumbnail_size_h", "150", "yes");
INSERT INTO `wp_464683_options` VALUES("60", "thumbnail_crop", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("61", "medium_size_w", "300", "yes");
INSERT INTO `wp_464683_options` VALUES("62", "medium_size_h", "300", "yes");
INSERT INTO `wp_464683_options` VALUES("63", "avatar_default", "mystery", "yes");
INSERT INTO `wp_464683_options` VALUES("64", "large_size_w", "1024", "yes");
INSERT INTO `wp_464683_options` VALUES("65", "large_size_h", "1024", "yes");
INSERT INTO `wp_464683_options` VALUES("66", "image_default_link_type", "none", "yes");
INSERT INTO `wp_464683_options` VALUES("67", "image_default_size", "", "yes");
INSERT INTO `wp_464683_options` VALUES("68", "image_default_align", "", "yes");
INSERT INTO `wp_464683_options` VALUES("69", "close_comments_for_old_posts", "0", "yes");
INSERT INTO `wp_464683_options` VALUES("70", "close_comments_days_old", "14", "yes");
INSERT INTO `wp_464683_options` VALUES("71", "thread_comments", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("72", "thread_comments_depth", "5", "yes");
INSERT INTO `wp_464683_options` VALUES("73", "page_comments", "0", "yes");
INSERT INTO `wp_464683_options` VALUES("74", "comments_per_page", "50", "yes");
INSERT INTO `wp_464683_options` VALUES("75", "default_comments_page", "newest", "yes");
INSERT INTO `wp_464683_options` VALUES("76", "comment_order", "asc", "yes");
INSERT INTO `wp_464683_options` VALUES("77", "sticky_posts", "a:0:{}", "yes");
INSERT INTO `wp_464683_options` VALUES("78", "widget_categories", "a:2:{i:2;a:4:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:12:\"hierarchical\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("79", "widget_text", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("80", "widget_rss", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("81", "uninstall_plugins", "a:7:{s:11:\"counter.php\";s:23:\"count_per_day_uninstall\";s:27:\"wp-super-cache/wp-cache.php\";s:22:\"wpsupercache_uninstall\";s:31:\"advanced-access-manager/aam.php\";a:2:{i:0;s:3:\"AAM\";i:1;s:9:\"uninstall\";}s:23:\"elementor/elementor.php\";a:2:{i:0;s:21:\"Elementor\\Maintenance\";i:1;s:9:\"uninstall\";}s:41:\"better-wp-security/better-wp-security.php\";a:2:{i:0;s:10:\"ITSEC_Core\";i:1;s:16:\"handle_uninstall\";}s:33:\"classic-editor/classic-editor.php\";a:2:{i:0;s:14:\"Classic_Editor\";i:1;s:9:\"uninstall\";}s:41:\"all-in-one-favicon/all-in-one-favicon.php\";a:2:{i:0;s:15:\"AllInOneFavicon\";i:1;s:19:\"uninstallAioFavicon\";}}", "no");
INSERT INTO `wp_464683_options` VALUES("82", "timezone_string", "America/Los_Angeles", "yes");
INSERT INTO `wp_464683_options` VALUES("83", "page_for_posts", "0", "yes");
INSERT INTO `wp_464683_options` VALUES("84", "page_on_front", "287", "yes");
INSERT INTO `wp_464683_options` VALUES("85", "default_post_format", "0", "yes");
INSERT INTO `wp_464683_options` VALUES("86", "link_manager_enabled", "0", "yes");
INSERT INTO `wp_464683_options` VALUES("87", "finished_splitting_shared_terms", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("88", "site_icon", "0", "yes");
INSERT INTO `wp_464683_options` VALUES("89", "medium_large_size_w", "768", "yes");
INSERT INTO `wp_464683_options` VALUES("90", "medium_large_size_h", "0", "yes");
INSERT INTO `wp_464683_options` VALUES("91", "wp_page_for_privacy_policy", "3", "yes");
INSERT INTO `wp_464683_options` VALUES("92", "show_comments_cookies_opt_in", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("93", "initial_db_version", "44719", "yes");
INSERT INTO `wp_464683_options` VALUES("94", "wp_464683_user_roles", "a:5:{s:13:\"administrator\";a:2:{s:4:\"name\";s:13:\"Administrator\";s:12:\"capabilities\";a:62:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;s:10:\"copy_posts\";b:1;}}s:6:\"editor\";a:2:{s:4:\"name\";s:6:\"Editor\";s:12:\"capabilities\";a:35:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:10:\"copy_posts\";b:1;}}s:6:\"author\";a:2:{s:4:\"name\";s:6:\"Author\";s:12:\"capabilities\";a:10:{s:12:\"upload_files\";b:1;s:10:\"edit_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:22:\"delete_published_posts\";b:1;}}s:11:\"contributor\";a:2:{s:4:\"name\";s:11:\"Contributor\";s:12:\"capabilities\";a:5:{s:10:\"edit_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;}}s:10:\"subscriber\";a:2:{s:4:\"name\";s:10:\"Subscriber\";s:12:\"capabilities\";a:2:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;}}}", "yes");
INSERT INTO `wp_464683_options` VALUES("95", "fresh_site", "0", "yes");
INSERT INTO `wp_464683_options` VALUES("96", "widget_search", "a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("97", "widget_recent-posts", "a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("98", "widget_recent-comments", "a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("99", "widget_archives", "a:2:{i:2;a:3:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("100", "widget_meta", "a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("101", "sidebars_widgets", "a:3:{s:19:\"wp_inactive_widgets\";a:0:{}s:19:\"primary-widget-area\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:13:\"array_version\";i:3;}", "yes");
INSERT INTO `wp_464683_options` VALUES("102", "cron", "a:14:{i:1573381667;a:1:{s:34:\"wp_privacy_delete_old_export_files\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1573383600;a:1:{s:19:\"hmbkp_schedule_hook\";a:1:{s:32:\"a1224654e7ab96387b2c3b6c8e80456b\";a:3:{s:8:\"schedule\";s:6:\"weekly\";s:4:\"args\";a:1:{s:2:\"id\";s:10:\"1573308762\";}s:8:\"interval\";i:604800;}}}i:1573392500;a:2:{s:19:\"wp_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}s:25:\"delete_expired_transients\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1573392502;a:1:{s:30:\"wp_scheduled_auto_draft_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1573395160;a:2:{s:8:\"aam-cron\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}s:28:\"elementor/tracker/send_event\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1573396240;a:1:{s:10:\"itsec_cron\";a:1:{s:32:\"3ec3d6914daf50bcdb5e5b065213e29b\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:1:{i:0;s:17:\"purge-log-entries\";}s:8:\"interval\";i:86400;}}}i:1573396300;a:1:{s:10:\"itsec_cron\";a:1:{s:32:\"aa768a35ceed34e467f270ebdc5d82f4\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:1:{i:0;s:14:\"purge-lockouts\";}s:8:\"interval\";i:86400;}}}i:1573396960;a:1:{s:10:\"itsec_cron\";a:1:{s:32:\"7a0fd5d064c59cf40c3df9ad0bb6e63d\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:1:{i:0;s:11:\"clear-locks\";}s:8:\"interval\";i:86400;}}}i:1573409510;a:1:{s:15:\"itsec_cron_test\";a:1:{s:32:\"dfd2bd6d302bc2097bbc7ec4c5ec933b\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:1573409510;}}}}i:1573421267;a:3:{s:16:\"wp_version_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:17:\"wp_update_plugins\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:16:\"wp_update_themes\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1573455600;a:1:{s:19:\"hmbkp_schedule_hook\";a:1:{s:32:\"50b75a448f0ae44818db8db2b70afed2\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:1:{s:2:\"id\";s:10:\"1573308761\";}s:8:\"interval\";i:86400;}}}i:1573464467;a:1:{s:32:\"recovery_mode_clean_expired_keys\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1575883688;a:1:{s:32:\"et_core_page_resource_auto_clear\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:7:\"monthly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:2592000;}}}s:7:\"version\";i:2;}", "yes");
INSERT INTO `wp_464683_options` VALUES("103", "widget_pages", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("104", "widget_calendar", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("105", "widget_media_audio", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("106", "widget_media_image", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("107", "widget_media_gallery", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("108", "widget_media_video", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("109", "widget_tag_cloud", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("110", "widget_nav_menu", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("111", "widget_custom_html", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("113", "theme_mods_twentynineteen", "a:1:{s:18:\"custom_css_post_id\";i:-1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("114", "recovery_keys", "a:0:{}", "yes");
INSERT INTO `wp_464683_options` VALUES("116", "wpsupercache_gc_time", "1573291667", "yes");
INSERT INTO `wp_464683_options` VALUES("117", "vod_infomaniak", "a:18:{s:5:\"width\";i:480;s:6:\"height\";i:360;s:8:\"template\";s:7:\"{video}\";s:7:\"stretch\";i:0;s:4:\"loop\";i:0;s:8:\"autoplay\";i:0;s:7:\"privacy\";i:0;s:5:\"wtext\";s:0:\"\";s:6:\"wtitle\";s:0:\"\";s:3:\"tag\";s:3:\"vod\";s:6:\"iframe\";s:2:\"on\";s:18:\"updateFilterFolder\";s:0:\"\";s:17:\"vod_api_connected\";s:3:\"off\";s:21:\"vod_right_integration\";i:1;s:16:\"vod_right_upload\";i:1;s:16:\"vod_right_player\";i:1;s:18:\"vod_right_playlist\";i:1;s:22:\"vod_api_valid_callback\";s:3:\"off\";}", "yes");
INSERT INTO `wp_464683_options` VALUES("118", "count_per_day", "a:31:{s:7:\"version\";s:5:\"3.6.1\";s:10:\"onlinetime\";i:300;s:4:\"user\";i:0;s:10:\"user_level\";i:0;s:9:\"autocount\";i:1;s:4:\"bots\";s:143:\"bot\nspider\nsearch\ncrawler\nask.com\nvalidator\nsnoopy\nsuchen.de\nsuchbaer.de\nshelob\nsemager\nxenu\nsuch_de\nia_archiver\nMicrosoft URL Control\nnetluchs\";s:15:\"dashboard_posts\";i:20;s:20:\"dashboard_last_posts\";i:20;s:19:\"dashboard_last_days\";i:7;s:13:\"show_in_lists\";i:1;s:10:\"chart_days\";i:60;s:12:\"chart_height\";i:200;s:9:\"countries\";i:20;s:17:\"exclude_countries\";s:0:\"\";s:9:\"startdate\";s:0:\"\";s:10:\"startcount\";s:0:\"\";s:10:\"startreads\";s:0:\"\";s:5:\"anoip\";i:0;s:12:\"massbotlimit\";i:25;s:7:\"clients\";s:42:\"Firefox, Edge, MSIE, Chrome, Safari, Opera\";s:4:\"ajax\";i:0;s:5:\"debug\";i:0;s:8:\"referers\";i:1;s:12:\"referers_cut\";i:0;s:8:\"fieldlen\";i:150;s:8:\"localref\";i:1;s:18:\"dashboard_referers\";i:20;s:18:\"referers_last_days\";i:7;s:12:\"no_front_css\";i:0;s:9:\"whocansee\";s:13:\"publish_posts\";s:11:\"backup_part\";i:10000;}", "yes");
INSERT INTO `wp_464683_options` VALUES("119", "wpcaptcha_status", "disabled", "yes");
INSERT INTO `wp_464683_options` VALUES("121", "rsssl_check_redirect_dismissed", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("122", "rsssl_success_message_shown", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("123", "wpcaptcha_login", "", "yes");
INSERT INTO `wp_464683_options` VALUES("124", "wpcaptcha_register", "yes", "yes");
INSERT INTO `wp_464683_options` VALUES("125", "wpcaptcha_lost", "yes", "yes");
INSERT INTO `wp_464683_options` VALUES("126", "wpcaptcha_comments", "yes", "yes");
INSERT INTO `wp_464683_options` VALUES("127", "wpcaptcha_registered", "", "yes");
INSERT INTO `wp_464683_options` VALUES("128", "wpcaptcha_type", "alphanumeric", "yes");
INSERT INTO `wp_464683_options` VALUES("129", "wpcaptcha_letters", "capital", "yes");
INSERT INTO `wp_464683_options` VALUES("130", "wpcaptcha_total_no_of_characters", "3", "yes");
INSERT INTO `wp_464683_options` VALUES("133", "current_theme", "BlankSlate", "yes");
INSERT INTO `wp_464683_options` VALUES("134", "theme_switched", "", "yes");
INSERT INTO `wp_464683_options` VALUES("144", "et_core_version", "4.0.4", "yes");
INSERT INTO `wp_464683_options` VALUES("146", "et_divi", "a:96:{s:39:\"static_css_custom_css_safety_check_done\";b:1;s:31:\"divi_previous_installed_version\";s:0:\"\";s:29:\"divi_latest_installed_version\";s:5:\"4.0.4\";s:27:\"et_pb_clear_templates_cache\";b:1;s:21:\"custom_footer_credits\";s:192:\"Powered by <a href=\'https://wordpress.org\' target=\'_blank\'>WordPress</a> and hosted on <a href=\'https://www.infomaniak.com/en/create-a-website/wordpress-hosting\' target=\'_blank\'>Infomaniak<a/>\";s:23:\"2_5_flush_rewrite_rules\";s:4:\"done\";s:30:\"et_flush_rewrite_rules_library\";s:5:\"4.0.4\";s:9:\"divi_logo\";s:56:\"https://emilyhunt.ch/wp-content/uploads/2017/02/Logo.png\";s:12:\"divi_favicon\";s:0:\"\";s:14:\"divi_fixed_nav\";s:2:\"on\";s:26:\"divi_gallery_layout_enable\";s:5:\"false\";s:18:\"divi_color_palette\";s:63:\"#000000|#ffffff|#e02b20|#e09900|#edf000|#7cda24|#0c71c3|#8300e9\";s:15:\"divi_grab_image\";s:5:\"false\";s:15:\"divi_blog_style\";s:5:\"false\";s:22:\"divi_shop_page_sidebar\";s:16:\"et_right_sidebar\";s:23:\"divi_show_facebook_icon\";s:2:\"on\";s:22:\"divi_show_twitter_icon\";s:2:\"on\";s:21:\"divi_show_google_icon\";s:2:\"on\";s:18:\"divi_show_rss_icon\";s:2:\"on\";s:17:\"divi_facebook_url\";s:1:\"#\";s:16:\"divi_twitter_url\";s:1:\"#\";s:15:\"divi_google_url\";s:1:\"#\";s:12:\"divi_rss_url\";s:0:\"\";s:34:\"divi_woocommerce_archive_num_posts\";s:1:\"9\";s:17:\"divi_catnum_posts\";s:1:\"6\";s:21:\"divi_archivenum_posts\";s:1:\"5\";s:20:\"divi_searchnum_posts\";s:1:\"5\";s:17:\"divi_tagnum_posts\";s:1:\"5\";s:16:\"divi_date_format\";s:6:\"M j, Y\";s:16:\"divi_use_excerpt\";s:5:\"false\";s:26:\"divi_responsive_shortcodes\";s:2:\"on\";s:33:\"divi_gf_enable_all_character_sets\";s:5:\"false\";s:16:\"divi_back_to_top\";s:5:\"false\";s:18:\"divi_smooth_scroll\";s:5:\"false\";s:25:\"divi_disable_translations\";s:5:\"false\";s:15:\"divi_custom_css\";s:0:\"\";s:21:\"divi_enable_dropdowns\";s:2:\"on\";s:14:\"divi_home_link\";s:2:\"on\";s:15:\"divi_sort_pages\";s:10:\"post_title\";s:15:\"divi_order_page\";s:3:\"asc\";s:22:\"divi_tiers_shown_pages\";s:1:\"3\";s:32:\"divi_enable_dropdowns_categories\";s:2:\"on\";s:21:\"divi_categories_empty\";s:2:\"on\";s:27:\"divi_tiers_shown_categories\";s:1:\"3\";s:13:\"divi_sort_cat\";s:4:\"name\";s:14:\"divi_order_cat\";s:3:\"asc\";s:20:\"divi_disable_toptier\";s:5:\"false\";s:25:\"divi_scroll_to_anchor_fix\";s:5:\"false\";s:14:\"divi_postinfo2\";a:4:{i:0;s:6:\"author\";i:1;s:4:\"date\";i:2;s:10:\"categories\";i:3;s:8:\"comments\";}s:22:\"divi_show_postcomments\";s:2:\"on\";s:15:\"divi_thumbnails\";s:2:\"on\";s:20:\"divi_page_thumbnails\";s:5:\"false\";s:23:\"divi_show_pagescomments\";s:5:\"false\";s:14:\"divi_postinfo1\";a:3:{i:0;s:6:\"author\";i:1;s:4:\"date\";i:2;s:10:\"categories\";}s:21:\"divi_thumbnails_index\";s:2:\"on\";s:19:\"divi_seo_home_title\";s:5:\"false\";s:25:\"divi_seo_home_description\";s:5:\"false\";s:22:\"divi_seo_home_keywords\";s:5:\"false\";s:23:\"divi_seo_home_canonical\";s:5:\"false\";s:23:\"divi_seo_home_titletext\";s:0:\"\";s:29:\"divi_seo_home_descriptiontext\";s:0:\"\";s:26:\"divi_seo_home_keywordstext\";s:0:\"\";s:18:\"divi_seo_home_type\";s:27:\"BlogName | Blog description\";s:22:\"divi_seo_home_separate\";s:3:\" | \";s:21:\"divi_seo_single_title\";s:5:\"false\";s:27:\"divi_seo_single_description\";s:5:\"false\";s:24:\"divi_seo_single_keywords\";s:5:\"false\";s:25:\"divi_seo_single_canonical\";s:5:\"false\";s:27:\"divi_seo_single_field_title\";s:9:\"seo_title\";s:33:\"divi_seo_single_field_description\";s:15:\"seo_description\";s:30:\"divi_seo_single_field_keywords\";s:12:\"seo_keywords\";s:20:\"divi_seo_single_type\";s:21:\"Post title | BlogName\";s:24:\"divi_seo_single_separate\";s:3:\" | \";s:24:\"divi_seo_index_canonical\";s:5:\"false\";s:26:\"divi_seo_index_description\";s:5:\"false\";s:19:\"divi_seo_index_type\";s:24:\"Category name | BlogName\";s:23:\"divi_seo_index_separate\";s:3:\" | \";s:28:\"divi_integrate_header_enable\";s:2:\"on\";s:26:\"divi_integrate_body_enable\";s:2:\"on\";s:31:\"divi_integrate_singletop_enable\";s:2:\"on\";s:34:\"divi_integrate_singlebottom_enable\";s:2:\"on\";s:21:\"divi_integration_head\";s:0:\"\";s:21:\"divi_integration_body\";s:0:\"\";s:27:\"divi_integration_single_top\";s:0:\"\";s:30:\"divi_integration_single_bottom\";s:0:\"\";s:15:\"divi_468_enable\";s:5:\"false\";s:14:\"divi_468_image\";s:0:\"\";s:12:\"divi_468_url\";s:0:\"\";s:16:\"divi_468_adsense\";s:0:\"\";s:23:\"builder_custom_defaults\";O:8:\"stdClass\":0:{}s:33:\"customizer_settings_migrated_flag\";b:1;s:34:\"builder_custom_defaults_unmigrated\";b:0;s:40:\"divi_email_provider_credentials_migrated\";b:1;s:15:\"divi_1_3_images\";s:7:\"checked\";s:21:\"et_pb_layouts_updated\";b:1;s:30:\"library_removed_legacy_layouts\";b:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("147", "theme_mods_divi-photography", "a:9:{s:18:\"custom_css_post_id\";i:-1;s:16:\"et_pb_css_synced\";s:3:\"yes\";s:18:\"nav_menu_locations\";a:1:{s:12:\"primary-menu\";s:28:\"msw-primary-menu-photography\";}s:32:\"nav_menu_locations[primary-menu]\";i:3;s:21:\"et_pb_layouts_updated\";s:3:\"yes\";s:39:\"et_updated_layouts_built_for_post_types\";s:3:\"yes\";s:30:\"et_pb_predefined_layouts_added\";s:2:\"on\";s:34:\"et_pb_predefined_layouts_version_2\";s:2:\"on\";s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1573308396;s:4:\"data\";a:8:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:9:\"sidebar-2\";a:0:{}s:9:\"sidebar-3\";a:0:{}s:9:\"sidebar-4\";a:0:{}s:9:\"sidebar-5\";a:0:{}s:9:\"sidebar-6\";a:0:{}s:9:\"sidebar-7\";a:0:{}}}}", "yes");
INSERT INTO `wp_464683_options` VALUES("148", "widget_countperday_widget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("149", "widget_countperday_popular_posts_widget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("150", "widget_aboutmewidget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("151", "widget_adsensewidget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("152", "widget_advwidget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("153", "et_support_site_id", "*3vOh8tdPZHb2XkW+cra", "yes");
INSERT INTO `wp_464683_options` VALUES("154", "et_safe_mode_plugins_whitelist", "a:8:{i:0;s:15:\"etdev/etdev.php\";i:1;s:15:\"bloom/bloom.php\";i:2;s:19:\"monarch/monarch.php\";i:3;s:29:\"divi-builder/divi-builder.php\";i:4;s:27:\"ari-adminer/ari-adminer.php\";i:5;s:31:\"query-monitor/query-monitor.php\";i:6;s:27:\"woocommerce/woocommerce.php\";i:7;s:47:\"really-simple-ssl/rlrsssl-really-simple-ssl.php\";}", "yes");
INSERT INTO `wp_464683_options` VALUES("156", "et_images_temp_folder", "/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content/uploads/et_temp", "yes");
INSERT INTO `wp_464683_options` VALUES("157", "et_schedule_clean_images_last_time", "1573291670", "yes");
INSERT INTO `wp_464683_options` VALUES("158", "et_bfb_settings", "a:2:{s:10:\"enable_bfb\";s:2:\"on\";s:10:\"toggle_bfb\";s:2:\"on\";}", "yes");
INSERT INTO `wp_464683_options` VALUES("164", "et_pb_builder_plugin_status", "activated", "yes");
INSERT INTO `wp_464683_options` VALUES("169", "et_automatic_updates_options", "a:3:{s:3:\"msf\";i:1;s:8:\"username\";s:10:\"infomaniak\";s:7:\"api_key\";s:40:\"138f1cc01db72d0d493f370fd6cf106b07d0cec3\";}", "yes");
INSERT INTO `wp_464683_options` VALUES("173", "category_children", "a:0:{}", "yes");
INSERT INTO `wp_464683_options` VALUES("174", "project_category_children", "a:0:{}", "yes");
INSERT INTO `wp_464683_options` VALUES("178", "et_google_api_settings", "a:2:{s:7:\"api_key\";s:39:\"AIzaSyCQAUxzgyd1PuZqS7yYYDWaOo7mpQOBi1E\";s:26:\"enqueue_google_maps_script\";s:2:\"on\";}", "yes");
INSERT INTO `wp_464683_options` VALUES("182", "count_per_day_online", "a:1:{s:13:\"83.166.138.99\";a:2:{i:0;i:1573308390;i:1;i:38;}}", "yes");
INSERT INTO `wp_464683_options` VALUES("183", "et_pb_builder_options", "a:2:{i:0;b:0;s:35:\"email_provider_credentials_migrated\";b:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("192", "duplicate_post_copytitle", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("193", "duplicate_post_copydate", "0", "yes");
INSERT INTO `wp_464683_options` VALUES("194", "duplicate_post_copystatus", "0", "yes");
INSERT INTO `wp_464683_options` VALUES("195", "duplicate_post_copyslug", "0", "yes");
INSERT INTO `wp_464683_options` VALUES("196", "duplicate_post_copyexcerpt", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("197", "duplicate_post_copycontent", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("198", "duplicate_post_copythumbnail", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("199", "duplicate_post_copytemplate", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("200", "duplicate_post_copyformat", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("201", "duplicate_post_copyauthor", "0", "yes");
INSERT INTO `wp_464683_options` VALUES("202", "duplicate_post_copypassword", "0", "yes");
INSERT INTO `wp_464683_options` VALUES("203", "duplicate_post_copyattachments", "0", "yes");
INSERT INTO `wp_464683_options` VALUES("204", "duplicate_post_copychildren", "0", "yes");
INSERT INTO `wp_464683_options` VALUES("205", "duplicate_post_copycomments", "0", "yes");
INSERT INTO `wp_464683_options` VALUES("206", "duplicate_post_copymenuorder", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("207", "duplicate_post_taxonomies_blacklist", "a:0:{}", "yes");
INSERT INTO `wp_464683_options` VALUES("208", "duplicate_post_blacklist", "", "yes");
INSERT INTO `wp_464683_options` VALUES("209", "duplicate_post_types_enabled", "a:2:{i:0;s:4:\"post\";i:1;s:4:\"page\";}", "yes");
INSERT INTO `wp_464683_options` VALUES("210", "duplicate_post_show_row", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("211", "duplicate_post_show_adminbar", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("212", "duplicate_post_show_submitbox", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("213", "duplicate_post_show_bulkactions", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("214", "duplicate_post_version", "3.2.3", "yes");
INSERT INTO `wp_464683_options` VALUES("215", "duplicate_post_show_notice", "0", "no");
INSERT INTO `wp_464683_options` VALUES("216", "shop_catalog_image_size", "a:3:{s:5:\"width\";s:3:\"400\";s:6:\"height\";s:3:\"400\";s:4:\"crop\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("217", "shop_single_image_size", "a:3:{s:5:\"width\";s:3:\"510\";s:6:\"height\";s:4:\"9999\";s:4:\"crop\";i:0;}", "yes");
INSERT INTO `wp_464683_options` VALUES("218", "shop_thumbnail_image_size", "a:3:{s:5:\"width\";s:3:\"157\";s:6:\"height\";s:3:\"157\";s:4:\"crop\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("241", "can_compress_scripts", "0", "no");
INSERT INTO `wp_464683_options` VALUES("242", "et_account_status", "active", "no");
INSERT INTO `wp_464683_options` VALUES("243", "et_account_status_last_checked", "1573306109", "no");
INSERT INTO `wp_464683_options` VALUES("247", "recently_activated", "a:7:{s:41:\"captcha-code-authentication/wpCaptcha.php\";i:1573308603;s:25:\"count-per-day/counter.php\";i:1573308603;s:33:\"instant-images/instant-images.php\";i:1573308603;s:47:\"really-simple-ssl/rlrsssl-really-simple-ssl.php\";i:1573308603;s:22:\"vod-infomaniak/vod.php\";i:1573308603;s:41:\"wordpress-importer/wordpress-importer.php\";i:1573308603;s:27:\"wp-super-cache/wp-cache.php\";i:1573308603;}", "yes");
INSERT INTO `wp_464683_options` VALUES("260", "theme_mods_blankslate", "a:3:{i:0;b:0;s:18:\"nav_menu_locations\";a:1:{s:9:\"main-menu\";s:28:\"msw-primary-menu-photography\";}s:18:\"custom_css_post_id\";i:285;}", "yes");
INSERT INTO `wp_464683_options` VALUES("267", "WPLANG", "", "yes");
INSERT INTO `wp_464683_options` VALUES("268", "new_admin_email", "stickysites@protonmail.com", "yes");
INSERT INTO `wp_464683_options` VALUES("273", "disable_comments_options", "a:4:{s:19:\"disabled_post_types\";a:3:{i:0;s:4:\"post\";i:1;s:4:\"page\";i:2;s:10:\"attachment\";}s:17:\"remove_everywhere\";b:1;s:16:\"extra_post_types\";b:0;s:10:\"db_version\";i:6;}", "yes");
INSERT INTO `wp_464683_options` VALUES("274", "duplicator_settings", "a:15:{s:7:\"version\";s:6:\"1.3.22\";s:18:\"uninstall_settings\";b:1;s:15:\"uninstall_files\";b:1;s:16:\"uninstall_tables\";b:1;s:13:\"package_debug\";b:0;s:17:\"package_mysqldump\";b:1;s:22:\"package_mysqldump_path\";s:0:\"\";s:24:\"package_phpdump_qrylimit\";s:3:\"100\";s:17:\"package_zip_flush\";b:0;s:20:\"storage_htaccess_off\";b:0;s:18:\"archive_build_mode\";i:2;s:17:\"skip_archive_scan\";b:0;s:21:\"unhook_third_party_js\";b:0;s:22:\"unhook_third_party_css\";b:0;s:17:\"active_package_id\";i:3;}", "yes");
INSERT INTO `wp_464683_options` VALUES("275", "duplicator_version_plugin", "1.3.22", "yes");
INSERT INTO `wp_464683_options` VALUES("278", "elementor_extras_do_activation_redirect", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("286", "itsec_cron", "a:2:{s:6:\"single\";a:0:{}s:9:\"recurring\";a:3:{s:17:\"purge-log-entries\";a:1:{s:4:\"data\";a:0:{}}s:14:\"purge-lockouts\";a:1:{s:4:\"data\";a:0:{}}s:11:\"clear-locks\";a:1:{s:4:\"data\";a:0:{}}}}", "no");
INSERT INTO `wp_464683_options` VALUES("292", "signals_csmm_options", "a:69:{s:6:\"status\";s:1:\"2\";s:5:\"title\";s:25:\"Emily Hunt is coming soon\";s:11:\"description\";s:66:\"We are doing some maintenance on our site. Please come back later.\";s:4:\"love\";s:1:\"0\";s:11:\"header_text\";s:23:\"Our site is coming soon\";s:14:\"secondary_text\";s:147:\"We are doing some maintenance on our site. It won\'t take long, we promise. Come back and visit us again in a few days. Thank you for your patience!\";s:13:\"antispam_text\";s:26:\"And yes, we hate spam too!\";s:16:\"custom_login_url\";s:7:\"/login/\";s:14:\"show_logged_in\";s:1:\"1\";s:17:\"show_login_button\";s:1:\"0\";s:10:\"exclude_se\";s:1:\"0\";s:7:\"arrange\";s:31:\"logo,header,secondary,form,html\";s:9:\"analytics\";s:0:\"\";s:16:\"disable_adminbar\";s:1:\"0\";s:19:\"settings_customized\";s:1:\"0\";s:18:\"mailoptin_campaign\";i:0;s:26:\"notificationx_notification\";i:0;s:18:\"mail_system_to_use\";s:2:\"mc\";s:13:\"mailchimp_api\";s:0:\"\";s:14:\"mailchimp_list\";s:0:\"\";s:15:\"message_noemail\";s:37:\"Please provide a valid email address.\";s:18:\"message_subscribed\";s:27:\"You are already subscribed!\";s:13:\"message_wrong\";s:27:\"Oops! Something went wrong.\";s:12:\"message_done\";s:29:\"Thank you! We\'ll be in touch!\";s:4:\"logo\";s:109:\"https://emilyhunt.ch/wp-content/plugins/minimal-coming-soon-maintenance-mode/framework/public/img/mm-logo.png\";s:7:\"favicon\";s:112:\"https://emilyhunt.ch/wp-content/plugins/minimal-coming-soon-maintenance-mode/framework/public/img/mm-favicon.png\";s:8:\"bg_cover\";s:113:\"https://emilyhunt.ch/wp-content/plugins/minimal-coming-soon-maintenance-mode/framework/public/img/mountain-bg.jpg\";s:15:\"content_overlay\";i:1;s:13:\"content_width\";s:3:\"600\";s:8:\"bg_color\";s:6:\"FFFFFF\";s:16:\"content_position\";s:6:\"center\";s:17:\"content_alignment\";s:4:\"left\";s:11:\"header_font\";s:5:\"Karla\";s:14:\"secondary_font\";s:5:\"Karla\";s:16:\"header_font_size\";s:2:\"28\";s:19:\"secondary_font_size\";s:2:\"14\";s:17:\"header_font_color\";s:6:\"FFFFFF\";s:20:\"secondary_font_color\";s:6:\"FFFFFF\";s:18:\"antispam_font_size\";s:2:\"13\";s:19:\"antispam_font_color\";s:6:\"BBBBBB\";s:10:\"input_text\";s:29:\"Enter your best email address\";s:11:\"button_text\";s:9:\"Subscribe\";s:9:\"gdpr_text\";s:80:\"I understand the site\'s privacy policy and am willingly sharing my email address\";s:9:\"gdpr_fail\";s:62:\"Please confirm the subscription terms with the checkbox below.\";s:18:\"ignore_form_styles\";i:1;s:15:\"input_font_size\";s:2:\"13\";s:16:\"button_font_size\";s:2:\"12\";s:16:\"input_font_color\";s:6:\"FFFFFF\";s:17:\"button_font_color\";s:6:\"FFFFFF\";s:8:\"input_bg\";s:0:\"\";s:9:\"button_bg\";s:6:\"0F0F0F\";s:14:\"input_bg_hover\";s:0:\"\";s:15:\"button_bg_hover\";s:6:\"0A0A0A\";s:12:\"input_border\";s:6:\"EEEEEE\";s:13:\"button_border\";s:6:\"0F0F0F\";s:18:\"input_border_hover\";s:6:\"BBBBBB\";s:19:\"button_border_hover\";s:6:\"0A0A0A\";s:18:\"success_background\";s:6:\"90C695\";s:13:\"success_color\";s:6:\"FFFFFF\";s:16:\"error_background\";s:6:\"E08283\";s:11:\"error_color\";s:6:\"FFFFFF\";s:22:\"form_placeholder_color\";s:6:\"DEDEDE\";s:16:\"disable_settings\";s:1:\"2\";s:11:\"custom_html\";s:0:\"\";s:10:\"custom_css\";s:0:\"\";s:8:\"block_se\";s:0:\"\";s:14:\"tracking_pixel\";s:0:\"\";s:14:\"social_preview\";s:0:\"\";s:20:\"signals_ip_whitelist\";s:0:\"\";}", "yes");
INSERT INTO `wp_464683_options` VALUES("293", "signals_csmm_meta", "a:3:{s:13:\"first_version\";s:4:\"2.07\";s:17:\"first_install_gmt\";i:1573308760;s:13:\"first_install\";d:1573279960;}", "yes");
INSERT INTO `wp_464683_options` VALUES("294", "password_protected_version", "2.2.5", "yes");
INSERT INTO `wp_464683_options` VALUES("295", "itsec-storage", "a:4:{s:6:\"global\";a:33:{s:15:\"lockout_message\";s:5:\"error\";s:20:\"user_lockout_message\";s:64:\"You have been locked out due to too many invalid login attempts.\";s:25:\"community_lockout_message\";s:77:\"Your IP address has been flagged as a threat by the iThemes Security network.\";s:9:\"blacklist\";b:1;s:15:\"blacklist_count\";i:3;s:16:\"blacklist_period\";i:7;s:14:\"lockout_period\";i:15;s:18:\"lockout_white_list\";a:0:{}s:12:\"log_rotation\";i:60;s:17:\"file_log_rotation\";i:180;s:8:\"log_type\";s:8:\"database\";s:12:\"log_location\";s:97:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content/uploads/ithemes-security/logs\";s:8:\"log_info\";s:0:\"\";s:14:\"allow_tracking\";b:0;s:11:\"write_files\";b:1;s:10:\"nginx_file\";s:67:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/nginx.conf\";s:24:\"infinitewp_compatibility\";b:0;s:11:\"did_upgrade\";b:0;s:9:\"lock_file\";b:0;s:5:\"proxy\";s:9:\"automatic\";s:12:\"proxy_header\";s:20:\"HTTP_X_FORWARDED_FOR\";s:14:\"hide_admin_bar\";b:0;s:16:\"show_error_codes\";b:0;s:19:\"show_security_check\";b:0;s:5:\"build\";i:4114;s:13:\"initial_build\";i:4114;s:20:\"activation_timestamp\";i:1573308760;s:11:\"cron_status\";i:1;s:8:\"use_cron\";b:1;s:14:\"cron_test_time\";i:1573409510;s:19:\"enable_grade_report\";b:0;s:10:\"server_ips\";a:0:{}s:13:\"feature_flags\";a:0:{}}s:19:\"network-brute-force\";a:5:{s:7:\"api_key\";s:32:\"4Gii0i94uWL9b84tMg6zm1NZ90ao7rvA\";s:10:\"api_secret\";s:128:\"8U8Y4xznp6QJQt3IwpMOpJ5tCtH2ArQf90js9Fnm2eW155Dm2dw3ITj88Q5l37G9320r1Fn70fribh8dn03VHSV36F3Kd5Ya76DW5CtHd4rybP7bICh44t9767pOUw28\";s:10:\"enable_ban\";b:1;s:13:\"updates_optin\";b:0;s:7:\"api_nag\";b:0;}s:19:\"notification-center\";a:8:{s:10:\"from_email\";s:0:\"\";s:18:\"default_recipients\";a:1:{s:9:\"user_list\";a:1:{i:0;s:1:\"1\";}}s:13:\"notifications\";a:3:{s:6:\"backup\";a:2:{s:7:\"subject\";N;s:10:\"email_list\";a:1:{i:0;s:26:\"stickysites@protonmail.com\";}}s:6:\"digest\";a:5:{s:7:\"enabled\";b:1;s:7:\"subject\";N;s:8:\"schedule\";s:5:\"daily\";s:14:\"recipient_type\";s:7:\"default\";s:9:\"user_list\";a:1:{i:0;s:18:\"role:administrator\";}}s:7:\"lockout\";a:4:{s:7:\"enabled\";b:1;s:7:\"subject\";N;s:14:\"recipient_type\";s:7:\"default\";s:9:\"user_list\";a:1:{i:0;s:18:\"role:administrator\";}}}s:9:\"last_sent\";a:0:{}s:4:\"data\";a:0:{}s:9:\"resend_at\";a:0:{}s:12:\"admin_emails\";a:0:{}s:15:\"last_mail_error\";s:0:\"\";}s:11:\"brute-force\";a:4:{s:17:\"max_attempts_host\";i:2;s:17:\"max_attempts_user\";i:5;s:12:\"check_period\";i:60;s:14:\"auto_ban_admin\";b:1;}}", "yes");
INSERT INTO `wp_464683_options` VALUES("296", "itsec_temp_whitelist_ip", "a:1:{s:11:\"88.8.240.47\";i:1573464148;}", "no");
INSERT INTO `wp_464683_options` VALUES("297", "elementor_version", "2.7.5", "yes");
INSERT INTO `wp_464683_options` VALUES("298", "elementor_pro_version", "2.7.3", "yes");
INSERT INTO `wp_464683_options` VALUES("299", "widget_textblockswidget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("300", "widget_aam_backend_login", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("301", "widget_elementor-library", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("303", "wpmss_settings", "a:1:{s:7:\"general\";a:13:{s:11:\"plugin_sent\";s:1:\"1\";s:9:\"timestamp\";s:10:\"1573309287\";s:9:\"frameRate\";s:3:\"150\";s:13:\"animationTime\";s:4:\"1000\";s:8:\"stepSize\";s:3:\"100\";s:10:\"pulseScale\";s:1:\"4\";s:14:\"pulseNormalize\";s:1:\"1\";s:17:\"accelerationDelta\";s:2:\"50\";s:15:\"accelerationMax\";s:1:\"3\";s:15:\"keyboardSupport\";s:1:\"1\";s:11:\"arrowScroll\";s:3:\"480\";s:15:\"fixedBackground\";s:1:\"1\";s:15:\"allowedBrowsers\";a:4:{i:0;s:6:\"IEWin7\";i:1;s:6:\"Chrome\";i:2;s:6:\"Safari\";i:3;s:7:\"Firefox\";}}}", "yes");
INSERT INTO `wp_464683_options` VALUES("304", "_elementor_pro_installed_time", "1573308761", "yes");
INSERT INTO `wp_464683_options` VALUES("305", "hmbkp_plugin_version", "3.10", "yes");
INSERT INTO `wp_464683_options` VALUES("306", "elementor_extras_widgets", "a:28:{s:12:\"enable_posts\";s:3:\"off\";s:15:\"enable_timeline\";s:3:\"off\";s:14:\"enable_gallery\";s:2:\"on\";s:21:\"enable_gallery_slider\";s:2:\"on\";s:23:\"enable_scroll_indicator\";s:3:\"off\";s:15:\"enable_hotspots\";s:3:\"off\";s:15:\"enable_switcher\";s:3:\"off\";s:14:\"enable_devices\";s:3:\"off\";s:15:\"enable_calendar\";s:3:\"off\";s:16:\"enable_offcanvas\";s:3:\"off\";s:17:\"enable_slide_menu\";s:3:\"off\";s:18:\"enable_search_form\";s:3:\"off\";s:21:\"enable_toggle_element\";s:3:\"off\";s:17:\"enable_google_map\";s:3:\"off\";s:13:\"enable_unfold\";s:3:\"off\";s:18:\"enable_html5_video\";s:3:\"off\";s:19:\"enable_audio_player\";s:3:\"off\";s:22:\"enable_circle_progress\";s:3:\"off\";s:19:\"enable_random_image\";s:3:\"off\";s:23:\"enable_image_comparison\";s:3:\"off\";s:12:\"enable_popup\";s:3:\"off\";s:15:\"enable_age_gate\";s:3:\"off\";s:19:\"enable_button_group\";s:3:\"off\";s:17:\"enable_inline_svg\";s:2:\"on\";s:14:\"enable_heading\";s:2:\"on\";s:19:\"enable_text_divider\";s:2:\"on\";s:12:\"enable_table\";s:2:\"on\";s:18:\"enable_breadcrumbs\";s:3:\"off\";}", "yes");
INSERT INTO `wp_464683_options` VALUES("307", "elementor_extras_extensions", "a:6:{s:25:\"enable_display_conditions\";s:3:\"off\";s:25:\"enable_portfolio_parallax\";s:3:\"off\";s:22:\"enable_sticky_elements\";s:2:\"on\";s:24:\"enable_parallax_elements\";s:3:\"off\";s:26:\"enable_parallax_background\";s:3:\"off\";s:14:\"enable_tooltip\";s:3:\"off\";}", "yes");
INSERT INTO `wp_464683_options` VALUES("308", "elementor_extras_apis", "", "yes");
INSERT INTO `wp_464683_options` VALUES("309", "elementor_extras_advanced", "", "yes");
INSERT INTO `wp_464683_options` VALUES("310", "granular_general_settings", "", "yes");
INSERT INTO `wp_464683_options` VALUES("311", "granular_editor_settings", "a:9:{s:20:\"granular_editor_skin\";s:0:\"\";s:22:\"granular_editor_hack_2\";s:2:\"no\";s:27:\"granular_editor_parallax_on\";s:2:\"no\";s:28:\"granular_editor_particles_on\";s:2:\"no\";s:23:\"granular_editor_exit_on\";s:3:\"yes\";s:26:\"granular_editor_exit_point\";s:10:\"type_pages\";s:27:\"granular_editor_exit_target\";s:0:\"\";s:25:\"granular_editor_exit_name\";s:17:\"Exit To Dashboard\";s:30:\"granular_editor_live_view_name\";s:14:\"View Live Page\";}", "yes");
INSERT INTO `wp_464683_options` VALUES("312", "granular_advanced_settings", "", "yes");
INSERT INTO `wp_464683_options` VALUES("315", "hmbkp_schedule_1573308761", "a:7:{s:11:\"max_backups\";i:7;s:8:\"excludes\";a:0:{}s:4:\"type\";s:8:\"database\";s:12:\"reoccurrence\";s:5:\"daily\";s:19:\"schedule_start_time\";d:1573369200;s:14:\"duration_total\";i:1573377749;s:16:\"backup_run_count\";i:1;}", "yes");
INSERT INTO `wp_464683_options` VALUES("316", "hmbkp_schedule_1573308762", "a:5:{s:11:\"max_backups\";i:3;s:8:\"excludes\";a:0:{}s:4:\"type\";s:8:\"complete\";s:12:\"reoccurrence\";s:6:\"weekly\";s:19:\"schedule_start_time\";d:1573383600;}", "yes");
INSERT INTO `wp_464683_options` VALUES("319", "_elementor_installed_time", "1573308761", "yes");
INSERT INTO `wp_464683_options` VALUES("320", "elementor_remote_info_library", "a:3:{s:10:\"types_data\";a:2:{s:5:\"block\";a:1:{s:10:\"categories\";a:22:{i:0;s:8:\"404 page\";i:1;s:5:\"about\";i:2;s:7:\"archive\";i:3;s:14:\"call to action\";i:4;s:7:\"clients\";i:5;s:7:\"contact\";i:6;s:3:\"faq\";i:7;s:8:\"features\";i:8;s:6:\"footer\";i:9;s:6:\"header\";i:10;s:4:\"hero\";i:11;s:9:\"portfolio\";i:12;s:7:\"pricing\";i:13;s:15:\"product archive\";i:14;s:8:\"services\";i:15;s:11:\"single page\";i:16;s:11:\"single post\";i:17;s:14:\"single product\";i:18;s:5:\"stats\";i:19;s:9:\"subscribe\";i:20;s:4:\"team\";i:21;s:12:\"testimonials\";}}s:5:\"popup\";a:1:{s:10:\"categories\";a:6:{i:0;s:10:\"bottom bar\";i:1;s:7:\"classic\";i:2;s:6:\"fly-in\";i:3;s:11:\"full screen\";i:4;s:9:\"hello bar\";i:5;s:8:\"slide-in\";}}}s:10:\"categories\";s:247:\"[\"404 page\",\"about\",\"archive\",\"call to action\",\"clients\",\"contact\",\"faq\",\"features\",\"footer\",\"header\",\"hero\",\"portfolio\",\"pricing\",\"product archive\",\"services\",\"single page\",\"single post\",\"single product\",\"stats\",\"subscribe\",\"team\",\"testimonials\"]\";s:9:\"templates\";a:613:{i:0;a:14:{s:2:\"id\";s:4:\"5525\";s:5:\"title\";s:8:\"About 14\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2018/03/about_white_10.png\";s:12:\"tmpl_created\";s:10:\"1520443532\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/about-14/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"13\";s:11:\"trend_index\";s:2:\"10\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:1;a:14:{s:2:\"id\";s:5:\"10107\";s:5:\"title\";s:34:\"Classic | Promotion | Announcement\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/balls_small.png\";s:12:\"tmpl_created\";s:10:\"1547851373\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:127:\"https://library.elementor.com/popups/classic-promotion-announcement/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"298\";s:11:\"trend_index\";s:3:\"284\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:2;a:14:{s:2:\"id\";s:4:\"5533\";s:5:\"title\";s:8:\"About 15\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2018/03/about_black_10.png\";s:12:\"tmpl_created\";s:10:\"1520443534\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/about-15/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"40\";s:11:\"trend_index\";s:2:\"24\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:3;a:14:{s:2:\"id\";s:4:\"5575\";s:5:\"title\";s:5:\"CTA 7\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520443543\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/cta-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"21\";s:11:\"trend_index\";s:1:\"9\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:4;a:14:{s:2:\"id\";s:4:\"5615\";s:5:\"title\";s:10:\"Features 6\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_5.png\";s:12:\"tmpl_created\";s:10:\"1520443551\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/features-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"features\";s:4:\"tags\";s:12:\"[\"features\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"37\";s:11:\"trend_index\";s:2:\"25\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:5;a:14:{s:2:\"id\";s:4:\"5624\";s:5:\"title\";s:10:\"Features 5\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/features_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443553\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/features-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"features\";s:4:\"tags\";s:12:\"[\"features\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"87\";s:11:\"trend_index\";s:2:\"67\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:6;a:14:{s:2:\"id\";s:4:\"5684\";s:5:\"title\";s:5:\"FAQ 8\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/faq_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443565\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/faq-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:3:\"faq\";s:4:\"tags\";s:7:\"[\"faq\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"77\";s:11:\"trend_index\";s:2:\"48\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:7;a:14:{s:2:\"id\";s:5:\"10158\";s:5:\"title\";s:17:\"Classic | Contact\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/01/coco_small.png\";s:12:\"tmpl_created\";s:10:\"1547852227\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/popups/classic-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"308\";s:11:\"trend_index\";s:3:\"247\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:8;a:14:{s:2:\"id\";s:4:\"5693\";s:5:\"title\";s:5:\"FAQ 9\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/faq_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443567\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/faq-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:3:\"faq\";s:4:\"tags\";s:7:\"[\"faq\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"206\";s:11:\"trend_index\";s:3:\"217\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:9;a:14:{s:2:\"id\";s:4:\"5703\";s:5:\"title\";s:6:\"FAQ 13\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/faq_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443569\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/faq-13/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:3:\"faq\";s:4:\"tags\";s:7:\"[\"faq\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"34\";s:11:\"trend_index\";s:2:\"21\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:10;a:14:{s:2:\"id\";s:4:\"5711\";s:5:\"title\";s:5:\"FAQ 1\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/faq_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443571\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/faq-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:3:\"faq\";s:4:\"tags\";s:7:\"[\"faq\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"211\";s:11:\"trend_index\";s:3:\"183\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:11;a:14:{s:2:\"id\";s:5:\"10190\";s:5:\"title\";s:30:\"Classic | Register | Subscribe\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/01/engage_small.png\";s:12:\"tmpl_created\";s:10:\"1547885703\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:125:\"https://library.elementor.com/popups/classic-register-subscribe-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"325\";s:11:\"trend_index\";s:3:\"200\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:12;a:14:{s:2:\"id\";s:4:\"5719\";s:5:\"title\";s:5:\"FAQ 4\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/faq_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520443573\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/faq-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:3:\"faq\";s:4:\"tags\";s:7:\"[\"faq\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"125\";s:11:\"trend_index\";s:3:\"101\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:13;a:14:{s:2:\"id\";s:4:\"5729\";s:5:\"title\";s:5:\"FAQ 5\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/faq_black_3.png\";s:12:\"tmpl_created\";s:10:\"1520443575\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/faq-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:3:\"faq\";s:4:\"tags\";s:7:\"[\"faq\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"302\";s:11:\"trend_index\";s:3:\"202\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:14;a:14:{s:2:\"id\";s:4:\"5737\";s:5:\"title\";s:6:\"FAQ 10\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/faq_white_4.png\";s:12:\"tmpl_created\";s:10:\"1520443576\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/faq-10/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:3:\"faq\";s:4:\"tags\";s:7:\"[\"faq\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"160\";s:11:\"trend_index\";s:3:\"116\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:15;a:14:{s:2:\"id\";s:4:\"5746\";s:5:\"title\";s:6:\"FAQ 11\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/faq_black_4.png\";s:12:\"tmpl_created\";s:10:\"1520443578\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/faq-11/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:3:\"faq\";s:4:\"tags\";s:7:\"[\"faq\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"203\";s:11:\"trend_index\";s:3:\"203\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:16;a:14:{s:2:\"id\";s:4:\"5755\";s:5:\"title\";s:5:\"FAQ 6\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/faq_white_5.png\";s:12:\"tmpl_created\";s:10:\"1520443580\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/faq-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:3:\"faq\";s:4:\"tags\";s:7:\"[\"faq\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"98\";s:11:\"trend_index\";s:2:\"92\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:17;a:14:{s:2:\"id\";s:4:\"5764\";s:5:\"title\";s:5:\"FAQ 7\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/faq_black_5.png\";s:12:\"tmpl_created\";s:10:\"1520443582\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/faq-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:3:\"faq\";s:4:\"tags\";s:7:\"[\"faq\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"301\";s:11:\"trend_index\";s:3:\"301\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:18;a:14:{s:2:\"id\";s:5:\"10256\";s:5:\"title\";s:20:\"Classic | Sale | Pop\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/fruit_small.png\";s:12:\"tmpl_created\";s:10:\"1547888909\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/popups/classic-sale-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"421\";s:11:\"trend_index\";s:3:\"343\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:19;a:14:{s:2:\"id\";s:4:\"5773\";s:5:\"title\";s:7:\"Hero 11\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2018/03/header_1.png\";s:12:\"tmpl_created\";s:10:\"1520443584\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/hero-11/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"hero\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"38\";s:11:\"trend_index\";s:2:\"20\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:20;a:14:{s:2:\"id\";s:5:\"10267\";s:5:\"title\";s:29:\"Classic | Contact | Christmas\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2019/01/christmas_small.png\";s:12:\"tmpl_created\";s:10:\"1547889047\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:122:\"https://library.elementor.com/popups/classic-contact-christmas/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"368\";s:11:\"trend_index\";s:3:\"272\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:21;a:14:{s:2:\"id\";s:4:\"5783\";s:5:\"title\";s:7:\"Hero 10\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2018/03/header_2.png\";s:12:\"tmpl_created\";s:10:\"1520443586\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/hero-10/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"hero\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"339\";s:11:\"trend_index\";s:3:\"459\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:22;a:14:{s:2:\"id\";s:4:\"5792\";s:5:\"title\";s:6:\"Hero 9\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2018/03/header_3.png\";s:12:\"tmpl_created\";s:10:\"1520443588\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/hero-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"hero\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"226\";s:11:\"trend_index\";s:3:\"210\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:23;a:14:{s:2:\"id\";s:4:\"5801\";s:5:\"title\";s:6:\"Hero 7\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2018/03/header_4.png\";s:12:\"tmpl_created\";s:10:\"1520443589\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/hero-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"hero\";s:4:\"tags\";s:10:\"[\"header\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"24\";s:11:\"trend_index\";s:2:\"14\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:24;a:14:{s:2:\"id\";s:4:\"5811\";s:5:\"title\";s:6:\"Hero 8\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2018/03/header_5.png\";s:12:\"tmpl_created\";s:10:\"1520443591\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/hero-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"hero\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"114\";s:11:\"trend_index\";s:2:\"84\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:25;a:14:{s:2:\"id\";s:5:\"10307\";s:5:\"title\";s:43:\"Fly In | Promotion | Christmas | Teddy Bear\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/teddy_small.png\";s:12:\"tmpl_created\";s:10:\"1547893266\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:123:\"https://library.elementor.com/popups/fly-in-promotion-christmas/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"526\";s:11:\"trend_index\";s:3:\"572\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:26;a:14:{s:2:\"id\";s:4:\"5820\";s:5:\"title\";s:9:\"Contact 2\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/contact_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443593\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/contact-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:11:\"[\"contact\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"184\";s:11:\"trend_index\";s:3:\"180\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:27;a:14:{s:2:\"id\";s:5:\"10318\";s:5:\"title\";s:27:\"Classic | Contact | Bicycle\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2019/01/by_small.png\";s:12:\"tmpl_created\";s:10:\"1547893367\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/popups/classic-contact-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"366\";s:11:\"trend_index\";s:3:\"350\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:28;a:14:{s:2:\"id\";s:4:\"5828\";s:5:\"title\";s:9:\"Contact 3\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/contact_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443595\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/contact-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:11:\"[\"contact\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"293\";s:11:\"trend_index\";s:3:\"394\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:29;a:14:{s:2:\"id\";s:4:\"5836\";s:5:\"title\";s:10:\"Contact 10\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/contact_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443597\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/contact-10/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:11:\"[\"contact\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"118\";s:11:\"trend_index\";s:3:\"107\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:30;a:14:{s:2:\"id\";s:5:\"10339\";s:5:\"title\";s:22:\"Fly In | Contact | Spa\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/spa_small.png\";s:12:\"tmpl_created\";s:10:\"1547893603\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/popups/fly-in-contact-spa/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"416\";s:11:\"trend_index\";s:3:\"361\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:31;a:14:{s:2:\"id\";s:4:\"5844\";s:5:\"title\";s:10:\"Contact 11\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/contact_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443599\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/contact-11/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:11:\"[\"contact\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"278\";s:11:\"trend_index\";s:3:\"337\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:32;a:14:{s:2:\"id\";s:5:\"10352\";s:5:\"title\";s:23:\"Fly In | Contact | Wine\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/01/fly_wine_small.png\";s:12:\"tmpl_created\";s:10:\"1547915335\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/popups/fly-in-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"456\";s:11:\"trend_index\";s:3:\"426\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:33;a:14:{s:2:\"id\";s:4:\"5852\";s:5:\"title\";s:6:\"CTA 34\";s:9:\"thumbnail\";s:67:\"https://library.elementor.com/wp-content/uploads/2018/03/form_1.png\";s:12:\"tmpl_created\";s:10:\"1520443600\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-34/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:8:\"[\"form\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"457\";s:11:\"trend_index\";s:3:\"351\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:34;a:14:{s:2:\"id\";s:4:\"5947\";s:5:\"title\";s:7:\"Stats 8\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/numbers_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443621\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/stats-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:9:\"[\"Stats\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"340\";s:11:\"trend_index\";s:3:\"412\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:35;a:14:{s:2:\"id\";s:5:\"10372\";s:5:\"title\";s:29:\"Fly In | Register | Subscribe\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/phone_small.png\";s:12:\"tmpl_created\";s:10:\"1547915554\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:124:\"https://library.elementor.com/popups/fly-in-register-subscribe-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"521\";s:11:\"trend_index\";s:3:\"498\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:36;a:14:{s:2:\"id\";s:4:\"5956\";s:5:\"title\";s:7:\"Stats 7\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/numbers_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443623\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/stats-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:9:\"[\"Stats\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"448\";s:11:\"trend_index\";s:3:\"490\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:37;a:14:{s:2:\"id\";s:5:\"10382\";s:5:\"title\";s:35:\"Bottom Bar | Announcement | Cookies\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2019/01/bottom_pink_small.png\";s:12:\"tmpl_created\";s:10:\"1547916616\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:120:\"https://library.elementor.com/popups/bottom-bar-announcement/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:10:\"bottom bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"341\";s:11:\"trend_index\";s:3:\"290\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:38;a:14:{s:2:\"id\";s:4:\"5963\";s:5:\"title\";s:10:\"Features 7\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/features_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443626\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/features-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"features\";s:4:\"tags\";s:12:\"[\"features\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"72\";s:11:\"trend_index\";s:2:\"49\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:39;a:14:{s:2:\"id\";s:4:\"5974\";s:5:\"title\";s:10:\"Features 4\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/features_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520443629\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/features-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"features\";s:4:\"tags\";s:12:\"[\"features\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"66\";s:11:\"trend_index\";s:2:\"57\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:40;a:14:{s:2:\"id\";s:4:\"5983\";s:5:\"title\";s:10:\"Features 3\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/features_black_3.png\";s:12:\"tmpl_created\";s:10:\"1520443630\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/features-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"features\";s:4:\"tags\";s:11:\"[\"featues\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"242\";s:11:\"trend_index\";s:3:\"211\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:41;a:14:{s:2:\"id\";s:4:\"5991\";s:5:\"title\";s:11:\"Features 10\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/features_white_4.png\";s:12:\"tmpl_created\";s:10:\"1520443632\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/features-10/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"features\";s:4:\"tags\";s:12:\"[\"features\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"121\";s:11:\"trend_index\";s:2:\"93\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:42;a:14:{s:2:\"id\";s:4:\"5999\";s:5:\"title\";s:7:\"Team 14\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/team_black_10.png\";s:12:\"tmpl_created\";s:10:\"1520443634\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/team-14/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"83\";s:11:\"trend_index\";s:2:\"63\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:43;a:14:{s:2:\"id\";s:5:\"10434\";s:5:\"title\";s:27:\"Classic | Sale | Headphones\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/01/head_small.png\";s:12:\"tmpl_created\";s:10:\"1547961950\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/popups/classic-sale-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"395\";s:11:\"trend_index\";s:3:\"369\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:44;a:14:{s:2:\"id\";s:4:\"6008\";s:5:\"title\";s:6:\"Team 6\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/team_white_10.png\";s:12:\"tmpl_created\";s:10:\"1520443636\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/team-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"71\";s:11:\"trend_index\";s:2:\"59\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:45;a:14:{s:2:\"id\";s:5:\"10444\";s:5:\"title\";s:17:\"Classic | Contact\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/plant_small.png\";s:12:\"tmpl_created\";s:10:\"1547962029\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/popups/classic-contact-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"413\";s:11:\"trend_index\";s:3:\"400\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:46;a:14:{s:2:\"id\";s:4:\"6027\";s:5:\"title\";s:7:\"About 5\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/about_white_1-1.png\";s:12:\"tmpl_created\";s:10:\"1520443639\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/about-5-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"42\";s:11:\"trend_index\";s:2:\"37\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:47;a:14:{s:2:\"id\";s:4:\"6036\";s:5:\"title\";s:7:\"About 6\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/about_black_1-1.png\";s:12:\"tmpl_created\";s:10:\"1520443641\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/about-6-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"89\";s:11:\"trend_index\";s:2:\"83\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:48;a:14:{s:2:\"id\";s:5:\"10467\";s:5:\"title\";s:27:\"Bottom Bar | Contact | Lego\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/tro_small.png\";s:12:\"tmpl_created\";s:10:\"1547962277\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/popups/bottom-bar-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:10:\"bottom bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"567\";s:11:\"trend_index\";s:3:\"568\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:49;a:14:{s:2:\"id\";s:4:\"6044\";s:5:\"title\";s:11:\"Features 11\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/features_white_5.png\";s:12:\"tmpl_created\";s:10:\"1520443643\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/features-11/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"features\";s:4:\"tags\";s:12:\"[\"features\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"76\";s:11:\"trend_index\";s:2:\"77\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:50;a:14:{s:2:\"id\";s:4:\"6053\";s:5:\"title\";s:10:\"Features 1\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/features_black_5.png\";s:12:\"tmpl_created\";s:10:\"1520443645\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/features-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"features\";s:4:\"tags\";s:12:\"[\"features\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"172\";s:11:\"trend_index\";s:3:\"117\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:51;a:14:{s:2:\"id\";s:5:\"10487\";s:5:\"title\";s:18:\"Slide In | Contact\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/acc_small.png\";s:12:\"tmpl_created\";s:10:\"1547964527\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/popups/slide-in-contact-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"498\";s:11:\"trend_index\";s:3:\"404\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:52;a:14:{s:2:\"id\";s:4:\"6063\";s:5:\"title\";s:7:\"Stats 5\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/numbers_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443647\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/stats-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:11:\"[\"numbers\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"156\";s:11:\"trend_index\";s:3:\"193\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:53;a:14:{s:2:\"id\";s:5:\"10498\";s:5:\"title\";s:14:\"Classic | Sale\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/01/pink_small-1.png\";s:12:\"tmpl_created\";s:10:\"1547964616\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/popups/classic-sale-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"436\";s:11:\"trend_index\";s:3:\"345\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:54;a:14:{s:2:\"id\";s:4:\"6071\";s:5:\"title\";s:8:\"Stats 13\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/numbers_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520443649\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/stats-13/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:11:\"[\"numbers\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"158\";s:11:\"trend_index\";s:3:\"123\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:55;a:14:{s:2:\"id\";s:4:\"6079\";s:5:\"title\";s:7:\"Stats 3\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/numbers_white_4.png\";s:12:\"tmpl_created\";s:10:\"1520443651\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/stats-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:11:\"[\"numbers\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"265\";s:11:\"trend_index\";s:3:\"216\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:56;a:14:{s:2:\"id\";s:5:\"10519\";s:5:\"title\";s:27:\"Hello Bar | Promotion | App\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/app_small-1.png\";s:12:\"tmpl_created\";s:10:\"1547964801\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:122:\"https://library.elementor.com/popups/hello-bar-promotion-app-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:9:\"hello bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"515\";s:11:\"trend_index\";s:3:\"487\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:57;a:14:{s:2:\"id\";s:4:\"6089\";s:5:\"title\";s:7:\"Stats 4\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/numbers_white_5.png\";s:12:\"tmpl_created\";s:10:\"1520443653\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/stats-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:9:\"[\"Stats\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"180\";s:11:\"trend_index\";s:3:\"229\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:58;a:14:{s:2:\"id\";s:4:\"6097\";s:5:\"title\";s:7:\"Stats 6\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/numbers_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443655\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/stats-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:11:\"[\"numbers\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"260\";s:11:\"trend_index\";s:3:\"222\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:59;a:14:{s:2:\"id\";s:4:\"6106\";s:5:\"title\";s:7:\"Stats 2\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/numbers_white_6.png\";s:12:\"tmpl_created\";s:10:\"1520443657\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/stats-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:11:\"[\"numbers\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"327\";s:11:\"trend_index\";s:3:\"363\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:60;a:14:{s:2:\"id\";s:4:\"6114\";s:5:\"title\";s:7:\"Stats 1\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/numbers_black_6.png\";s:12:\"tmpl_created\";s:10:\"1520443659\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/stats-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:11:\"[\"numbers\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"358\";s:11:\"trend_index\";s:3:\"341\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:61;a:14:{s:2:\"id\";s:4:\"6122\";s:5:\"title\";s:7:\"About 8\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/about_white_2-1.png\";s:12:\"tmpl_created\";s:10:\"1520443661\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/about-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"41\";s:11:\"trend_index\";s:2:\"28\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:62;a:14:{s:2:\"id\";s:5:\"10569\";s:5:\"title\";s:15:\"Slide In | Sale\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/off_small.png\";s:12:\"tmpl_created\";s:10:\"1547967812\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/popups/slide-in-sale/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"472\";s:11:\"trend_index\";s:3:\"489\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:63;a:14:{s:2:\"id\";s:4:\"6135\";s:5:\"title\";s:8:\"About 10\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443663\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/about-10/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"85\";s:11:\"trend_index\";s:2:\"74\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:64;a:14:{s:2:\"id\";s:4:\"6144\";s:5:\"title\";s:7:\"Team 17\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/team_white_11.png\";s:12:\"tmpl_created\";s:10:\"1520443664\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/team-17/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"148\";s:11:\"trend_index\";s:3:\"140\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:65;a:14:{s:2:\"id\";s:5:\"10590\";s:5:\"title\";s:19:\"Full Screen | Login\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/pass1_small.png\";s:12:\"tmpl_created\";s:10:\"1547967978\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/popups/classic-login-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"466\";s:11:\"trend_index\";s:3:\"495\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:66;a:14:{s:2:\"id\";s:4:\"6152\";s:5:\"title\";s:7:\"Stats 9\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/progress_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443666\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/stats-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:9:\"[\"Stats\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"238\";s:11:\"trend_index\";s:3:\"243\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:67;a:14:{s:2:\"id\";s:5:\"10600\";s:5:\"title\";s:18:\"Slide In | Contact\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/01/orange_small.png\";s:12:\"tmpl_created\";s:10:\"1547968080\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/popups/slide-in-contact-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"464\";s:11:\"trend_index\";s:3:\"374\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:68;a:14:{s:2:\"id\";s:4:\"6162\";s:5:\"title\";s:11:\"Services 31\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/progress_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443668\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-31/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:9:\"[\"Stats\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"323\";s:11:\"trend_index\";s:3:\"326\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:69;a:14:{s:2:\"id\";s:4:\"6170\";s:5:\"title\";s:8:\"Stats 11\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/progress_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443670\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/stats-11/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:9:\"[\"Stats\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"320\";s:11:\"trend_index\";s:3:\"259\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:70;a:14:{s:2:\"id\";s:5:\"10622\";s:5:\"title\";s:34:\"Full Screen | Contact | Headphones\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2019/01/full_hear_small.png\";s:12:\"tmpl_created\";s:10:\"1547969678\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:118:\"https://library.elementor.com/popups/full-screen-contact-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"475\";s:11:\"trend_index\";s:3:\"535\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:71;a:14:{s:2:\"id\";s:4:\"6178\";s:5:\"title\";s:8:\"Stats 10\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/progress_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443676\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/stats-10/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:9:\"[\"Stats\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"363\";s:11:\"trend_index\";s:3:\"355\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:72;a:14:{s:2:\"id\";s:5:\"10633\";s:5:\"title\";s:23:\"Slide In | Login | Lego\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/tro_small-1.png\";s:12:\"tmpl_created\";s:10:\"1547969858\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/popups/slide-in-login/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"548\";s:11:\"trend_index\";s:3:\"545\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:73;a:14:{s:2:\"id\";s:4:\"6186\";s:5:\"title\";s:8:\"Stats 12\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/progress_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520443678\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/stats-12/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"stats\";s:4:\"tags\";s:9:\"[\"Stats\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"418\";s:11:\"trend_index\";s:3:\"393\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:74;a:14:{s:2:\"id\";s:5:\"10644\";s:5:\"title\";s:26:\"Fly In | Contact | Webinar\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/01/blue_small-1.png\";s:12:\"tmpl_created\";s:10:\"1547970814\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/popups/fly-in-contact-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"442\";s:11:\"trend_index\";s:3:\"449\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:75;a:14:{s:2:\"id\";s:4:\"6196\";s:5:\"title\";s:10:\"Features 9\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/features_white_6.png\";s:12:\"tmpl_created\";s:10:\"1520443680\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/features-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"features\";s:4:\"tags\";s:12:\"[\"features\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"107\";s:11:\"trend_index\";s:3:\"120\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:76;a:14:{s:2:\"id\";s:5:\"10654\";s:5:\"title\";s:31:\"Full Screen | Login | Christmas\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2019/01/full_login_small.png\";s:12:\"tmpl_created\";s:10:\"1547970917\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:124:\"https://library.elementor.com/popups/full-screen-login-christmas/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"530\";s:11:\"trend_index\";s:3:\"471\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:77;a:14:{s:2:\"id\";s:4:\"6204\";s:5:\"title\";s:10:\"Features 8\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/progress_black_6.png\";s:12:\"tmpl_created\";s:10:\"1520443681\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/features-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"features\";s:4:\"tags\";s:12:\"[\"features\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"215\";s:11:\"trend_index\";s:3:\"279\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:78;a:14:{s:2:\"id\";s:5:\"10664\";s:5:\"title\";s:34:\"Slide In | Contact | Gym | Fitness\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2019/01/slide_gym_small.png\";s:12:\"tmpl_created\";s:10:\"1547973928\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/popups/slide-in-contact-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"471\";s:11:\"trend_index\";s:3:\"492\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:79;a:14:{s:2:\"id\";s:4:\"6212\";s:5:\"title\";s:11:\"Features 12\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/features_white_7.png\";s:12:\"tmpl_created\";s:10:\"1520443684\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/features-12/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"features\";s:4:\"tags\";s:12:\"[\"features\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"81\";s:11:\"trend_index\";s:2:\"69\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:80;a:14:{s:2:\"id\";s:5:\"10675\";s:5:\"title\";s:35:\"Full Screen | Login | Gym | Fitness\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/01/gym_full_small.png\";s:12:\"tmpl_created\";s:10:\"1547974110\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/popups/full-screen-login-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"470\";s:11:\"trend_index\";s:3:\"317\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:81;a:14:{s:2:\"id\";s:4:\"6220\";s:5:\"title\";s:10:\"Features 2\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/features_white_8.png\";s:12:\"tmpl_created\";s:10:\"1520443685\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/features-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"features\";s:4:\"tags\";s:12:\"[\"features\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"84\";s:11:\"trend_index\";s:2:\"65\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:82;a:14:{s:2:\"id\";s:4:\"6230\";s:5:\"title\";s:6:\"Hero 6\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/heroo_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443687\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/hero-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"hero\";s:4:\"tags\";s:8:\"[\"hero\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"364\";s:11:\"trend_index\";s:3:\"427\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:83;a:14:{s:2:\"id\";s:4:\"9719\";s:5:\"title\";s:30:\"Classic | Subscribe | Register\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/01/register_small.png\";s:12:\"tmpl_created\";s:10:\"1547976107\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:123:\"https://library.elementor.com/popups/classic-subscribe-register/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"432\";s:11:\"trend_index\";s:3:\"497\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:84;a:14:{s:2:\"id\";s:4:\"6239\";s:5:\"title\";s:6:\"Hero 3\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/heroo_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443689\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/hero-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"hero\";s:4:\"tags\";s:8:\"[\"hero\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"28\";s:11:\"trend_index\";s:2:\"15\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:85;a:14:{s:2:\"id\";s:4:\"6249\";s:5:\"title\";s:6:\"Hero 5\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/heroo_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443691\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/hero-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"hero\";s:4:\"tags\";s:8:\"[\"hero\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"62\";s:11:\"trend_index\";s:2:\"35\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:86;a:14:{s:2:\"id\";s:4:\"6258\";s:5:\"title\";s:6:\"Hero 4\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/heroo_black_3.png\";s:12:\"tmpl_created\";s:10:\"1520443693\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/hero-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"hero\";s:4:\"tags\";s:8:\"[\"hero\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"396\";s:11:\"trend_index\";s:3:\"379\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:87;a:14:{s:2:\"id\";s:5:\"10137\";s:5:\"title\";s:34:\"Full Screen | Contact | Restaurant\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/01/rest_small.png\";s:12:\"tmpl_created\";s:10:\"1547976342\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/popups/full-screen-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"482\";s:11:\"trend_index\";s:3:\"392\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:88;a:14:{s:2:\"id\";s:4:\"6266\";s:5:\"title\";s:6:\"Hero 1\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/heroo_black_4.png\";s:12:\"tmpl_created\";s:10:\"1520443695\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/hero-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"hero\";s:4:\"tags\";s:8:\"[\"hero\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"53\";s:11:\"trend_index\";s:2:\"53\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:89;a:14:{s:2:\"id\";s:5:\"10244\";s:5:\"title\";s:17:\"Bottom Bar | Sale\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/wow_small.png\";s:12:\"tmpl_created\";s:10:\"1547976402\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/popups/bottom-bar-sale/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:10:\"bottom bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"513\";s:11:\"trend_index\";s:3:\"475\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:90;a:14:{s:2:\"id\";s:4:\"6274\";s:5:\"title\";s:6:\"Hero 2\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/heroo_black_5.png\";s:12:\"tmpl_created\";s:10:\"1520443698\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/hero-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"hero\";s:4:\"tags\";s:8:\"[\"hero\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"101\";s:11:\"trend_index\";s:3:\"105\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:91;a:14:{s:2:\"id\";s:4:\"6017\";s:5:\"title\";s:6:\"CTA 14\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_black_14.png\";s:12:\"tmpl_created\";s:10:\"1520520331\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-14/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"164\";s:11:\"trend_index\";s:3:\"154\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:92;a:14:{s:2:\"id\";s:5:\"10127\";s:5:\"title\";s:35:\"Fly In | Announcement | Maintenance\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/pizza_small.png\";s:12:\"tmpl_created\";s:10:\"1547984061\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:118:\"https://library.elementor.com/popups/fly-in-announcement-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"564\";s:11:\"trend_index\";s:3:\"564\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:93;a:14:{s:2:\"id\";s:4:\"4826\";s:5:\"title\";s:14:\"Testimonial 24\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520520544\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/blocks/testimonial-24-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"255\";s:11:\"trend_index\";s:3:\"253\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:94;a:14:{s:2:\"id\";s:4:\"4835\";s:5:\"title\";s:14:\"Testimonial 16\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520520546\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-16/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"369\";s:11:\"trend_index\";s:3:\"377\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:95;a:14:{s:2:\"id\";s:4:\"4843\";s:5:\"title\";s:14:\"Testimonial 18\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520520548\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-18/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"388\";s:11:\"trend_index\";s:3:\"419\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:96;a:14:{s:2:\"id\";s:4:\"4854\";s:5:\"title\";s:14:\"Testimonial 13\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520520549\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-13/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"485\";s:11:\"trend_index\";s:3:\"529\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:97;a:14:{s:2:\"id\";s:4:\"4863\";s:5:\"title\";s:14:\"Testimonial 19\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520520551\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-19/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"253\";s:11:\"trend_index\";s:3:\"238\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:98;a:14:{s:2:\"id\";s:5:\"10776\";s:5:\"title\";s:33:\"Fly In | Contact | Social | Share\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/01/social1_small.png\";s:12:\"tmpl_created\";s:10:\"1548047055\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:124:\"https://library.elementor.com/popups/fly-in-contact-social-share/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"554\";s:11:\"trend_index\";s:3:\"592\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:99;a:14:{s:2:\"id\";s:4:\"4871\";s:5:\"title\";s:14:\"Testimonial 12\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_black_3.png\";s:12:\"tmpl_created\";s:10:\"1520520552\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-12/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"241\";s:11:\"trend_index\";s:3:\"189\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:100;a:14:{s:2:\"id\";s:5:\"10785\";s:5:\"title\";s:33:\"Fly In | Contact | Social | Share\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/01/social2_small.png\";s:12:\"tmpl_created\";s:10:\"1548047593\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:126:\"https://library.elementor.com/popups/fly-in-contact-social-share-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"451\";s:11:\"trend_index\";s:3:\"391\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:101;a:14:{s:2:\"id\";s:4:\"4880\";s:5:\"title\";s:14:\"Testimonial 20\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/customers-1.jpg\";s:12:\"tmpl_created\";s:10:\"1520520554\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-20/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"371\";s:11:\"trend_index\";s:3:\"385\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:102;a:14:{s:2:\"id\";s:4:\"4889\";s:5:\"title\";s:14:\"Testimonial 11\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/customers-2.jpg\";s:12:\"tmpl_created\";s:10:\"1520520556\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-11/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"435\";s:11:\"trend_index\";s:3:\"511\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:103;a:14:{s:2:\"id\";s:4:\"4897\";s:5:\"title\";s:14:\"Testimonial 21\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_white_5.png\";s:12:\"tmpl_created\";s:10:\"1520520557\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-21/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"79\";s:11:\"trend_index\";s:2:\"50\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:104;a:14:{s:2:\"id\";s:4:\"4905\";s:5:\"title\";s:14:\"Testimonial 22\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_white_6.png\";s:12:\"tmpl_created\";s:10:\"1520520559\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-22/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"113\";s:11:\"trend_index\";s:2:\"79\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:105;a:14:{s:2:\"id\";s:4:\"4913\";s:5:\"title\";s:14:\"Testimonial 23\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_white_7.png\";s:12:\"tmpl_created\";s:10:\"1520520561\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-23/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"233\";s:11:\"trend_index\";s:3:\"207\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:106;a:14:{s:2:\"id\";s:4:\"4921\";s:5:\"title\";s:14:\"Testimonial 10\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_black_5.png\";s:12:\"tmpl_created\";s:10:\"1520520562\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-10/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"212\";s:11:\"trend_index\";s:3:\"166\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:107;a:14:{s:2:\"id\";s:4:\"4929\";s:5:\"title\";s:14:\"Testimonial 24\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_white_8.png\";s:12:\"tmpl_created\";s:10:\"1520520564\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-24/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"44\";s:11:\"trend_index\";s:2:\"26\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:108;a:14:{s:2:\"id\";s:4:\"4939\";s:5:\"title\";s:13:\"Testimonial 9\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_black_8.png\";s:12:\"tmpl_created\";s:10:\"1520520565\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/testimonial-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"88\";s:11:\"trend_index\";s:2:\"82\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:109;a:14:{s:2:\"id\";s:4:\"4947\";s:5:\"title\";s:14:\"Testimonial 27\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_white_9.png\";s:12:\"tmpl_created\";s:10:\"1520520567\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-27/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"192\";s:11:\"trend_index\";s:3:\"144\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:110;a:14:{s:2:\"id\";s:4:\"4955\";s:5:\"title\";s:14:\"Testimonial 29\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_black_9.png\";s:12:\"tmpl_created\";s:10:\"1520520569\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-29/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"324\";s:11:\"trend_index\";s:3:\"344\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:111;a:14:{s:2:\"id\";s:4:\"4963\";s:5:\"title\";s:14:\"Testimonial 25\";s:9:\"thumbnail\";s:82:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_white_10.png\";s:12:\"tmpl_created\";s:10:\"1520520570\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/blocks/testimonial-25-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"377\";s:11:\"trend_index\";s:3:\"375\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:112;a:14:{s:2:\"id\";s:4:\"4971\";s:5:\"title\";s:14:\"Testimonial 26\";s:9:\"thumbnail\";s:82:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_white_11.png\";s:12:\"tmpl_created\";s:10:\"1520520572\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-26/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"494\";s:11:\"trend_index\";s:3:\"590\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:113;a:14:{s:2:\"id\";s:4:\"4979\";s:5:\"title\";s:14:\"Testimonial 15\";s:9:\"thumbnail\";s:82:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_black_10.png\";s:12:\"tmpl_created\";s:10:\"1520520573\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-15/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"454\";s:11:\"trend_index\";s:3:\"584\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:114;a:14:{s:2:\"id\";s:4:\"4987\";s:5:\"title\";s:14:\"Testimonial 17\";s:9:\"thumbnail\";s:84:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_white_12-1.png\";s:12:\"tmpl_created\";s:10:\"1520520575\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-17/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"143\";s:11:\"trend_index\";s:3:\"156\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:115;a:14:{s:2:\"id\";s:4:\"4995\";s:5:\"title\";s:14:\"Testimonial 14\";s:9:\"thumbnail\";s:82:\"https://library.elementor.com/wp-content/uploads/2018/03/testimonials_black_12.png\";s:12:\"tmpl_created\";s:10:\"1520520577\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/testimonial-14/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:12:\"testimonials\";s:4:\"tags\";s:15:\"[\"Testimonial\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"353\";s:11:\"trend_index\";s:3:\"293\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:116;a:14:{s:2:\"id\";s:4:\"5007\";s:5:\"title\";s:11:\"Portfolio 7\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520520578\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/portfolio-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"46\";s:11:\"trend_index\";s:2:\"31\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:117;a:14:{s:2:\"id\";s:4:\"5019\";s:5:\"title\";s:11:\"Portfolio 1\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520520580\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/portfolio-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"167\";s:11:\"trend_index\";s:3:\"153\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:118;a:14:{s:2:\"id\";s:4:\"5027\";s:5:\"title\";s:12:\"Portfolio 11\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520520581\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/portfolio-11/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"295\";s:11:\"trend_index\";s:3:\"342\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:119;a:14:{s:2:\"id\";s:5:\"10794\";s:5:\"title\";s:34:\"Classic | Contact | Social | Share\";s:9:\"thumbnail\";s:68:\"https://library.elementor.com/wp-content/uploads/2019/01/s_small.png\";s:12:\"tmpl_created\";s:10:\"1548067619\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:125:\"https://library.elementor.com/popups/classic-contact-social-share/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"450\";s:11:\"trend_index\";s:3:\"413\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:120;a:14:{s:2:\"id\";s:4:\"5037\";s:5:\"title\";s:12:\"Portfolio 12\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520520583\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/portfolio-12/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"266\";s:11:\"trend_index\";s:3:\"329\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:121;a:14:{s:2:\"id\";s:4:\"5057\";s:5:\"title\";s:12:\"Portfolio 13\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_white_4.png\";s:12:\"tmpl_created\";s:10:\"1520520586\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/portfolio-13/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"219\";s:11:\"trend_index\";s:3:\"269\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:122;a:14:{s:2:\"id\";s:4:\"5071\";s:5:\"title\";s:12:\"Portfolio 14\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_white_5.png\";s:12:\"tmpl_created\";s:10:\"1520520588\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/portfolio-14/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"269\";s:11:\"trend_index\";s:3:\"261\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:123;a:14:{s:2:\"id\";s:5:\"10871\";s:5:\"title\";s:20:\"Bottom Bar | Contact\";s:9:\"thumbnail\";s:68:\"https://library.elementor.com/wp-content/uploads/2019/01/m_small.png\";s:12:\"tmpl_created\";s:10:\"1548074396\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/popups/bottom-bar-contact-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:10:\"bottom bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"553\";s:11:\"trend_index\";s:3:\"493\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:124;a:14:{s:2:\"id\";s:4:\"5082\";s:5:\"title\";s:11:\"Portfolio 4\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_black_4.png\";s:12:\"tmpl_created\";s:10:\"1520520589\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/portfolio-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"414\";s:11:\"trend_index\";s:3:\"430\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:125;a:14:{s:2:\"id\";s:5:\"10936\";s:5:\"title\";s:25:\"Full Screen | Toggle Menu\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/01/menu_small.png\";s:12:\"tmpl_created\";s:10:\"1548874587\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:120:\"https://library.elementor.com/popups/full-screen-toggle-menu/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"428\";s:11:\"trend_index\";s:3:\"409\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:126;a:14:{s:2:\"id\";s:4:\"5090\";s:5:\"title\";s:12:\"Portfolio 15\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_white_6.png\";s:12:\"tmpl_created\";s:10:\"1520520591\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/portfolio-15/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"186\";s:11:\"trend_index\";s:3:\"187\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:127;a:14:{s:2:\"id\";s:4:\"5098\";s:5:\"title\";s:12:\"Portfolio 16\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_white_7.png\";s:12:\"tmpl_created\";s:10:\"1520520593\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/portfolio-16/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"157\";s:11:\"trend_index\";s:3:\"160\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:128;a:14:{s:2:\"id\";s:4:\"5107\";s:5:\"title\";s:11:\"Portfolio 5\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_black_7.png\";s:12:\"tmpl_created\";s:10:\"1520520594\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/portfolio-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"351\";s:11:\"trend_index\";s:3:\"378\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:129;a:14:{s:2:\"id\";s:5:\"10964\";s:5:\"title\";s:59:\"Classic | Promotion | Coupon | Love | Valentine&#8217;s Day\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/02/love_small.png\";s:12:\"tmpl_created\";s:10:\"1550039106\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:121:\"https://library.elementor.com/popups/classic-promotion-coupon/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"536\";s:11:\"trend_index\";s:3:\"518\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:130;a:14:{s:2:\"id\";s:4:\"5115\";s:5:\"title\";s:12:\"Portfolio 17\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_white_8.png\";s:12:\"tmpl_created\";s:10:\"1520520596\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/portfolio-17/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"26\";s:11:\"trend_index\";s:2:\"19\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:131;a:14:{s:2:\"id\";s:5:\"10992\";s:5:\"title\";s:59:\"Classic | Promotion | Coupon | Love | Valentine&#8217;s Day\";s:9:\"thumbnail\";s:68:\"https://library.elementor.com/wp-content/uploads/2019/02/h_small.png\";s:12:\"tmpl_created\";s:10:\"1550072007\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:141:\"https://library.elementor.com/popups/classic-promotion-coupon-love-valentines-day/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"550\";s:11:\"trend_index\";s:3:\"482\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:132;a:14:{s:2:\"id\";s:4:\"5125\";s:5:\"title\";s:11:\"Portfolio 6\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_black_8.png\";s:12:\"tmpl_created\";s:10:\"1520520597\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/portfolio-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"232\";s:11:\"trend_index\";s:3:\"249\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:133;a:14:{s:2:\"id\";s:5:\"11005\";s:5:\"title\";s:50:\"Classic | Promotion | Love | Valentine&#8217;s Day\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/02/bear_small.png\";s:12:\"tmpl_created\";s:10:\"1550073303\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:134:\"https://library.elementor.com/popups/classic-promotion-love-valentines-day/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"555\";s:11:\"trend_index\";s:3:\"503\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:134;a:14:{s:2:\"id\";s:4:\"5133\";s:5:\"title\";s:12:\"Portfolio 18\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_white_9.png\";s:12:\"tmpl_created\";s:10:\"1520520599\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/portfolio-18/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"166\";s:11:\"trend_index\";s:3:\"158\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:135;a:14:{s:2:\"id\";s:4:\"5141\";s:5:\"title\";s:12:\"Portfolio 10\";s:9:\"thumbnail\";s:79:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_white_10.png\";s:12:\"tmpl_created\";s:10:\"1520520601\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/portfolio-10/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"313\";s:11:\"trend_index\";s:3:\"438\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:136;a:14:{s:2:\"id\";s:4:\"5149\";s:5:\"title\";s:11:\"Portfolio 2\";s:9:\"thumbnail\";s:79:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_black_10.png\";s:12:\"tmpl_created\";s:10:\"1520520602\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/portfolio-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"299\";s:11:\"trend_index\";s:3:\"416\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:137;a:14:{s:2:\"id\";s:4:\"5542\";s:5:\"title\";s:6:\"CTA 19\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520520681\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-19/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"162\";s:11:\"trend_index\";s:3:\"184\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:138;a:14:{s:2:\"id\";s:4:\"5550\";s:5:\"title\";s:6:\"CTA 33\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520520682\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-33/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"275\";s:11:\"trend_index\";s:3:\"214\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:139;a:14:{s:2:\"id\";s:4:\"5558\";s:5:\"title\";s:5:\"CTA 1\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520520684\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/cta-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"126\";s:11:\"trend_index\";s:3:\"129\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:140;a:14:{s:2:\"id\";s:4:\"5567\";s:5:\"title\";s:5:\"CTA 2\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520520685\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/cta-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"173\";s:11:\"trend_index\";s:3:\"181\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:141;a:14:{s:2:\"id\";s:5:\"11231\";s:5:\"title\";s:14:\"Digital Agency\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/07/Post_small1.png\";s:12:\"tmpl_created\";s:10:\"1564642380\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/blocks/digital-agency/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:30:\"[\"Digital Agency\",\"marketing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"315\";s:11:\"trend_index\";s:3:\"139\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:142;a:14:{s:2:\"id\";s:4:\"5583\";s:5:\"title\";s:6:\"CTA 26\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_black_3.png\";s:12:\"tmpl_created\";s:10:\"1520520689\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-26/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"239\";s:11:\"trend_index\";s:3:\"149\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:143;a:14:{s:2:\"id\";s:5:\"11220\";s:5:\"title\";s:14:\"Digital Agency\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/08/Archive_small1.png\";s:12:\"tmpl_created\";s:10:\"1564642385\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/blocks/digital-agency-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:30:\"[\"Digital Agency\",\"marketing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"261\";s:11:\"trend_index\";s:2:\"55\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:144;a:14:{s:2:\"id\";s:4:\"5591\";s:5:\"title\";s:5:\"CTA 5\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_4.png\";s:12:\"tmpl_created\";s:10:\"1520520691\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/cta-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"120\";s:11:\"trend_index\";s:3:\"150\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:145;a:14:{s:2:\"id\";s:5:\"11204\";s:5:\"title\";s:14:\"Digital Agency\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/07/404_small.jpg\";s:12:\"tmpl_created\";s:10:\"1564642389\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/blocks/digital-agency-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:36:\"[\"404\",\"Digital Agency\",\"marketing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"426\";s:11:\"trend_index\";s:3:\"292\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:146;a:14:{s:2:\"id\";s:4:\"5599\";s:5:\"title\";s:5:\"CTA 6\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_black_4.png\";s:12:\"tmpl_created\";s:10:\"1520520693\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/cta-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"274\";s:11:\"trend_index\";s:3:\"278\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:147;a:14:{s:2:\"id\";s:5:\"11198\";s:5:\"title\";s:14:\"Digital Agency\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/07/Header_small_3.jpg\";s:12:\"tmpl_created\";s:10:\"1564642395\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/blocks/digital-agency-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:39:\"[\"Digital Agency\",\"header\",\"marketing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"141\";s:11:\"trend_index\";s:2:\"17\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:148;a:14:{s:2:\"id\";s:4:\"5607\";s:5:\"title\";s:6:\"CTA 13\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_black_5.png\";s:12:\"tmpl_created\";s:10:\"1520520695\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-13/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"150\";s:11:\"trend_index\";s:3:\"164\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:149;a:14:{s:2:\"id\";s:5:\"11192\";s:5:\"title\";s:14:\"Digital Agency\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/07/Footer_small.jpg\";s:12:\"tmpl_created\";s:10:\"1564642399\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/blocks/digital-agency-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:39:\"[\"Digital Agency\",\"footer\",\"marketing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"348\";s:11:\"trend_index\";s:3:\"155\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:150;a:14:{s:2:\"id\";s:4:\"5634\";s:5:\"title\";s:6:\"CTA 24\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_6.png\";s:12:\"tmpl_created\";s:10:\"1520520699\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-24/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"171\";s:11:\"trend_index\";s:3:\"177\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:151;a:14:{s:2:\"id\";s:4:\"5642\";s:5:\"title\";s:6:\"CTA 25\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_black_6.png\";s:12:\"tmpl_created\";s:10:\"1520520701\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-25/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"225\";s:11:\"trend_index\";s:3:\"232\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:152;a:14:{s:2:\"id\";s:4:\"5650\";s:5:\"title\";s:5:\"CTA 9\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_7.png\";s:12:\"tmpl_created\";s:10:\"1520520702\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/cta-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"104\";s:11:\"trend_index\";s:2:\"94\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:153;a:14:{s:2:\"id\";s:4:\"5658\";s:5:\"title\";s:5:\"CTA 8\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_black_7.png\";s:12:\"tmpl_created\";s:10:\"1520520704\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/cta-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"198\";s:11:\"trend_index\";s:3:\"182\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:154;a:14:{s:2:\"id\";s:4:\"5667\";s:5:\"title\";s:5:\"CTA 3\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_8.png\";s:12:\"tmpl_created\";s:10:\"1520520705\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/cta-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"138\";s:11:\"trend_index\";s:3:\"151\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:155;a:14:{s:2:\"id\";s:4:\"5675\";s:5:\"title\";s:5:\"CTA 4\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_black_8.png\";s:12:\"tmpl_created\";s:10:\"1520520707\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/cta-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"362\";s:11:\"trend_index\";s:3:\"289\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:156;a:14:{s:2:\"id\";s:4:\"5860\";s:5:\"title\";s:6:\"CTA 17\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_9.png\";s:12:\"tmpl_created\";s:10:\"1520520746\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-17/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"132\";s:11:\"trend_index\";s:2:\"98\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:157;a:14:{s:2:\"id\";s:4:\"5869\";s:5:\"title\";s:6:\"CTA 18\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_10.png\";s:12:\"tmpl_created\";s:10:\"1520520747\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-18/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"282\";s:11:\"trend_index\";s:3:\"320\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:158;a:14:{s:2:\"id\";s:4:\"5877\";s:5:\"title\";s:6:\"CTA 16\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_black_10.png\";s:12:\"tmpl_created\";s:10:\"1520520749\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-16/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"430\";s:11:\"trend_index\";s:3:\"470\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:159;a:14:{s:2:\"id\";s:5:\"11468\";s:5:\"title\";s:20:\"Classic | Sale | Gym\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/08/PopUp_Small.png\";s:12:\"tmpl_created\";s:10:\"1567393182\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/popups/classic-sale-gym/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"588\";s:11:\"trend_index\";s:3:\"505\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:160;a:14:{s:2:\"id\";s:4:\"5885\";s:5:\"title\";s:6:\"CTA 15\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_11.png\";s:12:\"tmpl_created\";s:10:\"1520520751\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-15/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"287\";s:11:\"trend_index\";s:3:\"246\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:161;a:14:{s:2:\"id\";s:5:\"11461\";s:5:\"title\";s:3:\"GYM\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/08/Header_Small.png\";s:12:\"tmpl_created\";s:10:\"1567393219\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:100:\"https://library.elementor.com/blocks/gym/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:16:\"[\"Gym\",\"header\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"399\";s:11:\"trend_index\";s:3:\"136\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:162;a:14:{s:2:\"id\";s:4:\"5893\";s:5:\"title\";s:6:\"CTA 21\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_black_12.png\";s:12:\"tmpl_created\";s:10:\"1520520752\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-21/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"243\";s:11:\"trend_index\";s:3:\"250\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:163;a:14:{s:2:\"id\";s:5:\"11453\";s:5:\"title\";s:3:\"GYM\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/08/Footer_Small.png\";s:12:\"tmpl_created\";s:10:\"1567393224\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/gym-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:16:\"[\"footer\",\"Gym\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"425\";s:11:\"trend_index\";s:3:\"225\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:164;a:14:{s:2:\"id\";s:4:\"5904\";s:5:\"title\";s:6:\"CTA 27\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_13.png\";s:12:\"tmpl_created\";s:10:\"1520520754\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-27/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"403\";s:11:\"trend_index\";s:3:\"466\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:165;a:14:{s:2:\"id\";s:5:\"11445\";s:5:\"title\";s:3:\"GYM\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/08/Post_Small.png\";s:12:\"tmpl_created\";s:10:\"1567393229\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/gym-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:7:\"[\"Gym\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"501\";s:11:\"trend_index\";s:3:\"286\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:166;a:14:{s:2:\"id\";s:4:\"5912\";s:5:\"title\";s:6:\"CTA 28\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_black_11.png\";s:12:\"tmpl_created\";s:10:\"1520520755\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-28/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"509\";s:11:\"trend_index\";s:3:\"512\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:167;a:14:{s:2:\"id\";s:5:\"11435\";s:5:\"title\";s:3:\"GYM\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/08/Archiv_Small.png\";s:12:\"tmpl_created\";s:10:\"1567393296\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/gym-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:7:\"[\"Gym\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"497\";s:11:\"trend_index\";s:3:\"266\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:168;a:14:{s:2:\"id\";s:4:\"5921\";s:5:\"title\";s:6:\"CTA 12\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_14.png\";s:12:\"tmpl_created\";s:10:\"1520520757\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-12/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"251\";s:11:\"trend_index\";s:3:\"244\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:169;a:14:{s:2:\"id\";s:5:\"11424\";s:5:\"title\";s:3:\"GYM\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/08/404_Small.png\";s:12:\"tmpl_created\";s:10:\"1567393309\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/blocks/gym-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:13:\"[\"404\",\"Gym\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"578\";s:11:\"trend_index\";s:3:\"514\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:170;a:14:{s:2:\"id\";s:4:\"5930\";s:5:\"title\";s:6:\"CTA 11\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_white_15.png\";s:12:\"tmpl_created\";s:10:\"1520520758\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-11/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"69\";s:11:\"trend_index\";s:3:\"110\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:171;a:14:{s:2:\"id\";s:4:\"5939\";s:5:\"title\";s:6:\"CTA 10\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2018/03/cta_black_13-1.png\";s:12:\"tmpl_created\";s:10:\"1520520760\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-10/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:7:\"[\"cta\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"185\";s:11:\"trend_index\";s:3:\"185\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:172;a:14:{s:2:\"id\";s:4:\"7596\";s:5:\"title\";s:8:\"Header 1\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/header350.12.jpg\";s:12:\"tmpl_created\";s:10:\"1521546999\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/header-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:10:\"[\"header\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"36\";s:11:\"trend_index\";s:2:\"45\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:173;a:14:{s:2:\"id\";s:4:\"7615\";s:5:\"title\";s:8:\"Header 2\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/header350.1.jpg\";s:12:\"tmpl_created\";s:10:\"1521547237\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/header-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:10:\"[\"header\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"31\";s:11:\"trend_index\";s:2:\"41\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:174;a:14:{s:2:\"id\";s:4:\"7627\";s:5:\"title\";s:8:\"Footer 8\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/footer_hero_1.png\";s:12:\"tmpl_created\";s:10:\"1521547332\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/footer-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:10:\"[\"footer\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"106\";s:11:\"trend_index\";s:3:\"178\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:175;a:14:{s:2:\"id\";s:5:\"11822\";s:5:\"title\";s:30:\"Full Screen | Menu | Portfolio\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/09/PopUp_small.png\";s:12:\"tmpl_created\";s:10:\"1569429896\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:123:\"https://library.elementor.com/popups/full-screen-menu-portfolio/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"581\";s:11:\"trend_index\";s:3:\"494\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:176;a:14:{s:2:\"id\";s:4:\"7638\";s:5:\"title\";s:8:\"Footer 9\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/footer_hero_2.png\";s:12:\"tmpl_created\";s:10:\"1521547502\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/footer-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:10:\"[\"footer\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"123\";s:11:\"trend_index\";s:3:\"125\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:177;a:14:{s:2:\"id\";s:5:\"11877\";s:5:\"title\";s:27:\"Portfolio &#8211; Project 3\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/09/Project3_small.png\";s:12:\"tmpl_created\";s:10:\"1569429954\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/blocks/portfolio-project-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:34:\"[\"creative portfolio\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"579\";s:11:\"trend_index\";s:3:\"463\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:178;a:14:{s:2:\"id\";s:4:\"7663\";s:5:\"title\";s:13:\"Single Post 2\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/single_post_2_v2.jpg\";s:12:\"tmpl_created\";s:10:\"1521547761\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-post-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:24:\"[\"Blog\",\"Post\",\"Single\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"43\";s:11:\"trend_index\";s:2:\"75\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:179;a:14:{s:2:\"id\";s:5:\"11870\";s:5:\"title\";s:27:\"Portfolio &#8211; Project 2\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/09/Project2_small.png\";s:12:\"tmpl_created\";s:10:\"1569429964\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/blocks/portfolio-project-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:34:\"[\"creative portfolio\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"571\";s:11:\"trend_index\";s:3:\"448\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:180;a:14:{s:2:\"id\";s:4:\"7650\";s:5:\"title\";s:13:\"Single Post 1\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/03/single_post_1_v2.jpg\";s:12:\"tmpl_created\";s:10:\"1521557736\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-post-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:24:\"[\"Blog\",\"Post\",\"Single\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"86\";s:11:\"trend_index\";s:3:\"143\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:181;a:14:{s:2:\"id\";s:5:\"11861\";s:5:\"title\";s:27:\"Portfolio &#8211; Project 1\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/09/Project1_small.png\";s:12:\"tmpl_created\";s:10:\"1569429975\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/blocks/portfolio-project-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:34:\"[\"creative portfolio\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"570\";s:11:\"trend_index\";s:3:\"435\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:182;a:14:{s:2:\"id\";s:4:\"7686\";s:5:\"title\";s:12:\"Blog Posts 1\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2018/03/blog_posts.png\";s:12:\"tmpl_created\";s:10:\"1521558047\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/blog-posts-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:26:\"[\"archive\",\"Blog\",\"posts\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"115\";s:11:\"trend_index\";s:3:\"188\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:183;a:14:{s:2:\"id\";s:5:\"11854\";s:5:\"title\";s:9:\"Portfolio\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/09/Post_small.png\";s:12:\"tmpl_created\";s:10:\"1569429983\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/portfolio/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:34:\"[\"creative portfolio\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"533\";s:11:\"trend_index\";s:3:\"402\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:184;a:14:{s:2:\"id\";s:4:\"4676\";s:5:\"title\";s:8:\"Footer 7\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2018/03/footer_7.png\";s:12:\"tmpl_created\";s:10:\"1522014215\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/footer_7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:10:\"[\"footer\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"213\";s:11:\"trend_index\";s:3:\"287\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:185;a:14:{s:2:\"id\";s:5:\"11847\";s:5:\"title\";s:9:\"Portfolio\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/09/Archiv_small.png\";s:12:\"tmpl_created\";s:10:\"1569430010\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/portfolio-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:34:\"[\"creative portfolio\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"496\";s:11:\"trend_index\";s:3:\"212\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:186;a:14:{s:2:\"id\";s:4:\"7997\";s:5:\"title\";s:10:\"footer 014\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.1.jpg\";s:12:\"tmpl_created\";s:10:\"1524582343\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/footer-014/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"93\";s:11:\"trend_index\";s:2:\"81\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:187;a:14:{s:2:\"id\";s:5:\"11839\";s:5:\"title\";s:9:\"Portfolio\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/09/Header_small.png\";s:12:\"tmpl_created\";s:10:\"1569430015\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/portfolio-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:43:\"[\"creative portfolio\",\"header\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"465\";s:11:\"trend_index\";s:3:\"169\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:188;a:14:{s:2:\"id\";s:4:\"7982\";s:5:\"title\";s:10:\"footer 013\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.2.jpg\";s:12:\"tmpl_created\";s:10:\"1524582468\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/footer-013/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"250\";s:11:\"trend_index\";s:3:\"227\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:189;a:14:{s:2:\"id\";s:5:\"11832\";s:5:\"title\";s:9:\"Portfolio\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/09/Footer_small.png\";s:12:\"tmpl_created\";s:10:\"1569430019\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/portfolio-19/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:43:\"[\"creative portfolio\",\"footer\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"488\";s:11:\"trend_index\";s:3:\"167\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:190;a:14:{s:2:\"id\";s:4:\"7959\";s:5:\"title\";s:10:\"footer 012\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.3.jpg\";s:12:\"tmpl_created\";s:10:\"1524582605\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/footer-012/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"191\";s:11:\"trend_index\";s:3:\"255\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:191;a:14:{s:2:\"id\";s:5:\"11807\";s:5:\"title\";s:9:\"Portfolio\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/09/404_small.png\";s:12:\"tmpl_created\";s:10:\"1569430070\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/portfolio-20/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:40:\"[\"404\",\"creative portfolio\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"552\";s:11:\"trend_index\";s:3:\"408\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:192;a:14:{s:2:\"id\";s:4:\"7950\";s:5:\"title\";s:10:\"footer 011\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.4.jpg\";s:12:\"tmpl_created\";s:10:\"1524582631\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/footer-011/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"248\";s:11:\"trend_index\";s:3:\"251\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:193;a:14:{s:2:\"id\";s:4:\"7937\";s:5:\"title\";s:10:\"footer 010\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.5.jpg\";s:12:\"tmpl_created\";s:10:\"1524582665\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/footer-010/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"209\";s:11:\"trend_index\";s:3:\"268\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:194;a:14:{s:2:\"id\";s:5:\"11897\";s:5:\"title\";s:27:\"Portfolio &#8211; Project 2\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/09/Project2_small.png\";s:12:\"tmpl_created\";s:10:\"1569494236\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:118:\"https://library.elementor.com/blocks/portfolio-project-2-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:34:\"[\"creative portfolio\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"608\";s:11:\"trend_index\";s:3:\"557\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:195;a:14:{s:2:\"id\";s:4:\"7927\";s:5:\"title\";s:9:\"footer 09\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.6.jpg\";s:12:\"tmpl_created\";s:10:\"1524582691\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/footer-09/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"183\";s:11:\"trend_index\";s:3:\"219\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:196;a:14:{s:2:\"id\";s:5:\"11890\";s:5:\"title\";s:9:\"Portfolio\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/09/Header_small.png\";s:12:\"tmpl_created\";s:10:\"1571907344\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/portfolio-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:43:\"[\"creative portfolio\",\"header\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"523\";s:11:\"trend_index\";s:3:\"298\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:197;a:14:{s:2:\"id\";s:4:\"7917\";s:5:\"title\";s:9:\"footer 08\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.7.jpg\";s:12:\"tmpl_created\";s:10:\"1524582788\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/footer-08/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"102\";s:11:\"trend_index\";s:2:\"91\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:198;a:14:{s:2:\"id\";s:4:\"7904\";s:5:\"title\";s:9:\"footer 07\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.8.jpg\";s:12:\"tmpl_created\";s:10:\"1524582814\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/footer-07/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"200\";s:11:\"trend_index\";s:3:\"252\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:199;a:14:{s:2:\"id\";s:4:\"7837\";s:5:\"title\";s:9:\"footer 01\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.14.jpg\";s:12:\"tmpl_created\";s:10:\"1524582852\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/footer-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"411\";s:11:\"trend_index\";s:3:\"488\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:200;a:14:{s:2:\"id\";s:4:\"7852\";s:5:\"title\";s:9:\"footer 02\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.13.jpg\";s:12:\"tmpl_created\";s:10:\"1524582875\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/footer-02/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"218\";s:11:\"trend_index\";s:3:\"237\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:201;a:14:{s:2:\"id\";s:4:\"7862\";s:5:\"title\";s:9:\"footer 03\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.12.jpg\";s:12:\"tmpl_created\";s:10:\"1524582903\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/footer-03/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"137\";s:11:\"trend_index\";s:3:\"145\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:202;a:14:{s:2:\"id\";s:5:\"12212\";s:5:\"title\";s:28:\"Law Firm &#8211; Single Post\";s:9:\"thumbnail\";s:67:\"https://library.elementor.com/wp-content/uploads/2019/11/single.png\";s:12:\"tmpl_created\";s:10:\"1572846914\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/blocks/law-firm-single-post/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:18:\"[\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"599\";s:11:\"trend_index\";s:3:\"204\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:203;a:14:{s:2:\"id\";s:4:\"7871\";s:5:\"title\";s:9:\"footer 04\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.11.jpg\";s:12:\"tmpl_created\";s:10:\"1524582927\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/footer-04/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"100\";s:11:\"trend_index\";s:2:\"97\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:204;a:14:{s:2:\"id\";s:5:\"12203\";s:5:\"title\";s:30:\"Law Firm &#8211; Search Archiv\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/11/search_result.png\";s:12:\"tmpl_created\";s:10:\"1572846925\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:119:\"https://library.elementor.com/blocks/law-firm-search-archiv/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:18:\"[\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"611\";s:11:\"trend_index\";s:3:\"405\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:205;a:14:{s:2:\"id\";s:4:\"7884\";s:5:\"title\";s:9:\"footer 05\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.10.jpg\";s:12:\"tmpl_created\";s:10:\"1524582944\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/footer-05/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"58\";s:11:\"trend_index\";s:3:\"172\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:206;a:14:{s:2:\"id\";s:5:\"12194\";s:5:\"title\";s:23:\"Law Firm &#8211; Header\";s:9:\"thumbnail\";s:67:\"https://library.elementor.com/wp-content/uploads/2019/11/header.png\";s:12:\"tmpl_created\";s:10:\"1572846935\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/blocks/law-firm-header/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:27:\"[\"header\",\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"543\";s:11:\"trend_index\";s:2:\"44\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:207;a:14:{s:2:\"id\";s:4:\"7892\";s:5:\"title\";s:9:\"footer 06\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/footer350.9.jpg\";s:12:\"tmpl_created\";s:10:\"1524583015\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/footer-06/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"108\";s:11:\"trend_index\";s:3:\"109\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:208;a:14:{s:2:\"id\";s:5:\"12179\";s:5:\"title\";s:23:\"Law Firm &#8211; Footer\";s:9:\"thumbnail\";s:67:\"https://library.elementor.com/wp-content/uploads/2019/11/footer.png\";s:12:\"tmpl_created\";s:10:\"1572846958\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/blocks/law-firm-footer/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:27:\"[\"footer\",\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"597\";s:11:\"trend_index\";s:3:\"171\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:209;a:14:{s:2:\"id\";s:4:\"4212\";s:5:\"title\";s:11:\"Services 23\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443248\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-23/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"129\";s:11:\"trend_index\";s:3:\"121\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:210;a:14:{s:2:\"id\";s:4:\"7825\";s:5:\"title\";s:9:\"header 12\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/header350.11.jpg\";s:12:\"tmpl_created\";s:10:\"1524583273\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/header-12/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"78\";s:11:\"trend_index\";s:3:\"162\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:211;a:14:{s:2:\"id\";s:5:\"12170\";s:5:\"title\";s:23:\"Law Firm &#8211; Archiv\";s:9:\"thumbnail\";s:67:\"https://library.elementor.com/wp-content/uploads/2019/11/archiv.png\";s:12:\"tmpl_created\";s:10:\"1572846967\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/blocks/law-firm-archiv/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:18:\"[\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"605\";s:11:\"trend_index\";s:3:\"196\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:212;a:14:{s:2:\"id\";s:4:\"4227\";s:5:\"title\";s:11:\"Services 30\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443250\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-30/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"337\";s:11:\"trend_index\";s:3:\"280\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:213;a:14:{s:2:\"id\";s:4:\"7812\";s:5:\"title\";s:9:\"header 11\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/header350.10.jpg\";s:12:\"tmpl_created\";s:10:\"1524583298\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/header-11/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"109\";s:11:\"trend_index\";s:3:\"119\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:214;a:14:{s:2:\"id\";s:5:\"12164\";s:5:\"title\";s:20:\"Law Firm &#8211; 404\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2019/11/404.png\";s:12:\"tmpl_created\";s:10:\"1572846979\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/law-firm-404/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:24:\"[\"404\",\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"613\";s:11:\"trend_index\";s:3:\"477\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:215;a:14:{s:2:\"id\";s:4:\"4235\";s:5:\"title\";s:11:\"Services 18\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443251\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-18/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"289\";s:11:\"trend_index\";s:3:\"241\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:216;a:14:{s:2:\"id\";s:4:\"7724\";s:5:\"title\";s:8:\"header 4\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/header350.3.jpg\";s:12:\"tmpl_created\";s:10:\"1524583367\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/header-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"33\";s:11:\"trend_index\";s:2:\"46\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:217;a:14:{s:2:\"id\";s:4:\"4244\";s:5:\"title\";s:11:\"Services 26\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443253\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-26/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"420\";s:11:\"trend_index\";s:3:\"476\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:218;a:14:{s:2:\"id\";s:4:\"7734\";s:5:\"title\";s:8:\"header 5\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/header350.4.jpg\";s:12:\"tmpl_created\";s:10:\"1524583436\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/header-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"35\";s:11:\"trend_index\";s:2:\"78\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:219;a:14:{s:2:\"id\";s:4:\"4252\";s:5:\"title\";s:10:\"Services 9\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520443255\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/services-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"49\";s:11:\"trend_index\";s:2:\"38\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:220;a:14:{s:2:\"id\";s:4:\"7771\";s:5:\"title\";s:8:\"header 8\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/header350.7.jpg\";s:12:\"tmpl_created\";s:10:\"1524583540\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/header-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"105\";s:11:\"trend_index\";s:3:\"114\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:221;a:14:{s:2:\"id\";s:4:\"4260\";s:5:\"title\";s:11:\"Services 25\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_black_3.png\";s:12:\"tmpl_created\";s:10:\"1520443257\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-25/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"202\";s:11:\"trend_index\";s:3:\"176\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:222;a:14:{s:2:\"id\";s:4:\"7787\";s:5:\"title\";s:8:\"header 9\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/header350.8.jpg\";s:12:\"tmpl_created\";s:10:\"1524583598\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/header-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"103\";s:11:\"trend_index\";s:3:\"173\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:223;a:14:{s:2:\"id\";s:4:\"4268\";s:5:\"title\";s:10:\"Services 8\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_4.png\";s:12:\"tmpl_created\";s:10:\"1520443259\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/services-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"153\";s:11:\"trend_index\";s:3:\"254\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:224;a:14:{s:2:\"id\";s:4:\"7801\";s:5:\"title\";s:9:\"header 10\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/header350.9.jpg\";s:12:\"tmpl_created\";s:10:\"1524583659\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/header-10/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"60\";s:11:\"trend_index\";s:2:\"68\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:225;a:14:{s:2:\"id\";s:4:\"4276\";s:5:\"title\";s:11:\"Services 24\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_black_4.png\";s:12:\"tmpl_created\";s:10:\"1520443261\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-24/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"336\";s:11:\"trend_index\";s:3:\"331\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:226;a:14:{s:2:\"id\";s:4:\"7754\";s:5:\"title\";s:8:\"header 7\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/header350.6.jpg\";s:12:\"tmpl_created\";s:10:\"1524583712\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/header-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"70\";s:11:\"trend_index\";s:3:\"134\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:227;a:14:{s:2:\"id\";s:4:\"4284\";s:5:\"title\";s:10:\"Services 7\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_5.png\";s:12:\"tmpl_created\";s:10:\"1520443263\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/services-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"61\";s:11:\"trend_index\";s:2:\"47\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:228;a:14:{s:2:\"id\";s:4:\"7713\";s:5:\"title\";s:8:\"header 3\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/header350.2.jpg\";s:12:\"tmpl_created\";s:10:\"1524584780\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/header-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"47\";s:11:\"trend_index\";s:2:\"34\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:229;a:14:{s:2:\"id\";s:4:\"4293\";s:5:\"title\";s:10:\"Services 6\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_6.png\";s:12:\"tmpl_created\";s:10:\"1520443265\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/services-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"268\";s:11:\"trend_index\";s:3:\"334\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:230;a:14:{s:2:\"id\";s:4:\"7744\";s:5:\"title\";s:8:\"Header 6\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/03/header350.5.jpg\";s:12:\"tmpl_created\";s:10:\"1524584784\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/header-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"56\";s:11:\"trend_index\";s:2:\"76\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:231;a:14:{s:2:\"id\";s:4:\"4302\";s:5:\"title\";s:10:\"Services 5\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_7.png\";s:12:\"tmpl_created\";s:10:\"1520443266\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/services-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"75\";s:11:\"trend_index\";s:2:\"62\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:232;a:14:{s:2:\"id\";s:5:\"12229\";s:5:\"title\";s:33:\"Slide In | Law Firm | Information\";s:9:\"thumbnail\";s:66:\"https://library.elementor.com/wp-content/uploads/2019/11/popup.png\";s:12:\"tmpl_created\";s:10:\"1572847842\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:126:\"https://library.elementor.com/popups/slide-in-law-firm-information/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:18:\"[\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"612\";s:11:\"trend_index\";s:3:\"397\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:233;a:14:{s:2:\"id\";s:4:\"4313\";s:5:\"title\";s:11:\"Services 13\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_8.png\";s:12:\"tmpl_created\";s:10:\"1520443268\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-13/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"128\";s:11:\"trend_index\";s:3:\"147\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:234;a:14:{s:2:\"id\";s:4:\"8523\";s:5:\"title\";s:11:\"404 page 06\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2018/05/006.jpg\";s:12:\"tmpl_created\";s:10:\"1526415291\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/404-page-06/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"297\";s:11:\"trend_index\";s:3:\"398\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:235;a:14:{s:2:\"id\";s:4:\"4324\";s:5:\"title\";s:11:\"Services 14\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_9.png\";s:12:\"tmpl_created\";s:10:\"1520443270\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-14/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"294\";s:11:\"trend_index\";s:3:\"234\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:236;a:14:{s:2:\"id\";s:4:\"8524\";s:5:\"title\";s:11:\"404 page 07\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2018/05/007.jpg\";s:12:\"tmpl_created\";s:10:\"1526415337\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/404-page-07/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"286\";s:11:\"trend_index\";s:3:\"396\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:237;a:14:{s:2:\"id\";s:4:\"4332\";s:5:\"title\";s:11:\"Services 22\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_10.png\";s:12:\"tmpl_created\";s:10:\"1520443272\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-22/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"142\";s:11:\"trend_index\";s:3:\"135\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:238;a:14:{s:2:\"id\";s:4:\"8525\";s:5:\"title\";s:11:\"404 page 08\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2018/05/008.jpg\";s:12:\"tmpl_created\";s:10:\"1526415374\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/404-page-08/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"419\";s:11:\"trend_index\";s:3:\"558\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:239;a:14:{s:2:\"id\";s:4:\"4341\";s:5:\"title\";s:11:\"Services 21\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_11.png\";s:12:\"tmpl_created\";s:10:\"1520443274\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-21/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"139\";s:11:\"trend_index\";s:3:\"168\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:240;a:14:{s:2:\"id\";s:4:\"8513\";s:5:\"title\";s:11:\"404 page 04\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2018/05/004.jpg\";s:12:\"tmpl_created\";s:10:\"1526415417\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/404-page-04/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"389\";s:11:\"trend_index\";s:3:\"441\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:241;a:14:{s:2:\"id\";s:4:\"4349\";s:5:\"title\";s:11:\"Services 29\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_black_11.png\";s:12:\"tmpl_created\";s:10:\"1520443275\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-29/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"318\";s:11:\"trend_index\";s:3:\"263\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:242;a:14:{s:2:\"id\";s:4:\"8512\";s:5:\"title\";s:11:\"404 page 03\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2018/05/003.jpg\";s:12:\"tmpl_created\";s:10:\"1526415449\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/404-page-03/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"422\";s:11:\"trend_index\";s:3:\"547\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:243;a:14:{s:2:\"id\";s:4:\"4357\";s:5:\"title\";s:11:\"Services 20\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_12.png\";s:12:\"tmpl_created\";s:10:\"1520443277\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-20/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"48\";s:11:\"trend_index\";s:2:\"36\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:244;a:14:{s:2:\"id\";s:4:\"8526\";s:5:\"title\";s:11:\"404 page 09\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2018/05/009.jpg\";s:12:\"tmpl_created\";s:10:\"1526415474\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/404-page-09/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"424\";s:11:\"trend_index\";s:3:\"565\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:245;a:14:{s:2:\"id\";s:4:\"4368\";s:5:\"title\";s:11:\"Services 16\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_13.png\";s:12:\"tmpl_created\";s:10:\"1520443279\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-16/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"68\";s:11:\"trend_index\";s:2:\"87\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:246;a:14:{s:2:\"id\";s:4:\"8505\";s:5:\"title\";s:11:\"404 page 01\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2018/05/001.jpg\";s:12:\"tmpl_created\";s:10:\"1526415501\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/404-page-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"490\";s:11:\"trend_index\";s:3:\"499\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:247;a:14:{s:2:\"id\";s:4:\"4376\";s:5:\"title\";s:11:\"Services 28\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_black_12.png\";s:12:\"tmpl_created\";s:10:\"1520443281\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-28/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"145\";s:11:\"trend_index\";s:3:\"157\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:248;a:14:{s:2:\"id\";s:4:\"8511\";s:5:\"title\";s:11:\"404 page 02\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2018/05/002.jpg\";s:12:\"tmpl_created\";s:10:\"1526415528\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/404-page-02/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"347\";s:11:\"trend_index\";s:3:\"356\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:249;a:14:{s:2:\"id\";s:4:\"4391\";s:5:\"title\";s:11:\"Services 17\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_white_14.png\";s:12:\"tmpl_created\";s:10:\"1520443283\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-17/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"147\";s:11:\"trend_index\";s:3:\"138\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:250;a:14:{s:2:\"id\";s:4:\"8514\";s:5:\"title\";s:11:\"404 Page 05\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2018/05/005.jpg\";s:12:\"tmpl_created\";s:10:\"1526415558\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/404-page-05/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"404 page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"398\";s:11:\"trend_index\";s:3:\"406\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:251;a:14:{s:2:\"id\";s:4:\"4400\";s:5:\"title\";s:11:\"Services 27\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/02/Service_black_13.png\";s:12:\"tmpl_created\";s:10:\"1520443285\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/services-27/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:8:\"services\";s:4:\"tags\";s:12:\"[\"services\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"259\";s:11:\"trend_index\";s:3:\"226\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:252;a:14:{s:2:\"id\";s:4:\"8676\";s:5:\"title\";s:13:\"single page 1\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2018/05/S_P350.6.jpg\";s:12:\"tmpl_created\";s:10:\"1527682423\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-page-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"333\";s:11:\"trend_index\";s:3:\"380\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:253;a:14:{s:2:\"id\";s:4:\"4411\";s:5:\"title\";s:9:\"Contact 3\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/02/map_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443287\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/contact-3-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:11:\"[\"contact\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"96\";s:11:\"trend_index\";s:2:\"88\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:254;a:14:{s:2:\"id\";s:4:\"8678\";s:5:\"title\";s:13:\"single page 2\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2018/05/S_P350.2.jpg\";s:12:\"tmpl_created\";s:10:\"1527682780\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-page-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"179\";s:11:\"trend_index\";s:3:\"141\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:255;a:14:{s:2:\"id\";s:4:\"4420\";s:5:\"title\";s:9:\"Contact 1\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/02/map_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443289\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/contact-1-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:11:\"[\"contact\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"176\";s:11:\"trend_index\";s:3:\"137\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:256;a:14:{s:2:\"id\";s:4:\"8679\";s:5:\"title\";s:13:\"single page 3\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2018/05/S_P350.3.jpg\";s:12:\"tmpl_created\";s:10:\"1527682847\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-page-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"199\";s:11:\"trend_index\";s:3:\"201\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:257;a:14:{s:2:\"id\";s:4:\"4428\";s:5:\"title\";s:9:\"Contact 4\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/02/map_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443291\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/contact-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:11:\"[\"contact\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"97\";s:11:\"trend_index\";s:2:\"73\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:258;a:14:{s:2:\"id\";s:4:\"8680\";s:5:\"title\";s:13:\"single page 4\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2018/05/S_P350.1.jpg\";s:12:\"tmpl_created\";s:10:\"1527682896\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-page-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"397\";s:11:\"trend_index\";s:3:\"371\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:259;a:14:{s:2:\"id\";s:4:\"4436\";s:5:\"title\";s:11:\"Contact  16\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/02/map_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443293\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/contact-16/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:11:\"[\"contact\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"165\";s:11:\"trend_index\";s:3:\"199\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:260;a:14:{s:2:\"id\";s:4:\"8681\";s:5:\"title\";s:13:\"single page 5\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2018/05/S_P350.5.jpg\";s:12:\"tmpl_created\";s:10:\"1527682969\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-page-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"304\";s:11:\"trend_index\";s:3:\"410\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:261;a:14:{s:2:\"id\";s:4:\"4444\";s:5:\"title\";s:9:\"Contact 5\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/contact_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443295\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/contact-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:11:\"[\"contact\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"99\";s:11:\"trend_index\";s:3:\"128\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:262;a:14:{s:2:\"id\";s:4:\"8682\";s:5:\"title\";s:13:\"single page 6\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2018/05/S_P350.4.jpg\";s:12:\"tmpl_created\";s:10:\"1527683026\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-page-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"409\";s:11:\"trend_index\";s:3:\"509\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:263;a:14:{s:2:\"id\";s:4:\"4452\";s:5:\"title\";s:9:\"Contact 6\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/contact_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443296\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/contact-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:11:\"[\"contact\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"149\";s:11:\"trend_index\";s:3:\"124\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:264;a:14:{s:2:\"id\";s:4:\"8703\";s:5:\"title\";s:13:\"single page 7\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2018/05/S_P350.7.jpg\";s:12:\"tmpl_created\";s:10:\"1527683072\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-page-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"393\";s:11:\"trend_index\";s:3:\"483\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:265;a:14:{s:2:\"id\";s:4:\"4460\";s:5:\"title\";s:9:\"Contact 9\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/contact_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443298\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/contact-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:11:\"[\"contact\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"122\";s:11:\"trend_index\";s:2:\"95\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:266;a:14:{s:2:\"id\";s:4:\"8961\";s:5:\"title\";s:9:\"archive 1\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/06/Archive_350.1.jpg\";s:12:\"tmpl_created\";s:10:\"1528639909\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/archive-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"74\";s:11:\"trend_index\";s:3:\"130\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:267;a:14:{s:2:\"id\";s:4:\"4468\";s:5:\"title\";s:9:\"Contact 7\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/contact_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520443301\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/contact-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:18:\"[\"contact\",\"form\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"134\";s:11:\"trend_index\";s:3:\"111\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:268;a:14:{s:2:\"id\";s:4:\"8969\";s:5:\"title\";s:9:\"archive 2\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/06/Archive_350.2.jpg\";s:12:\"tmpl_created\";s:10:\"1528700014\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/archive-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"194\";s:11:\"trend_index\";s:3:\"319\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:269;a:14:{s:2:\"id\";s:4:\"4476\";s:5:\"title\";s:10:\"Contact 15\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/contact_white_4.png\";s:12:\"tmpl_created\";s:10:\"1520443303\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/contact-15/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:18:\"[\"contact\",\"form\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"244\";s:11:\"trend_index\";s:3:\"236\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:270;a:14:{s:2:\"id\";s:4:\"8973\";s:5:\"title\";s:9:\"archive 3\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/06/Archive_350.3.jpg\";s:12:\"tmpl_created\";s:10:\"1528700205\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/archive-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"161\";s:11:\"trend_index\";s:3:\"359\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:271;a:14:{s:2:\"id\";s:4:\"4484\";s:5:\"title\";s:9:\"Contact 8\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/02/contact_black_3.png\";s:12:\"tmpl_created\";s:10:\"1520443305\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/contact-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:18:\"[\"contact\",\"form\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"331\";s:11:\"trend_index\";s:3:\"288\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:272;a:14:{s:2:\"id\";s:4:\"8977\";s:5:\"title\";s:9:\"archive 4\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/06/Archive_350.4.jpg\";s:12:\"tmpl_created\";s:10:\"1528700326\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/archive-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"321\";s:11:\"trend_index\";s:3:\"318\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:273;a:14:{s:2:\"id\";s:4:\"4492\";s:5:\"title\";s:9:\"Contact 5\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/02/map_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520443307\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/contact-5-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:11:\"[\"contact\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"50\";s:11:\"trend_index\";s:2:\"39\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:274;a:14:{s:2:\"id\";s:4:\"8981\";s:5:\"title\";s:9:\"archive 5\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/06/Archive_350.5.jpg\";s:12:\"tmpl_created\";s:10:\"1528700484\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/archive-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"285\";s:11:\"trend_index\";s:3:\"322\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:275;a:14:{s:2:\"id\";s:4:\"4500\";s:5:\"title\";s:9:\"Pricing 7\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443308\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/pricing-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"412\";s:11:\"trend_index\";s:3:\"432\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:276;a:14:{s:2:\"id\";s:4:\"8985\";s:5:\"title\";s:9:\"archive 6\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/06/Archive_350.6.jpg\";s:12:\"tmpl_created\";s:10:\"1528700612\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/archive-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"196\";s:11:\"trend_index\";s:3:\"165\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:277;a:14:{s:2:\"id\";s:4:\"4509\";s:5:\"title\";s:9:\"Pricing 1\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443310\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/pricing-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"545\";s:11:\"trend_index\";s:1:\"0\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:278;a:14:{s:2:\"id\";s:4:\"8989\";s:5:\"title\";s:9:\"archive 7\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/06/Archive_350.7.jpg\";s:12:\"tmpl_created\";s:10:\"1528701063\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/archive-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"189\";s:11:\"trend_index\";s:3:\"274\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:279;a:14:{s:2:\"id\";s:4:\"4521\";s:5:\"title\";s:9:\"Pricing 8\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443312\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/pricing-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"319\";s:11:\"trend_index\";s:3:\"291\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:280;a:14:{s:2:\"id\";s:4:\"8996\";s:5:\"title\";s:9:\"archive 8\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/06/Archive_350.8.jpg\";s:12:\"tmpl_created\";s:10:\"1528701290\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/archive-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"182\";s:11:\"trend_index\";s:3:\"282\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:281;a:14:{s:2:\"id\";s:4:\"4529\";s:5:\"title\";s:9:\"Pricing 2\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443314\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/pricing-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"487\";s:11:\"trend_index\";s:3:\"542\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:282;a:14:{s:2:\"id\";s:4:\"9001\";s:5:\"title\";s:9:\"archive 9\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/06/Archive_350.9.jpg\";s:12:\"tmpl_created\";s:10:\"1528701433\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/archive-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"archive\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"224\";s:11:\"trend_index\";s:3:\"220\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:283;a:14:{s:2:\"id\";s:4:\"4537\";s:5:\"title\";s:9:\"Pricing 9\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520443315\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/pricing-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"467\";s:11:\"trend_index\";s:3:\"467\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:284;a:14:{s:2:\"id\";s:4:\"9119\";s:5:\"title\";s:10:\"footer 015\";s:9:\"thumbnail\";s:82:\"https://library.elementor.com/wp-content/uploads/2018/07/Footer_GetStarted_350.png\";s:12:\"tmpl_created\";s:10:\"1532428138\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:101:\"https://library.elementor.com/blocks/demo/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"footer\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"249\";s:11:\"trend_index\";s:3:\"270\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:285;a:14:{s:2:\"id\";s:4:\"4545\";s:5:\"title\";s:9:\"Pricing 3\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_black_3.png\";s:12:\"tmpl_created\";s:10:\"1520443317\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/pricing-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"538\";s:11:\"trend_index\";s:3:\"506\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:286;a:14:{s:2:\"id\";s:4:\"9127\";s:5:\"title\";s:9:\"header 13\";s:9:\"thumbnail\";s:86:\"https://library.elementor.com/wp-content/uploads/2018/07/Header_get_started_1200V3.png\";s:12:\"tmpl_created\";s:10:\"1532428699\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/header-13/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:6:\"header\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"52\";s:11:\"trend_index\";s:2:\"85\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:287;a:14:{s:2:\"id\";s:4:\"4553\";s:5:\"title\";s:10:\"Pricing 10\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_white_4.png\";s:12:\"tmpl_created\";s:10:\"1520443319\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/pricing-10/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"434\";s:11:\"trend_index\";s:3:\"457\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:288;a:14:{s:2:\"id\";s:4:\"4562\";s:5:\"title\";s:9:\"Pricing 4\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_black_4.png\";s:12:\"tmpl_created\";s:10:\"1520443322\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/pricing-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"534\";s:11:\"trend_index\";s:3:\"554\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:289;a:14:{s:2:\"id\";s:4:\"4572\";s:5:\"title\";s:10:\"Pricing 11\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_white_5.png\";s:12:\"tmpl_created\";s:10:\"1520443324\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/pricing-11/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"303\";s:11:\"trend_index\";s:3:\"271\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:290;a:14:{s:2:\"id\";s:4:\"9174\";s:5:\"title\";s:17:\"single product 01\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/07/single_product01_350.png\";s:12:\"tmpl_created\";s:10:\"1532950125\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/blocks/single-product-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"single product\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"67\";s:11:\"trend_index\";s:2:\"32\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:291;a:14:{s:2:\"id\";s:4:\"4580\";s:5:\"title\";s:10:\"Pricing 12\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_white_6.png\";s:12:\"tmpl_created\";s:10:\"1520443326\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/pricing-12/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"458\";s:11:\"trend_index\";s:3:\"548\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:292;a:14:{s:2:\"id\";s:4:\"9178\";s:5:\"title\";s:17:\"single product 02\";s:9:\"thumbnail\";s:84:\"https://library.elementor.com/wp-content/uploads/2018/07/single_product02_350new.png\";s:12:\"tmpl_created\";s:10:\"1532951997\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/blocks/single-product-02/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"single product\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"112\";s:11:\"trend_index\";s:2:\"66\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:293;a:14:{s:2:\"id\";s:4:\"4589\";s:5:\"title\";s:9:\"Pricing 5\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_black_6.png\";s:12:\"tmpl_created\";s:10:\"1520443327\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/pricing-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"544\";s:11:\"trend_index\";s:3:\"546\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:294;a:14:{s:2:\"id\";s:4:\"9180\";s:5:\"title\";s:17:\"single product 03\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2018/07/single_product03_350.png\";s:12:\"tmpl_created\";s:10:\"1532952302\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/blocks/single-product-03/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"single product\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"152\";s:11:\"trend_index\";s:3:\"100\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:295;a:14:{s:2:\"id\";s:4:\"4597\";s:5:\"title\";s:10:\"Pricing 13\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_white_7.png\";s:12:\"tmpl_created\";s:10:\"1520443330\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/pricing-13/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"477\";s:11:\"trend_index\";s:3:\"537\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:296;a:14:{s:2:\"id\";s:4:\"9182\";s:5:\"title\";s:17:\"single product 04\";s:9:\"thumbnail\";s:82:\"https://library.elementor.com/wp-content/uploads/2018/07/single_product040_350.png\";s:12:\"tmpl_created\";s:10:\"1532952606\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/blocks/single-product-04/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"single product\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"168\";s:11:\"trend_index\";s:3:\"118\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:297;a:14:{s:2:\"id\";s:4:\"4605\";s:5:\"title\";s:9:\"Pricing 6\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_black_7.png\";s:12:\"tmpl_created\";s:10:\"1520443332\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/pricing-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"558\";s:11:\"trend_index\";s:3:\"513\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:298;a:14:{s:2:\"id\";s:4:\"9239\";s:5:\"title\";s:17:\"product archive 1\";s:9:\"thumbnail\";s:82:\"https://library.elementor.com/wp-content/uploads/2018/07/product-archive-350-1.png\";s:12:\"tmpl_created\";s:10:\"1532953482\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/blocks/product-archive-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:15:\"product archive\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"116\";s:11:\"trend_index\";s:2:\"56\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:299;a:14:{s:2:\"id\";s:4:\"4613\";s:5:\"title\";s:10:\"Pricing 14\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/02/price_white_8.png\";s:12:\"tmpl_created\";s:10:\"1520443334\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/pricing-14/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"pricing\";s:4:\"tags\";s:11:\"[\"pricing\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"453\";s:11:\"trend_index\";s:3:\"458\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:300;a:14:{s:2:\"id\";s:4:\"9247\";s:5:\"title\";s:17:\"product archive 2\";s:9:\"thumbnail\";s:82:\"https://library.elementor.com/wp-content/uploads/2018/07/product-archive-350-2.png\";s:12:\"tmpl_created\";s:10:\"1532953793\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/blocks/product-archive-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:15:\"product archive\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"127\";s:11:\"trend_index\";s:3:\"108\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:301;a:14:{s:2:\"id\";s:4:\"9254\";s:5:\"title\";s:17:\"product archive 3\";s:9:\"thumbnail\";s:82:\"https://library.elementor.com/wp-content/uploads/2018/07/product-archive-350-3.png\";s:12:\"tmpl_created\";s:10:\"1532954032\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/blocks/product-archive-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:15:\"product archive\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"131\";s:11:\"trend_index\";s:2:\"80\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:302;a:14:{s:2:\"id\";s:4:\"9301\";s:5:\"title\";s:13:\"Single Post 4\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2018/09/3003.jpg\";s:12:\"tmpl_created\";s:10:\"1537440661\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-post-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"193\";s:11:\"trend_index\";s:3:\"239\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:303;a:14:{s:2:\"id\";s:4:\"9296\";s:5:\"title\";s:13:\"Single Post 3\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2018/09/3002.jpg\";s:12:\"tmpl_created\";s:10:\"1537440673\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-post-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"190\";s:11:\"trend_index\";s:3:\"163\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:304;a:14:{s:2:\"id\";s:4:\"9313\";s:5:\"title\";s:13:\"Single Post 5\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2018/09/3001.jpg\";s:12:\"tmpl_created\";s:10:\"1537440798\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-post-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"163\";s:11:\"trend_index\";s:3:\"152\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:305;a:14:{s:2:\"id\";s:4:\"9343\";s:5:\"title\";s:13:\"Single Post 6\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2018/09/3004.jpg\";s:12:\"tmpl_created\";s:10:\"1537443531\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-post-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"177\";s:11:\"trend_index\";s:3:\"191\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:306;a:14:{s:2:\"id\";s:4:\"9349\";s:5:\"title\";s:13:\"Single Post 7\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2018/09/3005.jpg\";s:12:\"tmpl_created\";s:10:\"1537443903\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/single-post-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:11:\"single post\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"124\";s:11:\"trend_index\";s:3:\"115\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:307;a:14:{s:2:\"id\";s:4:\"4690\";s:5:\"title\";s:6:\"Team 7\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443348\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/team-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"231\";s:11:\"trend_index\";s:3:\"309\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:308;a:14:{s:2:\"id\";s:4:\"4698\";s:5:\"title\";s:7:\"Team 15\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443350\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/team-15/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"381\";s:11:\"trend_index\";s:3:\"313\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:309;a:14:{s:2:\"id\";s:4:\"4706\";s:5:\"title\";s:6:\"Team 5\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443352\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/team-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"135\";s:11:\"trend_index\";s:3:\"146\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:310;a:14:{s:2:\"id\";s:4:\"4718\";s:5:\"title\";s:6:\"Team 4\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520443354\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/team-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"174\";s:11:\"trend_index\";s:3:\"206\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:311;a:14:{s:2:\"id\";s:4:\"4727\";s:5:\"title\";s:7:\"Team 13\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443356\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/team-13/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"354\";s:11:\"trend_index\";s:3:\"338\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:312;a:14:{s:2:\"id\";s:4:\"4736\";s:5:\"title\";s:7:\"Team 20\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_white_4.png\";s:12:\"tmpl_created\";s:10:\"1520443358\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/team-20/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"136\";s:11:\"trend_index\";s:3:\"142\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:313;a:14:{s:2:\"id\";s:4:\"4746\";s:5:\"title\";s:7:\"Team 23\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_black_4.png\";s:12:\"tmpl_created\";s:10:\"1520443360\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/team-23/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"247\";s:11:\"trend_index\";s:3:\"228\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:314;a:14:{s:2:\"id\";s:4:\"4759\";s:5:\"title\";s:7:\"Team 22\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_white_5.png\";s:12:\"tmpl_created\";s:10:\"1520443362\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/team-22/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"267\";s:11:\"trend_index\";s:3:\"277\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:315;a:14:{s:2:\"id\";s:4:\"4770\";s:5:\"title\";s:7:\"Team 12\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_white_6.png\";s:12:\"tmpl_created\";s:10:\"1520443364\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/team-12-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"359\";s:11:\"trend_index\";s:3:\"468\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:316;a:14:{s:2:\"id\";s:4:\"4781\";s:5:\"title\";s:7:\"Team 16\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_white_7.png\";s:12:\"tmpl_created\";s:10:\"1520443365\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/team-16/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"234\";s:11:\"trend_index\";s:3:\"349\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:317;a:14:{s:2:\"id\";s:4:\"9611\";s:5:\"title\";s:16:\"Hello Bar | Sale\";s:9:\"thumbnail\";s:82:\"https://library.elementor.com/wp-content/uploads/2019/01/Top-Bar_Sale_small_01.png\";s:12:\"tmpl_created\";s:10:\"1546965350\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/popups/hello-bar-sale-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:9:\"hello bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"517\";s:11:\"trend_index\";s:3:\"446\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:318;a:14:{s:2:\"id\";s:4:\"4793\";s:5:\"title\";s:7:\"Team 18\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_white_8.png\";s:12:\"tmpl_created\";s:10:\"1520443367\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/team-18/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"188\";s:11:\"trend_index\";s:3:\"257\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:319;a:14:{s:2:\"id\";s:4:\"9622\";s:5:\"title\";s:19:\"Classic | Promotion\";s:9:\"thumbnail\";s:87:\"https://library.elementor.com/wp-content/uploads/2019/01/classic_promotion_small_02.png\";s:12:\"tmpl_created\";s:10:\"1546965896\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/popups/classic-promotion-02/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"505\";s:11:\"trend_index\";s:3:\"571\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:320;a:14:{s:2:\"id\";s:4:\"4801\";s:5:\"title\";s:7:\"Team 11\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_black_8.png\";s:12:\"tmpl_created\";s:10:\"1520443369\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/team-11/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"329\";s:11:\"trend_index\";s:3:\"302\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:321;a:14:{s:2:\"id\";s:4:\"9631\";s:5:\"title\";s:38:\"Slide-in | Sale | Register | Subscribe\";s:9:\"thumbnail\";s:83:\"https://library.elementor.com/wp-content/uploads/2019/01/Slide-in_Sale_small_01.png\";s:12:\"tmpl_created\";s:10:\"1546968270\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/popups/slide-in-sale-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"516\";s:11:\"trend_index\";s:3:\"415\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:322;a:14:{s:2:\"id\";s:4:\"4809\";s:5:\"title\";s:7:\"Team 19\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_white_9.png\";s:12:\"tmpl_created\";s:10:\"1520443371\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/team-19/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"258\";s:11:\"trend_index\";s:3:\"273\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:323;a:14:{s:2:\"id\";s:4:\"4818\";s:5:\"title\";s:7:\"Team 21\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/team_black_9.png\";s:12:\"tmpl_created\";s:10:\"1520443373\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/team-21/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"team\";s:4:\"tags\";s:8:\"[\"team\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"405\";s:11:\"trend_index\";s:3:\"303\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:324;a:14:{s:2:\"id\";s:4:\"5045\";s:5:\"title\";s:11:\"Portfolio 3\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/portfolio_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443423\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/portfolio-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"portfolio\";s:4:\"tags\";s:13:\"[\"portfolio\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"478\";s:11:\"trend_index\";s:3:\"538\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:325;a:14:{s:2:\"id\";s:4:\"9662\";s:5:\"title\";s:33:\"Bottom Bar | Register | Subscribe\";s:9:\"thumbnail\";s:89:\"https://library.elementor.com/wp-content/uploads/2019/01/Bottom-Bar_Register_small_01.png\";s:12:\"tmpl_created\";s:10:\"1547009087\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:119:\"https://library.elementor.com/popups/bottom-bar-register-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:10:\"bottom bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"546\";s:11:\"trend_index\";s:3:\"515\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:326;a:14:{s:2:\"id\";s:4:\"5157\";s:5:\"title\";s:11:\"Subscribe 1\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/subscribe_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443448\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/subscribe-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"subscribe\";s:4:\"tags\";s:20:\"[\"form\",\"subscribe\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"342\";s:11:\"trend_index\";s:3:\"296\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:327;a:14:{s:2:\"id\";s:4:\"5165\";s:5:\"title\";s:11:\"Subscribe 3\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/subscribe_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443450\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/subscribe-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"subscribe\";s:4:\"tags\";s:20:\"[\"form\",\"subscribe\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"440\";s:11:\"trend_index\";s:3:\"420\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:328;a:14:{s:2:\"id\";s:4:\"5173\";s:5:\"title\";s:11:\"Subscribe 5\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/subscribe_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443452\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/subscribe-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"subscribe\";s:4:\"tags\";s:20:\"[\"form\",\"subscribe\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"271\";s:11:\"trend_index\";s:3:\"299\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:329;a:14:{s:2:\"id\";s:4:\"9690\";s:5:\"title\";s:17:\"Classic | Contact\";s:9:\"thumbnail\";s:85:\"https://library.elementor.com/wp-content/uploads/2019/01/Classic_Contact_small_01.png\";s:12:\"tmpl_created\";s:10:\"1547011716\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/popups/classic-contact-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"390\";s:11:\"trend_index\";s:3:\"376\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:330;a:14:{s:2:\"id\";s:4:\"5181\";s:5:\"title\";s:11:\"Subscribe 2\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/subscribe_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443454\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/blocks/subscribe-2-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"subscribe\";s:4:\"tags\";s:20:\"[\"form\",\"subscribe\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"404\";s:11:\"trend_index\";s:3:\"562\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:331;a:14:{s:2:\"id\";s:4:\"9699\";s:5:\"title\";s:33:\"Classic | Contact | Gym | Fitness\";s:9:\"thumbnail\";s:85:\"https://library.elementor.com/wp-content/uploads/2019/01/Classic_Contact_small_02.png\";s:12:\"tmpl_created\";s:10:\"1547015827\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/popups/classic-contact-02/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"431\";s:11:\"trend_index\";s:3:\"364\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:332;a:14:{s:2:\"id\";s:4:\"5189\";s:5:\"title\";s:6:\"CTA 29\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/form_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443456\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-29/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:8:\"[\"form\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"392\";s:11:\"trend_index\";s:3:\"454\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:333;a:14:{s:2:\"id\";s:4:\"5198\";s:5:\"title\";s:6:\"CTA 30\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/form_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443458\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-30/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:8:\"[\"form\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"445\";s:11:\"trend_index\";s:3:\"525\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:334;a:14:{s:2:\"id\";s:4:\"9571\";s:5:\"title\";s:14:\"Fly In | Login\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2019/01/FlyIn_Login_01_small.png\";s:12:\"tmpl_created\";s:10:\"1547726151\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/popups/fly-in-login-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"512\";s:11:\"trend_index\";s:3:\"491\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:335;a:14:{s:2:\"id\";s:4:\"5206\";s:5:\"title\";s:6:\"CTA 31\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/form_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443459\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-31/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:8:\"[\"form\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"468\";s:11:\"trend_index\";s:3:\"452\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:336;a:14:{s:2:\"id\";s:4:\"5214\";s:5:\"title\";s:10:\"Contact 16\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/form_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443462\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/blocks/contact-16-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:18:\"[\"contact\",\"form\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"201\";s:11:\"trend_index\";s:3:\"248\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:337;a:14:{s:2:\"id\";s:4:\"5222\";s:5:\"title\";s:11:\"Subscribe 4\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2018/03/subscribe_black_3.png\";s:12:\"tmpl_created\";s:10:\"1520443464\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/subscribe-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:9:\"subscribe\";s:4:\"tags\";s:20:\"[\"form\",\"subscribe\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"376\";s:11:\"trend_index\";s:3:\"418\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:338;a:14:{s:2:\"id\";s:4:\"9740\";s:5:\"title\";s:25:\"Classic | Promotion | App\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/app_small.png\";s:12:\"tmpl_created\";s:10:\"1547822836\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:118:\"https://library.elementor.com/popups/classic-promotion-app/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"499\";s:11:\"trend_index\";s:3:\"536\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:339;a:14:{s:2:\"id\";s:4:\"5230\";s:5:\"title\";s:10:\"Contact 17\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/form_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520443466\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/contact-17/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:18:\"[\"contact\",\"form\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"316\";s:11:\"trend_index\";s:3:\"347\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:340;a:14:{s:2:\"id\";s:4:\"5238\";s:5:\"title\";s:7:\"Hero 12\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/form_white_4.png\";s:12:\"tmpl_created\";s:10:\"1520443468\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/hero-12/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:4:\"hero\";s:4:\"tags\";s:8:\"[\"hero\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"474\";s:11:\"trend_index\";s:3:\"560\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:341;a:14:{s:2:\"id\";s:4:\"9762\";s:5:\"title\";s:36:\"Classic | Register | Subscribe | Spa\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2019/01/spa_small_classic.png\";s:12:\"tmpl_created\";s:10:\"1547824145\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:127:\"https://library.elementor.com/popups/classic-register-subscribe-spa/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"433\";s:11:\"trend_index\";s:3:\"382\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:342;a:14:{s:2:\"id\";s:4:\"5249\";s:5:\"title\";s:6:\"CTA 32\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/form_black_4.png\";s:12:\"tmpl_created\";s:10:\"1520443470\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/blocks/cta-32/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:14:\"call to action\";s:4:\"tags\";s:8:\"[\"form\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"439\";s:11:\"trend_index\";s:3:\"507\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:343;a:14:{s:2:\"id\";s:4:\"9772\";s:5:\"title\";s:27:\"Hello bar | Promotion | App\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2019/01/app_hello_small.png\";s:12:\"tmpl_created\";s:10:\"1547824279\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:120:\"https://library.elementor.com/popups/hello-bar-promotion-app/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:9:\"hello bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"580\";s:11:\"trend_index\";s:1:\"0\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:344;a:14:{s:2:\"id\";s:4:\"5257\";s:5:\"title\";s:10:\"Contact 18\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/form_white_5.png\";s:12:\"tmpl_created\";s:10:\"1520443472\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/contact-18/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"contact\";s:4:\"tags\";s:8:\"[\"form\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"383\";s:11:\"trend_index\";s:3:\"474\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:345;a:14:{s:2:\"id\";s:4:\"5266\";s:5:\"title\";s:9:\"Clients 4\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/clients_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443474\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/clients-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"119\";s:11:\"trend_index\";s:2:\"86\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:346;a:14:{s:2:\"id\";s:4:\"9793\";s:5:\"title\";s:13:\"Fly In | Sale\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2019/01/flyin_black_small.png\";s:12:\"tmpl_created\";s:10:\"1547831151\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/popups/fly-in-sale/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"535\";s:11:\"trend_index\";s:3:\"442\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:347;a:14:{s:2:\"id\";s:4:\"5275\";s:5:\"title\";s:9:\"Clients 5\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/clients_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443476\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/clients-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"334\";s:11:\"trend_index\";s:3:\"308\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:348;a:14:{s:2:\"id\";s:4:\"5283\";s:5:\"title\";s:9:\"Clients 1\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/clients_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443478\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/clients-1-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"281\";s:11:\"trend_index\";s:3:\"365\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:349;a:14:{s:2:\"id\";s:4:\"5290\";s:5:\"title\";s:9:\"Clients 3\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/clients_black_2.png\";s:12:\"tmpl_created\";s:10:\"1520443480\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/clients-3-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"447\";s:11:\"trend_index\";s:3:\"570\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:350;a:14:{s:2:\"id\";s:4:\"5298\";s:5:\"title\";s:10:\"Clients 15\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/clients_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520443482\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/clients-15/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"400\";s:11:\"trend_index\";s:3:\"411\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:351;a:14:{s:2:\"id\";s:4:\"9836\";s:5:\"title\";s:21:\"Classic | Login | Pop\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/01/login_b_small.png\";s:12:\"tmpl_created\";s:10:\"1547835635\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/popups/classic-login/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"508\";s:11:\"trend_index\";s:3:\"553\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:352;a:14:{s:2:\"id\";s:4:\"5306\";s:5:\"title\";s:10:\"Clients 10\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/clients_black_3.png\";s:12:\"tmpl_created\";s:10:\"1520443484\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/clients-10/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"507\";s:11:\"trend_index\";s:3:\"566\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:353;a:14:{s:2:\"id\";s:4:\"9847\";s:5:\"title\";s:25:\"Fly In | Promotion | Lego\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2019/01/fly_in_promotion_tro.png\";s:12:\"tmpl_created\";s:10:\"1547836956\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/popups/fly-in-promotion/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"574\";s:11:\"trend_index\";s:3:\"587\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:354;a:14:{s:2:\"id\";s:4:\"5315\";s:5:\"title\";s:10:\"Clients 12\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2018/03/form_white_4-1.png\";s:12:\"tmpl_created\";s:10:\"1520443486\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/clients-12/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"417\";s:11:\"trend_index\";s:3:\"575\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:355;a:14:{s:2:\"id\";s:4:\"9858\";s:5:\"title\";s:27:\"Slide In | Promotion | Wine\";s:9:\"thumbnail\";s:90:\"https://library.elementor.com/wp-content/uploads/2019/01/slide-in_promotion_wine_small.png\";s:12:\"tmpl_created\";s:10:\"1547837100\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/popups/slide-in-promotion/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"590\";s:11:\"trend_index\";s:1:\"0\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:356;a:14:{s:2:\"id\";s:4:\"5324\";s:5:\"title\";s:9:\"Clients 8\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2018/03/form_white_5-1.png\";s:12:\"tmpl_created\";s:10:\"1520443488\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/clients-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"438\";s:11:\"trend_index\";s:3:\"522\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:357;a:14:{s:2:\"id\";s:4:\"5333\";s:5:\"title\";s:10:\"Clients 13\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/form_white_6.png\";s:12:\"tmpl_created\";s:10:\"1520443489\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/clients-13/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"235\";s:11:\"trend_index\";s:3:\"231\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:358;a:14:{s:2:\"id\";s:4:\"5341\";s:5:\"title\";s:10:\"Clients 11\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/clients_black_4.png\";s:12:\"tmpl_created\";s:10:\"1520443491\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/clients-11/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"476\";s:11:\"trend_index\";s:3:\"532\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:359;a:14:{s:2:\"id\";s:4:\"5349\";s:5:\"title\";s:9:\"Clients 7\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/form_white_7.png\";s:12:\"tmpl_created\";s:10:\"1520443493\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/clients-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"236\";s:11:\"trend_index\";s:3:\"197\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:360;a:14:{s:2:\"id\";s:4:\"5357\";s:5:\"title\";s:9:\"Clients 2\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/clients_black_7.png\";s:12:\"tmpl_created\";s:10:\"1520443495\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/blocks/clients-2-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"310\";s:11:\"trend_index\";s:3:\"307\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:361;a:14:{s:2:\"id\";s:4:\"5368\";s:5:\"title\";s:9:\"Clients 9\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/form_white_8.png\";s:12:\"tmpl_created\";s:10:\"1520443497\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/clients-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"227\";s:11:\"trend_index\";s:3:\"283\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:362;a:14:{s:2:\"id\";s:4:\"5381\";s:5:\"title\";s:10:\"Clients 16\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/form_white_9.png\";s:12:\"tmpl_created\";s:10:\"1520443499\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/clients-16/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"178\";s:11:\"trend_index\";s:3:\"233\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:363;a:14:{s:2:\"id\";s:4:\"5389\";s:5:\"title\";s:10:\"Clients 14\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/03/form_black_9.png\";s:12:\"tmpl_created\";s:10:\"1520443501\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/blocks/clients-14/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:7:\"clients\";s:4:\"tags\";s:11:\"[\"clients\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"370\";s:11:\"trend_index\";s:3:\"425\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:364;a:14:{s:2:\"id\";s:4:\"9944\";s:5:\"title\";s:33:\"Slide In | Promotion | Headphones\";s:9:\"thumbnail\";s:79:\"https://library.elementor.com/wp-content/uploads/2019/01/slidein_head_small.png\";s:12:\"tmpl_created\";s:10:\"1547841939\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/popups/slide-in-promotion-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"572\";s:11:\"trend_index\";s:1:\"0\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:365;a:14:{s:2:\"id\";s:4:\"5397\";s:5:\"title\";s:8:\"About 11\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_white_1.png\";s:12:\"tmpl_created\";s:10:\"1520443503\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/about-11/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"146\";s:11:\"trend_index\";s:3:\"174\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:366;a:14:{s:2:\"id\";s:4:\"9955\";s:5:\"title\";s:14:\"Fly In | Login\";s:9:\"thumbnail\";s:83:\"https://library.elementor.com/wp-content/uploads/2019/01/flyin_login_lock_small.png\";s:12:\"tmpl_created\";s:10:\"1547842065\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/popups/fly-in-login/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"489\";s:11:\"trend_index\";s:3:\"543\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:367;a:14:{s:2:\"id\";s:4:\"5405\";s:5:\"title\";s:8:\"About 12\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_black_1.png\";s:12:\"tmpl_created\";s:10:\"1520443505\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/about-12/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"223\";s:11:\"trend_index\";s:3:\"215\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:368;a:14:{s:2:\"id\";s:4:\"9965\";s:5:\"title\";s:30:\"Classic | Register | Subscribe\";s:9:\"thumbnail\";s:79:\"https://library.elementor.com/wp-content/uploads/2019/01/classic_moon_small.png\";s:12:\"tmpl_created\";s:10:\"1547842174\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:125:\"https://library.elementor.com/popups/classic-register-subscribe-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"473\";s:11:\"trend_index\";s:3:\"324\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:369;a:14:{s:2:\"id\";s:4:\"5413\";s:5:\"title\";s:8:\"About 21\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_white_2.png\";s:12:\"tmpl_created\";s:10:\"1520443507\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/about-21/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"133\";s:11:\"trend_index\";s:3:\"159\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:370;a:14:{s:2:\"id\";s:4:\"5421\";s:5:\"title\";s:8:\"About 13\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_white_3.png\";s:12:\"tmpl_created\";s:10:\"1520443509\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/about-13/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"245\";s:11:\"trend_index\";s:3:\"224\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:371;a:14:{s:2:\"id\";s:4:\"5429\";s:5:\"title\";s:8:\"About 16\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_white_4.png\";s:12:\"tmpl_created\";s:10:\"1520443510\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/about-16/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"91\";s:11:\"trend_index\";s:2:\"70\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:372;a:14:{s:2:\"id\";s:4:\"9995\";s:5:\"title\";s:27:\"Slide In | Sale | Christmas\";s:9:\"thumbnail\";s:84:\"https://library.elementor.com/wp-content/uploads/2019/01/slidein_christmas_small.png\";s:12:\"tmpl_created\";s:10:\"1547844802\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:120:\"https://library.elementor.com/popups/slide-in-sale-christmas/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"600\";s:11:\"trend_index\";s:3:\"527\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:373;a:14:{s:2:\"id\";s:4:\"5438\";s:5:\"title\";s:7:\"About 1\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_black_4.png\";s:12:\"tmpl_created\";s:10:\"1520443512\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/about-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"207\";s:11:\"trend_index\";s:3:\"195\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:374;a:14:{s:2:\"id\";s:4:\"5447\";s:5:\"title\";s:7:\"About 3\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_white_5.png\";s:12:\"tmpl_created\";s:10:\"1520443514\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/about-3-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"64\";s:11:\"trend_index\";s:2:\"61\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:375;a:14:{s:2:\"id\";s:5:\"10016\";s:5:\"title\";s:16:\"Hello Bar | Sale\";s:9:\"thumbnail\";s:90:\"https://library.elementor.com/wp-content/uploads/2019/01/Hello-Bar_Promotion_bag_small.png\";s:12:\"tmpl_created\";s:10:\"1547845062\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/popups/hello-bar-sale/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:9:\"hello bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"607\";s:11:\"trend_index\";s:1:\"0\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:376;a:14:{s:2:\"id\";s:4:\"5455\";s:5:\"title\";s:8:\"About 20\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_white_6.png\";s:12:\"tmpl_created\";s:10:\"1520443516\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/about-20/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"130\";s:11:\"trend_index\";s:3:\"126\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:377;a:14:{s:2:\"id\";s:5:\"10026\";s:5:\"title\";s:46:\"Classic | Register | Subscribe | Gym | Fitness\";s:9:\"thumbnail\";s:83:\"https://library.elementor.com/wp-content/uploads/2019/01/classic_register_small.png\";s:12:\"tmpl_created\";s:10:\"1547845205\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:125:\"https://library.elementor.com/popups/classic-register-subscribe-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"479\";s:11:\"trend_index\";s:3:\"479\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:378;a:14:{s:2:\"id\";s:4:\"5464\";s:5:\"title\";s:8:\"About 17\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_black_6.png\";s:12:\"tmpl_created\";s:10:\"1520443518\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/about-17/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"229\";s:11:\"trend_index\";s:3:\"235\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:379;a:14:{s:2:\"id\";s:5:\"10036\";s:5:\"title\";s:43:\"Full Screen | Sale | Promotion | Headphones\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2019/01/full_sale_head_small.png\";s:12:\"tmpl_created\";s:10:\"1547845409\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:123:\"https://library.elementor.com/popups/full-screen-sale-promotion/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"503\";s:11:\"trend_index\";s:3:\"444\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:380;a:14:{s:2:\"id\";s:4:\"5472\";s:5:\"title\";s:7:\"About 2\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_white_7.png\";s:12:\"tmpl_created\";s:10:\"1520443520\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/about-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"195\";s:11:\"trend_index\";s:3:\"230\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:381;a:14:{s:2:\"id\";s:4:\"5480\";s:5:\"title\";s:7:\"About 4\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/about_black_7-1.png\";s:12:\"tmpl_created\";s:10:\"1520443522\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blocks/about-4-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"394\";s:11:\"trend_index\";s:3:\"328\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:382;a:14:{s:2:\"id\";s:5:\"10057\";s:5:\"title\";s:48:\"Hello Bar | Register | Subscribe | Gym | Fitness\";s:9:\"thumbnail\";s:91:\"https://library.elementor.com/wp-content/uploads/2019/01/hello-bar_register_sport_small.png\";s:12:\"tmpl_created\";s:10:\"1547847938\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:125:\"https://library.elementor.com/popups/hello-bar-register-subscribe/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:9:\"hello bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"585\";s:11:\"trend_index\";s:1:\"0\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:383;a:14:{s:2:\"id\";s:4:\"5488\";s:5:\"title\";s:7:\"About 7\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_white_8.png\";s:12:\"tmpl_created\";s:10:\"1520443524\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/about-7/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"284\";s:11:\"trend_index\";s:3:\"300\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:384;a:14:{s:2:\"id\";s:4:\"5496\";s:5:\"title\";s:7:\"About 9\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/03/about_black_8-1.png\";s:12:\"tmpl_created\";s:10:\"1520443526\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/blocks/about-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"429\";s:11:\"trend_index\";s:3:\"478\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:385;a:14:{s:2:\"id\";s:4:\"5504\";s:5:\"title\";s:8:\"About 18\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_white_9.png\";s:12:\"tmpl_created\";s:10:\"1520443528\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/about-18/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:2:\"95\";s:11:\"trend_index\";s:3:\"102\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:386;a:14:{s:2:\"id\";s:5:\"10087\";s:5:\"title\";s:25:\"Full Screen | Login | Spa\";s:9:\"thumbnail\";s:88:\"https://library.elementor.com/wp-content/uploads/2019/01/full-screen_login_spa_small.png\";s:12:\"tmpl_created\";s:10:\"1547848301\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:118:\"https://library.elementor.com/popups/full-screen-login-spa/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"514\";s:11:\"trend_index\";s:3:\"519\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:387;a:14:{s:2:\"id\";s:4:\"5515\";s:5:\"title\";s:8:\"About 19\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2018/03/about_black_9.png\";s:12:\"tmpl_created\";s:10:\"1520443530\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/blocks/about-19/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"block\";s:7:\"subtype\";s:5:\"about\";s:4:\"tags\";s:9:\"[\"About\"]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"257\";s:11:\"trend_index\";s:3:\"285\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:388;a:14:{s:2:\"id\";s:5:\"10097\";s:5:\"title\";s:37:\"Classic | Register | Subscribe | Lego\";s:9:\"thumbnail\";s:79:\"https://library.elementor.com/wp-content/uploads/2019/01/classic_lego_small.png\";s:12:\"tmpl_created\";s:10:\"1547848411\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:125:\"https://library.elementor.com/popups/classic-register-subscribe-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"0\";s:16:\"popularity_index\";s:3:\"540\";s:11:\"trend_index\";s:3:\"520\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:389;a:14:{s:2:\"id\";s:4:\"1190\";s:5:\"title\";s:26:\"Landing Page &#8211; Hotel\";s:9:\"thumbnail\";s:66:\"https://library.elementor.com/wp-content/uploads/2017/03/lp2-l.png\";s:12:\"tmpl_created\";s:10:\"1490707391\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/landing-page-hotel/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"1\";s:16:\"popularity_index\";s:1:\"5\";s:11:\"trend_index\";s:1:\"1\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:390;a:14:{s:2:\"id\";s:4:\"9816\";s:5:\"title\";s:30:\"Classic | Sale | Gym | Fitness\";s:9:\"thumbnail\";s:85:\"https://library.elementor.com/wp-content/uploads/2019/01/classic_sale_sport_small.png\";s:12:\"tmpl_created\";s:10:\"1547991876\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/popups/classic-sale-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"1\";s:16:\"popularity_index\";s:3:\"551\";s:11:\"trend_index\";s:3:\"579\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:391;a:14:{s:2:\"id\";s:4:\"9602\";s:5:\"title\";s:35:\"Bottom Bar | Announcement | Cookies\";s:9:\"thumbnail\";s:92:\"https://library.elementor.com/wp-content/uploads/2019/01/Bottombar_Announcement_small_01.png\";s:12:\"tmpl_created\";s:10:\"1546964559\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:123:\"https://library.elementor.com/popups/bottom-bar-announcement-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:10:\"bottom bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"1\";s:16:\"popularity_index\";s:3:\"502\";s:11:\"trend_index\";s:3:\"417\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:392;a:14:{s:2:\"id\";s:3:\"225\";s:5:\"title\";s:27:\"Homepage &#8211; Restaurant\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0016.png\";s:12:\"tmpl_created\";s:10:\"1470829872\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/homepage-restaurant/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:32:\"[\"Food\",\"Homepage\",\"Restaurant\"]\";s:10:\"menu_order\";s:1:\"2\";s:16:\"popularity_index\";s:1:\"2\";s:11:\"trend_index\";s:1:\"2\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:393;a:14:{s:2:\"id\";s:3:\"463\";s:5:\"title\";s:22:\"Homepage &#8211; Study\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/10/0022.png\";s:12:\"tmpl_created\";s:10:\"1477388340\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/homepage-study/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:32:\"[\"Education\",\"Homepage\",\"Study\"]\";s:10:\"menu_order\";s:1:\"3\";s:16:\"popularity_index\";s:1:\"4\";s:11:\"trend_index\";s:1:\"4\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:394;a:14:{s:2:\"id\";s:5:\"10277\";s:5:\"title\";s:36:\"Bottom Bar | Promotion | Sale | Book\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/01/book_small.png\";s:12:\"tmpl_created\";s:10:\"1548055999\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:122:\"https://library.elementor.com/popups/bottom-bar-promotion-book/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:10:\"bottom bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"3\";s:16:\"popularity_index\";s:3:\"566\";s:11:\"trend_index\";s:3:\"552\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:395;a:14:{s:2:\"id\";s:5:\"11241\";s:5:\"title\";s:36:\"Classic | Digital Agency | Marketing\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/07/PopUp_small.jpg\";s:12:\"tmpl_created\";s:10:\"1564643043\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:129:\"https://library.elementor.com/popups/classic-digital-agency-marketing/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"3\";s:16:\"popularity_index\";s:3:\"441\";s:11:\"trend_index\";s:3:\"327\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:396;a:14:{s:2:\"id\";s:3:\"181\";s:5:\"title\";s:23:\"Homepage &#8211; Agency\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0019.png\";s:12:\"tmpl_created\";s:10:\"1470826567\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/homepage-agency/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:32:\"[\"Agency\",\"Creative\",\"Homepage\"]\";s:10:\"menu_order\";s:1:\"4\";s:16:\"popularity_index\";s:1:\"3\";s:11:\"trend_index\";s:1:\"3\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:397;a:14:{s:2:\"id\";s:4:\"9903\";s:5:\"title\";s:34:\"Bottom Bar | Promotion | Olive Oil\";s:9:\"thumbnail\";s:93:\"https://library.elementor.com/wp-content/uploads/2019/01/bottom-bar_promotion_olive_small.png\";s:12:\"tmpl_created\";s:10:\"1547838896\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/popups/bottom-bar-promotion/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:10:\"bottom bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"4\";s:16:\"popularity_index\";s:3:\"582\";s:11:\"trend_index\";s:3:\"585\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:398;a:14:{s:2:\"id\";s:3:\"150\";s:5:\"title\";s:19:\"Product &#8211; App\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0003.png\";s:12:\"tmpl_created\";s:10:\"1470829879\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:101:\"https://library.elementor.com/product-app/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"5\";s:16:\"popularity_index\";s:2:\"11\";s:11:\"trend_index\";s:1:\"5\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:399;a:14:{s:2:\"id\";s:5:\"10549\";s:5:\"title\";s:33:\"Bottom Bar | Register | Subscribe\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/com_small.png\";s:12:\"tmpl_created\";s:10:\"1547967595\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:126:\"https://library.elementor.com/popups/bottom-bar-register-subscribe/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:10:\"bottom bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"6\";s:16:\"popularity_index\";s:3:\"562\";s:11:\"trend_index\";s:1:\"0\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:400;a:14:{s:2:\"id\";s:5:\"11763\";s:5:\"title\";s:27:\"Portfolio &#8211; Home Page\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/09/Homepage_small.png\";s:12:\"tmpl_created\";s:10:\"1569428959\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/portfolio-home-page/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:34:\"[\"creative portfolio\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"6\";s:16:\"popularity_index\";s:3:\"407\";s:11:\"trend_index\";s:3:\"170\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:401;a:14:{s:2:\"id\";s:5:\"11781\";s:5:\"title\";s:23:\"Portfolio &#8211; About\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/09/About_small.png\";s:12:\"tmpl_created\";s:10:\"1569428955\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/portfolio-about/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:34:\"[\"creative portfolio\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"7\";s:16:\"popularity_index\";s:3:\"462\";s:11:\"trend_index\";s:3:\"205\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:402;a:14:{s:2:\"id\";s:5:\"11793\";s:5:\"title\";s:26:\"Portfolio &#8211; Projects\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/09/Projects_small.png\";s:12:\"tmpl_created\";s:10:\"1569428951\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/portfolio-projects/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:34:\"[\"creative portfolio\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"8\";s:16:\"popularity_index\";s:3:\"491\";s:11:\"trend_index\";s:3:\"265\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:403;a:14:{s:2:\"id\";s:5:\"10529\";s:5:\"title\";s:36:\"Classic | Announcement | Maintenance\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/01/icon_small.png\";s:12:\"tmpl_created\";s:10:\"1548046309\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/popups/classic-announcement/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:1:\"9\";s:16:\"popularity_index\";s:3:\"455\";s:11:\"trend_index\";s:3:\"462\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:404;a:14:{s:2:\"id\";s:5:\"11800\";s:5:\"title\";s:25:\"Portfolio &#8211; Contact\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/09/Contact_small.png\";s:12:\"tmpl_created\";s:10:\"1569428946\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/portfolio-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:34:\"[\"creative portfolio\",\"portfolio\"]\";s:10:\"menu_order\";s:1:\"9\";s:16:\"popularity_index\";s:3:\"519\";s:11:\"trend_index\";s:3:\"256\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:405;a:14:{s:2:\"id\";s:5:\"11163\";s:5:\"title\";s:32:\"Digital Agency &#8211; Home Page\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/07/Home_small.png\";s:12:\"tmpl_created\";s:10:\"1564641877\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/digital-agency-home-page/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:30:\"[\"Digital Agency\",\"marketing\"]\";s:10:\"menu_order\";s:2:\"10\";s:16:\"popularity_index\";s:3:\"159\";s:11:\"trend_index\";s:2:\"27\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:406;a:14:{s:2:\"id\";s:5:\"11129\";s:5:\"title\";s:28:\"Digital Agency &#8211; About\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/07/About_small.png\";s:12:\"tmpl_created\";s:10:\"1564641889\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/digital-agency-about/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:30:\"[\"Digital Agency\",\"marketing\"]\";s:10:\"menu_order\";s:2:\"11\";s:16:\"popularity_index\";s:3:\"312\";s:11:\"trend_index\";s:3:\"104\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:407;a:14:{s:2:\"id\";s:5:\"11074\";s:5:\"title\";s:31:\"Digital Agency &#8211; Services\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/07/Services_small.png\";s:12:\"tmpl_created\";s:10:\"1564641872\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/digital-agency-services/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:30:\"[\"Digital Agency\",\"marketing\"]\";s:10:\"menu_order\";s:2:\"12\";s:16:\"popularity_index\";s:3:\"277\";s:11:\"trend_index\";s:2:\"72\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:408;a:14:{s:2:\"id\";s:5:\"11056\";s:5:\"title\";s:35:\"Digital Agency &#8211; Social Media\";s:9:\"thumbnail\";s:79:\"https://library.elementor.com/wp-content/uploads/2019/07/Social-Media_small.png\";s:12:\"tmpl_created\";s:10:\"1564641867\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/digital-agency-social-media/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:30:\"[\"Digital Agency\",\"marketing\"]\";s:10:\"menu_order\";s:2:\"13\";s:16:\"popularity_index\";s:3:\"391\";s:11:\"trend_index\";s:3:\"190\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:409;a:14:{s:2:\"id\";s:5:\"11094\";s:5:\"title\";s:30:\"Digital Agency &#8211; Clients\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/07/Clients_small.png\";s:12:\"tmpl_created\";s:10:\"1564641885\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/digital-agency-clients/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:30:\"[\"Digital Agency\",\"marketing\"]\";s:10:\"menu_order\";s:2:\"14\";s:16:\"popularity_index\";s:3:\"463\";s:11:\"trend_index\";s:3:\"335\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:410;a:14:{s:2:\"id\";s:5:\"11034\";s:5:\"title\";s:30:\"Digital Agency &#8211; Contact\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2019/07/Contsct-Us_small.png\";s:12:\"tmpl_created\";s:10:\"1564641881\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/contact-digital-agency/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:30:\"[\"Digital Agency\",\"marketing\"]\";s:10:\"menu_order\";s:2:\"15\";s:16:\"popularity_index\";s:3:\"326\";s:11:\"trend_index\";s:3:\"106\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:411;a:14:{s:2:\"id\";s:3:\"519\";s:5:\"title\";s:24:\"Homepage &#8211; Fitness\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/10/0023.png\";s:12:\"tmpl_created\";s:10:\"1477388808\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/homepage-fitness/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:45:\"[\"Fitness\",\"Gym\",\"Health\",\"Homepage\",\"Sport\"]\";s:10:\"menu_order\";s:2:\"16\";s:16:\"popularity_index\";s:1:\"8\";s:11:\"trend_index\";s:2:\"13\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:412;a:14:{s:2:\"id\";s:5:\"10413\";s:5:\"title\";s:28:\"Classic | Content Lock | Pop\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/hot_small.png\";s:12:\"tmpl_created\";s:10:\"1547961774\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/popups/classic-content-lock/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"17\";s:16:\"popularity_index\";s:3:\"573\";s:11:\"trend_index\";s:3:\"534\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:413;a:14:{s:2:\"id\";s:4:\"9139\";s:5:\"title\";s:25:\"Homepage &#8211; Business\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/07/Get_Started_250.png\";s:12:\"tmpl_created\";s:10:\"1532949924\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/homepage-business/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:167:\"[\"Agency\",\"bootstrap\",\"business\",\"corporate\",\"Landing Page\",\"marketing campaign\",\"marketing landing page\",\"product launch\",\"software\",\"Startup\",\"startup landing page\"]\";s:10:\"menu_order\";s:2:\"17\";s:16:\"popularity_index\";s:1:\"6\";s:11:\"trend_index\";s:1:\"6\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:414;a:14:{s:2:\"id\";s:4:\"1504\";s:5:\"title\";s:33:\"Landing Page &#8211; Mobile App 3\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-app2.png\";s:12:\"tmpl_created\";s:10:\"1494352112\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/landing-page-mobile-app-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"18\";s:16:\"popularity_index\";s:3:\"140\";s:11:\"trend_index\";s:3:\"161\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:415;a:14:{s:2:\"id\";s:5:\"10223\";s:5:\"title\";s:15:\"Classic | Login\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/01/welcome_small.png\";s:12:\"tmpl_created\";s:10:\"1547887343\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/popups/classic-login-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"19\";s:16:\"popularity_index\";s:3:\"437\";s:11:\"trend_index\";s:3:\"433\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:416;a:14:{s:2:\"id\";s:5:\"10559\";s:5:\"title\";s:33:\"Bottom Bar | Register | Subscribe\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/fly_small.png\";s:12:\"tmpl_created\";s:10:\"1547967711\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:128:\"https://library.elementor.com/popups/bottom-bar-register-subscribe-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:10:\"bottom bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"19\";s:16:\"popularity_index\";s:3:\"529\";s:11:\"trend_index\";s:1:\"0\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:417;a:14:{s:2:\"id\";s:4:\"1503\";s:5:\"title\";s:33:\"Landing Page &#8211; Mobile App 2\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-app1.png\";s:12:\"tmpl_created\";s:10:\"1494352113\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/landing-page-mobile-app-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"19\";s:16:\"popularity_index\";s:3:\"144\";s:11:\"trend_index\";s:3:\"194\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:418;a:14:{s:2:\"id\";s:5:\"10403\";s:5:\"title\";s:15:\"Classic | Login\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/hello_small.png\";s:12:\"tmpl_created\";s:10:\"1548056371\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/popups/classic-login-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"20\";s:16:\"popularity_index\";s:3:\"500\";s:11:\"trend_index\";s:3:\"469\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:419;a:14:{s:2:\"id\";s:4:\"1634\";s:5:\"title\";s:33:\"Landing Page &#8211; Chiropractor\";s:9:\"thumbnail\";s:86:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-Chiropractor.png\";s:12:\"tmpl_created\";s:10:\"1494352119\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/landing-page-chiropractor/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"20\";s:16:\"popularity_index\";s:3:\"197\";s:11:\"trend_index\";s:3:\"275\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:420;a:14:{s:2:\"id\";s:5:\"12155\";s:5:\"title\";s:26:\"Law Firm &#8211; Home Page\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2019/11/home.png\";s:12:\"tmpl_created\";s:10:\"1572847054\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/law-firm-home-page/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:18:\"[\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:2:\"21\";s:16:\"popularity_index\";s:3:\"547\";s:11:\"trend_index\";s:2:\"52\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:421;a:14:{s:2:\"id\";s:4:\"9913\";s:5:\"title\";s:27:\"Classic | Login | Christmas\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/log_small.png\";s:12:\"tmpl_created\";s:10:\"1547841430\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/popups/classic-login-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"21\";s:16:\"popularity_index\";s:3:\"483\";s:11:\"trend_index\";s:3:\"484\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:422;a:14:{s:2:\"id\";s:5:\"12143\";s:5:\"title\";s:22:\"Law Firm &#8211; About\";s:9:\"thumbnail\";s:66:\"https://library.elementor.com/wp-content/uploads/2019/11/about.png\";s:12:\"tmpl_created\";s:10:\"1572847069\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/law-firm-about/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:18:\"[\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:2:\"22\";s:16:\"popularity_index\";s:3:\"594\";s:11:\"trend_index\";s:3:\"218\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:423;a:14:{s:2:\"id\";s:5:\"12133\";s:5:\"title\";s:24:\"Law Firm &#8211; Careers\";s:9:\"thumbnail\";s:68:\"https://library.elementor.com/wp-content/uploads/2019/11/careers.png\";s:12:\"tmpl_created\";s:10:\"1572847078\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/law-firm-careers/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:18:\"[\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:2:\"23\";s:16:\"popularity_index\";s:3:\"609\";s:11:\"trend_index\";s:3:\"372\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:424;a:14:{s:2:\"id\";s:5:\"12124\";s:5:\"title\";s:25:\"Law Firm &#8211; Services\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2019/11/services.png\";s:12:\"tmpl_created\";s:10:\"1572847096\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/law-firm-services/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:18:\"[\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:2:\"24\";s:16:\"popularity_index\";s:3:\"604\";s:11:\"trend_index\";s:3:\"262\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:425;a:14:{s:2:\"id\";s:5:\"12116\";s:5:\"title\";s:24:\"Law Firm &#8211; Service\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/11/family_law.png\";s:12:\"tmpl_created\";s:10:\"1572847105\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/law-firm-service/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:18:\"[\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:2:\"25\";s:16:\"popularity_index\";s:3:\"606\";s:11:\"trend_index\";s:3:\"175\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:426;a:14:{s:2:\"id\";s:5:\"12091\";s:5:\"title\";s:21:\"Law Firm &#8211; Team\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2019/11/team.png\";s:12:\"tmpl_created\";s:10:\"1572847113\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/law-firm-team/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:18:\"[\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:2:\"26\";s:16:\"popularity_index\";s:3:\"603\";s:11:\"trend_index\";s:3:\"179\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:427;a:14:{s:2:\"id\";s:4:\"9592\";s:5:\"title\";s:26:\"Classic | Promotion | Sale\";s:9:\"thumbnail\";s:87:\"https://library.elementor.com/wp-content/uploads/2019/01/Classic_Promotion_small_01.png\";s:12:\"tmpl_created\";s:10:\"1546963720\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/popups/classic-promotion-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"26\";s:16:\"popularity_index\";s:3:\"522\";s:11:\"trend_index\";s:3:\"555\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:428;a:14:{s:2:\"id\";s:5:\"10210\";s:5:\"title\";s:29:\"Classic | Promotion | Webinar\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/web_small-1.png\";s:12:\"tmpl_created\";s:10:\"1547886103\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:122:\"https://library.elementor.com/popups/classic-promotion-webinar/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"27\";s:16:\"popularity_index\";s:3:\"595\";s:11:\"trend_index\";s:3:\"593\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:429;a:14:{s:2:\"id\";s:5:\"12080\";s:5:\"title\";s:24:\"Law Firm &#8211; Partner\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/11/partner-1.png\";s:12:\"tmpl_created\";s:10:\"1572847120\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/law-firm-partner/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:18:\"[\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:2:\"27\";s:16:\"popularity_index\";s:3:\"610\";s:11:\"trend_index\";s:3:\"360\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:430;a:14:{s:2:\"id\";s:5:\"12044\";s:5:\"title\";s:24:\"Law Firm &#8211; Contact\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/11/contsct_us.png\";s:12:\"tmpl_created\";s:10:\"1572847130\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/law-firm-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:18:\"[\"Law\",\"Law Firm\"]\";s:10:\"menu_order\";s:2:\"28\";s:16:\"popularity_index\";s:3:\"601\";s:11:\"trend_index\";s:3:\"223\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:431;a:14:{s:2:\"id\";s:5:\"11545\";s:5:\"title\";s:21:\"Gym &#8211; Home Page\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/08/Home_Small.png\";s:12:\"tmpl_created\";s:10:\"1567392943\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/gym-home-page/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:7:\"[\"Gym\"]\";s:10:\"menu_order\";s:2:\"29\";s:16:\"popularity_index\";s:3:\"410\";s:11:\"trend_index\";s:3:\"127\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:432;a:14:{s:2:\"id\";s:5:\"11478\";s:5:\"title\";s:17:\"Gym &#8211; About\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/08/About_Small.png\";s:12:\"tmpl_created\";s:10:\"1567392939\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:99:\"https://library.elementor.com/gym-about/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:7:\"[\"Gym\"]\";s:10:\"menu_order\";s:2:\"30\";s:16:\"popularity_index\";s:3:\"493\";s:11:\"trend_index\";s:3:\"305\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:433;a:14:{s:2:\"id\";s:5:\"10047\";s:5:\"title\";s:15:\"Classic | Login\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/01/yellow_small.png\";s:12:\"tmpl_created\";s:10:\"1547847757\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/popups/classic-login-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"30\";s:16:\"popularity_index\";s:3:\"459\";s:11:\"trend_index\";s:3:\"528\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:434;a:14:{s:2:\"id\";s:5:\"11572\";s:5:\"title\";s:19:\"Gym &#8211; Trainer\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/08/Trainer_Small.png\";s:12:\"tmpl_created\";s:10:\"1567392934\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:101:\"https://library.elementor.com/gym-trainer/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:7:\"[\"Gym\"]\";s:10:\"menu_order\";s:2:\"31\";s:16:\"popularity_index\";s:3:\"532\";s:11:\"trend_index\";s:3:\"486\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:435;a:14:{s:2:\"id\";s:4:\"9879\";s:5:\"title\";s:38:\"Classic | Register | Subscribe | Leads\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/dog_small.png\";s:12:\"tmpl_created\";s:10:\"1547838416\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:123:\"https://library.elementor.com/popups/classic-register-subscribe/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"31\";s:16:\"popularity_index\";s:3:\"524\";s:11:\"trend_index\";s:3:\"530\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:436;a:14:{s:2:\"id\";s:5:\"11506\";s:5:\"title\";s:19:\"Gym &#8211; Classes\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/08/Classes_Small.png\";s:12:\"tmpl_created\";s:10:\"1567392930\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:101:\"https://library.elementor.com/gym-classes/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:7:\"[\"Gym\"]\";s:10:\"menu_order\";s:2:\"32\";s:16:\"popularity_index\";s:3:\"527\";s:11:\"trend_index\";s:3:\"434\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:437;a:14:{s:2:\"id\";s:5:\"11536\";s:5:\"title\";s:19:\"Gym &#8211; Fitness\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/08/Fitness_Small.png\";s:12:\"tmpl_created\";s:10:\"1567392927\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:101:\"https://library.elementor.com/gym-fitness/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:7:\"[\"Gym\"]\";s:10:\"menu_order\";s:2:\"33\";s:16:\"popularity_index\";s:3:\"557\";s:11:\"trend_index\";s:3:\"461\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:438;a:14:{s:2:\"id\";s:5:\"11563\";s:5:\"title\";s:19:\"Gym &#8211; Pricing\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/08/Pricing_Small.png\";s:12:\"tmpl_created\";s:10:\"1567392923\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:101:\"https://library.elementor.com/gym-pricing/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:7:\"[\"Gym\"]\";s:10:\"menu_order\";s:2:\"34\";s:16:\"popularity_index\";s:3:\"531\";s:11:\"trend_index\";s:3:\"281\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:439;a:14:{s:2:\"id\";s:5:\"10297\";s:5:\"title\";s:14:\"Classic | Sale\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/01/s_yellow_small.png\";s:12:\"tmpl_created\";s:10:\"1548056099\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/popups/classic-sale-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"35\";s:16:\"popularity_index\";s:3:\"492\";s:11:\"trend_index\";s:3:\"431\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:440;a:14:{s:2:\"id\";s:5:\"11528\";s:5:\"title\";s:19:\"Gym &#8211; Contact\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/08/Contact_Small.png\";s:12:\"tmpl_created\";s:10:\"1567392917\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:101:\"https://library.elementor.com/gym-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:7:\"[\"Gym\"]\";s:10:\"menu_order\";s:2:\"35\";s:16:\"popularity_index\";s:3:\"518\";s:11:\"trend_index\";s:3:\"516\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:441;a:14:{s:2:\"id\";s:3:\"487\";s:5:\"title\";s:29:\"Landing Page &#8211; Vacation\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/10/0021.png\";s:12:\"tmpl_created\";s:10:\"1477388357\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/landing-page-vacation/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"36\";s:16:\"popularity_index\";s:2:\"23\";s:11:\"trend_index\";s:2:\"22\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:442;a:14:{s:2:\"id\";s:5:\"10393\";s:5:\"title\";s:14:\"Classic | Sale\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/01/blue_small.png\";s:12:\"tmpl_created\";s:10:\"1548056682\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/popups/classic-sale-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"36\";s:16:\"popularity_index\";s:3:\"542\";s:11:\"trend_index\";s:3:\"485\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:443;a:14:{s:2:\"id\";s:3:\"855\";s:5:\"title\";s:37:\"Landing Page &#8211; Personal Trainer\";s:9:\"thumbnail\";s:90:\"https://library.elementor.com/wp-content/uploads/2017/02/Landing-Page-Personal-Trainer.png\";s:12:\"tmpl_created\";s:10:\"1494352061\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:119:\"https://library.elementor.com/landing-page-personal-trainer/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"37\";s:16:\"popularity_index\";s:3:\"228\";s:11:\"trend_index\";s:3:\"348\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:444;a:14:{s:2:\"id\";s:5:\"10579\";s:5:\"title\";s:14:\"Classic | Sale\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/sale1_small.png\";s:12:\"tmpl_created\";s:10:\"1547967887\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/popups/classic-sale-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"38\";s:16:\"popularity_index\";s:3:\"556\";s:11:\"trend_index\";s:3:\"577\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:445;a:14:{s:2:\"id\";s:3:\"955\";s:5:\"title\";s:31:\"Landing Page &#8211; Law Office\";s:9:\"thumbnail\";s:84:\"https://library.elementor.com/wp-content/uploads/2017/02/Landing-Page-Law-Office.png\";s:12:\"tmpl_created\";s:10:\"1494352069\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/landing-page-law-office/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:31:\"[\"Landing Page\",\"Law\",\"Office\"]\";s:10:\"menu_order\";s:2:\"38\";s:16:\"popularity_index\";s:3:\"151\";s:11:\"trend_index\";s:3:\"213\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:446;a:14:{s:2:\"id\";s:4:\"9373\";s:5:\"title\";s:33:\"Landing Page &#8211; Conference 5\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2018/11/conference-250.png\";s:12:\"tmpl_created\";s:10:\"1542811219\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/landing-page-conference-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"39\";s:16:\"popularity_index\";s:3:\"217\";s:11:\"trend_index\";s:3:\"242\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:447;a:14:{s:2:\"id\";s:3:\"974\";s:5:\"title\";s:28:\"Landing Page &#8211; Stylist\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2017/03/Landing-Page-Stylist.png\";s:12:\"tmpl_created\";s:10:\"1494352071\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/landing-page-stylist/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:146:\"[\"cosmetics\",\"fashion\",\"girly\",\"hairdresser\",\"lifestyle\",\"makeup\",\"manicure\",\"pedicure\",\"products\",\"salon\",\"Shop\",\"skincare\",\"stylist\",\"wellness\"]\";s:10:\"menu_order\";s:2:\"40\";s:16:\"popularity_index\";s:3:\"272\";s:11:\"trend_index\";s:3:\"260\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:448;a:14:{s:2:\"id\";s:5:\"11948\";s:5:\"title\";s:18:\"Maintenance Mode 3\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2019/10/mm3.png\";s:12:\"tmpl_created\";s:10:\"1572153978\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/maintenance-mode-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:20:\"[\"Maintenance mode\"]\";s:10:\"menu_order\";s:2:\"41\";s:16:\"popularity_index\";s:3:\"510\";s:11:\"trend_index\";s:2:\"71\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:449;a:14:{s:2:\"id\";s:3:\"754\";s:5:\"title\";s:25:\"Services &#8211; Interior\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2017/01/Interior-Services.png\";s:12:\"tmpl_created\";s:10:\"1485269691\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/services-interior/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"42\";s:16:\"popularity_index\";s:3:\"221\";s:11:\"trend_index\";s:3:\"221\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:450;a:14:{s:2:\"id\";s:3:\"752\";s:5:\"title\";s:24:\"Contact &#8211; Interior\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2017/01/interior-contact.png\";s:12:\"tmpl_created\";s:10:\"1485269737\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/contact-interior/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"43\";s:16:\"popularity_index\";s:3:\"273\";s:11:\"trend_index\";s:3:\"340\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:451;a:14:{s:2:\"id\";s:5:\"10180\";s:5:\"title\";s:21:\"Fly In | Announcement\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/glass_small.png\";s:12:\"tmpl_created\";s:10:\"1548045309\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:118:\"https://library.elementor.com/popups/fly-in-announcement-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"43\";s:16:\"popularity_index\";s:3:\"541\";s:11:\"trend_index\";s:3:\"559\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:452;a:14:{s:2:\"id\";s:3:\"753\";s:5:\"title\";s:22:\"About &#8211; Interior\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2017/01/Interior-About.png\";s:12:\"tmpl_created\";s:10:\"1485269710\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/about-interior/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"44\";s:16:\"popularity_index\";s:3:\"256\";s:11:\"trend_index\";s:3:\"295\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:453;a:14:{s:2:\"id\";s:3:\"751\";s:5:\"title\";s:25:\"Homepage &#8211; Interior\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2017/01/interior-home.png\";s:12:\"tmpl_created\";s:10:\"1485269743\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/homepage-interior/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"45\";s:16:\"popularity_index\";s:3:\"220\";s:11:\"trend_index\";s:3:\"267\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:454;a:14:{s:2:\"id\";s:4:\"9731\";s:5:\"title\";s:26:\"Classic | Sale | Promotion\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2019/01/icecream_small.png\";s:12:\"tmpl_created\";s:10:\"1547976166\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/popups/classic-sale/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:7:\"classic\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"46\";s:16:\"popularity_index\";s:3:\"506\";s:11:\"trend_index\";s:3:\"510\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:455;a:14:{s:2:\"id\";s:4:\"2402\";s:5:\"title\";s:32:\"Homepage &#8211; Interior Design\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2017/09/Interior.png\";s:12:\"tmpl_created\";s:10:\"1506441447\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/homepage-interior-design/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:193:\"[\"Architecture\",\"building\",\"business\",\"Creative\",\"exterior design\",\"furniture design\",\"Gallery\",\"garden design\",\"house\",\"interior design\",\"landscape design\",\"multipurpose\",\"portfolio\",\"studio\"]\";s:10:\"menu_order\";s:2:\"46\";s:16:\"popularity_index\";s:2:\"73\";s:11:\"trend_index\";s:3:\"186\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:456;a:14:{s:2:\"id\";s:4:\"3626\";s:5:\"title\";s:30:\"Snowboard Site &#8211; Contact\";s:9:\"thumbnail\";s:62:\"https://library.elementor.com/wp-content/uploads/2017/12/3.png\";s:12:\"tmpl_created\";s:10:\"1513513193\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/snowboard-site-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"47\";s:16:\"popularity_index\";s:3:\"222\";s:11:\"trend_index\";s:3:\"389\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:457;a:14:{s:2:\"id\";s:5:\"11966\";s:5:\"title\";s:18:\"Maintenance mode 4\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2019/10/mm4.png\";s:12:\"tmpl_created\";s:10:\"1572154274\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/maintenance-mode-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:20:\"[\"Maintenance mode\"]\";s:10:\"menu_order\";s:2:\"48\";s:16:\"popularity_index\";s:3:\"602\";s:11:\"trend_index\";s:3:\"312\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:458;a:14:{s:2:\"id\";s:4:\"3632\";s:5:\"title\";s:31:\"Snowboard Site &#8211; Services\";s:9:\"thumbnail\";s:62:\"https://library.elementor.com/wp-content/uploads/2017/12/2.png\";s:12:\"tmpl_created\";s:10:\"1513513171\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/snowboard-site-services/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"49\";s:16:\"popularity_index\";s:3:\"187\";s:11:\"trend_index\";s:3:\"304\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:459;a:14:{s:2:\"id\";s:4:\"3619\";s:5:\"title\";s:31:\"Snowboard Site &#8211; Homepage\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2017/12/home.png\";s:12:\"tmpl_created\";s:10:\"1513513137\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/snowboard-site-homepage/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"50\";s:16:\"popularity_index\";s:3:\"204\";s:11:\"trend_index\";s:3:\"258\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:460;a:14:{s:2:\"id\";s:4:\"9425\";s:5:\"title\";s:38:\"Black Friday &#8211;  80&#8217;s style\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2018/11/unnamed-file.png\";s:12:\"tmpl_created\";s:10:\"1542901234\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/black-friday-80s-style/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"51\";s:16:\"popularity_index\";s:3:\"292\";s:11:\"trend_index\";s:3:\"460\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:461;a:14:{s:2:\"id\";s:5:\"11973\";s:5:\"title\";s:18:\"Maintenance mode 5\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2019/10/mm5.png\";s:12:\"tmpl_created\";s:10:\"1572154523\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/maintenance-mode-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:20:\"[\"Maintenance mode\"]\";s:10:\"menu_order\";s:2:\"52\";s:16:\"popularity_index\";s:3:\"596\";s:11:\"trend_index\";s:3:\"321\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:462;a:14:{s:2:\"id\";s:5:\"10005\";s:5:\"title\";s:38:\"Fly In | Promotion | Spa | Body Lotion\";s:9:\"thumbnail\";s:79:\"https://library.elementor.com/wp-content/uploads/2019/01/Flyin_lotion_small.png\";s:12:\"tmpl_created\";s:10:\"1547844909\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/popups/fly-in-promotion-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"54\";s:16:\"popularity_index\";s:3:\"575\";s:11:\"trend_index\";s:3:\"582\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:463;a:14:{s:2:\"id\";s:5:\"10424\";s:5:\"title\";s:21:\"Fly In | Announcement\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/01/flower_small.png\";s:12:\"tmpl_created\";s:10:\"1547961866\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:118:\"https://library.elementor.com/popups/fly-in-announcement-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"55\";s:16:\"popularity_index\";s:3:\"504\";s:11:\"trend_index\";s:3:\"539\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:464;a:14:{s:2:\"id\";s:4:\"9975\";s:5:\"title\";s:24:\"Fly In | Promotion | App\";s:9:\"thumbnail\";s:84:\"https://library.elementor.com/wp-content/uploads/2019/01/flyin_webinar_app_small.png\";s:12:\"tmpl_created\";s:10:\"1547842284\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:121:\"https://library.elementor.com/popups/fly-in-promotion-webinar/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"55\";s:16:\"popularity_index\";s:3:\"593\";s:11:\"trend_index\";s:1:\"0\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:465;a:14:{s:2:\"id\";s:5:\"10067\";s:5:\"title\";s:31:\"Fly In | Announcement | Cookies\";s:9:\"thumbnail\";s:87:\"https://library.elementor.com/wp-content/uploads/2019/01/fly-in_cookie_yellow_small.png\";s:12:\"tmpl_created\";s:10:\"1547848075\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/popups/fly-in-announcement/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"56\";s:16:\"popularity_index\";s:3:\"486\";s:11:\"trend_index\";s:3:\"550\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:466;a:14:{s:2:\"id\";s:5:\"10329\";s:5:\"title\";s:25:\"Fly In | Sale | Promotion\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2019/01/organic_small.png\";s:12:\"tmpl_created\";s:10:\"1547893478\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:118:\"https://library.elementor.com/popups/fly-in-sale-promotion/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"59\";s:16:\"popularity_index\";s:3:\"598\";s:11:\"trend_index\";s:3:\"586\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:467;a:14:{s:2:\"id\";s:4:\"9650\";s:5:\"title\";s:36:\"Fly In | Register | Subscribe | Sale\";s:9:\"thumbnail\";s:86:\"https://library.elementor.com/wp-content/uploads/2019/01/Fly-In_Register_small_01a.png\";s:12:\"tmpl_created\";s:10:\"1547007598\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:119:\"https://library.elementor.com/popups/fly-in-register_big-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"60\";s:16:\"popularity_index\";s:3:\"587\";s:11:\"trend_index\";s:1:\"0\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:468;a:14:{s:2:\"id\";s:5:\"10200\";s:5:\"title\";s:33:\"Full Screen | Content Lock | Wine\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2019/01/lock_wine_small.png\";s:12:\"tmpl_created\";s:10:\"1548055635\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:121:\"https://library.elementor.com/popups/full-screen-content-lock/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"63\";s:16:\"popularity_index\";s:3:\"565\";s:11:\"trend_index\";s:3:\"573\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:469;a:14:{s:2:\"id\";s:5:\"11981\";s:5:\"title\";s:18:\"Maintenance mode 6\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2019/10/mm6.png\";s:12:\"tmpl_created\";s:10:\"1572155125\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/maintenance-mode-6/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:20:\"[\"Maintenance mode\"]\";s:10:\"menu_order\";s:2:\"63\";s:16:\"popularity_index\";s:3:\"589\";s:11:\"trend_index\";s:3:\"276\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:470;a:14:{s:2:\"id\";s:5:\"10287\";s:5:\"title\";s:34:\"Full Screen | Register | Subscribe\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2019/01/glass_pink_small.png\";s:12:\"tmpl_created\";s:10:\"1547994301\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/popups/full-screen-login-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"64\";s:16:\"popularity_index\";s:3:\"495\";s:11:\"trend_index\";s:3:\"569\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:471;a:14:{s:2:\"id\";s:4:\"9889\";s:5:\"title\";s:28:\"Full Screen | Login | Cactus\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/cac_small.png\";s:12:\"tmpl_created\";s:10:\"1547838722\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/popups/full-screen-login/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"66\";s:16:\"popularity_index\";s:3:\"576\";s:11:\"trend_index\";s:3:\"583\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:472;a:14:{s:2:\"id\";s:3:\"147\";s:5:\"title\";s:20:\"Homepage &#8211; App\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0004.png\";s:12:\"tmpl_created\";s:10:\"1470829868\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/homepage-app/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:18:\"[\"App\",\"Homepage\"]\";s:10:\"menu_order\";s:2:\"67\";s:16:\"popularity_index\";s:1:\"1\";s:11:\"trend_index\";s:1:\"8\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:473;a:14:{s:2:\"id\";s:5:\"10077\";s:5:\"title\";s:29:\"Fly In | Register | Subscribe\";s:9:\"thumbnail\";s:86:\"https://library.elementor.com/wp-content/uploads/2019/01/flyin_register_blue_small.png\";s:12:\"tmpl_created\";s:10:\"1547848197\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:122:\"https://library.elementor.com/popups/fly-in-register-subscribe/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"67\";s:16:\"popularity_index\";s:3:\"452\";s:11:\"trend_index\";s:3:\"472\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:474;a:14:{s:2:\"id\";s:3:\"777\";s:5:\"title\";s:28:\"Homepage &#8211; Coffee Shop\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2017/01/rest-home.jpg\";s:12:\"tmpl_created\";s:10:\"1485273092\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/homepage-coffee-shop/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:41:\"[\"Coffee\",\"Homepage\",\"Restaurant\",\"Shop\"]\";s:10:\"menu_order\";s:2:\"68\";s:16:\"popularity_index\";s:3:\"110\";s:11:\"trend_index\";s:3:\"208\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:475;a:14:{s:2:\"id\";s:5:\"10362\";s:5:\"title\";s:32:\"Full Screen | Login | Restaurant\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/vip_small.png\";s:12:\"tmpl_created\";s:10:\"1548056253\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/popups/full-screen-login-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"69\";s:16:\"popularity_index\";s:3:\"511\";s:11:\"trend_index\";s:3:\"496\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:476;a:14:{s:2:\"id\";s:4:\"2404\";s:5:\"title\";s:24:\"Homepage &#8211; Product\";s:9:\"thumbnail\";s:68:\"https://library.elementor.com/wp-content/uploads/2017/09/product.png\";s:12:\"tmpl_created\";s:10:\"1506441452\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/homepage-product/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:103:\"[\"business\",\"colorful\",\"ecommerce\",\"flat\",\"mobile\",\"modern\",\"responsive\",\"retina\",\"Shop\",\"woocommerce\"]\";s:10:\"menu_order\";s:2:\"69\";s:16:\"popularity_index\";s:3:\"111\";s:11:\"trend_index\";s:3:\"297\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:477;a:14:{s:2:\"id\";s:3:\"492\";s:5:\"title\";s:25:\"Homepage &#8211; Law firm\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/10/0024.png\";s:12:\"tmpl_created\";s:10:\"1477388365\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/homepage-law-firm/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:25:\"[\"Firm\",\"Homepage\",\"Law\"]\";s:10:\"menu_order\";s:2:\"70\";s:16:\"popularity_index\";s:1:\"9\";s:11:\"trend_index\";s:2:\"33\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:478;a:14:{s:2:\"id\";s:5:\"10454\";s:5:\"title\";s:29:\"Full Screen | Promotion | App\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/01/appy_small.png\";s:12:\"tmpl_created\";s:10:\"1548056896\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:122:\"https://library.elementor.com/popups/full-screen-promotion-app/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"71\";s:16:\"popularity_index\";s:3:\"591\";s:11:\"trend_index\";s:3:\"561\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:479;a:14:{s:2:\"id\";s:4:\"3451\";s:5:\"title\";s:39:\"Homepage &#8211; Goodness meal services\";s:9:\"thumbnail\";s:84:\"https://library.elementor.com/wp-content/uploads/2017/11/goodness-featured-image.png\";s:12:\"tmpl_created\";s:10:\"1512054116\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:121:\"https://library.elementor.com/homepage-goodness-meal-services/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"71\";s:16:\"popularity_index\";s:3:\"181\";s:11:\"trend_index\";s:3:\"368\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:480;a:14:{s:2:\"id\";s:4:\"2152\";s:5:\"title\";s:26:\"Homepage &#8211; Cake Shop\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2017/07/cake-home.png\";s:12:\"tmpl_created\";s:10:\"1499774132\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/homepage-cake-shop/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:39:\"[\"Cake\",\"Homepage\",\"Restaurant\",\"Shop\"]\";s:10:\"menu_order\";s:2:\"72\";s:16:\"popularity_index\";s:3:\"283\";s:11:\"trend_index\";s:3:\"381\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:481;a:14:{s:2:\"id\";s:4:\"9803\";s:5:\"title\";s:41:\"Full Screen | Register | Contact | Meetup\";s:9:\"thumbnail\";s:80:\"https://library.elementor.com/wp-content/uploads/2019/01/designme_full_small.png\";s:12:\"tmpl_created\";s:10:\"1547831298\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:125:\"https://library.elementor.com/popups/full-screen-register-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"72\";s:16:\"popularity_index\";s:3:\"539\";s:11:\"trend_index\";s:3:\"594\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:482;a:14:{s:2:\"id\";s:5:\"10611\";s:5:\"title\";s:18:\"Full Screen | Sale\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/fla_small.png\";s:12:\"tmpl_created\";s:10:\"1547968868\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/popups/full-screen-sale/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"73\";s:16:\"popularity_index\";s:3:\"592\";s:11:\"trend_index\";s:3:\"591\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:483;a:14:{s:2:\"id\";s:4:\"1068\";s:5:\"title\";s:27:\"Homepage &#8211; Copywriter\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2017/03/copywriter.png\";s:12:\"tmpl_created\";s:10:\"1488805928\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/homepage-copywriter/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:25:\"[\"Copywriter\",\"Homepage\"]\";s:10:\"menu_order\";s:2:\"73\";s:16:\"popularity_index\";s:3:\"170\";s:11:\"trend_index\";s:3:\"294\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:484;a:14:{s:2:\"id\";s:4:\"2813\";s:5:\"title\";s:32:\"Homepage &#8211; Creative Agency\";s:9:\"thumbnail\";s:90:\"https://library.elementor.com/wp-content/uploads/2017/11/Creative-Agency-–-Home-Page.png\";s:12:\"tmpl_created\";s:10:\"1509615049\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/homepage-creative-agency/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:32:\"[\"Agency\",\"Creative\",\"Homepage\"]\";s:10:\"menu_order\";s:2:\"74\";s:16:\"popularity_index\";s:2:\"80\";s:11:\"trend_index\";s:3:\"192\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:485;a:14:{s:2:\"id\";s:5:\"10508\";s:5:\"title\";s:25:\"Full Screen | Welcome Mat\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2019/01/hand_small-1.png\";s:12:\"tmpl_created\";s:10:\"1547964711\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:122:\"https://library.elementor.com/popups/full-screen-welcome-mat-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"75\";s:16:\"popularity_index\";s:3:\"549\";s:11:\"trend_index\";s:3:\"588\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:486;a:14:{s:2:\"id\";s:3:\"728\";s:5:\"title\";s:33:\"Homepage &#8211; Delivery Company\";s:9:\"thumbnail\";s:87:\"https://library.elementor.com/wp-content/uploads/2017/01/delivery-company-home-page.jpg\";s:12:\"tmpl_created\";s:10:\"1485269993\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/homepage-delivery-company/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:23:\"[\"Delivery\",\"Homepage\"]\";s:10:\"menu_order\";s:2:\"75\";s:16:\"popularity_index\";s:3:\"214\";s:11:\"trend_index\";s:3:\"366\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:487;a:14:{s:2:\"id\";s:4:\"2403\";s:5:\"title\";s:29:\"Homepage &#8211; Luxury Hotel\";s:9:\"thumbnail\";s:66:\"https://library.elementor.com/wp-content/uploads/2017/09/Hotel.png\";s:12:\"tmpl_created\";s:10:\"1506441428\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/homepage-luxury-hotel/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"76\";s:16:\"popularity_index\";s:3:\"210\";s:11:\"trend_index\";s:3:\"330\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:488;a:14:{s:2:\"id\";s:4:\"9934\";s:5:\"title\";s:38:\"Full Screen | Welcome Mat | Teddy Bear\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2019/01/full_mat_teddy_small.png\";s:12:\"tmpl_created\";s:10:\"1547841787\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:120:\"https://library.elementor.com/popups/full-screen-welcome-mat/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"76\";s:16:\"popularity_index\";s:3:\"525\";s:11:\"trend_index\";s:1:\"0\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:489;a:14:{s:2:\"id\";s:4:\"1903\";s:5:\"title\";s:20:\"One Page &#8211; Spa\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2017/06/spa.png\";s:12:\"tmpl_created\";s:10:\"1496822325\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/one-page-spa/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:132:\"[\"beauty\",\"care\",\"girly\",\"hair\",\"Health\",\"hospitality\",\"massage\",\"medical\",\"parlor\",\"physiotherapy\",\"salon\",\"spa\",\"wellness\",\"yoga\"]\";s:10:\"menu_order\";s:2:\"77\";s:16:\"popularity_index\";s:3:\"154\";s:11:\"trend_index\";s:3:\"245\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:490;a:14:{s:2:\"id\";s:4:\"2123\";s:5:\"title\";s:33:\"One Page &#8211; Architect Office\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2017/06/architect.png\";s:12:\"tmpl_created\";s:10:\"1499772989\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/one-page-architect-office/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"78\";s:16:\"popularity_index\";s:2:\"10\";s:11:\"trend_index\";s:2:\"12\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:491;a:14:{s:2:\"id\";s:4:\"9709\";s:5:\"title\";s:25:\"Full Screen | Welcome Mat\";s:9:\"thumbnail\";s:95:\"https://library.elementor.com/wp-content/uploads/2019/01/Full-Screen_Welcome-Mat_01_small-1.png\";s:12:\"tmpl_created\";s:10:\"1547023834\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:123:\"https://library.elementor.com/popups/full-screen-welcome-mat-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:11:\"full screen\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"78\";s:16:\"popularity_index\";s:3:\"561\";s:11:\"trend_index\";s:3:\"578\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:492;a:14:{s:2:\"id\";s:4:\"1888\";s:5:\"title\";s:32:\"One Page &#8211; Creative Meetup\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2017/06/creative-meetup.png\";s:12:\"tmpl_created\";s:10:\"1496822319\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/one-page-creative-meetup/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"79\";s:16:\"popularity_index\";s:3:\"208\";s:11:\"trend_index\";s:3:\"423\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:493;a:14:{s:2:\"id\";s:4:\"9671\";s:5:\"title\";s:34:\"Hello Bar | Announcement | Cookies\";s:9:\"thumbnail\";s:90:\"https://library.elementor.com/wp-content/uploads/2019/01/Top-Bar_Announcement_small_01.png\";s:12:\"tmpl_created\";s:10:\"1547010259\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:122:\"https://library.elementor.com/popups/hello-bar-announcement-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:9:\"hello bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"79\";s:16:\"popularity_index\";s:3:\"520\";s:11:\"trend_index\";s:3:\"504\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:494;a:14:{s:2:\"id\";s:5:\"10234\";s:5:\"title\";s:38:\"Hello Bar | Announcement | Maintenance\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/01/pink_small.png\";s:12:\"tmpl_created\";s:10:\"1548055049\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:119:\"https://library.elementor.com/popups/hello-bar-announcement/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:9:\"hello bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"80\";s:16:\"popularity_index\";s:3:\"584\";s:11:\"trend_index\";s:3:\"549\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:495;a:14:{s:2:\"id\";s:4:\"1891\";s:5:\"title\";s:35:\"One Page &#8211; Textile Convention\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2017/06/textile-meetup.png\";s:12:\"tmpl_created\";s:10:\"1496822323\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/one-page-textile-convention/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"80\";s:16:\"popularity_index\";s:3:\"349\";s:11:\"trend_index\";s:3:\"531\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:496;a:14:{s:2:\"id\";s:4:\"1880\";s:5:\"title\";s:24:\"One Page &#8211; Wedding\";s:9:\"thumbnail\";s:68:\"https://library.elementor.com/wp-content/uploads/2017/06/wedding.png\";s:12:\"tmpl_created\";s:10:\"1496822317\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/one-page-wedding/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:82:\"[\"bride\",\"ceremony\",\"cute\",\"event\",\"fancy\",\"girly\",\"groom\",\"guestbook\",\"marriage\"]\";s:10:\"menu_order\";s:2:\"81\";s:16:\"popularity_index\";s:3:\"372\";s:11:\"trend_index\";s:3:\"451\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:497;a:14:{s:2:\"id\";s:4:\"1885\";s:5:\"title\";s:29:\"One Page &#8211; Yacht Rental\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2017/06/yacht-home.png\";s:12:\"tmpl_created\";s:10:\"1496822321\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/one-page-yacht-rental/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"82\";s:16:\"popularity_index\";s:3:\"169\";s:11:\"trend_index\";s:3:\"315\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:498;a:14:{s:2:\"id\";s:4:\"2723\";s:5:\"title\";s:34:\"Portfolio &#8211; Graphic Designer\";s:9:\"thumbnail\";s:91:\"https://library.elementor.com/wp-content/uploads/2017/11/Graphic-Designer-–-Portfolio.png\";s:12:\"tmpl_created\";s:10:\"1509633883\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/portfolio-graphic-designer/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"83\";s:16:\"popularity_index\";s:3:\"155\";s:11:\"trend_index\";s:3:\"240\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:499;a:14:{s:2:\"id\";s:4:\"9869\";s:5:\"title\";s:28:\"Hello Bar | Promotion | Sale\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2019/01/ru_small.png\";s:12:\"tmpl_created\";s:10:\"1547837269\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/popups/hello-bar-promotion/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:9:\"hello bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"83\";s:16:\"popularity_index\";s:3:\"583\";s:11:\"trend_index\";s:1:\"0\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:500;a:14:{s:2:\"id\";s:5:\"10539\";s:5:\"title\";s:19:\"Hello Bar | Contact\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2019/01/hello_pink_small.png\";s:12:\"tmpl_created\";s:10:\"1548056994\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:127:\"https://library.elementor.com/popups/hello-bar-register-subscribe-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:9:\"hello bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"84\";s:16:\"popularity_index\";s:3:\"560\";s:11:\"trend_index\";s:3:\"526\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:501;a:14:{s:2:\"id\";s:4:\"2145\";s:5:\"title\";s:30:\"About &#8211; Delivery Company\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2017/07/delivery-about.png\";s:12:\"tmpl_created\";s:10:\"1499774125\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/about-delivery-company/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:10:\"[\"moving\"]\";s:10:\"menu_order\";s:2:\"84\";s:16:\"popularity_index\";s:3:\"290\";s:11:\"trend_index\";s:3:\"521\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:502;a:14:{s:2:\"id\";s:4:\"2155\";s:5:\"title\";s:23:\"About &#8211; Cake Shop\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2017/07/cake-about.png\";s:12:\"tmpl_created\";s:10:\"1499774130\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/about-cake-shop/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:8:\"[\"Food\"]\";s:10:\"menu_order\";s:2:\"85\";s:16:\"popularity_index\";s:3:\"346\";s:11:\"trend_index\";s:3:\"388\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:503;a:14:{s:2:\"id\";s:4:\"1085\";s:5:\"title\";s:21:\"About &#8211; Startup\";s:9:\"thumbnail\";s:68:\"https://library.elementor.com/wp-content/uploads/2017/03/Startup.png\";s:12:\"tmpl_created\";s:10:\"1488810874\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/about-startup/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:19:\"[\"About\",\"Startup\"]\";s:10:\"menu_order\";s:2:\"86\";s:16:\"popularity_index\";s:1:\"7\";s:11:\"trend_index\";s:1:\"7\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:504;a:14:{s:2:\"id\";s:3:\"143\";s:5:\"title\";s:22:\"About &#8211; Personal\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0010.png\";s:12:\"tmpl_created\";s:10:\"1470820447\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/about-personal/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:20:\"[\"About\",\"Personal\"]\";s:10:\"menu_order\";s:2:\"87\";s:16:\"popularity_index\";s:2:\"19\";s:11:\"trend_index\";s:2:\"58\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:505;a:14:{s:2:\"id\";s:3:\"101\";s:5:\"title\";s:16:\"About &#8211; CV\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0018.png\";s:12:\"tmpl_created\";s:10:\"1470829785\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:98:\"https://library.elementor.com/about-cv/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:77:\"[\"creative portfolio\",\"Personal\",\"portfolio\",\"professional\",\"resume\",\"vcard\"]\";s:10:\"menu_order\";s:2:\"88\";s:16:\"popularity_index\";s:2:\"29\";s:11:\"trend_index\";s:2:\"54\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:506;a:14:{s:2:\"id\";s:3:\"140\";s:5:\"title\";s:25:\"About &#8211; Art Gallery\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0009.png\";s:12:\"tmpl_created\";s:10:\"1470820463\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/about-art-gallery/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:25:\"[\"About\",\"Art\",\"Gallery\"]\";s:10:\"menu_order\";s:2:\"89\";s:16:\"popularity_index\";s:2:\"15\";s:11:\"trend_index\";s:2:\"29\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:507;a:14:{s:2:\"id\";s:5:\"10147\";s:5:\"title\";s:34:\"Hello Bar | Sale | Promotion | Pop\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/donut_small.png\";s:12:\"tmpl_created\";s:10:\"1548055522\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:121:\"https://library.elementor.com/popups/hello-bar-sale-promotion/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:9:\"hello bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"89\";s:16:\"popularity_index\";s:3:\"586\";s:11:\"trend_index\";s:3:\"567\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:508;a:14:{s:2:\"id\";s:3:\"213\";s:5:\"title\";s:26:\"About &#8211; Architecture\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0008.png\";s:12:\"tmpl_created\";s:10:\"1470829766\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/about-architecture/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:24:\"[\"About\",\"Architecture\"]\";s:10:\"menu_order\";s:2:\"90\";s:16:\"popularity_index\";s:2:\"16\";s:11:\"trend_index\";s:2:\"30\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:509;a:14:{s:2:\"id\";s:4:\"9923\";s:5:\"title\";s:23:\"Slide In | Announcement\";s:9:\"thumbnail\";s:87:\"https://library.elementor.com/wp-content/uploads/2019/01/slide-in_ann_italian_small.png\";s:12:\"tmpl_created\";s:10:\"1547841537\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:118:\"https://library.elementor.com/popups/slide-in-announcement/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"90\";s:16:\"popularity_index\";s:3:\"537\";s:11:\"trend_index\";s:3:\"589\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:510;a:14:{s:2:\"id\";s:5:\"10117\";s:5:\"title\";s:23:\"Slide In | Announcement\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/white_small.png\";s:12:\"tmpl_created\";s:10:\"1548066998\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:120:\"https://library.elementor.com/popups/slide-in-announcement-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"91\";s:16:\"popularity_index\";s:3:\"559\";s:11:\"trend_index\";s:1:\"0\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:511;a:14:{s:2:\"id\";s:4:\"2802\";s:5:\"title\";s:38:\"Portfolio &#8211; Fashion Photographer\";s:9:\"thumbnail\";s:95:\"https://library.elementor.com/wp-content/uploads/2017/11/Fashion-photographer-–-Portfolio.png\";s:12:\"tmpl_created\";s:10:\"1509615440\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:120:\"https://library.elementor.com/portfolio-fashion-photographer/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"91\";s:16:\"popularity_index\";s:3:\"175\";s:11:\"trend_index\";s:3:\"367\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:512;a:14:{s:2:\"id\";s:4:\"2828\";s:5:\"title\";s:35:\"Landing Page &#8211; Law Convention\";s:9:\"thumbnail\";s:92:\"https://library.elementor.com/wp-content/uploads/2017/11/Law-Convention-–-Landing-Page.png\";s:12:\"tmpl_created\";s:10:\"1509631636\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/landing-page-law-convention/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:35:\"[\"Convention\",\"Landing Page\",\"Law\"]\";s:10:\"menu_order\";s:2:\"92\";s:16:\"popularity_index\";s:3:\"306\";s:11:\"trend_index\";s:3:\"450\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:513;a:14:{s:2:\"id\";s:4:\"9826\";s:5:\"title\";s:33:\"Slide In | Announcement | webinar\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2019/01/web_small-2.png\";s:12:\"tmpl_created\";s:10:\"1547835513\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:126:\"https://library.elementor.com/popups/slide-in-announcement-webinar/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"92\";s:16:\"popularity_index\";s:3:\"569\";s:11:\"trend_index\";s:1:\"0\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:514;a:14:{s:2:\"id\";s:5:\"10478\";s:5:\"title\";s:18:\"Slide In | Contact\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2019/01/slide_wow_small.png\";s:12:\"tmpl_created\";s:10:\"1548056829\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/popups/slide-in-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"93\";s:16:\"popularity_index\";s:3:\"480\";s:11:\"trend_index\";s:3:\"403\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:515;a:14:{s:2:\"id\";s:4:\"1461\";s:5:\"title\";s:28:\"Landing Page &#8211; Ebook 1\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-Ebook-1.png\";s:12:\"tmpl_created\";s:10:\"1494352121\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/landing-page-ebook-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:127:\"[\"App\",\"author\",\"book\",\"brochure\",\"download\",\"e-book\",\"ebook\",\"marketing\",\"product\",\"publisher\",\"sell online\",\"seo\",\"showcase\"]\";s:10:\"menu_order\";s:2:\"93\";s:16:\"popularity_index\";s:3:\"300\";s:11:\"trend_index\";s:3:\"428\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:516;a:14:{s:2:\"id\";s:4:\"1460\";s:5:\"title\";s:28:\"Landing Page &#8211; Ebook 2\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-Ebook-2.png\";s:12:\"tmpl_created\";s:10:\"1494352124\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/landing-page-ebook-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"94\";s:16:\"popularity_index\";s:3:\"317\";s:11:\"trend_index\";s:3:\"445\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:517;a:14:{s:2:\"id\";s:4:\"1459\";s:5:\"title\";s:28:\"Landing Page &#8211; Ebook 3\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-Ebook-3.png\";s:12:\"tmpl_created\";s:10:\"1494352125\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/landing-page-ebook-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"95\";s:16:\"popularity_index\";s:3:\"205\";s:11:\"trend_index\";s:3:\"339\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:518;a:14:{s:2:\"id\";s:4:\"1052\";s:5:\"title\";s:33:\"Landing Page &#8211; Mobile App 1\";s:9:\"thumbnail\";s:64:\"https://library.elementor.com/wp-content/uploads/2017/03/app.png\";s:12:\"tmpl_created\";s:10:\"1488810873\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/landing-page-mobile-app/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"96\";s:16:\"popularity_index\";s:2:\"25\";s:11:\"trend_index\";s:2:\"64\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:519;a:14:{s:2:\"id\";s:5:\"10685\";s:5:\"title\";s:32:\"Hello Bar | Register | Subscribe\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2019/01/env_small.png\";s:12:\"tmpl_created\";s:10:\"1547974729\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:127:\"https://library.elementor.com/popups/hello-bar-register-subscribe-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:9:\"hello bar\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"96\";s:16:\"popularity_index\";s:3:\"528\";s:11:\"trend_index\";s:1:\"0\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:520;a:14:{s:2:\"id\";s:4:\"1505\";s:5:\"title\";s:33:\"Landing Page &#8211; Mobile App 4\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-app3.png\";s:12:\"tmpl_created\";s:10:\"1494352110\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/landing-page-mobile-app-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"97\";s:16:\"popularity_index\";s:3:\"344\";s:11:\"trend_index\";s:3:\"523\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:521;a:14:{s:2:\"id\";s:3:\"726\";s:5:\"title\";s:33:\"Landing Page &#8211; Conference 1\";s:9:\"thumbnail\";s:84:\"https://library.elementor.com/wp-content/uploads/2017/01/convention-landing-page.jpg\";s:12:\"tmpl_created\";s:10:\"1485270062\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/landing-page-conference/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"98\";s:16:\"popularity_index\";s:3:\"361\";s:11:\"trend_index\";s:3:\"517\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:522;a:14:{s:2:\"id\";s:4:\"9985\";s:5:\"title\";s:20:\"Slide In | Promotion\";s:9:\"thumbnail\";s:87:\"https://library.elementor.com/wp-content/uploads/2019/01/slidein_promotion_av_small.png\";s:12:\"tmpl_created\";s:10:\"1547844661\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/popups/slide-in-promotion-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"98\";s:16:\"popularity_index\";s:3:\"577\";s:11:\"trend_index\";s:1:\"0\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:523;a:14:{s:2:\"id\";s:4:\"1613\";s:5:\"title\";s:33:\"Landing Page &#8211; Conference 2\";s:9:\"thumbnail\";s:109:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-International-Womens-Day-Conference.png\";s:12:\"tmpl_created\";s:10:\"1494352129\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/landing-page-conference-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:2:\"99\";s:16:\"popularity_index\";s:3:\"375\";s:11:\"trend_index\";s:3:\"332\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:524;a:14:{s:2:\"id\";s:4:\"1612\";s:5:\"title\";s:33:\"Landing Page &#8211; Conference 3\";s:9:\"thumbnail\";s:89:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-Tech-Conference.png\";s:12:\"tmpl_created\";s:10:\"1494352127\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/landing-page-conference-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"100\";s:16:\"popularity_index\";s:3:\"387\";s:11:\"trend_index\";s:3:\"563\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:525;a:14:{s:2:\"id\";s:4:\"1614\";s:5:\"title\";s:33:\"Landing Page &#8211; Conference 4\";s:9:\"thumbnail\";s:99:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-Sustainability-Conference.png\";s:12:\"tmpl_created\";s:10:\"1494352131\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/landing-page-conference-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"101\";s:16:\"popularity_index\";s:3:\"330\";s:11:\"trend_index\";s:3:\"437\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:526;a:14:{s:2:\"id\";s:3:\"906\";s:5:\"title\";s:29:\"Landing Page &#8211;  Coacher\";s:9:\"thumbnail\";s:80:\"https://library.elementor.com/wp-content/uploads/2017/02/Landin-Page-Coacher.png\";s:12:\"tmpl_created\";s:10:\"1494352066\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/landing-page-coacher/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"102\";s:16:\"popularity_index\";s:3:\"216\";s:11:\"trend_index\";s:3:\"354\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:527;a:14:{s:2:\"id\";s:3:\"879\";s:5:\"title\";s:41:\"Landing Page &#8211; Financial Consultant\";s:9:\"thumbnail\";s:94:\"https://library.elementor.com/wp-content/uploads/2017/02/Landing-Page-Financial-consultant.png\";s:12:\"tmpl_created\";s:10:\"1494352064\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:123:\"https://library.elementor.com/landing-page-financial-consultant/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"103\";s:16:\"popularity_index\";s:3:\"240\";s:11:\"trend_index\";s:3:\"357\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:528;a:14:{s:2:\"id\";s:3:\"926\";s:5:\"title\";s:33:\"Landing Page &#8211; Private Chef\";s:9:\"thumbnail\";s:86:\"https://library.elementor.com/wp-content/uploads/2017/02/Landing-Page-Private-Chef.png\";s:12:\"tmpl_created\";s:10:\"1494352068\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/landing-page-private-chef/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"104\";s:16:\"popularity_index\";s:3:\"345\";s:11:\"trend_index\";s:3:\"383\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:529;a:14:{s:2:\"id\";s:4:\"1032\";s:5:\"title\";s:27:\"Landing Page &#8211; Agency\";s:9:\"thumbnail\";s:67:\"https://library.elementor.com/wp-content/uploads/2017/03/Agency.png\";s:12:\"tmpl_created\";s:10:\"1488810866\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/landing-page-agency/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"105\";s:16:\"popularity_index\";s:3:\"338\";s:11:\"trend_index\";s:3:\"465\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:530;a:14:{s:2:\"id\";s:4:\"9559\";s:5:\"title\";s:16:\"Slide In | Login\";s:9:\"thumbnail\";s:83:\"https://library.elementor.com/wp-content/uploads/2019/01/slidein_login_01_small.png\";s:12:\"tmpl_created\";s:10:\"1546946547\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/popups/slide-in-login-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"105\";s:16:\"popularity_index\";s:3:\"469\";s:11:\"trend_index\";s:3:\"556\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:531;a:14:{s:2:\"id\";s:3:\"730\";s:5:\"title\";s:24:\"Landing Page &#8211; App\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2017/01/app.-landing-page.jpg\";s:12:\"tmpl_created\";s:10:\"1485273430\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/landing-page-app/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"106\";s:16:\"popularity_index\";s:3:\"309\";s:11:\"trend_index\";s:3:\"370\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:532;a:14:{s:2:\"id\";s:3:\"643\";s:5:\"title\";s:29:\"Landing Page &#8211; Festival\";s:9:\"thumbnail\";s:69:\"https://library.elementor.com/wp-content/uploads/2016/12/festival.jpg\";s:12:\"tmpl_created\";s:10:\"1481549290\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/landing-page-festival/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"107\";s:16:\"popularity_index\";s:3:\"360\";s:11:\"trend_index\";s:3:\"581\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:533;a:14:{s:2:\"id\";s:4:\"9752\";s:5:\"title\";s:27:\"Slide In | Sale | Promotion\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2019/01/rush_small.png\";s:12:\"tmpl_created\";s:10:\"1547823982\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:120:\"https://library.elementor.com/popups/slide-in-sale-promotion/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:6:\"fly-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"107\";s:16:\"popularity_index\";s:3:\"563\";s:11:\"trend_index\";s:1:\"0\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:534;a:14:{s:2:\"id\";s:3:\"542\";s:5:\"title\";s:28:\"Landing Page &#8211; Wedding\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/10/0025.png\";s:12:\"tmpl_created\";s:10:\"1477388484\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/landing-page-wedding/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"108\";s:16:\"popularity_index\";s:2:\"65\";s:11:\"trend_index\";s:3:\"132\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:535;a:14:{s:2:\"id\";s:4:\"1187\";s:5:\"title\";s:32:\"Landing Page &#8211; Photography\";s:9:\"thumbnail\";s:66:\"https://library.elementor.com/wp-content/uploads/2017/03/lp1-l.png\";s:12:\"tmpl_created\";s:10:\"1490707385\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/landing-page-photography/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"109\";s:16:\"popularity_index\";s:2:\"30\";s:11:\"trend_index\";s:2:\"60\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:536;a:14:{s:2:\"id\";s:3:\"641\";s:5:\"title\";s:28:\"Landing Page &#8211; Fashion\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2016/12/fashion-landing-page.jpg\";s:12:\"tmpl_created\";s:10:\"1481549264\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/landing-page-fashion/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"110\";s:16:\"popularity_index\";s:3:\"276\";s:11:\"trend_index\";s:3:\"401\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:537;a:14:{s:2:\"id\";s:3:\"189\";s:5:\"title\";s:30:\"Landing Page &#8211; Tourism 1\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0005.png\";s:12:\"tmpl_created\";s:10:\"1470820715\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/landing-page-tourism/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"111\";s:16:\"popularity_index\";s:2:\"14\";s:11:\"trend_index\";s:2:\"16\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:538;a:14:{s:2:\"id\";s:5:\"10169\";s:5:\"title\";s:37:\"Slide In | Register | Subscribe | App\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2019/01/slideinapp_small.png\";s:12:\"tmpl_created\";s:10:\"1547852334\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:126:\"https://library.elementor.com/popups/slide-in-register-subscribe-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"112\";s:16:\"popularity_index\";s:3:\"355\";s:11:\"trend_index\";s:3:\"541\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:539;a:14:{s:2:\"id\";s:4:\"1547\";s:5:\"title\";s:30:\"Landing Page &#8211; Tourism 2\";s:9:\"thumbnail\";s:82:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-Truism-1.png\";s:12:\"tmpl_created\";s:10:\"1494352115\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/landing-page-tourism-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"112\";s:16:\"popularity_index\";s:3:\"288\";s:11:\"trend_index\";s:3:\"456\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:540;a:14:{s:2:\"id\";s:4:\"1546\";s:5:\"title\";s:30:\"Landing Page &#8211; Tourism 3\";s:9:\"thumbnail\";s:82:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-Truism-2.png\";s:12:\"tmpl_created\";s:10:\"1494352116\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/landing-page-tourism-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"113\";s:16:\"popularity_index\";s:3:\"382\";s:11:\"trend_index\";s:3:\"501\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:541;a:14:{s:2:\"id\";s:4:\"1545\";s:5:\"title\";s:30:\"Landing Page &#8211; Tourism 4\";s:9:\"thumbnail\";s:82:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-Truism-3.png\";s:12:\"tmpl_created\";s:10:\"1494352118\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/landing-page-tourism-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"114\";s:16:\"popularity_index\";s:3:\"328\";s:11:\"trend_index\";s:3:\"480\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:542;a:14:{s:2:\"id\";s:4:\"2714\";s:5:\"title\";s:30:\"Landing Page &#8211; Tourism 5\";s:9:\"thumbnail\";s:86:\"https://library.elementor.com/wp-content/uploads/2017/11/Vacation-–-Landing-Page.png\";s:12:\"tmpl_created\";s:10:\"1509631782\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:112:\"https://library.elementor.com/landing-page-tourism-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"115\";s:16:\"popularity_index\";s:3:\"322\";s:11:\"trend_index\";s:3:\"453\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:543;a:14:{s:2:\"id\";s:4:\"9680\";s:5:\"title\";s:23:\"Slide In | Content Lock\";s:9:\"thumbnail\";s:91:\"https://library.elementor.com/wp-content/uploads/2019/01/Slide-in_Content-lock_small_01.png\";s:12:\"tmpl_created\";s:10:\"1547010967\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:121:\"https://library.elementor.com/popups/slide-in-content-lock-01/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"115\";s:16:\"popularity_index\";s:3:\"568\";s:11:\"trend_index\";s:3:\"576\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:544;a:14:{s:2:\"id\";s:3:\"195\";s:5:\"title\";s:28:\"Landing Page &#8211; Product\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0006.png\";s:12:\"tmpl_created\";s:10:\"1470820765\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/landing-page-product/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"116\";s:16:\"popularity_index\";s:2:\"39\";s:11:\"trend_index\";s:2:\"90\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:545;a:14:{s:2:\"id\";s:3:\"197\";s:5:\"title\";s:34:\"Landing Page &#8211; Real Estate 1\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0007.png\";s:12:\"tmpl_created\";s:10:\"1470825711\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/landing-page-real-estate/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"117\";s:16:\"popularity_index\";s:2:\"90\";s:11:\"trend_index\";s:3:\"198\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:546;a:14:{s:2:\"id\";s:4:\"9783\";s:5:\"title\";s:31:\"Slide In | Register | Subscribe\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2019/01/slidein_yellow_small.png\";s:12:\"tmpl_created\";s:10:\"1547831059\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:124:\"https://library.elementor.com/popups/slide-in-register-subscribe/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:5:\"popup\";s:7:\"subtype\";s:8:\"slide-in\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"117\";s:16:\"popularity_index\";s:3:\"461\";s:11:\"trend_index\";s:3:\"386\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"1\";}i:547;a:14:{s:2:\"id\";s:4:\"1193\";s:5:\"title\";s:34:\"Landing Page &#8211; Real Estate 2\";s:9:\"thumbnail\";s:66:\"https://library.elementor.com/wp-content/uploads/2017/03/lp3-l.png\";s:12:\"tmpl_created\";s:10:\"1490707422\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/landing-page-real-estate-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"118\";s:16:\"popularity_index\";s:2:\"51\";s:11:\"trend_index\";s:3:\"103\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:548;a:14:{s:2:\"id\";s:4:\"1415\";s:5:\"title\";s:34:\"Landing Page &#8211; Real Estate 3\";s:9:\"thumbnail\";s:87:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-Real-Estate-1.png\";s:12:\"tmpl_created\";s:10:\"1494352106\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/landing-page-real-estate-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"119\";s:16:\"popularity_index\";s:3:\"305\";s:11:\"trend_index\";s:3:\"323\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:549;a:14:{s:2:\"id\";s:4:\"1414\";s:5:\"title\";s:34:\"Landing Page &#8211; Real Estate 4\";s:9:\"thumbnail\";s:87:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-Real-Estate-2.png\";s:12:\"tmpl_created\";s:10:\"1494352107\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/landing-page-real-estate-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"120\";s:16:\"popularity_index\";s:3:\"406\";s:11:\"trend_index\";s:3:\"533\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:550;a:14:{s:2:\"id\";s:4:\"1413\";s:5:\"title\";s:34:\"Landing Page &#8211; Real Estate 5\";s:9:\"thumbnail\";s:87:\"https://library.elementor.com/wp-content/uploads/2017/05/Landing-Page-Real-Estate-3.png\";s:12:\"tmpl_created\";s:10:\"1494352109\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/landing-page-real-estate-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:134:\"[\"Agent\",\"business\",\"clean\",\"corporate\",\"flat\",\"google maps\",\"homes\",\"listing\",\"modern\",\"real estate\",\"realestate\",\"realtor\",\"realty\"]\";s:10:\"menu_order\";s:3:\"121\";s:16:\"popularity_index\";s:3:\"374\";s:11:\"trend_index\";s:3:\"574\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:551;a:14:{s:2:\"id\";s:4:\"1573\";s:5:\"title\";s:29:\"Landing Page &#8211; Coupon 1\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2017/05/Coupon-02.png\";s:12:\"tmpl_created\";s:10:\"1494352133\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/landing-page-coupon-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"122\";s:16:\"popularity_index\";s:3:\"415\";s:11:\"trend_index\";s:3:\"481\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:552;a:14:{s:2:\"id\";s:4:\"1572\";s:5:\"title\";s:29:\"Landing Page &#8211; Coupon 2\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2017/05/Coupon-03.png\";s:12:\"tmpl_created\";s:10:\"1494352134\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/landing-page-coupon-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"123\";s:16:\"popularity_index\";s:3:\"449\";s:11:\"trend_index\";s:3:\"421\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:553;a:14:{s:2:\"id\";s:4:\"1570\";s:5:\"title\";s:29:\"Landing Page &#8211; Coupon 3\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2017/05/Coupon-01.png\";s:12:\"tmpl_created\";s:10:\"1494352136\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/landing-page-coupon-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"124\";s:16:\"popularity_index\";s:3:\"481\";s:11:\"trend_index\";s:3:\"424\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:554;a:14:{s:2:\"id\";s:4:\"1571\";s:5:\"title\";s:29:\"Landing Page &#8211; Coupon 4\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2017/05/Coupon-04.png\";s:12:\"tmpl_created\";s:10:\"1494352138\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/landing-page-coupon-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"125\";s:16:\"popularity_index\";s:3:\"460\";s:11:\"trend_index\";s:1:\"0\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:555;a:14:{s:2:\"id\";s:3:\"192\";s:5:\"title\";s:28:\"Landing Page &#8211; Webinar\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0015.png\";s:12:\"tmpl_created\";s:10:\"1470820734\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/landing-page-webinar/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"126\";s:16:\"popularity_index\";s:2:\"82\";s:11:\"trend_index\";s:3:\"209\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:556;a:14:{s:2:\"id\";s:4:\"2141\";s:5:\"title\";s:32:\"Contact &#8211; Delivery Company\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2017/07/delivery-contact.png\";s:12:\"tmpl_created\";s:10:\"1499774122\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/contact-delivery-company/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"127\";s:16:\"popularity_index\";s:3:\"279\";s:11:\"trend_index\";s:3:\"384\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:557;a:14:{s:2:\"id\";s:3:\"137\";s:5:\"title\";s:22:\"Contact &#8211; Modern\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0013.png\";s:12:\"tmpl_created\";s:10:\"1470829828\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/contact-modern/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"128\";s:16:\"popularity_index\";s:2:\"32\";s:11:\"trend_index\";s:2:\"51\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:558;a:14:{s:2:\"id\";s:3:\"256\";s:5:\"title\";s:26:\"Contact &#8211; Restaurant\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0011.png\";s:12:\"tmpl_created\";s:10:\"1470829796\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/contact-restaurant/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"129\";s:16:\"popularity_index\";s:2:\"94\";s:11:\"trend_index\";s:3:\"133\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:559;a:14:{s:2:\"id\";s:4:\"2150\";s:5:\"title\";s:25:\"Contact &#8211; Cake Shop\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2017/07/cake-contact.png\";s:12:\"tmpl_created\";s:10:\"1499774127\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/contact-cake-shop/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"130\";s:16:\"popularity_index\";s:2:\"54\";s:11:\"trend_index\";s:3:\"122\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:560;a:14:{s:2:\"id\";s:3:\"223\";s:5:\"title\";s:21:\"Contact &#8211; Hotel\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0002.png\";s:12:\"tmpl_created\";s:10:\"1470820471\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/contact-hotel/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"131\";s:16:\"popularity_index\";s:2:\"92\";s:11:\"trend_index\";s:3:\"148\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:561;a:14:{s:2:\"id\";s:2:\"24\";s:5:\"title\";s:25:\"Contact &#8211; Corporate\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0012.png\";s:12:\"tmpl_created\";s:10:\"1470248619\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/contact-corporate/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"132\";s:16:\"popularity_index\";s:2:\"12\";s:11:\"trend_index\";s:2:\"11\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:562;a:14:{s:2:\"id\";s:3:\"184\";s:5:\"title\";s:23:\"Services &#8211; Moving\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0017.png\";s:12:\"tmpl_created\";s:10:\"1470829889\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/services-moving/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"133\";s:16:\"popularity_index\";s:2:\"22\";s:11:\"trend_index\";s:2:\"23\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:563;a:14:{s:2:\"id\";s:3:\"625\";s:5:\"title\";s:31:\"Services &#8211; Cake Shop Menu\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2016/12/cake-shop-menu.jpg\";s:12:\"tmpl_created\";s:10:\"1481549196\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/services-cake-shop-menu/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"134\";s:16:\"popularity_index\";s:3:\"446\";s:11:\"trend_index\";s:3:\"580\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:564;a:14:{s:2:\"id\";s:3:\"187\";s:5:\"title\";s:20:\"Services &#8211; Fun\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0001.png\";s:12:\"tmpl_created\";s:10:\"1470829892\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/services-fun/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"135\";s:16:\"popularity_index\";s:2:\"55\";s:11:\"trend_index\";s:2:\"99\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:565;a:14:{s:2:\"id\";s:3:\"238\";s:5:\"title\";s:27:\"Services &#8211; Consulting\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0014.png\";s:12:\"tmpl_created\";s:10:\"1470829865\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/services-consulting/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"136\";s:16:\"popularity_index\";s:2:\"20\";s:11:\"trend_index\";s:2:\"40\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:566;a:14:{s:2:\"id\";s:3:\"647\";s:5:\"title\";s:33:\"Services &#8211; Coffee Shop Menu\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2016/12/restaurant-menu.jpg\";s:12:\"tmpl_created\";s:10:\"1481549320\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/services-coffee-shop-menu/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"137\";s:16:\"popularity_index\";s:3:\"386\";s:11:\"trend_index\";s:3:\"502\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:567;a:14:{s:2:\"id\";s:4:\"2138\";s:5:\"title\";s:33:\"Services &#8211; Delivery Company\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2017/07/delivery-services.png\";s:12:\"tmpl_created\";s:10:\"1499774119\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/services-delivery-company/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"138\";s:16:\"popularity_index\";s:3:\"343\";s:11:\"trend_index\";s:3:\"390\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:568;a:14:{s:2:\"id\";s:3:\"823\";s:5:\"title\";s:19:\"Pricing &#8211; App\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2017/01/pricing-app.jpg\";s:12:\"tmpl_created\";s:10:\"1485272966\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/pricing-app-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"139\";s:16:\"popularity_index\";s:3:\"311\";s:11:\"trend_index\";s:3:\"336\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:569;a:14:{s:2:\"id\";s:3:\"824\";s:5:\"title\";s:24:\"Pricing &#8211; Software\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2017/01/pricing-software.png\";s:12:\"tmpl_created\";s:10:\"1485272900\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/pricing-software-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"140\";s:16:\"popularity_index\";s:3:\"335\";s:11:\"trend_index\";s:3:\"500\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:570;a:14:{s:2:\"id\";s:3:\"825\";s:5:\"title\";s:24:\"Product &#8211; Speakers\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2017/01/product-page.jpg\";s:12:\"tmpl_created\";s:10:\"1485272513\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/product-speakers/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"141\";s:16:\"popularity_index\";s:3:\"350\";s:11:\"trend_index\";s:3:\"436\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:571;a:14:{s:2:\"id\";s:3:\"245\";s:5:\"title\";s:21:\"Product &#8211; Clean\";s:9:\"thumbnail\";s:65:\"https://library.elementor.com/wp-content/uploads/2016/08/0020.png\";s:12:\"tmpl_created\";s:10:\"1470829876\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/product-clean/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:48:\"[\"fast\",\"minimal\",\"minimalistic\",\"seo\",\"simple\"]\";s:10:\"menu_order\";s:3:\"142\";s:16:\"popularity_index\";s:2:\"63\";s:11:\"trend_index\";s:3:\"131\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:572;a:14:{s:2:\"id\";s:4:\"1075\";s:5:\"title\";s:19:\"Shop &#8211; Sweets\";s:9:\"thumbnail\";s:67:\"https://library.elementor.com/wp-content/uploads/2017/03/Sweets.png\";s:12:\"tmpl_created\";s:10:\"1488810871\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:101:\"https://library.elementor.com/shop-sweets/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:154:\"[\"bakery\",\"beverage\",\"business\",\"cafe\",\"candy bar\",\"catering\",\"delivery service\",\"Food\",\"online shop\",\"pastry\",\"Restaurant\",\"store\",\"sweet shop\",\"sweets\"]\";s:10:\"menu_order\";s:3:\"143\";s:16:\"popularity_index\";s:2:\"45\";s:11:\"trend_index\";s:3:\"113\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:573;a:14:{s:2:\"id\";s:4:\"1051\";s:5:\"title\";s:24:\"Blog Post &#8211; Launch\";s:9:\"thumbnail\";s:71:\"https://library.elementor.com/wp-content/uploads/2017/03/post-cloud.png\";s:12:\"tmpl_created\";s:10:\"1488810869\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/blog-post-launch/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:210:\"[\"Agency\",\"bootstrap\",\"business\",\"corporate\",\"Landing Page\",\"launch\",\"marketing campaign\",\"marketing landing page\",\"marketing template landing page\",\"product launch\",\"software\",\"Startup\",\"startup landing page\"]\";s:10:\"menu_order\";s:3:\"144\";s:16:\"popularity_index\";s:2:\"17\";s:11:\"trend_index\";s:2:\"18\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:574;a:14:{s:2:\"id\";s:4:\"1245\";s:5:\"title\";s:13:\"Coming Soon 1\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2017/03/Coming-Soon-1.png\";s:12:\"tmpl_created\";s:10:\"1491207184\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/coming-soon-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"145\";s:16:\"popularity_index\";s:3:\"246\";s:11:\"trend_index\";s:3:\"316\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:575;a:14:{s:2:\"id\";s:4:\"1247\";s:5:\"title\";s:13:\"Coming Soon 2\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2017/03/Coming-Soon-2.png\";s:12:\"tmpl_created\";s:10:\"1491207138\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/coming-soon-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"146\";s:16:\"popularity_index\";s:2:\"27\";s:11:\"trend_index\";s:2:\"42\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:576;a:14:{s:2:\"id\";s:4:\"1248\";s:5:\"title\";s:13:\"Coming Soon 3\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2017/03/Coming-Soon-3.png\";s:12:\"tmpl_created\";s:10:\"1491207050\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/coming-soon-3/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"147\";s:16:\"popularity_index\";s:3:\"352\";s:11:\"trend_index\";s:3:\"373\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:577;a:14:{s:2:\"id\";s:4:\"1249\";s:5:\"title\";s:13:\"Coming Soon 4\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2017/03/Coming-Soon-4.png\";s:12:\"tmpl_created\";s:10:\"1491207380\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/coming-soon-4/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"148\";s:16:\"popularity_index\";s:3:\"379\";s:11:\"trend_index\";s:3:\"464\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:578;a:14:{s:2:\"id\";s:4:\"1250\";s:5:\"title\";s:13:\"Coming Soon 5\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2017/03/Coming-Soon-5.png\";s:12:\"tmpl_created\";s:10:\"1491207450\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/coming-soon-5/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"149\";s:16:\"popularity_index\";s:2:\"59\";s:11:\"trend_index\";s:2:\"89\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:579;a:14:{s:2:\"id\";s:4:\"1260\";s:5:\"title\";s:18:\"Maintenance Mode 1\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2017/03/Coming-Soon-6.png\";s:12:\"tmpl_created\";s:10:\"1491207507\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/maintenance-mode-1/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"150\";s:16:\"popularity_index\";s:3:\"384\";s:11:\"trend_index\";s:3:\"524\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:580;a:14:{s:2:\"id\";s:4:\"1261\";s:5:\"title\";s:18:\"Maintenance Mode 2\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2017/04/Coming-Soon-7.png\";s:12:\"tmpl_created\";s:10:\"1491207584\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/maintenance-mode-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"151\";s:16:\"popularity_index\";s:2:\"57\";s:11:\"trend_index\";s:2:\"96\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:581;a:14:{s:2:\"id\";s:4:\"1272\";s:5:\"title\";s:13:\"Coming Soon 8\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2017/03/Coming-Soon-8.png\";s:12:\"tmpl_created\";s:10:\"1491207674\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/coming-soon-8/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"152\";s:16:\"popularity_index\";s:3:\"262\";s:11:\"trend_index\";s:3:\"333\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:582;a:14:{s:2:\"id\";s:4:\"1279\";s:5:\"title\";s:13:\"Coming Soon 9\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2017/03/Coming-Soon-9.png\";s:12:\"tmpl_created\";s:10:\"1491207756\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:103:\"https://library.elementor.com/coming-soon-9/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"153\";s:16:\"popularity_index\";s:3:\"117\";s:11:\"trend_index\";s:3:\"112\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}i:583;a:14:{s:2:\"id\";s:4:\"1745\";s:5:\"title\";s:14:\"Coming Soon 10\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2017/05/login-002.png\";s:12:\"tmpl_created\";s:10:\"1494849745\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/coming-soon-10/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"154\";s:16:\"popularity_index\";s:3:\"252\";s:11:\"trend_index\";s:3:\"311\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:584;a:14:{s:2:\"id\";s:4:\"1742\";s:5:\"title\";s:12:\"Login Page 1\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2017/05/login-003.png\";s:12:\"tmpl_created\";s:10:\"1494849744\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:100:\"https://library.elementor.com/login-page/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"155\";s:16:\"popularity_index\";s:3:\"373\";s:11:\"trend_index\";s:3:\"551\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:585;a:14:{s:2:\"id\";s:4:\"1748\";s:5:\"title\";s:12:\"Login Page 2\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2017/05/login-001.png\";s:12:\"tmpl_created\";s:10:\"1494849742\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:102:\"https://library.elementor.com/login-page-2/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"156\";s:16:\"popularity_index\";s:3:\"270\";s:11:\"trend_index\";s:3:\"352\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:586;a:14:{s:2:\"id\";s:4:\"3963\";s:5:\"title\";s:32:\"Restaurant Site &#8211; Homepage\";s:9:\"thumbnail\";s:76:\"https://library.elementor.com/wp-content/uploads/2018/01/R.HomepageThumb.png\";s:12:\"tmpl_created\";s:10:\"1516284821\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:114:\"https://library.elementor.com/restaurant-site-homepage/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:109:\"[\"bar\",\"cafe\",\"cooking\",\"drink\",\"events\",\"fast food\",\"Food\",\"menu\",\"modern\",\"reservation\",\"Shop\",\"snack bar\"]\";s:10:\"menu_order\";s:3:\"157\";s:16:\"popularity_index\";s:3:\"230\";s:11:\"trend_index\";s:3:\"325\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:587;a:14:{s:2:\"id\";s:4:\"3969\";s:5:\"title\";s:28:\"Restaurant Site &#8211; Menu\";s:9:\"thumbnail\";s:72:\"https://library.elementor.com/wp-content/uploads/2018/01/R.MenuThumb.png\";s:12:\"tmpl_created\";s:10:\"1516284829\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/restaurant-site-menu/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:109:\"[\"bar\",\"cafe\",\"cooking\",\"drink\",\"events\",\"fast food\",\"Food\",\"menu\",\"modern\",\"reservation\",\"Shop\",\"snack bar\"]\";s:10:\"menu_order\";s:3:\"158\";s:16:\"popularity_index\";s:3:\"365\";s:11:\"trend_index\";s:3:\"455\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:588;a:14:{s:2:\"id\";s:4:\"3966\";s:5:\"title\";s:29:\"Restaurant Site &#8211; About\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2018/01/R.AboutThumb.png.png\";s:12:\"tmpl_created\";s:10:\"1516284839\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:111:\"https://library.elementor.com/restaurant-site-about/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:109:\"[\"bar\",\"cafe\",\"cooking\",\"drink\",\"events\",\"fast food\",\"Food\",\"menu\",\"modern\",\"reservation\",\"Shop\",\"snack bar\"]\";s:10:\"menu_order\";s:3:\"159\";s:16:\"popularity_index\";s:3:\"237\";s:11:\"trend_index\";s:3:\"358\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:589;a:14:{s:2:\"id\";s:4:\"3972\";s:5:\"title\";s:31:\"Restaurant Site &#8211; Contact\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2018/01/R.ContactThumb.png\";s:12:\"tmpl_created\";s:10:\"1516284847\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/restaurant-site-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:109:\"[\"bar\",\"cafe\",\"cooking\",\"drink\",\"events\",\"fast food\",\"Food\",\"menu\",\"modern\",\"reservation\",\"Shop\",\"snack bar\"]\";s:10:\"menu_order\";s:3:\"160\";s:16:\"popularity_index\";s:3:\"332\";s:11:\"trend_index\";s:3:\"508\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:590;a:14:{s:2:\"id\";s:4:\"2080\";s:5:\"title\";s:27:\"Ski Resort &#8211; Homepage\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2017/10/Ski-Resort-Home-Page.png\";s:12:\"tmpl_created\";s:10:\"1508161124\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/ski-resort-homepage/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"161\";s:16:\"popularity_index\";s:3:\"296\";s:11:\"trend_index\";s:3:\"387\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:591;a:14:{s:2:\"id\";s:4:\"2088\";s:5:\"title\";s:24:\"Ski Resort &#8211; About\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2017/10/Ski-Resort-About.png\";s:12:\"tmpl_created\";s:10:\"1508161129\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:106:\"https://library.elementor.com/ski-resort-about/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"162\";s:16:\"popularity_index\";s:3:\"367\";s:11:\"trend_index\";s:3:\"395\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:592;a:14:{s:2:\"id\";s:4:\"2085\";s:5:\"title\";s:27:\"Ski Resort &#8211; Services\";s:9:\"thumbnail\";s:80:\"https://library.elementor.com/wp-content/uploads/2017/10/Ski-Resort-Services.png\";s:12:\"tmpl_created\";s:10:\"1508161134\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/ski-resort-services/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"163\";s:16:\"popularity_index\";s:3:\"443\";s:11:\"trend_index\";s:3:\"544\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:593;a:14:{s:2:\"id\";s:4:\"2462\";s:5:\"title\";s:23:\"Architect &#8211; About\";s:9:\"thumbnail\";s:80:\"https://library.elementor.com/wp-content/uploads/2017/10/architect-–-about.png\";s:12:\"tmpl_created\";s:10:\"1508243317\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:105:\"https://library.elementor.com/architect-about/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"164\";s:16:\"popularity_index\";s:3:\"291\";s:11:\"trend_index\";s:3:\"447\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:594;a:14:{s:2:\"id\";s:4:\"2362\";s:5:\"title\";s:26:\"Architect &#8211; Projects\";s:9:\"thumbnail\";s:79:\"https://library.elementor.com/wp-content/uploads/2017/10/Architect-Projects.png\";s:12:\"tmpl_created\";s:10:\"1508243335\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:108:\"https://library.elementor.com/architect-projects/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"165\";s:16:\"popularity_index\";s:3:\"357\";s:11:\"trend_index\";s:3:\"346\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:595;a:14:{s:2:\"id\";s:3:\"614\";s:5:\"title\";s:25:\"Architect &#8211; Contact\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2016/12/architect-contact.jpg\";s:12:\"tmpl_created\";s:10:\"1481549169\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/architect-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"166\";s:16:\"popularity_index\";s:3:\"254\";s:11:\"trend_index\";s:3:\"443\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:596;a:14:{s:2:\"id\";s:4:\"2126\";s:5:\"title\";s:37:\"Construction Company &#8211; Homepage\";s:9:\"thumbnail\";s:91:\"https://library.elementor.com/wp-content/uploads/2017/10/Construction-Company-Home-Page.png\";s:12:\"tmpl_created\";s:10:\"1508325849\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:119:\"https://library.elementor.com/construction-company-homepage/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"167\";s:16:\"popularity_index\";s:3:\"263\";s:11:\"trend_index\";s:3:\"306\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:597;a:14:{s:2:\"id\";s:4:\"2129\";s:5:\"title\";s:34:\"Construction Company &#8211; About\";s:9:\"thumbnail\";s:87:\"https://library.elementor.com/wp-content/uploads/2017/10/Construction-Company-About.png\";s:12:\"tmpl_created\";s:10:\"1508325881\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:116:\"https://library.elementor.com/construction-company-about/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"168\";s:16:\"popularity_index\";s:3:\"280\";s:11:\"trend_index\";s:3:\"314\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:598;a:14:{s:2:\"id\";s:4:\"2135\";s:5:\"title\";s:36:\"Construction Company &#8211; Contact\";s:9:\"thumbnail\";s:89:\"https://library.elementor.com/wp-content/uploads/2017/10/Construction-Company-Contact.png\";s:12:\"tmpl_created\";s:10:\"1508325922\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:118:\"https://library.elementor.com/construction-company-contact/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"169\";s:16:\"popularity_index\";s:3:\"307\";s:11:\"trend_index\";s:3:\"439\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:599;a:14:{s:2:\"id\";s:4:\"2094\";s:5:\"title\";s:28:\"Plants Shop &#8211; Homepage\";s:9:\"thumbnail\";s:77:\"https://library.elementor.com/wp-content/uploads/2017/11/Plants-Shop-Home.png\";s:12:\"tmpl_created\";s:10:\"1509621053\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/plants-shop-homepage/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"170\";s:16:\"popularity_index\";s:3:\"264\";s:11:\"trend_index\";s:3:\"264\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:600;a:14:{s:2:\"id\";s:4:\"2120\";s:5:\"title\";s:25:\"Plants Shop &#8211; About\";s:9:\"thumbnail\";s:78:\"https://library.elementor.com/wp-content/uploads/2017/11/Plants-Shop-About.png\";s:12:\"tmpl_created\";s:10:\"1509631820\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:107:\"https://library.elementor.com/plants-shop-about/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"171\";s:16:\"popularity_index\";s:3:\"314\";s:11:\"trend_index\";s:3:\"362\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:601;a:14:{s:2:\"id\";s:4:\"3153\";s:5:\"title\";s:14:\"Halloween Pack\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2017/10/halloween.png\";s:12:\"tmpl_created\";s:10:\"1508950132\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:104:\"https://library.elementor.com/halloween-pack/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"172\";s:16:\"popularity_index\";s:3:\"484\";s:11:\"trend_index\";s:1:\"0\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:602;a:14:{s:2:\"id\";s:4:\"3338\";s:5:\"title\";s:31:\"Black Friday &#8211; Nature Set\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2017/11/black-friday-1.png\";s:12:\"tmpl_created\";s:10:\"1511203351\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/black-friday-nature-set/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"173\";s:16:\"popularity_index\";s:3:\"427\";s:11:\"trend_index\";s:3:\"540\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:603;a:14:{s:2:\"id\";s:4:\"3339\";s:5:\"title\";s:35:\"Black Friday &#8211; Pop-Styled Set\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2017/11/black-friday-2.png\";s:12:\"tmpl_created\";s:10:\"1511203636\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/black-friday-pop-styled-set/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"174\";s:16:\"popularity_index\";s:3:\"402\";s:11:\"trend_index\";s:3:\"353\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:604;a:14:{s:2:\"id\";s:4:\"3335\";s:5:\"title\";s:31:\"Black Friday &#8211; Retail Set\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2017/11/black-friday-4.png\";s:12:\"tmpl_created\";s:10:\"1511203246\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:113:\"https://library.elementor.com/black-friday-retail-set/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"175\";s:16:\"popularity_index\";s:3:\"401\";s:11:\"trend_index\";s:3:\"473\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:605;a:14:{s:2:\"id\";s:4:\"3340\";s:5:\"title\";s:41:\"Black Friday &#8211; Software Product Set\";s:9:\"thumbnail\";s:75:\"https://library.elementor.com/wp-content/uploads/2017/11/black-friday-3.png\";s:12:\"tmpl_created\";s:10:\"1511203713\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:123:\"https://library.elementor.com/black-friday-software-product-set/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"176\";s:16:\"popularity_index\";s:3:\"385\";s:11:\"trend_index\";s:3:\"310\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:606;a:14:{s:2:\"id\";s:4:\"3517\";s:5:\"title\";s:27:\"Christmas &#8211; Gift Shop\";s:9:\"thumbnail\";s:70:\"https://library.elementor.com/wp-content/uploads/2017/12/XmasThumb.png\";s:12:\"tmpl_created\";s:10:\"1513877937\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/christmas-gift-shop/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"177\";s:16:\"popularity_index\";s:3:\"444\";s:11:\"trend_index\";s:3:\"407\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:607;a:14:{s:2:\"id\";s:4:\"3734\";s:5:\"title\";s:28:\"Christmas &#8211; Car Agency\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2017/12/cover-lib-v3.png\";s:12:\"tmpl_created\";s:10:\"1514197794\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:110:\"https://library.elementor.com/christmas-car-agency/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"178\";s:16:\"popularity_index\";s:3:\"423\";s:11:\"trend_index\";s:3:\"422\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:608;a:14:{s:2:\"id\";s:4:\"3764\";s:5:\"title\";s:33:\"Christmas &#8211; Interior Design\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2017/12/cover-lib-v6.png\";s:12:\"tmpl_created\";s:10:\"1514198234\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:115:\"https://library.elementor.com/christmas-interior-design/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"179\";s:16:\"popularity_index\";s:3:\"408\";s:11:\"trend_index\";s:3:\"414\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:609;a:14:{s:2:\"id\";s:4:\"3565\";s:5:\"title\";s:27:\"Christmas &#8211; Tree Shop\";s:9:\"thumbnail\";s:74:\"https://library.elementor.com/wp-content/uploads/2017/12/XmasTreeThumb.png\";s:12:\"tmpl_created\";s:10:\"1514204382\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:109:\"https://library.elementor.com/christmas-tree-shop/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"180\";s:16:\"popularity_index\";s:3:\"380\";s:11:\"trend_index\";s:3:\"399\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:610;a:14:{s:2:\"id\";s:4:\"3862\";s:5:\"title\";s:35:\"Christmas &#8211; Design Conference\";s:9:\"thumbnail\";s:63:\"https://library.elementor.com/wp-content/uploads/2017/12/q1.png\";s:12:\"tmpl_created\";s:10:\"1514206745\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:117:\"https://library.elementor.com/christmas-design-conference/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"181\";s:16:\"popularity_index\";s:3:\"356\";s:11:\"trend_index\";s:3:\"440\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:611;a:14:{s:2:\"id\";s:4:\"3777\";s:5:\"title\";s:39:\"Christmas &#8211; Snowboard Competition\";s:9:\"thumbnail\";s:73:\"https://library.elementor.com/wp-content/uploads/2017/12/cover-lib-v7.png\";s:12:\"tmpl_created\";s:10:\"1514205420\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:121:\"https://library.elementor.com/christmas-snowboard-competition/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"182\";s:16:\"popularity_index\";s:3:\"378\";s:11:\"trend_index\";s:3:\"429\";s:6:\"is_pro\";s:1:\"1\";s:17:\"has_page_settings\";s:1:\"0\";}i:612;a:14:{s:2:\"id\";s:3:\"420\";s:5:\"title\";s:11:\"Hero UI Kit\";s:9:\"thumbnail\";s:81:\"https://library.elementor.com/wp-content/uploads/2016/09/library-ui-kit-cover.png\";s:12:\"tmpl_created\";s:10:\"1475067229\";s:6:\"author\";s:9:\"Elementor\";s:3:\"url\";s:101:\"https://library.elementor.com/hero-ui-kit/?utm_source=library&utm_medium=wp-dash&utm_campaign=preview\";s:4:\"type\";s:4:\"page\";s:7:\"subtype\";s:4:\"page\";s:4:\"tags\";s:2:\"[]\";s:10:\"menu_order\";s:3:\"183\";s:16:\"popularity_index\";s:2:\"18\";s:11:\"trend_index\";s:2:\"43\";s:6:\"is_pro\";s:1:\"0\";s:17:\"has_page_settings\";s:1:\"0\";}}}", "no");
INSERT INTO `wp_464683_options` VALUES("321", "elementor_remote_info_feed_data", "a:5:{i:0;a:5:{s:5:\"title\";s:28:\"4 Takeaways from WordCamp US\";s:7:\"excerpt\";s:128:\"This past weekend, thousands attended the biggest WordPress event of the year, WordCamp US. We were there too. Here\'s our recap.\";s:7:\"created\";s:10:\"1573120186\";s:5:\"badge\";s:0:\"\";s:3:\"url\";s:128:\"https://elementor.com/blog/4-takeaways-from-wordcamp-us/?utm_source=wp-overview-widget&utm_medium=wp-dash&utm_campaign=news-feed\";}i:1;a:5:{s:5:\"title\";s:77:\"Monday Masterclass: How to Build an Online Store With WooCommerce & Elementor\";s:7:\"excerpt\";s:185:\"We are happy to be back with our Monday Masterclasses after a short break. This week we will take you through the exciting process of building a WordPress online store with WooCommerce.\";s:7:\"created\";s:10:\"1572856019\";s:5:\"badge\";s:0:\"\";s:3:\"url\";s:155:\"https://elementor.com/blog/how-to-build-an-online-store-with-woocommerce-elementor/?utm_source=wp-overview-widget&utm_medium=wp-dash&utm_campaign=news-feed\";}i:2;a:5:{s:5:\"title\";s:38:\"Podcast #52: Growing Your Online Sales\";s:7:\"excerpt\";s:206:\"Greg Karelitz, global manager of HubSpot for Startups, explains why and when you need to use CRM, describes the first steps of email automation, and shares tips on planning your sales journey the right way.\";s:7:\"created\";s:10:\"1572512063\";s:5:\"badge\";s:0:\"\";s:3:\"url\";s:124:\"https://elementor.com/blog/podcast-52-greg-karelitz/?utm_source=wp-overview-widget&utm_medium=wp-dash&utm_campaign=news-feed\";}i:3;a:5:{s:5:\"title\";s:38:\"Hilarious Stories of Nightmare Clients\";s:7:\"excerpt\";s:148:\"This Halloween, we asked our community to share their most gruesome clients. These stories cracked us up, and we hope they will do the same for you!\";s:7:\"created\";s:10:\"1572353741\";s:5:\"badge\";s:0:\"\";s:3:\"url\";s:117:\"https://elementor.com/blog/nightmare-clients/?utm_source=wp-overview-widget&utm_medium=wp-dash&utm_campaign=news-feed\";}i:4;a:5:{s:5:\"title\";s:34:\"WordCamp US 2019 — Here We Come!\";s:7:\"excerpt\";s:84:\"Elementor is coming to WordCamp US — St. Louis, and we hope to see you guys there.\";s:7:\"created\";s:10:\"1572346501\";s:5:\"badge\";s:0:\"\";s:3:\"url\";s:116:\"https://elementor.com/blog/wordcamp-us-2019/?utm_source=wp-overview-widget&utm_medium=wp-dash&utm_campaign=news-feed\";}}", "no");
INSERT INTO `wp_464683_options` VALUES("324", "jet-elements-db-version", "2.1.2", "yes");
INSERT INTO `wp_464683_options` VALUES("331", "elementor_connect_site_key", "4b057b2d12933edc96f33acc1a48ab99", "yes");
INSERT INTO `wp_464683_options` VALUES("332", "elementor_pro_license_key", "67c20af166fce49cd36baf11cb604b3a", "yes");
INSERT INTO `wp_464683_options` VALUES("335", "updraftplus_tour_cancelled_on", "intro", "yes");
INSERT INTO `wp_464683_options` VALUES("336", "elementor_extras_license_key", "9c11c4ea0cf9aa02f3d2fa31a131076c", "yes");
INSERT INTO `wp_464683_options` VALUES("339", "edd_sl_4d48928767973217de0ddada1b0adc6f", "a:2:{s:7:\"timeout\";i:1573319766;s:5:\"value\";s:156664:\"{\"new_version\":\"2.2.9\",\"stable_version\":\"2.2.9\",\"name\":\"Elementor Extras\",\"slug\":\"elementor-extras\",\"url\":\"https:\\/\\/shop.namogo.com\\/product\\/elementor-extras\\/?changelog=1\",\"last_updated\":\"2 weeks ago\",\"homepage\":\"https:\\/\\/shop.namogo.com\\/product\\/elementor-extras\",\"package\":\"https:\\/\\/shop.namogo.com\\/edd-sl\\/package_download\\/MTU3MzU3NTM2Njo5YzExYzRlYTBjZjlhYTAyZjNkMmZhMzFhMTMxMDc2YzoxOTo4YmJkNDBkNTM3ZDE0MzU2YTliMTgxYTgxYTQxZDk1NDpodHRwc0AvL2VtaWx5aHVudC5jaDow\",\"download_link\":\"https:\\/\\/shop.namogo.com\\/edd-sl\\/package_download\\/MTU3MzU3NTM2Njo5YzExYzRlYTBjZjlhYTAyZjNkMmZhMzFhMTMxMDc2YzoxOTo4YmJkNDBkNTM3ZDE0MzU2YTliMTgxYTgxYTQxZDk1NDpodHRwc0AvL2VtaWx5aHVudC5jaDow\",\"sections\":{\"description\":\"<p>Elementor Extras is one of the first premium Wordpress plugin for Elementor. It extends its capability with many unique widgets and extensions that make Elementor even more powerful.<\\/p>\\n<h4> Copyright and licensing <\\/h4>\\n<p>Copyright (C) 2016-2019 Elementor Ltd.<\\/p>\\n<p>This program is free software: you can redistribute it and\\/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.<\\/p>\\n<p>This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.<\\/p>\\n<p>You should have received a copy of the GNU General Public License along with this program. If not, see <a href=\\\"https:\\/\\/www.gnu.org\\/licenses\\/\\\">https:\\/\\/www.gnu.org\\/licenses\\/<\\/a>.<\\/p>\\n<h4> Third Party Code <\\/h4>\\n<p>Elementor Extras incorporates code from:<\\/p>\\n<ul>\\n<li><strong>jquery-circle-progress<\\/strong> v1.2.2, Copyright Rostyslav Bryzgunov Licenses: MIT Source: link <a href=\\\"http:\\/\\/kottenator.github.io\\/jquery-circle-progress\\/\\\">http:\\/\\/kottenator.github.io\\/jquery-circle-progress\\/<\\/a><\\/li>\\n<li><strong>jQuery appear plugin<\\/strong> v0.3.6, Copyright 2012 Andrey Sidorov Licenses: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/morr\\/jquery.appear\\/\\\">https:\\/\\/github.com\\/morr\\/jquery.appear\\/<\\/a><\\/li>\\n<li><strong>LongShadow jQuery Plugin<\\/strong> v1.1.0, Copyright 2013 - 2016 Dang Van Thanh Licenses: MIT Source: link git:\\/\\/github.com\\/dangvanthanh\\/jquery.longShadow.git<\\/li>\\n<li><strong>HC-Sticky<\\/strong> v2.2.3, Copyright Some Web Media License: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/somewebmedia\\/hc-sticky\\\">https:\\/\\/github.com\\/somewebmedia\\/hc-sticky<\\/a><\\/li>\\n<li><strong>jQuery Mobile<\\/strong> v1.4.3, Copyright 2010, 2014 jQuery Foundation, Inc. Licenses: jquery.org\\/license<\\/li>\\n<li><strong>jquery-visible<\\/strong>, Copyright 2012, Digital Fusion, License: <a href=\\\"http:\\/\\/teamdf.com\\/jquery-plugins\\/license\\/\\\">http:\\/\\/teamdf.com\\/jquery-plugins\\/license\\/<\\/a> Source: <a href=\\\"http:\\/\\/teamdf.com\\/jquery-plugins\\/license\\/\\\">http:\\/\\/teamdf.com\\/jquery-plugins\\/license\\/<\\/a><\\/li>\\n<li><strong>Parallax Background<\\/strong> v1.2, by Eren Suleymanoglu Licenses: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/erensuleymanoglu\\/parallax-background\\\">https:\\/\\/github.com\\/erensuleymanoglu\\/parallax-background<\\/a><\\/li>\\n<li><strong>TableSorter<\\/strong> v2.0.5b, Copyright 2007 Christian Bach Licenses: Dual licensed under the MIT and GPL licenses Source: link <a href=\\\"http:\\/\\/tablesorter.com\\\">http:\\/\\/tablesorter.com<\\/a><\\/li>\\n<li><strong>Isotope<\\/strong> PACKAGED v3.0.6, Copyright 2017 Metafizzy License: GPLv3 Source: link <a href=\\\"http:\\/\\/isotope.metafizzy.co\\\">http:\\/\\/isotope.metafizzy.co<\\/a><\\/li>\\n<li><strong>Infinite Scroll<\\/strong> PACKAGED v3.0.2, Copyright 2017 Metafizzy License: GPLv3 Source: link <a href=\\\"https:\\/\\/infinite-scroll.com\\\">https:\\/\\/infinite-scroll.com<\\/a><\\/li>\\n<li><strong>Packery layout mode<\\/strong> PACKAGED v2.0.0 Copyright 2017 Metafizzy License: GPLv3 Source: link <a href=\\\"http:\\/\\/isotope.metafizzy.co\\\">http:\\/\\/isotope.metafizzy.co<\\/a><\\/li>\\n<li><strong>javascript-detect-element-resize<\\/strong> v0.5.3 Copyright (c) 2013 Sebasti\\u00e1n D\\u00e9cima License: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/sdecima\\/javascript-detect-element-resize\\\">https:\\/\\/github.com\\/sdecima\\/javascript-detect-element-resize<\\/a><\\/li>\\n<li><strong>tilt.js<\\/strong> 1.2.1, Copyright (c) 2017 Gijs Rog\\u00e9 License: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/gijsroge\\/tilt.js\\\">https:\\/\\/github.com\\/gijsroge\\/tilt.js<\\/a><\\/li>\\n<li><strong>CLNDR<\\/strong> v1.4.7, Copyright Kyle Stetz (github.com\\/kylestetz) License: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/kylestetz\\/CLNDR\\\">https:\\/\\/github.com\\/kylestetz\\/CLNDR<\\/a><\\/li>\\n<li><strong>GMAP3 Plugin for jQuery<\\/strong> v7.2 Copyright DEMONTE Jean-Baptiste License: GPL-3.0+ Source: link <a href=\\\"http:\\/\\/gmap3.net\\\">http:\\/\\/gmap3.net<\\/a><\\/li>\\n<li><strong>Moment.js<\\/strong> v2.22.2 License: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/moment\\/moment\\/\\\">https:\\/\\/github.com\\/moment\\/moment\\/<\\/a><\\/li>\\n<li><strong>Slidebars<\\/strong> v2 Copyright Adam Charles Smith License: MIT <a href=\\\"http:\\/\\/www.adchsm.com\\/slidebars\\/license\\/\\\">http:\\/\\/www.adchsm.com\\/slidebars\\/license\\/<\\/a> Source: link <a href=\\\"http:\\/\\/www.adchsm.com\\/slidebars\\/\\\">http:\\/\\/www.adchsm.com\\/slidebars\\/<\\/a><\\/li>\\n<li><strong>Splittext.js<\\/strong> Copyright (c) 2008-2016, GreenSock<\\/li>\\n<li><strong>Magnific Popup<\\/strong> v1.1.0 License: MIT Copyright 2016 Dmitry Semenov Soruce: link <a href=\\\"http:\\/\\/dimsemenov.com\\/plugins\\/magnific-popup\\/\\\">http:\\/\\/dimsemenov.com\\/plugins\\/magnific-popup\\/<\\/a><\\/li>\\n<\\/ul>\\n<h4> Important Links <\\/h4>\\n<p><a href=\\\"https:\\/\\/shop.namogo.com\\/docs\\/elementor-extras\\/getting-started\\/#update-official\\\">Updating Extras<\\/a>\\n<a href=\\\"https:\\/\\/shop.namogo.com\\/topic\\/elementor-extras\\/\\\">Documentation<\\/a>\\n<a href=\\\"https:\\/\\/shop.namogo.com\\/account\\/\\\">Your Account<\\/a>\\n<a href=\\\"https:\\/\\/shop.namogo.com\\/account\\/support\\/\\\">Support<\\/a>\\n<a href=\\\"https:\\/\\/shop.namogo.com\\/docs\\/elementor-extras\\/frequently-asked-questions\\/\\\">FAQ<\\/a><\\/p>\",\"changelog\":\"<h4> 2.2.9 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Align media vertically on horizontal post layouts<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Text separator not displaying<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Default horizontal layout width control to 30<\\/li>\\n<\\/ul>\\n<h4> 2.2.8 <\\/h4>\\n<ul>\\n<li>Added: Breadcrumbs \\u2014 Granular controls for crumbs settings on archive and single pages<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Moved images loaded container selector to ajax response<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Show all filters option not working<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Infinite scroll pagination html output rendering more links than needed<\\/li>\\n<li>Fixed: PHP notice for licensing admin notification<\\/li>\\n<li>Fixed: Switcher \\u2014 Border radius control CSS selector<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Cleanup on pagination html output needed for infinite scroll<\\/li>\\n<\\/ul>\\n<h4> 2.2.7 <\\/h4>\\n<ul>\\n<li>Fixed: Compatibility with third-party plugin<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Edge case bug when calculating anchor position<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Notices<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Overlapping items on infinite scroll when filters active<\\/li>\\n<\\/ul>\\n<h4> 2.2.6 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Global \'elementor_extras\\/widgets\\/posts\\/link\' filter<\\/li>\\n<li>Added: Offcanvas \\u2014 Typography control for content boxes<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Infinite Scroll stopping before all posts load<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Panel background selector<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Page jump when navigating to anchor<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Edge case js error in nouislider script<\\/li>\\n<li>Fixed: Templates Control \\u2014 Restrict global query override for templates inside loops<\\/li>\\n<li>Fixed: Slide Menu \\u2014 Nav menu item classes don\'t work when coming from template control<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Wrong order for hierarchical taxonomies<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Flicker when performing infinite scroll on filtered posts<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Additional padding in some cases below sticky element<\\/li>\\n<li>Fixed: Display Conditions \\u2014 Missing day of week condition<\\/li>\\n<li>Fixed: Hotspots \\u2014 Better handling of icon vertical alignment in css<\\/li>\\n<\\/ul>\\n<h4> 2.2.5 <\\/h4>\\n<ul>\\n<li>Added: Toggle Element \\u2014 Control to hide items without any content<\\/li>\\n<li>Added: Popup \\u2014 Support for usage within Posts Extra custom post skin<\\/li>\\n<li>Added: Audio Player \\u2014 Option to disable preloading of audio files<\\/li>\\n<li>Added: Calendar \\u2014 Search custom fields by field name<\\/li>\\n<li>Added: Offcanvas \\u2014 Options in widgets\' settings to fix page jump issue<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Certain actions not working<\\/li>\\n<li>Fixed: Calendar \\u2014 Pods controls not fetching fields<\\/li>\\n<li>Fixed: Calendar \\u2014 Toolset controls not fetching fields<\\/li>\\n<li>Fixed: Query Control \\u2014 Return only matching queries for pods and toolset<\\/li>\\n<li>Fixed: Calendar \\u2014 Placeholder functionality<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Edge case where css width selectors get overridden by defaults<\\/li>\\n<li>Tweak: Posts Extra \\u2013 Default css order value for parts and areas in frontend css<\\/li>\\n<li>Tweak: Popup \\u2014 Replaced multiple template selection control with single control. IMPORTANT: Settings review required!<\\/li>\\n<li>Tweak: Breadcrumbs \\u2014 Refactor widget code<\\/li>\\n<\\/ul>\\n<h4> 2.2.4 <\\/h4>\\n<ul>\\n<li>Added: Dynamic background image support for custom post skin<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Filter for home breadcrumb link<\\/li>\\n<li>Fixed: Timeline \\u2014 Wrong card content selector for transition control<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Broken selectors after last offcanvas update<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Remove default border around posts<\\/li>\\n<\\/ul>\\n<h4> 2.2.3 <\\/h4>\\n<ul>\\n<li>Added: Offcanvas \\u2014 Compatibility with templates in loops in Posts Extra and other plugins<\\/li>\\n<li>Added: Posts Extra \\u2014 Refresh all widgets scripts on appended infinite scroll items<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Button style gone when placed in linked media area<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Bug when sticky section inside page body within theme builder header template<\\/li>\\n<li>Fixed: Scroll Indicator \\u2014 Tooltips not working with bullets skin<\\/li>\\n<\\/ul>\\n<h4> 2.2.2 <\\/h4>\\n<ul>\\n<li>Fixed: Scroll Indicator \\u2014 Bug when tooltips disabled on bullets skin<\\/li>\\n<li>Fixed: Timeline \\u2014 Option to hide thumbnail not working in posts mode<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Bug with before parent category filters<\\/li>\\n<li>Fixed: Bug with third party elementor addon that enqueue editor scripts on plugin load<\\/li>\\n<li>Fixed: Posts \\u2014 Default metas control to include price for previous saved settings<\\/li>\\n<li>Added: Search Form \\u2014 Compatibility with Relevanssi search results on custom templates with search form id condition<\\/li>\\n<li>Added: Timeline \\u2014 Option to set a dynamic tag instead of date, title and excerpt in posts mode<\\/li>\\n<li>Added: Timeline \\u2014 Option to set HTML element for title in posts mode<\\/li>\\n<li>Added: Posts Extra \\u2014 Filter for the media area link<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to open media and button links in new tab<\\/li>\\n<li>Added: Table \\u2014 WPML translation of header cells text<\\/li>\\n<li>Tweak: Sticky Elements \\u2014 Additional listeners for recalculating sticky<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Less restrictive css selector for the woocommerce add to cart button<\\/li>\\n<\\/ul>\\n<h4> 2.2.1 <\\/h4>\\n<ul>\\n<li>Added: Scroll Indicator \\u2014 Option to offset start and end positions<\\/li>\\n<li>Added: Posts Extra \\u2014 Responsive media width control<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Missing custom field order options<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Avatar meta showing even if removed from metas list<\\/li>\\n<li>Fixed: Display Conditions \\u2014 ACF Choice fails for radio field<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Bug with left aligned media flex width on mobile<\\/li>\\n<\\/ul>\\n<h4> 2.2.0 <\\/h4>\\n<ul>\\n<li>Added: Google Map \\u2014 Route travel mode options<\\/li>\\n<li>Added: Global Tooltips \\u2014 Compatibility with usage inside post skin templates for Posts Extra<\\/li>\\n<li>Added: Global Tooltips \\u2014 z-index control in both element and global settings<\\/li>\\n<li>Added: Display Conditions \\u2014 Term archive condition<\\/li>\\n<li>Added: Display Conditions \\u2014 ACF conditions<\\/li>\\n<li>Added: Display Conditions \\u2014 POST and GET variable conditions<\\/li>\\n<li>Added: Timeline \\u2014 Custom Post Skin via Elementor templates<\\/li>\\n<li>Added: Timeline \\u2014 Replaced default query controls with related query controls<\\/li>\\n<li>Added: Timeline \\u2014 Trim custom excerpt control<\\/li>\\n<li>Added: Timeline \\u2014 Custom post skin<\\/li>\\n<li>Added: Posts Extra \\u2014 Date formatting controls<\\/li>\\n<li>Added: Posts Extra \\u2014 Actions and filters<\\/li>\\n<li>Added: Calendar \\u2014 Actions and filters<\\/li>\\n<li>Added: Devices \\u2014 Actions<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Actions and filters<\\/li>\\n<li>Added: Scroll Indicator \\u2014 Custom html tags for title and subtitle in list skin<\\/li>\\n<li>Added: Custom implementation for Template controls<\\/li>\\n<li>Fixed: Toggle Element \\u2014 Support for slick slider based widgets inside elements<\\/li>\\n<li>Fixed: Switcher \\u2014 Missing image link control<\\/li>\\n<li>Fixed: Timeline \\u2014 Markup improvement to allow for simpler border radius around cards<\\/li>\\n<li>Fixed: Timeline \\u2014 Custom icon replaces global if global is set<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Separator vertical alignment bug<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Icon migration markup issue<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Update elementor nerd box classes<\\/li>\\n<li>Fixed: Posts Extra \\u2014 ACF fields for custom skins used on archive pages<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Wrong access type for _query property<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Price conditions issue for area and editor panel section display<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Author and avatar metas additional controls conditions<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Removed infinite scroll pages loaded limit<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Handle multiple paginations control condition bug<\\/li>\\n<li>Fixed: Scroll Indicator \\u2014 Custom height control condition<\\/li>\\n<li>Fixed: Popup \\u2014 Compatibility with usage inside post skin templates for Posts Extra<\\/li>\\n<li>Fixed: Buttons \\u2014 Flip effect back is hidden during transition<\\/li>\\n<li>Tweak: Breadcrumbs \\u2014 Remove useless icon and icon class filters<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Update button text filters to include \\/posts\\/<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Default taxonomy order for filters<\\/li>\\n<\\/ul>\\n<h4> 2.1.8 <\\/h4>\\n<ul>\\n<li>Fixed: Missing elementor pro active condition<\\/li>\\n<\\/ul>\\n<h4> 2.1.7 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Order posts by custom fields<\\/li>\\n<li>Fixed: Calendar \\u2014 No events fetched when acf date field return format is different that display format<\\/li>\\n<li>Tweak: Better notices and plugin activation prevention for dependencies<\\/li>\\n<\\/ul>\\n<h4> 2.1.6 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Exclude category pages from previous current query fix<\\/li>\\n<li>Fixed: Posts Extra \\u2014 ACF fields for custom post skins used on archive pages<\\/li>\\n<\\/ul>\\n<h4> 2.1.5 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Filter for button link<\\/li>\\n<li>Added: Posts Extra \\u2014 Apply both \'button\' and \'add_to_cart\' filters to button<\\/li>\\n<li>Added: Audio Player \\u2014 Autoplay option<\\/li>\\n<li>Added: Support for new icon library in Elementor 2.6 in all widgets<\\/li>\\n<li>Added: Support for scaling SVG icon library assets when added to widgets<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Option to hide current page<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Template control not fetching results after Elementor Pro 2.6.0 update<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Body order on horizontal posts<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Default query args prevent correct number of results on search templates<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Show all filters initially not working<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Wrong hierarchical taxonomies order when using custom post types<\\/li>\\n<li>Fixed: Calendar \\u2014 Border radius overflow issue<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Progress not showing when shown below<\\/li>\\n<li>Fixed: Timeline \\u2014 Text align on tablet for RTL<\\/li>\\n<li>Fixed: Switcher \\u2014 Remove link image option when using overlay skin<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Edge case where page scrolls up when panel closed on firefox<\\/li>\\n<li>Fixed: Video Player \\u2014 Play button not centered in edge cases<\\/li>\\n<li>Tweak: Search Form \\u2014 Tax query verification<\\/li>\\n<\\/ul>\\n<h4> 2.1.4 <\\/h4>\\n<ul>\\n<li>Fixed: Audio Player \\u2014 External URL not. accepting dynamic tag in URL category<\\/li>\\n<li>Fixed: Video Player \\u2014 External URL not. accepting dynamic tag in URL category<\\/li>\\n<li>Fixed: Search Form \\u2014 Undefined index notice<\\/li>\\n<li>Added: Offcanvas \\u2014 Custom select for the close button<\\/li>\\n<li>Tweak: Offcanvas \\u2014 Separate control sections for title and close settings<\\/li>\\n<\\/ul>\\n<h4> 2.1.3 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Add to cart button alignment<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Pagination links on single templates<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Deprecated certain filters<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added button text filter<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added add to cart text filter<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Changed skin source terminology<\\/li>\\n<li>Tweak: Dissmisable admin licensing notices<\\/li>\\n<\\/ul>\\n<h4> 2.1.2 <\\/h4>\\n<ul>\\n<li>Added: Display Conditions \\u2014 New Term Archive condition<\\/li>\\n<li>Added: Posts Extra \\u2014 Area ordering controls<\\/li>\\n<li>Added: Posts Extra \\u2014 Add to cart button<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to use Elementor templates as custom skin for posts<\\/li>\\n<li>Added: Timeline \\u2014 Separate controls for dates in hover and focused state<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Force square avatar image<\\/li>\\n<li>Fixed: Timeline \\u2014 Remove empty image wrapper when no image exists<\\/li>\\n<li>Fixed: Timeline \\u2014 Hover background color of arrow when focused<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Show price if source is current query<\\/li>\\n<li>Tweak: Timeline \\u2014 Allow Elementor custom image size<\\/li>\\n<li>Tweak: Timeline \\u2014 Responsive color controls<\\/li>\\n<\\/ul>\\n<h4> 2.1.1 <\\/h4>\\n<ul>\\n<li>Added: Tooltips \\u2014 Event for closing the tooltip by clicking anywhere<\\/li>\\n<li>Fixed: Buttons \\u2014 Text align when min width is set<\\/li>\\n<li>Tweak: Scroll Indicator \\u2014 Added options to select progress start and end calculation on scroll for sections<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Moved Infinite Scroll, Pagination and Filters activation controls to their respective sections.<\\/li>\\n<li>Tweak: Licensing \\u2014 Increase remote post request timeout value<\\/li>\\n<\\/ul>\\n<h4> 2.1.0 <\\/h4>\\n<ul>\\n<li>New Widget: Search Form \\u2014 Form widget with restrictions and filters<\\/li>\\n<li>New Widget: Scroll Indicator \\u2014 Create different types of scroll navigation indicators<\\/li>\\n<li>New Feature: Instagram \\u2014 Pull instagram feed to the Gallery widget<\\/li>\\n<li>Added: Posts Extra \\u2014 Vertical carousel<\\/li>\\n<li>Added: Posts Extra \\u2014 New control to select breakpoint for collapsing horizontal post layouts<\\/li>\\n<li>Added: Posts Extra \\u2014 Keep control to define page number limit for infinite scroll<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to not show the &quot;All&quot; filter<\\/li>\\n<li>Added: Posts Extra \\u2014 New control for Slides to Show and deprecated old control [ Settings Review Required ]<\\/li>\\n<li>Added: Posts Extra \\u2014 Exclude taxonomy terms from filters<\\/li>\\n<li>Added: Gallery \\u2014 New spacing control specifically for mixed masonry layout. [ Settings Review Required ]<\\/li>\\n<li>Added: Gallery Slider \\u2014 Control to hide thumbnails<\\/li>\\n<li>Added: Tooltips \\u2014 Mobile event listeners [ Settings Review Required ]<\\/li>\\n<li>Added: Tooltips \\u2014 Responsive triggers and hide events [ Settings Review Required ]<\\/li>\\n<li>Added: Tooltips \\u2014 Separate events for closing the tooltip [ Settings Review Required ]<\\/li>\\n<li>Added: Tooltips \\u2014 New offset control to adjust alignment of arrow tip to target<\\/li>\\n<li>Added: Devices \\u2014 Option for video to cover screen<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Hover colors controls<\\/li>\\n<li>Added: Calendar \\u2014 Disable links to posts<\\/li>\\n<li>Added: Calendar \\u2014 Add nofollow and open in new window on posts source<\\/li>\\n<li>Added: Buttons \\u2014 General padding control<\\/li>\\n<li>Added: Popup \\u2014 Horizontal align for inline trigger and popup close button<\\/li>\\n<li>Added: Notice for license domain mismatch<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Wrong absolute max values<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Infinite scroll loading same posts<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Aligned column breakpoints to elementor default values<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Better override default theme padding on post item<\\/li>\\n<li>Fixed: Timeline \\u2014 CSS bug with overflow<\\/li>\\n<li>Fixed: Timeline \\u2014 Arrow color not working on frontend<\\/li>\\n<li>Fixed: Timeline \\u2014 Invalid code being generated in post css<\\/li>\\n<li>Fixed: Calendar \\u2014 Link target and nofollow<\\/li>\\n<li>Fixed: Devices \\u2014 Video controls conditions<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Conflict with Elementor Pro scrolling effect<\\/li>\\n<li>Fixed: Popup \\u2014 Dynamic css selector for trigger not working<\\/li>\\n<li>Fixed: Calendar \\u2014 Link attributes in compact mode not working<\\/li>\\n<li>Fixed: Google Map \\u2014 Wrong value for default description tag<\\/li>\\n<li>Fixed: Google Map \\u2013 Set overflow to hidden to allow for advanced border radius setting<\\/li>\\n<li>Fixed: Switcher \\u2014 Rename effects section for compatibility with motion effects section name<\\/li>\\n<li>Fixed: Switcher \\u2014 Link to control should not be responsive<\\/li>\\n<li>Fixed: Unfold \\u2014 Bug with closing without focusing<\\/li>\\n<li>Fixed: Random Image \\u2014 Wrong caption<\\/li>\\n<li>Fixed: Display Conditions \\u2014 Check correct condition value<\\/li>\\n<li>Fixed: Toggle Element \\u2014 Text Label align controls<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Safari 12.1 CSS bug<\\/li>\\n<li>Fixed: Gallery \\u2014 Hover effects on mixed layout<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Edge case js error<\\/li>\\n<li>Fixed: Remove duplicate empty template messages from editor panel<\\/li>\\n<li>Fixed: Check license data before mismatch check<\\/li>\\n<li>Fixed: Tooltips \\u2014 Bug with hide event prevent default<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Allow horizontal post layout independent of columns value<\\/li>\\n<li>Tweak: Gallery \\u2014 Better controls conditions<\\/li>\\n<li>Tweak: Gallery \\u2014 Moved settings in their own sections under Content<\\/li>\\n<li>Tweak: Gallery \\u2014 Control conditions<\\/li>\\n<li>Tweak: Gallery \\u2014 Better markup, controls and css optimisation<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Better markup, controls and css optimisation<\\/li>\\n<li>Tweak: Better license management, notifications and performance<\\/li>\\n<li>Tweak: Remove extension default enable for sticky and parallax background<\\/li>\\n<li>Tweak: Remove custom panel alert classes and revert to elementor ones<\\/li>\\n<li>Tweak: Update docs and support links in extras admin pages<\\/li>\\n<li>Tweak: Streamline get_image_caption across all modules to avoid code redundancy<\\/li>\\n<li>Tweak: Toggle Element \\u2014 Better Label alignment controls<\\/li>\\n<li>Tweak: Popup \\u2014 Empty trigger css adjustments<\\/li>\\n<li>Tweak: Admin pages styles<\\/li>\\n<\\/ul>\\n<h4> 2.0.17 <\\/h4>\\n<ul>\\n<li>Added: Timeline \\u2014 Overlay horizontal alignment option<\\/li>\\n<li>Fixed: Timeline \\u2014 Icon showing twice<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Default horizontal alignment to left<\\/li>\\n<\\/ul>\\n<h4> 2.0.16 <\\/h4>\\n<ul>\\n<li>Fixed: Include admin script only on extras pages<\\/li>\\n<li>Fixed: Posts Extra \\u2014 RTL margins and arrows<\\/li>\\n<li>Fixed: Calendar \\u2014 RTL arrows<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Override current query posts per page with control setting<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Carousel style section condition<\\/li>\\n<li>Added: Text Divider \\u2014 Control for alignment of text<\\/li>\\n<li>Added: Unfold \\u2014 Columns settings for content<\\/li>\\n<li>Added: Timeline \\u2014 New alignment controls to allow selecting layouts per breakpoint<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to align posts horizontally<\\/li>\\n<li>Tweak: Admin settings RTL<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Responsive alignment controls<\\/li>\\n<li>Tweak: Timeline \\u2014 Responsive defaults for alignment controls<\\/li>\\n<\\/ul>\\n<h4> 2.0.15 <\\/h4>\\n<ul>\\n<li>IMPORTANT: This version requires Elementor 2.5 or above<\\/li>\\n<li>IMPORTANT: If you have Elementor Pro, this version requires version 2.5 or above<\\/li>\\n<li>Added: Posts Extra \\u2014 Elementor Pro new related posts module with include \\/ exclude and date range<\\/li>\\n<li>Added: Circle Progress \\u2014 Option to turn off animation<\\/li>\\n<li>Added: Display Conditions \\u2014 Day of week condition<\\/li>\\n<li>Added: Video Player &amp; Devices \\u2014 Option to not hide bar when video is playing<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Unstick for 768px wide tablets<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Compatibility with Elementor Pro 2.5<\\/li>\\n<li>Fixed: Timeline \\u2014 Compatibility with Elementor Pro 2.5<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Adjust on resize in editor<\\/li>\\n<li>Fixed: Calendar \\u2014 Query compatibility with WPML<\\/li>\\n<li>Fixed: Hotspots \\u2014 Check spaces in hotspot links<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Edge case where images don\'t display entirely<\\/li>\\n<li>Fixed: Timeline \\u2014 Correctly render dynamic tags<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Isotope on loading more posts when filter active<\\/li>\\n<li>Tweak: Video Player \\u2014 Automatically hide bar on mobile when playing<\\/li>\\n<\\/ul>\\n<h4> 2.0.14 <\\/h4>\\n<ul>\\n<li>Added: Toggle Element \\u2014 Option to select which item is active by default<\\/li>\\n<li>Fixed: Table \\u2014 Restrict cell max-width to msie<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Wrong arranging in some cases<\\/li>\\n<li>Fixed: Media Player text indicators wrapping<\\/li>\\n<\\/ul>\\n<h4> 2.0.13 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Carousel js error<\\/li>\\n<\\/ul>\\n<h4> 2.0.12 <\\/h4>\\n<ul>\\n<li>Added: Unfold \\u2014 Options to keep focus on content when folding or unfolding<\\/li>\\n<li>Fixed: Toggle Element \\u2014 Make sure Gallery Extra is initiated when toggling<\\/li>\\n<li>Fixed: Table \\u2014 Min-width breakpoint bug<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Compatibility with Elementor 2.5<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Z-index issues for panel<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Allow scroll on page not working<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Rare selector for anchors with link issue<\\/li>\\n<li>Fixed: Hotspots \\u2014 Rename css pulse animation<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Editor defaultView error<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Adjust breakpoint values<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Fallback to default wp posts per page option<\\/li>\\n<li>Tweak: Offcanvas \\u2014 Make sure html element has auto height<\\/li>\\n<li>Tweak: Better wpml classes check<\\/li>\\n<\\/ul>\\n<h4> 2.0.11 <\\/h4>\\n<ul>\\n<li>Fixed: Offcanvas \\u2014 Trigger not closing after open<\\/li>\\n<li>Fixed: Posts \\u2014 Grid overlapping on safari when infinite scroll is enabled<\\/li>\\n<li>Fixed: Table \\u2014 Restrict IE hack to tablet and up<\\/li>\\n<li>Fixed: Get element settings on frontend in edit mode<\\/li>\\n<li>Fixed: Google Map \\u2014 Require resize plugin<\\/li>\\n<li>Added: Posts Extra \\u2014 Button border controls<\\/li>\\n<\\/ul>\\n<h4> 2.0.10 <\\/h4>\\n<ul>\\n<li>Added: Parallax Elements \\u2014 Option to allow moving elements when they aren\'t visible inside viewport<\\/li>\\n<li>Fixed: Google Map \\u2014 Centering with dynamic tags not working<\\/li>\\n<li>Fixed: Calendar \\u2014 Don\'t limit number of posts fetched<\\/li>\\n<li>Fixed: Display Conditions \\u2014 Chrome check failing<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Responsive item aligning<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Custom size control compatibility + tweaks<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Type control condition<\\/li>\\n<li>Tweak: Google Map \\u2014 Disable fitting and centering when route is enabled<\\/li>\\n<\\/ul>\\n<h4> 2.0.9 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Handle multiple paginated loops<\\/li>\\n<li>Added: Posts Extra \\u2014 Nothing found message<\\/li>\\n<li>Added: Image Comparison \\u2014 Option to turn off animation on entrance<\\/li>\\n<li>Added: Posts Extra \\u2014 Query ID filter on top of elementor pro one<\\/li>\\n<li>Added: Offcanvas \\u2014 Control to enable page scroll when offcanvas panel is open<\\/li>\\n<li>Fixed: Table \\u2014 IE cell text wrapping<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Wrong absolute value when multiple widget instances on same page<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Wrong thumbnail order<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Z-index issues<\\/li>\\n<li>Fixed: Calendar \\u2014 Convert timestamp to integer<\\/li>\\n<li>Fixed: Gallery module attachment check<\\/li>\\n<li>Tweak: Timeline \\u2014 Rename timeline script<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Responsive row spacing control<\\/li>\\n<li>Tweak: Parallax Background \\u2014 Compatibility with Elementor 2.4<\\/li>\\n<\\/ul>\\n<h4> 2.0.8 <\\/h4>\\n<ul>\\n<li>Fixed: Text Divider \\u2014 Selector for link color<\\/li>\\n<li>Fixed: Timeline \\u2014 Notice<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Escape jquery expression<\\/li>\\n<li>Fixed: Google Map \\u2014 Handle invalid or undefined snazzy map style<\\/li>\\n<\\/ul>\\n<h4> 2.0.7 <\\/h4>\\n<ul>\\n<li>Fixed: Offcanvas \\u2014 Anchor navigation scroll calculation<\\/li>\\n<li>Added: Timeline \\u2014 Allow post content to be shown instead of excerpt<\\/li>\\n<li>Added: Timeline \\u2014 Control to set line progress position relative to viewport<\\/li>\\n<li>Tweak: Offcanvas \\u2014 Anchor condition<\\/li>\\n<\\/ul>\\n<h4> 2.0.6 <\\/h4>\\n<ul>\\n<li>Fixed: Popup \\u2014 Duplicate tab control name<\\/li>\\n<li>Fixed: Popup \\u2014 Remove rtl suffix<\\/li>\\n<li>Added: Offcanvas \\u2014 Global control for offcanvas container background color<\\/li>\\n<\\/ul>\\n<h4> 2.0.5 <\\/h4>\\n<ul>\\n<li>Added: Editor panel labels for widgets<\\/li>\\n<li>Added: Calendar \\u2014 Control to customise month names<\\/li>\\n<li>Added: Offcanvas \\u2014 Link navigate to anchors on page<\\/li>\\n<li>Added: Popup \\u2014 Text trigger styling controls<\\/li>\\n<li>Fixed: Inline SVG \\u2014 Multiple svgs have same settings<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 No parent custom taxonomy terms render all terms<\\/li>\\n<li>Fixed: Posts Extra \\u2014 PHP notice<\\/li>\\n<li>Tweak: Updated language file<\\/li>\\n<\\/ul>\\n<h4> 2.0.4 <\\/h4>\\n<ul>\\n<li>Fixed: Display Conditions \\u2014 Editor section for sections actions<\\/li>\\n<li>Fixed: Display Conditions \\u2014 Conditions evaluation per element<\\/li>\\n<\\/ul>\\n<h4> 2.0.3 <\\/h4>\\n<ul>\\n<li>Fixed: Popup Display Conditions \\u2014 Check widget visibility before opening automatically<\\/li>\\n<li>Fixed: Table \\u2014 First row has no classes<\\/li>\\n<li>Fixed: Google Map \\u2014 Handle no snazzy maps selection<\\/li>\\n<li>Fixed: Display Conditions \\u2014 Wrong default keys resulting in wrong display<\\/li>\\n<li>Fixed: Audio Player \\u2014 Border type selector<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Position structured data property<\\/li>\\n<li>Fixed: Parallax Element \\u2014 Parallax column affecting child columns<\\/li>\\n<li>Fixed: Devices \\u2014 Image extending outside the widget area<\\/li>\\n<li>Fixed: Popup \\u2014 Move font family to pseudo-element<\\/li>\\n<li>Fixed: Slide Menu \\u2014 Sub-menu links not working with link navigation turned on<\\/li>\\n<li>Tweak: Rename infinite-scroll script<\\/li>\\n<li>Tweak: Breadcrumbs \\u2014 Increase typography selector specificity<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Additional conditions for areas style sections<\\/li>\\n<li>Remove widget disabling admin notif<\\/li>\\n<li>Update Wordpress stable tag to 5.0.0<\\/li>\\n<\\/ul>\\n<h4> 2.0.2 <\\/h4>\\n<ul>\\n<li>Added: New Query Control<\\/li>\\n<li>Added: Display Conditions \\u2014 Ajax powered fields<\\/li>\\n<li>Added: Display Conditions \\u2014 Current post condition<\\/li>\\n<li>Fixed: Switcher \\u2013 Autoplay not working without entrance animation<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Custom taxonomy archive crumbs<\\/li>\\n<li>Tweak: Audio Player \\u2014 Added option for external sources<\\/li>\\n<\\/ul>\\n<h4> 2.0.1 <\\/h4>\\n<ul>\\n<li>Fixed: Google Map \\u2014 Navigation z-index<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Default button position to hidden<\\/li>\\n<li>Fixed: Devices \\u2014 Video in window frame not displaying<\\/li>\\n<li>Fixed: Google Map \\u2014 JSON incorrectly reported as invalid<\\/li>\\n<li>Fixed: Switcher \\u2014 Cover picture tag with CSS<\\/li>\\n<li>Fixed: Devices \\u2014 Video css for browser frame<\\/li>\\n<li>Added: Posts Extra \\u2014 Infinite load button transition control<\\/li>\\n<li>Added: Posts Extra \\u2014 Infinite load button border control<\\/li>\\n<li>Added: Hotspots \\u2014 Individual hover controls for each hotspot<\\/li>\\n<li>Added: Audio Player \\u2014 Option to loop playlist<\\/li>\\n<li>Tweak: Google Map \\u2014 Make fields dynamic<\\/li>\\n<li>Tweak: Audio Player \\u2014 Added custom js events<\\/li>\\n<li>Tweak: Audio Player \\u2014 Separate control for play icon size<\\/li>\\n<li>Tweak: Video Player \\u2014 Added custom js events<\\/li>\\n<\\/ul>\\n<h4> 2.0.0 <\\/h4>\\n<ul>\\n<li>New Extension: Display Conditions<\\/li>\\n<li>New Widget: Google Map<\\/li>\\n<li>New Widget: Popup<\\/li>\\n<li>New Widget: Age Gate<\\/li>\\n<li>New Widget: Toggle Element<\\/li>\\n<li>New Widget: Calendar<\\/li>\\n<li>New Widget: Audio Player<\\/li>\\n<li>New Widget: Offcanvas<\\/li>\\n<li>New Widget: Slide Menu<\\/li>\\n<li>New Widget: Random Image<\\/li>\\n<li>Added: Posts Extra \\u2014 Support for terms from multiple taxonomies<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Include blog posts page in breadcrumbs<\\/li>\\n<li>Added: Switcher \\u2014 New option to add description<\\/li>\\n<li>Added: Sticky Elements \\u2014 Completely rewritten code<\\/li>\\n<li>Added: Sticky Elements \\u2014 Offset bottom control<\\/li>\\n<li>Added: Global Tooltips \\u2014 Control to disable on breakpoint<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Option to show taxonomy terms for custom post types instead of CPT name<\\/li>\\n<li>Added: Tooltips \\u2014 New trigger on page load<\\/li>\\n<li>Added: Switcher \\u2014 Events to update when inside toggle element<\\/li>\\n<li>Added: Posts Extra \\u2014 Price meta for woocommerce products<\\/li>\\n<li>Added: Posts Extra \\u2014 Button content part replaces read more<\\/li>\\n<li>Added: Posts Extra \\u2014 Post count for filters<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Schema.org properties<\\/li>\\n<li>Fixed: Tooltips \\u2014 Add option to disable on breakpoint<\\/li>\\n<li>Fixed: Global Tooltips \\u2014 Destroy on editor mode<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Out of view sections have wrong background image positions<\\/li>\\n<li>Fixed: Global Tooltips \\u2014 Settings not being saved<\\/li>\\n<li>Fixed: Parallax Element \\u2014 Start position option not applying<\\/li>\\n<li>Fixed: Hotspots \\u2014 Image display block<\\/li>\\n<li>Fixed: Unfold \\u2014 Button alignment<\\/li>\\n<li>Fixed: Unfold \\u2014 Button icon position and indent<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Check for woocommerce for price fields<\\/li>\\n<li>Fixed: Video Player \\u2014 Volume size undefined error<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 RTL behviour on clicking thumbs<\\/li>\\n<li>Fixed: Inline SVG \\u2014 ACF image field<\\/li>\\n<li>Fixed: Update to getEditModel method<\\/li>\\n<li>Fixed: Compatibility with Elementor 2.3.0<\\/li>\\n<li>Fixed: License not deactivating if expired<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Distance for top-aligned labels<\\/li>\\n<li>Fixed: Devices + Hotspots \\u2014 Compatibility with Elementor 2.3.0<\\/li>\\n<li>Fixed: Switcher \\u2014 Astra theme images css conflict<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Multiple hierarchical categories not showing<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Filtered posts not found message<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Wrong grid item width when filters are active and multiple instances on page<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Controls conditions<\\/li>\\n<li>Fixed: Breacrumbs \\u2014 Wrap crumbs automatically<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Hide fields not available for Current Query option<\\/li>\\n<li>Tweak: Hotspots \\u2014 Default hotspots for better ux<\\/li>\\n<li>Tweak: Video Player + Devices \\u2014 Better behaviour and interactions for video player<\\/li>\\n<li>Tweak: Video Player + Devices \\u2014 Better selection of video source files<\\/li>\\n<li>Tweak: Video Player + Devices \\u2014 Added playback speed option<\\/li>\\n<li>Tweak: Timeline \\u2014 Support for point numbers and letter for posts<\\/li>\\n<li>Tweak: Table \\u2014 Remove render template to improve editing performance<\\/li>\\n<li>Tweak: Buttons \\u2014 Add bottom margin to custom spacing control<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Increase options for carousel rows and slides to scroll<\\/li>\\n<li>Tweak: Enable docs link in admin settings page<\\/li>\\n<li>Tweak: Switcher \\u2014 Make description field dynamic<\\/li>\\n<li>Tweak: Google Maps \\u2013 Adjust controls structure<\\/li>\\n<li>Tweak: Table \\u2014 Control names<\\/li>\\n<li>Tweak: Text Divider \\u2014 Controls position<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added read more to translatable fields for WPML<\\/li>\\n<\\/ul>\\n<h4> 1.9.16 <\\/h4>\\n<ul>\\n<li>Fixed: Elementor 2.3.0 compatibility<\\/li>\\n<\\/ul>\\n<h4> 1.9.15 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Load more button for multiple widget instances<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Responsive speed options<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Columns above 9 don\'t become full width<\\/li>\\n<li>Tweak: Improve Elementor Pro version dependency and posts widget compatibility<\\/li>\\n<li>Tweak: Timeline \\u2014 Enable dynamic fields for custom source<\\/li>\\n<li>Tweak: Circle Progress \\u2014 Handling of divisions operation in value control<\\/li>\\n<li>Tweak: Circle Progress \\u2014 Option to allow numbers with decimals instead of percetanges<\\/li>\\n<li>Tweak: Circle Progress \\u2014 Options to allow for absolute values to be shown<\\/li>\\n<li>Tweak: Hotspots \\u2014 Make hotspots size and opacity control responsive<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Remove swiper slide overflow hidden<\\/li>\\n<li>Tweak: Added option to enable updates to beta versions or Extras<\\/li>\\n<\\/ul>\\n<h4> 1.9.14 <\\/h4>\\n<ul>\\n<li>Fixed: Rename resize script to avoid potential conflicts<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Carousel flickering when used in Tabs widget and switching tabs<\\/li>\\n<li>Fixed: Timeline \\u2014 Date showing current date instead of post date<\\/li>\\n<li>Fixed: Extras admin page conflict with Jetpack<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Link not accessible for preview images with caption<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added query id control for server side filtering of widget queries<\\/li>\\n<li>Tweak: Hotspots \\u2014 HTML valid structure issue<\\/li>\\n<li>Tweak: Table \\u2014 Minor terminology improvements<\\/li>\\n<\\/ul>\\n<h4> 1.9.13 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Infinite scroll loading same posts<\\/li>\\n<li>Fixed: Inline SVG \\u2014 Space under image<\\/li>\\n<li>Fixed: Extensions not showing when Elementor Pro not active<\\/li>\\n<\\/ul>\\n<h4> 1.9.12 <\\/h4>\\n<ul>\\n<li>Added: CSS filter controls for widgets<\\/li>\\n<li>Added: Global Tooltips \\u2014 Support for shortcodes and dynamic fields<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Load more button causing error when not paginated<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Content inside media not showing when no thumbnail available<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Media area display conditions<\\/li>\\n<li>Fixed: Posts Extra \\u2014 PHP warning when excerpt length is empty<\\/li>\\n<li>Fixed: Posts Extra \\u2014 RTL alignment of posts in masonry mode<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Default control value to string<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Dynamic fields values not working<\\/li>\\n<li>Fixed: Parallax Elements \\u2014 Window height calculation<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Repeater fields conditions<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Breaks when dynamic field is used<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Allow offset to be used in current query<\\/li>\\n<li>Tweak: Timeline \\u2014 Allow drafts and scheduled posts to be included<\\/li>\\n<\\/ul>\\n<h4> 1.9.11 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Sticky posts compatibility with pagination<\\/li>\\n<li>Fixed: Compatibility with new Swiper version in Elementor 2.1<\\/li>\\n<li>Tweak: Timeline \\u2014 Responsive date padding and margin controls<\\/li>\\n<\\/ul>\\n<h4> 1.9.10 <\\/h4>\\n<ul>\\n<li>Fixed: Sticky Elements \\u2014 Options appear twice<\\/li>\\n<li>Tweak: Remove group control sticky<\\/li>\\n<\\/ul>\\n<h4> 1.9.9 <\\/h4>\\n<ul>\\n<li>Fixed: Timeline \\u2014 Points and line not aligned on mobile and tablet if size defined only on desktop<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Default placeholder image overriding post thumbnail<\\/li>\\n<li>Fixed: Sticky Elements no longer working<\\/li>\\n<li>Fixed: Additional check for active Elementor Pro<\\/li>\\n<li>Tweak: Moved Extras advanced section behind Custom CSS section<\\/li>\\n<\\/ul>\\n<h4> 1.9.8 <\\/h4>\\n<ul>\\n<li>Added: Gallery Slider \\u2014 Arrows controls for preview<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to show all filters when using infinite scroll<\\/li>\\n<li>Fixed: Unfold \\u2014 Icon right align not working<\\/li>\\n<li>Fixed: Compatibility with Elementor 2.1 beta<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Allow excerpt in media area<\\/li>\\n<li>Tweak: Timeline \\u2014 More specific color selectors<\\/li>\\n<li>Tweak: Timeline \\u2014 Text align dates to the right for right hand items<\\/li>\\n<\\/ul>\\n<h4> 1.9.7 <\\/h4>\\n<ul>\\n<li>Fixed: Gallery Extra \\u2014 Implemented work-around for warning caused by Elementor bug<\\/li>\\n<li>Fixed: Posts Extra \\u2014 IE 10 images bug<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Time not showing<\\/li>\\n<li>Fixed: Buttons \\u2014 Wrap buttons by default<\\/li>\\n<li>Fixed: Remove too broad css declaration<\\/li>\\n<li>Fixed: Parallax background \\u2014 Correct element resize function name<\\/li>\\n<\\/ul>\\n<h4> 1.9.6 <\\/h4>\\n<ul>\\n<li>Fixed: Parallax Elements \\u2014 Breaks if pan distance is undefined<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Read more typography control conditions<\\/li>\\n<li>Fixed: Unfold \\u2014 Force icon to show hide as inline block<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Stretch body to align all footers to bottom<\\/li>\\n<li>Fixed: Posts Extra \\u2014 IE 10 horizontal layout for posts<\\/li>\\n<li>Fixed: Renamed jquery resize plugin function<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 CSS overflow fix<\\/li>\\n<\\/ul>\\n<h4> 1.9.5 <\\/h4>\\n<ul>\\n<li>Added: Dynamic fields support for all widgets<\\/li>\\n<li>Fixed: Global Tooltips \\u2014 Position not being overriden<\\/li>\\n<li>Fixed: Timeline \\u2014 Pointer cursor not showing on linked cards<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Image bottom spacing on some themes<\\/li>\\n<li>Tweak: Gallery Extra \\u2014 Added unique classes to each item<\\/li>\\n<li>Tweak: HTML5 Video \\u2014 Added control to enable muted video for autoplay<\\/li>\\n<li>Tweak: HTML5 Video \\u2014 Added controls to enable or disable all elements inside the bar<\\/li>\\n<\\/ul>\\n<h4> 1.9.4 <\\/h4>\\n<ul>\\n<li>Added: Timeline \\u2014 Control to center images<\\/li>\\n<li>Added: Posts Extra \\u2014 New filters for post title, excerpt, comments and date<\\/li>\\n<li>Added: HTML5 Video \\u2014 Control to stop all other video players when current one is played.<\\/li>\\n<li>Fixed: Fixed: Column widths in post-css are rendered in the wrong order<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Posts per page doesn\'t take into account sticky posts<\\/li>\\n<li>Fixed: Buttons \\u2014 Item typography group control not working<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Responsive horizontal alignment for filters<\\/li>\\n<li>Fixed: Hotspots \\u2014 Tooltip position not being overriden at hotspot level<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Control conditions<\\/li>\\n<li>Tweak: Updated isotope version to 3.0.6 to fix 1px grid gap<\\/li>\\n<li>Tweak: Remove default webkit left padding from list navs<\\/li>\\n<li>Tweak: Parallax Background \\u2014 Increase plugin timeout reinit<\\/li>\\n<li>Tweak: Posts \\u2014 Increase excerpt length filter priority<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added option to show only sticky posts<\\/li>\\n<\\/ul>\\n<h4> 1.9.3 <\\/h4>\\n<ul>\\n<li>Added: Sticky Elements \\u2014 Compatibility with the Lazy Loader wordpress plugin<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Safari &lt; 10.2 layout glitch layout glitch on mobile<\\/li>\\n<li>Fixed: HTML5 Video \\u2014 m4v files condition<\\/li>\\n<li>Fixed: Sticky \\u2014 Sticks only when resizing browser window<\\/li>\\n<li>Fixed: Sticky \\u2014 Not working correctly with Stretched parent<\\/li>\\n<li>Fixed: HTML5 Video \\u2014 m4v format not sufficient<\\/li>\\n<li>Fixed: Image Comparison \\u2013 Allow 0 percent values<\\/li>\\n<li>Tweak: HTML5 Video \\u2014 Render attributes<\\/li>\\n<li>Tweak: HTML5 Video \\u2014 Control conditions<\\/li>\\n<\\/ul>\\n<h4> 1.9.2 <\\/h4>\\n<ul>\\n<li>Fixed: Switcher \\u2014 Bug with arrow loader position and stroke width in older versions of Safari<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Compatibility with IE 11<\\/li>\\n<li>Fixed: Parallax Elements \\u2014 Control value undefined check<\\/li>\\n<\\/ul>\\n<h4> 1.9.1 <\\/h4>\\n<ul>\\n<li>Fixed: Parallax Elements \\u2014 Max distance not taking into account scroll position<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Filters not stacking on responsive.<\\/li>\\n<li>Fixed: Switcher \\u2014 Arrow loader not displaying in firefox<\\/li>\\n<li>Fixed: Parallax Elements \\u2014 Wrong position for scroll with start position<\\/li>\\n<li>Fixed: GSAP dependencies<\\/li>\\n<\\/ul>\\n<h4> 1.9.0 <\\/h4>\\n<ul>\\n<li>Added: New Switcher Widget! \\u2014 Switch photos and text using powerful javascript driven transitions. Features menu and arrows navigation, autoplay with progress loader, entrance animations, page background color switcher, two skins (default and overlay) and much more.<\\/li>\\n<li>Added: New Feature for Parallax Elements! \\u2014 Option to parallax columns and widgets on mouse move<\\/li>\\n<li>Added: Posts Extra \\u2014 Controls to style only sticky posts<\\/li>\\n<li>Added: Image Comparison \\u2014 Option to enable clicking on labels to uncover images<\\/li>\\n<li>Added: Hotspots \\u2014 Separate color controls for each hotspot<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Sticky posts not working when a category is selected in the query<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Invisible gallery when preview position is top on desktop<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Remove labels if no text is present<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Hide carousel until properly rendered<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Added alt and title tags to image element<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Issue with negative margin resulting in right whitespace for the gallery<\\/li>\\n<li>Fixed: Timeline \\u2014 Controls conditions<\\/li>\\n<li>Fixed: Timeline \\u2014 Item point color override<\\/li>\\n<li>Fixed: Timeline \\u2014 Properly override point content<\\/li>\\n<li>Tweak: Parallax Elements \\u2014 Removed group control<\\/li>\\n<li>Tweak: Gallery Extra, Gallery Slider, Posts Extra \\u2014 Added notice with link to blend mode browser support for blend mode controls<\\/li>\\n<li>Tweak: Timeline \\u2014 Added repeater setting key method to card render function<\\/li>\\n<\\/ul>\\n<h4> 1.8.8 <\\/h4>\\n<ul>\\n<li>Added: Gallery Extra \\u2014 Control width and ratio of each individual image in manual mode<\\/li>\\n<li>Added: Timeline \\u2014 Option for automatic numbering and letters instead of icons to points<\\/li>\\n<li>Added: Timeline \\u2014 New control to set excerpt length<\\/li>\\n<li>Added: Unfold \\u2014 Option to change icon when unfolded<\\/li>\\n<li>Added: Sticky Elements \\u2014 Option to turn off bottoming of elements inside the parent<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to enable sticky posts in query<\\/li>\\n<li>Added: Posts Extra \\u2014 Arrows sizing controls<\\/li>\\n<li>Added: Posts Extra \\u2014 Transition control for carousel arrows and pagination<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to set how many slides to scroll<\\/li>\\n<li>Added: Image Comparison \\u2014 Control to define initial position of separator<\\/li>\\n<li>Added: Image Comparison \\u2014 Option to enable moving separator by clicking anywhere on the image<\\/li>\\n<li>Added: Buttons \\u2014 Control for label min width<\\/li>\\n<li>Added: Hotspots \\u2014 Control to disable pulsating animation<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Controls not showing on inner sections<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Images wider than 100% on mobile in manual mixed masonry layout mode<\\/li>\\n<li>Fixed: HTML5 Video \\u2014 CSS bottom whitespace<\\/li>\\n<li>Fixed: Buttons \\u2014 Remove block label for buttons icon, id and class controls<\\/li>\\n<li>Tweak: Timeline \\u2014 Take sticky posts into consideration in query<\\/li>\\n<li>Tweak: Unfold \\u2014 Organise controls<\\/li>\\n<li>Tweak: WPML Compatibility \\u2014 Change method to fix fields not saving<\\/li>\\n<\\/ul>\\n<h4> 1.8.7 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Filtering one widget\'s posts affects all other widgets<\\/li>\\n<li>Fixed: Hotspots \\u2014 Tooltips have an extra space at the bottom when first hovering<\\/li>\\n<li>Fixed: HTML5 Video \\u2014 Volume functionality breaks when controls are hidden<\\/li>\\n<li>Fixed: HTML5 Video \\u2014 Video reloading after each loop<\\/li>\\n<li>Added: Global Tooltips \\u2014 Global controls for distance and width<\\/li>\\n<li>Tweak: HTML5 Video \\u2014 Added width and horizontal alignment control to player<\\/li>\\n<li>Tweak: Global Tooltips \\u2014 Remove default global styling values after Elementor enqueue fix in 1.9.5<\\/li>\\n<\\/ul>\\n<h4> 1.8.6 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Term slug classes to filters and post terms<\\/li>\\n<li>Fixed: Replaced create_function with anonymous function for PHP 7.2 support<\\/li>\\n<li>Fixed: Inline SVG \\u2014 Handle internal CSS in non color overriding situations<\\/li>\\n<li>Fixed: Hotspots \\u2014 Tooltips showing even if they have no content<\\/li>\\n<li>Tweak: Sticky Elements \\u2014 Prevent sticky on a section that is stretched with js<\\/li>\\n<li>Tweak: Buttons \\u2014 Move typography control above tabs<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Move hover animation controls to separate section for better ux<\\/li>\\n<li>Tweak: Gallery Extra \\u2014 Moved hover controls to separate section<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Moved hover controls to separate section<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Default font size for thumbnail captions<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Fix condition<\\/li>\\n<li>Tweak: Hotspots \\u2014 Show label for tooltip content in editor<\\/li>\\n<\\/ul>\\n<h4> 1.8.5 <\\/h4>\\n<ul>\\n<li>Fixed: Gallery Extra \\u2014 Missing js dependency<\\/li>\\n<\\/ul>\\n<h4> 1.8.4 <\\/h4>\\n<ul>\\n<li>Fixed: Gallery Extra \\u2014 Random ordering not working<\\/li>\\n<li>Fixed: Timeline \\u2014 RTL optimisation<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Custom image size not working on manual mode<\\/li>\\n<li>Tweak: Add dismissible notice for recommended php version<\\/li>\\n<li>Tweak: Gallery Extra \\u2014 Add title and description caption types<\\/li>\\n<li>Tweak: Timeline \\u2014 Add link control description to avoid linking cards when content already contains links<\\/li>\\n<\\/ul>\\n<h4> 1.8.3 <\\/h4>\\n<ul>\\n<li>Fixed: HTML5 Video \\u2014 Video not playing on Safari and some mobile environments<\\/li>\\n<li>Fixed: Buttons \\u2014 Safari buttons vertical alignment<\\/li>\\n<li>Fixed: Devices \\u2014 device not displaying on Safari when portrait mode is enabled<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Grid broken on Safari<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 reinit masonry when images done loading<\\/li>\\n<li>Tweak: Move all Extras admin settings into Elementor menu<\\/li>\\n<li>Tweak: Image Comparison \\u2014 Remove default value for width control<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 default mobile and tablet gallery columns to larger numbers<\\/li>\\n<\\/ul>\\n<h4> 1.8.2 <\\/h4>\\n<ul>\\n<li>Added: Parallax Background \\u2014 Support for section resize in elementor preview mode<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Compatibility with stretched section<\\/li>\\n<li>Fixed: HTML5 Video \\u2014 Interface style controls conditions<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Right side white-space after thumbnails on top preview position<\\/li>\\n<li>Fixed: Unfold \\u2014 Page stops responding when entering invalid html in text editor mode<\\/li>\\n<li>Tweak: Unfold \\u2014 Allow accordions, tabs and all resizing elements inside content<\\/li>\\n<\\/ul>\\n<h4> 1.8.1 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Masonry broken when infinite scroll is enabled<\\/li>\\n<\\/ul>\\n<h4> 1.8.0 <\\/h4>\\n<ul>\\n<li>New extension: Global Tooltips \\u2014 Add a tooltip to any widget<\\/li>\\n<li>New: Disable Widgets &amp; Extensions \\u2014 You can now disable Extras widgets and extensions via the admin settings page<\\/li>\\n<li>Added: WPML compatibility \\u2014 String Translation and Translation Editor support for all widgets<\\/li>\\n<li>Added: Circle Progress \\u2014 Icon support inside circle<\\/li>\\n<li>Added: Update .pot translation file<\\/li>\\n<li>Added: Buttons \\u2014 Tooltips duration control<\\/li>\\n<li>Added: Global settings for Extras tooltips<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Widget not available on multisite installations<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Infinite scroll breaks when using multiple widgets on same page<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Conflict with Anywhere Elementor Pro featured image background<\\/li>\\n<li>Tweak: Parallax Background \\u2014 requestAnimationFrame method for better performance<\\/li>\\n<li>Tweak: Buttons \\u2014 Rename text align label<\\/li>\\n<li>Tweak: Update nicons font<\\/li>\\n<\\/ul>\\n<h4> 1.7.4 <\\/h4>\\n<ul>\\n<li>Fixed: Gallery Extra \\u2014 Custom link broken and attributes not added<\\/li>\\n<\\/ul>\\n<h4> 1.7.3 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Column vertical alignment controls for carousel<\\/li>\\n<li>Added: Timeline \\u2014  Color controls for post title and excerpt<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Carousel rows number control not impacting preview<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Avatar vertical alignment on stretched media content<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Incorrect spacer height<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Improve editing flow by with advanced controls conditioning<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Controls position<\\/li>\\n<li>Tweak: Sticky Elements \\u2014 Remove popover from group control<\\/li>\\n<li>Tweak: Parallax Elements \\u2014 Remove popover from group control<\\/li>\\n<\\/ul>\\n<h4> 1.7.2 <\\/h4>\\n<ul>\\n<li>Added: Gallery Slider \\u2014 Overlay captions for preview and thumbnails<\\/li>\\n<li>Added: Gallery Slider \\u2014 Controls for caption effects, layout and hover properties<\\/li>\\n<li>Added: Gallery Slider \\u2014 Controls for active thumbs caption<\\/li>\\n<li>Fixed: Buttons \\u2014 Removed popover control on effects<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Improved carousel adapt on preview resize<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Improved thumbnails grid<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Better controls for stacking and position of preview<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Replace background color with background control for preview captions and overlay<\\/li>\\n<li>Tweak: Gallery Slider + Gallery Extra \\u2014 Better BEM classes<\\/li>\\n<\\/ul>\\n<h4> 1.7.1 <\\/h4>\\n<ul>\\n<li>Added: Gallery Extra \\u2014 Caption horizontal and vertical alignment and hover effects<\\/li>\\n<li>Added: Gallery Extra \\u2014 Ratio and alignment controls to masonry layout<\\/li>\\n<li>Added: Gallery Extra \\u2014 New border and border radius controls for captions<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Bring image to front when hovered<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Images not displaying on infinite load on iOS Safari and Chrome<\\/li>\\n<li>Tweak: Image Comparison \\u2014 Force override of modified image max-width attribute<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added extra classes to media elements<\\/li>\\n<\\/ul>\\n<h4> 1.7.0 <\\/h4>\\n<ul>\\n<li>Added: Gallery Extra \\u2014 Masonry layout with mixed mode<\\/li>\\n<li>Added: Gallery Extra \\u2014 Tilt effect<\\/li>\\n<li>Added: Gallery Extra \\u2014 Caption horizontal and vertical alignment and hover effects<\\/li>\\n<li>Added: Gallery Extra \\u2014 Overlay, caption and image transition controls<\\/li>\\n<li>Added: Gallery Extra \\u2014 Overlay blend mode control<\\/li>\\n<li>Added: Gallery Extra \\u2014 Image scale controls for default and hover states<\\/li>\\n<li>Added: Gallery Extra \\u2014 Overlay margin controls for default and hover states<\\/li>\\n<li>Added: Gallery Extra \\u2014 Manual mode that allows entering of every image manually and linking it to any URL<\\/li>\\n<li>Added: Inline SVG widget<\\/li>\\n<li>Added: Posts Extra \\u2014 Controls to disable linking for post title, media and terms<\\/li>\\n<li>Added: Posts Extra \\u2014 Control to select default applied filter for filter bar<\\/li>\\n<li>Added: Timeline \\u2014 New controls for post title typography and spacing, post excerpt typography and padding<\\/li>\\n<li>Added: Image Comparison \\u2014 Image size control<\\/li>\\n<li>Added: New css transition control for Gallery Extra, Gallery Slider, Hotspots, Posts Extra, Timeline, Table and Inline SVG widgets<\\/li>\\n<li>Added: HTML5 Video \\u2014 M4V format support<\\/li>\\n<li>Added: Devices \\u2014 M4V format support for video<\\/li>\\n<li>Fixed: Buttons \\u2014 Flicker on flip effect<\\/li>\\n<li>Fixed: Timeline \\u2014 CSS class conflict<\\/li>\\n<li>Fixed: Table \\u2014 ID and class don\'t apply to header<\\/li>\\n<li>Tweak: Improved Elementor 1.9 compatibility for Extras group controls<\\/li>\\n<li>Tweak: Update TweenMax to latest version (1.20.2)<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Simplified CSS<\\/li>\\n<li>Tweak: Unfold \\u2014 Disconnect button and content from control alignment logic<\\/li>\\n<\\/ul>\\n<h4> 1.6.3 <\\/h4>\\n<ul>\\n<li>Fixed: Breadcrumbs \\u2014 Display correctly when used within an Elementor library template<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Condition terms separator<\\/li>\\n<li>Tweak: Breadcrumbs \\u2014 Avoid naming conflict with Elementor Pro widget<\\/li>\\n<\\/ul>\\n<h4> 1.6.2 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 New autoplay, autoheight and fade effect controls<\\/li>\\n<li>Added: Posts Extra \\u2014 &quot;Top&quot; option to media position on horizontal layout<\\/li>\\n<li>Added: Posts Extra \\u2014 Allowed media to be positioned horizontally on 2 columns layouts<\\/li>\\n<li>Added: Posts Extra \\u2014 New border controls for media<\\/li>\\n<li>Added: Table \\u2014 Allow table responsive behaviour to be turned off<\\/li>\\n<li>Tweak: Buttons \\u2014 Default button content alignment to justify<\\/li>\\n<li>Fix: Timeline \\u2014 Potential fatal error<\\/li>\\n<li>Fix: Posts Extra \\u2014 Post media position controls conditions<\\/li>\\n<li>Fix: Buttons \\u2014 Delay on transitioned properties<\\/li>\\n<li>Fix: Posts Extra \\u2014 Wrong tablet breakpoint set for number of columns<\\/li>\\n<li>Fix: Parallax Background \\u2014 Remove initial background image once parallax is activated<\\/li>\\n<\\/ul>\\n<h4> 1.6.1 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Link author name and avatar to author posts pages<\\/li>\\n<li>Added: Posts Extra \\u2014 Read more link to excerpt<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added separate hide option for Position for better UX <\\/li>\\n<li>Tweak: Posts Extra \\u2014 Improved position icons<\\/li>\\n<\\/ul>\\n<h4> 1.6.0 <\\/h4>\\n<ul>\\n<li>New Widget \\u2014 Posts Extra - Create ANY layout for posts with masonry, infinite load, filtering and custom post type support. Works only with Elementor Pro<\\/li>\\n<li>Tweak: Breadcrumbs \\u2014 Added horizontal position and text alignment controls<\\/li>\\n<li>Tweak: Buttons \\u2014 Improved CSS and better alignment and stacking options<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Error outputting separator<\\/li>\\n<li>Fixed: Buttons \\u2014 Transition on button content when effects are turned on<\\/li>\\n<\\/ul>\\n<h4> 1.5.6 <\\/h4>\\n<ul>\\n<li>Fixed: Parallax Background \\u2014 Replaced parallax class name to avoid future conflicts<\\/li>\\n<li>Fixed: Timeline \\u2014 Remove flex from left aligned timeline and allow image spacing for horizontal layouts<\\/li>\\n<li>Fixed: PHP fatal error<\\/li>\\n<li>Tweak: Unfold \\u2014 Switched Settings with Content sections in editor for better UX<\\/li>\\n<\\/ul>\\n<h4> 1.5.5 <\\/h4>\\n<ul>\\n<li>Added: Buttons \\u2014 Inline editing<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Inline editing<\\/li>\\n<li>Added: Circle Progress \\u2014 Inline editing<\\/li>\\n<li>Added: Hotspots \\u2014 Inline editing<\\/li>\\n<li>Added: Image Comparison \\u2014 Inline editing<\\/li>\\n<li>Added: Table \\u2014 Inline editing<\\/li>\\n<li>Added: Text Divider \\u2014 Inline editing<\\/li>\\n<li>Added: Timeline \\u2014 Inline editing<\\/li>\\n<li>Added: Unfold \\u2014 Inline editing<\\/li>\\n<li>Fixed: Tooltips \\u2014 Error &quot;size&quot; of undefined appears for delay_in in some cases<\\/li>\\n<li>Fixed: Unfold \\u2014 Issue that resulted in wrong calculation of unfolded height<\\/li>\\n<li>Tweak: Default to text cursor for text where inline editing is available<\\/li>\\n<\\/ul>\\n<h4> 1.5.4 <\\/h4>\\n<ul>\\n<li>Added: HTML5 Video \\u2014 Option to end video at last frame<\\/li>\\n<li>Tweak: HTML5 Video \\u2014 Removed auto pausing when interacting with progress bar<\\/li>\\n<\\/ul>\\n<h4> 1.5.3 <\\/h4>\\n<ul>\\n<li>Fixed: Unfold \\u2014 Content folds back automatically when scrolling on mobile browsers that vertically resize the viewport<\\/li>\\n<\\/ul>\\n<h4> 1.5.2 <\\/h4>\\n<ul>\\n<li>Added: Gallery Extra \\u2014 Allow gallery navigation in lightbox<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Image box shadow not applying<\\/li>\\n<li>Fixed: Buttons \\u2014 Issue with transition delays on buttons without effects<\\/li>\\n<\\/ul>\\n<h4> 1.5.1 <\\/h4>\\n<ul>\\n<li>Added: Table \\u2014 Control to show header on mobile as a block or a column<\\/li>\\n<li>Added: Table \\u2014 Border control for table rows<\\/li>\\n<li>Added: Table \\u2014 Option to automatically try to fetch correct headers for mobile with override possibility<\\/li>\\n<li>Added: Table \\u2014 Control to set width for mobile headers<\\/li>\\n<li>Tweak: Table \\u2014 Remove column rules from mobile<\\/li>\\n<li>Tweak: Table \\u2014 Removed first \\/ last child border rules from mobile<\\/li>\\n<li>Tweak: Table \\u2014 Added pointer cursor on sortable header cells<\\/li>\\n<li>Tweak: Table \\u2014 Moved padding to text for better handling of responsive layout and removed negative margin technique<\\/li>\\n<li>Tweak: Table \\u2014 Responsive cells and header cells padding controls<\\/li>\\n<li>Tweak: Table \\u2014 Move cell header control to top<\\/li>\\n<li>Tweak: Table \\u2014 Added option to hide headers completely on mobile<\\/li>\\n<li>Tweak: Table \\u2014 Hide mobile headers that have no content<\\/li>\\n<li>Tweak: Sticky \\u2014 Set default z-index to 1 for stickable elements<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Separator not showing<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Remove space between images and widget container<\\/li>\\n<li>Fixed: Table \\u2014 PHP Warning when allowing empty on repeater fields<\\/li>\\n<li>Fixed: Table \\u2014 Width and alignment not working<\\/li>\\n<li>Fixed: Table \\u2014 Added missing custom class and id from markup<\\/li>\\n<\\/ul>\\n<h4> 1.5.0 <\\/h4>\\n<ul>\\n<li>New Widget: Table<\\/li>\\n<li>Fixed: Prefix CSS helper classes to avoid potential conflicts<\\/li>\\n<\\/ul>\\n<h4> 1.4.0 <\\/h4>\\n<ul>\\n<li>New: Buttons Effects<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Control to manually specify which post or page to generate breadcrumbs for<\\/li>\\n<li>Fixed: Devices \\u2014 Horizontal orientation image not visible<\\/li>\\n<\\/ul>\\n<h4> 1.3.1 <\\/h4>\\n<ul>\\n<li>Fixed: Parallax Background \\u2014 Wrong position when loading page off viewport<\\/li>\\n<li>Fixed: Timeline \\u2014 Enlarged points not aligned to line on tablet and mobile<\\/li>\\n<li>Added: Timeline \\u2014 Responsive controls for point size and icon size<\\/li>\\n<\\/ul>\\n<h4> 1.3.0 <\\/h4>\\n<ul>\\n<li>Added: New Widget! \\u2014 HTML5 Video<\\/li>\\n<li>Added: Devices \\u2014 Added HTML5 Video controls<\\/li>\\n<li>Added: Devices \\u2014 Added option to stretch the video to fit into the device screen<\\/li>\\n<li>Added: Devices \\u2014 Added option to choose wether or not to stop the video when leaving viewport<\\/li>\\n<li>Added: Timeline \\u2014 Hover properties for points<\\/li>\\n<li>Added: Timeline \\u2014 More style override options for each card<\\/li>\\n<li>Added: Gallery Slider \\u2014 More responsive controls for preview position and spacing<\\/li>\\n<li>Fixed: Timeline \\u2014 Removed unnecessary z-index from cards<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Preview spacing doesn\'t work on mobile when the layout is vertical<\\/li>\\n<li>Fixed: Devices \\u2014 Replaced SVG IDs with classes to avoid code invalidation<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Canvas distorted on responsive<\\/li>\\n<li>Fixed: Hotspots \\u2014 Links concatenating from one repeater field to another<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Images move up after scrolling up and down multiple times<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Background position is off when section Stretch is turned on<\\/li>\\n<li>Fixed: Hotspots \\u2014 Links inside tooltips appear outside of the tooltip<\\/li>\\n<li>Tweak: Timeline \\u2014 Changed &quot;Size Ratio&quot; name to &quot;Scale&quot;<\\/li>\\n<li>Tweak: Gallery Extras \\u2014 Bring 3D items to front on hover<\\/li>\\n<li>Tweak: Hotspots \\u2014 Moved tooltip content outside hotspot to avoid invalid nodes<\\/li>\\n<li>Tweak: Hotspots \\u2014 Don\'t activate tooltips that have no content set<\\/li>\\n<\\/ul>\\n<h4> 1.2.5 <\\/h4>\\n<ul>\\n<li>Tweak: Replaced text align icons with horizontal align icons where appropriate<\\/li>\\n<li>Fixed: Sticky elements not bottoming out correctly when using custom parent selector<\\/li>\\n<li>Fixed: Removing unstick for any breakpoint would break sticky functionality<\\/li>\\n<\\/ul>\\n<h4> 1.2.4 <\\/h4>\\n<ul>\\n<li>Added: Sticky \\u2014 Custom selector for sticky parent to allow for elements to stick in any parent element<\\/li>\\n<li>Tweak: Timeline \\u2014 Responsive padding controls<\\/li>\\n<li>Tweak: Timeline \\u2014 Refactoring and improved performance and accuracy on progress bar<\\/li>\\n<li>Tweak: Image Comparison \\u2014 Adjust spacing method for labels and vertical alignment improvements<\\/li>\\n<li>Tweak: Image Comparison \\u2014 Allow for widget border radius control to affect images<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Scroll breaks on mobile when hiding a parallaxed section<\\/li>\\n<li>Fixed: Timeline \\u2014 Cards not animating when first in view<\\/li>\\n<li>Fixed: Timeline \\u2014 Content wrapper present even if no card content is set<\\/li>\\n<\\/ul>\\n<h4> 1.2.3 <\\/h4>\\n<ul>\\n<li>Fixed: Parallax Background \\u2014 Section background not reverting after parallax turned on again<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Calculating wrong dimensions when using Elementor JS stretch option<\\/li>\\n<li>Fixed: Issue where updating Elementor when Extras is active would result in an error<\\/li>\\n<li>Tweak: Hotspots \\u2014 Adjusted default tooltip width<\\/li>\\n<\\/ul>\\n<h4> 1.2.2 <\\/h4>\\n<ul>\\n<li>Fixed: Heading Extra \\u2014 Complete html support<\\/li>\\n<\\/ul>\\n<h4> 1.2.1 <\\/h4>\\n<ul>\\n<li>Fixed: Heading Extra \\u2014 Gradient would show only for the first line<\\/li>\\n<li>Fixed: Parallax Background \\u2014 When using padding on sections, image position calculation would not be correct<\\/li>\\n<\\/ul>\\n<h4> 1.2.0 <\\/h4>\\n<ul>\\n<li>Added: New Feature! \\u2014 Parallax Background \\u2014 Now you can parallax section backgrounds and have it move up, down, left or right while scrolling<\\/li>\\n<li>Added: New Widget! \\u2014 Unfold \\u2014 Lets you hide content and reveal it on demand<\\/li>\\n<li>Added: New Widget! \\u2014 Breadcrumbs<\\/li>\\n<li>Added: Parallax Elements \\u2014 Allow to select whether to parallax an element relative to its own position or the middle of the viewport<\\/li>\\n<li>Added: Hotspots \\u2014 Ability to add links to hotspots if tooltips are triggered on hover<\\/li>\\n<li>Added: Tooltips \\u2014 Added left and right tooltips for both Hotspots and Button Groups<\\/li>\\n<li>Added: Tooltips \\u2014 Better handling of repositioning tooltips when they flow outside of the viewport<\\/li>\\n<li>Added: Tooltips \\u2014 Ability to override tooltip position for each button of hotspot individually<\\/li>\\n<li>Added: Heading Extra \\u2014 Text fill now supports clipped images<\\/li>\\n<li>Tweak: Heading Extra \\u2014 Allow to have both text shadow and long shadow on the same text<\\/li>\\n<li>Tweak: Text Divider \\u2014 Responsive alignment and spacing controls<\\/li>\\n<li>Tweak: Text Divider \\u2014 Proper horizontal alignment of text and separators<\\/li>\\n<li>Fixed: Heading Extra \\u2014 Multiple z-index related issues<\\/li>\\n<li>Fixed: Parallax Elements \\u2014 Fix issue where elements would jump when scrolling<\\/li>\\n<\\/ul>\\n<h4> 1.1.4 <\\/h4>\\n<ul>\\n<li>Added: Sticky sections!<\\/li>\\n<li>Added: Sticky \\u2014 New controls to unstick for mobile and tablet<\\/li>\\n<li>Added: Parallax Elements \\u2014 New controls to set different speeds for different breakpoints<\\/li>\\n<li>Added: Gallery Slider \\u2014 Links on images and support for the new Elementor lightbox feature<\\/li>\\n<li>Tweak: Improved shortcode support for all widgets, especially tooltips<\\/li>\\n<li>Tweak: Parallax Elements \\u2014 Greatly improved performance for parallaxed items<\\/li>\\n<li>Tweak: Parallax Elements \\u2014 Changed speed control logic to allow for reverse parallax<\\/li>\\n<li>Tweak: Created custom group controls for Sticky and Parallax features<\\/li>\\n<li>Fixed: Removed z-index from sticky elements to allow z-index setting from Elementor controls<\\/li>\\n<li>Fixed: Gallery Extras \\u2014 Some styling controls were conditioned by the &quot;Link to&quot; control<\\/li>\\n<li>Fixed: Removed potentially buggy call to Elementor class<\\/li>\\n<\\/ul>\\n<h4> 1.1.3 <\\/h4>\\n<ul>\\n<li>Tweak: Devices \\u2014 Refactored and cleaned up code for editor functionality<\\/li>\\n<li>Tweak: Gallery Extra \\u2014 Moved distance control after parallax controls<\\/li>\\n<li>Added: Controls to add parallax to any widget or column<\\/li>\\n<li>Added: Global control for turning off parallax functionality for tablet and mobile<\\/li>\\n<li>Added: Gallery Extra \\u2014 Control for settings horizontal overlap of images<\\/li>\\n<li>Added: Image Comparison \\u2014 Separator between images<\\/li>\\n<li>Added: Global \\u2014 Implemented the new Text Shadow controls for all widgets<\\/li>\\n<li>Added: Button Groups \\u2014 Responsive control of spacing for stacked buttons<\\/li>\\n<li>Fixed: Devices \\u2014 Issue where frames would not properly change in editor mode<\\/li>\\n<li>Fixed: Changed license page capability to \'manage_options\'<\\/li>\\n<li>Fixed: Compatibility with Elementor 1.6<\\/li>\\n<\\/ul>\\n<h4> 1.1.2 <\\/h4>\\n<ul>\\n<li>Fixed: Class namespace change in Elementor Pro 1.5.7 resulting in fatal error<\\/li>\\n<\\/ul>\\n<h4> 1.1.1 <\\/h4>\\n<ul>\\n<li>Fixed: Devices \\u2014 Overlay not visible for laptop and desktop<\\/li>\\n<li>Fixed: Timeline \\u2014 PHP empty function fatal error<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Width remained 50% even if vertical layout selected<\\/li>\\n<\\/ul>\\n<h4> 1.1.0 <\\/h4>\\n<ul>\\n<li>Added: New Widget! \\u2014 Gallery Extra \\u2014 We\'ve taken aside the parallax functionality and created a whole new widget with nots of posibilities.<\\/li>\\n<li>Added: New Widget! \\u2014 Gallery Slider \\u2014 A gallery layout with inline preview.<\\/li>\\n<li>Added: New Feature! \\u2014 Button tooltips \\u2014 You can now use the Button Groups widget to add buttons with tooltips.<\\/li>\\n<li>Added: New Feature! \\u2014 Timeline \\u2014 Integration with Woocommerce products.<\\/li>\\n<li>Added: New Feature! \\u2014 Hotspots \\u2014 Added support for icons inside hotspots.<\\/li>\\n<li>Added: New Feature! \\u2014 Hotspots \\u2014 Ability to set the delay for both entrance close animations.<\\/li>\\n<li>Added: Circle Progress \\u2014 Control too choose start angle for the circle progress.<\\/li>\\n<li>Added: Devices \\u2014 Support for multiple video formats<\\/li>\\n<li>Added: Timeline \\u2014 Add featured images from separate control.<\\/li>\\n<li>Added: Elementor Portfolio Widget \\u2014 Speed control for parallax feature.<\\/li>\\n<li>Added: Timeline \\u2014 Turn on and off for excerpts, content, title and featured image.<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Handle now goes all the way until the end of the image.<\\/li>\\n<li>Fixed: Timeline \\u2014 Date color wasn\'t changing properly.<\\/li>\\n<li>Fixed: Issue where disabling and changing license was not possible.<\\/li>\\n<li>Fixed: Sticky - Issue where in preview mode wrong height of the element was calculated.<\\/li>\\n<li>Fixed: Image Gallery \\u2014 Issue with displaying on Firefox.<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Handle jumps when using multiple widgets on same page.<\\/li>\\n<li>Fixed: Timeline \\u2014 Scheme style override issue for points.<\\/li>\\n<li>Fixed: Devices \\u2014 Video would not play on iOS devices<\\/li>\\n<\\/ul>\\n<h4> 1.0.5 <\\/h4>\\n<ul>\\n<li>Added: Button Groups \\u2014 Box shadow control.<\\/li>\\n<li>Fixed: Ensured compatibility with other jquery appear plugins.<\\/li>\\n<li>Fixed: Issue where disabling and changing license was not possible.<\\/li>\\n<\\/ul>\\n<h4> 1.0.4 <\\/h4>\\n<ul>\\n<li>Added: Added translation support<\\/li>\\n<li>Fixed: Devices \\u2014 Issue where controls would always display as a white rectangular shape.<\\/li>\\n<\\/ul>\\n<h4> 1.0.3 <\\/h4>\\n<ul>\\n<li>Fixed: Image Galleries \\u2014 Issue where galleries with no links would break the layout<\\/li>\\n<li>Fixed: Hotspots \\u2014 When using multiple hotspots widgets on the same page additional widgets would show the first widget\'s tooltips instead of their own<\\/li>\\n<\\/ul>\\n<h4> 1.0.2 <\\/h4>\\n<ul>\\n<li>Added: Hotspots \\u2014 New controls: text align, padding, border and typography<\\/li>\\n<li>Fixed: Hotspots \\u2014 Hide arrow control not working<\\/li>\\n<li>Fixed: Hotspots \\u2014 Issue where tooltips don\'t remain open on click trigger option and thus preventing clicking off links inside tooltips<\\/li>\\n<li>Fixed: Button Groups \\u2014 Replaced custom border controls with border group control<\\/li>\\n<li>Fixed: Extended Heading \\u2014 Compability with Elementor 1.5<\\/li>\\n<li>Fixed: Extended Heading \\u2014 Heading size not working<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Issue where colors of labels would not change colors for printed templates<\\/li>\\n<\\/ul>\\n<h4> 1.0.1 <\\/h4>\\n<ul>\\n<li>Fixed: Image Comparison \\u2014 Issue where dragging the handle on mobile would not work<\\/li>\\n<\\/ul>\\n<h4> 1.0.0 <\\/h4>\\n<ul>\\n<li>Added: New &quot;Timeline&quot; widget with posts support for Elementor Pro<\\/li>\\n<li>Added: Image Comparison \\u2014 Different colors for both labels<\\/li>\\n<li>Tweak: Image Comparison \\u2014 Moved alignment &amp; scaling options to widget wrapper<\\/li>\\n<li>Tweak: Aligned default widgets colors to selected color scheme<\\/li>\\n<li>Tweak: Removed sticky from sections temporarily<\\/li>\\n<li>Tweak: Removed parallax scrolling from section backgrounds<\\/li>\\n<li>Tweak: Button Groups \\u2014 Reorganized repeater controls under tabs<\\/li>\\n<li>Tweak: Full compatibility with global color schemes for all widgets<\\/li>\\n<li>Tweak: Hotspots \\u2014 Reorganized repeater controls under tabs<\\/li>\\n<li>Fixed: Timeline \\u2014 Issue where arrow colors would not apply<\\/li>\\n<li>Fixed: Extended Heading \\u2014 Entrace animation hides the shadow when animation is complete<\\/li>\\n<li>Fixed: Devices \\u2014 Border type not present in hover state for video controls<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Removed small space after widget<\\/li>\\n<li>Fixed: Hotspots \\u2014 Syntax error in JS template<\\/li>\\n<li>Fixed: Hotspots \\u2014 JS error when adding new hotpots<\\/li>\\n<li>Fixed: Hotspots \\u2014 Tooltips z-index issue<\\/li>\\n<li>Fixed: Hotspots \\u2014 Bottom tooltips animated down instead of up<\\/li>\\n<li>Fixed: Hotspots \\u2014 Html being added as string when hotspots are triggered through the open_editor hook<\\/li>\\n<li>Fixed: Hotspots \\u2014 Tooltips not editable immediately when dragged into preview<\\/li>\\n<li>Fixed: Image Comparison \\u2014 images are not set to occupy full width<\\/li>\\n<\\/ul>\\n<h4> 0.1.2 <\\/h4>\\n<ul>\\n<li>Added: Hotspots \\u2014 Rewrote code entirely to allow for preview mode support, customisation of tooltips and faster rendering<\\/li>\\n<li>Added: Circle progress \\u2014 Better handling of value suffix<\\/li>\\n<li>Fixed: Scripts dependencies<\\/li>\\n<li>Fixed: Devices \\u2014 Issue where global colors where used instead of skins<\\/li>\\n<li>Fixed: Various compatibility issues with the Elementor color scheme<\\/li>\\n<li>Fixed: Image Gallery Extension \\u2014 Styling issues when choosing to justify gallery items<\\/li>\\n<li>Fixed: Sticky Extension \\u2014 Sitcky offset would not preview correctly and sometimes having multiple sticky widgets would cause interference amongst them<\\/li>\\n<li>Fixed: Parallax Gallery \\u2014 Removed any kinds of transformation for odd children<\\/li>\\n<\\/ul>\\n<h4> 0.1.1 <\\/h4>\\n<ul>\\n<li>Fixed: Buttons groups \\u2014 Responsive alignment of buttons<\\/li>\\n<li>Added: Buttons groups \\u2014 option to stack buttons on tablet or mobile<\\/li>\\n<\\/ul>\\n<h4> 0.1.0 <\\/h4>\\n<ul>\\n<li>Initial Private Beta<\\/li>\\n<\\/ul>\",\"installation\":\"<ol>\\n<li>Make sure Elementor is installed and active on your website<\\/li>\\n<li>Activate the plugin through the \'Plugins\' menu in WordPress<\\/li>\\n<li>Edit a page (or post) using Elementor<\\/li>\\n<li>Find and use the new widgets and extensions<\\/li>\\n<\\/ol>\"},\"banners\":{\"high\":\"https:\\/\\/shop.namogo.com\\/wp-content\\/uploads\\/edd\\/2019\\/09\\/Banner-2.2.png\",\"low\":\"https:\\/\\/shop.namogo.com\\/wp-content\\/uploads\\/edd\\/2019\\/09\\/Banner-2.2@05x.png\"},\"icons\":{\"1x\":\"https:\\/\\/shop.namogo.com\\/wp-content\\/uploads\\/2017\\/08\\/Logo@2x.png\",\"2x\":\"https:\\/\\/shop.namogo.com\\/wp-content\\/uploads\\/2017\\/08\\/Logo@2x.png\"},\"tested\":\"4.9.8\",\"compatibility\":\"a:1:{s:5:\\\"4.9.8\\\";a:1:{s:6:\\\"1.5.21\\\";a:3:{i:0;s:4:\\\"100%\\\";i:1;s:1:\\\"5\\\";i:2;s:1:\\\"5\\\";}}}\",\"stable_tag\":\"2.2.9\",\"license\":\"GPLv3 or later\",\"license_uri\":\"http:\\/\\/www.gnu.org\\/licenses\\/gpl-3.0.html\",\"added\":\"2017-05-31\",\"description\":[\"<p>Elementor Extras is one of the first premium Wordpress plugin for Elementor. It extends its capability with many unique widgets and extensions that make Elementor even more powerful.<\\/p>\\n<h4> Copyright and licensing <\\/h4>\\n<p>Copyright (C) 2016-2019 Elementor Ltd.<\\/p>\\n<p>This program is free software: you can redistribute it and\\/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.<\\/p>\\n<p>This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.<\\/p>\\n<p>You should have received a copy of the GNU General Public License along with this program. If not, see <a href=\\\"https:\\/\\/www.gnu.org\\/licenses\\/\\\">https:\\/\\/www.gnu.org\\/licenses\\/<\\/a>.<\\/p>\\n<h4> Third Party Code <\\/h4>\\n<p>Elementor Extras incorporates code from:<\\/p>\\n<ul>\\n<li><strong>jquery-circle-progress<\\/strong> v1.2.2, Copyright Rostyslav Bryzgunov Licenses: MIT Source: link <a href=\\\"http:\\/\\/kottenator.github.io\\/jquery-circle-progress\\/\\\">http:\\/\\/kottenator.github.io\\/jquery-circle-progress\\/<\\/a><\\/li>\\n<li><strong>jQuery appear plugin<\\/strong> v0.3.6, Copyright 2012 Andrey Sidorov Licenses: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/morr\\/jquery.appear\\/\\\">https:\\/\\/github.com\\/morr\\/jquery.appear\\/<\\/a><\\/li>\\n<li><strong>LongShadow jQuery Plugin<\\/strong> v1.1.0, Copyright 2013 - 2016 Dang Van Thanh Licenses: MIT Source: link git:\\/\\/github.com\\/dangvanthanh\\/jquery.longShadow.git<\\/li>\\n<li><strong>HC-Sticky<\\/strong> v2.2.3, Copyright Some Web Media License: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/somewebmedia\\/hc-sticky\\\">https:\\/\\/github.com\\/somewebmedia\\/hc-sticky<\\/a><\\/li>\\n<li><strong>jQuery Mobile<\\/strong> v1.4.3, Copyright 2010, 2014 jQuery Foundation, Inc. Licenses: jquery.org\\/license<\\/li>\\n<li><strong>jquery-visible<\\/strong>, Copyright 2012, Digital Fusion, License: <a href=\\\"http:\\/\\/teamdf.com\\/jquery-plugins\\/license\\/\\\">http:\\/\\/teamdf.com\\/jquery-plugins\\/license\\/<\\/a> Source: <a href=\\\"http:\\/\\/teamdf.com\\/jquery-plugins\\/license\\/\\\">http:\\/\\/teamdf.com\\/jquery-plugins\\/license\\/<\\/a><\\/li>\\n<li><strong>Parallax Background<\\/strong> v1.2, by Eren Suleymanoglu Licenses: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/erensuleymanoglu\\/parallax-background\\\">https:\\/\\/github.com\\/erensuleymanoglu\\/parallax-background<\\/a><\\/li>\\n<li><strong>TableSorter<\\/strong> v2.0.5b, Copyright 2007 Christian Bach Licenses: Dual licensed under the MIT and GPL licenses Source: link <a href=\\\"http:\\/\\/tablesorter.com\\\">http:\\/\\/tablesorter.com<\\/a><\\/li>\\n<li><strong>Isotope<\\/strong> PACKAGED v3.0.6, Copyright 2017 Metafizzy License: GPLv3 Source: link <a href=\\\"http:\\/\\/isotope.metafizzy.co\\\">http:\\/\\/isotope.metafizzy.co<\\/a><\\/li>\\n<li><strong>Infinite Scroll<\\/strong> PACKAGED v3.0.2, Copyright 2017 Metafizzy License: GPLv3 Source: link <a href=\\\"https:\\/\\/infinite-scroll.com\\\">https:\\/\\/infinite-scroll.com<\\/a><\\/li>\\n<li><strong>Packery layout mode<\\/strong> PACKAGED v2.0.0 Copyright 2017 Metafizzy License: GPLv3 Source: link <a href=\\\"http:\\/\\/isotope.metafizzy.co\\\">http:\\/\\/isotope.metafizzy.co<\\/a><\\/li>\\n<li><strong>javascript-detect-element-resize<\\/strong> v0.5.3 Copyright (c) 2013 Sebasti\\u00e1n D\\u00e9cima License: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/sdecima\\/javascript-detect-element-resize\\\">https:\\/\\/github.com\\/sdecima\\/javascript-detect-element-resize<\\/a><\\/li>\\n<li><strong>tilt.js<\\/strong> 1.2.1, Copyright (c) 2017 Gijs Rog\\u00e9 License: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/gijsroge\\/tilt.js\\\">https:\\/\\/github.com\\/gijsroge\\/tilt.js<\\/a><\\/li>\\n<li><strong>CLNDR<\\/strong> v1.4.7, Copyright Kyle Stetz (github.com\\/kylestetz) License: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/kylestetz\\/CLNDR\\\">https:\\/\\/github.com\\/kylestetz\\/CLNDR<\\/a><\\/li>\\n<li><strong>GMAP3 Plugin for jQuery<\\/strong> v7.2 Copyright DEMONTE Jean-Baptiste License: GPL-3.0+ Source: link <a href=\\\"http:\\/\\/gmap3.net\\\">http:\\/\\/gmap3.net<\\/a><\\/li>\\n<li><strong>Moment.js<\\/strong> v2.22.2 License: MIT Source: link <a href=\\\"https:\\/\\/github.com\\/moment\\/moment\\/\\\">https:\\/\\/github.com\\/moment\\/moment\\/<\\/a><\\/li>\\n<li><strong>Slidebars<\\/strong> v2 Copyright Adam Charles Smith License: MIT <a href=\\\"http:\\/\\/www.adchsm.com\\/slidebars\\/license\\/\\\">http:\\/\\/www.adchsm.com\\/slidebars\\/license\\/<\\/a> Source: link <a href=\\\"http:\\/\\/www.adchsm.com\\/slidebars\\/\\\">http:\\/\\/www.adchsm.com\\/slidebars\\/<\\/a><\\/li>\\n<li><strong>Splittext.js<\\/strong> Copyright (c) 2008-2016, GreenSock<\\/li>\\n<li><strong>Magnific Popup<\\/strong> v1.1.0 License: MIT Copyright 2016 Dmitry Semenov Soruce: link <a href=\\\"http:\\/\\/dimsemenov.com\\/plugins\\/magnific-popup\\/\\\">http:\\/\\/dimsemenov.com\\/plugins\\/magnific-popup\\/<\\/a><\\/li>\\n<\\/ul>\\n<h4> Important Links <\\/h4>\\n<p><a href=\\\"https:\\/\\/shop.namogo.com\\/docs\\/elementor-extras\\/getting-started\\/#update-official\\\">Updating Extras<\\/a>\\n<a href=\\\"https:\\/\\/shop.namogo.com\\/topic\\/elementor-extras\\/\\\">Documentation<\\/a>\\n<a href=\\\"https:\\/\\/shop.namogo.com\\/account\\/\\\">Your Account<\\/a>\\n<a href=\\\"https:\\/\\/shop.namogo.com\\/account\\/support\\/\\\">Support<\\/a>\\n<a href=\\\"https:\\/\\/shop.namogo.com\\/docs\\/elementor-extras\\/frequently-asked-questions\\/\\\">FAQ<\\/a><\\/p>\"],\"changelog\":[\"<h4> 2.2.9 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Align media vertically on horizontal post layouts<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Text separator not displaying<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Default horizontal layout width control to 30<\\/li>\\n<\\/ul>\\n<h4> 2.2.8 <\\/h4>\\n<ul>\\n<li>Added: Breadcrumbs \\u2014 Granular controls for crumbs settings on archive and single pages<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Moved images loaded container selector to ajax response<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Show all filters option not working<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Infinite scroll pagination html output rendering more links than needed<\\/li>\\n<li>Fixed: PHP notice for licensing admin notification<\\/li>\\n<li>Fixed: Switcher \\u2014 Border radius control CSS selector<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Cleanup on pagination html output needed for infinite scroll<\\/li>\\n<\\/ul>\\n<h4> 2.2.7 <\\/h4>\\n<ul>\\n<li>Fixed: Compatibility with third-party plugin<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Edge case bug when calculating anchor position<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Notices<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Overlapping items on infinite scroll when filters active<\\/li>\\n<\\/ul>\\n<h4> 2.2.6 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Global \'elementor_extras\\/widgets\\/posts\\/link\' filter<\\/li>\\n<li>Added: Offcanvas \\u2014 Typography control for content boxes<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Infinite Scroll stopping before all posts load<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Panel background selector<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Page jump when navigating to anchor<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Edge case js error in nouislider script<\\/li>\\n<li>Fixed: Templates Control \\u2014 Restrict global query override for templates inside loops<\\/li>\\n<li>Fixed: Slide Menu \\u2014 Nav menu item classes don\'t work when coming from template control<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Wrong order for hierarchical taxonomies<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Flicker when performing infinite scroll on filtered posts<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Additional padding in some cases below sticky element<\\/li>\\n<li>Fixed: Display Conditions \\u2014 Missing day of week condition<\\/li>\\n<li>Fixed: Hotspots \\u2014 Better handling of icon vertical alignment in css<\\/li>\\n<\\/ul>\\n<h4> 2.2.5 <\\/h4>\\n<ul>\\n<li>Added: Toggle Element \\u2014 Control to hide items without any content<\\/li>\\n<li>Added: Popup \\u2014 Support for usage within Posts Extra custom post skin<\\/li>\\n<li>Added: Audio Player \\u2014 Option to disable preloading of audio files<\\/li>\\n<li>Added: Calendar \\u2014 Search custom fields by field name<\\/li>\\n<li>Added: Offcanvas \\u2014 Options in widgets\' settings to fix page jump issue<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Certain actions not working<\\/li>\\n<li>Fixed: Calendar \\u2014 Pods controls not fetching fields<\\/li>\\n<li>Fixed: Calendar \\u2014 Toolset controls not fetching fields<\\/li>\\n<li>Fixed: Query Control \\u2014 Return only matching queries for pods and toolset<\\/li>\\n<li>Fixed: Calendar \\u2014 Placeholder functionality<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Edge case where css width selectors get overridden by defaults<\\/li>\\n<li>Tweak: Posts Extra \\u2013 Default css order value for parts and areas in frontend css<\\/li>\\n<li>Tweak: Popup \\u2014 Replaced multiple template selection control with single control. IMPORTANT: Settings review required!<\\/li>\\n<li>Tweak: Breadcrumbs \\u2014 Refactor widget code<\\/li>\\n<\\/ul>\\n<h4> 2.2.4 <\\/h4>\\n<ul>\\n<li>Added: Dynamic background image support for custom post skin<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Filter for home breadcrumb link<\\/li>\\n<li>Fixed: Timeline \\u2014 Wrong card content selector for transition control<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Broken selectors after last offcanvas update<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Remove default border around posts<\\/li>\\n<\\/ul>\\n<h4> 2.2.3 <\\/h4>\\n<ul>\\n<li>Added: Offcanvas \\u2014 Compatibility with templates in loops in Posts Extra and other plugins<\\/li>\\n<li>Added: Posts Extra \\u2014 Refresh all widgets scripts on appended infinite scroll items<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Button style gone when placed in linked media area<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Bug when sticky section inside page body within theme builder header template<\\/li>\\n<li>Fixed: Scroll Indicator \\u2014 Tooltips not working with bullets skin<\\/li>\\n<\\/ul>\\n<h4> 2.2.2 <\\/h4>\\n<ul>\\n<li>Fixed: Scroll Indicator \\u2014 Bug when tooltips disabled on bullets skin<\\/li>\\n<li>Fixed: Timeline \\u2014 Option to hide thumbnail not working in posts mode<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Bug with before parent category filters<\\/li>\\n<li>Fixed: Bug with third party elementor addon that enqueue editor scripts on plugin load<\\/li>\\n<li>Fixed: Posts \\u2014 Default metas control to include price for previous saved settings<\\/li>\\n<li>Added: Search Form \\u2014 Compatibility with Relevanssi search results on custom templates with search form id condition<\\/li>\\n<li>Added: Timeline \\u2014 Option to set a dynamic tag instead of date, title and excerpt in posts mode<\\/li>\\n<li>Added: Timeline \\u2014 Option to set HTML element for title in posts mode<\\/li>\\n<li>Added: Posts Extra \\u2014 Filter for the media area link<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to open media and button links in new tab<\\/li>\\n<li>Added: Table \\u2014 WPML translation of header cells text<\\/li>\\n<li>Tweak: Sticky Elements \\u2014 Additional listeners for recalculating sticky<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Less restrictive css selector for the woocommerce add to cart button<\\/li>\\n<\\/ul>\\n<h4> 2.2.1 <\\/h4>\\n<ul>\\n<li>Added: Scroll Indicator \\u2014 Option to offset start and end positions<\\/li>\\n<li>Added: Posts Extra \\u2014 Responsive media width control<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Missing custom field order options<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Avatar meta showing even if removed from metas list<\\/li>\\n<li>Fixed: Display Conditions \\u2014 ACF Choice fails for radio field<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Bug with left aligned media flex width on mobile<\\/li>\\n<\\/ul>\\n<h4> 2.2.0 <\\/h4>\\n<ul>\\n<li>Added: Google Map \\u2014 Route travel mode options<\\/li>\\n<li>Added: Global Tooltips \\u2014 Compatibility with usage inside post skin templates for Posts Extra<\\/li>\\n<li>Added: Global Tooltips \\u2014 z-index control in both element and global settings<\\/li>\\n<li>Added: Display Conditions \\u2014 Term archive condition<\\/li>\\n<li>Added: Display Conditions \\u2014 ACF conditions<\\/li>\\n<li>Added: Display Conditions \\u2014 POST and GET variable conditions<\\/li>\\n<li>Added: Timeline \\u2014 Custom Post Skin via Elementor templates<\\/li>\\n<li>Added: Timeline \\u2014 Replaced default query controls with related query controls<\\/li>\\n<li>Added: Timeline \\u2014 Trim custom excerpt control<\\/li>\\n<li>Added: Timeline \\u2014 Custom post skin<\\/li>\\n<li>Added: Posts Extra \\u2014 Date formatting controls<\\/li>\\n<li>Added: Posts Extra \\u2014 Actions and filters<\\/li>\\n<li>Added: Calendar \\u2014 Actions and filters<\\/li>\\n<li>Added: Devices \\u2014 Actions<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Actions and filters<\\/li>\\n<li>Added: Scroll Indicator \\u2014 Custom html tags for title and subtitle in list skin<\\/li>\\n<li>Added: Custom implementation for Template controls<\\/li>\\n<li>Fixed: Toggle Element \\u2014 Support for slick slider based widgets inside elements<\\/li>\\n<li>Fixed: Switcher \\u2014 Missing image link control<\\/li>\\n<li>Fixed: Timeline \\u2014 Markup improvement to allow for simpler border radius around cards<\\/li>\\n<li>Fixed: Timeline \\u2014 Custom icon replaces global if global is set<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Separator vertical alignment bug<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Icon migration markup issue<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Update elementor nerd box classes<\\/li>\\n<li>Fixed: Posts Extra \\u2014 ACF fields for custom skins used on archive pages<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Wrong access type for _query property<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Price conditions issue for area and editor panel section display<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Author and avatar metas additional controls conditions<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Removed infinite scroll pages loaded limit<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Handle multiple paginations control condition bug<\\/li>\\n<li>Fixed: Scroll Indicator \\u2014 Custom height control condition<\\/li>\\n<li>Fixed: Popup \\u2014 Compatibility with usage inside post skin templates for Posts Extra<\\/li>\\n<li>Fixed: Buttons \\u2014 Flip effect back is hidden during transition<\\/li>\\n<li>Tweak: Breadcrumbs \\u2014 Remove useless icon and icon class filters<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Update button text filters to include \\/posts\\/<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Default taxonomy order for filters<\\/li>\\n<\\/ul>\\n<h4> 2.1.8 <\\/h4>\\n<ul>\\n<li>Fixed: Missing elementor pro active condition<\\/li>\\n<\\/ul>\\n<h4> 2.1.7 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Order posts by custom fields<\\/li>\\n<li>Fixed: Calendar \\u2014 No events fetched when acf date field return format is different that display format<\\/li>\\n<li>Tweak: Better notices and plugin activation prevention for dependencies<\\/li>\\n<\\/ul>\\n<h4> 2.1.6 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Exclude category pages from previous current query fix<\\/li>\\n<li>Fixed: Posts Extra \\u2014 ACF fields for custom post skins used on archive pages<\\/li>\\n<\\/ul>\\n<h4> 2.1.5 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Filter for button link<\\/li>\\n<li>Added: Posts Extra \\u2014 Apply both \'button\' and \'add_to_cart\' filters to button<\\/li>\\n<li>Added: Audio Player \\u2014 Autoplay option<\\/li>\\n<li>Added: Support for new icon library in Elementor 2.6 in all widgets<\\/li>\\n<li>Added: Support for scaling SVG icon library assets when added to widgets<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Option to hide current page<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Template control not fetching results after Elementor Pro 2.6.0 update<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Body order on horizontal posts<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Default query args prevent correct number of results on search templates<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Show all filters initially not working<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Wrong hierarchical taxonomies order when using custom post types<\\/li>\\n<li>Fixed: Calendar \\u2014 Border radius overflow issue<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Progress not showing when shown below<\\/li>\\n<li>Fixed: Timeline \\u2014 Text align on tablet for RTL<\\/li>\\n<li>Fixed: Switcher \\u2014 Remove link image option when using overlay skin<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Edge case where page scrolls up when panel closed on firefox<\\/li>\\n<li>Fixed: Video Player \\u2014 Play button not centered in edge cases<\\/li>\\n<li>Tweak: Search Form \\u2014 Tax query verification<\\/li>\\n<\\/ul>\\n<h4> 2.1.4 <\\/h4>\\n<ul>\\n<li>Fixed: Audio Player \\u2014 External URL not. accepting dynamic tag in URL category<\\/li>\\n<li>Fixed: Video Player \\u2014 External URL not. accepting dynamic tag in URL category<\\/li>\\n<li>Fixed: Search Form \\u2014 Undefined index notice<\\/li>\\n<li>Added: Offcanvas \\u2014 Custom select for the close button<\\/li>\\n<li>Tweak: Offcanvas \\u2014 Separate control sections for title and close settings<\\/li>\\n<\\/ul>\\n<h4> 2.1.3 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Add to cart button alignment<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Pagination links on single templates<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Deprecated certain filters<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added button text filter<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added add to cart text filter<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Changed skin source terminology<\\/li>\\n<li>Tweak: Dissmisable admin licensing notices<\\/li>\\n<\\/ul>\\n<h4> 2.1.2 <\\/h4>\\n<ul>\\n<li>Added: Display Conditions \\u2014 New Term Archive condition<\\/li>\\n<li>Added: Posts Extra \\u2014 Area ordering controls<\\/li>\\n<li>Added: Posts Extra \\u2014 Add to cart button<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to use Elementor templates as custom skin for posts<\\/li>\\n<li>Added: Timeline \\u2014 Separate controls for dates in hover and focused state<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Force square avatar image<\\/li>\\n<li>Fixed: Timeline \\u2014 Remove empty image wrapper when no image exists<\\/li>\\n<li>Fixed: Timeline \\u2014 Hover background color of arrow when focused<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Show price if source is current query<\\/li>\\n<li>Tweak: Timeline \\u2014 Allow Elementor custom image size<\\/li>\\n<li>Tweak: Timeline \\u2014 Responsive color controls<\\/li>\\n<\\/ul>\\n<h4> 2.1.1 <\\/h4>\\n<ul>\\n<li>Added: Tooltips \\u2014 Event for closing the tooltip by clicking anywhere<\\/li>\\n<li>Fixed: Buttons \\u2014 Text align when min width is set<\\/li>\\n<li>Tweak: Scroll Indicator \\u2014 Added options to select progress start and end calculation on scroll for sections<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Moved Infinite Scroll, Pagination and Filters activation controls to their respective sections.<\\/li>\\n<li>Tweak: Licensing \\u2014 Increase remote post request timeout value<\\/li>\\n<\\/ul>\\n<h4> 2.1.0 <\\/h4>\\n<ul>\\n<li>New Widget: Search Form \\u2014 Form widget with restrictions and filters<\\/li>\\n<li>New Widget: Scroll Indicator \\u2014 Create different types of scroll navigation indicators<\\/li>\\n<li>New Feature: Instagram \\u2014 Pull instagram feed to the Gallery widget<\\/li>\\n<li>Added: Posts Extra \\u2014 Vertical carousel<\\/li>\\n<li>Added: Posts Extra \\u2014 New control to select breakpoint for collapsing horizontal post layouts<\\/li>\\n<li>Added: Posts Extra \\u2014 Keep control to define page number limit for infinite scroll<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to not show the &quot;All&quot; filter<\\/li>\\n<li>Added: Posts Extra \\u2014 New control for Slides to Show and deprecated old control [ Settings Review Required ]<\\/li>\\n<li>Added: Posts Extra \\u2014 Exclude taxonomy terms from filters<\\/li>\\n<li>Added: Gallery \\u2014 New spacing control specifically for mixed masonry layout. [ Settings Review Required ]<\\/li>\\n<li>Added: Gallery Slider \\u2014 Control to hide thumbnails<\\/li>\\n<li>Added: Tooltips \\u2014 Mobile event listeners [ Settings Review Required ]<\\/li>\\n<li>Added: Tooltips \\u2014 Responsive triggers and hide events [ Settings Review Required ]<\\/li>\\n<li>Added: Tooltips \\u2014 Separate events for closing the tooltip [ Settings Review Required ]<\\/li>\\n<li>Added: Tooltips \\u2014 New offset control to adjust alignment of arrow tip to target<\\/li>\\n<li>Added: Devices \\u2014 Option for video to cover screen<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Hover colors controls<\\/li>\\n<li>Added: Calendar \\u2014 Disable links to posts<\\/li>\\n<li>Added: Calendar \\u2014 Add nofollow and open in new window on posts source<\\/li>\\n<li>Added: Buttons \\u2014 General padding control<\\/li>\\n<li>Added: Popup \\u2014 Horizontal align for inline trigger and popup close button<\\/li>\\n<li>Added: Notice for license domain mismatch<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Wrong absolute max values<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Infinite scroll loading same posts<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Aligned column breakpoints to elementor default values<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Better override default theme padding on post item<\\/li>\\n<li>Fixed: Timeline \\u2014 CSS bug with overflow<\\/li>\\n<li>Fixed: Timeline \\u2014 Arrow color not working on frontend<\\/li>\\n<li>Fixed: Timeline \\u2014 Invalid code being generated in post css<\\/li>\\n<li>Fixed: Calendar \\u2014 Link target and nofollow<\\/li>\\n<li>Fixed: Devices \\u2014 Video controls conditions<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Conflict with Elementor Pro scrolling effect<\\/li>\\n<li>Fixed: Popup \\u2014 Dynamic css selector for trigger not working<\\/li>\\n<li>Fixed: Calendar \\u2014 Link attributes in compact mode not working<\\/li>\\n<li>Fixed: Google Map \\u2014 Wrong value for default description tag<\\/li>\\n<li>Fixed: Google Map \\u2013 Set overflow to hidden to allow for advanced border radius setting<\\/li>\\n<li>Fixed: Switcher \\u2014 Rename effects section for compatibility with motion effects section name<\\/li>\\n<li>Fixed: Switcher \\u2014 Link to control should not be responsive<\\/li>\\n<li>Fixed: Unfold \\u2014 Bug with closing without focusing<\\/li>\\n<li>Fixed: Random Image \\u2014 Wrong caption<\\/li>\\n<li>Fixed: Display Conditions \\u2014 Check correct condition value<\\/li>\\n<li>Fixed: Toggle Element \\u2014 Text Label align controls<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Safari 12.1 CSS bug<\\/li>\\n<li>Fixed: Gallery \\u2014 Hover effects on mixed layout<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Edge case js error<\\/li>\\n<li>Fixed: Remove duplicate empty template messages from editor panel<\\/li>\\n<li>Fixed: Check license data before mismatch check<\\/li>\\n<li>Fixed: Tooltips \\u2014 Bug with hide event prevent default<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Allow horizontal post layout independent of columns value<\\/li>\\n<li>Tweak: Gallery \\u2014 Better controls conditions<\\/li>\\n<li>Tweak: Gallery \\u2014 Moved settings in their own sections under Content<\\/li>\\n<li>Tweak: Gallery \\u2014 Control conditions<\\/li>\\n<li>Tweak: Gallery \\u2014 Better markup, controls and css optimisation<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Better markup, controls and css optimisation<\\/li>\\n<li>Tweak: Better license management, notifications and performance<\\/li>\\n<li>Tweak: Remove extension default enable for sticky and parallax background<\\/li>\\n<li>Tweak: Remove custom panel alert classes and revert to elementor ones<\\/li>\\n<li>Tweak: Update docs and support links in extras admin pages<\\/li>\\n<li>Tweak: Streamline get_image_caption across all modules to avoid code redundancy<\\/li>\\n<li>Tweak: Toggle Element \\u2014 Better Label alignment controls<\\/li>\\n<li>Tweak: Popup \\u2014 Empty trigger css adjustments<\\/li>\\n<li>Tweak: Admin pages styles<\\/li>\\n<\\/ul>\\n<h4> 2.0.17 <\\/h4>\\n<ul>\\n<li>Added: Timeline \\u2014 Overlay horizontal alignment option<\\/li>\\n<li>Fixed: Timeline \\u2014 Icon showing twice<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Default horizontal alignment to left<\\/li>\\n<\\/ul>\\n<h4> 2.0.16 <\\/h4>\\n<ul>\\n<li>Fixed: Include admin script only on extras pages<\\/li>\\n<li>Fixed: Posts Extra \\u2014 RTL margins and arrows<\\/li>\\n<li>Fixed: Calendar \\u2014 RTL arrows<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Override current query posts per page with control setting<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Carousel style section condition<\\/li>\\n<li>Added: Text Divider \\u2014 Control for alignment of text<\\/li>\\n<li>Added: Unfold \\u2014 Columns settings for content<\\/li>\\n<li>Added: Timeline \\u2014 New alignment controls to allow selecting layouts per breakpoint<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to align posts horizontally<\\/li>\\n<li>Tweak: Admin settings RTL<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Responsive alignment controls<\\/li>\\n<li>Tweak: Timeline \\u2014 Responsive defaults for alignment controls<\\/li>\\n<\\/ul>\\n<h4> 2.0.15 <\\/h4>\\n<ul>\\n<li>IMPORTANT: This version requires Elementor 2.5 or above<\\/li>\\n<li>IMPORTANT: If you have Elementor Pro, this version requires version 2.5 or above<\\/li>\\n<li>Added: Posts Extra \\u2014 Elementor Pro new related posts module with include \\/ exclude and date range<\\/li>\\n<li>Added: Circle Progress \\u2014 Option to turn off animation<\\/li>\\n<li>Added: Display Conditions \\u2014 Day of week condition<\\/li>\\n<li>Added: Video Player &amp; Devices \\u2014 Option to not hide bar when video is playing<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Unstick for 768px wide tablets<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Compatibility with Elementor Pro 2.5<\\/li>\\n<li>Fixed: Timeline \\u2014 Compatibility with Elementor Pro 2.5<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Adjust on resize in editor<\\/li>\\n<li>Fixed: Calendar \\u2014 Query compatibility with WPML<\\/li>\\n<li>Fixed: Hotspots \\u2014 Check spaces in hotspot links<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Edge case where images don\'t display entirely<\\/li>\\n<li>Fixed: Timeline \\u2014 Correctly render dynamic tags<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Isotope on loading more posts when filter active<\\/li>\\n<li>Tweak: Video Player \\u2014 Automatically hide bar on mobile when playing<\\/li>\\n<\\/ul>\\n<h4> 2.0.14 <\\/h4>\\n<ul>\\n<li>Added: Toggle Element \\u2014 Option to select which item is active by default<\\/li>\\n<li>Fixed: Table \\u2014 Restrict cell max-width to msie<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Wrong arranging in some cases<\\/li>\\n<li>Fixed: Media Player text indicators wrapping<\\/li>\\n<\\/ul>\\n<h4> 2.0.13 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Carousel js error<\\/li>\\n<\\/ul>\\n<h4> 2.0.12 <\\/h4>\\n<ul>\\n<li>Added: Unfold \\u2014 Options to keep focus on content when folding or unfolding<\\/li>\\n<li>Fixed: Toggle Element \\u2014 Make sure Gallery Extra is initiated when toggling<\\/li>\\n<li>Fixed: Table \\u2014 Min-width breakpoint bug<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Compatibility with Elementor 2.5<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Z-index issues for panel<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Allow scroll on page not working<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Rare selector for anchors with link issue<\\/li>\\n<li>Fixed: Hotspots \\u2014 Rename css pulse animation<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Editor defaultView error<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Adjust breakpoint values<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Fallback to default wp posts per page option<\\/li>\\n<li>Tweak: Offcanvas \\u2014 Make sure html element has auto height<\\/li>\\n<li>Tweak: Better wpml classes check<\\/li>\\n<\\/ul>\\n<h4> 2.0.11 <\\/h4>\\n<ul>\\n<li>Fixed: Offcanvas \\u2014 Trigger not closing after open<\\/li>\\n<li>Fixed: Posts \\u2014 Grid overlapping on safari when infinite scroll is enabled<\\/li>\\n<li>Fixed: Table \\u2014 Restrict IE hack to tablet and up<\\/li>\\n<li>Fixed: Get element settings on frontend in edit mode<\\/li>\\n<li>Fixed: Google Map \\u2014 Require resize plugin<\\/li>\\n<li>Added: Posts Extra \\u2014 Button border controls<\\/li>\\n<\\/ul>\\n<h4> 2.0.10 <\\/h4>\\n<ul>\\n<li>Added: Parallax Elements \\u2014 Option to allow moving elements when they aren\'t visible inside viewport<\\/li>\\n<li>Fixed: Google Map \\u2014 Centering with dynamic tags not working<\\/li>\\n<li>Fixed: Calendar \\u2014 Don\'t limit number of posts fetched<\\/li>\\n<li>Fixed: Display Conditions \\u2014 Chrome check failing<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Responsive item aligning<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Custom size control compatibility + tweaks<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Type control condition<\\/li>\\n<li>Tweak: Google Map \\u2014 Disable fitting and centering when route is enabled<\\/li>\\n<\\/ul>\\n<h4> 2.0.9 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Handle multiple paginated loops<\\/li>\\n<li>Added: Posts Extra \\u2014 Nothing found message<\\/li>\\n<li>Added: Image Comparison \\u2014 Option to turn off animation on entrance<\\/li>\\n<li>Added: Posts Extra \\u2014 Query ID filter on top of elementor pro one<\\/li>\\n<li>Added: Offcanvas \\u2014 Control to enable page scroll when offcanvas panel is open<\\/li>\\n<li>Fixed: Table \\u2014 IE cell text wrapping<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Wrong absolute value when multiple widget instances on same page<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Wrong thumbnail order<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Z-index issues<\\/li>\\n<li>Fixed: Calendar \\u2014 Convert timestamp to integer<\\/li>\\n<li>Fixed: Gallery module attachment check<\\/li>\\n<li>Tweak: Timeline \\u2014 Rename timeline script<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Responsive row spacing control<\\/li>\\n<li>Tweak: Parallax Background \\u2014 Compatibility with Elementor 2.4<\\/li>\\n<\\/ul>\\n<h4> 2.0.8 <\\/h4>\\n<ul>\\n<li>Fixed: Text Divider \\u2014 Selector for link color<\\/li>\\n<li>Fixed: Timeline \\u2014 Notice<\\/li>\\n<li>Fixed: Offcanvas \\u2014 Escape jquery expression<\\/li>\\n<li>Fixed: Google Map \\u2014 Handle invalid or undefined snazzy map style<\\/li>\\n<\\/ul>\\n<h4> 2.0.7 <\\/h4>\\n<ul>\\n<li>Fixed: Offcanvas \\u2014 Anchor navigation scroll calculation<\\/li>\\n<li>Added: Timeline \\u2014 Allow post content to be shown instead of excerpt<\\/li>\\n<li>Added: Timeline \\u2014 Control to set line progress position relative to viewport<\\/li>\\n<li>Tweak: Offcanvas \\u2014 Anchor condition<\\/li>\\n<\\/ul>\\n<h4> 2.0.6 <\\/h4>\\n<ul>\\n<li>Fixed: Popup \\u2014 Duplicate tab control name<\\/li>\\n<li>Fixed: Popup \\u2014 Remove rtl suffix<\\/li>\\n<li>Added: Offcanvas \\u2014 Global control for offcanvas container background color<\\/li>\\n<\\/ul>\\n<h4> 2.0.5 <\\/h4>\\n<ul>\\n<li>Added: Editor panel labels for widgets<\\/li>\\n<li>Added: Calendar \\u2014 Control to customise month names<\\/li>\\n<li>Added: Offcanvas \\u2014 Link navigate to anchors on page<\\/li>\\n<li>Added: Popup \\u2014 Text trigger styling controls<\\/li>\\n<li>Fixed: Inline SVG \\u2014 Multiple svgs have same settings<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 No parent custom taxonomy terms render all terms<\\/li>\\n<li>Fixed: Posts Extra \\u2014 PHP notice<\\/li>\\n<li>Tweak: Updated language file<\\/li>\\n<\\/ul>\\n<h4> 2.0.4 <\\/h4>\\n<ul>\\n<li>Fixed: Display Conditions \\u2014 Editor section for sections actions<\\/li>\\n<li>Fixed: Display Conditions \\u2014 Conditions evaluation per element<\\/li>\\n<\\/ul>\\n<h4> 2.0.3 <\\/h4>\\n<ul>\\n<li>Fixed: Popup Display Conditions \\u2014 Check widget visibility before opening automatically<\\/li>\\n<li>Fixed: Table \\u2014 First row has no classes<\\/li>\\n<li>Fixed: Google Map \\u2014 Handle no snazzy maps selection<\\/li>\\n<li>Fixed: Display Conditions \\u2014 Wrong default keys resulting in wrong display<\\/li>\\n<li>Fixed: Audio Player \\u2014 Border type selector<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Position structured data property<\\/li>\\n<li>Fixed: Parallax Element \\u2014 Parallax column affecting child columns<\\/li>\\n<li>Fixed: Devices \\u2014 Image extending outside the widget area<\\/li>\\n<li>Fixed: Popup \\u2014 Move font family to pseudo-element<\\/li>\\n<li>Fixed: Slide Menu \\u2014 Sub-menu links not working with link navigation turned on<\\/li>\\n<li>Tweak: Rename infinite-scroll script<\\/li>\\n<li>Tweak: Breadcrumbs \\u2014 Increase typography selector specificity<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Additional conditions for areas style sections<\\/li>\\n<li>Remove widget disabling admin notif<\\/li>\\n<li>Update Wordpress stable tag to 5.0.0<\\/li>\\n<\\/ul>\\n<h4> 2.0.2 <\\/h4>\\n<ul>\\n<li>Added: New Query Control<\\/li>\\n<li>Added: Display Conditions \\u2014 Ajax powered fields<\\/li>\\n<li>Added: Display Conditions \\u2014 Current post condition<\\/li>\\n<li>Fixed: Switcher \\u2013 Autoplay not working without entrance animation<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Custom taxonomy archive crumbs<\\/li>\\n<li>Tweak: Audio Player \\u2014 Added option for external sources<\\/li>\\n<\\/ul>\\n<h4> 2.0.1 <\\/h4>\\n<ul>\\n<li>Fixed: Google Map \\u2014 Navigation z-index<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Default button position to hidden<\\/li>\\n<li>Fixed: Devices \\u2014 Video in window frame not displaying<\\/li>\\n<li>Fixed: Google Map \\u2014 JSON incorrectly reported as invalid<\\/li>\\n<li>Fixed: Switcher \\u2014 Cover picture tag with CSS<\\/li>\\n<li>Fixed: Devices \\u2014 Video css for browser frame<\\/li>\\n<li>Added: Posts Extra \\u2014 Infinite load button transition control<\\/li>\\n<li>Added: Posts Extra \\u2014 Infinite load button border control<\\/li>\\n<li>Added: Hotspots \\u2014 Individual hover controls for each hotspot<\\/li>\\n<li>Added: Audio Player \\u2014 Option to loop playlist<\\/li>\\n<li>Tweak: Google Map \\u2014 Make fields dynamic<\\/li>\\n<li>Tweak: Audio Player \\u2014 Added custom js events<\\/li>\\n<li>Tweak: Audio Player \\u2014 Separate control for play icon size<\\/li>\\n<li>Tweak: Video Player \\u2014 Added custom js events<\\/li>\\n<\\/ul>\\n<h4> 2.0.0 <\\/h4>\\n<ul>\\n<li>New Extension: Display Conditions<\\/li>\\n<li>New Widget: Google Map<\\/li>\\n<li>New Widget: Popup<\\/li>\\n<li>New Widget: Age Gate<\\/li>\\n<li>New Widget: Toggle Element<\\/li>\\n<li>New Widget: Calendar<\\/li>\\n<li>New Widget: Audio Player<\\/li>\\n<li>New Widget: Offcanvas<\\/li>\\n<li>New Widget: Slide Menu<\\/li>\\n<li>New Widget: Random Image<\\/li>\\n<li>Added: Posts Extra \\u2014 Support for terms from multiple taxonomies<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Include blog posts page in breadcrumbs<\\/li>\\n<li>Added: Switcher \\u2014 New option to add description<\\/li>\\n<li>Added: Sticky Elements \\u2014 Completely rewritten code<\\/li>\\n<li>Added: Sticky Elements \\u2014 Offset bottom control<\\/li>\\n<li>Added: Global Tooltips \\u2014 Control to disable on breakpoint<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Option to show taxonomy terms for custom post types instead of CPT name<\\/li>\\n<li>Added: Tooltips \\u2014 New trigger on page load<\\/li>\\n<li>Added: Switcher \\u2014 Events to update when inside toggle element<\\/li>\\n<li>Added: Posts Extra \\u2014 Price meta for woocommerce products<\\/li>\\n<li>Added: Posts Extra \\u2014 Button content part replaces read more<\\/li>\\n<li>Added: Posts Extra \\u2014 Post count for filters<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Schema.org properties<\\/li>\\n<li>Fixed: Tooltips \\u2014 Add option to disable on breakpoint<\\/li>\\n<li>Fixed: Global Tooltips \\u2014 Destroy on editor mode<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Out of view sections have wrong background image positions<\\/li>\\n<li>Fixed: Global Tooltips \\u2014 Settings not being saved<\\/li>\\n<li>Fixed: Parallax Element \\u2014 Start position option not applying<\\/li>\\n<li>Fixed: Hotspots \\u2014 Image display block<\\/li>\\n<li>Fixed: Unfold \\u2014 Button alignment<\\/li>\\n<li>Fixed: Unfold \\u2014 Button icon position and indent<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Check for woocommerce for price fields<\\/li>\\n<li>Fixed: Video Player \\u2014 Volume size undefined error<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 RTL behviour on clicking thumbs<\\/li>\\n<li>Fixed: Inline SVG \\u2014 ACF image field<\\/li>\\n<li>Fixed: Update to getEditModel method<\\/li>\\n<li>Fixed: Compatibility with Elementor 2.3.0<\\/li>\\n<li>Fixed: License not deactivating if expired<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Distance for top-aligned labels<\\/li>\\n<li>Fixed: Devices + Hotspots \\u2014 Compatibility with Elementor 2.3.0<\\/li>\\n<li>Fixed: Switcher \\u2014 Astra theme images css conflict<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Multiple hierarchical categories not showing<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Filtered posts not found message<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Wrong grid item width when filters are active and multiple instances on page<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Controls conditions<\\/li>\\n<li>Fixed: Breacrumbs \\u2014 Wrap crumbs automatically<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Hide fields not available for Current Query option<\\/li>\\n<li>Tweak: Hotspots \\u2014 Default hotspots for better ux<\\/li>\\n<li>Tweak: Video Player + Devices \\u2014 Better behaviour and interactions for video player<\\/li>\\n<li>Tweak: Video Player + Devices \\u2014 Better selection of video source files<\\/li>\\n<li>Tweak: Video Player + Devices \\u2014 Added playback speed option<\\/li>\\n<li>Tweak: Timeline \\u2014 Support for point numbers and letter for posts<\\/li>\\n<li>Tweak: Table \\u2014 Remove render template to improve editing performance<\\/li>\\n<li>Tweak: Buttons \\u2014 Add bottom margin to custom spacing control<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Increase options for carousel rows and slides to scroll<\\/li>\\n<li>Tweak: Enable docs link in admin settings page<\\/li>\\n<li>Tweak: Switcher \\u2014 Make description field dynamic<\\/li>\\n<li>Tweak: Google Maps \\u2013 Adjust controls structure<\\/li>\\n<li>Tweak: Table \\u2014 Control names<\\/li>\\n<li>Tweak: Text Divider \\u2014 Controls position<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added read more to translatable fields for WPML<\\/li>\\n<\\/ul>\\n<h4> 1.9.16 <\\/h4>\\n<ul>\\n<li>Fixed: Elementor 2.3.0 compatibility<\\/li>\\n<\\/ul>\\n<h4> 1.9.15 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Load more button for multiple widget instances<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Responsive speed options<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Columns above 9 don\'t become full width<\\/li>\\n<li>Tweak: Improve Elementor Pro version dependency and posts widget compatibility<\\/li>\\n<li>Tweak: Timeline \\u2014 Enable dynamic fields for custom source<\\/li>\\n<li>Tweak: Circle Progress \\u2014 Handling of divisions operation in value control<\\/li>\\n<li>Tweak: Circle Progress \\u2014 Option to allow numbers with decimals instead of percetanges<\\/li>\\n<li>Tweak: Circle Progress \\u2014 Options to allow for absolute values to be shown<\\/li>\\n<li>Tweak: Hotspots \\u2014 Make hotspots size and opacity control responsive<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Remove swiper slide overflow hidden<\\/li>\\n<li>Tweak: Added option to enable updates to beta versions or Extras<\\/li>\\n<\\/ul>\\n<h4> 1.9.14 <\\/h4>\\n<ul>\\n<li>Fixed: Rename resize script to avoid potential conflicts<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Carousel flickering when used in Tabs widget and switching tabs<\\/li>\\n<li>Fixed: Timeline \\u2014 Date showing current date instead of post date<\\/li>\\n<li>Fixed: Extras admin page conflict with Jetpack<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Link not accessible for preview images with caption<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added query id control for server side filtering of widget queries<\\/li>\\n<li>Tweak: Hotspots \\u2014 HTML valid structure issue<\\/li>\\n<li>Tweak: Table \\u2014 Minor terminology improvements<\\/li>\\n<\\/ul>\\n<h4> 1.9.13 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Infinite scroll loading same posts<\\/li>\\n<li>Fixed: Inline SVG \\u2014 Space under image<\\/li>\\n<li>Fixed: Extensions not showing when Elementor Pro not active<\\/li>\\n<\\/ul>\\n<h4> 1.9.12 <\\/h4>\\n<ul>\\n<li>Added: CSS filter controls for widgets<\\/li>\\n<li>Added: Global Tooltips \\u2014 Support for shortcodes and dynamic fields<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Load more button causing error when not paginated<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Content inside media not showing when no thumbnail available<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Media area display conditions<\\/li>\\n<li>Fixed: Posts Extra \\u2014 PHP warning when excerpt length is empty<\\/li>\\n<li>Fixed: Posts Extra \\u2014 RTL alignment of posts in masonry mode<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Default control value to string<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Dynamic fields values not working<\\/li>\\n<li>Fixed: Parallax Elements \\u2014 Window height calculation<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Repeater fields conditions<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Breaks when dynamic field is used<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Allow offset to be used in current query<\\/li>\\n<li>Tweak: Timeline \\u2014 Allow drafts and scheduled posts to be included<\\/li>\\n<\\/ul>\\n<h4> 1.9.11 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Sticky posts compatibility with pagination<\\/li>\\n<li>Fixed: Compatibility with new Swiper version in Elementor 2.1<\\/li>\\n<li>Tweak: Timeline \\u2014 Responsive date padding and margin controls<\\/li>\\n<\\/ul>\\n<h4> 1.9.10 <\\/h4>\\n<ul>\\n<li>Fixed: Sticky Elements \\u2014 Options appear twice<\\/li>\\n<li>Tweak: Remove group control sticky<\\/li>\\n<\\/ul>\\n<h4> 1.9.9 <\\/h4>\\n<ul>\\n<li>Fixed: Timeline \\u2014 Points and line not aligned on mobile and tablet if size defined only on desktop<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Default placeholder image overriding post thumbnail<\\/li>\\n<li>Fixed: Sticky Elements no longer working<\\/li>\\n<li>Fixed: Additional check for active Elementor Pro<\\/li>\\n<li>Tweak: Moved Extras advanced section behind Custom CSS section<\\/li>\\n<\\/ul>\\n<h4> 1.9.8 <\\/h4>\\n<ul>\\n<li>Added: Gallery Slider \\u2014 Arrows controls for preview<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to show all filters when using infinite scroll<\\/li>\\n<li>Fixed: Unfold \\u2014 Icon right align not working<\\/li>\\n<li>Fixed: Compatibility with Elementor 2.1 beta<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Allow excerpt in media area<\\/li>\\n<li>Tweak: Timeline \\u2014 More specific color selectors<\\/li>\\n<li>Tweak: Timeline \\u2014 Text align dates to the right for right hand items<\\/li>\\n<\\/ul>\\n<h4> 1.9.7 <\\/h4>\\n<ul>\\n<li>Fixed: Gallery Extra \\u2014 Implemented work-around for warning caused by Elementor bug<\\/li>\\n<li>Fixed: Posts Extra \\u2014 IE 10 images bug<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Time not showing<\\/li>\\n<li>Fixed: Buttons \\u2014 Wrap buttons by default<\\/li>\\n<li>Fixed: Remove too broad css declaration<\\/li>\\n<li>Fixed: Parallax background \\u2014 Correct element resize function name<\\/li>\\n<\\/ul>\\n<h4> 1.9.6 <\\/h4>\\n<ul>\\n<li>Fixed: Parallax Elements \\u2014 Breaks if pan distance is undefined<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Read more typography control conditions<\\/li>\\n<li>Fixed: Unfold \\u2014 Force icon to show hide as inline block<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Stretch body to align all footers to bottom<\\/li>\\n<li>Fixed: Posts Extra \\u2014 IE 10 horizontal layout for posts<\\/li>\\n<li>Fixed: Renamed jquery resize plugin function<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 CSS overflow fix<\\/li>\\n<\\/ul>\\n<h4> 1.9.5 <\\/h4>\\n<ul>\\n<li>Added: Dynamic fields support for all widgets<\\/li>\\n<li>Fixed: Global Tooltips \\u2014 Position not being overriden<\\/li>\\n<li>Fixed: Timeline \\u2014 Pointer cursor not showing on linked cards<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Image bottom spacing on some themes<\\/li>\\n<li>Tweak: Gallery Extra \\u2014 Added unique classes to each item<\\/li>\\n<li>Tweak: HTML5 Video \\u2014 Added control to enable muted video for autoplay<\\/li>\\n<li>Tweak: HTML5 Video \\u2014 Added controls to enable or disable all elements inside the bar<\\/li>\\n<\\/ul>\\n<h4> 1.9.4 <\\/h4>\\n<ul>\\n<li>Added: Timeline \\u2014 Control to center images<\\/li>\\n<li>Added: Posts Extra \\u2014 New filters for post title, excerpt, comments and date<\\/li>\\n<li>Added: HTML5 Video \\u2014 Control to stop all other video players when current one is played.<\\/li>\\n<li>Fixed: Fixed: Column widths in post-css are rendered in the wrong order<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Posts per page doesn\'t take into account sticky posts<\\/li>\\n<li>Fixed: Buttons \\u2014 Item typography group control not working<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Responsive horizontal alignment for filters<\\/li>\\n<li>Fixed: Hotspots \\u2014 Tooltip position not being overriden at hotspot level<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Control conditions<\\/li>\\n<li>Tweak: Updated isotope version to 3.0.6 to fix 1px grid gap<\\/li>\\n<li>Tweak: Remove default webkit left padding from list navs<\\/li>\\n<li>Tweak: Parallax Background \\u2014 Increase plugin timeout reinit<\\/li>\\n<li>Tweak: Posts \\u2014 Increase excerpt length filter priority<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added option to show only sticky posts<\\/li>\\n<\\/ul>\\n<h4> 1.9.3 <\\/h4>\\n<ul>\\n<li>Added: Sticky Elements \\u2014 Compatibility with the Lazy Loader wordpress plugin<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Safari &lt; 10.2 layout glitch layout glitch on mobile<\\/li>\\n<li>Fixed: HTML5 Video \\u2014 m4v files condition<\\/li>\\n<li>Fixed: Sticky \\u2014 Sticks only when resizing browser window<\\/li>\\n<li>Fixed: Sticky \\u2014 Not working correctly with Stretched parent<\\/li>\\n<li>Fixed: HTML5 Video \\u2014 m4v format not sufficient<\\/li>\\n<li>Fixed: Image Comparison \\u2013 Allow 0 percent values<\\/li>\\n<li>Tweak: HTML5 Video \\u2014 Render attributes<\\/li>\\n<li>Tweak: HTML5 Video \\u2014 Control conditions<\\/li>\\n<\\/ul>\\n<h4> 1.9.2 <\\/h4>\\n<ul>\\n<li>Fixed: Switcher \\u2014 Bug with arrow loader position and stroke width in older versions of Safari<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Compatibility with IE 11<\\/li>\\n<li>Fixed: Parallax Elements \\u2014 Control value undefined check<\\/li>\\n<\\/ul>\\n<h4> 1.9.1 <\\/h4>\\n<ul>\\n<li>Fixed: Parallax Elements \\u2014 Max distance not taking into account scroll position<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Filters not stacking on responsive.<\\/li>\\n<li>Fixed: Switcher \\u2014 Arrow loader not displaying in firefox<\\/li>\\n<li>Fixed: Parallax Elements \\u2014 Wrong position for scroll with start position<\\/li>\\n<li>Fixed: GSAP dependencies<\\/li>\\n<\\/ul>\\n<h4> 1.9.0 <\\/h4>\\n<ul>\\n<li>Added: New Switcher Widget! \\u2014 Switch photos and text using powerful javascript driven transitions. Features menu and arrows navigation, autoplay with progress loader, entrance animations, page background color switcher, two skins (default and overlay) and much more.<\\/li>\\n<li>Added: New Feature for Parallax Elements! \\u2014 Option to parallax columns and widgets on mouse move<\\/li>\\n<li>Added: Posts Extra \\u2014 Controls to style only sticky posts<\\/li>\\n<li>Added: Image Comparison \\u2014 Option to enable clicking on labels to uncover images<\\/li>\\n<li>Added: Hotspots \\u2014 Separate color controls for each hotspot<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Sticky posts not working when a category is selected in the query<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Invisible gallery when preview position is top on desktop<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Remove labels if no text is present<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Hide carousel until properly rendered<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Added alt and title tags to image element<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Issue with negative margin resulting in right whitespace for the gallery<\\/li>\\n<li>Fixed: Timeline \\u2014 Controls conditions<\\/li>\\n<li>Fixed: Timeline \\u2014 Item point color override<\\/li>\\n<li>Fixed: Timeline \\u2014 Properly override point content<\\/li>\\n<li>Tweak: Parallax Elements \\u2014 Removed group control<\\/li>\\n<li>Tweak: Gallery Extra, Gallery Slider, Posts Extra \\u2014 Added notice with link to blend mode browser support for blend mode controls<\\/li>\\n<li>Tweak: Timeline \\u2014 Added repeater setting key method to card render function<\\/li>\\n<\\/ul>\\n<h4> 1.8.8 <\\/h4>\\n<ul>\\n<li>Added: Gallery Extra \\u2014 Control width and ratio of each individual image in manual mode<\\/li>\\n<li>Added: Timeline \\u2014 Option for automatic numbering and letters instead of icons to points<\\/li>\\n<li>Added: Timeline \\u2014 New control to set excerpt length<\\/li>\\n<li>Added: Unfold \\u2014 Option to change icon when unfolded<\\/li>\\n<li>Added: Sticky Elements \\u2014 Option to turn off bottoming of elements inside the parent<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to enable sticky posts in query<\\/li>\\n<li>Added: Posts Extra \\u2014 Arrows sizing controls<\\/li>\\n<li>Added: Posts Extra \\u2014 Transition control for carousel arrows and pagination<\\/li>\\n<li>Added: Posts Extra \\u2014 Option to set how many slides to scroll<\\/li>\\n<li>Added: Image Comparison \\u2014 Control to define initial position of separator<\\/li>\\n<li>Added: Image Comparison \\u2014 Option to enable moving separator by clicking anywhere on the image<\\/li>\\n<li>Added: Buttons \\u2014 Control for label min width<\\/li>\\n<li>Added: Hotspots \\u2014 Control to disable pulsating animation<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Controls not showing on inner sections<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Images wider than 100% on mobile in manual mixed masonry layout mode<\\/li>\\n<li>Fixed: HTML5 Video \\u2014 CSS bottom whitespace<\\/li>\\n<li>Fixed: Buttons \\u2014 Remove block label for buttons icon, id and class controls<\\/li>\\n<li>Tweak: Timeline \\u2014 Take sticky posts into consideration in query<\\/li>\\n<li>Tweak: Unfold \\u2014 Organise controls<\\/li>\\n<li>Tweak: WPML Compatibility \\u2014 Change method to fix fields not saving<\\/li>\\n<\\/ul>\\n<h4> 1.8.7 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Filtering one widget\'s posts affects all other widgets<\\/li>\\n<li>Fixed: Hotspots \\u2014 Tooltips have an extra space at the bottom when first hovering<\\/li>\\n<li>Fixed: HTML5 Video \\u2014 Volume functionality breaks when controls are hidden<\\/li>\\n<li>Fixed: HTML5 Video \\u2014 Video reloading after each loop<\\/li>\\n<li>Added: Global Tooltips \\u2014 Global controls for distance and width<\\/li>\\n<li>Tweak: HTML5 Video \\u2014 Added width and horizontal alignment control to player<\\/li>\\n<li>Tweak: Global Tooltips \\u2014 Remove default global styling values after Elementor enqueue fix in 1.9.5<\\/li>\\n<\\/ul>\\n<h4> 1.8.6 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Term slug classes to filters and post terms<\\/li>\\n<li>Fixed: Replaced create_function with anonymous function for PHP 7.2 support<\\/li>\\n<li>Fixed: Inline SVG \\u2014 Handle internal CSS in non color overriding situations<\\/li>\\n<li>Fixed: Hotspots \\u2014 Tooltips showing even if they have no content<\\/li>\\n<li>Tweak: Sticky Elements \\u2014 Prevent sticky on a section that is stretched with js<\\/li>\\n<li>Tweak: Buttons \\u2014 Move typography control above tabs<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Move hover animation controls to separate section for better ux<\\/li>\\n<li>Tweak: Gallery Extra \\u2014 Moved hover controls to separate section<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Moved hover controls to separate section<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Default font size for thumbnail captions<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Fix condition<\\/li>\\n<li>Tweak: Hotspots \\u2014 Show label for tooltip content in editor<\\/li>\\n<\\/ul>\\n<h4> 1.8.5 <\\/h4>\\n<ul>\\n<li>Fixed: Gallery Extra \\u2014 Missing js dependency<\\/li>\\n<\\/ul>\\n<h4> 1.8.4 <\\/h4>\\n<ul>\\n<li>Fixed: Gallery Extra \\u2014 Random ordering not working<\\/li>\\n<li>Fixed: Timeline \\u2014 RTL optimisation<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Custom image size not working on manual mode<\\/li>\\n<li>Tweak: Add dismissible notice for recommended php version<\\/li>\\n<li>Tweak: Gallery Extra \\u2014 Add title and description caption types<\\/li>\\n<li>Tweak: Timeline \\u2014 Add link control description to avoid linking cards when content already contains links<\\/li>\\n<\\/ul>\\n<h4> 1.8.3 <\\/h4>\\n<ul>\\n<li>Fixed: HTML5 Video \\u2014 Video not playing on Safari and some mobile environments<\\/li>\\n<li>Fixed: Buttons \\u2014 Safari buttons vertical alignment<\\/li>\\n<li>Fixed: Devices \\u2014 device not displaying on Safari when portrait mode is enabled<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Grid broken on Safari<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 reinit masonry when images done loading<\\/li>\\n<li>Tweak: Move all Extras admin settings into Elementor menu<\\/li>\\n<li>Tweak: Image Comparison \\u2014 Remove default value for width control<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 default mobile and tablet gallery columns to larger numbers<\\/li>\\n<\\/ul>\\n<h4> 1.8.2 <\\/h4>\\n<ul>\\n<li>Added: Parallax Background \\u2014 Support for section resize in elementor preview mode<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Compatibility with stretched section<\\/li>\\n<li>Fixed: HTML5 Video \\u2014 Interface style controls conditions<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Right side white-space after thumbnails on top preview position<\\/li>\\n<li>Fixed: Unfold \\u2014 Page stops responding when entering invalid html in text editor mode<\\/li>\\n<li>Tweak: Unfold \\u2014 Allow accordions, tabs and all resizing elements inside content<\\/li>\\n<\\/ul>\\n<h4> 1.8.1 <\\/h4>\\n<ul>\\n<li>Fixed: Posts Extra \\u2014 Masonry broken when infinite scroll is enabled<\\/li>\\n<\\/ul>\\n<h4> 1.8.0 <\\/h4>\\n<ul>\\n<li>New extension: Global Tooltips \\u2014 Add a tooltip to any widget<\\/li>\\n<li>New: Disable Widgets &amp; Extensions \\u2014 You can now disable Extras widgets and extensions via the admin settings page<\\/li>\\n<li>Added: WPML compatibility \\u2014 String Translation and Translation Editor support for all widgets<\\/li>\\n<li>Added: Circle Progress \\u2014 Icon support inside circle<\\/li>\\n<li>Added: Update .pot translation file<\\/li>\\n<li>Added: Buttons \\u2014 Tooltips duration control<\\/li>\\n<li>Added: Global settings for Extras tooltips<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Widget not available on multisite installations<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Infinite scroll breaks when using multiple widgets on same page<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Conflict with Anywhere Elementor Pro featured image background<\\/li>\\n<li>Tweak: Parallax Background \\u2014 requestAnimationFrame method for better performance<\\/li>\\n<li>Tweak: Buttons \\u2014 Rename text align label<\\/li>\\n<li>Tweak: Update nicons font<\\/li>\\n<\\/ul>\\n<h4> 1.7.4 <\\/h4>\\n<ul>\\n<li>Fixed: Gallery Extra \\u2014 Custom link broken and attributes not added<\\/li>\\n<\\/ul>\\n<h4> 1.7.3 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Column vertical alignment controls for carousel<\\/li>\\n<li>Added: Timeline \\u2014  Color controls for post title and excerpt<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Carousel rows number control not impacting preview<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Avatar vertical alignment on stretched media content<\\/li>\\n<li>Fixed: Sticky Elements \\u2014 Incorrect spacer height<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Improve editing flow by with advanced controls conditioning<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Controls position<\\/li>\\n<li>Tweak: Sticky Elements \\u2014 Remove popover from group control<\\/li>\\n<li>Tweak: Parallax Elements \\u2014 Remove popover from group control<\\/li>\\n<\\/ul>\\n<h4> 1.7.2 <\\/h4>\\n<ul>\\n<li>Added: Gallery Slider \\u2014 Overlay captions for preview and thumbnails<\\/li>\\n<li>Added: Gallery Slider \\u2014 Controls for caption effects, layout and hover properties<\\/li>\\n<li>Added: Gallery Slider \\u2014 Controls for active thumbs caption<\\/li>\\n<li>Fixed: Buttons \\u2014 Removed popover control on effects<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Improved carousel adapt on preview resize<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Improved thumbnails grid<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Better controls for stacking and position of preview<\\/li>\\n<li>Tweak: Gallery Slider \\u2014 Replace background color with background control for preview captions and overlay<\\/li>\\n<li>Tweak: Gallery Slider + Gallery Extra \\u2014 Better BEM classes<\\/li>\\n<\\/ul>\\n<h4> 1.7.1 <\\/h4>\\n<ul>\\n<li>Added: Gallery Extra \\u2014 Caption horizontal and vertical alignment and hover effects<\\/li>\\n<li>Added: Gallery Extra \\u2014 Ratio and alignment controls to masonry layout<\\/li>\\n<li>Added: Gallery Extra \\u2014 New border and border radius controls for captions<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Bring image to front when hovered<\\/li>\\n<li>Fixed: Posts Extra \\u2014 Images not displaying on infinite load on iOS Safari and Chrome<\\/li>\\n<li>Tweak: Image Comparison \\u2014 Force override of modified image max-width attribute<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added extra classes to media elements<\\/li>\\n<\\/ul>\\n<h4> 1.7.0 <\\/h4>\\n<ul>\\n<li>Added: Gallery Extra \\u2014 Masonry layout with mixed mode<\\/li>\\n<li>Added: Gallery Extra \\u2014 Tilt effect<\\/li>\\n<li>Added: Gallery Extra \\u2014 Caption horizontal and vertical alignment and hover effects<\\/li>\\n<li>Added: Gallery Extra \\u2014 Overlay, caption and image transition controls<\\/li>\\n<li>Added: Gallery Extra \\u2014 Overlay blend mode control<\\/li>\\n<li>Added: Gallery Extra \\u2014 Image scale controls for default and hover states<\\/li>\\n<li>Added: Gallery Extra \\u2014 Overlay margin controls for default and hover states<\\/li>\\n<li>Added: Gallery Extra \\u2014 Manual mode that allows entering of every image manually and linking it to any URL<\\/li>\\n<li>Added: Inline SVG widget<\\/li>\\n<li>Added: Posts Extra \\u2014 Controls to disable linking for post title, media and terms<\\/li>\\n<li>Added: Posts Extra \\u2014 Control to select default applied filter for filter bar<\\/li>\\n<li>Added: Timeline \\u2014 New controls for post title typography and spacing, post excerpt typography and padding<\\/li>\\n<li>Added: Image Comparison \\u2014 Image size control<\\/li>\\n<li>Added: New css transition control for Gallery Extra, Gallery Slider, Hotspots, Posts Extra, Timeline, Table and Inline SVG widgets<\\/li>\\n<li>Added: HTML5 Video \\u2014 M4V format support<\\/li>\\n<li>Added: Devices \\u2014 M4V format support for video<\\/li>\\n<li>Fixed: Buttons \\u2014 Flicker on flip effect<\\/li>\\n<li>Fixed: Timeline \\u2014 CSS class conflict<\\/li>\\n<li>Fixed: Table \\u2014 ID and class don\'t apply to header<\\/li>\\n<li>Tweak: Improved Elementor 1.9 compatibility for Extras group controls<\\/li>\\n<li>Tweak: Update TweenMax to latest version (1.20.2)<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Simplified CSS<\\/li>\\n<li>Tweak: Unfold \\u2014 Disconnect button and content from control alignment logic<\\/li>\\n<\\/ul>\\n<h4> 1.6.3 <\\/h4>\\n<ul>\\n<li>Fixed: Breadcrumbs \\u2014 Display correctly when used within an Elementor library template<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Condition terms separator<\\/li>\\n<li>Tweak: Breadcrumbs \\u2014 Avoid naming conflict with Elementor Pro widget<\\/li>\\n<\\/ul>\\n<h4> 1.6.2 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 New autoplay, autoheight and fade effect controls<\\/li>\\n<li>Added: Posts Extra \\u2014 &quot;Top&quot; option to media position on horizontal layout<\\/li>\\n<li>Added: Posts Extra \\u2014 Allowed media to be positioned horizontally on 2 columns layouts<\\/li>\\n<li>Added: Posts Extra \\u2014 New border controls for media<\\/li>\\n<li>Added: Table \\u2014 Allow table responsive behaviour to be turned off<\\/li>\\n<li>Tweak: Buttons \\u2014 Default button content alignment to justify<\\/li>\\n<li>Fix: Timeline \\u2014 Potential fatal error<\\/li>\\n<li>Fix: Posts Extra \\u2014 Post media position controls conditions<\\/li>\\n<li>Fix: Buttons \\u2014 Delay on transitioned properties<\\/li>\\n<li>Fix: Posts Extra \\u2014 Wrong tablet breakpoint set for number of columns<\\/li>\\n<li>Fix: Parallax Background \\u2014 Remove initial background image once parallax is activated<\\/li>\\n<\\/ul>\\n<h4> 1.6.1 <\\/h4>\\n<ul>\\n<li>Added: Posts Extra \\u2014 Link author name and avatar to author posts pages<\\/li>\\n<li>Added: Posts Extra \\u2014 Read more link to excerpt<\\/li>\\n<li>Tweak: Posts Extra \\u2014 Added separate hide option for Position for better UX <\\/li>\\n<li>Tweak: Posts Extra \\u2014 Improved position icons<\\/li>\\n<\\/ul>\\n<h4> 1.6.0 <\\/h4>\\n<ul>\\n<li>New Widget \\u2014 Posts Extra - Create ANY layout for posts with masonry, infinite load, filtering and custom post type support. Works only with Elementor Pro<\\/li>\\n<li>Tweak: Breadcrumbs \\u2014 Added horizontal position and text alignment controls<\\/li>\\n<li>Tweak: Buttons \\u2014 Improved CSS and better alignment and stacking options<\\/li>\\n<li>Fixed: Breadcrumbs \\u2014 Error outputting separator<\\/li>\\n<li>Fixed: Buttons \\u2014 Transition on button content when effects are turned on<\\/li>\\n<\\/ul>\\n<h4> 1.5.6 <\\/h4>\\n<ul>\\n<li>Fixed: Parallax Background \\u2014 Replaced parallax class name to avoid future conflicts<\\/li>\\n<li>Fixed: Timeline \\u2014 Remove flex from left aligned timeline and allow image spacing for horizontal layouts<\\/li>\\n<li>Fixed: PHP fatal error<\\/li>\\n<li>Tweak: Unfold \\u2014 Switched Settings with Content sections in editor for better UX<\\/li>\\n<\\/ul>\\n<h4> 1.5.5 <\\/h4>\\n<ul>\\n<li>Added: Buttons \\u2014 Inline editing<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Inline editing<\\/li>\\n<li>Added: Circle Progress \\u2014 Inline editing<\\/li>\\n<li>Added: Hotspots \\u2014 Inline editing<\\/li>\\n<li>Added: Image Comparison \\u2014 Inline editing<\\/li>\\n<li>Added: Table \\u2014 Inline editing<\\/li>\\n<li>Added: Text Divider \\u2014 Inline editing<\\/li>\\n<li>Added: Timeline \\u2014 Inline editing<\\/li>\\n<li>Added: Unfold \\u2014 Inline editing<\\/li>\\n<li>Fixed: Tooltips \\u2014 Error &quot;size&quot; of undefined appears for delay_in in some cases<\\/li>\\n<li>Fixed: Unfold \\u2014 Issue that resulted in wrong calculation of unfolded height<\\/li>\\n<li>Tweak: Default to text cursor for text where inline editing is available<\\/li>\\n<\\/ul>\\n<h4> 1.5.4 <\\/h4>\\n<ul>\\n<li>Added: HTML5 Video \\u2014 Option to end video at last frame<\\/li>\\n<li>Tweak: HTML5 Video \\u2014 Removed auto pausing when interacting with progress bar<\\/li>\\n<\\/ul>\\n<h4> 1.5.3 <\\/h4>\\n<ul>\\n<li>Fixed: Unfold \\u2014 Content folds back automatically when scrolling on mobile browsers that vertically resize the viewport<\\/li>\\n<\\/ul>\\n<h4> 1.5.2 <\\/h4>\\n<ul>\\n<li>Added: Gallery Extra \\u2014 Allow gallery navigation in lightbox<\\/li>\\n<li>Fixed: Gallery Extra \\u2014 Image box shadow not applying<\\/li>\\n<li>Fixed: Buttons \\u2014 Issue with transition delays on buttons without effects<\\/li>\\n<\\/ul>\\n<h4> 1.5.1 <\\/h4>\\n<ul>\\n<li>Added: Table \\u2014 Control to show header on mobile as a block or a column<\\/li>\\n<li>Added: Table \\u2014 Border control for table rows<\\/li>\\n<li>Added: Table \\u2014 Option to automatically try to fetch correct headers for mobile with override possibility<\\/li>\\n<li>Added: Table \\u2014 Control to set width for mobile headers<\\/li>\\n<li>Tweak: Table \\u2014 Remove column rules from mobile<\\/li>\\n<li>Tweak: Table \\u2014 Removed first \\/ last child border rules from mobile<\\/li>\\n<li>Tweak: Table \\u2014 Added pointer cursor on sortable header cells<\\/li>\\n<li>Tweak: Table \\u2014 Moved padding to text for better handling of responsive layout and removed negative margin technique<\\/li>\\n<li>Tweak: Table \\u2014 Responsive cells and header cells padding controls<\\/li>\\n<li>Tweak: Table \\u2014 Move cell header control to top<\\/li>\\n<li>Tweak: Table \\u2014 Added option to hide headers completely on mobile<\\/li>\\n<li>Tweak: Table \\u2014 Hide mobile headers that have no content<\\/li>\\n<li>Tweak: Sticky \\u2014 Set default z-index to 1 for stickable elements<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Separator not showing<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Remove space between images and widget container<\\/li>\\n<li>Fixed: Table \\u2014 PHP Warning when allowing empty on repeater fields<\\/li>\\n<li>Fixed: Table \\u2014 Width and alignment not working<\\/li>\\n<li>Fixed: Table \\u2014 Added missing custom class and id from markup<\\/li>\\n<\\/ul>\\n<h4> 1.5.0 <\\/h4>\\n<ul>\\n<li>New Widget: Table<\\/li>\\n<li>Fixed: Prefix CSS helper classes to avoid potential conflicts<\\/li>\\n<\\/ul>\\n<h4> 1.4.0 <\\/h4>\\n<ul>\\n<li>New: Buttons Effects<\\/li>\\n<li>Added: Breadcrumbs \\u2014 Control to manually specify which post or page to generate breadcrumbs for<\\/li>\\n<li>Fixed: Devices \\u2014 Horizontal orientation image not visible<\\/li>\\n<\\/ul>\\n<h4> 1.3.1 <\\/h4>\\n<ul>\\n<li>Fixed: Parallax Background \\u2014 Wrong position when loading page off viewport<\\/li>\\n<li>Fixed: Timeline \\u2014 Enlarged points not aligned to line on tablet and mobile<\\/li>\\n<li>Added: Timeline \\u2014 Responsive controls for point size and icon size<\\/li>\\n<\\/ul>\\n<h4> 1.3.0 <\\/h4>\\n<ul>\\n<li>Added: New Widget! \\u2014 HTML5 Video<\\/li>\\n<li>Added: Devices \\u2014 Added HTML5 Video controls<\\/li>\\n<li>Added: Devices \\u2014 Added option to stretch the video to fit into the device screen<\\/li>\\n<li>Added: Devices \\u2014 Added option to choose wether or not to stop the video when leaving viewport<\\/li>\\n<li>Added: Timeline \\u2014 Hover properties for points<\\/li>\\n<li>Added: Timeline \\u2014 More style override options for each card<\\/li>\\n<li>Added: Gallery Slider \\u2014 More responsive controls for preview position and spacing<\\/li>\\n<li>Fixed: Timeline \\u2014 Removed unnecessary z-index from cards<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Preview spacing doesn\'t work on mobile when the layout is vertical<\\/li>\\n<li>Fixed: Devices \\u2014 Replaced SVG IDs with classes to avoid code invalidation<\\/li>\\n<li>Fixed: Circle Progress \\u2014 Canvas distorted on responsive<\\/li>\\n<li>Fixed: Hotspots \\u2014 Links concatenating from one repeater field to another<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Images move up after scrolling up and down multiple times<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Background position is off when section Stretch is turned on<\\/li>\\n<li>Fixed: Hotspots \\u2014 Links inside tooltips appear outside of the tooltip<\\/li>\\n<li>Tweak: Timeline \\u2014 Changed &quot;Size Ratio&quot; name to &quot;Scale&quot;<\\/li>\\n<li>Tweak: Gallery Extras \\u2014 Bring 3D items to front on hover<\\/li>\\n<li>Tweak: Hotspots \\u2014 Moved tooltip content outside hotspot to avoid invalid nodes<\\/li>\\n<li>Tweak: Hotspots \\u2014 Don\'t activate tooltips that have no content set<\\/li>\\n<\\/ul>\\n<h4> 1.2.5 <\\/h4>\\n<ul>\\n<li>Tweak: Replaced text align icons with horizontal align icons where appropriate<\\/li>\\n<li>Fixed: Sticky elements not bottoming out correctly when using custom parent selector<\\/li>\\n<li>Fixed: Removing unstick for any breakpoint would break sticky functionality<\\/li>\\n<\\/ul>\\n<h4> 1.2.4 <\\/h4>\\n<ul>\\n<li>Added: Sticky \\u2014 Custom selector for sticky parent to allow for elements to stick in any parent element<\\/li>\\n<li>Tweak: Timeline \\u2014 Responsive padding controls<\\/li>\\n<li>Tweak: Timeline \\u2014 Refactoring and improved performance and accuracy on progress bar<\\/li>\\n<li>Tweak: Image Comparison \\u2014 Adjust spacing method for labels and vertical alignment improvements<\\/li>\\n<li>Tweak: Image Comparison \\u2014 Allow for widget border radius control to affect images<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Scroll breaks on mobile when hiding a parallaxed section<\\/li>\\n<li>Fixed: Timeline \\u2014 Cards not animating when first in view<\\/li>\\n<li>Fixed: Timeline \\u2014 Content wrapper present even if no card content is set<\\/li>\\n<\\/ul>\\n<h4> 1.2.3 <\\/h4>\\n<ul>\\n<li>Fixed: Parallax Background \\u2014 Section background not reverting after parallax turned on again<\\/li>\\n<li>Fixed: Parallax Background \\u2014 Calculating wrong dimensions when using Elementor JS stretch option<\\/li>\\n<li>Fixed: Issue where updating Elementor when Extras is active would result in an error<\\/li>\\n<li>Tweak: Hotspots \\u2014 Adjusted default tooltip width<\\/li>\\n<\\/ul>\\n<h4> 1.2.2 <\\/h4>\\n<ul>\\n<li>Fixed: Heading Extra \\u2014 Complete html support<\\/li>\\n<\\/ul>\\n<h4> 1.2.1 <\\/h4>\\n<ul>\\n<li>Fixed: Heading Extra \\u2014 Gradient would show only for the first line<\\/li>\\n<li>Fixed: Parallax Background \\u2014 When using padding on sections, image position calculation would not be correct<\\/li>\\n<\\/ul>\\n<h4> 1.2.0 <\\/h4>\\n<ul>\\n<li>Added: New Feature! \\u2014 Parallax Background \\u2014 Now you can parallax section backgrounds and have it move up, down, left or right while scrolling<\\/li>\\n<li>Added: New Widget! \\u2014 Unfold \\u2014 Lets you hide content and reveal it on demand<\\/li>\\n<li>Added: New Widget! \\u2014 Breadcrumbs<\\/li>\\n<li>Added: Parallax Elements \\u2014 Allow to select whether to parallax an element relative to its own position or the middle of the viewport<\\/li>\\n<li>Added: Hotspots \\u2014 Ability to add links to hotspots if tooltips are triggered on hover<\\/li>\\n<li>Added: Tooltips \\u2014 Added left and right tooltips for both Hotspots and Button Groups<\\/li>\\n<li>Added: Tooltips \\u2014 Better handling of repositioning tooltips when they flow outside of the viewport<\\/li>\\n<li>Added: Tooltips \\u2014 Ability to override tooltip position for each button of hotspot individually<\\/li>\\n<li>Added: Heading Extra \\u2014 Text fill now supports clipped images<\\/li>\\n<li>Tweak: Heading Extra \\u2014 Allow to have both text shadow and long shadow on the same text<\\/li>\\n<li>Tweak: Text Divider \\u2014 Responsive alignment and spacing controls<\\/li>\\n<li>Tweak: Text Divider \\u2014 Proper horizontal alignment of text and separators<\\/li>\\n<li>Fixed: Heading Extra \\u2014 Multiple z-index related issues<\\/li>\\n<li>Fixed: Parallax Elements \\u2014 Fix issue where elements would jump when scrolling<\\/li>\\n<\\/ul>\\n<h4> 1.1.4 <\\/h4>\\n<ul>\\n<li>Added: Sticky sections!<\\/li>\\n<li>Added: Sticky \\u2014 New controls to unstick for mobile and tablet<\\/li>\\n<li>Added: Parallax Elements \\u2014 New controls to set different speeds for different breakpoints<\\/li>\\n<li>Added: Gallery Slider \\u2014 Links on images and support for the new Elementor lightbox feature<\\/li>\\n<li>Tweak: Improved shortcode support for all widgets, especially tooltips<\\/li>\\n<li>Tweak: Parallax Elements \\u2014 Greatly improved performance for parallaxed items<\\/li>\\n<li>Tweak: Parallax Elements \\u2014 Changed speed control logic to allow for reverse parallax<\\/li>\\n<li>Tweak: Created custom group controls for Sticky and Parallax features<\\/li>\\n<li>Fixed: Removed z-index from sticky elements to allow z-index setting from Elementor controls<\\/li>\\n<li>Fixed: Gallery Extras \\u2014 Some styling controls were conditioned by the &quot;Link to&quot; control<\\/li>\\n<li>Fixed: Removed potentially buggy call to Elementor class<\\/li>\\n<\\/ul>\\n<h4> 1.1.3 <\\/h4>\\n<ul>\\n<li>Tweak: Devices \\u2014 Refactored and cleaned up code for editor functionality<\\/li>\\n<li>Tweak: Gallery Extra \\u2014 Moved distance control after parallax controls<\\/li>\\n<li>Added: Controls to add parallax to any widget or column<\\/li>\\n<li>Added: Global control for turning off parallax functionality for tablet and mobile<\\/li>\\n<li>Added: Gallery Extra \\u2014 Control for settings horizontal overlap of images<\\/li>\\n<li>Added: Image Comparison \\u2014 Separator between images<\\/li>\\n<li>Added: Global \\u2014 Implemented the new Text Shadow controls for all widgets<\\/li>\\n<li>Added: Button Groups \\u2014 Responsive control of spacing for stacked buttons<\\/li>\\n<li>Fixed: Devices \\u2014 Issue where frames would not properly change in editor mode<\\/li>\\n<li>Fixed: Changed license page capability to \'manage_options\'<\\/li>\\n<li>Fixed: Compatibility with Elementor 1.6<\\/li>\\n<\\/ul>\\n<h4> 1.1.2 <\\/h4>\\n<ul>\\n<li>Fixed: Class namespace change in Elementor Pro 1.5.7 resulting in fatal error<\\/li>\\n<\\/ul>\\n<h4> 1.1.1 <\\/h4>\\n<ul>\\n<li>Fixed: Devices \\u2014 Overlay not visible for laptop and desktop<\\/li>\\n<li>Fixed: Timeline \\u2014 PHP empty function fatal error<\\/li>\\n<li>Fixed: Gallery Slider \\u2014 Width remained 50% even if vertical layout selected<\\/li>\\n<\\/ul>\\n<h4> 1.1.0 <\\/h4>\\n<ul>\\n<li>Added: New Widget! \\u2014 Gallery Extra \\u2014 We\'ve taken aside the parallax functionality and created a whole new widget with nots of posibilities.<\\/li>\\n<li>Added: New Widget! \\u2014 Gallery Slider \\u2014 A gallery layout with inline preview.<\\/li>\\n<li>Added: New Feature! \\u2014 Button tooltips \\u2014 You can now use the Button Groups widget to add buttons with tooltips.<\\/li>\\n<li>Added: New Feature! \\u2014 Timeline \\u2014 Integration with Woocommerce products.<\\/li>\\n<li>Added: New Feature! \\u2014 Hotspots \\u2014 Added support for icons inside hotspots.<\\/li>\\n<li>Added: New Feature! \\u2014 Hotspots \\u2014 Ability to set the delay for both entrance close animations.<\\/li>\\n<li>Added: Circle Progress \\u2014 Control too choose start angle for the circle progress.<\\/li>\\n<li>Added: Devices \\u2014 Support for multiple video formats<\\/li>\\n<li>Added: Timeline \\u2014 Add featured images from separate control.<\\/li>\\n<li>Added: Elementor Portfolio Widget \\u2014 Speed control for parallax feature.<\\/li>\\n<li>Added: Timeline \\u2014 Turn on and off for excerpts, content, title and featured image.<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Handle now goes all the way until the end of the image.<\\/li>\\n<li>Fixed: Timeline \\u2014 Date color wasn\'t changing properly.<\\/li>\\n<li>Fixed: Issue where disabling and changing license was not possible.<\\/li>\\n<li>Fixed: Sticky - Issue where in preview mode wrong height of the element was calculated.<\\/li>\\n<li>Fixed: Image Gallery \\u2014 Issue with displaying on Firefox.<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Handle jumps when using multiple widgets on same page.<\\/li>\\n<li>Fixed: Timeline \\u2014 Scheme style override issue for points.<\\/li>\\n<li>Fixed: Devices \\u2014 Video would not play on iOS devices<\\/li>\\n<\\/ul>\\n<h4> 1.0.5 <\\/h4>\\n<ul>\\n<li>Added: Button Groups \\u2014 Box shadow control.<\\/li>\\n<li>Fixed: Ensured compatibility with other jquery appear plugins.<\\/li>\\n<li>Fixed: Issue where disabling and changing license was not possible.<\\/li>\\n<\\/ul>\\n<h4> 1.0.4 <\\/h4>\\n<ul>\\n<li>Added: Added translation support<\\/li>\\n<li>Fixed: Devices \\u2014 Issue where controls would always display as a white rectangular shape.<\\/li>\\n<\\/ul>\\n<h4> 1.0.3 <\\/h4>\\n<ul>\\n<li>Fixed: Image Galleries \\u2014 Issue where galleries with no links would break the layout<\\/li>\\n<li>Fixed: Hotspots \\u2014 When using multiple hotspots widgets on the same page additional widgets would show the first widget\'s tooltips instead of their own<\\/li>\\n<\\/ul>\\n<h4> 1.0.2 <\\/h4>\\n<ul>\\n<li>Added: Hotspots \\u2014 New controls: text align, padding, border and typography<\\/li>\\n<li>Fixed: Hotspots \\u2014 Hide arrow control not working<\\/li>\\n<li>Fixed: Hotspots \\u2014 Issue where tooltips don\'t remain open on click trigger option and thus preventing clicking off links inside tooltips<\\/li>\\n<li>Fixed: Button Groups \\u2014 Replaced custom border controls with border group control<\\/li>\\n<li>Fixed: Extended Heading \\u2014 Compability with Elementor 1.5<\\/li>\\n<li>Fixed: Extended Heading \\u2014 Heading size not working<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Issue where colors of labels would not change colors for printed templates<\\/li>\\n<\\/ul>\\n<h4> 1.0.1 <\\/h4>\\n<ul>\\n<li>Fixed: Image Comparison \\u2014 Issue where dragging the handle on mobile would not work<\\/li>\\n<\\/ul>\\n<h4> 1.0.0 <\\/h4>\\n<ul>\\n<li>Added: New &quot;Timeline&quot; widget with posts support for Elementor Pro<\\/li>\\n<li>Added: Image Comparison \\u2014 Different colors for both labels<\\/li>\\n<li>Tweak: Image Comparison \\u2014 Moved alignment &amp; scaling options to widget wrapper<\\/li>\\n<li>Tweak: Aligned default widgets colors to selected color scheme<\\/li>\\n<li>Tweak: Removed sticky from sections temporarily<\\/li>\\n<li>Tweak: Removed parallax scrolling from section backgrounds<\\/li>\\n<li>Tweak: Button Groups \\u2014 Reorganized repeater controls under tabs<\\/li>\\n<li>Tweak: Full compatibility with global color schemes for all widgets<\\/li>\\n<li>Tweak: Hotspots \\u2014 Reorganized repeater controls under tabs<\\/li>\\n<li>Fixed: Timeline \\u2014 Issue where arrow colors would not apply<\\/li>\\n<li>Fixed: Extended Heading \\u2014 Entrace animation hides the shadow when animation is complete<\\/li>\\n<li>Fixed: Devices \\u2014 Border type not present in hover state for video controls<\\/li>\\n<li>Fixed: Image Comparison \\u2014 Removed small space after widget<\\/li>\\n<li>Fixed: Hotspots \\u2014 Syntax error in JS template<\\/li>\\n<li>Fixed: Hotspots \\u2014 JS error when adding new hotpots<\\/li>\\n<li>Fixed: Hotspots \\u2014 Tooltips z-index issue<\\/li>\\n<li>Fixed: Hotspots \\u2014 Bottom tooltips animated down instead of up<\\/li>\\n<li>Fixed: Hotspots \\u2014 Html being added as string when hotspots are triggered through the open_editor hook<\\/li>\\n<li>Fixed: Hotspots \\u2014 Tooltips not editable immediately when dragged into preview<\\/li>\\n<li>Fixed: Image Comparison \\u2014 images are not set to occupy full width<\\/li>\\n<\\/ul>\\n<h4> 0.1.2 <\\/h4>\\n<ul>\\n<li>Added: Hotspots \\u2014 Rewrote code entirely to allow for preview mode support, customisation of tooltips and faster rendering<\\/li>\\n<li>Added: Circle progress \\u2014 Better handling of value suffix<\\/li>\\n<li>Fixed: Scripts dependencies<\\/li>\\n<li>Fixed: Devices \\u2014 Issue where global colors where used instead of skins<\\/li>\\n<li>Fixed: Various compatibility issues with the Elementor color scheme<\\/li>\\n<li>Fixed: Image Gallery Extension \\u2014 Styling issues when choosing to justify gallery items<\\/li>\\n<li>Fixed: Sticky Extension \\u2014 Sitcky offset would not preview correctly and sometimes having multiple sticky widgets would cause interference amongst them<\\/li>\\n<li>Fixed: Parallax Gallery \\u2014 Removed any kinds of transformation for odd children<\\/li>\\n<\\/ul>\\n<h4> 0.1.1 <\\/h4>\\n<ul>\\n<li>Fixed: Buttons groups \\u2014 Responsive alignment of buttons<\\/li>\\n<li>Added: Buttons groups \\u2014 option to stack buttons on tablet or mobile<\\/li>\\n<\\/ul>\\n<h4> 0.1.0 <\\/h4>\\n<ul>\\n<li>Initial Private Beta<\\/li>\\n<\\/ul>\"],\"installation\":[\"<ol>\\n<li>Make sure Elementor is installed and active on your website<\\/li>\\n<li>Activate the plugin through the \'Plugins\' menu in WordPress<\\/li>\\n<li>Edit a page (or post) using Elementor<\\/li>\\n<li>Find and use the new widgets and extensions<\\/li>\\n<\\/ol>\"]}\";}", "no");
INSERT INTO `wp_464683_options` VALUES("356", "password_protected_status", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("357", "password_protected_feeds", "0", "yes");
INSERT INTO `wp_464683_options` VALUES("358", "password_protected_rest", "0", "yes");
INSERT INTO `wp_464683_options` VALUES("359", "password_protected_administrators", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("360", "password_protected_users", "1", "yes");
INSERT INTO `wp_464683_options` VALUES("361", "password_protected_password", "de953ff209fbfa12198f94c8722426dc", "yes");
INSERT INTO `wp_464683_options` VALUES("362", "password_protected_allowed_ip_addresses", "", "yes");
INSERT INTO `wp_464683_options` VALUES("363", "password_protected_remember_me_lifetime", "14", "yes");
INSERT INTO `wp_464683_options` VALUES("368", "jet-elements-settings", "a:12:{s:11:\"svg_uploads\";s:7:\"enabled\";s:13:\"jet_templates\";s:8:\"disabled\";s:18:\"widgets_load_level\";s:3:\"100\";s:7:\"api_key\";s:0:\"\";s:14:\"disable_api_js\";a:1:{s:7:\"disable\";s:5:\"false\";}s:17:\"mailchimp-api-key\";s:0:\"\";s:17:\"mailchimp-list-id\";s:0:\"\";s:23:\"mailchimp-double-opt-in\";s:5:\"false\";s:18:\"insta_access_token\";s:0:\"\";s:15:\"weather_api_key\";s:0:\"\";s:17:\"avaliable_widgets\";a:35:{s:30:\"jet-elements-advanced-carousel\";s:4:\"true\";s:25:\"jet-elements-advanced-map\";s:5:\"false\";s:25:\"jet-elements-animated-box\";s:5:\"false\";s:26:\"jet-elements-animated-text\";s:4:\"true\";s:18:\"jet-elements-audio\";s:5:\"false\";s:19:\"jet-elements-banner\";s:4:\"true\";s:22:\"jet-elements-bar-chart\";s:5:\"false\";s:19:\"jet-elements-brands\";s:5:\"false\";s:19:\"jet-elements-button\";s:5:\"false\";s:28:\"jet-elements-circle-progress\";s:5:\"false\";s:28:\"jet-elements-countdown-timer\";s:5:\"false\";s:28:\"jet-elements-download-button\";s:5:\"false\";s:20:\"jet-elements-dropbar\";s:5:\"false\";s:21:\"jet-elements-headline\";s:4:\"true\";s:32:\"jet-elements-horizontal-timeline\";s:5:\"false\";s:29:\"jet-elements-image-comparison\";s:5:\"false\";s:26:\"jet-elements-images-layout\";s:4:\"true\";s:23:\"jet-elements-inline-svg\";s:4:\"true\";s:30:\"jet-elements-instagram-gallery\";s:5:\"false\";s:22:\"jet-elements-pie-chart\";s:5:\"false\";s:22:\"jet-elements-portfolio\";s:4:\"true\";s:18:\"jet-elements-posts\";s:5:\"false\";s:23:\"jet-elements-price-list\";s:4:\"true\";s:26:\"jet-elements-pricing-table\";s:4:\"true\";s:25:\"jet-elements-progress-bar\";s:5:\"false\";s:30:\"jet-elements-scroll-navigation\";s:5:\"false\";s:21:\"jet-elements-services\";s:5:\"false\";s:19:\"jet-elements-slider\";s:4:\"true\";s:27:\"jet-elements-subscribe-form\";s:5:\"false\";s:18:\"jet-elements-table\";s:5:\"false\";s:24:\"jet-elements-team-member\";s:5:\"false\";s:25:\"jet-elements-testimonials\";s:5:\"false\";s:21:\"jet-elements-timeline\";s:5:\"false\";s:18:\"jet-elements-video\";s:5:\"false\";s:20:\"jet-elements-weather\";s:5:\"false\";}s:20:\"avaliable_extensions\";a:1:{s:16:\"section_parallax\";s:4:\"true\";}}", "yes");
INSERT INTO `wp_464683_options` VALUES("371", "elementor_custom_icon_sets_config", "a:0:{}", "yes");
INSERT INTO `wp_464683_options` VALUES("372", "elementor_controls_usage", "a:2:{s:4:\"page\";a:11:{s:11:\"menu-anchor\";a:2:{s:5:\"count\";i:7;s:8:\"controls\";a:2:{s:7:\"content\";a:1:{s:14:\"section_anchor\";a:1:{s:6:\"anchor\";i:7;}}s:8:\"advanced\";a:1:{s:14:\"_section_style\";a:1:{s:12:\"_css_classes\";i:1;}}}}s:7:\"heading\";a:2:{s:5:\"count\";i:10;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:13:\"section_title\";a:4:{s:5:\"title\";i:10;s:5:\"align\";i:10;s:12:\"align_mobile\";i:2;s:11:\"header_size\";i:1;}}s:5:\"style\";a:1:{s:19:\"section_title_style\";a:14:{s:11:\"title_color\";i:10;s:21:\"typography_typography\";i:10;s:22:\"typography_font_family\";i:10;s:20:\"typography_font_size\";i:10;s:27:\"typography_font_size_mobile\";i:9;s:22:\"typography_font_weight\";i:10;s:25:\"typography_letter_spacing\";i:1;s:28:\"text_shadow_text_shadow_type\";i:1;s:23:\"text_shadow_text_shadow\";i:1;s:21:\"typography_font_style\";i:1;s:22:\"typography_line_height\";i:2;s:25:\"typography_text_transform\";i:7;s:27:\"typography_font_size_tablet\";i:1;s:29:\"typography_line_height_mobile\";i:1;}}s:8:\"advanced\";a:5:{s:14:\"_section_style\";a:6:{s:7:\"_margin\";i:3;s:14:\"_margin_mobile\";i:1;s:8:\"_padding\";i:9;s:12:\"_css_classes\";i:1;s:15:\"_padding_tablet\";i:1;s:15:\"_padding_mobile\";i:1;}s:19:\"_section_background\";a:1:{s:22:\"_background_background\";i:2;}s:15:\"_section_border\";a:1:{s:14:\"_border_radius\";i:1;}s:33:\"section_elementor_extras_advanced\";a:3:{s:17:\"sticky_unstick_on\";i:1;s:13:\"sticky_offset\";i:1;s:13:\"sticky_enable\";i:1;}s:15:\"section_effects\";a:2:{s:18:\"animation_duration\";i:1;s:17:\"_animation_mobile\";i:1;}}}}s:6:\"column\";a:2:{s:5:\"count\";i:16;s:8:\"controls\";a:2:{s:6:\"layout\";a:1:{s:6:\"layout\";a:5:{s:19:\"_inline_size_tablet\";i:2;s:16:\"content_position\";i:5;s:12:\"_inline_size\";i:7;s:21:\"space_between_widgets\";i:8;s:19:\"_inline_size_mobile\";i:2;}}s:8:\"advanced\";a:2:{s:16:\"section_advanced\";a:5:{s:6:\"margin\";i:11;s:7:\"padding\";i:9;s:13:\"margin_mobile\";i:4;s:14:\"padding_mobile\";i:7;s:14:\"padding_tablet\";i:2;}s:15:\"section_effects\";a:1:{s:16:\"animation_mobile\";i:1;}}}}s:7:\"section\";a:2:{s:5:\"count\";i:14;s:8:\"controls\";a:3:{s:6:\"layout\";a:3:{s:14:\"section_layout\";a:9:{s:6:\"layout\";i:12;s:6:\"height\";i:2;s:13:\"custom_height\";i:2;s:20:\"custom_height_mobile\";i:2;s:15:\"column_position\";i:2;s:3:\"gap\";i:7;s:20:\"custom_height_tablet\";i:2;s:15:\"stretch_section\";i:5;s:16:\"content_position\";i:5;}s:16:\"section_parallax\";a:1:{s:24:\"jet_parallax_layout_list\";i:14;}s:17:\"section_structure\";a:1:{s:9:\"structure\";i:1;}}s:5:\"style\";a:4:{s:18:\"section_background\";a:17:{s:21:\"background_background\";i:9;s:21:\"background_attachment\";i:2;s:17:\"background_repeat\";i:3;s:15:\"background_size\";i:3;s:19:\"background_position\";i:2;s:26:\"background_position_mobile\";i:2;s:24:\"background_repeat_mobile\";i:2;s:22:\"background_size_mobile\";i:2;s:23:\"background_image_mobile\";i:1;s:23:\"background_image_tablet\";i:1;s:24:\"background_repeat_tablet\";i:2;s:22:\"background_size_tablet\";i:2;s:38:\"background_motion_fx_translateX_effect\";i:1;s:37:\"background_motion_fx_translateX_speed\";i:1;s:32:\"background_motion_fx_scale_speed\";i:1;s:16:\"background_image\";i:1;s:16:\"background_color\";i:7;}s:26:\"section_background_overlay\";a:16:{s:29:\"background_overlay_background\";i:9;s:27:\"background_overlay_position\";i:4;s:29:\"background_overlay_attachment\";i:4;s:25:\"background_overlay_repeat\";i:4;s:23:\"background_overlay_size\";i:4;s:26:\"background_overlay_opacity\";i:4;s:24:\"background_overlay_image\";i:8;s:31:\"background_overlay_image_tablet\";i:3;s:31:\"background_overlay_image_mobile\";i:3;s:32:\"background_overlay_repeat_mobile\";i:3;s:30:\"background_overlay_size_mobile\";i:3;s:34:\"background_overlay_position_mobile\";i:2;s:22:\"css_filters_css_filter\";i:1;s:22:\"css_filters_brightness\";i:1;s:20:\"css_filters_saturate\";i:1;s:34:\"background_overlay_position_tablet\";i:1;}s:14:\"section_border\";a:4:{s:13:\"border_border\";i:8;s:12:\"border_width\";i:8;s:12:\"border_color\";i:8;s:13:\"border_radius\";i:1;}s:21:\"section_shape_divider\";a:5:{s:23:\"shape_divider_top_color\";i:2;s:23:\"shape_divider_top_width\";i:2;s:24:\"shape_divider_top_height\";i:2;s:26:\"shape_divider_top_negative\";i:2;s:31:\"shape_divider_top_above_content\";i:2;}}s:8:\"advanced\";a:3:{s:16:\"section_advanced\";a:7:{s:11:\"css_classes\";i:1;s:13:\"margin_mobile\";i:8;s:6:\"margin\";i:11;s:7:\"padding\";i:10;s:14:\"padding_mobile\";i:10;s:14:\"padding_tablet\";i:3;s:13:\"margin_tablet\";i:1;}s:15:\"section_effects\";a:2:{s:9:\"animation\";i:1;s:18:\"animation_duration\";i:1;}s:18:\"section_custom_css\";a:1:{s:10:\"custom_css\";i:3;}}}}s:11:\"text-editor\";a:2:{s:5:\"count\";i:11;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:14:\"section_editor\";a:1:{s:6:\"editor\";i:11;}}s:5:\"style\";a:1:{s:13:\"section_style\";a:10:{s:5:\"align\";i:11;s:10:\"text_color\";i:10;s:21:\"typography_typography\";i:11;s:20:\"typography_font_size\";i:11;s:22:\"typography_font_weight\";i:3;s:22:\"typography_line_height\";i:3;s:12:\"align_mobile\";i:8;s:21:\"typography_font_style\";i:1;s:27:\"typography_font_size_mobile\";i:4;s:29:\"typography_line_height_mobile\";i:2;}}s:8:\"advanced\";a:1:{s:14:\"_section_style\";a:4:{s:7:\"_margin\";i:5;s:14:\"_margin_mobile\";i:3;s:15:\"_padding_mobile\";i:3;s:8:\"_padding\";i:2;}}}}s:14:\"jet-inline-svg\";a:2:{s:5:\"count\";i:3;s:8:\"controls\";a:2:{s:7:\"content\";a:1:{s:19:\"section_svg_content\";a:1:{s:7:\"svg_url\";i:3;}}s:5:\"style\";a:1:{s:17:\"section_svg_style\";a:4:{s:16:\"svg_custom_width\";i:3;s:9:\"svg_width\";i:3;s:16:\"svg_custom_color\";i:3;s:9:\"svg_color\";i:3;}}}}s:7:\"divider\";a:2:{s:5:\"count\";i:2;s:8:\"controls\";a:2:{s:7:\"content\";a:1:{s:15:\"section_divider\";a:4:{s:5:\"style\";i:1;s:5:\"width\";i:1;s:5:\"align\";i:1;s:12:\"width_mobile\";i:1;}}s:5:\"style\";a:1:{s:21:\"section_divider_style\";a:1:{s:5:\"color\";i:1;}}}}s:10:\"price-list\";a:2:{s:5:\"count\";i:1;s:8:\"controls\";a:2:{s:7:\"content\";a:1:{s:12:\"section_list\";a:1:{s:10:\"price_list\";i:1;}}s:5:\"style\";a:2:{s:18:\"section_list_style\";a:12:{s:13:\"heading_color\";i:1;s:29:\"heading_typography_typography\";i:1;s:28:\"heading_typography_font_size\";i:1;s:30:\"heading_typography_font_weight\";i:1;s:30:\"heading_typography_line_height\";i:1;s:33:\"description_typography_typography\";i:1;s:32:\"description_typography_font_size\";i:1;s:34:\"description_typography_font_weight\";i:1;s:16:\"separator_weight\";i:1;s:15:\"separator_color\";i:1;s:35:\"heading_typography_font_size_mobile\";i:1;s:33:\"description_typography_font_style\";i:1;}s:18:\"section_item_style\";a:1:{s:7:\"row_gap\";i:1;}}}}s:13:\"gallery-extra\";a:2:{s:5:\"count\";i:2;s:8:\"controls\";a:3:{s:7:\"content\";a:3:{s:15:\"section_gallery\";a:3:{s:12:\"gallery_type\";i:2;s:10:\"wp_gallery\";i:2;s:7:\"gallery\";i:2;}s:24:\"section_gallery_settings\";a:6:{s:14:\"thumbnail_size\";i:2;s:14:\"columns_mobile\";i:2;s:13:\"open_lightbox\";i:2;s:12:\"gallery_rand\";i:2;s:23:\"gallery_display_caption\";i:2;s:14:\"columns_tablet\";i:2;}s:20:\"section_gallery_tilt\";a:1:{s:9:\"tilt_axis\";i:2;}}s:5:\"style\";a:2:{s:22:\"section_gallery_layout\";a:8:{s:11:\"image_align\";i:2;s:20:\"image_vertical_align\";i:2;s:24:\"image_horizontal_spacing\";i:2;s:31:\"image_horizontal_spacing_mobile\";i:2;s:22:\"image_vertical_spacing\";i:2;s:29:\"image_vertical_spacing_mobile\";i:2;s:18:\"image_align_mobile\";i:2;s:27:\"image_vertical_align_mobile\";i:2;}s:21:\"section_hover_effects\";a:6:{s:27:\"image_transition_transition\";i:2;s:23:\"image_transition_easing\";i:2;s:11:\"image_scale\";i:2;s:17:\"image_scale_hover\";i:2;s:20:\"overlay_border_width\";i:2;s:20:\"overlay_border_color\";i:2;}}s:8:\"advanced\";a:2:{s:14:\"_section_style\";a:2:{s:14:\"_margin_mobile\";i:2;s:15:\"_padding_mobile\";i:2;}s:18:\"section_custom_css\";a:1:{s:10:\"custom_css\";i:2;}}}}s:4:\"form\";a:2:{s:5:\"count\";i:1;s:8:\"controls\";a:2:{s:7:\"content\";a:4:{s:19:\"section_form_fields\";a:2:{s:11:\"form_fields\";i:1;s:13:\"mark_required\";i:1;}s:21:\"section_submit_button\";a:5:{s:11:\"button_text\";i:1;s:11:\"button_size\";i:1;s:17:\"button_icon_align\";i:1;s:18:\"button_icon_indent\";i:1;s:20:\"selected_button_icon\";i:1;}s:13:\"section_email\";a:2:{s:13:\"form_metadata\";i:1;s:18:\"email_content_type\";i:1;}s:20:\"section_form_options\";a:3:{s:15:\"custom_messages\";i:1;s:15:\"success_message\";i:1;s:13:\"error_message\";i:1;}}s:5:\"style\";a:3:{s:18:\"section_form_style\";a:5:{s:7:\"row_gap\";i:1;s:11:\"label_color\";i:1;s:19:\"mark_required_color\";i:1;s:27:\"label_typography_typography\";i:1;s:26:\"label_typography_font_size\";i:1;}s:19:\"section_field_style\";a:6:{s:16:\"field_text_color\";i:1;s:27:\"field_typography_typography\";i:1;s:26:\"field_typography_font_size\";i:1;s:22:\"field_background_color\";i:1;s:18:\"field_border_color\";i:1;s:19:\"field_border_radius\";i:1;}s:20:\"section_button_style\";a:9:{s:23:\"button_background_color\";i:1;s:17:\"button_text_color\";i:1;s:28:\"button_typography_typography\";i:1;s:29:\"button_typography_font_family\";i:1;s:32:\"button_typography_text_transform\";i:1;s:20:\"button_border_radius\";i:1;s:29:\"button_background_hover_color\";i:1;s:18:\"button_hover_color\";i:1;s:22:\"button_hover_animation\";i:1;}}}}s:9:\"shortcode\";a:2:{s:5:\"count\";i:1;s:8:\"controls\";a:2:{s:7:\"content\";a:1:{s:17:\"section_shortcode\";a:1:{s:9:\"shortcode\";i:1;}}s:8:\"advanced\";a:1:{s:14:\"_section_style\";a:3:{s:7:\"_margin\";i:1;s:14:\"_margin_mobile\";i:1;s:15:\"_padding_mobile\";i:1;}}}}}s:7:\"wp-page\";a:11:{s:16:\"heading-extended\";a:2:{s:5:\"count\";i:1;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:13:\"section_title\";a:3:{s:5:\"title\";i:1;s:5:\"align\";i:1;s:12:\"align_mobile\";i:1;}}s:5:\"style\";a:3:{s:18:\"section_title_fill\";a:1:{s:11:\"title_color\";i:1;}s:18:\"section_title_type\";a:8:{s:21:\"typography_typography\";i:1;s:22:\"typography_font_family\";i:1;s:20:\"typography_font_size\";i:1;s:27:\"typography_font_size_mobile\";i:1;s:22:\"typography_font_weight\";i:1;s:21:\"typography_font_style\";i:1;s:22:\"typography_line_height\";i:1;s:25:\"typography_letter_spacing\";i:1;}s:20:\"section_title_shadow\";a:6:{s:37:\"title_classic_shadow_text_shadow_type\";i:1;s:32:\"title_classic_shadow_text_shadow\";i:1;s:24:\"title_long_shadow_enable\";i:1;s:23:\"title_long_shadow_color\";i:1;s:22:\"title_long_shadow_size\";i:1;s:27:\"title_long_shadow_direction\";i:1;}}s:8:\"advanced\";a:5:{s:14:\"_section_style\";a:4:{s:7:\"_margin\";i:1;s:14:\"_margin_mobile\";i:1;s:8:\"_padding\";i:1;s:12:\"_css_classes\";i:1;}s:15:\"section_effects\";a:2:{s:17:\"_animation_mobile\";i:1;s:18:\"animation_duration\";i:1;}s:19:\"_section_background\";a:1:{s:22:\"_background_background\";i:1;}s:15:\"_section_border\";a:1:{s:14:\"_border_radius\";i:1;}s:33:\"section_elementor_extras_advanced\";a:3:{s:13:\"sticky_enable\";i:1;s:13:\"sticky_offset\";i:1;s:20:\"sticky_offset_bottom\";i:1;}}}}s:6:\"column\";a:2:{s:5:\"count\";i:12;s:8:\"controls\";a:2:{s:6:\"layout\";a:1:{s:6:\"layout\";a:6:{s:19:\"_inline_size_tablet\";i:2;s:16:\"content_position\";i:2;s:23:\"content_position_mobile\";i:1;s:21:\"space_between_widgets\";i:5;s:12:\"_inline_size\";i:3;s:19:\"_inline_size_mobile\";i:1;}}s:8:\"advanced\";a:2:{s:16:\"section_advanced\";a:6:{s:13:\"margin_mobile\";i:5;s:14:\"padding_mobile\";i:7;s:7:\"padding\";i:6;s:6:\"margin\";i:8;s:13:\"margin_tablet\";i:1;s:14:\"padding_tablet\";i:3;}s:15:\"section_effects\";a:1:{s:16:\"animation_mobile\";i:1;}}}}s:7:\"section\";a:2:{s:5:\"count\";i:12;s:8:\"controls\";a:3:{s:6:\"layout\";a:2:{s:14:\"section_layout\";a:9:{s:6:\"layout\";i:8;s:6:\"height\";i:2;s:13:\"custom_height\";i:2;s:20:\"custom_height_mobile\";i:2;s:15:\"column_position\";i:2;s:3:\"gap\";i:7;s:20:\"custom_height_tablet\";i:2;s:15:\"stretch_section\";i:5;s:16:\"content_position\";i:5;}s:16:\"section_parallax\";a:1:{s:24:\"jet_parallax_layout_list\";i:12;}}s:5:\"style\";a:4:{s:18:\"section_background\";a:15:{s:21:\"background_background\";i:9;s:21:\"background_attachment\";i:2;s:17:\"background_repeat\";i:3;s:15:\"background_size\";i:3;s:19:\"background_position\";i:2;s:26:\"background_position_mobile\";i:2;s:24:\"background_repeat_mobile\";i:2;s:22:\"background_size_mobile\";i:2;s:23:\"background_image_tablet\";i:1;s:24:\"background_repeat_tablet\";i:2;s:22:\"background_size_tablet\";i:2;s:38:\"background_motion_fx_translateX_effect\";i:1;s:37:\"background_motion_fx_translateX_speed\";i:1;s:32:\"background_motion_fx_scale_speed\";i:1;s:16:\"background_color\";i:9;}s:26:\"section_background_overlay\";a:18:{s:29:\"background_overlay_background\";i:9;s:27:\"background_overlay_position\";i:4;s:29:\"background_overlay_attachment\";i:4;s:25:\"background_overlay_repeat\";i:4;s:23:\"background_overlay_size\";i:4;s:26:\"background_overlay_opacity\";i:4;s:24:\"background_overlay_image\";i:9;s:31:\"background_overlay_image_mobile\";i:4;s:31:\"background_overlay_image_tablet\";i:3;s:34:\"background_overlay_position_mobile\";i:3;s:32:\"background_overlay_repeat_mobile\";i:3;s:30:\"background_overlay_size_mobile\";i:3;s:30:\"background_overlay_xpos_mobile\";i:1;s:22:\"css_filters_css_filter\";i:1;s:22:\"css_filters_brightness\";i:1;s:20:\"css_filters_saturate\";i:1;s:34:\"background_overlay_position_tablet\";i:1;s:23:\"background_overlay_ypos\";i:1;}s:14:\"section_border\";a:4:{s:13:\"border_border\";i:6;s:12:\"border_width\";i:8;s:12:\"border_color\";i:8;s:13:\"border_radius\";i:1;}s:21:\"section_shape_divider\";a:5:{s:23:\"shape_divider_top_color\";i:1;s:23:\"shape_divider_top_width\";i:1;s:24:\"shape_divider_top_height\";i:1;s:26:\"shape_divider_top_negative\";i:1;s:31:\"shape_divider_top_above_content\";i:1;}}s:8:\"advanced\";a:3:{s:16:\"section_advanced\";a:7:{s:11:\"css_classes\";i:1;s:13:\"margin_mobile\";i:10;s:6:\"margin\";i:9;s:7:\"padding\";i:8;s:14:\"padding_mobile\";i:10;s:14:\"padding_tablet\";i:3;s:13:\"margin_tablet\";i:1;}s:15:\"section_effects\";a:2:{s:9:\"animation\";i:1;s:18:\"animation_duration\";i:1;}s:18:\"section_custom_css\";a:1:{s:10:\"custom_css\";i:2;}}}}s:7:\"heading\";a:2:{s:5:\"count\";i:8;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:13:\"section_title\";a:4:{s:5:\"title\";i:8;s:5:\"align\";i:8;s:12:\"align_mobile\";i:1;s:11:\"header_size\";i:1;}}s:5:\"style\";a:1:{s:19:\"section_title_style\";a:12:{s:11:\"title_color\";i:8;s:21:\"typography_typography\";i:8;s:22:\"typography_font_family\";i:8;s:20:\"typography_font_size\";i:8;s:22:\"typography_font_weight\";i:8;s:27:\"typography_font_size_mobile\";i:8;s:25:\"typography_text_transform\";i:6;s:28:\"text_shadow_text_shadow_type\";i:6;s:23:\"text_shadow_text_shadow\";i:6;s:27:\"typography_font_size_tablet\";i:6;s:29:\"typography_line_height_mobile\";i:1;s:22:\"typography_line_height\";i:1;}}s:8:\"advanced\";a:2:{s:14:\"_section_style\";a:4:{s:8:\"_padding\";i:7;s:7:\"_margin\";i:8;s:15:\"_padding_tablet\";i:1;s:15:\"_padding_mobile\";i:1;}s:19:\"_section_background\";a:1:{s:22:\"_background_background\";i:1;}}}}s:11:\"text-editor\";a:2:{s:5:\"count\";i:3;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:14:\"section_editor\";a:1:{s:6:\"editor\";i:3;}}s:5:\"style\";a:1:{s:13:\"section_style\";a:10:{s:5:\"align\";i:3;s:10:\"text_color\";i:3;s:21:\"typography_typography\";i:3;s:20:\"typography_font_size\";i:3;s:22:\"typography_font_weight\";i:3;s:22:\"typography_line_height\";i:3;s:12:\"align_mobile\";i:3;s:21:\"typography_font_style\";i:3;s:22:\"typography_font_family\";i:3;s:27:\"typography_font_size_mobile\";i:3;}}s:8:\"advanced\";a:1:{s:14:\"_section_style\";a:4:{s:7:\"_margin\";i:3;s:14:\"_margin_mobile\";i:3;s:15:\"_padding_mobile\";i:3;s:12:\"_css_classes\";i:3;}}}}s:14:\"jet-inline-svg\";a:2:{s:5:\"count\";i:4;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:19:\"section_svg_content\";a:1:{s:7:\"svg_url\";i:4;}}s:5:\"style\";a:1:{s:17:\"section_svg_style\";a:4:{s:16:\"svg_custom_width\";i:4;s:9:\"svg_width\";i:4;s:16:\"svg_custom_color\";i:4;s:9:\"svg_color\";i:4;}}s:8:\"advanced\";a:1:{s:14:\"_section_style\";a:1:{s:7:\"_margin\";i:3;}}}}s:10:\"price-list\";a:2:{s:5:\"count\";i:2;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:12:\"section_list\";a:1:{s:10:\"price_list\";i:2;}}s:5:\"style\";a:2:{s:18:\"section_list_style\";a:15:{s:13:\"heading_color\";i:2;s:29:\"heading_typography_typography\";i:2;s:28:\"heading_typography_font_size\";i:2;s:30:\"heading_typography_font_weight\";i:2;s:30:\"heading_typography_line_height\";i:2;s:33:\"description_typography_typography\";i:2;s:32:\"description_typography_font_size\";i:2;s:34:\"description_typography_font_weight\";i:2;s:16:\"separator_weight\";i:2;s:15:\"separator_color\";i:2;s:35:\"heading_typography_font_size_mobile\";i:2;s:33:\"description_typography_font_style\";i:2;s:17:\"description_color\";i:2;s:34:\"description_typography_line_height\";i:2;s:30:\"heading_typography_font_family\";i:2;}s:18:\"section_item_style\";a:1:{s:7:\"row_gap\";i:2;}}s:8:\"advanced\";a:1:{s:14:\"_section_style\";a:4:{s:14:\"_margin_tablet\";i:2;s:15:\"_padding_tablet\";i:2;s:14:\"_margin_mobile\";i:1;s:15:\"_padding_mobile\";i:1;}}}}s:13:\"gallery-extra\";a:2:{s:5:\"count\";i:1;s:8:\"controls\";a:2:{s:7:\"content\";a:2:{s:15:\"section_gallery\";a:2:{s:12:\"gallery_type\";i:1;s:7:\"gallery\";i:1;}s:24:\"section_gallery_settings\";a:4:{s:7:\"columns\";i:1;s:13:\"open_lightbox\";i:1;s:23:\"gallery_display_caption\";i:1;s:14:\"columns_mobile\";i:1;}}s:5:\"style\";a:3:{s:22:\"section_gallery_layout\";a:6:{s:11:\"image_align\";i:1;s:20:\"image_vertical_align\";i:1;s:24:\"image_horizontal_spacing\";i:1;s:22:\"image_vertical_spacing\";i:1;s:31:\"image_horizontal_spacing_mobile\";i:1;s:29:\"image_vertical_spacing_mobile\";i:1;}s:22:\"section_gallery_images\";a:3:{s:19:\"image_border_border\";i:1;s:18:\"image_border_width\";i:1;s:18:\"image_border_color\";i:1;}s:21:\"section_hover_effects\";a:9:{s:27:\"image_transition_transition\";i:1;s:23:\"image_transition_easing\";i:1;s:25:\"image_transition_duration\";i:1;s:11:\"image_scale\";i:1;s:17:\"image_scale_hover\";i:1;s:20:\"image_opacity_mobile\";i:1;s:18:\"image_scale_mobile\";i:1;s:26:\"image_opacity_hover_mobile\";i:1;s:24:\"image_scale_hover_mobile\";i:1;}}}}s:9:\"icon-list\";a:2:{s:5:\"count\";i:1;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:12:\"section_icon\";a:1:{s:9:\"icon_list\";i:1;}}s:5:\"style\";a:3:{s:17:\"section_icon_list\";a:2:{s:13:\"space_between\";i:1;s:10:\"icon_align\";i:1;}s:18:\"section_icon_style\";a:2:{s:10:\"icon_color\";i:1;s:9:\"icon_size\";i:1;}s:18:\"section_text_style\";a:6:{s:10:\"text_color\";i:1;s:26:\"icon_typography_typography\";i:1;s:27:\"icon_typography_font_family\";i:1;s:25:\"icon_typography_font_size\";i:1;s:27:\"icon_typography_font_weight\";i:1;s:32:\"icon_typography_font_size_mobile\";i:1;}}s:8:\"advanced\";a:1:{s:14:\"_section_style\";a:5:{s:7:\"_margin\";i:1;s:8:\"_padding\";i:1;s:14:\"_margin_mobile\";i:1;s:15:\"_padding_tablet\";i:1;s:15:\"_padding_mobile\";i:1;}}}}s:4:\"form\";a:2:{s:5:\"count\";i:2;s:8:\"controls\";a:2:{s:7:\"content\";a:4:{s:19:\"section_form_fields\";a:2:{s:11:\"form_fields\";i:2;s:13:\"mark_required\";i:2;}s:21:\"section_submit_button\";a:5:{s:11:\"button_text\";i:2;s:11:\"button_size\";i:2;s:17:\"button_icon_align\";i:2;s:18:\"button_icon_indent\";i:2;s:20:\"selected_button_icon\";i:2;}s:13:\"section_email\";a:2:{s:13:\"form_metadata\";i:2;s:18:\"email_content_type\";i:2;}s:20:\"section_form_options\";a:3:{s:15:\"custom_messages\";i:2;s:15:\"success_message\";i:2;s:13:\"error_message\";i:2;}}s:5:\"style\";a:3:{s:18:\"section_form_style\";a:9:{s:7:\"row_gap\";i:2;s:11:\"label_color\";i:2;s:19:\"mark_required_color\";i:2;s:27:\"label_typography_typography\";i:2;s:26:\"label_typography_font_size\";i:2;s:28:\"label_typography_font_family\";i:2;s:28:\"label_typography_font_weight\";i:2;s:28:\"label_typography_line_height\";i:2;s:33:\"label_typography_font_size_mobile\";i:2;}s:19:\"section_field_style\";a:9:{s:16:\"field_text_color\";i:2;s:27:\"field_typography_typography\";i:2;s:26:\"field_typography_font_size\";i:2;s:22:\"field_background_color\";i:2;s:18:\"field_border_color\";i:2;s:19:\"field_border_radius\";i:2;s:28:\"field_typography_font_family\";i:2;s:33:\"field_typography_font_size_mobile\";i:2;s:28:\"field_typography_font_weight\";i:2;}s:20:\"section_button_style\";a:12:{s:23:\"button_background_color\";i:2;s:17:\"button_text_color\";i:2;s:28:\"button_typography_typography\";i:2;s:29:\"button_typography_font_family\";i:2;s:32:\"button_typography_text_transform\";i:2;s:20:\"button_border_radius\";i:2;s:29:\"button_background_hover_color\";i:2;s:18:\"button_hover_color\";i:2;s:22:\"button_hover_animation\";i:2;s:20:\"button_border_border\";i:2;s:26:\"button_border_width_mobile\";i:2;s:19:\"button_border_color\";i:2;}}}}s:7:\"divider\";a:2:{s:5:\"count\";i:1;s:8:\"controls\";a:0:{}}}}", "no");
INSERT INTO `wp_464683_options` VALUES("373", "elementor_pro_theme_builder_conditions", "a:0:{}", "yes");
INSERT INTO `wp_464683_options` VALUES("374", "elementor_fonts_manager_font_types", "a:0:{}", "yes");
INSERT INTO `wp_464683_options` VALUES("375", "elementor_fonts_manager_fonts", "a:0:{}", "yes");
INSERT INTO `wp_464683_options` VALUES("376", "_elementor_general_settings", "a:3:{s:21:\"default_generic_fonts\";s:10:\"Sans-serif\";s:15:\"container_width\";s:4:\"1260\";s:21:\"global_image_lightbox\";s:3:\"yes\";}", "yes");
INSERT INTO `wp_464683_options` VALUES("377", "_elementor_settings_update_time", "1573309310", "yes");
INSERT INTO `wp_464683_options` VALUES("378", "elementor_cpt_support", "a:2:{i:0;s:4:\"post\";i:1;s:4:\"page\";}", "yes");
INSERT INTO `wp_464683_options` VALUES("379", "elementor_disable_color_schemes", "", "yes");
INSERT INTO `wp_464683_options` VALUES("380", "elementor_disable_typography_schemes", "", "yes");
INSERT INTO `wp_464683_options` VALUES("381", "elementor_allow_tracking", "no", "yes");
INSERT INTO `wp_464683_options` VALUES("382", "elementor_default_generic_fonts", "Sans-serif", "yes");
INSERT INTO `wp_464683_options` VALUES("383", "elementor_container_width", "1260", "yes");
INSERT INTO `wp_464683_options` VALUES("384", "elementor_space_between_widgets", "", "yes");
INSERT INTO `wp_464683_options` VALUES("385", "elementor_stretched_section_container", "", "yes");
INSERT INTO `wp_464683_options` VALUES("386", "elementor_page_title_selector", "", "yes");
INSERT INTO `wp_464683_options` VALUES("387", "elementor_viewport_lg", "", "yes");
INSERT INTO `wp_464683_options` VALUES("389", "elementor_viewport_md", "900", "yes");
INSERT INTO `wp_464683_options` VALUES("390", "elementor_global_image_lightbox", "yes", "yes");
INSERT INTO `wp_464683_options` VALUES("391", "elementor_pro_recaptcha_site_key", "", "yes");
INSERT INTO `wp_464683_options` VALUES("392", "elementor_pro_recaptcha_secret_key", "", "yes");
INSERT INTO `wp_464683_options` VALUES("393", "elementor_pro_recaptcha_v3_site_key", "", "yes");
INSERT INTO `wp_464683_options` VALUES("394", "elementor_pro_recaptcha_v3_secret_key", "", "yes");
INSERT INTO `wp_464683_options` VALUES("395", "elementor_pro_recaptcha_v3_threshold", "0.5", "yes");
INSERT INTO `wp_464683_options` VALUES("396", "elementor_pro_facebook_app_id", "", "yes");
INSERT INTO `wp_464683_options` VALUES("397", "elementor_pro_mailchimp_api_key", "", "yes");
INSERT INTO `wp_464683_options` VALUES("398", "elementor_validate_api_data", "", "yes");
INSERT INTO `wp_464683_options` VALUES("399", "elementor_pro_drip_api_token", "", "yes");
INSERT INTO `wp_464683_options` VALUES("400", "elementor_pro_activecampaign_api_key", "", "yes");
INSERT INTO `wp_464683_options` VALUES("401", "elementor_pro_activecampaign_api_url", "", "yes");
INSERT INTO `wp_464683_options` VALUES("402", "elementor_pro_getresponse_api_key", "", "yes");
INSERT INTO `wp_464683_options` VALUES("403", "elementor_pro_convertkit_api_key", "", "yes");
INSERT INTO `wp_464683_options` VALUES("404", "elementor_pro_mailerlite_api_key", "", "yes");
INSERT INTO `wp_464683_options` VALUES("405", "elementor_typekit-kit-id", "", "yes");
INSERT INTO `wp_464683_options` VALUES("406", "elementor_font_awesome_pro_kit_id", "", "yes");
INSERT INTO `wp_464683_options` VALUES("407", "elementor_css_print_method", "external", "yes");
INSERT INTO `wp_464683_options` VALUES("408", "elementor_editor_break_lines", "", "yes");
INSERT INTO `wp_464683_options` VALUES("409", "elementor_edit_buttons", "", "yes");
INSERT INTO `wp_464683_options` VALUES("410", "elementor_allow_svg", "", "yes");
INSERT INTO `wp_464683_options` VALUES("411", "elementor_load_fa4_shim", "", "yes");
INSERT INTO `wp_464683_options` VALUES("412", "elementor_scheme_color", "a:4:{i:1;s:7:\"#6ec1e4\";i:2;s:7:\"#54595f\";i:3;s:7:\"#7a7a7a\";i:4;s:7:\"#61ce70\";}", "yes");
INSERT INTO `wp_464683_options` VALUES("413", "elementor_scheme_typography", "a:4:{i:1;a:2:{s:11:\"font_family\";s:6:\"Roboto\";s:11:\"font_weight\";s:3:\"600\";}i:2;a:2:{s:11:\"font_family\";s:11:\"Roboto Slab\";s:11:\"font_weight\";s:3:\"400\";}i:3;a:2:{s:11:\"font_family\";s:10:\"Montserrat\";s:11:\"font_weight\";s:3:\"400\";}i:4;a:2:{s:11:\"font_family\";s:6:\"Roboto\";s:11:\"font_weight\";s:3:\"500\";}}", "yes");
INSERT INTO `wp_464683_options` VALUES("414", "elementor_scheme_color-picker", "a:8:{i:1;s:7:\"#6ec1e4\";i:2;s:7:\"#54595f\";i:3;s:7:\"#7a7a7a\";i:4;s:7:\"#61ce70\";i:5;s:7:\"#4054b2\";i:6;s:7:\"#23a455\";i:7;s:4:\"#000\";i:8;s:4:\"#fff\";}", "yes");
INSERT INTO `wp_464683_options` VALUES("415", "elementor-custom-breakpoints-files", "a:2:{s:19:\"custom-frontend.min\";a:1:{s:4:\"time\";i:1573309324;}s:23:\"custom-pro-frontend.min\";a:1:{s:4:\"time\";i:1573309324;}}", "yes");
INSERT INTO `wp_464683_options` VALUES("418", "elementor_log", "a:4:{s:32:\"e1d3a5a20a9b6c1872a17896b84c3f1c\";O:31:\"Elementor\\Core\\Logger\\Items\\PHP\":9:{s:7:\"\0*\0file\";s:115:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content/plugins/elementor/includes/controls/gallery.php\";s:7:\"\0*\0line\";i:57;s:7:\"\0*\0date\";s:19:\"2019-11-09 06:22:27\";s:7:\"\0*\0type\";s:7:\"warning\";s:10:\"\0*\0message\";s:60:\"array_filter() expects parameter 1 to be array, string given\";s:7:\"\0*\0meta\";a:1:{s:5:\"trace\";a:1:{i:0;a:3:{s:8:\"function\";s:8:\"shutdown\";s:5:\"class\";s:29:\"Elementor\\Core\\Logger\\Manager\";s:4:\"type\";s:2:\"->\";}}}s:8:\"\0*\0times\";i:1;s:14:\"\0*\0times_dates\";a:1:{i:0;s:19:\"2019-11-09 06:22:27\";}s:7:\"\0*\0args\";a:5:{s:4:\"type\";s:7:\"warning\";s:7:\"message\";s:60:\"array_filter() expects parameter 1 to be array, string given\";s:4:\"file\";s:115:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content/plugins/elementor/includes/controls/gallery.php\";s:4:\"line\";i:57;s:5:\"trace\";b:1;}}s:32:\"6f1cbcc026fb9f7e9d90b59a8bb4e172\";O:30:\"Elementor\\Core\\Logger\\Items\\JS\":10:{s:9:\"\0*\0column\";s:5:\"39895\";s:7:\"\0*\0file\";s:91:\"https://emilyhunt.ch/wp-content/plugins/elementor/assets/js/editor-modules.min.js?ver=2.7.5\";s:7:\"\0*\0line\";s:1:\"2\";s:7:\"\0*\0date\";s:19:\"2019-11-09 14:53:15\";s:7:\"\0*\0type\";s:5:\"error\";s:10:\"\0*\0message\";s:43:\"n.attributes[e.name].each is not a function\";s:7:\"\0*\0meta\";a:0:{}s:8:\"\0*\0times\";i:1;s:14:\"\0*\0times_dates\";a:1:{i:0;s:19:\"2019-11-09 14:53:15\";}s:7:\"\0*\0args\";a:6:{s:4:\"type\";s:5:\"error\";s:9:\"timestamp\";s:10:\"1573311195\";s:7:\"message\";s:43:\"n.attributes[e.name].each is not a function\";s:3:\"url\";s:91:\"https://emilyhunt.ch/wp-content/plugins/elementor/assets/js/editor-modules.min.js?ver=2.7.5\";s:4:\"line\";s:1:\"2\";s:6:\"column\";s:5:\"39895\";}}s:32:\"d537f168953909d1df5aafbd7bdc0052\";O:30:\"Elementor\\Core\\Logger\\Items\\JS\":10:{s:9:\"\0*\0column\";s:5:\"20270\";s:7:\"\0*\0file\";s:83:\"https://emilyhunt.ch/wp-content/plugins/elementor/assets/js/editor.min.js?ver=2.7.5\";s:7:\"\0*\0line\";s:1:\"7\";s:7:\"\0*\0date\";s:19:\"2019-11-09 15:24:33\";s:7:\"\0*\0type\";s:5:\"error\";s:10:\"\0*\0message\";s:58:\"Cannot read property \\&#039;noUiSlider\\&#039; of undefined\";s:7:\"\0*\0meta\";a:0:{}s:8:\"\0*\0times\";i:4;s:14:\"\0*\0times_dates\";a:4:{i:0;s:19:\"2019-11-09 15:24:33\";i:1;s:19:\"2019-11-09 15:25:03\";i:2;s:19:\"2019-11-09 16:04:54\";i:3;s:19:\"2019-11-09 16:06:24\";}s:7:\"\0*\0args\";a:6:{s:4:\"type\";s:5:\"error\";s:9:\"timestamp\";s:10:\"1573313073\";s:7:\"message\";s:48:\"Cannot read property \\\'noUiSlider\\\' of undefined\";s:3:\"url\";s:83:\"https://emilyhunt.ch/wp-content/plugins/elementor/assets/js/editor.min.js?ver=2.7.5\";s:4:\"line\";s:1:\"7\";s:6:\"column\";s:5:\"20270\";}}s:32:\"284434206d88c396322880f310d2ed01\";O:30:\"Elementor\\Core\\Logger\\Items\\JS\":10:{s:9:\"\0*\0column\";s:5:\"28632\";s:7:\"\0*\0file\";s:87:\"https://emilyhunt.ch/wp-content/plugins/elementor-pro/assets/js/editor.min.js?ver=2.7.3\";s:7:\"\0*\0line\";s:1:\"2\";s:7:\"\0*\0date\";s:19:\"2019-11-09 16:15:38\";s:7:\"\0*\0type\";s:5:\"error\";s:10:\"\0*\0message\";s:56:\"Cannot read property \\&#039;children\\&#039; of undefined\";s:7:\"\0*\0meta\";a:0:{}s:8:\"\0*\0times\";i:1;s:14:\"\0*\0times_dates\";a:1:{i:0;s:19:\"2019-11-09 16:15:38\";}s:7:\"\0*\0args\";a:6:{s:4:\"type\";s:5:\"error\";s:9:\"timestamp\";s:10:\"1573316138\";s:7:\"message\";s:46:\"Cannot read property \\\'children\\\' of undefined\";s:3:\"url\";s:87:\"https://emilyhunt.ch/wp-content/plugins/elementor-pro/assets/js/editor.min.js?ver=2.7.3\";s:4:\"line\";s:1:\"2\";s:6:\"column\";s:5:\"28632\";}}}", "no");
INSERT INTO `wp_464683_options` VALUES("419", "_elementor_scheme_last_updated", "1573309389", "yes");
INSERT INTO `wp_464683_options` VALUES("425", "duplicator_ui_view_state", "a:1:{s:22:\"dup-pack-archive-panel\";s:1:\"1\";}", "yes");
INSERT INTO `wp_464683_options` VALUES("426", "duplicator_package_active", "O:11:\"DUP_Package\":25:{s:7:\"Created\";s:19:\"2019-11-10 10:12:29\";s:7:\"Version\";s:6:\"1.3.22\";s:9:\"VersionWP\";s:5:\"5.2.4\";s:9:\"VersionDB\";s:6:\"5.7.26\";s:10:\"VersionPHP\";s:6:\"7.2.24\";s:9:\"VersionOS\";s:5:\"Linux\";s:2:\"ID\";N;s:4:\"Name\";s:18:\"20191109_emilyhunt\";s:4:\"Hash\";s:35:\"8e5327c6e4444f5b4285_20191110101229\";s:8:\"NameHash\";s:54:\"20191109_emilyhunt_8e5327c6e4444f5b4285_20191110101229\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:73:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-snapshots/tmp\";s:8:\"StoreURL\";s:34:\"https://emilyhunt.ch/wp-snapshots/\";s:8:\"ScanFile\";s:64:\"20191109_emilyhunt_8e5327c6e4444f5b4285_20191110101229_scan.json\";s:10:\"TimerStart\";i:-1;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";i:0;s:6:\"WPUser\";N;s:7:\"Archive\";O:11:\"DUP_Archive\":21:{s:10:\"FilterDirs\";s:74:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content/cache;\";s:11:\"FilterFiles\";s:0:\"\";s:10:\"FilterExts\";s:22:\"zip;rar;tar;gz;bz2;7z;\";s:13:\"FilterDirsAll\";a:0:{}s:14:\"FilterFilesAll\";a:0:{}s:13:\"FilterExtsAll\";a:0:{}s:8:\"FilterOn\";i:1;s:12:\"ExportOnlyDB\";i:0;s:4:\"File\";N;s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:56:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt\";s:4:\"Size\";i:0;s:4:\"Dirs\";a:0:{}s:5:\"Files\";a:0:{}s:10:\"FilterInfo\";O:23:\"DUP_Archive_Filter_Info\":8:{s:4:\"Dirs\";O:34:\"DUP_Archive_Filter_Scope_Directory\":5:{s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:5:\"Files\";O:29:\"DUP_Archive_Filter_Scope_File\":6:{s:4:\"Size\";a:0:{}s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:4:\"Exts\";O:29:\"DUP_Archive_Filter_Scope_Base\":3:{s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:9:\"UDirCount\";i:0;s:10:\"UFileCount\";i:0;s:9:\"UExtCount\";i:0;s:8:\"TreeSize\";a:0:{}s:11:\"TreeWarning\";a:0:{}}s:14:\"RecursiveLinks\";a:0:{}s:10:\"file_count\";i:-1;s:10:\"\0*\0Package\";O:11:\"DUP_Package\":25:{s:7:\"Created\";s:19:\"2019-11-10 10:12:29\";s:7:\"Version\";s:6:\"1.3.22\";s:9:\"VersionWP\";s:5:\"5.2.4\";s:9:\"VersionDB\";s:6:\"5.7.26\";s:10:\"VersionPHP\";s:6:\"7.2.24\";s:9:\"VersionOS\";s:5:\"Linux\";s:2:\"ID\";N;s:4:\"Name\";s:18:\"20191109_emilyhunt\";s:4:\"Hash\";s:35:\"8e5327c6e4444f5b4285_20191110101229\";s:8:\"NameHash\";s:54:\"20191109_emilyhunt_8e5327c6e4444f5b4285_20191110101229\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:73:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-snapshots/tmp\";s:8:\"StoreURL\";s:34:\"https://emilyhunt.ch/wp-snapshots/\";s:8:\"ScanFile\";N;s:10:\"TimerStart\";i:-1;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";i:0;s:6:\"WPUser\";N;s:7:\"Archive\";r:23;s:9:\"Installer\";O:13:\"DUP_Installer\":11:{s:4:\"File\";N;s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBPort\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:12:\"OptsSecureOn\";i:0;s:14:\"OptsSecurePass\";s:0:\"\";s:13:\"numFilesAdded\";i:0;s:12:\"numDirsAdded\";i:0;s:10:\"\0*\0Package\";r:63;}s:8:\"Database\";O:12:\"DUP_Database\":14:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";N;s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"Compatible\";s:0:\"\";s:8:\"Comments\";s:28:\"MySQL Community Server (GPL)\";s:4:\"info\";O:16:\"DUP_DatabaseInfo\":15:{s:9:\"buildMode\";N;s:13:\"collationList\";a:0:{}s:17:\"isTablesUpperCase\";N;s:15:\"isNameUpperCase\";N;s:4:\"name\";N;s:15:\"tablesBaseCount\";N;s:16:\"tablesFinalCount\";N;s:14:\"tablesRowCount\";N;s:16:\"tablesSizeOnDisk\";N;s:18:\"varLowerCaseTables\";i:0;s:7:\"version\";N;s:14:\"versionComment\";N;s:18:\"tableWiseRowCounts\";a:0:{}s:33:\"\0DUP_DatabaseInfo\0intFieldsStruct\";a:0:{}s:42:\"\0DUP_DatabaseInfo\0indexProcessedSchemaSize\";a:0:{}}s:10:\"\0*\0Package\";r:63;s:25:\"\0DUP_Database\0dbStorePath\";N;s:23:\"\0DUP_Database\0EOFMarker\";s:0:\"\";s:26:\"\0DUP_Database\0networkFlush\";b:0;}s:13:\"BuildProgress\";O:18:\"DUP_Build_Progress\":12:{s:17:\"thread_start_time\";N;s:11:\"initialized\";b:0;s:15:\"installer_built\";b:0;s:15:\"archive_started\";b:0;s:20:\"archive_has_database\";b:0;s:13:\"archive_built\";b:0;s:21:\"database_script_built\";b:0;s:6:\"failed\";b:0;s:7:\"retries\";i:0;s:14:\"build_failures\";a:0:{}s:19:\"validation_failures\";a:0:{}s:27:\"\0DUP_Build_Progress\0package\";r:63;}}s:29:\"\0DUP_Archive\0tmpFilterDirsAll\";a:0:{}s:24:\"\0DUP_Archive\0wpCorePaths\";a:5:{i:0;s:65:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-admin\";i:1;s:75:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content/uploads\";i:2;s:77:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content/languages\";i:3;s:74:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content/themes\";i:4;s:68:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-includes\";}s:29:\"\0DUP_Archive\0wpCoreExactPaths\";a:2:{i:0;s:56:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt\";i:1;s:67:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content\";}}s:9:\"Installer\";r:86;s:8:\"Database\";r:98;s:13:\"BuildProgress\";r:128;}", "yes");
INSERT INTO `wp_464683_options` VALUES("438", "_elementor_global_css", "a:5:{s:4:\"time\";i:1573317279;s:5:\"fonts\";a:3:{i:0;s:6:\"Roboto\";i:1;s:10:\"Montserrat\";i:4;s:11:\"Roboto Slab\";}s:5:\"icons\";a:0:{}s:6:\"status\";s:4:\"file\";i:0;b:0;}", "yes");
INSERT INTO `wp_464683_options` VALUES("456", "bsr_data", "a:8:{s:13:\"select_tables\";a:20:{i:0;s:21:\"wp_464683_commentmeta\";i:1;s:18:\"wp_464683_comments\";i:2;s:21:\"wp_464683_cpd_counter\";i:3;s:29:\"wp_464683_duplicator_packages\";i:4;s:35:\"wp_464683_itsec_distributed_storage\";i:5;s:28:\"wp_464683_itsec_fingerprints\";i:6;s:33:\"wp_464683_itsec_geolocation_cache\";i:7;s:24:\"wp_464683_itsec_lockouts\";i:8;s:20:\"wp_464683_itsec_logs\";i:9;s:20:\"wp_464683_itsec_temp\";i:10;s:15:\"wp_464683_links\";i:11;s:17:\"wp_464683_options\";i:12;s:18:\"wp_464683_postmeta\";i:13;s:15:\"wp_464683_posts\";i:14;s:28:\"wp_464683_term_relationships\";i:15;s:23:\"wp_464683_term_taxonomy\";i:16;s:18:\"wp_464683_termmeta\";i:17;s:15:\"wp_464683_terms\";i:18;s:18:\"wp_464683_usermeta\";i:19;s:15:\"wp_464683_users\";}s:16:\"case_insensitive\";s:2:\"on\";s:13:\"replace_guids\";s:3:\"off\";s:7:\"dry_run\";s:3:\"off\";s:10:\"search_for\";s:5:\"Nixon\";s:12:\"replace_with\";s:4:\"Hunt\";s:15:\"completed_pages\";i:20;s:11:\"total_pages\";i:20;}", "yes");
INSERT INTO `wp_464683_options` VALUES("476", "options-404-redirect-group", "a:5:{s:16:\"p404_redirect_to\";s:20:\"https://emilyhunt.ch\";s:11:\"p404_status\";s:1:\"1\";s:5:\"links\";i:71;s:12:\"install_date\";s:19:\"2019-11-09 04:55 pm\";s:16:\"redirected_links\";a:20:{i:0;a:2:{s:4:\"link\";s:73:\"https://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6651.jpg\";s:4:\"date\";s:19:\"2019-11-10 10:11 am\";}i:1;a:2:{s:4:\"link\";s:73:\"https://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6651.jpg\";s:4:\"date\";s:19:\"2019-11-10 10:11 am\";}i:2;a:2:{s:4:\"link\";s:73:\"https://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6651.jpg\";s:4:\"date\";s:19:\"2019-11-10 10:11 am\";}i:3;a:2:{s:4:\"link\";s:73:\"https://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6651.jpg\";s:4:\"date\";s:19:\"2019-11-10 10:10 am\";}i:4;a:2:{s:4:\"link\";s:73:\"https://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6651.jpg\";s:4:\"date\";s:19:\"2019-11-10 10:06 am\";}i:5;a:2:{s:4:\"link\";s:73:\"https://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6651.jpg\";s:4:\"date\";s:19:\"2019-11-10 10:06 am\";}i:6;a:2:{s:4:\"link\";s:73:\"https://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6651.jpg\";s:4:\"date\";s:19:\"2019-11-10 10:04 am\";}i:7;a:2:{s:4:\"link\";s:53:\"https://emilyhunt.ch/MeetMissEmilyHunt@protonmail.com\";s:4:\"date\";s:19:\"2019-11-10 10:04 am\";}i:8;a:2:{s:4:\"link\";s:73:\"https://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6651.jpg\";s:4:\"date\";s:19:\"2019-11-10 10:03 am\";}i:9;a:2:{s:4:\"link\";s:73:\"https://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6651.jpg\";s:4:\"date\";s:19:\"2019-11-10 10:02 am\";}i:10;a:2:{s:4:\"link\";s:73:\"https://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6651.jpg\";s:4:\"date\";s:19:\"2019-11-10 10:01 am\";}i:11;a:2:{s:4:\"link\";s:73:\"https://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6651.jpg\";s:4:\"date\";s:19:\"2019-11-10 10:00 am\";}i:12;a:2:{s:4:\"link\";s:73:\"https://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6651.jpg\";s:4:\"date\";s:19:\"2019-11-10 10:00 am\";}i:13;a:2:{s:4:\"link\";s:73:\"https://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6651.jpg\";s:4:\"date\";s:19:\"2019-11-10 10:00 am\";}i:14;a:2:{s:4:\"link\";s:73:\"https://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6651.jpg\";s:4:\"date\";s:19:\"2019-11-10 10:00 am\";}i:15;a:2:{s:4:\"link\";s:73:\"https://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6651.jpg\";s:4:\"date\";s:19:\"2019-11-10 10:00 am\";}i:16;a:2:{s:4:\"link\";s:73:\"https://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6651.jpg\";s:4:\"date\";s:19:\"2019-11-10 09:59 am\";}i:17;a:2:{s:4:\"link\";s:73:\"https://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6651.jpg\";s:4:\"date\";s:19:\"2019-11-10 09:59 am\";}i:18;a:2:{s:4:\"link\";s:73:\"https://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6651.jpg\";s:4:\"date\";s:19:\"2019-11-10 09:59 am\";}i:19;a:2:{s:4:\"link\";s:73:\"https://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6651.jpg\";s:4:\"date\";s:19:\"2019-11-10 09:59 am\";}}}", "yes");
INSERT INTO `wp_464683_options` VALUES("594", "_site_transient_timeout_itsec_wp_upload_dir", "1573467127", "no");
INSERT INTO `wp_464683_options` VALUES("595", "_site_transient_itsec_wp_upload_dir", "a:6:{s:4:\"path\";s:83:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content/uploads/2019/11\";s:3:\"url\";s:46:\"http://emilyhunt.ch/wp-content/uploads/2019/11\";s:6:\"subdir\";s:8:\"/2019/11\";s:7:\"basedir\";s:75:\"/home/clients/64ed22e7ae8be26a5d4b87612698f5f1/emilyhunt/wp-content/uploads\";s:7:\"baseurl\";s:38:\"http://emilyhunt.ch/wp-content/uploads\";s:5:\"error\";b:0;}", "no");
INSERT INTO `wp_464683_options` VALUES("596", "_transient_timeout_elementor_extras_license_data", "1573423930", "no");
INSERT INTO `wp_464683_options` VALUES("597", "_transient_elementor_extras_license_data", "a:13:{s:7:\"success\";b:1;s:7:\"license\";s:5:\"valid\";s:7:\"item_id\";b:0;s:9:\"item_name\";s:16:\"Elementor+Extras\";s:8:\"checksum\";s:32:\"d28fe2308d4b41d255a24ff439d4e470\";s:7:\"expires\";s:19:\"2020-11-18 23:59:59\";s:10:\"payment_id\";i:50916;s:13:\"customer_name\";s:12:\"Simon Verdon\";s:14:\"customer_email\";s:14:\"simv@pobox.com\";s:13:\"license_limit\";i:0;s:10:\"site_count\";i:82;s:16:\"activations_left\";s:9:\"unlimited\";s:8:\"price_id\";s:1:\"2\";}", "no");
INSERT INTO `wp_464683_options` VALUES("598", "_transient_timeout_hmbkp_schedules", "1573985530", "no");
INSERT INTO `wp_464683_options` VALUES("599", "_transient_hmbkp_schedules", "a:2:{i:0;s:25:\"hmbkp_schedule_1573308761\";i:1;s:25:\"hmbkp_schedule_1573308762\";}", "no");
INSERT INTO `wp_464683_options` VALUES("600", "_site_transient_update_core", "O:8:\"stdClass\":4:{s:7:\"updates\";a:1:{i:0;O:8:\"stdClass\":10:{s:8:\"response\";s:6:\"latest\";s:8:\"download\";s:59:\"https://downloads.wordpress.org/release/wordpress-5.2.4.zip\";s:6:\"locale\";s:5:\"en_US\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:59:\"https://downloads.wordpress.org/release/wordpress-5.2.4.zip\";s:10:\"no_content\";s:70:\"https://downloads.wordpress.org/release/wordpress-5.2.4-no-content.zip\";s:11:\"new_bundled\";s:71:\"https://downloads.wordpress.org/release/wordpress-5.2.4-new-bundled.zip\";s:7:\"partial\";b:0;s:8:\"rollback\";b:0;}s:7:\"current\";s:5:\"5.2.4\";s:7:\"version\";s:5:\"5.2.4\";s:11:\"php_version\";s:6:\"5.6.20\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"5.0\";s:15:\"partial_version\";s:0:\"\";}}s:12:\"last_checked\";i:1573380739;s:15:\"version_checked\";s:5:\"5.2.4\";s:12:\"translations\";a:0:{}}", "no");
INSERT INTO `wp_464683_options` VALUES("601", "_site_transient_update_plugins", "O:8:\"stdClass\":4:{s:12:\"last_checked\";i:1573380739;s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}s:9:\"no_update\";a:32:{s:31:\"advanced-access-manager/aam.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:37:\"w.org/plugins/advanced-access-manager\";s:4:\"slug\";s:23:\"advanced-access-manager\";s:6:\"plugin\";s:31:\"advanced-access-manager/aam.php\";s:11:\"new_version\";s:4:\"5.11\";s:3:\"url\";s:54:\"https://wordpress.org/plugins/advanced-access-manager/\";s:7:\"package\";s:71:\"https://downloads.wordpress.org/plugin/advanced-access-manager.5.11.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:76:\"https://ps.w.org/advanced-access-manager/assets/icon-256x256.png?rev=1466591\";s:2:\"1x\";s:76:\"https://ps.w.org/advanced-access-manager/assets/icon-128x128.png?rev=1466591\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:79:\"https://ps.w.org/advanced-access-manager/assets/banner-1544x500.png?rev=1466591\";s:2:\"1x\";s:78:\"https://ps.w.org/advanced-access-manager/assets/banner-772x250.png?rev=1466591\";}s:11:\"banners_rtl\";a:0:{}}s:61:\"all-404-redirect-to-homepage/all-404-redirect-to-homepage.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:42:\"w.org/plugins/all-404-redirect-to-homepage\";s:4:\"slug\";s:28:\"all-404-redirect-to-homepage\";s:6:\"plugin\";s:61:\"all-404-redirect-to-homepage/all-404-redirect-to-homepage.php\";s:11:\"new_version\";s:4:\"1.18\";s:3:\"url\";s:59:\"https://wordpress.org/plugins/all-404-redirect-to-homepage/\";s:7:\"package\";s:71:\"https://downloads.wordpress.org/plugin/all-404-redirect-to-homepage.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:81:\"https://ps.w.org/all-404-redirect-to-homepage/assets/icon-256x256.png?rev=1515215\";s:2:\"1x\";s:81:\"https://ps.w.org/all-404-redirect-to-homepage/assets/icon-128x128.png?rev=1515215\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:83:\"https://ps.w.org/all-404-redirect-to-homepage/assets/banner-772x250.png?rev=2153455\";}s:11:\"banners_rtl\";a:0:{}}s:41:\"all-in-one-favicon/all-in-one-favicon.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:32:\"w.org/plugins/all-in-one-favicon\";s:4:\"slug\";s:18:\"all-in-one-favicon\";s:6:\"plugin\";s:41:\"all-in-one-favicon/all-in-one-favicon.php\";s:11:\"new_version\";s:3:\"4.7\";s:3:\"url\";s:49:\"https://wordpress.org/plugins/all-in-one-favicon/\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/plugin/all-in-one-favicon.4.7.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:71:\"https://ps.w.org/all-in-one-favicon/assets/icon-256x256.jpg?rev=1523454\";s:2:\"1x\";s:71:\"https://ps.w.org/all-in-one-favicon/assets/icon-128x128.jpg?rev=1523454\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:73:\"https://ps.w.org/all-in-one-favicon/assets/banner-772x250.jpg?rev=1523454\";}s:11:\"banners_rtl\";a:0:{}}s:35:\"backupwordpress/backupwordpress.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:29:\"w.org/plugins/backupwordpress\";s:4:\"slug\";s:15:\"backupwordpress\";s:6:\"plugin\";s:35:\"backupwordpress/backupwordpress.php\";s:11:\"new_version\";s:4:\"3.10\";s:3:\"url\";s:46:\"https://wordpress.org/plugins/backupwordpress/\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/plugin/backupwordpress.3.10.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:68:\"https://ps.w.org/backupwordpress/assets/icon-256x256.jpg?rev=1105225\";s:2:\"1x\";s:68:\"https://ps.w.org/backupwordpress/assets/icon-128x128.png?rev=1105225\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:70:\"https://ps.w.org/backupwordpress/assets/banner-1544x500.jpg?rev=904756\";s:2:\"1x\";s:69:\"https://ps.w.org/backupwordpress/assets/banner-772x250.jpg?rev=904756\";}s:11:\"banners_rtl\";a:0:{}}s:47:\"better-search-replace/better-search-replace.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:35:\"w.org/plugins/better-search-replace\";s:4:\"slug\";s:21:\"better-search-replace\";s:6:\"plugin\";s:47:\"better-search-replace/better-search-replace.php\";s:11:\"new_version\";s:5:\"1.3.3\";s:3:\"url\";s:52:\"https://wordpress.org/plugins/better-search-replace/\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/plugin/better-search-replace.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:74:\"https://ps.w.org/better-search-replace/assets/icon-256x256.png?rev=1238934\";s:2:\"1x\";s:74:\"https://ps.w.org/better-search-replace/assets/icon-128x128.png?rev=1238934\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:77:\"https://ps.w.org/better-search-replace/assets/banner-1544x500.png?rev=1238934\";s:2:\"1x\";s:76:\"https://ps.w.org/better-search-replace/assets/banner-772x250.png?rev=1238934\";}s:11:\"banners_rtl\";a:0:{}}s:41:\"brozzme-scroll-top/brozzme_scroll_top.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:32:\"w.org/plugins/brozzme-scroll-top\";s:4:\"slug\";s:18:\"brozzme-scroll-top\";s:6:\"plugin\";s:41:\"brozzme-scroll-top/brozzme_scroll_top.php\";s:11:\"new_version\";s:5:\"1.8.5\";s:3:\"url\";s:49:\"https://wordpress.org/plugins/brozzme-scroll-top/\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/plugin/brozzme-scroll-top.zip\";s:5:\"icons\";a:1:{s:2:\"1x\";s:71:\"https://ps.w.org/brozzme-scroll-top/assets/icon-128x128.png?rev=1487748\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:73:\"https://ps.w.org/brozzme-scroll-top/assets/banner-772x250.png?rev=1487748\";}s:11:\"banners_rtl\";a:0:{}}s:31:\"cache-enabler/cache-enabler.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:27:\"w.org/plugins/cache-enabler\";s:4:\"slug\";s:13:\"cache-enabler\";s:6:\"plugin\";s:31:\"cache-enabler/cache-enabler.php\";s:11:\"new_version\";s:5:\"1.3.4\";s:3:\"url\";s:44:\"https://wordpress.org/plugins/cache-enabler/\";s:7:\"package\";s:56:\"https://downloads.wordpress.org/plugin/cache-enabler.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:66:\"https://ps.w.org/cache-enabler/assets/icon-256x256.png?rev=1270483\";s:2:\"1x\";s:66:\"https://ps.w.org/cache-enabler/assets/icon-128x128.png?rev=1270483\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:69:\"https://ps.w.org/cache-enabler/assets/banner-1544x500.png?rev=1270483\";s:2:\"1x\";s:68:\"https://ps.w.org/cache-enabler/assets/banner-772x250.png?rev=1270483\";}s:11:\"banners_rtl\";a:0:{}}s:33:\"classic-editor/classic-editor.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:28:\"w.org/plugins/classic-editor\";s:4:\"slug\";s:14:\"classic-editor\";s:6:\"plugin\";s:33:\"classic-editor/classic-editor.php\";s:11:\"new_version\";s:3:\"1.5\";s:3:\"url\";s:45:\"https://wordpress.org/plugins/classic-editor/\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/plugin/classic-editor.1.5.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:67:\"https://ps.w.org/classic-editor/assets/icon-256x256.png?rev=1998671\";s:2:\"1x\";s:67:\"https://ps.w.org/classic-editor/assets/icon-128x128.png?rev=1998671\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:70:\"https://ps.w.org/classic-editor/assets/banner-1544x500.png?rev=1998671\";s:2:\"1x\";s:69:\"https://ps.w.org/classic-editor/assets/banner-772x250.png?rev=1998676\";}s:11:\"banners_rtl\";a:0:{}}s:37:\"disable-comments/disable-comments.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:30:\"w.org/plugins/disable-comments\";s:4:\"slug\";s:16:\"disable-comments\";s:6:\"plugin\";s:37:\"disable-comments/disable-comments.php\";s:11:\"new_version\";s:6:\"1.10.2\";s:3:\"url\";s:47:\"https://wordpress.org/plugins/disable-comments/\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/plugin/disable-comments.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:68:\"https://ps.w.org/disable-comments/assets/icon-256x256.png?rev=971176\";s:2:\"1x\";s:68:\"https://ps.w.org/disable-comments/assets/icon-128x128.png?rev=971176\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:72:\"https://ps.w.org/disable-comments/assets/banner-1544x500.png?rev=1652560\";s:2:\"1x\";s:71:\"https://ps.w.org/disable-comments/assets/banner-772x250.png?rev=1652560\";}s:11:\"banners_rtl\";a:0:{}}s:35:\"disable-xml-rpc/disable-xml-rpc.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:29:\"w.org/plugins/disable-xml-rpc\";s:4:\"slug\";s:15:\"disable-xml-rpc\";s:6:\"plugin\";s:35:\"disable-xml-rpc/disable-xml-rpc.php\";s:11:\"new_version\";s:5:\"1.0.1\";s:3:\"url\";s:46:\"https://wordpress.org/plugins/disable-xml-rpc/\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/plugin/disable-xml-rpc.1.0.1.zip\";s:5:\"icons\";a:1:{s:7:\"default\";s:59:\"https://s.w.org/plugins/geopattern-icon/disable-xml-rpc.svg\";}s:7:\"banners\";a:0:{}s:11:\"banners_rtl\";a:0:{}}s:33:\"duplicate-post/duplicate-post.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:28:\"w.org/plugins/duplicate-post\";s:4:\"slug\";s:14:\"duplicate-post\";s:6:\"plugin\";s:33:\"duplicate-post/duplicate-post.php\";s:11:\"new_version\";s:5:\"3.2.3\";s:3:\"url\";s:45:\"https://wordpress.org/plugins/duplicate-post/\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/plugin/duplicate-post.3.2.3.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:67:\"https://ps.w.org/duplicate-post/assets/icon-256x256.png?rev=1612753\";s:2:\"1x\";s:67:\"https://ps.w.org/duplicate-post/assets/icon-128x128.png?rev=1612753\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:69:\"https://ps.w.org/duplicate-post/assets/banner-772x250.png?rev=1612986\";}s:11:\"banners_rtl\";a:0:{}}s:25:\"duplicator/duplicator.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:24:\"w.org/plugins/duplicator\";s:4:\"slug\";s:10:\"duplicator\";s:6:\"plugin\";s:25:\"duplicator/duplicator.php\";s:11:\"new_version\";s:6:\"1.3.22\";s:3:\"url\";s:41:\"https://wordpress.org/plugins/duplicator/\";s:7:\"package\";s:60:\"https://downloads.wordpress.org/plugin/duplicator.1.3.22.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:63:\"https://ps.w.org/duplicator/assets/icon-256x256.png?rev=2083921\";s:2:\"1x\";s:63:\"https://ps.w.org/duplicator/assets/icon-128x128.png?rev=2083921\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:65:\"https://ps.w.org/duplicator/assets/banner-772x250.png?rev=2085472\";}s:11:\"banners_rtl\";a:0:{}}s:23:\"elementor/elementor.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:23:\"w.org/plugins/elementor\";s:4:\"slug\";s:9:\"elementor\";s:6:\"plugin\";s:23:\"elementor/elementor.php\";s:11:\"new_version\";s:5:\"2.7.5\";s:3:\"url\";s:40:\"https://wordpress.org/plugins/elementor/\";s:7:\"package\";s:58:\"https://downloads.wordpress.org/plugin/elementor.2.7.5.zip\";s:5:\"icons\";a:3:{s:2:\"2x\";s:62:\"https://ps.w.org/elementor/assets/icon-256x256.png?rev=1427768\";s:2:\"1x\";s:54:\"https://ps.w.org/elementor/assets/icon.svg?rev=1426809\";s:3:\"svg\";s:54:\"https://ps.w.org/elementor/assets/icon.svg?rev=1426809\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:65:\"https://ps.w.org/elementor/assets/banner-1544x500.png?rev=1475479\";s:2:\"1x\";s:64:\"https://ps.w.org/elementor/assets/banner-772x250.png?rev=1475479\";}s:11:\"banners_rtl\";a:0:{}}s:23:\"email-log/email-log.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:23:\"w.org/plugins/email-log\";s:4:\"slug\";s:9:\"email-log\";s:6:\"plugin\";s:23:\"email-log/email-log.php\";s:11:\"new_version\";s:5:\"2.3.1\";s:3:\"url\";s:40:\"https://wordpress.org/plugins/email-log/\";s:7:\"package\";s:58:\"https://downloads.wordpress.org/plugin/email-log.2.3.1.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:62:\"https://ps.w.org/email-log/assets/icon-256x256.png?rev=1710920\";s:2:\"1x\";s:62:\"https://ps.w.org/email-log/assets/icon-128x128.png?rev=1710920\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:65:\"https://ps.w.org/email-log/assets/banner-1544x500.png?rev=1708230\";s:2:\"1x\";s:64:\"https://ps.w.org/email-log/assets/banner-772x250.png?rev=1708230\";}s:11:\"banners_rtl\";a:2:{s:2:\"2x\";s:69:\"https://ps.w.org/email-log/assets/banner-1544x500-rtl.png?rev=1708230\";s:2:\"1x\";s:68:\"https://ps.w.org/email-log/assets/banner-772x250-rtl.png?rev=1708230\";}}s:43:\"email-notification-on-admin-login/index.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:47:\"w.org/plugins/email-notification-on-admin-login\";s:4:\"slug\";s:33:\"email-notification-on-admin-login\";s:6:\"plugin\";s:43:\"email-notification-on-admin-login/index.php\";s:11:\"new_version\";s:3:\"1.1\";s:3:\"url\";s:64:\"https://wordpress.org/plugins/email-notification-on-admin-login/\";s:7:\"package\";s:76:\"https://downloads.wordpress.org/plugin/email-notification-on-admin-login.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:86:\"https://ps.w.org/email-notification-on-admin-login/assets/icon-256x256.jpg?rev=1951088\";s:2:\"1x\";s:86:\"https://ps.w.org/email-notification-on-admin-login/assets/icon-256x256.jpg?rev=1951088\";}s:7:\"banners\";a:0:{}s:11:\"banners_rtl\";a:0:{}}s:43:\"google-analytics-dashboard-for-wp/gadwp.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:47:\"w.org/plugins/google-analytics-dashboard-for-wp\";s:4:\"slug\";s:33:\"google-analytics-dashboard-for-wp\";s:6:\"plugin\";s:43:\"google-analytics-dashboard-for-wp/gadwp.php\";s:11:\"new_version\";s:5:\"5.3.9\";s:3:\"url\";s:64:\"https://wordpress.org/plugins/google-analytics-dashboard-for-wp/\";s:7:\"package\";s:82:\"https://downloads.wordpress.org/plugin/google-analytics-dashboard-for-wp.5.3.9.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:85:\"https://ps.w.org/google-analytics-dashboard-for-wp/assets/icon-256x256.png?rev=970326\";s:2:\"1x\";s:85:\"https://ps.w.org/google-analytics-dashboard-for-wp/assets/icon-128x128.png?rev=970326\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:88:\"https://ps.w.org/google-analytics-dashboard-for-wp/assets/banner-772x250.png?rev=1064664\";}s:11:\"banners_rtl\";a:0:{}}s:36:\"google-sitemap-generator/sitemap.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:38:\"w.org/plugins/google-sitemap-generator\";s:4:\"slug\";s:24:\"google-sitemap-generator\";s:6:\"plugin\";s:36:\"google-sitemap-generator/sitemap.php\";s:11:\"new_version\";s:5:\"4.1.0\";s:3:\"url\";s:55:\"https://wordpress.org/plugins/google-sitemap-generator/\";s:7:\"package\";s:73:\"https://downloads.wordpress.org/plugin/google-sitemap-generator.4.1.0.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:77:\"https://ps.w.org/google-sitemap-generator/assets/icon-256x256.png?rev=1701944\";s:2:\"1x\";s:77:\"https://ps.w.org/google-sitemap-generator/assets/icon-128x128.png?rev=1701944\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:79:\"https://ps.w.org/google-sitemap-generator/assets/banner-772x250.png?rev=1701944\";}s:11:\"banners_rtl\";a:0:{}}s:63:\"granular-controls-for-elementor/granular-controls-elementor.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:45:\"w.org/plugins/granular-controls-for-elementor\";s:4:\"slug\";s:31:\"granular-controls-for-elementor\";s:6:\"plugin\";s:63:\"granular-controls-for-elementor/granular-controls-elementor.php\";s:11:\"new_version\";s:5:\"1.0.5\";s:3:\"url\";s:62:\"https://wordpress.org/plugins/granular-controls-for-elementor/\";s:7:\"package\";s:80:\"https://downloads.wordpress.org/plugin/granular-controls-for-elementor.1.0.5.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:84:\"https://ps.w.org/granular-controls-for-elementor/assets/icon-256x256.png?rev=1801298\";s:2:\"1x\";s:84:\"https://ps.w.org/granular-controls-for-elementor/assets/icon-256x256.png?rev=1801298\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:86:\"https://ps.w.org/granular-controls-for-elementor/assets/banner-772x250.png?rev=1801298\";}s:11:\"banners_rtl\";a:0:{}}s:41:\"better-wp-security/better-wp-security.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:32:\"w.org/plugins/better-wp-security\";s:4:\"slug\";s:18:\"better-wp-security\";s:6:\"plugin\";s:41:\"better-wp-security/better-wp-security.php\";s:11:\"new_version\";s:5:\"7.4.1\";s:3:\"url\";s:49:\"https://wordpress.org/plugins/better-wp-security/\";s:7:\"package\";s:67:\"https://downloads.wordpress.org/plugin/better-wp-security.7.4.1.zip\";s:5:\"icons\";a:3:{s:2:\"2x\";s:70:\"https://ps.w.org/better-wp-security/assets/icon-256x256.jpg?rev=969999\";s:2:\"1x\";s:62:\"https://ps.w.org/better-wp-security/assets/icon.svg?rev=970042\";s:3:\"svg\";s:62:\"https://ps.w.org/better-wp-security/assets/icon.svg?rev=970042\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:72:\"https://ps.w.org/better-wp-security/assets/banner-772x250.png?rev=881897\";}s:11:\"banners_rtl\";a:0:{}}s:25:\"login-logo/login-logo.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:24:\"w.org/plugins/login-logo\";s:4:\"slug\";s:10:\"login-logo\";s:6:\"plugin\";s:25:\"login-logo/login-logo.php\";s:11:\"new_version\";s:5:\"0.9.0\";s:3:\"url\";s:41:\"https://wordpress.org/plugins/login-logo/\";s:7:\"package\";s:53:\"https://downloads.wordpress.org/plugin/login-logo.zip\";s:5:\"icons\";a:1:{s:7:\"default\";s:61:\"https://s.w.org/plugins/geopattern-icon/login-logo_e7e7e7.svg\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:64:\"https://ps.w.org/login-logo/assets/banner-772x250.png?rev=479545\";}s:11:\"banners_rtl\";a:0:{}}s:29:\"mainwp-child/mainwp-child.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:26:\"w.org/plugins/mainwp-child\";s:4:\"slug\";s:12:\"mainwp-child\";s:6:\"plugin\";s:29:\"mainwp-child/mainwp-child.php\";s:11:\"new_version\";s:5:\"4.0.3\";s:3:\"url\";s:43:\"https://wordpress.org/plugins/mainwp-child/\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/plugin/mainwp-child.4.0.3.zip\";s:5:\"icons\";a:1:{s:2:\"1x\";s:65:\"https://ps.w.org/mainwp-child/assets/icon-128x128.png?rev=2147214\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:68:\"https://ps.w.org/mainwp-child/assets/banner-1544x500.jpg?rev=2150284\";s:2:\"1x\";s:67:\"https://ps.w.org/mainwp-child/assets/banner-772x250.jpg?rev=2150284\";}s:11:\"banners_rtl\";a:2:{s:2:\"2x\";s:72:\"https://ps.w.org/mainwp-child/assets/banner-1544x500-rtl.jpg?rev=2150284\";s:2:\"1x\";s:71:\"https://ps.w.org/mainwp-child/assets/banner-772x250-rtl.jpg?rev=2150284\";}}s:77:\"minimal-coming-soon-maintenance-mode/minimal-coming-soon-maintenance-mode.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:50:\"w.org/plugins/minimal-coming-soon-maintenance-mode\";s:4:\"slug\";s:36:\"minimal-coming-soon-maintenance-mode\";s:6:\"plugin\";s:77:\"minimal-coming-soon-maintenance-mode/minimal-coming-soon-maintenance-mode.php\";s:11:\"new_version\";s:4:\"2.07\";s:3:\"url\";s:67:\"https://wordpress.org/plugins/minimal-coming-soon-maintenance-mode/\";s:7:\"package\";s:84:\"https://downloads.wordpress.org/plugin/minimal-coming-soon-maintenance-mode.2.07.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:89:\"https://ps.w.org/minimal-coming-soon-maintenance-mode/assets/icon-256x256.png?rev=1797141\";s:2:\"1x\";s:89:\"https://ps.w.org/minimal-coming-soon-maintenance-mode/assets/icon-128x128.png?rev=1797141\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:92:\"https://ps.w.org/minimal-coming-soon-maintenance-mode/assets/banner-1544x500.png?rev=1807800\";s:2:\"1x\";s:91:\"https://ps.w.org/minimal-coming-soon-maintenance-mode/assets/banner-772x250.png?rev=1807800\";}s:11:\"banners_rtl\";a:0:{}}s:53:\"mousewheel-smooth-scroll/mousewheel-smooth-scroll.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:38:\"w.org/plugins/mousewheel-smooth-scroll\";s:4:\"slug\";s:24:\"mousewheel-smooth-scroll\";s:6:\"plugin\";s:53:\"mousewheel-smooth-scroll/mousewheel-smooth-scroll.php\";s:11:\"new_version\";s:3:\"5.3\";s:3:\"url\";s:55:\"https://wordpress.org/plugins/mousewheel-smooth-scroll/\";s:7:\"package\";s:71:\"https://downloads.wordpress.org/plugin/mousewheel-smooth-scroll.5.3.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:77:\"https://ps.w.org/mousewheel-smooth-scroll/assets/icon-256x256.png?rev=1063217\";s:2:\"1x\";s:77:\"https://ps.w.org/mousewheel-smooth-scroll/assets/icon-128x128.png?rev=1063217\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:79:\"https://ps.w.org/mousewheel-smooth-scroll/assets/banner-772x250.jpg?rev=1063217\";}s:11:\"banners_rtl\";a:0:{}}s:21:\"newsletter/plugin.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:24:\"w.org/plugins/newsletter\";s:4:\"slug\";s:10:\"newsletter\";s:6:\"plugin\";s:21:\"newsletter/plugin.php\";s:11:\"new_version\";s:5:\"6.3.7\";s:3:\"url\";s:41:\"https://wordpress.org/plugins/newsletter/\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/plugin/newsletter.6.3.7.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:63:\"https://ps.w.org/newsletter/assets/icon-256x256.png?rev=1052028\";s:2:\"1x\";s:63:\"https://ps.w.org/newsletter/assets/icon-128x128.png?rev=1160467\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:66:\"https://ps.w.org/newsletter/assets/banner-1544x500.png?rev=1052027\";s:2:\"1x\";s:65:\"https://ps.w.org/newsletter/assets/banner-772x250.png?rev=1052027\";}s:11:\"banners_rtl\";a:0:{}}s:53:\"page-management-dropdown/page-management-dropdown.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:38:\"w.org/plugins/page-management-dropdown\";s:4:\"slug\";s:24:\"page-management-dropdown\";s:6:\"plugin\";s:53:\"page-management-dropdown/page-management-dropdown.php\";s:11:\"new_version\";s:3:\"2.7\";s:3:\"url\";s:55:\"https://wordpress.org/plugins/page-management-dropdown/\";s:7:\"package\";s:71:\"https://downloads.wordpress.org/plugin/page-management-dropdown.2.7.zip\";s:5:\"icons\";a:1:{s:7:\"default\";s:68:\"https://s.w.org/plugins/geopattern-icon/page-management-dropdown.svg\";}s:7:\"banners\";a:0:{}s:11:\"banners_rtl\";a:0:{}}s:41:\"password-protected/password-protected.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:32:\"w.org/plugins/password-protected\";s:4:\"slug\";s:18:\"password-protected\";s:6:\"plugin\";s:41:\"password-protected/password-protected.php\";s:11:\"new_version\";s:5:\"2.2.5\";s:3:\"url\";s:49:\"https://wordpress.org/plugins/password-protected/\";s:7:\"package\";s:67:\"https://downloads.wordpress.org/plugin/password-protected.2.2.5.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:70:\"https://ps.w.org/password-protected/assets/icon-256x256.png?rev=993628\";s:2:\"1x\";s:70:\"https://ps.w.org/password-protected/assets/icon-128x128.png?rev=993628\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:73:\"https://ps.w.org/password-protected/assets/banner-1544x500.png?rev=993628\";s:2:\"1x\";s:72:\"https://ps.w.org/password-protected/assets/banner-772x250.png?rev=993628\";}s:11:\"banners_rtl\";a:0:{}}s:37:\"rcd-right-click-disabler/rcd-main.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:38:\"w.org/plugins/rcd-right-click-disabler\";s:4:\"slug\";s:24:\"rcd-right-click-disabler\";s:6:\"plugin\";s:37:\"rcd-right-click-disabler/rcd-main.php\";s:11:\"new_version\";s:3:\"1.0\";s:3:\"url\";s:55:\"https://wordpress.org/plugins/rcd-right-click-disabler/\";s:7:\"package\";s:67:\"https://downloads.wordpress.org/plugin/rcd-right-click-disabler.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:77:\"https://ps.w.org/rcd-right-click-disabler/assets/icon-256x256.png?rev=1770776\";s:2:\"1x\";s:77:\"https://ps.w.org/rcd-right-click-disabler/assets/icon-128x128.png?rev=1770776\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:79:\"https://ps.w.org/rcd-right-click-disabler/assets/banner-772x250.jpg?rev=1770750\";}s:11:\"banners_rtl\";a:0:{}}s:36:\"reusable-text-blocks/text-blocks.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:34:\"w.org/plugins/reusable-text-blocks\";s:4:\"slug\";s:20:\"reusable-text-blocks\";s:6:\"plugin\";s:36:\"reusable-text-blocks/text-blocks.php\";s:11:\"new_version\";s:5:\"1.5.3\";s:3:\"url\";s:51:\"https://wordpress.org/plugins/reusable-text-blocks/\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/plugin/reusable-text-blocks.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:73:\"https://ps.w.org/reusable-text-blocks/assets/icon-256x256.png?rev=1082000\";s:2:\"1x\";s:73:\"https://ps.w.org/reusable-text-blocks/assets/icon-128x128.png?rev=1082000\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:75:\"https://ps.w.org/reusable-text-blocks/assets/banner-772x250.jpg?rev=1089723\";}s:11:\"banners_rtl\";a:0:{}}s:27:\"updraftplus/updraftplus.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:25:\"w.org/plugins/updraftplus\";s:4:\"slug\";s:11:\"updraftplus\";s:6:\"plugin\";s:27:\"updraftplus/updraftplus.php\";s:11:\"new_version\";s:7:\"1.16.20\";s:3:\"url\";s:42:\"https://wordpress.org/plugins/updraftplus/\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/plugin/updraftplus.1.16.20.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:64:\"https://ps.w.org/updraftplus/assets/icon-256x256.jpg?rev=1686200\";s:2:\"1x\";s:64:\"https://ps.w.org/updraftplus/assets/icon-128x128.jpg?rev=1686200\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:67:\"https://ps.w.org/updraftplus/assets/banner-1544x500.png?rev=1686200\";s:2:\"1x\";s:66:\"https://ps.w.org/updraftplus/assets/banner-772x250.png?rev=1686200\";}s:11:\"banners_rtl\";a:0:{}}s:53:\"w2o-admin-drop-down-menu/w2o-admin-drop-down-menu.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:38:\"w.org/plugins/w2o-admin-drop-down-menu\";s:4:\"slug\";s:24:\"w2o-admin-drop-down-menu\";s:6:\"plugin\";s:53:\"w2o-admin-drop-down-menu/w2o-admin-drop-down-menu.php\";s:11:\"new_version\";s:3:\"3.0\";s:3:\"url\";s:55:\"https://wordpress.org/plugins/w2o-admin-drop-down-menu/\";s:7:\"package\";s:71:\"https://downloads.wordpress.org/plugin/w2o-admin-drop-down-menu.3.0.zip\";s:5:\"icons\";a:1:{s:2:\"1x\";s:77:\"https://ps.w.org/w2o-admin-drop-down-menu/assets/icon-128x128.png?rev=1347375\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:79:\"https://ps.w.org/w2o-admin-drop-down-menu/assets/banner-772x250.png?rev=1577854\";}s:11:\"banners_rtl\";a:0:{}}s:32:\"white-label-cms/wlcms-plugin.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:29:\"w.org/plugins/white-label-cms\";s:4:\"slug\";s:15:\"white-label-cms\";s:6:\"plugin\";s:32:\"white-label-cms/wlcms-plugin.php\";s:11:\"new_version\";s:5:\"2.1.1\";s:3:\"url\";s:46:\"https://wordpress.org/plugins/white-label-cms/\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/plugin/white-label-cms.2.1.1.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:68:\"https://ps.w.org/white-label-cms/assets/icon-256x256.png?rev=1977768\";s:2:\"1x\";s:68:\"https://ps.w.org/white-label-cms/assets/icon-128x128.png?rev=1977768\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:71:\"https://ps.w.org/white-label-cms/assets/banner-1544x500.png?rev=2010322\";s:2:\"1x\";s:70:\"https://ps.w.org/white-label-cms/assets/banner-772x250.png?rev=2010322\";}s:11:\"banners_rtl\";a:0:{}}s:21:\"wp-sweep/wp-sweep.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:22:\"w.org/plugins/wp-sweep\";s:4:\"slug\";s:8:\"wp-sweep\";s:6:\"plugin\";s:21:\"wp-sweep/wp-sweep.php\";s:11:\"new_version\";s:5:\"1.1.1\";s:3:\"url\";s:39:\"https://wordpress.org/plugins/wp-sweep/\";s:7:\"package\";s:57:\"https://downloads.wordpress.org/plugin/wp-sweep.1.1.1.zip\";s:5:\"icons\";a:2:{s:2:\"1x\";s:53:\"https://ps.w.org/wp-sweep/assets/icon.svg?rev=1098912\";s:3:\"svg\";s:53:\"https://ps.w.org/wp-sweep/assets/icon.svg?rev=1098912\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:64:\"https://ps.w.org/wp-sweep/assets/banner-1544x500.jpg?rev=1098912\";s:2:\"1x\";s:63:\"https://ps.w.org/wp-sweep/assets/banner-772x250.jpg?rev=1098912\";}s:11:\"banners_rtl\";a:0:{}}}}", "no");
INSERT INTO `wp_464683_options` VALUES("602", "_site_transient_timeout_elementor_pro_remote_info_api_data_2.7.3", "1573423941", "no");
INSERT INTO `wp_464683_options` VALUES("603", "_site_transient_elementor_pro_remote_info_api_data_2.7.3", "a:16:{s:14:\"stable_version\";s:5:\"2.7.3\";s:12:\"last_updated\";s:19:\"2019-10-29 05:43:58\";s:8:\"sections\";s:86492:\"a:2:{s:11:\"description\";s:161:\"Elementor Pro adds new features to the Elementor Page Builder plugin. Control your conversions, your user engagement, your entire website, from one page builder.\";s:9:\"changelog\";s:86270:\"<h4>2.7.3 - 2019-10-28</h4>\n<ul>\n<li>Tweak: Added RTL support to Galleries widget (<a href=\"https://github.com/elementor/elementor/issues/9213\">#9213</a>)</li>\n<li>Tweak: Added Custom Icons compatibility for WordPress 5.3</li>\n<li>Fix: Missing template function declaration causes fatal error in WC mini-cart widget</li>\n<li>Fix: Pause on hover doesn\'t work in Carousel widgets</li>\n<li>Fix: Link-actions conflict with <code>?action=</code> parameter in the URL</li>\n<li>Fix: Lightbox navigation not working in Gallery widget Single mode</li>\n<li>Fix: Ken burns effect not working on the 1st slide if Infinite Loop option is turned off in Carousel widgets</li>\n<li>Fix: Popup Advanced Rules detects internal links as external if current URL starts with <code>www</code></li>\n</ul>\n<h4>2.7.2 - 2019-10-06</h4>\n<ul>\n<li>Fix: Slide Overlay not working when applying Ken burns effect in Slides widget (<a href=\"https://github.com/elementor/elementor/issues/9209\">#9209</a>)</li>\n<li>Fix: Content width glitch in Slides widget (<a href=\"https://github.com/elementor/elementor/issues/9180\">#9180</a>)</li>\n<li>Fix: Horizontal Alignment not working when applying custom style per slide in Slides widget (<a href=\"https://github.com/elementor/elementor/issues/9180\">#9180</a>)</li>\n<li>Fix: Missing semicolon in Custom Fonts <code>font-display</code> CSS</li>\n</ul>\n<h4>2.7.1 - 2019-09-26</h4>\n<ul>\n<li>Fix: Background Overlay layer is over the slide content in Slides widget (<a href=\"https://github.com/elementor/elementor/issues/9180\">#9180</a>)</li>\n<li>Fix: Duplicate images under &quot;All&quot; filter in Multiple Gallery</li>\n</ul>\n<h4>2.7.0 - 2019-09-24</h4>\n<ul>\n<li>New: Enhanced Galleries widget (<a href=\"https://github.com/elementor/elementor/issues/1898\">#1898</a>, <a href=\"https://github.com/elementor/elementor/issues/3103\">#3103</a>, <a href=\"https://github.com/elementor/elementor/issues/4279\">#4279</a>, <a href=\"https://github.com/elementor/elementor/issues/7631\">#7631</a>)</li>\n<li>New: Dynamic Number (<a href=\"https://github.com/elementor/elementor/issues/5952\">#5952</a>)</li>\n<li>New: Full content skin for Posts and Archive-posts widgets (<a href=\"https://github.com/elementor/elementor/issues/4617\">#4617</a>)</li>\n<li>Tweak: Added dynamic number capability to Price List, Price Table, Counter, Star Rating, Progress Bar widgets</li>\n<li>Tweak: Added tags support to forms Mailchimp action (<a href=\"https://github.com/elementor/elementor/issues/5418\">#5418</a>)</li>\n<li>Tweak: User Profile Picture Dynamic Tag (<a href=\"https://github.com/elementor/elementor/issues/7947\">#7947</a>, <a href=\"https://github.com/elementor/elementor/issues/8740\">#8740</a>)</li>\n<li>Tweak: Added <code>font-display</code> support to custom fonts (<a href=\"https://github.com/elementor/elementor/issues/5993\">#5993</a>, <a href=\"https://developers.elementor.com/elementor-pro-2-7-custom-fonts-font-display-support/\">Developers Blog Post</a>)</li>\n<li>Tweak: Added Text Shadow control to Slides widget (<a href=\"https://github.com/elementor/elementor/issues/8800\">#8800</a>)</li>\n<li>Tweak: Added Re-subscribe support to MailerLite (<a href=\"https://github.com/elementor/elementor/issues/8799\">#8799</a>)</li>\n<li>Tweak: Added Dynamic capabilities to Facebook Embed widget (<a href=\"https://github.com/elementor/elementor/issues/9030\">#9030</a>)</li>\n<li>Tweak: Use <code>swiper.js</code> instead of <code>slick.js</code> in Slides widget (<a href=\"https://developers.elementor.com/elementor-2-7-moving-sliders-from-slick-to-swiper/\">Developers Blog Post</a>)</li>\n<li>Tweak: Added <code>elementor_pro/search_form/before_input</code> action hook to Search Form widget (<a href=\"https://github.com/elementor/elementor/issues/5598\">#5598</a>)</li>\n<li>Tweak: Added <code>elementor_pro/search_form/after_input</code> action hook to Search Form widget (<a href=\"https://github.com/elementor/elementor/issues/5598\">#5598</a>)</li>\n<li>Tweak: Added dynamic support for Custom field key (<a href=\"https://github.com/elementor/elementor/issues/7789\">#7789</a>)</li>\n<li>Tweak: Increased expired license notice bar frequency</li>\n<li>Tweak: Changed the icon name of Slides widget</li>\n<li>Tweak: Added designated Finder\'s Icons for Custom icons &amp; Custom fonts</li>\n<li>Tweak: Use Ken Burns Effect as an external module</li>\n<li>Tweak: Remove Fontello conflicting CSS on import to Custom Icons sets</li>\n<li>Tweak: Editor Panel UI tweaks</li>\n<li>Tweak: Added DOM events on Popup show/hide (<a href=\"https://developers.elementor.com/elementor-pro-2-7-popup-events/\">Developers Blog Post</a>)</li>\n<li>Tweak: Added option to change the variations field width in Add to Cart widget</li>\n<li>Tweak: Use select control instead of select2 in Menu Cart widget</li>\n<li>Tweak: Added conditions to the tabs instead of to each control in Share Buttons widget</li>\n<li>Tweak: Added Typography controls to HTML field in Forms widget</li>\n<li>Tweak: Allow edit selected Font file in Custom Font</li>\n<li>Tweak: Changed reCAPTCHA v3 error message</li>\n<li>Tweak: Remove the &quot;Save as Global&quot; option on Global widget context menu</li>\n<li>Fix: Corrected selector for <code>removeControlSpinner()</code> (<a href=\"https://github.com/elementor/elementor/issues/8790\">#8790</a>)</li>\n<li>Fix: Slides widget navigation icons misplacement (<a href=\"https://github.com/elementor/elementor/issues/8533\">#8533</a>)</li>\n<li>Fix: Horizontal Scrollbar when Slider widget is set to Full Width (<a href=\"https://github.com/elementor/elementor/issues/8527\">#8527</a>)</li>\n<li>Fix: Inconsistent behavior when &quot;Infinite Loop&quot; enabled with &quot;Autoplay&quot; in Slides widget (<a href=\"https://github.com/elementor/elementor/issues/6726\">#6726</a>)</li>\n<li>Fix: Ken Burns effect on Chrome transition glitches (<a href=\"https://github.com/elementor/elementor/issues/1671\">#1671</a>)</li>\n<li>Fix: Nothing found message shows up inside the columns set in Posts Archive widget (<a href=\"https://github.com/elementor/elementor/issues/7347\">#7347</a>)</li>\n<li>Fix: Responsive UI glitch in Popup Conditions modal tabs</li>\n<li>Fix: Removed unnecessary divider in Call to Action widget</li>\n<li>Fix: Custom Add To Cart * button style (size, position and background color) when <code>quantity</code> is enabled.</li>\n<li>Fix: Add support for Document/PageBase in Theme Builder (Core &gt;=2.7.0)</li>\n<li>Fix: Ampersand character breaks email link in Share Buttons widget</li>\n<li>Fix: Correct custom font attachment <code>mime-type</code> to show uploaded Custom Fonts</li>\n<li>Fix: Mini-Cart not refreshing in Menu Cart widget</li>\n<li>Fix: Cart drawer not working when WC Subscriptions plugin is activated</li>\n<li>Fix:  Querying CPT with custom taxonomies does not show the taxonomies before saving</li>\n<li>Fix: Double rendering on change caused console error in Theme Builder\'s conditions screen</li>\n<li>Fix: Translations and Strings in Share Buttons widget</li>\n<li>Fix: Avoid using offset if the source is Manual selection in Query Control</li>\n<li>Fix: Form being submitted although reCAPTCHA v3 validation failed in Forms widget</li>\n</ul>\n<h4>2.6.5 - 2019-08-26</h4>\n<ul>\n<li>Tweak: Added compatibility for the upcoming release of Elementor v2.7</li>\n<li>Fix: Button style not working when <code>quantity</code> is enabled in Custom Add To Cart widget</li>\n<li>Fix: Updated minified JS file fixed WhatsApp base URL in Share Buttons widget</li>\n</ul>\n<h4>2.6.4 - 2019-08-21</h4>\n<ul>\n<li>Tweak: Added compatibility for the upcoming release of Elementor v2.7</li>\n<li>Fix: Changed WhatsApp base URL in Share Buttons widget for cross-device compatibility</li>\n<li>Fix: Random slides order after several clicks on pagination in Testimonial Carousel widget</li>\n</ul>\n<h4>2.6.3 - 2019-08-18</h4>\n<ul>\n<li>Fix: Core version rollback to <code>&gt;2.6.0</code> causes a fatal error</li>\n<li>Fix: Duplicate images when slideshow skin is selected in Media Carousel lightbox</li>\n<li>Fix: Default bottom margin added to reCAPTCHA V3 badge</li>\n<li>Fix: Input glitch in reCAPTCHA V3 threshold settings</li>\n</ul>\n<h4>2.6.2 - 2019-07-30</h4>\n<ul>\n<li>Tweak: Better accessibility support in Search Form widget</li>\n<li>Fix: UI glitched in Popup publish screen (<a href=\"https://github.com/elementor/elementor/issues/8616\">#8616</a>)</li>\n<li>Fix: &quot;Child of Term&quot; and &quot;Any child of term&quot; conditions (<a href=\"https://github.com/elementor/elementor/issues/8695\">#8695</a>)</li>\n<li>Fix: Restored <code>library_widget_templates</code> action hook for 3rd party compatibility (<a href=\"https://github.com/elementor/elementor/issues/8687\">#8687</a>)</li>\n<li>Fix: Twitter Icon missing in Blockquote widget</li>\n<li>Fix: Form reCAPTCHA v3 badge position not working</li>\n<li>Fix: Renewal notice bar appears in wrong situations</li>\n<li>Fix: Draft Icon Set loads empty Icon Library</li>\n</ul>\n<h4>2.6.1 - 2019-07-24</h4>\n<ul>\n<li>Fix: Query Control autocomplete not retrieving results (<a href=\"https://github.com/elementor/elementor/issues/8672\">#8672</a>, <a href=\"https://github.com/elementor/elementor/issues/8661\">#8661</a>)</li>\n<li>Fix: Price Table features section not working (<a href=\"https://github.com/elementor/elementor/issues/8660\">#8660</a>)</li>\n</ul>\n<h4>2.6.0 - 2019-07-23</h4>\n<ul>\n<li>New: Introducing Custom Icon sets - including Fontello, IcoMoon and Fontastic support (<a href=\"https://github.com/elementor/elementor/issues/110\">#110</a>)</li>\n<li>New: Added Font Awesome 5 Pro integration including 5,300+ icons (<a href=\"https://github.com/elementor/elementor/issues/4430\">#4430</a>)</li>\n<li>New: Added reCAPTCHA v3 integration to Form widget (<a href=\"https://github.com/elementor/elementor/issues/8213\">#8213</a>, <a href=\"https://github.com/elementor/elementor/issues/6039\">#6039</a>, <a href=\"https://github.com/elementor/elementor/issues/7165\">#7165</a>)</li>\n<li>Tweak: Added Exit Animation for Popups (<a href=\"https://github.com/elementor/elementor/issues/7063\">#7063</a>)</li>\n<li>Tweak: Added ACF Dynamic tag support for archive pages (<a href=\"https://github.com/elementor/elementor/issues/5147\">#5147</a>)</li>\n<li>Tweak: Added Navigator Indicators for Custom CSS &amp; Motion Effects (<a href=\"https://github.com/elementor/elementor/issues/2180\">#2180</a>)</li>\n<li>Tweak: Added Dynamic capabilities for Form Redirect action (<a href=\"https://github.com/elementor/elementor/issues/7552\">#7552</a>)</li>\n<li>Tweak: Added Logged In Message styling options for Login widget (<a href=\"https://github.com/elementor/elementor/issues/7928\">#7928</a>)</li>\n<li>Tweak: Added <code>none</code> breakpoint option to Nav Menu widget (<a href=\"https://github.com/elementor/elementor/issues/7916\">#7916</a>)</li>\n<li>Tweak: Added option to place Post Terms dynamic tag without links (<a href=\"https://github.com/elementor/elementor/issues/8366\">#8366</a>)</li>\n<li>Tweak: Added <code>elementor/query/query_results</code> hook to Query Control to allow full control over results (<a href=\"https://github.com/elementor/elementor/issues/7912\">#7912</a>)</li>\n<li>Tweak: Allow choosing Heading HTML tag in Price Table widget (<a href=\"https://github.com/elementor/elementor/issues/8090\">#8090</a>)</li>\n<li>Tweak: Show popup on dynamic click even when <code>Avoid Multiple Popups</code> option is selected (<a href=\"https://github.com/elementor/elementor/issues/8189\">#8189</a>)</li>\n<li>Tweak: Added condition option to all of archive child pages (<a href=\"https://github.com/elementor/elementor/issues/8256\">#8256</a>)</li>\n<li>Tweak: Added <code>Effects Relative To</code> control to Scrolling Effects</li>\n<li>Tweak: Allow shortcodes in HTML Form field</li>\n<li>Tweak: Removed donReach integration from Share Buttons widget due to service inconsistent stability</li>\n<li>Tweak: Changed MailChimp <code>List</code> label to <code>Audience</code></li>\n<li>Tweak: Improved Entrance and Exit animation behavior in Popup</li>\n<li>Tweak: Added <code>Deprecated Notice</code> control to <code>Archive Products</code> and <code>Woo Products</code> widgets</li>\n<li>Tweak: Added default dynamic title for archives in Theme Builder</li>\n<li>Tweak: Added condition to show <code>Centered Slides</code> control in Media Carousel widget</li>\n<li>Tweak: Added notice bar in the Editor when the license is expired or not activated</li>\n<li>Tweak: Replaced <code>select</code> control with <code>choose</code> control in Price List widget</li>\n<li>Tweak: Removed Font Awesome 4 dependencies from the Editor</li>\n<li>Tweak: Minor styling tweaks in the Popup publish modal</li>\n<li>Tweak: Hide ordering form in Products widget on front page</li>\n<li>Tweak: Removed page title markup when \'Hide Title\' is active</li>\n<li>Tweak: Added style controls for HTML field in Form widget</li>\n<li>Fix: Form widget Date picker makes the Popup builder disappear (<a href=\"https://github.com/elementor/elementor/issues/7240\">#7240</a>)</li>\n<li>Fix: Sticky element stop point stops working on viewport resize (<a href=\"https://github.com/elementor/elementor/issues/7884\">#7884</a>)</li>\n<li>Fix: Copy-Paste style not pasting the Pointer option in Nav Menu widget (<a href=\"https://github.com/elementor/elementor/issues/8497\">#8497</a>)</li>\n<li>Fix: Missing Print icon in Share Buttons (<a href=\"https://github.com/elementor/elementor/issues/8506\">#8506</a>)</li>\n<li>Fix: UI style glitch in Blockquote widget when viewing from iPad</li>\n<li>Deprecated: <code>DB::save_editor()</code> - Remove usage of this method (<a href=\"https://developers.elementor.com/v2-6-0-planned-deprecations/\">Deprecation Post</a>)</li>\n<li>Deprecated: <code>DB::get_plain_editor()</code> - Remove usage of this method (<a href=\"https://developers.elementor.com/v2-6-0-planned-deprecations/\">Deprecation Post</a>)</li>\n</ul>\n<h4>2.5.14 - 2019-07-14</h4>\n<ul>\n<li>Fix: Better WC Related Product grid support to various themes (<a href=\"https://github.com/elementor/elementor/issues/8555\">#8555</a>)</li>\n</ul>\n<h4>2.5.13 - 2019-07-11</h4>\n<ul>\n<li>Fix: Better WC grid support to various themes</li>\n</ul>\n<h4>2.5.12 - 2019-07-10</h4>\n<ul>\n<li>Fix: Grid for WooCommerce Archive Product widget</li>\n<li>Fix: Remove redundant <code>whitespace</code> CSS property causes style glitch in iPad</li>\n<li>Tweak: Added more compatibility for Elementor v2.6</li>\n</ul>\n<h4>2.5.11 - 2019-07-02</h4>\n<ul>\n<li>Fix: Close icon missing from Nav Menu widget (<a href=\"https://github.com/elementor/elementor/issues/8460\">#8460</a>)</li>\n<li>Fix: Elementor Pro v2.5.10 shows PHP notice regarding notice bar (<a href=\"https://github.com/elementor/elementor/issues/8461\">#8461</a>)</li>\n<li>Fix: Fatal error when deleting used Pods fields (<a href=\"https://github.com/elementor/elementor/issues/8396\">#8396</a>)</li>\n<li>Fix: Missing dropdown icon in conditions screen</li>\n</ul>\n<h4>2.5.10 - 2019-05-28</h4>\n<ul>\n<li>Tweak: Added compatibility for the upcoming release of Elementor v2.6</li>\n<li>Tweak: Error caused by empty Rows &amp; Columns values in Products widget (<a href=\"https://github.com/elementor/elementor/issues/8261\">#8261</a>)</li>\n<li>Fix: Do not unset <code>product</code> CPT if it\'s not from WooCommerce (<a href=\"https://github.com/elementor/elementor/issues/8160\">#8160</a>)</li>\n<li>Fix: Column Spacing not working in WooCommerce Archive Products widget (<a href=\"https://github.com/elementor/elementor/issues/8285\">#8285</a>)</li>\n<li>Fix: Title styling not working in Products Categories widget</li>\n<li>Fix: Empty value in Dynamic Pods Gallery dropdown using Safari browser</li>\n<li>Fix: WooCommerce archives included in &quot;All Archives&quot; condition</li>\n</ul>\n<h4>2.5.9 - 2019-05-28</h4>\n<ul>\n<li>Tweak: Removed <code>auto-confirm</code> control from MailPoet to support new version of MailPoet</li>\n<li>Fix: Multiple Custom Fonts not rendered in the editor</li>\n<li>Fix: Products <code>sale</code> query - handle exclude by manual selection.</li>\n<li>Fix: Product Categories grid row &amp; column style</li>\n<li>Fix: Form integration AJAX cache override</li>\n<li>Fix: Removed redundant CSS on Canvas &amp; Header-Footer page templates</li>\n</ul>\n<h4>2.5.8 - 2019-05-06</h4>\n<ul>\n<li>Fix: Popup entrance animation not working in frontend</li>\n<li>Fix: Popup Exit Intent trigger activated multiple times</li>\n</ul>\n<h4>2.5.7 - 2019-05-05</h4>\n<ul>\n<li>Fix: Embedded video keeps playing after a Popup is closed (<a href=\"https://github.com/elementor/elementor/issues/7875\">#7875</a>)</li>\n<li>Fix: Maximum call stack size exceeded error in Safari (<a href=\"https://github.com/elementor/elementor/issues/7824\">#7824</a>)</li>\n<li>Fix: Entrance animations not appearing on Popup reopen (<a href=\"https://github.com/elementor/elementor/issues/7395\">#7395</a>)</li>\n<li>Fix: WC variations select style glitch in several themes (<a href=\"https://github.com/elementor/elementor/issues/8008\">#8008</a>)</li>\n<li>Fix: Theme Builder taxonomy conditions not retrieving proper results in edge cases</li>\n</ul>\n<h4>2.5.6 - 2019-04-29</h4>\n<ul>\n<li>Tweak: Removed <code>Shortcode</code> dynamic from Image, Gallery and Media control</li>\n<li>Fix: Popup not inheriting entrance animation in responsive mode (<a href=\"https://github.com/elementor/elementor/issues/7809\">#7809</a>)</li>\n<li>Fix: Terms autocomplete retrieves wrong results in Query Control</li>\n<li>Fix: Query Control Related by author glitches in edge cases</li>\n<li>Fix: Query Control using terms for Products widget</li>\n<li>Fix: Posts cards style glitch in small screens</li>\n<li>Fix: Display conditions delete icon missing in small screens</li>\n<li>Fix: Avoid rendering Menu Cart widget in WordPress native editor</li>\n</ul>\n<h4>2.5.5 - 2019-04-08</h4>\n<ul>\n<li>Tweak: Allow text selection inside a Popup</li>\n<li>Fix: Added backwards compatibility for <code>tax_query</code> in Query Control (<a href=\"https://github.com/elementor/elementor/issues/7751\">#7751</a>)</li>\n<li>Fix: Missing arguments for <code>widget_title</code> filter (<a href=\"https://github.com/elementor/elementor/issues/7745\">#7745</a>)</li>\n</ul>\n<h4>2.5.4 - 2019-04-03</h4>\n<ul>\n<li>Fix: Move Query from using <code>term_id</code> to <code>term_taxonomy_id</code> (<a href=\"https://github.com/elementor/elementor/issues/7653\">#7653</a>)</li>\n<li>Fix: Offset manipulation hook removal in Query control</li>\n<li>Fix: Missing form field <code>ID</code> in some edge cases (<a href=\"https://github.com/elementor/elementor/issues/7711\">#7711</a>, <a href=\"https://github.com/elementor/elementor/issues/7660\">#7660</a>)</li>\n</ul>\n<h4>2.5.3 - 2019-03-31</h4>\n<ul>\n<li>Tweak: Updated Google Calendar dynamic tag URL (<a href=\"https://github.com/elementor/elementor/issues/7673\">#7673</a>)</li>\n<li>Fix: Missing form field names (<a href=\"https://github.com/elementor/elementor/issues/7651\">#7651</a>)</li>\n<li>Fix: PHP 5.4 backward compatibility in Query Control (<a href=\"https://github.com/elementor/elementor/issues/7633\">#7633</a>)</li>\n<li>Fix: <code>products_deprecated</code> Query Control module compatibility (<a href=\"https://github.com/elementor/elementor/issues/7654\">#7654</a>)</li>\n<li>Fix: Changed query method from <code>term_id</code> to <code>term_taxonomy_id</code> (<a href=\"https://github.com/elementor/elementor/issues/7653\">#7653</a>)</li>\n</ul>\n<h4>2.5.2 - 2019-03-27</h4>\n<ul>\n<li>Fix: Overwrite parent widget type in Global Widget (<a href=\"https://github.com/elementor/elementor/issues/7632\">#7632</a>)</li>\n<li>Fix: Avoid Duplicates option not working in Query Control (<a href=\"https://github.com/elementor/elementor/issues/7635\">#7635</a>)</li>\n<li>Fix: Manual Selection option not working in Query Control (<a href=\"https://github.com/elementor/elementor/issues/7634\">#7634</a>)</li>\n<li>Fix: Incorrect condition caused handlers issues inside popup</li>\n</ul>\n<h4>2.5.1 - 2019-03-26</h4>\n<ul>\n<li>Fix: Query Control invalid call to deprecated action (<a href=\"https://github.com/elementor/elementor/issues/7619\">#7619</a>)</li>\n<li>Tweak: Renamed action hook from <code>elementor_pro/{$widget_name}/query/{$query_id}</code> to <code>elementor/query/{$query_id}</code></li>\n<li>Tweak: Renamed filter hook from <code>elementor_pro/query_control/get_query_args/current_query</code> to <code>elementor/query/get_query_args/current_query</code></li>\n</ul>\n<h4>2.5.0 - 2019-03-26</h4>\n<ul>\n<li>New: Introducing Motion Effects including Scrolling &amp; Mouse effects (<a href=\"https://github.com/elementor/elementor/issues/72\">#72</a>)</li>\n<li>New: Introducing Related Posts for Query Control (<a href=\"https://github.com/elementor/elementor/issues/7306\">#7306</a>, <a href=\"https://github.com/elementor/elementor/issues/7490\">#7490</a>)</li>\n<li>New: Introducing Date query for Query Control</li>\n<li>New: Introducing Sticky Posts support for Query Control (<a href=\"https://github.com/elementor/elementor/issues/2501\">#2501</a>)</li>\n<li>Tweak: Added option to open a Popup by a custom selector (<a href=\"https://github.com/elementor/elementor/issues/6871\">#6871</a>, <a href=\"https://github.com/elementor/elementor/issues/6876\">#6876</a>, <a href=\"https://github.com/elementor/elementor/issues/7258\">#7258</a>)</li>\n<li>Tweak: Option to count when Popup is closed in &quot;Show up to X times&quot; Advanced Rule</li>\n<li>Tweak: Added full border radius control options inside Popup</li>\n<li>Tweak: Changed exit intent icon in Popups</li>\n<li>Tweak: Show only one popup in its own preview</li>\n<li>Tweak: Added responsive support to Popup entrance animation control</li>\n<li>Tweak: Conditions - Singular <code>All Pages</code> string changed to <code>Pages</code></li>\n<li>Tweak: Added form field shortcode support for Drip tags (<a href=\"https://github.com/elementor/elementor/issues/7000\">#7000</a>)</li>\n<li>Tweak: Added dynamic capabilities to Price List widget (<a href=\"https://github.com/elementor/elementor/issues/7258\">#7258</a>)</li>\n<li>Tweak: Added Dynamic capabilities to Custom Attributes (<a href=\"https://github.com/elementor/elementor/issues/6779\">#6779</a>)</li>\n<li>Tweak: Added dynamic capabilities to Flip Box widget (<a href=\"https://github.com/elementor/elementor/issues/6986\">#6986</a>)</li>\n<li>Tweak: Decrease <code>z-index</code> for Nav Menu (<a href=\"https://github.com/elementor/elementor/issues/6869\">#6869</a>)</li>\n<li>Tweak: Changed &quot;Scrolling Effects&quot; section label to &quot;Motion Effects&quot;</li>\n<li>Tweak: Use filter <code>get_meta_viewport</code> for header templates (<a href=\"https://github.com/elementor/elementor/issues/7043\">#7043</a>)</li>\n<li>Tweak: use filterable <code>Util::get_public_post_types()</code> in Theme Builder (<a href=\"https://github.com/elementor/elementor/issues/7172\">#7172</a>)</li>\n<li>Tweak: Added Cloudflare rocket-loader support (<a href=\"https://github.com/elementor/elementor/issues/7443\">#7443</a>)</li>\n<li>Tweak: Added responsive support to WC Products Columns &amp; Rows Gap controls (<a href=\"https://github.com/elementor/elementor/issues/6913\">#6913</a>)</li>\n<li>Tweak: WC Menu cart &quot;View Cart&quot; &amp; &quot;Checkout&quot; buttons styling</li>\n<li>Fix: Custom ID reset to default when dragging repeater</li>\n<li>Fix: Conflict between archive-products widget and WC customizer</li>\n<li>Fix: Add to Cart widget <code>spacing</code> and <code>space-between</code></li>\n<li>Fix: Library view when creating a new Header or Footer</li>\n<li>Fix: Post types labels missing on Add New Template modal</li>\n</ul>\n<h4>2.4.8 - 2019-03-11</h4>\n<ul>\n<li>Fix: Missing query section in Products widget</li>\n<li>Fix: Missing Taxonomy controls in Products widget in edge cases</li>\n</ul>\n<h4>2.4.7 - 2019-03-06</h4>\n<ul>\n<li>Fix: Compatibility Global Widget with Elementor v2.5.0+</li>\n</ul>\n<h4>2.4.6 - 2019-03-04</h4>\n<ul>\n<li>Fix: Pods gallery dynamic when empty (<a href=\"https://github.com/elementor/elementor/issues/7127\">#7127</a>)</li>\n<li>Fix: Duplicate call for conditions screen issue</li>\n<li>Fix: Compatibility with Elementor v2.5.0</li>\n</ul>\n<h4>2.4.5 - 2019-02-18</h4>\n<ul>\n<li>Fix: Image size issue in Testimonial Carousel (<a href=\"https://github.com/elementor/elementor/issues/7058\">#7058</a>)</li>\n<li>Fix: MailChimp groups not saved in a form integration (<a href=\"https://github.com/elementor/elementor/issues/7083\">#7083</a>)</li>\n<li>Fix: Show popup preview only on it\'s own preview</li>\n<li>Fix: Elementor dashboard templates URL corrupted links in edge cases</li>\n</ul>\n<h4>2.4.4 - 2019-02-11</h4>\n<ul>\n<li>Tweak: Added ACF Date Time Picker field support (<a href=\"https://github.com/elementor/elementor/issues/6690\">#6690</a>)</li>\n<li>Tweak: Changed the term of <code>All Posts</code> condition to <code>Posts</code></li>\n<li>Fix: Added <code>&lt;IfModule&gt;</code> to avoid 500 error when <code>mod-headers</code> is missing (<a href=\"https://github.com/elementor/elementor/issues/7034\">#7034</a>)</li>\n<li>Fix: Include post CSS deletion in Global Widget update (<a href=\"https://github.com/elementor/elementor/issues/6856\">#6856</a>)</li>\n<li>Fix: <code>Textarea</code> default value in Forms Widget (<a href=\"https://github.com/elementor/elementor/issues/6934\">#6934</a>)</li>\n<li>Fix: MailPoet latest version caused fatal error (<a href=\"https://github.com/elementor/elementor/issues/6996\">#6996</a>)</li>\n<li>Fix: Fatal Error caused by calling MailPoet deleted method</li>\n<li>Notice: MailPoet <code>Auto Confirm</code> option will now default to &quot;On&quot;</li>\n</ul>\n<h4>2.4.3 - 2019-01-30</h4>\n<ul>\n<li>Fix: Custom Add to Cart widget responsive alignment settings</li>\n<li>Fix: Links in Post Info widget</li>\n<li>Fix: WooCommerce <code>View Cart</code> string translate</li>\n<li>Fix: Wrapper classes for header/footer templates (<a href=\"https://github.com/elementor/elementor/issues/6884\">#6884</a>)</li>\n</ul>\n<h4>2.4.2 - 2019-01-25</h4>\n<ul>\n<li>Tweak: Added pixel units to Close Button position control in Popups</li>\n<li>Fix: Exclude error in WC Products widget</li>\n</ul>\n<h4>2.4.1 - 2019-01-24</h4>\n<ul>\n<li>Tweak: Added CSS classes control to Popup (<a href=\"https://github.com/elementor/elementor/issues/6826\">#6826</a>)</li>\n<li>Tweak: Added responsive image size to Testimonial Carousel widget</li>\n<li>Fix: PHP warning when Toolset Date dynamic is empty (<a href=\"https://github.com/elementor/elementor/issues/6842\">#6842</a>)</li>\n<li>Fix: Support of exclude-ids in WC Products widget</li>\n<li>Fix: Popup close button not clickable</li>\n<li>Fix: Alignment justify issue of Add to Cart widget (<a href=\"https://github.com/elementor/elementor/issues/6749\">#6749</a>)</li>\n<li>Fix: Bad anchors breaks the page JS</li>\n<li>Fix: Popup overlay shown when turned off</li>\n</ul>\n<h4>2.4.0 - 2019-01-21</h4>\n<ul>\n<li>New: Introducing Popup Builder (<a href=\"https://github.com/elementor/elementor/issues/628\">#628</a>)</li>\n<li>New: Added <code>Popup</code> Dynamic Tag</li>\n<li>New: Added <code>Popup</code> forms action after submit</li>\n<li>New: Added User Info dynamic tag (<a href=\"https://github.com/elementor/elementor/issues/6322\">#6322</a>)</li>\n<li>Tweak: Added dynamic capabilities for &quot;Nothing Found&quot; message</li>\n<li>Tweak: Added <code>elementor_pro/theme_builder/archive/escape_nothing_found_message</code> Filter to avoid HTML escaping in &quot;Nothing Found&quot; message (<a href=\"https://github.com/elementor/elementor/issues/6053\">#6053</a>)</li>\n<li>Tweak: Added <code>add_doc_to_location</code> method to Allow insertion of a document to a location</li>\n<li>Fix: <code>z-index</code> issue with CTA widget (<a href=\"https://github.com/elementor/elementor/issues/6486\">#6486</a>)</li>\n<li>Fix: Hide the Post Content widget and show it only in a Single document</li>\n<li>Fix: <code>selector</code> replacement in Custom CSS</li>\n<li>Fix: Apply <code>the_content</code> on the real content only</li>\n<li>Fix: CSS for WC products selector (<a href=\"https://github.com/elementor/elementor/issues/6559\">#6559</a>)</li>\n<li>Fix: Odnoklassniki share URL (<a href=\"https://github.com/elementor/elementor/issues/6638\">#6638</a>)</li>\n<li>Fix: Custom link new tab in Post Info widget (<a href=\"https://github.com/elementor/elementor/issues/5766\">#5766</a>)</li>\n<li>Fix: <code>nofollow</code> link in Flip Box &amp; CTA widgets</li>\n<li>Fix: Post Terms in Post Info widget</li>\n<li>Fix: Added screen reader to some icons &amp; buttons for better accessibility (<a href=\"https://github.com/elementor/elementor/issues/5386\">#5386</a>)</li>\n<li>Fix: Accessibility labels in Reviews widget (<a href=\"https://github.com/elementor/elementor/issues/6630\">#6630</a>)</li>\n<li>Fix: Link to cart page not working when WooCommerce Subscriptions is active</li>\n<li>Fix: MailChimp Selected list not showing on reloading in Form widget</li>\n<li>Fix: Sub-menu arrow position in Nav Menu widget</li>\n<li>Fix: Conflict with WP Security Audit Log plugin (<a href=\"https://github.com/elementor/elementor/issues/6648\">#6648</a>)</li>\n</ul>\n<h4>2.3.1 - 2018-12-19</h4>\n<ul>\n<li>Fix: Template widget search functionality (<a href=\"https://github.com/elementor/elementor/issues/6473\">#6473</a>)</li>\n<li>Fix: Apply <code>the_content</code> filter to post content in theme builder</li>\n</ul>\n<h4>2.3.0 - 2018-12-17</h4>\n<ul>\n<li>New: Introducing Discord Integration for Forms (<a href=\"https://github.com/elementor/elementor/issues/4218\">#4218</a>)</li>\n<li>New: Introducing Slack Integration for Forms</li>\n<li>New: Introducing MailerLite Integration for Forms (<a href=\"https://github.com/elementor/elementor/issues/4462\">#4462</a>)</li>\n<li>New: Activate Elementor Pro plugin by connecting to Elementor account</li>\n<li>Tweak: Added <code>elementor_pro/utils/get_public_post_types</code> filter hook (<a href=\"https://github.com/elementor/elementor/issues/5900\">#5900</a>)</li>\n<li>Tweak: Added <code>loop_start</code> &amp; <code>the_content</code> hooks for Post Content (<a href=\"https://github.com/elementor/elementor/issues/6173\">#6173</a>)</li>\n<li>Tweak: Removed Custom Attributes from Page Settings</li>\n<li>Tweak: Always add the Custom CSS control to the Advanced tab</li>\n<li>Fix: In sub Term condition false positive in edge cases</li>\n<li>Fix: ToolSet Dynamic Image fallback</li>\n<li>Fix: Style glitch with the dropdown color in Nav Menu widget</li>\n<li>Fix: Style glitch in the Conditions screen in Safari browser</li>\n<li>Fix: Ribbon in the CTA widget obscures drop down menu (<a href=\"https://github.com/elementor/elementor/issues/6080\">#6080</a>)</li>\n<li>Fix: The color of label won\'t change color in Widget login</li>\n</ul>\n<h4>2.2.5 - 2018-12-11</h4>\n<ul>\n<li>New: Add Style Tab &amp; Custom CSS for Header &amp; Footer Templates.</li>\n<li>Tweak: Added a better identifier for subpages (<a href=\"https://github.com/elementor/elementor/issues/6362\">#6362</a>)</li>\n<li>Tweak: Removed Custom Attributes from page settings</li>\n<li>Fix: Yahoo event URL date issue (<a href=\"https://github.com/elementor/elementor/issues/6354\">#6354</a>)</li>\n<li>Fix: Allow timezone settings in Google event URL (<a href=\"https://github.com/elementor/elementor/issues/6354\">#6354</a>)</li>\n<li>Fix: Avoid <code>z-index</code> changes by <code>nanocss</code> in build process</li>\n<li>Fix: Added missing WC upsells products CSS</li>\n<li>Fix: Nav Menu dropdown losing color on hover</li>\n<li>Fix: WC Product Add-ons CSS compatibility</li>\n</ul>\n<h4>2.2.4 - 2018-12-04</h4>\n<ul>\n<li>Fix: Global widget not saving changes (<a href=\"https://github.com/elementor/elementor/issues/6340\">#6340</a>)</li>\n<li>Fix: Dynamic tags support in Blockquote widget (<a href=\"https://github.com/elementor/elementor/issues/6334\">#6334</a>)</li>\n<li>Fix: Forms Redirect URL action when using form field values with spaces</li>\n</ul>\n<h4>2.2.3 - 2018-11-29</h4>\n<ul>\n<li>Fix: Missing &quot;Edit Template&quot; in Template widget (<a href=\"https://github.com/elementor/elementor/issues/6271\">#6271</a>)</li>\n<li>Fix: Follow menu anchors with UTF8 characters in Nav Menu</li>\n<li>Fix: Show only supported templates in Template widget</li>\n<li>Fix: Revert conflicting fix for a default order for WC archive</li>\n</ul>\n<h4>2.2.2 - 2018-11-28</h4>\n<ul>\n<li>Fix: Lightbox dynamic tag crashes the editor</li>\n</ul>\n<h4>2.2.1 - 2018-11-28</h4>\n<ul>\n<li>New: Added <code>ACF File</code> Dynamic tag to support text controls.</li>\n<li>Tweak: Added option to hide item count bubble when cart is empty in Menu Cart widget (<a href=\"https://github.com/elementor/elementor/issues/6223\">#6223</a>)</li>\n<li>Tweak: Added Actions group for Lightbox and Contact URL tags</li>\n<li>Tweak: Added filter <code>elementor_pro/dynamic_tags/shortcode/should_escape</code> to avoid escaping in Shortcode dynamic tag</li>\n<li>Tweak: MailPoet3 integration allow Subscriber to to subscribe to multiple lists</li>\n<li>Tweak: Added front-end max file size validation for upload fields</li>\n<li>Tweak: Added <code>by-author</code> per Post-Type condition for theme builder</li>\n<li>Fix: Template widget panel not showing the selected template (<a href=\"https://github.com/elementor/elementor/issues/6271\">#6271</a>)</li>\n<li>Fix: Conflict between ACF with Safari browser on Select option in Dynamic tag</li>\n<li>Fix: Add post classes only for the Single template</li>\n<li>Fix: Set document type as not editable for unsupported document like Global widget</li>\n<li>Fix: Avoid duplicate query for current WC product query</li>\n<li>Fix: Product Archive showing oldest products instead of latest</li>\n<li>Fix: CSS reset in Posts widget using cards skin</li>\n</ul>\n<h4>2.2.0 - 2018-11-19</h4>\n<ul>\n<li>New: Introducing Custom Attributes (<a href=\"https://github.com/elementor/elementor/issues/290\">#290</a>, <a href=\"https://github.com/elementor/elementor/issues/3990\">#3990</a>)</li>\n<li>New: Added evergreen option for Countdown widget (<a href=\"https://github.com/elementor/elementor/issues/4459\">#4459</a>)</li>\n<li>New: Added expire actions option for Countdown widget (<a href=\"https://github.com/elementor/elementor/issues/5242\">#5242</a>)</li>\n<li>New: Introducing Reviews widget (<a href=\"https://github.com/elementor/elementor/issues/3854\">#3854</a>)</li>\n<li>New: Introducing Sitemap widget (<a href=\"https://github.com/elementor/elementor/issues/5594\">#5594</a>)</li>\n<li>New: Added Request Parameter dynamic tag (<a href=\"https://github.com/elementor/elementor/issues/4934\">#4934</a>)</li>\n<li>New: Added Shortcode dynamic tag</li>\n<li>New: Added Image and Video Lightbox dynamic tag</li>\n<li>New: Added Contact URL dynamic tag</li>\n<li>New: Added Featured Image Data dynamic tag</li>\n<li>New: Added default value to each field in the Form widget (<a href=\"https://github.com/elementor/elementor/issues/4268\">#4268</a>)</li>\n<li>New: Added &quot;Any Child Of&quot; condition to template conditions (<a href=\"https://github.com/elementor/elementor/issues/5321\">#5321</a>)</li>\n<li>New: Added &quot;In Child&quot; condition to template conditions (<a href=\"https://github.com/elementor/elementor/issues/5587\">#5587</a>)</li>\n<li>Tweak: Added Form Redirect URL with form values (<a href=\"https://github.com/elementor/elementor/issues/2564\">#2564</a>)</li>\n<li>Tweak: Added default post classes to template wrapper (<a href=\"https://github.com/elementor/elementor/issues/5959\">#5959</a>)</li>\n<li>Tweak: Better labels for terms in Query control (<a href=\"https://github.com/elementor/elementor/issues/6092\">#6092</a>)</li>\n<li>Tweak: Renamed &quot;Child Of&quot; templates condition to &quot;Direct Child Of&quot;</li>\n<li>Tweak: Added <code>elementor/theme/get_location_templates/condition_sub_id</code> filter hook to allow template condition translations</li>\n<li>Tweak: Load the Template Library widget via Ajax for better performance</li>\n<li>Tweak: Added 404 page title for Page Title dynamic tag</li>\n<li>Fix: Menu Cart Toggle has # URL link (<a href=\"https://github.com/elementor/elementor/issues/6141\">#6141</a>)</li>\n<li>Fix: Alignment issue in Nav Menu widget (<a href=\"https://github.com/elementor/elementor/issues/5790\">#5790</a>)</li>\n<li>Fix: Avoid potential security risk in forms</li>\n<li>Fix: Template By Author condition conflicts with 404 page</li>\n<li>Fix: Restored WC Product Content widget in Single Product template</li>\n<li>Fix: Theme Builder Preview URLs for date archives and 404 pages</li>\n<li>Fix: Highlight active menu anchor items only when scrolled into view</li>\n<li>Fix: Carousel Pagination Progress style to support new Swiper version</li>\n</ul>\n<h4>2.1.13 - 2018-11-12</h4>\n<ul>\n<li>Tweak: Added compatibility for new brand Finder in v2.3.0</li>\n<li>Fix: Settings conflict when there are multiple carousels in the page</li>\n</ul>\n<h4>2.1.12 - 2018-11-05</h4>\n<ul>\n<li>Tweak: Added compatibility for the upcoming release of Elementor v2.3</li>\n<li>Tweak: Better performance for Template Library widget</li>\n<li>Fix: Fatal error if a taxonomy used in a dynamic field is removed (<a href=\"https://github.com/elementor/elementor/issues/6029\">#6029</a>)</li>\n<li>Fix: Date Time dynamic tag now respect site language (<a href=\"https://github.com/elementor/elementor/issues/6001\">#6001</a>)</li>\n<li>Fix: Custom CSS printed twice in the front-end</li>\n<li>Fix: ACF Image field PHP warning (<a href=\"https://github.com/elementor/elementor/issues/6051\">#6051</a>)</li>\n</ul>\n<h4>2.1.11 - 2018-10-22</h4>\n<ul>\n<li>New: Added ACF local fields compatibility</li>\n<li>Tweak: Re-brand TypeKit by Adobe Fonts integration</li>\n<li>Fix: Exclude <code>is_embed</code> from Singular condition (<a href=\"https://github.com/elementor/elementor/issues/5915\">#5915</a>)</li>\n<li>Fix: Avoid conflict with Ad Blockers and Share Buttons</li>\n<li>Fix: Current date time dynamic tag now shows local time</li>\n<li>Fix: Avoid conflict with 3rd party plugins that filter the permalink</li>\n<li>Fix: Avoid PHP warning when no groups are selected for MailChimp integration</li>\n<li>Fix: Avoid PHP warning if checkbox field is empty for ACF</li>\n<li>Fix: Respect password protected for a WC single product template</li>\n<li>Fix: Respect <code>order</code> settings for WC archive also without pagination</li>\n</ul>\n<h4>2.1.10 - 2018-10-09</h4>\n<ul>\n<li>Tweak: Added responsive alignment control for Share Buttons widget (<a href=\"https://github.com/elementor/elementor/issues/5821\">#5821</a>)</li>\n<li>Tweak: Added link control to Animated Headline widget</li>\n<li>Fix: Mobile nav menu jump on RTL (<a href=\"https://github.com/elementor/elementor/issues/5711\">#5711</a>)</li>\n<li>Fix: Responsive alignment control in Add to Cart widget (<a href=\"https://github.com/elementor/elementor/issues/5830\">#5830</a>)</li>\n<li>Fix: Added IE compatibility for Animated Headline widget</li>\n<li>Fix: Post Content widget is now shown only on <code>Single</code> templates</li>\n<li>Fix: Query Control Pagination with offset</li>\n</ul>\n<h4>2.1.9 - 2018-09-17</h4>\n<ul>\n<li>Tweak: Added Centered Slides option for Slideshow carousel</li>\n<li>Fix: Allow only public CPT for Manual Selection in Query Control (<a href=\"https://github.com/elementor/elementor/issues/5091\">#5091</a>)</li>\n<li>Fix: ACF Gallery option support (<a href=\"https://github.com/elementor/elementor/issues/5344\">#5344</a>)</li>\n<li>Fix: Page scrolling on resize when sticky is active (<a href=\"https://github.com/elementor/elementor/issues/5740\">#5740</a>)</li>\n<li>Fix: Edit custom name for Global Widget in the Navigator (<a href=\"https://github.com/elementor/elementor/issues/5689\">#5689</a>)</li>\n<li>Fix: Coverflow transition effect in Carousel</li>\n<li>Fix: Weird mobile behavior with Cube effect in Carousel</li>\n<li>Fix: Show the first thumbnail in the Slideshow carousel correctly</li>\n</ul>\n<h4>2.1.8 - 2018-09-12</h4>\n<ul>\n<li>Tweak: Added styling options for WC Additional Information widget</li>\n<li>Tweak: Added styling options for \'View Cart\' link in Products widget</li>\n<li>Fix: 3rd party plugin support for WC single product template (<a href=\"https://github.com/elementor/elementor/issues/5338\">#5338</a>)</li>\n<li>Fix: Layout of Related Product widget with WC native style</li>\n</ul>\n<h4>2.1.7 - 2018-09-03</h4>\n<ul>\n<li>New: WC Archive Description widget</li>\n<li>Tweak: Added blend mode to Slides widget background overlay (<a href=\"https://github.com/elementor/elementor/issues/5555\">#5555</a>)</li>\n<li>Tweak: Added \'Current Subcategories\' option to Product Categories widget</li>\n<li>Fix: Added default vertical alignment in Author Box widget (<a href=\"https://github.com/elementor/elementor/issues/5589\">#5589</a>)</li>\n<li>Tweak: Added more blend mode options for CTA widget</li>\n<li>Tweak: Improved plugin updater method based on WordPress version</li>\n<li>Fix: Improved IE compatibility for Posts and Portfolio widgets</li>\n<li>Fix: Added default gap for products pagination</li>\n<li>Fix: Post thumbnail flickering in Safari browser</li>\n<li>Fix: Close mobile nav menu on click only in full-width mode</li>\n<li>Fix: Added trailing slash to pagination links in Posts widget</li>\n</ul>\n<h4>2.1.6 - 2018-08-28</h4>\n<ul>\n<li>New: WC Product Category Image widget and Dynamic tag (<a href=\"https://github.com/elementor/elementor/issues/5117\">#5117</a>)</li>\n<li>Tweak: Allow HTML in Excerpt widget (<a href=\"https://github.com/elementor/elementor/issues/5491\">#5491</a>)</li>\n<li>Tweak: Added compatibility for the upcoming release of Elementor v2.2</li>\n<li>Tweak: Deprecated Follow option in the Facebook Button widget</li>\n<li>Fix: Posts widget grid in Safari &amp; IE11 (Depended on Elementor v2.2)</li>\n<li>Fix: Posts widget CSS when using cards skin in masonry mode</li>\n<li>Fix: ACF Image &amp; ACF URL option support (<a href=\"https://github.com/elementor/elementor/issues/5344\">#5344</a>)</li>\n<li>Fix: WC product gallery links in RTL</li>\n<li>Fix: Dynamic tags in Call To Action widget</li>\n</ul>\n<h4>2.1.5 - 2018-08-21</h4>\n<ul>\n<li>Tweak: Added compatibility for the upcoming release of Elementor v2.2</li>\n<li>Fix: Posts Widget layout theme compatibility</li>\n<li>Fix: Added compatibility for WooCommerce native style</li>\n</ul>\n<h4>2.1.4 - 2018-08-19</h4>\n<ul>\n<li>Fix: Layout issue compatibility with themes caused by v2.1 (<a href=\"https://github.com/elementor/elementor/issues/5442\">#5442</a>)</li>\n<li>Fix: Dynamic setting in Pricing Table widget (<a href=\"https://github.com/elementor/elementor/issues/5460\">#5460</a>)</li>\n<li>Fix: Hide Target URL control if is not necessary in Blockquote widget</li>\n<li>Fix: Selector specificity for WooCommerce Products widget</li>\n<li>Fix: WooCommerce conflicts in the editor in edge cases</li>\n</ul>\n<h4>2.1.3 - 2018-08-15</h4>\n<ul>\n<li>Fix: Thumbnails in the Posts widget jumping (<a href=\"https://github.com/elementor/elementor/issues/5350\">#5350</a>)</li>\n<li>Fix: Responsive grid in the Share Buttons widget (<a href=\"https://github.com/elementor/elementor/issues/5375\">#5375</a>)</li>\n<li>Fix: Added missing <code>setup_postdata</code> for Product Data Tabs widget</li>\n<li>Fix: Rollback to older version of Flip Box widget to resolve 3D depth issue (<a href=\"https://github.com/elementor/elementor/issues/5399\">#5399</a>)</li>\n<li>Fix: Allowed types in the Upload File field are now case-insensitive (<a href=\"https://github.com/elementor/elementor/issues/5254\">#5254</a>)</li>\n<li>Fix: Carousel behavior when using a single slide</li>\n</ul>\n<h4>2.1.2 - 2018-08-12</h4>\n<ul>\n<li>Fix: Error when ACF Pro is not installed (<a href=\"https://github.com/elementor/elementor/issues/5367\">#5367</a>)</li>\n<li>Fix: Edge cases in Inspector where document is a boolean</li>\n<li>Fix: Edge cases for incorrect file fields in PODS</li>\n</ul>\n<h4>2.1.1 - 2018-08-09</h4>\n<ul>\n<li>Fix: Highlighted text in Animated Headline widget (<a href=\"https://github.com/elementor/elementor/issues/5345\">#5345</a>)</li>\n<li>Fix: Flip Box effect issues</li>\n<li>Fix: ACF Options page fields support (<a href=\"https://github.com/elementor/elementor/issues/5329\">#5329</a>)</li>\n<li>Fix: Import Pro templates in edge cases</li>\n</ul>\n<h4>2.1.0 - 2018-08-07</h4>\n<ul>\n<li>New: Introducing WooCommerce Builder (<a href=\"https://github.com/elementor/elementor/issues/1690\">#1690</a>)</li>\n<li>New: Introducing 12 new dynamic tags &amp; widgets for WooCommerce: Gallery, Image, Price, Rating, Description, Breadcrumbs, Data Tabs, Stock, Related, Upsell, Title &amp; Archive</li>\n<li>New: Introducing Cart Menu widget (<a href=\"https://github.com/elementor/elementor/issues/4220\">#4220</a>, <a href=\"https://github.com/elementor/elementor/issues/4600\">#4600</a>)</li>\n<li>New: Added integration with Toolset (<a href=\"https://github.com/elementor/elementor/issues/2949\">#2949</a>)</li>\n<li>New: Added integration with Pods (<a href=\"https://github.com/elementor/elementor/issues/4129\">#4129</a>)</li>\n<li>New: Added stick to bottom in scrolling effects (<a href=\"https://github.com/elementor/elementor/issues/4799\">#4799</a>)</li>\n<li>New: Added Scrolling Effect to Widgets under advanced tab</li>\n<li>New: Introducing Internal URL Dynamic Tag</li>\n<li>Tweak: Added a Last Updated Date in the Post Info widget (<a href=\"https://github.com/elementor/elementor/issues/4597\">#4597</a>)</li>\n<li>Tweak: Added Redirect after Logout option for Login widget (<a href=\"https://github.com/elementor/elementor/issues/4447\">#4447</a>)</li>\n<li>Tweak: Avoid repeating posts when using more than one in the Posts widget (<a href=\"https://github.com/elementor/elementor/issues/1878\">#1878</a>)</li>\n<li>Tweak: Add Custom Query hook for Query control (<a href=\"https://developers.elementor.com/custom-query-filter/\">More Info</a>) (<a href=\"https://github.com/elementor/elementor/issues/1748\">#1748</a>)</li>\n<li>Tweak: Added form-message style (<a href=\"https://github.com/elementor/elementor/issues/1180\">#1180</a>)</li>\n<li>Tweak: Added dynamic tag for button on the Price Table widget (<a href=\"https://github.com/elementor/elementor/issues/4242\">#4242</a>)</li>\n<li>Tweak: Added dynamic tag for Call to action widget (<a href=\"https://github.com/elementor/elementor/issues/4767\">#4767</a>)</li>\n<li>Tweak: Added Dynamic Tags support for Google Map field (<a href=\"https://github.com/elementor/elementor/issues/4602\">#4602</a>)</li>\n<li>Tweak: Added an support for <code>label|value</code> in options field (<a href=\"https://github.com/elementor/elementor/issues/4594\">#4594</a>)</li>\n<li>Tweak: Added <code>by-author</code> condition for theme builder (<a href=\"https://github.com/elementor/elementor/issues/4681\">#4681</a>)</li>\n<li>Tweak: Added Activate/Deactivate license key via WP-CLI command (<a href=\"https://github.com/elementor/elementor/issues/4149\">#4149</a>)</li>\n<li>Tweak: Added <code>is_scroll</code> trigger to scrolling effect (<a href=\"https://github.com/elementor/elementor/issues/4340\">#4340</a>)</li>\n<li>Tweak: Added In Same Term support for Post Navigation widget (<a href=\"https://github.com/elementor/elementor/issues/4177\">#4177</a>)</li>\n<li>Tweak: Added responsive control for Slides To Scroll control in all carousel widgets (<a href=\"https://github.com/elementor/elementor/issues/3697\">#3697</a>)</li>\n<li>Tweak: Added style options for Posts widget (<a href=\"https://github.com/elementor/elementor/issues/1335\">#1335</a>)</li>\n<li>Tweak: Added button CSS ID for Forms widget</li>\n<li>Tweak: Added pixel units to Post-Info divider height control</li>\n<li>Tweak: Rewrite sticky library to handle with stretch section, auto scroller &amp; more bugs</li>\n<li>Tweak: Re-organize the panel categories per document type</li>\n<li>Tweak: Added ACF support for <code>options-page</code> fields</li>\n<li>Tweak: Added dynamic tag for Animated headlines</li>\n<li>Tweak: Added dynamic tag for BlockQuote widget</li>\n<li>Fix: Elementor Full Width template in GeneratePress theme (<a href=\"https://github.com/elementor/elementor/issues/4817\">#4817</a>)</li>\n<li>Fix: Checkbox fields can accidentally be set to required (<a href=\"https://github.com/elementor/elementor/issues/4324\">#4324</a>)</li>\n<li>Fix: Initial slide in Carousel widget</li>\n<li>Fix: Stay on current slide while editing in Carousel widget</li>\n<li>Fix: Default slides per device in Carousel widget</li>\n<li>Deprecated: Woo Products, Woo Elements &amp; Single elements widgets</li>\n</ul>\n<h4>2.0.18 - 2018-07-27</h4>\n<ul>\n<li>Fix: Global widget error on saving page</li>\n</ul>\n<h4>2.0.17 - 2018-07-26</h4>\n<ul>\n<li>Fix: Sub menu indicator direction in Nav Menu widget</li>\n<li>Fix: Change the title and icon for Global Widget when is moving</li>\n<li>Fix: CSS wrapper selector for Page Document</li>\n</ul>\n<h4>2.0.16 - 2018-07-16</h4>\n<ul>\n<li>Tweak: CSS Filter Control module is now included in Elementor</li>\n<li>Fix: Border gap in Portfolio widget when item gap set as <code>0</code> (<a href=\"https://github.com/elementor/elementor/issues/5077\">#5077</a>)</li>\n<li>Fix: Restore current query after get Global Widget data</li>\n<li>Fix: Add action item in History on unlink Global widget</li>\n</ul>\n<h4>2.0.15 - 2018-07-10</h4>\n<ul>\n<li>Fix: Dropdown menu items collapsing when activated (<a href=\"https://github.com/elementor/elementor/issues/4996\">#4996</a>)</li>\n<li>Fix: GMT offset in Countdown widget (<a href=\"https://github.com/elementor/elementor/issues/4997\">#4997</a>)</li>\n</ul>\n<h4>2.0.14 - 2018-07-08</h4>\n<ul>\n<li>Tweak: Added set method to form record for developers (<a href=\"https://github.com/elementor/elementor/issues/4983\">#4983</a>)</li>\n<li>Fix: Autoplay option for Carousels</li>\n<li>Fix: Close mobile menu on item click in the Nav Menu widget</li>\n</ul>\n<h4>2.0.13 - 2018-07-03</h4>\n<ul>\n<li>Tweak: Added compatibility for Elementor v2.1</li>\n</ul>\n<h4>2.0.12 - 2018-07-02</h4>\n<ul>\n<li>Fix: Global widget PHP notices</li>\n<li>Fix: Slides widget active slide lost focus when clicking Editor tabs</li>\n<li>Fix: Form select field send all selected values on multiple selection</li>\n<li>Fix: Validate time field only if it\'s not empty</li>\n<li>Fix: ConvertKit API not saving name field</li>\n</ul>\n<h4>2.0.11 - 2018-06-12</h4>\n<ul>\n<li>Fix: Theme Builder <code>author</code> archive condition (<a href=\"https://github.com/elementor/elementor/issues/4593\">#4593</a>)</li>\n<li>Fix: Respect password protected posts in Post Content widget</li>\n<li>Fix: Custom Fonts redirect to post edit screen in edge cases.</li>\n</ul>\n<h4>2.0.10 - 2018-06-05</h4>\n<ul>\n<li>Tweak: Added <code>elementor/theme/get_location_templates/template_id</code> filter hook for multi-language plugins</li>\n<li>Fix: Dynamic Post Terms missing taxonomies if the taxonomy is registered to more then one post types (#4386)</li>\n<li>Fix: Fields shortcode missing after removing a field in Form widget</li>\n<li>Deprecated: <code>get_theme_templates_by_location</code> is replaced by <code>get_location_templates</code></li>\n</ul>\n<h4>2.0.9 - 2018-05-28</h4>\n<ul>\n<li>Fix: Compatibility for PHP version 5.4</li>\n</ul>\n<h4>2.0.8 - 2018-05-28</h4>\n<ul>\n<li>Tweak: Added Active state for Nav Menu dropdown</li>\n<li>Tweak: Added style for &quot;Nothing Found&quot; Message for Archive Posts widget</li>\n<li>Tweak: Removed caption control in Site Logo widget</li>\n<li>Tweak: Added option to position currency symbol before/after In Price Table widget</li>\n<li>Fix: Query control manual selection does not show more than 10 items (<a href=\"https://github.com/elementor/elementor/issues/4479\">#4479</a>)</li>\n<li>Fix: Styling glitch with terms list in Post Info widget (<a href=\"https://github.com/elementor/elementor/issues/4342\">#4342</a>)</li>\n<li>Fix: Sub terms missing in Query control in edge cases (<a href=\"https://github.com/elementor/elementor/issues/4527\">#4527</a>)</li>\n<li>Fix: Avoid rendering a template if it\'s not published</li>\n<li>Fix: 404 Page style not working</li>\n<li>Fix: Price Table button with hover animation not working in editor</li>\n<li>Fix: Styling conflict in Call to Action widget</li>\n<li>Fix: Global Widget tab translation</li>\n<li>Fix: Adding parent wrapper class to Site Title widget</li>\n</ul>\n<h4>2.0.7 - 2018-05-16</h4>\n<ul>\n<li>Fix: Content not found on section when single is set to &quot;All Singular&quot;</li>\n<li>Fix: Open 404 template library for 404 page</li>\n<li>Tweak: Added CSS prefix for dev files</li>\n<li>Tweak: Removed product post type from display conditions</li>\n</ul>\n<h4>2.0.6 - 2018-05-15</h4>\n<ul>\n<li>Tweak: Set type on create new single template</li>\n<li>Tweak: Always show the conditions dialog in the Draft status</li>\n<li>Tweak: Added document type <code>widget</code></li>\n<li>Tweak: Added Post Custom Field tag to URL category</li>\n<li>Fix: When ACF Field Groups are Empty (<a href=\"https://github.com/elementor/elementor/issues/4428\">#4428</a>)</li>\n<li>Fix: Links inside carousel in edge cases</li>\n<li>Fix: Responsive issue in My Templates area</li>\n<li>Fix: Image alignment for post content with text alignment</li>\n<li>Fix: Post Content widget when preview post is missing</li>\n<li>Fix: Global Widget tab translation</li>\n<li>Fix: Style settings for Post / Archive Title widgets</li>\n</ul>\n<h4>2.0.5 - 2018-05-08</h4>\n<ul>\n<li>Fix: Creating a CPT with name like document-type breaks the editor (<a href=\"https://github.com/elementor/elementor/issues/4203\">#4203</a>)</li>\n<li>Fix: Added support for new version of reCAPTCHA</li>\n<li>Fix: Added fallback for controls after <code>post_status</code></li>\n<li>Fix: Required field in forms widget</li>\n<li>Fix: Media Carousel in the Coverflow skin</li>\n<li>Fix: 404 Page show wrong template in edge cases</li>\n<li>Fix: Save the default menu in the Nav Menu widget</li>\n</ul>\n<h4>2.0.4 - 2018-05-02</h4>\n<ul>\n<li>Tweak: Added parent\'s class for extended widgets</li>\n<li>Tweak: Set entire-site as default to avoid conflict with save without conditions</li>\n<li>Tweak: Initialize global model when it\'s needed</li>\n<li>Tweak: Removed some duplicate strings</li>\n<li>Tweak: Query control now includes empty terms</li>\n<li>Tweak: Design polish for conditions dialog</li>\n<li>Tweak: Decreasing <code>minimumInputLength</code> to 1 of select2</li>\n<li>Fix: Editor not loading for single templates in edge cases</li>\n<li>Fix: Select2 in Safari takes it\'s time to get the original select width (<a href=\"https://github.com/elementor/elementor/issues/4310\">#4310</a>)</li>\n<li>Fix: Slides per view not working for some effects</li>\n<li>Fix: New slides not showing in the editor</li>\n<li>Fix: Editor for section without a defined location, defaults to content area</li>\n</ul>\n<h4>2.0.3 - 2018-04-24</h4>\n<ul>\n<li>Tweak: Optimize CSS for Post Info widget (<a href=\"https://github.com/elementor/elementor/issues/4214\">#4214</a>, <a href=\"https://github.com/elementor/elementor/issues/4216\">#4216</a>, <a href=\"https://github.com/elementor/elementor/issues/4225\">#4225</a>)</li>\n<li>Fix: Double render on frontend view in core locations</li>\n<li>Fix: Masonry not working in edge cases</li>\n<li>Fix: Added default setting for Author Info tag</li>\n</ul>\n<h4>2.0.2 - 2018-04-18</h4>\n<ul>\n<li>Fix: Regenerate conditions to include all templates</li>\n</ul>\n<h4>2.0.1 - 2018-04-17</h4>\n<ul>\n<li>Tweak: Added div wrapper for Nothing Found massage (<a href=\"https://github.com/elementor/elementor/issues/4136\">#4136</a>)</li>\n<li>Tweak: Show empty categories in Query Control &amp; Display Conditions (<a href=\"https://github.com/elementor/elementor/issues/4127\">#4127</a>)</li>\n<li>Tweak: Added Divider control for Post Info widget</li>\n<li>Fix: Update admin links in Yoast Breadcrumbs widget</li>\n<li>Fix: Sticky element conflict with clearfix CSS</li>\n<li>Fix: Compatibility for PHP version 5.4.32 &amp; 5.5.16 and below</li>\n<li>Fix: Avoid running <code>wp_head</code> hooks twice</li>\n</ul>\n<h4>2.0.0 - 2018-04-16</h4>\n<ul>\n<li>New: Introducing Theme Builder - <a href=\"https://elementor.com/introducing-theme-builder/\">Release Post</a> (<a href=\"https://github.com/elementor/elementor/issues/417\">#417</a>)</li>\n<li>New: Introducing Locations API to inject custom location templates</li>\n<li>New: Introducing Display Conditions for all dynamic templates</li>\n<li>New: Introducing Dynamic Tag feature - a new way to add dynamic content to your design</li>\n<li>New: Introducing Role manager to allow &quot;Content Only mode&quot; (<a href=\"https://github.com/elementor/elementor/issues/483\">#483</a>, <a href=\"https://github.com/elementor/elementor/issues/653\">#653</a>, <a href=\"https://github.com/elementor/elementor/issues/885\">#885</a>)</li>\n<li>New: Introducing 9 new dynamic widgets: Archive Posts, Archive Title, Post Content, Post Info, Post Title, Post Excerpt, Featured Image, Site Logo &amp; Site Name (<a href=\"https://github.com/elementor/elementor/issues/543\">#543</a>)</li>\n<li>New: Introducing Developers area with guides and API documentation - <a href=\"https://elementor.com/introducing-elementor-developer-api/\">Release Post</a> (<a href=\"https://github.com/elementor/elementor/issues/451\">#451</a>)</li>\n<li>New: Introducing <a href=\"https://github.com/elementor/elementor-hello-theme\">Elementor Hello Theme</a> - A demonstration theme for developers</li>\n<li>New: Added new type of templates: Header, Footer, Single and Archive (<a href=\"https://github.com/elementor/elementor/issues/2761\">#2761</a>, <a href=\"https://github.com/elementor/elementor/issues/2623\">#2623</a>, <a href=\"https://github.com/elementor/elementor/issues/2109\">#2109</a>, <a href=\"https://github.com/elementor/elementor/issues/2061\">#2061</a>, <a href=\"https://github.com/elementor/elementor/issues/2439\">#2439</a>)</li>\n<li>New: Design 404 page with Single template (<a href=\"https://github.com/elementor/elementor/issues/1558\">#1558</a>)</li>\n<li>New: Design Search Results with Archive template (<a href=\"https://github.com/elementor/elementor/issues/3196\">#3196</a>, <a href=\"https://github.com/elementor/elementor/issues/2590\">#2590</a>)</li>\n<li>New: Added Scrolling Effect for sections including <em>Sticky Element</em> per device (<a href=\"https://github.com/elementor/elementor/issues/2412\">#2412</a>)</li>\n<li>New: Integration with Custom Fields (<a href=\"https://github.com/elementor/elementor/issues/2054\">#2054</a>)</li>\n<li>New: Partial support for Toolset integration (<a href=\"https://github.com/elementor/elementor/issues/2949\">#2949</a>)</li>\n<li>New: Partial support for Pods integration (<a href=\"https://github.com/elementor/elementor/issues/2169\">#2169</a>)</li>\n<li>New: Partial support for ACF integration (<a href=\"https://github.com/elementor/elementor/issues/2041\">#2041</a>, <a href=\"https://github.com/elementor/elementor/issues/2059\">#2059</a>)</li>\n<li>Tweak: Add custom fields support for ActiveCampaign (<a href=\"https://github.com/elementor/elementor/issues/3531\">#3531</a>)</li>\n<li>Tweak: Allow brackets in Forms Tel field</li>\n<li>Tweak: Added currency format control for Price Table widget</li>\n<li>Tweak: Reduced API request for some servers</li>\n<li>Fix: Dropdown <code>border-radius</code> in Nav Menu widget</li>\n<li>Fix: Price List widget layout breaks in edge cases</li>\n<li>Note: This version requires Elementor v2.0.6</li>\n</ul>\n<h4>1.15.6 - 2018-03-28</h4>\n<ul>\n<li>Fix: Removed duplicate Custom CSS section (<a href=\"https://github.com/elementor/elementor/issues/3938\">#3938</a>)</li>\n<li>Fix: <code>box-shadow</code> issue with cards skin (<a href=\"https://github.com/elementor/elementor/issues/3940\">#3940</a>)</li>\n</ul>\n<h4>1.15.5 - 2018-03-27</h4>\n<ul>\n<li>Fix: Added global widget compatibility for Elementor v2.0</li>\n<li>Fix: Reduced API request for some servers</li>\n</ul>\n<h4>1.15.4 - 2018-03-26</h4>\n<ul>\n<li>Tweak: Allow brackets in phone field</li>\n<li>Tweak: Added compatibility with Yoast 7.0.+</li>\n<li>Tweak: Added compatibility for the future release of Elementor v2.0</li>\n<li>Fix: Support for multiple carousel setting in editor</li>\n<li>Fix: <code>on_export</code> issue in forms widget (<a href=\"https://github.com/elementor/elementor/issues/3890\">#3890</a>)</li>\n</ul>\n<h4>1.15.3 - 2018-03-07</h4>\n<ul>\n<li>Tweak: Added unique class to field group div (<a href=\"https://github.com/elementor/elementor/issues/3595\">#3595</a>)</li>\n<li>Fix: Screen Options missing when Pro is active (<a href=\"https://github.com/elementor/elementor/issues/3622\">#3622</a>)</li>\n<li>Fix: Allow label styling even when <code>show labels</code> is set hide (<a href=\"https://github.com/elementor/elementor/issues/3544\">#3544</a>)</li>\n<li>Fix: Typography control not working in edge cases</li>\n<li>Fix: Safari compatibility for Search widget</li>\n</ul>\n<h4>1.15.2 - 2018-02-27</h4>\n<ul>\n<li>Fix: Only add support mine-type if needed (<a href=\"https://github.com/elementor/elementor/issues/3543\">#3543</a>)</li>\n<li>Fix: Better support for Old Typekit kits</li>\n</ul>\n<h4>1.15.1 - 2018-02-21</h4>\n<ul>\n<li>Tweak: Custom font title placeholder is not <code>enter font family</code></li>\n<li>Tweak: Custom font title set as required</li>\n<li>Fix: Custom font, <code>font-face</code> enqueued only once if used in global (<a href=\"https://github.com/elementor/elementor/issues/3513\">#3513</a>)</li>\n<li>Fix: Added workaround for upload validation which relies on a PHP extension (fileinfo) with inconsistent reporting behavior.</li>\n</ul>\n<h4>1.15.0 - 2018-02-19</h4>\n<ul>\n<li>New: Added custom fonts manager for self hosted fonts (<a href=\"https://github.com/elementor/elementor/issues/852\">#852</a>)</li>\n<li>New: Integration with Adobe TypeKit fonts (<a href=\"https://github.com/elementor/elementor/issues/631\">#631</a>)</li>\n<li>Tweak: Clear menu from Nav Menu widget on template export</li>\n<li>Tweak: Allow zero for GetResponse integration as <code>day of cycle</code></li>\n</ul>\n<h4>1.14.2 - 2018-02-13</h4>\n<ul>\n<li>Fix: Global widget content that got affected by previous update</li>\n</ul>\n<h4>1.14.1 - 2018-02-13</h4>\n<ul>\n<li>Tweak: Added <code>none</code> option to content animation in CTA widget</li>\n<li>Tweak: Added <code>form_id</code> to ActiveCampaign integration (<a href=\"https://github.com/elementor/elementor/issues/3422\">#3422</a>)</li>\n<li>Fix: Page crashed when Global widget not found.</li>\n</ul>\n<h4>1.14.0 - 2018-02-12</h4>\n<ul>\n<li>New: Added Call to Action widget</li>\n<li>Tweak: MailPoet pull field mapping from MailPoet instead of hardcoded</li>\n<li>Tweak: Added compatibility for the future release of Elementor v2.0</li>\n<li>Fix: Allow zero (0) to be accepted as a field value</li>\n<li>Fix: Login form when custom login URL is set</li>\n<li>Fix: Added Day of cycle control to GetResponse integration</li>\n</ul>\n<h4>1.13.2 - 2018-01-23</h4>\n<ul>\n<li>Tweak: Added placeholder to Password field</li>\n<li>Tweak: Removed <code>subscriber_already_exists_message</code> control to prevent potential data leakage</li>\n<li>Fix: MailPoet Subscriber Already Exists error validation against translated string directly from MailPoet</li>\n<li>Fix: Changed <code>imagesLoaded()</code> to Vanilla JS to avoid compatibility issues with some themes</li>\n<li>Fix: Only validate Tel field if not empty</li>\n<li>Fix: Stop slider while editing</li>\n</ul>\n<h4>1.13.1 - 2018-01-16</h4>\n<ul>\n<li>Fix: Added compatibility with old PHP versions</li>\n</ul>\n<h4>1.13.0 - 2018-01-16</h4>\n<ul>\n<li>New: Added File Upload field for Forms widget (<a href=\"https://github.com/elementor/elementor/issues/1482\">#1482</a>, <a href=\"https://github.com/elementor/elementor/issues/2974\">#2974</a>)</li>\n<li>New: Added Acceptance field for Forms widget (<a href=\"https://github.com/elementor/elementor/issues/1693\">#1693</a>, <a href=\"https://github.com/elementor/elementor/issues/2974\">#2974</a>)</li>\n<li>New: Added Date field for Forms widget (<a href=\"https://github.com/elementor/elementor/issues/1868\">#1868</a>)</li>\n<li>New: Added Time field for Forms widget</li>\n<li>New: Added Password field for Forms widget (<a href=\"https://github.com/elementor/elementor/issues/2164\">#2164</a>)</li>\n<li>New: Added HTML field for Forms widget (<a href=\"https://github.com/elementor/elementor/issues/1500\">#1500</a>)</li>\n<li>Tweak: Added characters validation for Tel field</li>\n<li>Tweak: Added min &amp; max validation for Number field</li>\n<li>Tweak: Added multiple selection for Select field</li>\n<li>Tweak: Added donReach integration for Share Buttons widget</li>\n</ul>\n<h4>1.12.3 - 2018-01-09</h4>\n<ul>\n<li>Fix: Render element plain content instead of parsed content when not needed in global widget</li>\n<li>Fix: Apply <code>url-encoding</code> to &quot;Tweet&quot; button text in Blockquote widget to prevent unexpected corruption of the tweet text</li>\n<li>Fix: Removed My Account link from dashboard widget</li>\n</ul>\n<h4>1.12.2 - 2018-01-03</h4>\n<ul>\n<li>Tweak: Added animation none for Nav Menu widget (<a href=\"https://github.com/elementor/elementor/issues/2964\">#2964</a>)</li>\n<li>Fix: Active license button style</li>\n</ul>\n<h4>1.12.1 - 2018-01-02</h4>\n<ul>\n<li>Tweak: Removed theme-element widgets from plain content</li>\n<li>Tweak: Set all theme-element widgets to extend same widget Base</li>\n<li>Tweak: Removed credit URL in forms meta data</li>\n<li>Tweak: Added compatibility for the future release of Elementor v1.9</li>\n<li>Fix: Validate Get response Error as real error</li>\n<li>Fix: Removed responsive height control from Facebook Page widget</li>\n</ul>\n<h4>1.12.0 - 2017-12-20</h4>\n<ul>\n<li>New: Added Drip integration to Forms</li>\n<li>New: Added ActiveCampaign integration to Forms</li>\n<li>New: Added ConverKit integration to Forms</li>\n<li>New: Added GetResponse integration to Forms</li>\n<li>New: Added form <code>id</code>, <code>name</code> attributes to handle integration with auto collectors like HubSpot</li>\n<li>New: Added Global API key for MailChimp to improve the workflow</li>\n<li>Tweak: Better error handling and message display for Forms</li>\n<li>Fix: PHP notice Undefined variable <code>$cc_header</code> (<a href=\"https://github.com/elementor/elementor/issues/2934\">#2934</a>)</li>\n</ul>\n<h4>1.11.0 - 2017-12-11</h4>\n<ul>\n<li>New: Added a native Comments widget (<a href=\"https://github.com/elementor/elementor/issues/543\">#543</a>)</li>\n<li>New: Added an Author Box widget</li>\n<li>New: Added a Post Navigation widget</li>\n<li>New: Added a Yoast Breadcrumbs widget (<a href=\"https://github.com/elementor/elementor/issues/2749\">#2749</a>)</li>\n<li>Tweak: Added a close button to search widget under Full Screen skin (<a href=\"https://github.com/elementor/elementor/issues/2762\">#2762</a>)</li>\n<li>Fix: Allow currency symbol to appear even if price isn\'t numeric</li>\n<li>Fix: Edge cases when the nav menu is empty in a stretched section</li>\n<li>Fix: Added fallback when you remove the <code>space-between</code> on Swiper carousel</li>\n</ul>\n<h4>1.10.2 - 2017-12-03</h4>\n<ul>\n<li>Fix: Missing save widget icon (<a href=\"https://github.com/elementor/elementor/issues/2878\">#2878</a>)</li>\n<li>Fix: Global widgets not saving edits (<a href=\"https://github.com/elementor/elementor/issues/2874\">#2874</a>)</li>\n<li>Fix: Removed <code>white-space: nowrap;</code> property from vertical menu in Nav Menu widget (<a href=\"https://github.com/elementor/elementor/issues/2815\">#2815</a>)</li>\n</ul>\n<h4>1.10.1 - 2017-11-30</h4>\n<ul>\n<li>Tweak: Added default value for search form</li>\n<li>Tweak: Order template list A-Z in the library widget</li>\n<li>Tweak: get_users/authors query is now done using AJAX only, for better performance in Query Control (<a href=\"https://github.com/elementor/elementor/issues/2865\">#2865</a>)</li>\n<li>Fix: When adding <code>.00</code> it is not displayed on the front</li>\n<li>Fix: Make sure space between is numeric for carousel control</li>\n<li>Fix: Added space for radio &amp; checkbox fields in form widget</li>\n</ul>\n<h4>1.10.0 - 2017-11-15</h4>\n<ul>\n<li>New: Added native Search form widget (<a href=\"https://github.com/elementor/elementor/issues/2576\">#2576</a>)</li>\n<li>Tweak: Added Slides To Scroll &amp; Loop controls to Media Carousel and Testimonials widgets</li>\n<li>Tweak: Added Inline editing to Blockquote widget</li>\n<li>Fix: Animated Headline color bug (<a href=\"https://github.com/elementor/elementor/issues/2516\">#2516</a>)</li>\n<li>Fix: Animated Headline with Rotating skin</li>\n<li>Fix: RTL fix for Animated Headline widget in \'typing\' and \'clip\' animations</li>\n<li>Fix: Empty menu cause jQuery to crash in Menu widget (<a href=\"https://github.com/elementor/elementor/issues/2662\">#2662</a>)</li>\n<li>Fix: Custom CSS gone after reloading the editor</li>\n</ul>\n<h4>1.9.5 - 2017-10-27</h4>\n<ul>\n<li>Fix: Broken Global widget with JS (<a href=\"https://github.com/elementor/elementor/issues/2639\">#2639</a>)</li>\n</ul>\n<h4>1.9.4 - 2017-10-24</h4>\n<ul>\n<li>Tweak: Improved UI for notices and license page</li>\n<li>Fix: Update system conflict with other EDD plugins</li>\n<li>Fix: WooCommerce frontend hooks on Elementor editor (<a href=\"https://github.com/elementor/elementor/issues/2577\">#2577</a>)</li>\n<li>Fix: Removed default border left in Nav Menu dropdown CSS (<a href=\"https://github.com/elementor/elementor/issues/2496\">#2496</a>)</li>\n<li>Fix: Increased submenu max-width (<a href=\"https://github.com/elementor/elementor/issues/2558\">#2558</a>)</li>\n<li>Fix: Save global templates without their defaults</li>\n<li>Fix: Horizontal scrolling issue with posts grid</li>\n</ul>\n<h4>1.9.3 - 2017-10-03</h4>\n<ul>\n<li>Fix: Condition slide style that got affected by previous update</li>\n</ul>\n<h4>1.9.2 - 2017-10-02</h4>\n<ul>\n<li>New: Added integration with MailPoet 3 for Forms actions</li>\n<li>Fix: Removed height control from Testimonial carousel in mobile editing mode</li>\n<li>Fix: Removed bottom padding when there\'s no pagination in Testimonial carousel</li>\n<li>Fix: Added condition for slides style section in skin bubble mode</li>\n<li>Fix: Slides per view control for mobile editing in Testimonial carousel</li>\n<li>Fix: Navigation Arrows icons matched with common Elementor Navigation Arrows</li>\n</ul>\n<h4>1.9.1 - 2017-09-28</h4>\n<ul>\n<li>Fix: Slides per view for slideshow carousel</li>\n<li>Fix: Final polish for the new Testimonial Carousel widget</li>\n<li>Fix: Don\'t play video if slide type is not video</li>\n<li>Fix: Removed slides style section condition (<a href=\"https://github.com/elementor/elementor/issues/2497\">#2497</a>)</li>\n<li>Fix: Set cursor as pointer for slideshow thumbnails</li>\n</ul>\n<h4>1.9.0 - 2017-09-26</h4>\n<ul>\n<li>New: Added Media Carousel widget (<a href=\"https://github.com/elementor/elementor/issues/216\">#216</a>, <a href=\"https://github.com/elementor/elementor/issues/347\">#347</a>, <a href=\"https://github.com/elementor/elementor/issues/2209\">#2209</a>)</li>\n<li>New: Added Testimonial Carousel widget (<a href=\"https://github.com/elementor/elementor/issues/715\">#715</a>)</li>\n</ul>\n<h4>1.8.3 - 2017-09-24</h4>\n<ul>\n<li>Fix: Added compatibility for WordPress 4.8.2 &amp; 4.7.6</li>\n<li>Fix: Remove slashes from Form sent data</li>\n</ul>\n<h4>1.8.2 - 2017-09-19</h4>\n<ul>\n<li>Tweak: Added target URL for the tweet message in Blockquote widget</li>\n<li>Tweak: Render the slide height before the slider is finished loading</li>\n<li>Fix: Space between words for Animated Headline widget</li>\n<li>Fix: RTL compatibility for Animated Headline widget</li>\n<li>Fix: Italic font style for Animated Headline widget</li>\n<li>Fix: Excluded Menu widget from the WP Editor text rendering</li>\n</ul>\n<h4>1.8.1 - 2017-09-18</h4>\n<ul>\n<li>Fix: WCAG Compatible &quot;required&quot; field attribute for W3C validation (<a href=\"https://github.com/elementor/elementor/issues/2391\">#2391</a>)</li>\n<li>Fix: Print the main menu only when is necessary in Menu widget</li>\n<li>Fix: Use CSS media query instead of JS to hide items in Menu widget to avoid flickering on page load (<a href=\"https://github.com/elementor/elementor/issues/2381\">#2381</a>)</li>\n</ul>\n<h4>1.8.0 - 2017-09-12</h4>\n<ul>\n<li>New: Added Nav Menu widget (<a href=\"https://github.com/elementor/elementor/issues/1406\">#1406</a>)</li>\n<li>Fix: Field ID for checkbox control in Form widget (<a href=\"https://github.com/elementor/elementor/issues/2279\">#2279</a>)</li>\n<li>Fix: Style for Blockquote widget included</li>\n</ul>\n<h4>1.7.2 - 2017-09-07</h4>\n<ul>\n<li>Tweak: Loading Facebook SDK via JS for better compatibility with caching plugins</li>\n<li>Fix: Responsive Embed Facebook post widget for Safari iOS (<a href=\"https://github.com/elementor/elementor/issues/2340\">#2340</a>)</li>\n</ul>\n<h4>1.7.1 - 2017-09-05</h4>\n<ul>\n<li>Fix: Facebook SDK version</li>\n</ul>\n<h4>1.7.0 - 2017-09-05</h4>\n<ul>\n<li>New: Added Facebook Button widget for Like, Recommend, Share and Follow</li>\n<li>New: Added Facebook Embed widget for Post, Video and Comment</li>\n<li>New: Added Facebook Comments widget</li>\n<li>New: Added Facebook Page widget (Previously known as Like Box)</li>\n<li>New: Added Blockquote widget with Tweet button</li>\n<li>Tweak: Added Facebook SDK integration for all Facebook widgets</li>\n<li>Fix: Animated headline rotating with long words</li>\n</ul>\n<h4>1.6.1 - 2017-08-28</h4>\n<ul>\n<li>Fix: Animated Headline marker gets in front of neighboring spans even when &quot;Bring to Front&quot; is not set</li>\n<li>Fix: Stroke animation in Animated Headline for MS Edge browser</li>\n<li>Fix: Animated headline with more than 1-word per rotation</li>\n<li>Fix: Animated Headline in two lines</li>\n<li>Fix: Some errors in Global widget</li>\n</ul>\n<h4>1.6.0 - 2017-08-22</h4>\n<ul>\n<li>New: Added Animated Headline widget</li>\n<li>New: Added Hidden field for Forms widget (<a href=\"https://github.com/elementor/elementor/issues/2038\">#2038</a>)</li>\n<li>Tweak: Added notice to update Elementor to v1.6.5 or higher</li>\n<li>Fix: CSS Animations names no longer minified, in order to prevent unexpected conflicts</li>\n</ul>\n<h4>1.5.9 - 2017-08-16</h4>\n<ul>\n<li>Tweak: Added compatibility for the future release of Elementor v1.7</li>\n<li>Fix: Portfolio compatibility for GeneratePress theme</li>\n<li>Fix: Portfolio filter compatibility for RTL</li>\n<li>Fix: Pagination apply for all posts widget in the page</li>\n<li>Fix: Global form widget with MailChimp integration not saving</li>\n</ul>\n<h4>1.5.8 - 2017-07-25</h4>\n<ul>\n<li>Tweak: Added compatibility for the future release of Elementor v1.6</li>\n<li>Fix: Improved backward compatibility for query control rename</li>\n</ul>\n<h4>1.5.7 - 2017-07-24</h4>\n<ul>\n<li>Tweak: Moved JS render of reCAPTCHA to a separate file</li>\n<li>Tweak: Display the label in the reCAPTCHA field for better experience</li>\n<li>Tweak: Rename <code>panel-posts-control</code> to <code>query-control</code> and added fallback support</li>\n<li>Tweak: Added compatibility for the future release of Elementor with history feature</li>\n<li>Fix: reCAPTCHA preview on the editor</li>\n<li>Fix: Manual selection (query control) has stopped working after saving (<a href=\"https://github.com/elementor/elementor/issues/2000\">#2000</a>)</li>\n<li>Fix: Added condition for icon size control in Share Buttons widget</li>\n</ul>\n<h4>1.5.6 - 2017-07-12</h4>\n<ul>\n<li>Fix: Query Control correction for taxonomies (<a href=\"https://github.com/elementor/elementor/issues/1963\">#1963</a>)</li>\n<li>Fix: Custom CSS override scheme color in the editor</li>\n<li>Fix: Added order by Menu Order for Query Control in WC widget</li>\n<li>Fix: Glitch with Flip Box background overlay</li>\n</ul>\n<h4>1.5.5 - 2017-07-03</h4>\n<ul>\n<li>Tweak: Moved reCAPTCHA render to handler &amp; load only if a form is exist</li>\n<li>Fix: MailChimp integration: Default number of items returned by API increased to 999</li>\n<li>Fix: MailChimp integration: Refresh the groups list if API is changed</li>\n<li>Fix: Sorted items in filter bar by A-Z</li>\n<li>Fix: Editor glitch with Elementor v1.5 (<a href=\"https://github.com/elementor/elementor/issues/1927\">#1927</a>)</li>\n</ul>\n<h4>1.5.4 - 2017-06-22</h4>\n<ul>\n<li>Tweak: Improved compatibility for Elementor v1.5</li>\n<li>Fix: URL default for Add To Cart widget</li>\n<li>Fix: Allowed <code>date</code> and <code>birthday</code> fields as text for MailChimp integration</li>\n</ul>\n<h4>1.5.3 - 2017-06-19</h4>\n<ul>\n<li>Tweak: Make flip-box height responsive control</li>\n<li>Fix: Facebook share count now gets retrieved by Elementor (<a href=\"https://github.com/elementor/elementor/issues/1829\">#1829</a>)</li>\n<li>Fix: Global form widget with MailChimp integration not saving</li>\n</ul>\n<h4>1.5.2 - 2017-06-13</h4>\n<ul>\n<li>Fix: Custom CSS panel location compatibility for the old versions</li>\n</ul>\n<h4>1.5.1 - 2017-06-12</h4>\n<ul>\n<li>Fix: MailChimp update existing user registration</li>\n<li>Fix: Global widget with JS in the editor mode</li>\n<li>Fix: Label section condition in Login widget</li>\n<li>Fix: Changes to unlinked global widget do not appear in the editor</li>\n</ul>\n<h4>1.5.0 - 2017-05-23</h4>\n<ul>\n<li>New: Added Cards, a new skin for Posts widget</li>\n<li>New: Added Exclude option to post query control group</li>\n<li>Tweak: Added <code>post_class()</code> for each post in the loop</li>\n<li>Tweak: Added <code>.elementor-posts-masonry</code> class when Masonry layout is enabled</li>\n<li>Tweak: Added compatibility for the next release of Elementor v1.5.0</li>\n<li>Tweak: CSS <code>autoprefixer</code> now supports last 5 versions of browsers</li>\n<li>Tweak: Added <code>imageLoaded</code> library for Posts &amp; Portfolio widgets</li>\n</ul>\n<h4>1.4.4 - 2017-05-18</h4>\n<ul>\n<li>Fix: Force Mailchimp API to return all lists and not just 10 (<a href=\"https://github.com/elementor/elementor/issues/1683\">#1683</a>)</li>\n<li>Fix: Added <code>.elementor-form</code> class to Login form to fix style glitch</li>\n</ul>\n<h4>1.4.3 - 2017-05-14</h4>\n<ul>\n<li>Tweak: Added Redirect After Login option to Login widget</li>\n<li>Tweak: Stay in the current page after logout in Login widget</li>\n<li>Tweak: Preparation for Elementor settings tabs in future version</li>\n<li>Fix: Pinterest in Share Buttons widget now sharing the URL alone</li>\n<li>Fix: Bug with <code>active</code> class in portfolio filter item</li>\n<li>Fix: Higher specific list-style-type <code>none</code> for filter items to override some theme style</li>\n</ul>\n<h4>1.4.2 - 2017-05-06</h4>\n<ul>\n<li>Fix: Temporary patch for form field shortcode in some servers</li>\n</ul>\n<h4>1.4.1 - 2017-05-03</h4>\n<ul>\n<li>Fix: Bug with custom success message in form widget</li>\n<li>Fix: Bug with meta data in email action</li>\n</ul>\n<h4>1.4.0 - 2017-05-03</h4>\n<ul>\n<li>New: Forms: integration with MailChimp</li>\n<li>New: Forms: integration with MailPoet</li>\n<li>New: Forms: Added Email 2 action for email confirmation</li>\n<li>New: Forms: Added shortcodes for fields</li>\n<li>New: Forms: Added custom ID for fields</li>\n<li>New: Forms: Added option to edit email HTML template (<a href=\"https://github.com/elementor/elementor/issues/1180\">#1180</a>)</li>\n<li>New: Added Login widget</li>\n<li>Tweak: Move <code>send_html</code> control to <code>email_content_type</code></li>\n<li>Fix: Email still sent even if validation failed in form widget</li>\n</ul>\n<h4>1.3.2 - 2017-05-01</h4>\n<ul>\n<li>New: Added action <code>elementor_pro/init</code> for better integration with Elementor Pro</li>\n<li>Fix: Posts without featured image in Posts widget (<a href=\"https://github.com/elementor/elementor/issues/1234\">#1234</a>, <a href=\"https://github.com/elementor/elementor/issues/1382\">#1382</a>)</li>\n<li>Fix: reCAPTCHA &amp; Honeypot fields with new method</li>\n<li>Fix: Added border width control in Share Buttons to avoid a glitch on Chrome browser</li>\n<li>Fix: Border radius glitch on hover in Share Buttons</li>\n</ul>\n<h4>1.3.1 - 2017-04-25</h4>\n<ul>\n<li>Fix: Conflict update with revision history module</li>\n</ul>\n<h4>1.3.0 - 2017-04-25</h4>\n<ul>\n<li>New: Added Share Buttons widget (<a href=\"https://wordpress.org/support/topic/social-sharing-buttons-is-it-possible/\">Topic</a>)</li>\n<li>New: Added Custom CSS for Page Settings</li>\n<li>New: Added Masonry layout for Portfolio widget</li>\n<li>New: Added Cc &amp; Bcc options to email action (<a href=\"https://github.com/elementor/elementor/issues/1181\">#1181</a>)</li>\n<li>New: Introduced <code>ElementorPro\\Modules\\Forms\\Classes\\Action_Base</code> class for better 3rd party integration for forms</li>\n<li>Tweak: Debugger module now also shows errors from Pro</li>\n<li>Tweak: Added options for Elementor Library</li>\n<li>Tweak: New base posts module for optimized performance</li>\n<li>Tweak: Adjusting Posts / Portfolio to the new structure</li>\n<li>Fix: Export for posts / portfolio</li>\n<li>Fix: Duplicate repeater field with switcher control (<a href=\"https://github.com/elementor/elementor/issues/1442\">#1442</a>)</li>\n<li>Fix: Post per Page in the query control</li>\n<li>Fix: Metadata does not come through on form emails (<a href=\"https://github.com/elementor/elementor/issues/1566\">#1566</a>)</li>\n</ul>\n<h4>1.2.6 - 2017-04-19</h4>\n<ul>\n<li>Fix: Added compatibility with WooCommerce 3.0 - Products &amp; Add to Cart widgets</li>\n</ul>\n<h4>1.2.5 - 2017-04-18</h4>\n<ul>\n<li>Fix: Offset query for posts widgets (Posts, Portfolio and Products)</li>\n</ul>\n<h4>1.2.4 - 2017-03-21</h4>\n<ul>\n<li>Tweak: Added Indian Rupee sign to Price Table widget</li>\n<li>Fix: Portfolio grid for IE11</li>\n<li>Fix: Link target blank in Price List widget</li>\n<li>Fix: Active item for filter bar in Portfolio widget</li>\n</ul>\n<h4>1.2.3 - 2017-03-06</h4>\n<ul>\n<li>Tweak: Fully compatible with Elementor v1.3.0</li>\n<li>Tweak: Added trigger for after form submission in Forms widget</li>\n<li>Tweak: Changed handle name in reCAPTCHA field to avoid conflict with other contact forms</li>\n<li>Fix: Portfolio filter syntax in Non-Latin languages</li>\n<li>Fix: Added <code>no-repeat</code> property for slide with <code>background-size:contain</code></li>\n<li>Fix: Condition control &amp; Import value in Posts widgets</li>\n<li>Fix: Offset and Pagination in WordPress (<a href=\"https://codex.wordpress.org/Making_Custom_Queries_using_Offset_and_Pagination\">More Info</a>)</li>\n<li>Fix: Submit handler bubbling for custom events in Forms widget</li>\n</ul>\n<h4>1.2.2 - 2017-02-23</h4>\n<ul>\n<li>Tweak: Change name from Side A/B to Front and Back in Flip Box widget</li>\n<li>Fix: Error when saving third party widgets in the global widget</li>\n<li>Fix: Image position &quot;none&quot; remains visible in editor preview (Posts)</li>\n<li>Fix: Hide the pagination when there are no links</li>\n</ul>\n<h4>1.2.1 - 2017-02-21</h4>\n<ul>\n<li>Fix: Firefox Flip Box 3D compatibility</li>\n</ul>\n<h4>1.2.0 - 2017-02-21</h4>\n<ul>\n<li>New: Added Flip Box widget</li>\n<li>New: Added Ken Burns effect for slides</li>\n<li>New: Added Masonry layout for Posts widget</li>\n<li>New: Added Pagination option for Posts widget</li>\n<li>Tweak: Added background size contain to slides</li>\n<li>Tweak: Improve Query control by preload items</li>\n<li>Fix: Text color for Checkbox and Radio fields</li>\n</ul>\n<h4>1.1.2 - 2017-02-05</h4>\n<ul>\n<li>Tweak: Added <code>aria-required</code> for better accessibility in forms widget</li>\n<li>Fix: Conflict Call to <code>undefined</code> method in Posts &amp; Portfolio widgets (<a href=\"https://github.com/elementor/elementor/issues/1271\">#1271</a>, <a href=\"https://github.com/elementor/elementor/issues/1266\">#1266</a>)</li>\n<li>Fix: Submit button HTML after error sending</li>\n<li>Fix: Success message for <code>skip_email</code> function</li>\n<li>Notice: Elementor 1.2.0 or later now required</li>\n</ul>\n<h4>1.1.1 - 2017-01-24</h4>\n<ul>\n<li>Fix: Can\'t save global widgets when <code>WP_DEBUG</code> is <code>true</code></li>\n<li>Fix: Undefined variable in WC widgets</li>\n<li>Fix: Removed duplicate strings</li>\n</ul>\n<h4>1.1.0 - 2017-01-24</h4>\n<ul>\n<li>New: Price Table widget (<a href=\"https://github.com/elementor/elementor/issues/102\">#102</a>)</li>\n<li>New: WooCommerce Add to Cart widget</li>\n<li>New: WooCommerce Categories widget</li>\n<li>New: WooCommerce Elements widget</li>\n<li>New: Honeypot field for Forms widgets</li>\n<li>Tweak: Added inline options for taxonomies &amp; authors if is less than 15 items</li>\n<li>Tweak: Added Required Mark for fields in Forms widget</li>\n<li>Fix: CSS selectors priority in Slides widget</li>\n<li>Fix: CSS bug in Price List widget</li>\n<li>Fix: Update all Post CSS files that includes specific Global Widget</li>\n</ul>\n<h4>1.0.9 - 2017-01-18</h4>\n<ul>\n<li>Fix: Auto complete bug in query controls</li>\n<li>Fix: Render template with escaping slashes</li>\n<li>Fix: Reply-to field in Forms widget</li>\n</ul>\n<h4>1.0.8 - 2017-01-11</h4>\n<ul>\n<li>Tweak: Code adjustments for Elementor API</li>\n<li>Fix: Removed go pro link from plugins page in admin</li>\n</ul>\n<h4>1.0.7 - 2017-01-05</h4>\n<ul>\n<li>Tweak: Added filter by featured / sale for WC Products widget</li>\n<li>Tweak: Added author control in Portfolio widget</li>\n<li>Tweak: Code adjustments for Elementor API</li>\n<li>Fix: Added support for empty image ratio</li>\n<li>Fix: Avoid nesting a sidebar within a template that will appear in the sidebar itself</li>\n</ul>\n<h4>1.0.6 - 2017-01-01</h4>\n<ul>\n<li>Tweak: Added Auto-updates for local translation files</li>\n<li>Fix: Custom CSS for Global widgets</li>\n<li>Fix: Remove <code>nonce</code> field (Fix some cache plugins)</li>\n</ul>\n<h4>1.0.5 - 2016-12-27</h4>\n<ul>\n<li>Fix: Slide element bug fix - \'Link apply on\' logic</li>\n<li>Fix: Removed unique wrapper for Custom CSS in order to allow media queries (<a href=\"https://github.com/elementor/elementor/issues/1086\">#1086</a>)</li>\n</ul>\n<h4>1.0.4 - 2016-12-21</h4>\n<ul>\n<li>Tweak: Mobile Editing for fields in the form widget</li>\n<li>Tweak: Mobile Editing for posts</li>\n<li>Tweak: Allow send form as HTML</li>\n<li>Tweak: Improved auto upgrades for Multisite installation</li>\n<li>Tweak: Improve editor rendering experience for Portfolio widget</li>\n<li>Fix: Posts widget check if image exist</li>\n<li>Fix: Changed the clone method for global widget (<a href=\"https://github.com/elementor/elementor/issues/1042\">#1042</a>)</li>\n<li>Fix: Bug slides in RTL (removed direction control)</li>\n<li>Fix: Slides with no height jumps when changing slides</li>\n</ul>\n<h4>1.0.3 - 2016-12-13</h4>\n<ul>\n<li>Fix: Added escape placeholder for HTML Entities in form widget</li>\n<li>Fix: Countdown widget RTL bug</li>\n<li>Fix: Remove redundant #elementor selector for control style</li>\n<li>Fix: Added prefixing with \'0\' for one digit number in Countdown widget</li>\n</ul>\n<h4>1.0.2 - 2016-12-12</h4>\n<ul>\n<li>Fix: Page layout collapses when inserting reCAPTCHA field in Form</li>\n</ul>\n<h4>1.0.1 - 2016-12-12</h4>\n<ul>\n<li>Fix: WordPress widgets disappear from Editor when Elementor Pro active</li>\n</ul>\n<h4>1.0.0 - 2016-12-12</h4>\n<ul>\n<li>Initial release</li>\n</ul>\";}\";s:11:\"new_version\";s:5:\"2.7.3\";s:4:\"name\";s:13:\"Elementor Pro\";s:4:\"slug\";s:13:\"elementor-pro\";s:3:\"url\";s:36:\"https://elementor.com/pro/changelog/\";s:8:\"homepage\";s:26:\"https://elementor.com/pro/\";s:8:\"requires\";s:3:\"4.7\";s:6:\"tested\";s:5:\"5.2.3\";s:7:\"package\";s:184:\"http://my.elementor.com/edd-sl/package_download/MTU3MzQ2NzE0MTo2N2MyMGFmMTY2ZmNlNDljZDM2YmFmMTFjYjYwNGIzYToxOmUxNWYxYWUyYWU5ZTg1MzEwODI5ODdhNDkxNGJlNjQ1Omh0dHBzQC8vZW1pbHlodW50LmNoOjA=\";s:13:\"download_link\";s:184:\"http://my.elementor.com/edd-sl/package_download/MTU3MzQ2NzE0MTo2N2MyMGFmMTY2ZmNlNDljZDM2YmFmMTFjYjYwNGIzYToxOmUxNWYxYWUyYWU5ZTg1MzEwODI5ODdhNDkxNGJlNjQ1Omh0dHBzQC8vZW1pbHlodW50LmNoOjA=\";s:7:\"banners\";a:2:{s:2:\"2x\";s:65:\"https://ps.w.org/elementor/assets/banner-1544x500.png?rev=1475479\";s:2:\"1x\";s:64:\"https://ps.w.org/elementor/assets/banner-772x250.png?rev=1475479\";}s:5:\"icons\";a:1:{s:3:\"svg\";s:42:\"https://ps.w.org/elementor/assets/icon.svg\";}s:17:\"canary_deployment\";a:2:{s:11:\"plugin_info\";a:11:{s:11:\"new_version\";s:5:\"2.7.1\";s:4:\"name\";s:13:\"Elementor Pro\";s:4:\"slug\";s:13:\"elementor-pro\";s:3:\"url\";s:36:\"https://elementor.com/pro/changelog/\";s:8:\"homepage\";s:26:\"https://elementor.com/pro/\";s:8:\"requires\";s:3:\"4.7\";s:6:\"tested\";s:5:\"5.2.3\";s:7:\"package\";s:189:\"http://my.elementor.com/edd-sl/previous_download/MTU3MzQ2NzE0MTo2N2MyMGFmMTY2ZmNlNDljZDM2YmFmMTFjYjYwNGIzYToxOjIuNy4xOmE3OTQ0ZjM5YjcxNWNkYmNlOGM4MjViMmJjNDcxMWZjOmh0dHBzQC8vZW1pbHlodW50LmNo\";s:13:\"download_link\";s:189:\"http://my.elementor.com/edd-sl/previous_download/MTU3MzQ2NzE0MTo2N2MyMGFmMTY2ZmNlNDljZDM2YmFmMTFjYjYwNGIzYToxOjIuNy4xOmE3OTQ0ZjM5YjcxNWNkYmNlOGM4MjViMmJjNDcxMWZjOmh0dHBzQC8vZW1pbHlodW50LmNo\";s:7:\"banners\";a:2:{s:2:\"2x\";s:65:\"https://ps.w.org/elementor/assets/banner-1544x500.png?rev=1475479\";s:2:\"1x\";s:64:\"https://ps.w.org/elementor/assets/banner-772x250.png?rev=1475479\";}s:5:\"icons\";a:1:{s:3:\"svg\";s:42:\"https://ps.w.org/elementor/assets/icon.svg\";}}s:10:\"conditions\";a:1:{i:0;a:1:{i:0;a:3:{s:4:\"type\";s:8:\"language\";s:9:\"languages\";a:6:{i:0;s:5:\"he_IL\";i:1;s:5:\"en_GB\";i:2;s:5:\"en_NZ\";i:3;s:5:\"en_ZA\";i:4;s:5:\"en_AU\";i:5;s:5:\"en_CA\";}s:8:\"operator\";s:2:\"in\";}}}}s:12:\"translations\";a:1:{i:0;a:3:{s:8:\"language\";s:5:\"fr_FR\";s:7:\"updated\";s:24:\"2019-11-10 08:15:07+0000\";s:7:\"package\";s:90:\"http://translate.elementor.com/wp-content/uploads/pro-translations/elementor-pro-fr_FR.zip\";}}}", "no");
INSERT INTO `wp_464683_options` VALUES("604", "_transient_timeout_elementor_remote_info_api_data_2.7.5", "1573423941", "no");
INSERT INTO `wp_464683_options` VALUES("605", "_transient_elementor_remote_info_api_data_2.7.5", "a:3:{s:9:\"timestamp\";i:1573378090;s:14:\"upgrade_notice\";a:3:{s:7:\"version\";s:5:\"2.0.0\";s:7:\"message\";s:0:\"\";s:11:\"update_link\";s:0:\"\";}s:17:\"canary_deployment\";a:2:{s:11:\"plugin_info\";a:11:{s:2:\"id\";s:23:\"w.org/plugins/elementor\";s:4:\"slug\";s:9:\"elementor\";s:6:\"plugin\";s:23:\"elementor/elementor.php\";s:11:\"new_version\";s:5:\"2.7.0\";s:7:\"package\";s:58:\"https://downloads.wordpress.org/plugin/elementor.2.7.0.zip\";s:3:\"url\";s:40:\"https://wordpress.org/plugins/elementor/\";s:5:\"icons\";a:3:{s:2:\"2x\";s:62:\"https://ps.w.org/elementor/assets/icon-256x256.png?rev=1427768\";s:2:\"1x\";s:54:\"https://ps.w.org/elementor/assets/icon.svg?rev=1426809\";s:3:\"svg\";s:54:\"https://ps.w.org/elementor/assets/icon.svg?rev=1426809\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:65:\"https://ps.w.org/elementor/assets/banner-1544x500.png?rev=1475479\";s:2:\"1x\";s:64:\"https://ps.w.org/elementor/assets/banner-772x250.png?rev=1475479\";}s:11:\"banners_rtl\";a:0:{}s:6:\"tested\";s:5:\"5.2.3\";s:12:\"requires_php\";s:3:\"5.4\";}s:10:\"conditions\";a:1:{i:0;a:1:{i:0;a:3:{s:4:\"type\";s:8:\"language\";s:9:\"languages\";a:6:{i:0;s:5:\"he_IL\";i:1;s:5:\"en_GB\";i:2;s:5:\"en_NZ\";i:3;s:5:\"en_ZA\";i:4;s:5:\"en_AU\";i:5;s:5:\"en_CA\";}s:8:\"operator\";s:2:\"in\";}}}}}", "no");
INSERT INTO `wp_464683_options` VALUES("606", "_site_transient_timeout_theme_roots", "1573382541", "no");
INSERT INTO `wp_464683_options` VALUES("607", "_site_transient_theme_roots", "a:3:{s:10:\"blankslate\";s:7:\"/themes\";s:14:\"twentynineteen\";s:7:\"/themes\";s:15:\"twentyseventeen\";s:7:\"/themes\";}", "no");
INSERT INTO `wp_464683_options` VALUES("608", "_site_transient_update_themes", "O:8:\"stdClass\":4:{s:12:\"last_checked\";i:1573380742;s:7:\"checked\";a:3:{s:10:\"blankslate\";s:6:\"2019.1\";s:14:\"twentynineteen\";s:3:\"1.4\";s:15:\"twentyseventeen\";s:3:\"2.2\";}s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}}", "no");
INSERT INTO `wp_464683_options` VALUES("609", "_transient_timeout_elementor_pro_license_data", "1573423942", "no");
INSERT INTO `wp_464683_options` VALUES("610", "_transient_elementor_pro_license_data", "a:14:{s:7:\"success\";b:1;s:7:\"license\";s:5:\"valid\";s:7:\"item_id\";b:0;s:9:\"item_name\";s:13:\"Elementor Pro\";s:8:\"checksum\";s:32:\"81f6b46a2d090abf0c199c2a42203cdd\";s:7:\"expires\";s:19:\"2020-10-30 23:59:59\";s:10:\"payment_id\";i:45491;s:13:\"customer_name\";s:16:\"Karyna Ainsworth\";s:14:\"customer_email\";s:20:\"kwebmaster@pobox.com\";s:13:\"license_limit\";i:1000;s:10:\"site_count\";i:115;s:16:\"activations_left\";i:885;s:8:\"price_id\";s:1:\"3\";s:13:\"subscriptions\";s:6:\"enable\";}", "no");

/* INSERT TABLE DATA: wp_464683_postmeta */
INSERT INTO `wp_464683_postmeta` VALUES("2", "3", "_wp_page_template", "default");
INSERT INTO `wp_464683_postmeta` VALUES("122", "184", "_menu_item_type", "custom");
INSERT INTO `wp_464683_postmeta` VALUES("123", "184", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_464683_postmeta` VALUES("124", "184", "_menu_item_object_id", "184");
INSERT INTO `wp_464683_postmeta` VALUES("125", "184", "_menu_item_object", "custom");
INSERT INTO `wp_464683_postmeta` VALUES("126", "184", "_menu_item_target", "");
INSERT INTO `wp_464683_postmeta` VALUES("127", "184", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_464683_postmeta` VALUES("128", "184", "_menu_item_xfn", "");
INSERT INTO `wp_464683_postmeta` VALUES("129", "184", "_menu_item_url", "#aboutme");
INSERT INTO `wp_464683_postmeta` VALUES("130", "185", "_menu_item_type", "custom");
INSERT INTO `wp_464683_postmeta` VALUES("131", "185", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_464683_postmeta` VALUES("132", "185", "_menu_item_object_id", "185");
INSERT INTO `wp_464683_postmeta` VALUES("133", "185", "_menu_item_object", "custom");
INSERT INTO `wp_464683_postmeta` VALUES("134", "185", "_menu_item_target", "");
INSERT INTO `wp_464683_postmeta` VALUES("135", "185", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_464683_postmeta` VALUES("136", "185", "_menu_item_xfn", "");
INSERT INTO `wp_464683_postmeta` VALUES("137", "185", "_menu_item_url", "#materials");
INSERT INTO `wp_464683_postmeta` VALUES("138", "186", "_menu_item_type", "custom");
INSERT INTO `wp_464683_postmeta` VALUES("139", "186", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_464683_postmeta` VALUES("140", "186", "_menu_item_object_id", "186");
INSERT INTO `wp_464683_postmeta` VALUES("141", "186", "_menu_item_object", "custom");
INSERT INTO `wp_464683_postmeta` VALUES("142", "186", "_menu_item_target", "");
INSERT INTO `wp_464683_postmeta` VALUES("143", "186", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_464683_postmeta` VALUES("144", "186", "_menu_item_xfn", "");
INSERT INTO `wp_464683_postmeta` VALUES("145", "186", "_menu_item_url", "#portfolio");
INSERT INTO `wp_464683_postmeta` VALUES("146", "187", "_menu_item_type", "custom");
INSERT INTO `wp_464683_postmeta` VALUES("147", "187", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_464683_postmeta` VALUES("148", "187", "_menu_item_object_id", "187");
INSERT INTO `wp_464683_postmeta` VALUES("149", "187", "_menu_item_object", "custom");
INSERT INTO `wp_464683_postmeta` VALUES("150", "187", "_menu_item_target", "");
INSERT INTO `wp_464683_postmeta` VALUES("151", "187", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_464683_postmeta` VALUES("152", "187", "_menu_item_xfn", "");
INSERT INTO `wp_464683_postmeta` VALUES("153", "187", "_menu_item_url", "#video");
INSERT INTO `wp_464683_postmeta` VALUES("154", "188", "_menu_item_type", "custom");
INSERT INTO `wp_464683_postmeta` VALUES("155", "188", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_464683_postmeta` VALUES("156", "188", "_menu_item_object_id", "188");
INSERT INTO `wp_464683_postmeta` VALUES("157", "188", "_menu_item_object", "custom");
INSERT INTO `wp_464683_postmeta` VALUES("158", "188", "_menu_item_target", "");
INSERT INTO `wp_464683_postmeta` VALUES("159", "188", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_464683_postmeta` VALUES("160", "188", "_menu_item_xfn", "");
INSERT INTO `wp_464683_postmeta` VALUES("161", "188", "_menu_item_url", "#blog");
INSERT INTO `wp_464683_postmeta` VALUES("162", "189", "_menu_item_type", "custom");
INSERT INTO `wp_464683_postmeta` VALUES("163", "189", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_464683_postmeta` VALUES("164", "189", "_menu_item_object_id", "189");
INSERT INTO `wp_464683_postmeta` VALUES("165", "189", "_menu_item_object", "custom");
INSERT INTO `wp_464683_postmeta` VALUES("166", "189", "_menu_item_target", "");
INSERT INTO `wp_464683_postmeta` VALUES("167", "189", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_464683_postmeta` VALUES("168", "189", "_menu_item_xfn", "");
INSERT INTO `wp_464683_postmeta` VALUES("169", "189", "_menu_item_url", "#contact");
INSERT INTO `wp_464683_postmeta` VALUES("184", "285", "_elementor_controls_usage", "a:0:{}");
INSERT INTO `wp_464683_postmeta` VALUES("188", "287", "_edit_last", "1");
INSERT INTO `wp_464683_postmeta` VALUES("189", "287", "_edit_lock", "1573380716:1");
INSERT INTO `wp_464683_postmeta` VALUES("190", "287", "_wp_page_template", "elementor_canvas");
INSERT INTO `wp_464683_postmeta` VALUES("214", "287", "_elementor_edit_mode", "builder");
INSERT INTO `wp_464683_postmeta` VALUES("215", "287", "_elementor_template_type", "wp-page");
INSERT INTO `wp_464683_postmeta` VALUES("216", "287", "_elementor_version", "2.7.5");
INSERT INTO `wp_464683_postmeta` VALUES("217", "287", "_elementor_pro_version", "2.7.3");
INSERT INTO `wp_464683_postmeta` VALUES("221", "296", "_wp_attached_file", "2019/11/elegant-1769669.svg");
INSERT INTO `wp_464683_postmeta` VALUES("222", "296", "_wp_attachment_metadata", "a:2:{s:5:\"width\";d:2641.46500000000014551915228366851806640625;s:6:\"height\";d:318.75;}");
INSERT INTO `wp_464683_postmeta` VALUES("223", "296", "_elementor_source_image_hash", "4fb713d8674ceee204146440c3aff93254109a06");
INSERT INTO `wp_464683_postmeta` VALUES("224", "297", "_wp_attached_file", "2019/11/white-silk-fabric-website-background.jpg");
INSERT INTO `wp_464683_postmeta` VALUES("225", "297", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:632;s:6:\"height\";i:441;s:4:\"file\";s:48:\"2019/11/white-silk-fabric-website-background.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:48:\"white-silk-fabric-website-background-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:48:\"white-silk-fabric-website-background-300x209.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:209;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_464683_postmeta` VALUES("226", "297", "_elementor_source_image_hash", "1783e5d615adaf5b9ddeafaf4fd278c2cc4f5db6");
INSERT INTO `wp_464683_postmeta` VALUES("281", "316", "_elementor_edit_mode", "builder");
INSERT INTO `wp_464683_postmeta` VALUES("282", "316", "_elementor_template_type", "page");
INSERT INTO `wp_464683_postmeta` VALUES("283", "316", "_elementor_controls_usage", "a:11:{s:11:\"menu-anchor\";a:3:{s:5:\"count\";i:7;s:15:\"control_percent\";i:0;s:8:\"controls\";a:2:{s:7:\"content\";a:1:{s:14:\"section_anchor\";a:1:{s:6:\"anchor\";i:7;}}s:8:\"advanced\";a:1:{s:14:\"_section_style\";a:1:{s:12:\"_css_classes\";i:1;}}}}s:7:\"heading\";a:3:{s:5:\"count\";i:10;s:15:\"control_percent\";i:5;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:13:\"section_title\";a:4:{s:5:\"title\";i:10;s:5:\"align\";i:10;s:12:\"align_mobile\";i:2;s:11:\"header_size\";i:1;}}s:5:\"style\";a:1:{s:19:\"section_title_style\";a:14:{s:11:\"title_color\";i:10;s:21:\"typography_typography\";i:10;s:22:\"typography_font_family\";i:10;s:20:\"typography_font_size\";i:10;s:27:\"typography_font_size_mobile\";i:9;s:22:\"typography_font_weight\";i:10;s:25:\"typography_letter_spacing\";i:1;s:28:\"text_shadow_text_shadow_type\";i:1;s:23:\"text_shadow_text_shadow\";i:1;s:21:\"typography_font_style\";i:1;s:22:\"typography_line_height\";i:2;s:25:\"typography_text_transform\";i:7;s:27:\"typography_font_size_tablet\";i:1;s:29:\"typography_line_height_mobile\";i:1;}}s:8:\"advanced\";a:5:{s:14:\"_section_style\";a:6:{s:7:\"_margin\";i:3;s:14:\"_margin_mobile\";i:1;s:8:\"_padding\";i:9;s:12:\"_css_classes\";i:1;s:15:\"_padding_tablet\";i:1;s:15:\"_padding_mobile\";i:1;}s:19:\"_section_background\";a:1:{s:22:\"_background_background\";i:2;}s:15:\"_section_border\";a:1:{s:14:\"_border_radius\";i:1;}s:33:\"section_elementor_extras_advanced\";a:3:{s:17:\"sticky_unstick_on\";i:1;s:13:\"sticky_offset\";i:1;s:13:\"sticky_enable\";i:1;}s:15:\"section_effects\";a:2:{s:18:\"animation_duration\";i:1;s:17:\"_animation_mobile\";i:1;}}}}s:6:\"column\";a:3:{s:5:\"count\";i:16;s:15:\"control_percent\";i:0;s:8:\"controls\";a:2:{s:6:\"layout\";a:1:{s:6:\"layout\";a:5:{s:19:\"_inline_size_tablet\";i:2;s:16:\"content_position\";i:5;s:12:\"_inline_size\";i:7;s:21:\"space_between_widgets\";i:8;s:19:\"_inline_size_mobile\";i:2;}}s:8:\"advanced\";a:2:{s:16:\"section_advanced\";a:5:{s:6:\"margin\";i:11;s:7:\"padding\";i:9;s:13:\"margin_mobile\";i:4;s:14:\"padding_mobile\";i:7;s:14:\"padding_tablet\";i:2;}s:15:\"section_effects\";a:1:{s:16:\"animation_mobile\";i:1;}}}}s:7:\"section\";a:3:{s:5:\"count\";i:14;s:15:\"control_percent\";i:4;s:8:\"controls\";a:3:{s:6:\"layout\";a:3:{s:14:\"section_layout\";a:9:{s:6:\"layout\";i:12;s:6:\"height\";i:2;s:13:\"custom_height\";i:2;s:20:\"custom_height_mobile\";i:2;s:15:\"column_position\";i:2;s:3:\"gap\";i:7;s:20:\"custom_height_tablet\";i:2;s:15:\"stretch_section\";i:5;s:16:\"content_position\";i:5;}s:16:\"section_parallax\";a:1:{s:24:\"jet_parallax_layout_list\";i:14;}s:17:\"section_structure\";a:1:{s:9:\"structure\";i:1;}}s:5:\"style\";a:4:{s:18:\"section_background\";a:17:{s:21:\"background_background\";i:9;s:21:\"background_attachment\";i:2;s:17:\"background_repeat\";i:3;s:15:\"background_size\";i:3;s:19:\"background_position\";i:2;s:26:\"background_position_mobile\";i:2;s:24:\"background_repeat_mobile\";i:2;s:22:\"background_size_mobile\";i:2;s:23:\"background_image_mobile\";i:1;s:23:\"background_image_tablet\";i:1;s:24:\"background_repeat_tablet\";i:2;s:22:\"background_size_tablet\";i:2;s:38:\"background_motion_fx_translateX_effect\";i:1;s:37:\"background_motion_fx_translateX_speed\";i:1;s:32:\"background_motion_fx_scale_speed\";i:1;s:16:\"background_image\";i:1;s:16:\"background_color\";i:7;}s:26:\"section_background_overlay\";a:16:{s:29:\"background_overlay_background\";i:9;s:27:\"background_overlay_position\";i:4;s:29:\"background_overlay_attachment\";i:4;s:25:\"background_overlay_repeat\";i:4;s:23:\"background_overlay_size\";i:4;s:26:\"background_overlay_opacity\";i:4;s:24:\"background_overlay_image\";i:8;s:31:\"background_overlay_image_tablet\";i:3;s:31:\"background_overlay_image_mobile\";i:3;s:32:\"background_overlay_repeat_mobile\";i:3;s:30:\"background_overlay_size_mobile\";i:3;s:34:\"background_overlay_position_mobile\";i:2;s:22:\"css_filters_css_filter\";i:1;s:22:\"css_filters_brightness\";i:1;s:20:\"css_filters_saturate\";i:1;s:34:\"background_overlay_position_tablet\";i:1;}s:14:\"section_border\";a:4:{s:13:\"border_border\";i:8;s:12:\"border_width\";i:8;s:12:\"border_color\";i:8;s:13:\"border_radius\";i:1;}s:21:\"section_shape_divider\";a:5:{s:23:\"shape_divider_top_color\";i:2;s:23:\"shape_divider_top_width\";i:2;s:24:\"shape_divider_top_height\";i:2;s:26:\"shape_divider_top_negative\";i:2;s:31:\"shape_divider_top_above_content\";i:2;}}s:8:\"advanced\";a:3:{s:16:\"section_advanced\";a:7:{s:11:\"css_classes\";i:1;s:13:\"margin_mobile\";i:8;s:6:\"margin\";i:11;s:7:\"padding\";i:10;s:14:\"padding_mobile\";i:10;s:14:\"padding_tablet\";i:3;s:13:\"margin_tablet\";i:1;}s:15:\"section_effects\";a:2:{s:9:\"animation\";i:1;s:18:\"animation_duration\";i:1;}s:18:\"section_custom_css\";a:1:{s:10:\"custom_css\";i:3;}}}}s:11:\"text-editor\";a:3:{s:5:\"count\";i:11;s:15:\"control_percent\";i:4;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:14:\"section_editor\";a:1:{s:6:\"editor\";i:11;}}s:5:\"style\";a:1:{s:13:\"section_style\";a:10:{s:5:\"align\";i:11;s:10:\"text_color\";i:10;s:21:\"typography_typography\";i:11;s:20:\"typography_font_size\";i:11;s:22:\"typography_font_weight\";i:3;s:22:\"typography_line_height\";i:3;s:12:\"align_mobile\";i:8;s:21:\"typography_font_style\";i:1;s:27:\"typography_font_size_mobile\";i:4;s:29:\"typography_line_height_mobile\";i:2;}}s:8:\"advanced\";a:1:{s:14:\"_section_style\";a:4:{s:7:\"_margin\";i:5;s:14:\"_margin_mobile\";i:3;s:15:\"_padding_mobile\";i:3;s:8:\"_padding\";i:2;}}}}s:14:\"jet-inline-svg\";a:3:{s:5:\"count\";i:3;s:15:\"control_percent\";i:2;s:8:\"controls\";a:2:{s:7:\"content\";a:1:{s:19:\"section_svg_content\";a:1:{s:7:\"svg_url\";i:3;}}s:5:\"style\";a:1:{s:17:\"section_svg_style\";a:4:{s:16:\"svg_custom_width\";i:3;s:9:\"svg_width\";i:3;s:16:\"svg_custom_color\";i:3;s:9:\"svg_color\";i:3;}}}}s:7:\"divider\";a:3:{s:5:\"count\";i:2;s:15:\"control_percent\";i:0;s:8:\"controls\";a:2:{s:7:\"content\";a:1:{s:15:\"section_divider\";a:4:{s:5:\"style\";i:1;s:5:\"width\";i:1;s:5:\"align\";i:1;s:12:\"width_mobile\";i:1;}}s:5:\"style\";a:1:{s:21:\"section_divider_style\";a:1:{s:5:\"color\";i:1;}}}}s:10:\"price-list\";a:3:{s:5:\"count\";i:1;s:15:\"control_percent\";i:5;s:8:\"controls\";a:2:{s:7:\"content\";a:1:{s:12:\"section_list\";a:1:{s:10:\"price_list\";i:1;}}s:5:\"style\";a:2:{s:18:\"section_list_style\";a:12:{s:13:\"heading_color\";i:1;s:29:\"heading_typography_typography\";i:1;s:28:\"heading_typography_font_size\";i:1;s:30:\"heading_typography_font_weight\";i:1;s:30:\"heading_typography_line_height\";i:1;s:33:\"description_typography_typography\";i:1;s:32:\"description_typography_font_size\";i:1;s:34:\"description_typography_font_weight\";i:1;s:16:\"separator_weight\";i:1;s:15:\"separator_color\";i:1;s:35:\"heading_typography_font_size_mobile\";i:1;s:33:\"description_typography_font_style\";i:1;}s:18:\"section_item_style\";a:1:{s:7:\"row_gap\";i:1;}}}}s:13:\"gallery-extra\";a:3:{s:5:\"count\";i:2;s:15:\"control_percent\";i:6;s:8:\"controls\";a:3:{s:7:\"content\";a:3:{s:15:\"section_gallery\";a:3:{s:12:\"gallery_type\";i:2;s:10:\"wp_gallery\";i:2;s:7:\"gallery\";i:2;}s:24:\"section_gallery_settings\";a:6:{s:14:\"thumbnail_size\";i:2;s:14:\"columns_mobile\";i:2;s:13:\"open_lightbox\";i:2;s:12:\"gallery_rand\";i:2;s:23:\"gallery_display_caption\";i:2;s:14:\"columns_tablet\";i:2;}s:20:\"section_gallery_tilt\";a:1:{s:9:\"tilt_axis\";i:2;}}s:5:\"style\";a:2:{s:22:\"section_gallery_layout\";a:8:{s:11:\"image_align\";i:2;s:20:\"image_vertical_align\";i:2;s:24:\"image_horizontal_spacing\";i:2;s:31:\"image_horizontal_spacing_mobile\";i:2;s:22:\"image_vertical_spacing\";i:2;s:29:\"image_vertical_spacing_mobile\";i:2;s:18:\"image_align_mobile\";i:2;s:27:\"image_vertical_align_mobile\";i:2;}s:21:\"section_hover_effects\";a:6:{s:27:\"image_transition_transition\";i:2;s:23:\"image_transition_easing\";i:2;s:11:\"image_scale\";i:2;s:17:\"image_scale_hover\";i:2;s:20:\"overlay_border_width\";i:2;s:20:\"overlay_border_color\";i:2;}}s:8:\"advanced\";a:2:{s:14:\"_section_style\";a:2:{s:14:\"_margin_mobile\";i:2;s:15:\"_padding_mobile\";i:2;}s:18:\"section_custom_css\";a:1:{s:10:\"custom_css\";i:2;}}}}s:4:\"form\";a:3:{s:5:\"count\";i:1;s:15:\"control_percent\";i:7;s:8:\"controls\";a:2:{s:7:\"content\";a:4:{s:19:\"section_form_fields\";a:2:{s:11:\"form_fields\";i:1;s:13:\"mark_required\";i:1;}s:21:\"section_submit_button\";a:5:{s:11:\"button_text\";i:1;s:11:\"button_size\";i:1;s:17:\"button_icon_align\";i:1;s:18:\"button_icon_indent\";i:1;s:20:\"selected_button_icon\";i:1;}s:13:\"section_email\";a:2:{s:13:\"form_metadata\";i:1;s:18:\"email_content_type\";i:1;}s:20:\"section_form_options\";a:3:{s:15:\"custom_messages\";i:1;s:15:\"success_message\";i:1;s:13:\"error_message\";i:1;}}s:5:\"style\";a:3:{s:18:\"section_form_style\";a:5:{s:7:\"row_gap\";i:1;s:11:\"label_color\";i:1;s:19:\"mark_required_color\";i:1;s:27:\"label_typography_typography\";i:1;s:26:\"label_typography_font_size\";i:1;}s:19:\"section_field_style\";a:6:{s:16:\"field_text_color\";i:1;s:27:\"field_typography_typography\";i:1;s:26:\"field_typography_font_size\";i:1;s:22:\"field_background_color\";i:1;s:18:\"field_border_color\";i:1;s:19:\"field_border_radius\";i:1;}s:20:\"section_button_style\";a:9:{s:23:\"button_background_color\";i:1;s:17:\"button_text_color\";i:1;s:28:\"button_typography_typography\";i:1;s:29:\"button_typography_font_family\";i:1;s:32:\"button_typography_text_transform\";i:1;s:20:\"button_border_radius\";i:1;s:29:\"button_background_hover_color\";i:1;s:18:\"button_hover_color\";i:1;s:22:\"button_hover_animation\";i:1;}}}}s:9:\"shortcode\";a:3:{s:5:\"count\";i:1;s:15:\"control_percent\";i:2;s:8:\"controls\";a:2:{s:7:\"content\";a:1:{s:17:\"section_shortcode\";a:1:{s:9:\"shortcode\";i:1;}}s:8:\"advanced\";a:1:{s:14:\"_section_style\";a:3:{s:7:\"_margin\";i:1;s:14:\"_margin_mobile\";i:1;s:15:\"_padding_mobile\";i:1;}}}}}");
INSERT INTO `wp_464683_postmeta` VALUES("284", "316", "_elementor_version", "2.7.5");
INSERT INTO `wp_464683_postmeta` VALUES("285", "316", "_elementor_pro_version", "2.7.3");
INSERT INTO `wp_464683_postmeta` VALUES("286", "316", "_elementor_data", "[{\"id\":\"409a24f\",\"elType\":\"section\",\"settings\":{\"layout\":\"full_width\",\"height\":\"min-height\",\"custom_height\":{\"unit\":\"vh\",\"size\":110},\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"29bccec\",\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"background_background\":\"classic\",\"background_attachment\":\"fixed\",\"background_repeat\":\"no-repeat\",\"background_size\":\"cover\",\"css_classes\":\"parallax\",\"custom_height_mobile\":{\"unit\":\"vh\",\"size\":100},\"column_position\":\"stretch\",\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":false},\"gap\":\"no\",\"custom_height_tablet\":{\"unit\":\"vh\",\"size\":100},\"animation\":\"fadeIn\",\"animation_duration\":\"slow\",\"background_position\":\"top left\",\"parallax_speed\":3,\"custom_css\":\"\\n\",\"background_position_mobile\":\"top center\",\"background_attachment_mobile\":\"scroll\",\"background_repeat_mobile\":\"no-repeat\",\"background_size_mobile\":\"cover\",\"background_image_mobile\":{\"id\":295,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/Emily-noblur-IMG_6651.jpg\"},\"background_image_tablet\":{\"id\":295,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/Emily-noblur-IMG_6651.jpg\"},\"background_attachment_tablet\":\"scroll\",\"background_repeat_tablet\":\"no-repeat\",\"background_size_tablet\":\"cover\",\"background_motion_fx_translateX_effect\":\"yes\",\"background_motion_fx_translateX_speed\":{\"unit\":\"px\",\"size\":2,\"sizes\":[]},\"background_motion_fx_scale_speed\":{\"unit\":\"px\",\"size\":1,\"sizes\":[]},\"parallax_background_direction\":\"up\",\"background_overlay_background\":\"classic\",\"background_overlay_position\":\"center center\",\"background_overlay_attachment\":\"fixed\",\"background_overlay_repeat\":\"no-repeat\",\"background_overlay_size\":\"cover\",\"background_overlay_opacity\":{\"unit\":\"px\",\"size\":1,\"sizes\":[]},\"background_image\":{\"id\":295,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/Emily-noblur-IMG_6651.jpg\"},\"parallax_background_speed\":{\"unit\":\"px\",\"size\":0.179999999999999993338661852249060757458209991455078125,\"sizes\":[]},\"border_border\":\"groove\",\"border_width\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"01\",\"left\":\"0\",\"isLinked\":false},\"border_color\":\"#af5a00\",\"parallax_background_speed_mobile\":{\"unit\":\"px\",\"size\":0,\"sizes\":[]},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"58bcf085\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"_inline_size_tablet\":100,\"content_position\":\"top\",\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"33f3354d\",\"elType\":\"widget\",\"settings\":{\"anchor\":\"Home\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"menu-anchor\"},{\"id\":\"2da2b401\",\"elType\":\"widget\",\"settings\":{\"title\":\"Emily<br \\/>Hunt\",\"align\":\"left\",\"title_color\":\"#000000\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Cinzel Decorative\",\"typography_font_size\":{\"unit\":\"em\",\"size\":3.5},\"typography_font_size_mobile\":{\"unit\":\"vw\",\"size\":8},\"typography_font_weight\":\"300\",\"typography_letter_spacing\":{\"unit\":\"px\",\"size\":2.70000000000000017763568394002504646778106689453125},\"text_shadow_text_shadow_type\":\"yes\",\"text_shadow_text_shadow\":{\"horizontal\":2,\"vertical\":2,\"blur\":3,\"color\":\"rgba(0,0,0,0.3)\"},\"_margin\":{\"unit\":\"%\",\"top\":\"02\",\"right\":\"02\",\"bottom\":\"0\",\"left\":\"020\",\"isLinked\":false},\"_margin_mobile\":{\"unit\":\"%\",\"top\":\"15\",\"right\":\"1\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"typography_font_style\":\"italic\",\"_padding\":{\"unit\":\"px\",\"top\":\"30\",\"right\":\"10\",\"bottom\":\"10\",\"left\":\"10\",\"isLinked\":false},\"_background_background\":\"classic\",\"_css_classes\":\"title\",\"align_mobile\":\"left\",\"_border_radius\":{\"unit\":\"px\",\"top\":\"10\",\"right\":\"10\",\"bottom\":\"10\",\"left\":\"10\",\"isLinked\":true},\"sticky_unstick_on\":\"none\",\"sticky_offset\":{\"unit\":\"px\",\"size\":40},\"typography_line_height\":{\"unit\":\"em\",\"size\":1.100000000000000088817841970012523233890533447265625},\"animation_duration\":\"slow\",\"sticky_enable\":\"yes\",\"_animation_mobile\":\"fadeIn\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"heading\"}],\"isInner\":false}],\"isInner\":false},{\"id\":\"1e881eef\",\"elType\":\"section\",\"settings\":{\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"d51247d\",\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":false},\"stretch_section\":\"section-stretched\",\"layout\":\"full_width\",\"gap\":\"no\",\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":true},\"padding\":{\"unit\":\"%\",\"top\":\"5\",\"right\":\"0\",\"bottom\":\"05\",\"left\":\"0\",\"isLinked\":false},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"20\",\"right\":\"0\",\"bottom\":\"20\",\"left\":\"0\",\"isLinked\":false},\"content_position\":\"top\",\"background_background\":\"classic\",\"background_color\":\"rgba(175,90,0,0.5)\",\"background_overlay_background\":\"classic\",\"background_overlay_image\":{\"id\":297,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/white-silk-fabric-website-background.jpg\"},\"border_border\":\"groove\",\"border_width\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"01\",\"left\":\"0\",\"isLinked\":false},\"border_color\":\"#af5a00\",\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"21b88fac\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"space_between_widgets\":0,\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"10\",\"bottom\":\"10\",\"left\":\"10\",\"isLinked\":false},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"20\",\"right\":\"20\",\"bottom\":\"20\",\"left\":\"20\",\"isLinked\":true},\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"93c534d\",\"elType\":\"widget\",\"settings\":{\"anchor\":\"About\",\"_css_classes\":\"about\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"menu-anchor\"},{\"id\":\"c042c2d\",\"elType\":\"widget\",\"settings\":{\"title\":\"About Me\",\"align\":\"center\",\"title_color\":\"333333\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Fanwood Text\",\"typography_font_size\":{\"unit\":\"px\",\"size\":84},\"typography_font_weight\":\"500\",\"typography_font_size_mobile\":{\"unit\":\"px\",\"size\":25},\"_padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"typography_text_transform\":\"uppercase\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"heading\"},{\"id\":\"7ceee8dc\",\"elType\":\"widget\",\"settings\":{\"editor\":\"<p>Hi my name is Emily. I am a tall blonde bombshell from Newport Beach CA, sweetly aged 28yr old standing 5 foot 8 inches with exotic features. I have new fun enhanced assets reaching triple D\'s. I live a healthy lifestyle and enjoy being outdoors, especially hiking or by the ocean. My hard work has paid off with a firm body and sexy kitten green eyes.<\\/p><p>I present myself with superior first-rate standards, I am highly confident that you will enjoy our time together. I consider new ideas and look for a connection that is real. I am attentive sensual, passionate and I look forward to stimulating you every way possible. I look forward to meeting you in person...<\\/p><p>XO<\\/p>\",\"align\":\"center\",\"text_color\":\"#000000\",\"typography_typography\":\"custom\",\"typography_font_size\":{\"unit\":\"px\",\"size\":18},\"typography_font_weight\":\"500\",\"typography_line_height\":{\"unit\":\"em\",\"size\":1.8000000000000000444089209850062616169452667236328125},\"_margin\":{\"unit\":\"%\",\"top\":\"0\",\"right\":\"20\",\"bottom\":\"0\",\"left\":\"20\",\"isLinked\":false},\"align_mobile\":\"center\",\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"_padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"10\",\"bottom\":\"0\",\"left\":\"10\",\"isLinked\":false},\"typography_font_style\":\"italic\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"text-editor\"},{\"id\":\"77416dfe\",\"elType\":\"widget\",\"settings\":{\"svg_url\":{\"id\":296,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/elegant-1769669.svg\"},\"svg_custom_width\":\"yes\",\"svg_width\":{\"unit\":\"px\",\"size\":570,\"sizes\":[]},\"svg_custom_color\":\"yes\",\"svg_color\":\"rgba(0,0,0,0.75)\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"jet-inline-svg\"},{\"id\":\"234a17cd\",\"elType\":\"section\",\"settings\":{\"structure\":\"30\",\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"4b162ae\",\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"margin\":{\"unit\":\"px\",\"top\":\"20\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":false},\"padding\":{\"unit\":\"%\",\"top\":\"5\",\"right\":\"20\",\"bottom\":\"05\",\"left\":\"20\",\"isLinked\":false},\"layout\":\"full_width\",\"shape_divider_top_color\":\"333333\",\"shape_divider_top_width\":{\"unit\":\"%\",\"size\":100},\"shape_divider_top_height\":{\"unit\":\"px\",\"size\":0},\"shape_divider_top_negative\":\"yes\",\"shape_divider_top_above_content\":\"yes\",\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"234bf4f0\",\"elType\":\"column\",\"settings\":{\"_column_size\":33,\"_inline_size\":35.9440000000000026147972675971686840057373046875,\"content_position\":\"top\",\"space_between_widgets\":0,\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"_inline_size_mobile\":100,\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"4c9ae2c6\",\"elType\":\"widget\",\"settings\":{\"editor\":\"<p><b>Measurements:<\\/b> 32DDD-24-32<br \\/><b>Age:<\\/b> 28<\\/p>\",\"align\":\"left\",\"text_color\":\"#333333\",\"typography_typography\":\"custom\",\"typography_font_size\":{\"unit\":\"px\",\"size\":18},\"align_mobile\":\"center\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"text-editor\"}],\"isInner\":true},{\"id\":\"23665faf\",\"elType\":\"column\",\"settings\":{\"_column_size\":33,\"_inline_size\":38.0859999999999985220711096189916133880615234375,\"content_position\":\"top\",\"space_between_widgets\":0,\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"5d2cdf1b\",\"elType\":\"widget\",\"settings\":{\"editor\":\"<b>Main City:<\\/b> Orange County, CA<br \\/>\\n<b>Height:<\\/b> 5\' 8\\\"\",\"align\":\"left\",\"text_color\":\"#333333\",\"typography_typography\":\"custom\",\"typography_font_size\":{\"unit\":\"px\",\"size\":18},\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"_padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"align_mobile\":\"center\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"text-editor\"}],\"isInner\":true},{\"id\":\"70260f97\",\"elType\":\"column\",\"settings\":{\"_column_size\":33,\"_inline_size\":25.96300000000000096633812063373625278472900390625,\"content_position\":\"top\",\"space_between_widgets\":0,\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"40dcc03c\",\"elType\":\"widget\",\"settings\":{\"editor\":\"<p><b>Sex:<\\/b> Female<br \\/><b>Weight:<\\/b> 125 lbs<\\/p>\",\"align\":\"left\",\"text_color\":\"#333333\",\"typography_typography\":\"custom\",\"typography_font_size\":{\"unit\":\"px\",\"size\":18},\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"_padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"align_mobile\":\"center\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"text-editor\"}],\"isInner\":true}],\"isInner\":true}],\"isInner\":false}],\"isInner\":false},{\"id\":\"153c942e\",\"elType\":\"section\",\"settings\":{\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"bbc7692\",\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"padding_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"20\",\"bottom\":\"0\",\"left\":\"20\",\"isLinked\":false},\"border_border\":\"groove\",\"border_width\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"01\",\"left\":\"0\",\"isLinked\":false},\"border_color\":\"#af5a00\",\"background_background\":\"classic\",\"background_repeat\":\"repeat\",\"background_size\":\"auto\",\"background_overlay_background\":\"classic\",\"background_overlay_image\":{\"id\":298,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/Emily-noblur-IMG_6657.jpg\"},\"background_overlay_repeat\":\"no-repeat\",\"background_overlay_opacity\":{\"unit\":\"px\",\"size\":0.34999999999999997779553950749686919152736663818359375},\"shape_divider_top_color\":\"333333\",\"shape_divider_top_width\":{\"unit\":\"%\",\"size\":150},\"shape_divider_top_height\":{\"unit\":\"px\",\"size\":128},\"shape_divider_top_negative\":\"yes\",\"shape_divider_top_above_content\":\"yes\",\"background_overlay_position\":\"bottom center\",\"background_overlay_attachment\":\"fixed\",\"background_overlay_size\":\"cover\",\"background_overlay_image_tablet\":{\"id\":298,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/Emily-noblur-IMG_6657.jpg\"},\"background_overlay_image_mobile\":{\"id\":298,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/Emily-noblur-IMG_6657.jpg\"},\"background_overlay_attachment_mobile\":\"scroll\",\"background_overlay_repeat_mobile\":\"no-repeat\",\"background_overlay_size_mobile\":\"cover\",\"border_radius\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"background_color\":\"rgba(175,90,0,0.18)\",\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"1f4a5cb3\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"margin\":{\"unit\":\"px\",\"top\":\"20\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"space_between_widgets\":0,\"animation_mobile\":\"fadeInUp\",\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"7498b722\",\"elType\":\"widget\",\"settings\":{\"anchor\":\"Rates\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"menu-anchor\"},{\"id\":\"33534de7\",\"elType\":\"widget\",\"settings\":{\"title\":\"Rates\",\"align\":\"center\",\"title_color\":\"333333\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Fanwood Text\",\"typography_font_size\":{\"unit\":\"px\",\"size\":84},\"typography_font_weight\":\"500\",\"_padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"typography_font_size_mobile\":{\"unit\":\"px\",\"size\":25},\"typography_text_transform\":\"uppercase\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"heading\"},{\"id\":\"49454ff6\",\"elType\":\"widget\",\"settings\":{\"editor\":\"<p>Rates apply to incall. For outcall add $200.<\\/p>\",\"align\":\"center\",\"typography_typography\":\"custom\",\"typography_font_size\":{\"unit\":\"px\",\"size\":16},\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"text-editor\"},{\"id\":\"2d107c51\",\"elType\":\"widget\",\"settings\":{\"style\":\"dotted\",\"color\":\"#000000\",\"width\":{\"unit\":\"%\",\"size\":70},\"align\":\"center\",\"width_mobile\":{\"unit\":\"%\",\"size\":90},\"text\":\"Divider\",\"icon\":{\"value\":\"fas fa-star\",\"library\":\"fa-solid\"},\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"divider\"},{\"id\":\"2cfdc82e\",\"elType\":\"section\",\"settings\":{\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"bc4a4dd\",\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"layout\":\"full_width\",\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":false},\"padding\":{\"unit\":\"%\",\"top\":\"0\",\"right\":\"020\",\"bottom\":\"0\",\"left\":\"20\",\"isLinked\":false},\"gap\":\"narrow\",\"padding_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"10\",\"bottom\":\"0\",\"left\":\"10\",\"isLinked\":false},\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"f964dcd\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"_inline_size\":null,\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"10\",\"right\":\"10\",\"bottom\":\"10\",\"left\":\"10\",\"isLinked\":true},\"padding_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"20\",\"isLinked\":false},\"_inline_size_tablet\":100,\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"6fb028b2\",\"elType\":\"widget\",\"settings\":{\"price_list\":[{\"title\":\"&bull;&nbsp;1 Hour\",\"item_description\":\"\",\"price\":\"$800\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"595534c\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"&bull;&nbsp;1&frac12; Hours\",\"item_description\":\"\",\"price\":\"$1200\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"3791d57\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"&bull;&nbsp;2 Hours\",\"item_description\":\"\",\"price\":\"$1500\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"a5af224\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"&bull;&nbsp;3 Hours\",\"item_description\":\"\",\"price\":\"$2200\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"c5388ab\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"&bull;&nbsp;4 Hours\",\"item_description\":\"\",\"price\":\"$2700\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"1b9c108\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"&bull;&nbsp;6 Hours\",\"item_description\":\"\",\"price\":\"$3500\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"3fafb8c\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"&bull;&nbsp;12 Hours\",\"item_description\":\"\",\"price\":\"$5000\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"2c885d9\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"&bull;&nbsp;Same day cancelation\",\"item_description\":\"\",\"price\":\"$200 fee\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"6738e43\",\"image\":{\"url\":\"\",\"id\":\"\"}}],\"heading_color\":\"#333333\",\"heading_typography_typography\":\"custom\",\"heading_typography_font_size\":{\"unit\":\"px\",\"size\":18},\"heading_typography_font_weight\":\"300\",\"heading_typography_line_height\":{\"unit\":\"em\",\"size\":1.600000000000000088817841970012523233890533447265625},\"description_typography_typography\":\"custom\",\"description_typography_font_size\":{\"unit\":\"px\",\"size\":16},\"description_typography_font_weight\":\"500\",\"separator_weight\":{\"unit\":\"px\",\"size\":1},\"separator_color\":\"#000000\",\"heading_typography_font_size_mobile\":{\"unit\":\"em\",\"size\":1.1999999999999999555910790149937383830547332763671875},\"row_gap\":{\"unit\":\"px\",\"size\":10},\"description_typography_font_style\":\"italic\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"price-list\"},{\"id\":\"327c87b\",\"elType\":\"widget\",\"settings\":{\"svg_url\":{\"id\":296,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/elegant-1769669.svg\"},\"svg_custom_width\":\"yes\",\"svg_width\":{\"unit\":\"px\",\"size\":570,\"sizes\":[]},\"svg_custom_color\":\"yes\",\"svg_color\":\"rgba(0,0,0,0.75)\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"jet-inline-svg\"}],\"isInner\":true}],\"isInner\":true}],\"isInner\":false}],\"isInner\":false},{\"id\":\"2ad89b16\",\"elType\":\"section\",\"settings\":{\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"d51247d\",\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"layout\":\"full_width\",\"padding_mobile\":{\"unit\":\"px\",\"top\":\"20\",\"right\":\"0\",\"bottom\":\"20\",\"left\":\"0\",\"isLinked\":false},\"stretch_section\":\"section-stretched\",\"gap\":\"no\",\"content_position\":\"top\",\"background_background\":\"classic\",\"background_color\":\"rgba(175,90,0,0.5)\",\"background_overlay_background\":\"classic\",\"background_overlay_image\":{\"id\":297,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/white-silk-fabric-website-background.jpg\"},\"border_border\":\"groove\",\"border_width\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"01\",\"left\":\"0\",\"isLinked\":false},\"border_color\":\"#af5a00\",\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":true},\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":false},\"padding\":{\"unit\":\"%\",\"top\":\"5\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"b1c62e0\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"margin\":{\"unit\":\"px\",\"top\":\"20\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"space_between_widgets\":0,\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"2f0b3151\",\"elType\":\"widget\",\"settings\":{\"anchor\":\"Photos\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"menu-anchor\"},{\"id\":\"6fc8cad9\",\"elType\":\"widget\",\"settings\":{\"title\":\"Photos\",\"align\":\"center\",\"title_color\":\"333333\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Fanwood Text\",\"typography_font_size\":{\"unit\":\"px\",\"size\":84},\"typography_font_weight\":\"500\",\"_padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"typography_font_size_mobile\":{\"unit\":\"px\",\"size\":25},\"typography_text_transform\":\"uppercase\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"heading\"},{\"id\":\"4190962c\",\"elType\":\"section\",\"settings\":{\"layout\":\"full_width\",\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"34668a6\",\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"margin\":{\"unit\":\"%\",\"top\":\"02\",\"right\":0,\"bottom\":\"02\",\"left\":0,\"isLinked\":true},\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"custom_css\":\".gallery-item:hover {\\n    cursor: -moz-zoom-in; \\n    cursor: -webkit-zoom-in; \\n    cursor: zoom-in;\\n    transform: scale(1.05);\\n}\\n\",\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"554b76ac\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"_inline_size\":null,\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"padding\":{\"unit\":\"%\",\"top\":\"0\",\"right\":\"20\",\"bottom\":\"0\",\"left\":\"20\",\"isLinked\":false},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"03\",\"right\":\"03\",\"bottom\":\"03\",\"left\":\"03\",\"isLinked\":true},\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"374e980c\",\"elType\":\"widget\",\"settings\":{\"editor\":\"<p>Professional photoshoot<\\/p>\",\"align\":\"left\",\"typography_typography\":\"custom\",\"typography_font_size\":{\"unit\":\"em\",\"size\":1.8000000000000000444089209850062616169452667236328125},\"text_color\":\"rgba(0,0,0,0.72)\",\"align_mobile\":\"center\",\"typography_font_size_mobile\":{\"unit\":\"em\",\"size\":1.3000000000000000444089209850062616169452667236328125,\"sizes\":[]},\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"text-editor\"},{\"id\":\"61130ce1\",\"elType\":\"widget\",\"settings\":{\"gallery_type\":\"manual\",\"wp_gallery\":null,\"gallery\":[{\"image\":{\"id\":299,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/Emily-noblur-IMG_6645.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/EmilyHunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"6f5f8d0\"},{\"image\":{\"id\":300,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/Emily-noblur-IMG_6646.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/EmilyHunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"c88db24\"},{\"image\":{\"id\":295,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/Emily-noblur-IMG_6651.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/EmilyHunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"b50f5df\"},{\"image\":{\"id\":298,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/Emily-noblur-IMG_6657.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/EmilyHunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"55be810\"},{\"image\":{\"id\":301,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/Emily-noblur-IMG_5029.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/EmilyHunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"4329c03\"},{\"image\":{\"id\":302,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/Emily-noblur-IMG_5030.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/EmilyHunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"42095f1\"},{\"image\":{\"id\":303,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/Emily-noblur-IMG_6649.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/EmilyHunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"4834f78\"},{\"image\":{\"id\":304,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/Emily-noblur-IMG_6653.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/EmilyHunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"58ae2d7\"},{\"image\":{\"id\":305,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/Emily-noblur-IMG_6655-crop.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/EmilyHunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"3194f63\"}],\"thumbnail_size\":\"medium_large\",\"columns_mobile\":\"3\",\"open_lightbox\":\"yes\",\"gallery_rand\":\"rand\",\"gallery_display_caption\":\"none\",\"image_align\":\"center\",\"image_vertical_align\":\"middle\",\"image_horizontal_spacing\":{\"unit\":\"px\",\"size\":5},\"image_horizontal_spacing_mobile\":{\"unit\":\"px\",\"size\":2},\"image_vertical_spacing\":{\"unit\":\"px\",\"size\":5},\"image_vertical_spacing_mobile\":{\"unit\":\"px\",\"size\":2},\"image_transition_transition\":\"custom\",\"image_transition_easing\":\"ease-in-out\",\"image_scale\":{\"unit\":\"px\",\"size\":1},\"image_scale_hover\":{\"unit\":\"px\",\"size\":1.0700000000000000621724893790087662637233734130859375},\"overlay_border_width\":{\"unit\":\"px\",\"top\":\"1\",\"right\":\"1\",\"bottom\":\"1\",\"left\":\"1\",\"isLinked\":true},\"overlay_border_color\":\"#af5a00\",\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"_padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"custom_css\":\"@media all and (orientation:portrait) {.swiper-zoom-container{\\n    min-width:100vw;\\n    overflow:hidden;\\n}}\\n@media all and (orientation:landscape) {.swiper-zoom-container{\\n    min-height:100vh;\\n    overflow:hidden;\\n}}\",\"tilt_axis\":\"x\",\"columns_tablet\":\"3\",\"image_align_mobile\":\"center\",\"image_vertical_align_mobile\":\"middle\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"gallery-extra\"}],\"isInner\":true}],\"isInner\":true},{\"id\":\"6db07ccb\",\"elType\":\"section\",\"settings\":{\"layout\":\"full_width\",\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"34668a6\",\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"margin\":{\"unit\":\"%\",\"top\":\"02\",\"right\":0,\"bottom\":\"02\",\"left\":0,\"isLinked\":true},\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"custom_css\":\".gallery-item:hover {\\n    cursor: -moz-zoom-in; \\n    cursor: -webkit-zoom-in; \\n    cursor: zoom-in;\\n    transform: scale(1.05);\\n}\\n\",\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"7e49f720\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"_inline_size\":null,\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"padding\":{\"unit\":\"%\",\"top\":\"0\",\"right\":\"20\",\"bottom\":\"0\",\"left\":\"20\",\"isLinked\":false},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"03\",\"right\":\"03\",\"bottom\":\"03\",\"left\":\"03\",\"isLinked\":true},\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"3bb90c1a\",\"elType\":\"widget\",\"settings\":{\"editor\":\"<p>Personal images<\\/p>\",\"align\":\"left\",\"typography_typography\":\"custom\",\"typography_font_size\":{\"unit\":\"em\",\"size\":1.8000000000000000444089209850062616169452667236328125},\"text_color\":\"rgba(0,0,0,0.72)\",\"align_mobile\":\"center\",\"typography_font_size_mobile\":{\"unit\":\"em\",\"size\":1.3000000000000000444089209850062616169452667236328125,\"sizes\":[]},\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"text-editor\"},{\"id\":\"26c41a3\",\"elType\":\"widget\",\"settings\":{\"gallery_type\":\"manual\",\"wp_gallery\":null,\"gallery\":[{\"image\":{\"id\":306,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/Emily-noblur-EmilyHunt04.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/EmilyHunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"3194f63\"},{\"image\":{\"id\":307,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/Emily-noblur-EmilyHunt11.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/EmilyHunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"90ac1e6\"},{\"image\":{\"id\":308,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/Emily-noblur-EmilyHunt18.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/EmilyHunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"9186934\"},{\"image\":{\"id\":309,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt09.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/EmilyHunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"e16a09b\"},{\"image\":{\"id\":310,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt10.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/EmilyHunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"40872a5\"},{\"image\":{\"id\":311,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt23.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/EmilyHunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"e8a9ad1\"},{\"image\":{\"id\":312,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt30.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/EmilyHunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"70bfb20\"},{\"image\":{\"id\":313,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt26.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/EmilyHunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"24ea067\"},{\"image\":{\"id\":314,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt24.jpg\"},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/EmilyHunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"517e2a6\"}],\"thumbnail_size\":\"medium_large\",\"columns_mobile\":\"3\",\"open_lightbox\":\"yes\",\"gallery_rand\":\"rand\",\"gallery_display_caption\":\"none\",\"image_align\":\"center\",\"image_vertical_align\":\"middle\",\"image_horizontal_spacing\":{\"unit\":\"px\",\"size\":5},\"image_horizontal_spacing_mobile\":{\"unit\":\"px\",\"size\":2},\"image_vertical_spacing\":{\"unit\":\"px\",\"size\":5},\"image_vertical_spacing_mobile\":{\"unit\":\"px\",\"size\":2},\"image_transition_transition\":\"custom\",\"image_transition_easing\":\"ease-in-out\",\"image_scale\":{\"unit\":\"px\",\"size\":1},\"image_scale_hover\":{\"unit\":\"px\",\"size\":1.0700000000000000621724893790087662637233734130859375},\"overlay_border_width\":{\"unit\":\"px\",\"top\":\"1\",\"right\":\"1\",\"bottom\":\"1\",\"left\":\"1\",\"isLinked\":true},\"overlay_border_color\":\"#af5a00\",\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"_padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"custom_css\":\"@media all and (orientation:portrait) {.swiper-zoom-container{\\n    min-width:100vw;\\n    overflow:hidden;\\n}}\\n@media all and (orientation:landscape) {.swiper-zoom-container{\\n    min-height:100vh;\\n    overflow:hidden;\\n}}\",\"tilt_axis\":\"x\",\"columns_tablet\":\"3\",\"image_align_mobile\":\"center\",\"image_vertical_align_mobile\":\"middle\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"gallery-extra\"}],\"isInner\":true}],\"isInner\":true}],\"isInner\":false}],\"isInner\":false},{\"id\":\"5353064d\",\"elType\":\"section\",\"settings\":{\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"3d6fb8f\",\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"layout\":\"full_width\",\"background_background\":\"classic\",\"background_overlay_background\":\"classic\",\"background_overlay_image\":{\"id\":299,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/Emily-noblur-IMG_6645.jpg\"},\"background_overlay_repeat\":\"no-repeat\",\"background_overlay_opacity\":{\"unit\":\"px\",\"size\":0.34999999999999997779553950749686919152736663818359375},\"border_border\":\"groove\",\"border_width\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"01\",\"left\":\"0\",\"isLinked\":false},\"border_color\":\"#af5a00\",\"background_overlay_position\":\"top center\",\"background_overlay_attachment\":\"fixed\",\"background_overlay_size\":\"cover\",\"background_overlay_image_tablet\":{\"id\":299,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/Emily-noblur-IMG_6645.jpg\"},\"background_overlay_image_mobile\":{\"id\":299,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/Emily-noblur-IMG_6645.jpg\"},\"background_overlay_position_mobile\":\"top right\",\"background_overlay_attachment_mobile\":\"scroll\",\"background_overlay_repeat_mobile\":\"no-repeat\",\"background_overlay_size_mobile\":\"cover\",\"background_color\":\"rgba(175,90,0,0.19)\",\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":true},\"padding\":{\"unit\":\"%\",\"top\":\"05\",\"right\":\"0\",\"bottom\":\"05\",\"left\":\"0\",\"isLinked\":false},\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"5c8be425\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"f7033dc\",\"elType\":\"widget\",\"settings\":{\"anchor\":\"Tour\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"menu-anchor\"},{\"id\":\"425cc317\",\"elType\":\"widget\",\"settings\":{\"title\":\"Tour\",\"align\":\"center\",\"title_color\":\"333333\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Fanwood Text\",\"typography_font_size\":{\"unit\":\"px\",\"size\":84},\"typography_font_weight\":\"500\",\"_padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"typography_font_size_mobile\":{\"unit\":\"px\",\"size\":25},\"typography_text_transform\":\"uppercase\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"heading\"},{\"id\":\"53687154\",\"elType\":\"widget\",\"settings\":{\"editor\":\"[text-blocks id=\\\"touring\\\"]\",\"align\":\"center\",\"text_color\":\"#333\",\"typography_typography\":\"custom\",\"typography_font_size\":{\"unit\":\"px\",\"size\":24},\"typography_font_size_mobile\":{\"unit\":\"em\",\"size\":1.1999999999999999555910790149937383830547332763671875,\"sizes\":[]},\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"text-editor\"},{\"id\":\"3df8a384\",\"elType\":\"widget\",\"settings\":{\"svg_url\":{\"id\":296,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/elegant-1769669.svg\"},\"svg_custom_width\":\"yes\",\"svg_width\":{\"unit\":\"px\",\"size\":570,\"sizes\":[]},\"svg_custom_color\":\"yes\",\"svg_color\":\"rgba(0,0,0,0.75)\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"jet-inline-svg\"},{\"id\":\"59831a89\",\"elType\":\"widget\",\"settings\":{\"anchor\":\"Wishlist\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"menu-anchor\"},{\"id\":\"48b2749a\",\"elType\":\"widget\",\"settings\":{\"title\":\"Wishlist\",\"align\":\"center\",\"title_color\":\"333333\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Fanwood Text\",\"typography_font_size\":{\"unit\":\"px\",\"size\":84},\"typography_font_weight\":\"500\",\"_padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"typography_font_size_mobile\":{\"unit\":\"px\",\"size\":25},\"typography_text_transform\":\"uppercase\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"heading\"},{\"id\":\"10414b1e\",\"elType\":\"widget\",\"settings\":{\"editor\":\"<p><a style=\\\"color: black;\\\" href=\\\"https:\\/\\/www.amazon.com\\/gp\\/registry\\/wishlist\\/15C9HX41ATNR2\\\" target=\\\"_blank\\\" rel=\\\"noopener\\\">Click<\\/a><a style=\\\"color: black;\\\" href=\\\"https:\\/\\/www.amazon.com\\/gp\\/registry\\/wishlist\\/15C9HX41ATNR2\\\" target=\\\"_blank\\\" rel=\\\"noopener\\\"> to check out my Amazon Wishlist\\u00a0<\\/a><b><a style=\\\"color: black;\\\" href=\\\"https:\\/\\/www.amazon.com\\/gp\\/registry\\/wishlist\\/15C9HX41ATNR2\\\" target=\\\"_blank\\\" rel=\\\"noopener\\\"><br \\/><\\/a><\\/b><\\/p>\",\"align\":\"center\",\"text_color\":\"#333\",\"typography_typography\":\"custom\",\"typography_font_size\":{\"unit\":\"em\",\"size\":1.5},\"typography_font_size_mobile\":{\"unit\":\"em\",\"size\":1.1999999999999999555910790149937383830547332763671875,\"sizes\":[]},\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"text-editor\"}],\"isInner\":false}],\"isInner\":false},{\"id\":\"3f3a60c1\",\"elType\":\"section\",\"settings\":{\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"d51247d\",\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"stretch_section\":\"section-stretched\",\"layout\":\"full_width\",\"gap\":\"no\",\"content_position\":\"top\",\"background_background\":\"classic\",\"background_color\":\"rgba(175,90,0,0.5)\",\"background_overlay_background\":\"classic\",\"background_overlay_image\":{\"id\":297,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/white-silk-fabric-website-background.jpg\"},\"border_border\":\"groove\",\"border_width\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"01\",\"left\":\"0\",\"isLinked\":false},\"border_color\":\"#af5a00\",\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":true},\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":false},\"padding\":{\"unit\":\"%\",\"top\":\"5\",\"right\":\"0\",\"bottom\":\"05\",\"left\":\"0\",\"isLinked\":false},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"257ec1a5\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"margin\":{\"unit\":\"px\",\"top\":\"20\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"20\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"padding_tablet\":{\"unit\":\"px\",\"top\":\"30\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"space_between_widgets\":0,\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"3d7c931\",\"elType\":\"widget\",\"settings\":{\"anchor\":\"Contact\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"menu-anchor\"},{\"id\":\"6fd869dd\",\"elType\":\"widget\",\"settings\":{\"title\":\"Contact\",\"align\":\"center\",\"title_color\":\"333333\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Fanwood Text\",\"typography_font_size\":{\"unit\":\"px\",\"size\":84},\"typography_font_weight\":\"500\",\"_padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"typography_font_size_mobile\":{\"unit\":\"px\",\"size\":25},\"typography_text_transform\":\"uppercase\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"heading\"},{\"id\":\"1ba66a24\",\"elType\":\"section\",\"settings\":{\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"bc4a4dd\",\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":true},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"5cab8315\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"_inline_size\":null,\"space_between_widgets\":0,\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"23a3f0f1\",\"elType\":\"widget\",\"settings\":{\"editor\":\"<p>If you need to email me meetmissemilyhunt@protonmail.com<\\/p>\",\"align\":\"center\",\"text_color\":\"#333\",\"typography_typography\":\"custom\",\"typography_font_size\":{\"unit\":\"px\",\"size\":18},\"typography_font_weight\":\"500\",\"typography_line_height\":{\"unit\":\"em\",\"size\":1.8000000000000000444089209850062616169452667236328125},\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"160\",\"bottom\":\"0\",\"left\":\"160\",\"isLinked\":false},\"align_mobile\":\"center\",\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"_padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"20\",\"bottom\":\"0\",\"left\":\"20\",\"isLinked\":false},\"typography_line_height_mobile\":{\"unit\":\"em\",\"size\":1.5},\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"text-editor\"}],\"isInner\":true}],\"isInner\":true}],\"isInner\":false}],\"isInner\":false},{\"id\":\"e3211d1\",\"elType\":\"section\",\"settings\":{\"stretch_section\":\"section-stretched\",\"layout\":\"full_width\",\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"d51247d\",\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"gap\":\"no\",\"content_position\":\"top\",\"background_background\":\"classic\",\"background_color\":\"rgba(175,90,0,0.5)\",\"background_overlay_background\":\"classic\",\"background_overlay_image\":{\"id\":297,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/white-silk-fabric-website-background.jpg\"},\"border_border\":\"groove\",\"border_width\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"01\",\"left\":\"0\",\"isLinked\":false},\"border_color\":\"#af5a00\",\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":true},\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":false},\"padding\":{\"unit\":\"%\",\"top\":\"5\",\"right\":\"0\",\"bottom\":\"05\",\"left\":\"0\",\"isLinked\":false},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"170a95a1\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"padding\":{\"unit\":\"%\",\"top\":\"5\",\"right\":\"20\",\"bottom\":\"0\",\"left\":\"20\",\"isLinked\":false},\"_inline_size_mobile\":100,\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"10\",\"right\":\"10\",\"bottom\":\"10\",\"left\":\"10\",\"isLinked\":true},\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"1fbac3c2\",\"elType\":\"widget\",\"settings\":{\"form_name\":\"New Form\",\"form_fields\":[{\"_id\":\"881210a\",\"field_type\":\"html\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"\",\"width\":\"100\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"<p style=\\\"margin-bottom:-0px; font-size:18px;\\\"><u>About You<\\/u><\\/p>\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":0,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"881210a\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"name\",\"field_type\":\"text\",\"field_label\":\"Name\",\"placeholder\":\"First name\",\"width\":\"50\",\"field_value\":\"\",\"required\":\"true\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"name\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"last\",\"field_type\":\"text\",\"field_label\":\"&nbsp;\",\"placeholder\":\"Last name\",\"width\":\"50\",\"field_value\":\"\",\"required\":\"true\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"last\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"email\",\"field_type\":\"text\",\"required\":\"true\",\"field_label\":\"Age\",\"placeholder\":\"\",\"width\":\"33\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"email\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"7ce8033\",\"field_type\":\"text\",\"required\":\"true\",\"field_label\":\"City\",\"placeholder\":\"\",\"width\":\"33\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"7ce8033\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"bc7977d\",\"field_type\":\"text\",\"required\":\"\",\"field_label\":\"Ethnicity\",\"placeholder\":\"\",\"width\":\"33\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"bc7977d\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"0ed2d57\",\"field_type\":\"text\",\"required\":\"true\",\"field_label\":\"Occupation\",\"placeholder\":\"\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"0ed2d57\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"06a5f20\",\"field_type\":\"text\",\"required\":\"true\",\"field_label\":\"Company\",\"placeholder\":\"\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"100\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"06a5f20\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"3e1810e\",\"field_type\":\"html\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"\",\"width\":\"100\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"<p style=\\\"margin-bottom:-0px; font-size:18px;\\\"><u>Contact Information<\\/u><\\/p>\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":0,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"3e1810e\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"7c48152\",\"field_type\":\"email\",\"required\":\"true\",\"field_label\":\"Email Address\",\"placeholder\":\"\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"7c48152\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"field_2\",\"field_type\":\"tel\",\"required\":\"true\",\"field_label\":\"Phone\",\"placeholder\":\"###-###-####\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_2\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"0f38393\",\"field_type\":\"html\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"\",\"width\":\"100\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"<p style=\\\"margin-bottom:-0px; font-size:18px;\\\"><u>Appointment Details<\\/u><\\/p>\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":0,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"0f38393\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"date\",\"field_type\":\"text\",\"required\":\"true\",\"field_label\":\"Date\",\"placeholder\":\"mm\\/dd\\/yyyy\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"2018-06-01\",\"max_date\":\"2018-12-31\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"date\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"field_6\",\"field_type\":\"text\",\"required\":\"true\",\"field_label\":\"Time\",\"placeholder\":\"eg 9:30pm\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"2018-06-01\",\"max_date\":\"2018-12-31\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_6\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"field_7\",\"field_type\":\"text\",\"required\":\"true\",\"field_label\":\"Duration of date\",\"placeholder\":\"\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"2018-06-01\",\"max_date\":\"2018-12-31\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_7\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"field_8\",\"field_type\":\"text\",\"required\":\"true\",\"field_label\":\"Location: Incall or Outcall\",\"placeholder\":\"\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"2018-06-01\",\"max_date\":\"2018-12-31\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_8\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"message\",\"field_type\":\"textarea\",\"field_label\":\"Any Special Requests?\",\"placeholder\":\"Message\",\"width\":\"100\",\"field_value\":\"\",\"required\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"message\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"field_12\",\"field_type\":\"html\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"\",\"width\":\"100\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"<p style=\\\"margin-bottom:-0px; font-size:18px;\\\"><br \\/><u>References<\\/u><\\/p><small>Names and contact info of providers you\'ve seen before, and any forum usernames or handles: <\\/small><\\/p>\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":0,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_12\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"field_13\",\"field_type\":\"textarea\",\"field_label\":\"Reference Information\",\"placeholder\":\"Details\",\"width\":\"100\",\"field_value\":\"\",\"required\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_13\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"cc47c29\",\"field_type\":\"html\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"\",\"width\":\"100\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"<p style=\\\"margin-bottom:-0px; font-size:18px;\\\"><br \\/><u>How did you hear about me<\\/u><\\/p>\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":0,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"cc47c29\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"e7afcad\",\"field_type\":\"textarea\",\"field_label\":\"\",\"placeholder\":\"Details\",\"width\":\"100\",\"field_value\":\"\",\"required\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"e7afcad\",\"recaptcha_badge\":\"bottomright\"}],\"mark_required\":\"yes\",\"button_text\":\"Send booking request\",\"button_size\":\"md\",\"button_icon\":\"fa fa-send-o\",\"button_icon_align\":\"right\",\"button_icon_indent\":{\"unit\":\"px\",\"size\":12},\"email_content\":\"[all-fields]\",\"form_metadata\":[\"date\",\"time\",\"page_url\",\"user_agent\",\"remote_ip\"],\"email_content_type\":\"plain\",\"email_content_2\":\"[all-fields]\",\"custom_messages\":\"yes\",\"success_message\":\"<center><p style=\\\"background-color:white;\\\"><strong>The form was sent successfully!<\\/strong><\\/p><\\/center>\",\"error_message\":\"An errors occurred.\",\"required_field_message\":\"This field is required.\",\"invalid_message\":\"There\'s something wrong. The form is invalid.\",\"row_gap\":{\"unit\":\"px\",\"size\":18},\"label_color\":\"#000000\",\"mark_required_color\":\"#666666\",\"label_typography_typography\":\"custom\",\"label_typography_font_size\":{\"unit\":\"px\",\"size\":18},\"field_text_color\":\"#000000\",\"field_typography_typography\":\"custom\",\"field_typography_font_size\":{\"unit\":\"px\",\"size\":14},\"field_background_color\":\"#f7f7f7\",\"field_border_color\":\"rgba(0,0,0,0.51)\",\"field_border_radius\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"button_background_color\":\"#000000\",\"button_text_color\":\"#ffffff\",\"button_typography_typography\":\"custom\",\"button_typography_font_family\":\"PT Sans\",\"button_typography_text_transform\":\"uppercase\",\"button_border_radius\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"button_background_hover_color\":\"#999999\",\"button_hover_color\":\"#000000\",\"button_hover_animation\":\"pulse\",\"selected_button_icon\":{\"value\":\"far fa-paper-plane\",\"library\":\"fa-regular\"},\"__fa4_migrated\":{\"selected_button_icon\":true},\"mailchimp_fields_map\":[],\"drip_fields_map\":[],\"activecampaign_fields_map\":[],\"getresponse_fields_map\":[],\"convertkit_fields_map\":[],\"mailerlite_fields_map\":[],\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"form\"},{\"id\":\"a78292\",\"elType\":\"widget\",\"settings\":{\"text\":\"Divider\",\"icon\":{\"value\":\"fas fa-star\",\"library\":\"fa-solid\"},\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"divider\"},{\"id\":\"12388c30\",\"elType\":\"widget\",\"settings\":{\"title\":\"Touring\",\"align\":\"center\",\"title_color\":\"333333\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Fanwood Text\",\"typography_font_size\":{\"unit\":\"px\",\"size\":36},\"typography_font_weight\":\"500\",\"_padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"typography_font_size_mobile\":{\"unit\":\"px\",\"size\":25},\"typography_text_transform\":\"uppercase\",\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"heading\"},{\"id\":\"4cc34a8a\",\"elType\":\"widget\",\"settings\":{\"editor\":\"<p>[text-blocks id=\\\"touring\\\"]<\\/p><p>Please use the form below if you wish to be notified when I\'m visiting your city.<\\/p>\",\"text_color\":\"#333\",\"typography_typography\":\"custom\",\"typography_font_size\":{\"unit\":\"px\",\"size\":18},\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"50\",\"bottom\":\"0\",\"left\":\"50\",\"isLinked\":false},\"align\":\"center\",\"align_mobile\":\"center\",\"typography_font_weight\":\"500\",\"typography_line_height\":{\"unit\":\"em\",\"size\":1.8000000000000000444089209850062616169452667236328125},\"typography_line_height_mobile\":{\"unit\":\"em\",\"size\":1.5},\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"_padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"20\",\"bottom\":\"0\",\"left\":\"20\",\"isLinked\":false},\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"text-editor\"},{\"id\":\"3d45dac7\",\"elType\":\"widget\",\"settings\":{\"shortcode\":\"[newsletter_form form=1]\",\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"100\",\"bottom\":\"0\",\"left\":\"100\",\"isLinked\":false},\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"_padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"20\",\"bottom\":\"0\",\"left\":\"20\",\"isLinked\":false},\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"shortcode\"}],\"isInner\":false}],\"isInner\":false},{\"id\":\"55e1db0a\",\"elType\":\"section\",\"settings\":{\"layout\":\"full_width\",\"height\":\"min-height\",\"column_position\":\"bottom\",\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"74eb174\",\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"background_background\":\"classic\",\"background_position\":\"top center\",\"background_attachment\":\"fixed\",\"background_repeat\":\"no-repeat\",\"background_size\":\"cover\",\"section_parallax_on\":\"yes\",\"parallax_type\":\"scale\",\"parallax_speed\":0.5,\"custom_height_tablet\":{\"unit\":\"vh\",\"size\":75},\"custom_height_mobile\":{\"unit\":\"vh\",\"size\":35},\"custom_height\":{\"unit\":\"vh\",\"size\":100},\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":false},\"background_overlay_background\":\"classic\",\"background_overlay_image\":{\"id\":315,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/Emily-noblur-IMG_6659.jpg\"},\"background_overlay_position\":\"center right\",\"background_overlay_attachment\":\"fixed\",\"background_overlay_repeat\":\"no-repeat\",\"background_overlay_size\":\"cover\",\"background_overlay_opacity\":{\"unit\":\"px\",\"size\":1},\"css_filters_css_filter\":\"custom\",\"css_filters_brightness\":{\"unit\":\"px\",\"size\":141},\"css_filters_saturate\":{\"unit\":\"px\",\"size\":145},\"background_attachment_tablet\":\"scroll\",\"background_attachment_mobile\":\"scroll\",\"background_repeat_tablet\":\"no-repeat\",\"background_repeat_mobile\":\"no-repeat\",\"background_size_tablet\":\"cover\",\"background_size_mobile\":\"contain\",\"background_position_mobile\":\"top left\",\"background_overlay_image_tablet\":{\"id\":315,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/Emily-noblur-IMG_6659.jpg\"},\"background_overlay_position_tablet\":\"top left\",\"background_overlay_position_mobile\":\"top left\",\"background_overlay_attachment_mobile\":\"scroll\",\"background_overlay_repeat_mobile\":\"no-repeat\",\"background_overlay_size_mobile\":\"cover\",\"margin_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":true},\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":true},\"padding_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"background_overlay_image_mobile\":{\"id\":315,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/Emily-noblur-IMG_6659.jpg\"},\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"94946e2\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"content_position\":\"bottom\",\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"4fe166a3\",\"elType\":\"widget\",\"settings\":{\"title\":\"Emily xoxo\",\"align\":\"right\",\"title_color\":\"#ffffff\",\"typography_typography\":\"custom\",\"typography_font_family\":\"League Script\",\"typography_font_size\":{\"unit\":\"em\",\"size\":3},\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"20\",\"left\":\"0\",\"isLinked\":false},\"typography_font_weight\":\"bold\",\"_padding\":{\"unit\":\"px\",\"top\":\"15\",\"right\":\"35\",\"bottom\":\"5\",\"left\":\"15\",\"isLinked\":false},\"_background_background\":\"classic\",\"typography_font_size_tablet\":{\"unit\":\"em\",\"size\":3},\"typography_font_size_mobile\":{\"unit\":\"em\",\"size\":1.5},\"_padding_tablet\":{\"unit\":\"px\",\"top\":\"10\",\"right\":\"30\",\"bottom\":\"10\",\"left\":\"10\",\"isLinked\":false},\"_padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"heading\"}],\"isInner\":false}],\"isInner\":false},{\"id\":\"6102b03a\",\"elType\":\"section\",\"settings\":{\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"d51247d\",\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"border_border\":\"groove\",\"border_width\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"01\",\"left\":\"0\",\"isLinked\":false},\"border_color\":\"#af5a00\",\"background_background\":\"classic\",\"background_color\":\"rgba(175,90,0,0.5)\",\"background_overlay_background\":\"classic\",\"background_overlay_image\":{\"id\":297,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/white-silk-fabric-website-background.jpg\"},\"stretch_section\":\"section-stretched\",\"layout\":\"full_width\",\"gap\":\"no\",\"content_position\":\"top\",\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":true},\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":false},\"padding\":{\"unit\":\"%\",\"top\":\"5\",\"right\":\"0\",\"bottom\":\"05\",\"left\":\"0\",\"isLinked\":false},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"10\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"3f8358fd\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"background_image\":{\"url\":\"\",\"id\":\"\"},\"background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_slideshow_gallery\":[],\"background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_hover_slideshow_gallery\":[],\"background_overlay_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_slideshow_gallery\":[],\"background_overlay_hover_image\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"background_overlay_hover_slideshow_gallery\":[]},\"elements\":[{\"id\":\"5543ad15\",\"elType\":\"widget\",\"settings\":{\"title\":\"| \\u00a9 2019 EmilyHunt.ch | All rights Reserved | <br>| <a href=\\\"https:\\/\\/stickysites.ch\\\" target=\\\"new\\\">Design &amp; Hosting: StickySites.ch<\\/a> |\",\"title_color\":\"#54595f\",\"typography_typography\":\"custom\",\"typography_font_size\":{\"unit\":\"px\",\"size\":13},\"typography_font_weight\":\"200\",\"align\":\"center\",\"align_mobile\":\"center\",\"typography_line_height_mobile\":{\"unit\":\"px\",\"size\":19},\"header_size\":\"p\",\"typography_font_family\":\"PT Sans\",\"typography_line_height\":{\"unit\":\"em\",\"size\":1.1999999999999999555910790149937383830547332763671875},\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"10\",\"left\":\"0\",\"isLinked\":false},\"_background_image\":{\"url\":\"\",\"id\":\"\"},\"_background_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_slideshow_gallery\":[],\"_background_hover_image\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_video_fallback\":{\"url\":\"\",\"id\":\"\"},\"_background_hover_slideshow_gallery\":[]},\"elements\":[],\"widgetType\":\"heading\"}],\"isInner\":false}],\"isInner\":false}]");
INSERT INTO `wp_464683_postmeta` VALUES("293", "287", "_elementor_data", "[{\"id\":\"4a72d473\",\"elType\":\"section\",\"settings\":{\"layout\":\"full_width\",\"height\":\"min-height\",\"custom_height\":{\"unit\":\"vh\",\"size\":110},\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"29bccec\",\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"background_background\":\"classic\",\"background_attachment\":\"fixed\",\"background_repeat\":\"no-repeat\",\"background_size\":\"cover\",\"css_classes\":\"parallax\",\"custom_height_mobile\":{\"unit\":\"vh\",\"size\":100},\"column_position\":\"stretch\",\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":false},\"gap\":\"no\",\"custom_height_tablet\":{\"unit\":\"vh\",\"size\":100},\"animation\":\"fadeIn\",\"animation_duration\":\"slow\",\"background_position\":\"top left\",\"parallax_speed\":3,\"custom_css\":\"\\n\",\"background_position_mobile\":\"top center\",\"background_attachment_mobile\":\"scroll\",\"background_repeat_mobile\":\"no-repeat\",\"background_size_mobile\":\"cover\",\"background_image_tablet\":{\"id\":295,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/Emily-noblur-IMG_6651.jpg\"},\"background_attachment_tablet\":\"scroll\",\"background_repeat_tablet\":\"no-repeat\",\"background_size_tablet\":\"cover\",\"background_motion_fx_translateX_effect\":\"yes\",\"background_motion_fx_translateX_speed\":{\"unit\":\"px\",\"size\":2,\"sizes\":[]},\"background_motion_fx_scale_speed\":{\"unit\":\"px\",\"size\":1,\"sizes\":[]},\"parallax_background_direction\":\"up\",\"background_overlay_background\":\"classic\",\"background_overlay_position\":\"center center\",\"background_overlay_attachment\":\"fixed\",\"background_overlay_repeat\":\"no-repeat\",\"background_overlay_size\":\"cover\",\"background_overlay_opacity\":{\"unit\":\"px\",\"size\":0.8000000000000000444089209850062616169452667236328125,\"sizes\":[]},\"parallax_background_speed\":{\"unit\":\"px\",\"size\":0.179999999999999993338661852249060757458209991455078125,\"sizes\":[]},\"border_border\":\"groove\",\"border_width\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"01\",\"left\":\"0\",\"isLinked\":false},\"border_color\":\"#af5a00\",\"parallax_background_speed_mobile\":{\"unit\":\"px\",\"size\":0,\"sizes\":[]},\"background_overlay_image\":{\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-14.jpg\",\"id\":333},\"background_color\":\"rgba(125,51,138,0.8)\",\"background_overlay_image_mobile\":{\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-14.jpg\",\"id\":333}},\"elements\":[{\"id\":\"4e123b8b\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"_inline_size_tablet\":100,\"content_position\":\"top\",\"content_position_mobile\":\"top\",\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true}},\"elements\":[{\"id\":\"fedb971\",\"elType\":\"widget\",\"settings\":{\"title\":\"Emily<br\\/>Hunt\",\"align\":\"left\",\"align_mobile\":\"left\",\"title_color\":\"#510b5d\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Euphoria Script\",\"typography_font_size\":{\"unit\":\"vw\",\"size\":7.5},\"typography_font_size_mobile\":{\"unit\":\"em\",\"size\":3.20000000000000017763568394002504646778106689453125},\"typography_font_weight\":\"400\",\"typography_font_style\":\"italic\",\"typography_line_height\":{\"unit\":\"em\",\"size\":0.8000000000000000444089209850062616169452667236328125},\"typography_letter_spacing\":{\"unit\":\"px\",\"size\":2.70000000000000017763568394002504646778106689453125},\"title_classic_shadow_text_shadow_type\":\"yes\",\"title_classic_shadow_text_shadow\":{\"horizontal\":2,\"vertical\":2,\"blur\":\"\",\"color\":\"#ffffff\"},\"title_long_shadow_enable\":\"yes\",\"title_long_shadow_color\":\"#f2dff6\",\"title_long_shadow_size\":{\"unit\":\"px\",\"size\":6,\"sizes\":[]},\"title_long_shadow_direction\":\"top\",\"_margin\":{\"unit\":\"%\",\"top\":\"0\",\"right\":\"02\",\"bottom\":\"0\",\"left\":\"010\",\"isLinked\":false},\"_margin_mobile\":{\"unit\":\"%\",\"top\":\"30\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"06\",\"isLinked\":false},\"_padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"10\",\"bottom\":\"10\",\"left\":\"10\",\"isLinked\":false},\"_css_classes\":\"title\",\"_animation_mobile\":\"fadeIn\",\"animation_duration\":\"slow\",\"_background_background\":\"classic\",\"_border_radius\":{\"unit\":\"px\",\"top\":\"10\",\"right\":\"10\",\"bottom\":\"10\",\"left\":\"10\",\"isLinked\":true},\"sticky_enable\":\"yes\",\"sticky_offset\":{\"unit\":\"px\",\"size\":200},\"sticky_offset_bottom\":{\"unit\":\"px\",\"size\":50,\"sizes\":[]}},\"elements\":[],\"widgetType\":\"heading-extended\"}],\"isInner\":false}],\"isInner\":false},{\"id\":\"701bdce9\",\"elType\":\"section\",\"settings\":{\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"d51247d\",\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":false},\"stretch_section\":\"section-stretched\",\"layout\":\"full_width\",\"gap\":\"no\",\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":true},\"padding\":{\"unit\":\"%\",\"top\":\"5\",\"right\":\"0\",\"bottom\":\"05\",\"left\":\"0\",\"isLinked\":false},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"20\",\"right\":\"0\",\"bottom\":\"20\",\"left\":\"0\",\"isLinked\":false},\"content_position\":\"top\",\"background_background\":\"classic\",\"background_color\":\"rgba(186,127,197,0.64)\",\"background_overlay_background\":\"classic\",\"background_overlay_image\":{\"id\":297,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/white-silk-fabric-website-background.jpg\"},\"border_border\":\"groove\",\"border_width\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"01\",\"left\":\"0\",\"isLinked\":false},\"border_color\":\"#af5a00\"},\"elements\":[{\"id\":\"7ef4065f\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"space_between_widgets\":0,\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"10\",\"bottom\":\"10\",\"left\":\"10\",\"isLinked\":false},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"20\",\"right\":\"20\",\"bottom\":\"20\",\"left\":\"20\",\"isLinked\":true},\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true}},\"elements\":[{\"id\":\"60f3d281\",\"elType\":\"widget\",\"settings\":{\"title\":\"About\",\"align\":\"center\",\"title_color\":\"#510b5d\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Euphoria Script\",\"typography_font_size\":{\"unit\":\"vw\",\"size\":5},\"typography_font_weight\":\"500\",\"typography_font_size_mobile\":{\"unit\":\"em\",\"size\":3},\"_padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"typography_text_transform\":\"uppercase\",\"_margin\":{\"unit\":\"%\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"2\",\"left\":\"0\",\"isLinked\":false},\"text_shadow_text_shadow_type\":\"yes\",\"text_shadow_text_shadow\":{\"horizontal\":2,\"vertical\":1,\"blur\":0,\"color\":\"#f2dff6\"},\"typography_font_size_tablet\":{\"unit\":\"em\",\"size\":3.5,\"sizes\":[]}},\"elements\":[],\"widgetType\":\"heading\"},{\"id\":\"256e56ca\",\"elType\":\"widget\",\"settings\":{\"editor\":\"<p>I could write a very generic About Me with lots of catchy words but it\\u2019s just not my style so I will keep this short.<\\/p><p>When I say I am Portland\\u2019s Sweetest girlfriend, it\\u2019s not a falsehood. I am extremely empathetic and fantastic at reading others. I\\u2019m all woman, petite yet curvy with mesmerizing eyes. But I am so, so much more than just another pretty face.<\\/p><p>I love connecting with and meeting new people, traveling (as most people do), dark chocolate and red wine. I moved to Oregon because I love hiking and being outdoors, but I can very easily cozy up with a book for hours or a really good crime podcast or even in some kickass sheets with a special someone.<\\/p><p>I strive to be a better person by making a conscious effort to practice kindness every single day and personal growth is so important to me.<\\/p><p>P.S. Food is always the way to my heart.<\\/p><p>INTERESTS<\\/p><p>New places, new faces, new experiences. Laughing, fitness, outdoor activities, dark chocolate, red wine, tulips, vintage clothing shopping, neck kisses and bold adventures.<\\/p>\",\"align\":\"center\",\"text_color\":\"#510b5d\",\"typography_typography\":\"custom\",\"typography_font_size\":{\"unit\":\"em\",\"size\":1.100000000000000088817841970012523233890533447265625},\"typography_font_weight\":\"300\",\"typography_line_height\":{\"unit\":\"em\",\"size\":1.3000000000000000444089209850062616169452667236328125},\"_margin\":{\"unit\":\"%\",\"top\":\"0\",\"right\":\"20\",\"bottom\":\"0\",\"left\":\"20\",\"isLinked\":false},\"align_mobile\":\"center\",\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"10\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"_padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"10\",\"bottom\":\"0\",\"left\":\"10\",\"isLinked\":false},\"typography_font_style\":\"italic\",\"_css_classes\":\"bio\",\"typography_font_family\":\"Montserrat\",\"typography_font_size_mobile\":{\"unit\":\"em\",\"size\":1.100000000000000088817841970012523233890533447265625,\"sizes\":[]}},\"elements\":[],\"widgetType\":\"text-editor\"},{\"id\":\"7a30415a\",\"elType\":\"widget\",\"settings\":{\"svg_url\":{\"id\":375,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/floral-17510881.svg\"},\"svg_custom_width\":\"yes\",\"svg_width\":{\"unit\":\"px\",\"size\":500,\"sizes\":[]},\"svg_custom_color\":\"yes\",\"svg_color\":\"#510b5d\",\"_margin\":{\"unit\":\"px\",\"top\":\"40\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false}},\"elements\":[],\"widgetType\":\"jet-inline-svg\"}],\"isInner\":false}],\"isInner\":false},{\"id\":\"2f04ea9\",\"elType\":\"section\",\"settings\":{\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"3d6fb8f\",\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"background_background\":\"classic\",\"background_overlay_background\":\"classic\",\"background_overlay_image\":{\"id\":338,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-19.jpg\"},\"background_overlay_repeat\":\"no-repeat\",\"background_overlay_opacity\":{\"unit\":\"px\",\"size\":0.59999999999999997779553950749686919152736663818359375},\"border_border\":\"groove\",\"border_width\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"01\",\"left\":\"0\",\"isLinked\":false},\"border_color\":\"#af5a00\",\"background_overlay_position\":\"top center\",\"background_overlay_attachment\":\"fixed\",\"background_overlay_size\":\"cover\",\"background_overlay_image_tablet\":{\"id\":338,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-19.jpg\"},\"background_overlay_image_mobile\":{\"id\":338,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-19.jpg\"},\"background_overlay_position_mobile\":\"initial\",\"background_overlay_attachment_mobile\":\"scroll\",\"background_overlay_repeat_mobile\":\"no-repeat\",\"background_overlay_size_mobile\":\"cover\",\"background_color\":\"rgba(186,127,197,0.93)\",\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":true},\"padding\":{\"unit\":\"%\",\"top\":\"05\",\"right\":\"20\",\"bottom\":\"05\",\"left\":\"20\",\"isLinked\":false},\"background_overlay_xpos_mobile\":{\"unit\":\"px\",\"size\":-257,\"sizes\":[]},\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":true},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"20\",\"right\":\"20\",\"bottom\":\"20\",\"left\":\"20\",\"isLinked\":false}},\"elements\":[{\"id\":\"aaef3b4\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"padding\":{\"unit\":\"%\",\"top\":\"0\",\"right\":\"20\",\"bottom\":\"0\",\"left\":\"20\",\"isLinked\":false},\"margin_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"padding_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true}},\"elements\":[{\"id\":\"237e7d4\",\"elType\":\"widget\",\"settings\":{\"title\":\"Stats\",\"align\":\"center\",\"title_color\":\"#510b5d\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Euphoria Script\",\"typography_font_size\":{\"unit\":\"vw\",\"size\":5},\"typography_font_weight\":\"500\",\"_padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"typography_font_size_mobile\":{\"unit\":\"em\",\"size\":3},\"typography_text_transform\":\"uppercase\",\"_margin\":{\"unit\":\"%\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"2\",\"left\":\"0\",\"isLinked\":false},\"text_shadow_text_shadow_type\":\"yes\",\"text_shadow_text_shadow\":{\"horizontal\":2,\"vertical\":1,\"blur\":0,\"color\":\"#f2dff6\"},\"typography_font_size_tablet\":{\"unit\":\"em\",\"size\":3.5,\"sizes\":[]}},\"elements\":[],\"widgetType\":\"heading\"},{\"id\":\"65c12fd\",\"elType\":\"widget\",\"settings\":{\"price_list\":[{\"title\":\"&bull;&nbsp;Based in\",\"item_description\":\"\",\"price\":\"Portland, Oregon\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"595534c\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"&bull;&nbsp;Caters to\",\"item_description\":\"\",\"price\":\"Male,Female,Couples\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"3791d57\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"&bull;&nbsp;Age\",\"item_description\":\"\",\"price\":\"20\'s\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"a5af224\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"&bull;&nbsp;Body type\",\"item_description\":\"\",\"price\":\"Curvy\\/Athletic\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"c5388ab\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"&bull;&nbsp;Cup size\",\"item_description\":\"\",\"price\":\"B cup\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"8ce5068\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"&bull;&nbsp;Height\",\"item_description\":\"\",\"price\":\"165 cm \\/ 5\\u2032 5\\u2033\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"1b9c108\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"&bull;&nbsp;Hair color\",\"item_description\":\"\",\"price\":\"Brunette\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"4ad6b2b\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"&bull;&nbsp;Eye color\",\"item_description\":\"\",\"price\":\"Brown\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"0edbfef\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"&bull;&nbsp;Shoe size\",\"item_description\":\"\",\"price\":\"6\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"41662a6\",\"image\":{\"url\":\"\",\"id\":\"\"}}],\"heading_color\":\"#ffffff\",\"heading_typography_typography\":\"custom\",\"heading_typography_font_size\":{\"unit\":\"em\",\"size\":1.100000000000000088817841970012523233890533447265625},\"heading_typography_font_weight\":\"normal\",\"heading_typography_line_height\":{\"unit\":\"em\",\"size\":1.600000000000000088817841970012523233890533447265625},\"description_typography_typography\":\"custom\",\"description_typography_font_size\":{\"unit\":\"em\",\"size\":1},\"description_typography_font_weight\":\"300\",\"separator_weight\":{\"unit\":\"px\",\"size\":1},\"separator_color\":\"#f2dff6\",\"heading_typography_font_size_mobile\":{\"unit\":\"em\",\"size\":1.100000000000000088817841970012523233890533447265625},\"row_gap\":{\"unit\":\"px\",\"size\":10},\"description_typography_font_style\":\"italic\",\"description_color\":\"#f2dff6\",\"description_typography_line_height\":{\"unit\":\"em\",\"size\":0.1000000000000000055511151231257827021181583404541015625,\"sizes\":[]},\"heading_typography_font_family\":\"Montserrat\",\"_margin_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"_padding_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"_padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"10\",\"bottom\":\"0\",\"left\":\"10\",\"isLinked\":false}},\"elements\":[],\"widgetType\":\"price-list\"},{\"id\":\"94b6e3a\",\"elType\":\"widget\",\"settings\":{\"svg_url\":{\"id\":375,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/floral-17510881.svg\"},\"svg_custom_width\":\"yes\",\"svg_width\":{\"unit\":\"px\",\"size\":570,\"sizes\":[]},\"svg_custom_color\":\"yes\",\"svg_color\":\"#f2dff6\"},\"elements\":[],\"widgetType\":\"jet-inline-svg\"}],\"isInner\":false}],\"isInner\":false},{\"id\":\"2c763194\",\"elType\":\"section\",\"settings\":{\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"d51247d\",\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"layout\":\"full_width\",\"padding_mobile\":{\"unit\":\"px\",\"top\":\"20\",\"right\":\"0\",\"bottom\":\"20\",\"left\":\"0\",\"isLinked\":false},\"stretch_section\":\"section-stretched\",\"gap\":\"no\",\"content_position\":\"top\",\"background_background\":\"classic\",\"background_color\":\"rgba(186,127,197,0.64)\",\"background_overlay_background\":\"classic\",\"background_overlay_image\":{\"id\":297,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/white-silk-fabric-website-background.jpg\"},\"border_border\":\"groove\",\"border_width\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"01\",\"left\":\"0\",\"isLinked\":false},\"border_color\":\"#af5a00\",\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":true},\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":false},\"padding\":{\"unit\":\"%\",\"top\":\"5\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false}},\"elements\":[{\"id\":\"1153629d\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"margin\":{\"unit\":\"px\",\"top\":\"20\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"space_between_widgets\":0,\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true}},\"elements\":[{\"id\":\"2988309\",\"elType\":\"widget\",\"settings\":{\"title\":\"Photos\",\"align\":\"center\",\"title_color\":\"#510b5d\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Euphoria Script\",\"typography_font_size\":{\"unit\":\"vw\",\"size\":5},\"typography_font_weight\":\"500\",\"_padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"typography_font_size_mobile\":{\"unit\":\"em\",\"size\":3},\"typography_text_transform\":\"uppercase\",\"_margin\":{\"unit\":\"%\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"2\",\"left\":\"0\",\"isLinked\":false},\"text_shadow_text_shadow_type\":\"yes\",\"text_shadow_text_shadow\":{\"horizontal\":2,\"vertical\":1,\"blur\":0,\"color\":\"#f2dff6\"},\"typography_font_size_tablet\":{\"unit\":\"em\",\"size\":3.5,\"sizes\":[]}},\"elements\":[],\"widgetType\":\"heading\"},{\"id\":\"5d015b70\",\"elType\":\"section\",\"settings\":{\"layout\":\"full_width\",\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"34668a6\",\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"margin\":{\"unit\":\"%\",\"top\":\"04\",\"right\":0,\"bottom\":\"04\",\"left\":0,\"isLinked\":true},\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"custom_css\":\".gallery-item:hover {\\n    cursor: -moz-zoom-in; \\n    cursor: -webkit-zoom-in; \\n    cursor: zoom-in;\\n    transform: scale(1.05);\\n}\\n\",\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"10\",\"bottom\":\"0\",\"left\":\"10\",\"isLinked\":false}},\"elements\":[{\"id\":\"86054a4\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"_inline_size\":null,\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"padding\":{\"unit\":\"%\",\"top\":\"0\",\"right\":\"20\",\"bottom\":\"0\",\"left\":\"20\",\"isLinked\":false},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"03\",\"right\":\"03\",\"bottom\":\"03\",\"left\":\"03\",\"isLinked\":true}},\"elements\":[{\"id\":\"6f9d706\",\"elType\":\"widget\",\"settings\":{\"gallery_type\":\"manual\",\"gallery\":[{\"_id\":\"d1412fb\",\"image\":{\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-20.jpg\",\"id\":339},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/emilyhunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"}},{\"_id\":\"d767ea0\",\"image\":{\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-8.jpg\",\"id\":327},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/emilyhunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"}},{\"_id\":\"a8a09f3\",\"image\":{\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-14.jpg\",\"id\":333},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/emilyhunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"}},{\"_id\":\"ab59d04\",\"image\":{\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-19.jpg\",\"id\":338},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/emilyhunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"}},{\"_id\":\"a027e3d\",\"image\":{\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-17.jpg\",\"id\":336},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/emilyhunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"}},{\"_id\":\"e2268e5\",\"image\":{\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-16.jpg\",\"id\":335},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/emilyhunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"}},{\"_id\":\"945015e\",\"image\":{\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-3.jpg\",\"id\":322},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/emilyhunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"}},{\"_id\":\"abd2d46\",\"image\":{\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-7.jpg\",\"id\":326},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/emilyhunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"}},{\"_id\":\"a02ea1d\",\"image\":{\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-1.jpg\",\"id\":320},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/emilyhunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"}},{\"_id\":\"34c13e1\",\"image\":{\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-12.jpg\",\"id\":331},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/emilyhunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"}},{\"_id\":\"77d55d1\",\"image\":{\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-11.jpg\",\"id\":330},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/emilyhunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"}},{\"_id\":\"dba5f94\",\"image\":{\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-10.jpg\",\"id\":329},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/emilyhunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"}},{\"_id\":\"767c9d3\",\"image\":{\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-9.jpg\",\"id\":328},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":70,\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":80,\"sizes\":[]},\"width\":\"50%\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/emilyhunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"}},{\"_id\":\"0023b66\",\"image\":{\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-15.jpg\",\"id\":334},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":70,\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":80,\"sizes\":[]},\"width\":\"50%\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/emilyhunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"}},{\"_id\":\"7da6f8e\",\"image\":{\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-18.jpg\",\"id\":337},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/emilyhunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"}},{\"_id\":\"5ac7aee\",\"image\":{\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-5.jpg\",\"id\":324},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/emilyhunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"}},{\"_id\":\"bae19a0\",\"image\":{\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-2.jpg\",\"id\":321},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/emilyhunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"}},{\"_id\":\"d156dce\",\"image\":{\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-6.jpg\",\"id\":325},\"custom_size\":\"yes\",\"height_ratio\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_tablet\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"height_ratio_mobile\":{\"unit\":\"px\",\"size\":\"\",\"sizes\":[]},\"width\":\"25%\",\"width_tablet\":\"\",\"width_mobile\":\"50%\",\"link\":\"file\",\"link_url\":{\"url\":\"https:\\/\\/emilyhunt.ch\\/\",\"is_external\":\"\",\"nofollow\":\"\"}}],\"columns\":\"4\",\"open_lightbox\":\"yes\",\"gallery_display_caption\":\"none\",\"image_align\":\"center\",\"image_vertical_align\":\"middle\",\"image_horizontal_spacing\":{\"unit\":\"px\",\"size\":10,\"sizes\":[]},\"image_vertical_spacing\":{\"unit\":\"px\",\"size\":10,\"sizes\":[]},\"image_border_border\":\"groove\",\"image_border_width\":{\"unit\":\"px\",\"top\":\"2\",\"right\":\"2\",\"bottom\":\"2\",\"left\":\"2\",\"isLinked\":true},\"image_border_color\":\"#510b5d\",\"image_transition_transition\":\"custom\",\"image_transition_easing\":\"ease-in-out\",\"image_transition_duration\":0.59999999999999997779553950749686919152736663818359375,\"image_scale\":{\"unit\":\"px\",\"size\":1,\"sizes\":[]},\"image_scale_hover\":{\"unit\":\"px\",\"size\":1.04000000000000003552713678800500929355621337890625,\"sizes\":[]},\"columns_mobile\":\"2\",\"image_horizontal_spacing_mobile\":{\"unit\":\"px\",\"size\":3,\"sizes\":[]},\"image_vertical_spacing_mobile\":{\"unit\":\"px\",\"size\":3,\"sizes\":[]},\"image_opacity_mobile\":{\"unit\":\"px\",\"size\":0.8000000000000000444089209850062616169452667236328125,\"sizes\":[]},\"image_scale_mobile\":{\"unit\":\"px\",\"size\":1,\"sizes\":[]},\"image_opacity_hover_mobile\":{\"unit\":\"px\",\"size\":1,\"sizes\":[]},\"image_scale_hover_mobile\":{\"unit\":\"px\",\"size\":1.020000000000000017763568394002504646778106689453125,\"sizes\":[]}},\"elements\":[],\"widgetType\":\"gallery-extra\"}],\"isInner\":true}],\"isInner\":true}],\"isInner\":false}],\"isInner\":false},{\"id\":\"4027ef6\",\"elType\":\"section\",\"settings\":{\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"bbc7692\",\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"padding_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"20\",\"bottom\":\"0\",\"left\":\"20\",\"isLinked\":false},\"border_border\":\"groove\",\"border_width\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"01\",\"left\":\"0\",\"isLinked\":false},\"border_color\":\"#af5a00\",\"background_background\":\"classic\",\"background_repeat\":\"repeat\",\"background_size\":\"auto\",\"background_overlay_background\":\"classic\",\"background_overlay_image\":{\"id\":334,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-15.jpg\"},\"background_overlay_repeat\":\"no-repeat\",\"background_overlay_opacity\":{\"unit\":\"px\",\"size\":0.65000000000000002220446049250313080847263336181640625},\"shape_divider_top_color\":\"333333\",\"shape_divider_top_width\":{\"unit\":\"%\",\"size\":150},\"shape_divider_top_height\":{\"unit\":\"px\",\"size\":128},\"shape_divider_top_negative\":\"yes\",\"shape_divider_top_above_content\":\"yes\",\"background_overlay_position\":\"bottom center\",\"background_overlay_attachment\":\"fixed\",\"background_overlay_size\":\"cover\",\"background_overlay_image_tablet\":{\"id\":334,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-15.jpg\"},\"background_overlay_image_mobile\":{\"id\":334,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-15.jpg\"},\"background_overlay_attachment_mobile\":\"scroll\",\"background_overlay_repeat_mobile\":\"no-repeat\",\"background_overlay_size_mobile\":\"cover\",\"border_radius\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"background_color\":\"rgba(186,127,197,0.72)\",\"background_overlay_position_mobile\":\"center right\"},\"elements\":[{\"id\":\"5741350\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"margin\":{\"unit\":\"px\",\"top\":\"20\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"space_between_widgets\":0,\"animation_mobile\":\"fadeInUp\"},\"elements\":[{\"id\":\"dd71cf9\",\"elType\":\"widget\",\"settings\":{\"title\":\"Rates\",\"align\":\"center\",\"title_color\":\"#510b5d\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Euphoria Script\",\"typography_font_size\":{\"unit\":\"vw\",\"size\":5},\"typography_font_weight\":\"500\",\"_padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"typography_font_size_mobile\":{\"unit\":\"em\",\"size\":3},\"typography_text_transform\":\"uppercase\",\"_margin\":{\"unit\":\"%\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"2\",\"left\":\"0\",\"isLinked\":false},\"text_shadow_text_shadow_type\":\"yes\",\"text_shadow_text_shadow\":{\"horizontal\":2,\"vertical\":1,\"blur\":0,\"color\":\"#f2dff6\"},\"typography_font_size_tablet\":{\"unit\":\"em\",\"size\":3.5,\"sizes\":[]}},\"elements\":[],\"widgetType\":\"heading\"},{\"id\":\"db8da4a\",\"elType\":\"section\",\"settings\":{\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"bc4a4dd\",\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":false},\"padding\":{\"unit\":\"%\",\"top\":\"0\",\"right\":\"020\",\"bottom\":\"0\",\"left\":\"20\",\"isLinked\":false},\"gap\":\"narrow\",\"padding_tablet\":{\"unit\":\"%\",\"top\":\"0\",\"right\":\"20\",\"bottom\":\"0\",\"left\":\"20\",\"isLinked\":false},\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":true},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true}},\"elements\":[{\"id\":\"2751064\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"_inline_size\":null,\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"padding\":{\"unit\":\"%\",\"top\":\"0\",\"right\":\"20\",\"bottom\":\"0\",\"left\":\"20\",\"isLinked\":false},\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"10\",\"right\":\"10\",\"bottom\":\"10\",\"left\":\"10\",\"isLinked\":true},\"padding_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"20\",\"isLinked\":false},\"_inline_size_tablet\":100},\"elements\":[{\"id\":\"b9ee688\",\"elType\":\"widget\",\"settings\":{\"price_list\":[{\"title\":\"&bull;&nbsp;1 Hour\",\"item_description\":\"\",\"price\":\"$700\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"595534c\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"&bull;&nbsp;1&frac12; Hours\",\"item_description\":\"\",\"price\":\"$850\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"3791d57\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"&bull;&nbsp;2 Hours\",\"item_description\":\"\",\"price\":\"$1000\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"a5af224\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"&bull;&nbsp;Weekend Getaway\",\"item_description\":\"\",\"price\":\"$3000\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"c5388ab\",\"image\":{\"url\":\"\",\"id\":\"\"}},{\"title\":\"&bull;&nbsp;Two days\",\"item_description\":\"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Fly Me To You Companionship\",\"price\":\"$3500\",\"link\":{\"url\":\"#\",\"is_external\":\"\",\"nofollow\":\"\"},\"_id\":\"1b9c108\",\"image\":{\"url\":\"\",\"id\":\"\"}}],\"heading_color\":\"#ffffff\",\"heading_typography_typography\":\"custom\",\"heading_typography_font_size\":{\"unit\":\"em\",\"size\":1.100000000000000088817841970012523233890533447265625},\"heading_typography_font_weight\":\"normal\",\"heading_typography_line_height\":{\"unit\":\"em\",\"size\":1.600000000000000088817841970012523233890533447265625},\"description_typography_typography\":\"custom\",\"description_typography_font_size\":{\"unit\":\"em\",\"size\":1},\"description_typography_font_weight\":\"300\",\"separator_weight\":{\"unit\":\"px\",\"size\":1},\"separator_color\":\"#f2dff6\",\"heading_typography_font_size_mobile\":{\"unit\":\"em\",\"size\":1.100000000000000088817841970012523233890533447265625},\"row_gap\":{\"unit\":\"px\",\"size\":10},\"description_typography_font_style\":\"italic\",\"description_color\":\"#f2dff6\",\"description_typography_line_height\":{\"unit\":\"em\",\"size\":0.1000000000000000055511151231257827021181583404541015625,\"sizes\":[]},\"heading_typography_font_family\":\"Montserrat\",\"_margin_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"_padding_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true}},\"elements\":[],\"widgetType\":\"price-list\"},{\"id\":\"c87e58a\",\"elType\":\"widget\",\"settings\":{\"svg_url\":{\"id\":375,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/floral-17510881.svg\"},\"svg_custom_width\":\"yes\",\"svg_width\":{\"unit\":\"px\",\"size\":570,\"sizes\":[]},\"svg_custom_color\":\"yes\",\"svg_color\":\"#f2dff6\",\"_margin\":{\"unit\":\"px\",\"top\":\"30\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false}},\"elements\":[],\"widgetType\":\"jet-inline-svg\"}],\"isInner\":true}],\"isInner\":true}],\"isInner\":false}],\"isInner\":false},{\"id\":\"63236568\",\"elType\":\"section\",\"settings\":{\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"d51247d\",\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"stretch_section\":\"section-stretched\",\"layout\":\"full_width\",\"gap\":\"no\",\"content_position\":\"top\",\"background_background\":\"classic\",\"background_color\":\"rgba(186,127,197,0.64)\",\"background_overlay_background\":\"classic\",\"background_overlay_image\":{\"id\":297,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/white-silk-fabric-website-background.jpg\"},\"border_width\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"01\",\"left\":\"0\",\"isLinked\":false},\"border_color\":\"#af5a00\",\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":true},\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":false},\"padding\":{\"unit\":\"%\",\"top\":\"5\",\"right\":\"0\",\"bottom\":\"05\",\"left\":\"0\",\"isLinked\":false},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"20\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false}},\"elements\":[{\"id\":\"6ff50274\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"margin\":{\"unit\":\"px\",\"top\":\"20\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"20\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"padding_tablet\":{\"unit\":\"px\",\"top\":\"30\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"space_between_widgets\":0,\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true}},\"elements\":[{\"id\":\"79a78bf0\",\"elType\":\"widget\",\"settings\":{\"title\":\"Contact\",\"align\":\"center\",\"title_color\":\"#510b5d\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Euphoria Script\",\"typography_font_size\":{\"unit\":\"vw\",\"size\":5},\"typography_font_weight\":\"500\",\"_padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"typography_font_size_mobile\":{\"unit\":\"em\",\"size\":3},\"typography_text_transform\":\"uppercase\",\"_margin\":{\"unit\":\"%\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"2\",\"left\":\"0\",\"isLinked\":false},\"text_shadow_text_shadow_type\":\"yes\",\"text_shadow_text_shadow\":{\"horizontal\":2,\"vertical\":1,\"blur\":0,\"color\":\"#f2dff6\"},\"typography_font_size_tablet\":{\"unit\":\"em\",\"size\":3.5,\"sizes\":[]}},\"elements\":[],\"widgetType\":\"heading\"},{\"id\":\"4931a512\",\"elType\":\"section\",\"settings\":{\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"bc4a4dd\",\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":true},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true}},\"elements\":[{\"id\":\"b2671df\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"_inline_size\":null,\"space_between_widgets\":0,\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true}},\"elements\":[{\"id\":\"33622d52\",\"elType\":\"widget\",\"settings\":{\"editor\":\"<p>Screening is required for all new persons. My rates are for my time and companionship only. To really catch my eye send a detailed email.<\\/p>\",\"align\":\"center\",\"text_color\":\"#510b5d\",\"typography_typography\":\"custom\",\"typography_font_size\":{\"unit\":\"em\",\"size\":1.100000000000000088817841970012523233890533447265625},\"typography_font_weight\":\"300\",\"typography_line_height\":{\"unit\":\"em\",\"size\":1.3000000000000000444089209850062616169452667236328125},\"_margin\":{\"unit\":\"%\",\"top\":\"0\",\"right\":\"20\",\"bottom\":\"0\",\"left\":\"20\",\"isLinked\":false},\"align_mobile\":\"center\",\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"_padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"10\",\"bottom\":\"0\",\"left\":\"10\",\"isLinked\":false},\"typography_font_style\":\"italic\",\"_css_classes\":\"bio\",\"typography_font_family\":\"Montserrat\",\"typography_font_size_mobile\":{\"unit\":\"em\",\"size\":1,\"sizes\":[]}},\"elements\":[],\"widgetType\":\"text-editor\"},{\"id\":\"aa81044\",\"elType\":\"widget\",\"settings\":{\"icon_list\":[{\"text\":\"MeetMissEmilyHunt@protonmail.com\",\"selected_icon\":{\"value\":\"fas fa-envelope\",\"library\":\"fa-solid\"},\"_id\":\"8ade805\",\"link\":{\"url\":\"MeetMissEmilyHunt@protonmail.com\",\"is_external\":\"on\",\"nofollow\":\"on\"}},{\"text\":\"+1 559-802-2868\",\"selected_icon\":{\"value\":\"fas fa-phone-square-alt\",\"library\":\"fa-solid\"},\"_id\":\"20e9f60\",\"link\":{\"url\":\"tel:+15598022868\",\"is_external\":\"\",\"nofollow\":\"\"}},{\"text\":\"Twitter: @meetemilyhunt\",\"selected_icon\":{\"value\":\"fab fa-twitter-square\",\"library\":\"fa-brands\"},\"_id\":\"fbf6e8a\",\"link\":{\"url\":\"https:\\/\\/twitter.com\\/meetemilyhunt\",\"is_external\":\"on\",\"nofollow\":\"on\"}},{\"text\":\"Instagram: @Almightywoman\",\"selected_icon\":{\"value\":\"fab fa-instagram\",\"library\":\"fa-brands\"},\"_id\":\"284e85d\",\"link\":{\"url\":\"https:\\/\\/instagram.com\\/Almightywoman\",\"is_external\":\"on\",\"nofollow\":\"on\"}},{\"text\":\"OnlyFans: @Missemilyhunt\",\"selected_icon\":{\"value\":\"fas fa-unlock-alt\",\"library\":\"fa-solid\"},\"_id\":\"8996729\",\"link\":{\"url\":\"https:\\/\\/onlyfans.com\\/missemilyhunt\",\"is_external\":\"on\",\"nofollow\":\"on\"}}],\"space_between\":{\"unit\":\"px\",\"size\":8,\"sizes\":[]},\"icon_align\":\"left\",\"icon_color\":\"#510b5d\",\"icon_size\":{\"unit\":\"px\",\"size\":19,\"sizes\":[]},\"text_color\":\"#510b5d\",\"_margin\":{\"unit\":\"px\",\"top\":\"20\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"_padding\":{\"unit\":\"%\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"040\",\"isLinked\":false},\"icon_typography_typography\":\"custom\",\"icon_typography_font_family\":\"Montserrat\",\"icon_typography_font_size\":{\"unit\":\"em\",\"size\":1.100000000000000088817841970012523233890533447265625,\"sizes\":[]},\"icon_typography_font_weight\":\"300\",\"icon_typography_font_size_mobile\":{\"unit\":\"em\",\"size\":1,\"sizes\":[]},\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"_padding_tablet\":{\"unit\":\"%\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"35\",\"isLinked\":false},\"_padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"10\",\"bottom\":\"0\",\"left\":\"20\",\"isLinked\":false}},\"elements\":[],\"widgetType\":\"icon-list\"}],\"isInner\":true}],\"isInner\":true}],\"isInner\":false}],\"isInner\":false},{\"id\":\"639d98f0\",\"elType\":\"section\",\"settings\":{\"stretch_section\":\"section-stretched\",\"layout\":\"full_width\",\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"d51247d\",\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"gap\":\"no\",\"content_position\":\"top\",\"background_background\":\"classic\",\"background_color\":\"rgba(186,127,197,0.64)\",\"background_overlay_background\":\"classic\",\"background_overlay_image\":{\"id\":297,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/white-silk-fabric-website-background.jpg\"},\"border_width\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"01\",\"left\":\"0\",\"isLinked\":false},\"border_color\":\"#af5a00\",\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":true},\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":false},\"padding\":{\"unit\":\"%\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"05\",\"left\":\"0\",\"isLinked\":false},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"20\",\"right\":\"0\",\"bottom\":\"20\",\"left\":\"0\",\"isLinked\":false}},\"elements\":[{\"id\":\"578c04f7\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"padding\":{\"unit\":\"%\",\"top\":\"00\",\"right\":\"20\",\"bottom\":\"0\",\"left\":\"20\",\"isLinked\":false},\"_inline_size_mobile\":100,\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"10\",\"right\":\"10\",\"bottom\":\"10\",\"left\":\"10\",\"isLinked\":true}},\"elements\":[{\"id\":\"490c79f0\",\"elType\":\"widget\",\"settings\":{\"form_name\":\"New Form\",\"form_fields\":[{\"_id\":\"881210a\",\"field_type\":\"html\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"\",\"width\":\"100\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"<p style=\\\"margin-bottom:-0px; font-size:1.1em; color:#510b5d;font-style:Merriweather;\\\"><u>About You<\\/u><\\/p>\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":0,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"881210a\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"name\",\"field_type\":\"text\",\"field_label\":\"Name\",\"placeholder\":\"First name\",\"width\":\"50\",\"field_value\":\"\",\"required\":\"true\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"name\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"last\",\"field_type\":\"text\",\"field_label\":\"&nbsp;\",\"placeholder\":\"Last name\",\"width\":\"50\",\"field_value\":\"\",\"required\":\"true\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"last\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"d0e3cfd\",\"field_type\":\"text\",\"required\":\"\",\"field_label\":\"City\",\"placeholder\":\"\",\"width\":\"33\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"33\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"7ce8033\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"email\",\"field_type\":\"text\",\"required\":\"\",\"field_label\":\"Age\",\"placeholder\":\"\",\"width\":\"33\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"33\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"email\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"bc7977d\",\"field_type\":\"text\",\"required\":\"\",\"field_label\":\"Ethnicity\",\"placeholder\":\"\",\"width\":\"33\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"33\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"bc7977d\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"bb89bd8\",\"field_type\":\"text\",\"required\":\"\",\"field_label\":\"Company\",\"placeholder\":\"\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"06a5f20\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"0ed2d57\",\"field_type\":\"text\",\"required\":\"\",\"field_label\":\"Occupation\",\"placeholder\":\"\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"0ed2d57\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"3e1810e\",\"field_type\":\"html\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"\",\"width\":\"100\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"<p style=\\\"margin-bottom:-0px; font-size:1.1em; color:#510b5d;font-style:Merriweather;\\\"><u>Contact Information<\\/u><\\/p>\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":0,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"3e1810e\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"7c48152\",\"field_type\":\"email\",\"required\":\"true\",\"field_label\":\"Email Address\",\"placeholder\":\"\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"7c48152\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"field_2\",\"field_type\":\"tel\",\"required\":\"\",\"field_label\":\"Phone\",\"placeholder\":\"###-###-####\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_2\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"0f38393\",\"field_type\":\"html\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"\",\"width\":\"100\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"<p style=\\\"margin-bottom:-0px; font-size:1.1em; color:#510b5d;font-style:Merriweather;\\\"><u>Appointment Details<\\/u><\\/p>\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":0,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"0f38393\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"date\",\"field_type\":\"text\",\"required\":\"\",\"field_label\":\"Date\",\"placeholder\":\"mm\\/dd\\/yyyy\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"2018-06-01\",\"max_date\":\"2018-12-31\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"date\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"field_6\",\"field_type\":\"text\",\"required\":\"\",\"field_label\":\"Time\",\"placeholder\":\"eg 9:30pm\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"2018-06-01\",\"max_date\":\"2018-12-31\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_6\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"field_7\",\"field_type\":\"text\",\"required\":\"\",\"field_label\":\"Duration of date\",\"placeholder\":\"\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"2018-06-01\",\"max_date\":\"2018-12-31\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_7\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"field_8\",\"field_type\":\"text\",\"required\":\"\",\"field_label\":\"Location\",\"placeholder\":\"Incall or Outcall\",\"width\":\"50\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"2018-06-01\",\"max_date\":\"2018-12-31\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"50\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_8\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"message\",\"field_type\":\"textarea\",\"field_label\":\"Any Special Requests?\",\"placeholder\":\"Message\",\"width\":\"100\",\"field_value\":\"\",\"required\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"message\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"field_12\",\"field_type\":\"html\",\"required\":\"\",\"field_label\":\"\",\"placeholder\":\"\",\"width\":\"100\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"elementor-subgroup-inline\",\"field_html\":\"<p style=\\\"margin-bottom:-0px; font-size:1.1em; color:#510b5d;font-style:Merriweather;\\\"><br \\/><u>References<\\/u><br\\/><small>Names and contact info of providers you\'ve seen before, and any forum usernames or handles: <\\/small><\\/p>\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":0,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_12\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"field_13\",\"field_type\":\"textarea\",\"field_label\":\"Reference #1\",\"placeholder\":\"Contact information from previous engagement\",\"width\":\"50\",\"field_value\":\"\",\"required\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_13\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"9d8df48\",\"field_type\":\"textarea\",\"field_label\":\"Reference #2\",\"placeholder\":\"Contact information from previous engagement\",\"width\":\"50\",\"field_value\":\"\",\"required\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"field_1\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"e7afcad\",\"field_type\":\"textarea\",\"field_label\":\"How did you hear about me?\",\"placeholder\":\"Details\",\"width\":\"100\",\"field_value\":\"\",\"required\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"\",\"rows\":2,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"e7afcad\",\"recaptcha_badge\":\"bottomright\"}],\"mark_required\":\"yes\",\"button_text\":\"Send booking request\",\"button_size\":\"md\",\"button_icon\":\"fa fa-send-o\",\"button_icon_align\":\"right\",\"button_icon_indent\":{\"unit\":\"px\",\"size\":12},\"email_content\":\"[all-fields]\",\"form_metadata\":[\"date\",\"time\",\"page_url\",\"user_agent\",\"remote_ip\"],\"email_content_type\":\"plain\",\"email_content_2\":\"[all-fields]\",\"custom_messages\":\"yes\",\"success_message\":\"<center><p style=\\\"background-color:white;\\\"><strong>The form was sent successfully!<\\/strong><\\/p><\\/center>\",\"error_message\":\"An errors occurred.\",\"required_field_message\":\"This field is required.\",\"invalid_message\":\"There\'s something wrong. The form is invalid.\",\"row_gap\":{\"unit\":\"px\",\"size\":18},\"label_color\":\"#510b5d\",\"mark_required_color\":\"#510b5d\",\"label_typography_typography\":\"custom\",\"label_typography_font_size\":{\"unit\":\"em\",\"size\":1.100000000000000088817841970012523233890533447265625},\"field_text_color\":\"#510b5d\",\"field_typography_typography\":\"custom\",\"field_typography_font_size\":{\"unit\":\"vw\",\"size\":1.1999999999999999555910790149937383830547332763671875},\"field_background_color\":\"#f7f7f7\",\"field_border_color\":\"#510b5d\",\"field_border_radius\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"button_background_color\":\"#510b5d\",\"button_text_color\":\"#ffffff\",\"button_typography_typography\":\"custom\",\"button_typography_font_family\":\"PT Sans\",\"button_typography_text_transform\":\"uppercase\",\"button_border_radius\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"button_background_hover_color\":\"#f2dff6\",\"button_hover_color\":\"#510b5d\",\"button_hover_animation\":\"pulse\",\"selected_button_icon\":{\"value\":\"far fa-paper-plane\",\"library\":\"fa-regular\"},\"__fa4_migrated\":{\"selected_button_icon\":true},\"email_to\":\"stickysites@protonmail.com\",\"email_subject\":\"New message from \\\"Emily Hunt\\\"\",\"email_from\":\"email@emilyhunt.ch\",\"email_from_name\":\"Emily Hunt\",\"email_to_2\":\"stickysites@protonmail.com\",\"email_subject_2\":\"New message from \\\"Emily Hunt\\\"\",\"email_from_2\":\"email@emilyhunt.ch\",\"email_from_name_2\":\"Emily Hunt\",\"email_reply_to_2\":\"stickysites@protonmail.com\",\"label_typography_font_family\":\"Montserrat\",\"label_typography_font_weight\":\"300\",\"label_typography_line_height\":{\"unit\":\"em\",\"size\":1.3000000000000000444089209850062616169452667236328125,\"sizes\":[]},\"field_typography_font_family\":\"Montserrat\",\"label_typography_font_size_mobile\":{\"unit\":\"em\",\"size\":1,\"sizes\":[]},\"field_typography_font_size_mobile\":{\"unit\":\"em\",\"size\":0.90000000000000002220446049250313080847263336181640625,\"sizes\":[]},\"field_typography_font_weight\":\"300\",\"button_border_border\":\"solid\",\"button_border_width_mobile\":{\"unit\":\"px\",\"top\":\"1\",\"right\":\"1\",\"bottom\":\"1\",\"left\":\"1\",\"isLinked\":true},\"button_border_color\":\"#510b5d\"},\"elements\":[],\"widgetType\":\"form\"},{\"id\":\"1453d7eb\",\"elType\":\"widget\",\"settings\":{\"text\":\"Divider\"},\"elements\":[],\"widgetType\":\"divider\"},{\"id\":\"3c1fdfd9\",\"elType\":\"widget\",\"settings\":{\"title\":\"Touring\",\"align\":\"center\",\"title_color\":\"#510b5d\",\"typography_typography\":\"custom\",\"typography_font_family\":\"Euphoria Script\",\"typography_font_size\":{\"unit\":\"vw\",\"size\":3},\"typography_font_weight\":\"500\",\"_padding\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false},\"typography_font_size_mobile\":{\"unit\":\"em\",\"size\":2},\"typography_text_transform\":\"uppercase\",\"text_shadow_text_shadow_type\":\"yes\",\"text_shadow_text_shadow\":{\"horizontal\":2,\"vertical\":1,\"blur\":0,\"color\":\"#f2dff6\"},\"_margin\":{\"unit\":\"%\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"2\",\"left\":\"0\",\"isLinked\":false}},\"elements\":[],\"widgetType\":\"heading\"},{\"id\":\"78b357ec\",\"elType\":\"widget\",\"settings\":{\"editor\":\"<p>[text-blocks id=\\\"touring\\\"]<\\/p><p>Please use the form below if you wish to be notified when I\'m visiting your city.<\\/p>\",\"text_color\":\"#510b5d\",\"typography_typography\":\"custom\",\"typography_font_size\":{\"unit\":\"em\",\"size\":1.100000000000000088817841970012523233890533447265625},\"_margin\":{\"unit\":\"%\",\"top\":\"0\",\"right\":\"20\",\"bottom\":\"0\",\"left\":\"20\",\"isLinked\":false},\"align\":\"center\",\"align_mobile\":\"center\",\"typography_font_weight\":\"300\",\"typography_line_height\":{\"unit\":\"em\",\"size\":1.3000000000000000444089209850062616169452667236328125},\"_margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"_padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"10\",\"bottom\":\"0\",\"left\":\"10\",\"isLinked\":false},\"typography_font_style\":\"italic\",\"_css_classes\":\"bio\",\"typography_font_family\":\"Montserrat\",\"typography_font_size_mobile\":{\"unit\":\"em\",\"size\":1,\"sizes\":[]}},\"elements\":[],\"widgetType\":\"text-editor\"},{\"id\":\"80c9f11\",\"elType\":\"widget\",\"settings\":{\"form_name\":\"New Form\",\"form_fields\":[{\"_id\":\"name\",\"field_type\":\"text\",\"field_label\":\"\",\"placeholder\":\"First name\",\"width\":\"33\",\"field_value\":\"\",\"required\":\"true\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"33\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"name\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"7ce8033\",\"field_type\":\"text\",\"required\":\"true\",\"field_label\":\"\",\"placeholder\":\"City\",\"width\":\"33\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"33\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"7ce8033\",\"recaptcha_badge\":\"bottomright\"},{\"_id\":\"7c48152\",\"field_type\":\"email\",\"required\":\"true\",\"field_label\":\"\",\"placeholder\":\"Email\",\"width\":\"33\",\"field_value\":\"\",\"file_sizes\":\"\",\"file_types\":\"\",\"allow_multiple_upload\":\"\",\"max_files\":\"\",\"acceptance_text\":\"\",\"checked_by_default\":\"\",\"field_min\":\"\",\"field_max\":\"\",\"min_date\":\"\",\"max_date\":\"\",\"use_native_date\":\"\",\"use_native_time\":\"\",\"field_options\":\"\",\"allow_multiple\":\"\",\"select_size\":\"\",\"inline_list\":\"\",\"field_html\":\"\",\"width_tablet\":\"\",\"width_mobile\":\"33\",\"rows\":4,\"recaptcha_size\":\"normal\",\"recaptcha_style\":\"light\",\"css_classes\":\"\",\"custom_id\":\"7c48152\",\"recaptcha_badge\":\"bottomright\"}],\"mark_required\":\"yes\",\"button_text\":\"Send touring request\",\"button_size\":\"md\",\"button_icon\":\"fa fa-send-o\",\"button_icon_align\":\"right\",\"button_icon_indent\":{\"unit\":\"px\",\"size\":12},\"email_content\":\"[all-fields]\",\"form_metadata\":[\"date\",\"time\",\"page_url\",\"user_agent\",\"remote_ip\"],\"email_content_type\":\"plain\",\"email_content_2\":\"[all-fields]\",\"custom_messages\":\"yes\",\"success_message\":\"<center><p style=\\\"background-color:white;\\\"><strong>The form was sent successfully!<\\/strong><\\/p><\\/center>\",\"error_message\":\"An errors occurred.\",\"required_field_message\":\"This field is required.\",\"invalid_message\":\"There\'s something wrong. The form is invalid.\",\"row_gap\":{\"unit\":\"px\",\"size\":18},\"label_color\":\"#510b5d\",\"mark_required_color\":\"#510b5d\",\"label_typography_typography\":\"custom\",\"label_typography_font_size\":{\"unit\":\"em\",\"size\":1.100000000000000088817841970012523233890533447265625},\"field_text_color\":\"#510b5d\",\"field_typography_typography\":\"custom\",\"field_typography_font_size\":{\"unit\":\"vw\",\"size\":1.1999999999999999555910790149937383830547332763671875},\"field_background_color\":\"#f7f7f7\",\"field_border_color\":\"#510b5d\",\"field_border_radius\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"button_background_color\":\"#510b5d\",\"button_text_color\":\"#ffffff\",\"button_typography_typography\":\"custom\",\"button_typography_font_family\":\"PT Sans\",\"button_typography_text_transform\":\"uppercase\",\"button_border_radius\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"button_background_hover_color\":\"#f2dff6\",\"button_hover_color\":\"#510b5d\",\"button_hover_animation\":\"pulse\",\"selected_button_icon\":{\"value\":\"far fa-paper-plane\",\"library\":\"fa-regular\"},\"__fa4_migrated\":{\"selected_button_icon\":true},\"email_to\":\"stickysites@protonmail.com\",\"email_subject\":\"New message from \\\"Emily Hunt\\\"\",\"email_from\":\"email@emilyhunt.ch\",\"email_from_name\":\"Emily Hunt\",\"email_to_2\":\"stickysites@protonmail.com\",\"email_subject_2\":\"New message from \\\"Emily Hunt\\\"\",\"email_from_2\":\"email@emilyhunt.ch\",\"email_from_name_2\":\"Emily Hunt\",\"email_reply_to_2\":\"stickysites@protonmail.com\",\"label_typography_font_family\":\"Montserrat\",\"label_typography_font_weight\":\"300\",\"label_typography_line_height\":{\"unit\":\"em\",\"size\":1.3000000000000000444089209850062616169452667236328125,\"sizes\":[]},\"field_typography_font_family\":\"Montserrat\",\"label_typography_font_size_mobile\":{\"unit\":\"em\",\"size\":1,\"sizes\":[]},\"field_typography_font_size_mobile\":{\"unit\":\"em\",\"size\":0.90000000000000002220446049250313080847263336181640625,\"sizes\":[]},\"field_typography_font_weight\":\"300\",\"button_border_border\":\"solid\",\"button_border_width_mobile\":{\"unit\":\"px\",\"top\":\"1\",\"right\":\"1\",\"bottom\":\"1\",\"left\":\"1\",\"isLinked\":true},\"button_border_color\":\"#510b5d\"},\"elements\":[],\"widgetType\":\"form\"},{\"id\":\"eece539\",\"elType\":\"widget\",\"settings\":{\"svg_url\":{\"id\":375,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/floral-17510881.svg\"},\"svg_custom_width\":\"yes\",\"svg_width\":{\"unit\":\"px\",\"size\":500,\"sizes\":[]},\"svg_custom_color\":\"yes\",\"svg_color\":\"#510b5d\",\"_margin\":{\"unit\":\"px\",\"top\":\"40\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false}},\"elements\":[],\"widgetType\":\"jet-inline-svg\"}],\"isInner\":false}],\"isInner\":false},{\"id\":\"7fe8b376\",\"elType\":\"section\",\"settings\":{\"layout\":\"full_width\",\"height\":\"min-height\",\"column_position\":\"bottom\",\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"74eb174\",\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"background_background\":\"classic\",\"background_position\":\"top center\",\"background_attachment\":\"fixed\",\"background_repeat\":\"no-repeat\",\"background_size\":\"cover\",\"section_parallax_on\":\"yes\",\"parallax_type\":\"scale\",\"parallax_speed\":0.5,\"custom_height_tablet\":{\"unit\":\"vh\",\"size\":100},\"custom_height_mobile\":{\"unit\":\"vh\",\"size\":80},\"custom_height\":{\"unit\":\"vh\",\"size\":100},\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":false},\"background_overlay_background\":\"classic\",\"background_overlay_image\":{\"id\":330,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-11.jpg\"},\"background_overlay_position\":\"initial\",\"background_overlay_attachment\":\"fixed\",\"background_overlay_repeat\":\"no-repeat\",\"background_overlay_size\":\"cover\",\"background_overlay_opacity\":{\"unit\":\"px\",\"size\":0.7399999999999999911182158029987476766109466552734375},\"css_filters_css_filter\":\"custom\",\"css_filters_brightness\":{\"unit\":\"px\",\"size\":141},\"css_filters_saturate\":{\"unit\":\"px\",\"size\":145},\"background_attachment_tablet\":\"scroll\",\"background_attachment_mobile\":\"scroll\",\"background_repeat_tablet\":\"no-repeat\",\"background_repeat_mobile\":\"no-repeat\",\"background_size_tablet\":\"cover\",\"background_size_mobile\":\"contain\",\"background_position_mobile\":\"top left\",\"background_overlay_image_tablet\":{\"id\":330,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-11.jpg\"},\"background_overlay_position_tablet\":\"top left\",\"background_overlay_position_mobile\":\"top center\",\"background_overlay_attachment_mobile\":\"scroll\",\"background_overlay_repeat_mobile\":\"no-repeat\",\"background_overlay_size_mobile\":\"cover\",\"margin_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":true},\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":true},\"padding_tablet\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true},\"background_overlay_image_mobile\":{\"id\":330,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/EmilyHunt-11.jpg\"},\"background_color\":\"rgba(186,127,197,0.64)\",\"background_overlay_ypos\":{\"unit\":\"px\",\"size\":-64,\"sizes\":[]}},\"elements\":[{\"id\":\"696b2dc6\",\"elType\":\"column\",\"settings\":{\"_column_size\":100,\"content_position\":\"bottom\"},\"elements\":[{\"id\":\"3b93f848\",\"elType\":\"widget\",\"settings\":{\"title\":\"Emily xoxo\",\"align\":\"right\",\"title_color\":\"#10004c\",\"typography_typography\":\"custom\",\"typography_font_family\":\"League Script\",\"typography_font_size\":{\"unit\":\"em\",\"size\":3},\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"20\",\"left\":\"0\",\"isLinked\":false},\"typography_font_weight\":\"bold\",\"_padding\":{\"unit\":\"px\",\"top\":\"15\",\"right\":\"35\",\"bottom\":\"5\",\"left\":\"15\",\"isLinked\":false},\"_background_background\":\"classic\",\"typography_font_size_tablet\":{\"unit\":\"em\",\"size\":3},\"typography_font_size_mobile\":{\"unit\":\"em\",\"size\":1.5},\"_padding_tablet\":{\"unit\":\"px\",\"top\":\"10\",\"right\":\"30\",\"bottom\":\"10\",\"left\":\"10\",\"isLinked\":false},\"_padding_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":true}},\"elements\":[],\"widgetType\":\"heading\"}],\"isInner\":false}],\"isInner\":false},{\"id\":\"b7ee130\",\"elType\":\"section\",\"settings\":{\"content_delay_time\":\"0.50\",\"jet_parallax_layout_list\":[{\"jet_parallax_layout_image\":{\"url\":\"\",\"id\":\"\"},\"_id\":\"d51247d\",\"jet_parallax_layout_speed\":{\"unit\":\"%\",\"size\":50,\"sizes\":[]},\"jet_parallax_layout_type\":\"scroll\",\"jet_parallax_layout_z_index\":\"\",\"jet_parallax_layout_bg_x\":50,\"jet_parallax_layout_bg_y\":50,\"jet_parallax_layout_bg_size\":\"auto\",\"jet_parallax_layout_animation_prop\":\"transform\",\"jet_parallax_layout_on\":[\"desktop\",\"tablet\"],\"jet_parallax_layout_image_tablet\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_image_mobile\":{\"url\":\"\",\"id\":\"\"},\"jet_parallax_layout_direction\":\"1\",\"jet_parallax_layout_fx_direction\":\"fade-in\"}],\"border_border\":\"groove\",\"border_width\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"01\",\"left\":\"0\",\"isLinked\":false},\"border_color\":\"#af5a00\",\"background_background\":\"classic\",\"background_color\":\"rgba(186,127,197,0.64)\",\"background_overlay_background\":\"classic\",\"background_overlay_image\":{\"id\":297,\"url\":\"http:\\/\\/emilyhunt.ch\\/wp-content\\/uploads\\/2019\\/11\\/white-silk-fabric-website-background.jpg\"},\"stretch_section\":\"section-stretched\",\"layout\":\"full_width\",\"gap\":\"no\",\"content_position\":\"top\",\"margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":true},\"margin_mobile\":{\"unit\":\"px\",\"top\":\"0\",\"right\":0,\"bottom\":\"0\",\"left\":0,\"isLinked\":false},\"padding\":{\"unit\":\"%\",\"top\":\"5\",\"right\":\"0\",\"bottom\":\"05\",\"left\":\"0\",\"isLinked\":false},\"padding_mobile\":{\"unit\":\"px\",\"top\":\"10\",\"right\":\"0\",\"bottom\":\"0\",\"left\":\"0\",\"isLinked\":false}},\"elements\":[{\"id\":\"1ec4cefa\",\"elType\":\"column\",\"settings\":{\"_column_size\":100},\"elements\":[{\"id\":\"292c67f4\",\"elType\":\"widget\",\"settings\":{\"title\":\"| \\u00a9 2019 EmilyHunt.ch | All rights Reserved | <br>| <a href=\\\"https:\\/\\/stickysites.ch\\\" target=\\\"new\\\">Design &amp; Hosting: StickySites.ch<\\/a> |\",\"title_color\":\"#510b5d\",\"typography_typography\":\"custom\",\"typography_font_size\":{\"unit\":\"em\",\"size\":1},\"typography_font_weight\":\"300\",\"align\":\"center\",\"align_mobile\":\"center\",\"typography_line_height_mobile\":{\"unit\":\"px\",\"size\":19},\"header_size\":\"p\",\"typography_font_family\":\"Montserrat\",\"typography_line_height\":{\"unit\":\"em\",\"size\":1.1999999999999999555910790149937383830547332763671875},\"_margin\":{\"unit\":\"px\",\"top\":\"0\",\"right\":\"0\",\"bottom\":\"10\",\"left\":\"0\",\"isLinked\":false},\"typography_font_size_mobile\":{\"unit\":\"em\",\"size\":0.90000000000000002220446049250313080847263336181640625,\"sizes\":[]}},\"elements\":[],\"widgetType\":\"heading\"}],\"isInner\":false}],\"isInner\":false}]");
INSERT INTO `wp_464683_postmeta` VALUES("308", "296", "_elementor_inline_svg", "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<!DOCTYPE svg  PUBLIC \'-//W3C//DTD SVG 1.1//EN\'  \'http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd\'>\n<svg enable-background=\"new 0 0 2641.465 318.75\" version=\"1.1\" viewBox=\"0 0 2641.465 318.75\" xml:space=\"preserve\" xmlns=\"http://www.w3.org/2000/svg\">\n	<path d=\"m1742.1 193.97c-8.155 0.553-8.818 14.018-1.059 15.756 7.902 1.975 16.151 0.774 24.195 1.027 268.66-0.016 537.31-0.016 805.97 0 7.68-0.19 15.487 0.758 23.057-0.759 3.856-0.743 6.542-4.551 6.495-8.344-0.095-5.547-5.452-8.613-10.541-8.107-272.88 0.047-545.77 0-818.66 0.031-9.798 0.254-19.675-0.726-29.457 0.396z\" enable-background=\"new    \"/>\n	<path d=\"m899.39 193.97c8.155 0.553 8.818 14.018 1.059 15.756-7.902 1.975-16.151 0.774-24.195 1.027-268.66-0.016-537.31-0.016-805.97 0-7.68-0.19-15.487 0.758-23.057-0.759-3.856-0.743-6.542-4.551-6.495-8.344 0.095-5.547 5.452-8.613 10.541-8.107 272.88 0.047 545.77 0 818.66 0.031 9.798 0.254 19.675-0.726 29.457 0.396z\" enable-background=\"new    \"/>\n	<path d=\"m1686 201.38c-0.743 12.169 12.943 22.757 24.448 17.969 9.166-2.845 14.35-13.117 11.805-22.251-1.849-7.017-8.233-12.88-15.614-13.275-10.383-1.818-20.718 7.048-20.639 17.557zm27.735-2.386c2.781 6.4-4.488 14.176-11.141 12.564-4.488-0.996-8.076-5.373-7.933-10.003 0.458-4.757 4.536-8.676 9.071-9.592 4.329 0.03 8.581 2.89 10.003 7.031z\" enable-background=\"new    \"/>\n	<path d=\"m955.45 201.38c0.743 12.169-12.943 22.757-24.448 17.969-9.166-2.845-14.35-13.117-11.805-22.251 1.849-7.017 8.233-12.88 15.614-13.275 10.383-1.818 20.718 7.048 20.639 17.557zm-27.735-2.386c-2.781 6.4 4.488 14.176 11.141 12.564 4.488-0.996 8.076-5.373 7.933-10.003-0.458-4.757-4.536-8.676-9.071-9.592-4.329 0.03-8.581 2.89-10.003 7.031z\" enable-background=\"new    \"/>\n	<path d=\"m1320.7 237.4c4.371-0.255 8.733-0.635 13.076-1.14 48.453-4.931 94.441-23.974 135.8-49.085 20.544-12.248 38.845-27.845 59.326-40.204 20.323-12.406 43.127-22.077 67.212-22.82 26.044 0.49 51.298 16.056 63.213 39.255 9.071 17.463 9.925 38.371 4.804 57.161-3.003 11.695-8.36 23.184-17.399 31.433-8.518 7.743-20.228 11.426-31.654 11.015-15.456 0.442-32.223-5.705-40.694-19.264-9.751-15.092-5.784-38.276 10.193-47.489 11.22-6.653 25.349-4.757 36.632 0.695 5.484 2.544 6.795 9.055 10.857 13.085 1.264-4.156 2.876-8.55 1.596-12.864-1.849-6.827-7.286-12.137-13.417-15.361-9.466-5.184-20.876-5.816-31.259-3.414-14.681 3.572-26.455 16.325-29.236 31.117-1.896 10.92-0.616 22.709 5.294 32.27 7.886 13.702 23.531 21.461 38.908 22.773 11.173 0.268 22.725 1.011 33.408-2.971 16.246-5.373 29.015-19.027 34.578-35.052 6.306-18.3 6.59-38.702 0.379-57.066-7.791-23.231-27.214-41.673-50.223-49.686-12.089-4.788-25.396-4.425-38.133-3.366-30.643 4.694-57.619 21.477-82.019 39.73-15.329 11.726-30.991 23.073-47.694 32.823-40.599 23.794-86.317 41.083-133.54 43.728-47.228-2.644-92.947-19.933-133.54-43.728-16.704-9.751-32.365-21.098-47.694-32.823-24.4-18.253-51.376-35.036-82.019-39.73-12.738-1.059-26.044-1.422-38.134 3.366-23.01 8.012-42.432 26.455-50.223 49.686-6.211 18.364-5.926 38.766 0.379 57.066 5.563 16.025 18.332 29.679 34.578 35.052 10.683 3.983 22.235 3.24 33.408 2.971 15.377-1.312 31.022-9.071 38.908-22.773 5.91-9.561 7.191-21.35 5.294-32.27-2.781-14.792-14.555-27.545-29.236-31.117-10.383-2.402-21.793-1.77-31.259 3.414-6.132 3.224-11.568 8.534-13.417 15.361-1.28 4.314 0.332 8.708 1.596 12.864 4.062-4.03 5.373-10.541 10.857-13.085 11.284-5.452 25.412-7.348 36.632-0.695 15.977 9.213 19.944 32.397 10.193 47.489-8.471 13.559-25.238 19.706-40.694 19.264-11.426 0.411-23.136-3.272-31.654-11.015-9.039-8.249-14.397-19.738-17.399-31.433-5.12-18.79-4.267-39.698 4.804-57.161 11.916-23.199 37.169-38.766 63.213-39.255 24.084 0.743 46.889 10.414 67.212 22.82 20.481 12.358 38.782 27.956 59.326 40.204 41.357 25.111 87.345 44.154 135.8 49.085 4.343 0.505 8.704 0.885 13.075 1.14zm0-16.381c23.825-0.755 48.012-9.056 64.959-26.211 14.539-15.14 24.495-34.23 40.441-48.09 8.076-7.601 17.716-13.101 26.834-19.264-9.751-0.901-19.296-3.461-29.094-3.998-14.871-0.158-30.295 0.427-44.012 6.827-20.339 9.15-34.847 27.419-55.201 36.506-1.296 0.53-2.605 1.027-3.926 1.493-1.321-0.466-2.63-0.964-3.926-1.493-20.355-9.087-34.862-27.355-55.201-36.506-13.717-6.401-29.141-6.985-44.012-6.827-9.798 0.537-19.343 3.097-29.094 3.998 9.119 6.163 18.758 11.663 26.834 19.264 15.945 13.859 25.901 32.95 40.441 48.09 16.945 17.155 41.132 25.455 64.957 26.211zm0-42.074c6.04-1.938 11.825-4.583 17.09-8.174 18.158-11.6 31.038-30.516 51.361-38.813 18.174-6.716 38.228-7.933 56.987-2.908-13.259 8.455-26.186 17.668-36.996 29.189-14.745 15.772-28.035 34.372-48.564 43.112-12.601 5.464-26.157 8.587-39.879 9.44-13.721-0.853-27.278-3.975-39.879-9.44-20.529-8.739-33.819-27.34-48.564-43.112-10.81-11.521-23.737-20.734-36.996-29.189 18.759-5.025 38.813-3.809 56.987 2.908 20.323 8.297 33.203 27.213 51.361 38.813 5.267 3.592 11.053 6.237 17.092 8.174zm0-16.967c11.662-8.17 20.736-20.059 25.671-33.433 7.286-19.659 6.416-43.839-7.269-60.558-4.911-6.165-11.296-10.88-18.402-14.036-7.106 3.156-13.491 7.87-18.402 14.036-13.686 16.72-14.555 40.899-7.269 60.558 4.936 13.373 14.009 25.263 25.671 33.433zm0-104.06c8.436 4.271 15.62 10.925 19.982 19.437 6.084 10.73 6.701 23.5 5.405 35.51-2.426 16.99-11.841 32.882-25.387 43.352-13.546-10.47-22.961-26.362-25.387-43.352-1.296-12.01-0.679-24.78 5.405-35.51 4.362-8.512 11.546-15.166 19.982-19.437z\" enable-background=\"new    \"/>\n	<path d=\"m1529.3 230.48c-3.145-7.617-10.588-12.152-17.304-16.277-21.745-12.437-48.532-12.011-71.921-4.789-12.532 4.03-25.175 8.803-35.684 16.957 31.212-0.806 59.263 14.681 89.178 20.892 9.166 1.691 18.948 1.422 27.624-2.149 5.579-2.197 10.509-8.502 8.107-14.634zm-33.582 7.57c-26.692-4.804-52.531-15.74-80.044-14.95 17.225-6.543 35.605-10.841 54.095-10.636 18.648 0.727 38.671 6.669 50.792 21.682-7.38 4.552-16.42 5.216-24.843 3.904z\" enable-background=\"new    \"/>\n	<path d=\"m1112.2 230.48c3.145-7.617 10.588-12.152 17.304-16.277 21.745-12.437 48.532-12.011 71.921-4.789 12.532 4.03 25.175 8.803 35.684 16.957-31.212-0.806-59.263 14.681-89.178 20.892-9.166 1.691-18.948 1.422-27.624-2.149-5.579-2.197-10.51-8.502-8.107-14.634zm33.582 7.57c26.692-4.804 52.531-15.74 80.044-14.95-17.225-6.543-35.605-10.841-54.095-10.636-18.648 0.727-38.671 6.669-50.792 21.682 7.38 4.552 16.419 5.216 24.843 3.904z\" enable-background=\"new    \"/>\n</svg>\n");
INSERT INTO `wp_464683_postmeta` VALUES("309", "320", "_wp_attached_file", "2019/11/EmilyHunt-1.jpg");
INSERT INTO `wp_464683_postmeta` VALUES("310", "320", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:870;s:6:\"height\";i:1280;s:4:\"file\";s:23:\"2019/11/EmilyHunt-1.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"EmilyHunt-1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"EmilyHunt-1-204x300.jpg\";s:5:\"width\";i:204;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-1-696x1024.jpg\";s:5:\"width\";i:696;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_464683_postmeta` VALUES("311", "321", "_wp_attached_file", "2019/11/EmilyHunt-2.jpg");
INSERT INTO `wp_464683_postmeta` VALUES("312", "321", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:876;s:6:\"height\";i:1280;s:4:\"file\";s:23:\"2019/11/EmilyHunt-2.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"EmilyHunt-2-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"EmilyHunt-2-205x300.jpg\";s:5:\"width\";i:205;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-2-701x1024.jpg\";s:5:\"width\";i:701;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_464683_postmeta` VALUES("313", "322", "_wp_attached_file", "2019/11/EmilyHunt-3.jpg");
INSERT INTO `wp_464683_postmeta` VALUES("314", "322", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:876;s:6:\"height\";i:1280;s:4:\"file\";s:23:\"2019/11/EmilyHunt-3.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"EmilyHunt-3-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"EmilyHunt-3-205x300.jpg\";s:5:\"width\";i:205;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-3-701x1024.jpg\";s:5:\"width\";i:701;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_464683_postmeta` VALUES("315", "323", "_wp_attached_file", "2019/11/EmilyHunt-4.jpg");
INSERT INTO `wp_464683_postmeta` VALUES("316", "323", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:875;s:6:\"height\";i:1280;s:4:\"file\";s:23:\"2019/11/EmilyHunt-4.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"EmilyHunt-4-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"EmilyHunt-4-205x300.jpg\";s:5:\"width\";i:205;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-4-700x1024.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_464683_postmeta` VALUES("317", "324", "_wp_attached_file", "2019/11/EmilyHunt-5.jpg");
INSERT INTO `wp_464683_postmeta` VALUES("318", "324", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:870;s:6:\"height\";i:1280;s:4:\"file\";s:23:\"2019/11/EmilyHunt-5.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"EmilyHunt-5-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"EmilyHunt-5-204x300.jpg\";s:5:\"width\";i:204;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-5-696x1024.jpg\";s:5:\"width\";i:696;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_464683_postmeta` VALUES("319", "325", "_wp_attached_file", "2019/11/EmilyHunt-6.jpg");
INSERT INTO `wp_464683_postmeta` VALUES("320", "325", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:868;s:6:\"height\";i:1280;s:4:\"file\";s:23:\"2019/11/EmilyHunt-6.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"EmilyHunt-6-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"EmilyHunt-6-203x300.jpg\";s:5:\"width\";i:203;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-6-694x1024.jpg\";s:5:\"width\";i:694;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_464683_postmeta` VALUES("321", "326", "_wp_attached_file", "2019/11/EmilyHunt-7.jpg");
INSERT INTO `wp_464683_postmeta` VALUES("322", "326", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:870;s:6:\"height\";i:1280;s:4:\"file\";s:23:\"2019/11/EmilyHunt-7.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"EmilyHunt-7-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"EmilyHunt-7-204x300.jpg\";s:5:\"width\";i:204;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-7-696x1024.jpg\";s:5:\"width\";i:696;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_464683_postmeta` VALUES("323", "327", "_wp_attached_file", "2019/11/EmilyHunt-8.jpg");
INSERT INTO `wp_464683_postmeta` VALUES("324", "327", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:877;s:6:\"height\";i:1280;s:4:\"file\";s:23:\"2019/11/EmilyHunt-8.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"EmilyHunt-8-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"EmilyHunt-8-206x300.jpg\";s:5:\"width\";i:206;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-8-702x1024.jpg\";s:5:\"width\";i:702;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_464683_postmeta` VALUES("325", "328", "_wp_attached_file", "2019/11/EmilyHunt-9.jpg");
INSERT INTO `wp_464683_postmeta` VALUES("326", "328", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:875;s:6:\"height\";i:1280;s:4:\"file\";s:23:\"2019/11/EmilyHunt-9.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"EmilyHunt-9-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"EmilyHunt-9-205x300.jpg\";s:5:\"width\";i:205;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-9-700x1024.jpg\";s:5:\"width\";i:700;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_464683_postmeta` VALUES("327", "329", "_wp_attached_file", "2019/11/EmilyHunt-10.jpg");
INSERT INTO `wp_464683_postmeta` VALUES("328", "329", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:981;s:6:\"height\";i:1280;s:4:\"file\";s:24:\"2019/11/EmilyHunt-10.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-10-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-10-230x300.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:25:\"EmilyHunt-10-785x1024.jpg\";s:5:\"width\";i:785;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_464683_postmeta` VALUES("329", "330", "_wp_attached_file", "2019/11/EmilyHunt-11.jpg");
INSERT INTO `wp_464683_postmeta` VALUES("330", "330", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1009;s:6:\"height\";i:1280;s:4:\"file\";s:24:\"2019/11/EmilyHunt-11.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-11-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-11-236x300.jpg\";s:5:\"width\";i:236;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:25:\"EmilyHunt-11-807x1024.jpg\";s:5:\"width\";i:807;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_464683_postmeta` VALUES("331", "331", "_wp_attached_file", "2019/11/EmilyHunt-12.jpg");
INSERT INTO `wp_464683_postmeta` VALUES("332", "331", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1127;s:6:\"height\";i:1280;s:4:\"file\";s:24:\"2019/11/EmilyHunt-12.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-12-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-12-264x300.jpg\";s:5:\"width\";i:264;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:25:\"EmilyHunt-12-902x1024.jpg\";s:5:\"width\";i:902;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_464683_postmeta` VALUES("333", "332", "_wp_attached_file", "2019/11/EmilyHunt-13.jpg");
INSERT INTO `wp_464683_postmeta` VALUES("334", "332", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:807;s:4:\"file\";s:24:\"2019/11/EmilyHunt-13.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-13-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-13-300x189.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:189;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:25:\"EmilyHunt-13-1024x646.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:646;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_464683_postmeta` VALUES("335", "333", "_wp_attached_file", "2019/11/EmilyHunt-14.jpg");
INSERT INTO `wp_464683_postmeta` VALUES("336", "333", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:808;s:4:\"file\";s:24:\"2019/11/EmilyHunt-14.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-14-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-14-300x189.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:189;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:25:\"EmilyHunt-14-1024x646.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:646;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_464683_postmeta` VALUES("337", "334", "_wp_attached_file", "2019/11/EmilyHunt-15.jpg");
INSERT INTO `wp_464683_postmeta` VALUES("338", "334", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:806;s:4:\"file\";s:24:\"2019/11/EmilyHunt-15.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-15-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-15-300x189.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:189;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:25:\"EmilyHunt-15-1024x645.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:645;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_464683_postmeta` VALUES("339", "335", "_wp_attached_file", "2019/11/EmilyHunt-16.jpg");
INSERT INTO `wp_464683_postmeta` VALUES("340", "335", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:688;s:4:\"file\";s:24:\"2019/11/EmilyHunt-16.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-16-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-16-300x161.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:161;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:25:\"EmilyHunt-16-1024x550.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:550;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_464683_postmeta` VALUES("341", "336", "_wp_attached_file", "2019/11/EmilyHunt-17.jpg");
INSERT INTO `wp_464683_postmeta` VALUES("342", "336", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:947;s:4:\"file\";s:24:\"2019/11/EmilyHunt-17.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-17-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-17-300x222.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:222;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:25:\"EmilyHunt-17-1024x758.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:758;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_464683_postmeta` VALUES("343", "337", "_wp_attached_file", "2019/11/EmilyHunt-18.jpg");
INSERT INTO `wp_464683_postmeta` VALUES("344", "337", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:809;s:4:\"file\";s:24:\"2019/11/EmilyHunt-18.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-18-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-18-300x190.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:190;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:25:\"EmilyHunt-18-1024x647.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:647;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_464683_postmeta` VALUES("345", "338", "_wp_attached_file", "2019/11/EmilyHunt-19.jpg");
INSERT INTO `wp_464683_postmeta` VALUES("346", "338", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:810;s:4:\"file\";s:24:\"2019/11/EmilyHunt-19.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-19-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-19-300x190.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:190;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:25:\"EmilyHunt-19-1024x648.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:648;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_464683_postmeta` VALUES("347", "339", "_wp_attached_file", "2019/11/EmilyHunt-20.jpg");
INSERT INTO `wp_464683_postmeta` VALUES("348", "339", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1280;s:6:\"height\";i:812;s:4:\"file\";s:24:\"2019/11/EmilyHunt-20.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-20-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:24:\"EmilyHunt-20-300x190.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:190;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:25:\"EmilyHunt-20-1024x650.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:650;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_464683_postmeta` VALUES("545", "368", "_wp_attached_file", "2019/11/Decorative_text_divider_-_central_flare.svg");
INSERT INTO `wp_464683_postmeta` VALUES("546", "368", "_wp_attachment_metadata", "a:2:{s:5:\"width\";d:300;s:6:\"height\";d:20;}");
INSERT INTO `wp_464683_postmeta` VALUES("547", "368", "_elementor_inline_svg", "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>\n<!-- Created with Inkscape (http://www.inkscape.org/) -->\n\n<svg\n   xmlns:dc=\"http://purl.org/dc/elements/1.1/\"\n   xmlns:cc=\"http://creativecommons.org/ns#\"\n   xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\"\n   xmlns:svg=\"http://www.w3.org/2000/svg\"\n   xmlns=\"http://www.w3.org/2000/svg\"\n   xmlns:sodipodi=\"http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd\"\n   xmlns:inkscape=\"http://www.inkscape.org/namespaces/inkscape\"\n   version=\"1.1\"\n   width=\"300\"\n   height=\"20\"\n   id=\"svg2\"\n   inkscape:version=\"0.47pre4 \"\n   sodipodi:docname=\"Decorative text divider - central flare.svg\">\n  <metadata\n     id=\"metadata2835\">\n    <rdf:RDF>\n      <cc:Work\n         rdf:about=\"\">\n        <dc:format>image/svg+xml</dc:format>\n        <dc:type\n           rdf:resource=\"http://purl.org/dc/dcmitype/StillImage\" />\n        <dc:title></dc:title>\n      </cc:Work>\n    </rdf:RDF>\n  </metadata>\n  <sodipodi:namedview\n     pagecolor=\"#ffffff\"\n     bordercolor=\"#666666\"\n     borderopacity=\"1\"\n     objecttolerance=\"10\"\n     gridtolerance=\"10\"\n     guidetolerance=\"10\"\n     inkscape:pageopacity=\"0\"\n     inkscape:pageshadow=\"2\"\n     inkscape:window-width=\"1395\"\n     inkscape:window-height=\"874\"\n     id=\"namedview2833\"\n     showgrid=\"true\"\n     inkscape:zoom=\"1\"\n     inkscape:cx=\"11.376966\"\n     inkscape:cy=\"10.07637\"\n     inkscape:window-x=\"41\"\n     inkscape:window-y=\"-4\"\n     inkscape:window-maximized=\"1\"\n     inkscape:current-layer=\"svg2\">\n    <inkscape:grid\n       type=\"xygrid\"\n       id=\"grid2845\"\n       empspacing=\"5\"\n       visible=\"true\"\n       enabled=\"true\"\n       snapvisiblegridlinesonly=\"true\" />\n  </sodipodi:namedview>\n  <defs\n     id=\"defs4\">\n    <inkscape:perspective\n       sodipodi:type=\"inkscape:persp3d\"\n       inkscape:vp_x=\"0 : 7 : 1\"\n       inkscape:vp_y=\"0 : 1000 : 0\"\n       inkscape:vp_z=\"400 : 7 : 1\"\n       inkscape:persp3d-origin=\"200 : 4.6666667 : 1\"\n       id=\"perspective2837\" />\n  </defs>\n  <path\n     style=\"fill:#000000;fill-opacity:1;stroke:none\"\n     d=\"m 150,1.5 c 0,8.1555533 -40,8.5 -145,9 105,0.5 145,0.844447 145,9 0,-8.155553 40,-8.5 145,-9 C 190,10 150,9.6555533 150,1.5 z\"\n     id=\"path2849\" />\n  <path\n     style=\"fill:none;stroke:#000000;stroke-width:1;stroke-linecap:butt;stroke-opacity:1\"\n     d=\"m 5,10.5 290,0\"\n     id=\"path2871\"\n     sodipodi:nodetypes=\"cc\" />\n</svg>\n");
INSERT INTO `wp_464683_postmeta` VALUES("548", "369", "_wp_attached_file", "2019/11/Decorative_text_divider.svg");
INSERT INTO `wp_464683_postmeta` VALUES("549", "369", "_wp_attachment_metadata", "a:2:{s:5:\"width\";d:400;s:6:\"height\";d:16;}");
INSERT INTO `wp_464683_postmeta` VALUES("550", "369", "_elementor_inline_svg", "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>\n<!-- Created with Inkscape (http://www.inkscape.org/) -->\n\n<svg\n   xmlns:svg=\"http://www.w3.org/2000/svg\"\n   xmlns=\"http://www.w3.org/2000/svg\"\n   version=\"1.1\"\n   width=\"400\"\n   height=\"16\"\n   id=\"svg2\">\n  <defs\n     id=\"defs4\" />\n  <g\n     transform=\"translate(0,-1036.3622)\"\n     id=\"layer1\">\n    <path\n       d=\"m 205,1043.375 0,2 180,0 10,-0.5 0,-1 -10,-0.5 -180,0 z\"\n       id=\"path2834\"\n       style=\"font-size:medium;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-indent:0;text-align:start;text-decoration:none;line-height:normal;letter-spacing:normal;word-spacing:normal;text-transform:none;direction:ltr;block-progression:tb;writing-mode:lr-tb;text-anchor:start;color:#000000;fill:#000000;fill-opacity:1;stroke:none;stroke-width:2;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate;font-family:Bitstream Vera Sans;-inkscape-font-specification:Bitstream Vera Sans\" />\n    <path\n       d=\"m 5,1043.875 0,1 9.96875,0.5 180.03125,0 0,-2 -180.03125,0 -9.96875,0.5 z\"\n       id=\"path2836\"\n       style=\"font-size:medium;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-indent:0;text-align:start;text-decoration:none;line-height:normal;letter-spacing:normal;word-spacing:normal;text-transform:none;direction:ltr;block-progression:tb;writing-mode:lr-tb;text-anchor:start;color:#000000;fill:#000000;fill-opacity:1;stroke:none;stroke-width:2;marker:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate;font-family:Bitstream Vera Sans;-inkscape-font-specification:Bitstream Vera Sans\" />\n    <path\n       d=\"m 15,1046.8622 370,0\"\n       id=\"path2840\"\n       style=\"fill:#ffffff;fill-opacity:1;stroke:#000000;stroke-width:1;stroke-linecap:butt;stroke-opacity:1\" />\n    <path\n       d=\"m 15,1041.8622 370,0\"\n       id=\"path2838\"\n       style=\"fill:#ffffff;fill-opacity:1;stroke:#000000;stroke-width:1;stroke-linecap:butt;stroke-opacity:1\" />\n    <path\n       d=\"M 105,5 A 5,5 0 1 1 95,5 5,5 0 1 1 105,5 z\"\n       transform=\"matrix(1.275,0,0,1.275,72.5,1037.9872)\"\n       id=\"path2830\"\n       style=\"fill:#ffffff;fill-opacity:1;stroke:#000000;stroke-width:1.17647064\" />\n    <path\n       d=\"M 105,5 A 5,5 0 1 1 95,5 5,5 0 1 1 105,5 z\"\n       transform=\"matrix(0.55502525,0,0,0.55502525,144.49747,1041.5871)\"\n       id=\"path2832\"\n       style=\"fill:none;stroke:#000000;stroke-width:2.70257974\" />\n  </g>\n</svg>\n");
INSERT INTO `wp_464683_postmeta` VALUES("551", "370", "_wp_attached_file", "2019/11/SciAm_Wavy_Text_Divider.svg");
INSERT INTO `wp_464683_postmeta` VALUES("552", "370", "_wp_attachment_metadata", "a:2:{s:5:\"width\";d:150;s:6:\"height\";d:8;}");
INSERT INTO `wp_464683_postmeta` VALUES("553", "370", "_elementor_inline_svg", "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>\n<!-- Created with Inkscape (http://www.inkscape.org/) -->\n\n<svg\n   xmlns:dc=\"http://purl.org/dc/elements/1.1/\"\n   xmlns:cc=\"http://creativecommons.org/ns#\"\n   xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\"\n   xmlns:svg=\"http://www.w3.org/2000/svg\"\n   xmlns=\"http://www.w3.org/2000/svg\"\n   xmlns:sodipodi=\"http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd\"\n   xmlns:inkscape=\"http://www.inkscape.org/namespaces/inkscape\"\n   width=\"150\"\n   height=\"8\"\n   id=\"svg4192\"\n   version=\"1.1\"\n   inkscape:version=\"0.48.3.1 r9886\"\n   sodipodi:docname=\"New document 9\">\n  <defs\n     id=\"defs4194\" />\n  <sodipodi:namedview\n     id=\"base\"\n     pagecolor=\"#ffffff\"\n     bordercolor=\"#666666\"\n     borderopacity=\"1.0\"\n     inkscape:pageopacity=\"0.0\"\n     inkscape:pageshadow=\"2\"\n     inkscape:zoom=\"1.4142136\"\n     inkscape:cx=\"50.572791\"\n     inkscape:cy=\"1.7890872\"\n     inkscape:document-units=\"px\"\n     inkscape:current-layer=\"layer1\"\n     showgrid=\"false\"\n     fit-margin-top=\"0\"\n     fit-margin-left=\"0\"\n     fit-margin-right=\"0\"\n     fit-margin-bottom=\"0\"\n     inkscape:window-width=\"1450\"\n     inkscape:window-height=\"876\"\n     inkscape:window-x=\"150\"\n     inkscape:window-y=\"0\"\n     inkscape:window-maximized=\"1\">\n    <inkscape:grid\n       type=\"xygrid\"\n       id=\"grid4209\"\n       empspacing=\"5\"\n       visible=\"true\"\n       enabled=\"true\"\n       snapvisiblegridlinesonly=\"true\" />\n  </sodipodi:namedview>\n  <metadata\n     id=\"metadata4197\">\n    <rdf:RDF>\n      <cc:Work\n         rdf:about=\"\">\n        <dc:format>image/svg+xml</dc:format>\n        <dc:type\n           rdf:resource=\"http://purl.org/dc/dcmitype/StillImage\" />\n        <dc:title></dc:title>\n      </cc:Work>\n    </rdf:RDF>\n  </metadata>\n  <g\n     inkscape:label=\"Layer 1\"\n     inkscape:groupmode=\"layer\"\n     id=\"layer1\"\n     transform=\"translate(-339.88865,-333.39203)\">\n    <path\n       id=\"path4173\"\n       style=\"fill:#000000;fill-opacity:1;stroke:none\"\n       d=\"m 487.08078,337.09131 c -0.7256,-0.0553 -1.45245,0.35429 -2.17827,0.15539 -0.7258,-0.19895 -1.44967,-0.37399 -2.17483,-0.0953 -0.72515,0.27865 -1.4509,0.12605 -2.17682,-0.1657 -0.72593,-0.29179 -1.45077,0.20144 -2.17614,0.32979 -0.72535,0.12844 -1.45186,-0.60329 -2.17739,-0.60526 -0.72557,-0.001 -1.45011,0.71978 -2.1759,0.53132 -0.72578,-0.18843 -1.45222,-0.856 -2.17738,-0.58697 -0.72517,0.26914 -1.45001,0.76315 -2.17608,0.37562 -0.72606,-0.38745 -1.45214,-0.79163 -2.1771,-0.38732 -0.72501,0.40427 -1.45015,0.68838 -2.17633,0.20996 -0.72618,-0.47832 -1.45212,-0.78111 -2.17702,-0.31432 -0.72488,0.46684 -1.44997,0.78952 -2.17622,0.27478 -0.72622,-0.51468 -1.45242,-1.01144 -2.17733,-0.55244 -0.72493,0.45896 -1.44954,1.12537 -2.17563,0.70332 -0.7261,-0.42206 -1.45292,-1.36392 -2.17815,-1.13995 -0.72522,0.22398 -1.44925,1.31501 -2.1748,1.31988 -0.72552,0.005 -1.45259,-1.12609 -2.17863,-1.51002 -0.72606,-0.38395 -1.45055,0.3881 -2.17517,1.04116 -0.72466,0.65304 -1.45036,0.53346 -2.17692,-0.23453 -0.72657,-0.76799 -1.45317,-1.54329 -2.17815,-1.13723 -0.72496,0.40608 -1.44876,1.67565 -2.17399,1.90851 -0.7252,0.23289 -1.45206,-0.74134 -2.17876,-1.60027 -0.7267,-0.85895 -1.45258,-1.11134 -2.17714,-0.40738 -0.72458,0.70397 -1.44837,1.99297 -2.17363,2.17952 -0.72527,0.18652 -1.45217,-0.80994 -2.17906,-1.82367 -0.72692,-1.0138 -1.45334,-1.67325 -2.17826,-1.2161 -0.72491,0.45716 -1.44853,1.86459 -2.17292,2.68808 -0.72443,0.82348 -1.44992,0.8494 -2.17659,0.011 -0.72667,-0.83896 -1.45425,-2.34456 -2.18082,-3.11804 -0.72658,-0.77343 -1.45201,-0.6939 -2.17637,0.16544 -0.72436,0.85937 -1.44787,2.34991 -2.17216,3.26664 -0.72427,0.91669 -1.44948,1.16397 -2.17585,0.54954 -0.72634,-0.61443 -1.45379,-2.0104 -2.18103,-3.27783 0,0 0.53091,1.8303 1.27388,3.0675 0.74295,1.23724 1.48772,2.60298 2.22146,3.18718 0.73373,0.58421 1.45531,0.30666 2.16742,-0.64038 0.71212,-0.94704 1.41612,-2.46797 2.12905,-3.35765 0.71293,-0.8897 1.43685,-0.99948 2.17284,-0.25624 0.73597,0.74324 1.48229,2.2187 2.2192,3.02743 0.73691,0.80873 1.4616,0.7525 2.17504,-0.10132 0.71341,-0.85376 1.41861,-2.29159 2.1372,-2.77901 0.7186,-0.48749 1.45298,0.14178 2.19237,1.12533 0.73937,0.98352 1.47849,1.94975 2.20093,1.73293 0.72241,-0.21685 1.42927,-1.53617 2.14439,-2.27045 0.71512,-0.73426 1.44373,-0.51212 2.18092,0.31657 0.7372,0.82873 1.47603,1.77267 2.19777,1.50958 0.72179,-0.26311 1.42891,-1.56308 2.14824,-1.99946 0.71934,-0.43635 1.45534,0.30872 2.19123,1.04647 0.7359,0.73777 1.46265,0.82708 2.17849,0.14378 0.71583,-0.68337 1.43,-1.48572 2.16049,-1.13202 0.73046,0.35369 1.47149,1.45437 2.19649,1.41928 0.725,-0.0349 1.43464,-1.15654 2.15654,-1.41078 0.7219,-0.25422 1.46025,0.65739 2.19128,1.04919 0.73101,0.39179 1.44666,-0.30487 2.16523,-0.79419 0.71858,-0.4893 1.45067,-0.0228 2.18298,0.46166 0.73233,0.4845 1.45283,0.13155 2.17129,-0.3656 0.71848,-0.4971 1.4478,-0.22468 2.17963,0.2235 0.73182,0.44816 1.45287,0.13381 2.1722,-0.30091 0.71935,-0.43461 1.45012,-0.0607 2.18065,0.29657 0.73054,0.35725 1.44861,-0.16717 2.16988,-0.46649 0.72127,-0.29933 1.45574,0.33801 2.18348,0.49621 0.7277,0.15806 1.44259,-0.59317 2.16767,-0.62221 0.72507,-0.03 1.46047,0.67314 2.18371,0.51446 0.72325,-0.15866 1.44137,-0.68212 2.17052,-0.42061 0.72918,0.26152 1.45639,0.38382 2.17752,0.0748 0.72111,-0.30895 1.07619,-0.01 1.80405,0.15806 0.72788,0.16858 1.81962,-0.42488 2.54545,-0.39975 0.72585,0.0252 1.54922,0.22967 1.54922,0.26334 -1.35607,0.20835 -2.08225,-0.27842 -2.80788,-0.33382 z\"\n       inkscape:connector-curvature=\"0\"\n       sodipodi:nodetypes=\"cccscccccccccccccssssccsscccccsssccssssscsscssscscscscsscsccscccccscccc\" />\n    <path\n       sodipodi:nodetypes=\"cccscccccccccccccssssccsscccccsssccssssscsscssscscscscsscsccscccccscccc\"\n       inkscape:connector-curvature=\"0\"\n       d=\"m 342.69652,337.69283 c 0.72561,0.0553 1.45245,-0.35427 2.17827,-0.15538 0.7258,0.19895 1.44967,0.37399 2.17484,0.0953 0.72514,-0.27866 1.45089,-0.12605 2.17681,0.1657 0.72594,0.29178 1.45077,-0.20145 2.17614,-0.32979 0.72535,-0.12844 1.45187,0.60328 2.17739,0.60526 0.72557,0.001 1.4501,-0.71978 2.1759,-0.53133 0.72578,0.18844 1.45222,0.856 2.17738,0.58698 0.72517,-0.26914 1.45001,-0.76315 2.17608,-0.37562 0.72606,0.38745 1.45214,0.79162 2.1771,0.38731 0.72501,-0.40427 1.45015,-0.68837 2.17633,-0.20997 0.72619,0.47832 1.45212,0.78112 2.17702,0.31433 0.72488,-0.46683 1.44997,-0.7895 2.17622,-0.27477 0.72621,0.51469 1.45242,1.01144 2.17734,0.55243 0.72492,-0.45895 1.44953,-1.12536 2.17563,-0.70332 0.72609,0.42207 1.45291,1.36393 2.17815,1.13997 0.72521,-0.22399 1.44925,-1.31502 2.17479,-1.31989 0.72553,-0.005 1.4526,1.12609 2.17863,1.51002 0.72606,0.38394 1.45055,-0.3881 2.17517,-1.04116 0.72466,-0.65305 1.45036,-0.53345 2.17693,0.23454 0.72656,0.76799 1.45316,1.54328 2.17814,1.13722 0.72496,-0.40608 1.44876,-1.67565 2.17399,-1.90851 0.7252,-0.23289 1.45206,0.74134 2.17876,1.60027 0.7267,0.85894 1.45258,1.11133 2.17715,0.40738 0.72458,-0.70397 1.44836,-1.99296 2.17363,-2.17951 0.72527,-0.18653 1.45216,0.80993 2.17906,1.82366 0.72691,1.0138 1.45333,1.67325 2.17825,1.2161 0.72491,-0.45716 1.44854,-1.86461 2.17293,-2.68808 0.72442,-0.82347 1.44992,-0.8494 2.17658,-0.011 0.72667,0.83896 1.45425,2.34458 2.18082,3.11806 0.72658,0.77341 1.45201,0.69389 2.17637,-0.16546 0.72436,-0.85935 1.44788,-2.34992 2.17216,-3.26662 0.72427,-0.9167 1.44948,-1.16399 2.17585,-0.54954 0.72634,0.61442 1.45379,2.01039 2.18103,3.27783 0,0 -0.53091,-1.83031 -1.27387,-3.0675 -0.74296,-1.23725 -1.48773,-2.603 -2.22146,-3.18719 -0.73374,-0.5842 -1.45532,-0.30666 -2.16743,0.64038 -0.71211,0.94704 -1.41612,2.46796 -2.12905,3.35766 -0.71293,0.88968 -1.43685,0.99947 -2.17284,0.25624 -0.73597,-0.74326 -1.48229,-2.2187 -2.2192,-3.02744 -0.73691,-0.80873 -1.46159,-0.75251 -2.17504,0.10132 -0.71341,0.85377 -1.41861,2.29161 -2.1372,2.77902 -0.7186,0.48749 -1.45298,-0.14178 -2.19236,-1.12533 -0.73938,-0.98352 -1.4785,-1.94975 -2.20094,-1.73293 -0.72241,0.21685 -1.42927,1.53618 -2.14439,2.27045 -0.7151,0.73426 -1.44373,0.51213 -2.18092,-0.31658 -0.7372,-0.82871 -1.47602,-1.77266 -2.19777,-1.50956 -0.72179,0.2631 -1.4289,1.56308 -2.14824,1.99945 -0.71934,0.43636 -1.45533,-0.30873 -2.19123,-1.04648 -0.7359,-0.73776 -1.46265,-0.82707 -2.17848,-0.14378 -0.71584,0.68337 -1.43001,1.48572 -2.16049,1.13203 -0.73047,-0.35369 -1.4715,-1.45438 -2.1965,-1.41929 -0.72499,0.0349 -1.43464,1.15656 -2.15654,1.41079 -0.72189,0.25422 -1.46025,-0.65739 -2.19128,-1.04918 -0.731,-0.39181 -1.44665,0.30487 -2.16523,0.79417 -0.71858,0.48932 -1.45067,0.0229 -2.18298,-0.46166 -0.73233,-0.48449 -1.45282,-0.13153 -2.17129,0.36561 -0.71848,0.4971 -1.4478,0.22468 -2.17962,-0.2235 -0.73182,-0.44817 -1.45288,-0.13381 -2.1722,0.3009 -0.71936,0.43461 -1.45013,0.0607 -2.18066,-0.29657 -0.73053,-0.35725 -1.44861,0.16718 -2.16988,0.46651 -0.72125,0.29929 -1.45574,-0.33803 -2.18348,-0.49622 -0.72769,-0.15806 -1.44259,0.59317 -2.16767,0.6222 -0.72507,0.03 -1.46046,-0.67314 -2.18371,-0.51446 -0.72325,0.15865 -1.44137,0.68212 -2.17052,0.42063 -0.72918,-0.26153 -1.45639,-0.38383 -2.17751,-0.0749 -0.72112,0.30897 -1.07619,0.0108 -1.80406,-0.15804 -0.72788,-0.16857 -1.81961,0.42489 -2.54545,0.39976 -0.72584,-0.0252 -1.54922,-0.22972 -1.54922,-0.26334 1.35608,-0.20838 2.08226,0.27841 2.80788,0.33381 z\"\n       style=\"fill:#000000;fill-opacity:1;stroke:none\"\n       id=\"path4178\" />\n  </g>\n</svg>\n");
INSERT INTO `wp_464683_postmeta` VALUES("554", "371", "_wp_attached_file", "2019/11/decorative-2773445.svg");
INSERT INTO `wp_464683_postmeta` VALUES("555", "371", "_wp_attachment_metadata", "a:2:{s:5:\"width\";d:2634.0489999999999781721271574497222900390625;s:6:\"height\";d:647.587999999999965439201332628726959228515625;}");
INSERT INTO `wp_464683_postmeta` VALUES("556", "371", "_elementor_inline_svg", "<?xml version=\'1.0\' encoding=\'utf-8\'?>\n<svg xmlns=\"http://www.w3.org/2000/svg\" version=\"1.1\" id=\"Layer_1\" x=\"0px\" y=\"0px\" viewBox=\"0 0 2634.049 647.588\" enable-background=\"new 0 0 2634.049 647.588\"> <g> <path d=\"M1317.025,378.586c98.151,54.688,188.788,108.698,251.794,108.698c134.13,0,157.779-116.158,157.779-152.743 c0-36.556-52.36-229.478-313.388-229.478c-36.075,0-68.111,4.988-96.184,13.696c-28.073-8.708-60.109-13.696-96.184-13.696 c-261.028,0-313.388,192.922-313.388,229.478c0,36.584,23.649,152.743,157.779,152.743 C1128.237,487.285,1218.874,433.274,1317.025,378.586z M1317.025,407.774c138.403-38.462,337.391-238.41,558.721-249.267 c109.727-5.364,120.481,105.417,60.247,100.027c0,0,5.391,52.687,60.233,52.687c54.869,0,80.685-80.658,19.369-143.058 c0,0,103.251,57.379,103.251,148.463c0,77.435-19.342,55.898-19.342,113.279c0,41.617,48.038,37.297,48.038,16.502 c0,0,18.643,12.194,27.971-2.141c0,0-19.37,94.664-104.692,94.664c-56.667,0-65.994-58.107-65.994-58.107 s7.915,18.641,34.444,18.641c58.08,0,69.562-126.941-34.444-126.941c-125.473,0-121.892,240.26,53.8,240.26 c164.924,0,234.505-233.045,63.826-410.918c0,0,69.548,53.058,93.937,86.776c24.389,33.703,71.701,83.183,110.432,42.318 c0,0,12.902,7.174,35.131,7.174s35.13-30.849,17.208-48.752c0,0,19.362,5.008,48.772,5.008 c220.877,0,210.829-259.588,53.799-259.588c-37.29,0-83.93,16.502-83.93,74.582c0,26.502,11.489,39.437,11.489,39.437 s1.07-13.978,21.503-13.978c48.409,0,65.61,111.852-86.05,111.852c-74.239,0-119.382-33.334-119.382-33.334 s43.032,6.05,44.101-21.536c0.699-18.641-11.837-23.662-11.837-23.662s47.688-5.721,47.688-53.759 c0-62.401-97.538-61.701-97.538-7.901c0,28.683,24.391,29.383,24.391,29.383s-17.943,10.796-39.451,10.796 c-93.211,0-132.662-65.296-294.719-65.296c-178.88,0-395.141,150.655-580.971,251.269 c-185.83-100.614-402.09-251.269-580.971-251.269c-162.057,0-201.509,65.296-294.719,65.296c-21.508,0-39.451-10.796-39.451-10.796 s24.391-0.7,24.391-29.383c0-53.8-97.538-54.499-97.538,7.901c0,48.038,47.688,53.759,47.688,53.759s-12.537,5.02-11.837,23.662 c1.069,27.586,44.101,21.536,44.101,21.536s-45.143,33.334-119.382,33.334c-151.66,0-134.458-111.852-86.05-111.852 c20.432,0,21.503,13.978,21.503,13.978s11.489-12.936,11.489-39.437c0-58.08-46.64-74.582-83.93-74.582 c-157.03,0-167.079,259.588,53.799,259.588c29.411,0,48.773-5.008,48.773-5.008c-17.922,17.902-5.02,48.752,17.208,48.752 s35.131-7.174,35.131-7.174c38.731,40.864,86.043-8.615,110.432-42.318c24.389-33.717,93.937-86.776,93.937-86.776 c-170.679,177.874-101.098,410.918,63.826,410.918c175.692,0,179.273-240.26,53.8-240.26c-104.005,0-92.524,126.941-34.444,126.941 c26.528,0,34.444-18.641,34.444-18.641s-9.327,58.107-65.994,58.107c-85.322,0-104.692-94.664-104.692-94.664 c9.328,14.335,27.971,2.141,27.971,2.141c0,20.795,48.038,25.115,48.038-16.502c0-57.38-19.342-35.844-19.342-113.279 c0-91.084,103.251-148.463,103.251-148.463c-61.316,62.399-35.5,143.058,19.369,143.058c54.842,0,60.233-52.687,60.233-52.687 c-60.233,5.39-49.479-105.392,60.247-100.027C979.633,169.364,1178.621,369.312,1317.025,407.774z M1317.025,152.784 c163.113,79.995,329.595,201.497,450.093,201.497c166.736,0,201.166-294.746-32.262-294.746 c-127.436,0-277.46,113.54-417.83,200.271c-140.37-86.731-290.395-200.271-417.83-200.271 c-233.428,0-198.998,294.746-32.262,294.746C987.429,354.281,1153.912,232.779,1317.025,152.784z M1317.025,234.681 c177.002,90.486,393.473,223.92,577.363,223.92c186.474,0,203.676-248.133-11.454-248.133 c-198.922,0-408.068,206.368-565.91,252.137c-157.841-45.769-366.988-252.137-565.91-252.137 c-215.13,0-197.928,248.133-11.454,248.133C923.552,458.601,1140.022,325.168,1317.025,234.681z M1317.025,56.926 c31.089-7.324,65.742-11.383,104.099-11.383c476.158,0,423.071,507.722,195.034,507.722c-164.924,0-50.193-240.96,166.378-240.96 c166.364,0,143.429,195.075,1.427,195.075c-124.15,0-286.676-123.123-466.939-213.771 c-180.263,90.648-342.789,213.771-466.939,213.771c-142.001,0-164.937-195.075,1.427-195.075 c216.571,0,331.302,240.96,166.378,240.96c-228.037,0-281.123-507.722,195.034-507.722 C1251.282,45.544,1285.936,49.602,1317.025,56.926z M1317.025,306.156c170.823,89.486,337.204,205.148,465.169,205.148 c152.729,0,189.299-204.363-10.768-204.363c-203.319,0-335.61,251.701-154.898,251.701c252.758,0,288.286-519.56-197.914-519.56 c-37.246,0-71.075,3.93-101.589,11.044c-30.514-7.114-64.343-11.044-101.589-11.044c-486.2,0-450.672,519.56-197.914,519.56 c180.713,0,48.422-251.701-154.898-251.701c-200.067,0-163.497,204.363-10.768,204.363 C979.82,511.304,1146.202,395.642,1317.025,306.156z M1317.025,467.745c164.961-43.898,369.494-252.242,561.973-252.242 c215.143,0,185.006,238.819,9.684,238.819c-170.921,0-387.068-140.634-571.656-231.731 c-184.589,91.097-400.735,231.731-571.656,231.731c-175.323,0-205.46-238.819,9.684-238.819 C947.53,215.502,1152.064,423.846,1317.025,467.745z M1317.025,268.602c143.347-87.41,294.677-204.774,418.899-204.774 c219.438,0,182.853,287.215,30.124,287.215c-103.637,0-276.07-126.558-449.024-206.723 c-172.954,80.165-345.387,206.723-449.024,206.723c-152.729,0-189.313-287.215,30.124-287.215 C1022.347,63.828,1173.678,181.192,1317.025,268.602z M1317.025,337.633c187.169-100.825,404.205-252.638,586.69-252.638 c124.061,0,212.277,65.967,272.51,65.967c73.155,0,70.261-22.237,70.261-22.237s-35.844,13.622-35.844-21.508 c0-49.492,88.21-50.191,88.21,7.188c0,42.318-43.738,50.179-43.738,50.179s-29.409-5.72-28.682,1.44 c0.712,7.161,25.829,1.441,25.829,1.441s12.895-7.161,12.895,22.222c0,29.397-43.032,21.536-43.032,21.536 s-31.193-24.76-36.57-16.159c-5.391,8.601,27.97,17.201,27.97,17.201s47.338,37.641,145.198,37.641 c80.699,0,109.739-44.101,109.739-78.518c0-34.404-21.529-46.241-38.738-46.241c-17.201,0-18.292,11.837-18.292,11.837 s-9.678-9.67-9.678-29.039c0-103.279,187.188-94.678,187.188,37.639c0,160.261-183.95,150.618-212.99,140.92 c-10.418-3.457-36.577-13.978-36.577-10.741c0,3.21,4.28,11.824,29.04,11.824c17.208,0,25.809,45.158-16.133,45.158 c-29.06,0-16.138-7.518-26.878-7.518c-8.629,0-19.39,16.118-36.599,16.118c-33.334,0-98.944-98.944-169.958-146.283 c-11.455-7.64-48.382-43.018-51.619-30.11c-3.224,12.895,43.018,30.11,43.018,30.11c75.308,71.001,105.719,164.581,106.487,220.521 c1.097,77.421-54.842,191.468-159.19,191.468c-175.335,0-173.168-231.276-50.548-231.276c94.65,0,81.741,116.187,31.207,116.187 c-32.278,0-37.669-29.04-37.669-29.04s-11.839,75.281,71.001,79.602c79.507,4.102,97.888-66.721,112.949-119.423 c15.048-52.717-19.369-67.737-10.768-48.395c8.601,19.355,12.909,68.847-6.46,71.014c-19.369,2.141-22.58-11.837-22.58-11.837 c0,30.082-43.03,33.319-43.03-5.391c0-38.711,24.348-37.71,21.522-114.019c-3.224-87.147-97.901-146.31-116.173-155.967 c-18.3-9.685-58.094-36.598-57.01-23.663c1.07,12.881,52.716,26.899,52.716,26.899c69.904,50.521,38.711,152.73-8.627,145.198 c-47.312-7.53-51.619-43.018-51.619-43.018c67.778,3.211,51.619-111.878-68.848-109.739 c-221.699,3.96-425.338,206.504-556.581,248.473c-131.244-41.969-334.882-244.514-556.582-248.473 c-120.467-2.139-136.626,112.95-68.848,109.739c0,0-4.307,35.487-51.618,43.018c-47.339,7.532-78.532-94.677-8.627-145.198 c0,0,51.645-14.019,52.716-26.899c1.084-12.936-38.71,13.978-57.01,23.663c-18.272,9.657-112.949,68.82-116.172,155.967 c-2.826,76.31,21.522,75.308,21.522,114.019c0,38.71-43.03,35.473-43.03,5.391c0,0-3.211,13.978-22.58,11.837 c-19.369-2.167-15.061-51.659-6.46-71.014c8.601-19.342-25.816-4.322-10.768,48.395c15.061,52.701,33.442,123.525,112.949,119.423 c82.84-4.321,71.001-79.602,71.001-79.602s-5.391,29.04-37.669,29.04c-50.534,0-63.443-116.187,31.207-116.187 c122.62,0,124.787,231.276-50.548,231.276c-104.348,0-160.287-114.047-159.19-191.468c0.768-55.939,31.179-149.519,106.487-220.521 c0,0,46.241-17.216,43.018-30.11c-3.236-12.907-40.163,22.47-51.618,30.11c-71.014,47.338-136.624,146.283-169.958,146.283 c-17.208,0-27.97-16.118-36.598-16.118c-10.74,0,2.181,7.518-26.878,7.518c-41.942,0-33.341-45.158-16.133-45.158 c24.76,0,29.04-8.615,29.04-11.824c0-3.236-26.159,7.285-36.577,10.741c-29.04,9.698-212.99,19.341-212.99-140.92 c0-132.318,187.188-140.918,187.188-37.639c0,19.369-9.678,29.039-9.678,29.039s-1.09-11.837-18.292-11.837 c-17.209,0-38.738,11.837-38.738,46.241c0,34.417,29.04,78.518,109.739,78.518c97.86,0,145.198-37.641,145.198-37.641 s33.361-8.601,27.97-17.201c-5.377-8.601-36.57,16.159-36.57,16.159s-43.032,7.86-43.032-21.536 c0-29.383,12.895-22.222,12.895-22.222s25.117,5.72,25.829-1.441c0.728-7.16-28.682-1.44-28.682-1.44s-43.738-7.86-43.738-50.179 c0-57.379,88.21-56.679,88.21-7.188c0,35.131-35.844,21.508-35.844,21.508s-2.894,22.237,70.261,22.237 c60.233,0,148.449-65.967,272.51-65.967C912.819,84.995,1129.856,236.808,1317.025,337.633z M1317.025,122.191 c28.319-9.042,60.726-14.246,97.281-14.246c343.128,0,392.62,374.32,153.801,374.32c-57.567,0-149.439-56.237-251.082-111.91 c-101.643,55.674-193.515,111.91-251.082,111.91c-238.819,0-189.327-374.32,153.801-374.32 C1256.299,107.945,1288.705,113.149,1317.025,122.191z\"/> </g> </svg>");
INSERT INTO `wp_464683_postmeta` VALUES("557", "372", "_wp_attached_file", "2019/11/divider-2154993.svg");
INSERT INTO `wp_464683_postmeta` VALUES("558", "372", "_wp_attachment_metadata", "a:2:{s:5:\"width\";d:2654.28499999999985448084771633148193359375;s:6:\"height\";d:189.53100000000000591171556152403354644775390625;}");
INSERT INTO `wp_464683_postmeta` VALUES("559", "372", "_elementor_inline_svg", "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<svg enable-background=\"new 0 0 2654.285 189.531\" version=\"1.1\" viewBox=\"0 0 2654.285 189.531\" xmlns=\"http://www.w3.org/2000/svg\">\n <path d=\"m684.81 45.133c34.229-7.489 106.37 0.096 158.84-2.184 25.117-1.092 50.189-4.697 75.329-0.704 62.716 9.962 76.678 35.174 99.705 37.477 8.291-42.721 21.754-36.894 37.88-36.553 18.415 0.802 26.35 23.585 22.617 39.124-18.983 11.997-5.337-7.578-20.654-23.723-33.763-1.743-23.725 28.405-17.834 34.396 23.365 23.764 86.471 40.525 99.346-4.258-7.355 0.802-14.793 4.037-22.203 2.378-52.151-35.806 51.183-86.14 50.018 6.442-0.142 11.298 84.307-94.179 150.44-44.998 23.977 17.83 25.482-25.406 84.278-8.365 45.567 13.207 66.264 45.508 86.427 50.349 2.238-19.024 0.832-39.235 26.82-48.553 41.669-8.455 59.624 58.376-0.166 40.258-1.828 30.916 45.73 46.817 82.009 23.253 8.212-5.364 18.691-9.511 22.341-19.438 5.253-10.949 1.576-27.733-10.977-31.604-9.65-1.051-10.507 11.779-16.424 16.894-4.507 0.221-10.922 0.636-12.94-4.452-0.513-20.284 22.726-33.084 40.534-25.615 24.106 10.111 13.593 31.15 20.627 40.103 1.597 2.033 45.918-21.374 50.912-23.341 95.042-37.432 259.04-18.215 355.84 16.65 17.585 8.018 37.023 12.608 56.433 12.028 11.982 0.964 1.955-23.56-18.608-21.622-7.825 0.636-15.511 2.184-23.281 2.903 0.636-3.373 1.493-6.691 2.544-9.954 11.834-6.995 26.848-4.396 39.511-1.134 12.691 3.622 16.977 16.728 23.309 26.737 33.823 7.087 28.068-29.343 58.914-11.894 33.701 19.063 413.36 6.431 416.12 7.398 8.439 2.95 2.808 13.223 2.443 19.371 0.166-2.795-328.31-3.692-373.35-3.041-35.114 0.507-35.708 7.006-49.084 15.197-23.203 14.208-42.216-28.904-60.63-8.809-32.227 35.167-94.755 24.781-136.94 2.131-16.733-8.984-34.837-18.681-54.338-19.412 0.951 16.785 8.42 35.522-8.56 47.336-27.132 18.877-50.946-18.338-28.865-42.053 3.959-4.252 11.435-6.225 11.268-12.997-35.034-38.529-99.037-11.592-110.07 5.642 54.964-4.548 60.085 61.85 7.503 55.016-15.423-2.005-13.546-15.589-1.532-14.174 3.668 0.432 7.249 1.926 10.926 1.583 8.475-0.791 13.101-11.919 9.48-19.621-17.901-38.079-88.205 31.727-217.46 39.911-47.052 2.979-40.857-1.284-71.255-11.204-54.106-16.415-121.08-110.67-177.9-78.525-3.871 2.35-3.899 7.355-5.253 11.198 1.128-3.199 35.137 23.534 37.708 26.698 10.361 12.75 19.79 23.726 38.172 22.567-12.285-34.566 11.74-37.162 21.155-32.684 30.451 14.483 8.814 87.828-79.837 42.755-31.997 11.61-19.55 23.71-66.359-0.664-82.402 48.732-107.61-20.542-81.354-39.249 9.629-6.86 29.092-4.207 28.394 15.308-0.114 3.182-3.619 9.924-2.837 12.569 1.776 5.979 18.783 9.939 38.069-21.585 8.812-14.404 16.96-21.457 34.013-23.449-0.604-4.935 1.872-10.318-25.998-16.57-34.786-7.803-60.6 11.688-83.494 29.814-88.05 77.738-132.15 75.104-249.35 38.215-27.898-8.781-54.848-21.556-83.662-27.045-28.594-4.24-40.137 20.004-35.085 27.438 7.941 11.683 28.846-10.661 32.54 2.706 2.849 10.31-21.554 26.645-41.476 12.121-14.946-10.897-14.471-32.045 3.48-43.619 15.965-10.293 33.583-6.145 32.275-14.158-0.377-2.31-2.878-3.53-5.061-4.377-23.393-9.071-56.678-27.929-95.862 9.245-1.134 6.138 4.452 10.645 6.581 15.926 15.346 31.766-15.686 49.136-31.023 39.622-15.816-12.525-15.871-37.576-2.323-51.843-36.003-8.272-39.607 6.125-95.45 26.278-96.493 34.823-104.7-8.109-111.12-15.55-14.35-1.327-29.253 3.512-39.954 13.189-4.894 3.76-10.286 10.286-17.198 7.217-5.641-5.751-9.014-14.986-18.111-16.009-34.547-3.885-401.6 1.454-406.63-3.665-33.817-34.494 381-8.128 411.58-17.736 11.222-3.524 12.415-29.164 32.322-10.133 8.655 8.275 19.091 9.631 30.142 13.314 1.184 0.395 14.711-16.97 16.723-19.012 31.804-32.272 46.162-7.309 33.991 1.043-3.15 2.162-7.062 2.79-10.768 3.722-8.027 2.018-8.79 4.979-10.417 12.201 41.951-1.581 61.856-26.068 132.14-40.147m-80.682 41.336c-16.313 6.138-34.12 6.912-50.239 13.521-1.604 7.272 8.433 7.88 13.161 10.341 29.198 7.023 57.345-7.88 83.281-19.41 19.659-7.327 39.76-14.267 60.636-17.005 12.912 0.138 25.493 5.06 38.544 4.12 8.35-3.954 16.092-9.069 24.442-13.023 0.028-3.069 0.055-6.138 0.055-9.207-19.88-0.47-39.788 0.028-59.64 0.415-37.853 5.308-74.489 17.059-110.24 30.248m253.24-30.663c0.359 1.548 1.078 4.673 1.41 6.221 10.977 1.825 21.677 4.977 31.908 9.346 42.387 15.788 81.566 39.373 125.12 52.092 25.133 9.207 51.981 14.433 78.746 10.313 8.267-1.88 19.078-1.078 24-9.401-10.645-0.47-21.041 2.184-31.576 2.71-23.64-2.599-43.714-16.23-64.258-26.958-15.124-6.525-28.451-16.507-43.742-22.645-37.548-17.918-80.101-26.545-121.6-21.678m838.14 18.94c-22.258 7.935-42.774 19.769-63.649 30.608-14.461 9.705-30.249 17.115-46.811 22.452-0.055 1.106-0.166 3.346-0.221 4.452 10.535 3.982 22.12 3.097 32.931 0.802 22.23-5.419 44.848-10.452 65.336-21.069 38.267-15.539 75.179-34.313 113.75-49.106 0.111-1.825 0.332-5.475 0.442-7.3-34.867-2.544-70.203 4.258-101.78 19.161m209.45-18.774c0.415 13.604 15.484 21.981 27.981 20.903 41.613 1.714 78.442 22.894 117.46 34.811 17.004 5.502 36.581 5.226 52.009-4.617-1.825-2.765-2.876-7.189-6.885-7.3-13.88-2.765-28.23-3.373-41.723-7.825-27.069-9.539-53.889-20.046-82.119-25.825-21.651-6.691-44.323-7.935-66.719-10.147m257.17 42.331c5.226 0.995 11.806 5.253 16.424 0.442 6.194-3.594-0.276-12.138-5.309-12.691-6.829-0.58-9.401 7.079-11.115 12.249m-1682.2-8.765c-0.829 0.636-2.516 1.853-3.346 2.461-4.673 12.415 17.475 13.244 18.083 2.295-3.788-3.816-9.263-7.161-14.737-4.756m1420.9 13.742c-0.857 5.723-0.083 11.502 0.442 17.226 3.401-0.332 7.3 0.94 10.424-0.94 7.051-5.917 3.871-16.092 4.369-24.055-6.194-0.277-12.055 2.35-15.235 7.769m-1155.3-3.124c-0.912 7.88 0.332 15.733 2.267 23.364 3.124-0.138 6.249-0.276 9.401-0.442 0.829-8.738 0.885-24.609-11.668-22.922z\"/>\n <path d=\"m1177.5 84.665c0.57 0.57 0.57 0.57 0 0z\"/>\n</svg>\n");
INSERT INTO `wp_464683_postmeta` VALUES("560", "373", "_wp_attached_file", "2019/11/dividers-2341200.svg");
INSERT INTO `wp_464683_postmeta` VALUES("561", "373", "_wp_attachment_metadata", "a:2:{s:5:\"width\";d:3500;s:6:\"height\";d:2900;}");
INSERT INTO `wp_464683_postmeta` VALUES("562", "373", "_elementor_inline_svg", "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<svg version=\"1.1\" viewBox=\"0 0 3500 2900\" xmlns=\"http://www.w3.org/2000/svg\">\n <g transform=\"translate(0 1847.6)\">\n  <g transform=\"translate(349.56 70.291)\" fill-rule=\"evenodd\">\n   <g transform=\"translate(-494.37 111.61)\">\n    <path d=\"m232.15 552.36c-9e-3 -8e-3 -0.0127-0.0224-0.0107-0.0432 6e-3 -0.025 0.019-0.0585 0.0396-0.1004 0.0411-0.0837 0.11162-0.20069 0.21175-0.351v-1e-5c0.19989-0.30007 0.51466-0.72836 0.94876-1.2873 0.8663-1.1154 2.1682-2.7021 3.9574-4.7924 3.5364-4.1316 8.7036-9.9218 15.825-17.47 13.505-14.314 33.575-34.489 60.66-58.588 24.981-22.227 56.632-48.384 94.337-75.09 34.562-24.48 75.565-50.379 122.04-73.548 42.442-21.161 90.886-40.727 143.8-53.909 49.277-12.276 103.47-19.087 159.61-16.028 55.924 3.0591 113.59 16.141 169.15 40.217 61.666 26.742 119.34 66.021 172.04 114.52 53.184 48.931 116.13 89.935 185.93 120.04 6.7274 2.9022 13.513 5.7031 20.353 8.4034 62.15 24.534 126.67 39.905 190.36 48.225 75.531 9.8653 150.29 9.9818 221.39 3.9688 76.865-6.5036 149.99-20.203 217.71-37.939v-2e-5c73.04-19.134 139.65-42.895 199.58-69.009 64.727-28.206 119.63-58.125 167.04-89.185 25.042-16.408 47.086-32.577 66.822-48.744 21.089-17.277 38.492-33.66 53.319-49.688 16.951-18.328 28.988-34.48 38.097-49.27 9.0569-14.712 14.144-26.365 17.314-34.813 3.1022-8.2666 4.1543-12.741 4.4743-12.663 0.1522 0.037-0.4327 4.6278-3.1203 13.131-2.7316 8.6415-7.4982 20.711-16.26 35.786-8.8108 15.166-20.688 31.823-37.475 50.586-14.688 16.422-32.031 33.234-53.056 50.9-19.681 16.538-41.718 33.085-66.758 49.845-47.388 31.718-102.44 62.302-167.34 91.075-60.107 26.654-127 50.921-200.42 70.486 0-1e-5 -1e-4 2e-5 -1e-4 2e-5 -68.067 18.142-141.66 32.186-219.12 38.944-71.655 6.2541-147.11 6.2686-223.48-3.6065-64.402-8.3253-129.73-23.859-192.75-48.732-6.9366-2.7375-13.818-5.5775-20.643-8.5207-70.828-30.553-134.67-72.227-188.63-121.99-51.976-47.93-108.64-86.745-169.13-113.14-54.453-23.775-111.03-36.824-165.9-40.045-55.106-3.246-108.51 3.2102-157.19 15.035-52.297 12.703-100.38 31.756-142.62 52.404-46.252 22.611-87.231 47.973-121.86 71.941-37.778 26.145-69.658 51.781-94.91 73.5-27.396 23.564-47.839 43.206-61.795 57.028-7.4747 7.4034-12.646 12.703-16.563 16.7-1.8899 1.9285-3.3898 3.4541-4.3628 4.41-0.50201 0.49314-0.89078 0.86185-1.16 1.0967-0.13572 0.11839-0.24234 0.20393-0.3194 0.25585-0.0387 0.0261-0.07 0.0437-0.0939 0.0529-0.0203 5e-3 -0.0351 3e-3 -0.0443-5e-3z\"/>\n    <path d=\"m317.25 307.15c0.30801-0.0439 1.8218 8.4219 4.4326 24.652 2.6712 14.566 6.9561 36.164 13.884 62.608 6.1336 23.414 14.8 52.39 27.107 83.35 10.689 26.884 24.881 57.29 44.034 86.805 16.465 25.361 37.605 51.607 64.502 73.017 12.36 9.8457 26.071 18.768 40.991 26.043 14.719 7.1801 30.67 12.771 47.45 16.333 17.471 3.7121 35.79 5.2138 54.501 4.5662 20.513-0.70842 41.311-3.9826 62.179-9.3505 23.664-6.088 47.089-14.781 70.423-25.49 26.819-12.31 53.059-27.086 79.156-43.85 49.996-32.121 100.67-67.052 152.3-105.09 41.454-30.539 82.493-62.353 124.95-95.941 33.271-26.325 68.722-54.877 103.68-81.606 28.127-21.515 57.432-43.124 88.585-62.08 24.742-15.076 51.257-28.764 79.87-37.233 12.524-3.6984 25.474-6.324 38.651-7.4802 0 1e-5 1e-4 -2e-5 1e-4 -2e-5 12.836-1.1222 25.841-0.81422 38.69 0.99344 0.8991 0.12686 1.7971 0.26092 2.6939 0.40209 12.546 1.9749 24.799 5.3302 36.562 9.7554 14.169 5.3316 27.643 12.156 40.406 19.875 32.604 19.734 61.168 44.972 87.26 71.117 33.765 33.807 71.475 62.986 110.03 88.851 45.596 30.577 93.02 56.744 140.37 79.431 53.917 25.832 108.08 47.249 161.32 64.928 59.129 19.632 116.94 34.581 172.93 45.43 61.54 11.921 119.87 18.709 175.21 20.98 61.642 2.5264 117.39-0.61679 168.23-8.3852 60.905-9.31 110.96-24.722 152.11-42.618 44.493-19.349 76.605-40.952 97.009-56.339 20.646-15.569 30.327-25.301 30.776-24.824 0.088 0.0932-9.0676 10.389-29.376 26.626-20.062 16.04-52.014 38.424-96.634 58.543-41.236 18.593-91.629 34.72-152.94 44.62-51.177 8.2664-107.37 11.857-169.45 9.6878-55.746-1.9455-114.52-8.4633-176.49-20.181-56.392-10.661-114.62-25.477-174.18-45.035-53.633-17.611-108.22-39.018-162.59-64.91-47.742-22.735-95.614-49.036-141.72-79.849-38.988-26.048-77.224-55.583-111.62-89.941-25.847-25.795-53.804-50.526-85.41-69.583-12.343-7.4478-25.269-14.002-38.759-19.064-11.188-4.1999-22.787-7.3818-34.598-9.2362-0.8443-0.13256-1.6894-0.25828-2.5352-0.37707-12.08-1.7018-24.331-1.9917-36.426-0.93716l-2e-4 2e-5c-12.426 1.0793-24.725 3.5781-36.696 7.1006-27.412 8.0468-53.155 21.374-77.531 36.148-30.669 18.616-59.712 40.003-87.778 61.403-34.83 26.566-70.333 55.07-103.68 81.35-42.557 33.544-83.77 65.343-125.42 95.859-51.883 38.009-102.83 72.889-153.11 104.93-26.434 16.846-53.093 31.706-80.387 44.094-23.748 10.78-47.679 19.522-71.911 25.634-21.376 5.3934-42.756 8.6306-63.9 9.2511-19.295 0.56489-38.211-1.1072-56.278-5.057-17.355-3.7977-33.814-9.6898-48.982-17.218-15.369-7.6304-29.427-16.92-42.05-27.137-27.447-22.23-48.771-49.14-65.221-75.043-19.144-30.133-33.142-60.979-43.572-88.205-12.018-31.364-20.286-60.59-26.017-84.23-6.48-26.731-10.236-48.437-12.393-63.161-2.0287-16.332-2.9396-24.884-2.6316-24.928z\"/>\n    <path d=\"m178.85 522.2c-0.0948-0.0537 0.76603-2.2344 3.307-6.0249 2.5925-3.8674 6.7368-9.0576 13.504-15.088 6.9418-6.1921 15.719-12.519 27.579-19.128 10.535-5.8726 22.549-11.445 36.84-16.874 13.518-5.1368 28.342-9.8651 45.006-14.237 31.978-8.3888 68.066-14.873 110.3-18.986 39.616-3.8602 83.029-5.4124 130.39-3.6704 85.996 3.1581 185.3 17.054 287.78 51.531 46.693 15.71 94.305 35.907 140.74 61.729 44.149 24.549 87.471 54.382 127.48 90.098 23.194 20.697 48.247 40.333 75.558 56.692 21.348 12.782 44.262 23.677 68.485 30.637 20.137 5.7908 41.285 8.8342 62.456 8.1458 19.512-0.61965 39.054-4.4125 57.817-10.91 19.01-6.5775 37.196-15.877 54.51-26.899 18.325-11.67 35.588-25.22 52.18-39.867 17.61-15.549 34.338-32.254 50.687-49.651 6.147-6.5417 12.228-13.171 18.265-19.877 10.781-11.975 21.358-24.12 31.794-36.278 35.055-40.842 66.677-79.614 101.93-118.62 17.485-19.343 35.267-38.052 53.811-55.861 18.267-17.545 37.156-34.087 57.048-49.158 19.514-14.786 39.904-28.044 61.318-39.11 21.382-11.05 43.692-19.791 66.59-25.64 24.017-6.1289 48.537-8.986 72.716-8.6941 27.3 0.33673 54.092 4.6255 79.535 11.62 46.834 12.864 90.376 31.76 129.45 55.182 38.217 22.918 72.189 50.099 101.91 78.732 30.642 29.522 57.5 61.175 81.048 91.884 24.476 31.916 47.166 65.203 66.988 94.784 22.392 33.413 39.316 59.376 59.693 87.531 9.8693 13.636 19.409 26.13 29.202 37.886 9.9893 11.99 19.786 22.671 29.875 32.295 10.502 10.017 20.863 18.452 31.374 25.479 11.572 7.7373 22.879 13.447 33.733 17.483v1e-5c13.663 5.0832 26.407 7.4188 37.045 8.3477 27.362 2.3936 41.231-2.914 41.506-1.4723-0.1276-0.66844-13.828 5.4662-41.678 3.8072-10.839-0.64734-23.891-2.7275-37.966-7.6552v-1e-5c-11.173-3.9137-22.845-9.5482-34.775-17.263-10.83-7.0036-21.517-15.444-32.303-25.472-10.362-9.6318-20.425-20.331-30.642-32.321-10.018-11.754-19.772-24.249-29.827-37.856-20.679-27.987-38.03-54.082-60.583-87.177-20.02-29.375-42.889-62.428-67.39-93.96-23.586-30.353-50.381-61.582-80.8-90.583-29.498-28.124-63.11-54.774-100.78-77.146-38.501-22.873-81.381-41.293-127.45-53.794-24.818-6.7277-50.855-10.828-77.256-11.07-23.375-0.2203-47.079 2.603-70.271 8.5791-22.124 5.6956-43.741 14.229-64.525 25.012-20.826 10.804-40.723 23.802-59.854 38.335-19.503 14.818-38.077 31.139-56.113 48.497-18.307 17.622-35.906 36.182-53.268 55.419-35.026 38.81-66.53 77.489-101.7 118.48-10.464 12.197-21.092 24.403-31.947 36.46-6.0788 6.7517-12.208 13.433-18.41 20.034-16.492 17.552-33.45 34.469-51.369 50.285-16.881 14.902-34.567 28.755-53.446 40.771-17.843 11.361-36.736 20.98-56.616 27.858-19.653 6.7934-40.172 10.74-60.741 11.38-22.316 0.67798-44.464-2.5255-65.463-8.615-25.219-7.3188-48.872-18.588-70.726-31.759-27.95-16.838-53.434-36.881-76.876-57.923-39.342-35.303-82.029-64.875-125.58-89.286-45.81-25.679-92.865-45.85-139.06-61.623-101.41-34.622-199.93-48.984-285.37-52.754-47.061-2.0742-90.197-0.89871-129.61 2.5549-42.033 3.6859-77.882 9.6956-109.75 17.591-16.599 4.1125-31.346 8.5667-44.824 13.427-14.254 5.1415-26.209 10.4-36.75 15.97-11.875 6.2779-20.631 12.222-27.684 18.094-6.875 5.729-11.125 10.563-13.962 14.218-2.7567 3.5508-3.8958 5.5712-4.0809 5.4664z\"/>\n   </g>\n   <g transform=\"matrix(-1 0 0 1 3301.3 111.61)\">\n    <path d=\"m232.15 552.36c-9e-3 -8e-3 -0.0127-0.0224-0.0107-0.0432 6e-3 -0.025 0.019-0.0585 0.0396-0.1004 0.0411-0.0837 0.11162-0.20069 0.21175-0.351v-1e-5c0.19989-0.30007 0.51466-0.72836 0.94876-1.2873 0.8663-1.1154 2.1682-2.7021 3.9574-4.7924 3.5364-4.1316 8.7036-9.9218 15.825-17.47 13.505-14.314 33.575-34.489 60.66-58.588 24.981-22.227 56.632-48.384 94.337-75.09 34.562-24.48 75.565-50.379 122.04-73.548 42.442-21.161 90.886-40.727 143.8-53.909 49.277-12.276 103.47-19.087 159.61-16.028 55.924 3.0591 113.59 16.141 169.15 40.217 61.666 26.742 119.34 66.021 172.04 114.52 53.184 48.931 116.13 89.935 185.93 120.04 6.7274 2.9022 13.513 5.7031 20.353 8.4034 62.15 24.534 126.67 39.905 190.36 48.225 75.531 9.8653 150.29 9.9818 221.39 3.9688 76.865-6.5036 149.99-20.203 217.71-37.939v-2e-5c73.04-19.134 139.65-42.895 199.58-69.009 64.727-28.206 119.63-58.125 167.04-89.185 25.042-16.408 47.086-32.577 66.822-48.744 21.089-17.277 38.492-33.66 53.319-49.688 16.951-18.328 28.988-34.48 38.097-49.27 9.0569-14.712 14.144-26.365 17.314-34.813 3.1022-8.2666 4.1543-12.741 4.4743-12.663 0.1522 0.037-0.4327 4.6278-3.1203 13.131-2.7316 8.6415-7.4982 20.711-16.26 35.786-8.8108 15.166-20.688 31.823-37.475 50.586-14.688 16.422-32.031 33.234-53.056 50.9-19.681 16.538-41.718 33.085-66.758 49.845-47.388 31.718-102.44 62.302-167.34 91.075-60.107 26.654-127 50.921-200.42 70.486 0-1e-5 -1e-4 2e-5 -1e-4 2e-5 -68.067 18.142-141.66 32.186-219.12 38.944-71.655 6.2541-147.11 6.2686-223.48-3.6065-64.402-8.3253-129.73-23.859-192.75-48.732-6.9366-2.7375-13.818-5.5775-20.643-8.5207-70.828-30.553-134.67-72.227-188.63-121.99-51.976-47.93-108.64-86.745-169.13-113.14-54.453-23.775-111.03-36.824-165.9-40.045-55.106-3.246-108.51 3.2102-157.19 15.035-52.297 12.703-100.38 31.756-142.62 52.404-46.252 22.611-87.231 47.973-121.86 71.941-37.778 26.145-69.658 51.781-94.91 73.5-27.396 23.564-47.839 43.206-61.795 57.028-7.4747 7.4034-12.646 12.703-16.563 16.7-1.8899 1.9285-3.3898 3.4541-4.3628 4.41-0.50201 0.49314-0.89078 0.86185-1.16 1.0967-0.13572 0.11839-0.24234 0.20393-0.3194 0.25585-0.0387 0.0261-0.07 0.0437-0.0939 0.0529-0.0203 5e-3 -0.0351 3e-3 -0.0443-5e-3z\"/>\n    <path d=\"m317.25 307.15c0.30801-0.0439 1.8218 8.4219 4.4326 24.652 2.6712 14.566 6.9561 36.164 13.884 62.608 6.1336 23.414 14.8 52.39 27.107 83.35 10.689 26.884 24.881 57.29 44.034 86.805 16.465 25.361 37.605 51.607 64.502 73.017 12.36 9.8457 26.071 18.768 40.991 26.043 14.719 7.1801 30.67 12.771 47.45 16.333 17.471 3.7121 35.79 5.2138 54.501 4.5662 20.513-0.70842 41.311-3.9826 62.179-9.3505 23.664-6.088 47.089-14.781 70.423-25.49 26.819-12.31 53.059-27.086 79.156-43.85 49.996-32.121 100.67-67.052 152.3-105.09 41.454-30.539 82.493-62.353 124.95-95.941 33.271-26.325 68.722-54.877 103.68-81.606 28.127-21.515 57.432-43.124 88.585-62.08 24.742-15.076 51.257-28.764 79.87-37.233 12.524-3.6984 25.474-6.324 38.651-7.4802 0 1e-5 1e-4 -2e-5 1e-4 -2e-5 12.836-1.1222 25.841-0.81422 38.69 0.99344 0.8991 0.12686 1.7971 0.26092 2.6939 0.40209 12.546 1.9749 24.799 5.3302 36.562 9.7554 14.169 5.3316 27.643 12.156 40.406 19.875 32.604 19.734 61.168 44.972 87.26 71.117 33.765 33.807 71.475 62.986 110.03 88.851 45.596 30.577 93.02 56.744 140.37 79.431 53.917 25.832 108.08 47.249 161.32 64.928 59.129 19.632 116.94 34.581 172.93 45.43 61.54 11.921 119.87 18.709 175.21 20.98 61.642 2.5264 117.39-0.61679 168.23-8.3852 60.905-9.31 110.96-24.722 152.11-42.618 44.493-19.349 76.605-40.952 97.009-56.339 20.646-15.569 30.327-25.301 30.776-24.824 0.088 0.0932-9.0676 10.389-29.376 26.626-20.062 16.04-52.014 38.424-96.634 58.543-41.236 18.593-91.629 34.72-152.94 44.62-51.177 8.2664-107.37 11.857-169.45 9.6878-55.746-1.9455-114.52-8.4633-176.49-20.181-56.392-10.661-114.62-25.477-174.18-45.035-53.633-17.611-108.22-39.018-162.59-64.91-47.742-22.735-95.614-49.036-141.72-79.849-38.988-26.048-77.224-55.583-111.62-89.941-25.847-25.795-53.804-50.526-85.41-69.583-12.343-7.4478-25.269-14.002-38.759-19.064-11.188-4.1999-22.787-7.3818-34.598-9.2362-0.8443-0.13256-1.6894-0.25828-2.5352-0.37707-12.08-1.7018-24.331-1.9917-36.426-0.93716l-2e-4 2e-5c-12.426 1.0793-24.725 3.5781-36.696 7.1006-27.412 8.0468-53.155 21.374-77.531 36.148-30.669 18.616-59.712 40.003-87.778 61.403-34.83 26.566-70.333 55.07-103.68 81.35-42.557 33.544-83.77 65.343-125.42 95.859-51.883 38.009-102.83 72.889-153.11 104.93-26.434 16.846-53.093 31.706-80.387 44.094-23.748 10.78-47.679 19.522-71.911 25.634-21.376 5.3934-42.756 8.6306-63.9 9.2511-19.295 0.56489-38.211-1.1072-56.278-5.057-17.355-3.7977-33.814-9.6898-48.982-17.218-15.369-7.6304-29.427-16.92-42.05-27.137-27.447-22.23-48.771-49.14-65.221-75.043-19.144-30.133-33.142-60.979-43.572-88.205-12.018-31.364-20.286-60.59-26.017-84.23-6.48-26.731-10.236-48.437-12.393-63.161-2.0287-16.332-2.9396-24.884-2.6316-24.928z\"/>\n    <path d=\"m178.85 522.2c-0.0948-0.0537 0.76603-2.2344 3.307-6.0249 2.5925-3.8674 6.7368-9.0576 13.504-15.088 6.9418-6.1921 15.719-12.519 27.579-19.128 10.535-5.8726 22.549-11.445 36.84-16.874 13.518-5.1368 28.342-9.8651 45.006-14.237 31.978-8.3888 68.066-14.873 110.3-18.986 39.616-3.8602 83.029-5.4124 130.39-3.6704 85.996 3.1581 185.3 17.054 287.78 51.531 46.693 15.71 94.305 35.907 140.74 61.729 44.149 24.549 87.471 54.382 127.48 90.098 23.194 20.697 48.247 40.333 75.558 56.692 21.348 12.782 44.262 23.677 68.485 30.637 20.137 5.7908 41.285 8.8342 62.456 8.1458 19.512-0.61965 39.054-4.4125 57.817-10.91 19.01-6.5775 37.196-15.877 54.51-26.899 18.325-11.67 35.588-25.22 52.18-39.867 17.61-15.549 34.338-32.254 50.687-49.651 6.147-6.5417 12.228-13.171 18.265-19.877 10.781-11.975 21.358-24.12 31.794-36.278 35.055-40.842 66.677-79.614 101.93-118.62 17.485-19.343 35.267-38.052 53.811-55.861 18.267-17.545 37.156-34.087 57.048-49.158 19.514-14.786 39.904-28.044 61.318-39.11 21.382-11.05 43.692-19.791 66.59-25.64 24.017-6.1289 48.537-8.986 72.716-8.6941 27.3 0.33673 54.092 4.6255 79.535 11.62 46.834 12.864 90.376 31.76 129.45 55.182 38.217 22.918 72.189 50.099 101.91 78.732 30.642 29.522 57.5 61.175 81.048 91.884 24.476 31.916 47.166 65.203 66.988 94.784 22.392 33.413 39.316 59.376 59.693 87.531 9.8693 13.636 19.409 26.13 29.202 37.886 9.9893 11.99 19.786 22.671 29.875 32.295 10.502 10.017 20.863 18.452 31.374 25.479 11.572 7.7373 22.879 13.447 33.733 17.483v1e-5c13.663 5.0832 26.407 7.4188 37.045 8.3477 27.362 2.3936 41.231-2.914 41.506-1.4723-0.1276-0.66844-13.828 5.4662-41.678 3.8072-10.839-0.64734-23.891-2.7275-37.966-7.6552v-1e-5c-11.173-3.9137-22.845-9.5482-34.775-17.263-10.83-7.0036-21.517-15.444-32.303-25.472-10.362-9.6318-20.425-20.331-30.642-32.321-10.018-11.754-19.772-24.249-29.827-37.856-20.679-27.987-38.03-54.082-60.583-87.177-20.02-29.375-42.889-62.428-67.39-93.96-23.586-30.353-50.381-61.582-80.8-90.583-29.498-28.124-63.11-54.774-100.78-77.146-38.501-22.873-81.381-41.293-127.45-53.794-24.818-6.7277-50.855-10.828-77.256-11.07-23.375-0.2203-47.079 2.603-70.271 8.5791-22.124 5.6956-43.741 14.229-64.525 25.012-20.826 10.804-40.723 23.802-59.854 38.335-19.503 14.818-38.077 31.139-56.113 48.497-18.307 17.622-35.906 36.182-53.268 55.419-35.026 38.81-66.53 77.489-101.7 118.48-10.464 12.197-21.092 24.403-31.947 36.46-6.0788 6.7517-12.208 13.433-18.41 20.034-16.492 17.552-33.45 34.469-51.369 50.285-16.881 14.902-34.567 28.755-53.446 40.771-17.843 11.361-36.736 20.98-56.616 27.858-19.653 6.7934-40.172 10.74-60.741 11.38-22.316 0.67798-44.464-2.5255-65.463-8.615-25.219-7.3188-48.872-18.588-70.726-31.759-27.95-16.838-53.434-36.881-76.876-57.923-39.342-35.303-82.029-64.875-125.58-89.286-45.81-25.679-92.865-45.85-139.06-61.623-101.41-34.622-199.93-48.984-285.37-52.754-47.061-2.0742-90.197-0.89871-129.61 2.5549-42.033 3.6859-77.882 9.6956-109.75 17.591-16.599 4.1125-31.346 8.5667-44.824 13.427-14.254 5.1415-26.209 10.4-36.75 15.97-11.875 6.2779-20.631 12.222-27.684 18.094-6.875 5.729-11.125 10.563-13.962 14.218-2.7567 3.5508-3.8958 5.5712-4.0809 5.4664z\"/>\n   </g>\n  </g>\n  <g transform=\"translate(526.81 70.291)\" fill-rule=\"evenodd\">\n   <path d=\"m114.96-86.408c-0.30212-0.15566 4.2484-9.7128 13.203-27.793 8.9849-16.848 22.79-40.723 42.962-69.82 18.788-27.099 43.459-59.165 74.856-92.708 29.485-31.501 65.669-65.073 108.94-96.483 41.426-30.071 89.994-58.533 145.21-81.055 55.22-22.519 116.97-38.949 183.56-46.314 71.106-7.8576 146.27-5.3215 223.79 7.7358-1e-5 2e-5 1.1e-4 2e-5 1.1e-4 2e-5 88.265 14.868 176.81 42.57 265.76 80.922 91.807 39.57 188.96 73.931 291.09 102.5 4.9578 1.387 9.9256 2.7598 14.903 4.1185 94.137 25.694 187.53 45.138 279.07 59.215 98.194 15.098 193.45 23.915 285.16 27.394 93.31 3.5381 181.37 1.5318 264.62-5.313l1e-4 -1e-5c84.682-6.9641 161.43-18.6 232.35-34.778 72.635-16.576 134-36.556 188.36-60.981 27.671-12.432 52.098-25.444 74.042-39.285 23.22-14.648 42.464-29.458 58.713-44.594 18.792-17.507 32.222-34.216 42.041-49.512 10.416-16.227 16.318-30.293 19.718-39.59 3.4563-9.4492 4.6165-14.545 4.9456-14.465 0.1337 0.0325-0.5671 5.2421-3.6143 14.918-2.9973 9.5172-8.5258 23.923-18.715 40.599-9.5903 15.695-22.916 32.92-41.67 50.91-16.213 15.556-35.503 30.815-58.78 45.864-21.997 14.224-46.528 27.618-74.297 40.395-54.525 25.086-116.23 45.706-189.11 62.792-71.181 16.693-148.28 28.788-233.27 36.124l-1e-4 1e-5c-83.573 7.2153-172 9.5257-265.67 6.2103-92.067-3.2577-187.72-11.93-286.31-26.969-91.92-14.021-185.69-33.487-280.22-59.286-4.9982-1.3642-9.9864-2.7429-14.964-4.1358-102.55-28.695-200.11-63.28-292.27-103.15-88.325-38.201-176.05-65.867-263.43-80.809h-1.1e-4c-76.722-13.121-151.03-15.897-221.33-8.4007-65.826 7.0142-126.93 22.953-181.63 44.916-54.709 21.959-102.97 49.825-144.24 79.314-43.112 30.804-79.32 63.809-108.94 94.798-31.537 32.998-56.484 64.583-75.612 91.257-20.538 28.637-34.769 52.082-44.266 68.601-9.5112 17.76-14.652 27.013-14.954 26.857z\"/>\n   <path d=\"m186.54-561.43c9e-3 7.1e-4 0.0168 7e-3 0.0245 0.0196 7e-3 0.0161 0.0139 0.0399 0.02 0.0713v1e-5c0.0121 0.0624 0.0219 0.15543 0.0297 0.27823 0.0155 0.2425 0.0235 0.60911 0.0266 1.0885 6e-3 0.88603-7e-3 2.4254-0.015 4.224-0.0163 3.7357-0.0191 8.8779 0.2052 15.982 0.41795 13.233 1.5845 32.485 5.4076 56.862 3.5262 22.479 9.4535 49.936 19.778 80.085 9.691 28.297 23.562 59.722 43.358 91.362 19.276 30.813 44.387 62.039 76.127 90.792 32.901 29.81 72.405 56.48 118.19 78.501 50.784 24.426 107.42 42.384 169.74 54.472 1e-5 -1.3e-5 1.1e-4 2e-5 1.1e-4 2e-5 72.285 14.017 148.81 19.599 230.8 18.56v-1.1e-5l1.2e-4 9e-6c81.513-1.0482 167.75-9.8307 253.38-31.881 65.838-16.948 131.58-41.977 194.4-75.967 52.381-28.336 102.36-62.708 150.13-101.74 41.57-33.964 80.751-70.876 120.35-109.29 3.3737-3.2731 6.7454-6.5509 10.123-9.8362 14.494-14.099 28.825-28.07 43.39-41.925 16.878-16.056 33.874-31.769 51.499-46.777 16.497-14.05 33.475-27.404 51.346-39.472 16.878-11.4 34.525-21.577 53.073-29.781 18.186-8.0427 37.183-14.078 56.61-17.594 20.479-3.6977 41.298-4.5491 61.741-2.8849 23.472 1.9167 46.412 7.0362 68.344 14.153 26.824 8.7028 52.367 20.337 76.584 33.354 156.61 84.135 291.96 160.77 419.49 240.07 49.047 30.498 94.487 59.944 137.78 89.735 35.043 24.111 67.285 47.451 97.789 71.47 23.071 18.164 44.199 35.899 63.788 54.69 13.286 12.735 25.454 25.396 35.806 39.48 3.4343 4.67 6.6206 9.4838 9.2977 14.607l1e-4 7.8e-5c1.9073 3.6261 3.569 7.4754 4.5311 11.618 0.6869 2.8117 0.9484 5.9379 0.2341 9.1125-0.2963 1.2519-0.7949 2.4862-1.5116 3.6381l-1e-4 8.59e-5c-0.6793 1.0768-1.5341 2.0228-2.5225 2.802-1.0159 0.79331-2.1185 1.3974-3.2494 1.8269l-1e-4 3.3e-5c-1.2334 0.46896-2.4822 0.76158-3.7055 0.91758-2.8769 0.36008-5.6857 0.12818-8.2983-0.39986-3.1784-0.62847-6.2053-1.6566-9.0485-2.9105-3.2696-1.4378-6.353-3.1835-9.2298-5.1426-6.5098-4.4251-12.061-9.9774-16.287-16.279-2.2847-3.4081-4.1642-7.0409-5.5691-10.821-1.4926-4.0192-2.4286-8.1867-2.7913-12.36-0.399-4.6274-0.092-9.2279 0.7884-13.625 1.0387-5.1763 2.8411-10.072 5.093-14.576 2.8037-5.608 6.2986-10.694 10.054-15.267 4.8631-5.9246 10.255-11.15 15.681-15.776 16.866-14.378 35.808-24.846 51.114-32.443 24.668-12.251 47.957-20.678 60.903-25.097 14.168-4.8357 21.68-6.8538 21.746-6.6522 0.1048 0.31712-7.2398 2.8464-21.201 8.164-12.573 4.7889-35.94 13.888-60.032 26.378-15.052 7.808-33.641 18.437-49.903 32.691-5.2292 4.5823-10.389 9.702-14.976 15.436-3.5387 4.4259-6.8004 9.2807-9.3531 14.551-2.0474 4.2278-3.6675 8.7631-4.553 13.479-0.7535 4.0008-0.9895 8.1604-0.5856 12.298 0.3616 3.7333 1.2425 7.4675 2.618 11.064 1.2944 3.387 3.0302 6.6555 5.1345 9.7342 3.8993 5.7073 9.0421 10.741 15.048 14.753 2.6548 1.7694 5.471 3.3328 8.4242 4.5971 2.5756 1.0991 5.2373 1.9856 7.9445 2.4871 2.2391 0.4034 4.4683 0.59553 6.5451 0.28711 0.8702-0.12654 1.6993-0.32082 2.4446-0.6205l1e-4 -2.12e-5c0.6752-0.2721 1.2965-0.61054 1.8051-1.027 0.4929-0.39626 0.923-0.8801 1.2501-1.4137v-4.26e-5c0.3595-0.57008 0.6175-1.2532 0.7932-1.9857 0.4992-1.9269 0.2095-4.1872-0.3047-6.5431-0.8037-3.4549-2.3251-6.8306-4.1125-10.221v-6.7e-5c-2.5212-4.7496-5.5861-9.285-8.9398-13.786-10.136-13.597-22.153-25.889-35.406-38.439-19.516-18.465-40.587-35.912-63.665-53.861-30.506-23.724-62.738-46.784-97.816-70.662-43.338-29.5-88.788-58.664-137.88-88.926-127.76-78.747-262.91-154.76-419.68-238.63-23.873-12.764-48.909-24.132-75.052-32.557-21.363-6.8829-43.576-11.824-66.151-13.623-19.644-1.5707-39.615-0.73667-59.199 2.8264-18.585 3.373-36.83 9.1978-54.36 16.959-17.896 7.921-35.021 17.826-51.514 28.968-17.466 11.802-34.141 24.94-50.443 38.827-17.414 14.837-34.269 30.431-51.078 46.425-14.504 13.802-28.805 27.748-43.306 41.853-3.3788 3.2865-6.7537 6.5674-10.132 9.8451-39.662 38.481-79.074 75.575-121.02 109.82-48.203 39.351-98.736 74.027-151.77 102.65-63.608 34.317-130.13 59.523-196.71 76.523-86.581 22.099-173.55 30.752-255.63 31.547l-1.2e-4 -1e-5c-82.458 0.81376-159.57-5.1108-232.44-19.547l-1.1e-4 -3.4e-5c-62.834-12.445-120.02-30.911-171.3-55.911-46.251-22.549-86.124-49.856-119.28-80.316-31.984-29.389-57.171-61.243-76.405-92.618-19.747-32.217-33.427-64.121-42.856-92.798-10.046-30.552-15.607-58.3-18.743-80.984-3.3996-24.59-4.1019-43.984-4.0456-57.273 0.03-7.084 0.28143-12.351 0.55859-16.035 0.1411-1.8758 0.28444-3.2616 0.41318-4.218 0.0646-0.4796 0.12384-0.83682 0.1762-1.0779 0.0262-0.12071 0.0505-0.21088 0.0725-0.27093 0.0111-0.0301 0.0215-0.0525 0.0314-0.0673 0.01-0.0109 0.0188-0.0161 0.0274-0.0154z\"/>\n   <path d=\"m2843.6-505.04c0.01 1e-4 0.016 5e-3 0.024 0.0135 0.01 0.0118 0.015 0.0294 0.023 0.0528 0.015 0.0467 0.03 0.11612 0.044 0.20866v1e-5c0.028 0.18498 0.052 0.45757 0.07 0.82282 0.037 0.72947 0.049 1.7819 0.015 3.2054-0.067 2.8073-0.3025 6.7981-0.923 12.158-1.1826 10.217-3.6777 24.878-9.2922 43.377-5.3296 17.563-13.5 38.517-26.157 61.287-12.446 22.389-29.172 46.361-51.355 70.136-22.866 24.504-50.948 48.198-84.835 69.842-36.715 23.45-78.714 43.636-126.49 60.387-53.725 18.838-112.12 32.544-176.27 41.833 0-1e-5 -1e-4 1e-5 -1e-4 1e-5 -73.556 10.654-150.97 15.046-234.19 14.234h-1e-4c-81.152-0.78202-167.42-7.1852-254.31-24.151-64.655-12.624-130.22-31.373-194.11-58.035-51.168-21.359-101-47.781-149.09-78.64-21.749-13.957-43.033-28.747-64.119-44.133-18.721-13.661-37.113-27.665-55.205-41.696-35.555-27.567-69.126-54.54-104.9-79.64-16.977-11.914-34.162-23.165-51.82-33.389-17.568-10.172-35.533-19.284-53.957-26.976-18.969-7.921-38.39-14.317-58.063-19.015-21.235-5.0735-42.767-8.1714-64.208-9.5005-24.334-1.5101-48.612-0.75756-72.423 1.6308-28.162 2.8248-55.829 7.9459-82.664 14.438-38.413 9.2942-74.648 23.915-107.61 42.443-31.795 17.864-60.9 39.471-87.531 61.975-27.088 22.894-53.225 48.078-77.53 71.311-26.411 25.253-50.978 48.499-77.509 70.192-28.525 23.328-57.402 43.022-87.538 58.387-35.939 18.313-72.603 29.701-107.46 35.684-50.091 8.5856-98.037 6.7297-136.95 2.1604-55.449-6.5081-103.6-19.642-131.02-27.863-29.57-8.8661-44.81-14.868-44.734-15.1 0.18613-0.56298 15.685 4.6619 45.403 12.76 27.387 7.4626 75.921 19.815 130.86 25.584 38.664 4.0577 86.168 5.4252 135.4-3.4611 34.247-6.1736 70.206-17.645 105.37-35.862 29.509-15.28 57.816-34.862 85.91-58.08 26.144-21.612 50.419-44.829 76.706-70.193 24.185-23.343 50.319-48.736 77.601-71.989 26.821-22.864 56.287-44.887 88.66-63.236 33.583-19.025 70.542-34.065 109.79-43.675 27.15-6.6496 55.223-11.912 83.894-14.858 24.246-2.4916 49.034-3.3062 73.959-1.8121 21.968 1.3183 44.054 4.4585 65.87 9.6319 20.211 4.795 40.14 11.324 59.584 19.415 18.88 7.8577 37.237 17.136 55.129 27.475 17.98 10.39 35.419 21.78 52.578 33.804 36.128 25.319 69.854 52.377 105.32 79.866 18.051 13.987 36.368 27.932 54.979 41.514 20.962 15.298 42.079 29.978 63.619 43.805 47.626 30.577 96.928 56.763 147.51 77.93 63.164 26.44 128.07 45.096 192.15 57.738 86.132 16.995 171.83 23.563 252.57 24.605l1e-4 -1e-5c82.857 1.0598 159.82-2.9964 232.95-13.248l1e-4 -2e-5c63.781-8.9438 121.74-22.201 175.09-40.539 47.436-16.308 89.1-35.946 125.57-58.828 33.655-21.115 61.591-44.22 84.422-68.169 22.149-23.232 38.96-46.678 51.585-68.626 12.841-22.322 21.292-42.894 26.956-60.179 5.9709-18.222 8.865-32.638 10.484-42.746 0.8542-5.335 1.305-9.1921 1.6162-12.01 0.1468-1.3299 0.2714-2.5248 0.3494-3.169 0.043-0.35867 0.082-0.63307 0.1161-0.81343v-1e-5c0.018-0.0914 0.034-0.1604 0.05-0.20632 0.01-0.0231 0.016-0.0404 0.024-0.052 0.01-9e-3 0.016-0.013 0.024-0.0129z\"/>\n   <path d=\"m149.67-364.05c1.1942-0.5573 3.8819 10.746 19.136 25.757 6.3906 6.2929 14.853 12.824 25.935 18.582 9.3474 4.8567 20.069 8.936 32.58 12.195 11.756 3.06 24.438 5.2259 38.545 6.6428 27.761 2.789 56.969 2.4606 91.821-0.0911 33.318-2.4452 67.136-6.6656 105.96-12.344 37.929-5.5489 71.039-11.071 113.46-17.812 35.716-5.6766 75.001-11.742 114.35-16.466 34.605-4.1568 71.356-7.5956 108.68-8.2803 31.284-0.58272 64.084 0.68813 96.567 6.8393 55.955 10.636 110.91 29.916 166.21 54.692 52.227 23.391 100.82 49.573 153.85 76.952 48.28 24.91 98.781 50.084 151.44 68.901 1.5396 0.5504 3.0818 1.0956 4.6265 1.6354 24.18 8.4496 48.599 15.443 73.261 20.467 26.941 5.4885 54.077 8.5931 81.026 8.9828 47.534 0.70239 94.489-5.6377 139.26-15.873 48.924-11.188 96.018-27.161 140.47-44.824 48.904-19.436 96.026-41.538 140.07-63.42 47.334-23.519 95.609-49.124 138.07-71.542 48.86-25.8 90.77-47.83 134.5-69.139 47.167-22.986 88.626-41.275 129.39-56.168v-2e-5c47.285-17.28 86.76-27.352 122.71-32.528 22.575-3.2488 41.918-4.2181 58.284-3.9756 36.815 0.54544 55.671 6.8189 55.694 6.7013-0.2128 1.0968-19.241-4.1625-55.701-3.7812-16.235 0.16978-35.337 1.5233-57.657 5.1233-35.584 5.7368-74.446 16.227-121.3 33.91v2e-5c-40.395 15.249-81.396 33.79-128.29 57.083-43.54 21.631-85.024 43.792-133.83 69.917-42.393 22.692-90.46 48.487-137.91 72.309-44.085 22.133-91.345 44.497-140.54 64.219-44.71 17.926-92.224 34.157-141.77 45.594-45.347 10.472-93.067 16.966-141.58 16.316-27.614-0.37817-55.369-3.5287-82.877-9.1244-25.174-5.1218-50.031-12.229-74.569-20.808-1.5676-0.54803-3.1324-1.1015-4.6942-1.6603-53.403-19.113-104.28-44.486-152.62-69.512-53.138-27.493-101.47-53.647-153.25-76.962-54.795-24.66-108.97-43.869-163.98-54.488-31.565-6.1171-63.765-7.4639-94.701-7.0406-36.886 0.51512-73.382 3.7621-107.85 7.7145-39.163 4.4925-78.437 10.32-114.14 15.752-42.123 6.4093-75.931 11.779-113.68 16.977-38.921 5.3602-73.009 9.2756-106.52 11.365-35.048 2.191-64.653 2.1233-92.694-1.1146-14.27-1.6481-27.148-4.0752-39.067-7.4097-12.689-3.5477-23.591-7.9668-33.05-13.16-11.224-6.1622-19.731-13.128-26.051-19.782-15.092-15.898-17.01-27.57-17.542-27.322z\"/>\n   <g transform=\"matrix(-1 0 0 1 2453.2 0)\">\n    <path d=\"m114.96-86.408c-0.30212-0.15566 4.2484-9.7128 13.203-27.793 8.9849-16.848 22.79-40.723 42.962-69.82 18.788-27.099 43.459-59.165 74.856-92.708 29.485-31.501 65.669-65.073 108.94-96.483 41.426-30.071 89.994-58.533 145.21-81.055 55.22-22.519 116.97-38.949 183.56-46.314 71.106-7.8576 146.27-5.3215 223.79 7.7358-1e-5 2e-5 1.1e-4 2e-5 1.1e-4 2e-5 88.265 14.868 176.81 42.57 265.76 80.922 91.807 39.57 188.96 73.931 291.09 102.5 4.9578 1.387 9.9256 2.7598 14.903 4.1185 94.137 25.694 187.53 45.138 279.07 59.215 98.194 15.098 193.45 23.915 285.16 27.394 93.31 3.5381 181.37 1.5318 264.62-5.313l1e-4 -1e-5c84.682-6.9641 161.43-18.6 232.35-34.778 72.635-16.576 134-36.556 188.36-60.981 27.671-12.432 52.098-25.444 74.042-39.285 23.22-14.648 42.464-29.458 58.713-44.594 18.792-17.507 32.222-34.216 42.041-49.512 10.416-16.227 16.318-30.293 19.718-39.59 3.4563-9.4492 4.6165-14.545 4.9456-14.465 0.1337 0.0325-0.5671 5.2421-3.6143 14.918-2.9973 9.5172-8.5258 23.923-18.715 40.599-9.5903 15.695-22.916 32.92-41.67 50.91-16.213 15.556-35.503 30.815-58.78 45.864-21.997 14.224-46.528 27.618-74.297 40.395-54.525 25.086-116.23 45.706-189.11 62.792-71.181 16.693-148.28 28.788-233.27 36.124l-1e-4 1e-5c-83.573 7.2153-172 9.5257-265.67 6.2103-92.067-3.2577-187.72-11.93-286.31-26.969-91.92-14.021-185.69-33.487-280.22-59.286-4.9982-1.3642-9.9864-2.7429-14.964-4.1358-102.55-28.695-200.11-63.28-292.27-103.15-88.325-38.201-176.05-65.867-263.43-80.809h-1.1e-4c-76.722-13.121-151.03-15.897-221.33-8.4007-65.826 7.0142-126.93 22.953-181.63 44.916-54.709 21.959-102.97 49.825-144.24 79.314-43.112 30.804-79.32 63.809-108.94 94.798-31.537 32.998-56.484 64.583-75.612 91.257-20.538 28.637-34.769 52.082-44.266 68.601-9.5112 17.76-14.652 27.013-14.954 26.857z\"/>\n    <path d=\"m186.54-561.43c9e-3 7.1e-4 0.0168 7e-3 0.0245 0.0196 7e-3 0.0161 0.0139 0.0399 0.02 0.0713v1e-5c0.0121 0.0624 0.0219 0.15543 0.0297 0.27823 0.0155 0.2425 0.0235 0.60911 0.0266 1.0885 6e-3 0.88603-7e-3 2.4254-0.015 4.224-0.0163 3.7357-0.0191 8.8779 0.2052 15.982 0.41795 13.233 1.5845 32.485 5.4076 56.862 3.5262 22.479 9.4535 49.936 19.778 80.085 9.691 28.297 23.562 59.722 43.358 91.362 19.276 30.813 44.387 62.039 76.127 90.792 32.901 29.81 72.405 56.48 118.19 78.501 50.784 24.426 107.42 42.384 169.74 54.472 1e-5 -1.3e-5 1.1e-4 2e-5 1.1e-4 2e-5 72.285 14.017 148.81 19.599 230.8 18.56v-1.1e-5l1.2e-4 9e-6c81.513-1.0482 167.75-9.8307 253.38-31.881 65.838-16.948 131.58-41.977 194.4-75.967 52.381-28.336 102.36-62.708 150.13-101.74 41.57-33.964 80.751-70.876 120.35-109.29 3.3737-3.2731 6.7454-6.5509 10.123-9.8362 14.494-14.099 28.825-28.07 43.39-41.925 16.878-16.056 33.874-31.769 51.499-46.777 16.497-14.05 33.475-27.404 51.346-39.472 16.878-11.4 34.525-21.577 53.073-29.781 18.186-8.0427 37.183-14.078 56.61-17.594 20.479-3.6977 41.298-4.5491 61.741-2.8849 23.472 1.9167 46.412 7.0362 68.344 14.153 26.824 8.7028 52.367 20.337 76.584 33.354 156.61 84.135 291.96 160.77 419.49 240.07 49.047 30.498 94.487 59.944 137.78 89.735 35.043 24.111 67.285 47.451 97.789 71.47 23.071 18.164 44.199 35.899 63.788 54.69 13.286 12.735 25.454 25.396 35.806 39.48 3.4343 4.67 6.6206 9.4838 9.2977 14.607l1e-4 7.8e-5c1.9073 3.6261 3.569 7.4754 4.5311 11.618 0.6869 2.8117 0.9484 5.9379 0.2341 9.1125-0.2963 1.2519-0.7949 2.4862-1.5116 3.6381l-1e-4 8.59e-5c-0.6793 1.0768-1.5341 2.0228-2.5225 2.802-1.0159 0.79331-2.1185 1.3974-3.2494 1.8269l-1e-4 3.3e-5c-1.2334 0.46896-2.4822 0.76158-3.7055 0.91758-2.8769 0.36008-5.6857 0.12818-8.2983-0.39986-3.1784-0.62847-6.2053-1.6566-9.0485-2.9105-3.2696-1.4378-6.353-3.1835-9.2298-5.1426-6.5098-4.4251-12.061-9.9774-16.287-16.279-2.2847-3.4081-4.1642-7.0409-5.5691-10.821-1.4926-4.0192-2.4286-8.1867-2.7913-12.36-0.399-4.6274-0.092-9.2279 0.7884-13.625 1.0387-5.1763 2.8411-10.072 5.093-14.576 2.8037-5.608 6.2986-10.694 10.054-15.267 4.8631-5.9246 10.255-11.15 15.681-15.776 16.866-14.378 35.808-24.846 51.114-32.443 24.668-12.251 47.957-20.678 60.903-25.097 14.168-4.8357 21.68-6.8538 21.746-6.6522 0.1048 0.31712-7.2398 2.8464-21.201 8.164-12.573 4.7889-35.94 13.888-60.032 26.378-15.052 7.808-33.641 18.437-49.903 32.691-5.2292 4.5823-10.389 9.702-14.976 15.436-3.5387 4.4259-6.8004 9.2807-9.3531 14.551-2.0474 4.2278-3.6675 8.7631-4.553 13.479-0.7535 4.0008-0.9895 8.1604-0.5856 12.298 0.3616 3.7333 1.2425 7.4675 2.618 11.064 1.2944 3.387 3.0302 6.6555 5.1345 9.7342 3.8993 5.7073 9.0421 10.741 15.048 14.753 2.6548 1.7694 5.471 3.3328 8.4242 4.5971 2.5756 1.0991 5.2373 1.9856 7.9445 2.4871 2.2391 0.4034 4.4683 0.59553 6.5451 0.28711 0.8702-0.12654 1.6993-0.32082 2.4446-0.6205l1e-4 -2.12e-5c0.6752-0.2721 1.2965-0.61054 1.8051-1.027 0.4929-0.39626 0.923-0.8801 1.2501-1.4137v-4.26e-5c0.3595-0.57008 0.6175-1.2532 0.7932-1.9857 0.4992-1.9269 0.2095-4.1872-0.3047-6.5431-0.8037-3.4549-2.3251-6.8306-4.1125-10.221v-6.7e-5c-2.5212-4.7496-5.5861-9.285-8.9398-13.786-10.136-13.597-22.153-25.889-35.406-38.439-19.516-18.465-40.587-35.912-63.665-53.861-30.506-23.724-62.738-46.784-97.816-70.662-43.338-29.5-88.788-58.664-137.88-88.926-127.76-78.747-262.91-154.76-419.68-238.63-23.873-12.764-48.909-24.132-75.052-32.557-21.363-6.8829-43.576-11.824-66.151-13.623-19.644-1.5707-39.615-0.73667-59.199 2.8264-18.585 3.373-36.83 9.1978-54.36 16.959-17.896 7.921-35.021 17.826-51.514 28.968-17.466 11.802-34.141 24.94-50.443 38.827-17.414 14.837-34.269 30.431-51.078 46.425-14.504 13.802-28.805 27.748-43.306 41.853-3.3788 3.2865-6.7537 6.5674-10.132 9.8451-39.662 38.481-79.074 75.575-121.02 109.82-48.203 39.351-98.736 74.027-151.77 102.65-63.608 34.317-130.13 59.523-196.71 76.523-86.581 22.099-173.55 30.752-255.63 31.547l-1.2e-4 -1e-5c-82.458 0.81376-159.57-5.1108-232.44-19.547l-1.1e-4 -3.4e-5c-62.834-12.445-120.02-30.911-171.3-55.911-46.251-22.549-86.124-49.856-119.28-80.316-31.984-29.389-57.171-61.243-76.405-92.618-19.747-32.217-33.427-64.121-42.856-92.798-10.046-30.552-15.607-58.3-18.743-80.984-3.3996-24.59-4.1019-43.984-4.0456-57.273 0.03-7.084 0.28143-12.351 0.55859-16.035 0.1411-1.8758 0.28444-3.2616 0.41318-4.218 0.0646-0.4796 0.12384-0.83682 0.1762-1.0779 0.0262-0.12071 0.0505-0.21088 0.0725-0.27093 0.0111-0.0301 0.0215-0.0525 0.0314-0.0673 0.01-0.0109 0.0188-0.0161 0.0274-0.0154z\"/>\n    <path d=\"m2843.6-505.04c0.01 1e-4 0.016 5e-3 0.024 0.0135 0.01 0.0118 0.015 0.0294 0.023 0.0528 0.015 0.0467 0.03 0.11612 0.044 0.20866v1e-5c0.028 0.18498 0.052 0.45757 0.07 0.82282 0.037 0.72947 0.049 1.7819 0.015 3.2054-0.067 2.8073-0.3025 6.7981-0.923 12.158-1.1826 10.217-3.6777 24.878-9.2922 43.377-5.3296 17.563-13.5 38.517-26.157 61.287-12.446 22.389-29.172 46.361-51.355 70.136-22.866 24.504-50.948 48.198-84.835 69.842-36.715 23.45-78.714 43.636-126.49 60.387-53.725 18.838-112.12 32.544-176.27 41.833 0-1e-5 -1e-4 1e-5 -1e-4 1e-5 -73.556 10.654-150.97 15.046-234.19 14.234h-1e-4c-81.152-0.78202-167.42-7.1852-254.31-24.151-64.655-12.624-130.22-31.373-194.11-58.035-51.168-21.359-101-47.781-149.09-78.64-21.749-13.957-43.033-28.747-64.119-44.133-18.721-13.661-37.113-27.665-55.205-41.696-35.555-27.567-69.126-54.54-104.9-79.64-16.977-11.914-34.162-23.165-51.82-33.389-17.568-10.172-35.533-19.284-53.957-26.976-18.969-7.921-38.39-14.317-58.063-19.015-21.235-5.0735-42.767-8.1714-64.208-9.5005-24.334-1.5101-48.612-0.75756-72.423 1.6308-28.162 2.8248-55.829 7.9459-82.664 14.438-38.413 9.2942-74.648 23.915-107.61 42.443-31.795 17.864-60.9 39.471-87.531 61.975-27.088 22.894-53.225 48.078-77.53 71.311-26.411 25.253-50.978 48.499-77.509 70.192-28.525 23.328-57.402 43.022-87.538 58.387-35.939 18.313-72.603 29.701-107.46 35.684-50.091 8.5856-98.037 6.7297-136.95 2.1604-55.449-6.5081-103.6-19.642-131.02-27.863-29.57-8.8661-44.81-14.868-44.734-15.1 0.18613-0.56298 15.685 4.6619 45.403 12.76 27.387 7.4626 75.921 19.815 130.86 25.584 38.664 4.0577 86.168 5.4252 135.4-3.4611 34.247-6.1736 70.206-17.645 105.37-35.862 29.509-15.28 57.816-34.862 85.91-58.08 26.144-21.612 50.419-44.829 76.706-70.193 24.185-23.343 50.319-48.736 77.601-71.989 26.821-22.864 56.287-44.887 88.66-63.236 33.583-19.025 70.542-34.065 109.79-43.675 27.15-6.6496 55.223-11.912 83.894-14.858 24.246-2.4916 49.034-3.3062 73.959-1.8121 21.968 1.3183 44.054 4.4585 65.87 9.6319 20.211 4.795 40.14 11.324 59.584 19.415 18.88 7.8577 37.237 17.136 55.129 27.475 17.98 10.39 35.419 21.78 52.578 33.804 36.128 25.319 69.854 52.377 105.32 79.866 18.051 13.987 36.368 27.932 54.979 41.514 20.962 15.298 42.079 29.978 63.619 43.805 47.626 30.577 96.928 56.763 147.51 77.93 63.164 26.44 128.07 45.096 192.15 57.738 86.132 16.995 171.83 23.563 252.57 24.605l1e-4 -1e-5c82.857 1.0598 159.82-2.9964 232.95-13.248l1e-4 -2e-5c63.781-8.9438 121.74-22.201 175.09-40.539 47.436-16.308 89.1-35.946 125.57-58.828 33.655-21.115 61.591-44.22 84.422-68.169 22.149-23.232 38.96-46.678 51.585-68.626 12.841-22.322 21.292-42.894 26.956-60.179 5.9709-18.222 8.865-32.638 10.484-42.746 0.8542-5.335 1.305-9.1921 1.6162-12.01 0.1468-1.3299 0.2714-2.5248 0.3494-3.169 0.043-0.35867 0.082-0.63307 0.1161-0.81343v-1e-5c0.018-0.0914 0.034-0.1604 0.05-0.20632 0.01-0.0231 0.016-0.0404 0.024-0.052 0.01-9e-3 0.016-0.013 0.024-0.0129z\"/>\n    <path d=\"m149.67-364.05c1.1942-0.5573 3.8819 10.746 19.136 25.757 6.3906 6.2929 14.853 12.824 25.935 18.582 9.3474 4.8567 20.069 8.936 32.58 12.195 11.756 3.06 24.438 5.2259 38.545 6.6428 27.761 2.789 56.969 2.4606 91.821-0.0911 33.318-2.4452 67.136-6.6656 105.96-12.344 37.929-5.5489 71.039-11.071 113.46-17.812 35.716-5.6766 75.001-11.742 114.35-16.466 34.605-4.1568 71.356-7.5956 108.68-8.2803 31.284-0.58272 64.084 0.68813 96.567 6.8393 55.955 10.636 110.91 29.916 166.21 54.692 52.227 23.391 100.82 49.573 153.85 76.952 48.28 24.91 98.781 50.084 151.44 68.901 1.5396 0.5504 3.0818 1.0956 4.6265 1.6354 24.18 8.4496 48.599 15.443 73.261 20.467 26.941 5.4885 54.077 8.5931 81.026 8.9828 47.534 0.70239 94.489-5.6377 139.26-15.873 48.924-11.188 96.018-27.161 140.47-44.824 48.904-19.436 96.026-41.538 140.07-63.42 47.334-23.519 95.609-49.124 138.07-71.542 48.86-25.8 90.77-47.83 134.5-69.139 47.167-22.986 88.626-41.275 129.39-56.168v-2e-5c47.285-17.28 86.76-27.352 122.71-32.528 22.575-3.2488 41.918-4.2181 58.284-3.9756 36.815 0.54544 55.671 6.8189 55.694 6.7013-0.2128 1.0968-19.241-4.1625-55.701-3.7812-16.235 0.16978-35.337 1.5233-57.657 5.1233-35.584 5.7368-74.446 16.227-121.3 33.91v2e-5c-40.395 15.249-81.396 33.79-128.29 57.083-43.54 21.631-85.024 43.792-133.83 69.917-42.393 22.692-90.46 48.487-137.91 72.309-44.085 22.133-91.345 44.497-140.54 64.219-44.71 17.926-92.224 34.157-141.77 45.594-45.347 10.472-93.067 16.966-141.58 16.316-27.614-0.37817-55.369-3.5287-82.877-9.1244-25.174-5.1218-50.031-12.229-74.569-20.808-1.5676-0.54803-3.1324-1.1015-4.6942-1.6603-53.403-19.113-104.28-44.486-152.62-69.512-53.138-27.493-101.47-53.647-153.25-76.962-54.795-24.66-108.97-43.869-163.98-54.488-31.565-6.1171-63.765-7.4639-94.701-7.0406-36.886 0.51512-73.382 3.7621-107.85 7.7145-39.163 4.4925-78.437 10.32-114.14 15.752-42.123 6.4093-75.931 11.779-113.68 16.977-38.921 5.3602-73.009 9.2756-106.52 11.365-35.048 2.191-64.653 2.1233-92.694-1.1146-14.27-1.6481-27.148-4.0752-39.067-7.4097-12.689-3.5477-23.591-7.9668-33.05-13.16-11.224-6.1622-19.731-13.128-26.051-19.782-15.092-15.898-17.01-27.57-17.542-27.322z\"/>\n   </g>\n  </g>\n  <g transform=\"translate(910.92 72.703)\" fill-rule=\"evenodd\">\n   <g transform=\"translate(-930.9 -16.882)\">\n    <path d=\"m2722.8-1045.8c-0.3741 0.6847-16.461-8.5804-48.111-22.252-31.382-13.556-79.121-31.688-141.3-45.09-57.748-12.447-127.03-20.672-206.92-18.52-66.07 1.7815-137.82 10.638-213.44 29.336-67.94 16.802-138.15 41.369-208.15 75.24-32.612 15.779-63.072 31.167-96.823 47.864-29.359 14.526-59.765 29.314-90.759 42.88-28.433 12.448-57.915 24.085-88.379 33.509-28.916 8.9453-58.924 15.885-89.64 19.655-11.531 1.4138-23.156 2.372-34.838 2.8613-19.965 0.8363-39.875 0.29398-59.55-1.6024-35.232-3.4021-69.613-11.063-102.47-21.58-40.035-12.815-78.099-29.807-113.96-48.705-45.86-24.167-88.896-51.781-129.01-80.108-88.235-62.289-173.48-110.9-258.58-146.73-79.167-33.318-151.11-52.87-219.54-59.445-32.818-3.1561-63.087-3.0453-91.24 0.1295-29.111 3.2851-54.619 9.7024-76.878 18.471-25.754 10.144-45.865 22.976-61.148 35.672-16.799 13.951-28.061 28.034-34.655 37.082-6.8411 9.3869-9.7552 14.712-10.107 14.512-0.14004-0.079 2.2854-5.6832 8.7377-15.462 6.2301-9.4421 17.15-24.017 33.923-38.605 15.231-13.244 35.484-26.715 61.546-37.432 22.517-9.2584 48.404-16.152 77.921-19.815 28.541-3.5438 59.26-3.9805 92.499-1.0763 69.254 6.0569 142.2 25.272 222.09 58.426 85.913 35.635 172 84.227 260.84 146.59 39.96 28.041 82.715 55.343 128.14 79.165 35.512 18.623 73.077 35.341 112.44 47.884 32.292 10.291 65.989 17.785 100.41 21.086 19.216 1.8462 38.667 2.3723 58.174 1.5549 11.414-0.47826 22.773-1.4134 34.041-2.7924 30.024-3.67 59.46-10.471 87.919-19.242 29.992-9.245 59.143-20.723 87.371-33.029 30.77-13.416 61.07-28.092 90.418-42.536 33.672-16.574 64.334-31.969 97.015-47.67l1e-4 -1e-4c70.718-33.976 141.62-58.489 210.2-75.112 76.318-18.501 148.72-27.001 215.31-28.317 80.514-1.5938 150.29 7.3625 208.26 20.595 62.445 14.252 110.16 33.316 141.3 47.749 31.416 14.56 47.045 24.676 46.944 24.861z\"/>\n    <path d=\"m2783.1-1159.1c0.083 2.3633-32.798-0.8107-89.768 15.088-22.231 6.202-47.75 15.528-75.167 29.654-20.897 10.766-42.204 23.94-64.652 40.036-19.162 13.741-37.762 28.58-58.097 45.356-16.776 13.841-36.763 30.733-55.444 45.516-17.443 13.807-36.384 27.911-56.72 40.431-18.942 11.664-39.661 22.21-61.948 29.961-22.302 7.7468-46.243 12.619-70.978 13.929-29.023 1.3325-59.204-0.39709-89.193-6.6518-25.299-5.2901-50.225-13.792-74.529-24.861-23.293-10.61-45.574-23.193-68.057-36.605-22.517-13.426-46.886-28.616-70.104-41.995-25.867-14.904-52.8-29.057-80.8-41.317-31.989-14.011-65.513-25.659-100.21-34.703-23.051-6.0104-46.56-10.881-70.454-14.739-19.318-3.1185-38.659-5.5378-57.925-7.3655-55.855-5.2982-111.42-5.7128-165.28-3.4173-60.857 2.597-119.89 8.7683-176.5 17.556-54.667 8.4856-107.34 19.462-157.13 31.601h-1e-4c-48.419 11.805-95.598 25.102-139.04 37.936-52.947 15.642-73.996 22.501-122.21 36.543-38.677 11.267-72.467 20.43-106.63 27.386l-6e-5 1e-5c-33.948 6.9205-63.684 10.634-92.297 10.381l-5e-5 -1e-5c-14.734-0.13229-28.389-1.3827-41.117-3.6861-14.153-2.5617-26.777-6.3877-37.873-10.951-14.065-5.7859-25.632-12.749-34.627-19.202-22.685-16.275-30.643-29.035-30.927-28.771 0.94066-0.8753 9.5849 11.257 32.431 26.606 9.0504 6.0818 20.583 12.63 34.468 17.997 10.958 4.237 23.374 7.7381 37.271 10.011 12.503 2.0457 25.899 3.0563 40.385 2.9825h4e-5c28.169-0.13924 57.386-4.1793 91.028-11.39 0-1e-5 6e-5 -2e-5 6e-5 -2e-5 33.866-7.2674 67.307-16.678 105.86-28.242 58.363-17.511 58.674-18.289 121.93-37.399 43.452-13.127 90.66-26.7 139.24-38.775h1e-4c49.943-12.414 102.82-23.637 157.78-32.336 56.906-9.008 116.28-15.352 177.53-18.063 54.199-2.4027 110.21-2.0339 166.64 3.2885 19.468 1.836 39.027 4.2788 58.579 7.4367 24.184 3.906 48.003 8.8485 71.381 14.953 35.197 9.193 69.206 21.045 101.66 35.306 28.409 12.488 55.639 26.846 81.701 41.935 23.42 13.558 47.745 28.798 70.138 42.227 22.333 13.388 44.262 25.87 67.033 36.316 23.728 10.887 47.975 19.267 72.517 24.486 29.083 6.2016 58.513 8.007 86.916 6.85 23.89-1.1489 47.066-5.74 68.68-13.116 21.628-7.371 41.89-17.544 60.535-28.845 20.026-12.14 38.832-25.948 56.259-39.522 18.598-14.488 38.818-31.291 55.702-44.97 20.524-16.631 39.418-31.398 58.889-45.048 22.821-15.999 44.55-29.065 65.844-39.672 27.948-13.92 53.933-22.928 76.511-28.744 57.864-14.898 90.798-10.353 90.762-11.385z\"/>\n    <path d=\"m2749.3-905.91c0.022 0.21406-12.508 2.4054-36.535 3.7345-23.236 1.2853-60.296 1.8126-104.63-4.2512-36.645-5.0138-78.852-14.582-125.32-31.568-35.975-13.152-73.004-30.131-112.42-51.554-33.732-18.334-66.838-38.573-102.78-61.457-29.135-18.548-64.622-41.801-96.482-61.376-29.263-17.976-60.589-36.154-93.477-51.392-29.295-13.566-60.753-25.211-93.693-31.662-31.409-6.1604-64.542-7.4646-97.342-2.4776-32.281 4.8953-64.411 13.904-95.813 26.432-29.9 11.928-58.907 26.91-87.395 43.973-27.793 16.649-54.717 35.05-81.762 54.466-26.878 19.298-51.494 37.868-78.865 57.814-25.384 18.501-51.52 36.986-78.757 53.949-3.7829 2.3567-7.5923 4.6863-11.429 6.9834-22.651 13.562-45.91 25.788-70.083 35.814-28.116 11.663-57.34 20.134-87.109 24.199-31.944 4.3491-64.193 3.4735-95.242-1.9604-59.71-10.448-116.6-28.287-169.18-52.052-45.297-20.483-88.275-45.788-128.38-70.068-39.209-23.715-75.253-45.858-114.4-63.253-19.953-8.8711-40.092-16.173-60.424-21.552-22.432-5.9376-45.01-9.5028-67.225-10.942-11.257-0.7329-22.507-0.1761-33.48 1.3486-11.548 1.6043-22.856 4.2929-33.779 7.6574-24.237 7.459-47.108 18.383-68.19 29.866-24.018 13.09-47.243 27.873-68.437 41.65-25.318 16.461-44.834 29.616-68.089 44.099-23.592 14.698-45.138 27.019-67.285 37.156l-5e-5 1e-5c-23.261 10.658-44.857 17.699-66.092 20.738-11.408 1.6286-22.251 1.9739-32.432 1.1906-11.755-0.90614-22.456-3.3268-31.839-6.55-12.497-4.2953-22.963-10.094-31.035-15.46-21.73-14.446-29.305-26.197-29.657-25.848 0.9133-0.90537 9.0805 10.28 30.918 23.89 8.0956 5.046 18.506 10.485 30.772 14.413 9.2115 2.9521 19.667 5.1079 31.1 5.7939 9.9062 0.59591 20.442 0.0882 31.54-1.6584 20.689-3.2486 41.696-10.435 64.55-21.194 0-1e-5 6e-5 -3e-5 6e-5 -3e-5 21.757-10.254 42.927-22.665 66.288-37.513 23.141-14.713 42.245-27.839 67.616-44.618 21.132-13.977 44.382-29.008 68.602-42.425 21.242-11.774 44.483-23.033 69.383-30.878 11.231-3.5357 22.928-6.3811 34.958-8.1246 11.437-1.6574 23.221-2.2979 35.091-1.5919 22.729 1.3566 45.851 4.8938 68.855 10.871 20.845 5.4197 41.449 12.785 61.804 21.743 39.892 17.568 76.387 39.774 115.61 63.36 40.117 24.101 82.857 49.13 127.58 69.21 51.919 23.327 108.06 40.823 166.96 51.049 30.095 5.2243 61.333 6.0441 92.208 1.8078 28.793-3.9376 57.187-12.203 84.628-23.582 23.611-9.7907 46.43-21.802 68.77-35.174 3.7837-2.2648 7.5442-4.563 11.282-6.8889 26.908-16.749 52.852-35.094 78.171-53.521 27.254-19.839 51.993-38.468 78.967-57.796 27.184-19.48 54.363-38 82.514-54.812 28.857-17.236 58.36-32.397 88.863-44.505 32.049-12.72 64.904-21.84 97.968-26.775 33.982-5.0598 68.163-3.6237 100.5 2.8356 33.861 6.7738 65.94 18.754 95.613 32.662 33.308 15.603 64.83 34.069 94.134 52.272 32.03 19.892 67.194 43.206 96.272 61.958 35.756 23.056 68.55 43.405 101.96 61.877 39.022 21.577 75.592 38.727 111.14 52.11 45.906 17.282 87.611 27.258 123.9 32.756 43.839 6.6445 80.807 6.8612 103.93 6.2807 23.963-0.60158 36.569-2.039 36.625-1.4842z\"/>\n    <path d=\"m2667.3-1012c-0.3134 1.8376-40.183-7.9091-113.29-7.5637-30.575 0.144-65.862 2.1839-106.61 7.5603h-1e-4c-61.594 8.1234-119.19 21.448-197.34 40.476-28.848 7.0267-60.775 14.817-92.37 21.389-28.391 5.9072-58.463 11.251-89.23 14.354-28.026 2.8292-57.296 3.815-86.871 1.3588-28.33-2.3556-57.121-7.9935-85.151-17.69-27.677-9.5902-54.134-23.268-79.411-39.709-25.04-16.282-48.6-34.902-71.804-54.828-23.232-19.946-45.213-40.392-68.28-61.464-22.156-20.235-44.94-40.736-68.771-59.757-17.228-13.746-35.193-26.89-54.068-38.621-6.2805-3.9034-12.639-7.636-19.085-11.176-25.942-14.246-53.27-25.264-81.423-31.777-31.028-7.1968-62.946-8.8381-93.94-5.8543-38.637 3.707-76.068 14.386-111.04 28.312-41.302 16.462-80.555 35.977-117.45 56.666-38.673 21.685-75.524 45.106-110.02 68.306-35.826 24.099-71.18 49.404-103.37 72.604-35.388 25.502-65.184 47.183-97.548 69.526-32.75 22.612-62.444 41.937-92.558 59.049l-6e-5 3e-5c-31.508 17.911-60.116 31.428-88.414 41.114l-5e-5 1e-5c-15.014 5.1377-29.255 8.9101-42.899 11.463-15.222 2.8484-29.267 4.075-42.114 4.1071-16.058 0.0394-29.967-1.8093-41.327-4.2428-27.54-5.9017-40.111-14.356-40.231-14.081 0.4803-1.0961 13.422 6.5002 40.745 11.493 11.272 2.0604 24.993 3.5338 40.766 3.1653 12.623-0.29427 26.386-1.759 41.307-4.8059 13.376-2.7315 27.326-6.6577 42.063-11.927l5e-5 -2e-5c27.805-9.9388 55.863-23.625 86.978-41.721-1e-5 0 5e-5 -3e-5 5e-5 -3e-5 29.736-17.299 59.039-36.753 91.539-59.566 32.225-22.622 61.567-44.292 96.949-70.115 32.094-23.425 67.339-48.935 103.22-73.311 34.52-23.454 71.476-47.145 110.37-69.131 37.106-20.976 76.673-40.782 118.42-57.539 35.562-14.288 73.856-25.259 113.67-29.172 31.978-3.1335 64.962-1.4636 97.137 5.959 29.171 6.7466 57.361 18.077 83.993 32.716 6.6115 3.6344 13.124 7.4581 19.546 11.449 19.304 11.995 37.586 25.367 55.024 39.309 24.127 19.284 47.059 39.942 69.231 60.242 23.096 21.142 44.959 41.54 67.969 61.362 22.983 19.792 46.155 38.199 70.664 54.206 24.729 16.146 50.451 29.56 77.244 38.915 27.182 9.5081 55.208 15.092 82.846 17.506 28.869 2.5236 57.611 1.67 85.253-0.97753 30.35-2.9092 60.173-8.0522 88.432-13.757 31.423-6.345 63.371-13.924 92.245-20.74 78.129-18.451 136.54-31.372 198.4-38.807 41.033-4.9291 76.61-6.4764 107.34-6.0806 73.56 0.9485 113.21 12.167 113.27 11.805z\"/>\n   </g>\n   <g transform=\"matrix(-1 0 0 1 2614.2 -16.882)\">\n    <path d=\"m2722.8-1045.8c-0.3741 0.6847-16.461-8.5804-48.111-22.252-31.382-13.556-79.121-31.688-141.3-45.09-57.748-12.447-127.03-20.672-206.92-18.52-66.07 1.7815-137.82 10.638-213.44 29.336-67.94 16.802-138.15 41.369-208.15 75.24-32.612 15.779-63.072 31.167-96.823 47.864-29.359 14.526-59.765 29.314-90.759 42.88-28.433 12.448-57.915 24.085-88.379 33.509-28.916 8.9453-58.924 15.885-89.64 19.655-11.531 1.4138-23.156 2.372-34.838 2.8613-19.965 0.8363-39.875 0.29398-59.55-1.6024-35.232-3.4021-69.613-11.063-102.47-21.58-40.035-12.815-78.099-29.807-113.96-48.705-45.86-24.167-88.896-51.781-129.01-80.108-88.235-62.289-173.48-110.9-258.58-146.73-79.167-33.318-151.11-52.87-219.54-59.445-32.818-3.1561-63.087-3.0453-91.24 0.1295-29.111 3.2851-54.619 9.7024-76.878 18.471-25.754 10.144-45.865 22.976-61.148 35.672-16.799 13.951-28.061 28.034-34.655 37.082-6.8411 9.3869-9.7552 14.712-10.107 14.512-0.14004-0.079 2.2854-5.6832 8.7377-15.462 6.2301-9.4421 17.15-24.017 33.923-38.605 15.231-13.244 35.484-26.715 61.546-37.432 22.517-9.2584 48.404-16.152 77.921-19.815 28.541-3.5438 59.26-3.9805 92.499-1.0763 69.254 6.0569 142.2 25.272 222.09 58.426 85.913 35.635 172 84.227 260.84 146.59 39.96 28.041 82.715 55.343 128.14 79.165 35.512 18.623 73.077 35.341 112.44 47.884 32.292 10.291 65.989 17.785 100.41 21.086 19.216 1.8462 38.667 2.3723 58.174 1.5549 11.414-0.47826 22.773-1.4134 34.041-2.7924 30.024-3.67 59.46-10.471 87.919-19.242 29.992-9.245 59.143-20.723 87.371-33.029 30.77-13.416 61.07-28.092 90.418-42.536 33.672-16.574 64.334-31.969 97.015-47.67l1e-4 -1e-4c70.718-33.976 141.62-58.489 210.2-75.112 76.318-18.501 148.72-27.001 215.31-28.317 80.514-1.5938 150.29 7.3625 208.26 20.595 62.445 14.252 110.16 33.316 141.3 47.749 31.416 14.56 47.045 24.676 46.944 24.861z\"/>\n    <path d=\"m2783.1-1159.1c0.083 2.3633-32.798-0.8107-89.768 15.088-22.231 6.202-47.75 15.528-75.167 29.654-20.897 10.766-42.204 23.94-64.652 40.036-19.162 13.741-37.762 28.58-58.097 45.356-16.776 13.841-36.763 30.733-55.444 45.516-17.443 13.807-36.384 27.911-56.72 40.431-18.942 11.664-39.661 22.21-61.948 29.961-22.302 7.7468-46.243 12.619-70.978 13.929-29.023 1.3325-59.204-0.39709-89.193-6.6518-25.299-5.2901-50.225-13.792-74.529-24.861-23.293-10.61-45.574-23.193-68.057-36.605-22.517-13.426-46.886-28.616-70.104-41.995-25.867-14.904-52.8-29.057-80.8-41.317-31.989-14.011-65.513-25.659-100.21-34.703-23.051-6.0104-46.56-10.881-70.454-14.739-19.318-3.1185-38.659-5.5378-57.925-7.3655-55.855-5.2982-111.42-5.7128-165.28-3.4173-60.857 2.597-119.89 8.7683-176.5 17.556-54.667 8.4856-107.34 19.462-157.13 31.601h-1e-4c-48.419 11.805-95.598 25.102-139.04 37.936-52.947 15.642-73.996 22.501-122.21 36.543-38.677 11.267-72.467 20.43-106.63 27.386l-6e-5 1e-5c-33.948 6.9205-63.684 10.634-92.297 10.381l-5e-5 -1e-5c-14.734-0.13229-28.389-1.3827-41.117-3.6861-14.153-2.5617-26.777-6.3877-37.873-10.951-14.065-5.7859-25.632-12.749-34.627-19.202-22.685-16.275-30.643-29.035-30.927-28.771 0.94066-0.8753 9.5849 11.257 32.431 26.606 9.0504 6.0818 20.583 12.63 34.468 17.997 10.958 4.237 23.374 7.7381 37.271 10.011 12.503 2.0457 25.899 3.0563 40.385 2.9825h4e-5c28.169-0.13924 57.386-4.1793 91.028-11.39 0-1e-5 6e-5 -2e-5 6e-5 -2e-5 33.866-7.2674 67.307-16.678 105.86-28.242 58.363-17.511 58.674-18.289 121.93-37.399 43.452-13.127 90.66-26.7 139.24-38.775h1e-4c49.943-12.414 102.82-23.637 157.78-32.336 56.906-9.008 116.28-15.352 177.53-18.063 54.199-2.4027 110.21-2.0339 166.64 3.2885 19.468 1.836 39.027 4.2788 58.579 7.4367 24.184 3.906 48.003 8.8485 71.381 14.953 35.197 9.193 69.206 21.045 101.66 35.306 28.409 12.488 55.639 26.846 81.701 41.935 23.42 13.558 47.745 28.798 70.138 42.227 22.333 13.388 44.262 25.87 67.033 36.316 23.728 10.887 47.975 19.267 72.517 24.486 29.083 6.2016 58.513 8.007 86.916 6.85 23.89-1.1489 47.066-5.74 68.68-13.116 21.628-7.371 41.89-17.544 60.535-28.845 20.026-12.14 38.832-25.948 56.259-39.522 18.598-14.488 38.818-31.291 55.702-44.97 20.524-16.631 39.418-31.398 58.889-45.048 22.821-15.999 44.55-29.065 65.844-39.672 27.948-13.92 53.933-22.928 76.511-28.744 57.864-14.898 90.798-10.353 90.762-11.385z\"/>\n    <path d=\"m2749.3-905.91c0.022 0.21406-12.508 2.4054-36.535 3.7345-23.236 1.2853-60.296 1.8126-104.63-4.2512-36.645-5.0138-78.852-14.582-125.32-31.568-35.975-13.152-73.004-30.131-112.42-51.554-33.732-18.334-66.838-38.573-102.78-61.457-29.135-18.548-64.622-41.801-96.482-61.376-29.263-17.976-60.589-36.154-93.477-51.392-29.295-13.566-60.753-25.211-93.693-31.662-31.409-6.1604-64.542-7.4646-97.342-2.4776-32.281 4.8953-64.411 13.904-95.813 26.432-29.9 11.928-58.907 26.91-87.395 43.973-27.793 16.649-54.717 35.05-81.762 54.466-26.878 19.298-51.494 37.868-78.865 57.814-25.384 18.501-51.52 36.986-78.757 53.949-3.7829 2.3567-7.5923 4.6863-11.429 6.9834-22.651 13.562-45.91 25.788-70.083 35.814-28.116 11.663-57.34 20.134-87.109 24.199-31.944 4.3491-64.193 3.4735-95.242-1.9604-59.71-10.448-116.6-28.287-169.18-52.052-45.297-20.483-88.275-45.788-128.38-70.068-39.209-23.715-75.253-45.858-114.4-63.253-19.953-8.8711-40.092-16.173-60.424-21.552-22.432-5.9376-45.01-9.5028-67.225-10.942-11.257-0.7329-22.507-0.1761-33.48 1.3486-11.548 1.6043-22.856 4.2929-33.779 7.6574-24.237 7.459-47.108 18.383-68.19 29.866-24.018 13.09-47.243 27.873-68.437 41.65-25.318 16.461-44.834 29.616-68.089 44.099-23.592 14.698-45.138 27.019-67.285 37.156l-5e-5 1e-5c-23.261 10.658-44.857 17.699-66.092 20.738-11.408 1.6286-22.251 1.9739-32.432 1.1906-11.755-0.90614-22.456-3.3268-31.839-6.55-12.497-4.2953-22.963-10.094-31.035-15.46-21.73-14.446-29.305-26.197-29.657-25.848 0.9133-0.90537 9.0805 10.28 30.918 23.89 8.0956 5.046 18.506 10.485 30.772 14.413 9.2115 2.9521 19.667 5.1079 31.1 5.7939 9.9062 0.59591 20.442 0.0882 31.54-1.6584 20.689-3.2486 41.696-10.435 64.55-21.194 0-1e-5 6e-5 -3e-5 6e-5 -3e-5 21.757-10.254 42.927-22.665 66.288-37.513 23.141-14.713 42.245-27.839 67.616-44.618 21.132-13.977 44.382-29.008 68.602-42.425 21.242-11.774 44.483-23.033 69.383-30.878 11.231-3.5357 22.928-6.3811 34.958-8.1246 11.437-1.6574 23.221-2.2979 35.091-1.5919 22.729 1.3566 45.851 4.8938 68.855 10.871 20.845 5.4197 41.449 12.785 61.804 21.743 39.892 17.568 76.387 39.774 115.61 63.36 40.117 24.101 82.857 49.13 127.58 69.21 51.919 23.327 108.06 40.823 166.96 51.049 30.095 5.2243 61.333 6.0441 92.208 1.8078 28.793-3.9376 57.187-12.203 84.628-23.582 23.611-9.7907 46.43-21.802 68.77-35.174 3.7837-2.2648 7.5442-4.563 11.282-6.8889 26.908-16.749 52.852-35.094 78.171-53.521 27.254-19.839 51.993-38.468 78.967-57.796 27.184-19.48 54.363-38 82.514-54.812 28.857-17.236 58.36-32.397 88.863-44.505 32.049-12.72 64.904-21.84 97.968-26.775 33.982-5.0598 68.163-3.6237 100.5 2.8356 33.861 6.7738 65.94 18.754 95.613 32.662 33.308 15.603 64.83 34.069 94.134 52.272 32.03 19.892 67.194 43.206 96.272 61.958 35.756 23.056 68.55 43.405 101.96 61.877 39.022 21.577 75.592 38.727 111.14 52.11 45.906 17.282 87.611 27.258 123.9 32.756 43.839 6.6445 80.807 6.8612 103.93 6.2807 23.963-0.60158 36.569-2.039 36.625-1.4842z\"/>\n    <path d=\"m2667.3-1012c-0.3134 1.8376-40.183-7.9091-113.29-7.5637-30.575 0.144-65.862 2.1839-106.61 7.5603h-1e-4c-61.594 8.1234-119.19 21.448-197.34 40.476-28.848 7.0267-60.775 14.817-92.37 21.389-28.391 5.9072-58.463 11.251-89.23 14.354-28.026 2.8292-57.296 3.815-86.871 1.3588-28.33-2.3556-57.121-7.9935-85.151-17.69-27.677-9.5902-54.134-23.268-79.411-39.709-25.04-16.282-48.6-34.902-71.804-54.828-23.232-19.946-45.213-40.392-68.28-61.464-22.156-20.235-44.94-40.736-68.771-59.757-17.228-13.746-35.193-26.89-54.068-38.621-6.2805-3.9034-12.639-7.636-19.085-11.176-25.942-14.246-53.27-25.264-81.423-31.777-31.028-7.1968-62.946-8.8381-93.94-5.8543-38.637 3.707-76.068 14.386-111.04 28.312-41.302 16.462-80.555 35.977-117.45 56.666-38.673 21.685-75.524 45.106-110.02 68.306-35.826 24.099-71.18 49.404-103.37 72.604-35.388 25.502-65.184 47.183-97.548 69.526-32.75 22.612-62.444 41.937-92.558 59.049l-6e-5 3e-5c-31.508 17.911-60.116 31.428-88.414 41.114l-5e-5 1e-5c-15.014 5.1377-29.255 8.9101-42.899 11.463-15.222 2.8484-29.267 4.075-42.114 4.1071-16.058 0.0394-29.967-1.8093-41.327-4.2428-27.54-5.9017-40.111-14.356-40.231-14.081 0.4803-1.0961 13.422 6.5002 40.745 11.493 11.272 2.0604 24.993 3.5338 40.766 3.1653 12.623-0.29427 26.386-1.759 41.307-4.8059 13.376-2.7315 27.326-6.6577 42.063-11.927l5e-5 -2e-5c27.805-9.9388 55.863-23.625 86.978-41.721-1e-5 0 5e-5 -3e-5 5e-5 -3e-5 29.736-17.299 59.039-36.753 91.539-59.566 32.225-22.622 61.567-44.292 96.949-70.115 32.094-23.425 67.339-48.935 103.22-73.311 34.52-23.454 71.476-47.145 110.37-69.131 37.106-20.976 76.673-40.782 118.42-57.539 35.562-14.288 73.856-25.259 113.67-29.172 31.978-3.1335 64.962-1.4636 97.137 5.959 29.171 6.7466 57.361 18.077 83.993 32.716 6.6115 3.6344 13.124 7.4581 19.546 11.449 19.304 11.995 37.586 25.367 55.024 39.309 24.127 19.284 47.059 39.942 69.231 60.242 23.096 21.142 44.959 41.54 67.969 61.362 22.983 19.792 46.155 38.199 70.664 54.206 24.729 16.146 50.451 29.56 77.244 38.915 27.182 9.5081 55.208 15.092 82.846 17.506 28.869 2.5236 57.611 1.67 85.253-0.97753 30.35-2.9092 60.173-8.0522 88.432-13.757 31.423-6.345 63.371-13.924 92.245-20.74 78.129-18.451 136.54-31.372 198.4-38.807 41.033-4.9291 76.61-6.4764 107.34-6.0806 73.56 0.9485 113.21 12.167 113.27 11.805z\"/>\n   </g>\n  </g>\n  <g transform=\"translate(470.51 75.115)\">\n   <path d=\"m-93.285-1605.3c0.08594-0.6772 23.378 2.2958 66.831 5.9659 41.032 3.4657 109.46 8.2907 187.46 6.5897 57.935-1.2634 126.94-6.236 200.09-20.124 50.638-9.6129 104.12-23.74 158.87-43.773 43.059-15.754 86.094-34.894 130.46-57.093 39.228-19.629 73.665-38.579 114.82-60.067 35.419-18.5 72.86-37.155 111.87-52.565 38.385-15.163 79.127-27.309 121.48-34.314 46.562-7.6881 94.726-9.1619 143.31-5.178 40.074 3.2842 80.211 10.174 120.11 20.124 38.291 9.5491 76.136 21.818 113.68 36.098 0.7259 0.2761 1.4514 0.5528 2.1764 0.8302 78.143 29.897 153.18 67.599 223.94 104.23 78.015 40.376 147.24 77.603 222.03 111.68 78.284 35.653 153.74 63.451 230.17 79.791 31.825 6.8288 64.465 7.9047 95.688 6.644 36.526-1.487 72.556-6.3598 106.45-12.033 38.101-6.3803 76.514-14.41 111.18-21.719 40-8.4352 73.906-15.728 109.98-22.276 37.189-6.7549 70.302-11.554 102.92-13.66 16.423-1.0597 31.972-1.3485 47.002-0.7157 15.279 0.6422 29.549 2.2309 43.053 4.9172 14.045 2.7929 26.799 6.7162 38.341 11.734 12.805 5.5683 23.72 12.369 32.795 19.721l1e-4 1e-4c11.625 9.4228 20.212 19.746 26.337 28.799 16.135 23.855 17.771 39.298 18.498 39.037-1.4778 0.5321-3.9208-14.638-20.442-37.683-6.2583-8.7321-14.9-18.652-26.408-27.617v-1e-4c-8.9844-7.0026-19.734-13.438-32.304-18.679-11.336-4.7269-23.85-8.374-37.658-10.938-13.28-2.4647-27.318-3.8489-42.394-4.3152-14.83-0.4575-30.182-0.01-46.441 1.2038-32.321 2.4041-65.111 7.4628-102.14 14.482-35.968 6.8216-69.592 14.307-109.64 23.016-34.649 7.5369-73.071 15.799-111.37 22.42-34.042 5.8878-70.368 10.969-107.41 12.648-31.653 1.4452-64.994 0.4497-97.859-6.4384-77.313-16.261-153.53-44.049-232.27-79.729-75.185-34.056-144.73-71.294-222.65-111.52-70.728-36.503-145.47-74.021-222.98-103.66-0.7192-0.275-1.4388-0.5494-2.1588-0.8231-37.24-14.16-74.702-26.32-112.54-35.772-39.424-9.848-79.023-16.682-118.51-19.954-47.855-3.9633-95.218-2.5914-140.93 4.8891-41.569 6.7909-81.689 18.674-119.59 33.536-38.54 15.11-75.749 33.537-111.12 51.867-41.035 21.272-75.742 40.21-115.15 59.749-44.67 22.146-88.094 41.23-131.58 56.906-55.287 19.929-109.25 33.86-160.31 43.212-73.754 13.507-143.12 17.952-201.3 18.645-78.558 0.9357-146.6-4.8258-187.84-9.1956-43.427-4.6017-66.595-8.5562-66.552-8.893z\"/>\n   <path d=\"m-20.935-1728.3c0.5936-1.1118 40.345 21.594 116.52 51.821 35.849 14.225 78.97 29.779 130.15 45.315 77.251 23.452 172.02 46.781 280.53 61.71 44.127 6.0702 90.863 10.752 139.29 12.914 42.264 1.8857 86.362 1.904 131.18-1.3106 38.559-2.7682 78.192-7.9163 117.43-17.182 33.256-7.8598 66.697-18.721 98.016-34.593 71.608-36.253 112.5-61.431 187.37-100.15 40.684-21.045 82.901-41.372 126.46-59.23 29.338-12.028 58.865-22.765 88.743-31.898 39.555-12.085 79.419-21.246 119.37-26.982 43.004-6.1727 85.854-8.3032 127.87-6.4401 47.119 2.0922 93.014 9.1982 136.76 20.197 51.792 13.024 100.72 31.471 146 52.849h1e-4c94.554 44.627 180.72 77.751 265.71 99.672 74.89 19.298 140.29 27.78 201.6 24.679 28.562-1.4406 54.57-5.4553 78.322-11.833 24.666-6.6225 46.025-15.583 64.262-25.846 21.542-12.121 38.342-25.855 50.978-38.345 29.325-28.982 37.409-50.043 39.026-49.115-0.7433-0.4265-7.8943 21.175-36.913 51.205-12.506 12.94-29.302 27.209-51.018 39.874-18.381 10.717-39.991 20.14-64.979 27.163-24.056 6.7606-50.428 11.131-79.35 12.859-62.004 3.6952-128.31-4.3252-203.79-23.328-85.682-21.551-172.61-54.458-267.64-98.914h-1e-4c-44.906-20.997-93.338-39.09-144.49-51.804-43.196-10.739-88.473-17.649-134.9-19.624-41.403-1.7639-83.64 0.4002-126.04 6.5321-39.399 5.6965-78.756 14.779-117.87 26.743-29.543 9.0338-58.776 19.673-87.867 31.605-43.186 17.713-85.15 37.905-125.68 58.821-73.494 37.937-116.68 64.214-187.57 99.947-32.247 16.238-66.415 27.278-100.22 35.157-39.89 9.3053-80.023 14.411-118.96 17.071-45.263 3.0958-89.7 2.9161-132.22 0.8372-48.733-2.3812-95.696-7.3117-140-13.652-108.93-15.59-203.89-39.708-281.16-63.998-51.172-16.086-94.275-32.23-129.99-47.044-75.951-31.506-115.06-55.493-114.95-55.687z\" fill-rule=\"evenodd\"/>\n   <path d=\"m123.76-1506.4c0.50996 0.5539 40.949-44.399 125.79-107.02 32.495-23.984 73.104-51.386 119.94-76.691 33.823-18.276 72.031-36.053 113.86-50.689 33.614-11.761 69.936-21.595 108.39-28.125 33.085-5.6177 67.742-8.7792 103.55-8.9644 32.426-0.1667 65.595 2.0974 99.335 6.7642 62.427 8.6428 124.69 25.157 188.77 46.854 60.647 20.528 117.96 43.782 180.47 68.246 31.764 12.427 64.275 24.928 97.075 36.438 27.073 9.5 54.027 18.215 81.137 25.811 30.066 8.4263 60.073 15.394 90.138 20.407 30.81 5.1376 61.483 8.1843 91.857 8.7971 32.088 0.6488 63.7-1.4301 94.413-6.146 33.925-5.2067 66.714-13.622 97.866-24.459 124.36-43.266 237.42-86.788 333.99-125.77 24.78-10.002 95.465-38.887 114.58-46.628 32.119-13.008 58.807-23.675 86.56-33.569 23.419-8.3548 43.36-14.72 63.775-18.821 8.694-1.747 16.932-2.911 24.998-3.3227 7.4972-0.3847 14.569-0.071 21.27 1.0779 6.6561 1.1428 12.731 3.1256 18.107 5.7541 6.0876 2.9824 11.234 6.7723 15.422 10.621 5.697 5.2381 10.088 10.935 13.271 15.603 8.8831 13.022 11.253 21.004 11.348 20.956-0.6896 0.3516-3.6644-7.345-12.944-19.819-3.3133-4.4525-7.8047-9.8851-13.441-14.761-4.1409-3.5833-9.1647-7.0796-15.004-9.7604-5.1551-2.3716-10.965-4.1152-17.326-5.0738-6.4168-0.9683-13.204-1.1248-20.464-0.6247-7.8153 0.5405-15.816 1.8196-24.332 3.6714-20.05 4.3607-39.589 10.926-62.844 19.543-27.587 10.229-53.9 21.091-85.965 34.44-29.924 12.458-78.535 32.898-114.2 47.597-96.402 39.728-209.33 83.867-333.74 127.62-31.616 11.119-64.935 19.772-99.461 25.162-31.257 4.8781-63.422 7.0657-96.063 6.4635-30.894-0.5712-62.049-3.6145-93.291-8.7903-30.483-5.0502-60.849-12.069-91.206-20.563-27.367-7.6584-54.53-16.431-81.757-25.983-32.993-11.574-65.604-24.125-97.399-36.595-62.612-24.548-119.67-47.796-179.96-68.331-63.662-21.676-125.27-38.221-186.92-46.956-33.317-4.725-66.048-7.0922-98.035-7.0662-35.317 0.027-69.528 2.9763-102.21 8.3414-37.985 6.2343-73.94 15.73-107.27 27.132-41.479 14.187-79.496 31.508-113.23 49.334-46.7 24.676-87.431 51.496-120.11 74.912-85.377 61.182-126.99 104.87-128.73 102.98z\" fill-rule=\"evenodd\"/>\n   <path d=\"m2788.7-1781.3c-0.1327 0.1681-2.532-1.6824-7.4519-4.9662-4.3846-2.9265-12.857-8.3975-22.969-12.227-6.9179-2.618-16.001-4.9533-25.658-4.254-7.1749 0.5053-14.808 2.7539-22.116 6.9839-6.9915 4.0417-13.421 9.6251-19.604 16.504-6.3876 7.1158-12.118 15.187-17.762 24.348-5.7832 9.3921-11.108 19.378-16.499 30.356-11.234 22.875-19.866 43.778-31.717 71.201-9.6935 22.44-21.015 48.281-34.386 72.68-5.8965 10.76-12.446 21.688-19.901 32.241-6.6176 9.3713-14.086 18.618-22.686 27.029-7.6891 7.5243-16.43 14.445-26.27 19.881-9.3267 5.1465-19.676 8.8735-30.562 10.621-11.545 1.8371-23.486 1.4531-35.22-0.7608-13.85-2.6149-27.258-7.5616-40.176-13.922v-1e-4c-48.825-23.994-96.726-55.389-143.39-94.046-37.944-31.432-71.085-64.049-109.35-99.993-30.972-29.066-64.39-59.321-102.08-82.559-17.74-10.95-36.682-20.466-56.637-27.695-20.724-7.5141-42.588-12.566-64.99-15.062-17.29-1.9275-34.891-2.2549-52.567-1.1638-17.778 1.0972-35.592 3.6283-53.34 7.3177-36.628 7.6084-72.54 20.021-108.06 35.261-36.684 15.744-72.424 34.322-108.17 54.558-35.654 20.185-70.577 41.651-106.22 63.859-33.378 20.797-67.776 42.548-102.3 63.112-31.08 18.517-63.111 36.668-96.529 52.314-0.389 0.1821-0.7782 0.3639-1.1677 0.5453-14.549 6.777-29.32 13.022-44.411 18.411-14.227 5.0828-28.739 9.3908-43.552 12.443-13.586 2.8023-27.436 4.511-41.36 4.5766h-1e-4c-13.092 0.062-26.218-1.4006-38.915-4.7288-27.5-7.2372-53.881-17.632-79.315-28.831-30.54-13.438-60.243-28.408-89.158-43.573-32.397-16.99-64.646-34.733-95.932-51.912-33.745-18.529-66.368-36.433-99.493-53.854-33.48-17.607-66.445-34.205-99.776-49.39-32.255-14.692-64.245-27.834-96.726-38.518-30.084-9.8883-60.054-17.571-90.26-21.283-27.362-3.3487-54.527-3.3899-80.334 2.1184-25.082 5.3254-49.15 13.635-71.764 23.873-23.434 10.609-45.524 23.367-66.209 37.066-44.399 29.396-85.027 64.948-120.97 97.337-42.349 38.178-74.874 69.155-114.41 100.48-19.449 15.408-38.515 29.075-58.111 40.91-20.218 12.213-40.291 21.974-60.545 29.026-18.831 6.5616-36.98 10.983-54.945 12.505h-6e-5c-14.523 1.2395-28.389 0.4305-41.204-3.1704-10.846-3.0479-20.508-8.1758-28.146-15.067-7.3024-6.607-12.504-14.674-15.615-22.924-3.3877-8.9998-4.3936-18.207-3.8823-26.544 0.60448-9.8866 3.2932-18.762 6.8451-26.102 4.6365-9.5839 10.809-16.713 16.607-21.671 7.1023-6.0704 14.115-9.2763 18.425-10.882 4.5272-1.6864 6.9784-2.0136 7.0013-1.9321 0.0582 0.2069-2.3103 0.8257-6.6637 2.76-4.1362 1.8378-10.888 5.2789-17.594 11.379-5.4912 4.9919-11.28 12.049-15.555 21.391-3.2733 7.1554-5.6884 15.744-6.0987 25.212-0.34419 7.9774 0.75686 16.73 4.0875 25.166 3.044 7.7231 8.0526 15.241 14.964 21.324 7.2201 6.3743 16.406 11.068 26.738 13.863 12.246 3.3139 25.572 3.9077 39.681 2.5856h6e-5c17.461-1.647 35.141-6.1575 53.637-12.77 19.798-7.0845 39.431-16.849 59.285-29.043 19.246-11.823 37.993-25.477 57.197-40.898 39.113-31.411 71.199-62.368 113.49-100.9 35.833-32.658 76.544-68.607 121.4-98.61 20.902-13.977 43.31-27.033 67.186-37.96 23.048-10.547 47.652-19.135 73.388-24.699 26.978-5.8028 55.107-5.9018 83.169-2.5071 30.964 3.7303 61.531 11.452 92.009 21.402 32.921 10.74 65.261 23.926 97.753 38.646 33.584 15.213 66.747 31.824 100.35 49.423 33.251 17.412 65.966 35.297 99.733 53.776 31.312 17.135 63.537 34.813 95.833 51.705 28.838 15.081 58.354 29.928 88.59 43.2 25.211 11.058 51.112 21.265 77.858 28.267 11.747 3.0885 24.015 4.4355 36.343 4.3855h2e-4c13.13-0.053 26.321-1.6986 39.39-4.3849 14.252-2.9328 28.314-7.1182 42.205-12.075 14.732-5.2594 29.216-11.388 43.551-18.062 0.3837-0.1787 0.7673-0.3577 1.1507-0.5371 32.952-15.416 64.696-33.409 95.661-51.834 34.373-20.457 68.736-42.163 102.16-62.957 35.69-22.204 70.756-43.714 106.64-63.978 35.968-20.317 72.056-39.009 109.2-54.894 35.962-15.386 72.512-27.93 109.95-35.653 18.147-3.7411 36.413-6.2957 54.691-7.3899 18.176-1.0881 36.312-0.7073 54.168 1.3202 23.104 2.6246 45.659 7.8974 67.061 15.714 20.601 7.5307 40.067 17.368 58.224 28.654 38.519 23.966 72.276 54.663 103.22 83.946 38.253 36.172 71.095 68.758 108.6 100.07 46.09 38.49 93.325 69.788 141.48 93.761h1e-4c12.467 6.1959 25.239 11.015 38.308 13.536 11.04 2.1311 22.198 2.5763 32.888 0.9212 10.074-1.545 19.734-4.9615 28.478-9.7079 9.2528-5.0162 17.583-11.54 25.01-18.692 8.3102-8.0059 15.604-16.921 22.14-26.024 7.3586-10.252 13.872-20.946 19.78-31.525 13.392-23.981 24.877-49.614 34.766-71.93 12.049-27.198 21.004-48.244 32.538-71.074 5.5536-10.994 11.071-21.038 17.06-30.492 5.8384-9.2215 11.827-17.399 18.496-24.62 6.4499-6.9928 13.261-12.69 20.658-16.818 7.7724-4.3323 15.874-6.5372 23.458-6.9264 10.203-0.5042 19.519 2.1231 26.536 5.013 10.298 4.2388 18.528 10.014 22.824 13.238 4.7602 3.5721 6.9508 5.6845 6.8763 5.7788z\" fill-rule=\"evenodd\"/>\n   <g transform=\"matrix(-1 0 0 1 2564.4 0)\">\n    <path d=\"m-93.285-1605.3c0.08594-0.6772 23.378 2.2958 66.831 5.9659 41.032 3.4657 109.46 8.2907 187.46 6.5897 57.935-1.2634 126.94-6.236 200.09-20.124 50.638-9.6129 104.12-23.74 158.87-43.773 43.059-15.754 86.094-34.894 130.46-57.093 39.228-19.629 73.665-38.579 114.82-60.067 35.419-18.5 72.86-37.155 111.87-52.565 38.385-15.163 79.127-27.309 121.48-34.314 46.562-7.6881 94.726-9.1619 143.31-5.178 40.074 3.2842 80.211 10.174 120.11 20.124 38.291 9.5491 76.136 21.818 113.68 36.098 0.7259 0.2761 1.4514 0.5528 2.1764 0.8302 78.143 29.897 153.18 67.599 223.94 104.23 78.015 40.376 147.24 77.603 222.03 111.68 78.284 35.653 153.74 63.451 230.17 79.791 31.825 6.8288 64.465 7.9047 95.688 6.644 36.526-1.487 72.556-6.3598 106.45-12.033 38.101-6.3803 76.514-14.41 111.18-21.719 40-8.4352 73.906-15.728 109.98-22.276 37.189-6.7549 70.302-11.554 102.92-13.66 16.423-1.0597 31.972-1.3485 47.002-0.7157 15.279 0.6422 29.549 2.2309 43.053 4.9172 14.045 2.7929 26.799 6.7162 38.341 11.734 12.805 5.5683 23.72 12.369 32.795 19.721l1e-4 1e-4c11.625 9.4228 20.212 19.746 26.337 28.799 16.135 23.855 17.771 39.298 18.498 39.037-1.4778 0.5321-3.9208-14.638-20.442-37.683-6.2583-8.7321-14.9-18.652-26.408-27.617v-1e-4c-8.9844-7.0026-19.734-13.438-32.304-18.679-11.336-4.7269-23.85-8.374-37.658-10.938-13.28-2.4647-27.318-3.8489-42.394-4.3152-14.83-0.4575-30.182-0.01-46.441 1.2038-32.321 2.4041-65.111 7.4628-102.14 14.482-35.968 6.8216-69.592 14.307-109.64 23.016-34.649 7.5369-73.071 15.799-111.37 22.42-34.042 5.8878-70.368 10.969-107.41 12.648-31.653 1.4452-64.994 0.4497-97.859-6.4384-77.313-16.261-153.53-44.049-232.27-79.729-75.185-34.056-144.73-71.294-222.65-111.52-70.728-36.503-145.47-74.021-222.98-103.66-0.7192-0.275-1.4388-0.5494-2.1588-0.8231-37.24-14.16-74.702-26.32-112.54-35.772-39.424-9.848-79.023-16.682-118.51-19.954-47.855-3.9633-95.218-2.5914-140.93 4.8891-41.569 6.7909-81.689 18.674-119.59 33.536-38.54 15.11-75.749 33.537-111.12 51.867-41.035 21.272-75.742 40.21-115.15 59.749-44.67 22.146-88.094 41.23-131.58 56.906-55.287 19.929-109.25 33.86-160.31 43.212-73.754 13.507-143.12 17.952-201.3 18.645-78.558 0.9357-146.6-4.8258-187.84-9.1956-43.427-4.6017-66.595-8.5562-66.552-8.893z\"/>\n    <path d=\"m-20.935-1728.3c0.5936-1.1118 40.345 21.594 116.52 51.821 35.849 14.225 78.97 29.779 130.15 45.315 77.251 23.452 172.02 46.781 280.53 61.71 44.127 6.0702 90.863 10.752 139.29 12.914 42.264 1.8857 86.362 1.904 131.18-1.3106 38.559-2.7682 78.192-7.9163 117.43-17.182 33.256-7.8598 66.697-18.721 98.016-34.593 71.608-36.253 112.5-61.431 187.37-100.15 40.684-21.045 82.901-41.372 126.46-59.23 29.338-12.028 58.865-22.765 88.743-31.898 39.555-12.085 79.419-21.246 119.37-26.982 43.004-6.1727 85.854-8.3032 127.87-6.4401 47.119 2.0922 93.014 9.1982 136.76 20.197 51.792 13.024 100.72 31.471 146 52.849h1e-4c94.554 44.627 180.72 77.751 265.71 99.672 74.89 19.298 140.29 27.78 201.6 24.679 28.562-1.4406 54.57-5.4553 78.322-11.833 24.666-6.6225 46.025-15.583 64.262-25.846 21.542-12.121 38.342-25.855 50.978-38.345 29.325-28.982 37.409-50.043 39.026-49.115-0.7433-0.4265-7.8943 21.175-36.913 51.205-12.506 12.94-29.302 27.209-51.018 39.874-18.381 10.717-39.991 20.14-64.979 27.163-24.056 6.7606-50.428 11.131-79.35 12.859-62.004 3.6952-128.31-4.3252-203.79-23.328-85.682-21.551-172.61-54.458-267.64-98.914h-1e-4c-44.906-20.997-93.338-39.09-144.49-51.804-43.196-10.739-88.473-17.649-134.9-19.624-41.403-1.7639-83.64 0.4002-126.04 6.5321-39.399 5.6965-78.756 14.779-117.87 26.743-29.543 9.0338-58.776 19.673-87.867 31.605-43.186 17.713-85.15 37.905-125.68 58.821-73.494 37.937-116.68 64.214-187.57 99.947-32.247 16.238-66.415 27.278-100.22 35.157-39.89 9.3053-80.023 14.411-118.96 17.071-45.263 3.0958-89.7 2.9161-132.22 0.8372-48.733-2.3812-95.696-7.3117-140-13.652-108.93-15.59-203.89-39.708-281.16-63.998-51.172-16.086-94.275-32.23-129.99-47.044-75.951-31.506-115.06-55.493-114.95-55.687z\" fill-rule=\"evenodd\"/>\n    <path d=\"m123.76-1506.4c0.50996 0.5539 40.949-44.399 125.79-107.02 32.495-23.984 73.104-51.386 119.94-76.691 33.823-18.276 72.031-36.053 113.86-50.689 33.614-11.761 69.936-21.595 108.39-28.125 33.085-5.6177 67.742-8.7792 103.55-8.9644 32.426-0.1667 65.595 2.0974 99.335 6.7642 62.427 8.6428 124.69 25.157 188.77 46.854 60.647 20.528 117.96 43.782 180.47 68.246 31.764 12.427 64.275 24.928 97.075 36.438 27.073 9.5 54.027 18.215 81.137 25.811 30.066 8.4263 60.073 15.394 90.138 20.407 30.81 5.1376 61.483 8.1843 91.857 8.7971 32.088 0.6488 63.7-1.4301 94.413-6.146 33.925-5.2067 66.714-13.622 97.866-24.459 124.36-43.266 237.42-86.788 333.99-125.77 24.78-10.002 95.465-38.887 114.58-46.628 32.119-13.008 58.807-23.675 86.56-33.569 23.419-8.3548 43.36-14.72 63.775-18.821 8.694-1.747 16.932-2.911 24.998-3.3227 7.4972-0.3847 14.569-0.071 21.27 1.0779 6.6561 1.1428 12.731 3.1256 18.107 5.7541 6.0876 2.9824 11.234 6.7723 15.422 10.621 5.697 5.2381 10.088 10.935 13.271 15.603 8.8831 13.022 11.253 21.004 11.348 20.956-0.6896 0.3516-3.6644-7.345-12.944-19.819-3.3133-4.4525-7.8047-9.8851-13.441-14.761-4.1409-3.5833-9.1647-7.0796-15.004-9.7604-5.1551-2.3716-10.965-4.1152-17.326-5.0738-6.4168-0.9683-13.204-1.1248-20.464-0.6247-7.8153 0.5405-15.816 1.8196-24.332 3.6714-20.05 4.3607-39.589 10.926-62.844 19.543-27.587 10.229-53.9 21.091-85.965 34.44-29.924 12.458-78.535 32.898-114.2 47.597-96.402 39.728-209.33 83.867-333.74 127.62-31.616 11.119-64.935 19.772-99.461 25.162-31.257 4.8781-63.422 7.0657-96.063 6.4635-30.894-0.5712-62.049-3.6145-93.291-8.7903-30.483-5.0502-60.849-12.069-91.206-20.563-27.367-7.6584-54.53-16.431-81.757-25.983-32.993-11.574-65.604-24.125-97.399-36.595-62.612-24.548-119.67-47.796-179.96-68.331-63.662-21.676-125.27-38.221-186.92-46.956-33.317-4.725-66.048-7.0922-98.035-7.0662-35.317 0.027-69.528 2.9763-102.21 8.3414-37.985 6.2343-73.94 15.73-107.27 27.132-41.479 14.187-79.496 31.508-113.23 49.334-46.7 24.676-87.431 51.496-120.11 74.912-85.377 61.182-126.99 104.87-128.73 102.98z\" fill-rule=\"evenodd\"/>\n    <path d=\"m2788.7-1781.3c-0.1327 0.1681-2.532-1.6824-7.4519-4.9662-4.3846-2.9265-12.857-8.3975-22.969-12.227-6.9179-2.618-16.001-4.9533-25.658-4.254-7.1749 0.5053-14.808 2.7539-22.116 6.9839-6.9915 4.0417-13.421 9.6251-19.604 16.504-6.3876 7.1158-12.118 15.187-17.762 24.348-5.7832 9.3921-11.108 19.378-16.499 30.356-11.234 22.875-19.866 43.778-31.717 71.201-9.6935 22.44-21.015 48.281-34.386 72.68-5.8965 10.76-12.446 21.688-19.901 32.241-6.6176 9.3713-14.086 18.618-22.686 27.029-7.6891 7.5243-16.43 14.445-26.27 19.881-9.3267 5.1465-19.676 8.8735-30.562 10.621-11.545 1.8371-23.486 1.4531-35.22-0.7608-13.85-2.6149-27.258-7.5616-40.176-13.922v-1e-4c-48.825-23.994-96.726-55.389-143.39-94.046-37.944-31.432-71.085-64.049-109.35-99.993-30.972-29.066-64.39-59.321-102.08-82.559-17.74-10.95-36.682-20.466-56.637-27.695-20.724-7.5141-42.588-12.566-64.99-15.062-17.29-1.9275-34.891-2.2549-52.567-1.1638-17.778 1.0972-35.592 3.6283-53.34 7.3177-36.628 7.6084-72.54 20.021-108.06 35.261-36.684 15.744-72.424 34.322-108.17 54.558-35.654 20.185-70.577 41.651-106.22 63.859-33.378 20.797-67.776 42.548-102.3 63.112-31.08 18.517-63.111 36.668-96.529 52.314-0.389 0.1821-0.7782 0.3639-1.1677 0.5453-14.549 6.777-29.32 13.022-44.411 18.411-14.227 5.0828-28.739 9.3908-43.552 12.443-13.586 2.8023-27.436 4.511-41.36 4.5766h-1e-4c-13.092 0.062-26.218-1.4006-38.915-4.7288-27.5-7.2372-53.881-17.632-79.315-28.831-30.54-13.438-60.243-28.408-89.158-43.573-32.397-16.99-64.646-34.733-95.932-51.912-33.745-18.529-66.368-36.433-99.493-53.854-33.48-17.607-66.445-34.205-99.776-49.39-32.255-14.692-64.245-27.834-96.726-38.518-30.084-9.8883-60.054-17.571-90.26-21.283-27.362-3.3487-54.527-3.3899-80.334 2.1184-25.082 5.3254-49.15 13.635-71.764 23.873-23.434 10.609-45.524 23.367-66.209 37.066-44.399 29.396-85.027 64.948-120.97 97.337-42.349 38.178-74.874 69.155-114.41 100.48-19.449 15.408-38.515 29.075-58.111 40.91-20.218 12.213-40.291 21.974-60.545 29.026-18.831 6.5616-36.98 10.983-54.945 12.505h-6e-5c-14.523 1.2395-28.389 0.4305-41.204-3.1704-10.846-3.0479-20.508-8.1758-28.146-15.067-7.3024-6.607-12.504-14.674-15.615-22.924-3.3877-8.9998-4.3936-18.207-3.8823-26.544 0.60448-9.8866 3.2932-18.762 6.8451-26.102 4.6365-9.5839 10.809-16.713 16.607-21.671 7.1023-6.0704 14.115-9.2763 18.425-10.882 4.5272-1.6864 6.9784-2.0136 7.0013-1.9321 0.0582 0.2069-2.3103 0.8257-6.6637 2.76-4.1362 1.8378-10.888 5.2789-17.594 11.379-5.4912 4.9919-11.28 12.049-15.555 21.391-3.2733 7.1554-5.6884 15.744-6.0987 25.212-0.34419 7.9774 0.75686 16.73 4.0875 25.166 3.044 7.7231 8.0526 15.241 14.964 21.324 7.2201 6.3743 16.406 11.068 26.738 13.863 12.246 3.3139 25.572 3.9077 39.681 2.5856h6e-5c17.461-1.647 35.141-6.1575 53.637-12.77 19.798-7.0845 39.431-16.849 59.285-29.043 19.246-11.823 37.993-25.477 57.197-40.898 39.113-31.411 71.199-62.368 113.49-100.9 35.833-32.658 76.544-68.607 121.4-98.61 20.902-13.977 43.31-27.033 67.186-37.96 23.048-10.547 47.652-19.135 73.388-24.699 26.978-5.8028 55.107-5.9018 83.169-2.5071 30.964 3.7303 61.531 11.452 92.009 21.402 32.921 10.74 65.261 23.926 97.753 38.646 33.584 15.213 66.747 31.824 100.35 49.423 33.251 17.412 65.966 35.297 99.733 53.776 31.312 17.135 63.537 34.813 95.833 51.705 28.838 15.081 58.354 29.928 88.59 43.2 25.211 11.058 51.112 21.265 77.858 28.267 11.747 3.0885 24.015 4.4355 36.343 4.3855h2e-4c13.13-0.053 26.321-1.6986 39.39-4.3849 14.252-2.9328 28.314-7.1182 42.205-12.075 14.732-5.2594 29.216-11.388 43.551-18.062 0.3837-0.1787 0.7673-0.3577 1.1507-0.5371 32.952-15.416 64.696-33.409 95.661-51.834 34.373-20.457 68.736-42.163 102.16-62.957 35.69-22.204 70.756-43.714 106.64-63.978 35.968-20.317 72.056-39.009 109.2-54.894 35.962-15.386 72.512-27.93 109.95-35.653 18.147-3.7411 36.413-6.2957 54.691-7.3899 18.176-1.0881 36.312-0.7073 54.168 1.3202 23.104 2.6246 45.659 7.8974 67.061 15.714 20.601 7.5307 40.067 17.368 58.224 28.654 38.519 23.966 72.276 54.663 103.22 83.946 38.253 36.172 71.095 68.758 108.6 100.07 46.09 38.49 93.325 69.788 141.48 93.761h1e-4c12.467 6.1959 25.239 11.015 38.308 13.536 11.04 2.1311 22.198 2.5763 32.888 0.9212 10.074-1.545 19.734-4.9615 28.478-9.7079 9.2528-5.0162 17.583-11.54 25.01-18.692 8.3102-8.0059 15.604-16.921 22.14-26.024 7.3586-10.252 13.872-20.946 19.78-31.525 13.392-23.981 24.877-49.614 34.766-71.93 12.049-27.198 21.004-48.244 32.538-71.074 5.5536-10.994 11.071-21.038 17.06-30.492 5.8384-9.2215 11.827-17.399 18.496-24.62 6.4499-6.9928 13.261-12.69 20.658-16.818 7.7724-4.3323 15.874-6.5372 23.458-6.9264 10.203-0.5042 19.519 2.1231 26.536 5.013 10.298 4.2388 18.528 10.014 22.824 13.238 4.7602 3.5721 6.9508 5.6845 6.8763 5.7788z\" fill-rule=\"evenodd\"/>\n   </g>\n  </g>\n </g>\n</svg>\n");
INSERT INTO `wp_464683_postmeta` VALUES("563", "374", "_wp_attached_file", "2019/11/elegant-1769669-1.svg");
INSERT INTO `wp_464683_postmeta` VALUES("564", "374", "_wp_attachment_metadata", "a:2:{s:5:\"width\";d:2641.46500000000014551915228366851806640625;s:6:\"height\";d:318.75;}");
INSERT INTO `wp_464683_postmeta` VALUES("565", "374", "_elementor_inline_svg", "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<!DOCTYPE svg  PUBLIC \'-//W3C//DTD SVG 1.1//EN\'  \'http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd\'>\n<svg enable-background=\"new 0 0 2641.465 318.75\" version=\"1.1\" viewBox=\"0 0 2641.465 318.75\" xml:space=\"preserve\" xmlns=\"http://www.w3.org/2000/svg\">\n	<path d=\"m1742.1 193.97c-8.155 0.553-8.818 14.018-1.059 15.756 7.902 1.975 16.151 0.774 24.195 1.027 268.66-0.016 537.31-0.016 805.97 0 7.68-0.19 15.487 0.758 23.057-0.759 3.856-0.743 6.542-4.551 6.495-8.344-0.095-5.547-5.452-8.613-10.541-8.107-272.88 0.047-545.77 0-818.66 0.031-9.798 0.254-19.675-0.726-29.457 0.396z\" enable-background=\"new    \"/>\n	<path d=\"m899.39 193.97c8.155 0.553 8.818 14.018 1.059 15.756-7.902 1.975-16.151 0.774-24.195 1.027-268.66-0.016-537.31-0.016-805.97 0-7.68-0.19-15.487 0.758-23.057-0.759-3.856-0.743-6.542-4.551-6.495-8.344 0.095-5.547 5.452-8.613 10.541-8.107 272.88 0.047 545.77 0 818.66 0.031 9.798 0.254 19.675-0.726 29.457 0.396z\" enable-background=\"new    \"/>\n	<path d=\"m1686 201.38c-0.743 12.169 12.943 22.757 24.448 17.969 9.166-2.845 14.35-13.117 11.805-22.251-1.849-7.017-8.233-12.88-15.614-13.275-10.383-1.818-20.718 7.048-20.639 17.557zm27.735-2.386c2.781 6.4-4.488 14.176-11.141 12.564-4.488-0.996-8.076-5.373-7.933-10.003 0.458-4.757 4.536-8.676 9.071-9.592 4.329 0.03 8.581 2.89 10.003 7.031z\" enable-background=\"new    \"/>\n	<path d=\"m955.45 201.38c0.743 12.169-12.943 22.757-24.448 17.969-9.166-2.845-14.35-13.117-11.805-22.251 1.849-7.017 8.233-12.88 15.614-13.275 10.383-1.818 20.718 7.048 20.639 17.557zm-27.735-2.386c-2.781 6.4 4.488 14.176 11.141 12.564 4.488-0.996 8.076-5.373 7.933-10.003-0.458-4.757-4.536-8.676-9.071-9.592-4.329 0.03-8.581 2.89-10.003 7.031z\" enable-background=\"new    \"/>\n	<path d=\"m1320.7 237.4c4.371-0.255 8.733-0.635 13.076-1.14 48.453-4.931 94.441-23.974 135.8-49.085 20.544-12.248 38.845-27.845 59.326-40.204 20.323-12.406 43.127-22.077 67.212-22.82 26.044 0.49 51.298 16.056 63.213 39.255 9.071 17.463 9.925 38.371 4.804 57.161-3.003 11.695-8.36 23.184-17.399 31.433-8.518 7.743-20.228 11.426-31.654 11.015-15.456 0.442-32.223-5.705-40.694-19.264-9.751-15.092-5.784-38.276 10.193-47.489 11.22-6.653 25.349-4.757 36.632 0.695 5.484 2.544 6.795 9.055 10.857 13.085 1.264-4.156 2.876-8.55 1.596-12.864-1.849-6.827-7.286-12.137-13.417-15.361-9.466-5.184-20.876-5.816-31.259-3.414-14.681 3.572-26.455 16.325-29.236 31.117-1.896 10.92-0.616 22.709 5.294 32.27 7.886 13.702 23.531 21.461 38.908 22.773 11.173 0.268 22.725 1.011 33.408-2.971 16.246-5.373 29.015-19.027 34.578-35.052 6.306-18.3 6.59-38.702 0.379-57.066-7.791-23.231-27.214-41.673-50.223-49.686-12.089-4.788-25.396-4.425-38.133-3.366-30.643 4.694-57.619 21.477-82.019 39.73-15.329 11.726-30.991 23.073-47.694 32.823-40.599 23.794-86.317 41.083-133.54 43.728-47.228-2.644-92.947-19.933-133.54-43.728-16.704-9.751-32.365-21.098-47.694-32.823-24.4-18.253-51.376-35.036-82.019-39.73-12.738-1.059-26.044-1.422-38.134 3.366-23.01 8.012-42.432 26.455-50.223 49.686-6.211 18.364-5.926 38.766 0.379 57.066 5.563 16.025 18.332 29.679 34.578 35.052 10.683 3.983 22.235 3.24 33.408 2.971 15.377-1.312 31.022-9.071 38.908-22.773 5.91-9.561 7.191-21.35 5.294-32.27-2.781-14.792-14.555-27.545-29.236-31.117-10.383-2.402-21.793-1.77-31.259 3.414-6.132 3.224-11.568 8.534-13.417 15.361-1.28 4.314 0.332 8.708 1.596 12.864 4.062-4.03 5.373-10.541 10.857-13.085 11.284-5.452 25.412-7.348 36.632-0.695 15.977 9.213 19.944 32.397 10.193 47.489-8.471 13.559-25.238 19.706-40.694 19.264-11.426 0.411-23.136-3.272-31.654-11.015-9.039-8.249-14.397-19.738-17.399-31.433-5.12-18.79-4.267-39.698 4.804-57.161 11.916-23.199 37.169-38.766 63.213-39.255 24.084 0.743 46.889 10.414 67.212 22.82 20.481 12.358 38.782 27.956 59.326 40.204 41.357 25.111 87.345 44.154 135.8 49.085 4.343 0.505 8.704 0.885 13.075 1.14zm0-16.381c23.825-0.755 48.012-9.056 64.959-26.211 14.539-15.14 24.495-34.23 40.441-48.09 8.076-7.601 17.716-13.101 26.834-19.264-9.751-0.901-19.296-3.461-29.094-3.998-14.871-0.158-30.295 0.427-44.012 6.827-20.339 9.15-34.847 27.419-55.201 36.506-1.296 0.53-2.605 1.027-3.926 1.493-1.321-0.466-2.63-0.964-3.926-1.493-20.355-9.087-34.862-27.355-55.201-36.506-13.717-6.401-29.141-6.985-44.012-6.827-9.798 0.537-19.343 3.097-29.094 3.998 9.119 6.163 18.758 11.663 26.834 19.264 15.945 13.859 25.901 32.95 40.441 48.09 16.945 17.155 41.132 25.455 64.957 26.211zm0-42.074c6.04-1.938 11.825-4.583 17.09-8.174 18.158-11.6 31.038-30.516 51.361-38.813 18.174-6.716 38.228-7.933 56.987-2.908-13.259 8.455-26.186 17.668-36.996 29.189-14.745 15.772-28.035 34.372-48.564 43.112-12.601 5.464-26.157 8.587-39.879 9.44-13.721-0.853-27.278-3.975-39.879-9.44-20.529-8.739-33.819-27.34-48.564-43.112-10.81-11.521-23.737-20.734-36.996-29.189 18.759-5.025 38.813-3.809 56.987 2.908 20.323 8.297 33.203 27.213 51.361 38.813 5.267 3.592 11.053 6.237 17.092 8.174zm0-16.967c11.662-8.17 20.736-20.059 25.671-33.433 7.286-19.659 6.416-43.839-7.269-60.558-4.911-6.165-11.296-10.88-18.402-14.036-7.106 3.156-13.491 7.87-18.402 14.036-13.686 16.72-14.555 40.899-7.269 60.558 4.936 13.373 14.009 25.263 25.671 33.433zm0-104.06c8.436 4.271 15.62 10.925 19.982 19.437 6.084 10.73 6.701 23.5 5.405 35.51-2.426 16.99-11.841 32.882-25.387 43.352-13.546-10.47-22.961-26.362-25.387-43.352-1.296-12.01-0.679-24.78 5.405-35.51 4.362-8.512 11.546-15.166 19.982-19.437z\" enable-background=\"new    \"/>\n	<path d=\"m1529.3 230.48c-3.145-7.617-10.588-12.152-17.304-16.277-21.745-12.437-48.532-12.011-71.921-4.789-12.532 4.03-25.175 8.803-35.684 16.957 31.212-0.806 59.263 14.681 89.178 20.892 9.166 1.691 18.948 1.422 27.624-2.149 5.579-2.197 10.509-8.502 8.107-14.634zm-33.582 7.57c-26.692-4.804-52.531-15.74-80.044-14.95 17.225-6.543 35.605-10.841 54.095-10.636 18.648 0.727 38.671 6.669 50.792 21.682-7.38 4.552-16.42 5.216-24.843 3.904z\" enable-background=\"new    \"/>\n	<path d=\"m1112.2 230.48c3.145-7.617 10.588-12.152 17.304-16.277 21.745-12.437 48.532-12.011 71.921-4.789 12.532 4.03 25.175 8.803 35.684 16.957-31.212-0.806-59.263 14.681-89.178 20.892-9.166 1.691-18.948 1.422-27.624-2.149-5.579-2.197-10.51-8.502-8.107-14.634zm33.582 7.57c26.692-4.804 52.531-15.74 80.044-14.95-17.225-6.543-35.605-10.841-54.095-10.636-18.648 0.727-38.671 6.669-50.792 21.682 7.38 4.552 16.419 5.216 24.843 3.904z\" enable-background=\"new    \"/>\n</svg>\n");
INSERT INTO `wp_464683_postmeta` VALUES("566", "375", "_wp_attached_file", "2019/11/floral-17510881.svg");
INSERT INTO `wp_464683_postmeta` VALUES("567", "375", "_wp_attachment_metadata", "a:2:{s:5:\"width\";d:2686.688000000000101863406598567962646484375;s:6:\"height\";d:505.8890000000000100044417195022106170654296875;}");
INSERT INTO `wp_464683_postmeta` VALUES("568", "375", "_elementor_inline_svg", "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<svg enable-background=\"new 0 0 2686.688 505.889\" version=\"1.1\" viewBox=\"0 0 2686.688 505.889\" xml:space=\"preserve\" xmlns=\"http://www.w3.org/2000/svg\">\n	<path d=\"m1400.9 146.11c16.118-9.106 40.85-14.041 41.217-41.839 0.409-30.846-36.902-21.878-29.688 4.104 5.297 19.082-2.352 24.892-12.807 36.113-0.351 0.377-0.375 0.954-0.057 1.359 0.324 0.409 0.893 0.514 1.335 0.263z\"/>\n	<path d=\"m1285.8 146.11c0.454 0.255 1.016 0.14 1.335-0.263 0.785-1-0.457-1.793-2.582-4.037-25.161-26.502-0.638-34.629-12.863-50.712-8.176-10.751-27.397-8.814-27.105 13.173 0.366 27.816 25.152 32.764 41.215 41.839z\"/>\n	<path d=\"m1448 114.89c19.564-11.035 47.46-16.181 47.888-48.528 0.469-35.63-42.542-25.243-34.217 4.731 6.185 22.273-2.72 29.068-14.947 42.172-0.351 0.377-0.375 0.954-0.057 1.359 0.313 0.4 0.878 0.518 1.333 0.266z\"/>\n	<path d=\"m1238.7 114.89c0.455 0.252 1.02 0.134 1.333-0.266 0.785-1-0.404-1.745-2.998-4.474-29.48-31.036-0.758-40.295-14.98-59.005-9.418-12.385-31.577-10.239-31.242 15.217 0.427 32.342 28.314 37.487 47.887 48.528z\"/>\n	<path d=\"m2512 275.94c-64.212 0.265-145.8-3.779-232.63-11.36l-0.34-0.238-0.137 0.196c-6.237-0.545-12.498-1.107-18.784-1.689 52.311-3.386 198.38-8.556 201.34-58.401 1.741-29.462-29.559-29.832-37.678-14.575-6.094 11.442 2.217 27.353 17.594 20.976 13.025-5.4 6.783-19.429-0.866-20.016-5.048-0.374-11.484 4.168-8.966 5.476 0.499 0.257 1.123 0.041 1.404-0.44 0.438-0.751 4.209-3.362 7.71-2.92 5.161 0.655 10.859 11.429-0.081 15.971-13.827 5.74-19.952-8.661-14.947-18.061 7.111-13.351 35.356-13.689 33.744 13.469-2.865 48.214-150.77 53.294-201.34 56.567-13.259 0.859-8.082 1.048-27.123-0.861 8.765-18.857 5.393-41.861-9.168-55.607-38.411-36.266-93.804 22.684-119.5 40.409-29.258-4.047-55.43-8.148-77.128-12.072-12.526-39.093 25.612-58.716 47.165-43.384 15.278 10.865 16.887 37.968-8.873 39.925-20.762 1.576-21.294-20.482-12.578-25.74 5.35-3.231 13.221-1.905 14.253-1.071 0.453 0.364 1.111 0.29 1.47-0.159 2.125-2.622-9.878-4.739-16.802-0.56-10.456 6.314-9.389 31.361 13.817 29.616 27.43-2.082 26.99-31.573 9.926-43.712-22.829-16.237-62.753 4.038-50.701 44.662-53.686-9.824-43.573-10.133-109.3-31.306 8.029-61.449-78.539-134.82-136.26-61.591l1.452 1.481c72.356-54.856 114.77 6.246 120.08 55.431-82.994-25.98-159.75-43.517-229.77-52.519-1.675-17.737-10.176-33.03-25.37-45.566-33.149-27.356-89.751-4.893-89.535 38.543-60.319 0.904-123.17 10.06-177.42 35.206-5.414-17.609-17.331-31.207-33.305-40.569-15.671 9.179-27.808 22.677-33.309 40.568-54.262-25.15-117.13-34.301-177.42-35.206 0.11-22.139-16.438-43.856-43.058-49.22-38.497-7.753-68.738 23.331-71.846 56.243-70.009 9.002-146.76 26.538-229.75 52.516 5.351-49.523 47.911-110.14 120.08-55.428l1.452-1.481c-57.296-72.696-144.43-0.998-136.26 61.587-65.922 21.238-55.569 21.476-109.31 31.31 17.071-57.538-64.585-67.774-62.534-19.093 0.826 19.685 37.328 25.877 41.184 6.192 4.437-22.642-18.699-21.436-22.254-18.577-1.074 0.865 0.233 2.496 1.313 1.629 1.607-1.298 23.032-4.583 18.89 16.545-3.342 17.04-36.314 11.515-37.045-5.879-1.922-45.971 75.744-35.39 58.121 19.605-21.697 3.924-47.868 8.025-77.125 12.071-13.78-9.505-26.457-20.59-34.71-27.211-72.162-57.853-113.37 0.64-93.959 42.409-24.726 2.479-225.26-1.728-228.47-55.705-2.153-36.265 46.921-22.94 33.197 1.529-4.802 8.566-23.054 3.05-20.41-6.308 3.266-11.568 13.012-4.755 13.639-3.68 0.695 1.191 2.415 0.258 1.894-0.886-1.144-2.506-13.653-9.775-17.54 3.995-3.358 11.893 18.303 18.491 24.244 7.897 15.607-27.806-39.471-42.259-37.106-2.428 2.965 50.009 149.62 55.054 201.34 58.401-6.275 0.58-12.523 1.141-18.749 1.685l-0.133-0.19-0.33 0.231c-86.857 7.584-168.46 11.63-232.68 11.365-0.576-2e-3 -1.047 0.464-1.049 1.041-0.011 3.002 112.75 0.15 230.3-10.004l-26.469 18.51c-3.01-3.588-14.942-3.512-15.942-3.052-36.764 17.113-78.315 29.959-115.88 15.836-3.544-1.338-1.372 31.361 52.329 21.166-11.474 7.376-27.8 11.722-41.399 18.54-6.658 3.338-29.556 29.395-28.595 31.125 0.411 0.748-0.141 0.418 10.451 0.37 27.012-0.129 27.034 0.307 49.939-16.778 7.468-5.57 15.15-11.3 23.206-15.002-33.815 34.907-20.732 46.453-15.263 55.992 0.488 0.827 1.745 0.626 1.933-0.32 6.127-30.779 31.804-52.745 56.632-73.989 0.99-0.847 22.087-18.854 22.424-20.116 1.447-5.503 2.098-9.29 1.193-11.941l29.605-20.704c16.074-1.407 32.32-2.932 48.674-4.575 19.282 37.116 93.738 38.536 135.65 35.674-45.72 11.006-85.56 23.319-105.6 43.408-19.331-2.866-33.658 7.17-32.166 28.062-1.624 0.318-3.712 0.442-5.422 0.327 3.935-10.266-4.42-21.166-14.588-21.166-13.534 0-14.523 16.511-36.211 16.511-7.067 0-11.833-1.649-20.693-1.97 10.436 23.137 26.106 18.767 43.964 18.024 8.265 2.959 3.085 12.177-2.767 12.234-8.813-2.487-16.479-0.146-22.224 6.157-14.99 16.447-4.076 28.049-10.19 46.769-1.009 3.076-1.055 3.44-1.735 6.451 10.312-5.087 16.416-5.193 31.473-5.596 38.289-2.949 19.52-40.753 32.664-40.753 6.323 0 4.299 8.683 3.688 12.424-2.507 15.285-1.577 24.668 19.554 37.511 1.028-14.712-1.77-35.979 4.629-39.444 12.676-7.994 16.435-34.676-11.213-33.685 0.098-1.557 0.259-3.499 0.91-5.067 18.58 1.93 27.183-17.795 21.91-35.417 41.187-41.099 169.63-49.693 252.09-81.206 16.364-6.254 32.192-12.163 47.515-17.749 9.318 15.323 21.968 27.391 36.904 36.341-15.155 12.732-27.557 25.275-37.417 37.771-3.453-2.984-9.84-0.772-16.456 1.591-3.376 1.218-48.291 54.744-104.48 53.547-3.75-0.309 4.197 14.414 21.584 14.414 9.632 0 21.322-3.954 34.804-11.768-19.918 25.565-35.308 18.628-49.906 68.966-0.111 0.385 9e-3 0.803 0.309 1.071 0.64 0.57 30.933-9.797 35.847-14.836 12.032-12.337 20.344-30.613 32.629-42.484-20.343 44.122-4.193 50.695 4.137 57.888 0.725 0.628 1.856 0.019 1.72-0.938-7.824-55.103 52.571-106.2 41.167-125.8 9.942-12.664 22.524-25.382 37.966-38.303 38.305 21.978 103.92 30.026 194.34-14.339-28.142 35.863-41.633 81.463-38.956 82.164 0.545 0.146 1.126-0.177 1.276-0.747 8.594-32.9 23.072-60.567 41.575-83.354 0.141-0.071 0.73-0.363 1.569-0.786 0.64-1.018 1.296-1.955 2.528-3.338l1.232-0.751c0.125-0.382 0.172-0.533 0.287-0.858 6.205-6.234 18.374-14.754 35.173-23.693 39.663 22.01 100.21 15.59 111.84 11.625 26.08-8.795 59.136-21.091 100.47-21.291v2e-3c1.425 0.058 2.843 0.137 4.256 0.231-17.555 1.357-59.455 15.348-73.221 47.279-12.739 15.716-30.932 29.17-44.161 32.748-11.578-14.572-28.596-17.692-42.115-1.59-1.42-0.925-2.97-2.262-4.12-3.54 14.283-6.628 11.38-32.037-10.503-29.572-21.314-0.641-26.296-14.615-36.206-24.952-8.355 23.127 4.132 30.278 19.017 43.548 3.879 7.882-6.277 10.875-10.503 6.854-11.541-19.881-36.047-8.623-42.908-0.096-10.837 14.016-14.298 13.312-22.942 18.951 29.79 9.577 32.493 45.241 69.785 12.189 4.415-3.284 8.211-2.21 9.404 0.435 1.947 4.312-3.067 7.401-6.88 10.236-12.506 9.28-18.278 16.675-12.073 40.544 10.484-9.378 22.363-25.239 29.675-25.239 0.15 0 2.81 0.525 4.792 0.525 14.601 0 30.333-15.514 11.712-32.37 1.154-1.049 2.621-2.332 4.18-3.005 12.112 14.463 32.343 6.068 40.848-11.072 12.443-3.574 28.333-14.842 40.873-28.867-10.845 34.524 9.443 75.898 45.508 75.898 19.316 0 38.106-11.908 43.633-31.018 7.8-26.982-16.185-58.756-46.836-38.199-25.944 17.401-5.987 44.762 10.087 42.721 10.652-1.354 20.896-13.13 17.277-13.954-0.562-0.128-1.121 0.226-1.248 0.79-0.418 1.857-7.588 9.983-16.293 11.089-14.098 1.795-32.591-22.861-8.657-38.911 29.267-19.627 50.829 11.105 43.664 35.882-7.24 25.036-38.173 36.428-60.246 25.185-24.925-12.695-34.247-47.552-22.967-74.102 0.314-0.389 0.554-0.604 0.484-1.121 11.882-26.354 39.344-36.748 60.351-43.586 12.276-2.853 26.158-2.756 41.864 1.599 7.937 21.249 16.422 29.295 29.624 46.528 13.23-17.27 21.676-25.249 29.624-46.527 47.984-13.307 90.669 16.367 102.22 41.98-0.074 0.522 0.171 0.742 0.491 1.139 18.147 42.738-16.672 93.337-59.899 74.592-46.352-20.103-20.292-88.82 20.345-61.568 23.967 16.072 5.287 40.686-8.659 38.911-8.705-1.106-15.875-9.232-16.293-11.089-0.128-0.564-0.688-0.919-1.25-0.79-3.632 0.828 6.639 12.602 17.277 13.954 16.098 2.044 36.018-25.333 10.088-42.721-30.655-20.56-54.634 11.221-46.836 38.199 5.527 19.11 24.318 31.018 43.633 31.018 36.097 0 56.334-41.436 45.516-75.889 12.539 14.022 28.424 25.286 40.865 28.859 8.434 16.991 28.677 25.606 40.848 11.072 1.559 0.673 3.026 1.955 4.18 3.005-20.474 18.533 0.621 35.116 15.398 31.991 7.027-1.945 19.834 15.302 30.781 25.094 8.167-31.411-5.866-34.585-17.645-44.92-3.375-3.88-1.319-8.335 2.8-8.335 9.58 0 22.197 29.67 48.589 7.742 11.169-10.263 15.638-14.402 26.491-17.891-8.684-5.666-12.114-4.946-22.942-18.951-6.723-8.355-31.291-19.916-42.908 0.096-4.21 4.007-14.393 1.05-10.503-6.854 14.671-13.079 27.424-20.272 19.017-43.548-12.368 12.9-14.634 24.789-39.046 24.789-19.356 0-21.24 23.435-7.664 29.736-1.15 1.278-2.7 2.615-4.12 3.54-13.568-16.161-30.608-12.892-42.115 1.59-13.226-3.577-31.413-17.025-44.151-32.736-11.369-26.386-46.174-45.201-73.229-47.291 1.412-0.094 2.829-0.173 4.253-0.231v-2e-3c69.439 0.337 79.469 25.319 139.99 25.319 24.261 0 51.205-3.933 72.327-15.656 16.804 8.942 28.977 17.463 35.182 23.697 0.096 0.271 0.198 0.585 0.287 0.858l1.232 0.751c1.239 1.391 1.886 2.316 2.528 3.338 0.824 0.415 1.482 0.743 1.554 0.779 18.506 22.789 32.986 50.458 41.581 83.361 0.147 0.568 0.73 0.893 1.276 0.747 2.418-0.633-9.875-45.108-38.963-82.171 90.387 44.35 156.01 36.345 194.35 14.35 15.439 12.919 28.019 25.635 37.96 38.297-1.443 2.477-1.905 6.278-2.272 10.823-0.101 1.299 13.921 25.415 14.501 26.415 16.395 28.266 33.348 57.492 28.937 88.56-0.133 0.945 0.98 1.574 1.72 0.938 8.328-7.192 24.481-13.764 4.137-57.888 6.375 6.16 11.725 14.109 16.928 21.836 15.979 23.75 16.274 23.361 41.567 32.37 6.554 2.336 11.05 4.68 10.29 2.042-14.589-50.306-30.045-43.475-49.906-68.966 47.772 27.689 60.112-2.952 56.388-2.645-56.076 1.195-101.25-52.382-104.48-53.547-8.498-3.034-13.436-4.199-16.454-1.592-9.858-12.493-22.259-25.036-37.411-37.765 14.873-8.911 27.551-20.957 36.907-36.341 67.085 24.456 62.153 26.076 156.79 47.385 60.52 13.625 117.7 26.514 142.81 51.568-5.264 17.593 3.311 37.348 21.91 35.415 0.651 1.568 0.812 3.51 0.91 5.067-27.757-0.995-23.817 25.737-11.213 33.685 6.395 3.463 3.594 24.624 4.629 39.444l1.463-0.891c26.277-16.042 18.247-29.813 17.135-43.64 0.378-7.018 8.762-7.757 10.194 1.117 3.714 49.579 31.794 26.605 56.621 38.858l1.964 0.969c-0.677-2.994-0.715-3.325-1.735-6.451-6.284-19.241 5.029-30.07-10.19-46.769-5.74-6.298-13.4-8.648-22.224-6.157-5.853-0.057-11.033-9.275-2.767-12.234 17.887 0.745 33.526 5.118 43.964-18.024-8.855 0.321-13.627 1.97-20.691 1.97-21.67 0-22.708-16.511-36.211-16.511-10.131 0-18.537 10.863-14.588 21.166-1.709 0.115-3.797-9e-3 -5.422-0.327 1.526-21.353-13.447-30.838-32.167-28.062-20.036-20.09-59.877-32.402-105.6-43.408 41.742 2.851 116.34 1.498 135.65-35.674 16.371 1.645 32.635 3.172 48.726 4.58l29.561 20.673c-7.403 21.354 69.261 50.929 80.238 106.07 0.188 0.948 1.45 1.147 1.934 0.32 5.467-9.533 18.554-21.083-15.263-55.992 8.056 3.701 15.737 9.432 23.206 15.002 22.951 17.12 23.083 16.65 49.939 16.778 10.592 0.048 10.04 0.378 10.451-0.37 0.974-1.753-21.962-27.8-28.595-31.125-13.6-6.818-29.923-11.162-41.399-18.54 53.352 10.129 56.144-22.605 52.329-21.166-37.534 14.113-79.057 1.303-115.88-15.836-1-0.46-12.904-0.531-15.923 3.031l-26.433-18.485c119.1 10.287 230.26 12.907 230.25 10 2e-3 -0.567-0.454-1.044-1.046-1.044zm-291.71-69.991c14.084 13.294 17.185 35.683 8.391 53.865-40.48-4.082-82.931-9.007-123.41-14.559 23.479-16.524 78.266-74.009 115.02-39.306zm-120.64 40.636c-15.824 10.566-32.813 18.594-46.185 15.216-13.034-3.291-22.82-14.034-27.582-26.781 20.937 3.767 45.935 7.69 73.767 11.565zm-244.24 28.072c-37.163-29.866-89.493-60.863-159.63-94.765 54.074 13.474 117.92 32.939 194.71 60.679-7.559 13.967-19.546 25.495-35.083 34.086zm-1.992 1.077c-46.104 24.285-126.96 23.729-193.9-16.385-0.677-0.788-1.367-1.565-2.056-2.344-3.566-8.42-13.104-18.287-26.747-28.133 16.176-12.272 30.085-36.979 35.38-56.005 43.689 9.769 143.74 68.002 187.32 102.87zm-510.06-65.13c-10.811-7.447-22.316-13.69-34.466-18.734 0.194-5.704 0.985-11.384 2.481-16.926 11.382 5.393 22.058 11.365 31.986 17.911 9.927-6.545 20.603-12.517 31.983-17.909 1.496 5.542 2.287 11.221 2.481 16.925-12.15 5.043-23.654 11.285-34.465 18.733zm-314.09 46.384c-0.697 0.787-1.394 1.573-2.079 2.37-66.919 40.094-147.76 40.674-193.88 16.373 40.123-32.101 141.37-92.593 187.31-102.86 5.289 19.005 19.198 43.731 35.386 56.01-13.63 9.837-23.162 19.696-26.733 28.111zm-197.96 17.667c-15.535-8.592-27.522-20.121-35.08-34.087 76.789-27.74 140.63-47.204 194.71-60.678-70.134 33.902-122.46 64.898-159.63 94.765zm512.05-54.574c11.028-6.975 22.48-12.403 34.067-16.57-0.881 8.912-3.035 17.69-6.022 25.899-9.867 2.81-19.261 6.565-28.052 11.224-8.792-4.659-18.185-8.414-28.051-11.224-2.987-8.21-5.142-16.99-6.023-25.904 11.592 4.169 23.049 9.598 34.081 16.575zm555.61-21.471c1.179 13.951-0.703 26.593-7.518 40.081-85.582-30.955-159.87-53.408-224.81-67.944 2.284-8.999 3.001-17.141 2.519-24.783 70.011 9.032 146.79 26.612 229.81 52.646zm-339.8-45.691c-1.536-4.24-2.657-8.969-2.922-14.046 22.083-0.261 45.06 0.567 68.904 2.476 2.109 7.503 0.338 14.301-4.612 20.123-21.883-3.87-42.084-6.649-61.37-8.553zm59.591 10.465c-13.705 13.498-47.125 19.924-58.714-8.2 17.96 1.811 37.419 4.463 58.714 8.2zm8.601-21.855c12.977 1.072 26.208 2.462 39.693 4.172 0.606 7.872-0.164 16.115-2.328 24.617-14.38-3.193-28.299-5.995-41.782-8.414 4.59-5.969 6.261-13.085 4.417-20.375zm14.927-41.644c14.556 12.01 22.75 26.965 24.585 43.689-13.631-1.722-27.004-3.118-40.118-4.19-12.236-39.668-50.96-10.765-45.713-8.402 0.527 0.237 1.145 4e-3 1.383-0.523 0.997-2.219 12.004-10.545 23.104-9.704 8.847 0.673 15.222 6.875 18.975 18.445-23.632-1.869-46.413-2.677-68.32-2.417-0.185-41.776 54.32-63.125 86.104-36.898zm-88.141 39.02c0.251 4.955 1.283 9.592 2.723 13.787-45.902-4.381-81.957-3.268-114.17-0.927 36.508-8.656 73.928-12.298 111.45-12.86zm-115.58 13.868l0.106 1.389c33.345-2.551 70.764-3.916 119.03 0.79 12.345 31.586 49.748 24.021 63.619 8.885 13.515 2.41 27.764 5.255 42.836 8.598-5.197 18.556-19.129 43.175-35.228 55.17-68.454-48.152-172.62-67.28-249.07-36.575-0.244-5.72-1.075-11.415-2.602-16.975 18.622-8.657 39.111-15.77 61.31-21.282zm-95.208-18.924c14.976 9.102 26.255 22.106 31.401 39.065-11.146 5.265-21.63 11.079-31.401 17.441-9.772-6.362-20.256-12.176-31.402-17.441 5.138-16.932 16.41-29.957 31.402-39.065zm-36.504 57.179c-78.429-31.5-183.23-9.731-249.07 36.581-16.123-12.011-30.051-36.669-35.234-55.175 15.072-3.343 29.321-6.188 42.836-8.598 13.7 14.95 51.144 23.029 63.619-8.885 48.268-4.706 85.687-3.341 119.03-0.79l0.106-1.39c22.199 5.512 42.688 12.624 61.31 21.28-1.527 5.562-2.359 11.256-2.603 16.977zm-287.2-45.326c13.485-1.71 26.716-3.1 39.693-4.172-1.845 7.29-0.174 14.406 4.418 20.375-13.483 2.419-27.402 5.221-41.782 8.414-2.165-8.503-2.936-16.746-2.329-24.617zm46.513 15.77c-5.015-5.899-6.698-12.724-4.612-20.123 23.844-1.908 46.821-2.737 68.904-2.476-0.265 5.077-1.385 9.807-2.922 14.046-20.47 2.021-40.76 4.909-61.37 8.553zm60.495-6.288c-11.428 27.732-44.711 21.991-58.714 8.2 21.294-3.737 40.752-6.389 58.714-8.2zm117.35-3.418c-32.214-2.342-68.272-3.455-114.18 0.926 1.44-4.195 2.471-8.832 2.723-13.787 37.52 0.561 74.943 4.203 111.46 12.861zm-113.49-14.984c-21.907-0.259-44.688 0.548-68.32 2.417 10.671-32.892 40.307-12.683 42.079-8.74 0.566 1.257 2.474 0.404 1.905-0.86-2.55-5.665-35.124-26.235-46.235 9.784-13.114 1.072-26.487 2.468-40.118 4.191 8.141-74.158 110.97-69.173 110.69-6.792zm-112.97 9.182c-0.483 7.647 0.236 15.788 2.519 24.782-64.942 14.535-139.22 36.987-224.8 67.94-6.791-13.442-8.699-26.07-7.514-40.08 83.017-26.03 159.79-43.609 229.8-52.642zm-356.72 89.057c-4.776 12.782-14.581 23.497-27.582 26.78-13.372 3.378-30.361-4.65-46.184-15.215 27.833-3.876 52.829-7.798 73.766-11.565zm-105.52-10.162c7.311 6.041 16.392 13.54 26.136 20.397-40.465 5.55-82.917 10.475-123.41 14.559-18.655-38.57 17.251-101.12 97.275-34.956zm50.583 69.685c-1.541-0.157-121.28 14.422-146.83-32.733 40.516-4.096 83.539-9.083 124.92-14.797 13.667 9.338 33.75 20.859 49.785 16.816 14.127-3.567 24.644-15.38 29.45-29.24 54.863-9.987 45.202-10.463 110.33-31.46 2.068 13.836 6.62 26.871 13.414 38.573-83.069 30.32-52.439 23.068-181.07 52.841zm700.64-67.349c-0.256-1.275-24.34-3.66-27.891-3.66-41.476 0-75.585 12.639-101.58 21.405-9.098 3.1-68.401 10.879-108.94-10.815 67.877-35.407 164.41-57.161 239.02-31.368 0.794 8.919 2.839 17.715 5.723 25.973-2.09-0.557-4.205-1.063-6.336-1.535zm36.83 47.045c-11.425-14.815-19.435-22.605-27.136-42.393 9.548 2.828 18.632 6.566 27.136 11.162 8.504-4.596 17.588-8.334 27.136-11.162-7.669 19.705-15.54 27.355-27.136 42.393zm166.29-29.3c-1.002-0.338-74.321-26.587-101.77-21.367-2.396 0.106-27.377 2.054-27.693 3.621-2.133 0.472-4.251 0.979-6.344 1.537 2.884-8.257 4.929-17.051 5.724-25.969 75.519-26.115 172.49-3.349 239.03 31.359-38.904 20.822-97.541 14.707-108.95 10.819zm571.17 49.604c-126.16-29.202-95.947-21.771-181.06-52.837 6.795-11.702 11.347-24.737 13.417-38.574 65.18 21.013 55.502 21.478 110.32 31.457 6.697 19.312 22.343 30.077 36.483 30.077 13.245-1e-3 28.587-7.974 42.752-17.652 41.392 5.715 84.409 10.701 124.92 14.797-25.563 47.175-144.52 32.494-146.84 32.732z\"/>\n	<path d=\"m1701 355.47c-48.985 12.78-45.586 39.748-43.84 40.8 9.508 5.727 38.135-0.343 45.131-39.605 0.135-0.738-0.543-1.388-1.291-1.195z\"/>\n	<path d=\"m984.38 356.66c8.342 46.805 45.409 43.768 45.637 38.763 1.599-30.614-46.258-42.346-45.637-38.763z\"/>\n	<path d=\"m1706.5 383.99c-26.064 47.747-18.669 79.964 1.279 78.008 29.384-1.903 15.998-48.358-1.279-78.008z\"/>\n	<path d=\"m980.18 383.99c-23.765 40.771-25.778 78.076 0.4 78.09 19.73-3e-3 23.652-34.093-0.4-78.09z\"/>\n	<path d=\"m1711.6 357.23c8.278 46.505 45.354 44.073 45.631 38.768 1.615-30.768-46.242-42.163-45.631-38.768z\"/>\n	<path d=\"m973.84 356.04c-30.395 7.935-45.313 21.382-44.336 39.965 0.086 1.782 5.682 2.691 8.369 2.69 28.92 3e-3 41.234-44.011 35.967-42.655z\"/>\n	<path d=\"m2516.9 282.29c-1 0.918 5.287 47.481 36.062 48.273 1.753 0 5.723-8.545 1.56-20.019-7.917-21.81-36.408-29.378-37.622-28.254z\"/>\n	<path d=\"m132.13 310.54c-4.145 11.424-0.197 20.024 1.532 20.02 30.087-0.071 37.093-47.347 36.09-48.274-1.014-0.938-29.532 5.977-37.622 28.254z\"/>\n	<path d=\"m2545.5 279.99c44.065 28.73 78.278 25.617 77.872 4.805 0.398-30.399-48.579-18.941-77.872-4.805z\"/>\n	<path d=\"m141.22 279.99c-43.549-21.03-78.189-18.699-77.872 4.803-0.398 20.675 33.562 24.064 77.872-4.803z\"/>\n	<path d=\"m2519.2 272.87c39.402-3.88 48.053-31.818 43.008-41.901-0.646-1.294-27.204-8.267-44.097 40.519-0.257 0.738 0.369 1.475 1.089 1.382z\"/>\n	<path d=\"m168.59 271.49c-16.532-47.74-43.174-42.358-44.098-40.517-1.98 3.955-2.011 11.503 2.375 19.451 10.903 19.751 43.236 25.465 41.723 21.066z\"/>\n</svg>\n");
INSERT INTO `wp_464683_postmeta` VALUES("569", "376", "_wp_attached_file", "2019/11/image2vector-1.svg");
INSERT INTO `wp_464683_postmeta` VALUES("570", "376", "_wp_attachment_metadata", "a:2:{s:5:\"width\";d:400;s:6:\"height\";d:412.584269662921315102721564471721649169921875;}");
INSERT INTO `wp_464683_postmeta` VALUES("571", "376", "_elementor_inline_svg", "<svg id=\"svg\" version=\"1.1\" width=\"400\" height=\"412.5842696629213\" viewBox=\"0 0 400 412.5842696629213\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" ><g id=\"svgg\"><path id=\"path0\" d=\"\" stroke=\"none\" fill=\"#040404\" fill-rule=\"evenodd\"></path><path id=\"path1\" d=\"M172.000 0.600 C 172.000 0.933,171.644 1.200,171.200 1.200 C 170.760 1.200,170.400 1.377,170.400 1.592 C 170.400 1.808,169.950 2.098,169.400 2.236 C 168.774 2.393,168.400 2.770,168.400 3.243 C 168.400 3.660,168.220 4.000,168.000 4.000 C 167.780 4.000,167.600 4.469,167.600 5.042 C 167.600 5.947,167.191 6.634,165.194 9.083 C 164.977 9.349,164.800 9.714,164.800 9.895 C 164.800 10.076,164.440 10.483,164.000 10.800 C 163.560 11.117,163.200 11.600,163.200 11.872 C 163.200 12.527,160.177 15.596,159.516 15.613 C 158.900 15.628,157.600 16.563,157.600 16.990 C 157.600 17.466,154.698 20.000,154.154 20.000 C 153.884 20.000,152.885 20.807,151.932 21.793 C 149.943 23.853,148.800 24.137,148.800 22.571 C 148.800 21.517,149.608 20.400,150.371 20.400 C 150.607 20.400,150.800 19.950,150.800 19.400 C 150.800 18.850,150.980 18.400,151.200 18.400 C 151.420 18.400,151.600 17.950,151.600 17.400 C 151.600 16.600,151.400 16.400,150.600 16.400 C 149.800 16.400,149.600 16.600,149.600 17.400 C 149.600 17.950,149.420 18.400,149.200 18.400 C 148.980 18.400,148.800 18.760,148.800 19.200 C 148.800 19.640,148.620 20.000,148.400 20.000 C 148.180 20.000,148.000 20.284,148.000 20.632 C 148.000 20.979,147.190 22.073,146.200 23.063 C 145.210 24.053,144.400 25.044,144.400 25.264 C 144.400 25.884,136.671 33.592,136.045 33.596 C 135.740 33.598,134.952 34.230,134.294 35.000 C 133.636 35.770,132.839 36.400,132.522 36.400 C 132.205 36.400,131.169 37.210,130.221 38.200 C 129.272 39.190,128.287 40.000,128.031 40.000 C 127.776 40.000,127.180 40.360,126.708 40.800 C 126.236 41.240,125.594 41.600,125.282 41.600 C 124.970 41.600,124.361 42.050,123.929 42.600 C 123.496 43.150,122.795 43.600,122.371 43.600 C 121.947 43.600,121.600 43.780,121.600 44.000 C 121.600 44.220,121.240 44.400,120.800 44.400 C 120.360 44.400,120.000 44.580,120.000 44.800 C 120.000 45.020,119.550 45.200,119.000 45.200 C 118.450 45.200,118.000 45.335,118.000 45.500 C 117.998 46.172,116.055 48.000,115.342 48.000 C 114.921 48.000,114.312 48.369,113.988 48.819 C 113.362 49.692,111.432 50.800,110.539 50.800 C 110.242 50.800,110.000 50.980,110.000 51.200 C 110.000 51.420,109.640 51.600,109.200 51.600 C 108.760 51.600,108.400 51.780,108.400 52.000 C 108.400 52.220,107.950 52.400,107.400 52.400 C 106.850 52.400,106.400 52.567,106.400 52.771 C 106.400 53.198,104.141 54.400,103.339 54.400 C 103.042 54.400,102.800 54.580,102.800 54.800 C 102.800 55.020,102.210 55.200,101.488 55.200 C 100.624 55.200,99.976 55.480,99.588 56.019 C 98.989 56.853,97.043 58.000,96.227 58.000 C 95.979 58.000,95.517 58.360,95.200 58.800 C 94.883 59.240,94.213 59.600,93.712 59.600 C 93.210 59.600,92.800 59.735,92.800 59.900 C 92.798 60.561,90.860 62.401,90.153 62.411 C 89.739 62.417,88.696 63.227,87.835 64.211 C 86.974 65.195,86.021 66.000,85.717 66.000 C 85.414 66.000,84.199 66.990,83.017 68.200 C 81.836 69.410,80.584 70.400,80.235 70.400 C 79.151 70.400,79.535 69.146,81.000 67.894 C 81.770 67.236,82.400 66.401,82.400 66.037 C 82.400 65.674,82.760 65.117,83.200 64.800 C 83.640 64.483,84.000 63.916,84.000 63.541 C 84.000 63.165,84.450 62.504,85.000 62.071 C 85.550 61.639,86.000 61.030,86.000 60.718 C 86.000 60.406,86.360 59.764,86.800 59.292 C 87.240 58.820,87.600 58.227,87.600 57.974 C 87.600 57.722,88.050 57.161,88.600 56.729 C 89.150 56.296,89.600 55.667,89.600 55.331 C 89.600 54.996,90.140 54.217,90.800 53.600 C 91.460 52.983,92.000 52.216,92.000 51.896 C 92.000 51.575,92.450 50.974,93.000 50.561 C 93.550 50.148,94.000 49.503,94.000 49.129 C 94.000 48.754,94.180 48.336,94.400 48.200 C 94.620 48.064,94.800 47.603,94.800 47.176 C 94.800 46.749,94.980 46.400,95.200 46.400 C 95.420 46.400,95.600 46.034,95.600 45.587 C 95.600 45.141,95.870 44.671,96.200 44.545 C 96.542 44.413,96.800 43.817,96.800 43.157 C 96.800 42.521,96.980 42.000,97.200 42.000 C 97.823 42.000,97.678 38.420,97.029 37.771 C 95.659 36.402,92.000 37.356,92.000 39.083 C 92.000 39.490,91.640 40.083,91.200 40.400 C 90.760 40.717,90.400 41.303,90.400 41.701 C 90.400 42.099,90.130 42.529,89.800 42.655 C 89.470 42.782,89.200 43.226,89.200 43.643 C 89.200 44.059,89.020 44.400,88.800 44.400 C 88.580 44.400,88.400 44.749,88.400 45.176 C 88.400 45.603,88.220 46.064,88.000 46.200 C 87.780 46.336,87.600 46.797,87.600 47.224 C 87.600 47.651,87.420 48.000,87.200 48.000 C 86.980 48.000,86.800 48.360,86.800 48.800 C 86.800 49.240,86.640 49.600,86.443 49.600 C 86.247 49.600,85.974 50.050,85.836 50.600 C 85.698 51.150,85.408 51.600,85.192 51.600 C 84.977 51.600,84.800 51.949,84.800 52.376 C 84.800 52.803,84.620 53.264,84.400 53.400 C 84.180 53.536,84.000 53.997,84.000 54.424 C 84.000 54.851,83.820 55.200,83.600 55.200 C 83.380 55.200,83.200 55.560,83.200 56.000 C 83.200 56.440,83.040 56.800,82.843 56.800 C 82.647 56.800,82.374 57.250,82.236 57.800 C 82.098 58.350,81.808 58.800,81.592 58.800 C 81.377 58.800,81.200 59.160,81.200 59.600 C 81.200 60.040,81.020 60.400,80.800 60.400 C 80.580 60.400,80.400 60.850,80.400 61.400 C 80.400 61.950,80.220 62.400,80.000 62.400 C 79.780 62.400,79.600 62.760,79.600 63.200 C 79.600 63.640,79.440 64.000,79.243 64.000 C 79.047 64.000,78.774 64.450,78.636 65.000 C 78.498 65.550,78.208 66.000,77.992 66.000 C 77.777 66.000,77.600 66.360,77.600 66.800 C 77.600 67.240,77.420 67.600,77.200 67.600 C 76.980 67.600,76.800 67.984,76.800 68.453 C 76.800 68.922,76.466 69.597,76.057 69.953 C 75.649 70.309,75.187 71.005,75.030 71.500 C 74.874 71.995,74.578 72.400,74.373 72.400 C 74.168 72.400,74.000 72.720,74.000 73.112 C 74.000 73.503,73.640 74.083,73.200 74.400 C 72.760 74.717,72.400 75.179,72.400 75.427 C 72.400 76.160,71.173 78.400,70.771 78.400 C 70.567 78.400,70.400 78.670,70.400 79.000 C 70.400 79.330,70.220 79.600,70.000 79.600 C 69.780 79.600,69.600 79.960,69.600 80.400 C 69.600 80.840,69.420 81.200,69.200 81.200 C 68.980 81.200,68.800 81.537,68.800 81.949 C 68.800 82.361,68.192 83.218,67.448 83.853 C 66.704 84.488,66.027 85.366,65.942 85.804 C 65.688 87.123,64.615 86.755,64.475 85.300 C 64.404 84.570,64.536 84.000,64.775 84.000 C 65.375 84.000,65.306 81.325,64.700 81.102 C 63.816 80.777,63.200 81.241,63.200 82.233 C 63.200 82.765,63.020 83.200,62.800 83.200 C 62.580 83.200,62.400 84.190,62.400 85.400 C 62.400 86.610,62.220 87.600,62.000 87.600 C 61.780 87.600,61.600 88.129,61.600 88.776 C 61.600 89.423,61.420 90.064,61.200 90.200 C 60.980 90.336,60.800 90.892,60.800 91.436 C 60.800 91.980,60.530 92.529,60.200 92.655 C 59.870 92.782,59.600 93.277,59.600 93.754 C 59.600 94.232,59.240 94.883,58.800 95.200 C 58.360 95.517,58.000 96.084,58.000 96.459 C 58.000 96.835,57.550 97.496,57.000 97.929 C 56.450 98.361,56.000 98.922,56.000 99.174 C 56.000 99.427,55.640 100.020,55.200 100.492 C 54.760 100.964,54.400 101.646,54.400 102.008 C 54.400 102.369,53.950 102.906,53.400 103.200 C 52.818 103.511,52.400 104.088,52.400 104.579 C 52.400 105.044,52.040 105.683,51.600 106.000 C 51.160 106.317,50.800 106.884,50.800 107.259 C 50.800 107.635,50.350 108.296,49.800 108.729 C 49.250 109.161,48.800 109.722,48.800 109.974 C 48.800 110.227,48.440 110.820,48.000 111.292 C 47.560 111.764,47.200 112.446,47.200 112.808 C 47.200 113.169,46.750 113.706,46.200 114.000 C 45.572 114.336,45.200 114.882,45.200 115.468 C 45.200 115.980,45.020 116.400,44.800 116.400 C 44.580 116.400,44.400 116.760,44.400 117.200 C 44.400 117.640,44.220 118.000,44.000 118.000 C 43.780 118.000,43.600 118.242,43.600 118.539 C 43.600 119.341,42.398 121.600,41.971 121.600 C 41.767 121.600,41.600 122.063,41.600 122.629 C 41.600 123.394,41.420 123.624,40.900 123.526 C 40.109 123.376,39.608 120.000,40.377 120.000 C 40.637 120.000,40.800 118.838,40.800 116.987 C 40.800 114.679,40.940 113.921,41.400 113.745 C 41.831 113.579,42.000 112.906,42.000 111.357 C 42.000 110.171,42.180 109.200,42.400 109.200 C 42.620 109.200,42.800 108.390,42.800 107.400 C 42.800 106.410,42.980 105.600,43.200 105.600 C 43.420 105.600,43.600 104.790,43.600 103.800 C 43.600 102.810,43.780 102.000,44.000 102.000 C 44.220 102.000,44.400 101.454,44.400 100.787 C 44.400 100.079,44.649 99.479,45.000 99.345 C 45.342 99.213,45.600 98.617,45.600 97.957 C 45.600 97.321,45.780 96.800,46.000 96.800 C 46.220 96.800,46.400 96.170,46.400 95.400 C 46.400 94.630,46.580 94.000,46.800 94.000 C 47.020 94.000,47.200 93.370,47.200 92.600 C 47.200 91.830,47.380 91.200,47.600 91.200 C 47.820 91.200,48.000 90.654,48.000 89.987 C 48.000 89.279,48.249 88.679,48.600 88.545 C 48.930 88.418,49.200 87.974,49.200 87.557 C 49.200 87.141,49.380 86.800,49.600 86.800 C 49.820 86.800,50.000 86.170,50.000 85.400 C 50.000 84.630,50.180 84.000,50.400 84.000 C 50.620 84.000,50.800 83.578,50.800 83.061 C 50.800 81.944,51.903 79.600,52.429 79.600 C 52.633 79.600,52.800 78.970,52.800 78.200 C 52.800 77.430,52.980 76.800,53.200 76.800 C 53.420 76.800,53.600 76.620,53.600 76.400 C 53.600 76.180,53.330 76.000,53.000 76.000 C 52.667 76.000,52.400 76.356,52.400 76.800 C 52.400 77.240,52.220 77.600,52.000 77.600 C 51.780 77.600,51.600 77.949,51.600 78.376 C 51.600 78.803,51.420 79.264,51.200 79.400 C 50.980 79.536,50.800 79.997,50.800 80.424 C 50.800 80.851,50.620 81.200,50.400 81.200 C 50.180 81.200,50.000 81.566,50.000 82.013 C 50.000 82.459,49.730 82.929,49.400 83.055 C 49.070 83.182,48.800 83.626,48.800 84.043 C 48.800 84.459,48.620 84.800,48.400 84.800 C 48.180 84.800,48.000 85.430,48.000 86.200 C 48.000 86.970,47.820 87.600,47.600 87.600 C 47.380 87.600,47.200 88.104,47.200 88.720 C 47.200 89.336,47.035 90.011,46.834 90.220 C 46.632 90.429,46.407 91.050,46.334 91.600 C 46.243 92.280,45.912 92.641,45.300 92.728 C 44.406 92.855,44.400 92.822,44.400 87.599 C 44.400 83.577,44.266 82.209,43.829 81.771 C 41.819 79.762,38.000 83.089,38.000 86.848 C 38.000 88.149,37.821 89.200,37.600 89.200 C 37.346 89.200,37.200 92.333,37.200 97.800 C 37.200 103.267,37.054 106.400,36.800 106.400 C 36.552 106.400,36.400 108.600,36.400 112.200 C 36.400 115.800,36.248 118.000,36.000 118.000 C 35.758 118.000,35.600 119.738,35.600 122.413 C 35.600 125.966,35.483 126.870,35.000 127.055 C 34.569 127.221,34.400 127.894,34.400 129.443 C 34.400 130.629,34.220 131.600,34.000 131.600 C 33.780 131.600,33.600 132.230,33.600 133.000 C 33.600 133.770,33.420 134.400,33.200 134.400 C 32.980 134.400,32.800 134.940,32.800 135.600 C 32.800 136.260,32.620 136.800,32.400 136.800 C 32.180 136.800,32.000 137.346,32.000 138.013 C 32.000 138.721,31.751 139.321,31.400 139.455 C 31.030 139.597,30.800 140.205,30.800 141.043 C 30.800 141.789,30.620 142.400,30.400 142.400 C 30.180 142.400,29.994 142.895,29.987 143.500 C 29.972 144.823,29.157 146.000,28.256 146.000 C 27.773 146.000,27.600 145.631,27.600 144.600 C 27.600 143.267,27.533 143.200,26.200 143.200 C 25.222 143.200,24.800 143.381,24.800 143.800 C 24.800 144.130,24.980 144.400,25.200 144.400 C 25.420 144.400,25.600 144.760,25.600 145.200 C 25.600 145.640,25.780 146.000,26.000 146.000 C 26.220 146.000,26.400 146.630,26.400 147.400 C 26.400 148.170,26.580 148.800,26.800 148.800 C 27.026 148.800,27.200 149.933,27.200 151.400 C 27.200 152.867,27.026 154.000,26.800 154.000 C 26.580 154.000,26.400 154.810,26.400 155.800 C 26.400 156.790,26.220 157.600,26.000 157.600 C 25.780 157.600,25.600 158.230,25.600 159.000 C 25.600 159.770,25.420 160.400,25.200 160.400 C 24.980 160.400,24.800 161.126,24.800 162.013 C 24.800 163.077,24.596 163.703,24.200 163.855 C 23.793 164.012,23.600 164.650,23.600 165.843 C 23.600 166.809,23.420 167.600,23.200 167.600 C 22.980 167.600,22.800 168.590,22.800 169.800 C 22.800 171.533,22.667 172.000,22.171 172.000 C 20.908 172.000,20.400 170.930,20.400 168.271 C 20.400 166.342,20.248 165.627,19.800 165.455 C 19.325 165.273,19.200 164.432,19.200 161.413 C 19.200 159.138,19.039 157.600,18.800 157.600 C 18.552 157.600,18.400 155.400,18.400 151.800 C 18.400 148.200,18.248 146.000,18.000 146.000 C 17.752 146.000,17.600 143.800,17.600 140.200 C 17.600 136.600,17.448 134.400,17.200 134.400 C 16.980 134.400,16.800 133.609,16.800 132.643 C 16.800 131.450,16.607 130.812,16.200 130.655 C 15.870 130.529,15.600 130.059,15.600 129.613 C 15.600 129.166,15.420 128.800,15.200 128.800 C 14.980 128.800,14.800 128.451,14.800 128.024 C 14.800 127.597,14.620 127.136,14.400 127.000 C 14.180 126.864,14.000 126.481,14.000 126.148 C 14.000 125.286,13.000 124.400,12.029 124.400 C 11.573 124.400,11.200 124.220,11.200 124.000 C 11.200 123.363,10.683 123.530,9.500 124.547 C 8.895 125.067,8.400 125.877,8.400 126.347 C 8.400 126.816,8.220 127.200,8.000 127.200 C 6.757 127.200,7.600 133.385,9.009 134.596 C 9.774 135.254,10.400 136.109,10.400 136.496 C 10.400 136.883,10.580 137.200,10.800 137.200 C 11.020 137.200,11.200 137.560,11.200 138.000 C 11.200 138.440,11.380 138.800,11.600 138.800 C 11.820 138.800,12.000 139.250,12.000 139.800 C 12.000 140.350,12.180 140.800,12.400 140.800 C 12.620 140.800,12.800 141.610,12.800 142.600 C 12.800 143.933,12.956 144.400,13.400 144.400 C 13.844 144.400,14.000 144.867,14.000 146.200 C 14.000 147.190,14.180 148.000,14.400 148.000 C 14.631 148.000,14.800 149.267,14.800 151.000 C 14.800 152.821,14.964 154.000,15.218 154.000 C 15.480 154.000,15.592 155.013,15.518 156.700 C 15.399 159.418,14.382 160.684,14.072 158.500 C 14.002 158.005,13.777 157.600,13.572 157.600 C 13.367 157.600,13.200 157.240,13.200 156.800 C 13.200 156.360,13.023 156.000,12.808 156.000 C 12.592 156.000,12.302 155.550,12.164 155.000 C 12.007 154.374,11.630 154.000,11.157 154.000 C 10.616 154.000,10.400 154.286,10.400 155.000 C 10.400 155.550,10.580 156.000,10.800 156.000 C 11.020 156.000,11.200 156.360,11.200 156.800 C 11.200 157.240,11.380 157.600,11.600 157.600 C 11.820 157.600,12.000 157.870,12.000 158.200 C 12.000 158.530,12.180 158.800,12.400 158.800 C 12.620 158.800,12.800 159.141,12.800 159.557 C 12.800 159.974,13.070 160.418,13.400 160.545 C 13.751 160.679,14.000 161.279,14.000 161.987 C 14.000 162.654,14.180 163.200,14.400 163.200 C 14.620 163.200,14.800 163.830,14.800 164.600 C 14.800 165.370,14.980 166.000,15.200 166.000 C 15.420 166.000,15.600 166.360,15.600 166.800 C 15.600 167.240,15.780 167.600,16.000 167.600 C 16.220 167.600,16.400 168.230,16.400 169.000 C 16.400 169.978,16.581 170.400,17.000 170.400 C 17.471 170.400,17.600 170.953,17.600 172.976 C 17.600 174.393,17.780 175.664,18.000 175.800 C 18.220 175.936,18.400 177.567,18.400 179.424 C 18.400 181.408,18.565 182.800,18.800 182.800 C 19.062 182.800,19.200 190.733,19.200 205.800 C 19.200 220.867,19.338 228.800,19.600 228.800 C 19.831 228.800,20.000 230.071,20.000 231.813 C 20.000 234.121,20.140 234.879,20.600 235.055 C 21.031 235.221,21.200 235.894,21.200 237.443 C 21.200 238.629,21.380 239.600,21.600 239.600 C 21.820 239.600,22.000 240.140,22.000 240.800 C 22.000 241.733,21.822 242.000,21.200 242.000 C 20.682 242.000,20.400 241.733,20.400 241.243 C 20.400 240.826,20.130 240.382,19.800 240.255 C 19.470 240.129,19.200 239.659,19.200 239.213 C 19.200 238.766,19.020 238.400,18.800 238.400 C 18.580 238.400,18.400 238.040,18.400 237.600 C 18.400 237.160,18.220 236.800,18.000 236.800 C 17.780 236.800,17.600 236.350,17.600 235.800 C 17.600 235.250,17.420 234.800,17.200 234.800 C 16.980 234.800,16.800 234.459,16.800 234.043 C 16.800 233.626,16.530 233.182,16.200 233.055 C 15.870 232.929,15.600 232.459,15.600 232.013 C 15.600 231.566,15.420 231.200,15.200 231.200 C 14.980 231.200,14.800 230.840,14.800 230.400 C 14.800 229.960,14.620 229.600,14.400 229.600 C 14.180 229.600,14.000 229.150,14.000 228.600 C 14.000 228.050,13.820 227.600,13.600 227.600 C 13.380 227.600,13.200 227.082,13.200 226.449 C 13.200 225.816,12.930 225.074,12.600 224.800 C 12.270 224.526,12.000 224.054,12.000 223.751 C 12.000 223.448,11.820 223.200,11.600 223.200 C 11.380 223.200,11.200 222.851,11.200 222.424 C 11.200 221.997,11.020 221.536,10.800 221.400 C 10.580 221.264,10.400 220.803,10.400 220.376 C 10.400 219.949,10.220 219.600,10.000 219.600 C 9.780 219.600,9.600 219.306,9.600 218.946 C 9.600 218.586,9.150 217.875,8.600 217.365 C 8.050 216.855,7.600 216.252,7.600 216.024 C 7.600 215.549,6.550 214.188,5.455 213.243 C 5.046 212.889,4.474 212.375,4.184 212.100 C 3.555 211.503,2.000 211.432,2.000 212.000 C 2.000 212.220,1.550 212.400,1.000 212.400 C 0.044 212.400,0.000 212.507,0.000 214.800 C 0.000 216.667,0.133 217.200,0.600 217.200 C 0.933 217.200,1.200 217.556,1.200 218.000 C 1.200 218.440,1.368 218.800,1.573 218.800 C 1.778 218.800,2.074 219.205,2.230 219.700 C 2.387 220.195,2.849 220.891,3.257 221.247 C 3.666 221.603,4.000 222.188,4.000 222.547 C 4.000 222.906,4.180 223.200,4.400 223.200 C 4.620 223.200,4.800 223.388,4.800 223.617 C 4.800 223.846,4.977 224.251,5.194 224.517 C 7.107 226.863,7.600 227.591,7.600 228.069 C 7.600 228.374,7.960 228.883,8.400 229.200 C 8.840 229.517,9.200 230.072,9.200 230.432 C 9.200 230.793,9.650 231.426,10.200 231.839 C 10.750 232.252,11.200 232.825,11.200 233.112 C 11.200 233.399,11.560 234.020,12.000 234.492 C 12.440 234.964,12.800 235.606,12.800 235.918 C 12.800 236.230,13.250 236.839,13.800 237.271 C 14.350 237.704,14.800 238.365,14.800 238.741 C 14.800 239.116,15.160 239.683,15.600 240.000 C 16.040 240.317,16.400 240.903,16.400 241.301 C 16.400 241.699,16.670 242.129,17.000 242.255 C 17.330 242.382,17.600 242.787,17.600 243.154 C 17.600 243.522,17.960 244.083,18.400 244.400 C 18.840 244.717,19.200 245.387,19.200 245.888 C 19.200 246.390,19.380 246.800,19.600 246.800 C 19.820 246.800,20.000 247.141,20.000 247.557 C 20.000 247.974,20.270 248.418,20.600 248.545 C 20.930 248.671,21.200 249.101,21.200 249.499 C 21.200 249.897,21.560 250.483,22.000 250.800 C 22.440 251.117,22.800 251.686,22.800 252.065 C 22.800 252.443,22.980 252.864,23.200 253.000 C 23.420 253.136,23.600 253.597,23.600 254.024 C 23.600 254.451,23.767 254.800,23.971 254.800 C 24.398 254.800,25.600 257.059,25.600 257.861 C 25.600 258.158,25.780 258.400,26.000 258.400 C 26.220 258.400,26.400 258.760,26.400 259.200 C 26.400 259.640,26.580 260.000,26.800 260.000 C 27.020 260.000,27.200 260.385,27.200 260.856 C 27.200 261.327,27.515 261.945,27.900 262.229 C 28.455 262.639,28.498 262.850,28.108 263.245 C 27.462 263.900,25.899 263.106,25.176 261.756 C 24.862 261.168,24.306 260.800,23.732 260.800 C 21.814 260.800,22.725 262.334,27.400 266.975 C 29.930 269.486,32.000 271.824,32.000 272.170 C 32.000 272.517,32.180 272.800,32.400 272.800 C 32.620 272.800,32.800 273.149,32.800 273.576 C 32.800 274.003,32.980 274.464,33.200 274.600 C 33.420 274.736,33.600 275.197,33.600 275.624 C 33.600 276.051,33.780 276.400,34.000 276.400 C 34.220 276.400,34.400 276.741,34.400 277.157 C 34.400 277.574,34.670 278.018,35.000 278.145 C 35.330 278.271,35.600 278.741,35.600 279.187 C 35.600 279.634,35.780 280.000,36.000 280.000 C 36.220 280.000,36.400 280.360,36.400 280.800 C 36.400 281.240,36.580 281.600,36.800 281.600 C 37.020 281.600,37.200 282.050,37.200 282.600 C 37.200 283.150,37.380 283.600,37.600 283.600 C 37.820 283.600,38.000 283.941,38.000 284.357 C 38.000 284.774,38.270 285.218,38.600 285.345 C 38.930 285.471,39.200 285.941,39.200 286.387 C 39.200 286.834,39.380 287.200,39.600 287.200 C 39.820 287.200,40.000 287.560,40.000 288.000 C 40.000 288.440,40.180 288.800,40.400 288.800 C 40.620 288.800,40.800 289.250,40.800 289.800 C 40.800 290.350,40.980 290.800,41.200 290.800 C 41.420 290.800,41.600 291.141,41.600 291.557 C 41.600 291.974,41.870 292.418,42.200 292.545 C 42.530 292.671,42.800 293.141,42.800 293.587 C 42.800 294.034,42.980 294.400,43.200 294.400 C 43.420 294.400,43.600 294.760,43.600 295.200 C 43.600 295.640,43.780 296.000,44.000 296.000 C 44.220 296.000,44.400 296.407,44.400 296.905 C 44.400 297.404,44.849 298.147,45.400 298.561 C 45.950 298.974,46.400 299.607,46.400 299.968 C 46.400 300.328,46.760 300.883,47.200 301.200 C 48.150 301.885,48.264 303.200,47.373 303.200 C 47.028 303.200,46.152 302.570,45.426 301.800 C 44.700 301.030,43.886 300.400,43.617 300.400 C 43.348 300.400,42.341 299.590,41.379 298.600 C 40.417 297.610,39.426 296.800,39.178 296.800 C 38.567 296.800,25.600 283.856,25.600 283.247 C 25.600 282.982,24.610 281.814,23.400 280.651 C 22.190 279.489,21.200 278.310,21.200 278.033 C 21.200 277.756,20.390 276.741,19.400 275.779 C 18.410 274.817,17.600 273.772,17.600 273.457 C 17.600 272.922,16.985 272.229,14.978 270.506 C 14.525 270.118,13.850 269.355,13.478 268.811 L 12.800 267.822 12.800 268.753 C 12.800 269.271,13.245 270.035,13.800 270.471 C 14.350 270.904,14.800 271.565,14.800 271.941 C 14.800 272.316,15.160 272.883,15.600 273.200 C 16.040 273.517,16.400 274.034,16.400 274.348 C 16.400 274.663,17.210 275.685,18.200 276.620 C 19.222 277.586,20.000 278.684,20.000 279.160 C 20.000 279.622,20.188 280.000,20.418 280.000 C 20.961 280.000,22.800 281.839,22.800 282.382 C 22.800 282.612,22.980 282.800,23.200 282.800 C 23.420 282.800,23.600 283.160,23.600 283.600 C 23.600 284.704,22.617 284.602,21.671 283.400 C 21.239 282.850,20.606 282.400,20.266 282.400 C 19.926 282.400,19.536 282.220,19.400 282.000 C 19.264 281.780,18.843 281.600,18.465 281.600 C 18.086 281.600,17.517 281.240,17.200 280.800 C 16.738 280.159,16.165 280.000,14.312 280.000 L 12.000 280.000 12.000 282.200 C 12.000 283.410,12.180 284.400,12.400 284.400 C 12.620 284.400,12.800 284.720,12.800 285.111 C 12.800 285.845,14.103 287.200,14.808 287.200 C 15.028 287.200,15.767 287.735,16.450 288.388 C 17.134 289.041,18.032 289.683,18.447 289.815 C 18.861 289.946,19.200 290.222,19.200 290.427 C 19.200 290.632,19.610 290.800,20.112 290.800 C 20.613 290.800,21.283 291.160,21.600 291.600 C 21.917 292.040,22.415 292.400,22.707 292.400 C 22.999 292.400,23.655 292.850,24.165 293.400 C 24.675 293.950,25.346 294.400,25.658 294.400 C 25.969 294.400,26.483 294.760,26.800 295.200 C 27.117 295.640,27.684 296.000,28.059 296.000 C 28.435 296.000,29.096 296.450,29.529 297.000 C 29.961 297.550,30.654 298.000,31.069 298.000 C 31.484 298.000,32.083 298.360,32.400 298.800 C 32.717 299.240,33.215 299.600,33.507 299.600 C 33.799 299.600,34.455 300.050,34.965 300.600 C 35.475 301.150,36.146 301.600,36.458 301.600 C 36.769 301.600,37.283 301.960,37.600 302.400 C 37.917 302.840,38.474 303.200,38.837 303.200 C 39.201 303.200,40.036 303.830,40.694 304.600 C 41.352 305.370,42.235 306.000,42.657 306.000 C 43.078 306.000,43.683 306.360,44.000 306.800 C 44.317 307.240,44.801 307.600,45.075 307.600 C 45.349 307.600,46.203 308.230,46.973 309.000 C 47.743 309.770,48.583 310.400,48.839 310.400 C 49.446 310.400,54.400 315.356,54.400 315.964 C 54.400 316.221,55.853 317.859,57.629 319.605 C 61.282 323.194,61.706 324.493,59.300 324.725 C 57.750 324.875,57.286 326.800,58.800 326.800 C 59.240 326.800,59.600 326.980,59.600 327.200 C 59.600 327.420,60.579 327.600,61.776 327.600 C 62.973 327.600,64.064 327.780,64.200 328.000 C 64.336 328.220,64.719 328.400,65.052 328.400 C 65.751 328.400,66.800 329.343,66.800 329.971 C 66.800 330.207,66.945 330.400,67.122 330.400 C 67.634 330.400,70.400 333.061,70.400 333.554 C 70.400 333.799,70.545 334.000,70.722 334.000 C 71.234 334.000,74.000 336.661,74.000 337.154 C 74.000 337.399,74.145 337.600,74.322 337.600 C 74.793 337.600,77.600 340.242,77.600 340.686 C 77.600 340.895,78.050 341.306,78.600 341.600 C 79.150 341.894,79.600 342.285,79.600 342.468 C 79.600 342.650,79.960 342.800,80.400 342.800 C 80.933 342.800,81.200 343.067,81.200 343.600 C 81.200 344.222,80.933 344.400,80.000 344.400 C 79.340 344.400,78.800 344.220,78.800 344.000 C 78.800 343.780,78.170 343.600,77.400 343.600 C 76.630 343.600,76.000 343.420,76.000 343.200 C 76.000 342.980,75.640 342.800,75.200 342.800 C 74.760 342.800,74.400 342.620,74.400 342.400 C 74.400 342.180,73.854 342.000,73.187 342.000 C 72.479 342.000,71.879 341.751,71.745 341.400 C 71.618 341.070,71.084 340.800,70.557 340.800 C 70.031 340.800,69.600 340.620,69.600 340.400 C 69.600 340.180,69.240 340.000,68.800 340.000 C 68.360 340.000,68.000 339.820,68.000 339.600 C 68.000 339.380,67.758 339.200,67.461 339.200 C 66.659 339.200,64.400 337.998,64.400 337.571 C 64.400 337.367,63.950 337.200,63.400 337.200 C 62.850 337.200,62.400 337.020,62.400 336.800 C 62.400 336.580,62.040 336.400,61.600 336.400 C 61.160 336.400,60.800 336.220,60.800 336.000 C 60.800 335.780,60.170 335.600,59.400 335.600 C 58.630 335.600,58.000 335.420,58.000 335.200 C 58.000 334.980,57.724 334.800,57.387 334.800 C 57.051 334.800,56.671 334.530,56.545 334.200 C 56.418 333.870,55.884 333.600,55.357 333.600 C 54.831 333.600,54.400 333.420,54.400 333.200 C 54.400 332.980,54.040 332.800,53.600 332.800 C 53.160 332.800,52.800 332.620,52.800 332.400 C 52.800 332.180,52.350 332.000,51.800 332.000 C 51.250 332.000,50.800 331.820,50.800 331.600 C 50.800 331.380,50.524 331.200,50.187 331.200 C 49.851 331.200,49.471 330.930,49.345 330.600 C 49.218 330.270,48.684 330.000,48.157 330.000 C 47.631 330.000,47.200 329.820,47.200 329.600 C 47.200 329.380,46.840 329.200,46.400 329.200 C 45.960 329.200,45.600 329.020,45.600 328.800 C 45.600 328.580,44.790 328.400,43.800 328.400 C 42.810 328.400,42.000 328.220,42.000 328.000 C 42.000 327.473,35.726 327.473,35.400 328.000 C 35.264 328.220,34.881 328.400,34.548 328.400 C 33.849 328.400,32.800 329.343,32.800 329.971 C 32.800 330.207,32.980 330.400,33.200 330.400 C 33.420 330.400,33.600 330.940,33.600 331.600 C 33.600 332.260,33.780 332.800,34.000 332.800 C 34.220 332.800,34.400 333.070,34.400 333.400 C 34.400 333.730,34.630 334.000,34.912 334.000 C 35.193 334.000,35.683 334.360,36.000 334.800 C 36.317 335.240,36.897 335.600,37.288 335.600 C 37.680 335.600,38.000 335.780,38.000 336.000 C 38.000 336.521,40.678 336.521,41.000 336.000 C 41.136 335.780,42.767 335.600,44.624 335.600 C 46.608 335.600,48.000 335.765,48.000 336.000 C 48.000 336.220,48.726 336.400,49.613 336.400 C 50.677 336.400,51.303 336.604,51.455 337.000 C 51.612 337.407,52.250 337.600,53.443 337.600 C 54.409 337.600,55.200 337.780,55.200 338.000 C 55.200 338.220,55.549 338.400,55.976 338.400 C 56.403 338.400,56.864 338.580,57.000 338.800 C 57.136 339.020,57.777 339.200,58.424 339.200 C 59.071 339.200,59.600 339.380,59.600 339.600 C 59.600 339.820,60.146 340.000,60.813 340.000 C 61.521 340.000,62.121 340.249,62.255 340.600 C 62.382 340.930,62.816 341.200,63.219 341.200 C 63.623 341.200,64.064 341.380,64.200 341.600 C 64.336 341.820,64.977 342.000,65.624 342.000 C 66.533 342.000,66.800 342.181,66.800 342.800 C 66.800 343.547,66.533 343.600,62.800 343.600 C 58.749 343.600,58.180 343.837,59.371 345.029 C 59.808 345.466,61.173 345.600,65.171 345.600 C 68.390 345.600,70.400 345.754,70.400 346.000 C 70.400 346.229,71.600 346.400,73.200 346.400 C 74.800 346.400,76.000 346.571,76.000 346.800 C 76.000 347.020,76.540 347.200,77.200 347.200 C 77.860 347.200,78.400 347.380,78.400 347.600 C 78.400 347.820,78.837 348.000,79.371 348.000 C 79.906 348.000,80.613 348.270,80.943 348.600 C 81.273 348.930,81.916 349.200,82.371 349.200 C 82.827 349.200,83.200 349.380,83.200 349.600 C 83.200 349.820,83.740 350.000,84.400 350.000 C 85.060 350.000,85.600 350.180,85.600 350.400 C 85.600 350.620,85.949 350.800,86.376 350.800 C 86.803 350.800,87.264 350.980,87.400 351.200 C 87.536 351.420,88.074 351.600,88.595 351.600 C 89.116 351.600,89.813 351.870,90.143 352.200 C 90.473 352.530,91.026 352.800,91.371 352.800 C 91.717 352.800,92.000 352.980,92.000 353.200 C 92.000 353.420,92.349 353.600,92.776 353.600 C 93.203 353.600,93.664 353.780,93.800 354.000 C 93.936 354.220,94.366 354.400,94.756 354.400 C 95.146 354.400,95.706 354.850,96.000 355.400 C 96.336 356.028,96.882 356.400,97.468 356.400 C 97.980 356.400,98.400 356.580,98.400 356.800 C 98.400 357.020,98.760 357.200,99.200 357.200 C 99.640 357.200,100.000 357.380,100.000 357.600 C 100.000 357.820,100.337 358.000,100.749 358.000 C 101.161 358.000,102.036 358.630,102.694 359.400 C 103.352 360.170,104.209 360.800,104.598 360.800 C 104.988 360.800,105.597 361.134,105.953 361.543 C 106.309 361.951,107.005 362.413,107.500 362.570 C 107.995 362.726,108.400 363.022,108.400 363.227 C 108.400 363.432,108.760 363.600,109.200 363.600 C 109.640 363.600,110.000 363.780,110.000 364.000 C 110.000 364.220,110.332 364.400,110.738 364.400 C 111.144 364.400,111.802 364.760,112.200 365.200 C 112.598 365.640,113.172 366.000,113.475 366.000 C 113.777 366.000,114.129 366.270,114.255 366.600 C 114.382 366.930,114.916 367.200,115.443 367.200 C 115.969 367.200,116.400 367.380,116.400 367.600 C 116.400 367.820,116.760 368.000,117.200 368.000 C 117.640 368.000,118.000 368.159,118.000 368.354 C 118.000 368.549,118.630 369.008,119.400 369.373 C 120.170 369.739,120.800 370.209,120.800 370.419 C 120.800 370.628,121.250 370.800,121.800 370.800 C 122.350 370.800,122.800 370.980,122.800 371.200 C 122.800 371.420,123.160 371.600,123.600 371.600 C 124.040 371.600,124.400 371.780,124.400 372.000 C 124.400 372.220,124.642 372.400,124.939 372.400 C 125.741 372.400,128.000 373.602,128.000 374.029 C 128.000 374.233,128.630 374.400,129.400 374.400 C 130.170 374.400,130.800 374.580,130.800 374.800 C 130.800 375.020,131.160 375.200,131.600 375.200 C 132.040 375.200,132.400 375.380,132.400 375.600 C 132.400 375.820,133.030 376.000,133.800 376.000 C 134.570 376.000,135.200 376.180,135.200 376.400 C 135.200 376.620,135.731 376.800,136.380 376.800 C 137.029 376.800,137.704 377.054,137.880 377.365 C 138.056 377.676,138.740 377.991,139.400 378.065 C 140.140 378.148,140.600 378.430,140.600 378.800 C 140.600 379.534,132.556 379.916,131.855 379.215 C 131.615 378.975,129.445 378.800,126.720 378.800 C 122.791 378.800,122.000 378.699,122.000 378.200 C 122.000 377.694,121.071 377.600,116.043 377.600 C 111.116 377.600,110.046 377.704,109.855 378.200 C 109.710 378.580,109.096 378.800,108.184 378.800 C 105.809 378.800,104.466 381.723,106.093 383.350 C 106.862 384.119,127.200 384.360,127.200 383.600 C 127.200 383.339,133.267 383.200,144.600 383.200 C 159.741 383.200,162.000 383.277,162.000 383.795 C 162.000 384.749,160.701 386.000,159.711 386.000 C 159.067 386.000,158.800 386.234,158.800 386.800 C 158.800 387.481,159.067 387.600,160.600 387.600 C 161.590 387.600,162.400 387.420,162.400 387.200 C 162.400 386.980,162.929 386.800,163.576 386.800 C 164.223 386.800,164.864 386.620,165.000 386.400 C 165.136 386.180,165.946 386.000,166.800 386.000 C 167.654 386.000,168.464 385.820,168.600 385.600 C 168.746 385.364,171.137 385.200,174.424 385.200 C 177.875 385.200,180.000 385.352,180.000 385.600 C 180.000 385.852,182.667 386.000,187.200 386.000 C 191.733 386.000,194.400 386.148,194.400 386.400 C 194.400 386.936,204.269 386.936,204.600 386.400 C 205.105 385.583,208.000 385.923,208.000 386.800 C 208.000 387.448,207.733 387.600,206.600 387.600 C 205.830 387.600,205.200 387.780,205.200 388.000 C 205.200 388.220,204.859 388.400,204.443 388.400 C 204.026 388.400,203.582 388.670,203.455 389.000 C 203.321 389.351,202.721 389.600,202.013 389.600 C 201.346 389.600,200.800 389.780,200.800 390.000 C 200.800 390.220,200.451 390.400,200.024 390.400 C 199.597 390.400,199.136 390.580,199.000 390.800 C 198.864 391.020,198.223 391.200,197.576 391.200 C 196.929 391.200,196.400 391.380,196.400 391.600 C 196.400 391.820,195.789 392.000,195.043 392.000 C 194.205 392.000,193.597 392.230,193.455 392.600 C 193.321 392.951,192.721 393.200,192.013 393.200 C 191.346 393.200,190.800 393.380,190.800 393.600 C 190.800 393.820,189.990 394.000,189.000 394.000 C 188.010 394.000,187.200 394.180,187.200 394.400 C 187.200 394.620,186.210 394.800,185.000 394.800 C 183.790 394.800,182.800 394.980,182.800 395.200 C 182.800 395.420,181.829 395.600,180.643 395.600 C 179.094 395.600,178.421 395.769,178.255 396.200 C 178.093 396.622,177.435 396.800,176.036 396.800 C 174.942 396.800,173.936 396.980,173.800 397.200 C 173.664 397.420,172.393 397.600,170.976 397.600 C 169.525 397.600,168.400 397.775,168.400 398.000 C 168.400 398.226,167.267 398.400,165.800 398.400 C 164.370 398.400,163.200 398.569,163.200 398.776 C 163.200 398.983,162.525 399.222,161.700 399.309 C 160.875 399.395,162.476 399.496,165.257 399.533 C 169.427 399.588,170.355 399.495,170.545 399.000 C 170.714 398.559,171.409 398.400,173.164 398.400 C 174.478 398.400,175.664 398.220,175.800 398.000 C 176.290 397.207,178.400 397.532,178.400 398.400 C 178.400 398.977,178.133 399.200,177.443 399.200 C 176.916 399.200,176.382 399.470,176.255 399.800 C 176.129 400.130,175.749 400.400,175.413 400.400 C 175.076 400.400,174.800 400.580,174.800 400.800 C 174.800 401.020,174.390 401.200,173.888 401.200 C 173.387 401.200,172.717 401.560,172.400 402.000 C 172.083 402.440,171.595 402.800,171.316 402.800 C 170.398 402.800,169.200 404.159,169.200 405.200 C 169.200 406.284,170.409 407.600,171.405 407.600 C 171.732 407.600,172.000 407.780,172.000 408.000 C 172.000 408.220,172.630 408.400,173.400 408.400 C 174.170 408.400,174.800 408.220,174.800 408.000 C 174.800 407.780,175.430 407.600,176.200 407.600 C 176.970 407.600,177.600 407.420,177.600 407.200 C 177.600 406.980,177.941 406.800,178.357 406.800 C 178.774 406.800,179.218 406.530,179.345 406.200 C 179.471 405.870,179.941 405.600,180.387 405.600 C 180.834 405.600,181.200 405.420,181.200 405.200 C 181.200 404.980,181.549 404.800,181.976 404.800 C 182.403 404.800,182.864 404.620,183.000 404.400 C 183.136 404.180,183.597 404.000,184.024 404.000 C 184.451 404.000,184.800 403.820,184.800 403.600 C 184.800 403.380,185.141 403.200,185.557 403.200 C 185.974 403.200,186.418 402.930,186.545 402.600 C 186.671 402.270,187.141 402.000,187.587 402.000 C 188.034 402.000,188.400 401.820,188.400 401.600 C 188.400 401.380,188.749 401.200,189.176 401.200 C 189.603 401.200,190.064 401.020,190.200 400.800 C 190.336 400.580,190.797 400.400,191.224 400.400 C 191.651 400.400,192.000 400.220,192.000 400.000 C 192.000 399.780,192.341 399.600,192.757 399.600 C 193.174 399.600,193.618 399.330,193.745 399.000 C 193.871 398.670,194.341 398.400,194.787 398.400 C 195.234 398.400,195.600 398.220,195.600 398.000 C 195.600 397.780,195.949 397.600,196.376 397.600 C 196.803 397.600,197.264 397.420,197.400 397.200 C 197.536 396.980,197.997 396.800,198.424 396.800 C 198.851 396.800,199.200 396.620,199.200 396.400 C 199.200 396.180,199.541 396.000,199.957 396.000 C 200.374 396.000,200.818 395.730,200.945 395.400 C 201.071 395.070,201.541 394.800,201.987 394.800 C 202.434 394.800,202.800 394.620,202.800 394.400 C 202.800 394.180,203.430 394.000,204.200 394.000 C 204.970 394.000,205.600 393.820,205.600 393.600 C 205.600 393.380,205.960 393.200,206.400 393.200 C 206.840 393.200,207.200 393.020,207.200 392.800 C 207.200 392.580,207.650 392.400,208.200 392.400 C 208.822 392.400,209.200 392.173,209.200 391.800 C 209.200 391.467,209.556 391.200,210.000 391.200 C 210.440 391.200,210.800 391.020,210.800 390.800 C 210.800 390.580,211.250 390.400,211.800 390.400 C 212.350 390.400,212.800 390.220,212.800 390.000 C 212.800 389.780,213.340 389.600,214.000 389.600 C 214.660 389.600,215.200 389.420,215.200 389.200 C 215.200 388.980,215.811 388.800,216.557 388.800 C 217.395 388.800,218.003 388.570,218.145 388.200 C 218.307 387.778,218.965 387.600,220.364 387.600 C 221.458 387.600,222.464 387.420,222.600 387.200 C 222.736 386.980,223.827 386.800,225.024 386.800 C 226.221 386.800,227.200 386.620,227.200 386.400 C 227.200 386.180,228.190 386.000,229.400 386.000 C 230.610 386.000,231.600 385.820,231.600 385.600 C 231.600 385.380,231.960 385.200,232.400 385.200 C 233.452 385.200,233.452 386.442,232.400 387.200 C 231.437 387.894,231.316 389.600,232.230 389.600 C 232.577 389.600,234.106 388.340,235.627 386.800 C 237.149 385.260,238.666 384.000,238.997 384.000 C 239.329 384.000,239.600 383.820,239.600 383.600 C 239.600 383.380,240.230 383.200,241.000 383.200 C 241.770 383.200,242.400 383.020,242.400 382.800 C 242.400 382.580,243.210 382.400,244.200 382.400 C 245.190 382.400,246.000 382.220,246.000 382.000 C 246.000 381.780,246.971 381.600,248.157 381.600 C 249.706 381.600,250.379 381.431,250.545 381.000 C 250.679 380.649,251.279 380.400,251.987 380.400 C 252.654 380.400,253.200 380.220,253.200 380.000 C 253.200 379.780,253.729 379.600,254.376 379.600 C 255.023 379.600,255.664 379.420,255.800 379.200 C 255.936 378.980,256.577 378.800,257.224 378.800 C 257.871 378.800,258.400 378.620,258.400 378.400 C 258.400 378.180,258.760 378.000,259.200 378.000 C 259.748 378.000,260.000 378.267,260.000 378.847 C 260.000 379.496,259.814 379.645,259.200 379.484 C 258.760 379.369,258.400 379.451,258.400 379.666 C 258.400 380.189,257.365 381.200,256.829 381.200 C 256.593 381.200,256.400 381.393,256.400 381.629 C 256.400 382.266,255.347 383.200,254.629 383.200 C 254.283 383.200,254.000 383.380,254.000 383.600 C 254.000 383.820,253.796 384.000,253.547 384.000 C 253.068 384.000,251.201 385.989,251.200 386.500 C 251.200 386.665,250.790 386.800,250.288 386.800 C 249.787 386.800,249.117 387.160,248.800 387.600 C 248.483 388.040,247.985 388.400,247.693 388.400 C 247.401 388.400,246.745 388.850,246.235 389.400 C 245.725 389.950,245.054 390.400,244.742 390.400 C 244.431 390.400,243.917 390.760,243.600 391.200 C 243.283 391.640,242.613 392.000,242.112 392.000 C 241.610 392.000,241.200 392.135,241.200 392.300 C 241.198 392.968,239.256 394.800,238.548 394.800 C 238.131 394.800,237.452 395.250,237.039 395.800 C 236.626 396.350,235.993 396.800,235.632 396.800 C 235.272 396.800,234.717 397.160,234.400 397.600 C 234.083 398.040,233.585 398.400,233.294 398.400 C 233.003 398.400,232.280 398.850,231.687 399.400 C 231.093 399.950,230.474 400.400,230.311 400.400 C 229.979 400.400,227.877 402.198,226.861 403.350 C 226.497 403.763,225.795 404.520,225.300 405.032 C 224.805 405.544,224.400 406.109,224.400 406.286 C 224.400 406.463,223.950 407.093,223.400 407.687 C 222.638 408.508,222.400 409.198,222.400 410.583 L 222.400 412.400 226.600 412.400 C 229.745 412.400,230.800 412.271,230.800 411.888 C 230.800 411.607,231.160 411.117,231.600 410.800 C 232.100 410.440,232.400 409.765,232.400 409.000 C 232.400 408.235,232.700 407.560,233.200 407.200 C 233.640 406.883,234.000 406.401,234.000 406.130 C 234.000 405.858,234.450 405.186,235.000 404.636 C 235.550 404.086,236.000 403.425,236.000 403.166 C 236.000 402.554,240.953 397.600,241.566 397.600 C 241.824 397.600,243.001 396.610,244.183 395.400 C 245.364 394.190,246.550 393.200,246.818 393.200 C 247.086 393.200,247.900 392.570,248.626 391.800 C 250.102 390.235,251.200 389.979,251.200 391.200 C 251.200 391.640,251.020 392.000,250.800 392.000 C 250.580 392.000,250.400 392.366,250.400 392.813 C 250.400 393.259,250.130 393.729,249.800 393.855 C 249.470 393.982,249.200 394.426,249.200 394.843 C 249.200 395.259,249.020 395.600,248.800 395.600 C 248.580 395.600,248.400 396.050,248.400 396.600 C 248.400 397.400,248.600 397.600,249.400 397.600 C 250.133 397.600,250.400 397.387,250.400 396.800 C 250.400 396.360,250.580 396.000,250.800 396.000 C 251.020 396.000,251.200 395.758,251.200 395.461 C 251.200 394.659,252.402 392.400,252.829 392.400 C 253.033 392.400,253.200 392.170,253.200 391.888 C 253.200 391.607,253.560 391.117,254.000 390.800 C 254.440 390.483,254.800 389.992,254.800 389.709 C 254.800 389.427,255.610 388.397,256.600 387.421 C 257.590 386.445,258.400 385.394,258.400 385.085 C 258.400 384.414,259.661 383.200,260.359 383.200 C 260.632 383.200,261.631 382.390,262.579 381.400 C 263.528 380.410,264.504 379.600,264.747 379.600 C 265.228 379.600,266.538 378.617,267.546 377.500 C 267.894 377.115,268.372 376.800,268.610 376.800 C 268.847 376.800,269.842 376.035,270.821 375.100 C 271.799 374.165,273.095 373.145,273.700 372.832 C 274.305 372.520,274.800 372.115,274.800 371.932 C 274.800 371.750,275.160 371.600,275.600 371.600 C 276.040 371.600,276.400 371.420,276.400 371.200 C 276.400 370.980,276.831 370.800,277.357 370.800 C 277.884 370.800,278.418 370.530,278.545 370.200 C 278.671 369.870,279.023 369.600,279.325 369.600 C 279.628 369.600,280.202 369.240,280.600 368.800 C 281.001 368.357,281.832 368.000,282.462 368.000 C 283.088 368.000,283.600 367.820,283.600 367.600 C 283.600 367.380,284.050 367.200,284.600 367.200 C 285.150 367.200,285.600 367.033,285.600 366.829 C 285.600 366.427,287.840 365.200,288.573 365.200 C 288.821 365.200,289.283 364.840,289.600 364.400 C 289.917 363.960,290.497 363.600,290.888 363.600 C 291.280 363.600,291.600 363.432,291.600 363.227 C 291.600 363.022,292.005 362.726,292.500 362.570 C 292.995 362.413,293.691 361.951,294.047 361.543 C 294.403 361.134,295.078 360.800,295.547 360.800 C 296.016 360.800,296.400 360.620,296.400 360.400 C 296.400 360.180,296.741 360.000,297.157 360.000 C 297.574 360.000,298.018 359.730,298.145 359.400 C 298.271 359.070,298.701 358.800,299.099 358.800 C 299.497 358.800,300.083 358.440,300.400 358.000 C 300.717 357.560,301.297 357.200,301.688 357.200 C 302.080 357.200,302.400 357.020,302.400 356.800 C 302.400 356.580,302.651 356.400,302.957 356.400 C 303.264 356.400,303.618 356.130,303.745 355.800 C 303.871 355.470,304.223 355.200,304.525 355.200 C 304.828 355.200,305.402 354.840,305.800 354.400 C 306.198 353.960,306.811 353.596,307.162 353.591 C 307.513 353.587,308.338 352.957,308.996 352.191 C 309.654 351.426,310.430 350.800,310.719 350.800 C 311.009 350.800,312.045 349.990,313.021 349.000 C 313.997 348.010,314.978 347.200,315.201 347.200 C 315.425 347.200,316.172 346.660,316.863 346.000 C 318.172 344.749,319.600 344.407,319.600 345.344 C 319.600 345.643,319.150 346.226,318.600 346.639 C 318.050 347.052,317.600 347.673,317.600 348.020 C 317.600 348.366,317.240 349.036,316.800 349.508 C 316.360 349.980,316.000 350.573,316.000 350.826 C 316.000 351.078,315.550 351.639,315.000 352.071 C 314.450 352.504,314.000 353.165,314.000 353.541 C 314.000 353.916,313.640 354.483,313.200 354.800 C 312.760 355.117,312.400 355.674,312.400 356.037 C 312.400 356.401,311.770 357.236,311.000 357.894 C 310.230 358.552,309.600 359.360,309.600 359.690 C 309.600 360.330,307.725 362.400,307.145 362.400 C 306.955 362.400,306.800 362.850,306.800 363.400 C 306.800 363.950,306.620 364.400,306.400 364.400 C 306.180 364.400,306.000 364.760,306.000 365.200 C 306.000 365.640,305.820 366.000,305.600 366.000 C 305.380 366.000,305.200 366.242,305.200 366.539 C 305.200 367.341,303.998 369.600,303.571 369.600 C 303.367 369.600,303.200 370.230,303.200 371.000 C 303.200 371.770,303.020 372.400,302.800 372.400 C 302.580 372.400,302.400 372.964,302.400 373.653 C 302.400 375.007,304.033 376.799,305.268 376.800 C 306.190 376.800,309.600 373.312,309.600 372.368 C 309.600 371.946,309.870 371.600,310.200 371.600 C 310.530 371.600,310.800 371.251,310.800 370.824 C 310.800 370.397,310.980 369.936,311.200 369.800 C 311.420 369.664,311.600 369.203,311.600 368.776 C 311.600 368.349,311.780 368.000,312.000 368.000 C 312.220 368.000,312.400 367.651,312.400 367.224 C 312.400 366.797,312.580 366.336,312.800 366.200 C 313.020 366.064,313.200 365.603,313.200 365.176 C 313.200 364.749,313.380 364.400,313.600 364.400 C 313.820 364.400,314.000 364.152,314.000 363.849 C 314.000 363.546,314.270 363.074,314.600 362.800 C 314.930 362.526,315.200 361.964,315.200 361.551 C 315.200 361.138,315.380 360.800,315.600 360.800 C 315.820 360.800,316.000 360.451,316.000 360.024 C 316.000 359.597,316.180 359.136,316.400 359.000 C 316.620 358.864,316.800 358.403,316.800 357.976 C 316.800 357.549,316.980 357.200,317.200 357.200 C 317.420 357.200,317.600 356.952,317.600 356.649 C 317.600 356.346,317.870 355.874,318.200 355.600 C 318.530 355.326,318.800 354.764,318.800 354.351 C 318.800 353.938,318.980 353.600,319.200 353.600 C 319.420 353.600,319.600 353.240,319.600 352.800 C 319.600 352.360,319.780 352.000,320.000 352.000 C 320.220 352.000,320.400 351.550,320.400 351.000 C 320.400 350.450,320.580 350.000,320.800 350.000 C 321.020 350.000,321.200 349.724,321.200 349.387 C 321.200 349.051,321.470 348.671,321.800 348.545 C 322.130 348.418,322.400 347.884,322.400 347.357 C 322.400 346.831,322.580 346.400,322.800 346.400 C 323.020 346.400,323.200 346.040,323.200 345.600 C 323.200 345.160,323.359 344.800,323.554 344.800 C 323.749 344.800,324.208 344.170,324.573 343.400 C 324.939 342.630,325.409 342.000,325.619 342.000 C 325.828 342.000,326.000 341.550,326.000 341.000 C 326.000 340.450,326.180 340.000,326.400 340.000 C 326.620 340.000,326.800 339.680,326.800 339.288 C 326.800 338.897,327.160 338.317,327.600 338.000 C 328.040 337.683,328.400 337.097,328.400 336.699 C 328.400 336.301,328.670 335.871,329.000 335.745 C 329.330 335.618,329.600 335.256,329.600 334.940 C 329.600 334.625,329.960 333.980,330.400 333.508 C 330.840 333.036,331.200 332.354,331.200 331.992 C 331.200 331.631,331.650 331.094,332.200 330.800 C 332.750 330.506,333.200 329.922,333.200 329.504 C 333.200 328.581,334.113 327.600,334.971 327.600 C 335.403 327.600,335.600 327.976,335.600 328.800 C 335.600 329.460,335.420 330.000,335.200 330.000 C 334.980 330.000,334.800 330.630,334.800 331.400 C 334.800 332.627,334.924 332.800,335.800 332.800 C 336.533 332.800,336.800 332.587,336.800 332.000 C 336.800 331.560,336.980 331.200,337.200 331.200 C 337.420 331.200,337.600 330.210,337.600 329.000 C 337.600 327.790,337.780 326.800,338.000 326.800 C 338.220 326.800,338.400 326.170,338.400 325.400 C 338.400 324.630,338.580 324.000,338.800 324.000 C 339.020 324.000,339.200 323.454,339.200 322.787 C 339.200 322.079,339.449 321.479,339.800 321.345 C 340.130 321.218,340.400 320.774,340.400 320.357 C 340.400 319.941,340.580 319.600,340.800 319.600 C 341.020 319.600,341.200 319.216,341.200 318.747 C 341.200 317.966,342.989 316.002,343.700 316.000 C 343.865 316.000,344.000 315.550,344.000 315.000 C 344.000 314.450,344.180 314.000,344.400 314.000 C 344.620 314.000,344.800 313.640,344.800 313.200 C 344.800 312.760,344.959 312.400,345.154 312.400 C 345.349 312.400,345.788 311.815,346.129 311.100 C 346.471 310.385,347.121 309.535,347.575 309.212 C 348.029 308.888,348.400 308.279,348.400 307.858 C 348.400 307.145,350.228 305.202,350.900 305.200 C 351.065 305.200,351.200 304.750,351.200 304.200 C 351.200 303.650,351.380 303.200,351.600 303.200 C 351.820 303.200,352.000 302.880,352.000 302.488 C 352.000 302.097,352.360 301.517,352.800 301.200 C 353.240 300.883,353.600 300.328,353.600 299.968 C 353.600 299.607,354.050 298.974,354.600 298.561 C 355.151 298.147,355.600 297.404,355.600 296.905 C 355.600 296.407,355.780 296.000,356.000 296.000 C 356.220 296.000,356.400 295.640,356.400 295.200 C 356.400 294.760,356.580 294.400,356.800 294.400 C 357.020 294.400,357.200 294.034,357.200 293.587 C 357.200 293.141,357.470 292.671,357.800 292.545 C 358.130 292.418,358.400 291.974,358.400 291.557 C 358.400 291.067,358.682 290.800,359.200 290.800 C 359.867 290.800,360.000 291.067,360.000 292.400 C 360.000 293.280,359.820 294.000,359.600 294.000 C 359.369 294.000,359.200 295.271,359.200 297.013 C 359.200 299.321,359.060 300.079,358.600 300.255 C 358.169 300.421,358.000 301.094,358.000 302.643 C 358.000 303.829,357.820 304.800,357.600 304.800 C 357.380 304.800,357.200 305.610,357.200 306.600 C 357.200 307.590,357.020 308.400,356.800 308.400 C 356.580 308.400,356.400 309.210,356.400 310.200 C 356.400 311.190,356.220 312.000,356.000 312.000 C 355.780 312.000,355.600 312.546,355.600 313.213 C 355.600 313.921,355.351 314.521,355.000 314.655 C 354.630 314.797,354.400 315.405,354.400 316.243 C 354.400 316.989,354.220 317.600,354.000 317.600 C 353.780 317.600,353.600 318.129,353.600 318.776 C 353.600 319.423,353.420 320.064,353.200 320.200 C 352.980 320.336,352.800 320.977,352.800 321.624 C 352.800 322.271,352.620 322.800,352.400 322.800 C 352.180 322.800,352.000 323.166,352.000 323.613 C 352.000 324.059,351.730 324.529,351.400 324.655 C 351.030 324.797,350.800 325.405,350.800 326.243 C 350.800 326.989,350.620 327.600,350.400 327.600 C 350.180 327.600,350.000 328.140,350.000 328.800 C 350.000 329.460,349.820 330.000,349.600 330.000 C 349.380 330.000,349.200 330.450,349.200 331.000 C 349.200 331.550,349.020 332.000,348.800 332.000 C 348.580 332.000,348.400 332.546,348.400 333.213 C 348.400 333.921,348.151 334.521,347.800 334.655 C 347.458 334.787,347.200 335.383,347.200 336.043 C 347.200 336.679,347.020 337.200,346.800 337.200 C 346.580 337.200,346.400 337.470,346.400 337.800 C 346.400 338.130,346.670 338.400,347.000 338.400 C 347.373 338.400,347.600 338.022,347.600 337.400 C 347.600 336.850,347.780 336.400,348.000 336.400 C 348.220 336.400,348.400 336.040,348.400 335.600 C 348.400 335.160,348.580 334.800,348.800 334.800 C 349.020 334.800,349.200 334.558,349.200 334.261 C 349.200 333.459,350.402 331.200,350.829 331.200 C 351.033 331.200,351.200 330.570,351.200 329.800 C 351.200 329.030,351.380 328.400,351.600 328.400 C 351.820 328.400,352.000 328.040,352.000 327.600 C 352.000 327.160,352.180 326.800,352.400 326.800 C 352.620 326.800,352.800 326.170,352.800 325.400 C 352.800 324.630,352.969 324.000,353.175 324.000 C 353.381 324.000,353.606 323.415,353.675 322.700 C 353.770 321.708,353.990 321.400,354.600 321.400 C 355.353 321.400,355.407 321.704,355.512 326.541 C 355.634 332.122,355.883 332.800,357.811 332.800 C 358.482 332.800,359.296 332.354,360.000 331.600 C 360.617 330.940,361.319 330.400,361.560 330.400 C 361.831 330.400,362.000 329.477,362.000 328.000 C 362.000 326.667,362.178 325.600,362.400 325.600 C 362.654 325.600,362.800 322.533,362.800 317.200 C 362.800 311.867,362.946 308.800,363.200 308.800 C 363.448 308.800,363.600 306.600,363.600 303.000 C 363.600 299.400,363.752 297.200,364.000 297.200 C 364.245 297.200,364.400 295.329,364.400 292.387 C 364.400 288.479,364.513 287.532,365.000 287.345 C 365.453 287.171,365.600 286.439,365.600 284.357 C 365.600 282.786,365.772 281.600,366.000 281.600 C 366.220 281.600,366.400 281.240,366.400 280.800 C 366.400 280.360,366.580 280.000,366.800 280.000 C 367.020 280.000,367.200 279.370,367.200 278.600 C 367.200 277.830,367.380 277.200,367.600 277.200 C 367.820 277.200,368.000 276.654,368.000 275.987 C 368.000 275.279,368.249 274.679,368.600 274.545 C 368.942 274.413,369.200 273.817,369.200 273.157 C 369.200 272.521,369.380 272.000,369.600 272.000 C 369.820 272.000,370.000 271.447,370.000 270.771 C 370.000 269.437,370.775 268.400,371.771 268.400 C 372.203 268.400,372.400 268.776,372.400 269.600 C 372.400 270.613,372.556 270.800,373.400 270.800 C 374.276 270.800,374.400 270.627,374.400 269.400 C 374.400 268.630,374.220 268.000,374.000 268.000 C 373.780 268.000,373.600 267.460,373.600 266.800 C 373.600 266.140,373.420 265.600,373.200 265.600 C 372.971 265.600,372.800 264.400,372.800 262.800 C 372.800 261.200,372.971 260.000,373.200 260.000 C 373.420 260.000,373.600 259.291,373.600 258.424 C 373.600 257.557,373.780 256.736,374.000 256.600 C 374.220 256.464,374.400 255.823,374.400 255.176 C 374.400 254.529,374.580 254.000,374.800 254.000 C 375.020 254.000,375.200 253.190,375.200 252.200 C 375.200 250.867,375.356 250.400,375.800 250.400 C 376.244 250.400,376.400 249.933,376.400 248.600 C 376.400 247.610,376.571 246.800,376.780 246.800 C 376.989 246.800,377.214 245.765,377.280 244.500 C 377.392 242.345,377.463 242.200,378.400 242.200 C 379.367 242.200,379.404 242.299,379.519 245.195 C 379.603 247.300,379.811 248.287,380.219 248.515 C 380.655 248.759,380.800 249.679,380.800 252.196 C 380.800 254.042,380.980 255.664,381.200 255.800 C 381.436 255.946,381.600 258.330,381.600 261.600 C 381.600 264.870,381.764 267.254,382.000 267.400 C 382.237 267.546,382.400 270.004,382.400 273.424 C 382.400 277.008,382.552 279.200,382.800 279.200 C 383.020 279.200,383.200 280.190,383.200 281.400 C 383.200 282.610,383.367 283.600,383.571 283.600 C 383.998 283.600,385.200 285.859,385.200 286.661 C 385.200 286.958,385.380 287.200,385.600 287.200 C 385.820 287.200,386.000 287.483,386.000 287.829 C 386.000 288.915,387.082 289.600,388.800 289.600 C 390.518 289.600,391.600 288.915,391.600 287.829 C 391.600 287.483,391.780 287.200,392.000 287.200 C 392.233 287.200,392.400 285.867,392.400 284.000 C 392.400 282.240,392.250 280.800,392.068 280.800 C 391.885 280.800,391.494 280.350,391.200 279.800 C 390.906 279.250,390.425 278.800,390.132 278.800 C 389.840 278.800,389.600 278.440,389.600 278.000 C 389.600 277.560,389.420 277.200,389.200 277.200 C 388.980 277.200,388.800 276.750,388.800 276.200 C 388.800 275.650,388.620 275.200,388.400 275.200 C 388.180 275.200,388.000 274.660,388.000 274.000 C 388.000 273.340,387.820 272.800,387.600 272.800 C 387.380 272.800,387.200 272.189,387.200 271.443 C 387.200 270.605,386.970 269.997,386.600 269.855 C 386.178 269.693,386.000 269.035,386.000 267.636 C 386.000 266.542,385.820 265.536,385.600 265.400 C 385.380 265.264,385.200 263.993,385.200 262.576 C 385.200 261.125,385.025 260.000,384.800 260.000 C 384.574 260.000,384.400 258.867,384.400 257.400 C 384.400 255.067,384.482 254.800,385.200 254.800 C 385.725 254.800,386.000 255.067,386.000 255.576 C 386.000 256.003,386.180 256.464,386.400 256.600 C 386.620 256.736,386.800 257.177,386.800 257.581 C 386.800 257.984,387.070 258.418,387.400 258.545 C 387.730 258.671,388.000 259.051,388.000 259.387 C 388.000 259.733,388.348 260.000,388.800 260.000 C 389.648 260.000,389.946 258.661,389.200 258.200 C 388.980 258.064,388.800 257.643,388.800 257.265 C 388.800 256.886,388.440 256.317,388.000 256.000 C 387.560 255.683,387.200 255.097,387.200 254.699 C 387.200 254.301,386.930 253.871,386.600 253.745 C 386.262 253.615,386.000 253.019,386.000 252.381 C 386.000 251.757,385.820 251.136,385.600 251.000 C 385.380 250.864,385.200 250.223,385.200 249.576 C 385.200 248.929,385.020 248.400,384.800 248.400 C 384.580 248.400,384.400 247.950,384.400 247.400 C 384.400 246.850,384.220 246.400,384.000 246.400 C 383.780 246.400,383.600 245.879,383.600 245.243 C 383.600 244.583,383.342 243.987,383.000 243.855 C 382.551 243.683,382.400 242.966,382.400 241.013 C 382.400 239.538,382.226 238.400,382.000 238.400 C 381.763 238.400,381.600 236.933,381.600 234.800 C 381.600 232.667,381.437 231.200,381.200 231.200 C 380.938 231.200,380.800 223.333,380.800 208.400 C 380.800 193.467,380.662 185.600,380.400 185.600 C 380.167 185.600,380.000 184.281,380.000 182.443 C 380.000 180.005,379.863 179.233,379.400 179.055 C 378.981 178.895,378.800 178.241,378.800 176.893 C 378.800 175.830,378.605 174.765,378.366 174.526 C 377.728 173.888,378.089 172.229,378.900 172.075 C 379.420 171.976,379.600 172.206,379.600 172.971 C 379.600 173.537,379.767 174.000,379.971 174.000 C 380.398 174.000,381.600 176.259,381.600 177.061 C 381.600 177.358,381.780 177.600,382.000 177.600 C 382.220 177.600,382.400 177.960,382.400 178.400 C 382.400 178.840,382.580 179.200,382.800 179.200 C 383.020 179.200,383.200 179.650,383.200 180.200 C 383.200 180.750,383.367 181.200,383.571 181.200 C 383.998 181.200,385.200 183.459,385.200 184.261 C 385.200 184.558,385.380 184.800,385.600 184.800 C 385.820 184.800,386.000 185.160,386.000 185.600 C 386.000 186.040,386.180 186.400,386.400 186.400 C 386.620 186.400,386.800 187.030,386.800 187.800 C 386.800 188.570,386.967 189.200,387.171 189.200 C 387.598 189.200,388.800 191.459,388.800 192.261 C 388.800 192.558,388.980 192.800,389.200 192.800 C 389.420 192.800,389.600 193.141,389.600 193.558 C 389.600 193.975,390.047 194.740,390.593 195.258 C 391.139 195.776,391.589 196.397,391.593 196.638 C 391.597 196.879,391.960 197.402,392.400 197.800 C 392.840 198.198,393.200 198.774,393.200 199.080 C 393.200 200.514,395.088 201.600,397.582 201.600 L 400.000 201.600 400.000 199.400 C 400.000 197.711,399.861 197.200,399.400 197.200 C 399.027 197.200,398.800 196.822,398.800 196.200 C 398.800 195.650,398.633 195.200,398.429 195.200 C 398.057 195.200,396.800 192.983,396.800 192.325 C 396.800 192.132,396.170 191.343,395.400 190.573 C 394.630 189.803,394.000 188.949,394.000 188.675 C 394.000 188.401,393.640 187.917,393.200 187.600 C 392.760 187.283,392.400 186.703,392.400 186.312 C 392.400 185.920,392.220 185.600,392.000 185.600 C 391.780 185.600,391.600 185.193,391.600 184.695 C 391.600 184.196,391.151 183.453,390.600 183.039 C 390.050 182.626,389.600 181.993,389.600 181.632 C 389.600 181.272,389.240 180.717,388.800 180.400 C 388.360 180.083,388.000 179.569,388.000 179.258 C 388.000 178.946,387.550 178.275,387.000 177.765 C 386.450 177.255,386.000 176.599,386.000 176.307 C 386.000 176.015,385.640 175.517,385.200 175.200 C 384.760 174.883,384.400 174.253,384.400 173.800 C 384.400 173.347,384.031 172.712,383.581 172.388 C 382.747 171.789,381.600 169.843,381.600 169.027 C 381.600 168.779,381.240 168.317,380.800 168.000 C 380.360 167.683,380.000 167.013,380.000 166.512 C 380.000 165.968,379.758 165.600,379.400 165.600 C 379.067 165.600,378.800 165.244,378.800 164.800 C 378.800 164.360,378.620 164.000,378.400 164.000 C 378.180 164.000,378.000 163.590,378.000 163.088 C 378.000 162.587,377.640 161.917,377.200 161.600 C 376.760 161.283,376.400 160.722,376.400 160.354 C 376.400 159.987,376.130 159.582,375.800 159.455 C 375.470 159.329,375.200 158.859,375.200 158.413 C 375.200 157.966,375.020 157.600,374.800 157.600 C 374.580 157.600,374.400 157.251,374.400 156.824 C 374.400 156.397,374.220 155.936,374.000 155.800 C 373.780 155.664,373.600 155.203,373.600 154.776 C 373.600 154.349,373.420 154.000,373.200 154.000 C 372.980 154.000,372.800 153.659,372.800 153.243 C 372.800 152.826,372.530 152.382,372.200 152.255 C 371.413 151.954,371.429 150.841,372.224 150.535 C 372.626 150.381,373.322 150.813,374.178 151.748 C 375.719 153.431,377.200 153.699,377.200 152.295 C 377.200 151.776,376.741 151.051,376.122 150.595 C 375.530 150.158,374.765 149.462,374.422 149.050 C 373.663 148.134,372.358 146.821,371.350 145.957 C 370.238 145.004,369.200 143.651,369.200 143.153 C 369.200 142.912,368.750 142.361,368.200 141.929 C 367.650 141.496,367.200 140.795,367.200 140.371 C 367.200 139.947,367.020 139.600,366.800 139.600 C 366.580 139.600,366.400 138.970,366.400 138.200 C 366.400 137.430,366.220 136.800,366.000 136.800 C 365.780 136.800,365.600 136.511,365.600 136.158 C 365.600 135.804,365.150 135.161,364.600 134.729 C 364.050 134.296,363.600 133.595,363.600 133.171 C 363.600 132.747,363.420 132.400,363.200 132.400 C 362.980 132.400,362.800 132.040,362.800 131.600 C 362.800 131.160,362.620 130.800,362.400 130.800 C 362.180 130.800,362.000 130.350,362.000 129.800 C 362.000 129.250,361.833 128.800,361.629 128.800 C 361.103 128.800,360.000 126.456,360.000 125.339 C 360.000 124.822,359.820 124.400,359.600 124.400 C 359.380 124.400,359.200 123.950,359.200 123.400 C 359.200 122.850,359.020 122.400,358.800 122.400 C 358.580 122.400,358.400 122.111,358.400 121.758 C 358.400 121.404,357.950 120.761,357.400 120.329 C 356.850 119.896,356.400 119.195,356.400 118.771 C 356.400 118.347,356.220 118.000,356.000 118.000 C 355.780 118.000,355.600 117.640,355.600 117.200 C 355.600 116.760,355.420 116.400,355.200 116.400 C 354.980 116.400,354.800 115.980,354.800 115.468 C 354.800 114.882,354.428 114.336,353.800 114.000 C 352.371 113.235,352.470 112.000,353.960 112.000 C 355.077 112.000,358.000 114.344,358.000 115.240 C 358.000 115.438,358.357 115.600,358.792 115.600 C 359.696 115.600,375.200 130.875,375.200 131.766 C 375.200 132.068,375.667 132.740,376.238 133.258 C 378.497 135.309,379.600 136.541,379.600 137.015 C 379.600 137.288,380.680 138.588,382.000 139.904 C 383.320 141.220,384.400 142.455,384.400 142.648 C 384.401 143.199,386.241 145.200,386.747 145.200 C 387.502 145.200,387.258 144.555,386.200 143.761 C 385.650 143.348,385.200 142.727,385.200 142.380 C 385.200 142.034,384.840 141.364,384.400 140.892 C 383.960 140.420,383.600 139.855,383.600 139.636 C 383.600 139.417,382.970 138.627,382.200 137.879 C 381.430 137.131,380.800 136.308,380.800 136.051 C 380.800 135.793,379.810 134.608,378.600 133.417 C 376.304 131.158,375.830 130.000,377.200 130.000 C 377.640 130.000,378.000 130.180,378.000 130.400 C 378.000 130.620,378.360 130.800,378.800 130.800 C 379.240 130.800,379.600 130.959,379.600 131.154 C 379.600 131.349,380.230 131.808,381.000 132.173 C 381.770 132.539,382.400 133.009,382.400 133.219 C 382.400 133.428,382.749 133.600,383.176 133.600 C 383.603 133.600,384.064 133.780,384.200 134.000 C 384.570 134.599,386.775 134.482,387.429 133.829 C 389.209 132.048,386.678 126.000,384.152 126.000 C 383.848 126.000,383.600 125.820,383.600 125.600 C 383.600 125.380,383.330 125.200,383.000 125.200 C 382.670 125.200,382.400 125.020,382.400 124.800 C 382.400 124.580,382.080 124.400,381.688 124.400 C 381.297 124.400,380.717 124.040,380.400 123.600 C 380.083 123.160,379.601 122.800,379.330 122.800 C 379.058 122.800,378.386 122.350,377.836 121.800 C 377.286 121.250,376.569 120.800,376.242 120.800 C 375.915 120.800,375.536 120.620,375.400 120.400 C 375.264 120.180,374.834 120.000,374.444 120.000 C 374.054 120.000,373.494 119.550,373.200 119.000 C 372.906 118.450,372.317 118.000,371.893 118.000 C 371.468 118.000,370.617 117.460,370.000 116.800 C 369.383 116.140,368.689 115.600,368.458 115.600 C 368.226 115.600,367.586 115.150,367.036 114.600 C 366.486 114.050,365.786 113.600,365.480 113.600 C 365.174 113.600,364.598 113.240,364.200 112.800 C 363.802 112.360,363.228 112.000,362.925 112.000 C 362.623 112.000,362.271 111.730,362.145 111.400 C 362.018 111.070,361.664 110.800,361.357 110.800 C 361.051 110.800,360.800 110.620,360.800 110.400 C 360.800 110.180,360.480 110.000,360.088 110.000 C 359.697 110.000,359.117 109.640,358.800 109.200 C 358.483 108.760,357.946 108.400,357.608 108.400 C 357.269 108.400,356.454 107.774,355.796 107.009 C 355.138 106.243,354.308 105.613,353.951 105.609 C 353.594 105.604,352.764 104.970,352.106 104.200 C 351.448 103.430,350.568 102.800,350.150 102.800 C 349.732 102.800,349.032 102.315,348.595 101.722 C 348.158 101.130,347.485 100.370,347.100 100.033 C 346.715 99.697,346.400 99.223,346.400 98.979 C 346.400 98.735,345.050 97.177,343.400 95.517 C 341.750 93.856,340.400 92.287,340.400 92.029 C 340.400 91.772,339.920 91.149,339.333 90.644 C 338.634 90.043,338.354 89.497,338.520 89.063 C 338.840 88.231,340.742 88.184,341.055 89.000 C 341.470 90.079,342.000 89.630,342.000 88.200 L 342.000 86.800 339.400 86.800 C 337.356 86.800,336.800 86.672,336.800 86.200 C 336.800 85.796,336.396 85.600,335.560 85.600 C 334.482 85.600,333.332 84.607,326.759 78.000 C 322.600 73.820,318.928 70.400,318.599 70.400 C 318.267 70.400,318.000 70.044,318.000 69.600 C 318.000 69.067,318.267 68.800,318.800 68.800 C 319.240 68.800,319.600 68.980,319.600 69.200 C 319.600 69.420,320.140 69.600,320.800 69.600 C 321.460 69.600,322.000 69.780,322.000 70.000 C 322.000 70.220,322.366 70.400,322.813 70.400 C 323.259 70.400,323.729 70.670,323.855 71.000 C 323.997 71.370,324.605 71.600,325.443 71.600 C 326.189 71.600,326.800 71.780,326.800 72.000 C 326.800 72.220,327.160 72.400,327.600 72.400 C 328.040 72.400,328.400 72.580,328.400 72.800 C 328.400 73.020,328.749 73.200,329.176 73.200 C 329.603 73.200,330.064 73.380,330.200 73.600 C 330.336 73.820,330.892 74.000,331.436 74.000 C 331.980 74.000,332.529 74.270,332.655 74.600 C 332.782 74.930,333.316 75.200,333.843 75.200 C 334.369 75.200,334.800 75.380,334.800 75.600 C 334.800 75.820,335.160 76.000,335.600 76.000 C 336.040 76.000,336.400 76.180,336.400 76.400 C 336.400 76.620,336.850 76.800,337.400 76.800 C 337.950 76.800,338.400 76.980,338.400 77.200 C 338.400 77.420,338.676 77.600,339.013 77.600 C 339.349 77.600,339.729 77.870,339.855 78.200 C 339.982 78.530,340.516 78.800,341.043 78.800 C 341.569 78.800,342.000 78.980,342.000 79.200 C 342.000 79.420,342.360 79.600,342.800 79.600 C 343.240 79.600,343.600 79.780,343.600 80.000 C 343.600 80.220,344.050 80.400,344.600 80.400 C 345.150 80.400,345.600 80.580,345.600 80.800 C 345.600 81.020,345.876 81.200,346.213 81.200 C 346.549 81.200,346.929 81.470,347.055 81.800 C 347.182 82.130,347.716 82.400,348.243 82.400 C 348.769 82.400,349.200 82.580,349.200 82.800 C 349.200 83.020,349.560 83.200,350.000 83.200 C 350.440 83.200,350.800 83.380,350.800 83.600 C 350.800 83.820,351.250 84.000,351.800 84.000 C 352.350 84.000,352.800 84.180,352.800 84.400 C 352.800 84.620,353.346 84.800,354.013 84.800 C 354.721 84.800,355.321 85.049,355.455 85.400 C 355.621 85.831,356.294 86.000,357.843 86.000 C 359.029 86.000,360.000 86.180,360.000 86.400 C 360.000 86.620,360.990 86.800,362.200 86.800 C 363.410 86.800,364.400 86.620,364.400 86.400 C 364.400 86.180,364.807 86.000,365.304 86.000 C 366.301 86.000,367.639 84.346,366.854 84.085 C 366.605 84.002,366.400 83.408,366.400 82.766 C 366.400 81.527,363.644 78.400,362.552 78.400 C 362.248 78.400,362.000 78.220,362.000 78.000 C 362.000 77.780,361.100 77.600,360.000 77.600 C 358.900 77.600,358.000 77.780,358.000 78.000 C 358.000 78.220,357.280 78.400,356.400 78.400 C 355.520 78.400,354.800 78.220,354.800 78.000 C 354.800 77.767,353.467 77.600,351.600 77.600 C 349.733 77.600,348.400 77.433,348.400 77.200 C 348.400 76.980,347.770 76.800,347.000 76.800 C 346.230 76.800,345.600 76.620,345.600 76.400 C 345.600 76.180,345.054 76.000,344.387 76.000 C 343.679 76.000,343.079 75.751,342.945 75.400 C 342.818 75.070,342.374 74.800,341.957 74.800 C 341.541 74.800,341.200 74.620,341.200 74.400 C 341.200 74.180,340.570 74.000,339.800 74.000 C 339.030 74.000,338.400 73.820,338.400 73.600 C 338.400 73.380,337.978 73.200,337.461 73.200 C 333.253 73.200,333.105 70.642,337.304 70.483 C 340.071 70.379,340.400 70.283,340.400 69.583 C 340.400 68.849,340.099 68.800,335.587 68.800 C 331.679 68.800,330.732 68.687,330.545 68.200 C 330.374 67.754,329.664 67.600,327.781 67.600 C 326.387 67.600,325.136 67.420,325.000 67.200 C 324.864 66.980,324.054 66.800,323.200 66.800 C 322.346 66.800,321.536 66.620,321.400 66.400 C 321.264 66.180,320.803 66.000,320.376 66.000 C 319.949 66.000,319.600 65.820,319.600 65.600 C 319.600 65.380,319.165 65.200,318.632 65.200 C 317.610 65.200,315.207 64.009,315.203 63.500 C 315.201 63.335,314.750 63.200,314.200 63.200 C 313.650 63.200,313.200 63.020,313.200 62.800 C 313.200 62.580,312.660 62.400,312.000 62.400 C 311.340 62.400,310.800 62.220,310.800 62.000 C 310.800 61.780,310.558 61.600,310.261 61.600 C 309.459 61.600,307.200 60.398,307.200 59.971 C 307.200 59.767,306.750 59.600,306.200 59.600 C 305.650 59.600,305.200 59.420,305.200 59.200 C 305.200 58.980,304.840 58.800,304.400 58.800 C 303.960 58.800,303.600 58.620,303.600 58.400 C 303.600 58.180,303.358 58.000,303.061 58.000 C 302.259 58.000,300.000 56.798,300.000 56.371 C 300.000 56.167,299.730 56.000,299.400 56.000 C 299.070 56.000,298.800 55.820,298.800 55.600 C 298.800 55.380,298.518 55.200,298.173 55.200 C 297.828 55.200,296.952 54.570,296.226 53.800 C 295.500 53.030,294.612 52.400,294.253 52.400 C 293.894 52.400,293.600 52.220,293.600 52.000 C 293.600 51.780,293.268 51.600,292.862 51.600 C 292.456 51.600,291.798 51.240,291.400 50.800 C 291.002 50.360,290.428 50.000,290.125 50.000 C 289.823 50.000,289.471 49.730,289.345 49.400 C 289.218 49.070,288.684 48.800,288.157 48.800 C 287.631 48.800,287.200 48.620,287.200 48.400 C 287.200 48.180,286.840 48.000,286.400 48.000 C 285.960 48.000,285.600 47.841,285.600 47.646 C 285.600 47.451,284.970 46.992,284.200 46.627 C 283.430 46.261,282.800 45.791,282.800 45.581 C 282.800 45.372,282.350 45.200,281.800 45.200 C 281.250 45.200,280.800 45.020,280.800 44.800 C 280.800 44.580,280.440 44.400,280.000 44.400 C 279.560 44.400,279.200 44.220,279.200 44.000 C 279.200 43.780,278.958 43.600,278.661 43.600 C 277.859 43.600,275.600 42.398,275.600 41.971 C 275.600 41.767,275.251 41.600,274.824 41.600 C 274.397 41.600,273.936 41.420,273.800 41.200 C 273.664 40.980,273.203 40.800,272.776 40.800 C 272.349 40.800,272.000 40.620,272.000 40.400 C 272.000 40.180,271.651 40.000,271.224 40.000 C 270.797 40.000,270.336 39.820,270.200 39.600 C 270.064 39.380,269.508 39.200,268.964 39.200 C 268.420 39.200,267.871 38.930,267.745 38.600 C 267.618 38.270,267.084 38.000,266.557 38.000 C 266.031 38.000,265.600 37.820,265.600 37.600 C 265.600 37.380,265.071 37.200,264.424 37.200 C 263.777 37.200,263.136 37.020,263.000 36.800 C 262.864 36.580,262.223 36.400,261.576 36.400 C 260.667 36.400,260.400 36.219,260.400 35.600 C 260.400 34.837,260.667 34.800,266.200 34.800 C 269.800 34.800,272.000 34.952,272.000 35.200 C 272.000 35.440,273.600 35.600,276.000 35.600 C 278.400 35.600,280.000 35.760,280.000 36.000 C 280.000 36.531,287.872 36.531,288.200 36.000 C 288.336 35.780,289.427 35.600,290.624 35.600 C 291.821 35.600,292.800 35.420,292.800 35.200 C 292.800 34.980,293.160 34.800,293.600 34.800 C 294.248 34.800,294.400 34.533,294.400 33.400 C 294.400 32.630,294.580 32.000,294.800 32.000 C 295.020 32.000,295.200 31.807,295.200 31.571 C 295.200 30.681,294.000 30.000,292.429 30.000 C 291.533 30.000,290.800 29.820,290.800 29.600 C 290.800 29.367,289.467 29.200,287.600 29.200 C 285.733 29.200,284.400 29.367,284.400 29.600 C 284.400 29.852,281.733 30.000,277.200 30.000 C 272.667 30.000,270.000 30.148,270.000 30.400 C 270.000 31.099,239.274 30.931,238.571 30.229 C 237.645 29.302,237.870 28.400,239.029 28.400 C 239.594 28.400,240.314 28.143,240.629 27.829 C 241.281 27.177,241.402 25.600,240.800 25.600 C 240.580 25.600,240.400 25.780,240.400 26.000 C 240.400 26.220,239.590 26.400,238.600 26.400 C 237.610 26.400,236.800 26.580,236.800 26.800 C 236.800 27.020,236.170 27.200,235.400 27.200 C 234.422 27.200,234.000 27.381,234.000 27.800 C 234.000 28.244,233.533 28.400,232.200 28.400 C 231.210 28.400,230.400 28.580,230.400 28.800 C 230.400 29.031,229.133 29.200,227.400 29.200 C 225.667 29.200,224.400 29.031,224.400 28.800 C 224.400 28.547,221.600 28.400,216.800 28.400 C 210.311 28.400,209.200 28.312,209.200 27.800 C 209.200 27.287,208.063 27.200,201.371 27.200 C 194.130 27.200,193.551 27.147,193.674 26.500 C 193.761 26.039,194.249 25.757,195.103 25.675 C 195.816 25.606,196.400 25.381,196.400 25.175 C 196.400 24.969,196.850 24.800,197.400 24.800 C 197.950 24.800,198.400 24.620,198.400 24.400 C 198.400 24.180,198.921 24.000,199.557 24.000 C 200.217 24.000,200.813 23.742,200.945 23.400 C 201.071 23.070,201.541 22.800,201.987 22.800 C 202.434 22.800,202.800 22.620,202.800 22.400 C 202.800 22.180,203.430 22.000,204.200 22.000 C 204.970 22.000,205.600 21.820,205.600 21.600 C 205.600 21.380,206.410 21.200,207.400 21.200 C 208.390 21.200,209.200 21.020,209.200 20.800 C 209.200 20.580,209.721 20.400,210.357 20.400 C 211.017 20.400,211.613 20.142,211.745 19.800 C 211.911 19.367,212.590 19.200,214.187 19.200 C 215.404 19.200,216.400 19.020,216.400 18.800 C 216.400 18.580,217.210 18.400,218.200 18.400 C 219.190 18.400,220.000 18.220,220.000 18.000 C 220.000 17.774,221.133 17.600,222.600 17.600 C 224.067 17.600,225.200 17.426,225.200 17.200 C 225.200 16.972,226.386 16.800,227.957 16.800 C 230.039 16.800,230.771 16.653,230.945 16.200 C 231.114 15.758,231.812 15.600,233.587 15.600 C 234.929 15.600,236.000 15.422,236.000 15.200 C 236.000 14.980,236.810 14.800,237.800 14.800 C 238.790 14.800,239.600 14.620,239.600 14.400 C 239.600 13.878,236.122 13.878,235.800 14.400 C 235.664 14.621,233.870 14.800,231.800 14.800 C 229.730 14.800,227.936 14.979,227.800 15.200 C 227.664 15.420,226.573 15.600,225.376 15.600 C 224.179 15.600,223.200 15.780,223.200 16.000 C 223.200 16.220,222.840 16.400,222.400 16.400 C 220.708 16.400,221.992 14.044,223.700 14.013 C 224.085 14.006,224.400 13.820,224.400 13.600 C 224.400 13.380,224.741 13.200,225.157 13.200 C 225.574 13.200,226.018 12.930,226.145 12.600 C 226.271 12.270,226.741 12.000,227.187 12.000 C 227.634 12.000,228.000 11.820,228.000 11.600 C 228.000 11.380,228.360 11.200,228.800 11.200 C 229.240 11.200,229.600 11.020,229.600 10.800 C 229.600 10.580,229.870 10.400,230.200 10.400 C 231.922 10.400,230.435 6.844,228.700 6.813 C 228.315 6.806,228.000 6.530,228.000 6.200 C 228.000 5.354,224.580 5.354,224.255 6.200 C 224.121 6.551,223.521 6.800,222.813 6.800 C 222.146 6.800,221.600 6.980,221.600 7.200 C 221.600 7.420,221.150 7.600,220.600 7.600 C 220.050 7.600,219.600 7.780,219.600 8.000 C 219.600 8.220,219.240 8.400,218.800 8.400 C 218.360 8.400,218.000 8.580,218.000 8.800 C 218.000 9.020,217.550 9.200,217.000 9.200 C 216.450 9.200,216.000 9.393,216.000 9.629 C 216.000 10.257,214.951 11.200,214.252 11.200 C 213.919 11.200,213.536 11.380,213.400 11.600 C 213.264 11.820,212.803 12.000,212.376 12.000 C 211.949 12.000,211.600 12.180,211.600 12.400 C 211.600 12.620,211.259 12.800,210.843 12.800 C 210.426 12.800,209.982 13.070,209.855 13.400 C 209.729 13.730,209.259 14.000,208.813 14.000 C 208.366 14.000,208.000 14.180,208.000 14.400 C 208.000 14.620,207.651 14.800,207.224 14.800 C 206.797 14.800,206.336 14.980,206.200 15.200 C 206.064 15.420,205.423 15.600,204.776 15.600 C 204.129 15.600,203.600 15.780,203.600 16.000 C 203.600 16.220,203.150 16.400,202.600 16.400 C 201.978 16.400,201.600 16.627,201.600 17.000 C 201.600 17.333,201.244 17.600,200.800 17.600 C 200.360 17.600,200.000 17.780,200.000 18.000 C 200.000 18.220,199.550 18.400,199.000 18.400 C 198.450 18.400,198.000 18.580,198.000 18.800 C 198.000 19.020,197.640 19.200,197.200 19.200 C 196.760 19.200,196.400 19.380,196.400 19.600 C 196.400 19.820,195.950 20.000,195.400 20.000 C 194.778 20.000,194.400 20.227,194.400 20.600 C 194.400 20.933,194.044 21.200,193.600 21.200 C 193.160 21.200,192.800 21.380,192.800 21.600 C 192.800 21.820,192.350 22.000,191.800 22.000 C 191.250 22.000,190.800 22.180,190.800 22.400 C 190.800 22.620,190.440 22.800,190.000 22.800 C 189.560 22.800,189.200 22.980,189.200 23.200 C 189.200 23.420,188.570 23.600,187.800 23.600 C 187.030 23.600,186.400 23.767,186.400 23.971 C 186.400 24.578,183.978 25.600,182.539 25.600 C 181.802 25.600,181.200 25.780,181.200 26.000 C 181.200 26.222,180.133 26.400,178.800 26.400 C 177.467 26.400,176.400 26.578,176.400 26.800 C 176.400 27.020,175.429 27.200,174.243 27.200 C 172.694 27.200,172.021 27.369,171.855 27.800 C 171.527 28.656,168.064 28.633,167.734 27.773 C 167.602 27.428,167.698 26.942,167.947 26.693 C 168.769 25.871,168.514 23.600,167.600 23.600 C 167.138 23.600,166.800 23.867,166.800 24.231 C 166.800 25.061,161.872 30.000,161.043 30.000 C 160.689 30.000,160.400 30.180,160.400 30.400 C 160.400 30.620,159.609 30.800,158.643 30.800 C 157.450 30.800,156.812 30.993,156.655 31.400 C 156.503 31.796,155.877 32.000,154.813 32.000 C 153.926 32.000,153.200 32.180,153.200 32.400 C 153.200 32.620,152.390 32.800,151.400 32.800 C 150.410 32.800,149.600 32.980,149.600 33.200 C 149.600 33.420,148.790 33.600,147.800 33.600 C 146.810 33.600,146.000 33.780,146.000 34.000 C 146.000 34.220,145.634 34.400,145.187 34.400 C 144.741 34.400,144.271 34.670,144.145 35.000 C 144.015 35.338,143.419 35.600,142.781 35.600 C 142.157 35.600,141.536 35.780,141.400 36.000 C 141.019 36.616,140.000 36.474,140.000 35.805 C 140.000 35.052,141.223 33.600,141.857 33.600 C 142.121 33.600,143.147 32.790,144.137 31.800 C 145.127 30.810,146.149 30.000,146.408 30.000 C 146.667 30.000,147.383 29.460,148.000 28.800 C 148.617 28.140,149.499 27.600,149.960 27.600 C 150.422 27.600,150.800 27.412,150.800 27.182 C 150.800 26.490,152.711 24.800,153.494 24.800 C 153.895 24.800,154.488 24.429,154.812 23.975 C 155.135 23.521,155.985 22.871,156.700 22.529 C 157.415 22.188,158.000 21.749,158.000 21.554 C 158.000 21.359,158.317 21.200,158.705 21.200 C 159.093 21.200,159.748 20.750,160.161 20.200 C 160.574 19.650,161.207 19.200,161.568 19.200 C 161.928 19.200,162.483 18.840,162.800 18.400 C 163.117 17.960,163.678 17.600,164.046 17.600 C 164.415 17.600,165.140 17.153,165.658 16.607 C 166.176 16.061,166.797 15.611,167.038 15.607 C 167.279 15.603,167.802 15.240,168.200 14.800 C 168.598 14.360,169.152 14.000,169.431 14.000 C 170.120 14.000,175.600 8.544,175.600 7.859 C 175.600 7.558,176.050 6.974,176.600 6.561 C 177.978 5.526,178.129 1.200,176.787 1.200 C 176.341 1.200,175.871 0.930,175.745 0.600 C 175.420 -0.246,172.000 -0.246,172.000 0.600 M188.639 31.000 C 189.052 31.550,189.707 32.000,190.095 32.000 C 190.483 32.000,190.800 32.180,190.800 32.400 C 190.800 32.620,191.220 32.800,191.732 32.800 C 192.318 32.800,192.864 33.172,193.200 33.800 C 193.527 34.411,194.085 34.800,194.634 34.800 C 195.129 34.800,195.602 35.007,195.687 35.260 C 195.771 35.513,196.084 35.639,196.381 35.540 C 196.771 35.410,196.626 35.062,195.861 34.298 C 194.423 32.859,194.475 32.000,196.000 32.000 C 196.660 32.000,197.200 32.180,197.200 32.400 C 197.200 32.620,197.830 32.800,198.600 32.800 C 199.370 32.800,200.000 32.980,200.000 33.200 C 200.000 33.420,200.450 33.600,201.000 33.600 C 202.420 33.600,202.238 33.004,200.576 32.216 C 198.879 31.410,198.840 30.265,200.503 30.073 C 201.286 29.983,201.600 30.126,201.600 30.573 C 201.600 31.083,202.125 31.200,204.400 31.200 C 206.000 31.200,207.200 31.371,207.200 31.600 C 207.200 31.820,208.190 32.000,209.400 32.000 C 210.610 32.000,211.600 32.180,211.600 32.400 C 211.600 32.620,212.230 32.800,213.000 32.800 C 213.770 32.800,214.400 32.980,214.400 33.200 C 214.400 33.420,214.946 33.600,215.613 33.600 C 216.321 33.600,216.921 33.849,217.055 34.200 C 217.182 34.530,217.626 34.800,218.043 34.800 C 218.459 34.800,218.800 34.980,218.800 35.200 C 218.800 35.420,219.132 35.600,219.538 35.600 C 219.944 35.600,220.602 35.960,221.000 36.400 C 221.398 36.840,222.056 37.200,222.462 37.200 C 222.868 37.200,223.200 37.470,223.200 37.800 C 223.200 38.143,223.560 38.400,224.040 38.400 C 224.501 38.400,225.383 38.940,226.000 39.600 C 226.617 40.260,227.365 40.800,227.664 40.800 C 227.963 40.800,228.746 41.426,229.404 42.191 C 230.062 42.957,230.892 43.587,231.249 43.591 C 231.606 43.596,232.436 44.230,233.094 45.000 C 233.752 45.770,234.635 46.400,235.057 46.400 C 235.478 46.400,236.083 46.760,236.400 47.200 C 236.717 47.640,237.215 48.000,237.507 48.000 C 237.799 48.000,238.455 48.450,238.965 49.000 C 239.475 49.550,240.146 50.000,240.458 50.000 C 240.769 50.000,241.283 50.360,241.600 50.800 C 241.975 51.320,242.635 51.600,243.488 51.600 C 244.388 51.600,244.800 51.789,244.800 52.200 C 244.800 52.530,245.070 52.800,245.400 52.800 C 245.730 52.800,246.000 52.530,246.000 52.200 C 246.000 51.870,246.180 51.600,246.400 51.600 C 246.620 51.600,246.800 51.251,246.800 50.824 C 246.800 50.397,246.620 49.936,246.400 49.800 C 246.180 49.664,246.000 49.315,246.000 49.023 C 246.000 48.364,242.879 45.200,242.228 45.200 C 241.966 45.200,241.364 44.840,240.892 44.400 C 240.420 43.960,239.827 43.600,239.574 43.600 C 239.322 43.600,238.761 43.150,238.329 42.600 C 237.896 42.050,237.195 41.600,236.771 41.600 C 236.347 41.600,236.000 41.420,236.000 41.200 C 236.000 40.980,235.640 40.800,235.200 40.800 C 234.760 40.800,234.400 40.641,234.400 40.446 C 234.400 40.251,233.770 39.792,233.000 39.427 C 232.230 39.061,231.600 38.591,231.600 38.381 C 231.600 38.172,231.150 38.000,230.600 38.000 C 230.050 38.000,229.600 37.820,229.600 37.600 C 229.600 37.380,229.240 37.200,228.800 37.200 C 228.360 37.200,228.000 37.033,228.000 36.828 C 228.000 36.623,227.597 36.398,227.104 36.328 C 225.495 36.098,225.721 34.800,227.371 34.800 C 228.157 34.800,228.800 34.980,228.800 35.200 C 228.800 35.420,229.329 35.600,229.976 35.600 C 230.623 35.600,231.264 35.780,231.400 36.000 C 231.536 36.220,232.177 36.400,232.824 36.400 C 233.471 36.400,234.000 36.580,234.000 36.800 C 234.000 37.020,234.546 37.200,235.213 37.200 C 235.921 37.200,236.521 37.449,236.655 37.800 C 236.782 38.130,237.216 38.400,237.619 38.400 C 238.023 38.400,238.464 38.580,238.600 38.800 C 238.736 39.020,239.377 39.200,240.024 39.200 C 240.671 39.200,241.200 39.380,241.200 39.600 C 241.200 39.820,241.549 40.000,241.976 40.000 C 242.403 40.000,242.864 40.180,243.000 40.400 C 243.136 40.620,243.597 40.800,244.024 40.800 C 244.451 40.800,244.800 41.070,244.800 41.400 C 244.800 41.773,245.178 42.000,245.800 42.000 C 246.350 42.000,246.800 42.180,246.800 42.400 C 246.800 42.620,247.160 42.800,247.600 42.800 C 248.040 42.800,248.400 42.980,248.400 43.200 C 248.400 43.420,248.749 43.600,249.176 43.600 C 249.603 43.600,250.064 43.780,250.200 44.000 C 250.336 44.220,250.797 44.400,251.224 44.400 C 251.651 44.400,252.000 44.670,252.000 45.000 C 252.000 45.373,252.378 45.600,253.000 45.600 C 253.550 45.600,254.000 45.780,254.000 46.000 C 254.000 46.220,254.320 46.400,254.712 46.400 C 255.103 46.400,255.683 46.760,256.000 47.200 C 256.317 47.640,256.872 48.000,257.232 48.000 C 257.593 48.000,258.226 48.450,258.639 49.000 C 259.052 49.550,259.757 50.000,260.207 50.000 C 260.656 50.000,261.283 50.360,261.600 50.800 C 261.917 51.240,262.415 51.600,262.707 51.600 C 262.999 51.600,263.655 52.050,264.165 52.600 C 264.675 53.150,265.346 53.600,265.658 53.600 C 265.969 53.600,266.483 53.960,266.800 54.400 C 267.117 54.840,267.579 55.200,267.827 55.200 C 268.560 55.200,270.800 56.427,270.800 56.829 C 270.800 57.033,271.070 57.200,271.400 57.200 C 271.730 57.200,272.000 57.380,272.000 57.600 C 272.000 57.820,272.320 58.000,272.712 58.000 C 273.103 58.000,273.683 58.360,274.000 58.800 C 274.317 59.240,274.799 59.600,275.070 59.600 C 275.342 59.600,276.014 60.050,276.564 60.600 C 277.114 61.150,277.831 61.600,278.158 61.600 C 278.485 61.600,278.864 61.780,279.000 62.000 C 279.318 62.515,280.800 62.523,280.800 62.009 C 280.800 61.794,280.305 61.301,279.700 60.912 C 279.095 60.524,278.251 59.890,277.825 59.503 C 277.398 59.116,276.763 58.800,276.413 58.800 C 276.063 58.800,275.517 58.440,275.200 58.000 C 274.883 57.560,274.401 57.200,274.130 57.200 C 273.858 57.200,273.186 56.750,272.636 56.200 C 272.086 55.650,271.386 55.200,271.080 55.200 C 270.774 55.200,270.198 54.840,269.800 54.400 C 269.402 53.960,268.879 53.597,268.638 53.593 C 268.397 53.589,267.776 53.139,267.258 52.593 C 266.740 52.047,266.015 51.600,265.646 51.600 C 265.278 51.600,264.717 51.240,264.400 50.800 C 264.083 50.360,263.528 50.000,263.168 50.000 C 262.807 50.000,262.174 49.550,261.761 49.000 C 261.348 48.450,260.721 48.000,260.367 48.000 C 260.013 48.000,259.398 47.640,259.000 47.200 C 258.602 46.760,258.028 46.400,257.725 46.400 C 257.423 46.400,257.071 46.130,256.945 45.800 C 256.818 45.470,256.323 45.200,255.846 45.200 C 255.368 45.200,254.717 44.840,254.400 44.400 C 254.083 43.960,253.621 43.600,253.373 43.600 C 252.640 43.600,250.400 42.373,250.400 41.971 C 250.400 41.767,250.051 41.600,249.624 41.600 C 249.197 41.600,248.736 41.420,248.600 41.200 C 248.464 40.980,248.003 40.800,247.576 40.800 C 247.149 40.800,246.800 40.620,246.800 40.400 C 246.800 40.180,246.440 40.000,246.000 40.000 C 245.560 40.000,245.200 39.820,245.200 39.600 C 245.200 39.380,244.834 39.200,244.387 39.200 C 243.941 39.200,243.471 38.930,243.345 38.600 C 243.218 38.270,242.784 38.000,242.381 38.000 C 241.977 38.000,241.536 37.820,241.400 37.600 C 241.264 37.380,240.803 37.200,240.376 37.200 C 239.949 37.200,239.600 37.020,239.600 36.800 C 239.600 36.580,239.071 36.400,238.424 36.400 C 237.777 36.400,237.136 36.220,237.000 36.000 C 236.864 35.780,236.038 35.600,235.164 35.600 C 234.120 35.600,233.496 35.394,233.345 35.000 C 233.213 34.658,232.617 34.400,231.957 34.400 C 231.321 34.400,230.800 34.220,230.800 34.000 C 230.800 33.780,230.170 33.600,229.400 33.600 C 228.630 33.600,228.000 33.420,228.000 33.200 C 228.000 32.980,227.370 32.800,226.600 32.800 C 225.467 32.800,225.200 32.648,225.200 32.000 C 225.200 31.259,225.467 31.200,228.800 31.200 C 230.933 31.200,232.400 31.363,232.400 31.600 C 232.400 31.826,233.533 32.000,235.000 32.000 C 236.467 32.000,237.600 32.174,237.600 32.400 C 237.600 32.625,238.725 32.800,240.176 32.800 C 241.593 32.800,242.864 32.980,243.000 33.200 C 243.136 33.420,244.142 33.600,245.236 33.600 C 246.635 33.600,247.293 33.778,247.455 34.200 C 247.597 34.570,248.205 34.800,249.043 34.800 C 249.789 34.800,250.400 34.980,250.400 35.200 C 250.400 35.420,250.940 35.600,251.600 35.600 C 252.260 35.600,252.800 35.780,252.800 36.000 C 252.800 36.220,253.610 36.400,254.600 36.400 C 255.590 36.400,256.400 36.580,256.400 36.800 C 256.400 37.020,257.030 37.200,257.800 37.200 C 258.778 37.200,259.200 37.381,259.200 37.800 C 259.200 38.219,259.622 38.400,260.600 38.400 C 261.370 38.400,262.000 38.580,262.000 38.800 C 262.000 39.020,262.630 39.200,263.400 39.200 C 264.170 39.200,264.800 39.380,264.800 39.600 C 264.800 39.820,265.160 40.000,265.600 40.000 C 266.040 40.000,266.400 40.180,266.400 40.400 C 266.400 40.620,266.946 40.800,267.613 40.800 C 268.321 40.800,268.921 41.049,269.055 41.400 C 269.182 41.730,269.626 42.000,270.043 42.000 C 270.459 42.000,270.800 42.180,270.800 42.400 C 270.800 42.620,271.250 42.800,271.800 42.800 C 272.350 42.800,272.800 42.980,272.800 43.200 C 272.800 43.420,273.329 43.600,273.976 43.600 C 274.623 43.600,275.264 43.780,275.400 44.000 C 275.536 44.220,275.997 44.400,276.424 44.400 C 276.851 44.400,277.200 44.670,277.200 45.000 C 277.200 45.373,277.578 45.600,278.200 45.600 C 278.750 45.600,279.200 45.780,279.200 46.000 C 279.200 46.220,279.560 46.400,280.000 46.400 C 280.440 46.400,280.800 46.580,280.800 46.800 C 280.800 47.020,281.147 47.200,281.571 47.200 C 281.995 47.200,282.696 47.650,283.129 48.200 C 283.561 48.750,284.204 49.200,284.558 49.200 C 284.911 49.200,285.200 49.380,285.200 49.600 C 285.200 49.820,285.610 50.000,286.112 50.000 C 286.613 50.000,287.283 50.360,287.600 50.800 C 287.917 51.240,288.503 51.600,288.901 51.600 C 289.299 51.600,289.729 51.870,289.855 52.200 C 289.982 52.530,290.387 52.800,290.754 52.800 C 291.122 52.800,291.683 53.160,292.000 53.600 C 292.317 54.040,292.947 54.400,293.400 54.400 C 293.853 54.400,294.483 54.760,294.800 55.200 C 295.117 55.640,295.564 56.000,295.792 56.000 C 296.021 56.000,296.693 56.450,297.287 57.000 C 297.880 57.550,298.567 58.000,298.813 58.000 C 299.445 58.000,301.600 60.228,301.600 60.881 C 301.600 61.179,301.960 61.683,302.400 62.000 C 302.840 62.317,303.200 62.956,303.200 63.421 C 303.200 63.912,303.618 64.489,304.200 64.800 C 304.750 65.094,305.200 65.654,305.200 66.044 C 305.200 66.434,305.380 66.864,305.600 67.000 C 305.820 67.136,306.000 67.777,306.000 68.424 C 306.000 69.071,306.180 69.600,306.400 69.600 C 306.620 69.600,306.800 70.211,306.800 70.957 C 306.800 71.795,307.030 72.403,307.400 72.545 C 307.796 72.697,308.000 73.323,308.000 74.387 C 308.000 75.274,308.180 76.000,308.400 76.000 C 308.620 76.000,308.800 76.630,308.800 77.400 C 308.800 78.170,308.980 78.800,309.200 78.800 C 309.422 78.800,309.600 77.733,309.600 76.400 C 309.600 75.067,309.422 74.000,309.200 74.000 C 308.980 74.000,308.800 73.190,308.800 72.200 C 308.800 71.210,308.620 70.400,308.400 70.400 C 308.180 70.400,308.000 69.860,308.000 69.200 C 308.000 68.267,308.178 68.000,308.800 68.000 C 309.277 68.000,309.600 68.267,309.600 68.660 C 309.600 69.022,310.230 69.931,311.000 70.679 C 311.770 71.427,312.400 72.217,312.400 72.436 C 312.400 72.655,312.760 73.220,313.200 73.692 C 313.640 74.164,314.000 74.877,314.000 75.275 C 314.000 75.674,314.167 76.000,314.371 76.000 C 314.798 76.000,316.000 78.259,316.000 79.061 C 316.000 79.358,316.180 79.600,316.400 79.600 C 316.620 79.600,316.800 79.949,316.800 80.376 C 316.800 80.803,316.980 81.264,317.200 81.400 C 317.420 81.536,317.600 81.997,317.600 82.424 C 317.600 82.851,317.767 83.200,317.971 83.200 C 318.497 83.200,319.600 85.544,319.600 86.661 C 319.600 87.178,319.780 87.600,320.000 87.600 C 320.220 87.600,320.400 88.230,320.400 89.000 C 320.400 89.770,320.580 90.400,320.800 90.400 C 321.020 90.400,321.200 91.011,321.200 91.757 C 321.200 92.595,321.430 93.203,321.800 93.345 C 322.130 93.471,322.400 94.020,322.400 94.564 C 322.400 95.108,322.580 95.664,322.800 95.800 C 323.020 95.936,323.200 96.746,323.200 97.600 C 323.200 98.454,323.380 99.264,323.600 99.400 C 323.820 99.536,324.000 100.357,324.000 101.224 C 324.000 102.091,324.180 102.800,324.400 102.800 C 324.620 102.800,324.800 103.533,324.800 104.429 C 324.800 105.343,325.063 106.320,325.400 106.657 C 325.730 106.987,326.006 107.649,326.013 108.129 C 326.020 108.608,326.480 109.517,327.036 110.150 L 328.048 111.300 328.824 110.467 C 329.787 109.433,329.896 106.239,329.000 105.343 C 328.670 105.013,328.400 104.306,328.400 103.771 C 328.400 103.237,328.220 102.800,328.000 102.800 C 327.780 102.800,327.600 101.990,327.600 101.000 C 327.600 100.010,327.420 99.200,327.200 99.200 C 326.980 99.200,326.800 98.570,326.800 97.800 C 326.800 97.030,326.620 96.400,326.400 96.400 C 326.180 96.400,326.000 96.117,326.000 95.771 C 326.000 95.426,325.730 94.873,325.400 94.543 C 325.070 94.213,324.800 93.506,324.800 92.971 C 324.800 92.437,324.620 92.000,324.400 92.000 C 324.180 92.000,324.000 91.651,324.000 91.224 C 324.000 90.797,323.820 90.336,323.600 90.200 C 323.380 90.064,323.200 89.603,323.200 89.176 C 323.200 88.749,323.020 88.400,322.800 88.400 C 322.580 88.400,322.400 88.040,322.400 87.600 C 322.400 87.160,322.223 86.800,322.008 86.800 C 321.792 86.800,321.502 86.350,321.364 85.800 C 321.226 85.250,320.953 84.800,320.757 84.800 C 320.560 84.800,320.400 84.451,320.400 84.024 C 320.400 83.597,320.220 83.136,320.000 83.000 C 319.780 82.864,319.600 82.403,319.600 81.976 C 319.600 81.549,319.420 81.200,319.200 81.200 C 318.980 81.200,318.800 80.570,318.800 79.800 C 318.800 79.030,318.633 78.400,318.429 78.400 C 318.002 78.400,316.800 76.141,316.800 75.339 C 316.800 75.042,316.620 74.800,316.400 74.800 C 316.180 74.800,316.000 74.522,316.000 74.182 C 316.000 73.842,315.535 73.098,314.966 72.530 C 314.025 71.589,313.989 71.439,314.563 70.866 C 315.136 70.292,315.315 70.369,316.550 71.718 C 317.297 72.533,318.132 73.200,318.407 73.200 C 319.013 73.200,329.200 83.378,329.200 83.984 C 329.200 84.221,329.830 85.026,330.600 85.774 C 331.370 86.521,332.000 87.418,332.000 87.767 C 332.000 88.115,332.180 88.400,332.400 88.400 C 332.620 88.400,332.800 88.670,332.800 89.000 C 332.800 89.330,332.986 89.600,333.213 89.600 C 333.751 89.600,336.400 92.249,336.400 92.787 C 336.400 93.014,336.670 93.200,337.000 93.200 C 337.330 93.200,337.600 93.520,337.600 93.912 C 337.600 94.303,337.960 94.883,338.400 95.200 C 338.840 95.517,339.200 96.100,339.200 96.495 C 339.200 96.890,340.010 97.990,341.000 98.938 C 341.990 99.887,342.800 100.921,342.800 101.236 C 342.800 101.552,343.250 102.148,343.800 102.561 C 344.350 102.974,344.800 103.607,344.800 103.968 C 344.800 104.328,345.160 104.883,345.600 105.200 C 346.342 105.735,346.400 106.235,346.400 112.122 C 346.400 117.019,346.514 118.429,346.900 118.303 C 347.175 118.212,347.456 117.567,347.525 116.869 C 347.785 114.243,350.000 115.077,350.000 117.800 C 350.000 119.010,350.180 120.000,350.400 120.000 C 350.620 120.000,350.800 121.003,350.800 122.229 C 350.800 124.210,350.867 124.390,351.400 123.857 C 351.776 123.482,352.000 122.498,352.000 121.229 C 352.000 119.467,352.105 119.200,352.800 119.200 C 353.333 119.200,353.600 119.467,353.600 120.000 C 353.600 120.440,353.780 120.800,354.000 120.800 C 354.220 120.800,354.400 121.411,354.400 122.157 C 354.400 122.995,354.630 123.603,355.000 123.745 C 355.351 123.879,355.600 124.479,355.600 125.187 C 355.600 125.854,355.780 126.400,356.000 126.400 C 356.220 126.400,356.400 126.760,356.400 127.200 C 356.400 127.640,356.580 128.000,356.800 128.000 C 357.020 128.000,357.200 128.979,357.200 130.176 C 357.200 131.373,357.380 132.464,357.600 132.600 C 357.846 132.752,358.000 136.071,358.000 141.224 C 358.000 146.541,357.854 149.600,357.600 149.600 C 357.363 149.600,357.200 151.067,357.200 153.200 C 357.200 155.333,357.037 156.800,356.800 156.800 C 356.552 156.800,356.400 159.000,356.400 162.600 C 356.400 166.200,356.552 168.400,356.800 168.400 C 357.020 168.400,357.200 168.670,357.200 169.000 C 357.200 169.373,357.578 169.600,358.200 169.600 C 358.822 169.600,359.200 169.373,359.200 169.000 C 359.200 168.670,359.380 168.400,359.600 168.400 C 359.820 168.400,360.000 168.040,360.000 167.600 C 360.000 167.160,360.180 166.800,360.400 166.800 C 360.635 166.800,360.800 165.396,360.800 163.387 C 360.800 160.723,360.932 159.924,361.400 159.745 C 362.318 159.392,362.292 145.398,361.373 145.045 C 360.413 144.677,360.776 142.600,361.800 142.600 C 362.437 142.600,362.599 142.865,362.596 143.900 C 362.594 144.681,362.794 145.200,363.096 145.200 C 363.427 145.200,363.600 145.819,363.600 147.000 C 363.600 147.990,363.780 148.800,364.000 148.800 C 364.226 148.800,364.400 149.933,364.400 151.400 C 364.400 152.867,364.574 154.000,364.800 154.000 C 365.037 154.000,365.200 155.452,365.200 157.557 C 365.200 160.350,365.329 161.164,365.800 161.345 C 366.317 161.543,366.400 163.458,366.400 175.200 C 366.400 186.942,366.317 188.857,365.800 189.055 C 365.294 189.249,365.200 190.542,365.200 197.271 C 365.200 204.370,365.267 205.190,365.800 204.657 C 366.240 204.217,366.400 203.143,366.400 200.629 C 366.400 198.610,366.564 197.200,366.800 197.200 C 367.053 197.200,367.200 194.400,367.200 189.600 C 367.200 184.800,367.347 182.000,367.600 182.000 C 367.857 182.000,368.000 178.133,368.000 171.200 C 368.000 164.267,367.857 160.400,367.600 160.400 C 367.367 160.400,367.200 159.067,367.200 157.200 C 367.200 155.333,367.033 154.000,366.800 154.000 C 366.580 154.000,366.400 153.190,366.400 152.200 C 366.400 151.210,366.220 150.400,366.000 150.400 C 365.780 150.400,365.600 149.429,365.600 148.243 C 365.600 146.694,365.431 146.021,365.000 145.855 C 364.604 145.703,364.400 145.077,364.400 144.013 C 364.400 143.126,364.209 142.400,363.975 142.400 C 363.736 142.400,363.604 141.830,363.675 141.100 C 363.815 139.644,364.891 139.276,365.139 140.600 C 365.222 141.040,365.539 141.544,365.845 141.720 C 366.150 141.896,366.400 142.571,366.400 143.220 C 366.400 143.869,366.580 144.400,366.800 144.400 C 367.020 144.400,367.200 144.760,367.200 145.200 C 367.200 145.640,367.380 146.000,367.600 146.000 C 367.820 146.000,368.000 146.450,368.000 147.000 C 368.000 147.550,368.180 148.000,368.400 148.000 C 368.620 148.000,368.800 148.341,368.800 148.757 C 368.800 149.174,369.070 149.618,369.400 149.745 C 369.751 149.879,370.000 150.479,370.000 151.187 C 370.000 151.854,370.180 152.400,370.400 152.400 C 370.620 152.400,370.800 153.030,370.800 153.800 C 370.800 154.570,370.980 155.200,371.200 155.200 C 371.420 155.200,371.600 155.740,371.600 156.400 C 371.600 157.060,371.780 157.600,372.000 157.600 C 372.220 157.600,372.400 158.211,372.400 158.957 C 372.400 159.795,372.630 160.403,373.000 160.545 C 373.351 160.679,373.600 161.279,373.600 161.987 C 373.600 162.654,373.780 163.200,374.000 163.200 C 374.220 163.200,374.400 164.190,374.400 165.400 C 374.400 166.610,374.580 167.600,374.800 167.600 C 375.020 167.600,375.200 168.410,375.200 169.400 C 375.200 170.390,375.380 171.200,375.600 171.200 C 375.820 171.200,376.000 172.171,376.000 173.357 C 376.000 174.906,376.169 175.579,376.600 175.745 C 377.033 175.911,377.200 176.590,377.200 178.187 C 377.200 179.404,377.380 180.400,377.600 180.400 C 377.835 180.400,378.000 181.792,378.000 183.776 C 378.000 185.633,378.180 187.264,378.400 187.400 C 378.640 187.549,378.800 190.271,378.800 194.224 C 378.800 198.341,378.950 200.800,379.200 200.800 C 379.420 200.800,379.600 201.430,379.600 202.200 C 379.600 202.970,379.420 203.600,379.200 203.600 C 378.947 203.600,378.800 206.533,378.800 211.600 C 378.800 216.667,378.653 219.600,378.400 219.600 C 378.180 219.600,378.000 220.022,378.000 220.539 C 378.000 221.656,376.897 224.000,376.371 224.000 C 376.167 224.000,376.000 224.410,376.000 224.912 C 376.000 225.413,375.640 226.083,375.200 226.400 C 374.760 226.717,374.400 227.239,374.400 227.559 C 374.400 227.879,372.960 229.539,371.200 231.248 C 369.440 232.957,368.000 234.553,368.000 234.795 C 368.000 235.037,367.549 235.722,366.997 236.316 C 366.446 236.911,366.184 237.461,366.416 237.539 C 366.648 237.616,367.165 237.301,367.566 236.840 C 367.966 236.378,368.478 236.000,368.704 236.000 C 368.930 236.000,369.218 235.730,369.345 235.400 C 369.471 235.070,369.806 234.799,370.087 234.798 C 370.369 234.797,371.175 234.257,371.878 233.598 C 373.360 232.209,374.400 232.045,374.400 233.200 C 374.400 233.640,374.220 234.000,374.000 234.000 C 373.780 234.000,373.600 234.546,373.600 235.213 C 373.600 235.921,373.351 236.521,373.000 236.655 C 372.670 236.782,372.400 237.226,372.400 237.643 C 372.400 238.059,372.220 238.400,372.000 238.400 C 371.780 238.400,371.600 238.850,371.600 239.400 C 371.600 239.950,371.420 240.400,371.200 240.400 C 370.980 240.400,370.800 240.683,370.800 241.029 C 370.800 241.747,369.866 242.800,369.229 242.800 C 368.993 242.800,368.800 243.070,368.800 243.400 C 368.800 243.730,368.620 244.000,368.400 244.000 C 368.180 244.000,368.000 244.320,368.000 244.712 C 368.000 245.103,367.640 245.683,367.200 246.000 C 366.760 246.317,366.400 246.854,366.400 247.192 C 366.400 247.531,365.774 248.346,365.009 249.004 C 364.198 249.701,363.614 250.576,363.609 251.100 C 363.604 251.595,363.447 252.000,363.259 252.000 C 362.928 252.000,361.271 253.518,359.939 255.043 C 359.575 255.459,358.765 256.267,358.139 256.839 C 357.513 257.410,356.703 258.220,356.339 258.639 C 355.975 259.057,355.165 259.867,354.539 260.439 C 353.913 261.010,353.103 261.820,352.739 262.239 C 352.375 262.657,351.565 263.467,350.939 264.039 C 349.293 265.540,348.400 266.723,348.400 267.405 C 348.400 267.732,348.130 268.000,347.800 268.000 C 347.427 268.000,347.200 268.378,347.200 269.000 C 347.200 270.055,349.620 270.539,350.200 269.600 C 350.336 269.380,350.694 269.200,350.996 269.200 C 351.855 269.200,356.400 264.486,356.400 263.595 C 356.400 263.158,356.553 262.800,356.741 262.800 C 357.529 262.800,360.800 259.089,360.800 258.195 C 360.800 257.868,361.005 257.600,361.256 257.600 C 361.815 257.600,362.770 256.394,362.787 255.667 C 362.794 255.373,363.430 254.521,364.200 253.774 C 364.970 253.026,365.600 252.181,365.600 251.895 C 365.600 251.610,365.960 251.117,366.400 250.800 C 366.840 250.483,367.200 249.916,367.200 249.541 C 367.200 249.165,367.650 248.504,368.200 248.071 C 368.750 247.639,369.200 247.022,369.200 246.702 C 369.200 246.381,369.740 245.554,370.400 244.863 C 371.060 244.172,371.600 243.417,371.600 243.185 C 371.600 242.952,372.050 242.345,372.600 241.835 C 373.150 241.325,373.600 240.614,373.600 240.254 C 373.600 239.894,373.767 239.600,373.972 239.600 C 374.177 239.600,374.402 239.197,374.472 238.704 C 374.702 237.095,376.000 237.321,376.000 238.971 C 376.000 239.757,375.820 240.400,375.600 240.400 C 375.380 240.400,375.200 241.390,375.200 242.600 C 375.200 243.810,375.020 244.800,374.800 244.800 C 374.580 244.800,374.400 245.610,374.400 246.600 C 374.400 247.590,374.220 248.400,374.000 248.400 C 373.780 248.400,373.600 249.126,373.600 250.013 C 373.600 251.077,373.396 251.703,373.000 251.855 C 372.630 251.997,372.400 252.605,372.400 253.443 C 372.400 254.189,372.220 254.800,372.000 254.800 C 371.780 254.800,371.600 255.340,371.600 256.000 C 371.600 256.660,371.420 257.200,371.200 257.200 C 370.980 257.200,370.800 257.830,370.800 258.600 C 370.800 259.370,370.620 260.000,370.400 260.000 C 370.180 260.000,370.000 260.366,370.000 260.813 C 370.000 261.259,369.730 261.729,369.400 261.855 C 369.058 261.987,368.800 262.583,368.800 263.243 C 368.800 263.879,368.620 264.400,368.400 264.400 C 368.180 264.400,368.000 265.030,368.000 265.800 C 368.000 266.570,367.820 267.200,367.600 267.200 C 367.380 267.200,367.200 267.830,367.200 268.600 C 367.200 269.370,367.020 270.000,366.800 270.000 C 366.580 270.000,366.400 270.276,366.400 270.613 C 366.400 270.949,366.130 271.329,365.800 271.455 C 365.470 271.582,365.200 272.116,365.200 272.643 C 365.200 273.169,365.020 273.600,364.800 273.600 C 364.580 273.600,364.400 273.960,364.400 274.400 C 364.400 274.840,364.220 275.200,364.000 275.200 C 363.780 275.200,363.600 275.830,363.600 276.600 C 363.600 277.370,363.420 278.000,363.200 278.000 C 362.980 278.000,362.800 278.366,362.800 278.813 C 362.800 279.259,362.530 279.729,362.200 279.855 C 361.870 279.982,361.600 280.426,361.600 280.843 C 361.600 281.259,361.420 281.600,361.200 281.600 C 360.980 281.600,360.800 281.905,360.800 282.278 C 360.800 283.194,358.826 285.200,357.925 285.200 C 357.526 285.200,357.200 285.380,357.200 285.600 C 357.200 285.820,356.840 286.000,356.400 286.000 C 355.960 286.000,355.600 286.177,355.600 286.392 C 355.600 286.608,355.150 286.898,354.600 287.036 C 354.050 287.174,353.600 287.447,353.600 287.643 C 353.600 287.840,353.285 288.006,352.900 288.013 C 352.173 288.026,350.800 288.897,350.800 289.344 C 350.800 289.761,352.731 289.635,353.000 289.200 C 353.415 288.528,354.400 288.755,354.400 289.522 C 354.400 290.303,351.949 293.200,351.289 293.200 C 351.067 293.200,350.782 293.470,350.655 293.800 C 350.529 294.130,350.177 294.400,349.875 294.400 C 349.572 294.400,348.998 294.760,348.600 295.200 C 347.562 296.346,349.477 296.346,350.708 295.200 C 351.813 294.171,352.800 294.171,352.800 295.200 C 352.800 295.640,352.620 296.000,352.400 296.000 C 352.180 296.000,352.000 296.271,352.000 296.602 C 352.000 296.934,351.190 298.003,350.200 298.979 C 349.210 299.955,348.400 300.957,348.400 301.205 C 348.400 301.838,343.348 306.800,342.704 306.800 C 342.414 306.800,341.917 307.160,341.600 307.600 C 341.283 308.040,340.613 308.400,340.112 308.400 C 339.610 308.400,339.200 308.593,339.200 308.829 C 339.200 309.534,338.114 310.400,337.229 310.400 C 336.773 310.400,336.400 310.580,336.400 310.800 C 336.400 311.020,336.040 311.200,335.600 311.200 C 335.160 311.200,334.800 311.380,334.800 311.600 C 334.800 311.820,334.434 312.000,333.987 312.000 C 333.541 312.000,333.071 312.270,332.945 312.600 C 332.818 312.930,332.374 313.200,331.957 313.200 C 331.541 313.200,331.200 313.380,331.200 313.600 C 331.200 313.820,330.750 314.000,330.200 314.000 C 329.650 314.000,329.200 314.180,329.200 314.400 C 329.200 314.620,328.840 314.800,328.400 314.800 C 327.960 314.800,327.600 314.980,327.600 315.200 C 327.600 315.420,326.970 315.600,326.200 315.600 C 325.222 315.600,324.800 315.781,324.800 316.200 C 324.800 316.530,324.451 316.800,324.024 316.800 C 323.597 316.800,323.136 316.980,323.000 317.200 C 322.864 317.420,322.403 317.600,321.976 317.600 C 321.549 317.600,321.200 317.780,321.200 318.000 C 321.200 318.220,320.671 318.400,320.024 318.400 C 319.377 318.400,318.736 318.580,318.600 318.800 C 318.464 319.020,318.023 319.200,317.619 319.200 C 317.216 319.200,316.782 319.470,316.655 319.800 C 316.529 320.130,316.099 320.400,315.701 320.400 C 315.303 320.400,314.717 320.760,314.400 321.200 C 314.083 321.640,313.580 322.000,313.283 322.000 C 312.368 322.000,311.600 323.082,311.600 324.371 L 311.600 325.600 314.176 325.600 C 315.593 325.600,316.864 325.420,317.000 325.200 C 317.136 324.980,317.597 324.800,318.024 324.800 C 318.451 324.800,318.800 324.620,318.800 324.400 C 318.800 324.180,319.160 324.000,319.600 324.000 C 320.040 324.000,320.400 323.820,320.400 323.600 C 320.400 323.380,320.850 323.200,321.400 323.200 C 321.950 323.200,322.400 323.033,322.400 322.829 C 322.400 322.402,324.659 321.200,325.461 321.200 C 325.758 321.200,326.000 321.020,326.000 320.800 C 326.000 320.580,326.360 320.400,326.800 320.400 C 327.240 320.400,327.600 320.220,327.600 320.000 C 327.600 319.780,328.020 319.600,328.532 319.600 C 329.118 319.600,329.664 319.228,330.000 318.600 C 330.294 318.050,330.831 317.600,331.192 317.600 C 331.554 317.600,332.236 317.240,332.708 316.800 C 333.180 316.360,333.779 316.000,334.039 316.000 C 334.299 316.000,334.729 315.703,334.995 315.339 C 335.530 314.607,336.400 314.916,336.400 315.837 C 336.400 316.715,333.750 319.200,332.813 319.200 C 332.366 319.200,332.000 319.335,332.000 319.500 C 331.999 319.955,330.157 322.000,329.748 322.000 C 329.551 322.000,329.052 322.450,328.639 323.000 C 328.226 323.550,327.670 324.000,327.403 324.000 C 327.137 324.000,326.354 324.540,325.663 325.200 C 324.972 325.860,324.222 326.400,323.997 326.400 C 323.771 326.400,322.974 327.030,322.226 327.800 C 321.479 328.570,320.647 329.200,320.379 329.200 C 320.111 329.200,319.475 329.650,318.965 330.200 C 318.455 330.750,317.799 331.200,317.507 331.200 C 317.215 331.200,316.717 331.560,316.400 332.000 C 316.083 332.440,315.413 332.800,314.912 332.800 C 314.410 332.800,314.000 332.980,314.000 333.200 C 314.000 333.420,313.721 333.600,313.381 333.600 C 313.040 333.600,312.345 334.050,311.835 334.600 C 311.325 335.150,310.614 335.600,310.254 335.600 C 309.894 335.600,309.600 335.780,309.600 336.000 C 309.600 336.220,309.251 336.400,308.824 336.400 C 308.397 336.400,307.936 336.580,307.800 336.800 C 307.664 337.020,307.203 337.200,306.776 337.200 C 306.349 337.200,306.000 337.367,306.000 337.571 C 306.000 337.998,303.741 339.200,302.939 339.200 C 302.642 339.200,302.400 339.380,302.400 339.600 C 302.400 339.820,302.051 340.000,301.624 340.000 C 301.197 340.000,300.736 340.180,300.600 340.400 C 300.464 340.620,300.003 340.800,299.576 340.800 C 299.149 340.800,298.800 340.967,298.800 341.171 C 298.800 341.598,296.541 342.800,295.739 342.800 C 295.442 342.800,295.200 342.980,295.200 343.200 C 295.200 343.420,294.851 343.600,294.424 343.600 C 293.997 343.600,293.536 343.780,293.400 344.000 C 293.264 344.220,292.803 344.400,292.376 344.400 C 291.949 344.400,291.600 344.567,291.600 344.771 C 291.600 345.198,289.341 346.400,288.539 346.400 C 288.242 346.400,288.000 346.580,288.000 346.800 C 288.000 347.020,287.674 347.200,287.275 347.200 C 286.877 347.200,286.114 347.605,285.581 348.100 L 284.610 349.000 285.707 349.127 C 286.321 349.198,287.079 348.978,287.430 348.627 C 287.775 348.282,288.314 348.000,288.629 348.000 C 288.943 348.000,289.200 347.820,289.200 347.600 C 289.200 347.380,289.560 347.200,290.000 347.200 C 290.440 347.200,290.800 347.020,290.800 346.800 C 290.800 346.580,291.250 346.400,291.800 346.400 C 292.350 346.400,292.800 346.220,292.800 346.000 C 292.800 345.780,293.160 345.600,293.600 345.600 C 294.040 345.600,294.400 345.420,294.400 345.200 C 294.400 344.980,294.766 344.800,295.213 344.800 C 295.659 344.800,296.129 344.530,296.255 344.200 C 296.382 343.870,296.826 343.600,297.243 343.600 C 297.659 343.600,298.000 343.420,298.000 343.200 C 298.000 342.980,298.450 342.800,299.000 342.800 C 299.550 342.800,300.000 342.620,300.000 342.400 C 300.000 342.180,300.360 342.000,300.800 342.000 C 301.240 342.000,301.600 341.820,301.600 341.600 C 301.600 341.380,301.966 341.200,302.413 341.200 C 302.859 341.200,303.329 340.930,303.455 340.600 C 303.582 340.270,304.026 340.000,304.443 340.000 C 304.859 340.000,305.200 339.820,305.200 339.600 C 305.200 339.380,305.650 339.200,306.200 339.200 C 306.750 339.200,307.200 339.020,307.200 338.800 C 307.200 338.580,307.560 338.400,308.000 338.400 C 308.440 338.400,308.800 338.220,308.800 338.000 C 308.800 337.780,309.166 337.600,309.613 337.600 C 310.059 337.600,310.529 337.330,310.655 337.000 C 310.782 336.670,311.226 336.400,311.643 336.400 C 312.059 336.400,312.400 336.220,312.400 336.000 C 312.400 335.780,312.850 335.600,313.400 335.600 C 313.950 335.600,314.400 335.420,314.400 335.200 C 314.400 334.980,314.717 334.800,315.105 334.800 C 315.493 334.800,316.148 334.350,316.561 333.800 C 316.974 333.250,317.647 332.800,318.056 332.800 C 318.465 332.800,318.800 332.620,318.800 332.400 C 318.800 332.180,319.078 332.000,319.417 332.000 C 319.756 332.000,320.420 331.640,320.892 331.200 C 321.364 330.760,322.006 330.400,322.318 330.400 C 322.630 330.400,323.239 329.950,323.671 329.400 C 324.104 328.850,324.720 328.400,325.041 328.400 C 325.361 328.400,326.776 327.230,328.185 325.800 C 329.594 324.370,330.956 323.200,331.212 323.200 C 331.467 323.200,333.271 321.580,335.221 319.600 C 337.172 317.620,339.044 316.000,339.384 316.000 C 340.382 316.000,340.092 317.193,338.800 318.400 C 338.140 319.017,337.600 319.784,337.600 320.104 C 337.600 320.425,337.150 321.026,336.600 321.439 C 336.050 321.852,335.600 322.462,335.600 322.795 C 335.599 323.427,333.914 325.600,333.425 325.600 C 332.905 325.600,332.000 326.736,332.000 327.390 C 332.000 328.108,330.273 330.000,329.618 330.000 C 329.388 330.000,329.200 330.176,329.200 330.391 C 329.200 330.886,314.429 345.600,313.932 345.600 C 313.729 345.600,313.136 346.005,312.613 346.500 C 310.402 348.594,309.668 349.200,309.344 349.202 C 309.155 349.203,308.425 349.743,307.722 350.402 C 307.019 351.061,306.242 351.600,305.995 351.600 C 305.748 351.600,304.952 352.230,304.226 353.000 C 303.500 353.770,302.694 354.400,302.435 354.400 C 302.177 354.400,301.480 354.850,300.887 355.400 C 300.293 355.950,299.581 356.400,299.304 356.400 C 299.027 356.400,298.800 356.580,298.800 356.800 C 298.800 357.020,298.474 357.200,298.075 357.200 C 297.677 357.200,296.964 357.560,296.492 358.000 C 296.020 358.440,295.356 358.800,295.017 358.800 C 294.678 358.800,294.400 358.980,294.400 359.200 C 294.400 359.420,293.950 359.600,293.400 359.600 C 292.850 359.600,292.400 359.793,292.400 360.029 C 292.400 360.657,291.351 361.600,290.652 361.600 C 290.319 361.600,289.936 361.780,289.800 362.000 C 289.664 362.220,289.203 362.400,288.776 362.400 C 288.349 362.400,288.000 362.580,288.000 362.800 C 288.000 363.020,287.659 363.200,287.243 363.200 C 286.826 363.200,286.382 363.470,286.255 363.800 C 286.129 364.130,285.659 364.400,285.213 364.400 C 284.766 364.400,284.400 364.580,284.400 364.800 C 284.400 365.020,284.051 365.200,283.624 365.200 C 283.197 365.200,282.736 365.380,282.600 365.600 C 282.464 365.820,282.003 366.000,281.576 366.000 C 281.149 366.000,280.800 366.180,280.800 366.400 C 280.800 366.620,280.459 366.800,280.043 366.800 C 279.626 366.800,279.182 367.070,279.055 367.400 C 278.879 367.860,278.121 368.000,275.813 368.000 C 274.071 368.000,272.800 368.169,272.800 368.400 C 272.800 368.620,271.990 368.800,271.000 368.800 C 270.010 368.800,269.200 368.620,269.200 368.400 C 269.200 368.174,268.067 368.000,266.600 368.000 C 264.556 368.000,264.000 367.872,264.000 367.400 C 264.000 366.956,263.533 366.800,262.200 366.800 C 261.210 366.800,260.400 366.620,260.400 366.400 C 260.400 366.180,259.686 366.000,258.813 366.000 C 257.566 366.000,257.275 366.129,257.455 366.600 C 257.582 366.930,258.026 367.200,258.443 367.200 C 258.859 367.200,259.200 367.380,259.200 367.600 C 259.200 367.820,259.830 368.000,260.600 368.000 C 261.370 368.000,262.000 368.169,262.000 368.375 C 262.000 368.581,262.585 368.806,263.300 368.875 C 264.450 368.986,264.600 369.139,264.600 370.200 L 264.600 371.400 256.291 371.508 C 249.157 371.601,247.948 371.530,247.748 371.008 C 247.568 370.540,246.837 370.400,244.581 370.400 C 242.967 370.400,241.536 370.220,241.400 370.000 C 241.264 369.780,240.173 369.600,238.976 369.600 C 237.779 369.600,236.800 369.420,236.800 369.200 C 236.800 368.980,236.091 368.800,235.224 368.800 C 234.357 368.800,233.536 368.620,233.400 368.400 C 233.264 368.180,232.438 368.000,231.564 368.000 C 230.520 368.000,229.896 367.794,229.745 367.400 C 229.613 367.058,229.017 366.800,228.357 366.800 C 227.721 366.800,227.200 366.620,227.200 366.400 C 227.200 366.180,226.570 366.000,225.800 366.000 C 225.030 366.000,224.400 365.820,224.400 365.600 C 224.400 364.965,220.029 365.114,219.371 365.771 C 218.419 366.724,219.221 368.000,220.771 368.000 C 221.227 368.000,221.600 368.180,221.600 368.400 C 221.600 368.620,221.960 368.800,222.400 368.800 C 222.840 368.800,223.200 368.980,223.200 369.200 C 223.200 369.420,223.926 369.600,224.813 369.600 C 225.877 369.600,226.503 369.804,226.655 370.200 C 226.812 370.607,227.450 370.800,228.643 370.800 C 229.609 370.800,230.400 370.980,230.400 371.200 C 230.400 371.429,231.600 371.600,233.200 371.600 C 234.800 371.600,236.000 371.771,236.000 372.000 C 236.000 372.248,238.200 372.400,241.800 372.400 C 245.309 372.400,247.600 372.554,247.600 372.791 C 247.600 373.026,250.420 373.225,254.700 373.291 C 261.497 373.395,261.800 373.434,261.800 374.200 C 261.800 374.810,261.492 375.030,260.500 375.125 C 259.785 375.194,259.200 375.419,259.200 375.625 C 259.200 375.831,258.570 376.000,257.800 376.000 C 257.030 376.000,256.400 376.180,256.400 376.400 C 256.400 376.620,255.860 376.800,255.200 376.800 C 254.540 376.800,254.000 376.980,254.000 377.200 C 254.000 377.420,253.389 377.600,252.643 377.600 C 251.805 377.600,251.197 377.830,251.055 378.200 C 250.903 378.596,250.277 378.800,249.213 378.800 C 248.326 378.800,247.600 378.980,247.600 379.200 C 247.600 379.420,246.790 379.600,245.800 379.600 C 244.810 379.600,244.000 379.780,244.000 380.000 C 244.000 380.225,242.875 380.400,241.424 380.400 C 240.007 380.400,238.736 380.580,238.600 380.800 C 238.464 381.020,237.213 381.200,235.819 381.200 C 233.936 381.200,233.226 381.354,233.055 381.800 C 232.886 382.241,232.191 382.400,230.436 382.400 C 229.122 382.400,227.936 382.580,227.800 382.800 C 227.664 383.020,226.044 383.200,224.200 383.200 C 222.356 383.200,220.736 383.380,220.600 383.600 C 220.273 384.129,212.800 384.129,212.800 383.600 C 212.800 383.380,212.350 383.200,211.800 383.200 C 211.250 383.200,210.800 383.020,210.800 382.800 C 210.800 382.580,210.440 382.400,210.000 382.400 C 209.556 382.400,209.200 382.133,209.200 381.800 C 209.200 381.470,208.930 381.200,208.600 381.200 C 208.270 381.200,208.000 381.020,208.000 380.800 C 208.000 380.580,207.706 380.400,207.347 380.400 C 206.988 380.400,206.403 380.070,206.047 379.667 C 205.251 378.765,203.600 378.280,203.600 378.949 C 203.600 379.210,203.960 379.683,204.400 380.000 C 205.600 380.865,205.464 382.400,204.187 382.400 C 203.631 382.400,203.071 382.130,202.945 381.800 C 202.803 381.430,202.195 381.200,201.357 381.200 C 200.611 381.200,200.000 381.020,200.000 380.800 C 200.000 380.580,199.640 380.400,199.200 380.400 C 198.760 380.400,198.400 380.220,198.400 380.000 C 198.400 379.780,198.130 379.600,197.800 379.600 C 197.470 379.600,197.200 379.780,197.200 380.000 C 197.200 380.220,197.380 380.400,197.600 380.400 C 197.820 380.400,198.000 380.670,198.000 381.000 C 198.000 381.373,198.378 381.600,199.000 381.600 C 199.550 381.600,200.000 381.780,200.000 382.000 C 200.000 382.220,200.360 382.400,200.800 382.400 C 201.333 382.400,201.600 382.667,201.600 383.200 C 201.600 383.822,201.333 384.000,200.400 384.000 C 199.740 384.000,199.200 383.820,199.200 383.600 C 199.200 383.375,198.075 383.200,196.624 383.200 C 195.207 383.200,193.936 383.020,193.800 382.800 C 193.664 382.580,192.658 382.400,191.564 382.400 C 190.165 382.400,189.507 382.222,189.345 381.800 C 189.188 381.393,188.550 381.200,187.357 381.200 C 186.391 381.200,185.600 381.020,185.600 380.800 C 185.600 380.580,185.240 380.400,184.800 380.400 C 184.360 380.400,184.000 380.220,184.000 380.000 C 184.000 379.780,183.550 379.600,183.000 379.600 C 182.450 379.600,182.000 379.420,182.000 379.200 C 182.000 378.980,181.640 378.800,181.200 378.800 C 180.756 378.800,180.400 378.533,180.400 378.200 C 180.400 377.827,180.022 377.600,179.400 377.600 C 178.850 377.600,178.400 377.420,178.400 377.200 C 178.400 376.980,178.040 376.800,177.600 376.800 C 177.160 376.800,176.800 376.650,176.800 376.468 C 176.800 376.285,176.305 375.881,175.700 375.570 C 175.095 375.260,173.997 374.419,173.260 373.703 C 172.523 372.986,171.655 372.400,171.331 372.400 C 170.723 372.400,169.600 371.474,169.600 370.973 C 169.600 370.536,168.273 369.628,167.600 369.604 C 167.270 369.592,166.462 368.957,165.804 368.191 C 165.146 367.426,164.331 366.800,163.992 366.800 C 163.654 366.800,163.117 366.440,162.800 366.000 C 162.483 365.560,161.916 365.200,161.541 365.200 C 161.165 365.200,160.504 364.750,160.071 364.200 C 159.639 363.650,159.006 363.200,158.666 363.200 C 158.326 363.200,157.936 363.020,157.800 362.800 C 157.664 362.580,157.203 362.400,156.776 362.400 C 156.349 362.400,156.000 362.220,156.000 362.000 C 156.000 361.780,155.370 361.600,154.600 361.600 C 153.267 361.600,153.200 361.667,153.200 363.000 C 153.200 363.770,153.380 364.400,153.600 364.400 C 153.820 364.400,154.000 364.730,154.000 365.134 C 154.000 365.941,156.089 368.000,156.908 368.000 C 157.192 368.000,157.683 368.360,158.000 368.800 C 158.317 369.240,158.872 369.600,159.232 369.600 C 159.593 369.600,160.226 370.050,160.639 370.600 C 161.052 371.150,161.757 371.600,162.207 371.600 C 162.656 371.600,163.283 371.960,163.600 372.400 C 163.917 372.840,164.478 373.200,164.846 373.200 C 165.213 373.200,165.618 373.470,165.745 373.800 C 165.871 374.130,166.301 374.400,166.699 374.400 C 167.097 374.400,167.683 374.760,168.000 375.200 C 168.317 375.640,168.779 376.000,169.027 376.000 C 170.085 376.000,172.038 377.310,171.918 377.940 C 171.745 378.857,169.193 379.088,168.713 378.230 C 168.516 377.879,167.838 377.600,167.180 377.600 C 166.531 377.600,166.000 377.420,166.000 377.200 C 166.000 376.980,165.550 376.800,165.000 376.800 C 164.450 376.800,164.000 376.620,164.000 376.400 C 164.000 376.180,163.460 376.000,162.800 376.000 C 162.140 376.000,161.600 375.820,161.600 375.600 C 161.600 375.380,161.234 375.200,160.787 375.200 C 160.341 375.200,159.871 374.930,159.745 374.600 C 159.618 374.270,159.184 374.000,158.781 374.000 C 158.377 374.000,157.936 373.820,157.800 373.600 C 157.664 373.380,157.203 373.200,156.776 373.200 C 156.349 373.200,156.000 373.020,156.000 372.800 C 156.000 372.580,155.471 372.400,154.824 372.400 C 154.177 372.400,153.536 372.220,153.400 372.000 C 153.264 371.780,152.803 371.600,152.376 371.600 C 151.949 371.600,151.600 371.330,151.600 371.000 C 151.600 370.627,151.222 370.400,150.600 370.400 C 150.050 370.400,149.600 370.220,149.600 370.000 C 149.600 369.780,149.280 369.600,148.888 369.600 C 148.497 369.600,147.917 369.240,147.600 368.800 C 147.283 368.360,146.697 368.000,146.299 368.000 C 145.901 368.000,145.471 367.730,145.345 367.400 C 145.218 367.070,144.774 366.800,144.357 366.800 C 143.941 366.800,143.600 366.620,143.600 366.400 C 143.600 366.180,143.330 366.000,143.000 366.000 C 142.670 366.000,142.400 365.820,142.400 365.600 C 142.400 365.380,142.083 365.200,141.695 365.200 C 141.307 365.200,140.652 364.750,140.239 364.200 C 139.826 363.650,139.153 363.200,138.744 363.200 C 138.335 363.200,138.000 363.020,138.000 362.800 C 138.000 362.580,137.722 362.400,137.383 362.400 C 137.044 362.400,136.380 362.040,135.908 361.600 C 135.436 361.160,134.723 360.800,134.325 360.800 C 133.926 360.800,133.600 360.607,133.600 360.371 C 133.600 359.694,132.528 358.800,131.717 358.800 C 131.310 358.800,130.717 358.440,130.400 358.000 C 130.083 357.560,129.528 357.200,129.168 357.200 C 128.807 357.200,128.174 356.750,127.761 356.200 C 127.348 355.650,126.775 355.200,126.488 355.200 C 126.201 355.200,125.580 354.840,125.108 354.400 C 124.636 353.960,123.923 353.600,123.525 353.600 C 123.126 353.600,122.800 353.420,122.800 353.200 C 122.800 352.980,122.538 352.800,122.218 352.800 C 121.898 352.800,121.186 352.350,120.636 351.800 C 119.540 350.704,119.200 350.571,119.200 351.240 C 119.200 351.820,122.791 355.200,123.408 355.200 C 123.672 355.200,124.226 355.650,124.639 356.200 C 125.053 356.751,125.796 357.200,126.295 357.200 C 126.793 357.200,127.200 357.380,127.200 357.600 C 127.200 357.820,127.479 358.000,127.819 358.000 C 128.160 358.000,128.855 358.450,129.365 359.000 C 129.875 359.550,130.546 360.000,130.858 360.000 C 131.169 360.000,131.683 360.360,132.000 360.800 C 132.317 361.240,132.884 361.600,133.259 361.600 C 133.635 361.600,134.296 362.050,134.729 362.600 C 135.161 363.150,135.770 363.600,136.082 363.600 C 136.394 363.600,137.036 363.960,137.508 364.400 C 137.980 364.840,138.573 365.200,138.826 365.200 C 139.078 365.200,139.639 365.650,140.071 366.200 C 140.504 366.750,141.165 367.200,141.541 367.200 C 141.916 367.200,142.483 367.560,142.800 368.000 C 143.117 368.440,143.586 368.800,143.843 368.800 C 144.542 368.800,146.103 369.687,147.188 370.700 C 147.717 371.195,148.477 371.600,148.875 371.600 C 149.274 371.600,149.600 371.780,149.600 372.000 C 149.600 372.220,149.960 372.400,150.400 372.400 C 150.840 372.400,151.200 372.580,151.200 372.800 C 151.200 373.020,151.566 373.200,152.013 373.200 C 152.459 373.200,152.929 373.470,153.055 373.800 C 153.182 374.130,153.616 374.400,154.019 374.400 C 154.423 374.400,154.864 374.580,155.000 374.800 C 155.136 375.020,155.597 375.200,156.024 375.200 C 156.451 375.200,156.800 375.380,156.800 375.600 C 156.800 375.820,157.160 376.000,157.600 376.000 C 158.040 376.000,158.400 376.180,158.400 376.400 C 158.400 376.620,158.946 376.800,159.613 376.800 C 160.321 376.800,160.921 377.049,161.055 377.400 C 161.197 377.770,161.805 378.000,162.643 378.000 C 163.389 378.000,164.000 378.180,164.000 378.400 C 164.000 378.620,164.630 378.800,165.400 378.800 C 166.170 378.800,166.800 378.980,166.800 379.200 C 166.800 379.420,167.340 379.600,168.000 379.600 C 168.660 379.600,169.200 379.780,169.200 380.000 C 169.200 380.220,170.010 380.400,171.000 380.400 C 172.333 380.400,172.800 380.556,172.800 381.000 C 172.800 381.419,173.222 381.600,174.200 381.600 C 175.333 381.600,175.600 381.752,175.600 382.400 C 175.600 383.118,175.333 383.200,173.000 383.200 C 171.533 383.200,170.400 383.026,170.400 382.800 C 170.400 382.565,168.996 382.400,166.987 382.400 C 164.323 382.400,163.524 382.268,163.345 381.800 C 163.174 381.354,162.464 381.200,160.581 381.200 C 159.187 381.200,157.936 381.020,157.800 380.800 C 157.664 380.580,156.573 380.400,155.376 380.400 C 154.179 380.400,153.200 380.220,153.200 380.000 C 153.200 379.780,152.660 379.600,152.000 379.600 C 151.340 379.600,150.800 379.420,150.800 379.200 C 150.800 378.980,150.009 378.800,149.043 378.800 C 147.850 378.800,147.212 378.607,147.055 378.200 C 146.921 377.849,146.321 377.600,145.613 377.600 C 144.946 377.600,144.400 377.420,144.400 377.200 C 144.400 376.980,143.770 376.800,143.000 376.800 C 142.230 376.800,141.600 376.620,141.600 376.400 C 141.600 376.180,141.071 376.000,140.424 376.000 C 139.777 376.000,139.136 375.820,139.000 375.600 C 138.864 375.380,138.223 375.200,137.576 375.200 C 136.797 375.200,136.400 374.997,136.400 374.600 C 136.400 374.181,135.978 374.000,135.000 374.000 C 134.230 374.000,133.600 373.820,133.600 373.600 C 133.600 373.380,133.150 373.200,132.600 373.200 C 132.050 373.200,131.600 373.020,131.600 372.800 C 131.600 372.580,131.240 372.400,130.800 372.400 C 130.360 372.400,130.000 372.220,130.000 372.000 C 130.000 371.780,129.454 371.600,128.787 371.600 C 128.079 371.600,127.479 371.351,127.345 371.000 C 127.218 370.670,126.774 370.400,126.357 370.400 C 125.941 370.400,125.600 370.220,125.600 370.000 C 125.600 369.780,125.150 369.600,124.600 369.600 C 124.050 369.600,123.600 369.420,123.600 369.200 C 123.600 368.980,123.240 368.800,122.800 368.800 C 122.360 368.800,122.000 368.620,122.000 368.400 C 122.000 368.180,121.634 368.000,121.187 368.000 C 120.741 368.000,120.271 367.730,120.145 367.400 C 120.018 367.070,119.574 366.800,119.157 366.800 C 118.741 366.800,118.400 366.620,118.400 366.400 C 118.400 366.180,117.950 366.000,117.400 366.000 C 116.850 366.000,116.400 365.820,116.400 365.600 C 116.400 365.380,116.106 365.200,115.746 365.200 C 115.386 365.200,114.675 364.750,114.165 364.200 C 113.655 363.650,112.960 363.200,112.619 363.200 C 112.279 363.200,112.000 363.020,112.000 362.800 C 112.000 362.580,111.674 362.400,111.275 362.400 C 110.877 362.400,110.164 362.040,109.692 361.600 C 109.220 361.160,108.556 360.800,108.217 360.800 C 107.878 360.800,107.600 360.530,107.600 360.200 C 107.600 359.870,107.330 359.600,107.000 359.600 C 106.670 359.600,106.400 359.420,106.400 359.200 C 106.400 358.980,106.040 358.800,105.600 358.800 C 105.160 358.800,104.800 358.620,104.800 358.400 C 104.800 358.180,104.463 358.000,104.051 358.000 C 103.639 358.000,102.764 357.370,102.106 356.600 C 101.448 355.830,100.660 355.194,100.355 355.187 C 99.455 355.167,98.400 354.172,98.400 353.344 C 98.400 352.922,98.040 352.317,97.600 352.000 C 97.160 351.683,96.800 351.122,96.800 350.754 C 96.800 350.387,96.530 349.982,96.200 349.855 C 95.870 349.729,95.600 349.259,95.600 348.813 C 95.600 348.366,95.420 348.000,95.200 348.000 C 94.980 348.000,94.800 347.640,94.800 347.200 C 94.800 346.760,94.620 346.400,94.400 346.400 C 94.180 346.400,94.000 345.950,94.000 345.400 C 94.000 344.850,93.820 344.400,93.600 344.400 C 93.380 344.400,93.200 343.609,93.200 342.643 C 93.200 341.450,93.007 340.812,92.600 340.655 C 92.270 340.529,92.000 339.980,92.000 339.436 C 92.000 338.892,91.820 338.336,91.600 338.200 C 91.380 338.064,91.200 337.423,91.200 336.776 C 91.200 336.129,91.020 335.600,90.800 335.600 C 90.278 335.600,90.278 339.877,90.800 340.200 C 91.020 340.336,91.200 341.157,91.200 342.024 C 91.200 342.891,91.380 343.600,91.600 343.600 C 92.126 343.600,92.118 345.080,91.590 345.406 C 91.160 345.672,88.400 343.157,88.400 342.499 C 88.400 342.290,87.860 341.554,87.200 340.863 C 86.540 340.172,86.000 339.358,86.000 339.053 C 86.000 338.748,85.730 338.274,85.400 338.000 C 85.070 337.726,84.800 337.254,84.800 336.951 C 84.800 336.648,84.620 336.400,84.400 336.400 C 84.180 336.400,84.000 336.051,84.000 335.624 C 84.000 335.197,83.820 334.736,83.600 334.600 C 83.380 334.464,83.200 334.003,83.200 333.576 C 83.200 333.149,83.020 332.800,82.800 332.800 C 82.580 332.800,82.400 332.170,82.400 331.400 C 82.400 330.630,82.233 330.000,82.029 330.000 C 81.602 330.000,80.400 327.741,80.400 326.939 C 80.400 326.642,80.220 326.400,80.000 326.400 C 79.780 326.400,79.600 325.871,79.600 325.224 C 79.600 324.577,79.420 323.936,79.200 323.800 C 78.980 323.664,78.800 323.101,78.800 322.548 C 78.800 321.995,78.530 321.273,78.200 320.943 C 77.870 320.613,77.600 319.906,77.600 319.371 C 77.600 318.837,77.420 318.400,77.200 318.400 C 76.980 318.400,76.800 317.590,76.800 316.600 C 76.800 315.610,76.620 314.800,76.400 314.800 C 76.180 314.800,76.000 313.990,76.000 313.000 C 76.000 312.010,75.820 311.200,75.600 311.200 C 75.380 311.200,75.200 310.467,75.200 309.571 C 75.200 308.657,74.937 307.680,74.600 307.343 C 74.270 307.013,74.000 306.388,74.000 305.953 C 74.000 304.571,72.171 303.086,71.209 303.687 C 70.209 304.312,70.068 307.226,71.000 308.000 C 71.330 308.274,71.600 309.095,71.600 309.825 C 71.600 310.555,71.780 311.264,72.000 311.400 C 72.220 311.536,72.400 312.346,72.400 313.200 C 72.400 314.054,72.580 314.864,72.800 315.000 C 73.020 315.136,73.200 315.777,73.200 316.424 C 73.200 317.071,73.380 317.600,73.600 317.600 C 73.820 317.600,74.000 318.050,74.000 318.600 C 74.000 319.150,74.167 319.600,74.371 319.600 C 74.897 319.600,76.000 321.944,76.000 323.061 C 76.000 323.578,76.180 324.000,76.400 324.000 C 76.620 324.000,76.800 324.349,76.800 324.776 C 76.800 325.203,76.980 325.664,77.200 325.800 C 77.420 325.936,77.600 326.397,77.600 326.824 C 77.600 327.251,77.767 327.600,77.971 327.600 C 78.398 327.600,79.600 329.859,79.600 330.661 C 79.600 330.958,79.780 331.200,80.000 331.200 C 80.220 331.200,80.400 331.560,80.400 332.000 C 80.400 332.440,80.580 332.800,80.800 332.800 C 81.020 332.800,81.200 333.173,81.200 333.629 C 81.200 334.084,81.470 334.727,81.800 335.057 C 82.130 335.387,82.400 336.094,82.400 336.629 C 82.400 337.163,82.580 337.600,82.800 337.600 C 83.020 337.600,83.200 337.920,83.200 338.312 C 83.200 338.703,83.560 339.283,84.000 339.600 C 84.440 339.917,84.800 340.587,84.800 341.088 C 84.800 341.590,84.980 342.000,85.200 342.000 C 85.420 342.000,85.600 342.360,85.600 342.800 C 85.600 343.963,84.341 343.805,83.395 342.522 C 82.958 341.930,82.262 341.165,81.850 340.822 C 81.437 340.480,80.680 339.795,80.168 339.300 C 79.656 338.805,79.068 338.400,78.862 338.400 C 78.373 338.400,74.000 334.027,74.000 333.538 C 74.000 333.332,73.595 332.754,73.100 332.254 C 72.605 331.754,71.842 330.862,71.405 330.272 C 70.968 329.682,70.460 329.200,70.276 329.200 C 69.718 329.200,68.800 328.096,68.800 327.425 C 68.800 327.078,67.630 325.646,66.200 324.244 C 64.770 322.842,63.600 321.490,63.600 321.240 C 63.600 320.990,62.970 320.174,62.200 319.426 C 61.430 318.679,60.800 317.782,60.800 317.433 C 60.800 317.085,60.620 316.800,60.400 316.800 C 60.180 316.800,60.000 316.530,60.000 316.200 C 60.000 315.870,59.807 315.600,59.571 315.600 C 58.934 315.600,58.000 314.547,58.000 313.829 C 58.000 313.483,57.820 313.200,57.600 313.200 C 57.380 313.200,57.200 312.930,57.200 312.600 C 57.200 312.270,57.020 312.000,56.800 312.000 C 56.580 312.000,56.400 311.711,56.400 311.358 C 56.400 311.004,55.950 310.361,55.400 309.929 C 54.850 309.496,54.400 308.795,54.400 308.371 C 54.400 307.947,54.220 307.600,54.000 307.600 C 53.751 307.600,53.600 305.338,53.600 301.613 C 53.600 296.455,53.517 295.657,53.000 295.855 C 52.630 295.997,52.400 296.605,52.400 297.443 C 52.400 298.684,52.298 298.800,51.200 298.800 C 50.014 298.800,50.000 298.775,50.000 296.624 C 50.000 295.427,49.820 294.336,49.600 294.200 C 49.380 294.064,49.200 292.939,49.200 291.700 C 49.200 289.633,49.151 289.511,48.613 290.224 C 48.275 290.670,48.020 291.891,48.013 293.100 C 48.002 294.929,47.897 295.200,47.200 295.200 C 46.552 295.200,46.400 294.933,46.400 293.800 C 46.400 293.030,46.220 292.400,46.000 292.400 C 45.780 292.400,45.600 292.034,45.600 291.587 C 45.600 291.141,45.330 290.671,45.000 290.545 C 44.662 290.415,44.400 289.819,44.400 289.181 C 44.400 288.557,44.220 287.936,44.000 287.800 C 43.780 287.664,43.600 287.023,43.600 286.376 C 43.600 285.729,43.420 285.200,43.200 285.200 C 42.980 285.200,42.800 284.390,42.800 283.400 C 42.800 282.410,42.620 281.600,42.400 281.600 C 42.146 281.600,42.000 278.533,42.000 273.200 C 42.000 267.867,42.146 264.800,42.400 264.800 C 42.637 264.800,42.800 263.333,42.800 261.200 C 42.800 259.067,42.963 257.600,43.200 257.600 C 43.883 257.600,43.721 245.264,43.029 244.571 C 42.155 243.698,40.000 245.111,40.000 246.558 C 40.000 246.885,39.820 247.264,39.600 247.400 C 39.379 247.537,39.200 249.342,39.200 251.436 C 39.200 254.435,39.075 255.273,38.600 255.455 C 38.101 255.647,38.000 256.761,38.000 262.043 C 38.000 267.427,38.092 268.400,38.600 268.400 C 39.033 268.400,39.200 268.844,39.200 270.000 C 39.200 271.440,39.100 271.600,38.200 271.600 C 37.360 271.600,37.200 271.412,37.200 270.424 C 37.200 269.777,37.020 269.136,36.800 269.000 C 36.580 268.864,36.400 268.054,36.400 267.200 C 36.400 266.346,36.220 265.536,36.000 265.400 C 35.780 265.264,35.600 263.993,35.600 262.576 C 35.600 261.125,35.425 260.000,35.200 260.000 C 34.960 260.000,34.800 258.414,34.800 256.043 C 34.800 252.894,34.677 252.039,34.200 251.855 C 33.296 251.509,33.296 226.491,34.200 226.145 C 34.708 225.950,34.800 224.591,34.800 217.329 C 34.800 209.697,34.733 208.810,34.200 209.343 C 33.760 209.783,33.600 210.857,33.600 213.371 C 33.600 215.390,33.436 216.800,33.200 216.800 C 32.947 216.800,32.800 219.725,32.800 224.776 C 32.800 229.663,32.645 232.849,32.400 233.000 C 31.857 233.336,31.857 252.664,32.400 253.000 C 32.620 253.136,32.800 254.587,32.800 256.224 C 32.800 257.941,32.969 259.200,33.200 259.200 C 33.420 259.200,33.600 260.190,33.600 261.400 C 33.600 262.610,33.780 263.600,34.000 263.600 C 34.220 263.600,34.400 264.391,34.400 265.357 C 34.400 266.550,34.593 267.188,35.000 267.345 C 36.044 267.745,35.829 271.600,34.763 271.600 C 34.262 271.600,33.841 271.279,33.716 270.800 C 33.601 270.360,33.348 270.000,33.153 270.000 C 32.959 270.000,32.800 269.550,32.800 269.000 C 32.800 268.450,32.620 268.000,32.400 268.000 C 32.180 268.000,32.000 267.640,32.000 267.200 C 32.000 266.760,31.820 266.400,31.600 266.400 C 31.380 266.400,31.200 265.789,31.200 265.043 C 31.200 264.205,30.970 263.597,30.600 263.455 C 30.249 263.321,30.000 262.721,30.000 262.013 C 30.000 261.346,29.820 260.800,29.600 260.800 C 29.380 260.800,29.200 260.440,29.200 260.000 C 29.200 259.560,29.020 259.200,28.800 259.200 C 28.580 259.200,28.400 258.570,28.400 257.800 C 28.400 257.030,28.220 256.400,28.000 256.400 C 27.780 256.400,27.600 255.789,27.600 255.043 C 27.600 254.205,27.370 253.597,27.000 253.455 C 26.604 253.303,26.400 252.677,26.400 251.613 C 26.400 250.726,26.220 250.000,26.000 250.000 C 25.780 250.000,25.600 249.190,25.600 248.200 C 25.600 247.210,25.420 246.400,25.200 246.400 C 24.980 246.400,24.800 245.410,24.800 244.200 C 24.800 242.990,24.620 242.000,24.400 242.000 C 24.180 242.000,24.000 241.209,24.000 240.243 C 24.000 239.050,23.807 238.412,23.400 238.255 C 22.977 238.093,22.800 237.432,22.800 236.013 C 22.800 234.906,22.620 234.000,22.400 234.000 C 22.160 234.000,22.000 232.400,22.000 230.000 C 22.000 227.600,21.840 226.000,21.600 226.000 C 21.051 226.000,21.051 194.939,21.600 194.600 C 21.820 194.464,22.000 193.823,22.000 193.176 C 22.000 192.529,22.180 192.000,22.400 192.000 C 22.620 192.000,22.800 191.634,22.800 191.187 C 22.800 190.741,23.070 190.271,23.400 190.145 C 23.730 190.018,24.000 189.574,24.000 189.157 C 24.000 188.741,24.180 188.400,24.400 188.400 C 24.620 188.400,24.800 187.993,24.800 187.495 C 24.800 186.976,25.259 186.251,25.878 185.795 C 26.470 185.358,27.235 184.662,27.578 184.250 C 27.920 183.837,28.605 183.080,29.100 182.568 C 29.595 182.056,30.000 181.444,30.000 181.208 C 30.000 180.973,31.105 179.699,32.455 178.378 C 33.805 177.057,34.795 175.862,34.655 175.721 C 34.515 175.581,34.400 175.677,34.400 175.933 C 34.400 176.190,34.083 176.400,33.695 176.400 C 33.307 176.400,32.652 176.850,32.239 177.400 C 31.826 177.950,31.233 178.400,30.921 178.400 C 30.609 178.400,29.541 179.224,28.548 180.232 C 27.473 181.322,26.511 181.975,26.171 181.844 C 25.526 181.597,25.384 180.400,26.000 180.400 C 26.220 180.400,26.400 179.854,26.400 179.187 C 26.400 178.479,26.649 177.879,27.000 177.745 C 27.330 177.618,27.600 177.084,27.600 176.557 C 27.600 176.031,27.780 175.600,28.000 175.600 C 28.220 175.600,28.400 175.240,28.400 174.800 C 28.400 174.360,28.580 174.000,28.800 174.000 C 29.020 174.000,29.200 173.653,29.200 173.229 C 29.200 172.805,29.650 172.104,30.200 171.671 C 30.750 171.239,31.200 170.596,31.200 170.242 C 31.200 169.889,31.380 169.600,31.600 169.600 C 31.820 169.600,32.000 169.370,32.000 169.088 C 32.000 168.807,32.360 168.317,32.800 168.000 C 33.240 167.683,33.600 167.103,33.600 166.712 C 33.600 166.320,33.870 166.000,34.200 166.000 C 34.530 166.000,34.800 165.730,34.800 165.400 C 34.800 165.070,34.980 164.800,35.200 164.800 C 35.420 164.800,35.600 164.521,35.600 164.181 C 35.600 163.840,39.200 159.970,43.600 155.580 C 48.000 151.191,51.600 147.324,51.600 146.987 C 51.600 146.650,51.870 146.271,52.200 146.145 C 52.530 146.018,52.800 145.484,52.800 144.957 C 52.800 143.814,50.274 143.508,49.855 144.600 C 49.729 144.930,49.332 145.200,48.973 145.200 C 48.614 145.200,47.817 145.740,47.200 146.400 C 46.583 147.060,45.881 147.600,45.640 147.600 C 45.398 147.600,45.200 147.786,45.200 148.013 C 45.200 148.551,42.551 151.200,42.013 151.200 C 41.786 151.200,41.600 151.570,41.600 152.023 C 41.600 152.476,40.790 153.645,39.800 154.621 C 38.810 155.597,38.000 156.627,38.000 156.909 C 38.000 157.192,37.640 157.683,37.200 158.000 C 36.760 158.317,36.400 158.956,36.400 159.421 C 36.400 159.912,35.982 160.489,35.400 160.800 C 34.850 161.094,34.400 161.631,34.400 161.992 C 34.400 162.354,34.040 163.036,33.600 163.508 C 33.160 163.980,32.800 164.566,32.800 164.810 C 32.800 165.054,32.170 165.848,31.400 166.574 C 30.630 167.300,30.000 168.188,30.000 168.547 C 30.000 168.906,29.841 169.200,29.646 169.200 C 29.451 169.200,29.012 169.785,28.671 170.500 C 28.329 171.215,27.679 172.065,27.225 172.388 C 26.771 172.712,26.400 173.387,26.400 173.888 C 26.400 174.390,26.220 174.800,26.000 174.800 C 25.780 174.800,25.600 175.160,25.600 175.600 C 25.600 176.133,25.333 176.400,24.800 176.400 C 24.178 176.400,24.000 176.133,24.000 175.200 C 24.000 174.540,24.180 174.000,24.400 174.000 C 24.620 174.000,24.800 173.010,24.800 171.800 C 24.800 170.590,24.980 169.600,25.200 169.600 C 25.420 169.600,25.600 168.790,25.600 167.800 C 25.600 166.810,25.780 166.000,26.000 166.000 C 26.220 166.000,26.400 165.274,26.400 164.387 C 26.400 163.323,26.604 162.697,27.000 162.545 C 27.370 162.403,27.600 161.795,27.600 160.957 C 27.600 160.211,27.780 159.600,28.000 159.600 C 28.220 159.600,28.400 158.970,28.400 158.200 C 28.400 157.430,28.580 156.800,28.800 156.800 C 29.020 156.800,29.200 156.378,29.200 155.861 C 29.200 154.744,30.303 152.400,30.829 152.400 C 31.033 152.400,31.200 151.770,31.200 151.000 C 31.200 150.230,31.380 149.600,31.600 149.600 C 31.820 149.600,32.000 149.071,32.000 148.424 C 32.000 147.777,32.180 147.136,32.400 147.000 C 32.620 146.864,32.800 146.223,32.800 145.576 C 32.800 144.929,32.980 144.400,33.200 144.400 C 33.420 144.400,33.600 144.034,33.600 143.587 C 33.600 143.141,33.870 142.671,34.200 142.545 C 34.530 142.418,34.800 141.974,34.800 141.557 C 34.800 141.141,34.980 140.800,35.200 140.800 C 35.420 140.800,35.600 140.350,35.600 139.800 C 35.600 139.250,35.780 138.800,36.000 138.800 C 36.220 138.800,36.400 138.378,36.400 137.861 C 36.400 136.744,37.503 134.400,38.029 134.400 C 38.233 134.400,38.400 134.051,38.400 133.624 C 38.400 133.197,38.580 132.736,38.800 132.600 C 39.020 132.464,39.200 132.076,39.200 131.737 C 39.200 131.033,41.446 128.800,42.154 128.800 C 42.412 128.800,42.883 128.440,43.200 128.000 C 43.517 127.560,44.187 127.200,44.688 127.200 C 45.190 127.200,45.600 127.020,45.600 126.800 C 45.600 126.580,45.941 126.400,46.357 126.400 C 46.774 126.400,47.218 126.130,47.345 125.800 C 47.471 125.470,47.941 125.200,48.387 125.200 C 48.834 125.200,49.200 125.020,49.200 124.800 C 49.200 124.580,48.570 124.400,47.800 124.400 C 46.790 124.400,46.400 124.224,46.400 123.767 C 46.400 122.980,51.424 118.000,52.218 118.000 C 52.538 118.000,52.800 117.820,52.800 117.600 C 52.800 117.380,52.530 117.200,52.200 117.200 C 51.870 117.200,51.600 117.380,51.600 117.600 C 51.600 117.820,51.240 118.000,50.800 118.000 C 50.360 118.000,50.000 118.161,50.000 118.357 C 50.000 118.886,48.795 119.252,47.944 118.982 C 46.776 118.611,47.040 118.018,49.400 115.714 C 50.610 114.533,51.600 113.214,51.600 112.783 C 51.600 112.352,51.793 112.000,52.029 112.000 C 52.489 112.000,53.600 111.017,53.600 110.610 C 53.600 110.196,55.536 108.400,55.982 108.400 C 56.212 108.400,56.400 108.220,56.400 108.000 C 56.400 107.780,56.661 107.600,56.981 107.600 C 57.300 107.600,58.173 106.970,58.921 106.200 C 59.669 105.430,60.578 104.800,60.940 104.800 C 61.303 104.800,61.600 104.620,61.600 104.400 C 61.600 104.180,61.935 104.000,62.344 104.000 C 62.753 104.000,63.426 103.550,63.839 103.000 C 64.252 102.450,64.907 102.000,65.295 102.000 C 65.683 102.000,66.000 101.820,66.000 101.600 C 66.000 101.380,66.450 101.200,67.000 101.200 C 67.550 101.200,68.000 101.020,68.000 100.800 C 68.000 100.580,68.546 100.400,69.213 100.400 C 69.921 100.400,70.521 100.151,70.655 99.800 C 70.782 99.470,71.226 99.200,71.643 99.200 C 72.059 99.200,72.400 99.020,72.400 98.800 C 72.400 98.580,72.850 98.400,73.400 98.400 C 73.950 98.400,74.400 98.220,74.400 98.000 C 74.400 97.780,74.940 97.600,75.600 97.600 C 76.260 97.600,76.800 97.420,76.800 97.200 C 76.800 96.980,77.250 96.800,77.800 96.800 C 78.422 96.800,78.800 96.573,78.800 96.200 C 78.800 95.870,79.149 95.600,79.576 95.600 C 80.003 95.600,80.464 95.420,80.600 95.200 C 80.736 94.980,81.197 94.800,81.624 94.800 C 82.051 94.800,82.400 94.620,82.400 94.400 C 82.400 94.180,82.760 94.000,83.200 94.000 C 83.640 94.000,84.000 93.820,84.000 93.600 C 84.000 93.380,84.450 93.200,85.000 93.200 C 85.622 93.200,86.000 92.973,86.000 92.600 C 86.000 92.270,86.324 92.000,86.720 92.000 C 87.804 92.000,88.400 91.191,88.400 89.720 L 88.400 88.400 85.200 88.400 C 83.333 88.400,82.000 88.567,82.000 88.800 C 82.000 89.020,81.659 89.200,81.243 89.200 C 80.826 89.200,80.382 89.470,80.255 89.800 C 80.129 90.130,79.659 90.400,79.213 90.400 C 78.766 90.400,78.400 90.580,78.400 90.800 C 78.400 91.020,78.040 91.200,77.600 91.200 C 77.160 91.200,76.800 91.380,76.800 91.600 C 76.800 91.820,76.451 92.000,76.024 92.000 C 75.597 92.000,75.136 92.180,75.000 92.400 C 74.864 92.620,74.474 92.800,74.134 92.800 C 73.794 92.800,73.161 93.250,72.729 93.800 C 72.296 94.350,71.595 94.800,71.171 94.800 C 70.747 94.800,70.400 94.980,70.400 95.200 C 70.400 95.420,70.106 95.600,69.746 95.600 C 69.386 95.600,68.675 96.050,68.165 96.600 C 67.655 97.150,66.999 97.600,66.707 97.600 C 66.415 97.600,65.917 97.960,65.600 98.400 C 64.913 99.353,63.600 99.463,63.600 98.568 C 63.600 97.862,68.090 93.200,68.770 93.200 C 69.009 93.200,70.003 92.390,70.979 91.400 C 71.955 90.410,72.991 89.600,73.281 89.600 C 73.570 89.600,74.346 88.974,75.004 88.209 C 75.662 87.443,76.562 86.813,77.005 86.809 C 77.448 86.804,78.148 86.350,78.561 85.800 C 78.974 85.250,79.529 84.800,79.794 84.800 C 80.059 84.800,80.602 84.440,81.000 84.000 C 81.398 83.560,82.013 83.200,82.367 83.200 C 82.721 83.200,83.348 82.750,83.761 82.200 C 84.174 81.650,84.807 81.200,85.168 81.200 C 85.528 81.200,86.083 80.840,86.400 80.400 C 86.717 79.960,87.286 79.600,87.665 79.600 C 88.043 79.600,88.464 79.420,88.600 79.200 C 88.736 78.980,89.197 78.800,89.624 78.800 C 90.051 78.800,90.400 78.633,90.400 78.429 C 90.400 78.002,92.659 76.800,93.461 76.800 C 93.758 76.800,94.000 76.620,94.000 76.400 C 94.000 76.180,94.349 76.000,94.776 76.000 C 95.203 76.000,95.664 75.820,95.800 75.600 C 95.936 75.380,96.397 75.200,96.824 75.200 C 97.251 75.200,97.600 75.033,97.600 74.829 C 97.600 74.402,99.859 73.200,100.661 73.200 C 100.958 73.200,101.200 73.020,101.200 72.800 C 101.200 72.580,101.549 72.400,101.976 72.400 C 102.403 72.400,102.864 72.220,103.000 72.000 C 103.136 71.780,103.597 71.600,104.024 71.600 C 104.451 71.600,104.800 71.433,104.800 71.229 C 104.800 70.802,107.059 69.600,107.861 69.600 C 108.158 69.600,108.400 69.420,108.400 69.200 C 108.400 68.980,108.726 68.800,109.125 68.800 C 109.523 68.800,110.283 68.395,110.812 67.900 C 111.846 66.935,113.450 66.000,114.074 66.000 C 114.489 66.000,115.600 65.001,115.600 64.629 C 115.600 64.503,115.330 64.400,115.000 64.400 C 114.670 64.400,114.400 64.580,114.400 64.800 C 114.400 65.020,113.871 65.200,113.224 65.200 C 112.577 65.200,111.936 65.380,111.800 65.600 C 111.664 65.820,111.203 66.000,110.776 66.000 C 110.349 66.000,110.000 66.180,110.000 66.400 C 110.000 66.620,109.640 66.800,109.200 66.800 C 108.760 66.800,108.400 66.980,108.400 67.200 C 108.400 67.420,107.950 67.600,107.400 67.600 C 106.778 67.600,106.400 67.827,106.400 68.200 C 106.400 68.530,106.051 68.800,105.624 68.800 C 105.197 68.800,104.736 68.980,104.600 69.200 C 104.464 69.420,104.003 69.600,103.576 69.600 C 103.149 69.600,102.800 69.780,102.800 70.000 C 102.800 70.220,102.440 70.400,102.000 70.400 C 101.560 70.400,101.200 70.580,101.200 70.800 C 101.200 71.020,100.750 71.200,100.200 71.200 C 99.578 71.200,99.200 71.427,99.200 71.800 C 99.200 72.130,98.851 72.400,98.424 72.400 C 97.997 72.400,97.536 72.580,97.400 72.800 C 97.264 73.020,96.803 73.200,96.376 73.200 C 95.949 73.200,95.600 73.380,95.600 73.600 C 95.600 73.820,95.240 74.000,94.800 74.000 C 94.360 74.000,94.000 74.180,94.000 74.400 C 94.000 74.620,93.550 74.800,93.000 74.800 C 92.378 74.800,92.000 75.027,92.000 75.400 C 92.000 75.730,91.651 76.000,91.224 76.000 C 90.797 76.000,90.336 76.180,90.200 76.400 C 90.064 76.620,89.643 76.800,89.265 76.800 C 88.886 76.800,88.317 77.160,88.000 77.600 C 87.683 78.040,87.097 78.400,86.699 78.400 C 86.301 78.400,85.871 78.670,85.745 79.000 C 85.618 79.330,85.174 79.600,84.757 79.600 C 84.341 79.600,84.000 79.780,84.000 80.000 C 84.000 80.220,83.590 80.400,83.088 80.400 C 82.587 80.400,81.917 80.760,81.600 81.200 C 81.283 81.640,80.785 82.000,80.493 82.000 C 80.201 82.000,79.545 82.450,79.035 83.000 C 78.525 83.550,77.854 84.000,77.542 84.000 C 77.231 84.000,76.717 84.360,76.400 84.800 C 76.083 85.240,75.413 85.600,74.912 85.600 C 74.410 85.600,74.000 85.801,74.000 86.046 C 74.000 86.621,71.192 89.200,70.566 89.200 C 70.304 89.200,68.029 91.270,65.510 93.800 C 60.888 98.444,60.000 99.056,60.000 97.600 C 60.000 97.160,60.180 96.800,60.400 96.800 C 60.620 96.800,60.800 96.530,60.800 96.200 C 60.800 95.870,60.980 95.600,61.200 95.600 C 61.420 95.600,61.600 95.317,61.600 94.971 C 61.600 94.253,62.534 93.200,63.171 93.200 C 63.407 93.200,63.600 92.930,63.600 92.600 C 63.600 92.270,63.780 92.000,64.000 92.000 C 64.220 92.000,64.400 91.715,64.400 91.367 C 64.400 91.018,65.030 90.121,65.800 89.374 C 66.570 88.626,67.200 87.810,67.200 87.560 C 67.200 87.310,68.370 85.958,69.800 84.556 C 71.230 83.154,72.400 81.722,72.400 81.375 C 72.400 80.704,73.318 79.600,73.876 79.600 C 74.060 79.600,74.557 79.139,74.980 78.575 C 76.472 76.588,77.100 76.000,77.730 76.000 C 78.080 76.000,80.417 73.930,82.924 71.400 C 85.430 68.870,87.706 66.800,87.980 66.800 C 88.255 66.800,88.983 66.260,89.600 65.600 C 90.217 64.940,90.986 64.400,91.310 64.400 C 91.633 64.400,92.436 63.770,93.094 63.000 C 93.752 62.230,94.566 61.600,94.903 61.600 C 95.240 61.600,95.940 61.153,96.458 60.607 C 96.976 60.061,97.597 59.611,97.838 59.607 C 98.079 59.603,98.602 59.240,99.000 58.800 C 99.398 58.360,99.974 58.000,100.280 58.000 C 100.586 58.000,101.286 57.550,101.836 57.000 C 102.386 56.450,103.058 56.000,103.330 56.000 C 103.601 56.000,104.083 55.640,104.400 55.200 C 104.717 54.760,105.286 54.400,105.665 54.400 C 106.043 54.400,106.464 54.220,106.600 54.000 C 106.736 53.780,107.197 53.600,107.624 53.600 C 108.051 53.600,108.400 53.420,108.400 53.200 C 108.400 52.980,108.741 52.800,109.157 52.800 C 109.574 52.800,110.018 52.530,110.145 52.200 C 110.271 51.870,110.741 51.600,111.187 51.600 C 111.634 51.600,112.000 51.420,112.000 51.200 C 112.000 50.980,112.349 50.800,112.776 50.800 C 113.203 50.800,113.664 50.620,113.800 50.400 C 113.936 50.180,114.354 50.000,114.729 50.000 C 115.103 50.000,115.748 49.550,116.161 49.000 C 116.574 48.450,117.247 48.000,117.656 48.000 C 118.065 48.000,118.400 47.820,118.400 47.600 C 118.400 47.380,118.929 47.200,119.576 47.200 C 120.223 47.200,120.864 47.020,121.000 46.800 C 121.136 46.580,121.777 46.400,122.424 46.400 C 123.071 46.400,123.600 46.220,123.600 46.000 C 123.600 45.758,125.333 45.600,128.000 45.600 C 130.667 45.600,132.400 45.758,132.400 46.000 C 132.400 46.220,133.379 46.400,134.576 46.400 C 135.773 46.400,136.864 46.580,137.000 46.800 C 137.136 47.020,137.946 47.200,138.800 47.200 C 139.654 47.200,140.464 47.380,140.600 47.600 C 140.736 47.820,141.467 48.000,142.224 48.000 C 142.981 48.000,143.600 47.820,143.600 47.600 C 143.600 47.380,143.150 47.200,142.600 47.200 C 142.050 47.200,141.600 47.020,141.600 46.800 C 141.600 46.580,141.054 46.400,140.387 46.400 C 139.679 46.400,139.079 46.151,138.945 45.800 C 138.813 45.458,138.217 45.200,137.557 45.200 C 136.921 45.200,136.400 45.020,136.400 44.800 C 136.400 44.580,135.770 44.400,135.000 44.400 C 133.867 44.400,133.600 44.248,133.600 43.600 C 133.600 42.853,133.867 42.800,137.600 42.800 C 140.000 42.800,141.600 42.640,141.600 42.400 C 141.600 42.180,142.410 42.000,143.400 42.000 C 144.390 42.000,145.200 42.180,145.200 42.400 C 145.200 42.644,147.059 42.800,149.976 42.800 C 152.729 42.800,154.858 42.969,155.000 43.200 C 155.136 43.420,156.126 43.600,157.200 43.600 C 158.274 43.600,159.264 43.780,159.400 44.000 C 159.536 44.220,160.542 44.400,161.636 44.400 C 163.035 44.400,163.693 44.578,163.855 45.000 C 164.012 45.407,164.650 45.600,165.843 45.600 C 166.809 45.600,167.600 45.780,167.600 46.000 C 167.600 46.220,168.230 46.400,169.000 46.400 C 169.770 46.400,170.400 46.580,170.400 46.800 C 170.400 47.020,171.109 47.200,171.976 47.200 C 172.843 47.200,173.664 47.380,173.800 47.600 C 173.936 47.820,174.557 48.000,175.181 48.000 C 175.819 48.000,176.415 48.262,176.545 48.600 C 176.677 48.944,177.274 49.200,177.945 49.200 C 178.615 49.200,179.213 48.944,179.345 48.600 C 179.471 48.270,179.941 48.000,180.387 48.000 C 180.834 48.000,181.200 47.908,181.200 47.797 C 181.200 47.222,178.968 45.200,178.334 45.200 C 177.930 45.200,177.600 45.020,177.600 44.800 C 177.600 44.580,176.790 44.400,175.800 44.400 C 174.810 44.400,174.000 44.220,174.000 44.000 C 174.000 43.780,173.190 43.600,172.200 43.600 C 171.210 43.600,170.400 43.420,170.400 43.200 C 170.400 42.980,169.494 42.800,168.387 42.800 C 166.968 42.800,166.307 42.623,166.145 42.200 C 165.956 41.708,164.950 41.600,160.557 41.600 C 157.252 41.600,155.200 41.447,155.200 41.200 C 155.200 40.957,153.400 40.800,150.600 40.800 C 147.800 40.800,146.000 40.643,146.000 40.400 C 146.000 40.169,144.733 40.000,143.000 40.000 C 140.267 40.000,140.000 39.929,140.000 39.200 C 140.000 38.584,140.267 38.400,141.157 38.400 C 141.817 38.400,142.413 38.142,142.545 37.800 C 142.679 37.449,143.279 37.200,143.987 37.200 C 144.654 37.200,145.200 37.020,145.200 36.800 C 145.200 36.580,145.830 36.400,146.600 36.400 C 147.370 36.400,148.000 36.220,148.000 36.000 C 148.000 35.780,148.810 35.600,149.800 35.600 C 150.790 35.600,151.600 35.420,151.600 35.200 C 151.600 34.980,152.410 34.800,153.400 34.800 C 154.733 34.800,155.200 34.644,155.200 34.200 C 155.200 33.739,155.711 33.600,157.400 33.600 C 158.610 33.600,159.600 33.420,159.600 33.200 C 159.600 32.967,160.933 32.800,162.800 32.800 C 164.667 32.800,166.000 32.633,166.000 32.400 C 166.000 32.180,166.990 32.000,168.200 32.000 C 169.410 32.000,170.400 31.820,170.400 31.600 C 170.400 31.360,171.986 31.200,174.357 31.200 C 177.506 31.200,178.361 31.077,178.545 30.600 C 179.000 29.414,187.707 29.759,188.639 31.000 M202.655 34.200 C 202.782 34.530,203.046 34.800,203.243 34.800 C 203.439 34.800,203.600 34.530,203.600 34.200 C 203.600 33.870,203.336 33.600,203.013 33.600 C 202.655 33.600,202.515 33.835,202.655 34.200 M36.400 272.800 C 36.400 273.333,36.133 273.600,35.600 273.600 C 35.067 273.600,34.800 273.333,34.800 272.800 C 34.800 272.267,35.067 272.000,35.600 272.000 C 36.133 272.000,36.400 272.267,36.400 272.800 M255.600 365.600 C 255.600 365.820,255.870 366.000,256.200 366.000 C 256.530 366.000,256.800 365.820,256.800 365.600 C 256.800 365.380,256.530 365.200,256.200 365.200 C 255.870 365.200,255.600 365.380,255.600 365.600 M174.000 378.613 C 174.000 378.949,173.718 379.333,173.373 379.466 C 172.621 379.754,171.800 379.046,172.178 378.435 C 172.586 377.776,174.000 377.913,174.000 378.613 \" stroke=\"none\" fill=\"#000000\" fill-rule=\"evenodd\"></path><path id=\"path2\" d=\"\" stroke=\"none\" fill=\"#080404\" fill-rule=\"evenodd\"></path></g></svg>");
INSERT INTO `wp_464683_postmeta` VALUES("572", "377", "_wp_attached_file", "2019/11/image2vector.svg");
INSERT INTO `wp_464683_postmeta` VALUES("573", "377", "_wp_attachment_metadata", "a:2:{s:5:\"width\";d:400;s:6:\"height\";d:412.584269662921315102721564471721649169921875;}");
INSERT INTO `wp_464683_postmeta` VALUES("574", "377", "_elementor_inline_svg", "<svg id=\"svg\" version=\"1.1\" width=\"400\" height=\"412.5842696629213\" viewBox=\"0 0 400 412.5842696629213\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" ><g id=\"svgg\"><path id=\"path0\" d=\"\" stroke=\"none\" fill=\"#040404\" fill-rule=\"evenodd\"></path><path id=\"path1\" d=\"M172.000 0.600 C 172.000 0.933,171.644 1.200,171.200 1.200 C 170.760 1.200,170.400 1.377,170.400 1.592 C 170.400 1.808,169.950 2.098,169.400 2.236 C 168.774 2.393,168.400 2.770,168.400 3.243 C 168.400 3.660,168.220 4.000,168.000 4.000 C 167.780 4.000,167.600 4.469,167.600 5.042 C 167.600 5.947,167.191 6.634,165.194 9.083 C 164.977 9.349,164.800 9.714,164.800 9.895 C 164.800 10.076,164.440 10.483,164.000 10.800 C 163.560 11.117,163.200 11.600,163.200 11.872 C 163.200 12.527,160.177 15.596,159.516 15.613 C 158.900 15.628,157.600 16.563,157.600 16.990 C 157.600 17.466,154.698 20.000,154.154 20.000 C 153.884 20.000,152.885 20.807,151.932 21.793 C 149.943 23.853,148.800 24.137,148.800 22.571 C 148.800 21.517,149.608 20.400,150.371 20.400 C 150.607 20.400,150.800 19.950,150.800 19.400 C 150.800 18.850,150.980 18.400,151.200 18.400 C 151.420 18.400,151.600 17.950,151.600 17.400 C 151.600 16.600,151.400 16.400,150.600 16.400 C 149.800 16.400,149.600 16.600,149.600 17.400 C 149.600 17.950,149.420 18.400,149.200 18.400 C 148.980 18.400,148.800 18.760,148.800 19.200 C 148.800 19.640,148.620 20.000,148.400 20.000 C 148.180 20.000,148.000 20.284,148.000 20.632 C 148.000 20.979,147.190 22.073,146.200 23.063 C 145.210 24.053,144.400 25.044,144.400 25.264 C 144.400 25.884,136.671 33.592,136.045 33.596 C 135.740 33.598,134.952 34.230,134.294 35.000 C 133.636 35.770,132.839 36.400,132.522 36.400 C 132.205 36.400,131.169 37.210,130.221 38.200 C 129.272 39.190,128.287 40.000,128.031 40.000 C 127.776 40.000,127.180 40.360,126.708 40.800 C 126.236 41.240,125.594 41.600,125.282 41.600 C 124.970 41.600,124.361 42.050,123.929 42.600 C 123.496 43.150,122.795 43.600,122.371 43.600 C 121.947 43.600,121.600 43.780,121.600 44.000 C 121.600 44.220,121.240 44.400,120.800 44.400 C 120.360 44.400,120.000 44.580,120.000 44.800 C 120.000 45.020,119.550 45.200,119.000 45.200 C 118.450 45.200,118.000 45.335,118.000 45.500 C 117.998 46.172,116.055 48.000,115.342 48.000 C 114.921 48.000,114.312 48.369,113.988 48.819 C 113.362 49.692,111.432 50.800,110.539 50.800 C 110.242 50.800,110.000 50.980,110.000 51.200 C 110.000 51.420,109.640 51.600,109.200 51.600 C 108.760 51.600,108.400 51.780,108.400 52.000 C 108.400 52.220,107.950 52.400,107.400 52.400 C 106.850 52.400,106.400 52.567,106.400 52.771 C 106.400 53.198,104.141 54.400,103.339 54.400 C 103.042 54.400,102.800 54.580,102.800 54.800 C 102.800 55.020,102.210 55.200,101.488 55.200 C 100.624 55.200,99.976 55.480,99.588 56.019 C 98.989 56.853,97.043 58.000,96.227 58.000 C 95.979 58.000,95.517 58.360,95.200 58.800 C 94.883 59.240,94.213 59.600,93.712 59.600 C 93.210 59.600,92.800 59.735,92.800 59.900 C 92.798 60.561,90.860 62.401,90.153 62.411 C 89.739 62.417,88.696 63.227,87.835 64.211 C 86.974 65.195,86.021 66.000,85.717 66.000 C 85.414 66.000,84.199 66.990,83.017 68.200 C 81.836 69.410,80.584 70.400,80.235 70.400 C 79.151 70.400,79.535 69.146,81.000 67.894 C 81.770 67.236,82.400 66.401,82.400 66.037 C 82.400 65.674,82.760 65.117,83.200 64.800 C 83.640 64.483,84.000 63.916,84.000 63.541 C 84.000 63.165,84.450 62.504,85.000 62.071 C 85.550 61.639,86.000 61.030,86.000 60.718 C 86.000 60.406,86.360 59.764,86.800 59.292 C 87.240 58.820,87.600 58.227,87.600 57.974 C 87.600 57.722,88.050 57.161,88.600 56.729 C 89.150 56.296,89.600 55.667,89.600 55.331 C 89.600 54.996,90.140 54.217,90.800 53.600 C 91.460 52.983,92.000 52.216,92.000 51.896 C 92.000 51.575,92.450 50.974,93.000 50.561 C 93.550 50.148,94.000 49.503,94.000 49.129 C 94.000 48.754,94.180 48.336,94.400 48.200 C 94.620 48.064,94.800 47.603,94.800 47.176 C 94.800 46.749,94.980 46.400,95.200 46.400 C 95.420 46.400,95.600 46.034,95.600 45.587 C 95.600 45.141,95.870 44.671,96.200 44.545 C 96.542 44.413,96.800 43.817,96.800 43.157 C 96.800 42.521,96.980 42.000,97.200 42.000 C 97.823 42.000,97.678 38.420,97.029 37.771 C 95.659 36.402,92.000 37.356,92.000 39.083 C 92.000 39.490,91.640 40.083,91.200 40.400 C 90.760 40.717,90.400 41.303,90.400 41.701 C 90.400 42.099,90.130 42.529,89.800 42.655 C 89.470 42.782,89.200 43.226,89.200 43.643 C 89.200 44.059,89.020 44.400,88.800 44.400 C 88.580 44.400,88.400 44.749,88.400 45.176 C 88.400 45.603,88.220 46.064,88.000 46.200 C 87.780 46.336,87.600 46.797,87.600 47.224 C 87.600 47.651,87.420 48.000,87.200 48.000 C 86.980 48.000,86.800 48.360,86.800 48.800 C 86.800 49.240,86.640 49.600,86.443 49.600 C 86.247 49.600,85.974 50.050,85.836 50.600 C 85.698 51.150,85.408 51.600,85.192 51.600 C 84.977 51.600,84.800 51.949,84.800 52.376 C 84.800 52.803,84.620 53.264,84.400 53.400 C 84.180 53.536,84.000 53.997,84.000 54.424 C 84.000 54.851,83.820 55.200,83.600 55.200 C 83.380 55.200,83.200 55.560,83.200 56.000 C 83.200 56.440,83.040 56.800,82.843 56.800 C 82.647 56.800,82.374 57.250,82.236 57.800 C 82.098 58.350,81.808 58.800,81.592 58.800 C 81.377 58.800,81.200 59.160,81.200 59.600 C 81.200 60.040,81.020 60.400,80.800 60.400 C 80.580 60.400,80.400 60.850,80.400 61.400 C 80.400 61.950,80.220 62.400,80.000 62.400 C 79.780 62.400,79.600 62.760,79.600 63.200 C 79.600 63.640,79.440 64.000,79.243 64.000 C 79.047 64.000,78.774 64.450,78.636 65.000 C 78.498 65.550,78.208 66.000,77.992 66.000 C 77.777 66.000,77.600 66.360,77.600 66.800 C 77.600 67.240,77.420 67.600,77.200 67.600 C 76.980 67.600,76.800 67.984,76.800 68.453 C 76.800 68.922,76.466 69.597,76.057 69.953 C 75.649 70.309,75.187 71.005,75.030 71.500 C 74.874 71.995,74.578 72.400,74.373 72.400 C 74.168 72.400,74.000 72.720,74.000 73.112 C 74.000 73.503,73.640 74.083,73.200 74.400 C 72.760 74.717,72.400 75.179,72.400 75.427 C 72.400 76.160,71.173 78.400,70.771 78.400 C 70.567 78.400,70.400 78.670,70.400 79.000 C 70.400 79.330,70.220 79.600,70.000 79.600 C 69.780 79.600,69.600 79.960,69.600 80.400 C 69.600 80.840,69.420 81.200,69.200 81.200 C 68.980 81.200,68.800 81.537,68.800 81.949 C 68.800 82.361,68.192 83.218,67.448 83.853 C 66.704 84.488,66.027 85.366,65.942 85.804 C 65.688 87.123,64.615 86.755,64.475 85.300 C 64.404 84.570,64.536 84.000,64.775 84.000 C 65.375 84.000,65.306 81.325,64.700 81.102 C 63.816 80.777,63.200 81.241,63.200 82.233 C 63.200 82.765,63.020 83.200,62.800 83.200 C 62.580 83.200,62.400 84.190,62.400 85.400 C 62.400 86.610,62.220 87.600,62.000 87.600 C 61.780 87.600,61.600 88.129,61.600 88.776 C 61.600 89.423,61.420 90.064,61.200 90.200 C 60.980 90.336,60.800 90.892,60.800 91.436 C 60.800 91.980,60.530 92.529,60.200 92.655 C 59.870 92.782,59.600 93.277,59.600 93.754 C 59.600 94.232,59.240 94.883,58.800 95.200 C 58.360 95.517,58.000 96.084,58.000 96.459 C 58.000 96.835,57.550 97.496,57.000 97.929 C 56.450 98.361,56.000 98.922,56.000 99.174 C 56.000 99.427,55.640 100.020,55.200 100.492 C 54.760 100.964,54.400 101.646,54.400 102.008 C 54.400 102.369,53.950 102.906,53.400 103.200 C 52.818 103.511,52.400 104.088,52.400 104.579 C 52.400 105.044,52.040 105.683,51.600 106.000 C 51.160 106.317,50.800 106.884,50.800 107.259 C 50.800 107.635,50.350 108.296,49.800 108.729 C 49.250 109.161,48.800 109.722,48.800 109.974 C 48.800 110.227,48.440 110.820,48.000 111.292 C 47.560 111.764,47.200 112.446,47.200 112.808 C 47.200 113.169,46.750 113.706,46.200 114.000 C 45.572 114.336,45.200 114.882,45.200 115.468 C 45.200 115.980,45.020 116.400,44.800 116.400 C 44.580 116.400,44.400 116.760,44.400 117.200 C 44.400 117.640,44.220 118.000,44.000 118.000 C 43.780 118.000,43.600 118.242,43.600 118.539 C 43.600 119.341,42.398 121.600,41.971 121.600 C 41.767 121.600,41.600 122.063,41.600 122.629 C 41.600 123.394,41.420 123.624,40.900 123.526 C 40.109 123.376,39.608 120.000,40.377 120.000 C 40.637 120.000,40.800 118.838,40.800 116.987 C 40.800 114.679,40.940 113.921,41.400 113.745 C 41.831 113.579,42.000 112.906,42.000 111.357 C 42.000 110.171,42.180 109.200,42.400 109.200 C 42.620 109.200,42.800 108.390,42.800 107.400 C 42.800 106.410,42.980 105.600,43.200 105.600 C 43.420 105.600,43.600 104.790,43.600 103.800 C 43.600 102.810,43.780 102.000,44.000 102.000 C 44.220 102.000,44.400 101.454,44.400 100.787 C 44.400 100.079,44.649 99.479,45.000 99.345 C 45.342 99.213,45.600 98.617,45.600 97.957 C 45.600 97.321,45.780 96.800,46.000 96.800 C 46.220 96.800,46.400 96.170,46.400 95.400 C 46.400 94.630,46.580 94.000,46.800 94.000 C 47.020 94.000,47.200 93.370,47.200 92.600 C 47.200 91.830,47.380 91.200,47.600 91.200 C 47.820 91.200,48.000 90.654,48.000 89.987 C 48.000 89.279,48.249 88.679,48.600 88.545 C 48.930 88.418,49.200 87.974,49.200 87.557 C 49.200 87.141,49.380 86.800,49.600 86.800 C 49.820 86.800,50.000 86.170,50.000 85.400 C 50.000 84.630,50.180 84.000,50.400 84.000 C 50.620 84.000,50.800 83.578,50.800 83.061 C 50.800 81.944,51.903 79.600,52.429 79.600 C 52.633 79.600,52.800 78.970,52.800 78.200 C 52.800 77.430,52.980 76.800,53.200 76.800 C 53.420 76.800,53.600 76.620,53.600 76.400 C 53.600 76.180,53.330 76.000,53.000 76.000 C 52.667 76.000,52.400 76.356,52.400 76.800 C 52.400 77.240,52.220 77.600,52.000 77.600 C 51.780 77.600,51.600 77.949,51.600 78.376 C 51.600 78.803,51.420 79.264,51.200 79.400 C 50.980 79.536,50.800 79.997,50.800 80.424 C 50.800 80.851,50.620 81.200,50.400 81.200 C 50.180 81.200,50.000 81.566,50.000 82.013 C 50.000 82.459,49.730 82.929,49.400 83.055 C 49.070 83.182,48.800 83.626,48.800 84.043 C 48.800 84.459,48.620 84.800,48.400 84.800 C 48.180 84.800,48.000 85.430,48.000 86.200 C 48.000 86.970,47.820 87.600,47.600 87.600 C 47.380 87.600,47.200 88.104,47.200 88.720 C 47.200 89.336,47.035 90.011,46.834 90.220 C 46.632 90.429,46.407 91.050,46.334 91.600 C 46.243 92.280,45.912 92.641,45.300 92.728 C 44.406 92.855,44.400 92.822,44.400 87.599 C 44.400 83.577,44.266 82.209,43.829 81.771 C 41.819 79.762,38.000 83.089,38.000 86.848 C 38.000 88.149,37.821 89.200,37.600 89.200 C 37.346 89.200,37.200 92.333,37.200 97.800 C 37.200 103.267,37.054 106.400,36.800 106.400 C 36.552 106.400,36.400 108.600,36.400 112.200 C 36.400 115.800,36.248 118.000,36.000 118.000 C 35.758 118.000,35.600 119.738,35.600 122.413 C 35.600 125.966,35.483 126.870,35.000 127.055 C 34.569 127.221,34.400 127.894,34.400 129.443 C 34.400 130.629,34.220 131.600,34.000 131.600 C 33.780 131.600,33.600 132.230,33.600 133.000 C 33.600 133.770,33.420 134.400,33.200 134.400 C 32.980 134.400,32.800 134.940,32.800 135.600 C 32.800 136.260,32.620 136.800,32.400 136.800 C 32.180 136.800,32.000 137.346,32.000 138.013 C 32.000 138.721,31.751 139.321,31.400 139.455 C 31.030 139.597,30.800 140.205,30.800 141.043 C 30.800 141.789,30.620 142.400,30.400 142.400 C 30.180 142.400,29.994 142.895,29.987 143.500 C 29.972 144.823,29.157 146.000,28.256 146.000 C 27.773 146.000,27.600 145.631,27.600 144.600 C 27.600 143.267,27.533 143.200,26.200 143.200 C 25.222 143.200,24.800 143.381,24.800 143.800 C 24.800 144.130,24.980 144.400,25.200 144.400 C 25.420 144.400,25.600 144.760,25.600 145.200 C 25.600 145.640,25.780 146.000,26.000 146.000 C 26.220 146.000,26.400 146.630,26.400 147.400 C 26.400 148.170,26.580 148.800,26.800 148.800 C 27.026 148.800,27.200 149.933,27.200 151.400 C 27.200 152.867,27.026 154.000,26.800 154.000 C 26.580 154.000,26.400 154.810,26.400 155.800 C 26.400 156.790,26.220 157.600,26.000 157.600 C 25.780 157.600,25.600 158.230,25.600 159.000 C 25.600 159.770,25.420 160.400,25.200 160.400 C 24.980 160.400,24.800 161.126,24.800 162.013 C 24.800 163.077,24.596 163.703,24.200 163.855 C 23.793 164.012,23.600 164.650,23.600 165.843 C 23.600 166.809,23.420 167.600,23.200 167.600 C 22.980 167.600,22.800 168.590,22.800 169.800 C 22.800 171.533,22.667 172.000,22.171 172.000 C 20.908 172.000,20.400 170.930,20.400 168.271 C 20.400 166.342,20.248 165.627,19.800 165.455 C 19.325 165.273,19.200 164.432,19.200 161.413 C 19.200 159.138,19.039 157.600,18.800 157.600 C 18.552 157.600,18.400 155.400,18.400 151.800 C 18.400 148.200,18.248 146.000,18.000 146.000 C 17.752 146.000,17.600 143.800,17.600 140.200 C 17.600 136.600,17.448 134.400,17.200 134.400 C 16.980 134.400,16.800 133.609,16.800 132.643 C 16.800 131.450,16.607 130.812,16.200 130.655 C 15.870 130.529,15.600 130.059,15.600 129.613 C 15.600 129.166,15.420 128.800,15.200 128.800 C 14.980 128.800,14.800 128.451,14.800 128.024 C 14.800 127.597,14.620 127.136,14.400 127.000 C 14.180 126.864,14.000 126.481,14.000 126.148 C 14.000 125.286,13.000 124.400,12.029 124.400 C 11.573 124.400,11.200 124.220,11.200 124.000 C 11.200 123.363,10.683 123.530,9.500 124.547 C 8.895 125.067,8.400 125.877,8.400 126.347 C 8.400 126.816,8.220 127.200,8.000 127.200 C 6.757 127.200,7.600 133.385,9.009 134.596 C 9.774 135.254,10.400 136.109,10.400 136.496 C 10.400 136.883,10.580 137.200,10.800 137.200 C 11.020 137.200,11.200 137.560,11.200 138.000 C 11.200 138.440,11.380 138.800,11.600 138.800 C 11.820 138.800,12.000 139.250,12.000 139.800 C 12.000 140.350,12.180 140.800,12.400 140.800 C 12.620 140.800,12.800 141.610,12.800 142.600 C 12.800 143.933,12.956 144.400,13.400 144.400 C 13.844 144.400,14.000 144.867,14.000 146.200 C 14.000 147.190,14.180 148.000,14.400 148.000 C 14.631 148.000,14.800 149.267,14.800 151.000 C 14.800 152.821,14.964 154.000,15.218 154.000 C 15.480 154.000,15.592 155.013,15.518 156.700 C 15.399 159.418,14.382 160.684,14.072 158.500 C 14.002 158.005,13.777 157.600,13.572 157.600 C 13.367 157.600,13.200 157.240,13.200 156.800 C 13.200 156.360,13.023 156.000,12.808 156.000 C 12.592 156.000,12.302 155.550,12.164 155.000 C 12.007 154.374,11.630 154.000,11.157 154.000 C 10.616 154.000,10.400 154.286,10.400 155.000 C 10.400 155.550,10.580 156.000,10.800 156.000 C 11.020 156.000,11.200 156.360,11.200 156.800 C 11.200 157.240,11.380 157.600,11.600 157.600 C 11.820 157.600,12.000 157.870,12.000 158.200 C 12.000 158.530,12.180 158.800,12.400 158.800 C 12.620 158.800,12.800 159.141,12.800 159.557 C 12.800 159.974,13.070 160.418,13.400 160.545 C 13.751 160.679,14.000 161.279,14.000 161.987 C 14.000 162.654,14.180 163.200,14.400 163.200 C 14.620 163.200,14.800 163.830,14.800 164.600 C 14.800 165.370,14.980 166.000,15.200 166.000 C 15.420 166.000,15.600 166.360,15.600 166.800 C 15.600 167.240,15.780 167.600,16.000 167.600 C 16.220 167.600,16.400 168.230,16.400 169.000 C 16.400 169.978,16.581 170.400,17.000 170.400 C 17.471 170.400,17.600 170.953,17.600 172.976 C 17.600 174.393,17.780 175.664,18.000 175.800 C 18.220 175.936,18.400 177.567,18.400 179.424 C 18.400 181.408,18.565 182.800,18.800 182.800 C 19.062 182.800,19.200 190.733,19.200 205.800 C 19.200 220.867,19.338 228.800,19.600 228.800 C 19.831 228.800,20.000 230.071,20.000 231.813 C 20.000 234.121,20.140 234.879,20.600 235.055 C 21.031 235.221,21.200 235.894,21.200 237.443 C 21.200 238.629,21.380 239.600,21.600 239.600 C 21.820 239.600,22.000 240.140,22.000 240.800 C 22.000 241.733,21.822 242.000,21.200 242.000 C 20.682 242.000,20.400 241.733,20.400 241.243 C 20.400 240.826,20.130 240.382,19.800 240.255 C 19.470 240.129,19.200 239.659,19.200 239.213 C 19.200 238.766,19.020 238.400,18.800 238.400 C 18.580 238.400,18.400 238.040,18.400 237.600 C 18.400 237.160,18.220 236.800,18.000 236.800 C 17.780 236.800,17.600 236.350,17.600 235.800 C 17.600 235.250,17.420 234.800,17.200 234.800 C 16.980 234.800,16.800 234.459,16.800 234.043 C 16.800 233.626,16.530 233.182,16.200 233.055 C 15.870 232.929,15.600 232.459,15.600 232.013 C 15.600 231.566,15.420 231.200,15.200 231.200 C 14.980 231.200,14.800 230.840,14.800 230.400 C 14.800 229.960,14.620 229.600,14.400 229.600 C 14.180 229.600,14.000 229.150,14.000 228.600 C 14.000 228.050,13.820 227.600,13.600 227.600 C 13.380 227.600,13.200 227.082,13.200 226.449 C 13.200 225.816,12.930 225.074,12.600 224.800 C 12.270 224.526,12.000 224.054,12.000 223.751 C 12.000 223.448,11.820 223.200,11.600 223.200 C 11.380 223.200,11.200 222.851,11.200 222.424 C 11.200 221.997,11.020 221.536,10.800 221.400 C 10.580 221.264,10.400 220.803,10.400 220.376 C 10.400 219.949,10.220 219.600,10.000 219.600 C 9.780 219.600,9.600 219.306,9.600 218.946 C 9.600 218.586,9.150 217.875,8.600 217.365 C 8.050 216.855,7.600 216.252,7.600 216.024 C 7.600 215.549,6.550 214.188,5.455 213.243 C 5.046 212.889,4.474 212.375,4.184 212.100 C 3.555 211.503,2.000 211.432,2.000 212.000 C 2.000 212.220,1.550 212.400,1.000 212.400 C 0.044 212.400,0.000 212.507,0.000 214.800 C 0.000 216.667,0.133 217.200,0.600 217.200 C 0.933 217.200,1.200 217.556,1.200 218.000 C 1.200 218.440,1.368 218.800,1.573 218.800 C 1.778 218.800,2.074 219.205,2.230 219.700 C 2.387 220.195,2.849 220.891,3.257 221.247 C 3.666 221.603,4.000 222.188,4.000 222.547 C 4.000 222.906,4.180 223.200,4.400 223.200 C 4.620 223.200,4.800 223.388,4.800 223.617 C 4.800 223.846,4.977 224.251,5.194 224.517 C 7.107 226.863,7.600 227.591,7.600 228.069 C 7.600 228.374,7.960 228.883,8.400 229.200 C 8.840 229.517,9.200 230.072,9.200 230.432 C 9.200 230.793,9.650 231.426,10.200 231.839 C 10.750 232.252,11.200 232.825,11.200 233.112 C 11.200 233.399,11.560 234.020,12.000 234.492 C 12.440 234.964,12.800 235.606,12.800 235.918 C 12.800 236.230,13.250 236.839,13.800 237.271 C 14.350 237.704,14.800 238.365,14.800 238.741 C 14.800 239.116,15.160 239.683,15.600 240.000 C 16.040 240.317,16.400 240.903,16.400 241.301 C 16.400 241.699,16.670 242.129,17.000 242.255 C 17.330 242.382,17.600 242.787,17.600 243.154 C 17.600 243.522,17.960 244.083,18.400 244.400 C 18.840 244.717,19.200 245.387,19.200 245.888 C 19.200 246.390,19.380 246.800,19.600 246.800 C 19.820 246.800,20.000 247.141,20.000 247.557 C 20.000 247.974,20.270 248.418,20.600 248.545 C 20.930 248.671,21.200 249.101,21.200 249.499 C 21.200 249.897,21.560 250.483,22.000 250.800 C 22.440 251.117,22.800 251.686,22.800 252.065 C 22.800 252.443,22.980 252.864,23.200 253.000 C 23.420 253.136,23.600 253.597,23.600 254.024 C 23.600 254.451,23.767 254.800,23.971 254.800 C 24.398 254.800,25.600 257.059,25.600 257.861 C 25.600 258.158,25.780 258.400,26.000 258.400 C 26.220 258.400,26.400 258.760,26.400 259.200 C 26.400 259.640,26.580 260.000,26.800 260.000 C 27.020 260.000,27.200 260.385,27.200 260.856 C 27.200 261.327,27.515 261.945,27.900 262.229 C 28.455 262.639,28.498 262.850,28.108 263.245 C 27.462 263.900,25.899 263.106,25.176 261.756 C 24.862 261.168,24.306 260.800,23.732 260.800 C 21.814 260.800,22.725 262.334,27.400 266.975 C 29.930 269.486,32.000 271.824,32.000 272.170 C 32.000 272.517,32.180 272.800,32.400 272.800 C 32.620 272.800,32.800 273.149,32.800 273.576 C 32.800 274.003,32.980 274.464,33.200 274.600 C 33.420 274.736,33.600 275.197,33.600 275.624 C 33.600 276.051,33.780 276.400,34.000 276.400 C 34.220 276.400,34.400 276.741,34.400 277.157 C 34.400 277.574,34.670 278.018,35.000 278.145 C 35.330 278.271,35.600 278.741,35.600 279.187 C 35.600 279.634,35.780 280.000,36.000 280.000 C 36.220 280.000,36.400 280.360,36.400 280.800 C 36.400 281.240,36.580 281.600,36.800 281.600 C 37.020 281.600,37.200 282.050,37.200 282.600 C 37.200 283.150,37.380 283.600,37.600 283.600 C 37.820 283.600,38.000 283.941,38.000 284.357 C 38.000 284.774,38.270 285.218,38.600 285.345 C 38.930 285.471,39.200 285.941,39.200 286.387 C 39.200 286.834,39.380 287.200,39.600 287.200 C 39.820 287.200,40.000 287.560,40.000 288.000 C 40.000 288.440,40.180 288.800,40.400 288.800 C 40.620 288.800,40.800 289.250,40.800 289.800 C 40.800 290.350,40.980 290.800,41.200 290.800 C 41.420 290.800,41.600 291.141,41.600 291.557 C 41.600 291.974,41.870 292.418,42.200 292.545 C 42.530 292.671,42.800 293.141,42.800 293.587 C 42.800 294.034,42.980 294.400,43.200 294.400 C 43.420 294.400,43.600 294.760,43.600 295.200 C 43.600 295.640,43.780 296.000,44.000 296.000 C 44.220 296.000,44.400 296.407,44.400 296.905 C 44.400 297.404,44.849 298.147,45.400 298.561 C 45.950 298.974,46.400 299.607,46.400 299.968 C 46.400 300.328,46.760 300.883,47.200 301.200 C 48.150 301.885,48.264 303.200,47.373 303.200 C 47.028 303.200,46.152 302.570,45.426 301.800 C 44.700 301.030,43.886 300.400,43.617 300.400 C 43.348 300.400,42.341 299.590,41.379 298.600 C 40.417 297.610,39.426 296.800,39.178 296.800 C 38.567 296.800,25.600 283.856,25.600 283.247 C 25.600 282.982,24.610 281.814,23.400 280.651 C 22.190 279.489,21.200 278.310,21.200 278.033 C 21.200 277.756,20.390 276.741,19.400 275.779 C 18.410 274.817,17.600 273.772,17.600 273.457 C 17.600 272.922,16.985 272.229,14.978 270.506 C 14.525 270.118,13.850 269.355,13.478 268.811 L 12.800 267.822 12.800 268.753 C 12.800 269.271,13.245 270.035,13.800 270.471 C 14.350 270.904,14.800 271.565,14.800 271.941 C 14.800 272.316,15.160 272.883,15.600 273.200 C 16.040 273.517,16.400 274.034,16.400 274.348 C 16.400 274.663,17.210 275.685,18.200 276.620 C 19.222 277.586,20.000 278.684,20.000 279.160 C 20.000 279.622,20.188 280.000,20.418 280.000 C 20.961 280.000,22.800 281.839,22.800 282.382 C 22.800 282.612,22.980 282.800,23.200 282.800 C 23.420 282.800,23.600 283.160,23.600 283.600 C 23.600 284.704,22.617 284.602,21.671 283.400 C 21.239 282.850,20.606 282.400,20.266 282.400 C 19.926 282.400,19.536 282.220,19.400 282.000 C 19.264 281.780,18.843 281.600,18.465 281.600 C 18.086 281.600,17.517 281.240,17.200 280.800 C 16.738 280.159,16.165 280.000,14.312 280.000 L 12.000 280.000 12.000 282.200 C 12.000 283.410,12.180 284.400,12.400 284.400 C 12.620 284.400,12.800 284.720,12.800 285.111 C 12.800 285.845,14.103 287.200,14.808 287.200 C 15.028 287.200,15.767 287.735,16.450 288.388 C 17.134 289.041,18.032 289.683,18.447 289.815 C 18.861 289.946,19.200 290.222,19.200 290.427 C 19.200 290.632,19.610 290.800,20.112 290.800 C 20.613 290.800,21.283 291.160,21.600 291.600 C 21.917 292.040,22.415 292.400,22.707 292.400 C 22.999 292.400,23.655 292.850,24.165 293.400 C 24.675 293.950,25.346 294.400,25.658 294.400 C 25.969 294.400,26.483 294.760,26.800 295.200 C 27.117 295.640,27.684 296.000,28.059 296.000 C 28.435 296.000,29.096 296.450,29.529 297.000 C 29.961 297.550,30.654 298.000,31.069 298.000 C 31.484 298.000,32.083 298.360,32.400 298.800 C 32.717 299.240,33.215 299.600,33.507 299.600 C 33.799 299.600,34.455 300.050,34.965 300.600 C 35.475 301.150,36.146 301.600,36.458 301.600 C 36.769 301.600,37.283 301.960,37.600 302.400 C 37.917 302.840,38.474 303.200,38.837 303.200 C 39.201 303.200,40.036 303.830,40.694 304.600 C 41.352 305.370,42.235 306.000,42.657 306.000 C 43.078 306.000,43.683 306.360,44.000 306.800 C 44.317 307.240,44.801 307.600,45.075 307.600 C 45.349 307.600,46.203 308.230,46.973 309.000 C 47.743 309.770,48.583 310.400,48.839 310.400 C 49.446 310.400,54.400 315.356,54.400 315.964 C 54.400 316.221,55.853 317.859,57.629 319.605 C 61.282 323.194,61.706 324.493,59.300 324.725 C 57.750 324.875,57.286 326.800,58.800 326.800 C 59.240 326.800,59.600 326.980,59.600 327.200 C 59.600 327.420,60.579 327.600,61.776 327.600 C 62.973 327.600,64.064 327.780,64.200 328.000 C 64.336 328.220,64.719 328.400,65.052 328.400 C 65.751 328.400,66.800 329.343,66.800 329.971 C 66.800 330.207,66.945 330.400,67.122 330.400 C 67.634 330.400,70.400 333.061,70.400 333.554 C 70.400 333.799,70.545 334.000,70.722 334.000 C 71.234 334.000,74.000 336.661,74.000 337.154 C 74.000 337.399,74.145 337.600,74.322 337.600 C 74.793 337.600,77.600 340.242,77.600 340.686 C 77.600 340.895,78.050 341.306,78.600 341.600 C 79.150 341.894,79.600 342.285,79.600 342.468 C 79.600 342.650,79.960 342.800,80.400 342.800 C 80.933 342.800,81.200 343.067,81.200 343.600 C 81.200 344.222,80.933 344.400,80.000 344.400 C 79.340 344.400,78.800 344.220,78.800 344.000 C 78.800 343.780,78.170 343.600,77.400 343.600 C 76.630 343.600,76.000 343.420,76.000 343.200 C 76.000 342.980,75.640 342.800,75.200 342.800 C 74.760 342.800,74.400 342.620,74.400 342.400 C 74.400 342.180,73.854 342.000,73.187 342.000 C 72.479 342.000,71.879 341.751,71.745 341.400 C 71.618 341.070,71.084 340.800,70.557 340.800 C 70.031 340.800,69.600 340.620,69.600 340.400 C 69.600 340.180,69.240 340.000,68.800 340.000 C 68.360 340.000,68.000 339.820,68.000 339.600 C 68.000 339.380,67.758 339.200,67.461 339.200 C 66.659 339.200,64.400 337.998,64.400 337.571 C 64.400 337.367,63.950 337.200,63.400 337.200 C 62.850 337.200,62.400 337.020,62.400 336.800 C 62.400 336.580,62.040 336.400,61.600 336.400 C 61.160 336.400,60.800 336.220,60.800 336.000 C 60.800 335.780,60.170 335.600,59.400 335.600 C 58.630 335.600,58.000 335.420,58.000 335.200 C 58.000 334.980,57.724 334.800,57.387 334.800 C 57.051 334.800,56.671 334.530,56.545 334.200 C 56.418 333.870,55.884 333.600,55.357 333.600 C 54.831 333.600,54.400 333.420,54.400 333.200 C 54.400 332.980,54.040 332.800,53.600 332.800 C 53.160 332.800,52.800 332.620,52.800 332.400 C 52.800 332.180,52.350 332.000,51.800 332.000 C 51.250 332.000,50.800 331.820,50.800 331.600 C 50.800 331.380,50.524 331.200,50.187 331.200 C 49.851 331.200,49.471 330.930,49.345 330.600 C 49.218 330.270,48.684 330.000,48.157 330.000 C 47.631 330.000,47.200 329.820,47.200 329.600 C 47.200 329.380,46.840 329.200,46.400 329.200 C 45.960 329.200,45.600 329.020,45.600 328.800 C 45.600 328.580,44.790 328.400,43.800 328.400 C 42.810 328.400,42.000 328.220,42.000 328.000 C 42.000 327.473,35.726 327.473,35.400 328.000 C 35.264 328.220,34.881 328.400,34.548 328.400 C 33.849 328.400,32.800 329.343,32.800 329.971 C 32.800 330.207,32.980 330.400,33.200 330.400 C 33.420 330.400,33.600 330.940,33.600 331.600 C 33.600 332.260,33.780 332.800,34.000 332.800 C 34.220 332.800,34.400 333.070,34.400 333.400 C 34.400 333.730,34.630 334.000,34.912 334.000 C 35.193 334.000,35.683 334.360,36.000 334.800 C 36.317 335.240,36.897 335.600,37.288 335.600 C 37.680 335.600,38.000 335.780,38.000 336.000 C 38.000 336.521,40.678 336.521,41.000 336.000 C 41.136 335.780,42.767 335.600,44.624 335.600 C 46.608 335.600,48.000 335.765,48.000 336.000 C 48.000 336.220,48.726 336.400,49.613 336.400 C 50.677 336.400,51.303 336.604,51.455 337.000 C 51.612 337.407,52.250 337.600,53.443 337.600 C 54.409 337.600,55.200 337.780,55.200 338.000 C 55.200 338.220,55.549 338.400,55.976 338.400 C 56.403 338.400,56.864 338.580,57.000 338.800 C 57.136 339.020,57.777 339.200,58.424 339.200 C 59.071 339.200,59.600 339.380,59.600 339.600 C 59.600 339.820,60.146 340.000,60.813 340.000 C 61.521 340.000,62.121 340.249,62.255 340.600 C 62.382 340.930,62.816 341.200,63.219 341.200 C 63.623 341.200,64.064 341.380,64.200 341.600 C 64.336 341.820,64.977 342.000,65.624 342.000 C 66.533 342.000,66.800 342.181,66.800 342.800 C 66.800 343.547,66.533 343.600,62.800 343.600 C 58.749 343.600,58.180 343.837,59.371 345.029 C 59.808 345.466,61.173 345.600,65.171 345.600 C 68.390 345.600,70.400 345.754,70.400 346.000 C 70.400 346.229,71.600 346.400,73.200 346.400 C 74.800 346.400,76.000 346.571,76.000 346.800 C 76.000 347.020,76.540 347.200,77.200 347.200 C 77.860 347.200,78.400 347.380,78.400 347.600 C 78.400 347.820,78.837 348.000,79.371 348.000 C 79.906 348.000,80.613 348.270,80.943 348.600 C 81.273 348.930,81.916 349.200,82.371 349.200 C 82.827 349.200,83.200 349.380,83.200 349.600 C 83.200 349.820,83.740 350.000,84.400 350.000 C 85.060 350.000,85.600 350.180,85.600 350.400 C 85.600 350.620,85.949 350.800,86.376 350.800 C 86.803 350.800,87.264 350.980,87.400 351.200 C 87.536 351.420,88.074 351.600,88.595 351.600 C 89.116 351.600,89.813 351.870,90.143 352.200 C 90.473 352.530,91.026 352.800,91.371 352.800 C 91.717 352.800,92.000 352.980,92.000 353.200 C 92.000 353.420,92.349 353.600,92.776 353.600 C 93.203 353.600,93.664 353.780,93.800 354.000 C 93.936 354.220,94.366 354.400,94.756 354.400 C 95.146 354.400,95.706 354.850,96.000 355.400 C 96.336 356.028,96.882 356.400,97.468 356.400 C 97.980 356.400,98.400 356.580,98.400 356.800 C 98.400 357.020,98.760 357.200,99.200 357.200 C 99.640 357.200,100.000 357.380,100.000 357.600 C 100.000 357.820,100.337 358.000,100.749 358.000 C 101.161 358.000,102.036 358.630,102.694 359.400 C 103.352 360.170,104.209 360.800,104.598 360.800 C 104.988 360.800,105.597 361.134,105.953 361.543 C 106.309 361.951,107.005 362.413,107.500 362.570 C 107.995 362.726,108.400 363.022,108.400 363.227 C 108.400 363.432,108.760 363.600,109.200 363.600 C 109.640 363.600,110.000 363.780,110.000 364.000 C 110.000 364.220,110.332 364.400,110.738 364.400 C 111.144 364.400,111.802 364.760,112.200 365.200 C 112.598 365.640,113.172 366.000,113.475 366.000 C 113.777 366.000,114.129 366.270,114.255 366.600 C 114.382 366.930,114.916 367.200,115.443 367.200 C 115.969 367.200,116.400 367.380,116.400 367.600 C 116.400 367.820,116.760 368.000,117.200 368.000 C 117.640 368.000,118.000 368.159,118.000 368.354 C 118.000 368.549,118.630 369.008,119.400 369.373 C 120.170 369.739,120.800 370.209,120.800 370.419 C 120.800 370.628,121.250 370.800,121.800 370.800 C 122.350 370.800,122.800 370.980,122.800 371.200 C 122.800 371.420,123.160 371.600,123.600 371.600 C 124.040 371.600,124.400 371.780,124.400 372.000 C 124.400 372.220,124.642 372.400,124.939 372.400 C 125.741 372.400,128.000 373.602,128.000 374.029 C 128.000 374.233,128.630 374.400,129.400 374.400 C 130.170 374.400,130.800 374.580,130.800 374.800 C 130.800 375.020,131.160 375.200,131.600 375.200 C 132.040 375.200,132.400 375.380,132.400 375.600 C 132.400 375.820,133.030 376.000,133.800 376.000 C 134.570 376.000,135.200 376.180,135.200 376.400 C 135.200 376.620,135.731 376.800,136.380 376.800 C 137.029 376.800,137.704 377.054,137.880 377.365 C 138.056 377.676,138.740 377.991,139.400 378.065 C 140.140 378.148,140.600 378.430,140.600 378.800 C 140.600 379.534,132.556 379.916,131.855 379.215 C 131.615 378.975,129.445 378.800,126.720 378.800 C 122.791 378.800,122.000 378.699,122.000 378.200 C 122.000 377.694,121.071 377.600,116.043 377.600 C 111.116 377.600,110.046 377.704,109.855 378.200 C 109.710 378.580,109.096 378.800,108.184 378.800 C 105.809 378.800,104.466 381.723,106.093 383.350 C 106.862 384.119,127.200 384.360,127.200 383.600 C 127.200 383.339,133.267 383.200,144.600 383.200 C 159.741 383.200,162.000 383.277,162.000 383.795 C 162.000 384.749,160.701 386.000,159.711 386.000 C 159.067 386.000,158.800 386.234,158.800 386.800 C 158.800 387.481,159.067 387.600,160.600 387.600 C 161.590 387.600,162.400 387.420,162.400 387.200 C 162.400 386.980,162.929 386.800,163.576 386.800 C 164.223 386.800,164.864 386.620,165.000 386.400 C 165.136 386.180,165.946 386.000,166.800 386.000 C 167.654 386.000,168.464 385.820,168.600 385.600 C 168.746 385.364,171.137 385.200,174.424 385.200 C 177.875 385.200,180.000 385.352,180.000 385.600 C 180.000 385.852,182.667 386.000,187.200 386.000 C 191.733 386.000,194.400 386.148,194.400 386.400 C 194.400 386.936,204.269 386.936,204.600 386.400 C 205.105 385.583,208.000 385.923,208.000 386.800 C 208.000 387.448,207.733 387.600,206.600 387.600 C 205.830 387.600,205.200 387.780,205.200 388.000 C 205.200 388.220,204.859 388.400,204.443 388.400 C 204.026 388.400,203.582 388.670,203.455 389.000 C 203.321 389.351,202.721 389.600,202.013 389.600 C 201.346 389.600,200.800 389.780,200.800 390.000 C 200.800 390.220,200.451 390.400,200.024 390.400 C 199.597 390.400,199.136 390.580,199.000 390.800 C 198.864 391.020,198.223 391.200,197.576 391.200 C 196.929 391.200,196.400 391.380,196.400 391.600 C 196.400 391.820,195.789 392.000,195.043 392.000 C 194.205 392.000,193.597 392.230,193.455 392.600 C 193.321 392.951,192.721 393.200,192.013 393.200 C 191.346 393.200,190.800 393.380,190.800 393.600 C 190.800 393.820,189.990 394.000,189.000 394.000 C 188.010 394.000,187.200 394.180,187.200 394.400 C 187.200 394.620,186.210 394.800,185.000 394.800 C 183.790 394.800,182.800 394.980,182.800 395.200 C 182.800 395.420,181.829 395.600,180.643 395.600 C 179.094 395.600,178.421 395.769,178.255 396.200 C 178.093 396.622,177.435 396.800,176.036 396.800 C 174.942 396.800,173.936 396.980,173.800 397.200 C 173.664 397.420,172.393 397.600,170.976 397.600 C 169.525 397.600,168.400 397.775,168.400 398.000 C 168.400 398.226,167.267 398.400,165.800 398.400 C 164.370 398.400,163.200 398.569,163.200 398.776 C 163.200 398.983,162.525 399.222,161.700 399.309 C 160.875 399.395,162.476 399.496,165.257 399.533 C 169.427 399.588,170.355 399.495,170.545 399.000 C 170.714 398.559,171.409 398.400,173.164 398.400 C 174.478 398.400,175.664 398.220,175.800 398.000 C 176.290 397.207,178.400 397.532,178.400 398.400 C 178.400 398.977,178.133 399.200,177.443 399.200 C 176.916 399.200,176.382 399.470,176.255 399.800 C 176.129 400.130,175.749 400.400,175.413 400.400 C 175.076 400.400,174.800 400.580,174.800 400.800 C 174.800 401.020,174.390 401.200,173.888 401.200 C 173.387 401.200,172.717 401.560,172.400 402.000 C 172.083 402.440,171.595 402.800,171.316 402.800 C 170.398 402.800,169.200 404.159,169.200 405.200 C 169.200 406.284,170.409 407.600,171.405 407.600 C 171.732 407.600,172.000 407.780,172.000 408.000 C 172.000 408.220,172.630 408.400,173.400 408.400 C 174.170 408.400,174.800 408.220,174.800 408.000 C 174.800 407.780,175.430 407.600,176.200 407.600 C 176.970 407.600,177.600 407.420,177.600 407.200 C 177.600 406.980,177.941 406.800,178.357 406.800 C 178.774 406.800,179.218 406.530,179.345 406.200 C 179.471 405.870,179.941 405.600,180.387 405.600 C 180.834 405.600,181.200 405.420,181.200 405.200 C 181.200 404.980,181.549 404.800,181.976 404.800 C 182.403 404.800,182.864 404.620,183.000 404.400 C 183.136 404.180,183.597 404.000,184.024 404.000 C 184.451 404.000,184.800 403.820,184.800 403.600 C 184.800 403.380,185.141 403.200,185.557 403.200 C 185.974 403.200,186.418 402.930,186.545 402.600 C 186.671 402.270,187.141 402.000,187.587 402.000 C 188.034 402.000,188.400 401.820,188.400 401.600 C 188.400 401.380,188.749 401.200,189.176 401.200 C 189.603 401.200,190.064 401.020,190.200 400.800 C 190.336 400.580,190.797 400.400,191.224 400.400 C 191.651 400.400,192.000 400.220,192.000 400.000 C 192.000 399.780,192.341 399.600,192.757 399.600 C 193.174 399.600,193.618 399.330,193.745 399.000 C 193.871 398.670,194.341 398.400,194.787 398.400 C 195.234 398.400,195.600 398.220,195.600 398.000 C 195.600 397.780,195.949 397.600,196.376 397.600 C 196.803 397.600,197.264 397.420,197.400 397.200 C 197.536 396.980,197.997 396.800,198.424 396.800 C 198.851 396.800,199.200 396.620,199.200 396.400 C 199.200 396.180,199.541 396.000,199.957 396.000 C 200.374 396.000,200.818 395.730,200.945 395.400 C 201.071 395.070,201.541 394.800,201.987 394.800 C 202.434 394.800,202.800 394.620,202.800 394.400 C 202.800 394.180,203.430 394.000,204.200 394.000 C 204.970 394.000,205.600 393.820,205.600 393.600 C 205.600 393.380,205.960 393.200,206.400 393.200 C 206.840 393.200,207.200 393.020,207.200 392.800 C 207.200 392.580,207.650 392.400,208.200 392.400 C 208.822 392.400,209.200 392.173,209.200 391.800 C 209.200 391.467,209.556 391.200,210.000 391.200 C 210.440 391.200,210.800 391.020,210.800 390.800 C 210.800 390.580,211.250 390.400,211.800 390.400 C 212.350 390.400,212.800 390.220,212.800 390.000 C 212.800 389.780,213.340 389.600,214.000 389.600 C 214.660 389.600,215.200 389.420,215.200 389.200 C 215.200 388.980,215.811 388.800,216.557 388.800 C 217.395 388.800,218.003 388.570,218.145 388.200 C 218.307 387.778,218.965 387.600,220.364 387.600 C 221.458 387.600,222.464 387.420,222.600 387.200 C 222.736 386.980,223.827 386.800,225.024 386.800 C 226.221 386.800,227.200 386.620,227.200 386.400 C 227.200 386.180,228.190 386.000,229.400 386.000 C 230.610 386.000,231.600 385.820,231.600 385.600 C 231.600 385.380,231.960 385.200,232.400 385.200 C 233.452 385.200,233.452 386.442,232.400 387.200 C 231.437 387.894,231.316 389.600,232.230 389.600 C 232.577 389.600,234.106 388.340,235.627 386.800 C 237.149 385.260,238.666 384.000,238.997 384.000 C 239.329 384.000,239.600 383.820,239.600 383.600 C 239.600 383.380,240.230 383.200,241.000 383.200 C 241.770 383.200,242.400 383.020,242.400 382.800 C 242.400 382.580,243.210 382.400,244.200 382.400 C 245.190 382.400,246.000 382.220,246.000 382.000 C 246.000 381.780,246.971 381.600,248.157 381.600 C 249.706 381.600,250.379 381.431,250.545 381.000 C 250.679 380.649,251.279 380.400,251.987 380.400 C 252.654 380.400,253.200 380.220,253.200 380.000 C 253.200 379.780,253.729 379.600,254.376 379.600 C 255.023 379.600,255.664 379.420,255.800 379.200 C 255.936 378.980,256.577 378.800,257.224 378.800 C 257.871 378.800,258.400 378.620,258.400 378.400 C 258.400 378.180,258.760 378.000,259.200 378.000 C 259.748 378.000,260.000 378.267,260.000 378.847 C 260.000 379.496,259.814 379.645,259.200 379.484 C 258.760 379.369,258.400 379.451,258.400 379.666 C 258.400 380.189,257.365 381.200,256.829 381.200 C 256.593 381.200,256.400 381.393,256.400 381.629 C 256.400 382.266,255.347 383.200,254.629 383.200 C 254.283 383.200,254.000 383.380,254.000 383.600 C 254.000 383.820,253.796 384.000,253.547 384.000 C 253.068 384.000,251.201 385.989,251.200 386.500 C 251.200 386.665,250.790 386.800,250.288 386.800 C 249.787 386.800,249.117 387.160,248.800 387.600 C 248.483 388.040,247.985 388.400,247.693 388.400 C 247.401 388.400,246.745 388.850,246.235 389.400 C 245.725 389.950,245.054 390.400,244.742 390.400 C 244.431 390.400,243.917 390.760,243.600 391.200 C 243.283 391.640,242.613 392.000,242.112 392.000 C 241.610 392.000,241.200 392.135,241.200 392.300 C 241.198 392.968,239.256 394.800,238.548 394.800 C 238.131 394.800,237.452 395.250,237.039 395.800 C 236.626 396.350,235.993 396.800,235.632 396.800 C 235.272 396.800,234.717 397.160,234.400 397.600 C 234.083 398.040,233.585 398.400,233.294 398.400 C 233.003 398.400,232.280 398.850,231.687 399.400 C 231.093 399.950,230.474 400.400,230.311 400.400 C 229.979 400.400,227.877 402.198,226.861 403.350 C 226.497 403.763,225.795 404.520,225.300 405.032 C 224.805 405.544,224.400 406.109,224.400 406.286 C 224.400 406.463,223.950 407.093,223.400 407.687 C 222.638 408.508,222.400 409.198,222.400 410.583 L 222.400 412.400 226.600 412.400 C 229.745 412.400,230.800 412.271,230.800 411.888 C 230.800 411.607,231.160 411.117,231.600 410.800 C 232.100 410.440,232.400 409.765,232.400 409.000 C 232.400 408.235,232.700 407.560,233.200 407.200 C 233.640 406.883,234.000 406.401,234.000 406.130 C 234.000 405.858,234.450 405.186,235.000 404.636 C 235.550 404.086,236.000 403.425,236.000 403.166 C 236.000 402.554,240.953 397.600,241.566 397.600 C 241.824 397.600,243.001 396.610,244.183 395.400 C 245.364 394.190,246.550 393.200,246.818 393.200 C 247.086 393.200,247.900 392.570,248.626 391.800 C 250.102 390.235,251.200 389.979,251.200 391.200 C 251.200 391.640,251.020 392.000,250.800 392.000 C 250.580 392.000,250.400 392.366,250.400 392.813 C 250.400 393.259,250.130 393.729,249.800 393.855 C 249.470 393.982,249.200 394.426,249.200 394.843 C 249.200 395.259,249.020 395.600,248.800 395.600 C 248.580 395.600,248.400 396.050,248.400 396.600 C 248.400 397.400,248.600 397.600,249.400 397.600 C 250.133 397.600,250.400 397.387,250.400 396.800 C 250.400 396.360,250.580 396.000,250.800 396.000 C 251.020 396.000,251.200 395.758,251.200 395.461 C 251.200 394.659,252.402 392.400,252.829 392.400 C 253.033 392.400,253.200 392.170,253.200 391.888 C 253.200 391.607,253.560 391.117,254.000 390.800 C 254.440 390.483,254.800 389.992,254.800 389.709 C 254.800 389.427,255.610 388.397,256.600 387.421 C 257.590 386.445,258.400 385.394,258.400 385.085 C 258.400 384.414,259.661 383.200,260.359 383.200 C 260.632 383.200,261.631 382.390,262.579 381.400 C 263.528 380.410,264.504 379.600,264.747 379.600 C 265.228 379.600,266.538 378.617,267.546 377.500 C 267.894 377.115,268.372 376.800,268.610 376.800 C 268.847 376.800,269.842 376.035,270.821 375.100 C 271.799 374.165,273.095 373.145,273.700 372.832 C 274.305 372.520,274.800 372.115,274.800 371.932 C 274.800 371.750,275.160 371.600,275.600 371.600 C 276.040 371.600,276.400 371.420,276.400 371.200 C 276.400 370.980,276.831 370.800,277.357 370.800 C 277.884 370.800,278.418 370.530,278.545 370.200 C 278.671 369.870,279.023 369.600,279.325 369.600 C 279.628 369.600,280.202 369.240,280.600 368.800 C 281.001 368.357,281.832 368.000,282.462 368.000 C 283.088 368.000,283.600 367.820,283.600 367.600 C 283.600 367.380,284.050 367.200,284.600 367.200 C 285.150 367.200,285.600 367.033,285.600 366.829 C 285.600 366.427,287.840 365.200,288.573 365.200 C 288.821 365.200,289.283 364.840,289.600 364.400 C 289.917 363.960,290.497 363.600,290.888 363.600 C 291.280 363.600,291.600 363.432,291.600 363.227 C 291.600 363.022,292.005 362.726,292.500 362.570 C 292.995 362.413,293.691 361.951,294.047 361.543 C 294.403 361.134,295.078 360.800,295.547 360.800 C 296.016 360.800,296.400 360.620,296.400 360.400 C 296.400 360.180,296.741 360.000,297.157 360.000 C 297.574 360.000,298.018 359.730,298.145 359.400 C 298.271 359.070,298.701 358.800,299.099 358.800 C 299.497 358.800,300.083 358.440,300.400 358.000 C 300.717 357.560,301.297 357.200,301.688 357.200 C 302.080 357.200,302.400 357.020,302.400 356.800 C 302.400 356.580,302.651 356.400,302.957 356.400 C 303.264 356.400,303.618 356.130,303.745 355.800 C 303.871 355.470,304.223 355.200,304.525 355.200 C 304.828 355.200,305.402 354.840,305.800 354.400 C 306.198 353.960,306.811 353.596,307.162 353.591 C 307.513 353.587,308.338 352.957,308.996 352.191 C 309.654 351.426,310.430 350.800,310.719 350.800 C 311.009 350.800,312.045 349.990,313.021 349.000 C 313.997 348.010,314.978 347.200,315.201 347.200 C 315.425 347.200,316.172 346.660,316.863 346.000 C 318.172 344.749,319.600 344.407,319.600 345.344 C 319.600 345.643,319.150 346.226,318.600 346.639 C 318.050 347.052,317.600 347.673,317.600 348.020 C 317.600 348.366,317.240 349.036,316.800 349.508 C 316.360 349.980,316.000 350.573,316.000 350.826 C 316.000 351.078,315.550 351.639,315.000 352.071 C 314.450 352.504,314.000 353.165,314.000 353.541 C 314.000 353.916,313.640 354.483,313.200 354.800 C 312.760 355.117,312.400 355.674,312.400 356.037 C 312.400 356.401,311.770 357.236,311.000 357.894 C 310.230 358.552,309.600 359.360,309.600 359.690 C 309.600 360.330,307.725 362.400,307.145 362.400 C 306.955 362.400,306.800 362.850,306.800 363.400 C 306.800 363.950,306.620 364.400,306.400 364.400 C 306.180 364.400,306.000 364.760,306.000 365.200 C 306.000 365.640,305.820 366.000,305.600 366.000 C 305.380 366.000,305.200 366.242,305.200 366.539 C 305.200 367.341,303.998 369.600,303.571 369.600 C 303.367 369.600,303.200 370.230,303.200 371.000 C 303.200 371.770,303.020 372.400,302.800 372.400 C 302.580 372.400,302.400 372.964,302.400 373.653 C 302.400 375.007,304.033 376.799,305.268 376.800 C 306.190 376.800,309.600 373.312,309.600 372.368 C 309.600 371.946,309.870 371.600,310.200 371.600 C 310.530 371.600,310.800 371.251,310.800 370.824 C 310.800 370.397,310.980 369.936,311.200 369.800 C 311.420 369.664,311.600 369.203,311.600 368.776 C 311.600 368.349,311.780 368.000,312.000 368.000 C 312.220 368.000,312.400 367.651,312.400 367.224 C 312.400 366.797,312.580 366.336,312.800 366.200 C 313.020 366.064,313.200 365.603,313.200 365.176 C 313.200 364.749,313.380 364.400,313.600 364.400 C 313.820 364.400,314.000 364.152,314.000 363.849 C 314.000 363.546,314.270 363.074,314.600 362.800 C 314.930 362.526,315.200 361.964,315.200 361.551 C 315.200 361.138,315.380 360.800,315.600 360.800 C 315.820 360.800,316.000 360.451,316.000 360.024 C 316.000 359.597,316.180 359.136,316.400 359.000 C 316.620 358.864,316.800 358.403,316.800 357.976 C 316.800 357.549,316.980 357.200,317.200 357.200 C 317.420 357.200,317.600 356.952,317.600 356.649 C 317.600 356.346,317.870 355.874,318.200 355.600 C 318.530 355.326,318.800 354.764,318.800 354.351 C 318.800 353.938,318.980 353.600,319.200 353.600 C 319.420 353.600,319.600 353.240,319.600 352.800 C 319.600 352.360,319.780 352.000,320.000 352.000 C 320.220 352.000,320.400 351.550,320.400 351.000 C 320.400 350.450,320.580 350.000,320.800 350.000 C 321.020 350.000,321.200 349.724,321.200 349.387 C 321.200 349.051,321.470 348.671,321.800 348.545 C 322.130 348.418,322.400 347.884,322.400 347.357 C 322.400 346.831,322.580 346.400,322.800 346.400 C 323.020 346.400,323.200 346.040,323.200 345.600 C 323.200 345.160,323.359 344.800,323.554 344.800 C 323.749 344.800,324.208 344.170,324.573 343.400 C 324.939 342.630,325.409 342.000,325.619 342.000 C 325.828 342.000,326.000 341.550,326.000 341.000 C 326.000 340.450,326.180 340.000,326.400 340.000 C 326.620 340.000,326.800 339.680,326.800 339.288 C 326.800 338.897,327.160 338.317,327.600 338.000 C 328.040 337.683,328.400 337.097,328.400 336.699 C 328.400 336.301,328.670 335.871,329.000 335.745 C 329.330 335.618,329.600 335.256,329.600 334.940 C 329.600 334.625,329.960 333.980,330.400 333.508 C 330.840 333.036,331.200 332.354,331.200 331.992 C 331.200 331.631,331.650 331.094,332.200 330.800 C 332.750 330.506,333.200 329.922,333.200 329.504 C 333.200 328.581,334.113 327.600,334.971 327.600 C 335.403 327.600,335.600 327.976,335.600 328.800 C 335.600 329.460,335.420 330.000,335.200 330.000 C 334.980 330.000,334.800 330.630,334.800 331.400 C 334.800 332.627,334.924 332.800,335.800 332.800 C 336.533 332.800,336.800 332.587,336.800 332.000 C 336.800 331.560,336.980 331.200,337.200 331.200 C 337.420 331.200,337.600 330.210,337.600 329.000 C 337.600 327.790,337.780 326.800,338.000 326.800 C 338.220 326.800,338.400 326.170,338.400 325.400 C 338.400 324.630,338.580 324.000,338.800 324.000 C 339.020 324.000,339.200 323.454,339.200 322.787 C 339.200 322.079,339.449 321.479,339.800 321.345 C 340.130 321.218,340.400 320.774,340.400 320.357 C 340.400 319.941,340.580 319.600,340.800 319.600 C 341.020 319.600,341.200 319.216,341.200 318.747 C 341.200 317.966,342.989 316.002,343.700 316.000 C 343.865 316.000,344.000 315.550,344.000 315.000 C 344.000 314.450,344.180 314.000,344.400 314.000 C 344.620 314.000,344.800 313.640,344.800 313.200 C 344.800 312.760,344.959 312.400,345.154 312.400 C 345.349 312.400,345.788 311.815,346.129 311.100 C 346.471 310.385,347.121 309.535,347.575 309.212 C 348.029 308.888,348.400 308.279,348.400 307.858 C 348.400 307.145,350.228 305.202,350.900 305.200 C 351.065 305.200,351.200 304.750,351.200 304.200 C 351.200 303.650,351.380 303.200,351.600 303.200 C 351.820 303.200,352.000 302.880,352.000 302.488 C 352.000 302.097,352.360 301.517,352.800 301.200 C 353.240 300.883,353.600 300.328,353.600 299.968 C 353.600 299.607,354.050 298.974,354.600 298.561 C 355.151 298.147,355.600 297.404,355.600 296.905 C 355.600 296.407,355.780 296.000,356.000 296.000 C 356.220 296.000,356.400 295.640,356.400 295.200 C 356.400 294.760,356.580 294.400,356.800 294.400 C 357.020 294.400,357.200 294.034,357.200 293.587 C 357.200 293.141,357.470 292.671,357.800 292.545 C 358.130 292.418,358.400 291.974,358.400 291.557 C 358.400 291.067,358.682 290.800,359.200 290.800 C 359.867 290.800,360.000 291.067,360.000 292.400 C 360.000 293.280,359.820 294.000,359.600 294.000 C 359.369 294.000,359.200 295.271,359.200 297.013 C 359.200 299.321,359.060 300.079,358.600 300.255 C 358.169 300.421,358.000 301.094,358.000 302.643 C 358.000 303.829,357.820 304.800,357.600 304.800 C 357.380 304.800,357.200 305.610,357.200 306.600 C 357.200 307.590,357.020 308.400,356.800 308.400 C 356.580 308.400,356.400 309.210,356.400 310.200 C 356.400 311.190,356.220 312.000,356.000 312.000 C 355.780 312.000,355.600 312.546,355.600 313.213 C 355.600 313.921,355.351 314.521,355.000 314.655 C 354.630 314.797,354.400 315.405,354.400 316.243 C 354.400 316.989,354.220 317.600,354.000 317.600 C 353.780 317.600,353.600 318.129,353.600 318.776 C 353.600 319.423,353.420 320.064,353.200 320.200 C 352.980 320.336,352.800 320.977,352.800 321.624 C 352.800 322.271,352.620 322.800,352.400 322.800 C 352.180 322.800,352.000 323.166,352.000 323.613 C 352.000 324.059,351.730 324.529,351.400 324.655 C 351.030 324.797,350.800 325.405,350.800 326.243 C 350.800 326.989,350.620 327.600,350.400 327.600 C 350.180 327.600,350.000 328.140,350.000 328.800 C 350.000 329.460,349.820 330.000,349.600 330.000 C 349.380 330.000,349.200 330.450,349.200 331.000 C 349.200 331.550,349.020 332.000,348.800 332.000 C 348.580 332.000,348.400 332.546,348.400 333.213 C 348.400 333.921,348.151 334.521,347.800 334.655 C 347.458 334.787,347.200 335.383,347.200 336.043 C 347.200 336.679,347.020 337.200,346.800 337.200 C 346.580 337.200,346.400 337.470,346.400 337.800 C 346.400 338.130,346.670 338.400,347.000 338.400 C 347.373 338.400,347.600 338.022,347.600 337.400 C 347.600 336.850,347.780 336.400,348.000 336.400 C 348.220 336.400,348.400 336.040,348.400 335.600 C 348.400 335.160,348.580 334.800,348.800 334.800 C 349.020 334.800,349.200 334.558,349.200 334.261 C 349.200 333.459,350.402 331.200,350.829 331.200 C 351.033 331.200,351.200 330.570,351.200 329.800 C 351.200 329.030,351.380 328.400,351.600 328.400 C 351.820 328.400,352.000 328.040,352.000 327.600 C 352.000 327.160,352.180 326.800,352.400 326.800 C 352.620 326.800,352.800 326.170,352.800 325.400 C 352.800 324.630,352.969 324.000,353.175 324.000 C 353.381 324.000,353.606 323.415,353.675 322.700 C 353.770 321.708,353.990 321.400,354.600 321.400 C 355.353 321.400,355.407 321.704,355.512 326.541 C 355.634 332.122,355.883 332.800,357.811 332.800 C 358.482 332.800,359.296 332.354,360.000 331.600 C 360.617 330.940,361.319 330.400,361.560 330.400 C 361.831 330.400,362.000 329.477,362.000 328.000 C 362.000 326.667,362.178 325.600,362.400 325.600 C 362.654 325.600,362.800 322.533,362.800 317.200 C 362.800 311.867,362.946 308.800,363.200 308.800 C 363.448 308.800,363.600 306.600,363.600 303.000 C 363.600 299.400,363.752 297.200,364.000 297.200 C 364.245 297.200,364.400 295.329,364.400 292.387 C 364.400 288.479,364.513 287.532,365.000 287.345 C 365.453 287.171,365.600 286.439,365.600 284.357 C 365.600 282.786,365.772 281.600,366.000 281.600 C 366.220 281.600,366.400 281.240,366.400 280.800 C 366.400 280.360,366.580 280.000,366.800 280.000 C 367.020 280.000,367.200 279.370,367.200 278.600 C 367.200 277.830,367.380 277.200,367.600 277.200 C 367.820 277.200,368.000 276.654,368.000 275.987 C 368.000 275.279,368.249 274.679,368.600 274.545 C 368.942 274.413,369.200 273.817,369.200 273.157 C 369.200 272.521,369.380 272.000,369.600 272.000 C 369.820 272.000,370.000 271.447,370.000 270.771 C 370.000 269.437,370.775 268.400,371.771 268.400 C 372.203 268.400,372.400 268.776,372.400 269.600 C 372.400 270.613,372.556 270.800,373.400 270.800 C 374.276 270.800,374.400 270.627,374.400 269.400 C 374.400 268.630,374.220 268.000,374.000 268.000 C 373.780 268.000,373.600 267.460,373.600 266.800 C 373.600 266.140,373.420 265.600,373.200 265.600 C 372.971 265.600,372.800 264.400,372.800 262.800 C 372.800 261.200,372.971 260.000,373.200 260.000 C 373.420 260.000,373.600 259.291,373.600 258.424 C 373.600 257.557,373.780 256.736,374.000 256.600 C 374.220 256.464,374.400 255.823,374.400 255.176 C 374.400 254.529,374.580 254.000,374.800 254.000 C 375.020 254.000,375.200 253.190,375.200 252.200 C 375.200 250.867,375.356 250.400,375.800 250.400 C 376.244 250.400,376.400 249.933,376.400 248.600 C 376.400 247.610,376.571 246.800,376.780 246.800 C 376.989 246.800,377.214 245.765,377.280 244.500 C 377.392 242.345,377.463 242.200,378.400 242.200 C 379.367 242.200,379.404 242.299,379.519 245.195 C 379.603 247.300,379.811 248.287,380.219 248.515 C 380.655 248.759,380.800 249.679,380.800 252.196 C 380.800 254.042,380.980 255.664,381.200 255.800 C 381.436 255.946,381.600 258.330,381.600 261.600 C 381.600 264.870,381.764 267.254,382.000 267.400 C 382.237 267.546,382.400 270.004,382.400 273.424 C 382.400 277.008,382.552 279.200,382.800 279.200 C 383.020 279.200,383.200 280.190,383.200 281.400 C 383.200 282.610,383.367 283.600,383.571 283.600 C 383.998 283.600,385.200 285.859,385.200 286.661 C 385.200 286.958,385.380 287.200,385.600 287.200 C 385.820 287.200,386.000 287.483,386.000 287.829 C 386.000 288.915,387.082 289.600,388.800 289.600 C 390.518 289.600,391.600 288.915,391.600 287.829 C 391.600 287.483,391.780 287.200,392.000 287.200 C 392.233 287.200,392.400 285.867,392.400 284.000 C 392.400 282.240,392.250 280.800,392.068 280.800 C 391.885 280.800,391.494 280.350,391.200 279.800 C 390.906 279.250,390.425 278.800,390.132 278.800 C 389.840 278.800,389.600 278.440,389.600 278.000 C 389.600 277.560,389.420 277.200,389.200 277.200 C 388.980 277.200,388.800 276.750,388.800 276.200 C 388.800 275.650,388.620 275.200,388.400 275.200 C 388.180 275.200,388.000 274.660,388.000 274.000 C 388.000 273.340,387.820 272.800,387.600 272.800 C 387.380 272.800,387.200 272.189,387.200 271.443 C 387.200 270.605,386.970 269.997,386.600 269.855 C 386.178 269.693,386.000 269.035,386.000 267.636 C 386.000 266.542,385.820 265.536,385.600 265.400 C 385.380 265.264,385.200 263.993,385.200 262.576 C 385.200 261.125,385.025 260.000,384.800 260.000 C 384.574 260.000,384.400 258.867,384.400 257.400 C 384.400 255.067,384.482 254.800,385.200 254.800 C 385.725 254.800,386.000 255.067,386.000 255.576 C 386.000 256.003,386.180 256.464,386.400 256.600 C 386.620 256.736,386.800 257.177,386.800 257.581 C 386.800 257.984,387.070 258.418,387.400 258.545 C 387.730 258.671,388.000 259.051,388.000 259.387 C 388.000 259.733,388.348 260.000,388.800 260.000 C 389.648 260.000,389.946 258.661,389.200 258.200 C 388.980 258.064,388.800 257.643,388.800 257.265 C 388.800 256.886,388.440 256.317,388.000 256.000 C 387.560 255.683,387.200 255.097,387.200 254.699 C 387.200 254.301,386.930 253.871,386.600 253.745 C 386.262 253.615,386.000 253.019,386.000 252.381 C 386.000 251.757,385.820 251.136,385.600 251.000 C 385.380 250.864,385.200 250.223,385.200 249.576 C 385.200 248.929,385.020 248.400,384.800 248.400 C 384.580 248.400,384.400 247.950,384.400 247.400 C 384.400 246.850,384.220 246.400,384.000 246.400 C 383.780 246.400,383.600 245.879,383.600 245.243 C 383.600 244.583,383.342 243.987,383.000 243.855 C 382.551 243.683,382.400 242.966,382.400 241.013 C 382.400 239.538,382.226 238.400,382.000 238.400 C 381.763 238.400,381.600 236.933,381.600 234.800 C 381.600 232.667,381.437 231.200,381.200 231.200 C 380.938 231.200,380.800 223.333,380.800 208.400 C 380.800 193.467,380.662 185.600,380.400 185.600 C 380.167 185.600,380.000 184.281,380.000 182.443 C 380.000 180.005,379.863 179.233,379.400 179.055 C 378.981 178.895,378.800 178.241,378.800 176.893 C 378.800 175.830,378.605 174.765,378.366 174.526 C 377.728 173.888,378.089 172.229,378.900 172.075 C 379.420 171.976,379.600 172.206,379.600 172.971 C 379.600 173.537,379.767 174.000,379.971 174.000 C 380.398 174.000,381.600 176.259,381.600 177.061 C 381.600 177.358,381.780 177.600,382.000 177.600 C 382.220 177.600,382.400 177.960,382.400 178.400 C 382.400 178.840,382.580 179.200,382.800 179.200 C 383.020 179.200,383.200 179.650,383.200 180.200 C 383.200 180.750,383.367 181.200,383.571 181.200 C 383.998 181.200,385.200 183.459,385.200 184.261 C 385.200 184.558,385.380 184.800,385.600 184.800 C 385.820 184.800,386.000 185.160,386.000 185.600 C 386.000 186.040,386.180 186.400,386.400 186.400 C 386.620 186.400,386.800 187.030,386.800 187.800 C 386.800 188.570,386.967 189.200,387.171 189.200 C 387.598 189.200,388.800 191.459,388.800 192.261 C 388.800 192.558,388.980 192.800,389.200 192.800 C 389.420 192.800,389.600 193.141,389.600 193.558 C 389.600 193.975,390.047 194.740,390.593 195.258 C 391.139 195.776,391.589 196.397,391.593 196.638 C 391.597 196.879,391.960 197.402,392.400 197.800 C 392.840 198.198,393.200 198.774,393.200 199.080 C 393.200 200.514,395.088 201.600,397.582 201.600 L 400.000 201.600 400.000 199.400 C 400.000 197.711,399.861 197.200,399.400 197.200 C 399.027 197.200,398.800 196.822,398.800 196.200 C 398.800 195.650,398.633 195.200,398.429 195.200 C 398.057 195.200,396.800 192.983,396.800 192.325 C 396.800 192.132,396.170 191.343,395.400 190.573 C 394.630 189.803,394.000 188.949,394.000 188.675 C 394.000 188.401,393.640 187.917,393.200 187.600 C 392.760 187.283,392.400 186.703,392.400 186.312 C 392.400 185.920,392.220 185.600,392.000 185.600 C 391.780 185.600,391.600 185.193,391.600 184.695 C 391.600 184.196,391.151 183.453,390.600 183.039 C 390.050 182.626,389.600 181.993,389.600 181.632 C 389.600 181.272,389.240 180.717,388.800 180.400 C 388.360 180.083,388.000 179.569,388.000 179.258 C 388.000 178.946,387.550 178.275,387.000 177.765 C 386.450 177.255,386.000 176.599,386.000 176.307 C 386.000 176.015,385.640 175.517,385.200 175.200 C 384.760 174.883,384.400 174.253,384.400 173.800 C 384.400 173.347,384.031 172.712,383.581 172.388 C 382.747 171.789,381.600 169.843,381.600 169.027 C 381.600 168.779,381.240 168.317,380.800 168.000 C 380.360 167.683,380.000 167.013,380.000 166.512 C 380.000 165.968,379.758 165.600,379.400 165.600 C 379.067 165.600,378.800 165.244,378.800 164.800 C 378.800 164.360,378.620 164.000,378.400 164.000 C 378.180 164.000,378.000 163.590,378.000 163.088 C 378.000 162.587,377.640 161.917,377.200 161.600 C 376.760 161.283,376.400 160.722,376.400 160.354 C 376.400 159.987,376.130 159.582,375.800 159.455 C 375.470 159.329,375.200 158.859,375.200 158.413 C 375.200 157.966,375.020 157.600,374.800 157.600 C 374.580 157.600,374.400 157.251,374.400 156.824 C 374.400 156.397,374.220 155.936,374.000 155.800 C 373.780 155.664,373.600 155.203,373.600 154.776 C 373.600 154.349,373.420 154.000,373.200 154.000 C 372.980 154.000,372.800 153.659,372.800 153.243 C 372.800 152.826,372.530 152.382,372.200 152.255 C 371.413 151.954,371.429 150.841,372.224 150.535 C 372.626 150.381,373.322 150.813,374.178 151.748 C 375.719 153.431,377.200 153.699,377.200 152.295 C 377.200 151.776,376.741 151.051,376.122 150.595 C 375.530 150.158,374.765 149.462,374.422 149.050 C 373.663 148.134,372.358 146.821,371.350 145.957 C 370.238 145.004,369.200 143.651,369.200 143.153 C 369.200 142.912,368.750 142.361,368.200 141.929 C 367.650 141.496,367.200 140.795,367.200 140.371 C 367.200 139.947,367.020 139.600,366.800 139.600 C 366.580 139.600,366.400 138.970,366.400 138.200 C 366.400 137.430,366.220 136.800,366.000 136.800 C 365.780 136.800,365.600 136.511,365.600 136.158 C 365.600 135.804,365.150 135.161,364.600 134.729 C 364.050 134.296,363.600 133.595,363.600 133.171 C 363.600 132.747,363.420 132.400,363.200 132.400 C 362.980 132.400,362.800 132.040,362.800 131.600 C 362.800 131.160,362.620 130.800,362.400 130.800 C 362.180 130.800,362.000 130.350,362.000 129.800 C 362.000 129.250,361.833 128.800,361.629 128.800 C 361.103 128.800,360.000 126.456,360.000 125.339 C 360.000 124.822,359.820 124.400,359.600 124.400 C 359.380 124.400,359.200 123.950,359.200 123.400 C 359.200 122.850,359.020 122.400,358.800 122.400 C 358.580 122.400,358.400 122.111,358.400 121.758 C 358.400 121.404,357.950 120.761,357.400 120.329 C 356.850 119.896,356.400 119.195,356.400 118.771 C 356.400 118.347,356.220 118.000,356.000 118.000 C 355.780 118.000,355.600 117.640,355.600 117.200 C 355.600 116.760,355.420 116.400,355.200 116.400 C 354.980 116.400,354.800 115.980,354.800 115.468 C 354.800 114.882,354.428 114.336,353.800 114.000 C 352.371 113.235,352.470 112.000,353.960 112.000 C 355.077 112.000,358.000 114.344,358.000 115.240 C 358.000 115.438,358.357 115.600,358.792 115.600 C 359.696 115.600,375.200 130.875,375.200 131.766 C 375.200 132.068,375.667 132.740,376.238 133.258 C 378.497 135.309,379.600 136.541,379.600 137.015 C 379.600 137.288,380.680 138.588,382.000 139.904 C 383.320 141.220,384.400 142.455,384.400 142.648 C 384.401 143.199,386.241 145.200,386.747 145.200 C 387.502 145.200,387.258 144.555,386.200 143.761 C 385.650 143.348,385.200 142.727,385.200 142.380 C 385.200 142.034,384.840 141.364,384.400 140.892 C 383.960 140.420,383.600 139.855,383.600 139.636 C 383.600 139.417,382.970 138.627,382.200 137.879 C 381.430 137.131,380.800 136.308,380.800 136.051 C 380.800 135.793,379.810 134.608,378.600 133.417 C 376.304 131.158,375.830 130.000,377.200 130.000 C 377.640 130.000,378.000 130.180,378.000 130.400 C 378.000 130.620,378.360 130.800,378.800 130.800 C 379.240 130.800,379.600 130.959,379.600 131.154 C 379.600 131.349,380.230 131.808,381.000 132.173 C 381.770 132.539,382.400 133.009,382.400 133.219 C 382.400 133.428,382.749 133.600,383.176 133.600 C 383.603 133.600,384.064 133.780,384.200 134.000 C 384.570 134.599,386.775 134.482,387.429 133.829 C 389.209 132.048,386.678 126.000,384.152 126.000 C 383.848 126.000,383.600 125.820,383.600 125.600 C 383.600 125.380,383.330 125.200,383.000 125.200 C 382.670 125.200,382.400 125.020,382.400 124.800 C 382.400 124.580,382.080 124.400,381.688 124.400 C 381.297 124.400,380.717 124.040,380.400 123.600 C 380.083 123.160,379.601 122.800,379.330 122.800 C 379.058 122.800,378.386 122.350,377.836 121.800 C 377.286 121.250,376.569 120.800,376.242 120.800 C 375.915 120.800,375.536 120.620,375.400 120.400 C 375.264 120.180,374.834 120.000,374.444 120.000 C 374.054 120.000,373.494 119.550,373.200 119.000 C 372.906 118.450,372.317 118.000,371.893 118.000 C 371.468 118.000,370.617 117.460,370.000 116.800 C 369.383 116.140,368.689 115.600,368.458 115.600 C 368.226 115.600,367.586 115.150,367.036 114.600 C 366.486 114.050,365.786 113.600,365.480 113.600 C 365.174 113.600,364.598 113.240,364.200 112.800 C 363.802 112.360,363.228 112.000,362.925 112.000 C 362.623 112.000,362.271 111.730,362.145 111.400 C 362.018 111.070,361.664 110.800,361.357 110.800 C 361.051 110.800,360.800 110.620,360.800 110.400 C 360.800 110.180,360.480 110.000,360.088 110.000 C 359.697 110.000,359.117 109.640,358.800 109.200 C 358.483 108.760,357.946 108.400,357.608 108.400 C 357.269 108.400,356.454 107.774,355.796 107.009 C 355.138 106.243,354.308 105.613,353.951 105.609 C 353.594 105.604,352.764 104.970,352.106 104.200 C 351.448 103.430,350.568 102.800,350.150 102.800 C 349.732 102.800,349.032 102.315,348.595 101.722 C 348.158 101.130,347.485 100.370,347.100 100.033 C 346.715 99.697,346.400 99.223,346.400 98.979 C 346.400 98.735,345.050 97.177,343.400 95.517 C 341.750 93.856,340.400 92.287,340.400 92.029 C 340.400 91.772,339.920 91.149,339.333 90.644 C 338.634 90.043,338.354 89.497,338.520 89.063 C 338.840 88.231,340.742 88.184,341.055 89.000 C 341.470 90.079,342.000 89.630,342.000 88.200 L 342.000 86.800 339.400 86.800 C 337.356 86.800,336.800 86.672,336.800 86.200 C 336.800 85.796,336.396 85.600,335.560 85.600 C 334.482 85.600,333.332 84.607,326.759 78.000 C 322.600 73.820,318.928 70.400,318.599 70.400 C 318.267 70.400,318.000 70.044,318.000 69.600 C 318.000 69.067,318.267 68.800,318.800 68.800 C 319.240 68.800,319.600 68.980,319.600 69.200 C 319.600 69.420,320.140 69.600,320.800 69.600 C 321.460 69.600,322.000 69.780,322.000 70.000 C 322.000 70.220,322.366 70.400,322.813 70.400 C 323.259 70.400,323.729 70.670,323.855 71.000 C 323.997 71.370,324.605 71.600,325.443 71.600 C 326.189 71.600,326.800 71.780,326.800 72.000 C 326.800 72.220,327.160 72.400,327.600 72.400 C 328.040 72.400,328.400 72.580,328.400 72.800 C 328.400 73.020,328.749 73.200,329.176 73.200 C 329.603 73.200,330.064 73.380,330.200 73.600 C 330.336 73.820,330.892 74.000,331.436 74.000 C 331.980 74.000,332.529 74.270,332.655 74.600 C 332.782 74.930,333.316 75.200,333.843 75.200 C 334.369 75.200,334.800 75.380,334.800 75.600 C 334.800 75.820,335.160 76.000,335.600 76.000 C 336.040 76.000,336.400 76.180,336.400 76.400 C 336.400 76.620,336.850 76.800,337.400 76.800 C 337.950 76.800,338.400 76.980,338.400 77.200 C 338.400 77.420,338.676 77.600,339.013 77.600 C 339.349 77.600,339.729 77.870,339.855 78.200 C 339.982 78.530,340.516 78.800,341.043 78.800 C 341.569 78.800,342.000 78.980,342.000 79.200 C 342.000 79.420,342.360 79.600,342.800 79.600 C 343.240 79.600,343.600 79.780,343.600 80.000 C 343.600 80.220,344.050 80.400,344.600 80.400 C 345.150 80.400,345.600 80.580,345.600 80.800 C 345.600 81.020,345.876 81.200,346.213 81.200 C 346.549 81.200,346.929 81.470,347.055 81.800 C 347.182 82.130,347.716 82.400,348.243 82.400 C 348.769 82.400,349.200 82.580,349.200 82.800 C 349.200 83.020,349.560 83.200,350.000 83.200 C 350.440 83.200,350.800 83.380,350.800 83.600 C 350.800 83.820,351.250 84.000,351.800 84.000 C 352.350 84.000,352.800 84.180,352.800 84.400 C 352.800 84.620,353.346 84.800,354.013 84.800 C 354.721 84.800,355.321 85.049,355.455 85.400 C 355.621 85.831,356.294 86.000,357.843 86.000 C 359.029 86.000,360.000 86.180,360.000 86.400 C 360.000 86.620,360.990 86.800,362.200 86.800 C 363.410 86.800,364.400 86.620,364.400 86.400 C 364.400 86.180,364.807 86.000,365.304 86.000 C 366.301 86.000,367.639 84.346,366.854 84.085 C 366.605 84.002,366.400 83.408,366.400 82.766 C 366.400 81.527,363.644 78.400,362.552 78.400 C 362.248 78.400,362.000 78.220,362.000 78.000 C 362.000 77.780,361.100 77.600,360.000 77.600 C 358.900 77.600,358.000 77.780,358.000 78.000 C 358.000 78.220,357.280 78.400,356.400 78.400 C 355.520 78.400,354.800 78.220,354.800 78.000 C 354.800 77.767,353.467 77.600,351.600 77.600 C 349.733 77.600,348.400 77.433,348.400 77.200 C 348.400 76.980,347.770 76.800,347.000 76.800 C 346.230 76.800,345.600 76.620,345.600 76.400 C 345.600 76.180,345.054 76.000,344.387 76.000 C 343.679 76.000,343.079 75.751,342.945 75.400 C 342.818 75.070,342.374 74.800,341.957 74.800 C 341.541 74.800,341.200 74.620,341.200 74.400 C 341.200 74.180,340.570 74.000,339.800 74.000 C 339.030 74.000,338.400 73.820,338.400 73.600 C 338.400 73.380,337.978 73.200,337.461 73.200 C 333.253 73.200,333.105 70.642,337.304 70.483 C 340.071 70.379,340.400 70.283,340.400 69.583 C 340.400 68.849,340.099 68.800,335.587 68.800 C 331.679 68.800,330.732 68.687,330.545 68.200 C 330.374 67.754,329.664 67.600,327.781 67.600 C 326.387 67.600,325.136 67.420,325.000 67.200 C 324.864 66.980,324.054 66.800,323.200 66.800 C 322.346 66.800,321.536 66.620,321.400 66.400 C 321.264 66.180,320.803 66.000,320.376 66.000 C 319.949 66.000,319.600 65.820,319.600 65.600 C 319.600 65.380,319.165 65.200,318.632 65.200 C 317.610 65.200,315.207 64.009,315.203 63.500 C 315.201 63.335,314.750 63.200,314.200 63.200 C 313.650 63.200,313.200 63.020,313.200 62.800 C 313.200 62.580,312.660 62.400,312.000 62.400 C 311.340 62.400,310.800 62.220,310.800 62.000 C 310.800 61.780,310.558 61.600,310.261 61.600 C 309.459 61.600,307.200 60.398,307.200 59.971 C 307.200 59.767,306.750 59.600,306.200 59.600 C 305.650 59.600,305.200 59.420,305.200 59.200 C 305.200 58.980,304.840 58.800,304.400 58.800 C 303.960 58.800,303.600 58.620,303.600 58.400 C 303.600 58.180,303.358 58.000,303.061 58.000 C 302.259 58.000,300.000 56.798,300.000 56.371 C 300.000 56.167,299.730 56.000,299.400 56.000 C 299.070 56.000,298.800 55.820,298.800 55.600 C 298.800 55.380,298.518 55.200,298.173 55.200 C 297.828 55.200,296.952 54.570,296.226 53.800 C 295.500 53.030,294.612 52.400,294.253 52.400 C 293.894 52.400,293.600 52.220,293.600 52.000 C 293.600 51.780,293.268 51.600,292.862 51.600 C 292.456 51.600,291.798 51.240,291.400 50.800 C 291.002 50.360,290.428 50.000,290.125 50.000 C 289.823 50.000,289.471 49.730,289.345 49.400 C 289.218 49.070,288.684 48.800,288.157 48.800 C 287.631 48.800,287.200 48.620,287.200 48.400 C 287.200 48.180,286.840 48.000,286.400 48.000 C 285.960 48.000,285.600 47.841,285.600 47.646 C 285.600 47.451,284.970 46.992,284.200 46.627 C 283.430 46.261,282.800 45.791,282.800 45.581 C 282.800 45.372,282.350 45.200,281.800 45.200 C 281.250 45.200,280.800 45.020,280.800 44.800 C 280.800 44.580,280.440 44.400,280.000 44.400 C 279.560 44.400,279.200 44.220,279.200 44.000 C 279.200 43.780,278.958 43.600,278.661 43.600 C 277.859 43.600,275.600 42.398,275.600 41.971 C 275.600 41.767,275.251 41.600,274.824 41.600 C 274.397 41.600,273.936 41.420,273.800 41.200 C 273.664 40.980,273.203 40.800,272.776 40.800 C 272.349 40.800,272.000 40.620,272.000 40.400 C 272.000 40.180,271.651 40.000,271.224 40.000 C 270.797 40.000,270.336 39.820,270.200 39.600 C 270.064 39.380,269.508 39.200,268.964 39.200 C 268.420 39.200,267.871 38.930,267.745 38.600 C 267.618 38.270,267.084 38.000,266.557 38.000 C 266.031 38.000,265.600 37.820,265.600 37.600 C 265.600 37.380,265.071 37.200,264.424 37.200 C 263.777 37.200,263.136 37.020,263.000 36.800 C 262.864 36.580,262.223 36.400,261.576 36.400 C 260.667 36.400,260.400 36.219,260.400 35.600 C 260.400 34.837,260.667 34.800,266.200 34.800 C 269.800 34.800,272.000 34.952,272.000 35.200 C 272.000 35.440,273.600 35.600,276.000 35.600 C 278.400 35.600,280.000 35.760,280.000 36.000 C 280.000 36.531,287.872 36.531,288.200 36.000 C 288.336 35.780,289.427 35.600,290.624 35.600 C 291.821 35.600,292.800 35.420,292.800 35.200 C 292.800 34.980,293.160 34.800,293.600 34.800 C 294.248 34.800,294.400 34.533,294.400 33.400 C 294.400 32.630,294.580 32.000,294.800 32.000 C 295.020 32.000,295.200 31.807,295.200 31.571 C 295.200 30.681,294.000 30.000,292.429 30.000 C 291.533 30.000,290.800 29.820,290.800 29.600 C 290.800 29.367,289.467 29.200,287.600 29.200 C 285.733 29.200,284.400 29.367,284.400 29.600 C 284.400 29.852,281.733 30.000,277.200 30.000 C 272.667 30.000,270.000 30.148,270.000 30.400 C 270.000 31.099,239.274 30.931,238.571 30.229 C 237.645 29.302,237.870 28.400,239.029 28.400 C 239.594 28.400,240.314 28.143,240.629 27.829 C 241.281 27.177,241.402 25.600,240.800 25.600 C 240.580 25.600,240.400 25.780,240.400 26.000 C 240.400 26.220,239.590 26.400,238.600 26.400 C 237.610 26.400,236.800 26.580,236.800 26.800 C 236.800 27.020,236.170 27.200,235.400 27.200 C 234.422 27.200,234.000 27.381,234.000 27.800 C 234.000 28.244,233.533 28.400,232.200 28.400 C 231.210 28.400,230.400 28.580,230.400 28.800 C 230.400 29.031,229.133 29.200,227.400 29.200 C 225.667 29.200,224.400 29.031,224.400 28.800 C 224.400 28.547,221.600 28.400,216.800 28.400 C 210.311 28.400,209.200 28.312,209.200 27.800 C 209.200 27.287,208.063 27.200,201.371 27.200 C 194.130 27.200,193.551 27.147,193.674 26.500 C 193.761 26.039,194.249 25.757,195.103 25.675 C 195.816 25.606,196.400 25.381,196.400 25.175 C 196.400 24.969,196.850 24.800,197.400 24.800 C 197.950 24.800,198.400 24.620,198.400 24.400 C 198.400 24.180,198.921 24.000,199.557 24.000 C 200.217 24.000,200.813 23.742,200.945 23.400 C 201.071 23.070,201.541 22.800,201.987 22.800 C 202.434 22.800,202.800 22.620,202.800 22.400 C 202.800 22.180,203.430 22.000,204.200 22.000 C 204.970 22.000,205.600 21.820,205.600 21.600 C 205.600 21.380,206.410 21.200,207.400 21.200 C 208.390 21.200,209.200 21.020,209.200 20.800 C 209.200 20.580,209.721 20.400,210.357 20.400 C 211.017 20.400,211.613 20.142,211.745 19.800 C 211.911 19.367,212.590 19.200,214.187 19.200 C 215.404 19.200,216.400 19.020,216.400 18.800 C 216.400 18.580,217.210 18.400,218.200 18.400 C 219.190 18.400,220.000 18.220,220.000 18.000 C 220.000 17.774,221.133 17.600,222.600 17.600 C 224.067 17.600,225.200 17.426,225.200 17.200 C 225.200 16.972,226.386 16.800,227.957 16.800 C 230.039 16.800,230.771 16.653,230.945 16.200 C 231.114 15.758,231.812 15.600,233.587 15.600 C 234.929 15.600,236.000 15.422,236.000 15.200 C 236.000 14.980,236.810 14.800,237.800 14.800 C 238.790 14.800,239.600 14.620,239.600 14.400 C 239.600 13.878,236.122 13.878,235.800 14.400 C 235.664 14.621,233.870 14.800,231.800 14.800 C 229.730 14.800,227.936 14.979,227.800 15.200 C 227.664 15.420,226.573 15.600,225.376 15.600 C 224.179 15.600,223.200 15.780,223.200 16.000 C 223.200 16.220,222.840 16.400,222.400 16.400 C 220.708 16.400,221.992 14.044,223.700 14.013 C 224.085 14.006,224.400 13.820,224.400 13.600 C 224.400 13.380,224.741 13.200,225.157 13.200 C 225.574 13.200,226.018 12.930,226.145 12.600 C 226.271 12.270,226.741 12.000,227.187 12.000 C 227.634 12.000,228.000 11.820,228.000 11.600 C 228.000 11.380,228.360 11.200,228.800 11.200 C 229.240 11.200,229.600 11.020,229.600 10.800 C 229.600 10.580,229.870 10.400,230.200 10.400 C 231.922 10.400,230.435 6.844,228.700 6.813 C 228.315 6.806,228.000 6.530,228.000 6.200 C 228.000 5.354,224.580 5.354,224.255 6.200 C 224.121 6.551,223.521 6.800,222.813 6.800 C 222.146 6.800,221.600 6.980,221.600 7.200 C 221.600 7.420,221.150 7.600,220.600 7.600 C 220.050 7.600,219.600 7.780,219.600 8.000 C 219.600 8.220,219.240 8.400,218.800 8.400 C 218.360 8.400,218.000 8.580,218.000 8.800 C 218.000 9.020,217.550 9.200,217.000 9.200 C 216.450 9.200,216.000 9.393,216.000 9.629 C 216.000 10.257,214.951 11.200,214.252 11.200 C 213.919 11.200,213.536 11.380,213.400 11.600 C 213.264 11.820,212.803 12.000,212.376 12.000 C 211.949 12.000,211.600 12.180,211.600 12.400 C 211.600 12.620,211.259 12.800,210.843 12.800 C 210.426 12.800,209.982 13.070,209.855 13.400 C 209.729 13.730,209.259 14.000,208.813 14.000 C 208.366 14.000,208.000 14.180,208.000 14.400 C 208.000 14.620,207.651 14.800,207.224 14.800 C 206.797 14.800,206.336 14.980,206.200 15.200 C 206.064 15.420,205.423 15.600,204.776 15.600 C 204.129 15.600,203.600 15.780,203.600 16.000 C 203.600 16.220,203.150 16.400,202.600 16.400 C 201.978 16.400,201.600 16.627,201.600 17.000 C 201.600 17.333,201.244 17.600,200.800 17.600 C 200.360 17.600,200.000 17.780,200.000 18.000 C 200.000 18.220,199.550 18.400,199.000 18.400 C 198.450 18.400,198.000 18.580,198.000 18.800 C 198.000 19.020,197.640 19.200,197.200 19.200 C 196.760 19.200,196.400 19.380,196.400 19.600 C 196.400 19.820,195.950 20.000,195.400 20.000 C 194.778 20.000,194.400 20.227,194.400 20.600 C 194.400 20.933,194.044 21.200,193.600 21.200 C 193.160 21.200,192.800 21.380,192.800 21.600 C 192.800 21.820,192.350 22.000,191.800 22.000 C 191.250 22.000,190.800 22.180,190.800 22.400 C 190.800 22.620,190.440 22.800,190.000 22.800 C 189.560 22.800,189.200 22.980,189.200 23.200 C 189.200 23.420,188.570 23.600,187.800 23.600 C 187.030 23.600,186.400 23.767,186.400 23.971 C 186.400 24.578,183.978 25.600,182.539 25.600 C 181.802 25.600,181.200 25.780,181.200 26.000 C 181.200 26.222,180.133 26.400,178.800 26.400 C 177.467 26.400,176.400 26.578,176.400 26.800 C 176.400 27.020,175.429 27.200,174.243 27.200 C 172.694 27.200,172.021 27.369,171.855 27.800 C 171.527 28.656,168.064 28.633,167.734 27.773 C 167.602 27.428,167.698 26.942,167.947 26.693 C 168.769 25.871,168.514 23.600,167.600 23.600 C 167.138 23.600,166.800 23.867,166.800 24.231 C 166.800 25.061,161.872 30.000,161.043 30.000 C 160.689 30.000,160.400 30.180,160.400 30.400 C 160.400 30.620,159.609 30.800,158.643 30.800 C 157.450 30.800,156.812 30.993,156.655 31.400 C 156.503 31.796,155.877 32.000,154.813 32.000 C 153.926 32.000,153.200 32.180,153.200 32.400 C 153.200 32.620,152.390 32.800,151.400 32.800 C 150.410 32.800,149.600 32.980,149.600 33.200 C 149.600 33.420,148.790 33.600,147.800 33.600 C 146.810 33.600,146.000 33.780,146.000 34.000 C 146.000 34.220,145.634 34.400,145.187 34.400 C 144.741 34.400,144.271 34.670,144.145 35.000 C 144.015 35.338,143.419 35.600,142.781 35.600 C 142.157 35.600,141.536 35.780,141.400 36.000 C 141.019 36.616,140.000 36.474,140.000 35.805 C 140.000 35.052,141.223 33.600,141.857 33.600 C 142.121 33.600,143.147 32.790,144.137 31.800 C 145.127 30.810,146.149 30.000,146.408 30.000 C 146.667 30.000,147.383 29.460,148.000 28.800 C 148.617 28.140,149.499 27.600,149.960 27.600 C 150.422 27.600,150.800 27.412,150.800 27.182 C 150.800 26.490,152.711 24.800,153.494 24.800 C 153.895 24.800,154.488 24.429,154.812 23.975 C 155.135 23.521,155.985 22.871,156.700 22.529 C 157.415 22.188,158.000 21.749,158.000 21.554 C 158.000 21.359,158.317 21.200,158.705 21.200 C 159.093 21.200,159.748 20.750,160.161 20.200 C 160.574 19.650,161.207 19.200,161.568 19.200 C 161.928 19.200,162.483 18.840,162.800 18.400 C 163.117 17.960,163.678 17.600,164.046 17.600 C 164.415 17.600,165.140 17.153,165.658 16.607 C 166.176 16.061,166.797 15.611,167.038 15.607 C 167.279 15.603,167.802 15.240,168.200 14.800 C 168.598 14.360,169.152 14.000,169.431 14.000 C 170.120 14.000,175.600 8.544,175.600 7.859 C 175.600 7.558,176.050 6.974,176.600 6.561 C 177.978 5.526,178.129 1.200,176.787 1.200 C 176.341 1.200,175.871 0.930,175.745 0.600 C 175.420 -0.246,172.000 -0.246,172.000 0.600 M188.639 31.000 C 189.052 31.550,189.707 32.000,190.095 32.000 C 190.483 32.000,190.800 32.180,190.800 32.400 C 190.800 32.620,191.220 32.800,191.732 32.800 C 192.318 32.800,192.864 33.172,193.200 33.800 C 193.527 34.411,194.085 34.800,194.634 34.800 C 195.129 34.800,195.602 35.007,195.687 35.260 C 195.771 35.513,196.084 35.639,196.381 35.540 C 196.771 35.410,196.626 35.062,195.861 34.298 C 194.423 32.859,194.475 32.000,196.000 32.000 C 196.660 32.000,197.200 32.180,197.200 32.400 C 197.200 32.620,197.830 32.800,198.600 32.800 C 199.370 32.800,200.000 32.980,200.000 33.200 C 200.000 33.420,200.450 33.600,201.000 33.600 C 202.420 33.600,202.238 33.004,200.576 32.216 C 198.879 31.410,198.840 30.265,200.503 30.073 C 201.286 29.983,201.600 30.126,201.600 30.573 C 201.600 31.083,202.125 31.200,204.400 31.200 C 206.000 31.200,207.200 31.371,207.200 31.600 C 207.200 31.820,208.190 32.000,209.400 32.000 C 210.610 32.000,211.600 32.180,211.600 32.400 C 211.600 32.620,212.230 32.800,213.000 32.800 C 213.770 32.800,214.400 32.980,214.400 33.200 C 214.400 33.420,214.946 33.600,215.613 33.600 C 216.321 33.600,216.921 33.849,217.055 34.200 C 217.182 34.530,217.626 34.800,218.043 34.800 C 218.459 34.800,218.800 34.980,218.800 35.200 C 218.800 35.420,219.132 35.600,219.538 35.600 C 219.944 35.600,220.602 35.960,221.000 36.400 C 221.398 36.840,222.056 37.200,222.462 37.200 C 222.868 37.200,223.200 37.470,223.200 37.800 C 223.200 38.143,223.560 38.400,224.040 38.400 C 224.501 38.400,225.383 38.940,226.000 39.600 C 226.617 40.260,227.365 40.800,227.664 40.800 C 227.963 40.800,228.746 41.426,229.404 42.191 C 230.062 42.957,230.892 43.587,231.249 43.591 C 231.606 43.596,232.436 44.230,233.094 45.000 C 233.752 45.770,234.635 46.400,235.057 46.400 C 235.478 46.400,236.083 46.760,236.400 47.200 C 236.717 47.640,237.215 48.000,237.507 48.000 C 237.799 48.000,238.455 48.450,238.965 49.000 C 239.475 49.550,240.146 50.000,240.458 50.000 C 240.769 50.000,241.283 50.360,241.600 50.800 C 241.975 51.320,242.635 51.600,243.488 51.600 C 244.388 51.600,244.800 51.789,244.800 52.200 C 244.800 52.530,245.070 52.800,245.400 52.800 C 245.730 52.800,246.000 52.530,246.000 52.200 C 246.000 51.870,246.180 51.600,246.400 51.600 C 246.620 51.600,246.800 51.251,246.800 50.824 C 246.800 50.397,246.620 49.936,246.400 49.800 C 246.180 49.664,246.000 49.315,246.000 49.023 C 246.000 48.364,242.879 45.200,242.228 45.200 C 241.966 45.200,241.364 44.840,240.892 44.400 C 240.420 43.960,239.827 43.600,239.574 43.600 C 239.322 43.600,238.761 43.150,238.329 42.600 C 237.896 42.050,237.195 41.600,236.771 41.600 C 236.347 41.600,236.000 41.420,236.000 41.200 C 236.000 40.980,235.640 40.800,235.200 40.800 C 234.760 40.800,234.400 40.641,234.400 40.446 C 234.400 40.251,233.770 39.792,233.000 39.427 C 232.230 39.061,231.600 38.591,231.600 38.381 C 231.600 38.172,231.150 38.000,230.600 38.000 C 230.050 38.000,229.600 37.820,229.600 37.600 C 229.600 37.380,229.240 37.200,228.800 37.200 C 228.360 37.200,228.000 37.033,228.000 36.828 C 228.000 36.623,227.597 36.398,227.104 36.328 C 225.495 36.098,225.721 34.800,227.371 34.800 C 228.157 34.800,228.800 34.980,228.800 35.200 C 228.800 35.420,229.329 35.600,229.976 35.600 C 230.623 35.600,231.264 35.780,231.400 36.000 C 231.536 36.220,232.177 36.400,232.824 36.400 C 233.471 36.400,234.000 36.580,234.000 36.800 C 234.000 37.020,234.546 37.200,235.213 37.200 C 235.921 37.200,236.521 37.449,236.655 37.800 C 236.782 38.130,237.216 38.400,237.619 38.400 C 238.023 38.400,238.464 38.580,238.600 38.800 C 238.736 39.020,239.377 39.200,240.024 39.200 C 240.671 39.200,241.200 39.380,241.200 39.600 C 241.200 39.820,241.549 40.000,241.976 40.000 C 242.403 40.000,242.864 40.180,243.000 40.400 C 243.136 40.620,243.597 40.800,244.024 40.800 C 244.451 40.800,244.800 41.070,244.800 41.400 C 244.800 41.773,245.178 42.000,245.800 42.000 C 246.350 42.000,246.800 42.180,246.800 42.400 C 246.800 42.620,247.160 42.800,247.600 42.800 C 248.040 42.800,248.400 42.980,248.400 43.200 C 248.400 43.420,248.749 43.600,249.176 43.600 C 249.603 43.600,250.064 43.780,250.200 44.000 C 250.336 44.220,250.797 44.400,251.224 44.400 C 251.651 44.400,252.000 44.670,252.000 45.000 C 252.000 45.373,252.378 45.600,253.000 45.600 C 253.550 45.600,254.000 45.780,254.000 46.000 C 254.000 46.220,254.320 46.400,254.712 46.400 C 255.103 46.400,255.683 46.760,256.000 47.200 C 256.317 47.640,256.872 48.000,257.232 48.000 C 257.593 48.000,258.226 48.450,258.639 49.000 C 259.052 49.550,259.757 50.000,260.207 50.000 C 260.656 50.000,261.283 50.360,261.600 50.800 C 261.917 51.240,262.415 51.600,262.707 51.600 C 262.999 51.600,263.655 52.050,264.165 52.600 C 264.675 53.150,265.346 53.600,265.658 53.600 C 265.969 53.600,266.483 53.960,266.800 54.400 C 267.117 54.840,267.579 55.200,267.827 55.200 C 268.560 55.200,270.800 56.427,270.800 56.829 C 270.800 57.033,271.070 57.200,271.400 57.200 C 271.730 57.200,272.000 57.380,272.000 57.600 C 272.000 57.820,272.320 58.000,272.712 58.000 C 273.103 58.000,273.683 58.360,274.000 58.800 C 274.317 59.240,274.799 59.600,275.070 59.600 C 275.342 59.600,276.014 60.050,276.564 60.600 C 277.114 61.150,277.831 61.600,278.158 61.600 C 278.485 61.600,278.864 61.780,279.000 62.000 C 279.318 62.515,280.800 62.523,280.800 62.009 C 280.800 61.794,280.305 61.301,279.700 60.912 C 279.095 60.524,278.251 59.890,277.825 59.503 C 277.398 59.116,276.763 58.800,276.413 58.800 C 276.063 58.800,275.517 58.440,275.200 58.000 C 274.883 57.560,274.401 57.200,274.130 57.200 C 273.858 57.200,273.186 56.750,272.636 56.200 C 272.086 55.650,271.386 55.200,271.080 55.200 C 270.774 55.200,270.198 54.840,269.800 54.400 C 269.402 53.960,268.879 53.597,268.638 53.593 C 268.397 53.589,267.776 53.139,267.258 52.593 C 266.740 52.047,266.015 51.600,265.646 51.600 C 265.278 51.600,264.717 51.240,264.400 50.800 C 264.083 50.360,263.528 50.000,263.168 50.000 C 262.807 50.000,262.174 49.550,261.761 49.000 C 261.348 48.450,260.721 48.000,260.367 48.000 C 260.013 48.000,259.398 47.640,259.000 47.200 C 258.602 46.760,258.028 46.400,257.725 46.400 C 257.423 46.400,257.071 46.130,256.945 45.800 C 256.818 45.470,256.323 45.200,255.846 45.200 C 255.368 45.200,254.717 44.840,254.400 44.400 C 254.083 43.960,253.621 43.600,253.373 43.600 C 252.640 43.600,250.400 42.373,250.400 41.971 C 250.400 41.767,250.051 41.600,249.624 41.600 C 249.197 41.600,248.736 41.420,248.600 41.200 C 248.464 40.980,248.003 40.800,247.576 40.800 C 247.149 40.800,246.800 40.620,246.800 40.400 C 246.800 40.180,246.440 40.000,246.000 40.000 C 245.560 40.000,245.200 39.820,245.200 39.600 C 245.200 39.380,244.834 39.200,244.387 39.200 C 243.941 39.200,243.471 38.930,243.345 38.600 C 243.218 38.270,242.784 38.000,242.381 38.000 C 241.977 38.000,241.536 37.820,241.400 37.600 C 241.264 37.380,240.803 37.200,240.376 37.200 C 239.949 37.200,239.600 37.020,239.600 36.800 C 239.600 36.580,239.071 36.400,238.424 36.400 C 237.777 36.400,237.136 36.220,237.000 36.000 C 236.864 35.780,236.038 35.600,235.164 35.600 C 234.120 35.600,233.496 35.394,233.345 35.000 C 233.213 34.658,232.617 34.400,231.957 34.400 C 231.321 34.400,230.800 34.220,230.800 34.000 C 230.800 33.780,230.170 33.600,229.400 33.600 C 228.630 33.600,228.000 33.420,228.000 33.200 C 228.000 32.980,227.370 32.800,226.600 32.800 C 225.467 32.800,225.200 32.648,225.200 32.000 C 225.200 31.259,225.467 31.200,228.800 31.200 C 230.933 31.200,232.400 31.363,232.400 31.600 C 232.400 31.826,233.533 32.000,235.000 32.000 C 236.467 32.000,237.600 32.174,237.600 32.400 C 237.600 32.625,238.725 32.800,240.176 32.800 C 241.593 32.800,242.864 32.980,243.000 33.200 C 243.136 33.420,244.142 33.600,245.236 33.600 C 246.635 33.600,247.293 33.778,247.455 34.200 C 247.597 34.570,248.205 34.800,249.043 34.800 C 249.789 34.800,250.400 34.980,250.400 35.200 C 250.400 35.420,250.940 35.600,251.600 35.600 C 252.260 35.600,252.800 35.780,252.800 36.000 C 252.800 36.220,253.610 36.400,254.600 36.400 C 255.590 36.400,256.400 36.580,256.400 36.800 C 256.400 37.020,257.030 37.200,257.800 37.200 C 258.778 37.200,259.200 37.381,259.200 37.800 C 259.200 38.219,259.622 38.400,260.600 38.400 C 261.370 38.400,262.000 38.580,262.000 38.800 C 262.000 39.020,262.630 39.200,263.400 39.200 C 264.170 39.200,264.800 39.380,264.800 39.600 C 264.800 39.820,265.160 40.000,265.600 40.000 C 266.040 40.000,266.400 40.180,266.400 40.400 C 266.400 40.620,266.946 40.800,267.613 40.800 C 268.321 40.800,268.921 41.049,269.055 41.400 C 269.182 41.730,269.626 42.000,270.043 42.000 C 270.459 42.000,270.800 42.180,270.800 42.400 C 270.800 42.620,271.250 42.800,271.800 42.800 C 272.350 42.800,272.800 42.980,272.800 43.200 C 272.800 43.420,273.329 43.600,273.976 43.600 C 274.623 43.600,275.264 43.780,275.400 44.000 C 275.536 44.220,275.997 44.400,276.424 44.400 C 276.851 44.400,277.200 44.670,277.200 45.000 C 277.200 45.373,277.578 45.600,278.200 45.600 C 278.750 45.600,279.200 45.780,279.200 46.000 C 279.200 46.220,279.560 46.400,280.000 46.400 C 280.440 46.400,280.800 46.580,280.800 46.800 C 280.800 47.020,281.147 47.200,281.571 47.200 C 281.995 47.200,282.696 47.650,283.129 48.200 C 283.561 48.750,284.204 49.200,284.558 49.200 C 284.911 49.200,285.200 49.380,285.200 49.600 C 285.200 49.820,285.610 50.000,286.112 50.000 C 286.613 50.000,287.283 50.360,287.600 50.800 C 287.917 51.240,288.503 51.600,288.901 51.600 C 289.299 51.600,289.729 51.870,289.855 52.200 C 289.982 52.530,290.387 52.800,290.754 52.800 C 291.122 52.800,291.683 53.160,292.000 53.600 C 292.317 54.040,292.947 54.400,293.400 54.400 C 293.853 54.400,294.483 54.760,294.800 55.200 C 295.117 55.640,295.564 56.000,295.792 56.000 C 296.021 56.000,296.693 56.450,297.287 57.000 C 297.880 57.550,298.567 58.000,298.813 58.000 C 299.445 58.000,301.600 60.228,301.600 60.881 C 301.600 61.179,301.960 61.683,302.400 62.000 C 302.840 62.317,303.200 62.956,303.200 63.421 C 303.200 63.912,303.618 64.489,304.200 64.800 C 304.750 65.094,305.200 65.654,305.200 66.044 C 305.200 66.434,305.380 66.864,305.600 67.000 C 305.820 67.136,306.000 67.777,306.000 68.424 C 306.000 69.071,306.180 69.600,306.400 69.600 C 306.620 69.600,306.800 70.211,306.800 70.957 C 306.800 71.795,307.030 72.403,307.400 72.545 C 307.796 72.697,308.000 73.323,308.000 74.387 C 308.000 75.274,308.180 76.000,308.400 76.000 C 308.620 76.000,308.800 76.630,308.800 77.400 C 308.800 78.170,308.980 78.800,309.200 78.800 C 309.422 78.800,309.600 77.733,309.600 76.400 C 309.600 75.067,309.422 74.000,309.200 74.000 C 308.980 74.000,308.800 73.190,308.800 72.200 C 308.800 71.210,308.620 70.400,308.400 70.400 C 308.180 70.400,308.000 69.860,308.000 69.200 C 308.000 68.267,308.178 68.000,308.800 68.000 C 309.277 68.000,309.600 68.267,309.600 68.660 C 309.600 69.022,310.230 69.931,311.000 70.679 C 311.770 71.427,312.400 72.217,312.400 72.436 C 312.400 72.655,312.760 73.220,313.200 73.692 C 313.640 74.164,314.000 74.877,314.000 75.275 C 314.000 75.674,314.167 76.000,314.371 76.000 C 314.798 76.000,316.000 78.259,316.000 79.061 C 316.000 79.358,316.180 79.600,316.400 79.600 C 316.620 79.600,316.800 79.949,316.800 80.376 C 316.800 80.803,316.980 81.264,317.200 81.400 C 317.420 81.536,317.600 81.997,317.600 82.424 C 317.600 82.851,317.767 83.200,317.971 83.200 C 318.497 83.200,319.600 85.544,319.600 86.661 C 319.600 87.178,319.780 87.600,320.000 87.600 C 320.220 87.600,320.400 88.230,320.400 89.000 C 320.400 89.770,320.580 90.400,320.800 90.400 C 321.020 90.400,321.200 91.011,321.200 91.757 C 321.200 92.595,321.430 93.203,321.800 93.345 C 322.130 93.471,322.400 94.020,322.400 94.564 C 322.400 95.108,322.580 95.664,322.800 95.800 C 323.020 95.936,323.200 96.746,323.200 97.600 C 323.200 98.454,323.380 99.264,323.600 99.400 C 323.820 99.536,324.000 100.357,324.000 101.224 C 324.000 102.091,324.180 102.800,324.400 102.800 C 324.620 102.800,324.800 103.533,324.800 104.429 C 324.800 105.343,325.063 106.320,325.400 106.657 C 325.730 106.987,326.006 107.649,326.013 108.129 C 326.020 108.608,326.480 109.517,327.036 110.150 L 328.048 111.300 328.824 110.467 C 329.787 109.433,329.896 106.239,329.000 105.343 C 328.670 105.013,328.400 104.306,328.400 103.771 C 328.400 103.237,328.220 102.800,328.000 102.800 C 327.780 102.800,327.600 101.990,327.600 101.000 C 327.600 100.010,327.420 99.200,327.200 99.200 C 326.980 99.200,326.800 98.570,326.800 97.800 C 326.800 97.030,326.620 96.400,326.400 96.400 C 326.180 96.400,326.000 96.117,326.000 95.771 C 326.000 95.426,325.730 94.873,325.400 94.543 C 325.070 94.213,324.800 93.506,324.800 92.971 C 324.800 92.437,324.620 92.000,324.400 92.000 C 324.180 92.000,324.000 91.651,324.000 91.224 C 324.000 90.797,323.820 90.336,323.600 90.200 C 323.380 90.064,323.200 89.603,323.200 89.176 C 323.200 88.749,323.020 88.400,322.800 88.400 C 322.580 88.400,322.400 88.040,322.400 87.600 C 322.400 87.160,322.223 86.800,322.008 86.800 C 321.792 86.800,321.502 86.350,321.364 85.800 C 321.226 85.250,320.953 84.800,320.757 84.800 C 320.560 84.800,320.400 84.451,320.400 84.024 C 320.400 83.597,320.220 83.136,320.000 83.000 C 319.780 82.864,319.600 82.403,319.600 81.976 C 319.600 81.549,319.420 81.200,319.200 81.200 C 318.980 81.200,318.800 80.570,318.800 79.800 C 318.800 79.030,318.633 78.400,318.429 78.400 C 318.002 78.400,316.800 76.141,316.800 75.339 C 316.800 75.042,316.620 74.800,316.400 74.800 C 316.180 74.800,316.000 74.522,316.000 74.182 C 316.000 73.842,315.535 73.098,314.966 72.530 C 314.025 71.589,313.989 71.439,314.563 70.866 C 315.136 70.292,315.315 70.369,316.550 71.718 C 317.297 72.533,318.132 73.200,318.407 73.200 C 319.013 73.200,329.200 83.378,329.200 83.984 C 329.200 84.221,329.830 85.026,330.600 85.774 C 331.370 86.521,332.000 87.418,332.000 87.767 C 332.000 88.115,332.180 88.400,332.400 88.400 C 332.620 88.400,332.800 88.670,332.800 89.000 C 332.800 89.330,332.986 89.600,333.213 89.600 C 333.751 89.600,336.400 92.249,336.400 92.787 C 336.400 93.014,336.670 93.200,337.000 93.200 C 337.330 93.200,337.600 93.520,337.600 93.912 C 337.600 94.303,337.960 94.883,338.400 95.200 C 338.840 95.517,339.200 96.100,339.200 96.495 C 339.200 96.890,340.010 97.990,341.000 98.938 C 341.990 99.887,342.800 100.921,342.800 101.236 C 342.800 101.552,343.250 102.148,343.800 102.561 C 344.350 102.974,344.800 103.607,344.800 103.968 C 344.800 104.328,345.160 104.883,345.600 105.200 C 346.342 105.735,346.400 106.235,346.400 112.122 C 346.400 117.019,346.514 118.429,346.900 118.303 C 347.175 118.212,347.456 117.567,347.525 116.869 C 347.785 114.243,350.000 115.077,350.000 117.800 C 350.000 119.010,350.180 120.000,350.400 120.000 C 350.620 120.000,350.800 121.003,350.800 122.229 C 350.800 124.210,350.867 124.390,351.400 123.857 C 351.776 123.482,352.000 122.498,352.000 121.229 C 352.000 119.467,352.105 119.200,352.800 119.200 C 353.333 119.200,353.600 119.467,353.600 120.000 C 353.600 120.440,353.780 120.800,354.000 120.800 C 354.220 120.800,354.400 121.411,354.400 122.157 C 354.400 122.995,354.630 123.603,355.000 123.745 C 355.351 123.879,355.600 124.479,355.600 125.187 C 355.600 125.854,355.780 126.400,356.000 126.400 C 356.220 126.400,356.400 126.760,356.400 127.200 C 356.400 127.640,356.580 128.000,356.800 128.000 C 357.020 128.000,357.200 128.979,357.200 130.176 C 357.200 131.373,357.380 132.464,357.600 132.600 C 357.846 132.752,358.000 136.071,358.000 141.224 C 358.000 146.541,357.854 149.600,357.600 149.600 C 357.363 149.600,357.200 151.067,357.200 153.200 C 357.200 155.333,357.037 156.800,356.800 156.800 C 356.552 156.800,356.400 159.000,356.400 162.600 C 356.400 166.200,356.552 168.400,356.800 168.400 C 357.020 168.400,357.200 168.670,357.200 169.000 C 357.200 169.373,357.578 169.600,358.200 169.600 C 358.822 169.600,359.200 169.373,359.200 169.000 C 359.200 168.670,359.380 168.400,359.600 168.400 C 359.820 168.400,360.000 168.040,360.000 167.600 C 360.000 167.160,360.180 166.800,360.400 166.800 C 360.635 166.800,360.800 165.396,360.800 163.387 C 360.800 160.723,360.932 159.924,361.400 159.745 C 362.318 159.392,362.292 145.398,361.373 145.045 C 360.413 144.677,360.776 142.600,361.800 142.600 C 362.437 142.600,362.599 142.865,362.596 143.900 C 362.594 144.681,362.794 145.200,363.096 145.200 C 363.427 145.200,363.600 145.819,363.600 147.000 C 363.600 147.990,363.780 148.800,364.000 148.800 C 364.226 148.800,364.400 149.933,364.400 151.400 C 364.400 152.867,364.574 154.000,364.800 154.000 C 365.037 154.000,365.200 155.452,365.200 157.557 C 365.200 160.350,365.329 161.164,365.800 161.345 C 366.317 161.543,366.400 163.458,366.400 175.200 C 366.400 186.942,366.317 188.857,365.800 189.055 C 365.294 189.249,365.200 190.542,365.200 197.271 C 365.200 204.370,365.267 205.190,365.800 204.657 C 366.240 204.217,366.400 203.143,366.400 200.629 C 366.400 198.610,366.564 197.200,366.800 197.200 C 367.053 197.200,367.200 194.400,367.200 189.600 C 367.200 184.800,367.347 182.000,367.600 182.000 C 367.857 182.000,368.000 178.133,368.000 171.200 C 368.000 164.267,367.857 160.400,367.600 160.400 C 367.367 160.400,367.200 159.067,367.200 157.200 C 367.200 155.333,367.033 154.000,366.800 154.000 C 366.580 154.000,366.400 153.190,366.400 152.200 C 366.400 151.210,366.220 150.400,366.000 150.400 C 365.780 150.400,365.600 149.429,365.600 148.243 C 365.600 146.694,365.431 146.021,365.000 145.855 C 364.604 145.703,364.400 145.077,364.400 144.013 C 364.400 143.126,364.209 142.400,363.975 142.400 C 363.736 142.400,363.604 141.830,363.675 141.100 C 363.815 139.644,364.891 139.276,365.139 140.600 C 365.222 141.040,365.539 141.544,365.845 141.720 C 366.150 141.896,366.400 142.571,366.400 143.220 C 366.400 143.869,366.580 144.400,366.800 144.400 C 367.020 144.400,367.200 144.760,367.200 145.200 C 367.200 145.640,367.380 146.000,367.600 146.000 C 367.820 146.000,368.000 146.450,368.000 147.000 C 368.000 147.550,368.180 148.000,368.400 148.000 C 368.620 148.000,368.800 148.341,368.800 148.757 C 368.800 149.174,369.070 149.618,369.400 149.745 C 369.751 149.879,370.000 150.479,370.000 151.187 C 370.000 151.854,370.180 152.400,370.400 152.400 C 370.620 152.400,370.800 153.030,370.800 153.800 C 370.800 154.570,370.980 155.200,371.200 155.200 C 371.420 155.200,371.600 155.740,371.600 156.400 C 371.600 157.060,371.780 157.600,372.000 157.600 C 372.220 157.600,372.400 158.211,372.400 158.957 C 372.400 159.795,372.630 160.403,373.000 160.545 C 373.351 160.679,373.600 161.279,373.600 161.987 C 373.600 162.654,373.780 163.200,374.000 163.200 C 374.220 163.200,374.400 164.190,374.400 165.400 C 374.400 166.610,374.580 167.600,374.800 167.600 C 375.020 167.600,375.200 168.410,375.200 169.400 C 375.200 170.390,375.380 171.200,375.600 171.200 C 375.820 171.200,376.000 172.171,376.000 173.357 C 376.000 174.906,376.169 175.579,376.600 175.745 C 377.033 175.911,377.200 176.590,377.200 178.187 C 377.200 179.404,377.380 180.400,377.600 180.400 C 377.835 180.400,378.000 181.792,378.000 183.776 C 378.000 185.633,378.180 187.264,378.400 187.400 C 378.640 187.549,378.800 190.271,378.800 194.224 C 378.800 198.341,378.950 200.800,379.200 200.800 C 379.420 200.800,379.600 201.430,379.600 202.200 C 379.600 202.970,379.420 203.600,379.200 203.600 C 378.947 203.600,378.800 206.533,378.800 211.600 C 378.800 216.667,378.653 219.600,378.400 219.600 C 378.180 219.600,378.000 220.022,378.000 220.539 C 378.000 221.656,376.897 224.000,376.371 224.000 C 376.167 224.000,376.000 224.410,376.000 224.912 C 376.000 225.413,375.640 226.083,375.200 226.400 C 374.760 226.717,374.400 227.239,374.400 227.559 C 374.400 227.879,372.960 229.539,371.200 231.248 C 369.440 232.957,368.000 234.553,368.000 234.795 C 368.000 235.037,367.549 235.722,366.997 236.316 C 366.446 236.911,366.184 237.461,366.416 237.539 C 366.648 237.616,367.165 237.301,367.566 236.840 C 367.966 236.378,368.478 236.000,368.704 236.000 C 368.930 236.000,369.218 235.730,369.345 235.400 C 369.471 235.070,369.806 234.799,370.087 234.798 C 370.369 234.797,371.175 234.257,371.878 233.598 C 373.360 232.209,374.400 232.045,374.400 233.200 C 374.400 233.640,374.220 234.000,374.000 234.000 C 373.780 234.000,373.600 234.546,373.600 235.213 C 373.600 235.921,373.351 236.521,373.000 236.655 C 372.670 236.782,372.400 237.226,372.400 237.643 C 372.400 238.059,372.220 238.400,372.000 238.400 C 371.780 238.400,371.600 238.850,371.600 239.400 C 371.600 239.950,371.420 240.400,371.200 240.400 C 370.980 240.400,370.800 240.683,370.800 241.029 C 370.800 241.747,369.866 242.800,369.229 242.800 C 368.993 242.800,368.800 243.070,368.800 243.400 C 368.800 243.730,368.620 244.000,368.400 244.000 C 368.180 244.000,368.000 244.320,368.000 244.712 C 368.000 245.103,367.640 245.683,367.200 246.000 C 366.760 246.317,366.400 246.854,366.400 247.192 C 366.400 247.531,365.774 248.346,365.009 249.004 C 364.198 249.701,363.614 250.576,363.609 251.100 C 363.604 251.595,363.447 252.000,363.259 252.000 C 362.928 252.000,361.271 253.518,359.939 255.043 C 359.575 255.459,358.765 256.267,358.139 256.839 C 357.513 257.410,356.703 258.220,356.339 258.639 C 355.975 259.057,355.165 259.867,354.539 260.439 C 353.913 261.010,353.103 261.820,352.739 262.239 C 352.375 262.657,351.565 263.467,350.939 264.039 C 349.293 265.540,348.400 266.723,348.400 267.405 C 348.400 267.732,348.130 268.000,347.800 268.000 C 347.427 268.000,347.200 268.378,347.200 269.000 C 347.200 270.055,349.620 270.539,350.200 269.600 C 350.336 269.380,350.694 269.200,350.996 269.200 C 351.855 269.200,356.400 264.486,356.400 263.595 C 356.400 263.158,356.553 262.800,356.741 262.800 C 357.529 262.800,360.800 259.089,360.800 258.195 C 360.800 257.868,361.005 257.600,361.256 257.600 C 361.815 257.600,362.770 256.394,362.787 255.667 C 362.794 255.373,363.430 254.521,364.200 253.774 C 364.970 253.026,365.600 252.181,365.600 251.895 C 365.600 251.610,365.960 251.117,366.400 250.800 C 366.840 250.483,367.200 249.916,367.200 249.541 C 367.200 249.165,367.650 248.504,368.200 248.071 C 368.750 247.639,369.200 247.022,369.200 246.702 C 369.200 246.381,369.740 245.554,370.400 244.863 C 371.060 244.172,371.600 243.417,371.600 243.185 C 371.600 242.952,372.050 242.345,372.600 241.835 C 373.150 241.325,373.600 240.614,373.600 240.254 C 373.600 239.894,373.767 239.600,373.972 239.600 C 374.177 239.600,374.402 239.197,374.472 238.704 C 374.702 237.095,376.000 237.321,376.000 238.971 C 376.000 239.757,375.820 240.400,375.600 240.400 C 375.380 240.400,375.200 241.390,375.200 242.600 C 375.200 243.810,375.020 244.800,374.800 244.800 C 374.580 244.800,374.400 245.610,374.400 246.600 C 374.400 247.590,374.220 248.400,374.000 248.400 C 373.780 248.400,373.600 249.126,373.600 250.013 C 373.600 251.077,373.396 251.703,373.000 251.855 C 372.630 251.997,372.400 252.605,372.400 253.443 C 372.400 254.189,372.220 254.800,372.000 254.800 C 371.780 254.800,371.600 255.340,371.600 256.000 C 371.600 256.660,371.420 257.200,371.200 257.200 C 370.980 257.200,370.800 257.830,370.800 258.600 C 370.800 259.370,370.620 260.000,370.400 260.000 C 370.180 260.000,370.000 260.366,370.000 260.813 C 370.000 261.259,369.730 261.729,369.400 261.855 C 369.058 261.987,368.800 262.583,368.800 263.243 C 368.800 263.879,368.620 264.400,368.400 264.400 C 368.180 264.400,368.000 265.030,368.000 265.800 C 368.000 266.570,367.820 267.200,367.600 267.200 C 367.380 267.200,367.200 267.830,367.200 268.600 C 367.200 269.370,367.020 270.000,366.800 270.000 C 366.580 270.000,366.400 270.276,366.400 270.613 C 366.400 270.949,366.130 271.329,365.800 271.455 C 365.470 271.582,365.200 272.116,365.200 272.643 C 365.200 273.169,365.020 273.600,364.800 273.600 C 364.580 273.600,364.400 273.960,364.400 274.400 C 364.400 274.840,364.220 275.200,364.000 275.200 C 363.780 275.200,363.600 275.830,363.600 276.600 C 363.600 277.370,363.420 278.000,363.200 278.000 C 362.980 278.000,362.800 278.366,362.800 278.813 C 362.800 279.259,362.530 279.729,362.200 279.855 C 361.870 279.982,361.600 280.426,361.600 280.843 C 361.600 281.259,361.420 281.600,361.200 281.600 C 360.980 281.600,360.800 281.905,360.800 282.278 C 360.800 283.194,358.826 285.200,357.925 285.200 C 357.526 285.200,357.200 285.380,357.200 285.600 C 357.200 285.820,356.840 286.000,356.400 286.000 C 355.960 286.000,355.600 286.177,355.600 286.392 C 355.600 286.608,355.150 286.898,354.600 287.036 C 354.050 287.174,353.600 287.447,353.600 287.643 C 353.600 287.840,353.285 288.006,352.900 288.013 C 352.173 288.026,350.800 288.897,350.800 289.344 C 350.800 289.761,352.731 289.635,353.000 289.200 C 353.415 288.528,354.400 288.755,354.400 289.522 C 354.400 290.303,351.949 293.200,351.289 293.200 C 351.067 293.200,350.782 293.470,350.655 293.800 C 350.529 294.130,350.177 294.400,349.875 294.400 C 349.572 294.400,348.998 294.760,348.600 295.200 C 347.562 296.346,349.477 296.346,350.708 295.200 C 351.813 294.171,352.800 294.171,352.800 295.200 C 352.800 295.640,352.620 296.000,352.400 296.000 C 352.180 296.000,352.000 296.271,352.000 296.602 C 352.000 296.934,351.190 298.003,350.200 298.979 C 349.210 299.955,348.400 300.957,348.400 301.205 C 348.400 301.838,343.348 306.800,342.704 306.800 C 342.414 306.800,341.917 307.160,341.600 307.600 C 341.283 308.040,340.613 308.400,340.112 308.400 C 339.610 308.400,339.200 308.593,339.200 308.829 C 339.200 309.534,338.114 310.400,337.229 310.400 C 336.773 310.400,336.400 310.580,336.400 310.800 C 336.400 311.020,336.040 311.200,335.600 311.200 C 335.160 311.200,334.800 311.380,334.800 311.600 C 334.800 311.820,334.434 312.000,333.987 312.000 C 333.541 312.000,333.071 312.270,332.945 312.600 C 332.818 312.930,332.374 313.200,331.957 313.200 C 331.541 313.200,331.200 313.380,331.200 313.600 C 331.200 313.820,330.750 314.000,330.200 314.000 C 329.650 314.000,329.200 314.180,329.200 314.400 C 329.200 314.620,328.840 314.800,328.400 314.800 C 327.960 314.800,327.600 314.980,327.600 315.200 C 327.600 315.420,326.970 315.600,326.200 315.600 C 325.222 315.600,324.800 315.781,324.800 316.200 C 324.800 316.530,324.451 316.800,324.024 316.800 C 323.597 316.800,323.136 316.980,323.000 317.200 C 322.864 317.420,322.403 317.600,321.976 317.600 C 321.549 317.600,321.200 317.780,321.200 318.000 C 321.200 318.220,320.671 318.400,320.024 318.400 C 319.377 318.400,318.736 318.580,318.600 318.800 C 318.464 319.020,318.023 319.200,317.619 319.200 C 317.216 319.200,316.782 319.470,316.655 319.800 C 316.529 320.130,316.099 320.400,315.701 320.400 C 315.303 320.400,314.717 320.760,314.400 321.200 C 314.083 321.640,313.580 322.000,313.283 322.000 C 312.368 322.000,311.600 323.082,311.600 324.371 L 311.600 325.600 314.176 325.600 C 315.593 325.600,316.864 325.420,317.000 325.200 C 317.136 324.980,317.597 324.800,318.024 324.800 C 318.451 324.800,318.800 324.620,318.800 324.400 C 318.800 324.180,319.160 324.000,319.600 324.000 C 320.040 324.000,320.400 323.820,320.400 323.600 C 320.400 323.380,320.850 323.200,321.400 323.200 C 321.950 323.200,322.400 323.033,322.400 322.829 C 322.400 322.402,324.659 321.200,325.461 321.200 C 325.758 321.200,326.000 321.020,326.000 320.800 C 326.000 320.580,326.360 320.400,326.800 320.400 C 327.240 320.400,327.600 320.220,327.600 320.000 C 327.600 319.780,328.020 319.600,328.532 319.600 C 329.118 319.600,329.664 319.228,330.000 318.600 C 330.294 318.050,330.831 317.600,331.192 317.600 C 331.554 317.600,332.236 317.240,332.708 316.800 C 333.180 316.360,333.779 316.000,334.039 316.000 C 334.299 316.000,334.729 315.703,334.995 315.339 C 335.530 314.607,336.400 314.916,336.400 315.837 C 336.400 316.715,333.750 319.200,332.813 319.200 C 332.366 319.200,332.000 319.335,332.000 319.500 C 331.999 319.955,330.157 322.000,329.748 322.000 C 329.551 322.000,329.052 322.450,328.639 323.000 C 328.226 323.550,327.670 324.000,327.403 324.000 C 327.137 324.000,326.354 324.540,325.663 325.200 C 324.972 325.860,324.222 326.400,323.997 326.400 C 323.771 326.400,322.974 327.030,322.226 327.800 C 321.479 328.570,320.647 329.200,320.379 329.200 C 320.111 329.200,319.475 329.650,318.965 330.200 C 318.455 330.750,317.799 331.200,317.507 331.200 C 317.215 331.200,316.717 331.560,316.400 332.000 C 316.083 332.440,315.413 332.800,314.912 332.800 C 314.410 332.800,314.000 332.980,314.000 333.200 C 314.000 333.420,313.721 333.600,313.381 333.600 C 313.040 333.600,312.345 334.050,311.835 334.600 C 311.325 335.150,310.614 335.600,310.254 335.600 C 309.894 335.600,309.600 335.780,309.600 336.000 C 309.600 336.220,309.251 336.400,308.824 336.400 C 308.397 336.400,307.936 336.580,307.800 336.800 C 307.664 337.020,307.203 337.200,306.776 337.200 C 306.349 337.200,306.000 337.367,306.000 337.571 C 306.000 337.998,303.741 339.200,302.939 339.200 C 302.642 339.200,302.400 339.380,302.400 339.600 C 302.400 339.820,302.051 340.000,301.624 340.000 C 301.197 340.000,300.736 340.180,300.600 340.400 C 300.464 340.620,300.003 340.800,299.576 340.800 C 299.149 340.800,298.800 340.967,298.800 341.171 C 298.800 341.598,296.541 342.800,295.739 342.800 C 295.442 342.800,295.200 342.980,295.200 343.200 C 295.200 343.420,294.851 343.600,294.424 343.600 C 293.997 343.600,293.536 343.780,293.400 344.000 C 293.264 344.220,292.803 344.400,292.376 344.400 C 291.949 344.400,291.600 344.567,291.600 344.771 C 291.600 345.198,289.341 346.400,288.539 346.400 C 288.242 346.400,288.000 346.580,288.000 346.800 C 288.000 347.020,287.674 347.200,287.275 347.200 C 286.877 347.200,286.114 347.605,285.581 348.100 L 284.610 349.000 285.707 349.127 C 286.321 349.198,287.079 348.978,287.430 348.627 C 287.775 348.282,288.314 348.000,288.629 348.000 C 288.943 348.000,289.200 347.820,289.200 347.600 C 289.200 347.380,289.560 347.200,290.000 347.200 C 290.440 347.200,290.800 347.020,290.800 346.800 C 290.800 346.580,291.250 346.400,291.800 346.400 C 292.350 346.400,292.800 346.220,292.800 346.000 C 292.800 345.780,293.160 345.600,293.600 345.600 C 294.040 345.600,294.400 345.420,294.400 345.200 C 294.400 344.980,294.766 344.800,295.213 344.800 C 295.659 344.800,296.129 344.530,296.255 344.200 C 296.382 343.870,296.826 343.600,297.243 343.600 C 297.659 343.600,298.000 343.420,298.000 343.200 C 298.000 342.980,298.450 342.800,299.000 342.800 C 299.550 342.800,300.000 342.620,300.000 342.400 C 300.000 342.180,300.360 342.000,300.800 342.000 C 301.240 342.000,301.600 341.820,301.600 341.600 C 301.600 341.380,301.966 341.200,302.413 341.200 C 302.859 341.200,303.329 340.930,303.455 340.600 C 303.582 340.270,304.026 340.000,304.443 340.000 C 304.859 340.000,305.200 339.820,305.200 339.600 C 305.200 339.380,305.650 339.200,306.200 339.200 C 306.750 339.200,307.200 339.020,307.200 338.800 C 307.200 338.580,307.560 338.400,308.000 338.400 C 308.440 338.400,308.800 338.220,308.800 338.000 C 308.800 337.780,309.166 337.600,309.613 337.600 C 310.059 337.600,310.529 337.330,310.655 337.000 C 310.782 336.670,311.226 336.400,311.643 336.400 C 312.059 336.400,312.400 336.220,312.400 336.000 C 312.400 335.780,312.850 335.600,313.400 335.600 C 313.950 335.600,314.400 335.420,314.400 335.200 C 314.400 334.980,314.717 334.800,315.105 334.800 C 315.493 334.800,316.148 334.350,316.561 333.800 C 316.974 333.250,317.647 332.800,318.056 332.800 C 318.465 332.800,318.800 332.620,318.800 332.400 C 318.800 332.180,319.078 332.000,319.417 332.000 C 319.756 332.000,320.420 331.640,320.892 331.200 C 321.364 330.760,322.006 330.400,322.318 330.400 C 322.630 330.400,323.239 329.950,323.671 329.400 C 324.104 328.850,324.720 328.400,325.041 328.400 C 325.361 328.400,326.776 327.230,328.185 325.800 C 329.594 324.370,330.956 323.200,331.212 323.200 C 331.467 323.200,333.271 321.580,335.221 319.600 C 337.172 317.620,339.044 316.000,339.384 316.000 C 340.382 316.000,340.092 317.193,338.800 318.400 C 338.140 319.017,337.600 319.784,337.600 320.104 C 337.600 320.425,337.150 321.026,336.600 321.439 C 336.050 321.852,335.600 322.462,335.600 322.795 C 335.599 323.427,333.914 325.600,333.425 325.600 C 332.905 325.600,332.000 326.736,332.000 327.390 C 332.000 328.108,330.273 330.000,329.618 330.000 C 329.388 330.000,329.200 330.176,329.200 330.391 C 329.200 330.886,314.429 345.600,313.932 345.600 C 313.729 345.600,313.136 346.005,312.613 346.500 C 310.402 348.594,309.668 349.200,309.344 349.202 C 309.155 349.203,308.425 349.743,307.722 350.402 C 307.019 351.061,306.242 351.600,305.995 351.600 C 305.748 351.600,304.952 352.230,304.226 353.000 C 303.500 353.770,302.694 354.400,302.435 354.400 C 302.177 354.400,301.480 354.850,300.887 355.400 C 300.293 355.950,299.581 356.400,299.304 356.400 C 299.027 356.400,298.800 356.580,298.800 356.800 C 298.800 357.020,298.474 357.200,298.075 357.200 C 297.677 357.200,296.964 357.560,296.492 358.000 C 296.020 358.440,295.356 358.800,295.017 358.800 C 294.678 358.800,294.400 358.980,294.400 359.200 C 294.400 359.420,293.950 359.600,293.400 359.600 C 292.850 359.600,292.400 359.793,292.400 360.029 C 292.400 360.657,291.351 361.600,290.652 361.600 C 290.319 361.600,289.936 361.780,289.800 362.000 C 289.664 362.220,289.203 362.400,288.776 362.400 C 288.349 362.400,288.000 362.580,288.000 362.800 C 288.000 363.020,287.659 363.200,287.243 363.200 C 286.826 363.200,286.382 363.470,286.255 363.800 C 286.129 364.130,285.659 364.400,285.213 364.400 C 284.766 364.400,284.400 364.580,284.400 364.800 C 284.400 365.020,284.051 365.200,283.624 365.200 C 283.197 365.200,282.736 365.380,282.600 365.600 C 282.464 365.820,282.003 366.000,281.576 366.000 C 281.149 366.000,280.800 366.180,280.800 366.400 C 280.800 366.620,280.459 366.800,280.043 366.800 C 279.626 366.800,279.182 367.070,279.055 367.400 C 278.879 367.860,278.121 368.000,275.813 368.000 C 274.071 368.000,272.800 368.169,272.800 368.400 C 272.800 368.620,271.990 368.800,271.000 368.800 C 270.010 368.800,269.200 368.620,269.200 368.400 C 269.200 368.174,268.067 368.000,266.600 368.000 C 264.556 368.000,264.000 367.872,264.000 367.400 C 264.000 366.956,263.533 366.800,262.200 366.800 C 261.210 366.800,260.400 366.620,260.400 366.400 C 260.400 366.180,259.686 366.000,258.813 366.000 C 257.566 366.000,257.275 366.129,257.455 366.600 C 257.582 366.930,258.026 367.200,258.443 367.200 C 258.859 367.200,259.200 367.380,259.200 367.600 C 259.200 367.820,259.830 368.000,260.600 368.000 C 261.370 368.000,262.000 368.169,262.000 368.375 C 262.000 368.581,262.585 368.806,263.300 368.875 C 264.450 368.986,264.600 369.139,264.600 370.200 L 264.600 371.400 256.291 371.508 C 249.157 371.601,247.948 371.530,247.748 371.008 C 247.568 370.540,246.837 370.400,244.581 370.400 C 242.967 370.400,241.536 370.220,241.400 370.000 C 241.264 369.780,240.173 369.600,238.976 369.600 C 237.779 369.600,236.800 369.420,236.800 369.200 C 236.800 368.980,236.091 368.800,235.224 368.800 C 234.357 368.800,233.536 368.620,233.400 368.400 C 233.264 368.180,232.438 368.000,231.564 368.000 C 230.520 368.000,229.896 367.794,229.745 367.400 C 229.613 367.058,229.017 366.800,228.357 366.800 C 227.721 366.800,227.200 366.620,227.200 366.400 C 227.200 366.180,226.570 366.000,225.800 366.000 C 225.030 366.000,224.400 365.820,224.400 365.600 C 224.400 364.965,220.029 365.114,219.371 365.771 C 218.419 366.724,219.221 368.000,220.771 368.000 C 221.227 368.000,221.600 368.180,221.600 368.400 C 221.600 368.620,221.960 368.800,222.400 368.800 C 222.840 368.800,223.200 368.980,223.200 369.200 C 223.200 369.420,223.926 369.600,224.813 369.600 C 225.877 369.600,226.503 369.804,226.655 370.200 C 226.812 370.607,227.450 370.800,228.643 370.800 C 229.609 370.800,230.400 370.980,230.400 371.200 C 230.400 371.429,231.600 371.600,233.200 371.600 C 234.800 371.600,236.000 371.771,236.000 372.000 C 236.000 372.248,238.200 372.400,241.800 372.400 C 245.309 372.400,247.600 372.554,247.600 372.791 C 247.600 373.026,250.420 373.225,254.700 373.291 C 261.497 373.395,261.800 373.434,261.800 374.200 C 261.800 374.810,261.492 375.030,260.500 375.125 C 259.785 375.194,259.200 375.419,259.200 375.625 C 259.200 375.831,258.570 376.000,257.800 376.000 C 257.030 376.000,256.400 376.180,256.400 376.400 C 256.400 376.620,255.860 376.800,255.200 376.800 C 254.540 376.800,254.000 376.980,254.000 377.200 C 254.000 377.420,253.389 377.600,252.643 377.600 C 251.805 377.600,251.197 377.830,251.055 378.200 C 250.903 378.596,250.277 378.800,249.213 378.800 C 248.326 378.800,247.600 378.980,247.600 379.200 C 247.600 379.420,246.790 379.600,245.800 379.600 C 244.810 379.600,244.000 379.780,244.000 380.000 C 244.000 380.225,242.875 380.400,241.424 380.400 C 240.007 380.400,238.736 380.580,238.600 380.800 C 238.464 381.020,237.213 381.200,235.819 381.200 C 233.936 381.200,233.226 381.354,233.055 381.800 C 232.886 382.241,232.191 382.400,230.436 382.400 C 229.122 382.400,227.936 382.580,227.800 382.800 C 227.664 383.020,226.044 383.200,224.200 383.200 C 222.356 383.200,220.736 383.380,220.600 383.600 C 220.273 384.129,212.800 384.129,212.800 383.600 C 212.800 383.380,212.350 383.200,211.800 383.200 C 211.250 383.200,210.800 383.020,210.800 382.800 C 210.800 382.580,210.440 382.400,210.000 382.400 C 209.556 382.400,209.200 382.133,209.200 381.800 C 209.200 381.470,208.930 381.200,208.600 381.200 C 208.270 381.200,208.000 381.020,208.000 380.800 C 208.000 380.580,207.706 380.400,207.347 380.400 C 206.988 380.400,206.403 380.070,206.047 379.667 C 205.251 378.765,203.600 378.280,203.600 378.949 C 203.600 379.210,203.960 379.683,204.400 380.000 C 205.600 380.865,205.464 382.400,204.187 382.400 C 203.631 382.400,203.071 382.130,202.945 381.800 C 202.803 381.430,202.195 381.200,201.357 381.200 C 200.611 381.200,200.000 381.020,200.000 380.800 C 200.000 380.580,199.640 380.400,199.200 380.400 C 198.760 380.400,198.400 380.220,198.400 380.000 C 198.400 379.780,198.130 379.600,197.800 379.600 C 197.470 379.600,197.200 379.780,197.200 380.000 C 197.200 380.220,197.380 380.400,197.600 380.400 C 197.820 380.400,198.000 380.670,198.000 381.000 C 198.000 381.373,198.378 381.600,199.000 381.600 C 199.550 381.600,200.000 381.780,200.000 382.000 C 200.000 382.220,200.360 382.400,200.800 382.400 C 201.333 382.400,201.600 382.667,201.600 383.200 C 201.600 383.822,201.333 384.000,200.400 384.000 C 199.740 384.000,199.200 383.820,199.200 383.600 C 199.200 383.375,198.075 383.200,196.624 383.200 C 195.207 383.200,193.936 383.020,193.800 382.800 C 193.664 382.580,192.658 382.400,191.564 382.400 C 190.165 382.400,189.507 382.222,189.345 381.800 C 189.188 381.393,188.550 381.200,187.357 381.200 C 186.391 381.200,185.600 381.020,185.600 380.800 C 185.600 380.580,185.240 380.400,184.800 380.400 C 184.360 380.400,184.000 380.220,184.000 380.000 C 184.000 379.780,183.550 379.600,183.000 379.600 C 182.450 379.600,182.000 379.420,182.000 379.200 C 182.000 378.980,181.640 378.800,181.200 378.800 C 180.756 378.800,180.400 378.533,180.400 378.200 C 180.400 377.827,180.022 377.600,179.400 377.600 C 178.850 377.600,178.400 377.420,178.400 377.200 C 178.400 376.980,178.040 376.800,177.600 376.800 C 177.160 376.800,176.800 376.650,176.800 376.468 C 176.800 376.285,176.305 375.881,175.700 375.570 C 175.095 375.260,173.997 374.419,173.260 373.703 C 172.523 372.986,171.655 372.400,171.331 372.400 C 170.723 372.400,169.600 371.474,169.600 370.973 C 169.600 370.536,168.273 369.628,167.600 369.604 C 167.270 369.592,166.462 368.957,165.804 368.191 C 165.146 367.426,164.331 366.800,163.992 366.800 C 163.654 366.800,163.117 366.440,162.800 366.000 C 162.483 365.560,161.916 365.200,161.541 365.200 C 161.165 365.200,160.504 364.750,160.071 364.200 C 159.639 363.650,159.006 363.200,158.666 363.200 C 158.326 363.200,157.936 363.020,157.800 362.800 C 157.664 362.580,157.203 362.400,156.776 362.400 C 156.349 362.400,156.000 362.220,156.000 362.000 C 156.000 361.780,155.370 361.600,154.600 361.600 C 153.267 361.600,153.200 361.667,153.200 363.000 C 153.200 363.770,153.380 364.400,153.600 364.400 C 153.820 364.400,154.000 364.730,154.000 365.134 C 154.000 365.941,156.089 368.000,156.908 368.000 C 157.192 368.000,157.683 368.360,158.000 368.800 C 158.317 369.240,158.872 369.600,159.232 369.600 C 159.593 369.600,160.226 370.050,160.639 370.600 C 161.052 371.150,161.757 371.600,162.207 371.600 C 162.656 371.600,163.283 371.960,163.600 372.400 C 163.917 372.840,164.478 373.200,164.846 373.200 C 165.213 373.200,165.618 373.470,165.745 373.800 C 165.871 374.130,166.301 374.400,166.699 374.400 C 167.097 374.400,167.683 374.760,168.000 375.200 C 168.317 375.640,168.779 376.000,169.027 376.000 C 170.085 376.000,172.038 377.310,171.918 377.940 C 171.745 378.857,169.193 379.088,168.713 378.230 C 168.516 377.879,167.838 377.600,167.180 377.600 C 166.531 377.600,166.000 377.420,166.000 377.200 C 166.000 376.980,165.550 376.800,165.000 376.800 C 164.450 376.800,164.000 376.620,164.000 376.400 C 164.000 376.180,163.460 376.000,162.800 376.000 C 162.140 376.000,161.600 375.820,161.600 375.600 C 161.600 375.380,161.234 375.200,160.787 375.200 C 160.341 375.200,159.871 374.930,159.745 374.600 C 159.618 374.270,159.184 374.000,158.781 374.000 C 158.377 374.000,157.936 373.820,157.800 373.600 C 157.664 373.380,157.203 373.200,156.776 373.200 C 156.349 373.200,156.000 373.020,156.000 372.800 C 156.000 372.580,155.471 372.400,154.824 372.400 C 154.177 372.400,153.536 372.220,153.400 372.000 C 153.264 371.780,152.803 371.600,152.376 371.600 C 151.949 371.600,151.600 371.330,151.600 371.000 C 151.600 370.627,151.222 370.400,150.600 370.400 C 150.050 370.400,149.600 370.220,149.600 370.000 C 149.600 369.780,149.280 369.600,148.888 369.600 C 148.497 369.600,147.917 369.240,147.600 368.800 C 147.283 368.360,146.697 368.000,146.299 368.000 C 145.901 368.000,145.471 367.730,145.345 367.400 C 145.218 367.070,144.774 366.800,144.357 366.800 C 143.941 366.800,143.600 366.620,143.600 366.400 C 143.600 366.180,143.330 366.000,143.000 366.000 C 142.670 366.000,142.400 365.820,142.400 365.600 C 142.400 365.380,142.083 365.200,141.695 365.200 C 141.307 365.200,140.652 364.750,140.239 364.200 C 139.826 363.650,139.153 363.200,138.744 363.200 C 138.335 363.200,138.000 363.020,138.000 362.800 C 138.000 362.580,137.722 362.400,137.383 362.400 C 137.044 362.400,136.380 362.040,135.908 361.600 C 135.436 361.160,134.723 360.800,134.325 360.800 C 133.926 360.800,133.600 360.607,133.600 360.371 C 133.600 359.694,132.528 358.800,131.717 358.800 C 131.310 358.800,130.717 358.440,130.400 358.000 C 130.083 357.560,129.528 357.200,129.168 357.200 C 128.807 357.200,128.174 356.750,127.761 356.200 C 127.348 355.650,126.775 355.200,126.488 355.200 C 126.201 355.200,125.580 354.840,125.108 354.400 C 124.636 353.960,123.923 353.600,123.525 353.600 C 123.126 353.600,122.800 353.420,122.800 353.200 C 122.800 352.980,122.538 352.800,122.218 352.800 C 121.898 352.800,121.186 352.350,120.636 351.800 C 119.540 350.704,119.200 350.571,119.200 351.240 C 119.200 351.820,122.791 355.200,123.408 355.200 C 123.672 355.200,124.226 355.650,124.639 356.200 C 125.053 356.751,125.796 357.200,126.295 357.200 C 126.793 357.200,127.200 357.380,127.200 357.600 C 127.200 357.820,127.479 358.000,127.819 358.000 C 128.160 358.000,128.855 358.450,129.365 359.000 C 129.875 359.550,130.546 360.000,130.858 360.000 C 131.169 360.000,131.683 360.360,132.000 360.800 C 132.317 361.240,132.884 361.600,133.259 361.600 C 133.635 361.600,134.296 362.050,134.729 362.600 C 135.161 363.150,135.770 363.600,136.082 363.600 C 136.394 363.600,137.036 363.960,137.508 364.400 C 137.980 364.840,138.573 365.200,138.826 365.200 C 139.078 365.200,139.639 365.650,140.071 366.200 C 140.504 366.750,141.165 367.200,141.541 367.200 C 141.916 367.200,142.483 367.560,142.800 368.000 C 143.117 368.440,143.586 368.800,143.843 368.800 C 144.542 368.800,146.103 369.687,147.188 370.700 C 147.717 371.195,148.477 371.600,148.875 371.600 C 149.274 371.600,149.600 371.780,149.600 372.000 C 149.600 372.220,149.960 372.400,150.400 372.400 C 150.840 372.400,151.200 372.580,151.200 372.800 C 151.200 373.020,151.566 373.200,152.013 373.200 C 152.459 373.200,152.929 373.470,153.055 373.800 C 153.182 374.130,153.616 374.400,154.019 374.400 C 154.423 374.400,154.864 374.580,155.000 374.800 C 155.136 375.020,155.597 375.200,156.024 375.200 C 156.451 375.200,156.800 375.380,156.800 375.600 C 156.800 375.820,157.160 376.000,157.600 376.000 C 158.040 376.000,158.400 376.180,158.400 376.400 C 158.400 376.620,158.946 376.800,159.613 376.800 C 160.321 376.800,160.921 377.049,161.055 377.400 C 161.197 377.770,161.805 378.000,162.643 378.000 C 163.389 378.000,164.000 378.180,164.000 378.400 C 164.000 378.620,164.630 378.800,165.400 378.800 C 166.170 378.800,166.800 378.980,166.800 379.200 C 166.800 379.420,167.340 379.600,168.000 379.600 C 168.660 379.600,169.200 379.780,169.200 380.000 C 169.200 380.220,170.010 380.400,171.000 380.400 C 172.333 380.400,172.800 380.556,172.800 381.000 C 172.800 381.419,173.222 381.600,174.200 381.600 C 175.333 381.600,175.600 381.752,175.600 382.400 C 175.600 383.118,175.333 383.200,173.000 383.200 C 171.533 383.200,170.400 383.026,170.400 382.800 C 170.400 382.565,168.996 382.400,166.987 382.400 C 164.323 382.400,163.524 382.268,163.345 381.800 C 163.174 381.354,162.464 381.200,160.581 381.200 C 159.187 381.200,157.936 381.020,157.800 380.800 C 157.664 380.580,156.573 380.400,155.376 380.400 C 154.179 380.400,153.200 380.220,153.200 380.000 C 153.200 379.780,152.660 379.600,152.000 379.600 C 151.340 379.600,150.800 379.420,150.800 379.200 C 150.800 378.980,150.009 378.800,149.043 378.800 C 147.850 378.800,147.212 378.607,147.055 378.200 C 146.921 377.849,146.321 377.600,145.613 377.600 C 144.946 377.600,144.400 377.420,144.400 377.200 C 144.400 376.980,143.770 376.800,143.000 376.800 C 142.230 376.800,141.600 376.620,141.600 376.400 C 141.600 376.180,141.071 376.000,140.424 376.000 C 139.777 376.000,139.136 375.820,139.000 375.600 C 138.864 375.380,138.223 375.200,137.576 375.200 C 136.797 375.200,136.400 374.997,136.400 374.600 C 136.400 374.181,135.978 374.000,135.000 374.000 C 134.230 374.000,133.600 373.820,133.600 373.600 C 133.600 373.380,133.150 373.200,132.600 373.200 C 132.050 373.200,131.600 373.020,131.600 372.800 C 131.600 372.580,131.240 372.400,130.800 372.400 C 130.360 372.400,130.000 372.220,130.000 372.000 C 130.000 371.780,129.454 371.600,128.787 371.600 C 128.079 371.600,127.479 371.351,127.345 371.000 C 127.218 370.670,126.774 370.400,126.357 370.400 C 125.941 370.400,125.600 370.220,125.600 370.000 C 125.600 369.780,125.150 369.600,124.600 369.600 C 124.050 369.600,123.600 369.420,123.600 369.200 C 123.600 368.980,123.240 368.800,122.800 368.800 C 122.360 368.800,122.000 368.620,122.000 368.400 C 122.000 368.180,121.634 368.000,121.187 368.000 C 120.741 368.000,120.271 367.730,120.145 367.400 C 120.018 367.070,119.574 366.800,119.157 366.800 C 118.741 366.800,118.400 366.620,118.400 366.400 C 118.400 366.180,117.950 366.000,117.400 366.000 C 116.850 366.000,116.400 365.820,116.400 365.600 C 116.400 365.380,116.106 365.200,115.746 365.200 C 115.386 365.200,114.675 364.750,114.165 364.200 C 113.655 363.650,112.960 363.200,112.619 363.200 C 112.279 363.200,112.000 363.020,112.000 362.800 C 112.000 362.580,111.674 362.400,111.275 362.400 C 110.877 362.400,110.164 362.040,109.692 361.600 C 109.220 361.160,108.556 360.800,108.217 360.800 C 107.878 360.800,107.600 360.530,107.600 360.200 C 107.600 359.870,107.330 359.600,107.000 359.600 C 106.670 359.600,106.400 359.420,106.400 359.200 C 106.400 358.980,106.040 358.800,105.600 358.800 C 105.160 358.800,104.800 358.620,104.800 358.400 C 104.800 358.180,104.463 358.000,104.051 358.000 C 103.639 358.000,102.764 357.370,102.106 356.600 C 101.448 355.830,100.660 355.194,100.355 355.187 C 99.455 355.167,98.400 354.172,98.400 353.344 C 98.400 352.922,98.040 352.317,97.600 352.000 C 97.160 351.683,96.800 351.122,96.800 350.754 C 96.800 350.387,96.530 349.982,96.200 349.855 C 95.870 349.729,95.600 349.259,95.600 348.813 C 95.600 348.366,95.420 348.000,95.200 348.000 C 94.980 348.000,94.800 347.640,94.800 347.200 C 94.800 346.760,94.620 346.400,94.400 346.400 C 94.180 346.400,94.000 345.950,94.000 345.400 C 94.000 344.850,93.820 344.400,93.600 344.400 C 93.380 344.400,93.200 343.609,93.200 342.643 C 93.200 341.450,93.007 340.812,92.600 340.655 C 92.270 340.529,92.000 339.980,92.000 339.436 C 92.000 338.892,91.820 338.336,91.600 338.200 C 91.380 338.064,91.200 337.423,91.200 336.776 C 91.200 336.129,91.020 335.600,90.800 335.600 C 90.278 335.600,90.278 339.877,90.800 340.200 C 91.020 340.336,91.200 341.157,91.200 342.024 C 91.200 342.891,91.380 343.600,91.600 343.600 C 92.126 343.600,92.118 345.080,91.590 345.406 C 91.160 345.672,88.400 343.157,88.400 342.499 C 88.400 342.290,87.860 341.554,87.200 340.863 C 86.540 340.172,86.000 339.358,86.000 339.053 C 86.000 338.748,85.730 338.274,85.400 338.000 C 85.070 337.726,84.800 337.254,84.800 336.951 C 84.800 336.648,84.620 336.400,84.400 336.400 C 84.180 336.400,84.000 336.051,84.000 335.624 C 84.000 335.197,83.820 334.736,83.600 334.600 C 83.380 334.464,83.200 334.003,83.200 333.576 C 83.200 333.149,83.020 332.800,82.800 332.800 C 82.580 332.800,82.400 332.170,82.400 331.400 C 82.400 330.630,82.233 330.000,82.029 330.000 C 81.602 330.000,80.400 327.741,80.400 326.939 C 80.400 326.642,80.220 326.400,80.000 326.400 C 79.780 326.400,79.600 325.871,79.600 325.224 C 79.600 324.577,79.420 323.936,79.200 323.800 C 78.980 323.664,78.800 323.101,78.800 322.548 C 78.800 321.995,78.530 321.273,78.200 320.943 C 77.870 320.613,77.600 319.906,77.600 319.371 C 77.600 318.837,77.420 318.400,77.200 318.400 C 76.980 318.400,76.800 317.590,76.800 316.600 C 76.800 315.610,76.620 314.800,76.400 314.800 C 76.180 314.800,76.000 313.990,76.000 313.000 C 76.000 312.010,75.820 311.200,75.600 311.200 C 75.380 311.200,75.200 310.467,75.200 309.571 C 75.200 308.657,74.937 307.680,74.600 307.343 C 74.270 307.013,74.000 306.388,74.000 305.953 C 74.000 304.571,72.171 303.086,71.209 303.687 C 70.209 304.312,70.068 307.226,71.000 308.000 C 71.330 308.274,71.600 309.095,71.600 309.825 C 71.600 310.555,71.780 311.264,72.000 311.400 C 72.220 311.536,72.400 312.346,72.400 313.200 C 72.400 314.054,72.580 314.864,72.800 315.000 C 73.020 315.136,73.200 315.777,73.200 316.424 C 73.200 317.071,73.380 317.600,73.600 317.600 C 73.820 317.600,74.000 318.050,74.000 318.600 C 74.000 319.150,74.167 319.600,74.371 319.600 C 74.897 319.600,76.000 321.944,76.000 323.061 C 76.000 323.578,76.180 324.000,76.400 324.000 C 76.620 324.000,76.800 324.349,76.800 324.776 C 76.800 325.203,76.980 325.664,77.200 325.800 C 77.420 325.936,77.600 326.397,77.600 326.824 C 77.600 327.251,77.767 327.600,77.971 327.600 C 78.398 327.600,79.600 329.859,79.600 330.661 C 79.600 330.958,79.780 331.200,80.000 331.200 C 80.220 331.200,80.400 331.560,80.400 332.000 C 80.400 332.440,80.580 332.800,80.800 332.800 C 81.020 332.800,81.200 333.173,81.200 333.629 C 81.200 334.084,81.470 334.727,81.800 335.057 C 82.130 335.387,82.400 336.094,82.400 336.629 C 82.400 337.163,82.580 337.600,82.800 337.600 C 83.020 337.600,83.200 337.920,83.200 338.312 C 83.200 338.703,83.560 339.283,84.000 339.600 C 84.440 339.917,84.800 340.587,84.800 341.088 C 84.800 341.590,84.980 342.000,85.200 342.000 C 85.420 342.000,85.600 342.360,85.600 342.800 C 85.600 343.963,84.341 343.805,83.395 342.522 C 82.958 341.930,82.262 341.165,81.850 340.822 C 81.437 340.480,80.680 339.795,80.168 339.300 C 79.656 338.805,79.068 338.400,78.862 338.400 C 78.373 338.400,74.000 334.027,74.000 333.538 C 74.000 333.332,73.595 332.754,73.100 332.254 C 72.605 331.754,71.842 330.862,71.405 330.272 C 70.968 329.682,70.460 329.200,70.276 329.200 C 69.718 329.200,68.800 328.096,68.800 327.425 C 68.800 327.078,67.630 325.646,66.200 324.244 C 64.770 322.842,63.600 321.490,63.600 321.240 C 63.600 320.990,62.970 320.174,62.200 319.426 C 61.430 318.679,60.800 317.782,60.800 317.433 C 60.800 317.085,60.620 316.800,60.400 316.800 C 60.180 316.800,60.000 316.530,60.000 316.200 C 60.000 315.870,59.807 315.600,59.571 315.600 C 58.934 315.600,58.000 314.547,58.000 313.829 C 58.000 313.483,57.820 313.200,57.600 313.200 C 57.380 313.200,57.200 312.930,57.200 312.600 C 57.200 312.270,57.020 312.000,56.800 312.000 C 56.580 312.000,56.400 311.711,56.400 311.358 C 56.400 311.004,55.950 310.361,55.400 309.929 C 54.850 309.496,54.400 308.795,54.400 308.371 C 54.400 307.947,54.220 307.600,54.000 307.600 C 53.751 307.600,53.600 305.338,53.600 301.613 C 53.600 296.455,53.517 295.657,53.000 295.855 C 52.630 295.997,52.400 296.605,52.400 297.443 C 52.400 298.684,52.298 298.800,51.200 298.800 C 50.014 298.800,50.000 298.775,50.000 296.624 C 50.000 295.427,49.820 294.336,49.600 294.200 C 49.380 294.064,49.200 292.939,49.200 291.700 C 49.200 289.633,49.151 289.511,48.613 290.224 C 48.275 290.670,48.020 291.891,48.013 293.100 C 48.002 294.929,47.897 295.200,47.200 295.200 C 46.552 295.200,46.400 294.933,46.400 293.800 C 46.400 293.030,46.220 292.400,46.000 292.400 C 45.780 292.400,45.600 292.034,45.600 291.587 C 45.600 291.141,45.330 290.671,45.000 290.545 C 44.662 290.415,44.400 289.819,44.400 289.181 C 44.400 288.557,44.220 287.936,44.000 287.800 C 43.780 287.664,43.600 287.023,43.600 286.376 C 43.600 285.729,43.420 285.200,43.200 285.200 C 42.980 285.200,42.800 284.390,42.800 283.400 C 42.800 282.410,42.620 281.600,42.400 281.600 C 42.146 281.600,42.000 278.533,42.000 273.200 C 42.000 267.867,42.146 264.800,42.400 264.800 C 42.637 264.800,42.800 263.333,42.800 261.200 C 42.800 259.067,42.963 257.600,43.200 257.600 C 43.883 257.600,43.721 245.264,43.029 244.571 C 42.155 243.698,40.000 245.111,40.000 246.558 C 40.000 246.885,39.820 247.264,39.600 247.400 C 39.379 247.537,39.200 249.342,39.200 251.436 C 39.200 254.435,39.075 255.273,38.600 255.455 C 38.101 255.647,38.000 256.761,38.000 262.043 C 38.000 267.427,38.092 268.400,38.600 268.400 C 39.033 268.400,39.200 268.844,39.200 270.000 C 39.200 271.440,39.100 271.600,38.200 271.600 C 37.360 271.600,37.200 271.412,37.200 270.424 C 37.200 269.777,37.020 269.136,36.800 269.000 C 36.580 268.864,36.400 268.054,36.400 267.200 C 36.400 266.346,36.220 265.536,36.000 265.400 C 35.780 265.264,35.600 263.993,35.600 262.576 C 35.600 261.125,35.425 260.000,35.200 260.000 C 34.960 260.000,34.800 258.414,34.800 256.043 C 34.800 252.894,34.677 252.039,34.200 251.855 C 33.296 251.509,33.296 226.491,34.200 226.145 C 34.708 225.950,34.800 224.591,34.800 217.329 C 34.800 209.697,34.733 208.810,34.200 209.343 C 33.760 209.783,33.600 210.857,33.600 213.371 C 33.600 215.390,33.436 216.800,33.200 216.800 C 32.947 216.800,32.800 219.725,32.800 224.776 C 32.800 229.663,32.645 232.849,32.400 233.000 C 31.857 233.336,31.857 252.664,32.400 253.000 C 32.620 253.136,32.800 254.587,32.800 256.224 C 32.800 257.941,32.969 259.200,33.200 259.200 C 33.420 259.200,33.600 260.190,33.600 261.400 C 33.600 262.610,33.780 263.600,34.000 263.600 C 34.220 263.600,34.400 264.391,34.400 265.357 C 34.400 266.550,34.593 267.188,35.000 267.345 C 36.044 267.745,35.829 271.600,34.763 271.600 C 34.262 271.600,33.841 271.279,33.716 270.800 C 33.601 270.360,33.348 270.000,33.153 270.000 C 32.959 270.000,32.800 269.550,32.800 269.000 C 32.800 268.450,32.620 268.000,32.400 268.000 C 32.180 268.000,32.000 267.640,32.000 267.200 C 32.000 266.760,31.820 266.400,31.600 266.400 C 31.380 266.400,31.200 265.789,31.200 265.043 C 31.200 264.205,30.970 263.597,30.600 263.455 C 30.249 263.321,30.000 262.721,30.000 262.013 C 30.000 261.346,29.820 260.800,29.600 260.800 C 29.380 260.800,29.200 260.440,29.200 260.000 C 29.200 259.560,29.020 259.200,28.800 259.200 C 28.580 259.200,28.400 258.570,28.400 257.800 C 28.400 257.030,28.220 256.400,28.000 256.400 C 27.780 256.400,27.600 255.789,27.600 255.043 C 27.600 254.205,27.370 253.597,27.000 253.455 C 26.604 253.303,26.400 252.677,26.400 251.613 C 26.400 250.726,26.220 250.000,26.000 250.000 C 25.780 250.000,25.600 249.190,25.600 248.200 C 25.600 247.210,25.420 246.400,25.200 246.400 C 24.980 246.400,24.800 245.410,24.800 244.200 C 24.800 242.990,24.620 242.000,24.400 242.000 C 24.180 242.000,24.000 241.209,24.000 240.243 C 24.000 239.050,23.807 238.412,23.400 238.255 C 22.977 238.093,22.800 237.432,22.800 236.013 C 22.800 234.906,22.620 234.000,22.400 234.000 C 22.160 234.000,22.000 232.400,22.000 230.000 C 22.000 227.600,21.840 226.000,21.600 226.000 C 21.051 226.000,21.051 194.939,21.600 194.600 C 21.820 194.464,22.000 193.823,22.000 193.176 C 22.000 192.529,22.180 192.000,22.400 192.000 C 22.620 192.000,22.800 191.634,22.800 191.187 C 22.800 190.741,23.070 190.271,23.400 190.145 C 23.730 190.018,24.000 189.574,24.000 189.157 C 24.000 188.741,24.180 188.400,24.400 188.400 C 24.620 188.400,24.800 187.993,24.800 187.495 C 24.800 186.976,25.259 186.251,25.878 185.795 C 26.470 185.358,27.235 184.662,27.578 184.250 C 27.920 183.837,28.605 183.080,29.100 182.568 C 29.595 182.056,30.000 181.444,30.000 181.208 C 30.000 180.973,31.105 179.699,32.455 178.378 C 33.805 177.057,34.795 175.862,34.655 175.721 C 34.515 175.581,34.400 175.677,34.400 175.933 C 34.400 176.190,34.083 176.400,33.695 176.400 C 33.307 176.400,32.652 176.850,32.239 177.400 C 31.826 177.950,31.233 178.400,30.921 178.400 C 30.609 178.400,29.541 179.224,28.548 180.232 C 27.473 181.322,26.511 181.975,26.171 181.844 C 25.526 181.597,25.384 180.400,26.000 180.400 C 26.220 180.400,26.400 179.854,26.400 179.187 C 26.400 178.479,26.649 177.879,27.000 177.745 C 27.330 177.618,27.600 177.084,27.600 176.557 C 27.600 176.031,27.780 175.600,28.000 175.600 C 28.220 175.600,28.400 175.240,28.400 174.800 C 28.400 174.360,28.580 174.000,28.800 174.000 C 29.020 174.000,29.200 173.653,29.200 173.229 C 29.200 172.805,29.650 172.104,30.200 171.671 C 30.750 171.239,31.200 170.596,31.200 170.242 C 31.200 169.889,31.380 169.600,31.600 169.600 C 31.820 169.600,32.000 169.370,32.000 169.088 C 32.000 168.807,32.360 168.317,32.800 168.000 C 33.240 167.683,33.600 167.103,33.600 166.712 C 33.600 166.320,33.870 166.000,34.200 166.000 C 34.530 166.000,34.800 165.730,34.800 165.400 C 34.800 165.070,34.980 164.800,35.200 164.800 C 35.420 164.800,35.600 164.521,35.600 164.181 C 35.600 163.840,39.200 159.970,43.600 155.580 C 48.000 151.191,51.600 147.324,51.600 146.987 C 51.600 146.650,51.870 146.271,52.200 146.145 C 52.530 146.018,52.800 145.484,52.800 144.957 C 52.800 143.814,50.274 143.508,49.855 144.600 C 49.729 144.930,49.332 145.200,48.973 145.200 C 48.614 145.200,47.817 145.740,47.200 146.400 C 46.583 147.060,45.881 147.600,45.640 147.600 C 45.398 147.600,45.200 147.786,45.200 148.013 C 45.200 148.551,42.551 151.200,42.013 151.200 C 41.786 151.200,41.600 151.570,41.600 152.023 C 41.600 152.476,40.790 153.645,39.800 154.621 C 38.810 155.597,38.000 156.627,38.000 156.909 C 38.000 157.192,37.640 157.683,37.200 158.000 C 36.760 158.317,36.400 158.956,36.400 159.421 C 36.400 159.912,35.982 160.489,35.400 160.800 C 34.850 161.094,34.400 161.631,34.400 161.992 C 34.400 162.354,34.040 163.036,33.600 163.508 C 33.160 163.980,32.800 164.566,32.800 164.810 C 32.800 165.054,32.170 165.848,31.400 166.574 C 30.630 167.300,30.000 168.188,30.000 168.547 C 30.000 168.906,29.841 169.200,29.646 169.200 C 29.451 169.200,29.012 169.785,28.671 170.500 C 28.329 171.215,27.679 172.065,27.225 172.388 C 26.771 172.712,26.400 173.387,26.400 173.888 C 26.400 174.390,26.220 174.800,26.000 174.800 C 25.780 174.800,25.600 175.160,25.600 175.600 C 25.600 176.133,25.333 176.400,24.800 176.400 C 24.178 176.400,24.000 176.133,24.000 175.200 C 24.000 174.540,24.180 174.000,24.400 174.000 C 24.620 174.000,24.800 173.010,24.800 171.800 C 24.800 170.590,24.980 169.600,25.200 169.600 C 25.420 169.600,25.600 168.790,25.600 167.800 C 25.600 166.810,25.780 166.000,26.000 166.000 C 26.220 166.000,26.400 165.274,26.400 164.387 C 26.400 163.323,26.604 162.697,27.000 162.545 C 27.370 162.403,27.600 161.795,27.600 160.957 C 27.600 160.211,27.780 159.600,28.000 159.600 C 28.220 159.600,28.400 158.970,28.400 158.200 C 28.400 157.430,28.580 156.800,28.800 156.800 C 29.020 156.800,29.200 156.378,29.200 155.861 C 29.200 154.744,30.303 152.400,30.829 152.400 C 31.033 152.400,31.200 151.770,31.200 151.000 C 31.200 150.230,31.380 149.600,31.600 149.600 C 31.820 149.600,32.000 149.071,32.000 148.424 C 32.000 147.777,32.180 147.136,32.400 147.000 C 32.620 146.864,32.800 146.223,32.800 145.576 C 32.800 144.929,32.980 144.400,33.200 144.400 C 33.420 144.400,33.600 144.034,33.600 143.587 C 33.600 143.141,33.870 142.671,34.200 142.545 C 34.530 142.418,34.800 141.974,34.800 141.557 C 34.800 141.141,34.980 140.800,35.200 140.800 C 35.420 140.800,35.600 140.350,35.600 139.800 C 35.600 139.250,35.780 138.800,36.000 138.800 C 36.220 138.800,36.400 138.378,36.400 137.861 C 36.400 136.744,37.503 134.400,38.029 134.400 C 38.233 134.400,38.400 134.051,38.400 133.624 C 38.400 133.197,38.580 132.736,38.800 132.600 C 39.020 132.464,39.200 132.076,39.200 131.737 C 39.200 131.033,41.446 128.800,42.154 128.800 C 42.412 128.800,42.883 128.440,43.200 128.000 C 43.517 127.560,44.187 127.200,44.688 127.200 C 45.190 127.200,45.600 127.020,45.600 126.800 C 45.600 126.580,45.941 126.400,46.357 126.400 C 46.774 126.400,47.218 126.130,47.345 125.800 C 47.471 125.470,47.941 125.200,48.387 125.200 C 48.834 125.200,49.200 125.020,49.200 124.800 C 49.200 124.580,48.570 124.400,47.800 124.400 C 46.790 124.400,46.400 124.224,46.400 123.767 C 46.400 122.980,51.424 118.000,52.218 118.000 C 52.538 118.000,52.800 117.820,52.800 117.600 C 52.800 117.380,52.530 117.200,52.200 117.200 C 51.870 117.200,51.600 117.380,51.600 117.600 C 51.600 117.820,51.240 118.000,50.800 118.000 C 50.360 118.000,50.000 118.161,50.000 118.357 C 50.000 118.886,48.795 119.252,47.944 118.982 C 46.776 118.611,47.040 118.018,49.400 115.714 C 50.610 114.533,51.600 113.214,51.600 112.783 C 51.600 112.352,51.793 112.000,52.029 112.000 C 52.489 112.000,53.600 111.017,53.600 110.610 C 53.600 110.196,55.536 108.400,55.982 108.400 C 56.212 108.400,56.400 108.220,56.400 108.000 C 56.400 107.780,56.661 107.600,56.981 107.600 C 57.300 107.600,58.173 106.970,58.921 106.200 C 59.669 105.430,60.578 104.800,60.940 104.800 C 61.303 104.800,61.600 104.620,61.600 104.400 C 61.600 104.180,61.935 104.000,62.344 104.000 C 62.753 104.000,63.426 103.550,63.839 103.000 C 64.252 102.450,64.907 102.000,65.295 102.000 C 65.683 102.000,66.000 101.820,66.000 101.600 C 66.000 101.380,66.450 101.200,67.000 101.200 C 67.550 101.200,68.000 101.020,68.000 100.800 C 68.000 100.580,68.546 100.400,69.213 100.400 C 69.921 100.400,70.521 100.151,70.655 99.800 C 70.782 99.470,71.226 99.200,71.643 99.200 C 72.059 99.200,72.400 99.020,72.400 98.800 C 72.400 98.580,72.850 98.400,73.400 98.400 C 73.950 98.400,74.400 98.220,74.400 98.000 C 74.400 97.780,74.940 97.600,75.600 97.600 C 76.260 97.600,76.800 97.420,76.800 97.200 C 76.800 96.980,77.250 96.800,77.800 96.800 C 78.422 96.800,78.800 96.573,78.800 96.200 C 78.800 95.870,79.149 95.600,79.576 95.600 C 80.003 95.600,80.464 95.420,80.600 95.200 C 80.736 94.980,81.197 94.800,81.624 94.800 C 82.051 94.800,82.400 94.620,82.400 94.400 C 82.400 94.180,82.760 94.000,83.200 94.000 C 83.640 94.000,84.000 93.820,84.000 93.600 C 84.000 93.380,84.450 93.200,85.000 93.200 C 85.622 93.200,86.000 92.973,86.000 92.600 C 86.000 92.270,86.324 92.000,86.720 92.000 C 87.804 92.000,88.400 91.191,88.400 89.720 L 88.400 88.400 85.200 88.400 C 83.333 88.400,82.000 88.567,82.000 88.800 C 82.000 89.020,81.659 89.200,81.243 89.200 C 80.826 89.200,80.382 89.470,80.255 89.800 C 80.129 90.130,79.659 90.400,79.213 90.400 C 78.766 90.400,78.400 90.580,78.400 90.800 C 78.400 91.020,78.040 91.200,77.600 91.200 C 77.160 91.200,76.800 91.380,76.800 91.600 C 76.800 91.820,76.451 92.000,76.024 92.000 C 75.597 92.000,75.136 92.180,75.000 92.400 C 74.864 92.620,74.474 92.800,74.134 92.800 C 73.794 92.800,73.161 93.250,72.729 93.800 C 72.296 94.350,71.595 94.800,71.171 94.800 C 70.747 94.800,70.400 94.980,70.400 95.200 C 70.400 95.420,70.106 95.600,69.746 95.600 C 69.386 95.600,68.675 96.050,68.165 96.600 C 67.655 97.150,66.999 97.600,66.707 97.600 C 66.415 97.600,65.917 97.960,65.600 98.400 C 64.913 99.353,63.600 99.463,63.600 98.568 C 63.600 97.862,68.090 93.200,68.770 93.200 C 69.009 93.200,70.003 92.390,70.979 91.400 C 71.955 90.410,72.991 89.600,73.281 89.600 C 73.570 89.600,74.346 88.974,75.004 88.209 C 75.662 87.443,76.562 86.813,77.005 86.809 C 77.448 86.804,78.148 86.350,78.561 85.800 C 78.974 85.250,79.529 84.800,79.794 84.800 C 80.059 84.800,80.602 84.440,81.000 84.000 C 81.398 83.560,82.013 83.200,82.367 83.200 C 82.721 83.200,83.348 82.750,83.761 82.200 C 84.174 81.650,84.807 81.200,85.168 81.200 C 85.528 81.200,86.083 80.840,86.400 80.400 C 86.717 79.960,87.286 79.600,87.665 79.600 C 88.043 79.600,88.464 79.420,88.600 79.200 C 88.736 78.980,89.197 78.800,89.624 78.800 C 90.051 78.800,90.400 78.633,90.400 78.429 C 90.400 78.002,92.659 76.800,93.461 76.800 C 93.758 76.800,94.000 76.620,94.000 76.400 C 94.000 76.180,94.349 76.000,94.776 76.000 C 95.203 76.000,95.664 75.820,95.800 75.600 C 95.936 75.380,96.397 75.200,96.824 75.200 C 97.251 75.200,97.600 75.033,97.600 74.829 C 97.600 74.402,99.859 73.200,100.661 73.200 C 100.958 73.200,101.200 73.020,101.200 72.800 C 101.200 72.580,101.549 72.400,101.976 72.400 C 102.403 72.400,102.864 72.220,103.000 72.000 C 103.136 71.780,103.597 71.600,104.024 71.600 C 104.451 71.600,104.800 71.433,104.800 71.229 C 104.800 70.802,107.059 69.600,107.861 69.600 C 108.158 69.600,108.400 69.420,108.400 69.200 C 108.400 68.980,108.726 68.800,109.125 68.800 C 109.523 68.800,110.283 68.395,110.812 67.900 C 111.846 66.935,113.450 66.000,114.074 66.000 C 114.489 66.000,115.600 65.001,115.600 64.629 C 115.600 64.503,115.330 64.400,115.000 64.400 C 114.670 64.400,114.400 64.580,114.400 64.800 C 114.400 65.020,113.871 65.200,113.224 65.200 C 112.577 65.200,111.936 65.380,111.800 65.600 C 111.664 65.820,111.203 66.000,110.776 66.000 C 110.349 66.000,110.000 66.180,110.000 66.400 C 110.000 66.620,109.640 66.800,109.200 66.800 C 108.760 66.800,108.400 66.980,108.400 67.200 C 108.400 67.420,107.950 67.600,107.400 67.600 C 106.778 67.600,106.400 67.827,106.400 68.200 C 106.400 68.530,106.051 68.800,105.624 68.800 C 105.197 68.800,104.736 68.980,104.600 69.200 C 104.464 69.420,104.003 69.600,103.576 69.600 C 103.149 69.600,102.800 69.780,102.800 70.000 C 102.800 70.220,102.440 70.400,102.000 70.400 C 101.560 70.400,101.200 70.580,101.200 70.800 C 101.200 71.020,100.750 71.200,100.200 71.200 C 99.578 71.200,99.200 71.427,99.200 71.800 C 99.200 72.130,98.851 72.400,98.424 72.400 C 97.997 72.400,97.536 72.580,97.400 72.800 C 97.264 73.020,96.803 73.200,96.376 73.200 C 95.949 73.200,95.600 73.380,95.600 73.600 C 95.600 73.820,95.240 74.000,94.800 74.000 C 94.360 74.000,94.000 74.180,94.000 74.400 C 94.000 74.620,93.550 74.800,93.000 74.800 C 92.378 74.800,92.000 75.027,92.000 75.400 C 92.000 75.730,91.651 76.000,91.224 76.000 C 90.797 76.000,90.336 76.180,90.200 76.400 C 90.064 76.620,89.643 76.800,89.265 76.800 C 88.886 76.800,88.317 77.160,88.000 77.600 C 87.683 78.040,87.097 78.400,86.699 78.400 C 86.301 78.400,85.871 78.670,85.745 79.000 C 85.618 79.330,85.174 79.600,84.757 79.600 C 84.341 79.600,84.000 79.780,84.000 80.000 C 84.000 80.220,83.590 80.400,83.088 80.400 C 82.587 80.400,81.917 80.760,81.600 81.200 C 81.283 81.640,80.785 82.000,80.493 82.000 C 80.201 82.000,79.545 82.450,79.035 83.000 C 78.525 83.550,77.854 84.000,77.542 84.000 C 77.231 84.000,76.717 84.360,76.400 84.800 C 76.083 85.240,75.413 85.600,74.912 85.600 C 74.410 85.600,74.000 85.801,74.000 86.046 C 74.000 86.621,71.192 89.200,70.566 89.200 C 70.304 89.200,68.029 91.270,65.510 93.800 C 60.888 98.444,60.000 99.056,60.000 97.600 C 60.000 97.160,60.180 96.800,60.400 96.800 C 60.620 96.800,60.800 96.530,60.800 96.200 C 60.800 95.870,60.980 95.600,61.200 95.600 C 61.420 95.600,61.600 95.317,61.600 94.971 C 61.600 94.253,62.534 93.200,63.171 93.200 C 63.407 93.200,63.600 92.930,63.600 92.600 C 63.600 92.270,63.780 92.000,64.000 92.000 C 64.220 92.000,64.400 91.715,64.400 91.367 C 64.400 91.018,65.030 90.121,65.800 89.374 C 66.570 88.626,67.200 87.810,67.200 87.560 C 67.200 87.310,68.370 85.958,69.800 84.556 C 71.230 83.154,72.400 81.722,72.400 81.375 C 72.400 80.704,73.318 79.600,73.876 79.600 C 74.060 79.600,74.557 79.139,74.980 78.575 C 76.472 76.588,77.100 76.000,77.730 76.000 C 78.080 76.000,80.417 73.930,82.924 71.400 C 85.430 68.870,87.706 66.800,87.980 66.800 C 88.255 66.800,88.983 66.260,89.600 65.600 C 90.217 64.940,90.986 64.400,91.310 64.400 C 91.633 64.400,92.436 63.770,93.094 63.000 C 93.752 62.230,94.566 61.600,94.903 61.600 C 95.240 61.600,95.940 61.153,96.458 60.607 C 96.976 60.061,97.597 59.611,97.838 59.607 C 98.079 59.603,98.602 59.240,99.000 58.800 C 99.398 58.360,99.974 58.000,100.280 58.000 C 100.586 58.000,101.286 57.550,101.836 57.000 C 102.386 56.450,103.058 56.000,103.330 56.000 C 103.601 56.000,104.083 55.640,104.400 55.200 C 104.717 54.760,105.286 54.400,105.665 54.400 C 106.043 54.400,106.464 54.220,106.600 54.000 C 106.736 53.780,107.197 53.600,107.624 53.600 C 108.051 53.600,108.400 53.420,108.400 53.200 C 108.400 52.980,108.741 52.800,109.157 52.800 C 109.574 52.800,110.018 52.530,110.145 52.200 C 110.271 51.870,110.741 51.600,111.187 51.600 C 111.634 51.600,112.000 51.420,112.000 51.200 C 112.000 50.980,112.349 50.800,112.776 50.800 C 113.203 50.800,113.664 50.620,113.800 50.400 C 113.936 50.180,114.354 50.000,114.729 50.000 C 115.103 50.000,115.748 49.550,116.161 49.000 C 116.574 48.450,117.247 48.000,117.656 48.000 C 118.065 48.000,118.400 47.820,118.400 47.600 C 118.400 47.380,118.929 47.200,119.576 47.200 C 120.223 47.200,120.864 47.020,121.000 46.800 C 121.136 46.580,121.777 46.400,122.424 46.400 C 123.071 46.400,123.600 46.220,123.600 46.000 C 123.600 45.758,125.333 45.600,128.000 45.600 C 130.667 45.600,132.400 45.758,132.400 46.000 C 132.400 46.220,133.379 46.400,134.576 46.400 C 135.773 46.400,136.864 46.580,137.000 46.800 C 137.136 47.020,137.946 47.200,138.800 47.200 C 139.654 47.200,140.464 47.380,140.600 47.600 C 140.736 47.820,141.467 48.000,142.224 48.000 C 142.981 48.000,143.600 47.820,143.600 47.600 C 143.600 47.380,143.150 47.200,142.600 47.200 C 142.050 47.200,141.600 47.020,141.600 46.800 C 141.600 46.580,141.054 46.400,140.387 46.400 C 139.679 46.400,139.079 46.151,138.945 45.800 C 138.813 45.458,138.217 45.200,137.557 45.200 C 136.921 45.200,136.400 45.020,136.400 44.800 C 136.400 44.580,135.770 44.400,135.000 44.400 C 133.867 44.400,133.600 44.248,133.600 43.600 C 133.600 42.853,133.867 42.800,137.600 42.800 C 140.000 42.800,141.600 42.640,141.600 42.400 C 141.600 42.180,142.410 42.000,143.400 42.000 C 144.390 42.000,145.200 42.180,145.200 42.400 C 145.200 42.644,147.059 42.800,149.976 42.800 C 152.729 42.800,154.858 42.969,155.000 43.200 C 155.136 43.420,156.126 43.600,157.200 43.600 C 158.274 43.600,159.264 43.780,159.400 44.000 C 159.536 44.220,160.542 44.400,161.636 44.400 C 163.035 44.400,163.693 44.578,163.855 45.000 C 164.012 45.407,164.650 45.600,165.843 45.600 C 166.809 45.600,167.600 45.780,167.600 46.000 C 167.600 46.220,168.230 46.400,169.000 46.400 C 169.770 46.400,170.400 46.580,170.400 46.800 C 170.400 47.020,171.109 47.200,171.976 47.200 C 172.843 47.200,173.664 47.380,173.800 47.600 C 173.936 47.820,174.557 48.000,175.181 48.000 C 175.819 48.000,176.415 48.262,176.545 48.600 C 176.677 48.944,177.274 49.200,177.945 49.200 C 178.615 49.200,179.213 48.944,179.345 48.600 C 179.471 48.270,179.941 48.000,180.387 48.000 C 180.834 48.000,181.200 47.908,181.200 47.797 C 181.200 47.222,178.968 45.200,178.334 45.200 C 177.930 45.200,177.600 45.020,177.600 44.800 C 177.600 44.580,176.790 44.400,175.800 44.400 C 174.810 44.400,174.000 44.220,174.000 44.000 C 174.000 43.780,173.190 43.600,172.200 43.600 C 171.210 43.600,170.400 43.420,170.400 43.200 C 170.400 42.980,169.494 42.800,168.387 42.800 C 166.968 42.800,166.307 42.623,166.145 42.200 C 165.956 41.708,164.950 41.600,160.557 41.600 C 157.252 41.600,155.200 41.447,155.200 41.200 C 155.200 40.957,153.400 40.800,150.600 40.800 C 147.800 40.800,146.000 40.643,146.000 40.400 C 146.000 40.169,144.733 40.000,143.000 40.000 C 140.267 40.000,140.000 39.929,140.000 39.200 C 140.000 38.584,140.267 38.400,141.157 38.400 C 141.817 38.400,142.413 38.142,142.545 37.800 C 142.679 37.449,143.279 37.200,143.987 37.200 C 144.654 37.200,145.200 37.020,145.200 36.800 C 145.200 36.580,145.830 36.400,146.600 36.400 C 147.370 36.400,148.000 36.220,148.000 36.000 C 148.000 35.780,148.810 35.600,149.800 35.600 C 150.790 35.600,151.600 35.420,151.600 35.200 C 151.600 34.980,152.410 34.800,153.400 34.800 C 154.733 34.800,155.200 34.644,155.200 34.200 C 155.200 33.739,155.711 33.600,157.400 33.600 C 158.610 33.600,159.600 33.420,159.600 33.200 C 159.600 32.967,160.933 32.800,162.800 32.800 C 164.667 32.800,166.000 32.633,166.000 32.400 C 166.000 32.180,166.990 32.000,168.200 32.000 C 169.410 32.000,170.400 31.820,170.400 31.600 C 170.400 31.360,171.986 31.200,174.357 31.200 C 177.506 31.200,178.361 31.077,178.545 30.600 C 179.000 29.414,187.707 29.759,188.639 31.000 M202.655 34.200 C 202.782 34.530,203.046 34.800,203.243 34.800 C 203.439 34.800,203.600 34.530,203.600 34.200 C 203.600 33.870,203.336 33.600,203.013 33.600 C 202.655 33.600,202.515 33.835,202.655 34.200 M36.400 272.800 C 36.400 273.333,36.133 273.600,35.600 273.600 C 35.067 273.600,34.800 273.333,34.800 272.800 C 34.800 272.267,35.067 272.000,35.600 272.000 C 36.133 272.000,36.400 272.267,36.400 272.800 M255.600 365.600 C 255.600 365.820,255.870 366.000,256.200 366.000 C 256.530 366.000,256.800 365.820,256.800 365.600 C 256.800 365.380,256.530 365.200,256.200 365.200 C 255.870 365.200,255.600 365.380,255.600 365.600 M174.000 378.613 C 174.000 378.949,173.718 379.333,173.373 379.466 C 172.621 379.754,171.800 379.046,172.178 378.435 C 172.586 377.776,174.000 377.913,174.000 378.613 \" stroke=\"none\" fill=\"#000000\" fill-rule=\"evenodd\"></path><path id=\"path2\" d=\"\" stroke=\"none\" fill=\"#080404\" fill-rule=\"evenodd\"></path></g></svg>");
INSERT INTO `wp_464683_postmeta` VALUES("575", "378", "_wp_attached_file", "2019/11/p411.svg");
INSERT INTO `wp_464683_postmeta` VALUES("576", "378", "_wp_attachment_metadata", "a:2:{s:5:\"width\";d:118.599999999999994315658113919198513031005859375;s:6:\"height\";d:156.30000000000001136868377216160297393798828125;}");
INSERT INTO `wp_464683_postmeta` VALUES("577", "378", "_elementor_inline_svg", "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<!-- Generator: Adobe Illustrator 22.1.0, SVG Export Plug-In . SVG Version: 6.00 Build 0)  -->\n<svg version=\"1.1\" id=\"Layer_1\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" x=\"0px\" y=\"0px\"\n	 width=\"118.6px\" height=\"156.3px\" viewBox=\"0 0 118.6 156.3\" style=\"enable-background:new 0 0 118.6 156.3;\" xml:space=\"preserve\"\n	>\n<style type=\"text/css\">\n	.st0{fill:#FFFFFF;}\n	.st1{enable-background:new    ;}\n</style>\n<g>\n	<path class=\"st0\" d=\"M25.7,127.2v-8.8l-3.9,7.7H21l-3.9-7.7v8.8H16v-10.7h1.5l3.9,7.7l3.9-7.7h1.5v10.7H25.7z\"/>\n	<path class=\"st0\" d=\"M32.8,117.7v3.5h5.4v1.2h-5.4v3.7H39v1.2h-7.4v-10.7h7.2v1.2L32.8,117.7L32.8,117.7z\"/>\n	<path class=\"st0\" d=\"M52.7,127.2v-8.8l-3.9,7.7H48l-3.9-7.7v8.8H43v-10.7h1.5l3.9,7.7l3.9-7.7h1.5v10.7H52.7z\"/>\n	<path class=\"st0\" d=\"M63.1,116.5c2.1,0,3.4,1,3.4,2.7c0,1.2-0.7,2.1-2,2.4c1.5,0.2,2.4,1.2,2.4,2.7c0,1.8-1.4,2.9-3.8,2.9h-4.6\n		v-10.7H63.1z M59.8,121.1H63c1.4,0,2.3-0.6,2.3-1.7s-0.8-1.7-2.3-1.7h-3.2C59.8,117.7,59.8,121.1,59.8,121.1z M59.8,126H63\n		c1.7,0,2.7-0.7,2.7-1.9c0-1.2-1-1.8-2.7-1.8h-3.2C59.8,122.3,59.8,126,59.8,126z\"/>\n	<path class=\"st0\" d=\"M72.2,117.7v3.5h5.4v1.2h-5.4v3.7h6.2v1.2H71v-10.7h7.2v1.2L72.2,117.7L72.2,117.7z\"/>\n	<path class=\"st0\" d=\"M87.2,123.8c-0.2,0-0.5,0-0.7,0h-2.8v3.4h-1.2v-10.7h4.1c2.7,0,4.2,1.3,4.2,3.6c0,1.8-0.9,3-2.4,3.5l2.5,3.6\n		h-1.4L87.2,123.8z M86.5,122.6c1.9,0,3-0.9,3-2.5s-1.1-2.4-3-2.4h-2.8v5L86.5,122.6L86.5,122.6z\"/>\n	<path class=\"st0\" d=\"M101.6,117.4l-0.5,1.1c-1-0.6-2.1-0.9-2.9-0.9c-1.4,0-2.3,0.5-2.3,1.4c0,2.7,6,1.3,6,5.2\n		c0,1.8-1.6,2.9-3.9,2.9c-1.6,0-3.1-0.7-4.1-1.6l0.5-1.1c1,1,2.3,1.5,3.6,1.5c1.5,0,2.5-0.6,2.5-1.6c0-2.8-6-1.3-6-5.1\n		c0-1.7,1.5-2.8,3.7-2.8C99.4,116.5,100.7,116.8,101.6,117.4z\"/>\n	<path class=\"st0\" d=\"M24.6,143.5l-2.9-9l-2.9,9h-1.2L14,132.8h1.3l2.9,9.3l2.9-9.2h1.2l2.9,9.3l2.9-9.3h1.3l-3.6,10.7h-1.2\n		C24.6,143.6,24.6,143.5,24.6,143.5z\"/>\n	<path class=\"st0\" d=\"M33.8,134v3.5h5.4v1.2h-5.4v3.7H40v1.2h-7.4v-10.7h7.2v1.2L33.8,134L33.8,134z\"/>\n	<path class=\"st0\" d=\"M49.9,142.3v1.2H44v-10.7h1.2v9.5H49.9z\"/>\n	<path class=\"st0\" d=\"M61.9,134.3l-0.7,0.9c-0.8-0.8-2-1.3-3.2-1.3c-2.4,0-4.3,1.9-4.3,4.2s1.9,4.2,4.3,4.2c1.2,0,2.3-0.5,3.2-1.3\n		l0.7,0.8c-1.1,1-2.5,1.6-4,1.6c-3.1,0-5.5-2.4-5.5-5.4s2.5-5.4,5.6-5.4C59.4,132.8,60.9,133.4,61.9,134.3z\"/>\n	<path class=\"st0\" d=\"M75.5,138.1c0,3-2.5,5.4-5.6,5.4s-5.6-2.4-5.6-5.4s2.5-5.4,5.6-5.4C73.1,132.8,75.5,135.1,75.5,138.1z\n		 M65.6,138.1c0,2.3,2,4.2,4.4,4.2s4.3-1.9,4.3-4.2s-2-4.2-4.3-4.2S65.6,135.8,65.6,138.1z\"/>\n	<path class=\"st0\" d=\"M88.9,143.5v-8.8l-3.9,7.7h-0.7l-3.9-7.7v8.8h-1.2v-10.7h1.5l3.9,7.7l3.9-7.7H90v10.7H88.9z\"/>\n	<path class=\"st0\" d=\"M96.1,134v3.5h5.4v1.2h-5.4v3.7h6.2v1.2h-7.4v-10.7h7.2v1.2L96.1,134L96.1,134z\"/>\n</g>\n<g class=\"st1\">\n	<path class=\"st0\" d=\"M19.3,38.7h-2.4V14.3h3.8c2.7,0,4.1,1.9,4.1,5.6v1c0,3.7-1.3,5.6-4,5.6h-1.4v12.2H19.3z M20.6,24.1\n		c1.1,0,1.6-0.5,1.6-1.6v-4c0-1.1-0.5-1.6-1.6-1.6h-1.3v7.3h1.3V24.1z\"/>\n	<path class=\"st0\" d=\"M29.6,38.7h-2.4V14.3H31c2.7,0,4.1,1.7,4.1,5.1v2.7c0,2.2-0.6,3.8-1.9,4.8L35,38.7h-2.5L31,27.5h-1.3v11.2\n		H29.6z M31,25c1.1,0,1.6-0.5,1.6-1.6v-5c0-1.1-0.5-1.6-1.6-1.6h-1.3V25H31z\"/>\n	<path class=\"st0\" d=\"M39.9,36.3h3.8v2.4h-6.2V14.3h6.2v2.4h-3.8V25H42v2.4h-2.1V36.3z\"/>\n	<path class=\"st0\" d=\"M48.7,38.7h-2.4V14.3h6.2v2.4h-3.8V25h2.1v2.4h-2.1V38.7z\"/>\n	<path class=\"st0\" d=\"M57.3,36.3H61v2.4h-6.2V14.3H61v2.4h-3.8V25h2.1v2.4h-2.1L57.3,36.3L57.3,36.3z\"/>\n	<path class=\"st0\" d=\"M66,38.7h-2.4V14.3h3.8c2.7,0,4.1,1.7,4.1,5.1v2.7c0,2.2-0.6,3.8-1.9,4.8l1.8,11.8h-2.5l-1.5-11.2H66V38.7z\n		 M67.4,25c1.1,0,1.6-0.5,1.6-1.6v-5c0-1.1-0.5-1.6-1.6-1.6H66V25H67.4z\"/>\n	<path class=\"st0\" d=\"M76.3,38.7h-2.4V14.3h3.8c2.7,0,4.1,1.7,4.1,5.1v2.7c0,2.2-0.6,3.8-1.9,4.8l1.8,11.8h-2.5l-1.5-11.2h-1.3\n		L76.3,38.7L76.3,38.7z M77.7,25c1.1,0,1.6-0.5,1.6-1.6v-5c0-1.1-0.5-1.6-1.6-1.6h-1.3V25H77.7z\"/>\n	<path class=\"st0\" d=\"M86.6,36.3h3.8v2.4h-6.2V14.3h6.2v2.4h-3.8V25h2.1v2.4h-2.1V36.3z\"/>\n	<path class=\"st0\" d=\"M100.2,33.3c0,3.6-1.2,5.4-3.7,5.4h-3.7V14.3h3.7c2.4,0,3.7,1.8,3.7,5.4V33.3z M97.8,18.2c0-1-0.4-1.4-1.2-1.4\n		h-1.2v19.5h1.2c0.8,0,1.2-0.5,1.2-1.4V18.2z\"/>\n</g>\n<g class=\"st1\">\n	<path class=\"st0\" d=\"M34.3,84.7l11.6-39.1h5.3V85H54v5.7h-2.9v11.2h-5.3V90.7H34.3V84.7z M39.6,85h6.2V61.4l-1.6,6.8L39.6,85z\"/>\n	<path class=\"st0\" d=\"M56.1,51.2c2,0,3-1.4,3-4.3v-1.3h5.7v56.3h-5.7V56.8h-3C56.1,56.8,56.1,51.2,56.1,51.2z\"/>\n	<path class=\"st0\" d=\"M68.2,51.2c2,0,3-1.4,3-4.3v-1.3h5.7v56.3h-5.7V56.8h-3V51.2z\"/>\n</g>\n</svg>\n");
INSERT INTO `wp_464683_postmeta` VALUES("578", "379", "_wp_attached_file", "2019/11/Rhombus_200x6.svg");
INSERT INTO `wp_464683_postmeta` VALUES("579", "379", "_wp_attachment_metadata", "a:2:{s:5:\"width\";d:1000;s:6:\"height\";d:50;}");
INSERT INTO `wp_464683_postmeta` VALUES("580", "379", "_elementor_inline_svg", "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<svg xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" width=\"1000pt\" height=\"50pt\" viewBox=\"0 0 1000 50\" version=\"1.1\">\n<g id=\"surface1\">\n<path style=\" stroke:none;fill-rule:nonzero;fill:rgb(0%,0%,0%);fill-opacity:1;\" d=\"M 500 10 L 1000 25 L 500 40 L 0 25 Z M 500 10 \"/>\n</g>\n</svg>\n");
INSERT INTO `wp_464683_postmeta` VALUES("616", "385", "_edit_last", "1");
INSERT INTO `wp_464683_postmeta` VALUES("617", "385", "_edit_lock", "1573315307:1");
INSERT INTO `wp_464683_postmeta` VALUES("618", "385", "_elementor_controls_usage", "a:0:{}");
INSERT INTO `wp_464683_postmeta` VALUES("1183", "287", "_elementor_controls_usage", "a:11:{s:16:\"heading-extended\";a:3:{s:5:\"count\";i:1;s:15:\"control_percent\";i:9;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:13:\"section_title\";a:3:{s:5:\"title\";i:1;s:5:\"align\";i:1;s:12:\"align_mobile\";i:1;}}s:5:\"style\";a:3:{s:18:\"section_title_fill\";a:1:{s:11:\"title_color\";i:1;}s:18:\"section_title_type\";a:8:{s:21:\"typography_typography\";i:1;s:22:\"typography_font_family\";i:1;s:20:\"typography_font_size\";i:1;s:27:\"typography_font_size_mobile\";i:1;s:22:\"typography_font_weight\";i:1;s:21:\"typography_font_style\";i:1;s:22:\"typography_line_height\";i:1;s:25:\"typography_letter_spacing\";i:1;}s:20:\"section_title_shadow\";a:6:{s:37:\"title_classic_shadow_text_shadow_type\";i:1;s:32:\"title_classic_shadow_text_shadow\";i:1;s:24:\"title_long_shadow_enable\";i:1;s:23:\"title_long_shadow_color\";i:1;s:22:\"title_long_shadow_size\";i:1;s:27:\"title_long_shadow_direction\";i:1;}}s:8:\"advanced\";a:5:{s:14:\"_section_style\";a:4:{s:7:\"_margin\";i:1;s:14:\"_margin_mobile\";i:1;s:8:\"_padding\";i:1;s:12:\"_css_classes\";i:1;}s:15:\"section_effects\";a:2:{s:17:\"_animation_mobile\";i:1;s:18:\"animation_duration\";i:1;}s:19:\"_section_background\";a:1:{s:22:\"_background_background\";i:1;}s:15:\"_section_border\";a:1:{s:14:\"_border_radius\";i:1;}s:33:\"section_elementor_extras_advanced\";a:3:{s:13:\"sticky_enable\";i:1;s:13:\"sticky_offset\";i:1;s:20:\"sticky_offset_bottom\";i:1;}}}}s:6:\"column\";a:3:{s:5:\"count\";i:12;s:15:\"control_percent\";i:0;s:8:\"controls\";a:2:{s:6:\"layout\";a:1:{s:6:\"layout\";a:6:{s:19:\"_inline_size_tablet\";i:2;s:16:\"content_position\";i:2;s:23:\"content_position_mobile\";i:1;s:21:\"space_between_widgets\";i:5;s:12:\"_inline_size\";i:3;s:19:\"_inline_size_mobile\";i:1;}}s:8:\"advanced\";a:2:{s:16:\"section_advanced\";a:6:{s:13:\"margin_mobile\";i:5;s:14:\"padding_mobile\";i:7;s:7:\"padding\";i:6;s:6:\"margin\";i:8;s:13:\"margin_tablet\";i:1;s:14:\"padding_tablet\";i:3;}s:15:\"section_effects\";a:1:{s:16:\"animation_mobile\";i:1;}}}}s:7:\"section\";a:3:{s:5:\"count\";i:12;s:15:\"control_percent\";i:4;s:8:\"controls\";a:3:{s:6:\"layout\";a:2:{s:14:\"section_layout\";a:9:{s:6:\"layout\";i:8;s:6:\"height\";i:2;s:13:\"custom_height\";i:2;s:20:\"custom_height_mobile\";i:2;s:15:\"column_position\";i:2;s:3:\"gap\";i:7;s:20:\"custom_height_tablet\";i:2;s:15:\"stretch_section\";i:5;s:16:\"content_position\";i:5;}s:16:\"section_parallax\";a:1:{s:24:\"jet_parallax_layout_list\";i:12;}}s:5:\"style\";a:4:{s:18:\"section_background\";a:15:{s:21:\"background_background\";i:9;s:21:\"background_attachment\";i:2;s:17:\"background_repeat\";i:3;s:15:\"background_size\";i:3;s:19:\"background_position\";i:2;s:26:\"background_position_mobile\";i:2;s:24:\"background_repeat_mobile\";i:2;s:22:\"background_size_mobile\";i:2;s:23:\"background_image_tablet\";i:1;s:24:\"background_repeat_tablet\";i:2;s:22:\"background_size_tablet\";i:2;s:38:\"background_motion_fx_translateX_effect\";i:1;s:37:\"background_motion_fx_translateX_speed\";i:1;s:32:\"background_motion_fx_scale_speed\";i:1;s:16:\"background_color\";i:9;}s:26:\"section_background_overlay\";a:18:{s:29:\"background_overlay_background\";i:9;s:27:\"background_overlay_position\";i:4;s:29:\"background_overlay_attachment\";i:4;s:25:\"background_overlay_repeat\";i:4;s:23:\"background_overlay_size\";i:4;s:26:\"background_overlay_opacity\";i:4;s:24:\"background_overlay_image\";i:9;s:31:\"background_overlay_image_mobile\";i:4;s:31:\"background_overlay_image_tablet\";i:3;s:34:\"background_overlay_position_mobile\";i:3;s:32:\"background_overlay_repeat_mobile\";i:3;s:30:\"background_overlay_size_mobile\";i:3;s:30:\"background_overlay_xpos_mobile\";i:1;s:22:\"css_filters_css_filter\";i:1;s:22:\"css_filters_brightness\";i:1;s:20:\"css_filters_saturate\";i:1;s:34:\"background_overlay_position_tablet\";i:1;s:23:\"background_overlay_ypos\";i:1;}s:14:\"section_border\";a:4:{s:13:\"border_border\";i:6;s:12:\"border_width\";i:8;s:12:\"border_color\";i:8;s:13:\"border_radius\";i:1;}s:21:\"section_shape_divider\";a:5:{s:23:\"shape_divider_top_color\";i:1;s:23:\"shape_divider_top_width\";i:1;s:24:\"shape_divider_top_height\";i:1;s:26:\"shape_divider_top_negative\";i:1;s:31:\"shape_divider_top_above_content\";i:1;}}s:8:\"advanced\";a:3:{s:16:\"section_advanced\";a:7:{s:11:\"css_classes\";i:1;s:13:\"margin_mobile\";i:10;s:6:\"margin\";i:9;s:7:\"padding\";i:8;s:14:\"padding_mobile\";i:10;s:14:\"padding_tablet\";i:3;s:13:\"margin_tablet\";i:1;}s:15:\"section_effects\";a:2:{s:9:\"animation\";i:1;s:18:\"animation_duration\";i:1;}s:18:\"section_custom_css\";a:1:{s:10:\"custom_css\";i:2;}}}}s:7:\"heading\";a:3:{s:5:\"count\";i:8;s:15:\"control_percent\";i:5;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:13:\"section_title\";a:4:{s:5:\"title\";i:8;s:5:\"align\";i:8;s:12:\"align_mobile\";i:1;s:11:\"header_size\";i:1;}}s:5:\"style\";a:1:{s:19:\"section_title_style\";a:12:{s:11:\"title_color\";i:8;s:21:\"typography_typography\";i:8;s:22:\"typography_font_family\";i:8;s:20:\"typography_font_size\";i:8;s:22:\"typography_font_weight\";i:8;s:27:\"typography_font_size_mobile\";i:8;s:25:\"typography_text_transform\";i:6;s:28:\"text_shadow_text_shadow_type\";i:6;s:23:\"text_shadow_text_shadow\";i:6;s:27:\"typography_font_size_tablet\";i:6;s:29:\"typography_line_height_mobile\";i:1;s:22:\"typography_line_height\";i:1;}}s:8:\"advanced\";a:2:{s:14:\"_section_style\";a:4:{s:8:\"_padding\";i:7;s:7:\"_margin\";i:8;s:15:\"_padding_tablet\";i:1;s:15:\"_padding_mobile\";i:1;}s:19:\"_section_background\";a:1:{s:22:\"_background_background\";i:1;}}}}s:11:\"text-editor\";a:3:{s:5:\"count\";i:3;s:15:\"control_percent\";i:5;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:14:\"section_editor\";a:1:{s:6:\"editor\";i:3;}}s:5:\"style\";a:1:{s:13:\"section_style\";a:10:{s:5:\"align\";i:3;s:10:\"text_color\";i:3;s:21:\"typography_typography\";i:3;s:20:\"typography_font_size\";i:3;s:22:\"typography_font_weight\";i:3;s:22:\"typography_line_height\";i:3;s:12:\"align_mobile\";i:3;s:21:\"typography_font_style\";i:3;s:22:\"typography_font_family\";i:3;s:27:\"typography_font_size_mobile\";i:3;}}s:8:\"advanced\";a:1:{s:14:\"_section_style\";a:4:{s:7:\"_margin\";i:3;s:14:\"_margin_mobile\";i:3;s:15:\"_padding_mobile\";i:3;s:12:\"_css_classes\";i:3;}}}}s:14:\"jet-inline-svg\";a:3:{s:5:\"count\";i:4;s:15:\"control_percent\";i:2;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:19:\"section_svg_content\";a:1:{s:7:\"svg_url\";i:4;}}s:5:\"style\";a:1:{s:17:\"section_svg_style\";a:4:{s:16:\"svg_custom_width\";i:4;s:9:\"svg_width\";i:4;s:16:\"svg_custom_color\";i:4;s:9:\"svg_color\";i:4;}}s:8:\"advanced\";a:1:{s:14:\"_section_style\";a:1:{s:7:\"_margin\";i:3;}}}}s:10:\"price-list\";a:3:{s:5:\"count\";i:2;s:15:\"control_percent\";i:7;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:12:\"section_list\";a:1:{s:10:\"price_list\";i:2;}}s:5:\"style\";a:2:{s:18:\"section_list_style\";a:15:{s:13:\"heading_color\";i:2;s:29:\"heading_typography_typography\";i:2;s:28:\"heading_typography_font_size\";i:2;s:30:\"heading_typography_font_weight\";i:2;s:30:\"heading_typography_line_height\";i:2;s:33:\"description_typography_typography\";i:2;s:32:\"description_typography_font_size\";i:2;s:34:\"description_typography_font_weight\";i:2;s:16:\"separator_weight\";i:2;s:15:\"separator_color\";i:2;s:35:\"heading_typography_font_size_mobile\";i:2;s:33:\"description_typography_font_style\";i:2;s:17:\"description_color\";i:2;s:34:\"description_typography_line_height\";i:2;s:30:\"heading_typography_font_family\";i:2;}s:18:\"section_item_style\";a:1:{s:7:\"row_gap\";i:2;}}s:8:\"advanced\";a:1:{s:14:\"_section_style\";a:4:{s:14:\"_margin_tablet\";i:2;s:15:\"_padding_tablet\";i:2;s:14:\"_margin_mobile\";i:1;s:15:\"_padding_mobile\";i:1;}}}}s:13:\"gallery-extra\";a:3:{s:5:\"count\";i:1;s:15:\"control_percent\";i:5;s:8:\"controls\";a:2:{s:7:\"content\";a:2:{s:15:\"section_gallery\";a:2:{s:12:\"gallery_type\";i:1;s:7:\"gallery\";i:1;}s:24:\"section_gallery_settings\";a:4:{s:7:\"columns\";i:1;s:13:\"open_lightbox\";i:1;s:23:\"gallery_display_caption\";i:1;s:14:\"columns_mobile\";i:1;}}s:5:\"style\";a:3:{s:22:\"section_gallery_layout\";a:6:{s:11:\"image_align\";i:1;s:20:\"image_vertical_align\";i:1;s:24:\"image_horizontal_spacing\";i:1;s:22:\"image_vertical_spacing\";i:1;s:31:\"image_horizontal_spacing_mobile\";i:1;s:29:\"image_vertical_spacing_mobile\";i:1;}s:22:\"section_gallery_images\";a:3:{s:19:\"image_border_border\";i:1;s:18:\"image_border_width\";i:1;s:18:\"image_border_color\";i:1;}s:21:\"section_hover_effects\";a:9:{s:27:\"image_transition_transition\";i:1;s:23:\"image_transition_easing\";i:1;s:25:\"image_transition_duration\";i:1;s:11:\"image_scale\";i:1;s:17:\"image_scale_hover\";i:1;s:20:\"image_opacity_mobile\";i:1;s:18:\"image_scale_mobile\";i:1;s:26:\"image_opacity_hover_mobile\";i:1;s:24:\"image_scale_hover_mobile\";i:1;}}}}s:9:\"icon-list\";a:3:{s:5:\"count\";i:1;s:15:\"control_percent\";i:6;s:8:\"controls\";a:3:{s:7:\"content\";a:1:{s:12:\"section_icon\";a:1:{s:9:\"icon_list\";i:1;}}s:5:\"style\";a:3:{s:17:\"section_icon_list\";a:2:{s:13:\"space_between\";i:1;s:10:\"icon_align\";i:1;}s:18:\"section_icon_style\";a:2:{s:10:\"icon_color\";i:1;s:9:\"icon_size\";i:1;}s:18:\"section_text_style\";a:6:{s:10:\"text_color\";i:1;s:26:\"icon_typography_typography\";i:1;s:27:\"icon_typography_font_family\";i:1;s:25:\"icon_typography_font_size\";i:1;s:27:\"icon_typography_font_weight\";i:1;s:32:\"icon_typography_font_size_mobile\";i:1;}}s:8:\"advanced\";a:1:{s:14:\"_section_style\";a:5:{s:7:\"_margin\";i:1;s:8:\"_padding\";i:1;s:14:\"_margin_mobile\";i:1;s:15:\"_padding_tablet\";i:1;s:15:\"_padding_mobile\";i:1;}}}}s:4:\"form\";a:3:{s:5:\"count\";i:2;s:15:\"control_percent\";i:9;s:8:\"controls\";a:2:{s:7:\"content\";a:4:{s:19:\"section_form_fields\";a:2:{s:11:\"form_fields\";i:2;s:13:\"mark_required\";i:2;}s:21:\"section_submit_button\";a:5:{s:11:\"button_text\";i:2;s:11:\"button_size\";i:2;s:17:\"button_icon_align\";i:2;s:18:\"button_icon_indent\";i:2;s:20:\"selected_button_icon\";i:2;}s:13:\"section_email\";a:2:{s:13:\"form_metadata\";i:2;s:18:\"email_content_type\";i:2;}s:20:\"section_form_options\";a:3:{s:15:\"custom_messages\";i:2;s:15:\"success_message\";i:2;s:13:\"error_message\";i:2;}}s:5:\"style\";a:3:{s:18:\"section_form_style\";a:9:{s:7:\"row_gap\";i:2;s:11:\"label_color\";i:2;s:19:\"mark_required_color\";i:2;s:27:\"label_typography_typography\";i:2;s:26:\"label_typography_font_size\";i:2;s:28:\"label_typography_font_family\";i:2;s:28:\"label_typography_font_weight\";i:2;s:28:\"label_typography_line_height\";i:2;s:33:\"label_typography_font_size_mobile\";i:2;}s:19:\"section_field_style\";a:9:{s:16:\"field_text_color\";i:2;s:27:\"field_typography_typography\";i:2;s:26:\"field_typography_font_size\";i:2;s:22:\"field_background_color\";i:2;s:18:\"field_border_color\";i:2;s:19:\"field_border_radius\";i:2;s:28:\"field_typography_font_family\";i:2;s:33:\"field_typography_font_size_mobile\";i:2;s:28:\"field_typography_font_weight\";i:2;}s:20:\"section_button_style\";a:12:{s:23:\"button_background_color\";i:2;s:17:\"button_text_color\";i:2;s:28:\"button_typography_typography\";i:2;s:29:\"button_typography_font_family\";i:2;s:32:\"button_typography_text_transform\";i:2;s:20:\"button_border_radius\";i:2;s:29:\"button_background_hover_color\";i:2;s:18:\"button_hover_color\";i:2;s:22:\"button_hover_animation\";i:2;s:20:\"button_border_border\";i:2;s:26:\"button_border_width_mobile\";i:2;s:19:\"button_border_color\";i:2;}}}}s:7:\"divider\";a:3:{s:5:\"count\";i:1;s:15:\"control_percent\";i:0;s:8:\"controls\";a:0:{}}}");
INSERT INTO `wp_464683_postmeta` VALUES("1184", "287", "_elementor_css", "a:5:{s:4:\"time\";i:1573380643;s:5:\"fonts\";a:4:{i:0;s:15:\"Euphoria Script\";i:3;s:10:\"Montserrat\";i:30;s:7:\"PT Sans\";i:44;s:13:\"League Script\";}s:5:\"icons\";a:3:{i:0;s:8:\"fa-solid\";i:2;s:9:\"fa-brands\";i:20;s:10:\"fa-regular\";}s:6:\"status\";s:4:\"file\";i:0;s:0:\"\";}");

/* INSERT TABLE DATA: wp_464683_posts */
INSERT INTO `wp_464683_posts` VALUES("3", "1", "2019-11-09 09:27:47", "2019-11-09 09:27:47", "<!-- wp:heading --><h2>Who we are</h2><!-- /wp:heading --><!-- wp:paragraph --><p>Our website address is: https://emilyhunt.ch.</p><!-- /wp:paragraph --><!-- wp:heading --><h2>What personal data we collect and why we collect it</h2><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>Comments</h3><!-- /wp:heading --><!-- wp:paragraph --><p>When visitors leave comments on the site we collect the data shown in the comments form, and also the visitor&#8217;s IP address and browser user agent string to help spam detection.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>An anonymized string created from your email address (also called a hash) may be provided to the Gravatar service to see if you are using it. The Gravatar service privacy policy is available here: https://automattic.com/privacy/. After approval of your comment, your profile picture is visible to the public in the context of your comment.</p><!-- /wp:paragraph --><!-- wp:heading {\"level\":3} --><h3>Media</h3><!-- /wp:heading --><!-- wp:paragraph --><p>If you upload images to the website, you should avoid uploading images with embedded location data (EXIF GPS) included. Visitors to the website can download and extract any location data from images on the website.</p><!-- /wp:paragraph --><!-- wp:heading {\"level\":3} --><h3>Contact forms</h3><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>Cookies</h3><!-- /wp:heading --><!-- wp:paragraph --><p>If you leave a comment on our site you may opt-in to saving your name, email address and website in cookies. These are for your convenience so that you do not have to fill in your details again when you leave another comment. These cookies will last for one year.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>If you visit our login page, we will set a temporary cookie to determine if your browser accepts cookies. This cookie contains no personal data and is discarded when you close your browser.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>When you log in, we will also set up several cookies to save your login information and your screen display choices. Login cookies last for two days, and screen options cookies last for a year. If you select &quot;Remember Me&quot;, your login will persist for two weeks. If you log out of your account, the login cookies will be removed.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>If you edit or publish an article, an additional cookie will be saved in your browser. This cookie includes no personal data and simply indicates the post ID of the article you just edited. It expires after 1 day.</p><!-- /wp:paragraph --><!-- wp:heading {\"level\":3} --><h3>Embedded content from other websites</h3><!-- /wp:heading --><!-- wp:paragraph --><p>Articles on this site may include embedded content (e.g. videos, images, articles, etc.). Embedded content from other websites behaves in the exact same way as if the visitor has visited the other website.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>These websites may collect data about you, use cookies, embed additional third-party tracking, and monitor your interaction with that embedded content, including tracking your interaction with the embedded content if you have an account and are logged in to that website.</p><!-- /wp:paragraph --><!-- wp:heading {\"level\":3} --><h3>Analytics</h3><!-- /wp:heading --><!-- wp:heading --><h2>Who we share your data with</h2><!-- /wp:heading --><!-- wp:heading --><h2>How long we retain your data</h2><!-- /wp:heading --><!-- wp:paragraph --><p>If you leave a comment, the comment and its metadata are retained indefinitely. This is so we can recognize and approve any follow-up comments automatically instead of holding them in a moderation queue.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>For users that register on our website (if any), we also store the personal information they provide in their user profile. All users can see, edit, or delete their personal information at any time (except they cannot change their username). Website administrators can also see and edit that information.</p><!-- /wp:paragraph --><!-- wp:heading --><h2>What rights you have over your data</h2><!-- /wp:heading --><!-- wp:paragraph --><p>If you have an account on this site, or have left comments, you can request to receive an exported file of the personal data we hold about you, including any data you have provided to us. You can also request that we erase any personal data we hold about you. This does not include any data we are obliged to keep for administrative, legal, or security purposes.</p><!-- /wp:paragraph --><!-- wp:heading --><h2>Where we send your data</h2><!-- /wp:heading --><!-- wp:paragraph --><p>Visitor comments may be checked through an automated spam detection service.</p><!-- /wp:paragraph --><!-- wp:heading --><h2>Your contact information</h2><!-- /wp:heading --><!-- wp:heading --><h2>Additional information</h2><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>How we protect your data</h3><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>What data breach procedures we have in place</h3><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>What third parties we receive data from</h3><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>What automated decision making and/or profiling we do with user data</h3><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>Industry regulatory disclosure requirements</h3><!-- /wp:heading -->", "Privacy Policy", "", "draft", "closed", "open", "", "privacy-policy", "", "", "2019-11-09 09:27:47", "2019-11-09 09:27:47", "", "0", "https://emilyhunt.ch/?page_id=3", "0", "page", "", "0");
INSERT INTO `wp_464683_posts` VALUES("183", "0", "2017-02-23 14:16:20", "2017-02-23 14:16:20", "", "divi", "", "publish", "closed", "closed", "", "divi", "", "", "2017-02-23 14:16:20", "2017-02-23 14:16:20", "", "0", "https://demo.infomaniak.com/divi-onepage/2017/02/23/divi/", "0", "custom_css", "", "0");
INSERT INTO `wp_464683_posts` VALUES("184", "0", "2019-11-09 10:28:22", "2019-11-09 09:28:22", "", "ABOUT ME", "", "publish", "closed", "closed", "", "about-me", "", "", "2019-11-09 10:28:22", "2019-11-09 09:28:22", "", "0", "https://emilyhunt.ch/about-me/", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_464683_posts` VALUES("185", "0", "2019-11-09 10:28:22", "2019-11-09 09:28:22", "", "MATERIALS", "", "publish", "closed", "closed", "", "materials", "", "", "2019-11-09 10:28:22", "2019-11-09 09:28:22", "", "0", "https://emilyhunt.ch/materials/", "2", "nav_menu_item", "", "0");
INSERT INTO `wp_464683_posts` VALUES("186", "0", "2019-11-09 10:28:22", "2019-11-09 09:28:22", "", "PORTFOLIO", "", "publish", "closed", "closed", "", "portfolio", "", "", "2019-11-09 10:28:22", "2019-11-09 09:28:22", "", "0", "https://emilyhunt.ch/portfolio/", "3", "nav_menu_item", "", "0");
INSERT INTO `wp_464683_posts` VALUES("187", "0", "2019-11-09 10:28:22", "2019-11-09 09:28:22", "", "VIDEO", "", "publish", "closed", "closed", "", "video", "", "", "2019-11-09 10:28:22", "2019-11-09 09:28:22", "", "0", "https://emilyhunt.ch/video/", "4", "nav_menu_item", "", "0");
INSERT INTO `wp_464683_posts` VALUES("188", "0", "2019-11-09 10:28:22", "2019-11-09 09:28:22", "", "BLOG", "", "publish", "closed", "closed", "", "blog", "", "", "2019-11-09 10:28:22", "2019-11-09 09:28:22", "", "0", "https://emilyhunt.ch/blog/", "5", "nav_menu_item", "", "0");
INSERT INTO `wp_464683_posts` VALUES("189", "0", "2019-11-09 10:28:22", "2019-11-09 09:28:22", "", "CONTACT", "", "publish", "closed", "closed", "", "contact", "", "", "2019-11-09 10:28:22", "2019-11-09 09:28:22", "", "0", "https://emilyhunt.ch/contact/", "6", "nav_menu_item", "", "0");
INSERT INTO `wp_464683_posts` VALUES("285", "1", "2019-11-09 06:20:28", "2019-11-09 14:20:28", "html, body {margin:0px;padding:0;}\n.entry-content {margin-top:0;margin-bottom:0;}\n.bio p {padding-bottom:0.5em;}\n\n@media screen and (orientation:portrait) {\n	    .elementor-lightbox .elementor-lightbox-item {\n    padding: 0;\n}\n    .dialog-type-lightbox .dialog-header, .dialog-type-lightbox .dialog-message{\n        padding:0;\n    }\n}\n@media screen and (orientation:landscape) {\n    .elementor-lightbox-image{min-height:100vh!important;\n			overflow:hidden;}\n}\n@media screen and (min-width:1450) {\n.elementor-widget-text-editor {\n    font-size:1.3rem;}\n}\n", "blankslate", "", "publish", "closed", "closed", "", "blankslate", "", "", "2019-11-09 08:56:46", "2019-11-09 16:56:46", "", "0", "https://emilyhunt.ch/blankslate/", "0", "custom_css", "", "0");
INSERT INTO `wp_464683_posts` VALUES("287", "1", "2019-11-09 06:20:45", "2019-11-09 14:20:45", "<h1 data-title=\"Emily&lt;br/&gt;Hunt\">\n			Emily<br/>Hunt		\n			Emily<br/>Hunt		\n			Emily<br/>Hunt		</h1>\n			<h2>About</h2>		\n		<p>I could write a very generic About Me with lots of catchy words but it’s just not my style so I will keep this short.</p><p>When I say I am Portland’s Sweetest girlfriend, it’s not a falsehood. I am extremely empathetic and fantastic at reading others. I’m all woman, petite yet curvy with mesmerizing eyes. But I am so, so much more than just another pretty face.</p><p>I love connecting with and meeting new people, traveling (as most people do), dark chocolate and red wine. I moved to Oregon because I love hiking and being outdoors, but I can very easily cozy up with a book for hours or a really good crime podcast or even in some kickass sheets with a special someone.</p><p>I strive to be a better person by making a conscious effort to practice kindness every single day and personal growth is so important to me.</p><p>P.S. Food is always the way to my heart.</p><p>INTERESTS</p><p>New places, new faces, new experiences. Laughing, fitness, outdoor activities, dark chocolate, red wine, tulips, vintage clothing shopping, neck kisses and bold adventures.</p>		\n			<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<svg enable-background=\"new 0 0 2686.688 505.889\" version=\"1.1\" viewBox=\"0 0 2686.688 505.889\" xml:space=\"preserve\" xmlns=\"http://www.w3.org/2000/svg\">\n	<path d=\"m1400.9 146.11c16.118-9.106 40.85-14.041 41.217-41.839 0.409-30.846-36.902-21.878-29.688 4.104 5.297 19.082-2.352 24.892-12.807 36.113-0.351 0.377-0.375 0.954-0.057 1.359 0.324 0.409 0.893 0.514 1.335 0.263z\"/>\n	<path d=\"m1285.8 146.11c0.454 0.255 1.016 0.14 1.335-0.263 0.785-1-0.457-1.793-2.582-4.037-25.161-26.502-0.638-34.629-12.863-50.712-8.176-10.751-27.397-8.814-27.105 13.173 0.366 27.816 25.152 32.764 41.215 41.839z\"/>\n	<path d=\"m1448 114.89c19.564-11.035 47.46-16.181 47.888-48.528 0.469-35.63-42.542-25.243-34.217 4.731 6.185 22.273-2.72 29.068-14.947 42.172-0.351 0.377-0.375 0.954-0.057 1.359 0.313 0.4 0.878 0.518 1.333 0.266z\"/>\n	<path d=\"m1238.7 114.89c0.455 0.252 1.02 0.134 1.333-0.266 0.785-1-0.404-1.745-2.998-4.474-29.48-31.036-0.758-40.295-14.98-59.005-9.418-12.385-31.577-10.239-31.242 15.217 0.427 32.342 28.314 37.487 47.887 48.528z\"/>\n	<path d=\"m2512 275.94c-64.212 0.265-145.8-3.779-232.63-11.36l-0.34-0.238-0.137 0.196c-6.237-0.545-12.498-1.107-18.784-1.689 52.311-3.386 198.38-8.556 201.34-58.401 1.741-29.462-29.559-29.832-37.678-14.575-6.094 11.442 2.217 27.353 17.594 20.976 13.025-5.4 6.783-19.429-0.866-20.016-5.048-0.374-11.484 4.168-8.966 5.476 0.499 0.257 1.123 0.041 1.404-0.44 0.438-0.751 4.209-3.362 7.71-2.92 5.161 0.655 10.859 11.429-0.081 15.971-13.827 5.74-19.952-8.661-14.947-18.061 7.111-13.351 35.356-13.689 33.744 13.469-2.865 48.214-150.77 53.294-201.34 56.567-13.259 0.859-8.082 1.048-27.123-0.861 8.765-18.857 5.393-41.861-9.168-55.607-38.411-36.266-93.804 22.684-119.5 40.409-29.258-4.047-55.43-8.148-77.128-12.072-12.526-39.093 25.612-58.716 47.165-43.384 15.278 10.865 16.887 37.968-8.873 39.925-20.762 1.576-21.294-20.482-12.578-25.74 5.35-3.231 13.221-1.905 14.253-1.071 0.453 0.364 1.111 0.29 1.47-0.159 2.125-2.622-9.878-4.739-16.802-0.56-10.456 6.314-9.389 31.361 13.817 29.616 27.43-2.082 26.99-31.573 9.926-43.712-22.829-16.237-62.753 4.038-50.701 44.662-53.686-9.824-43.573-10.133-109.3-31.306 8.029-61.449-78.539-134.82-136.26-61.591l1.452 1.481c72.356-54.856 114.77 6.246 120.08 55.431-82.994-25.98-159.75-43.517-229.77-52.519-1.675-17.737-10.176-33.03-25.37-45.566-33.149-27.356-89.751-4.893-89.535 38.543-60.319 0.904-123.17 10.06-177.42 35.206-5.414-17.609-17.331-31.207-33.305-40.569-15.671 9.179-27.808 22.677-33.309 40.568-54.262-25.15-117.13-34.301-177.42-35.206 0.11-22.139-16.438-43.856-43.058-49.22-38.497-7.753-68.738 23.331-71.846 56.243-70.009 9.002-146.76 26.538-229.75 52.516 5.351-49.523 47.911-110.14 120.08-55.428l1.452-1.481c-57.296-72.696-144.43-0.998-136.26 61.587-65.922 21.238-55.569 21.476-109.31 31.31 17.071-57.538-64.585-67.774-62.534-19.093 0.826 19.685 37.328 25.877 41.184 6.192 4.437-22.642-18.699-21.436-22.254-18.577-1.074 0.865 0.233 2.496 1.313 1.629 1.607-1.298 23.032-4.583 18.89 16.545-3.342 17.04-36.314 11.515-37.045-5.879-1.922-45.971 75.744-35.39 58.121 19.605-21.697 3.924-47.868 8.025-77.125 12.071-13.78-9.505-26.457-20.59-34.71-27.211-72.162-57.853-113.37 0.64-93.959 42.409-24.726 2.479-225.26-1.728-228.47-55.705-2.153-36.265 46.921-22.94 33.197 1.529-4.802 8.566-23.054 3.05-20.41-6.308 3.266-11.568 13.012-4.755 13.639-3.68 0.695 1.191 2.415 0.258 1.894-0.886-1.144-2.506-13.653-9.775-17.54 3.995-3.358 11.893 18.303 18.491 24.244 7.897 15.607-27.806-39.471-42.259-37.106-2.428 2.965 50.009 149.62 55.054 201.34 58.401-6.275 0.58-12.523 1.141-18.749 1.685l-0.133-0.19-0.33 0.231c-86.857 7.584-168.46 11.63-232.68 11.365-0.576-2e-3 -1.047 0.464-1.049 1.041-0.011 3.002 112.75 0.15 230.3-10.004l-26.469 18.51c-3.01-3.588-14.942-3.512-15.942-3.052-36.764 17.113-78.315 29.959-115.88 15.836-3.544-1.338-1.372 31.361 52.329 21.166-11.474 7.376-27.8 11.722-41.399 18.54-6.658 3.338-29.556 29.395-28.595 31.125 0.411 0.748-0.141 0.418 10.451 0.37 27.012-0.129 27.034 0.307 49.939-16.778 7.468-5.57 15.15-11.3 23.206-15.002-33.815 34.907-20.732 46.453-15.263 55.992 0.488 0.827 1.745 0.626 1.933-0.32 6.127-30.779 31.804-52.745 56.632-73.989 0.99-0.847 22.087-18.854 22.424-20.116 1.447-5.503 2.098-9.29 1.193-11.941l29.605-20.704c16.074-1.407 32.32-2.932 48.674-4.575 19.282 37.116 93.738 38.536 135.65 35.674-45.72 11.006-85.56 23.319-105.6 43.408-19.331-2.866-33.658 7.17-32.166 28.062-1.624 0.318-3.712 0.442-5.422 0.327 3.935-10.266-4.42-21.166-14.588-21.166-13.534 0-14.523 16.511-36.211 16.511-7.067 0-11.833-1.649-20.693-1.97 10.436 23.137 26.106 18.767 43.964 18.024 8.265 2.959 3.085 12.177-2.767 12.234-8.813-2.487-16.479-0.146-22.224 6.157-14.99 16.447-4.076 28.049-10.19 46.769-1.009 3.076-1.055 3.44-1.735 6.451 10.312-5.087 16.416-5.193 31.473-5.596 38.289-2.949 19.52-40.753 32.664-40.753 6.323 0 4.299 8.683 3.688 12.424-2.507 15.285-1.577 24.668 19.554 37.511 1.028-14.712-1.77-35.979 4.629-39.444 12.676-7.994 16.435-34.676-11.213-33.685 0.098-1.557 0.259-3.499 0.91-5.067 18.58 1.93 27.183-17.795 21.91-35.417 41.187-41.099 169.63-49.693 252.09-81.206 16.364-6.254 32.192-12.163 47.515-17.749 9.318 15.323 21.968 27.391 36.904 36.341-15.155 12.732-27.557 25.275-37.417 37.771-3.453-2.984-9.84-0.772-16.456 1.591-3.376 1.218-48.291 54.744-104.48 53.547-3.75-0.309 4.197 14.414 21.584 14.414 9.632 0 21.322-3.954 34.804-11.768-19.918 25.565-35.308 18.628-49.906 68.966-0.111 0.385 9e-3 0.803 0.309 1.071 0.64 0.57 30.933-9.797 35.847-14.836 12.032-12.337 20.344-30.613 32.629-42.484-20.343 44.122-4.193 50.695 4.137 57.888 0.725 0.628 1.856 0.019 1.72-0.938-7.824-55.103 52.571-106.2 41.167-125.8 9.942-12.664 22.524-25.382 37.966-38.303 38.305 21.978 103.92 30.026 194.34-14.339-28.142 35.863-41.633 81.463-38.956 82.164 0.545 0.146 1.126-0.177 1.276-0.747 8.594-32.9 23.072-60.567 41.575-83.354 0.141-0.071 0.73-0.363 1.569-0.786 0.64-1.018 1.296-1.955 2.528-3.338l1.232-0.751c0.125-0.382 0.172-0.533 0.287-0.858 6.205-6.234 18.374-14.754 35.173-23.693 39.663 22.01 100.21 15.59 111.84 11.625 26.08-8.795 59.136-21.091 100.47-21.291v2e-3c1.425 0.058 2.843 0.137 4.256 0.231-17.555 1.357-59.455 15.348-73.221 47.279-12.739 15.716-30.932 29.17-44.161 32.748-11.578-14.572-28.596-17.692-42.115-1.59-1.42-0.925-2.97-2.262-4.12-3.54 14.283-6.628 11.38-32.037-10.503-29.572-21.314-0.641-26.296-14.615-36.206-24.952-8.355 23.127 4.132 30.278 19.017 43.548 3.879 7.882-6.277 10.875-10.503 6.854-11.541-19.881-36.047-8.623-42.908-0.096-10.837 14.016-14.298 13.312-22.942 18.951 29.79 9.577 32.493 45.241 69.785 12.189 4.415-3.284 8.211-2.21 9.404 0.435 1.947 4.312-3.067 7.401-6.88 10.236-12.506 9.28-18.278 16.675-12.073 40.544 10.484-9.378 22.363-25.239 29.675-25.239 0.15 0 2.81 0.525 4.792 0.525 14.601 0 30.333-15.514 11.712-32.37 1.154-1.049 2.621-2.332 4.18-3.005 12.112 14.463 32.343 6.068 40.848-11.072 12.443-3.574 28.333-14.842 40.873-28.867-10.845 34.524 9.443 75.898 45.508 75.898 19.316 0 38.106-11.908 43.633-31.018 7.8-26.982-16.185-58.756-46.836-38.199-25.944 17.401-5.987 44.762 10.087 42.721 10.652-1.354 20.896-13.13 17.277-13.954-0.562-0.128-1.121 0.226-1.248 0.79-0.418 1.857-7.588 9.983-16.293 11.089-14.098 1.795-32.591-22.861-8.657-38.911 29.267-19.627 50.829 11.105 43.664 35.882-7.24 25.036-38.173 36.428-60.246 25.185-24.925-12.695-34.247-47.552-22.967-74.102 0.314-0.389 0.554-0.604 0.484-1.121 11.882-26.354 39.344-36.748 60.351-43.586 12.276-2.853 26.158-2.756 41.864 1.599 7.937 21.249 16.422 29.295 29.624 46.528 13.23-17.27 21.676-25.249 29.624-46.527 47.984-13.307 90.669 16.367 102.22 41.98-0.074 0.522 0.171 0.742 0.491 1.139 18.147 42.738-16.672 93.337-59.899 74.592-46.352-20.103-20.292-88.82 20.345-61.568 23.967 16.072 5.287 40.686-8.659 38.911-8.705-1.106-15.875-9.232-16.293-11.089-0.128-0.564-0.688-0.919-1.25-0.79-3.632 0.828 6.639 12.602 17.277 13.954 16.098 2.044 36.018-25.333 10.088-42.721-30.655-20.56-54.634 11.221-46.836 38.199 5.527 19.11 24.318 31.018 43.633 31.018 36.097 0 56.334-41.436 45.516-75.889 12.539 14.022 28.424 25.286 40.865 28.859 8.434 16.991 28.677 25.606 40.848 11.072 1.559 0.673 3.026 1.955 4.18 3.005-20.474 18.533 0.621 35.116 15.398 31.991 7.027-1.945 19.834 15.302 30.781 25.094 8.167-31.411-5.866-34.585-17.645-44.92-3.375-3.88-1.319-8.335 2.8-8.335 9.58 0 22.197 29.67 48.589 7.742 11.169-10.263 15.638-14.402 26.491-17.891-8.684-5.666-12.114-4.946-22.942-18.951-6.723-8.355-31.291-19.916-42.908 0.096-4.21 4.007-14.393 1.05-10.503-6.854 14.671-13.079 27.424-20.272 19.017-43.548-12.368 12.9-14.634 24.789-39.046 24.789-19.356 0-21.24 23.435-7.664 29.736-1.15 1.278-2.7 2.615-4.12 3.54-13.568-16.161-30.608-12.892-42.115 1.59-13.226-3.577-31.413-17.025-44.151-32.736-11.369-26.386-46.174-45.201-73.229-47.291 1.412-0.094 2.829-0.173 4.253-0.231v-2e-3c69.439 0.337 79.469 25.319 139.99 25.319 24.261 0 51.205-3.933 72.327-15.656 16.804 8.942 28.977 17.463 35.182 23.697 0.096 0.271 0.198 0.585 0.287 0.858l1.232 0.751c1.239 1.391 1.886 2.316 2.528 3.338 0.824 0.415 1.482 0.743 1.554 0.779 18.506 22.789 32.986 50.458 41.581 83.361 0.147 0.568 0.73 0.893 1.276 0.747 2.418-0.633-9.875-45.108-38.963-82.171 90.387 44.35 156.01 36.345 194.35 14.35 15.439 12.919 28.019 25.635 37.96 38.297-1.443 2.477-1.905 6.278-2.272 10.823-0.101 1.299 13.921 25.415 14.501 26.415 16.395 28.266 33.348 57.492 28.937 88.56-0.133 0.945 0.98 1.574 1.72 0.938 8.328-7.192 24.481-13.764 4.137-57.888 6.375 6.16 11.725 14.109 16.928 21.836 15.979 23.75 16.274 23.361 41.567 32.37 6.554 2.336 11.05 4.68 10.29 2.042-14.589-50.306-30.045-43.475-49.906-68.966 47.772 27.689 60.112-2.952 56.388-2.645-56.076 1.195-101.25-52.382-104.48-53.547-8.498-3.034-13.436-4.199-16.454-1.592-9.858-12.493-22.259-25.036-37.411-37.765 14.873-8.911 27.551-20.957 36.907-36.341 67.085 24.456 62.153 26.076 156.79 47.385 60.52 13.625 117.7 26.514 142.81 51.568-5.264 17.593 3.311 37.348 21.91 35.415 0.651 1.568 0.812 3.51 0.91 5.067-27.757-0.995-23.817 25.737-11.213 33.685 6.395 3.463 3.594 24.624 4.629 39.444l1.463-0.891c26.277-16.042 18.247-29.813 17.135-43.64 0.378-7.018 8.762-7.757 10.194 1.117 3.714 49.579 31.794 26.605 56.621 38.858l1.964 0.969c-0.677-2.994-0.715-3.325-1.735-6.451-6.284-19.241 5.029-30.07-10.19-46.769-5.74-6.298-13.4-8.648-22.224-6.157-5.853-0.057-11.033-9.275-2.767-12.234 17.887 0.745 33.526 5.118 43.964-18.024-8.855 0.321-13.627 1.97-20.691 1.97-21.67 0-22.708-16.511-36.211-16.511-10.131 0-18.537 10.863-14.588 21.166-1.709 0.115-3.797-9e-3 -5.422-0.327 1.526-21.353-13.447-30.838-32.167-28.062-20.036-20.09-59.877-32.402-105.6-43.408 41.742 2.851 116.34 1.498 135.65-35.674 16.371 1.645 32.635 3.172 48.726 4.58l29.561 20.673c-7.403 21.354 69.261 50.929 80.238 106.07 0.188 0.948 1.45 1.147 1.934 0.32 5.467-9.533 18.554-21.083-15.263-55.992 8.056 3.701 15.737 9.432 23.206 15.002 22.951 17.12 23.083 16.65 49.939 16.778 10.592 0.048 10.04 0.378 10.451-0.37 0.974-1.753-21.962-27.8-28.595-31.125-13.6-6.818-29.923-11.162-41.399-18.54 53.352 10.129 56.144-22.605 52.329-21.166-37.534 14.113-79.057 1.303-115.88-15.836-1-0.46-12.904-0.531-15.923 3.031l-26.433-18.485c119.1 10.287 230.26 12.907 230.25 10 2e-3 -0.567-0.454-1.044-1.046-1.044zm-291.71-69.991c14.084 13.294 17.185 35.683 8.391 53.865-40.48-4.082-82.931-9.007-123.41-14.559 23.479-16.524 78.266-74.009 115.02-39.306zm-120.64 40.636c-15.824 10.566-32.813 18.594-46.185 15.216-13.034-3.291-22.82-14.034-27.582-26.781 20.937 3.767 45.935 7.69 73.767 11.565zm-244.24 28.072c-37.163-29.866-89.493-60.863-159.63-94.765 54.074 13.474 117.92 32.939 194.71 60.679-7.559 13.967-19.546 25.495-35.083 34.086zm-1.992 1.077c-46.104 24.285-126.96 23.729-193.9-16.385-0.677-0.788-1.367-1.565-2.056-2.344-3.566-8.42-13.104-18.287-26.747-28.133 16.176-12.272 30.085-36.979 35.38-56.005 43.689 9.769 143.74 68.002 187.32 102.87zm-510.06-65.13c-10.811-7.447-22.316-13.69-34.466-18.734 0.194-5.704 0.985-11.384 2.481-16.926 11.382 5.393 22.058 11.365 31.986 17.911 9.927-6.545 20.603-12.517 31.983-17.909 1.496 5.542 2.287 11.221 2.481 16.925-12.15 5.043-23.654 11.285-34.465 18.733zm-314.09 46.384c-0.697 0.787-1.394 1.573-2.079 2.37-66.919 40.094-147.76 40.674-193.88 16.373 40.123-32.101 141.37-92.593 187.31-102.86 5.289 19.005 19.198 43.731 35.386 56.01-13.63 9.837-23.162 19.696-26.733 28.111zm-197.96 17.667c-15.535-8.592-27.522-20.121-35.08-34.087 76.789-27.74 140.63-47.204 194.71-60.678-70.134 33.902-122.46 64.898-159.63 94.765zm512.05-54.574c11.028-6.975 22.48-12.403 34.067-16.57-0.881 8.912-3.035 17.69-6.022 25.899-9.867 2.81-19.261 6.565-28.052 11.224-8.792-4.659-18.185-8.414-28.051-11.224-2.987-8.21-5.142-16.99-6.023-25.904 11.592 4.169 23.049 9.598 34.081 16.575zm555.61-21.471c1.179 13.951-0.703 26.593-7.518 40.081-85.582-30.955-159.87-53.408-224.81-67.944 2.284-8.999 3.001-17.141 2.519-24.783 70.011 9.032 146.79 26.612 229.81 52.646zm-339.8-45.691c-1.536-4.24-2.657-8.969-2.922-14.046 22.083-0.261 45.06 0.567 68.904 2.476 2.109 7.503 0.338 14.301-4.612 20.123-21.883-3.87-42.084-6.649-61.37-8.553zm59.591 10.465c-13.705 13.498-47.125 19.924-58.714-8.2 17.96 1.811 37.419 4.463 58.714 8.2zm8.601-21.855c12.977 1.072 26.208 2.462 39.693 4.172 0.606 7.872-0.164 16.115-2.328 24.617-14.38-3.193-28.299-5.995-41.782-8.414 4.59-5.969 6.261-13.085 4.417-20.375zm14.927-41.644c14.556 12.01 22.75 26.965 24.585 43.689-13.631-1.722-27.004-3.118-40.118-4.19-12.236-39.668-50.96-10.765-45.713-8.402 0.527 0.237 1.145 4e-3 1.383-0.523 0.997-2.219 12.004-10.545 23.104-9.704 8.847 0.673 15.222 6.875 18.975 18.445-23.632-1.869-46.413-2.677-68.32-2.417-0.185-41.776 54.32-63.125 86.104-36.898zm-88.141 39.02c0.251 4.955 1.283 9.592 2.723 13.787-45.902-4.381-81.957-3.268-114.17-0.927 36.508-8.656 73.928-12.298 111.45-12.86zm-115.58 13.868l0.106 1.389c33.345-2.551 70.764-3.916 119.03 0.79 12.345 31.586 49.748 24.021 63.619 8.885 13.515 2.41 27.764 5.255 42.836 8.598-5.197 18.556-19.129 43.175-35.228 55.17-68.454-48.152-172.62-67.28-249.07-36.575-0.244-5.72-1.075-11.415-2.602-16.975 18.622-8.657 39.111-15.77 61.31-21.282zm-95.208-18.924c14.976 9.102 26.255 22.106 31.401 39.065-11.146 5.265-21.63 11.079-31.401 17.441-9.772-6.362-20.256-12.176-31.402-17.441 5.138-16.932 16.41-29.957 31.402-39.065zm-36.504 57.179c-78.429-31.5-183.23-9.731-249.07 36.581-16.123-12.011-30.051-36.669-35.234-55.175 15.072-3.343 29.321-6.188 42.836-8.598 13.7 14.95 51.144 23.029 63.619-8.885 48.268-4.706 85.687-3.341 119.03-0.79l0.106-1.39c22.199 5.512 42.688 12.624 61.31 21.28-1.527 5.562-2.359 11.256-2.603 16.977zm-287.2-45.326c13.485-1.71 26.716-3.1 39.693-4.172-1.845 7.29-0.174 14.406 4.418 20.375-13.483 2.419-27.402 5.221-41.782 8.414-2.165-8.503-2.936-16.746-2.329-24.617zm46.513 15.77c-5.015-5.899-6.698-12.724-4.612-20.123 23.844-1.908 46.821-2.737 68.904-2.476-0.265 5.077-1.385 9.807-2.922 14.046-20.47 2.021-40.76 4.909-61.37 8.553zm60.495-6.288c-11.428 27.732-44.711 21.991-58.714 8.2 21.294-3.737 40.752-6.389 58.714-8.2zm117.35-3.418c-32.214-2.342-68.272-3.455-114.18 0.926 1.44-4.195 2.471-8.832 2.723-13.787 37.52 0.561 74.943 4.203 111.46 12.861zm-113.49-14.984c-21.907-0.259-44.688 0.548-68.32 2.417 10.671-32.892 40.307-12.683 42.079-8.74 0.566 1.257 2.474 0.404 1.905-0.86-2.55-5.665-35.124-26.235-46.235 9.784-13.114 1.072-26.487 2.468-40.118 4.191 8.141-74.158 110.97-69.173 110.69-6.792zm-112.97 9.182c-0.483 7.647 0.236 15.788 2.519 24.782-64.942 14.535-139.22 36.987-224.8 67.94-6.791-13.442-8.699-26.07-7.514-40.08 83.017-26.03 159.79-43.609 229.8-52.642zm-356.72 89.057c-4.776 12.782-14.581 23.497-27.582 26.78-13.372 3.378-30.361-4.65-46.184-15.215 27.833-3.876 52.829-7.798 73.766-11.565zm-105.52-10.162c7.311 6.041 16.392 13.54 26.136 20.397-40.465 5.55-82.917 10.475-123.41 14.559-18.655-38.57 17.251-101.12 97.275-34.956zm50.583 69.685c-1.541-0.157-121.28 14.422-146.83-32.733 40.516-4.096 83.539-9.083 124.92-14.797 13.667 9.338 33.75 20.859 49.785 16.816 14.127-3.567 24.644-15.38 29.45-29.24 54.863-9.987 45.202-10.463 110.33-31.46 2.068 13.836 6.62 26.871 13.414 38.573-83.069 30.32-52.439 23.068-181.07 52.841zm700.64-67.349c-0.256-1.275-24.34-3.66-27.891-3.66-41.476 0-75.585 12.639-101.58 21.405-9.098 3.1-68.401 10.879-108.94-10.815 67.877-35.407 164.41-57.161 239.02-31.368 0.794 8.919 2.839 17.715 5.723 25.973-2.09-0.557-4.205-1.063-6.336-1.535zm36.83 47.045c-11.425-14.815-19.435-22.605-27.136-42.393 9.548 2.828 18.632 6.566 27.136 11.162 8.504-4.596 17.588-8.334 27.136-11.162-7.669 19.705-15.54 27.355-27.136 42.393zm166.29-29.3c-1.002-0.338-74.321-26.587-101.77-21.367-2.396 0.106-27.377 2.054-27.693 3.621-2.133 0.472-4.251 0.979-6.344 1.537 2.884-8.257 4.929-17.051 5.724-25.969 75.519-26.115 172.49-3.349 239.03 31.359-38.904 20.822-97.541 14.707-108.95 10.819zm571.17 49.604c-126.16-29.202-95.947-21.771-181.06-52.837 6.795-11.702 11.347-24.737 13.417-38.574 65.18 21.013 55.502 21.478 110.32 31.457 6.697 19.312 22.343 30.077 36.483 30.077 13.245-1e-3 28.587-7.974 42.752-17.652 41.392 5.715 84.409 10.701 124.92 14.797-25.563 47.175-144.52 32.494-146.84 32.732z\"/>\n	<path d=\"m1701 355.47c-48.985 12.78-45.586 39.748-43.84 40.8 9.508 5.727 38.135-0.343 45.131-39.605 0.135-0.738-0.543-1.388-1.291-1.195z\"/>\n	<path d=\"m984.38 356.66c8.342 46.805 45.409 43.768 45.637 38.763 1.599-30.614-46.258-42.346-45.637-38.763z\"/>\n	<path d=\"m1706.5 383.99c-26.064 47.747-18.669 79.964 1.279 78.008 29.384-1.903 15.998-48.358-1.279-78.008z\"/>\n	<path d=\"m980.18 383.99c-23.765 40.771-25.778 78.076 0.4 78.09 19.73-3e-3 23.652-34.093-0.4-78.09z\"/>\n	<path d=\"m1711.6 357.23c8.278 46.505 45.354 44.073 45.631 38.768 1.615-30.768-46.242-42.163-45.631-38.768z\"/>\n	<path d=\"m973.84 356.04c-30.395 7.935-45.313 21.382-44.336 39.965 0.086 1.782 5.682 2.691 8.369 2.69 28.92 3e-3 41.234-44.011 35.967-42.655z\"/>\n	<path d=\"m2516.9 282.29c-1 0.918 5.287 47.481 36.062 48.273 1.753 0 5.723-8.545 1.56-20.019-7.917-21.81-36.408-29.378-37.622-28.254z\"/>\n	<path d=\"m132.13 310.54c-4.145 11.424-0.197 20.024 1.532 20.02 30.087-0.071 37.093-47.347 36.09-48.274-1.014-0.938-29.532 5.977-37.622 28.254z\"/>\n	<path d=\"m2545.5 279.99c44.065 28.73 78.278 25.617 77.872 4.805 0.398-30.399-48.579-18.941-77.872-4.805z\"/>\n	<path d=\"m141.22 279.99c-43.549-21.03-78.189-18.699-77.872 4.803-0.398 20.675 33.562 24.064 77.872-4.803z\"/>\n	<path d=\"m2519.2 272.87c39.402-3.88 48.053-31.818 43.008-41.901-0.646-1.294-27.204-8.267-44.097 40.519-0.257 0.738 0.369 1.475 1.089 1.382z\"/>\n	<path d=\"m168.59 271.49c-16.532-47.74-43.174-42.358-44.098-40.517-1.98 3.955-2.011 11.503 2.375 19.451 10.903 19.751 43.236 25.465 41.723 21.066z\"/>\n</svg>\n			<h2>Stats</h2>		\n		<ul>\n									<li><a href=\"#\">				\n											&bull;&nbsp;Based in\n																			Portland, Oregon\n				</a></li>												<li><a href=\"#\">				\n											&bull;&nbsp;Caters to\n																			Male,Female,Couples\n				</a></li>												<li><a href=\"#\">				\n											&bull;&nbsp;Age\n																			20\'s\n				</a></li>												<li><a href=\"#\">				\n											&bull;&nbsp;Body type\n																			Curvy/Athletic\n				</a></li>												<li><a href=\"#\">				\n											&bull;&nbsp;Cup size\n																			B cup\n				</a></li>												<li><a href=\"#\">				\n											&bull;&nbsp;Height\n																			165 cm / 5′ 5″\n				</a></li>												<li><a href=\"#\">				\n											&bull;&nbsp;Hair color\n																			Brunette\n				</a></li>												<li><a href=\"#\">				\n											&bull;&nbsp;Eye color\n																			Brown\n				</a></li>												<li><a href=\"#\">				\n											&bull;&nbsp;Shoe size\n																			6\n				</a></li>					\n		</ul>\n			<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<svg enable-background=\"new 0 0 2686.688 505.889\" version=\"1.1\" viewBox=\"0 0 2686.688 505.889\" xml:space=\"preserve\" xmlns=\"http://www.w3.org/2000/svg\">\n	<path d=\"m1400.9 146.11c16.118-9.106 40.85-14.041 41.217-41.839 0.409-30.846-36.902-21.878-29.688 4.104 5.297 19.082-2.352 24.892-12.807 36.113-0.351 0.377-0.375 0.954-0.057 1.359 0.324 0.409 0.893 0.514 1.335 0.263z\"/>\n	<path d=\"m1285.8 146.11c0.454 0.255 1.016 0.14 1.335-0.263 0.785-1-0.457-1.793-2.582-4.037-25.161-26.502-0.638-34.629-12.863-50.712-8.176-10.751-27.397-8.814-27.105 13.173 0.366 27.816 25.152 32.764 41.215 41.839z\"/>\n	<path d=\"m1448 114.89c19.564-11.035 47.46-16.181 47.888-48.528 0.469-35.63-42.542-25.243-34.217 4.731 6.185 22.273-2.72 29.068-14.947 42.172-0.351 0.377-0.375 0.954-0.057 1.359 0.313 0.4 0.878 0.518 1.333 0.266z\"/>\n	<path d=\"m1238.7 114.89c0.455 0.252 1.02 0.134 1.333-0.266 0.785-1-0.404-1.745-2.998-4.474-29.48-31.036-0.758-40.295-14.98-59.005-9.418-12.385-31.577-10.239-31.242 15.217 0.427 32.342 28.314 37.487 47.887 48.528z\"/>\n	<path d=\"m2512 275.94c-64.212 0.265-145.8-3.779-232.63-11.36l-0.34-0.238-0.137 0.196c-6.237-0.545-12.498-1.107-18.784-1.689 52.311-3.386 198.38-8.556 201.34-58.401 1.741-29.462-29.559-29.832-37.678-14.575-6.094 11.442 2.217 27.353 17.594 20.976 13.025-5.4 6.783-19.429-0.866-20.016-5.048-0.374-11.484 4.168-8.966 5.476 0.499 0.257 1.123 0.041 1.404-0.44 0.438-0.751 4.209-3.362 7.71-2.92 5.161 0.655 10.859 11.429-0.081 15.971-13.827 5.74-19.952-8.661-14.947-18.061 7.111-13.351 35.356-13.689 33.744 13.469-2.865 48.214-150.77 53.294-201.34 56.567-13.259 0.859-8.082 1.048-27.123-0.861 8.765-18.857 5.393-41.861-9.168-55.607-38.411-36.266-93.804 22.684-119.5 40.409-29.258-4.047-55.43-8.148-77.128-12.072-12.526-39.093 25.612-58.716 47.165-43.384 15.278 10.865 16.887 37.968-8.873 39.925-20.762 1.576-21.294-20.482-12.578-25.74 5.35-3.231 13.221-1.905 14.253-1.071 0.453 0.364 1.111 0.29 1.47-0.159 2.125-2.622-9.878-4.739-16.802-0.56-10.456 6.314-9.389 31.361 13.817 29.616 27.43-2.082 26.99-31.573 9.926-43.712-22.829-16.237-62.753 4.038-50.701 44.662-53.686-9.824-43.573-10.133-109.3-31.306 8.029-61.449-78.539-134.82-136.26-61.591l1.452 1.481c72.356-54.856 114.77 6.246 120.08 55.431-82.994-25.98-159.75-43.517-229.77-52.519-1.675-17.737-10.176-33.03-25.37-45.566-33.149-27.356-89.751-4.893-89.535 38.543-60.319 0.904-123.17 10.06-177.42 35.206-5.414-17.609-17.331-31.207-33.305-40.569-15.671 9.179-27.808 22.677-33.309 40.568-54.262-25.15-117.13-34.301-177.42-35.206 0.11-22.139-16.438-43.856-43.058-49.22-38.497-7.753-68.738 23.331-71.846 56.243-70.009 9.002-146.76 26.538-229.75 52.516 5.351-49.523 47.911-110.14 120.08-55.428l1.452-1.481c-57.296-72.696-144.43-0.998-136.26 61.587-65.922 21.238-55.569 21.476-109.31 31.31 17.071-57.538-64.585-67.774-62.534-19.093 0.826 19.685 37.328 25.877 41.184 6.192 4.437-22.642-18.699-21.436-22.254-18.577-1.074 0.865 0.233 2.496 1.313 1.629 1.607-1.298 23.032-4.583 18.89 16.545-3.342 17.04-36.314 11.515-37.045-5.879-1.922-45.971 75.744-35.39 58.121 19.605-21.697 3.924-47.868 8.025-77.125 12.071-13.78-9.505-26.457-20.59-34.71-27.211-72.162-57.853-113.37 0.64-93.959 42.409-24.726 2.479-225.26-1.728-228.47-55.705-2.153-36.265 46.921-22.94 33.197 1.529-4.802 8.566-23.054 3.05-20.41-6.308 3.266-11.568 13.012-4.755 13.639-3.68 0.695 1.191 2.415 0.258 1.894-0.886-1.144-2.506-13.653-9.775-17.54 3.995-3.358 11.893 18.303 18.491 24.244 7.897 15.607-27.806-39.471-42.259-37.106-2.428 2.965 50.009 149.62 55.054 201.34 58.401-6.275 0.58-12.523 1.141-18.749 1.685l-0.133-0.19-0.33 0.231c-86.857 7.584-168.46 11.63-232.68 11.365-0.576-2e-3 -1.047 0.464-1.049 1.041-0.011 3.002 112.75 0.15 230.3-10.004l-26.469 18.51c-3.01-3.588-14.942-3.512-15.942-3.052-36.764 17.113-78.315 29.959-115.88 15.836-3.544-1.338-1.372 31.361 52.329 21.166-11.474 7.376-27.8 11.722-41.399 18.54-6.658 3.338-29.556 29.395-28.595 31.125 0.411 0.748-0.141 0.418 10.451 0.37 27.012-0.129 27.034 0.307 49.939-16.778 7.468-5.57 15.15-11.3 23.206-15.002-33.815 34.907-20.732 46.453-15.263 55.992 0.488 0.827 1.745 0.626 1.933-0.32 6.127-30.779 31.804-52.745 56.632-73.989 0.99-0.847 22.087-18.854 22.424-20.116 1.447-5.503 2.098-9.29 1.193-11.941l29.605-20.704c16.074-1.407 32.32-2.932 48.674-4.575 19.282 37.116 93.738 38.536 135.65 35.674-45.72 11.006-85.56 23.319-105.6 43.408-19.331-2.866-33.658 7.17-32.166 28.062-1.624 0.318-3.712 0.442-5.422 0.327 3.935-10.266-4.42-21.166-14.588-21.166-13.534 0-14.523 16.511-36.211 16.511-7.067 0-11.833-1.649-20.693-1.97 10.436 23.137 26.106 18.767 43.964 18.024 8.265 2.959 3.085 12.177-2.767 12.234-8.813-2.487-16.479-0.146-22.224 6.157-14.99 16.447-4.076 28.049-10.19 46.769-1.009 3.076-1.055 3.44-1.735 6.451 10.312-5.087 16.416-5.193 31.473-5.596 38.289-2.949 19.52-40.753 32.664-40.753 6.323 0 4.299 8.683 3.688 12.424-2.507 15.285-1.577 24.668 19.554 37.511 1.028-14.712-1.77-35.979 4.629-39.444 12.676-7.994 16.435-34.676-11.213-33.685 0.098-1.557 0.259-3.499 0.91-5.067 18.58 1.93 27.183-17.795 21.91-35.417 41.187-41.099 169.63-49.693 252.09-81.206 16.364-6.254 32.192-12.163 47.515-17.749 9.318 15.323 21.968 27.391 36.904 36.341-15.155 12.732-27.557 25.275-37.417 37.771-3.453-2.984-9.84-0.772-16.456 1.591-3.376 1.218-48.291 54.744-104.48 53.547-3.75-0.309 4.197 14.414 21.584 14.414 9.632 0 21.322-3.954 34.804-11.768-19.918 25.565-35.308 18.628-49.906 68.966-0.111 0.385 9e-3 0.803 0.309 1.071 0.64 0.57 30.933-9.797 35.847-14.836 12.032-12.337 20.344-30.613 32.629-42.484-20.343 44.122-4.193 50.695 4.137 57.888 0.725 0.628 1.856 0.019 1.72-0.938-7.824-55.103 52.571-106.2 41.167-125.8 9.942-12.664 22.524-25.382 37.966-38.303 38.305 21.978 103.92 30.026 194.34-14.339-28.142 35.863-41.633 81.463-38.956 82.164 0.545 0.146 1.126-0.177 1.276-0.747 8.594-32.9 23.072-60.567 41.575-83.354 0.141-0.071 0.73-0.363 1.569-0.786 0.64-1.018 1.296-1.955 2.528-3.338l1.232-0.751c0.125-0.382 0.172-0.533 0.287-0.858 6.205-6.234 18.374-14.754 35.173-23.693 39.663 22.01 100.21 15.59 111.84 11.625 26.08-8.795 59.136-21.091 100.47-21.291v2e-3c1.425 0.058 2.843 0.137 4.256 0.231-17.555 1.357-59.455 15.348-73.221 47.279-12.739 15.716-30.932 29.17-44.161 32.748-11.578-14.572-28.596-17.692-42.115-1.59-1.42-0.925-2.97-2.262-4.12-3.54 14.283-6.628 11.38-32.037-10.503-29.572-21.314-0.641-26.296-14.615-36.206-24.952-8.355 23.127 4.132 30.278 19.017 43.548 3.879 7.882-6.277 10.875-10.503 6.854-11.541-19.881-36.047-8.623-42.908-0.096-10.837 14.016-14.298 13.312-22.942 18.951 29.79 9.577 32.493 45.241 69.785 12.189 4.415-3.284 8.211-2.21 9.404 0.435 1.947 4.312-3.067 7.401-6.88 10.236-12.506 9.28-18.278 16.675-12.073 40.544 10.484-9.378 22.363-25.239 29.675-25.239 0.15 0 2.81 0.525 4.792 0.525 14.601 0 30.333-15.514 11.712-32.37 1.154-1.049 2.621-2.332 4.18-3.005 12.112 14.463 32.343 6.068 40.848-11.072 12.443-3.574 28.333-14.842 40.873-28.867-10.845 34.524 9.443 75.898 45.508 75.898 19.316 0 38.106-11.908 43.633-31.018 7.8-26.982-16.185-58.756-46.836-38.199-25.944 17.401-5.987 44.762 10.087 42.721 10.652-1.354 20.896-13.13 17.277-13.954-0.562-0.128-1.121 0.226-1.248 0.79-0.418 1.857-7.588 9.983-16.293 11.089-14.098 1.795-32.591-22.861-8.657-38.911 29.267-19.627 50.829 11.105 43.664 35.882-7.24 25.036-38.173 36.428-60.246 25.185-24.925-12.695-34.247-47.552-22.967-74.102 0.314-0.389 0.554-0.604 0.484-1.121 11.882-26.354 39.344-36.748 60.351-43.586 12.276-2.853 26.158-2.756 41.864 1.599 7.937 21.249 16.422 29.295 29.624 46.528 13.23-17.27 21.676-25.249 29.624-46.527 47.984-13.307 90.669 16.367 102.22 41.98-0.074 0.522 0.171 0.742 0.491 1.139 18.147 42.738-16.672 93.337-59.899 74.592-46.352-20.103-20.292-88.82 20.345-61.568 23.967 16.072 5.287 40.686-8.659 38.911-8.705-1.106-15.875-9.232-16.293-11.089-0.128-0.564-0.688-0.919-1.25-0.79-3.632 0.828 6.639 12.602 17.277 13.954 16.098 2.044 36.018-25.333 10.088-42.721-30.655-20.56-54.634 11.221-46.836 38.199 5.527 19.11 24.318 31.018 43.633 31.018 36.097 0 56.334-41.436 45.516-75.889 12.539 14.022 28.424 25.286 40.865 28.859 8.434 16.991 28.677 25.606 40.848 11.072 1.559 0.673 3.026 1.955 4.18 3.005-20.474 18.533 0.621 35.116 15.398 31.991 7.027-1.945 19.834 15.302 30.781 25.094 8.167-31.411-5.866-34.585-17.645-44.92-3.375-3.88-1.319-8.335 2.8-8.335 9.58 0 22.197 29.67 48.589 7.742 11.169-10.263 15.638-14.402 26.491-17.891-8.684-5.666-12.114-4.946-22.942-18.951-6.723-8.355-31.291-19.916-42.908 0.096-4.21 4.007-14.393 1.05-10.503-6.854 14.671-13.079 27.424-20.272 19.017-43.548-12.368 12.9-14.634 24.789-39.046 24.789-19.356 0-21.24 23.435-7.664 29.736-1.15 1.278-2.7 2.615-4.12 3.54-13.568-16.161-30.608-12.892-42.115 1.59-13.226-3.577-31.413-17.025-44.151-32.736-11.369-26.386-46.174-45.201-73.229-47.291 1.412-0.094 2.829-0.173 4.253-0.231v-2e-3c69.439 0.337 79.469 25.319 139.99 25.319 24.261 0 51.205-3.933 72.327-15.656 16.804 8.942 28.977 17.463 35.182 23.697 0.096 0.271 0.198 0.585 0.287 0.858l1.232 0.751c1.239 1.391 1.886 2.316 2.528 3.338 0.824 0.415 1.482 0.743 1.554 0.779 18.506 22.789 32.986 50.458 41.581 83.361 0.147 0.568 0.73 0.893 1.276 0.747 2.418-0.633-9.875-45.108-38.963-82.171 90.387 44.35 156.01 36.345 194.35 14.35 15.439 12.919 28.019 25.635 37.96 38.297-1.443 2.477-1.905 6.278-2.272 10.823-0.101 1.299 13.921 25.415 14.501 26.415 16.395 28.266 33.348 57.492 28.937 88.56-0.133 0.945 0.98 1.574 1.72 0.938 8.328-7.192 24.481-13.764 4.137-57.888 6.375 6.16 11.725 14.109 16.928 21.836 15.979 23.75 16.274 23.361 41.567 32.37 6.554 2.336 11.05 4.68 10.29 2.042-14.589-50.306-30.045-43.475-49.906-68.966 47.772 27.689 60.112-2.952 56.388-2.645-56.076 1.195-101.25-52.382-104.48-53.547-8.498-3.034-13.436-4.199-16.454-1.592-9.858-12.493-22.259-25.036-37.411-37.765 14.873-8.911 27.551-20.957 36.907-36.341 67.085 24.456 62.153 26.076 156.79 47.385 60.52 13.625 117.7 26.514 142.81 51.568-5.264 17.593 3.311 37.348 21.91 35.415 0.651 1.568 0.812 3.51 0.91 5.067-27.757-0.995-23.817 25.737-11.213 33.685 6.395 3.463 3.594 24.624 4.629 39.444l1.463-0.891c26.277-16.042 18.247-29.813 17.135-43.64 0.378-7.018 8.762-7.757 10.194 1.117 3.714 49.579 31.794 26.605 56.621 38.858l1.964 0.969c-0.677-2.994-0.715-3.325-1.735-6.451-6.284-19.241 5.029-30.07-10.19-46.769-5.74-6.298-13.4-8.648-22.224-6.157-5.853-0.057-11.033-9.275-2.767-12.234 17.887 0.745 33.526 5.118 43.964-18.024-8.855 0.321-13.627 1.97-20.691 1.97-21.67 0-22.708-16.511-36.211-16.511-10.131 0-18.537 10.863-14.588 21.166-1.709 0.115-3.797-9e-3 -5.422-0.327 1.526-21.353-13.447-30.838-32.167-28.062-20.036-20.09-59.877-32.402-105.6-43.408 41.742 2.851 116.34 1.498 135.65-35.674 16.371 1.645 32.635 3.172 48.726 4.58l29.561 20.673c-7.403 21.354 69.261 50.929 80.238 106.07 0.188 0.948 1.45 1.147 1.934 0.32 5.467-9.533 18.554-21.083-15.263-55.992 8.056 3.701 15.737 9.432 23.206 15.002 22.951 17.12 23.083 16.65 49.939 16.778 10.592 0.048 10.04 0.378 10.451-0.37 0.974-1.753-21.962-27.8-28.595-31.125-13.6-6.818-29.923-11.162-41.399-18.54 53.352 10.129 56.144-22.605 52.329-21.166-37.534 14.113-79.057 1.303-115.88-15.836-1-0.46-12.904-0.531-15.923 3.031l-26.433-18.485c119.1 10.287 230.26 12.907 230.25 10 2e-3 -0.567-0.454-1.044-1.046-1.044zm-291.71-69.991c14.084 13.294 17.185 35.683 8.391 53.865-40.48-4.082-82.931-9.007-123.41-14.559 23.479-16.524 78.266-74.009 115.02-39.306zm-120.64 40.636c-15.824 10.566-32.813 18.594-46.185 15.216-13.034-3.291-22.82-14.034-27.582-26.781 20.937 3.767 45.935 7.69 73.767 11.565zm-244.24 28.072c-37.163-29.866-89.493-60.863-159.63-94.765 54.074 13.474 117.92 32.939 194.71 60.679-7.559 13.967-19.546 25.495-35.083 34.086zm-1.992 1.077c-46.104 24.285-126.96 23.729-193.9-16.385-0.677-0.788-1.367-1.565-2.056-2.344-3.566-8.42-13.104-18.287-26.747-28.133 16.176-12.272 30.085-36.979 35.38-56.005 43.689 9.769 143.74 68.002 187.32 102.87zm-510.06-65.13c-10.811-7.447-22.316-13.69-34.466-18.734 0.194-5.704 0.985-11.384 2.481-16.926 11.382 5.393 22.058 11.365 31.986 17.911 9.927-6.545 20.603-12.517 31.983-17.909 1.496 5.542 2.287 11.221 2.481 16.925-12.15 5.043-23.654 11.285-34.465 18.733zm-314.09 46.384c-0.697 0.787-1.394 1.573-2.079 2.37-66.919 40.094-147.76 40.674-193.88 16.373 40.123-32.101 141.37-92.593 187.31-102.86 5.289 19.005 19.198 43.731 35.386 56.01-13.63 9.837-23.162 19.696-26.733 28.111zm-197.96 17.667c-15.535-8.592-27.522-20.121-35.08-34.087 76.789-27.74 140.63-47.204 194.71-60.678-70.134 33.902-122.46 64.898-159.63 94.765zm512.05-54.574c11.028-6.975 22.48-12.403 34.067-16.57-0.881 8.912-3.035 17.69-6.022 25.899-9.867 2.81-19.261 6.565-28.052 11.224-8.792-4.659-18.185-8.414-28.051-11.224-2.987-8.21-5.142-16.99-6.023-25.904 11.592 4.169 23.049 9.598 34.081 16.575zm555.61-21.471c1.179 13.951-0.703 26.593-7.518 40.081-85.582-30.955-159.87-53.408-224.81-67.944 2.284-8.999 3.001-17.141 2.519-24.783 70.011 9.032 146.79 26.612 229.81 52.646zm-339.8-45.691c-1.536-4.24-2.657-8.969-2.922-14.046 22.083-0.261 45.06 0.567 68.904 2.476 2.109 7.503 0.338 14.301-4.612 20.123-21.883-3.87-42.084-6.649-61.37-8.553zm59.591 10.465c-13.705 13.498-47.125 19.924-58.714-8.2 17.96 1.811 37.419 4.463 58.714 8.2zm8.601-21.855c12.977 1.072 26.208 2.462 39.693 4.172 0.606 7.872-0.164 16.115-2.328 24.617-14.38-3.193-28.299-5.995-41.782-8.414 4.59-5.969 6.261-13.085 4.417-20.375zm14.927-41.644c14.556 12.01 22.75 26.965 24.585 43.689-13.631-1.722-27.004-3.118-40.118-4.19-12.236-39.668-50.96-10.765-45.713-8.402 0.527 0.237 1.145 4e-3 1.383-0.523 0.997-2.219 12.004-10.545 23.104-9.704 8.847 0.673 15.222 6.875 18.975 18.445-23.632-1.869-46.413-2.677-68.32-2.417-0.185-41.776 54.32-63.125 86.104-36.898zm-88.141 39.02c0.251 4.955 1.283 9.592 2.723 13.787-45.902-4.381-81.957-3.268-114.17-0.927 36.508-8.656 73.928-12.298 111.45-12.86zm-115.58 13.868l0.106 1.389c33.345-2.551 70.764-3.916 119.03 0.79 12.345 31.586 49.748 24.021 63.619 8.885 13.515 2.41 27.764 5.255 42.836 8.598-5.197 18.556-19.129 43.175-35.228 55.17-68.454-48.152-172.62-67.28-249.07-36.575-0.244-5.72-1.075-11.415-2.602-16.975 18.622-8.657 39.111-15.77 61.31-21.282zm-95.208-18.924c14.976 9.102 26.255 22.106 31.401 39.065-11.146 5.265-21.63 11.079-31.401 17.441-9.772-6.362-20.256-12.176-31.402-17.441 5.138-16.932 16.41-29.957 31.402-39.065zm-36.504 57.179c-78.429-31.5-183.23-9.731-249.07 36.581-16.123-12.011-30.051-36.669-35.234-55.175 15.072-3.343 29.321-6.188 42.836-8.598 13.7 14.95 51.144 23.029 63.619-8.885 48.268-4.706 85.687-3.341 119.03-0.79l0.106-1.39c22.199 5.512 42.688 12.624 61.31 21.28-1.527 5.562-2.359 11.256-2.603 16.977zm-287.2-45.326c13.485-1.71 26.716-3.1 39.693-4.172-1.845 7.29-0.174 14.406 4.418 20.375-13.483 2.419-27.402 5.221-41.782 8.414-2.165-8.503-2.936-16.746-2.329-24.617zm46.513 15.77c-5.015-5.899-6.698-12.724-4.612-20.123 23.844-1.908 46.821-2.737 68.904-2.476-0.265 5.077-1.385 9.807-2.922 14.046-20.47 2.021-40.76 4.909-61.37 8.553zm60.495-6.288c-11.428 27.732-44.711 21.991-58.714 8.2 21.294-3.737 40.752-6.389 58.714-8.2zm117.35-3.418c-32.214-2.342-68.272-3.455-114.18 0.926 1.44-4.195 2.471-8.832 2.723-13.787 37.52 0.561 74.943 4.203 111.46 12.861zm-113.49-14.984c-21.907-0.259-44.688 0.548-68.32 2.417 10.671-32.892 40.307-12.683 42.079-8.74 0.566 1.257 2.474 0.404 1.905-0.86-2.55-5.665-35.124-26.235-46.235 9.784-13.114 1.072-26.487 2.468-40.118 4.191 8.141-74.158 110.97-69.173 110.69-6.792zm-112.97 9.182c-0.483 7.647 0.236 15.788 2.519 24.782-64.942 14.535-139.22 36.987-224.8 67.94-6.791-13.442-8.699-26.07-7.514-40.08 83.017-26.03 159.79-43.609 229.8-52.642zm-356.72 89.057c-4.776 12.782-14.581 23.497-27.582 26.78-13.372 3.378-30.361-4.65-46.184-15.215 27.833-3.876 52.829-7.798 73.766-11.565zm-105.52-10.162c7.311 6.041 16.392 13.54 26.136 20.397-40.465 5.55-82.917 10.475-123.41 14.559-18.655-38.57 17.251-101.12 97.275-34.956zm50.583 69.685c-1.541-0.157-121.28 14.422-146.83-32.733 40.516-4.096 83.539-9.083 124.92-14.797 13.667 9.338 33.75 20.859 49.785 16.816 14.127-3.567 24.644-15.38 29.45-29.24 54.863-9.987 45.202-10.463 110.33-31.46 2.068 13.836 6.62 26.871 13.414 38.573-83.069 30.32-52.439 23.068-181.07 52.841zm700.64-67.349c-0.256-1.275-24.34-3.66-27.891-3.66-41.476 0-75.585 12.639-101.58 21.405-9.098 3.1-68.401 10.879-108.94-10.815 67.877-35.407 164.41-57.161 239.02-31.368 0.794 8.919 2.839 17.715 5.723 25.973-2.09-0.557-4.205-1.063-6.336-1.535zm36.83 47.045c-11.425-14.815-19.435-22.605-27.136-42.393 9.548 2.828 18.632 6.566 27.136 11.162 8.504-4.596 17.588-8.334 27.136-11.162-7.669 19.705-15.54 27.355-27.136 42.393zm166.29-29.3c-1.002-0.338-74.321-26.587-101.77-21.367-2.396 0.106-27.377 2.054-27.693 3.621-2.133 0.472-4.251 0.979-6.344 1.537 2.884-8.257 4.929-17.051 5.724-25.969 75.519-26.115 172.49-3.349 239.03 31.359-38.904 20.822-97.541 14.707-108.95 10.819zm571.17 49.604c-126.16-29.202-95.947-21.771-181.06-52.837 6.795-11.702 11.347-24.737 13.417-38.574 65.18 21.013 55.502 21.478 110.32 31.457 6.697 19.312 22.343 30.077 36.483 30.077 13.245-1e-3 28.587-7.974 42.752-17.652 41.392 5.715 84.409 10.701 124.92 14.797-25.563 47.175-144.52 32.494-146.84 32.732z\"/>\n	<path d=\"m1701 355.47c-48.985 12.78-45.586 39.748-43.84 40.8 9.508 5.727 38.135-0.343 45.131-39.605 0.135-0.738-0.543-1.388-1.291-1.195z\"/>\n	<path d=\"m984.38 356.66c8.342 46.805 45.409 43.768 45.637 38.763 1.599-30.614-46.258-42.346-45.637-38.763z\"/>\n	<path d=\"m1706.5 383.99c-26.064 47.747-18.669 79.964 1.279 78.008 29.384-1.903 15.998-48.358-1.279-78.008z\"/>\n	<path d=\"m980.18 383.99c-23.765 40.771-25.778 78.076 0.4 78.09 19.73-3e-3 23.652-34.093-0.4-78.09z\"/>\n	<path d=\"m1711.6 357.23c8.278 46.505 45.354 44.073 45.631 38.768 1.615-30.768-46.242-42.163-45.631-38.768z\"/>\n	<path d=\"m973.84 356.04c-30.395 7.935-45.313 21.382-44.336 39.965 0.086 1.782 5.682 2.691 8.369 2.69 28.92 3e-3 41.234-44.011 35.967-42.655z\"/>\n	<path d=\"m2516.9 282.29c-1 0.918 5.287 47.481 36.062 48.273 1.753 0 5.723-8.545 1.56-20.019-7.917-21.81-36.408-29.378-37.622-28.254z\"/>\n	<path d=\"m132.13 310.54c-4.145 11.424-0.197 20.024 1.532 20.02 30.087-0.071 37.093-47.347 36.09-48.274-1.014-0.938-29.532 5.977-37.622 28.254z\"/>\n	<path d=\"m2545.5 279.99c44.065 28.73 78.278 25.617 77.872 4.805 0.398-30.399-48.579-18.941-77.872-4.805z\"/>\n	<path d=\"m141.22 279.99c-43.549-21.03-78.189-18.699-77.872 4.803-0.398 20.675 33.562 24.064 77.872-4.803z\"/>\n	<path d=\"m2519.2 272.87c39.402-3.88 48.053-31.818 43.008-41.901-0.646-1.294-27.204-8.267-44.097 40.519-0.257 0.738 0.369 1.475 1.089 1.382z\"/>\n	<path d=\"m168.59 271.49c-16.532-47.74-43.174-42.358-44.098-40.517-1.98 3.955-2.011 11.503 2.375 19.451 10.903 19.751 43.236 25.465 41.723 21.066z\"/>\n</svg>\n			<h2>Photos</h2>		\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6f9d706\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-20.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-20.jpg\" title=\"EmilyHunt-20\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6f9d706\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-8.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-8.jpg\" title=\"EmilyHunt-8\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6f9d706\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-14.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-14.jpg\" title=\"EmilyHunt-14\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6f9d706\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-19.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-19.jpg\" title=\"EmilyHunt-19\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6f9d706\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-17.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-17.jpg\" title=\"EmilyHunt-17\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6f9d706\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-16.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-16.jpg\" title=\"EmilyHunt-16\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6f9d706\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-3.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-3.jpg\" title=\"EmilyHunt-3\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6f9d706\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-7.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-7.jpg\" title=\"EmilyHunt-7\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6f9d706\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-1.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-1.jpg\" title=\"EmilyHunt-1\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6f9d706\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-12.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-12.jpg\" title=\"EmilyHunt-12\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6f9d706\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-11.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-11.jpg\" title=\"EmilyHunt-11\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6f9d706\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-10.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-10.jpg\" title=\"EmilyHunt-10\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6f9d706\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-9.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-9.jpg\" title=\"EmilyHunt-9\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6f9d706\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-15.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-15.jpg\" title=\"EmilyHunt-15\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6f9d706\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-18.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-18.jpg\" title=\"EmilyHunt-18\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6f9d706\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-5.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-5.jpg\" title=\"EmilyHunt-5\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6f9d706\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-2.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-2.jpg\" title=\"EmilyHunt-2\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"6f9d706\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-6.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-6.jpg\" title=\"EmilyHunt-6\" />\n					</a>\n			<h2>Rates</h2>		\n		<ul>\n									<li><a href=\"#\">				\n											&bull;&nbsp;1 Hour\n																			$700\n				</a></li>												<li><a href=\"#\">				\n											&bull;&nbsp;1&frac12; Hours\n																			$850\n				</a></li>												<li><a href=\"#\">				\n											&bull;&nbsp;2 Hours\n																			$1000\n				</a></li>												<li><a href=\"#\">				\n											&bull;&nbsp;Weekend Getaway\n																			$3000\n				</a></li>												<li><a href=\"#\">				\n											&bull;&nbsp;Two days\n																			$3500\n															<p>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Fly Me To You Companionship</p>\n				</a></li>					\n		</ul>\n			<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<svg enable-background=\"new 0 0 2686.688 505.889\" version=\"1.1\" viewBox=\"0 0 2686.688 505.889\" xml:space=\"preserve\" xmlns=\"http://www.w3.org/2000/svg\">\n	<path d=\"m1400.9 146.11c16.118-9.106 40.85-14.041 41.217-41.839 0.409-30.846-36.902-21.878-29.688 4.104 5.297 19.082-2.352 24.892-12.807 36.113-0.351 0.377-0.375 0.954-0.057 1.359 0.324 0.409 0.893 0.514 1.335 0.263z\"/>\n	<path d=\"m1285.8 146.11c0.454 0.255 1.016 0.14 1.335-0.263 0.785-1-0.457-1.793-2.582-4.037-25.161-26.502-0.638-34.629-12.863-50.712-8.176-10.751-27.397-8.814-27.105 13.173 0.366 27.816 25.152 32.764 41.215 41.839z\"/>\n	<path d=\"m1448 114.89c19.564-11.035 47.46-16.181 47.888-48.528 0.469-35.63-42.542-25.243-34.217 4.731 6.185 22.273-2.72 29.068-14.947 42.172-0.351 0.377-0.375 0.954-0.057 1.359 0.313 0.4 0.878 0.518 1.333 0.266z\"/>\n	<path d=\"m1238.7 114.89c0.455 0.252 1.02 0.134 1.333-0.266 0.785-1-0.404-1.745-2.998-4.474-29.48-31.036-0.758-40.295-14.98-59.005-9.418-12.385-31.577-10.239-31.242 15.217 0.427 32.342 28.314 37.487 47.887 48.528z\"/>\n	<path d=\"m2512 275.94c-64.212 0.265-145.8-3.779-232.63-11.36l-0.34-0.238-0.137 0.196c-6.237-0.545-12.498-1.107-18.784-1.689 52.311-3.386 198.38-8.556 201.34-58.401 1.741-29.462-29.559-29.832-37.678-14.575-6.094 11.442 2.217 27.353 17.594 20.976 13.025-5.4 6.783-19.429-0.866-20.016-5.048-0.374-11.484 4.168-8.966 5.476 0.499 0.257 1.123 0.041 1.404-0.44 0.438-0.751 4.209-3.362 7.71-2.92 5.161 0.655 10.859 11.429-0.081 15.971-13.827 5.74-19.952-8.661-14.947-18.061 7.111-13.351 35.356-13.689 33.744 13.469-2.865 48.214-150.77 53.294-201.34 56.567-13.259 0.859-8.082 1.048-27.123-0.861 8.765-18.857 5.393-41.861-9.168-55.607-38.411-36.266-93.804 22.684-119.5 40.409-29.258-4.047-55.43-8.148-77.128-12.072-12.526-39.093 25.612-58.716 47.165-43.384 15.278 10.865 16.887 37.968-8.873 39.925-20.762 1.576-21.294-20.482-12.578-25.74 5.35-3.231 13.221-1.905 14.253-1.071 0.453 0.364 1.111 0.29 1.47-0.159 2.125-2.622-9.878-4.739-16.802-0.56-10.456 6.314-9.389 31.361 13.817 29.616 27.43-2.082 26.99-31.573 9.926-43.712-22.829-16.237-62.753 4.038-50.701 44.662-53.686-9.824-43.573-10.133-109.3-31.306 8.029-61.449-78.539-134.82-136.26-61.591l1.452 1.481c72.356-54.856 114.77 6.246 120.08 55.431-82.994-25.98-159.75-43.517-229.77-52.519-1.675-17.737-10.176-33.03-25.37-45.566-33.149-27.356-89.751-4.893-89.535 38.543-60.319 0.904-123.17 10.06-177.42 35.206-5.414-17.609-17.331-31.207-33.305-40.569-15.671 9.179-27.808 22.677-33.309 40.568-54.262-25.15-117.13-34.301-177.42-35.206 0.11-22.139-16.438-43.856-43.058-49.22-38.497-7.753-68.738 23.331-71.846 56.243-70.009 9.002-146.76 26.538-229.75 52.516 5.351-49.523 47.911-110.14 120.08-55.428l1.452-1.481c-57.296-72.696-144.43-0.998-136.26 61.587-65.922 21.238-55.569 21.476-109.31 31.31 17.071-57.538-64.585-67.774-62.534-19.093 0.826 19.685 37.328 25.877 41.184 6.192 4.437-22.642-18.699-21.436-22.254-18.577-1.074 0.865 0.233 2.496 1.313 1.629 1.607-1.298 23.032-4.583 18.89 16.545-3.342 17.04-36.314 11.515-37.045-5.879-1.922-45.971 75.744-35.39 58.121 19.605-21.697 3.924-47.868 8.025-77.125 12.071-13.78-9.505-26.457-20.59-34.71-27.211-72.162-57.853-113.37 0.64-93.959 42.409-24.726 2.479-225.26-1.728-228.47-55.705-2.153-36.265 46.921-22.94 33.197 1.529-4.802 8.566-23.054 3.05-20.41-6.308 3.266-11.568 13.012-4.755 13.639-3.68 0.695 1.191 2.415 0.258 1.894-0.886-1.144-2.506-13.653-9.775-17.54 3.995-3.358 11.893 18.303 18.491 24.244 7.897 15.607-27.806-39.471-42.259-37.106-2.428 2.965 50.009 149.62 55.054 201.34 58.401-6.275 0.58-12.523 1.141-18.749 1.685l-0.133-0.19-0.33 0.231c-86.857 7.584-168.46 11.63-232.68 11.365-0.576-2e-3 -1.047 0.464-1.049 1.041-0.011 3.002 112.75 0.15 230.3-10.004l-26.469 18.51c-3.01-3.588-14.942-3.512-15.942-3.052-36.764 17.113-78.315 29.959-115.88 15.836-3.544-1.338-1.372 31.361 52.329 21.166-11.474 7.376-27.8 11.722-41.399 18.54-6.658 3.338-29.556 29.395-28.595 31.125 0.411 0.748-0.141 0.418 10.451 0.37 27.012-0.129 27.034 0.307 49.939-16.778 7.468-5.57 15.15-11.3 23.206-15.002-33.815 34.907-20.732 46.453-15.263 55.992 0.488 0.827 1.745 0.626 1.933-0.32 6.127-30.779 31.804-52.745 56.632-73.989 0.99-0.847 22.087-18.854 22.424-20.116 1.447-5.503 2.098-9.29 1.193-11.941l29.605-20.704c16.074-1.407 32.32-2.932 48.674-4.575 19.282 37.116 93.738 38.536 135.65 35.674-45.72 11.006-85.56 23.319-105.6 43.408-19.331-2.866-33.658 7.17-32.166 28.062-1.624 0.318-3.712 0.442-5.422 0.327 3.935-10.266-4.42-21.166-14.588-21.166-13.534 0-14.523 16.511-36.211 16.511-7.067 0-11.833-1.649-20.693-1.97 10.436 23.137 26.106 18.767 43.964 18.024 8.265 2.959 3.085 12.177-2.767 12.234-8.813-2.487-16.479-0.146-22.224 6.157-14.99 16.447-4.076 28.049-10.19 46.769-1.009 3.076-1.055 3.44-1.735 6.451 10.312-5.087 16.416-5.193 31.473-5.596 38.289-2.949 19.52-40.753 32.664-40.753 6.323 0 4.299 8.683 3.688 12.424-2.507 15.285-1.577 24.668 19.554 37.511 1.028-14.712-1.77-35.979 4.629-39.444 12.676-7.994 16.435-34.676-11.213-33.685 0.098-1.557 0.259-3.499 0.91-5.067 18.58 1.93 27.183-17.795 21.91-35.417 41.187-41.099 169.63-49.693 252.09-81.206 16.364-6.254 32.192-12.163 47.515-17.749 9.318 15.323 21.968 27.391 36.904 36.341-15.155 12.732-27.557 25.275-37.417 37.771-3.453-2.984-9.84-0.772-16.456 1.591-3.376 1.218-48.291 54.744-104.48 53.547-3.75-0.309 4.197 14.414 21.584 14.414 9.632 0 21.322-3.954 34.804-11.768-19.918 25.565-35.308 18.628-49.906 68.966-0.111 0.385 9e-3 0.803 0.309 1.071 0.64 0.57 30.933-9.797 35.847-14.836 12.032-12.337 20.344-30.613 32.629-42.484-20.343 44.122-4.193 50.695 4.137 57.888 0.725 0.628 1.856 0.019 1.72-0.938-7.824-55.103 52.571-106.2 41.167-125.8 9.942-12.664 22.524-25.382 37.966-38.303 38.305 21.978 103.92 30.026 194.34-14.339-28.142 35.863-41.633 81.463-38.956 82.164 0.545 0.146 1.126-0.177 1.276-0.747 8.594-32.9 23.072-60.567 41.575-83.354 0.141-0.071 0.73-0.363 1.569-0.786 0.64-1.018 1.296-1.955 2.528-3.338l1.232-0.751c0.125-0.382 0.172-0.533 0.287-0.858 6.205-6.234 18.374-14.754 35.173-23.693 39.663 22.01 100.21 15.59 111.84 11.625 26.08-8.795 59.136-21.091 100.47-21.291v2e-3c1.425 0.058 2.843 0.137 4.256 0.231-17.555 1.357-59.455 15.348-73.221 47.279-12.739 15.716-30.932 29.17-44.161 32.748-11.578-14.572-28.596-17.692-42.115-1.59-1.42-0.925-2.97-2.262-4.12-3.54 14.283-6.628 11.38-32.037-10.503-29.572-21.314-0.641-26.296-14.615-36.206-24.952-8.355 23.127 4.132 30.278 19.017 43.548 3.879 7.882-6.277 10.875-10.503 6.854-11.541-19.881-36.047-8.623-42.908-0.096-10.837 14.016-14.298 13.312-22.942 18.951 29.79 9.577 32.493 45.241 69.785 12.189 4.415-3.284 8.211-2.21 9.404 0.435 1.947 4.312-3.067 7.401-6.88 10.236-12.506 9.28-18.278 16.675-12.073 40.544 10.484-9.378 22.363-25.239 29.675-25.239 0.15 0 2.81 0.525 4.792 0.525 14.601 0 30.333-15.514 11.712-32.37 1.154-1.049 2.621-2.332 4.18-3.005 12.112 14.463 32.343 6.068 40.848-11.072 12.443-3.574 28.333-14.842 40.873-28.867-10.845 34.524 9.443 75.898 45.508 75.898 19.316 0 38.106-11.908 43.633-31.018 7.8-26.982-16.185-58.756-46.836-38.199-25.944 17.401-5.987 44.762 10.087 42.721 10.652-1.354 20.896-13.13 17.277-13.954-0.562-0.128-1.121 0.226-1.248 0.79-0.418 1.857-7.588 9.983-16.293 11.089-14.098 1.795-32.591-22.861-8.657-38.911 29.267-19.627 50.829 11.105 43.664 35.882-7.24 25.036-38.173 36.428-60.246 25.185-24.925-12.695-34.247-47.552-22.967-74.102 0.314-0.389 0.554-0.604 0.484-1.121 11.882-26.354 39.344-36.748 60.351-43.586 12.276-2.853 26.158-2.756 41.864 1.599 7.937 21.249 16.422 29.295 29.624 46.528 13.23-17.27 21.676-25.249 29.624-46.527 47.984-13.307 90.669 16.367 102.22 41.98-0.074 0.522 0.171 0.742 0.491 1.139 18.147 42.738-16.672 93.337-59.899 74.592-46.352-20.103-20.292-88.82 20.345-61.568 23.967 16.072 5.287 40.686-8.659 38.911-8.705-1.106-15.875-9.232-16.293-11.089-0.128-0.564-0.688-0.919-1.25-0.79-3.632 0.828 6.639 12.602 17.277 13.954 16.098 2.044 36.018-25.333 10.088-42.721-30.655-20.56-54.634 11.221-46.836 38.199 5.527 19.11 24.318 31.018 43.633 31.018 36.097 0 56.334-41.436 45.516-75.889 12.539 14.022 28.424 25.286 40.865 28.859 8.434 16.991 28.677 25.606 40.848 11.072 1.559 0.673 3.026 1.955 4.18 3.005-20.474 18.533 0.621 35.116 15.398 31.991 7.027-1.945 19.834 15.302 30.781 25.094 8.167-31.411-5.866-34.585-17.645-44.92-3.375-3.88-1.319-8.335 2.8-8.335 9.58 0 22.197 29.67 48.589 7.742 11.169-10.263 15.638-14.402 26.491-17.891-8.684-5.666-12.114-4.946-22.942-18.951-6.723-8.355-31.291-19.916-42.908 0.096-4.21 4.007-14.393 1.05-10.503-6.854 14.671-13.079 27.424-20.272 19.017-43.548-12.368 12.9-14.634 24.789-39.046 24.789-19.356 0-21.24 23.435-7.664 29.736-1.15 1.278-2.7 2.615-4.12 3.54-13.568-16.161-30.608-12.892-42.115 1.59-13.226-3.577-31.413-17.025-44.151-32.736-11.369-26.386-46.174-45.201-73.229-47.291 1.412-0.094 2.829-0.173 4.253-0.231v-2e-3c69.439 0.337 79.469 25.319 139.99 25.319 24.261 0 51.205-3.933 72.327-15.656 16.804 8.942 28.977 17.463 35.182 23.697 0.096 0.271 0.198 0.585 0.287 0.858l1.232 0.751c1.239 1.391 1.886 2.316 2.528 3.338 0.824 0.415 1.482 0.743 1.554 0.779 18.506 22.789 32.986 50.458 41.581 83.361 0.147 0.568 0.73 0.893 1.276 0.747 2.418-0.633-9.875-45.108-38.963-82.171 90.387 44.35 156.01 36.345 194.35 14.35 15.439 12.919 28.019 25.635 37.96 38.297-1.443 2.477-1.905 6.278-2.272 10.823-0.101 1.299 13.921 25.415 14.501 26.415 16.395 28.266 33.348 57.492 28.937 88.56-0.133 0.945 0.98 1.574 1.72 0.938 8.328-7.192 24.481-13.764 4.137-57.888 6.375 6.16 11.725 14.109 16.928 21.836 15.979 23.75 16.274 23.361 41.567 32.37 6.554 2.336 11.05 4.68 10.29 2.042-14.589-50.306-30.045-43.475-49.906-68.966 47.772 27.689 60.112-2.952 56.388-2.645-56.076 1.195-101.25-52.382-104.48-53.547-8.498-3.034-13.436-4.199-16.454-1.592-9.858-12.493-22.259-25.036-37.411-37.765 14.873-8.911 27.551-20.957 36.907-36.341 67.085 24.456 62.153 26.076 156.79 47.385 60.52 13.625 117.7 26.514 142.81 51.568-5.264 17.593 3.311 37.348 21.91 35.415 0.651 1.568 0.812 3.51 0.91 5.067-27.757-0.995-23.817 25.737-11.213 33.685 6.395 3.463 3.594 24.624 4.629 39.444l1.463-0.891c26.277-16.042 18.247-29.813 17.135-43.64 0.378-7.018 8.762-7.757 10.194 1.117 3.714 49.579 31.794 26.605 56.621 38.858l1.964 0.969c-0.677-2.994-0.715-3.325-1.735-6.451-6.284-19.241 5.029-30.07-10.19-46.769-5.74-6.298-13.4-8.648-22.224-6.157-5.853-0.057-11.033-9.275-2.767-12.234 17.887 0.745 33.526 5.118 43.964-18.024-8.855 0.321-13.627 1.97-20.691 1.97-21.67 0-22.708-16.511-36.211-16.511-10.131 0-18.537 10.863-14.588 21.166-1.709 0.115-3.797-9e-3 -5.422-0.327 1.526-21.353-13.447-30.838-32.167-28.062-20.036-20.09-59.877-32.402-105.6-43.408 41.742 2.851 116.34 1.498 135.65-35.674 16.371 1.645 32.635 3.172 48.726 4.58l29.561 20.673c-7.403 21.354 69.261 50.929 80.238 106.07 0.188 0.948 1.45 1.147 1.934 0.32 5.467-9.533 18.554-21.083-15.263-55.992 8.056 3.701 15.737 9.432 23.206 15.002 22.951 17.12 23.083 16.65 49.939 16.778 10.592 0.048 10.04 0.378 10.451-0.37 0.974-1.753-21.962-27.8-28.595-31.125-13.6-6.818-29.923-11.162-41.399-18.54 53.352 10.129 56.144-22.605 52.329-21.166-37.534 14.113-79.057 1.303-115.88-15.836-1-0.46-12.904-0.531-15.923 3.031l-26.433-18.485c119.1 10.287 230.26 12.907 230.25 10 2e-3 -0.567-0.454-1.044-1.046-1.044zm-291.71-69.991c14.084 13.294 17.185 35.683 8.391 53.865-40.48-4.082-82.931-9.007-123.41-14.559 23.479-16.524 78.266-74.009 115.02-39.306zm-120.64 40.636c-15.824 10.566-32.813 18.594-46.185 15.216-13.034-3.291-22.82-14.034-27.582-26.781 20.937 3.767 45.935 7.69 73.767 11.565zm-244.24 28.072c-37.163-29.866-89.493-60.863-159.63-94.765 54.074 13.474 117.92 32.939 194.71 60.679-7.559 13.967-19.546 25.495-35.083 34.086zm-1.992 1.077c-46.104 24.285-126.96 23.729-193.9-16.385-0.677-0.788-1.367-1.565-2.056-2.344-3.566-8.42-13.104-18.287-26.747-28.133 16.176-12.272 30.085-36.979 35.38-56.005 43.689 9.769 143.74 68.002 187.32 102.87zm-510.06-65.13c-10.811-7.447-22.316-13.69-34.466-18.734 0.194-5.704 0.985-11.384 2.481-16.926 11.382 5.393 22.058 11.365 31.986 17.911 9.927-6.545 20.603-12.517 31.983-17.909 1.496 5.542 2.287 11.221 2.481 16.925-12.15 5.043-23.654 11.285-34.465 18.733zm-314.09 46.384c-0.697 0.787-1.394 1.573-2.079 2.37-66.919 40.094-147.76 40.674-193.88 16.373 40.123-32.101 141.37-92.593 187.31-102.86 5.289 19.005 19.198 43.731 35.386 56.01-13.63 9.837-23.162 19.696-26.733 28.111zm-197.96 17.667c-15.535-8.592-27.522-20.121-35.08-34.087 76.789-27.74 140.63-47.204 194.71-60.678-70.134 33.902-122.46 64.898-159.63 94.765zm512.05-54.574c11.028-6.975 22.48-12.403 34.067-16.57-0.881 8.912-3.035 17.69-6.022 25.899-9.867 2.81-19.261 6.565-28.052 11.224-8.792-4.659-18.185-8.414-28.051-11.224-2.987-8.21-5.142-16.99-6.023-25.904 11.592 4.169 23.049 9.598 34.081 16.575zm555.61-21.471c1.179 13.951-0.703 26.593-7.518 40.081-85.582-30.955-159.87-53.408-224.81-67.944 2.284-8.999 3.001-17.141 2.519-24.783 70.011 9.032 146.79 26.612 229.81 52.646zm-339.8-45.691c-1.536-4.24-2.657-8.969-2.922-14.046 22.083-0.261 45.06 0.567 68.904 2.476 2.109 7.503 0.338 14.301-4.612 20.123-21.883-3.87-42.084-6.649-61.37-8.553zm59.591 10.465c-13.705 13.498-47.125 19.924-58.714-8.2 17.96 1.811 37.419 4.463 58.714 8.2zm8.601-21.855c12.977 1.072 26.208 2.462 39.693 4.172 0.606 7.872-0.164 16.115-2.328 24.617-14.38-3.193-28.299-5.995-41.782-8.414 4.59-5.969 6.261-13.085 4.417-20.375zm14.927-41.644c14.556 12.01 22.75 26.965 24.585 43.689-13.631-1.722-27.004-3.118-40.118-4.19-12.236-39.668-50.96-10.765-45.713-8.402 0.527 0.237 1.145 4e-3 1.383-0.523 0.997-2.219 12.004-10.545 23.104-9.704 8.847 0.673 15.222 6.875 18.975 18.445-23.632-1.869-46.413-2.677-68.32-2.417-0.185-41.776 54.32-63.125 86.104-36.898zm-88.141 39.02c0.251 4.955 1.283 9.592 2.723 13.787-45.902-4.381-81.957-3.268-114.17-0.927 36.508-8.656 73.928-12.298 111.45-12.86zm-115.58 13.868l0.106 1.389c33.345-2.551 70.764-3.916 119.03 0.79 12.345 31.586 49.748 24.021 63.619 8.885 13.515 2.41 27.764 5.255 42.836 8.598-5.197 18.556-19.129 43.175-35.228 55.17-68.454-48.152-172.62-67.28-249.07-36.575-0.244-5.72-1.075-11.415-2.602-16.975 18.622-8.657 39.111-15.77 61.31-21.282zm-95.208-18.924c14.976 9.102 26.255 22.106 31.401 39.065-11.146 5.265-21.63 11.079-31.401 17.441-9.772-6.362-20.256-12.176-31.402-17.441 5.138-16.932 16.41-29.957 31.402-39.065zm-36.504 57.179c-78.429-31.5-183.23-9.731-249.07 36.581-16.123-12.011-30.051-36.669-35.234-55.175 15.072-3.343 29.321-6.188 42.836-8.598 13.7 14.95 51.144 23.029 63.619-8.885 48.268-4.706 85.687-3.341 119.03-0.79l0.106-1.39c22.199 5.512 42.688 12.624 61.31 21.28-1.527 5.562-2.359 11.256-2.603 16.977zm-287.2-45.326c13.485-1.71 26.716-3.1 39.693-4.172-1.845 7.29-0.174 14.406 4.418 20.375-13.483 2.419-27.402 5.221-41.782 8.414-2.165-8.503-2.936-16.746-2.329-24.617zm46.513 15.77c-5.015-5.899-6.698-12.724-4.612-20.123 23.844-1.908 46.821-2.737 68.904-2.476-0.265 5.077-1.385 9.807-2.922 14.046-20.47 2.021-40.76 4.909-61.37 8.553zm60.495-6.288c-11.428 27.732-44.711 21.991-58.714 8.2 21.294-3.737 40.752-6.389 58.714-8.2zm117.35-3.418c-32.214-2.342-68.272-3.455-114.18 0.926 1.44-4.195 2.471-8.832 2.723-13.787 37.52 0.561 74.943 4.203 111.46 12.861zm-113.49-14.984c-21.907-0.259-44.688 0.548-68.32 2.417 10.671-32.892 40.307-12.683 42.079-8.74 0.566 1.257 2.474 0.404 1.905-0.86-2.55-5.665-35.124-26.235-46.235 9.784-13.114 1.072-26.487 2.468-40.118 4.191 8.141-74.158 110.97-69.173 110.69-6.792zm-112.97 9.182c-0.483 7.647 0.236 15.788 2.519 24.782-64.942 14.535-139.22 36.987-224.8 67.94-6.791-13.442-8.699-26.07-7.514-40.08 83.017-26.03 159.79-43.609 229.8-52.642zm-356.72 89.057c-4.776 12.782-14.581 23.497-27.582 26.78-13.372 3.378-30.361-4.65-46.184-15.215 27.833-3.876 52.829-7.798 73.766-11.565zm-105.52-10.162c7.311 6.041 16.392 13.54 26.136 20.397-40.465 5.55-82.917 10.475-123.41 14.559-18.655-38.57 17.251-101.12 97.275-34.956zm50.583 69.685c-1.541-0.157-121.28 14.422-146.83-32.733 40.516-4.096 83.539-9.083 124.92-14.797 13.667 9.338 33.75 20.859 49.785 16.816 14.127-3.567 24.644-15.38 29.45-29.24 54.863-9.987 45.202-10.463 110.33-31.46 2.068 13.836 6.62 26.871 13.414 38.573-83.069 30.32-52.439 23.068-181.07 52.841zm700.64-67.349c-0.256-1.275-24.34-3.66-27.891-3.66-41.476 0-75.585 12.639-101.58 21.405-9.098 3.1-68.401 10.879-108.94-10.815 67.877-35.407 164.41-57.161 239.02-31.368 0.794 8.919 2.839 17.715 5.723 25.973-2.09-0.557-4.205-1.063-6.336-1.535zm36.83 47.045c-11.425-14.815-19.435-22.605-27.136-42.393 9.548 2.828 18.632 6.566 27.136 11.162 8.504-4.596 17.588-8.334 27.136-11.162-7.669 19.705-15.54 27.355-27.136 42.393zm166.29-29.3c-1.002-0.338-74.321-26.587-101.77-21.367-2.396 0.106-27.377 2.054-27.693 3.621-2.133 0.472-4.251 0.979-6.344 1.537 2.884-8.257 4.929-17.051 5.724-25.969 75.519-26.115 172.49-3.349 239.03 31.359-38.904 20.822-97.541 14.707-108.95 10.819zm571.17 49.604c-126.16-29.202-95.947-21.771-181.06-52.837 6.795-11.702 11.347-24.737 13.417-38.574 65.18 21.013 55.502 21.478 110.32 31.457 6.697 19.312 22.343 30.077 36.483 30.077 13.245-1e-3 28.587-7.974 42.752-17.652 41.392 5.715 84.409 10.701 124.92 14.797-25.563 47.175-144.52 32.494-146.84 32.732z\"/>\n	<path d=\"m1701 355.47c-48.985 12.78-45.586 39.748-43.84 40.8 9.508 5.727 38.135-0.343 45.131-39.605 0.135-0.738-0.543-1.388-1.291-1.195z\"/>\n	<path d=\"m984.38 356.66c8.342 46.805 45.409 43.768 45.637 38.763 1.599-30.614-46.258-42.346-45.637-38.763z\"/>\n	<path d=\"m1706.5 383.99c-26.064 47.747-18.669 79.964 1.279 78.008 29.384-1.903 15.998-48.358-1.279-78.008z\"/>\n	<path d=\"m980.18 383.99c-23.765 40.771-25.778 78.076 0.4 78.09 19.73-3e-3 23.652-34.093-0.4-78.09z\"/>\n	<path d=\"m1711.6 357.23c8.278 46.505 45.354 44.073 45.631 38.768 1.615-30.768-46.242-42.163-45.631-38.768z\"/>\n	<path d=\"m973.84 356.04c-30.395 7.935-45.313 21.382-44.336 39.965 0.086 1.782 5.682 2.691 8.369 2.69 28.92 3e-3 41.234-44.011 35.967-42.655z\"/>\n	<path d=\"m2516.9 282.29c-1 0.918 5.287 47.481 36.062 48.273 1.753 0 5.723-8.545 1.56-20.019-7.917-21.81-36.408-29.378-37.622-28.254z\"/>\n	<path d=\"m132.13 310.54c-4.145 11.424-0.197 20.024 1.532 20.02 30.087-0.071 37.093-47.347 36.09-48.274-1.014-0.938-29.532 5.977-37.622 28.254z\"/>\n	<path d=\"m2545.5 279.99c44.065 28.73 78.278 25.617 77.872 4.805 0.398-30.399-48.579-18.941-77.872-4.805z\"/>\n	<path d=\"m141.22 279.99c-43.549-21.03-78.189-18.699-77.872 4.803-0.398 20.675 33.562 24.064 77.872-4.803z\"/>\n	<path d=\"m2519.2 272.87c39.402-3.88 48.053-31.818 43.008-41.901-0.646-1.294-27.204-8.267-44.097 40.519-0.257 0.738 0.369 1.475 1.089 1.382z\"/>\n	<path d=\"m168.59 271.49c-16.532-47.74-43.174-42.358-44.098-40.517-1.98 3.955-2.011 11.503 2.375 19.451 10.903 19.751 43.236 25.465 41.723 21.066z\"/>\n</svg>\n			<h2>Contact</h2>		\n		<p>Screening is required for all new persons. My rates are for my time and companionship only. To really catch my eye send a detailed email.</p>		\n					<ul>\n							<li >\n					<a href=\"MeetMissEmilyHunt@protonmail.com\" target=\"_blank\" rel=\"nofollow noopener noreferrer\">						\n										MeetMissEmilyHunt@protonmail.com\n											</a>\n									</li>\n								<li >\n					<a href=\"tel:+15598022868\">						\n										+1 559-802-2868\n											</a>\n									</li>\n								<li >\n					<a href=\"https://twitter.com/meetemilyhunt\" target=\"_blank\" rel=\"nofollow noopener noreferrer\">						\n										Twitter: @meetemilyhunt\n											</a>\n									</li>\n								<li >\n					<a href=\"https://instagram.com/Almightywoman\" target=\"_blank\" rel=\"nofollow noopener noreferrer\">						\n										Instagram: @Almightywoman\n											</a>\n									</li>\n								<li >\n					<a href=\"https://onlyfans.com/missemilyhunt\" target=\"_blank\" rel=\"nofollow noopener noreferrer\">						\n										OnlyFans: @Missemilyhunt\n											</a>\n									</li>\n						</ul>\n			<h2>Touring</h2>		\n		<p>[text-blocks id=\"touring\"]</p><p>Please use the form below if you wish to be notified when I\'m visiting your city.</p>		\n			<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<svg enable-background=\"new 0 0 2686.688 505.889\" version=\"1.1\" viewBox=\"0 0 2686.688 505.889\" xml:space=\"preserve\" xmlns=\"http://www.w3.org/2000/svg\">\n	<path d=\"m1400.9 146.11c16.118-9.106 40.85-14.041 41.217-41.839 0.409-30.846-36.902-21.878-29.688 4.104 5.297 19.082-2.352 24.892-12.807 36.113-0.351 0.377-0.375 0.954-0.057 1.359 0.324 0.409 0.893 0.514 1.335 0.263z\"/>\n	<path d=\"m1285.8 146.11c0.454 0.255 1.016 0.14 1.335-0.263 0.785-1-0.457-1.793-2.582-4.037-25.161-26.502-0.638-34.629-12.863-50.712-8.176-10.751-27.397-8.814-27.105 13.173 0.366 27.816 25.152 32.764 41.215 41.839z\"/>\n	<path d=\"m1448 114.89c19.564-11.035 47.46-16.181 47.888-48.528 0.469-35.63-42.542-25.243-34.217 4.731 6.185 22.273-2.72 29.068-14.947 42.172-0.351 0.377-0.375 0.954-0.057 1.359 0.313 0.4 0.878 0.518 1.333 0.266z\"/>\n	<path d=\"m1238.7 114.89c0.455 0.252 1.02 0.134 1.333-0.266 0.785-1-0.404-1.745-2.998-4.474-29.48-31.036-0.758-40.295-14.98-59.005-9.418-12.385-31.577-10.239-31.242 15.217 0.427 32.342 28.314 37.487 47.887 48.528z\"/>\n	<path d=\"m2512 275.94c-64.212 0.265-145.8-3.779-232.63-11.36l-0.34-0.238-0.137 0.196c-6.237-0.545-12.498-1.107-18.784-1.689 52.311-3.386 198.38-8.556 201.34-58.401 1.741-29.462-29.559-29.832-37.678-14.575-6.094 11.442 2.217 27.353 17.594 20.976 13.025-5.4 6.783-19.429-0.866-20.016-5.048-0.374-11.484 4.168-8.966 5.476 0.499 0.257 1.123 0.041 1.404-0.44 0.438-0.751 4.209-3.362 7.71-2.92 5.161 0.655 10.859 11.429-0.081 15.971-13.827 5.74-19.952-8.661-14.947-18.061 7.111-13.351 35.356-13.689 33.744 13.469-2.865 48.214-150.77 53.294-201.34 56.567-13.259 0.859-8.082 1.048-27.123-0.861 8.765-18.857 5.393-41.861-9.168-55.607-38.411-36.266-93.804 22.684-119.5 40.409-29.258-4.047-55.43-8.148-77.128-12.072-12.526-39.093 25.612-58.716 47.165-43.384 15.278 10.865 16.887 37.968-8.873 39.925-20.762 1.576-21.294-20.482-12.578-25.74 5.35-3.231 13.221-1.905 14.253-1.071 0.453 0.364 1.111 0.29 1.47-0.159 2.125-2.622-9.878-4.739-16.802-0.56-10.456 6.314-9.389 31.361 13.817 29.616 27.43-2.082 26.99-31.573 9.926-43.712-22.829-16.237-62.753 4.038-50.701 44.662-53.686-9.824-43.573-10.133-109.3-31.306 8.029-61.449-78.539-134.82-136.26-61.591l1.452 1.481c72.356-54.856 114.77 6.246 120.08 55.431-82.994-25.98-159.75-43.517-229.77-52.519-1.675-17.737-10.176-33.03-25.37-45.566-33.149-27.356-89.751-4.893-89.535 38.543-60.319 0.904-123.17 10.06-177.42 35.206-5.414-17.609-17.331-31.207-33.305-40.569-15.671 9.179-27.808 22.677-33.309 40.568-54.262-25.15-117.13-34.301-177.42-35.206 0.11-22.139-16.438-43.856-43.058-49.22-38.497-7.753-68.738 23.331-71.846 56.243-70.009 9.002-146.76 26.538-229.75 52.516 5.351-49.523 47.911-110.14 120.08-55.428l1.452-1.481c-57.296-72.696-144.43-0.998-136.26 61.587-65.922 21.238-55.569 21.476-109.31 31.31 17.071-57.538-64.585-67.774-62.534-19.093 0.826 19.685 37.328 25.877 41.184 6.192 4.437-22.642-18.699-21.436-22.254-18.577-1.074 0.865 0.233 2.496 1.313 1.629 1.607-1.298 23.032-4.583 18.89 16.545-3.342 17.04-36.314 11.515-37.045-5.879-1.922-45.971 75.744-35.39 58.121 19.605-21.697 3.924-47.868 8.025-77.125 12.071-13.78-9.505-26.457-20.59-34.71-27.211-72.162-57.853-113.37 0.64-93.959 42.409-24.726 2.479-225.26-1.728-228.47-55.705-2.153-36.265 46.921-22.94 33.197 1.529-4.802 8.566-23.054 3.05-20.41-6.308 3.266-11.568 13.012-4.755 13.639-3.68 0.695 1.191 2.415 0.258 1.894-0.886-1.144-2.506-13.653-9.775-17.54 3.995-3.358 11.893 18.303 18.491 24.244 7.897 15.607-27.806-39.471-42.259-37.106-2.428 2.965 50.009 149.62 55.054 201.34 58.401-6.275 0.58-12.523 1.141-18.749 1.685l-0.133-0.19-0.33 0.231c-86.857 7.584-168.46 11.63-232.68 11.365-0.576-2e-3 -1.047 0.464-1.049 1.041-0.011 3.002 112.75 0.15 230.3-10.004l-26.469 18.51c-3.01-3.588-14.942-3.512-15.942-3.052-36.764 17.113-78.315 29.959-115.88 15.836-3.544-1.338-1.372 31.361 52.329 21.166-11.474 7.376-27.8 11.722-41.399 18.54-6.658 3.338-29.556 29.395-28.595 31.125 0.411 0.748-0.141 0.418 10.451 0.37 27.012-0.129 27.034 0.307 49.939-16.778 7.468-5.57 15.15-11.3 23.206-15.002-33.815 34.907-20.732 46.453-15.263 55.992 0.488 0.827 1.745 0.626 1.933-0.32 6.127-30.779 31.804-52.745 56.632-73.989 0.99-0.847 22.087-18.854 22.424-20.116 1.447-5.503 2.098-9.29 1.193-11.941l29.605-20.704c16.074-1.407 32.32-2.932 48.674-4.575 19.282 37.116 93.738 38.536 135.65 35.674-45.72 11.006-85.56 23.319-105.6 43.408-19.331-2.866-33.658 7.17-32.166 28.062-1.624 0.318-3.712 0.442-5.422 0.327 3.935-10.266-4.42-21.166-14.588-21.166-13.534 0-14.523 16.511-36.211 16.511-7.067 0-11.833-1.649-20.693-1.97 10.436 23.137 26.106 18.767 43.964 18.024 8.265 2.959 3.085 12.177-2.767 12.234-8.813-2.487-16.479-0.146-22.224 6.157-14.99 16.447-4.076 28.049-10.19 46.769-1.009 3.076-1.055 3.44-1.735 6.451 10.312-5.087 16.416-5.193 31.473-5.596 38.289-2.949 19.52-40.753 32.664-40.753 6.323 0 4.299 8.683 3.688 12.424-2.507 15.285-1.577 24.668 19.554 37.511 1.028-14.712-1.77-35.979 4.629-39.444 12.676-7.994 16.435-34.676-11.213-33.685 0.098-1.557 0.259-3.499 0.91-5.067 18.58 1.93 27.183-17.795 21.91-35.417 41.187-41.099 169.63-49.693 252.09-81.206 16.364-6.254 32.192-12.163 47.515-17.749 9.318 15.323 21.968 27.391 36.904 36.341-15.155 12.732-27.557 25.275-37.417 37.771-3.453-2.984-9.84-0.772-16.456 1.591-3.376 1.218-48.291 54.744-104.48 53.547-3.75-0.309 4.197 14.414 21.584 14.414 9.632 0 21.322-3.954 34.804-11.768-19.918 25.565-35.308 18.628-49.906 68.966-0.111 0.385 9e-3 0.803 0.309 1.071 0.64 0.57 30.933-9.797 35.847-14.836 12.032-12.337 20.344-30.613 32.629-42.484-20.343 44.122-4.193 50.695 4.137 57.888 0.725 0.628 1.856 0.019 1.72-0.938-7.824-55.103 52.571-106.2 41.167-125.8 9.942-12.664 22.524-25.382 37.966-38.303 38.305 21.978 103.92 30.026 194.34-14.339-28.142 35.863-41.633 81.463-38.956 82.164 0.545 0.146 1.126-0.177 1.276-0.747 8.594-32.9 23.072-60.567 41.575-83.354 0.141-0.071 0.73-0.363 1.569-0.786 0.64-1.018 1.296-1.955 2.528-3.338l1.232-0.751c0.125-0.382 0.172-0.533 0.287-0.858 6.205-6.234 18.374-14.754 35.173-23.693 39.663 22.01 100.21 15.59 111.84 11.625 26.08-8.795 59.136-21.091 100.47-21.291v2e-3c1.425 0.058 2.843 0.137 4.256 0.231-17.555 1.357-59.455 15.348-73.221 47.279-12.739 15.716-30.932 29.17-44.161 32.748-11.578-14.572-28.596-17.692-42.115-1.59-1.42-0.925-2.97-2.262-4.12-3.54 14.283-6.628 11.38-32.037-10.503-29.572-21.314-0.641-26.296-14.615-36.206-24.952-8.355 23.127 4.132 30.278 19.017 43.548 3.879 7.882-6.277 10.875-10.503 6.854-11.541-19.881-36.047-8.623-42.908-0.096-10.837 14.016-14.298 13.312-22.942 18.951 29.79 9.577 32.493 45.241 69.785 12.189 4.415-3.284 8.211-2.21 9.404 0.435 1.947 4.312-3.067 7.401-6.88 10.236-12.506 9.28-18.278 16.675-12.073 40.544 10.484-9.378 22.363-25.239 29.675-25.239 0.15 0 2.81 0.525 4.792 0.525 14.601 0 30.333-15.514 11.712-32.37 1.154-1.049 2.621-2.332 4.18-3.005 12.112 14.463 32.343 6.068 40.848-11.072 12.443-3.574 28.333-14.842 40.873-28.867-10.845 34.524 9.443 75.898 45.508 75.898 19.316 0 38.106-11.908 43.633-31.018 7.8-26.982-16.185-58.756-46.836-38.199-25.944 17.401-5.987 44.762 10.087 42.721 10.652-1.354 20.896-13.13 17.277-13.954-0.562-0.128-1.121 0.226-1.248 0.79-0.418 1.857-7.588 9.983-16.293 11.089-14.098 1.795-32.591-22.861-8.657-38.911 29.267-19.627 50.829 11.105 43.664 35.882-7.24 25.036-38.173 36.428-60.246 25.185-24.925-12.695-34.247-47.552-22.967-74.102 0.314-0.389 0.554-0.604 0.484-1.121 11.882-26.354 39.344-36.748 60.351-43.586 12.276-2.853 26.158-2.756 41.864 1.599 7.937 21.249 16.422 29.295 29.624 46.528 13.23-17.27 21.676-25.249 29.624-46.527 47.984-13.307 90.669 16.367 102.22 41.98-0.074 0.522 0.171 0.742 0.491 1.139 18.147 42.738-16.672 93.337-59.899 74.592-46.352-20.103-20.292-88.82 20.345-61.568 23.967 16.072 5.287 40.686-8.659 38.911-8.705-1.106-15.875-9.232-16.293-11.089-0.128-0.564-0.688-0.919-1.25-0.79-3.632 0.828 6.639 12.602 17.277 13.954 16.098 2.044 36.018-25.333 10.088-42.721-30.655-20.56-54.634 11.221-46.836 38.199 5.527 19.11 24.318 31.018 43.633 31.018 36.097 0 56.334-41.436 45.516-75.889 12.539 14.022 28.424 25.286 40.865 28.859 8.434 16.991 28.677 25.606 40.848 11.072 1.559 0.673 3.026 1.955 4.18 3.005-20.474 18.533 0.621 35.116 15.398 31.991 7.027-1.945 19.834 15.302 30.781 25.094 8.167-31.411-5.866-34.585-17.645-44.92-3.375-3.88-1.319-8.335 2.8-8.335 9.58 0 22.197 29.67 48.589 7.742 11.169-10.263 15.638-14.402 26.491-17.891-8.684-5.666-12.114-4.946-22.942-18.951-6.723-8.355-31.291-19.916-42.908 0.096-4.21 4.007-14.393 1.05-10.503-6.854 14.671-13.079 27.424-20.272 19.017-43.548-12.368 12.9-14.634 24.789-39.046 24.789-19.356 0-21.24 23.435-7.664 29.736-1.15 1.278-2.7 2.615-4.12 3.54-13.568-16.161-30.608-12.892-42.115 1.59-13.226-3.577-31.413-17.025-44.151-32.736-11.369-26.386-46.174-45.201-73.229-47.291 1.412-0.094 2.829-0.173 4.253-0.231v-2e-3c69.439 0.337 79.469 25.319 139.99 25.319 24.261 0 51.205-3.933 72.327-15.656 16.804 8.942 28.977 17.463 35.182 23.697 0.096 0.271 0.198 0.585 0.287 0.858l1.232 0.751c1.239 1.391 1.886 2.316 2.528 3.338 0.824 0.415 1.482 0.743 1.554 0.779 18.506 22.789 32.986 50.458 41.581 83.361 0.147 0.568 0.73 0.893 1.276 0.747 2.418-0.633-9.875-45.108-38.963-82.171 90.387 44.35 156.01 36.345 194.35 14.35 15.439 12.919 28.019 25.635 37.96 38.297-1.443 2.477-1.905 6.278-2.272 10.823-0.101 1.299 13.921 25.415 14.501 26.415 16.395 28.266 33.348 57.492 28.937 88.56-0.133 0.945 0.98 1.574 1.72 0.938 8.328-7.192 24.481-13.764 4.137-57.888 6.375 6.16 11.725 14.109 16.928 21.836 15.979 23.75 16.274 23.361 41.567 32.37 6.554 2.336 11.05 4.68 10.29 2.042-14.589-50.306-30.045-43.475-49.906-68.966 47.772 27.689 60.112-2.952 56.388-2.645-56.076 1.195-101.25-52.382-104.48-53.547-8.498-3.034-13.436-4.199-16.454-1.592-9.858-12.493-22.259-25.036-37.411-37.765 14.873-8.911 27.551-20.957 36.907-36.341 67.085 24.456 62.153 26.076 156.79 47.385 60.52 13.625 117.7 26.514 142.81 51.568-5.264 17.593 3.311 37.348 21.91 35.415 0.651 1.568 0.812 3.51 0.91 5.067-27.757-0.995-23.817 25.737-11.213 33.685 6.395 3.463 3.594 24.624 4.629 39.444l1.463-0.891c26.277-16.042 18.247-29.813 17.135-43.64 0.378-7.018 8.762-7.757 10.194 1.117 3.714 49.579 31.794 26.605 56.621 38.858l1.964 0.969c-0.677-2.994-0.715-3.325-1.735-6.451-6.284-19.241 5.029-30.07-10.19-46.769-5.74-6.298-13.4-8.648-22.224-6.157-5.853-0.057-11.033-9.275-2.767-12.234 17.887 0.745 33.526 5.118 43.964-18.024-8.855 0.321-13.627 1.97-20.691 1.97-21.67 0-22.708-16.511-36.211-16.511-10.131 0-18.537 10.863-14.588 21.166-1.709 0.115-3.797-9e-3 -5.422-0.327 1.526-21.353-13.447-30.838-32.167-28.062-20.036-20.09-59.877-32.402-105.6-43.408 41.742 2.851 116.34 1.498 135.65-35.674 16.371 1.645 32.635 3.172 48.726 4.58l29.561 20.673c-7.403 21.354 69.261 50.929 80.238 106.07 0.188 0.948 1.45 1.147 1.934 0.32 5.467-9.533 18.554-21.083-15.263-55.992 8.056 3.701 15.737 9.432 23.206 15.002 22.951 17.12 23.083 16.65 49.939 16.778 10.592 0.048 10.04 0.378 10.451-0.37 0.974-1.753-21.962-27.8-28.595-31.125-13.6-6.818-29.923-11.162-41.399-18.54 53.352 10.129 56.144-22.605 52.329-21.166-37.534 14.113-79.057 1.303-115.88-15.836-1-0.46-12.904-0.531-15.923 3.031l-26.433-18.485c119.1 10.287 230.26 12.907 230.25 10 2e-3 -0.567-0.454-1.044-1.046-1.044zm-291.71-69.991c14.084 13.294 17.185 35.683 8.391 53.865-40.48-4.082-82.931-9.007-123.41-14.559 23.479-16.524 78.266-74.009 115.02-39.306zm-120.64 40.636c-15.824 10.566-32.813 18.594-46.185 15.216-13.034-3.291-22.82-14.034-27.582-26.781 20.937 3.767 45.935 7.69 73.767 11.565zm-244.24 28.072c-37.163-29.866-89.493-60.863-159.63-94.765 54.074 13.474 117.92 32.939 194.71 60.679-7.559 13.967-19.546 25.495-35.083 34.086zm-1.992 1.077c-46.104 24.285-126.96 23.729-193.9-16.385-0.677-0.788-1.367-1.565-2.056-2.344-3.566-8.42-13.104-18.287-26.747-28.133 16.176-12.272 30.085-36.979 35.38-56.005 43.689 9.769 143.74 68.002 187.32 102.87zm-510.06-65.13c-10.811-7.447-22.316-13.69-34.466-18.734 0.194-5.704 0.985-11.384 2.481-16.926 11.382 5.393 22.058 11.365 31.986 17.911 9.927-6.545 20.603-12.517 31.983-17.909 1.496 5.542 2.287 11.221 2.481 16.925-12.15 5.043-23.654 11.285-34.465 18.733zm-314.09 46.384c-0.697 0.787-1.394 1.573-2.079 2.37-66.919 40.094-147.76 40.674-193.88 16.373 40.123-32.101 141.37-92.593 187.31-102.86 5.289 19.005 19.198 43.731 35.386 56.01-13.63 9.837-23.162 19.696-26.733 28.111zm-197.96 17.667c-15.535-8.592-27.522-20.121-35.08-34.087 76.789-27.74 140.63-47.204 194.71-60.678-70.134 33.902-122.46 64.898-159.63 94.765zm512.05-54.574c11.028-6.975 22.48-12.403 34.067-16.57-0.881 8.912-3.035 17.69-6.022 25.899-9.867 2.81-19.261 6.565-28.052 11.224-8.792-4.659-18.185-8.414-28.051-11.224-2.987-8.21-5.142-16.99-6.023-25.904 11.592 4.169 23.049 9.598 34.081 16.575zm555.61-21.471c1.179 13.951-0.703 26.593-7.518 40.081-85.582-30.955-159.87-53.408-224.81-67.944 2.284-8.999 3.001-17.141 2.519-24.783 70.011 9.032 146.79 26.612 229.81 52.646zm-339.8-45.691c-1.536-4.24-2.657-8.969-2.922-14.046 22.083-0.261 45.06 0.567 68.904 2.476 2.109 7.503 0.338 14.301-4.612 20.123-21.883-3.87-42.084-6.649-61.37-8.553zm59.591 10.465c-13.705 13.498-47.125 19.924-58.714-8.2 17.96 1.811 37.419 4.463 58.714 8.2zm8.601-21.855c12.977 1.072 26.208 2.462 39.693 4.172 0.606 7.872-0.164 16.115-2.328 24.617-14.38-3.193-28.299-5.995-41.782-8.414 4.59-5.969 6.261-13.085 4.417-20.375zm14.927-41.644c14.556 12.01 22.75 26.965 24.585 43.689-13.631-1.722-27.004-3.118-40.118-4.19-12.236-39.668-50.96-10.765-45.713-8.402 0.527 0.237 1.145 4e-3 1.383-0.523 0.997-2.219 12.004-10.545 23.104-9.704 8.847 0.673 15.222 6.875 18.975 18.445-23.632-1.869-46.413-2.677-68.32-2.417-0.185-41.776 54.32-63.125 86.104-36.898zm-88.141 39.02c0.251 4.955 1.283 9.592 2.723 13.787-45.902-4.381-81.957-3.268-114.17-0.927 36.508-8.656 73.928-12.298 111.45-12.86zm-115.58 13.868l0.106 1.389c33.345-2.551 70.764-3.916 119.03 0.79 12.345 31.586 49.748 24.021 63.619 8.885 13.515 2.41 27.764 5.255 42.836 8.598-5.197 18.556-19.129 43.175-35.228 55.17-68.454-48.152-172.62-67.28-249.07-36.575-0.244-5.72-1.075-11.415-2.602-16.975 18.622-8.657 39.111-15.77 61.31-21.282zm-95.208-18.924c14.976 9.102 26.255 22.106 31.401 39.065-11.146 5.265-21.63 11.079-31.401 17.441-9.772-6.362-20.256-12.176-31.402-17.441 5.138-16.932 16.41-29.957 31.402-39.065zm-36.504 57.179c-78.429-31.5-183.23-9.731-249.07 36.581-16.123-12.011-30.051-36.669-35.234-55.175 15.072-3.343 29.321-6.188 42.836-8.598 13.7 14.95 51.144 23.029 63.619-8.885 48.268-4.706 85.687-3.341 119.03-0.79l0.106-1.39c22.199 5.512 42.688 12.624 61.31 21.28-1.527 5.562-2.359 11.256-2.603 16.977zm-287.2-45.326c13.485-1.71 26.716-3.1 39.693-4.172-1.845 7.29-0.174 14.406 4.418 20.375-13.483 2.419-27.402 5.221-41.782 8.414-2.165-8.503-2.936-16.746-2.329-24.617zm46.513 15.77c-5.015-5.899-6.698-12.724-4.612-20.123 23.844-1.908 46.821-2.737 68.904-2.476-0.265 5.077-1.385 9.807-2.922 14.046-20.47 2.021-40.76 4.909-61.37 8.553zm60.495-6.288c-11.428 27.732-44.711 21.991-58.714 8.2 21.294-3.737 40.752-6.389 58.714-8.2zm117.35-3.418c-32.214-2.342-68.272-3.455-114.18 0.926 1.44-4.195 2.471-8.832 2.723-13.787 37.52 0.561 74.943 4.203 111.46 12.861zm-113.49-14.984c-21.907-0.259-44.688 0.548-68.32 2.417 10.671-32.892 40.307-12.683 42.079-8.74 0.566 1.257 2.474 0.404 1.905-0.86-2.55-5.665-35.124-26.235-46.235 9.784-13.114 1.072-26.487 2.468-40.118 4.191 8.141-74.158 110.97-69.173 110.69-6.792zm-112.97 9.182c-0.483 7.647 0.236 15.788 2.519 24.782-64.942 14.535-139.22 36.987-224.8 67.94-6.791-13.442-8.699-26.07-7.514-40.08 83.017-26.03 159.79-43.609 229.8-52.642zm-356.72 89.057c-4.776 12.782-14.581 23.497-27.582 26.78-13.372 3.378-30.361-4.65-46.184-15.215 27.833-3.876 52.829-7.798 73.766-11.565zm-105.52-10.162c7.311 6.041 16.392 13.54 26.136 20.397-40.465 5.55-82.917 10.475-123.41 14.559-18.655-38.57 17.251-101.12 97.275-34.956zm50.583 69.685c-1.541-0.157-121.28 14.422-146.83-32.733 40.516-4.096 83.539-9.083 124.92-14.797 13.667 9.338 33.75 20.859 49.785 16.816 14.127-3.567 24.644-15.38 29.45-29.24 54.863-9.987 45.202-10.463 110.33-31.46 2.068 13.836 6.62 26.871 13.414 38.573-83.069 30.32-52.439 23.068-181.07 52.841zm700.64-67.349c-0.256-1.275-24.34-3.66-27.891-3.66-41.476 0-75.585 12.639-101.58 21.405-9.098 3.1-68.401 10.879-108.94-10.815 67.877-35.407 164.41-57.161 239.02-31.368 0.794 8.919 2.839 17.715 5.723 25.973-2.09-0.557-4.205-1.063-6.336-1.535zm36.83 47.045c-11.425-14.815-19.435-22.605-27.136-42.393 9.548 2.828 18.632 6.566 27.136 11.162 8.504-4.596 17.588-8.334 27.136-11.162-7.669 19.705-15.54 27.355-27.136 42.393zm166.29-29.3c-1.002-0.338-74.321-26.587-101.77-21.367-2.396 0.106-27.377 2.054-27.693 3.621-2.133 0.472-4.251 0.979-6.344 1.537 2.884-8.257 4.929-17.051 5.724-25.969 75.519-26.115 172.49-3.349 239.03 31.359-38.904 20.822-97.541 14.707-108.95 10.819zm571.17 49.604c-126.16-29.202-95.947-21.771-181.06-52.837 6.795-11.702 11.347-24.737 13.417-38.574 65.18 21.013 55.502 21.478 110.32 31.457 6.697 19.312 22.343 30.077 36.483 30.077 13.245-1e-3 28.587-7.974 42.752-17.652 41.392 5.715 84.409 10.701 124.92 14.797-25.563 47.175-144.52 32.494-146.84 32.732z\"/>\n	<path d=\"m1701 355.47c-48.985 12.78-45.586 39.748-43.84 40.8 9.508 5.727 38.135-0.343 45.131-39.605 0.135-0.738-0.543-1.388-1.291-1.195z\"/>\n	<path d=\"m984.38 356.66c8.342 46.805 45.409 43.768 45.637 38.763 1.599-30.614-46.258-42.346-45.637-38.763z\"/>\n	<path d=\"m1706.5 383.99c-26.064 47.747-18.669 79.964 1.279 78.008 29.384-1.903 15.998-48.358-1.279-78.008z\"/>\n	<path d=\"m980.18 383.99c-23.765 40.771-25.778 78.076 0.4 78.09 19.73-3e-3 23.652-34.093-0.4-78.09z\"/>\n	<path d=\"m1711.6 357.23c8.278 46.505 45.354 44.073 45.631 38.768 1.615-30.768-46.242-42.163-45.631-38.768z\"/>\n	<path d=\"m973.84 356.04c-30.395 7.935-45.313 21.382-44.336 39.965 0.086 1.782 5.682 2.691 8.369 2.69 28.92 3e-3 41.234-44.011 35.967-42.655z\"/>\n	<path d=\"m2516.9 282.29c-1 0.918 5.287 47.481 36.062 48.273 1.753 0 5.723-8.545 1.56-20.019-7.917-21.81-36.408-29.378-37.622-28.254z\"/>\n	<path d=\"m132.13 310.54c-4.145 11.424-0.197 20.024 1.532 20.02 30.087-0.071 37.093-47.347 36.09-48.274-1.014-0.938-29.532 5.977-37.622 28.254z\"/>\n	<path d=\"m2545.5 279.99c44.065 28.73 78.278 25.617 77.872 4.805 0.398-30.399-48.579-18.941-77.872-4.805z\"/>\n	<path d=\"m141.22 279.99c-43.549-21.03-78.189-18.699-77.872 4.803-0.398 20.675 33.562 24.064 77.872-4.803z\"/>\n	<path d=\"m2519.2 272.87c39.402-3.88 48.053-31.818 43.008-41.901-0.646-1.294-27.204-8.267-44.097 40.519-0.257 0.738 0.369 1.475 1.089 1.382z\"/>\n	<path d=\"m168.59 271.49c-16.532-47.74-43.174-42.358-44.098-40.517-1.98 3.955-2.011 11.503 2.375 19.451 10.903 19.751 43.236 25.465 41.723 21.066z\"/>\n</svg>\n			<h2>Emily xoxo</h2>		\n			<p>| © 2019 EmilyHunt.ch | All rights Reserved | <br>| <a href=\"https://stickysites.ch\" target=\"new\" rel=\"noopener noreferrer\">Design &amp; Hosting: StickySites.ch</a> |</p>", "Emily Hunt", "", "publish", "closed", "closed", "", "emily-hunt", "", "", "2019-11-10 02:10:38", "2019-11-10 10:10:38", "", "0", "https://emilyhunt.ch/?page_id=287", "0", "page", "", "0");
INSERT INTO `wp_464683_posts` VALUES("296", "1", "2019-11-09 06:22:23", "2019-11-09 14:22:23", "", "elegant-1769669.svg", "", "inherit", "closed", "closed", "", "elegant-1769669-svg", "", "", "2019-11-09 06:22:23", "2019-11-09 14:22:23", "", "0", "http://emilyhunt.ch/wp-content/uploads/2019/11/elegant-1769669.svg", "0", "attachment", "image/svg+xml", "0");
INSERT INTO `wp_464683_posts` VALUES("297", "1", "2019-11-09 06:22:23", "2019-11-09 14:22:23", "", "white-silk-fabric-website-background.jpg", "", "inherit", "closed", "closed", "", "white-silk-fabric-website-background-jpg", "", "", "2019-11-09 06:22:23", "2019-11-09 14:22:23", "", "0", "http://emilyhunt.ch/wp-content/uploads/2019/11/white-silk-fabric-website-background.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_464683_posts` VALUES("316", "1", "2019-11-09 06:22:27", "2019-11-09 14:22:27", "<h2>Emily<br />Hunt</h2>		\n			<h2>About Me</h2>		\n		<p>Hi my name is Emily. I am a tall blonde bombshell from Newport Beach CA, sweetly aged 28yr old standing 5 foot 8 inches with exotic features. I have new fun enhanced assets reaching triple D\'s. I live a healthy lifestyle and enjoy being outdoors, especially hiking or by the ocean. My hard work has paid off with a firm body and sexy kitten green eyes.</p><p>I present myself with superior first-rate standards, I am highly confident that you will enjoy our time together. I consider new ideas and look for a connection that is real. I am attentive sensual, passionate and I look forward to stimulating you every way possible. I look forward to meeting you in person...</p><p>XO</p>		\n			<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<!DOCTYPE svg  PUBLIC \'-//W3C//DTD SVG 1.1//EN\'  \'http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd\'>\n<svg enable-background=\"new 0 0 2641.465 318.75\" version=\"1.1\" viewBox=\"0 0 2641.465 318.75\" xml:space=\"preserve\" xmlns=\"http://www.w3.org/2000/svg\">\n	<path d=\"m1742.1 193.97c-8.155 0.553-8.818 14.018-1.059 15.756 7.902 1.975 16.151 0.774 24.195 1.027 268.66-0.016 537.31-0.016 805.97 0 7.68-0.19 15.487 0.758 23.057-0.759 3.856-0.743 6.542-4.551 6.495-8.344-0.095-5.547-5.452-8.613-10.541-8.107-272.88 0.047-545.77 0-818.66 0.031-9.798 0.254-19.675-0.726-29.457 0.396z\" enable-background=\"new    \"/>\n	<path d=\"m899.39 193.97c8.155 0.553 8.818 14.018 1.059 15.756-7.902 1.975-16.151 0.774-24.195 1.027-268.66-0.016-537.31-0.016-805.97 0-7.68-0.19-15.487 0.758-23.057-0.759-3.856-0.743-6.542-4.551-6.495-8.344 0.095-5.547 5.452-8.613 10.541-8.107 272.88 0.047 545.77 0 818.66 0.031 9.798 0.254 19.675-0.726 29.457 0.396z\" enable-background=\"new    \"/>\n	<path d=\"m1686 201.38c-0.743 12.169 12.943 22.757 24.448 17.969 9.166-2.845 14.35-13.117 11.805-22.251-1.849-7.017-8.233-12.88-15.614-13.275-10.383-1.818-20.718 7.048-20.639 17.557zm27.735-2.386c2.781 6.4-4.488 14.176-11.141 12.564-4.488-0.996-8.076-5.373-7.933-10.003 0.458-4.757 4.536-8.676 9.071-9.592 4.329 0.03 8.581 2.89 10.003 7.031z\" enable-background=\"new    \"/>\n	<path d=\"m955.45 201.38c0.743 12.169-12.943 22.757-24.448 17.969-9.166-2.845-14.35-13.117-11.805-22.251 1.849-7.017 8.233-12.88 15.614-13.275 10.383-1.818 20.718 7.048 20.639 17.557zm-27.735-2.386c-2.781 6.4 4.488 14.176 11.141 12.564 4.488-0.996 8.076-5.373 7.933-10.003-0.458-4.757-4.536-8.676-9.071-9.592-4.329 0.03-8.581 2.89-10.003 7.031z\" enable-background=\"new    \"/>\n	<path d=\"m1320.7 237.4c4.371-0.255 8.733-0.635 13.076-1.14 48.453-4.931 94.441-23.974 135.8-49.085 20.544-12.248 38.845-27.845 59.326-40.204 20.323-12.406 43.127-22.077 67.212-22.82 26.044 0.49 51.298 16.056 63.213 39.255 9.071 17.463 9.925 38.371 4.804 57.161-3.003 11.695-8.36 23.184-17.399 31.433-8.518 7.743-20.228 11.426-31.654 11.015-15.456 0.442-32.223-5.705-40.694-19.264-9.751-15.092-5.784-38.276 10.193-47.489 11.22-6.653 25.349-4.757 36.632 0.695 5.484 2.544 6.795 9.055 10.857 13.085 1.264-4.156 2.876-8.55 1.596-12.864-1.849-6.827-7.286-12.137-13.417-15.361-9.466-5.184-20.876-5.816-31.259-3.414-14.681 3.572-26.455 16.325-29.236 31.117-1.896 10.92-0.616 22.709 5.294 32.27 7.886 13.702 23.531 21.461 38.908 22.773 11.173 0.268 22.725 1.011 33.408-2.971 16.246-5.373 29.015-19.027 34.578-35.052 6.306-18.3 6.59-38.702 0.379-57.066-7.791-23.231-27.214-41.673-50.223-49.686-12.089-4.788-25.396-4.425-38.133-3.366-30.643 4.694-57.619 21.477-82.019 39.73-15.329 11.726-30.991 23.073-47.694 32.823-40.599 23.794-86.317 41.083-133.54 43.728-47.228-2.644-92.947-19.933-133.54-43.728-16.704-9.751-32.365-21.098-47.694-32.823-24.4-18.253-51.376-35.036-82.019-39.73-12.738-1.059-26.044-1.422-38.134 3.366-23.01 8.012-42.432 26.455-50.223 49.686-6.211 18.364-5.926 38.766 0.379 57.066 5.563 16.025 18.332 29.679 34.578 35.052 10.683 3.983 22.235 3.24 33.408 2.971 15.377-1.312 31.022-9.071 38.908-22.773 5.91-9.561 7.191-21.35 5.294-32.27-2.781-14.792-14.555-27.545-29.236-31.117-10.383-2.402-21.793-1.77-31.259 3.414-6.132 3.224-11.568 8.534-13.417 15.361-1.28 4.314 0.332 8.708 1.596 12.864 4.062-4.03 5.373-10.541 10.857-13.085 11.284-5.452 25.412-7.348 36.632-0.695 15.977 9.213 19.944 32.397 10.193 47.489-8.471 13.559-25.238 19.706-40.694 19.264-11.426 0.411-23.136-3.272-31.654-11.015-9.039-8.249-14.397-19.738-17.399-31.433-5.12-18.79-4.267-39.698 4.804-57.161 11.916-23.199 37.169-38.766 63.213-39.255 24.084 0.743 46.889 10.414 67.212 22.82 20.481 12.358 38.782 27.956 59.326 40.204 41.357 25.111 87.345 44.154 135.8 49.085 4.343 0.505 8.704 0.885 13.075 1.14zm0-16.381c23.825-0.755 48.012-9.056 64.959-26.211 14.539-15.14 24.495-34.23 40.441-48.09 8.076-7.601 17.716-13.101 26.834-19.264-9.751-0.901-19.296-3.461-29.094-3.998-14.871-0.158-30.295 0.427-44.012 6.827-20.339 9.15-34.847 27.419-55.201 36.506-1.296 0.53-2.605 1.027-3.926 1.493-1.321-0.466-2.63-0.964-3.926-1.493-20.355-9.087-34.862-27.355-55.201-36.506-13.717-6.401-29.141-6.985-44.012-6.827-9.798 0.537-19.343 3.097-29.094 3.998 9.119 6.163 18.758 11.663 26.834 19.264 15.945 13.859 25.901 32.95 40.441 48.09 16.945 17.155 41.132 25.455 64.957 26.211zm0-42.074c6.04-1.938 11.825-4.583 17.09-8.174 18.158-11.6 31.038-30.516 51.361-38.813 18.174-6.716 38.228-7.933 56.987-2.908-13.259 8.455-26.186 17.668-36.996 29.189-14.745 15.772-28.035 34.372-48.564 43.112-12.601 5.464-26.157 8.587-39.879 9.44-13.721-0.853-27.278-3.975-39.879-9.44-20.529-8.739-33.819-27.34-48.564-43.112-10.81-11.521-23.737-20.734-36.996-29.189 18.759-5.025 38.813-3.809 56.987 2.908 20.323 8.297 33.203 27.213 51.361 38.813 5.267 3.592 11.053 6.237 17.092 8.174zm0-16.967c11.662-8.17 20.736-20.059 25.671-33.433 7.286-19.659 6.416-43.839-7.269-60.558-4.911-6.165-11.296-10.88-18.402-14.036-7.106 3.156-13.491 7.87-18.402 14.036-13.686 16.72-14.555 40.899-7.269 60.558 4.936 13.373 14.009 25.263 25.671 33.433zm0-104.06c8.436 4.271 15.62 10.925 19.982 19.437 6.084 10.73 6.701 23.5 5.405 35.51-2.426 16.99-11.841 32.882-25.387 43.352-13.546-10.47-22.961-26.362-25.387-43.352-1.296-12.01-0.679-24.78 5.405-35.51 4.362-8.512 11.546-15.166 19.982-19.437z\" enable-background=\"new    \"/>\n	<path d=\"m1529.3 230.48c-3.145-7.617-10.588-12.152-17.304-16.277-21.745-12.437-48.532-12.011-71.921-4.789-12.532 4.03-25.175 8.803-35.684 16.957 31.212-0.806 59.263 14.681 89.178 20.892 9.166 1.691 18.948 1.422 27.624-2.149 5.579-2.197 10.509-8.502 8.107-14.634zm-33.582 7.57c-26.692-4.804-52.531-15.74-80.044-14.95 17.225-6.543 35.605-10.841 54.095-10.636 18.648 0.727 38.671 6.669 50.792 21.682-7.38 4.552-16.42 5.216-24.843 3.904z\" enable-background=\"new    \"/>\n	<path d=\"m1112.2 230.48c3.145-7.617 10.588-12.152 17.304-16.277 21.745-12.437 48.532-12.011 71.921-4.789 12.532 4.03 25.175 8.803 35.684 16.957-31.212-0.806-59.263 14.681-89.178 20.892-9.166 1.691-18.948 1.422-27.624-2.149-5.579-2.197-10.51-8.502-8.107-14.634zm33.582 7.57c26.692-4.804 52.531-15.74 80.044-14.95-17.225-6.543-35.605-10.841-54.095-10.636-18.648 0.727-38.671 6.669-50.792 21.682 7.38 4.552 16.419 5.216 24.843 3.904z\" enable-background=\"new    \"/>\n</svg>\n		<p><b>Measurements:</b> 32DDD-24-32<br /><b>Age:</b> 28</p><b>Main City:</b> Orange County, CA<br />\n<b>Height:</b> 5\' 8\"<p><b>Sex:</b> Female<br /><b>Weight:</b> 125 lbs</p>		\n			<h2>Rates</h2>		\n		<p>Rates apply to incall. For outcall add $200.</p>		\n		<ul>\n									<li><a href=\"#\">				\n											&bull;&nbsp;1 Hour\n																			$800\n				</a></li>												<li><a href=\"#\">				\n											&bull;&nbsp;1&frac12; Hours\n																			$1200\n				</a></li>												<li><a href=\"#\">				\n											&bull;&nbsp;2 Hours\n																			$1500\n				</a></li>												<li><a href=\"#\">				\n											&bull;&nbsp;3 Hours\n																			$2200\n				</a></li>												<li><a href=\"#\">				\n											&bull;&nbsp;4 Hours\n																			$2700\n				</a></li>												<li><a href=\"#\">				\n											&bull;&nbsp;6 Hours\n																			$3500\n				</a></li>												<li><a href=\"#\">				\n											&bull;&nbsp;12 Hours\n																			$5000\n				</a></li>												<li><a href=\"#\">				\n											&bull;&nbsp;Same day cancelation\n																			$200 fee\n				</a></li>					\n		</ul>\n			<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<!DOCTYPE svg  PUBLIC \'-//W3C//DTD SVG 1.1//EN\'  \'http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd\'>\n<svg enable-background=\"new 0 0 2641.465 318.75\" version=\"1.1\" viewBox=\"0 0 2641.465 318.75\" xml:space=\"preserve\" xmlns=\"http://www.w3.org/2000/svg\">\n	<path d=\"m1742.1 193.97c-8.155 0.553-8.818 14.018-1.059 15.756 7.902 1.975 16.151 0.774 24.195 1.027 268.66-0.016 537.31-0.016 805.97 0 7.68-0.19 15.487 0.758 23.057-0.759 3.856-0.743 6.542-4.551 6.495-8.344-0.095-5.547-5.452-8.613-10.541-8.107-272.88 0.047-545.77 0-818.66 0.031-9.798 0.254-19.675-0.726-29.457 0.396z\" enable-background=\"new    \"/>\n	<path d=\"m899.39 193.97c8.155 0.553 8.818 14.018 1.059 15.756-7.902 1.975-16.151 0.774-24.195 1.027-268.66-0.016-537.31-0.016-805.97 0-7.68-0.19-15.487 0.758-23.057-0.759-3.856-0.743-6.542-4.551-6.495-8.344 0.095-5.547 5.452-8.613 10.541-8.107 272.88 0.047 545.77 0 818.66 0.031 9.798 0.254 19.675-0.726 29.457 0.396z\" enable-background=\"new    \"/>\n	<path d=\"m1686 201.38c-0.743 12.169 12.943 22.757 24.448 17.969 9.166-2.845 14.35-13.117 11.805-22.251-1.849-7.017-8.233-12.88-15.614-13.275-10.383-1.818-20.718 7.048-20.639 17.557zm27.735-2.386c2.781 6.4-4.488 14.176-11.141 12.564-4.488-0.996-8.076-5.373-7.933-10.003 0.458-4.757 4.536-8.676 9.071-9.592 4.329 0.03 8.581 2.89 10.003 7.031z\" enable-background=\"new    \"/>\n	<path d=\"m955.45 201.38c0.743 12.169-12.943 22.757-24.448 17.969-9.166-2.845-14.35-13.117-11.805-22.251 1.849-7.017 8.233-12.88 15.614-13.275 10.383-1.818 20.718 7.048 20.639 17.557zm-27.735-2.386c-2.781 6.4 4.488 14.176 11.141 12.564 4.488-0.996 8.076-5.373 7.933-10.003-0.458-4.757-4.536-8.676-9.071-9.592-4.329 0.03-8.581 2.89-10.003 7.031z\" enable-background=\"new    \"/>\n	<path d=\"m1320.7 237.4c4.371-0.255 8.733-0.635 13.076-1.14 48.453-4.931 94.441-23.974 135.8-49.085 20.544-12.248 38.845-27.845 59.326-40.204 20.323-12.406 43.127-22.077 67.212-22.82 26.044 0.49 51.298 16.056 63.213 39.255 9.071 17.463 9.925 38.371 4.804 57.161-3.003 11.695-8.36 23.184-17.399 31.433-8.518 7.743-20.228 11.426-31.654 11.015-15.456 0.442-32.223-5.705-40.694-19.264-9.751-15.092-5.784-38.276 10.193-47.489 11.22-6.653 25.349-4.757 36.632 0.695 5.484 2.544 6.795 9.055 10.857 13.085 1.264-4.156 2.876-8.55 1.596-12.864-1.849-6.827-7.286-12.137-13.417-15.361-9.466-5.184-20.876-5.816-31.259-3.414-14.681 3.572-26.455 16.325-29.236 31.117-1.896 10.92-0.616 22.709 5.294 32.27 7.886 13.702 23.531 21.461 38.908 22.773 11.173 0.268 22.725 1.011 33.408-2.971 16.246-5.373 29.015-19.027 34.578-35.052 6.306-18.3 6.59-38.702 0.379-57.066-7.791-23.231-27.214-41.673-50.223-49.686-12.089-4.788-25.396-4.425-38.133-3.366-30.643 4.694-57.619 21.477-82.019 39.73-15.329 11.726-30.991 23.073-47.694 32.823-40.599 23.794-86.317 41.083-133.54 43.728-47.228-2.644-92.947-19.933-133.54-43.728-16.704-9.751-32.365-21.098-47.694-32.823-24.4-18.253-51.376-35.036-82.019-39.73-12.738-1.059-26.044-1.422-38.134 3.366-23.01 8.012-42.432 26.455-50.223 49.686-6.211 18.364-5.926 38.766 0.379 57.066 5.563 16.025 18.332 29.679 34.578 35.052 10.683 3.983 22.235 3.24 33.408 2.971 15.377-1.312 31.022-9.071 38.908-22.773 5.91-9.561 7.191-21.35 5.294-32.27-2.781-14.792-14.555-27.545-29.236-31.117-10.383-2.402-21.793-1.77-31.259 3.414-6.132 3.224-11.568 8.534-13.417 15.361-1.28 4.314 0.332 8.708 1.596 12.864 4.062-4.03 5.373-10.541 10.857-13.085 11.284-5.452 25.412-7.348 36.632-0.695 15.977 9.213 19.944 32.397 10.193 47.489-8.471 13.559-25.238 19.706-40.694 19.264-11.426 0.411-23.136-3.272-31.654-11.015-9.039-8.249-14.397-19.738-17.399-31.433-5.12-18.79-4.267-39.698 4.804-57.161 11.916-23.199 37.169-38.766 63.213-39.255 24.084 0.743 46.889 10.414 67.212 22.82 20.481 12.358 38.782 27.956 59.326 40.204 41.357 25.111 87.345 44.154 135.8 49.085 4.343 0.505 8.704 0.885 13.075 1.14zm0-16.381c23.825-0.755 48.012-9.056 64.959-26.211 14.539-15.14 24.495-34.23 40.441-48.09 8.076-7.601 17.716-13.101 26.834-19.264-9.751-0.901-19.296-3.461-29.094-3.998-14.871-0.158-30.295 0.427-44.012 6.827-20.339 9.15-34.847 27.419-55.201 36.506-1.296 0.53-2.605 1.027-3.926 1.493-1.321-0.466-2.63-0.964-3.926-1.493-20.355-9.087-34.862-27.355-55.201-36.506-13.717-6.401-29.141-6.985-44.012-6.827-9.798 0.537-19.343 3.097-29.094 3.998 9.119 6.163 18.758 11.663 26.834 19.264 15.945 13.859 25.901 32.95 40.441 48.09 16.945 17.155 41.132 25.455 64.957 26.211zm0-42.074c6.04-1.938 11.825-4.583 17.09-8.174 18.158-11.6 31.038-30.516 51.361-38.813 18.174-6.716 38.228-7.933 56.987-2.908-13.259 8.455-26.186 17.668-36.996 29.189-14.745 15.772-28.035 34.372-48.564 43.112-12.601 5.464-26.157 8.587-39.879 9.44-13.721-0.853-27.278-3.975-39.879-9.44-20.529-8.739-33.819-27.34-48.564-43.112-10.81-11.521-23.737-20.734-36.996-29.189 18.759-5.025 38.813-3.809 56.987 2.908 20.323 8.297 33.203 27.213 51.361 38.813 5.267 3.592 11.053 6.237 17.092 8.174zm0-16.967c11.662-8.17 20.736-20.059 25.671-33.433 7.286-19.659 6.416-43.839-7.269-60.558-4.911-6.165-11.296-10.88-18.402-14.036-7.106 3.156-13.491 7.87-18.402 14.036-13.686 16.72-14.555 40.899-7.269 60.558 4.936 13.373 14.009 25.263 25.671 33.433zm0-104.06c8.436 4.271 15.62 10.925 19.982 19.437 6.084 10.73 6.701 23.5 5.405 35.51-2.426 16.99-11.841 32.882-25.387 43.352-13.546-10.47-22.961-26.362-25.387-43.352-1.296-12.01-0.679-24.78 5.405-35.51 4.362-8.512 11.546-15.166 19.982-19.437z\" enable-background=\"new    \"/>\n	<path d=\"m1529.3 230.48c-3.145-7.617-10.588-12.152-17.304-16.277-21.745-12.437-48.532-12.011-71.921-4.789-12.532 4.03-25.175 8.803-35.684 16.957 31.212-0.806 59.263 14.681 89.178 20.892 9.166 1.691 18.948 1.422 27.624-2.149 5.579-2.197 10.509-8.502 8.107-14.634zm-33.582 7.57c-26.692-4.804-52.531-15.74-80.044-14.95 17.225-6.543 35.605-10.841 54.095-10.636 18.648 0.727 38.671 6.669 50.792 21.682-7.38 4.552-16.42 5.216-24.843 3.904z\" enable-background=\"new    \"/>\n	<path d=\"m1112.2 230.48c3.145-7.617 10.588-12.152 17.304-16.277 21.745-12.437 48.532-12.011 71.921-4.789 12.532 4.03 25.175 8.803 35.684 16.957-31.212-0.806-59.263 14.681-89.178 20.892-9.166 1.691-18.948 1.422-27.624-2.149-5.579-2.197-10.51-8.502-8.107-14.634zm33.582 7.57c26.692-4.804 52.531-15.74 80.044-14.95-17.225-6.543-35.605-10.841-54.095-10.636-18.648 0.727-38.671 6.669-50.792 21.682 7.38 4.552 16.419 5.216 24.843 3.904z\" enable-background=\"new    \"/>\n</svg>\n			<h2>Photos</h2>		\n		<p>Professional photoshoot</p>		\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"61130ce1\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6645.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6645.jpg\" title=\"Emily-noblur-IMG_6645.jpg\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"61130ce1\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6657.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6657.jpg\" title=\"Emily-noblur-IMG_6657.jpg\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"61130ce1\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_5030.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_5030.jpg\" title=\"Emily-noblur-IMG_5030.jpg\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"61130ce1\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6649.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6649.jpg\" title=\"Emily-noblur-IMG_6649.jpg\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"61130ce1\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6653.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6653.jpg\" title=\"Emily-noblur-IMG_6653.jpg\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"61130ce1\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6646.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6646.jpg\" title=\"Emily-noblur-IMG_6646.jpg\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"61130ce1\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6655-crop.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6655-crop.jpg\" title=\"Emily-noblur-IMG_6655-crop.jpg\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"61130ce1\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6651.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_6651.jpg\" title=\"Emily-noblur-IMG_6651.jpg\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"61130ce1\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_5029.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-IMG_5029.jpg\" title=\"Emily-noblur-IMG_5029.jpg\" />\n					</a>\n		<p>Personal images</p>		\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"26c41a3\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-EmilyHunt11.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-EmilyHunt11.jpg\" title=\"Emily-noblur-EmilyHunt11.jpg\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"26c41a3\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt09.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt09.jpg\" title=\"EmilyHunt09.jpg\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"26c41a3\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt30.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt30.jpg\" title=\"EmilyHunt30.jpg\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"26c41a3\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt10.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt10.jpg\" title=\"EmilyHunt10.jpg\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"26c41a3\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt23.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt23.jpg\" title=\"EmilyHunt23.jpg\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"26c41a3\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-EmilyHunt18.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-EmilyHunt18.jpg\" title=\"Emily-noblur-EmilyHunt18.jpg\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"26c41a3\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt26.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt26.jpg\" title=\"EmilyHunt26.jpg\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"26c41a3\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-EmilyHunt04.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/Emily-noblur-EmilyHunt04.jpg\" title=\"Emily-noblur-EmilyHunt04.jpg\" />\n					</a>\n									<a data-elementor-open-lightbox=\"yes\" data-elementor-lightbox-slideshow=\"26c41a3\" href=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt24.jpg\">\n			<img src=\"http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt24.jpg\" title=\"EmilyHunt24.jpg\" />\n					</a>\n			<h2>Tour</h2>		\n		[text-blocks id=\"touring\"]		\n			<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<!DOCTYPE svg  PUBLIC \'-//W3C//DTD SVG 1.1//EN\'  \'http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd\'>\n<svg enable-background=\"new 0 0 2641.465 318.75\" version=\"1.1\" viewBox=\"0 0 2641.465 318.75\" xml:space=\"preserve\" xmlns=\"http://www.w3.org/2000/svg\">\n	<path d=\"m1742.1 193.97c-8.155 0.553-8.818 14.018-1.059 15.756 7.902 1.975 16.151 0.774 24.195 1.027 268.66-0.016 537.31-0.016 805.97 0 7.68-0.19 15.487 0.758 23.057-0.759 3.856-0.743 6.542-4.551 6.495-8.344-0.095-5.547-5.452-8.613-10.541-8.107-272.88 0.047-545.77 0-818.66 0.031-9.798 0.254-19.675-0.726-29.457 0.396z\" enable-background=\"new    \"/>\n	<path d=\"m899.39 193.97c8.155 0.553 8.818 14.018 1.059 15.756-7.902 1.975-16.151 0.774-24.195 1.027-268.66-0.016-537.31-0.016-805.97 0-7.68-0.19-15.487 0.758-23.057-0.759-3.856-0.743-6.542-4.551-6.495-8.344 0.095-5.547 5.452-8.613 10.541-8.107 272.88 0.047 545.77 0 818.66 0.031 9.798 0.254 19.675-0.726 29.457 0.396z\" enable-background=\"new    \"/>\n	<path d=\"m1686 201.38c-0.743 12.169 12.943 22.757 24.448 17.969 9.166-2.845 14.35-13.117 11.805-22.251-1.849-7.017-8.233-12.88-15.614-13.275-10.383-1.818-20.718 7.048-20.639 17.557zm27.735-2.386c2.781 6.4-4.488 14.176-11.141 12.564-4.488-0.996-8.076-5.373-7.933-10.003 0.458-4.757 4.536-8.676 9.071-9.592 4.329 0.03 8.581 2.89 10.003 7.031z\" enable-background=\"new    \"/>\n	<path d=\"m955.45 201.38c0.743 12.169-12.943 22.757-24.448 17.969-9.166-2.845-14.35-13.117-11.805-22.251 1.849-7.017 8.233-12.88 15.614-13.275 10.383-1.818 20.718 7.048 20.639 17.557zm-27.735-2.386c-2.781 6.4 4.488 14.176 11.141 12.564 4.488-0.996 8.076-5.373 7.933-10.003-0.458-4.757-4.536-8.676-9.071-9.592-4.329 0.03-8.581 2.89-10.003 7.031z\" enable-background=\"new    \"/>\n	<path d=\"m1320.7 237.4c4.371-0.255 8.733-0.635 13.076-1.14 48.453-4.931 94.441-23.974 135.8-49.085 20.544-12.248 38.845-27.845 59.326-40.204 20.323-12.406 43.127-22.077 67.212-22.82 26.044 0.49 51.298 16.056 63.213 39.255 9.071 17.463 9.925 38.371 4.804 57.161-3.003 11.695-8.36 23.184-17.399 31.433-8.518 7.743-20.228 11.426-31.654 11.015-15.456 0.442-32.223-5.705-40.694-19.264-9.751-15.092-5.784-38.276 10.193-47.489 11.22-6.653 25.349-4.757 36.632 0.695 5.484 2.544 6.795 9.055 10.857 13.085 1.264-4.156 2.876-8.55 1.596-12.864-1.849-6.827-7.286-12.137-13.417-15.361-9.466-5.184-20.876-5.816-31.259-3.414-14.681 3.572-26.455 16.325-29.236 31.117-1.896 10.92-0.616 22.709 5.294 32.27 7.886 13.702 23.531 21.461 38.908 22.773 11.173 0.268 22.725 1.011 33.408-2.971 16.246-5.373 29.015-19.027 34.578-35.052 6.306-18.3 6.59-38.702 0.379-57.066-7.791-23.231-27.214-41.673-50.223-49.686-12.089-4.788-25.396-4.425-38.133-3.366-30.643 4.694-57.619 21.477-82.019 39.73-15.329 11.726-30.991 23.073-47.694 32.823-40.599 23.794-86.317 41.083-133.54 43.728-47.228-2.644-92.947-19.933-133.54-43.728-16.704-9.751-32.365-21.098-47.694-32.823-24.4-18.253-51.376-35.036-82.019-39.73-12.738-1.059-26.044-1.422-38.134 3.366-23.01 8.012-42.432 26.455-50.223 49.686-6.211 18.364-5.926 38.766 0.379 57.066 5.563 16.025 18.332 29.679 34.578 35.052 10.683 3.983 22.235 3.24 33.408 2.971 15.377-1.312 31.022-9.071 38.908-22.773 5.91-9.561 7.191-21.35 5.294-32.27-2.781-14.792-14.555-27.545-29.236-31.117-10.383-2.402-21.793-1.77-31.259 3.414-6.132 3.224-11.568 8.534-13.417 15.361-1.28 4.314 0.332 8.708 1.596 12.864 4.062-4.03 5.373-10.541 10.857-13.085 11.284-5.452 25.412-7.348 36.632-0.695 15.977 9.213 19.944 32.397 10.193 47.489-8.471 13.559-25.238 19.706-40.694 19.264-11.426 0.411-23.136-3.272-31.654-11.015-9.039-8.249-14.397-19.738-17.399-31.433-5.12-18.79-4.267-39.698 4.804-57.161 11.916-23.199 37.169-38.766 63.213-39.255 24.084 0.743 46.889 10.414 67.212 22.82 20.481 12.358 38.782 27.956 59.326 40.204 41.357 25.111 87.345 44.154 135.8 49.085 4.343 0.505 8.704 0.885 13.075 1.14zm0-16.381c23.825-0.755 48.012-9.056 64.959-26.211 14.539-15.14 24.495-34.23 40.441-48.09 8.076-7.601 17.716-13.101 26.834-19.264-9.751-0.901-19.296-3.461-29.094-3.998-14.871-0.158-30.295 0.427-44.012 6.827-20.339 9.15-34.847 27.419-55.201 36.506-1.296 0.53-2.605 1.027-3.926 1.493-1.321-0.466-2.63-0.964-3.926-1.493-20.355-9.087-34.862-27.355-55.201-36.506-13.717-6.401-29.141-6.985-44.012-6.827-9.798 0.537-19.343 3.097-29.094 3.998 9.119 6.163 18.758 11.663 26.834 19.264 15.945 13.859 25.901 32.95 40.441 48.09 16.945 17.155 41.132 25.455 64.957 26.211zm0-42.074c6.04-1.938 11.825-4.583 17.09-8.174 18.158-11.6 31.038-30.516 51.361-38.813 18.174-6.716 38.228-7.933 56.987-2.908-13.259 8.455-26.186 17.668-36.996 29.189-14.745 15.772-28.035 34.372-48.564 43.112-12.601 5.464-26.157 8.587-39.879 9.44-13.721-0.853-27.278-3.975-39.879-9.44-20.529-8.739-33.819-27.34-48.564-43.112-10.81-11.521-23.737-20.734-36.996-29.189 18.759-5.025 38.813-3.809 56.987 2.908 20.323 8.297 33.203 27.213 51.361 38.813 5.267 3.592 11.053 6.237 17.092 8.174zm0-16.967c11.662-8.17 20.736-20.059 25.671-33.433 7.286-19.659 6.416-43.839-7.269-60.558-4.911-6.165-11.296-10.88-18.402-14.036-7.106 3.156-13.491 7.87-18.402 14.036-13.686 16.72-14.555 40.899-7.269 60.558 4.936 13.373 14.009 25.263 25.671 33.433zm0-104.06c8.436 4.271 15.62 10.925 19.982 19.437 6.084 10.73 6.701 23.5 5.405 35.51-2.426 16.99-11.841 32.882-25.387 43.352-13.546-10.47-22.961-26.362-25.387-43.352-1.296-12.01-0.679-24.78 5.405-35.51 4.362-8.512 11.546-15.166 19.982-19.437z\" enable-background=\"new    \"/>\n	<path d=\"m1529.3 230.48c-3.145-7.617-10.588-12.152-17.304-16.277-21.745-12.437-48.532-12.011-71.921-4.789-12.532 4.03-25.175 8.803-35.684 16.957 31.212-0.806 59.263 14.681 89.178 20.892 9.166 1.691 18.948 1.422 27.624-2.149 5.579-2.197 10.509-8.502 8.107-14.634zm-33.582 7.57c-26.692-4.804-52.531-15.74-80.044-14.95 17.225-6.543 35.605-10.841 54.095-10.636 18.648 0.727 38.671 6.669 50.792 21.682-7.38 4.552-16.42 5.216-24.843 3.904z\" enable-background=\"new    \"/>\n	<path d=\"m1112.2 230.48c3.145-7.617 10.588-12.152 17.304-16.277 21.745-12.437 48.532-12.011 71.921-4.789 12.532 4.03 25.175 8.803 35.684 16.957-31.212-0.806-59.263 14.681-89.178 20.892-9.166 1.691-18.948 1.422-27.624-2.149-5.579-2.197-10.51-8.502-8.107-14.634zm33.582 7.57c26.692-4.804 52.531-15.74 80.044-14.95-17.225-6.543-35.605-10.841-54.095-10.636-18.648 0.727-38.671 6.669-50.792 21.682 7.38 4.552 16.419 5.216 24.843 3.904z\" enable-background=\"new    \"/>\n</svg>\n			<h2>Wishlist</h2>		\n		<p><a style=\"color: black;\" href=\"https://www.amazon.com/gp/registry/wishlist/15C9HX41ATNR2\" target=\"_blank\" rel=\"noopener noreferrer\">Click</a><a style=\"color: black;\" href=\"https://www.amazon.com/gp/registry/wishlist/15C9HX41ATNR2\" target=\"_blank\" rel=\"noopener noreferrer\"> to check out my Amazon Wishlist </a><b><a style=\"color: black;\" href=\"https://www.amazon.com/gp/registry/wishlist/15C9HX41ATNR2\" target=\"_blank\" rel=\"noopener noreferrer\"><br /></a></b></p>		\n			<h2>Contact</h2>		\n		<p>If you need to email me meetmissemilyhunt@protonmail.com</p>		\n			<h2>Touring</h2>		\n		<p>[text-blocks id=\"touring\"]</p><p>Please use the form below if you wish to be notified when I\'m visiting your city.</p>[newsletter_form form=1]		\n			<h2>Emily xoxo</h2>		\n			<p>| © 2019 EmilyHunt.ch | All rights Reserved | <br>| <a href=\"https://stickysites.ch\" target=\"new\" rel=\"noopener noreferrer\">Design &amp; Hosting: StickySites.ch</a> |</p>", "NN Page", "", "publish", "closed", "closed", "", "nn-page", "", "", "2019-11-09 06:22:27", "2019-11-09 14:22:27", "", "0", "https://emilyhunt.ch/?elementor_library=nn-page", "0", "elementor_library", "", "0");
INSERT INTO `wp_464683_posts` VALUES("320", "1", "2019-11-09 06:29:33", "2019-11-09 14:29:33", "", "EmilyHunt-1", "", "inherit", "closed", "closed", "", "emilyhunt-1", "", "", "2019-11-09 06:29:33", "2019-11-09 14:29:33", "", "287", "http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-1.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_464683_posts` VALUES("321", "1", "2019-11-09 06:29:34", "2019-11-09 14:29:34", "", "EmilyHunt-2", "", "inherit", "closed", "closed", "", "emilyhunt-2", "", "", "2019-11-09 06:29:34", "2019-11-09 14:29:34", "", "287", "http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-2.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_464683_posts` VALUES("322", "1", "2019-11-09 06:29:35", "2019-11-09 14:29:35", "", "EmilyHunt-3", "", "inherit", "closed", "closed", "", "emilyhunt-3", "", "", "2019-11-09 06:29:35", "2019-11-09 14:29:35", "", "287", "http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-3.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_464683_posts` VALUES("323", "1", "2019-11-09 06:29:36", "2019-11-09 14:29:36", "", "EmilyHunt-4", "", "inherit", "closed", "closed", "", "emilyhunt-4", "", "", "2019-11-09 06:29:36", "2019-11-09 14:29:36", "", "287", "http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-4.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_464683_posts` VALUES("324", "1", "2019-11-09 06:29:36", "2019-11-09 14:29:36", "", "EmilyHunt-5", "", "inherit", "closed", "closed", "", "emilyhunt-5", "", "", "2019-11-09 06:29:36", "2019-11-09 14:29:36", "", "287", "http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-5.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_464683_posts` VALUES("325", "1", "2019-11-09 06:29:37", "2019-11-09 14:29:37", "", "EmilyHunt-6", "", "inherit", "closed", "closed", "", "emilyhunt-6", "", "", "2019-11-09 06:29:37", "2019-11-09 14:29:37", "", "287", "http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-6.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_464683_posts` VALUES("326", "1", "2019-11-09 06:29:38", "2019-11-09 14:29:38", "", "EmilyHunt-7", "", "inherit", "closed", "closed", "", "emilyhunt-7", "", "", "2019-11-09 06:29:38", "2019-11-09 14:29:38", "", "287", "http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-7.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_464683_posts` VALUES("327", "1", "2019-11-09 06:29:39", "2019-11-09 14:29:39", "", "EmilyHunt-8", "", "inherit", "closed", "closed", "", "emilyhunt-8", "", "", "2019-11-09 06:29:39", "2019-11-09 14:29:39", "", "287", "http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-8.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_464683_posts` VALUES("328", "1", "2019-11-09 06:29:40", "2019-11-09 14:29:40", "", "EmilyHunt-9", "", "inherit", "closed", "closed", "", "emilyhunt-9", "", "", "2019-11-09 06:29:40", "2019-11-09 14:29:40", "", "287", "http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-9.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_464683_posts` VALUES("329", "1", "2019-11-09 06:29:41", "2019-11-09 14:29:41", "", "EmilyHunt-10", "", "inherit", "closed", "closed", "", "emilyhunt-10", "", "", "2019-11-09 06:29:41", "2019-11-09 14:29:41", "", "287", "http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-10.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_464683_posts` VALUES("330", "1", "2019-11-09 06:29:42", "2019-11-09 14:29:42", "", "EmilyHunt-11", "", "inherit", "closed", "closed", "", "emilyhunt-11", "", "", "2019-11-09 06:29:42", "2019-11-09 14:29:42", "", "287", "http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-11.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_464683_posts` VALUES("331", "1", "2019-11-09 06:29:43", "2019-11-09 14:29:43", "", "EmilyHunt-12", "", "inherit", "closed", "closed", "", "emilyhunt-12", "", "", "2019-11-09 06:29:43", "2019-11-09 14:29:43", "", "287", "http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-12.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_464683_posts` VALUES("332", "1", "2019-11-09 06:29:44", "2019-11-09 14:29:44", "", "EmilyHunt-13", "", "inherit", "closed", "closed", "", "emilyhunt-13", "", "", "2019-11-09 06:29:44", "2019-11-09 14:29:44", "", "287", "http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-13.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_464683_posts` VALUES("333", "1", "2019-11-09 06:29:44", "2019-11-09 14:29:44", "", "EmilyHunt-14", "", "inherit", "closed", "closed", "", "emilyhunt-14", "", "", "2019-11-09 06:29:44", "2019-11-09 14:29:44", "", "287", "http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-14.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_464683_posts` VALUES("334", "1", "2019-11-09 06:29:45", "2019-11-09 14:29:45", "", "EmilyHunt-15", "", "inherit", "closed", "closed", "", "emilyhunt-15", "", "", "2019-11-09 06:29:45", "2019-11-09 14:29:45", "", "287", "http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-15.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_464683_posts` VALUES("335", "1", "2019-11-09 06:29:46", "2019-11-09 14:29:46", "", "EmilyHunt-16", "", "inherit", "closed", "closed", "", "emilyhunt-16", "", "", "2019-11-09 06:29:46", "2019-11-09 14:29:46", "", "287", "http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-16.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_464683_posts` VALUES("336", "1", "2019-11-09 06:29:47", "2019-11-09 14:29:47", "", "EmilyHunt-17", "", "inherit", "closed", "closed", "", "emilyhunt-17", "", "", "2019-11-09 06:29:47", "2019-11-09 14:29:47", "", "287", "http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-17.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_464683_posts` VALUES("337", "1", "2019-11-09 06:29:48", "2019-11-09 14:29:48", "", "EmilyHunt-18", "", "inherit", "closed", "closed", "", "emilyhunt-18", "", "", "2019-11-09 06:29:48", "2019-11-09 14:29:48", "", "287", "http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-18.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_464683_posts` VALUES("338", "1", "2019-11-09 06:29:49", "2019-11-09 14:29:49", "", "EmilyHunt-19", "", "inherit", "closed", "closed", "", "emilyhunt-19", "", "", "2019-11-09 06:29:49", "2019-11-09 14:29:49", "", "287", "http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-19.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_464683_posts` VALUES("339", "1", "2019-11-09 06:29:50", "2019-11-09 14:29:50", "", "EmilyHunt-20", "", "inherit", "closed", "closed", "", "emilyhunt-20", "", "", "2019-11-09 06:29:50", "2019-11-09 14:29:50", "", "287", "http://emilyhunt.ch/wp-content/uploads/2019/11/EmilyHunt-20.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_464683_posts` VALUES("368", "1", "2019-11-09 07:50:59", "2019-11-09 15:50:59", "", "Decorative_text_divider_-_central_flare", "", "inherit", "closed", "closed", "", "decorative_text_divider_-_central_flare", "", "", "2019-11-09 07:50:59", "2019-11-09 15:50:59", "", "0", "http://emilyhunt.ch/wp-content/uploads/2019/11/Decorative_text_divider_-_central_flare.svg", "0", "attachment", "image/svg+xml", "0");
INSERT INTO `wp_464683_posts` VALUES("369", "1", "2019-11-09 07:50:59", "2019-11-09 15:50:59", "", "Decorative_text_divider", "", "inherit", "closed", "closed", "", "decorative_text_divider", "", "", "2019-11-09 07:50:59", "2019-11-09 15:50:59", "", "0", "http://emilyhunt.ch/wp-content/uploads/2019/11/Decorative_text_divider.svg", "0", "attachment", "image/svg+xml", "0");
INSERT INTO `wp_464683_posts` VALUES("370", "1", "2019-11-09 07:51:00", "2019-11-09 15:51:00", "", "SciAm_Wavy_Text_Divider", "", "inherit", "closed", "closed", "", "sciam_wavy_text_divider", "", "", "2019-11-09 07:51:00", "2019-11-09 15:51:00", "", "0", "http://emilyhunt.ch/wp-content/uploads/2019/11/SciAm_Wavy_Text_Divider.svg", "0", "attachment", "image/svg+xml", "0");
INSERT INTO `wp_464683_posts` VALUES("371", "1", "2019-11-09 07:51:01", "2019-11-09 15:51:01", "", "decorative-2773445", "", "inherit", "closed", "closed", "", "decorative-2773445", "", "", "2019-11-09 07:51:01", "2019-11-09 15:51:01", "", "0", "http://emilyhunt.ch/wp-content/uploads/2019/11/decorative-2773445.svg", "0", "attachment", "image/svg+xml", "0");
INSERT INTO `wp_464683_posts` VALUES("372", "1", "2019-11-09 07:51:01", "2019-11-09 15:51:01", "", "divider-2154993", "", "inherit", "closed", "closed", "", "divider-2154993", "", "", "2019-11-09 07:51:01", "2019-11-09 15:51:01", "", "0", "http://emilyhunt.ch/wp-content/uploads/2019/11/divider-2154993.svg", "0", "attachment", "image/svg+xml", "0");
INSERT INTO `wp_464683_posts` VALUES("373", "1", "2019-11-09 07:51:02", "2019-11-09 15:51:02", "", "dividers-2341200", "", "inherit", "closed", "closed", "", "dividers-2341200", "", "", "2019-11-09 07:51:02", "2019-11-09 15:51:02", "", "0", "http://emilyhunt.ch/wp-content/uploads/2019/11/dividers-2341200.svg", "0", "attachment", "image/svg+xml", "0");
INSERT INTO `wp_464683_posts` VALUES("374", "1", "2019-11-09 07:51:03", "2019-11-09 15:51:03", "", "elegant-1769669", "", "inherit", "closed", "closed", "", "elegant-1769669", "", "", "2019-11-09 07:51:03", "2019-11-09 15:51:03", "", "0", "http://emilyhunt.ch/wp-content/uploads/2019/11/elegant-1769669-1.svg", "0", "attachment", "image/svg+xml", "0");
INSERT INTO `wp_464683_posts` VALUES("375", "1", "2019-11-09 07:51:03", "2019-11-09 15:51:03", "", "floral-17510881", "", "inherit", "closed", "closed", "", "floral-17510881", "", "", "2019-11-09 07:51:03", "2019-11-09 15:51:03", "", "0", "http://emilyhunt.ch/wp-content/uploads/2019/11/floral-17510881.svg", "0", "attachment", "image/svg+xml", "0");
INSERT INTO `wp_464683_posts` VALUES("376", "1", "2019-11-09 07:51:04", "2019-11-09 15:51:04", "", "image2vector-1", "", "inherit", "closed", "closed", "", "image2vector-1", "", "", "2019-11-09 07:51:04", "2019-11-09 15:51:04", "", "0", "http://emilyhunt.ch/wp-content/uploads/2019/11/image2vector-1.svg", "0", "attachment", "image/svg+xml", "0");
INSERT INTO `wp_464683_posts` VALUES("377", "1", "2019-11-09 07:51:05", "2019-11-09 15:51:05", "", "image2vector", "", "inherit", "closed", "closed", "", "image2vector", "", "", "2019-11-09 07:51:05", "2019-11-09 15:51:05", "", "0", "http://emilyhunt.ch/wp-content/uploads/2019/11/image2vector.svg", "0", "attachment", "image/svg+xml", "0");
INSERT INTO `wp_464683_posts` VALUES("378", "1", "2019-11-09 07:51:06", "2019-11-09 15:51:06", "", "p411", "", "inherit", "closed", "closed", "", "p411", "", "", "2019-11-09 07:51:06", "2019-11-09 15:51:06", "", "0", "http://emilyhunt.ch/wp-content/uploads/2019/11/p411.svg", "0", "attachment", "image/svg+xml", "0");
INSERT INTO `wp_464683_posts` VALUES("379", "1", "2019-11-09 07:51:06", "2019-11-09 15:51:06", "", "Rhombus_200x6", "", "inherit", "closed", "closed", "", "rhombus_200x6", "", "", "2019-11-09 07:51:06", "2019-11-09 15:51:06", "", "0", "http://emilyhunt.ch/wp-content/uploads/2019/11/Rhombus_200x6.svg", "0", "attachment", "image/svg+xml", "0");
INSERT INTO `wp_464683_posts` VALUES("385", "1", "2019-11-09 08:04:05", "2019-11-09 16:04:05", "Watch this space for my touring schedule", "Touring", "", "publish", "closed", "closed", "", "touring", "", "", "2019-11-09 08:04:05", "2019-11-09 16:04:05", "", "0", "https://emilyhunt.ch/?post_type=text-blocks&#038;p=385", "0", "text-blocks", "", "0");

/* INSERT TABLE DATA: wp_464683_term_relationships */
INSERT INTO `wp_464683_term_relationships` VALUES("184", "3", "0");
INSERT INTO `wp_464683_term_relationships` VALUES("185", "3", "0");
INSERT INTO `wp_464683_term_relationships` VALUES("186", "3", "0");
INSERT INTO `wp_464683_term_relationships` VALUES("187", "3", "0");
INSERT INTO `wp_464683_term_relationships` VALUES("188", "3", "0");
INSERT INTO `wp_464683_term_relationships` VALUES("189", "3", "0");
INSERT INTO `wp_464683_term_relationships` VALUES("316", "4", "0");

/* INSERT TABLE DATA: wp_464683_term_taxonomy */
INSERT INTO `wp_464683_term_taxonomy` VALUES("1", "1", "category", "", "0", "0");
INSERT INTO `wp_464683_term_taxonomy` VALUES("2", "2", "category", "", "0", "0");
INSERT INTO `wp_464683_term_taxonomy` VALUES("3", "3", "nav_menu", "", "0", "6");
INSERT INTO `wp_464683_term_taxonomy` VALUES("4", "4", "elementor_library_type", "", "0", "1");

/* INSERT TABLE DATA: wp_464683_terms */
INSERT INTO `wp_464683_terms` VALUES("1", "Uncategorized", "uncategorized", "0");
INSERT INTO `wp_464683_terms` VALUES("2", "Blog", "blog", "0");
INSERT INTO `wp_464683_terms` VALUES("3", "MSW-PRIMARY-MENU-PHOTOGRAPHY", "msw-primary-menu-photography", "0");
INSERT INTO `wp_464683_terms` VALUES("4", "page", "page", "0");

/* INSERT TABLE DATA: wp_464683_usermeta */
INSERT INTO `wp_464683_usermeta` VALUES("1", "1", "nickname", "svadmin");
INSERT INTO `wp_464683_usermeta` VALUES("2", "1", "first_name", "");
INSERT INTO `wp_464683_usermeta` VALUES("3", "1", "last_name", "");
INSERT INTO `wp_464683_usermeta` VALUES("4", "1", "description", "");
INSERT INTO `wp_464683_usermeta` VALUES("5", "1", "rich_editing", "true");
INSERT INTO `wp_464683_usermeta` VALUES("6", "1", "syntax_highlighting", "true");
INSERT INTO `wp_464683_usermeta` VALUES("7", "1", "comment_shortcuts", "false");
INSERT INTO `wp_464683_usermeta` VALUES("8", "1", "admin_color", "fresh");
INSERT INTO `wp_464683_usermeta` VALUES("9", "1", "use_ssl", "0");
INSERT INTO `wp_464683_usermeta` VALUES("10", "1", "show_admin_bar_front", "false");
INSERT INTO `wp_464683_usermeta` VALUES("11", "1", "locale", "");
INSERT INTO `wp_464683_usermeta` VALUES("12", "1", "wp_464683_capabilities", "a:1:{s:13:\"administrator\";b:1;}");
INSERT INTO `wp_464683_usermeta` VALUES("13", "1", "wp_464683_user_level", "10");
INSERT INTO `wp_464683_usermeta` VALUES("14", "1", "dismissed_wp_pointers", "");
INSERT INTO `wp_464683_usermeta` VALUES("15", "1", "show_welcome_panel", "1");
INSERT INTO `wp_464683_usermeta` VALUES("16", "1", "session_tokens", "a:3:{s:64:\"8e6d5b9f97d6700bcb18bd7a5e6ad82aa42a2e550b4afd436646aabfe2e6fe36\";a:4:{s:10:\"expiration\";i:1573478900;s:2:\"ip\";s:11:\"88.8.240.47\";s:2:\"ua\";s:120:\"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3904.87 Safari/537.36\";s:5:\"login\";i:1573306100;}s:64:\"bd26627d06dbe4764760ccef172b66d6891d4f7f91f18c730a54da35d60408af\";a:4:{s:10:\"expiration\";i:1573481406;s:2:\"ip\";s:11:\"88.8.240.47\";s:2:\"ua\";s:120:\"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3904.87 Safari/537.36\";s:5:\"login\";i:1573308606;}s:64:\"55374baf8dadb25c87348fd46c703719017eced3640e8305302aae9bf9225ca3\";a:4:{s:10:\"expiration\";i:1573505972;s:2:\"ip\";s:11:\"88.8.240.47\";s:2:\"ua\";s:120:\"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3904.87 Safari/537.36\";s:5:\"login\";i:1573333172;}}");
INSERT INTO `wp_464683_usermeta` VALUES("17", "1", "wp_464683_dashboard_quick_press_last_post_id", "422");
INSERT INTO `wp_464683_usermeta` VALUES("18", "1", "community-events-location", "a:1:{s:2:\"ip\";s:10:\"88.8.240.0\";}");
INSERT INTO `wp_464683_usermeta` VALUES("19", "1", "itsec_user_activity_last_seen", "1573377752");
INSERT INTO `wp_464683_usermeta` VALUES("20", "1", "elementor_connect_common_data", "a:7:{s:9:\"client_id\";s:32:\"FcLrMyNvlb0UXf4hJS7KmQT5w0cIpwb5\";s:11:\"auth_secret\";s:32:\"4iV0JnlTWf5iwkLUOaGhpLQJzqfP4PBO\";s:12:\"access_token\";s:32:\"nm52x6ZHVFXyrAcYMcEaY1DIJiKEsPzP\";s:19:\"access_token_secret\";s:32:\"IwygluLV60H2cyKRhTuhA74nB7ekdqrF\";s:10:\"token_type\";s:6:\"bearer\";s:4:\"user\";O:8:\"stdClass\":1:{s:5:\"email\";s:20:\"kwebmaster@pobox.com\";}s:19:\"data_share_opted_in\";b:1;}");
INSERT INTO `wp_464683_usermeta` VALUES("21", "1", "itsec-settings-view", "grid");
INSERT INTO `wp_464683_usermeta` VALUES("22", "1", "elementor_introduction", "a:1:{s:10:\"rightClick\";b:1;}");
INSERT INTO `wp_464683_usermeta` VALUES("23", "1", "wp_464683_user-settings", "libraryContent=browse&editor=tinymce");
INSERT INTO `wp_464683_usermeta` VALUES("24", "1", "wp_464683_user-settings-time", "1573313455");
INSERT INTO `wp_464683_usermeta` VALUES("25", "1", "itsec-password-strength", "4");
INSERT INTO `wp_464683_usermeta` VALUES("26", "1", "_itsec_password_requirements", "a:1:{s:16:\"evaluation_times\";a:1:{s:8:\"strength\";i:1573333172;}}");
INSERT INTO `wp_464683_usermeta` VALUES("27", "1", "_itsec_has_logged_in", "1573333172");

/* INSERT TABLE DATA: wp_464683_users */
INSERT INTO `wp_464683_users` VALUES("1", "svadmin", "$P$BkQTLhK0dCgU/DYTh2ieunxvxjrUjY/", "svadmin", "stickysites@protonmail.com", "", "2019-11-09 09:27:47", "", "0", "svadmin");

SET FOREIGN_KEY_CHECKS = 1; 

/* Duplicator WordPress Timestamp: 2019-11-10 10:12:37*/
/* DUPLICATOR_MYSQLDUMP_EOF */
